/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    CCA_CoolingCoil
Macro id:      5766885350073958846
Macro version: 64
Last change:   13.08.2015 - 15:18
Access Level:  2
Inputs:
  [1] CoolCtrlSig
  [2] DehumCtrlSig
  [3] PlantMode
  [4] HumidityMode
Outputs:
  [1] ValveControl
  [2] ChillerEnable
Parameter:
  [1] HUM-01: cooling off by humidity
  [2] CLG-01: valve increase per minute
  [3] CLG-02: valve min position
  [4] CLG-03: valve max position
  [5] CLG-04: chiller enable on delay
  [6] CLG-05: chiller enable off delay
  [7] DISP-01: chiller enable
Description:
The "CCA_CoolingCoil" macro is an output module that provides modulating control of the cooling coil of an air handling unit and can be used for cooling and de-humidification.
================================================================================*/

public class BCmCCA_CoolingCoil
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmCCA_CoolingCoil_output_88().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmCCA_CoolingCoil_output_88().setStatus(BStatus.disabled);
    getCmCCA_CoolingCoil_output_18().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmCCA_CoolingCoil_output_88().setStatus(BStatus.ok);
    getCmCCA_CoolingCoil_output_18().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [1] Macro call CmEnable_Cooling
    func_1.CmEnable_Cooling_input_3 = (float) getCmCCA_CoolingCoil_input_12().getValue();
    func_1.CmEnable_Cooling_input_4 = (float) getCmCCA_CoolingCoil_input_14().getValue();
    func_1.Execute( this, 0 );

    // [45] Function call CfIdt
    func_45.input = (float) getCmCCA_CoolingCoil_parameter_28();
    func_45.Execute(  );
    setParameter(0, func_45.output[0]);

    // [60] Macro call CmIDT05
    func_60.CmIDT05_input_1 = (float) getCmCCA_CoolingCoil_parameter_11();
    func_60.CmIDT05_input_2 = (float) getCmCCA_CoolingCoil_parameter_23();
    func_60.CmIDT05_input_3 = (float) getCmCCA_CoolingCoil_parameter_24();
    func_60.CmIDT05_input_4 = 0F;
    func_60.CmIDT05_input_5 = 0F;
    func_60.Execute(  );
    setParameter(1, func_60.CmIDT05_output_21);
    setParameter(2, func_60.CmIDT05_output_22);
    setParameter(3, func_60.CmIDT05_output_23);

    // [5] Macro call CmCooling_Control
    func_5.CmCooling_Control_input_48 = (float) getCmCCA_CoolingCoil_input_16().getValue();
    func_5.CmCooling_Control_input_134 = (float) getCmCCA_CoolingCoil_input_14().getValue();
    func_5.CmCooling_Control_input_143 = func_1.CmEnable_Cooling_output_54;
    func_5.CmCooling_Control_input_146 = (float) getCmCCA_CoolingCoil_input_50().getValue();
    func_5.Execute( this, 1 );

    // [7] Macro call CmCooling_Demand
    func_7.CmCooling_Demand_input_1 = func_5.CmCooling_Control_output_36;
    func_7.CmCooling_Demand_input_22 = func_1.CmEnable_Cooling_output_54;
    func_7.Execute( this, 6 );
    setCmCCA_CoolingCoil_output_18(BooleanToFloat(func_7.CmCooling_Demand_output_24));

    // [19] Function call CfIdt
    func_19.input = func_5.CmCooling_Control_output_36;
    func_19.Execute(  );
    setCmCCA_CoolingCoil_output_88(func_19.output[0]);

    // [51] Macro call CmIDT05
    func_51.CmIDT05_input_1 = (float) getCmCCA_CoolingCoil_parameter_23();
    func_51.CmIDT05_input_2 = (float) getCmCCA_CoolingCoil_parameter_26();
    func_51.CmIDT05_input_3 = (float) getCmCCA_CoolingCoil_parameter_27();
    func_51.CmIDT05_input_4 = (float) getCmCCA_CoolingCoil_output_18().getValue();
    func_51.CmIDT05_input_5 = 0F;
    func_51.Execute(  );
    setParameter(6, func_51.CmIDT05_output_21);
    setParameter(7, func_51.CmIDT05_output_22);
    setParameter(8, func_51.CmIDT05_output_23);
    setCmCCA_CoolingCoil_parameter_47(func_51.CmIDT05_output_24);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    1F, 10F, 0F, 100F, 10F, 10F, 0F, 300F,
    300F, 0F, 10F, 10F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// ValveControl
  public static final Property CmCCA_CoolingCoil_output_88 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCCA_CoolingCoil_output_88() { return (BStatusNumeric) get(CmCCA_CoolingCoil_output_88); }
  public void setCmCCA_CoolingCoil_output_88(BStatusNumeric v) { set(CmCCA_CoolingCoil_output_88,v,null); }
  public void setCmCCA_CoolingCoil_output_88(float v) { getCmCCA_CoolingCoil_output_88().setValue(v); }
// ChillerEnable
  public static final Property CmCCA_CoolingCoil_output_18 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCCA_CoolingCoil_output_18() { return (BStatusNumeric) get(CmCCA_CoolingCoil_output_18); }
  public void setCmCCA_CoolingCoil_output_18(BStatusNumeric v) { set(CmCCA_CoolingCoil_output_18,v,null); }
  public void setCmCCA_CoolingCoil_output_18(float v) { getCmCCA_CoolingCoil_output_18().setValue(v); }

  // macro parameter
// HUM-01: cooling off by humidity
  public static final Property CmCCA_CoolingCoil_parameter_28 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCCA_CoolingCoil_parameter_28() { return getDouble(CmCCA_CoolingCoil_parameter_28); }
  public void setCmCCA_CoolingCoil_parameter_28(double v) { setDouble(CmCCA_CoolingCoil_parameter_28,v,null); }
// CLG-01: valve increase per minute
  public static final Property CmCCA_CoolingCoil_parameter_11 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("per minute"))));
  public double getCmCCA_CoolingCoil_parameter_11() { return getDouble(CmCCA_CoolingCoil_parameter_11); }
  public void setCmCCA_CoolingCoil_parameter_11(double v) { setDouble(CmCCA_CoolingCoil_parameter_11,v,null); }
// CLG-02: valve min position
  public static final Property CmCCA_CoolingCoil_parameter_23 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCCA_CoolingCoil_parameter_23() { return getDouble(CmCCA_CoolingCoil_parameter_23); }
  public void setCmCCA_CoolingCoil_parameter_23(double v) { setDouble(CmCCA_CoolingCoil_parameter_23,v,null); }
// CLG-03: valve max position
  public static final Property CmCCA_CoolingCoil_parameter_24 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCCA_CoolingCoil_parameter_24() { return getDouble(CmCCA_CoolingCoil_parameter_24); }
  public void setCmCCA_CoolingCoil_parameter_24(double v) { setDouble(CmCCA_CoolingCoil_parameter_24,v,null); }
// CLG-04: chiller enable on delay
  public static final Property CmCCA_CoolingCoil_parameter_26 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCCA_CoolingCoil_parameter_26() { return getDouble(CmCCA_CoolingCoil_parameter_26); }
  public void setCmCCA_CoolingCoil_parameter_26(double v) { setDouble(CmCCA_CoolingCoil_parameter_26,v,null); }
// CLG-05: chiller enable off delay
  public static final Property CmCCA_CoolingCoil_parameter_27 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCCA_CoolingCoil_parameter_27() { return getDouble(CmCCA_CoolingCoil_parameter_27); }
  public void setCmCCA_CoolingCoil_parameter_27(double v) { setDouble(CmCCA_CoolingCoil_parameter_27,v,null); }
// DISP-01: chiller enable
  public static final Property CmCCA_CoolingCoil_parameter_47 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCCA_CoolingCoil_parameter_47() { return getDouble(CmCCA_CoolingCoil_parameter_47); }
  public void setCmCCA_CoolingCoil_parameter_47(double v) { setDouble(CmCCA_CoolingCoil_parameter_47,v,null); }

  // macro inputs
// CoolCtrlSig
  public static final Property CmCCA_CoolingCoil_input_16 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmCCA_CoolingCoil_input_16() { return (BStatusNumeric) get(CmCCA_CoolingCoil_input_16); }
  public void setCmCCA_CoolingCoil_input_16(BStatusNumeric v) { set(CmCCA_CoolingCoil_input_16,v,null); }
  public void setCmCCA_CoolingCoil_input_16(float v) { getCmCCA_CoolingCoil_input_16().setValue(v); }
// DehumCtrlSig
  public static final Property CmCCA_CoolingCoil_input_50 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmCCA_CoolingCoil_input_50() { return (BStatusNumeric) get(CmCCA_CoolingCoil_input_50); }
  public void setCmCCA_CoolingCoil_input_50(BStatusNumeric v) { set(CmCCA_CoolingCoil_input_50,v,null); }
  public void setCmCCA_CoolingCoil_input_50(float v) { getCmCCA_CoolingCoil_input_50().setValue(v); }
// PlantMode
  public static final Property CmCCA_CoolingCoil_input_12 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmCCA_CoolingCoil_input_12() { return (BStatusNumeric) get(CmCCA_CoolingCoil_input_12); }
  public void setCmCCA_CoolingCoil_input_12(BStatusNumeric v) { set(CmCCA_CoolingCoil_input_12,v,null); }
  public void setCmCCA_CoolingCoil_input_12(float v) { getCmCCA_CoolingCoil_input_12().setValue(v); }
// HumidityMode
  public static final Property CmCCA_CoolingCoil_input_14 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmCCA_CoolingCoil_input_14() { return (BStatusNumeric) get(CmCCA_CoolingCoil_input_14); }
  public void setCmCCA_CoolingCoil_input_14(BStatusNumeric v) { set(CmCCA_CoolingCoil_input_14,v,null); }
  public void setCmCCA_CoolingCoil_input_14(float v) { getCmCCA_CoolingCoil_input_14().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.06 [64] 13.08.2015-15:18").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5766885350073958846").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmCCA_CoolingCoil.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }

  // class variables
  protected CmEnable_Cooling func_1 = new CmEnable_Cooling();
  protected CfIdt func_45 = new CfIdt();
  protected CmIDT05 func_60 = new CmIDT05();
  protected CmCooling_Control func_5 = new CmCooling_Control();
  protected CmCooling_Demand func_7 = new CmCooling_Demand();
  protected CfIdt func_19 = new CfIdt();
  protected CmIDT05 func_51 = new CmIDT05();

  // default constructor
  public BCmCCA_CoolingCoil()
  {
  }

  public void Start()
  {
    func_1.Start();
    func_60.Start();
    func_5.Start();
    func_7.Start();
    func_51.Start();
  }
}
