/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    CSB_CascContr
Macro id:      5899663857315480302
Macro version: 127
Last change:   19.03.2018 - 14:56
Access Level:  2
Inputs:
  [1] SupplyAirTemp
  [2] RoomRetAirTemp
  [3] RoomAirTempSp
  [4] ContrPtAdj
  [5] FilteredOATemp
  [6] CO2_Sensor
  [7] FanEnable
  [8] EnRecSeqSwitch
  [9] MinSAT_SpShift
  [10] PlantMode
  [11] HumidityMode
Outputs:
  [1] HeatCtrlSig
  [2] DamperCtrlSig
  [3] CoolCtrlSig
  [4] ERCCtrlSig
  [5] FanSpeedCtrlSig
  [6] FanStageCmd
  [7] CalcRoomTmpSp
  [8] CalcSupAirTmpSp
  [9] SAT_ContrDev
Parameter:
  [1] START-01: limit OAT to start frost  protection
  [2] START-02: supply air temperature setpoint raise
  [3] START-03: SAT control raised setpoint decrease time
  [4] START-04: period of forced recirculation after start
  [5] OAT-01: limit OAT;  heater closed
  [6] OAT-02: limit OAT;  cooler closed
  [7] SCR-01: start point OAT summer comp. RT
  [8] SCR-02: end point OAT summer comp. RT
  [9] SCR-03: room temperature setpoint raise
  [10] RMT-01: room temperature control P-band
  [11] RMT-02: room temperature control I-time
  [12] RMT-03: span for SAT-setpoint shift
  [13] RMT-04: fan speed control type
  [14] SAT-01: supply air temperature low setpoint
  [15] SAT-02: supply air temperature high setpoint
  [16] WCS-01: start point OAT winter comp. SAT
  [17] WCS-02: end  point OAT winter comp. SAT
  [18] WCS-03: supply air temperature setpoint  raise
  [19] SAT-03: supply air temp. control P-band
  [20] SAT-04: supply air temp. control I-time
  [21] SAT-05: sequence start point heating valve
  [22] SAT-06: sequence end point heating valve
  [23] SAT-07: sequence start point dampers
  [24] SAT-08: sequence end point dampers
  [25] SAT-09: sequence start point energy recovery
  [26] SAT-10 :sequence end point energy recovery
  [27] SAT-11: sequence start point cooling valve
  [28] SAT-12: sequence end point cooling valve
  [29] CO2-01: air quality setpoint ; 0 = disable internal controller
  [30] CO2-02: air quality P-band
  [31] CO2-03: sequence start point air quality override dampers
  [32] CO2-04: sequence end point air quality override dampers
  [33] CO2-05: sequence start point air quality override fan speed
  [34] CO2-06: sequence end point air quality override fan speed
  [35] SYS-01: economizer function
Description:
The macro CSB_CascContr is a control strategy module for an air handling unit with mixed air dampers. It determines the control strategy of an air handling unit with integrated options for fan enable, plant, humidity and economiser mode overrides.
The air handling strategy provides the following functions: 

Configuration
 - Defined start procedure after download, power failure or alarm 

Energy Saving Functions
 - Outdoor Temperature Heating/ Cooling Limits 
 - Summer/ Winter Compensation 
 - CO2 Or Air Quality Override Control 
 - Reversing Energy Recovery Control Signal 

Protection Functions 
 - Frost Protection and Frost Recovery 
 - AHU Stops At Fan Alarm 
 - Delayed Switch Off 

Overrides 
 - Plant Mode 
 - Humidity Mode
================================================================================*/

public class BCmCSB_CascContr
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmCSB_CascContr_output_11().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmCSB_CascContr_output_11().setStatus(BStatus.disabled);
    getCmCSB_CascContr_output_224().setStatus(BStatus.disabled);
    getCmCSB_CascContr_output_12().setStatus(BStatus.disabled);
    getCmCSB_CascContr_output_13().setStatus(BStatus.disabled);
    getCmCSB_CascContr_output_14().setStatus(BStatus.disabled);
    getCmCSB_CascContr_output_15().setStatus(BStatus.disabled);
    getCmCSB_CascContr_output_174().setStatus(BStatus.disabled);
    getCmCSB_CascContr_output_16().setStatus(BStatus.disabled);
    getCmCSB_CascContr_output_252().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmCSB_CascContr_output_11().setStatus(BStatus.ok);
    getCmCSB_CascContr_output_224().setStatus(BStatus.ok);
    getCmCSB_CascContr_output_12().setStatus(BStatus.ok);
    getCmCSB_CascContr_output_13().setStatus(BStatus.ok);
    getCmCSB_CascContr_output_14().setStatus(BStatus.ok);
    getCmCSB_CascContr_output_15().setStatus(BStatus.ok);
    getCmCSB_CascContr_output_174().setStatus(BStatus.ok);
    getCmCSB_CascContr_output_16().setStatus(BStatus.ok);
    getCmCSB_CascContr_output_252().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [54] Macro call CmIDT20
    func_54.CmIDT20_input_1 = 0F;
    func_54.CmIDT20_input_2 = (float) getCmCSB_CascContr_parameter_18();
    func_54.CmIDT20_input_3 = (float) getCmCSB_CascContr_parameter_19();
    func_54.CmIDT20_input_4 = (float) getCmCSB_CascContr_parameter_20();
    func_54.CmIDT20_input_5 = (float) getCmCSB_CascContr_parameter_21();
    func_54.CmIDT20_input_6 = (float) getCmCSB_CascContr_parameter_22();
    func_54.CmIDT20_input_7 = (float) getCmCSB_CascContr_parameter_23();
    func_54.CmIDT20_input_8 = (float) getCmCSB_CascContr_parameter_22();
    func_54.CmIDT20_input_9 = (float) getCmCSB_CascContr_parameter_23();
    func_54.CmIDT20_input_10 = (float) getCmCSB_CascContr_parameter_183();
    func_54.CmIDT20_input_11 = (float) getCmCSB_CascContr_parameter_28();
    func_54.CmIDT20_input_12 = (float) getCmCSB_CascContr_parameter_29();
    func_54.CmIDT20_input_13 = (float) getCmCSB_CascContr_parameter_27();
    func_54.CmIDT20_input_14 = (float) getCmCSB_CascContr_parameter_30();
    func_54.CmIDT20_input_15 = (float) getCmCSB_CascContr_parameter_31();
    func_54.CmIDT20_input_16 = (float) getCmCSB_CascContr_parameter_32();
    func_54.CmIDT20_input_17 = (float) getCmCSB_CascContr_parameter_33();
    func_54.CmIDT20_input_18 = (float) getCmCSB_CascContr_parameter_34();
    func_54.CmIDT20_input_19 = 0F;
    func_54.CmIDT20_input_20 = 0F;
    func_54.Execute(  );
    setParameter(22, func_54.CmIDT20_output_22);
    setParameter(23, func_54.CmIDT20_output_23);
    setParameter(43, func_54.CmIDT20_output_24);
    setParameter(44, func_54.CmIDT20_output_25);
    setParameter(25, func_54.CmIDT20_output_26);
    setParameter(26, func_54.CmIDT20_output_27);
    setParameter(9, func_54.CmIDT20_output_28);
    setParameter(10, func_54.CmIDT20_output_29);
    setParameter(11, func_54.CmIDT20_output_30);
    setParameter(27, func_54.CmIDT20_output_31);
    setParameter(28, func_54.CmIDT20_output_32);
    setParameter(37, func_54.CmIDT20_output_33);
    setParameter(38, func_54.CmIDT20_output_34);
    setParameter(39, func_54.CmIDT20_output_35);
    setParameter(40, func_54.CmIDT20_output_36);
    setParameter(41, func_54.CmIDT20_output_37);
    setParameter(42, func_54.CmIDT20_output_38);

    // [189] Macro call CmIDT20
    func_189.CmIDT20_input_1 = (float) getCmCSB_CascContr_parameter_28();
    func_189.CmIDT20_input_2 = (float) getCmCSB_CascContr_parameter_35();
    func_189.CmIDT20_input_3 = (float) getCmCSB_CascContr_parameter_36();
    func_189.CmIDT20_input_4 = (float) getCmCSB_CascContr_parameter_228();
    func_189.CmIDT20_input_5 = (float) getCmCSB_CascContr_parameter_229();
    func_189.CmIDT20_input_6 = (float) getCmCSB_CascContr_parameter_37();
    func_189.CmIDT20_input_7 = (float) getCmCSB_CascContr_parameter_38();
    func_189.CmIDT20_input_8 = (float) getCmCSB_CascContr_parameter_24();
    func_189.CmIDT20_input_9 = (float) getCmCSB_CascContr_parameter_25();
    func_189.CmIDT20_input_10 = (float) getCmCSB_CascContr_parameter_26();
    func_189.CmIDT20_input_11 = (float) getCmCSB_CascContr_parameter_187();
    func_189.CmIDT20_input_12 = (float) getCmCSB_CascContr_parameter_183();
    func_189.CmIDT20_input_13 = (float) getCmCSB_CascContr_parameter_185();
    func_189.CmIDT20_input_14 = (float) getCmCSB_CascContr_parameter_186();
    func_189.CmIDT20_input_15 = (float) getCmCSB_CascContr_parameter_185();
    func_189.CmIDT20_input_16 = (float) getCmCSB_CascContr_parameter_180();
    func_189.CmIDT20_input_17 = (float) getCmCSB_CascContr_parameter_181();
    func_189.CmIDT20_input_18 = (float) getCmCSB_CascContr_parameter_182();
    func_189.CmIDT20_input_19 = (float) getCmCSB_CascContr_parameter_184();
    func_189.CmIDT20_input_20 = (float) getCmCSB_CascContr_parameter_17();
    func_189.Execute(  );
    setParameter(4, func_189.CmIDT20_output_21);
    setParameter(52, func_189.CmIDT20_output_22);
    setParameter(53, func_189.CmIDT20_output_23);
    setParameter(54, func_189.CmIDT20_output_24);
    setParameter(55, func_189.CmIDT20_output_25);
    setParameter(56, func_189.CmIDT20_output_26);
    setParameter(57, func_189.CmIDT20_output_27);
    setParameter(6, func_189.CmIDT20_output_28);
    setParameter(7, func_189.CmIDT20_output_29);
    setParameter(8, func_189.CmIDT20_output_30);
    setParameter(35, func_189.CmIDT20_output_31);
    setParameter(45, func_189.CmIDT20_output_32);
    setParameter(46, func_189.CmIDT20_output_33);
    setParameter(47, func_189.CmIDT20_output_34);
    setParameter(13, func_189.CmIDT20_output_35);
    setParameter(0, func_189.CmIDT20_output_36);
    setParameter(1, func_189.CmIDT20_output_37);
    setParameter(2, func_189.CmIDT20_output_38);
    setParameter(12, func_189.CmIDT20_output_39);
    setParameter(3, func_189.CmIDT20_output_40);

    // [230] Macro call CmIDT05
    func_230.CmIDT05_input_1 = (float) getCmCSB_CascContr_parameter_226();
    func_230.CmIDT05_input_2 = (float) getCmCSB_CascContr_parameter_227();
    func_230.CmIDT05_input_3 = 0F;
    func_230.CmIDT05_input_4 = 0F;
    func_230.CmIDT05_input_5 = (float) getCmCSB_CascContr_parameter_225();
    func_230.Execute(  );
    setParameter(50, func_230.CmIDT05_output_21);
    setParameter(51, func_230.CmIDT05_output_22);
    setParameter(48, func_230.CmIDT05_output_23);
    setParameter(63, func_230.CmIDT05_output_25);

    // [135] Macro call CmSummer_Compensation
    func_135.CmSummer_Compensation_input_4 = (float) getCmCSB_CascContr_input_151().getValue();
    func_135.CmSummer_Compensation_input_23 = (float) getCmCSB_CascContr_input_172().getValue();
    func_135.CmSummer_Compensation_input_5 = (float) getCmCSB_CascContr_input_5().getValue();
    func_135.Execute( this, 0 );

    // [82] Macro call CmControl_Point_Adjustment
    func_82.CmControl_Point_Adjustment_input_7 = (float) getCmCSB_CascContr_input_3().getValue();
    func_82.Execute(  );

    // [40] Macro call CmAHU_Startup
    func_40.CmAHU_Startup_input_14 = getCmCSB_CascContr_input_4().getValue();
    func_40.CmAHU_Startup_input_15 = (float) getCmCSB_CascContr_input_6().getValue();
    func_40.CmAHU_Startup_input_16 = (float) getCmCSB_CascContr_input_5().getValue();
    func_40.Execute( this, 3 );

    // [152] Macro call CmCascaded_Control
    func_152.CmCascaded_Control_input_1 = func_135.CmSummer_Compensation_output_6;
    func_152.CmCascaded_Control_input_4 = func_82.CmControl_Point_Adjustment_output_10;
    func_152.CmCascaded_Control_input_13 = (float) getCmCSB_CascContr_input_172().getValue();
    func_152.CmCascaded_Control_input_23 = (float) getCmCSB_CascContr_input_5().getValue();
    func_152.CmCascaded_Control_input_18 = true;
    func_152.CmCascaded_Control_input_60 = (float) getCmCSB_CascContr_input_256().getValue();
    func_152.Execute( this, 6 );
    setCmCSB_CascContr_output_174(func_152.CmCascaded_Control_output_56);

    // [43] Macro call CmAHU_Setpoint_Ramp
    func_43.CmAHU_Setpoint_Ramp_input_1 = func_40.CmAHU_Startup_output_35;
    func_43.CmAHU_Setpoint_Ramp_input_47 = func_152.CmCascaded_Control_output_3;
    func_43.Execute( this, 22 );

    // [118] Macro call CmLimit_SAT
    func_118.CmLimit_SAT_input_1 = func_43.CmAHU_Setpoint_Ramp_output_48;
    func_118.CmLimit_SAT_input_14 = (float) getCmCSB_CascContr_input_256().getValue();
    func_118.Execute( this, 25 );
    setCmCSB_CascContr_output_16(func_118.CmLimit_SAT_output_2);

    // [204] Macro call CmSupply_PID
    func_204.CmSupply_PID_input_13 = func_118.CmLimit_SAT_output_3;
    func_204.CmSupply_PID_input_14 = (float) getCmCSB_CascContr_input_1().getValue();
    func_204.CmSupply_PID_input_15 = func_40.CmAHU_Startup_output_34;
    func_204.Execute( this, 27 );

    // [121] Macro call CmERC_Reverse
    func_121.CmERC_Reverse_input_2 = (float) getCmCSB_CascContr_input_5().getValue();
    func_121.CmERC_Reverse_input_4 = (float) getCmCSB_CascContr_input_172().getValue();
    func_121.CmERC_Reverse_input_29 = (float) getCmCSB_CascContr_output_174().getValue();
    func_121.CmERC_Reverse_input_3 = getCmCSB_CascContr_input_8().getValue();
    func_121.Execute( this, 35 );

    // [104] Macro call CmOutput_Sequence
    func_104.CmOutput_Sequence_input_1 = func_204.CmSupply_PID_output_22;
    func_104.CmOutput_Sequence_input_37 = func_121.CmERC_Reverse_output_1;
    func_104.Execute( this, 37 );

    // [113] Macro call CmOAT_Limits
    func_113.CmOAT_Limits_input_16 = (float) getCmCSB_CascContr_input_5().getValue();
    func_113.CmOAT_Limits_input_21 = (float) getCmCSB_CascContr_input_7().getValue();
    func_113.CmOAT_Limits_input_1 = func_104.CmOutput_Sequence_output_2;
    func_113.CmOAT_Limits_input_2 = func_104.CmOutput_Sequence_output_3;
    func_113.Execute( this, 43 );

    // [195] Macro call CmFan_Sequence
    func_195.CmFan_Sequence_input_1 = (float) getCmCSB_CascContr_output_174().getValue();
    func_195.CmFan_Sequence_input_51 = (float) getCmCSB_CascContr_input_172().getValue();
    func_195.CmFan_Sequence_input_107 = false;
    func_195.Execute( this, 45 );

    // [222] Macro call CmDamper_Sequence
    func_222.CmDamper_Sequence_input_1 = func_204.CmSupply_PID_output_22;
    func_222.CmDamper_Sequence_input_37 = func_121.CmERC_Reverse_output_1;
    func_222.Execute( this, 50 );

    // [101] Macro call CmCO2_Control
    func_101.CmCO2_Control_input_1 = func_195.CmFan_Sequence_output_2;
    func_101.CmCO2_Control_input_51 = func_222.CmDamper_Sequence_output_2;
    func_101.CmCO2_Control_input_7 = (float) getCmCSB_CascContr_input_2().getValue();
    func_101.Execute( this, 52 );

    // [223] Macro call CmDMP_Recirculation
    func_223.CmDMP_Recirculation_input_2 = func_101.CmCO2_Control_output_52;
    func_223.CmDMP_Recirculation_input_1 = func_40.CmAHU_Startup_output_35;
    func_223.Execute( this, 63 );

    // [76] Macro call CmFrost_Protection
    func_76.CmFrost_Protection_input_35 = func_40.CmAHU_Startup_output_34;
    func_76.CmFrost_Protection_input_51 = func_40.CmAHU_Startup_output_79;
    func_76.CmFrost_Protection_input_1 = func_113.CmOAT_Limits_output_3;
    func_76.CmFrost_Protection_input_2 = func_113.CmOAT_Limits_output_4;
    func_76.CmFrost_Protection_input_3 = func_104.CmOutput_Sequence_output_4;
    func_76.CmFrost_Protection_input_4 = func_101.CmCO2_Control_output_2;
    func_76.CmFrost_Protection_input_38 = func_223.CmDMP_Recirculation_output_4;
    func_76.CmFrost_Protection_input_22 = (float) getCmCSB_CascContr_input_6().getValue();
    func_76.Execute( this, 66 );
    setCmCSB_CascContr_output_11(func_76.CmFrost_Protection_output_6);
    setCmCSB_CascContr_output_12(func_76.CmFrost_Protection_output_7);
    setCmCSB_CascContr_output_13(func_76.CmFrost_Protection_output_8);
    setCmCSB_CascContr_output_14(func_76.CmFrost_Protection_output_9);
    setCmCSB_CascContr_output_15(func_76.CmFrost_Protection_output_10);
    setCmCSB_CascContr_output_224(func_76.CmFrost_Protection_output_39);

    // [253] Function call CfSubtract
    func_253.input[0] = (float) getCmCSB_CascContr_input_1().getValue();
    func_253.input[1] = (float) getCmCSB_CascContr_output_16().getValue();
    func_253.Execute(  );
    setCmCSB_CascContr_output_252(func_253.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    14F, 20F, 30F, 6F, 600F, 10F, -10F, 10F,
    4F, 14F, 26F, 2F, 0F, 60F, 3F, 0F,
    1000F, 100F, 0F, -10F, 10F, 4F, 10F, 600F,
    1F, 14F, 26F, 15F, 600F, 10F, 3F, 0F,
    1000F, 100F, 0F, 1F, 1F, 0F, 35F, 55F,
    75F, 75F, 100F, 20F, 14F, 2F, 60F, 3F,
    2F, 1F, 35F, 55F, 1000F, 200F, 0F, 50F,
    50F, 100F, 3F, 0F, 0F, 100F, 0F, 600F,
    0F, 10F, 10F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// HeatCtrlSig
  public static final Property CmCSB_CascContr_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSB_CascContr_output_11() { return (BStatusNumeric) get(CmCSB_CascContr_output_11); }
  public void setCmCSB_CascContr_output_11(BStatusNumeric v) { set(CmCSB_CascContr_output_11,v,null); }
  public void setCmCSB_CascContr_output_11(float v) { getCmCSB_CascContr_output_11().setValue(v); }
// DamperCtrlSig
  public static final Property CmCSB_CascContr_output_224 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSB_CascContr_output_224() { return (BStatusNumeric) get(CmCSB_CascContr_output_224); }
  public void setCmCSB_CascContr_output_224(BStatusNumeric v) { set(CmCSB_CascContr_output_224,v,null); }
  public void setCmCSB_CascContr_output_224(float v) { getCmCSB_CascContr_output_224().setValue(v); }
// CoolCtrlSig
  public static final Property CmCSB_CascContr_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSB_CascContr_output_12() { return (BStatusNumeric) get(CmCSB_CascContr_output_12); }
  public void setCmCSB_CascContr_output_12(BStatusNumeric v) { set(CmCSB_CascContr_output_12,v,null); }
  public void setCmCSB_CascContr_output_12(float v) { getCmCSB_CascContr_output_12().setValue(v); }
// ERCCtrlSig
  public static final Property CmCSB_CascContr_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSB_CascContr_output_13() { return (BStatusNumeric) get(CmCSB_CascContr_output_13); }
  public void setCmCSB_CascContr_output_13(BStatusNumeric v) { set(CmCSB_CascContr_output_13,v,null); }
  public void setCmCSB_CascContr_output_13(float v) { getCmCSB_CascContr_output_13().setValue(v); }
// FanSpeedCtrlSig
  public static final Property CmCSB_CascContr_output_14 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSB_CascContr_output_14() { return (BStatusNumeric) get(CmCSB_CascContr_output_14); }
  public void setCmCSB_CascContr_output_14(BStatusNumeric v) { set(CmCSB_CascContr_output_14,v,null); }
  public void setCmCSB_CascContr_output_14(float v) { getCmCSB_CascContr_output_14().setValue(v); }
// FanStageCmd
  public static final Property CmCSB_CascContr_output_15 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSB_CascContr_output_15() { return (BStatusNumeric) get(CmCSB_CascContr_output_15); }
  public void setCmCSB_CascContr_output_15(BStatusNumeric v) { set(CmCSB_CascContr_output_15,v,null); }
  public void setCmCSB_CascContr_output_15(float v) { getCmCSB_CascContr_output_15().setValue(v); }
// CalcRoomTmpSp
  public static final Property CmCSB_CascContr_output_174 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSB_CascContr_output_174() { return (BStatusNumeric) get(CmCSB_CascContr_output_174); }
  public void setCmCSB_CascContr_output_174(BStatusNumeric v) { set(CmCSB_CascContr_output_174,v,null); }
  public void setCmCSB_CascContr_output_174(float v) { getCmCSB_CascContr_output_174().setValue(v); }
// CalcSupAirTmpSp
  public static final Property CmCSB_CascContr_output_16 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSB_CascContr_output_16() { return (BStatusNumeric) get(CmCSB_CascContr_output_16); }
  public void setCmCSB_CascContr_output_16(BStatusNumeric v) { set(CmCSB_CascContr_output_16,v,null); }
  public void setCmCSB_CascContr_output_16(float v) { getCmCSB_CascContr_output_16().setValue(v); }
// SAT_ContrDev
  public static final Property CmCSB_CascContr_output_252 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSB_CascContr_output_252() { return (BStatusNumeric) get(CmCSB_CascContr_output_252); }
  public void setCmCSB_CascContr_output_252(BStatusNumeric v) { set(CmCSB_CascContr_output_252,v,null); }
  public void setCmCSB_CascContr_output_252(float v) { getCmCSB_CascContr_output_252().setValue(v); }

  // macro parameter
// START-01: limit OAT to start frost  protection
  public static final Property CmCSB_CascContr_parameter_17 = newProperty( 0, BDouble.make( 6 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(10)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSB_CascContr_parameter_17() { return getDouble(CmCSB_CascContr_parameter_17); }
  public void setCmCSB_CascContr_parameter_17(double v) { setDouble(CmCSB_CascContr_parameter_17,v,null); }
// START-02: supply air temperature setpoint raise
  public static final Property CmCSB_CascContr_parameter_18 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSB_CascContr_parameter_18() { return getDouble(CmCSB_CascContr_parameter_18); }
  public void setCmCSB_CascContr_parameter_18(double v) { setDouble(CmCSB_CascContr_parameter_18,v,null); }
// START-03: SAT control raised setpoint decrease time
  public static final Property CmCSB_CascContr_parameter_19 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCSB_CascContr_parameter_19() { return getDouble(CmCSB_CascContr_parameter_19); }
  public void setCmCSB_CascContr_parameter_19(double v) { setDouble(CmCSB_CascContr_parameter_19,v,null); }
// START-04: period of forced recirculation after start
  public static final Property CmCSB_CascContr_parameter_225 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCSB_CascContr_parameter_225() { return getDouble(CmCSB_CascContr_parameter_225); }
  public void setCmCSB_CascContr_parameter_225(double v) { setDouble(CmCSB_CascContr_parameter_225,v,null); }
// OAT-01: limit OAT;  heater closed
  public static final Property CmCSB_CascContr_parameter_20 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSB_CascContr_parameter_20() { return getDouble(CmCSB_CascContr_parameter_20); }
  public void setCmCSB_CascContr_parameter_20(double v) { setDouble(CmCSB_CascContr_parameter_20,v,null); }
// OAT-02: limit OAT;  cooler closed
  public static final Property CmCSB_CascContr_parameter_21 = newProperty( 0, BDouble.make( 14 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSB_CascContr_parameter_21() { return getDouble(CmCSB_CascContr_parameter_21); }
  public void setCmCSB_CascContr_parameter_21(double v) { setDouble(CmCSB_CascContr_parameter_21,v,null); }
// SCR-01: start point OAT summer comp. RT
  public static final Property CmCSB_CascContr_parameter_180 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSB_CascContr_parameter_180() { return getDouble(CmCSB_CascContr_parameter_180); }
  public void setCmCSB_CascContr_parameter_180(double v) { setDouble(CmCSB_CascContr_parameter_180,v,null); }
// SCR-02: end point OAT summer comp. RT
  public static final Property CmCSB_CascContr_parameter_181 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSB_CascContr_parameter_181() { return getDouble(CmCSB_CascContr_parameter_181); }
  public void setCmCSB_CascContr_parameter_181(double v) { setDouble(CmCSB_CascContr_parameter_181,v,null); }
// SCR-03: room temperature setpoint raise
  public static final Property CmCSB_CascContr_parameter_182 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(10)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSB_CascContr_parameter_182() { return getDouble(CmCSB_CascContr_parameter_182); }
  public void setCmCSB_CascContr_parameter_182(double v) { setDouble(CmCSB_CascContr_parameter_182,v,null); }
// RMT-01: room temperature control P-band
  public static final Property CmCSB_CascContr_parameter_183 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSB_CascContr_parameter_183() { return getDouble(CmCSB_CascContr_parameter_183); }
  public void setCmCSB_CascContr_parameter_183(double v) { setDouble(CmCSB_CascContr_parameter_183,v,null); }
// RMT-02: room temperature control I-time
  public static final Property CmCSB_CascContr_parameter_184 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1E+07)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCSB_CascContr_parameter_184() { return getDouble(CmCSB_CascContr_parameter_184); }
  public void setCmCSB_CascContr_parameter_184(double v) { setDouble(CmCSB_CascContr_parameter_184,v,null); }
// RMT-03: span for SAT-setpoint shift
  public static final Property CmCSB_CascContr_parameter_185 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSB_CascContr_parameter_185() { return getDouble(CmCSB_CascContr_parameter_185); }
  public void setCmCSB_CascContr_parameter_185(double v) { setDouble(CmCSB_CascContr_parameter_185,v,null); }
// RMT-04: fan speed control type
  public static final Property CmCSB_CascContr_parameter_186 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCSB_CascContr_parameter_186() { return getDouble(CmCSB_CascContr_parameter_186); }
  public void setCmCSB_CascContr_parameter_186(double v) { setDouble(CmCSB_CascContr_parameter_186,v,null); }
// SAT-01: supply air temperature low setpoint
  public static final Property CmCSB_CascContr_parameter_22 = newProperty( 0, BDouble.make( 14 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(6)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSB_CascContr_parameter_22() { return getDouble(CmCSB_CascContr_parameter_22); }
  public void setCmCSB_CascContr_parameter_22(double v) { setDouble(CmCSB_CascContr_parameter_22,v,null); }
// SAT-02: supply air temperature high setpoint
  public static final Property CmCSB_CascContr_parameter_23 = newProperty( 0, BDouble.make( 35 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(6)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSB_CascContr_parameter_23() { return getDouble(CmCSB_CascContr_parameter_23); }
  public void setCmCSB_CascContr_parameter_23(double v) { setDouble(CmCSB_CascContr_parameter_23,v,null); }
// WCS-01: start point OAT winter comp. SAT
  public static final Property CmCSB_CascContr_parameter_24 = newProperty( 0, BDouble.make( -10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSB_CascContr_parameter_24() { return getDouble(CmCSB_CascContr_parameter_24); }
  public void setCmCSB_CascContr_parameter_24(double v) { setDouble(CmCSB_CascContr_parameter_24,v,null); }
// WCS-02: end  point OAT winter comp. SAT
  public static final Property CmCSB_CascContr_parameter_25 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSB_CascContr_parameter_25() { return getDouble(CmCSB_CascContr_parameter_25); }
  public void setCmCSB_CascContr_parameter_25(double v) { setDouble(CmCSB_CascContr_parameter_25,v,null); }
// WCS-03: supply air temperature setpoint  raise
  public static final Property CmCSB_CascContr_parameter_26 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(10)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSB_CascContr_parameter_26() { return getDouble(CmCSB_CascContr_parameter_26); }
  public void setCmCSB_CascContr_parameter_26(double v) { setDouble(CmCSB_CascContr_parameter_26,v,null); }
// SAT-03: supply air temp. control P-band
  public static final Property CmCSB_CascContr_parameter_28 = newProperty( 0, BDouble.make( 200 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(5000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSB_CascContr_parameter_28() { return getDouble(CmCSB_CascContr_parameter_28); }
  public void setCmCSB_CascContr_parameter_28(double v) { setDouble(CmCSB_CascContr_parameter_28,v,null); }
// SAT-04: supply air temp. control I-time
  public static final Property CmCSB_CascContr_parameter_29 = newProperty( 0, BDouble.make( 50 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCSB_CascContr_parameter_29() { return getDouble(CmCSB_CascContr_parameter_29); }
  public void setCmCSB_CascContr_parameter_29(double v) { setDouble(CmCSB_CascContr_parameter_29,v,null); }
// SAT-05: sequence start point heating valve
  public static final Property CmCSB_CascContr_parameter_27 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSB_CascContr_parameter_27() { return getDouble(CmCSB_CascContr_parameter_27); }
  public void setCmCSB_CascContr_parameter_27(double v) { setDouble(CmCSB_CascContr_parameter_27,v,null); }
// SAT-06: sequence end point heating valve
  public static final Property CmCSB_CascContr_parameter_30 = newProperty( 0, BDouble.make( 40 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSB_CascContr_parameter_30() { return getDouble(CmCSB_CascContr_parameter_30); }
  public void setCmCSB_CascContr_parameter_30(double v) { setDouble(CmCSB_CascContr_parameter_30,v,null); }
// SAT-07: sequence start point dampers
  public static final Property CmCSB_CascContr_parameter_226 = newProperty( 0, BDouble.make( 40 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSB_CascContr_parameter_226() { return getDouble(CmCSB_CascContr_parameter_226); }
  public void setCmCSB_CascContr_parameter_226(double v) { setDouble(CmCSB_CascContr_parameter_226,v,null); }
// SAT-08: sequence end point dampers
  public static final Property CmCSB_CascContr_parameter_227 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSB_CascContr_parameter_227() { return getDouble(CmCSB_CascContr_parameter_227); }
  public void setCmCSB_CascContr_parameter_227(double v) { setDouble(CmCSB_CascContr_parameter_227,v,null); }
// SAT-09: sequence start point energy recovery
  public static final Property CmCSB_CascContr_parameter_31 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSB_CascContr_parameter_31() { return getDouble(CmCSB_CascContr_parameter_31); }
  public void setCmCSB_CascContr_parameter_31(double v) { setDouble(CmCSB_CascContr_parameter_31,v,null); }
// SAT-10 :sequence end point energy recovery
  public static final Property CmCSB_CascContr_parameter_32 = newProperty( 0, BDouble.make( 80 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSB_CascContr_parameter_32() { return getDouble(CmCSB_CascContr_parameter_32); }
  public void setCmCSB_CascContr_parameter_32(double v) { setDouble(CmCSB_CascContr_parameter_32,v,null); }
// SAT-11: sequence start point cooling valve
  public static final Property CmCSB_CascContr_parameter_33 = newProperty( 0, BDouble.make( 80 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSB_CascContr_parameter_33() { return getDouble(CmCSB_CascContr_parameter_33); }
  public void setCmCSB_CascContr_parameter_33(double v) { setDouble(CmCSB_CascContr_parameter_33,v,null); }
// SAT-12: sequence end point cooling valve
  public static final Property CmCSB_CascContr_parameter_34 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSB_CascContr_parameter_34() { return getDouble(CmCSB_CascContr_parameter_34); }
  public void setCmCSB_CascContr_parameter_34(double v) { setDouble(CmCSB_CascContr_parameter_34,v,null); }
// CO2-01: air quality setpoint ; 0 = disable internal controller
  public static final Property CmCSB_CascContr_parameter_35 = newProperty( 0, BDouble.make( 1000 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(10000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("parts per million"))));
  public double getCmCSB_CascContr_parameter_35() { return getDouble(CmCSB_CascContr_parameter_35); }
  public void setCmCSB_CascContr_parameter_35(double v) { setDouble(CmCSB_CascContr_parameter_35,v,null); }
// CO2-02: air quality P-band
  public static final Property CmCSB_CascContr_parameter_36 = newProperty( 0, BDouble.make( 200 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("parts per million"))));
  public double getCmCSB_CascContr_parameter_36() { return getDouble(CmCSB_CascContr_parameter_36); }
  public void setCmCSB_CascContr_parameter_36(double v) { setDouble(CmCSB_CascContr_parameter_36,v,null); }
// CO2-03: sequence start point air quality override dampers
  public static final Property CmCSB_CascContr_parameter_228 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSB_CascContr_parameter_228() { return getDouble(CmCSB_CascContr_parameter_228); }
  public void setCmCSB_CascContr_parameter_228(double v) { setDouble(CmCSB_CascContr_parameter_228,v,null); }
// CO2-04: sequence end point air quality override dampers
  public static final Property CmCSB_CascContr_parameter_229 = newProperty( 0, BDouble.make( 50 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSB_CascContr_parameter_229() { return getDouble(CmCSB_CascContr_parameter_229); }
  public void setCmCSB_CascContr_parameter_229(double v) { setDouble(CmCSB_CascContr_parameter_229,v,null); }
// CO2-05: sequence start point air quality override fan speed
  public static final Property CmCSB_CascContr_parameter_37 = newProperty( 0, BDouble.make( 50 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSB_CascContr_parameter_37() { return getDouble(CmCSB_CascContr_parameter_37); }
  public void setCmCSB_CascContr_parameter_37(double v) { setDouble(CmCSB_CascContr_parameter_37,v,null); }
// CO2-06: sequence end point air quality override fan speed
  public static final Property CmCSB_CascContr_parameter_38 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSB_CascContr_parameter_38() { return getDouble(CmCSB_CascContr_parameter_38); }
  public void setCmCSB_CascContr_parameter_38(double v) { setDouble(CmCSB_CascContr_parameter_38,v,null); }
// SYS-01: economizer function
  public static final Property CmCSB_CascContr_parameter_187 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCSB_CascContr_parameter_187() { return getDouble(CmCSB_CascContr_parameter_187); }
  public void setCmCSB_CascContr_parameter_187(double v) { setDouble(CmCSB_CascContr_parameter_187,v,null); }

  // macro inputs
// SupplyAirTemp
  public static final Property CmCSB_CascContr_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmCSB_CascContr_input_1() { return (BStatusNumeric) get(CmCSB_CascContr_input_1); }
  public void setCmCSB_CascContr_input_1(BStatusNumeric v) { set(CmCSB_CascContr_input_1,v,null); }
  public void setCmCSB_CascContr_input_1(float v) { getCmCSB_CascContr_input_1().setValue(v); }
// RoomRetAirTemp
  public static final Property CmCSB_CascContr_input_172 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmCSB_CascContr_input_172() { return (BStatusNumeric) get(CmCSB_CascContr_input_172); }
  public void setCmCSB_CascContr_input_172(BStatusNumeric v) { set(CmCSB_CascContr_input_172,v,null); }
  public void setCmCSB_CascContr_input_172(float v) { getCmCSB_CascContr_input_172().setValue(v); }
// RoomAirTempSp
  public static final Property CmCSB_CascContr_input_151 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmCSB_CascContr_input_151() { return (BStatusNumeric) get(CmCSB_CascContr_input_151); }
  public void setCmCSB_CascContr_input_151(BStatusNumeric v) { set(CmCSB_CascContr_input_151,v,null); }
  public void setCmCSB_CascContr_input_151(float v) { getCmCSB_CascContr_input_151().setValue(v); }
// ContrPtAdj
  public static final Property CmCSB_CascContr_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmCSB_CascContr_input_3() { return (BStatusNumeric) get(CmCSB_CascContr_input_3); }
  public void setCmCSB_CascContr_input_3(BStatusNumeric v) { set(CmCSB_CascContr_input_3,v,null); }
  public void setCmCSB_CascContr_input_3(float v) { getCmCSB_CascContr_input_3().setValue(v); }
// FilteredOATemp
  public static final Property CmCSB_CascContr_input_5 = newProperty( Flags.SUMMARY, new BStatusNumeric( 15 ), null);
  public BStatusNumeric getCmCSB_CascContr_input_5() { return (BStatusNumeric) get(CmCSB_CascContr_input_5); }
  public void setCmCSB_CascContr_input_5(BStatusNumeric v) { set(CmCSB_CascContr_input_5,v,null); }
  public void setCmCSB_CascContr_input_5(float v) { getCmCSB_CascContr_input_5().setValue(v); }
// CO2_Sensor
  public static final Property CmCSB_CascContr_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmCSB_CascContr_input_2() { return (BStatusNumeric) get(CmCSB_CascContr_input_2); }
  public void setCmCSB_CascContr_input_2(BStatusNumeric v) { set(CmCSB_CascContr_input_2,v,null); }
  public void setCmCSB_CascContr_input_2(float v) { getCmCSB_CascContr_input_2().setValue(v); }
// FanEnable
  public static final Property CmCSB_CascContr_input_4 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmCSB_CascContr_input_4() { return (BStatusBoolean) get(CmCSB_CascContr_input_4); }
  public void setCmCSB_CascContr_input_4(BStatusBoolean v) { set(CmCSB_CascContr_input_4,v,null); }
  public void setCmCSB_CascContr_input_4(boolean v) { getCmCSB_CascContr_input_4().setValue(v); }
// EnRecSeqSwitch
  public static final Property CmCSB_CascContr_input_8 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmCSB_CascContr_input_8() { return (BStatusBoolean) get(CmCSB_CascContr_input_8); }
  public void setCmCSB_CascContr_input_8(BStatusBoolean v) { set(CmCSB_CascContr_input_8,v,null); }
  public void setCmCSB_CascContr_input_8(boolean v) { getCmCSB_CascContr_input_8().setValue(v); }
// MinSAT_SpShift
  public static final Property CmCSB_CascContr_input_256 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmCSB_CascContr_input_256() { return (BStatusNumeric) get(CmCSB_CascContr_input_256); }
  public void setCmCSB_CascContr_input_256(BStatusNumeric v) { set(CmCSB_CascContr_input_256,v,null); }
  public void setCmCSB_CascContr_input_256(float v) { getCmCSB_CascContr_input_256().setValue(v); }
// PlantMode
  public static final Property CmCSB_CascContr_input_6 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmCSB_CascContr_input_6() { return (BStatusNumeric) get(CmCSB_CascContr_input_6); }
  public void setCmCSB_CascContr_input_6(BStatusNumeric v) { set(CmCSB_CascContr_input_6,v,null); }
  public void setCmCSB_CascContr_input_6(float v) { getCmCSB_CascContr_input_6().setValue(v); }
// HumidityMode
  public static final Property CmCSB_CascContr_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmCSB_CascContr_input_7() { return (BStatusNumeric) get(CmCSB_CascContr_input_7); }
  public void setCmCSB_CascContr_input_7(BStatusNumeric v) { set(CmCSB_CascContr_input_7,v,null); }
  public void setCmCSB_CascContr_input_7(float v) { getCmCSB_CascContr_input_7().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.08 [127] 19.03.2018-14:56").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5899663857315480302").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmCSB_CascContr.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions

  // class variables
  protected CmIDT20 func_54 = new CmIDT20();
  protected CmIDT20 func_189 = new CmIDT20();
  protected CmIDT05 func_230 = new CmIDT05();
  protected CmSummer_Compensation func_135 = new CmSummer_Compensation();
  protected CmControl_Point_Adjustment func_82 = new CmControl_Point_Adjustment();
  protected CmAHU_Startup func_40 = new CmAHU_Startup();
  protected CmCascaded_Control func_152 = new CmCascaded_Control();
  protected CmAHU_Setpoint_Ramp func_43 = new CmAHU_Setpoint_Ramp();
  protected CmLimit_SAT func_118 = new CmLimit_SAT();
  protected CmSupply_PID func_204 = new CmSupply_PID();
  protected CmERC_Reverse func_121 = new CmERC_Reverse();
  protected CmOutput_Sequence func_104 = new CmOutput_Sequence();
  protected CmOAT_Limits func_113 = new CmOAT_Limits();
  protected CmFan_Sequence func_195 = new CmFan_Sequence();
  protected CmDamper_Sequence func_222 = new CmDamper_Sequence();
  protected CmCO2_Control func_101 = new CmCO2_Control();
  protected CmDMP_Recirculation func_223 = new CmDMP_Recirculation();
  protected CmFrost_Protection func_76 = new CmFrost_Protection();
  protected CfSubtract func_253 = new CfSubtract();

  // default constructor
  public BCmCSB_CascContr()
  {
  }

  public void Start()
  {
    func_54.Start();
    func_189.Start();
    func_230.Start();
    func_135.Start();
    func_82.Start();
    func_40.Start();
    func_152.Start();
    func_43.Start();
    func_118.Start();
    func_204.Start();
    func_121.Start();
    func_104.Start();
    func_113.Start();
    func_195.Start();
    func_222.Start();
    func_101.Start();
    func_223.Start();
    func_76.Start();
  }
}
