/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    DMA_OnOffDamper
Macro id:      5823655416724194181
Macro version: 34
Last change:   16.02.2015 - 07:18
Access Level:  2
Inputs:
  [1] DamperEnable
  [2] OAD_EndSwitch
  [3] EAD_EndSwitch
  [4] PlantMode
Outputs:
  [1] OAD_Cmd
  [2] EAD_Cmd
  [3] FanEnable
  [4] DamperAlarm
  [5] OperationMode
Parameter:
  [1] ALM-01: damper run time
  [2] ALM-02: proximity switch existent
  [3] DISP-01: outside air damper alarm
  [4] DISP-02: exhaust air damper alarm
Description:
The macro "DMA_OnOffDamper" is an output module. This macro provides 2-position control of the outside air and exhaust air dampers, with integrated options for fan enable and plant mode.
================================================================================*/

public class BCmDMA_OnOffDamper
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmDMA_OnOffDamper_output_6().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmDMA_OnOffDamper_output_6().setStatus(BStatus.disabled);
    getCmDMA_OnOffDamper_output_7().setStatus(BStatus.disabled);
    getCmDMA_OnOffDamper_output_8().setStatus(BStatus.disabled);
    getCmDMA_OnOffDamper_output_9().setStatus(BStatus.disabled);
    getCmDMA_OnOffDamper_output_714().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmDMA_OnOffDamper_output_6().setStatus(BStatus.ok);
    getCmDMA_OnOffDamper_output_7().setStatus(BStatus.ok);
    getCmDMA_OnOffDamper_output_8().setStatus(BStatus.ok);
    getCmDMA_OnOffDamper_output_9().setStatus(BStatus.ok);
    getCmDMA_OnOffDamper_output_714().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [324] Function call CfIdt
    func_324.input = BooleanToFloat(func_81.outputOR);
    func_324.Execute(  );
    setCmDMA_OnOffDamper_output_9(FloatToBoolean(func_324.output[0]));

    // [470] Macro call CmDevice_Released
    func_470.CmDevice_Released_input_1 = (float) getCmDMA_OnOffDamper_input_5().getValue();
    func_470.CmDevice_Released_input_2 = getCmDMA_OnOffDamper_input_1().getValue();
    func_470.Execute(  );

    // [492] Function call CfIdt
    func_492.input = (float) getCmDMA_OnOffDamper_parameter_11();
    func_492.Execute(  );
    setParameter(0, func_492.output[0]);

    // [533] Function call CfIdt
    func_533.input = (float) getCmDMA_OnOffDamper_parameter_11();
    func_533.Execute(  );
    setParameter(1, func_533.output[0]);
    setParameter(2, func_533.output[1]);

    // [547] Function call CfCompare1
    func_547.inputA = (float) getCmDMA_OnOffDamper_input_5().getValue();
    func_547.inputB = 20F;
    func_547.Execute(  );

    // [548] Function call CfCompare1
    func_548.inputA = (float) getCmDMA_OnOffDamper_input_5().getValue();
    func_548.inputB = 21F;
    func_548.Execute(  );

    // [549] Function call CfCompare1
    func_549.inputA = (float) getCmDMA_OnOffDamper_input_5().getValue();
    func_549.inputB = 30F;
    func_549.Execute(  );

    // [325] Function call CfNot
    func_325.input = FloatToBoolean(func_324.output[1]);
    func_325.Execute(  );

    // [326] Function call CfIdt
    func_326.input = BooleanToFloat(func_470.CmDevice_Released_output_3);
    func_326.Execute(  );

    // [700] Function call CfOr
    func_700.input[0] = func_547.outputEqual;
    func_700.input[1] = func_548.outputEqual;
    func_700.input[2] = func_549.outputEqual;
    func_700.Execute(  );

    // [705] Function call CfInputMultiplexer
    func_705.inputSelect = BooleanToInt(func_548.outputEqual);
    func_705.input[1-1] = 15F;
    func_705.input[2-1] = 13F;
    func_705.Execute(  );

    // [354] Function call CfAnd
    func_354.input[0] = FloatToBoolean(func_326.output[2]);
    func_354.input[1] = getCmDMA_OnOffDamper_input_2().getValue();
    func_354.input[2] = getCmDMA_OnOffDamper_input_3().getValue();
    func_354.Execute(  );

    // [382] Function call CfInputMultiplexer
    func_382.inputSelect = FloatToInt((float) getCmDMA_OnOffDamper_parameter_12());
    func_382.input[1-1] = 0F;
    func_382.input[2-1] = func_326.output[2];
    func_382.Execute(  );

    // [384] Function call CfDelay
    func_384.inputA = FloatToBoolean(func_326.output[2]);
    func_384.inputB = FloatToBoolean(func_326.output[2]);
    func_384.Execute( this, 0 );

    // [565] Function call CfInputMultiplexer
    func_565.inputSelect = BooleanToInt(func_700.outputOR);
    func_565.input[1-1] = BooleanToFloat(func_97.outputAND);
    func_565.input[2-1] = 0F;
    func_565.Execute(  );
    setCmDMA_OnOffDamper_output_8(FloatToBoolean(func_565.output));

    // [598] Function call CfInputMultiplexer
    func_598.inputSelect = BooleanToInt(func_700.outputOR);
    func_598.input[1-1] = func_326.output[0];
    func_598.input[2-1] = 0F;
    func_598.Execute(  );
    setCmDMA_OnOffDamper_output_6(FloatToBoolean(func_598.output));

    // [642] Function call CfInputMultiplexer
    func_642.inputSelect = BooleanToInt(func_700.outputOR);
    func_642.input[1-1] = func_326.output[1];
    func_642.input[2-1] = 0F;
    func_642.Execute(  );
    setCmDMA_OnOffDamper_output_7(FloatToBoolean(func_642.output));

    // [706] Function call CfInputMultiplexer
    func_706.inputSelect = BooleanToInt(func_547.outputEqual);
    func_706.input[1-1] = func_705.output;
    func_706.input[2-1] = 12F;
    func_706.Execute(  );

    // [353] Function call CfInputMultiplexer
    func_353.inputSelect = FloatToInt((float) getCmDMA_OnOffDamper_parameter_12());
    func_353.input[1-1] = BooleanToFloat(func_384.outputDelayedA);
    func_353.input[2-1] = BooleanToFloat(func_354.outputAND);
    func_353.Execute(  );

    // [524] Function call CfDelay
    func_524.inputA = FloatToBoolean(func_382.output);
    func_524.inputB = getCmDMA_OnOffDamper_input_2().getValue();
    func_524.Execute( this, 1 );

    // [527] Function call CfDelay
    func_527.inputA = FloatToBoolean(func_382.output);
    func_527.inputB = getCmDMA_OnOffDamper_input_3().getValue();
    func_527.Execute( this, 2 );

    // [707] Function call CfInputMultiplexer
    func_707.inputSelect = FloatToInt(func_324.output[1]);
    func_707.input[1-1] = func_706.output;
    func_707.input[2-1] = 10F;
    func_707.Execute(  );

    // [507] Function call CfIdt
    func_507.input = BooleanToFloat(func_524.outputAlarm);
    func_507.Execute(  );
    setCmDMA_OnOffDamper_parameter_327(func_507.output[0]);

    // [508] Function call CfIdt
    func_508.input = BooleanToFloat(func_527.outputAlarm);
    func_508.Execute(  );
    setCmDMA_OnOffDamper_parameter_350(func_508.output[1]);

    // [81] Function call CfOr
    func_81.input[0] = FloatToBoolean(func_507.output[1]);
    func_81.input[1] = FloatToBoolean(func_508.output[0]);
    func_81.Execute(  );

    // [97] Function call CfAnd
    func_97.input[0] = func_325.output;
    func_97.input[1] = FloatToBoolean(func_353.output);
    func_97.Execute(  );

    // [709] Function call CfInputMultiplexer
    func_709.inputSelect = BooleanToInt(func_549.outputEqual);
    func_709.input[1-1] = func_707.output;
    func_709.input[2-1] = 2F;
    func_709.Execute(  );
    setCmDMA_OnOffDamper_output_714(func_709.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    10F, 10F, 10F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// OAD_Cmd
  public static final Property CmDMA_OnOffDamper_output_6 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDMA_OnOffDamper_output_6() { return (BStatusBoolean) get(CmDMA_OnOffDamper_output_6); }
  public void setCmDMA_OnOffDamper_output_6(BStatusBoolean v) { set(CmDMA_OnOffDamper_output_6,v,null); }
  public void setCmDMA_OnOffDamper_output_6(boolean v) { getCmDMA_OnOffDamper_output_6().setValue(v); }
// EAD_Cmd
  public static final Property CmDMA_OnOffDamper_output_7 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDMA_OnOffDamper_output_7() { return (BStatusBoolean) get(CmDMA_OnOffDamper_output_7); }
  public void setCmDMA_OnOffDamper_output_7(BStatusBoolean v) { set(CmDMA_OnOffDamper_output_7,v,null); }
  public void setCmDMA_OnOffDamper_output_7(boolean v) { getCmDMA_OnOffDamper_output_7().setValue(v); }
// FanEnable
  public static final Property CmDMA_OnOffDamper_output_8 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDMA_OnOffDamper_output_8() { return (BStatusBoolean) get(CmDMA_OnOffDamper_output_8); }
  public void setCmDMA_OnOffDamper_output_8(BStatusBoolean v) { set(CmDMA_OnOffDamper_output_8,v,null); }
  public void setCmDMA_OnOffDamper_output_8(boolean v) { getCmDMA_OnOffDamper_output_8().setValue(v); }
// DamperAlarm
  public static final Property CmDMA_OnOffDamper_output_9 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDMA_OnOffDamper_output_9() { return (BStatusBoolean) get(CmDMA_OnOffDamper_output_9); }
  public void setCmDMA_OnOffDamper_output_9(BStatusBoolean v) { set(CmDMA_OnOffDamper_output_9,v,null); }
  public void setCmDMA_OnOffDamper_output_9(boolean v) { getCmDMA_OnOffDamper_output_9().setValue(v); }
// OperationMode
  public static final Property CmDMA_OnOffDamper_output_714 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmDMA_OnOffDamper_output_714() { return (BStatusNumeric) get(CmDMA_OnOffDamper_output_714); }
  public void setCmDMA_OnOffDamper_output_714(BStatusNumeric v) { set(CmDMA_OnOffDamper_output_714,v,null); }
  public void setCmDMA_OnOffDamper_output_714(float v) { getCmDMA_OnOffDamper_output_714().setValue(v); }

  // macro parameter
// ALM-01: damper run time
  public static final Property CmDMA_OnOffDamper_parameter_11 = newProperty( 0, BDouble.make( 150 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1440)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmDMA_OnOffDamper_parameter_11() { return getDouble(CmDMA_OnOffDamper_parameter_11); }
  public void setCmDMA_OnOffDamper_parameter_11(double v) { setDouble(CmDMA_OnOffDamper_parameter_11,v,null); }
// ALM-02: proximity switch existent
  public static final Property CmDMA_OnOffDamper_parameter_12 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmDMA_OnOffDamper_parameter_12() { return getDouble(CmDMA_OnOffDamper_parameter_12); }
  public void setCmDMA_OnOffDamper_parameter_12(double v) { setDouble(CmDMA_OnOffDamper_parameter_12,v,null); }
// DISP-01: outside air damper alarm
  public static final Property CmDMA_OnOffDamper_parameter_327 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmDMA_OnOffDamper_parameter_327() { return getDouble(CmDMA_OnOffDamper_parameter_327); }
  public void setCmDMA_OnOffDamper_parameter_327(double v) { setDouble(CmDMA_OnOffDamper_parameter_327,v,null); }
// DISP-02: exhaust air damper alarm
  public static final Property CmDMA_OnOffDamper_parameter_350 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmDMA_OnOffDamper_parameter_350() { return getDouble(CmDMA_OnOffDamper_parameter_350); }
  public void setCmDMA_OnOffDamper_parameter_350(double v) { setDouble(CmDMA_OnOffDamper_parameter_350,v,null); }

  // macro inputs
// DamperEnable
  public static final Property CmDMA_OnOffDamper_input_1 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmDMA_OnOffDamper_input_1() { return (BStatusBoolean) get(CmDMA_OnOffDamper_input_1); }
  public void setCmDMA_OnOffDamper_input_1(BStatusBoolean v) { set(CmDMA_OnOffDamper_input_1,v,null); }
  public void setCmDMA_OnOffDamper_input_1(boolean v) { getCmDMA_OnOffDamper_input_1().setValue(v); }
// OAD_EndSwitch
  public static final Property CmDMA_OnOffDamper_input_2 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmDMA_OnOffDamper_input_2() { return (BStatusBoolean) get(CmDMA_OnOffDamper_input_2); }
  public void setCmDMA_OnOffDamper_input_2(BStatusBoolean v) { set(CmDMA_OnOffDamper_input_2,v,null); }
  public void setCmDMA_OnOffDamper_input_2(boolean v) { getCmDMA_OnOffDamper_input_2().setValue(v); }
// EAD_EndSwitch
  public static final Property CmDMA_OnOffDamper_input_3 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmDMA_OnOffDamper_input_3() { return (BStatusBoolean) get(CmDMA_OnOffDamper_input_3); }
  public void setCmDMA_OnOffDamper_input_3(BStatusBoolean v) { set(CmDMA_OnOffDamper_input_3,v,null); }
  public void setCmDMA_OnOffDamper_input_3(boolean v) { getCmDMA_OnOffDamper_input_3().setValue(v); }
// PlantMode
  public static final Property CmDMA_OnOffDamper_input_5 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmDMA_OnOffDamper_input_5() { return (BStatusNumeric) get(CmDMA_OnOffDamper_input_5); }
  public void setCmDMA_OnOffDamper_input_5(BStatusNumeric v) { set(CmDMA_OnOffDamper_input_5,v,null); }
  public void setCmDMA_OnOffDamper_input_5(float v) { getCmDMA_OnOffDamper_input_5().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.05 [34] 16.02.2015-07:18").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5823655416724194181").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmDMA_OnOffDamper.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfIdt func_324 = new CfIdt();
  protected CmDevice_Released func_470 = new CmDevice_Released();
  protected CfIdt func_492 = new CfIdt();
  protected CfIdt func_533 = new CfIdt();
  protected CfCompare1 func_547 = new CfCompare1();
  protected CfCompare1 func_548 = new CfCompare1();
  protected CfCompare1 func_549 = new CfCompare1();
  protected CfNot func_325 = new CfNot();
  protected CfIdt func_326 = new CfIdt();
  protected CfOr func_700 = new CfOr();
  protected CfInputMultiplexer func_705 = new CfInputMultiplexer();
  protected CfAnd func_354 = new CfAnd();
  protected CfInputMultiplexer func_382 = new CfInputMultiplexer();
  protected CfDelay func_384 = new CfDelay();
  protected CfInputMultiplexer func_565 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_598 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_642 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_706 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_353 = new CfInputMultiplexer();
  protected CfDelay func_524 = new CfDelay();
  protected CfDelay func_527 = new CfDelay();
  protected CfInputMultiplexer func_707 = new CfInputMultiplexer();
  protected CfIdt func_507 = new CfIdt();
  protected CfIdt func_508 = new CfIdt();
  protected CfOr func_81 = new CfOr();
  protected CfAnd func_97 = new CfAnd();
  protected CfInputMultiplexer func_709 = new CfInputMultiplexer();

  // default constructor
  public BCmDMA_OnOffDamper()
  {
    func_324.configure(2);
    func_533.configure(2);
    func_326.configure(3);
    func_700.configure(3);
    func_354.configure(3);
    func_507.configure(2);
    func_508.configure(2);
  }

  public void Start()
  {
    func_470.Start();
    func_384.Start();
    func_524.Start();
    func_527.Start();
  }
}
