/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    DMB_MixingDamper
Macro id:      5831850202017825547
Macro version: 49
Last change:   20.03.2018 - 10:39
Access Level:  2
Inputs:
  [1] DamperCtrlSig
  [2] DamperEnable
  [3] DamperMinPos
  [4] OutsideAirTemp
  [5] MixedAirTemp
  [6] PlantMode
Outputs:
  [1] OAD_Control
  [2] EAD_Control
  [3] MXD_Control
  [4] FanEnable
  [5] OperationMode
Parameter:
  [1] DMA-01 damper runtime
  [2] MAT-01 min mixed air temp setpiont
  [3] MAT-02 max mixed air temp setpoint
  [4] MAT-03 mixed air temp control P-band
  [5] OAT-01 min limit outside air temp
  [6] OAT-02 max limit outside air temp
  [7] DMS-01 Y-min Pos damper signal
  [8] DMS-02 Y-max Pos damper signal
  [9] DISP-01 display setpoint mixed air temp
Description:
The Macro "DMB_MixingDamper" is an output module for modulating control of mixed air dampers. Alternatively, it can be used as a standalone module for mixed air temperature control. 
This module provides modulating control of the outside air, mixed air and exhaust air dampers, with integrated options for fan enable, plant override.
================================================================================*/

public class BCmDMB_MixingDamper
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmDMB_MixingDamper_output_9().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmDMB_MixingDamper_output_9().setStatus(BStatus.disabled);
    getCmDMB_MixingDamper_output_10().setStatus(BStatus.disabled);
    getCmDMB_MixingDamper_output_11().setStatus(BStatus.disabled);
    getCmDMB_MixingDamper_output_12().setStatus(BStatus.disabled);
    getCmDMB_MixingDamper_output_1580().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmDMB_MixingDamper_output_9().setStatus(BStatus.ok);
    getCmDMB_MixingDamper_output_10().setStatus(BStatus.ok);
    getCmDMB_MixingDamper_output_11().setStatus(BStatus.ok);
    getCmDMB_MixingDamper_output_12().setStatus(BStatus.ok);
    getCmDMB_MixingDamper_output_1580().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [50] Function call CfIdt
    func_50.input = (float) getCmDMB_MixingDamper_input_2().getValue();
    func_50.Execute(  );

    // [55] Function call CfCompare1
    func_55.inputA = (float) getCmDMB_MixingDamper_input_3().getValue();
    func_55.inputB = 999F;
    func_55.Execute(  );

    // [56] Function call CfNot
    func_56.input = func_55.outputLess;
    func_56.Execute(  );

    // [57] Function call CfCompare1
    func_57.inputA = func_50.output[0];
    func_57.inputB = 999F;
    func_57.Execute(  );

    // [58] Function call CfNot
    func_58.input = func_57.outputLess;
    func_58.Execute(  );

    // [63] Function call CfIdt
    func_63.input = BooleanToFloat(func_56.output);
    func_63.Execute(  );

    // [973] Function call CfDelay
    func_973.inputA = getCmDMB_MixingDamper_input_1().getValue();
    func_973.inputB = getCmDMB_MixingDamper_input_1().getValue();
    func_973.Execute( this, 0 );

    // [977] Function call CfIdt
    func_977.input = (float) getCmDMB_MixingDamper_parameter_15();
    func_977.Execute(  );
    setParameter(0, func_977.output[0]);

    // [1492] Function call CfWindow
    func_1492.inputValue = (float) getCmDMB_MixingDamper_input_8().getValue();
    func_1492.inputMinimum = 0.5F;
    func_1492.inputMaximum = 6.5F;
    func_1492.Execute(  );

    // [1519] Macro call CmDamper_Control_Signal
    func_1519.CmDamper_Control_Signal_input_65 = (float) getCmDMB_MixingDamper_input_8().getValue();
    func_1519.CmDamper_Control_Signal_input_66 = (float) getCmDMB_MixingDamper_input_7().getValue();
    func_1519.CmDamper_Control_Signal_input_67 = (float) getCmDMB_MixingDamper_input_3().getValue();
    func_1519.CmDamper_Control_Signal_input_68 = func_66.output;
    func_1519.CmDamper_Control_Signal_input_70 = getCmDMB_MixingDamper_input_1().getValue();
    func_1519.CmDamper_Control_Signal_input_83 = getCmDMB_MixingDamper_input_1545().getValue();
    func_1519.CmDamper_Control_Signal_input_69 = FloatToBoolean(func_63.output[0]);
    func_1519.Execute( this, 1 );

    // [1520] Macro call CmIDT10
    func_1520.CmIDT10_input_1 = (float) getCmDMB_MixingDamper_parameter_19();
    func_1520.CmIDT10_input_2 = (float) getCmDMB_MixingDamper_parameter_20();
    func_1520.CmIDT10_input_3 = (float) getCmDMB_MixingDamper_parameter_16();
    func_1520.CmIDT10_input_4 = (float) getCmDMB_MixingDamper_parameter_17();
    func_1520.CmIDT10_input_5 = (float) getCmDMB_MixingDamper_parameter_18();
    func_1520.CmIDT10_input_6 = (float) getCmDMB_MixingDamper_parameter_21();
    func_1520.CmIDT10_input_7 = (float) getCmDMB_MixingDamper_parameter_22();
    func_1520.CmIDT10_input_8 = getParameter(8);
    func_1520.CmIDT10_input_9 = 0F;
    func_1520.CmIDT10_input_10 = 0F;
    func_1520.Execute(  );
    setParameter(4, func_1520.CmIDT10_output_21);
    setParameter(5, func_1520.CmIDT10_output_22);
    setParameter(1, func_1520.CmIDT10_output_23);
    setParameter(2, func_1520.CmIDT10_output_24);
    setParameter(3, func_1520.CmIDT10_output_25);
    setParameter(6, func_1520.CmIDT10_output_26);
    setParameter(7, func_1520.CmIDT10_output_27);
    setCmDMB_MixingDamper_parameter_27(func_1520.CmIDT10_output_28);

    // [64] Function call CfInputMultiplexer
    func_64.inputSelect = BooleanToInt(func_56.output);
    func_64.input[1-1] = (float) getCmDMB_MixingDamper_parameter_27();
    func_64.input[2-1] = 999F;
    func_64.Execute(  );
    setCmDMB_MixingDamper_parameter_27(func_64.output);

    // [66] Function call CfInputMultiplexer
    func_66.inputSelect = BooleanToInt(func_58.output);
    func_66.input[1-1] = func_50.output[1];
    func_66.input[2-1] = 100F;
    func_66.Execute(  );

    // [1552] Function call CfWindow
    func_1552.inputValue = (float) getCmDMB_MixingDamper_input_8().getValue();
    func_1552.inputMinimum = 19.8F;
    func_1552.inputMaximum = 30.2F;
    func_1552.Execute(  );

    // [1558] Function call CfCompare1
    func_1558.inputA = (float) getCmDMB_MixingDamper_input_8().getValue();
    func_1558.inputB = 20F;
    func_1558.Execute(  );

    // [1562] Function call CfCompare1
    func_1562.inputA = (float) getCmDMB_MixingDamper_input_8().getValue();
    func_1562.inputB = 30F;
    func_1562.Execute(  );

    // [1566] Function call CfCompare1
    func_1566.inputA = (float) getCmDMB_MixingDamper_input_8().getValue();
    func_1566.inputB = 21F;
    func_1566.Execute(  );

    // [1491] Function call CfAnd
    func_1491.input[0] = func_1492.output;
    func_1491.input[1] = func_973.outputDelayedA;
    func_1491.Execute(  );
    setCmDMB_MixingDamper_output_12(func_1491.outputAND);

    // [1553] Function call CfInputMultiplexer
    func_1553.inputSelect = BooleanToInt(func_1552.output);
    func_1553.input[1-1] = func_1519.CmDamper_Control_Signal_output_71;
    func_1553.input[2-1] = 0F;
    func_1553.Execute(  );
    setCmDMB_MixingDamper_output_9(func_1553.output);

    // [1554] Function call CfInputMultiplexer
    func_1554.inputSelect = BooleanToInt(func_1552.output);
    func_1554.input[1-1] = func_1519.CmDamper_Control_Signal_output_72;
    func_1554.input[2-1] = 0F;
    func_1554.Execute(  );
    setCmDMB_MixingDamper_output_10(func_1554.output);

    // [1555] Function call CfInputMultiplexer
    func_1555.inputSelect = BooleanToInt(func_1552.output);
    func_1555.input[1-1] = func_1519.CmDamper_Control_Signal_output_73;
    func_1555.input[2-1] = 0F;
    func_1555.Execute(  );
    setCmDMB_MixingDamper_output_11(func_1555.output);

    // [1572] Function call CfInputMultiplexer
    func_1572.inputSelect = BooleanToInt(func_1566.outputEqual);
    func_1572.input[1-1] = 15F;
    func_1572.input[2-1] = 13F;
    func_1572.Execute(  );

    // [1570] Function call CfInputMultiplexer
    func_1570.inputSelect = BooleanToInt(func_1558.outputEqual);
    func_1570.input[1-1] = func_1572.output;
    func_1570.input[2-1] = 12F;
    func_1570.Execute(  );

    // [1574] Function call CfInputMultiplexer
    func_1574.inputSelect = BooleanToInt(func_1562.outputEqual);
    func_1574.input[1-1] = func_1570.output;
    func_1574.input[2-1] = 2F;
    func_1574.Execute(  );
    setCmDMB_MixingDamper_output_1580(func_1574.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    10F, 10F, 15F, 10F, -10F, 10F, 20F, 100F,
    0F, -100F, 100F, -100F, 100F, -10F, 20F, 10F,
    10F, 15F, 100F, 15F, 0F, 110F, -10F, 110F,
    0F, 0F, 50F, 50F, 50F, 100F, 100F, 0F,
    100F, -1F, 100F, -1F, 0F, 0F, 0F, 23F,
    100F, 100F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// OAD_Control
  public static final Property CmDMB_MixingDamper_output_9 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmDMB_MixingDamper_output_9() { return (BStatusNumeric) get(CmDMB_MixingDamper_output_9); }
  public void setCmDMB_MixingDamper_output_9(BStatusNumeric v) { set(CmDMB_MixingDamper_output_9,v,null); }
  public void setCmDMB_MixingDamper_output_9(float v) { getCmDMB_MixingDamper_output_9().setValue(v); }
// EAD_Control
  public static final Property CmDMB_MixingDamper_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmDMB_MixingDamper_output_10() { return (BStatusNumeric) get(CmDMB_MixingDamper_output_10); }
  public void setCmDMB_MixingDamper_output_10(BStatusNumeric v) { set(CmDMB_MixingDamper_output_10,v,null); }
  public void setCmDMB_MixingDamper_output_10(float v) { getCmDMB_MixingDamper_output_10().setValue(v); }
// MXD_Control
  public static final Property CmDMB_MixingDamper_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmDMB_MixingDamper_output_11() { return (BStatusNumeric) get(CmDMB_MixingDamper_output_11); }
  public void setCmDMB_MixingDamper_output_11(BStatusNumeric v) { set(CmDMB_MixingDamper_output_11,v,null); }
  public void setCmDMB_MixingDamper_output_11(float v) { getCmDMB_MixingDamper_output_11().setValue(v); }
// FanEnable
  public static final Property CmDMB_MixingDamper_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDMB_MixingDamper_output_12() { return (BStatusBoolean) get(CmDMB_MixingDamper_output_12); }
  public void setCmDMB_MixingDamper_output_12(BStatusBoolean v) { set(CmDMB_MixingDamper_output_12,v,null); }
  public void setCmDMB_MixingDamper_output_12(boolean v) { getCmDMB_MixingDamper_output_12().setValue(v); }
// OperationMode
  public static final Property CmDMB_MixingDamper_output_1580 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmDMB_MixingDamper_output_1580() { return (BStatusNumeric) get(CmDMB_MixingDamper_output_1580); }
  public void setCmDMB_MixingDamper_output_1580(BStatusNumeric v) { set(CmDMB_MixingDamper_output_1580,v,null); }
  public void setCmDMB_MixingDamper_output_1580(float v) { getCmDMB_MixingDamper_output_1580().setValue(v); }

  // macro parameter
// DMA-01 damper runtime
  public static final Property CmDMB_MixingDamper_parameter_15 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1440)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmDMB_MixingDamper_parameter_15() { return getDouble(CmDMB_MixingDamper_parameter_15); }
  public void setCmDMB_MixingDamper_parameter_15(double v) { setDouble(CmDMB_MixingDamper_parameter_15,v,null); }
// MAT-01 min mixed air temp setpiont
  public static final Property CmDMB_MixingDamper_parameter_16 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmDMB_MixingDamper_parameter_16() { return getDouble(CmDMB_MixingDamper_parameter_16); }
  public void setCmDMB_MixingDamper_parameter_16(double v) { setDouble(CmDMB_MixingDamper_parameter_16,v,null); }
// MAT-02 max mixed air temp setpoint
  public static final Property CmDMB_MixingDamper_parameter_17 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmDMB_MixingDamper_parameter_17() { return getDouble(CmDMB_MixingDamper_parameter_17); }
  public void setCmDMB_MixingDamper_parameter_17(double v) { setDouble(CmDMB_MixingDamper_parameter_17,v,null); }
// MAT-03 mixed air temp control P-band
  public static final Property CmDMB_MixingDamper_parameter_18 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(5000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmDMB_MixingDamper_parameter_18() { return getDouble(CmDMB_MixingDamper_parameter_18); }
  public void setCmDMB_MixingDamper_parameter_18(double v) { setDouble(CmDMB_MixingDamper_parameter_18,v,null); }
// OAT-01 min limit outside air temp
  public static final Property CmDMB_MixingDamper_parameter_19 = newProperty( 0, BDouble.make( -10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmDMB_MixingDamper_parameter_19() { return getDouble(CmDMB_MixingDamper_parameter_19); }
  public void setCmDMB_MixingDamper_parameter_19(double v) { setDouble(CmDMB_MixingDamper_parameter_19,v,null); }
// OAT-02 max limit outside air temp
  public static final Property CmDMB_MixingDamper_parameter_20 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmDMB_MixingDamper_parameter_20() { return getDouble(CmDMB_MixingDamper_parameter_20); }
  public void setCmDMB_MixingDamper_parameter_20(double v) { setDouble(CmDMB_MixingDamper_parameter_20,v,null); }
// DMS-01 Y-min Pos damper signal
  public static final Property CmDMB_MixingDamper_parameter_21 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmDMB_MixingDamper_parameter_21() { return getDouble(CmDMB_MixingDamper_parameter_21); }
  public void setCmDMB_MixingDamper_parameter_21(double v) { setDouble(CmDMB_MixingDamper_parameter_21,v,null); }
// DMS-02 Y-max Pos damper signal
  public static final Property CmDMB_MixingDamper_parameter_22 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmDMB_MixingDamper_parameter_22() { return getDouble(CmDMB_MixingDamper_parameter_22); }
  public void setCmDMB_MixingDamper_parameter_22(double v) { setDouble(CmDMB_MixingDamper_parameter_22,v,null); }
// DISP-01 display setpoint mixed air temp
  public static final Property CmDMB_MixingDamper_parameter_27 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmDMB_MixingDamper_parameter_27() { return getDouble(CmDMB_MixingDamper_parameter_27); }
  public void setCmDMB_MixingDamper_parameter_27(double v) { setDouble(CmDMB_MixingDamper_parameter_27,v,null); }

  // macro inputs
// DamperCtrlSig
  public static final Property CmDMB_MixingDamper_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmDMB_MixingDamper_input_2() { return (BStatusNumeric) get(CmDMB_MixingDamper_input_2); }
  public void setCmDMB_MixingDamper_input_2(BStatusNumeric v) { set(CmDMB_MixingDamper_input_2,v,null); }
  public void setCmDMB_MixingDamper_input_2(float v) { getCmDMB_MixingDamper_input_2().setValue(v); }
// DamperEnable
  public static final Property CmDMB_MixingDamper_input_1 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmDMB_MixingDamper_input_1() { return (BStatusBoolean) get(CmDMB_MixingDamper_input_1); }
  public void setCmDMB_MixingDamper_input_1(BStatusBoolean v) { set(CmDMB_MixingDamper_input_1,v,null); }
  public void setCmDMB_MixingDamper_input_1(boolean v) { getCmDMB_MixingDamper_input_1().setValue(v); }
// DamperMinPos
  public static final Property CmDMB_MixingDamper_input_1545 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmDMB_MixingDamper_input_1545() { return (BStatusBoolean) get(CmDMB_MixingDamper_input_1545); }
  public void setCmDMB_MixingDamper_input_1545(BStatusBoolean v) { set(CmDMB_MixingDamper_input_1545,v,null); }
  public void setCmDMB_MixingDamper_input_1545(boolean v) { getCmDMB_MixingDamper_input_1545().setValue(v); }
// OutsideAirTemp
  public static final Property CmDMB_MixingDamper_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmDMB_MixingDamper_input_7() { return (BStatusNumeric) get(CmDMB_MixingDamper_input_7); }
  public void setCmDMB_MixingDamper_input_7(BStatusNumeric v) { set(CmDMB_MixingDamper_input_7,v,null); }
  public void setCmDMB_MixingDamper_input_7(float v) { getCmDMB_MixingDamper_input_7().setValue(v); }
// MixedAirTemp
  public static final Property CmDMB_MixingDamper_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmDMB_MixingDamper_input_3() { return (BStatusNumeric) get(CmDMB_MixingDamper_input_3); }
  public void setCmDMB_MixingDamper_input_3(BStatusNumeric v) { set(CmDMB_MixingDamper_input_3,v,null); }
  public void setCmDMB_MixingDamper_input_3(float v) { getCmDMB_MixingDamper_input_3().setValue(v); }
// PlantMode
  public static final Property CmDMB_MixingDamper_input_8 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmDMB_MixingDamper_input_8() { return (BStatusNumeric) get(CmDMB_MixingDamper_input_8); }
  public void setCmDMB_MixingDamper_input_8(BStatusNumeric v) { set(CmDMB_MixingDamper_input_8,v,null); }
  public void setCmDMB_MixingDamper_input_8(float v) { getCmDMB_MixingDamper_input_8().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.07 [49] 20.03.2018-10:39").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5831850202017825547").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmDMB_MixingDamper.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfIdt func_50 = new CfIdt();
  protected CfCompare1 func_55 = new CfCompare1();
  protected CfNot func_56 = new CfNot();
  protected CfCompare1 func_57 = new CfCompare1();
  protected CfNot func_58 = new CfNot();
  protected CfIdt func_63 = new CfIdt();
  protected CfDelay func_973 = new CfDelay();
  protected CfIdt func_977 = new CfIdt();
  protected CfWindow func_1492 = new CfWindow();
  protected CmDamper_Control_Signal func_1519 = new CmDamper_Control_Signal();
  protected CmIDT10 func_1520 = new CmIDT10();
  protected CfInputMultiplexer func_64 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_66 = new CfInputMultiplexer();
  protected CfWindow func_1552 = new CfWindow();
  protected CfCompare1 func_1558 = new CfCompare1();
  protected CfCompare1 func_1562 = new CfCompare1();
  protected CfCompare1 func_1566 = new CfCompare1();
  protected CfAnd func_1491 = new CfAnd();
  protected CfInputMultiplexer func_1553 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1554 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1555 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1572 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1570 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1574 = new CfInputMultiplexer();

  // default constructor
  public BCmDMB_MixingDamper()
  {
    func_50.configure(2);
  }

  public void Start()
  {
    func_973.Start();
    func_1519.Start();
    func_1520.Start();
  }
}
