/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    ERC_Plate
Macro id:      5880742776465785175
Macro version: 100
Last change:   20.03.2018 - 10:47
Access Level:  2
Inputs:
  [1] ERCCtrlSig
  [2] FilteredOATemp
  [3] EnRecTemp
  [4] DiffPressSwitch
  [5] PlantMode
Outputs:
  [1] EnRecControl
  [2] ERCFreezeProt
Parameter:
  [1] SYS-01: start-up delay
  [2] ERT-01: energy recovery temperature low setpoint
  [3] ERT-02: energy recovery temperature high setpoint
  [4] ERT-03: P-band energy recovery temperature control
  [5] OAT-01: outside air temperature minimum value
  [6] OAT-02: outside air temperature maximum value
  [7] ERS-01: minimum energy recovery control signal
  [8] ERS-02: maximum energy recovery control signal
  [9] ERS-03: difference IAT, RAT control signal sequence start
  [10] ERS-04: difference IAT, RAT control signal sequence stop
  [11] DISP-01: calc. setpoint energy recovery temperature
Description:
The macro "ERC_Plate" provides modulating control of energy recovery equipment of an air handling unit and operates in sequence with other output modules or as standalone module. The module has integrated features for plant mode overrides. This can be used in air handling systems for heating as well as for cooling or a combination of both and results in energy savings.

The energy recovery systems are equipped with temperature sensors which are connected to macro inputs.
================================================================================*/

public class BCmERC_Plate
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmERC_Plate_output_33().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmERC_Plate_output_33().setStatus(BStatus.disabled);
    getCmERC_Plate_output_261().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmERC_Plate_output_33().setStatus(BStatus.ok);
    getCmERC_Plate_output_261().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [234] Macro call CmIDT10
    func_234.CmIDT10_input_1 = (float) getCmERC_Plate_parameter_10();
    func_234.CmIDT10_input_2 = (float) getCmERC_Plate_parameter_11();
    func_234.CmIDT10_input_3 = (float) getCmERC_Plate_parameter_12();
    func_234.CmIDT10_input_4 = (float) getCmERC_Plate_parameter_13();
    func_234.CmIDT10_input_5 = (float) getCmERC_Plate_parameter_4();
    func_234.CmIDT10_input_6 = (float) getCmERC_Plate_parameter_5();
    func_234.CmIDT10_input_7 = (float) getCmERC_Plate_parameter_6();
    func_234.CmIDT10_input_8 = (float) getCmERC_Plate_parameter_7();
    func_234.CmIDT10_input_9 = (float) getCmERC_Plate_parameter_8();
    func_234.CmIDT10_input_10 = getParameter(10);
    func_234.Execute(  );
    setParameter(0, func_234.CmIDT10_output_21);
    setParameter(1, func_234.CmIDT10_output_22);
    setParameter(2, func_234.CmIDT10_output_23);
    setParameter(3, func_234.CmIDT10_output_24);
    setParameter(4, func_234.CmIDT10_output_25);
    setParameter(5, func_234.CmIDT10_output_26);
    setParameter(6, func_234.CmIDT10_output_27);
    setParameter(7, func_234.CmIDT10_output_28);
    setParameter(8, func_234.CmIDT10_output_29);
    setCmERC_Plate_parameter_22(func_234.CmIDT10_output_30);

    // [245] Function call CfIdt
    func_245.input = (float) getCmERC_Plate_parameter_247();
    func_245.Execute(  );
    setParameter(9, func_245.output[0]);

    // [162] Macro call CmEnergy_Recovery_Enable
    func_162.CmEnergy_Recovery_Enable_input_1 = (float) getCmERC_Plate_input_25().getValue();
    func_162.CmEnergy_Recovery_Enable_input_2 = false;
    func_162.Execute(  );

    // [174] Function call CfNot
    func_174.input = getCmERC_Plate_input_31().getValue();
    func_174.Execute(  );

    // [171] Function call CfAnd
    func_171.input[0] = func_174.output;
    func_171.input[1] = func_162.CmEnergy_Recovery_Enable_output_19;
    func_171.Execute(  );

    // [149] Macro call CmControl_Plate_and_Glycol
    func_149.CmControl_Plate_and_Glycol_input_10 = (float) getCmERC_Plate_input_26().getValue();
    func_149.CmControl_Plate_and_Glycol_input_11 = (float) getCmERC_Plate_input_32().getValue();
    func_149.CmControl_Plate_and_Glycol_input_12 = 999F;
    func_149.CmControl_Plate_and_Glycol_input_41 = (float) getCmERC_Plate_input_29().getValue();
    func_149.CmControl_Plate_and_Glycol_input_43 = (float) getCmERC_Plate_input_32().getValue();
    func_149.CmControl_Plate_and_Glycol_input_47 = func_171.outputAND;
    func_149.Execute( this, 0 );
    setCmERC_Plate_output_33(func_149.CmControl_Plate_and_Glycol_output_9);

    // [259] Function call CfIdt
    func_259.input = BooleanToFloat(getCmERC_Plate_input_31().getValue());
    func_259.Execute(  );
    setCmERC_Plate_output_261(FloatToBoolean(func_259.output[0]));

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 100F, 5F, 10F, 10F, 15F, 10F, -10F,
    10F, 5F, 0F, 5F, 0F, 100F, 5F, 10F,
    0F, 100F, 10F, 15F, 10F, -10F, 10F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// EnRecControl
  public static final Property CmERC_Plate_output_33 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmERC_Plate_output_33() { return (BStatusNumeric) get(CmERC_Plate_output_33); }
  public void setCmERC_Plate_output_33(BStatusNumeric v) { set(CmERC_Plate_output_33,v,null); }
  public void setCmERC_Plate_output_33(float v) { getCmERC_Plate_output_33().setValue(v); }
// ERCFreezeProt
  public static final Property CmERC_Plate_output_261 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmERC_Plate_output_261() { return (BStatusBoolean) get(CmERC_Plate_output_261); }
  public void setCmERC_Plate_output_261(BStatusBoolean v) { set(CmERC_Plate_output_261,v,null); }
  public void setCmERC_Plate_output_261(boolean v) { getCmERC_Plate_output_261().setValue(v); }

  // macro parameter
// SYS-01: start-up delay
  public static final Property CmERC_Plate_parameter_247 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(300)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmERC_Plate_parameter_247() { return getDouble(CmERC_Plate_parameter_247); }
  public void setCmERC_Plate_parameter_247(double v) { setDouble(CmERC_Plate_parameter_247,v,null); }
// ERT-01: energy recovery temperature low setpoint
  public static final Property CmERC_Plate_parameter_4 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmERC_Plate_parameter_4() { return getDouble(CmERC_Plate_parameter_4); }
  public void setCmERC_Plate_parameter_4(double v) { setDouble(CmERC_Plate_parameter_4,v,null); }
// ERT-02: energy recovery temperature high setpoint
  public static final Property CmERC_Plate_parameter_5 = newProperty( 0, BDouble.make( 15 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmERC_Plate_parameter_5() { return getDouble(CmERC_Plate_parameter_5); }
  public void setCmERC_Plate_parameter_5(double v) { setDouble(CmERC_Plate_parameter_5,v,null); }
// ERT-03: P-band energy recovery temperature control
  public static final Property CmERC_Plate_parameter_6 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(5000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmERC_Plate_parameter_6() { return getDouble(CmERC_Plate_parameter_6); }
  public void setCmERC_Plate_parameter_6(double v) { setDouble(CmERC_Plate_parameter_6,v,null); }
// OAT-01: outside air temperature minimum value
  public static final Property CmERC_Plate_parameter_7 = newProperty( 0, BDouble.make( -10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmERC_Plate_parameter_7() { return getDouble(CmERC_Plate_parameter_7); }
  public void setCmERC_Plate_parameter_7(double v) { setDouble(CmERC_Plate_parameter_7,v,null); }
// OAT-02: outside air temperature maximum value
  public static final Property CmERC_Plate_parameter_8 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmERC_Plate_parameter_8() { return getDouble(CmERC_Plate_parameter_8); }
  public void setCmERC_Plate_parameter_8(double v) { setDouble(CmERC_Plate_parameter_8,v,null); }
// ERS-01: minimum energy recovery control signal
  public static final Property CmERC_Plate_parameter_10 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmERC_Plate_parameter_10() { return getDouble(CmERC_Plate_parameter_10); }
  public void setCmERC_Plate_parameter_10(double v) { setDouble(CmERC_Plate_parameter_10,v,null); }
// ERS-02: maximum energy recovery control signal
  public static final Property CmERC_Plate_parameter_11 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmERC_Plate_parameter_11() { return getDouble(CmERC_Plate_parameter_11); }
  public void setCmERC_Plate_parameter_11(double v) { setDouble(CmERC_Plate_parameter_11,v,null); }
// ERS-03: difference IAT, RAT control signal sequence start
  public static final Property CmERC_Plate_parameter_12 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmERC_Plate_parameter_12() { return getDouble(CmERC_Plate_parameter_12); }
  public void setCmERC_Plate_parameter_12(double v) { setDouble(CmERC_Plate_parameter_12,v,null); }
// ERS-04: difference IAT, RAT control signal sequence stop
  public static final Property CmERC_Plate_parameter_13 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmERC_Plate_parameter_13() { return getDouble(CmERC_Plate_parameter_13); }
  public void setCmERC_Plate_parameter_13(double v) { setDouble(CmERC_Plate_parameter_13,v,null); }
// DISP-01: calc. setpoint energy recovery temperature
  public static final Property CmERC_Plate_parameter_22 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmERC_Plate_parameter_22() { return getDouble(CmERC_Plate_parameter_22); }
  public void setCmERC_Plate_parameter_22(double v) { setDouble(CmERC_Plate_parameter_22,v,null); }

  // macro inputs
// ERCCtrlSig
  public static final Property CmERC_Plate_input_26 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmERC_Plate_input_26() { return (BStatusNumeric) get(CmERC_Plate_input_26); }
  public void setCmERC_Plate_input_26(BStatusNumeric v) { set(CmERC_Plate_input_26,v,null); }
  public void setCmERC_Plate_input_26(float v) { getCmERC_Plate_input_26().setValue(v); }
// FilteredOATemp
  public static final Property CmERC_Plate_input_32 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmERC_Plate_input_32() { return (BStatusNumeric) get(CmERC_Plate_input_32); }
  public void setCmERC_Plate_input_32(BStatusNumeric v) { set(CmERC_Plate_input_32,v,null); }
  public void setCmERC_Plate_input_32(float v) { getCmERC_Plate_input_32().setValue(v); }
// EnRecTemp
  public static final Property CmERC_Plate_input_29 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmERC_Plate_input_29() { return (BStatusNumeric) get(CmERC_Plate_input_29); }
  public void setCmERC_Plate_input_29(BStatusNumeric v) { set(CmERC_Plate_input_29,v,null); }
  public void setCmERC_Plate_input_29(float v) { getCmERC_Plate_input_29().setValue(v); }
// DiffPressSwitch
  public static final Property CmERC_Plate_input_31 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmERC_Plate_input_31() { return (BStatusBoolean) get(CmERC_Plate_input_31); }
  public void setCmERC_Plate_input_31(BStatusBoolean v) { set(CmERC_Plate_input_31,v,null); }
  public void setCmERC_Plate_input_31(boolean v) { getCmERC_Plate_input_31().setValue(v); }
// PlantMode
  public static final Property CmERC_Plate_input_25 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmERC_Plate_input_25() { return (BStatusNumeric) get(CmERC_Plate_input_25); }
  public void setCmERC_Plate_input_25(BStatusNumeric v) { set(CmERC_Plate_input_25,v,null); }
  public void setCmERC_Plate_input_25(float v) { getCmERC_Plate_input_25().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.06 [100] 20.03.2018-10:47").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5880742776465785175").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmERC_Plate.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmIDT10 func_234 = new CmIDT10();
  protected CfIdt func_245 = new CfIdt();
  protected CmEnergy_Recovery_Enable func_162 = new CmEnergy_Recovery_Enable();
  protected CfNot func_174 = new CfNot();
  protected CfAnd func_171 = new CfAnd();
  protected CmControl_Plate_and_Glycol func_149 = new CmControl_Plate_and_Glycol();
  protected CfIdt func_259 = new CfIdt();

  // default constructor
  public BCmERC_Plate()
  {
  }

  public void Start()
  {
    func_234.Start();
    func_162.Start();
    func_149.Start();
  }
}
