/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    ERC_Water
Macro id:      5880747432920220238
Macro version: 137
Last change:   20.03.2018 - 10:47
Access Level:  2
Inputs:
  [1] ERCCtrlSig
  [2] FilteredOATemp
  [3] InletAirTemp
  [4] ReturnAirTemp
  [5] EnRecTemp
  [6] DiffPressSwitch
  [7] PlantMode
Outputs:
  [1] ValveControl
  [2] PumpCmd
  [3] ERCFreezeProt
Parameter:
  [1] SYS-01: start-up delay
  [2] ERT-01: energy recovery temperature low setpoint
  [3] ERT-02: energy recovery temperature high setpoint
  [4] ERT-03: P-band energy recovery temperature control
  [5] OAT-01: outside air temperature minimum value
  [6] OAT-02: outside air temperature maximum value
  [7] OAT-03: low limit frost protection
  [8] ERS-01: minimum energy recovery control signal
  [9] ERS-02: maximum energy recovery control signal
  [10] ERS-03: difference IAT, RAT control signal sequence start
  [11] ERS-04: difference IAT, RAT control signal sequence stop
  [12] ERP-01: pump switch off delay
  [13] DISP-01: calc. setpoint energy recovery temperature
Description:
The macro "ERC_Water" provides modulating control of energy recovery equipment of an air handling unit and operates in sequence with other output modules or as standalone module. The module has integrated features for plant mode overrides.

The air-liquid-air system with water as liquid medium has a pump in the return pipe of the outside air coil. The energy recovery systems are equipped with temperature sensors which are connected to macro inputs.
================================================================================*/

public class BCmERC_Water
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmERC_Water_output_260().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmERC_Water_output_260().setStatus(BStatus.disabled);
    getCmERC_Water_output_257().setStatus(BStatus.disabled);
    getCmERC_Water_output_263().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmERC_Water_output_260().setStatus(BStatus.ok);
    getCmERC_Water_output_257().setStatus(BStatus.ok);
    getCmERC_Water_output_263().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [210] Macro call CmIDT20
    func_210.CmIDT20_input_1 = (float) getCmERC_Water_parameter_10();
    func_210.CmIDT20_input_2 = (float) getCmERC_Water_parameter_11();
    func_210.CmIDT20_input_3 = (float) getCmERC_Water_parameter_12();
    func_210.CmIDT20_input_4 = (float) getCmERC_Water_parameter_13();
    func_210.CmIDT20_input_5 = (float) getCmERC_Water_parameter_4();
    func_210.CmIDT20_input_6 = (float) getCmERC_Water_parameter_5();
    func_210.CmIDT20_input_7 = (float) getCmERC_Water_parameter_6();
    func_210.CmIDT20_input_8 = (float) getCmERC_Water_parameter_7();
    func_210.CmIDT20_input_9 = (float) getCmERC_Water_parameter_8();
    func_210.CmIDT20_input_10 = (float) getCmERC_Water_parameter_9();
    func_210.CmIDT20_input_11 = 0F;
    func_210.CmIDT20_input_12 = 0F;
    func_210.CmIDT20_input_13 = 0F;
    func_210.CmIDT20_input_14 = 0F;
    func_210.CmIDT20_input_15 = (float) getCmERC_Water_parameter_14();
    func_210.CmIDT20_input_16 = (float) getCmERC_Water_parameter_15();
    func_210.CmIDT20_input_17 = getParameter(10);
    func_210.CmIDT20_input_18 = (float) getCmERC_Water_parameter_14();
    func_210.CmIDT20_input_19 = 0F;
    func_210.CmIDT20_input_20 = 0F;
    func_210.Execute(  );
    setParameter(0, func_210.CmIDT20_output_21);
    setParameter(1, func_210.CmIDT20_output_22);
    setParameter(2, func_210.CmIDT20_output_23);
    setParameter(3, func_210.CmIDT20_output_24);
    setParameter(4, func_210.CmIDT20_output_25);
    setParameter(5, func_210.CmIDT20_output_26);
    setParameter(8, func_210.CmIDT20_output_27);
    setParameter(6, func_210.CmIDT20_output_28);
    setParameter(7, func_210.CmIDT20_output_29);
    setParameter(29, func_210.CmIDT20_output_30);
    setParameter(24, func_210.CmIDT20_output_35);
    setParameter(25, func_210.CmIDT20_output_36);
    setCmERC_Water_parameter_22(func_210.CmIDT20_output_37);
    setParameter(9, func_210.CmIDT20_output_38);

    // [153] Macro call CmLow_Inlet_Temperature
    func_153.CmLow_Inlet_Temperature_input_1 = (float) getCmERC_Water_input_27().getValue();
    func_153.CmLow_Inlet_Temperature_input_2 = (float) getCmERC_Water_input_32().getValue();
    func_153.Execute(  );

    // [174] Function call CfNot
    func_174.input = getCmERC_Water_input_31().getValue();
    func_174.Execute(  );

    // [162] Macro call CmEnergy_Recovery_Enable
    func_162.CmEnergy_Recovery_Enable_input_1 = (float) getCmERC_Water_input_25().getValue();
    func_162.CmEnergy_Recovery_Enable_input_2 = false;
    func_162.Execute(  );

    // [171] Function call CfAnd
    func_171.input[0] = func_174.output;
    func_171.input[1] = func_162.CmEnergy_Recovery_Enable_output_19;
    func_171.Execute(  );

    // [234] Macro call CmControl_Water
    func_234.CmControl_Water_input_10 = (float) getCmERC_Water_input_26().getValue();
    func_234.CmControl_Water_input_11 = func_153.CmLow_Inlet_Temperature_output_7;
    func_234.CmControl_Water_input_12 = (float) getCmERC_Water_input_28().getValue();
    func_234.CmControl_Water_input_41 = (float) getCmERC_Water_input_29().getValue();
    func_234.CmControl_Water_input_43 = (float) getCmERC_Water_input_32().getValue();
    func_234.CmControl_Water_input_48 = func_171.outputAND;
    func_234.Execute( this, 0 );
    setCmERC_Water_output_260(func_234.CmControl_Water_output_9);

    // [253] Function call CfHysteresis
    func_253.inputX = (float) getCmERC_Water_output_260().getValue();
    func_253.inputW = 3F;
    func_253.Execute( this, 23 );

    // [165] Macro call CmERC_Pump_Command
    func_165.CmERC_Pump_Command_input_5 = func_253.output1;
    func_165.CmERC_Pump_Command_input_137 = false;
    func_165.Execute( this, 24 );

    // [239] Macro call CmBacnet
    func_239.CmBacnet_input_1 = (float) getCmERC_Water_input_25().getValue();
    func_239.CmBacnet_input_33 = (float) getCmERC_Water_input_32().getValue();
    func_239.CmBacnet_input_53 = func_165.CmERC_Pump_Command_output_143;
    func_239.CmBacnet_input_80 = getCmERC_Water_input_31().getValue();
    func_239.Execute( this, 29 );
    setCmERC_Water_output_257(func_239.CmBacnet_output_55);
    setCmERC_Water_output_263(func_239.CmBacnet_output_74);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 100F, 5F, 10F, 10F, 15F, -10F, 10F,
    10F, 5F, 0F, 5F, 0F, 100F, 5F, 10F,
    0F, 100F, 10F, 15F, 10F, -10F, 10F, 0F,
    5F, 300F, 5F, 0F, 300F, 6F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// ValveControl
  public static final Property CmERC_Water_output_260 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmERC_Water_output_260() { return (BStatusNumeric) get(CmERC_Water_output_260); }
  public void setCmERC_Water_output_260(BStatusNumeric v) { set(CmERC_Water_output_260,v,null); }
  public void setCmERC_Water_output_260(float v) { getCmERC_Water_output_260().setValue(v); }
// PumpCmd
  public static final Property CmERC_Water_output_257 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmERC_Water_output_257() { return (BStatusBoolean) get(CmERC_Water_output_257); }
  public void setCmERC_Water_output_257(BStatusBoolean v) { set(CmERC_Water_output_257,v,null); }
  public void setCmERC_Water_output_257(boolean v) { getCmERC_Water_output_257().setValue(v); }
// ERCFreezeProt
  public static final Property CmERC_Water_output_263 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmERC_Water_output_263() { return (BStatusBoolean) get(CmERC_Water_output_263); }
  public void setCmERC_Water_output_263(BStatusBoolean v) { set(CmERC_Water_output_263,v,null); }
  public void setCmERC_Water_output_263(boolean v) { getCmERC_Water_output_263().setValue(v); }

  // macro parameter
// SYS-01: start-up delay
  public static final Property CmERC_Water_parameter_14 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(300)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmERC_Water_parameter_14() { return getDouble(CmERC_Water_parameter_14); }
  public void setCmERC_Water_parameter_14(double v) { setDouble(CmERC_Water_parameter_14,v,null); }
// ERT-01: energy recovery temperature low setpoint
  public static final Property CmERC_Water_parameter_4 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmERC_Water_parameter_4() { return getDouble(CmERC_Water_parameter_4); }
  public void setCmERC_Water_parameter_4(double v) { setDouble(CmERC_Water_parameter_4,v,null); }
// ERT-02: energy recovery temperature high setpoint
  public static final Property CmERC_Water_parameter_5 = newProperty( 0, BDouble.make( 15 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmERC_Water_parameter_5() { return getDouble(CmERC_Water_parameter_5); }
  public void setCmERC_Water_parameter_5(double v) { setDouble(CmERC_Water_parameter_5,v,null); }
// ERT-03: P-band energy recovery temperature control
  public static final Property CmERC_Water_parameter_6 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(5000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmERC_Water_parameter_6() { return getDouble(CmERC_Water_parameter_6); }
  public void setCmERC_Water_parameter_6(double v) { setDouble(CmERC_Water_parameter_6,v,null); }
// OAT-01: outside air temperature minimum value
  public static final Property CmERC_Water_parameter_7 = newProperty( 0, BDouble.make( -10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmERC_Water_parameter_7() { return getDouble(CmERC_Water_parameter_7); }
  public void setCmERC_Water_parameter_7(double v) { setDouble(CmERC_Water_parameter_7,v,null); }
// OAT-02: outside air temperature maximum value
  public static final Property CmERC_Water_parameter_8 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmERC_Water_parameter_8() { return getDouble(CmERC_Water_parameter_8); }
  public void setCmERC_Water_parameter_8(double v) { setDouble(CmERC_Water_parameter_8,v,null); }
// OAT-03: low limit frost protection
  public static final Property CmERC_Water_parameter_9 = newProperty( 0, BDouble.make( 6 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmERC_Water_parameter_9() { return getDouble(CmERC_Water_parameter_9); }
  public void setCmERC_Water_parameter_9(double v) { setDouble(CmERC_Water_parameter_9,v,null); }
// ERS-01: minimum energy recovery control signal
  public static final Property CmERC_Water_parameter_10 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmERC_Water_parameter_10() { return getDouble(CmERC_Water_parameter_10); }
  public void setCmERC_Water_parameter_10(double v) { setDouble(CmERC_Water_parameter_10,v,null); }
// ERS-02: maximum energy recovery control signal
  public static final Property CmERC_Water_parameter_11 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmERC_Water_parameter_11() { return getDouble(CmERC_Water_parameter_11); }
  public void setCmERC_Water_parameter_11(double v) { setDouble(CmERC_Water_parameter_11,v,null); }
// ERS-03: difference IAT, RAT control signal sequence start
  public static final Property CmERC_Water_parameter_12 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmERC_Water_parameter_12() { return getDouble(CmERC_Water_parameter_12); }
  public void setCmERC_Water_parameter_12(double v) { setDouble(CmERC_Water_parameter_12,v,null); }
// ERS-04: difference IAT, RAT control signal sequence stop
  public static final Property CmERC_Water_parameter_13 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmERC_Water_parameter_13() { return getDouble(CmERC_Water_parameter_13); }
  public void setCmERC_Water_parameter_13(double v) { setDouble(CmERC_Water_parameter_13,v,null); }
// ERP-01: pump switch off delay
  public static final Property CmERC_Water_parameter_15 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(2600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmERC_Water_parameter_15() { return getDouble(CmERC_Water_parameter_15); }
  public void setCmERC_Water_parameter_15(double v) { setDouble(CmERC_Water_parameter_15,v,null); }
// DISP-01: calc. setpoint energy recovery temperature
  public static final Property CmERC_Water_parameter_22 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmERC_Water_parameter_22() { return getDouble(CmERC_Water_parameter_22); }
  public void setCmERC_Water_parameter_22(double v) { setDouble(CmERC_Water_parameter_22,v,null); }

  // macro inputs
// ERCCtrlSig
  public static final Property CmERC_Water_input_26 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmERC_Water_input_26() { return (BStatusNumeric) get(CmERC_Water_input_26); }
  public void setCmERC_Water_input_26(BStatusNumeric v) { set(CmERC_Water_input_26,v,null); }
  public void setCmERC_Water_input_26(float v) { getCmERC_Water_input_26().setValue(v); }
// FilteredOATemp
  public static final Property CmERC_Water_input_32 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmERC_Water_input_32() { return (BStatusNumeric) get(CmERC_Water_input_32); }
  public void setCmERC_Water_input_32(BStatusNumeric v) { set(CmERC_Water_input_32,v,null); }
  public void setCmERC_Water_input_32(float v) { getCmERC_Water_input_32().setValue(v); }
// InletAirTemp
  public static final Property CmERC_Water_input_27 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmERC_Water_input_27() { return (BStatusNumeric) get(CmERC_Water_input_27); }
  public void setCmERC_Water_input_27(BStatusNumeric v) { set(CmERC_Water_input_27,v,null); }
  public void setCmERC_Water_input_27(float v) { getCmERC_Water_input_27().setValue(v); }
// ReturnAirTemp
  public static final Property CmERC_Water_input_28 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmERC_Water_input_28() { return (BStatusNumeric) get(CmERC_Water_input_28); }
  public void setCmERC_Water_input_28(BStatusNumeric v) { set(CmERC_Water_input_28,v,null); }
  public void setCmERC_Water_input_28(float v) { getCmERC_Water_input_28().setValue(v); }
// EnRecTemp
  public static final Property CmERC_Water_input_29 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmERC_Water_input_29() { return (BStatusNumeric) get(CmERC_Water_input_29); }
  public void setCmERC_Water_input_29(BStatusNumeric v) { set(CmERC_Water_input_29,v,null); }
  public void setCmERC_Water_input_29(float v) { getCmERC_Water_input_29().setValue(v); }
// DiffPressSwitch
  public static final Property CmERC_Water_input_31 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmERC_Water_input_31() { return (BStatusBoolean) get(CmERC_Water_input_31); }
  public void setCmERC_Water_input_31(BStatusBoolean v) { set(CmERC_Water_input_31,v,null); }
  public void setCmERC_Water_input_31(boolean v) { getCmERC_Water_input_31().setValue(v); }
// PlantMode
  public static final Property CmERC_Water_input_25 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmERC_Water_input_25() { return (BStatusNumeric) get(CmERC_Water_input_25); }
  public void setCmERC_Water_input_25(BStatusNumeric v) { set(CmERC_Water_input_25,v,null); }
  public void setCmERC_Water_input_25(float v) { getCmERC_Water_input_25().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.07 [137] 20.03.2018-10:47").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5880747432920220238").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmERC_Water.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions

  // class variables
  protected CmIDT20 func_210 = new CmIDT20();
  protected CmLow_Inlet_Temperature func_153 = new CmLow_Inlet_Temperature();
  protected CfNot func_174 = new CfNot();
  protected CmEnergy_Recovery_Enable func_162 = new CmEnergy_Recovery_Enable();
  protected CfAnd func_171 = new CfAnd();
  protected CmControl_Water func_234 = new CmControl_Water();
  protected CfHysteresis func_253 = new CfHysteresis();
  protected CmERC_Pump_Command func_165 = new CmERC_Pump_Command();
  protected CmBacnet func_239 = new CmBacnet();

  // default constructor
  public BCmERC_Water()
  {
  }

  public void Start()
  {
    func_210.Start();
    func_153.Start();
    func_162.Start();
    func_234.Start();
    func_253.Start();
    func_165.Start();
    func_239.Start();
  }
}
