/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    ERC_Wheel
Macro id:      5880766064129737394
Macro version: 127
Last change:   13.08.2015 - 14:13
Access Level:  2
Inputs:
  [1] ERCCtrlSig
  [2] FilteredOATemp
  [3] InletAirTemp
  [4] ReturnAirTemp
  [5] PlantMode
Outputs:
  [1] EnRecControl
  [2] WheelCmd
Parameter:
  [1] SYS-01: start-up delay
  [2] SYS-02: wheel release
  [3] ERS-01: minimum energy recovery control signal
  [4] ERS-02: maximum energy recovery control signal
  [5] ERS-03: difference IAT, RAT control signal sequence start
  [6] ERS-04: difference IAT, RAT control signal sequence stop
Description:
The macro "ERC_Glycol" provides modulating control of energy recovery equipment of an air handling unit and operates in sequence with other output modules or 
as standalone module. The module has integrated features for plant mode overrides.

The air-liquid-air system with glycol as liquid medium has a pump in the return pipe of the exhaust air coil. The energy recovery systems are equipped with temperature sensors which are connected to macro inputs and are respectively.
================================================================================*/

public class BCmERC_Wheel
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmERC_Wheel_output_33().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmERC_Wheel_output_33().setStatus(BStatus.disabled);
    getCmERC_Wheel_output_283().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmERC_Wheel_output_33().setStatus(BStatus.ok);
    getCmERC_Wheel_output_283().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [256] Macro call CmIDT10
    func_256.CmIDT10_input_1 = (float) getCmERC_Wheel_parameter_10();
    func_256.CmIDT10_input_2 = (float) getCmERC_Wheel_parameter_11();
    func_256.CmIDT10_input_3 = (float) getCmERC_Wheel_parameter_12();
    func_256.CmIDT10_input_4 = (float) getCmERC_Wheel_parameter_13();
    func_256.CmIDT10_input_5 = 0F;
    func_256.CmIDT10_input_6 = 0F;
    func_256.CmIDT10_input_7 = (float) getCmERC_Wheel_parameter_14();
    func_256.CmIDT10_input_8 = 0F;
    func_256.CmIDT10_input_9 = -100F;
    func_256.CmIDT10_input_10 = (float) getCmERC_Wheel_parameter_14();
    func_256.Execute(  );
    setParameter(0, func_256.CmIDT10_output_21);
    setParameter(1, func_256.CmIDT10_output_22);
    setParameter(2, func_256.CmIDT10_output_23);
    setParameter(3, func_256.CmIDT10_output_24);
    setParameter(11, func_256.CmIDT10_output_27);
    setParameter(12, func_256.CmIDT10_output_28);
    setParameter(16, func_256.CmIDT10_output_29);
    setParameter(4, func_256.CmIDT10_output_30);

    // [153] Macro call CmLow_Inlet_Temperature
    func_153.CmLow_Inlet_Temperature_input_1 = (float) getCmERC_Wheel_input_27().getValue();
    func_153.CmLow_Inlet_Temperature_input_2 = (float) getCmERC_Wheel_input_32().getValue();
    func_153.Execute(  );

    // [162] Macro call CmEnergy_Recovery_Enable
    func_162.CmEnergy_Recovery_Enable_input_1 = (float) getCmERC_Wheel_input_25().getValue();
    func_162.CmEnergy_Recovery_Enable_input_2 = true;
    func_162.Execute(  );

    // [179] Function call CfOr
    func_179.input[0] = func_162.CmEnergy_Recovery_Enable_output_19;
    func_179.input[1] = FloatToBoolean((float) getCmERC_Wheel_parameter_239());
    func_179.Execute(  );

    // [234] Macro call CmControl_Wheel
    func_234.CmControl_Wheel_input_10 = (float) getCmERC_Wheel_input_26().getValue();
    func_234.CmControl_Wheel_input_11 = func_153.CmLow_Inlet_Temperature_output_7;
    func_234.CmControl_Wheel_input_12 = (float) getCmERC_Wheel_input_28().getValue();
    func_234.CmControl_Wheel_input_26 = func_179.outputOR;
    func_234.Execute( this, 0 );

    // [165] Macro call CmERC_Pump_Command
    func_165.CmERC_Pump_Command_input_5 = func_179.outputOR;
    func_165.CmERC_Pump_Command_input_137 = true;
    func_165.Execute( this, 11 );

    // [267] Function call CfCompare1
    func_267.inputA = (float) getCmERC_Wheel_input_25().getValue();
    func_267.inputB = 3F;
    func_267.Execute(  );

    // [265] Function call CfInputMultiplexer
    func_265.inputSelect = BooleanToInt(func_267.outputEqual);
    func_265.input[1-1] = func_234.CmControl_Wheel_output_9;
    func_265.input[2-1] = (float) getCmERC_Wheel_parameter_10();
    func_265.Execute(  );
    setCmERC_Wheel_output_33(func_265.output);

    // [275] Macro call CmBacnet
    func_275.CmBacnet_input_1 = (float) getCmERC_Wheel_input_25().getValue();
    func_275.CmBacnet_input_33 = 100F;
    func_275.CmBacnet_input_53 = func_165.CmERC_Pump_Command_output_143;
    func_275.CmBacnet_input_80 = false;
    func_275.Execute( this, 16 );
    setCmERC_Wheel_output_283(func_275.CmBacnet_output_55);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 100F, 5F, 10F, 5F, 0F, 5F, 0F,
    100F, 5F, 10F, 5F, 300F, 5F, 0F, 300F,
    6F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// EnRecControl
  public static final Property CmERC_Wheel_output_33 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmERC_Wheel_output_33() { return (BStatusNumeric) get(CmERC_Wheel_output_33); }
  public void setCmERC_Wheel_output_33(BStatusNumeric v) { set(CmERC_Wheel_output_33,v,null); }
  public void setCmERC_Wheel_output_33(float v) { getCmERC_Wheel_output_33().setValue(v); }
// WheelCmd
  public static final Property CmERC_Wheel_output_283 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmERC_Wheel_output_283() { return (BStatusBoolean) get(CmERC_Wheel_output_283); }
  public void setCmERC_Wheel_output_283(BStatusBoolean v) { set(CmERC_Wheel_output_283,v,null); }
  public void setCmERC_Wheel_output_283(boolean v) { getCmERC_Wheel_output_283().setValue(v); }

  // macro parameter
// SYS-01: start-up delay
  public static final Property CmERC_Wheel_parameter_14 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(300)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmERC_Wheel_parameter_14() { return getDouble(CmERC_Wheel_parameter_14); }
  public void setCmERC_Wheel_parameter_14(double v) { setDouble(CmERC_Wheel_parameter_14,v,null); }
// SYS-02: wheel release
  public static final Property CmERC_Wheel_parameter_239 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmERC_Wheel_parameter_239() { return getDouble(CmERC_Wheel_parameter_239); }
  public void setCmERC_Wheel_parameter_239(double v) { setDouble(CmERC_Wheel_parameter_239,v,null); }
// ERS-01: minimum energy recovery control signal
  public static final Property CmERC_Wheel_parameter_10 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmERC_Wheel_parameter_10() { return getDouble(CmERC_Wheel_parameter_10); }
  public void setCmERC_Wheel_parameter_10(double v) { setDouble(CmERC_Wheel_parameter_10,v,null); }
// ERS-02: maximum energy recovery control signal
  public static final Property CmERC_Wheel_parameter_11 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmERC_Wheel_parameter_11() { return getDouble(CmERC_Wheel_parameter_11); }
  public void setCmERC_Wheel_parameter_11(double v) { setDouble(CmERC_Wheel_parameter_11,v,null); }
// ERS-03: difference IAT, RAT control signal sequence start
  public static final Property CmERC_Wheel_parameter_12 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmERC_Wheel_parameter_12() { return getDouble(CmERC_Wheel_parameter_12); }
  public void setCmERC_Wheel_parameter_12(double v) { setDouble(CmERC_Wheel_parameter_12,v,null); }
// ERS-04: difference IAT, RAT control signal sequence stop
  public static final Property CmERC_Wheel_parameter_13 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmERC_Wheel_parameter_13() { return getDouble(CmERC_Wheel_parameter_13); }
  public void setCmERC_Wheel_parameter_13(double v) { setDouble(CmERC_Wheel_parameter_13,v,null); }

  // macro inputs
// ERCCtrlSig
  public static final Property CmERC_Wheel_input_26 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmERC_Wheel_input_26() { return (BStatusNumeric) get(CmERC_Wheel_input_26); }
  public void setCmERC_Wheel_input_26(BStatusNumeric v) { set(CmERC_Wheel_input_26,v,null); }
  public void setCmERC_Wheel_input_26(float v) { getCmERC_Wheel_input_26().setValue(v); }
// FilteredOATemp
  public static final Property CmERC_Wheel_input_32 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmERC_Wheel_input_32() { return (BStatusNumeric) get(CmERC_Wheel_input_32); }
  public void setCmERC_Wheel_input_32(BStatusNumeric v) { set(CmERC_Wheel_input_32,v,null); }
  public void setCmERC_Wheel_input_32(float v) { getCmERC_Wheel_input_32().setValue(v); }
// InletAirTemp
  public static final Property CmERC_Wheel_input_27 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmERC_Wheel_input_27() { return (BStatusNumeric) get(CmERC_Wheel_input_27); }
  public void setCmERC_Wheel_input_27(BStatusNumeric v) { set(CmERC_Wheel_input_27,v,null); }
  public void setCmERC_Wheel_input_27(float v) { getCmERC_Wheel_input_27().setValue(v); }
// ReturnAirTemp
  public static final Property CmERC_Wheel_input_28 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmERC_Wheel_input_28() { return (BStatusNumeric) get(CmERC_Wheel_input_28); }
  public void setCmERC_Wheel_input_28(BStatusNumeric v) { set(CmERC_Wheel_input_28,v,null); }
  public void setCmERC_Wheel_input_28(float v) { getCmERC_Wheel_input_28().setValue(v); }
// PlantMode
  public static final Property CmERC_Wheel_input_25 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmERC_Wheel_input_25() { return (BStatusNumeric) get(CmERC_Wheel_input_25); }
  public void setCmERC_Wheel_input_25(BStatusNumeric v) { set(CmERC_Wheel_input_25,v,null); }
  public void setCmERC_Wheel_input_25(float v) { getCmERC_Wheel_input_25().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.05 [127] 13.08.2015-14:13").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5880766064129737394").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmERC_Wheel.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmIDT10 func_256 = new CmIDT10();
  protected CmLow_Inlet_Temperature func_153 = new CmLow_Inlet_Temperature();
  protected CmEnergy_Recovery_Enable func_162 = new CmEnergy_Recovery_Enable();
  protected CfOr func_179 = new CfOr();
  protected CmControl_Wheel func_234 = new CmControl_Wheel();
  protected CmERC_Pump_Command func_165 = new CmERC_Pump_Command();
  protected CfCompare1 func_267 = new CfCompare1();
  protected CfInputMultiplexer func_265 = new CfInputMultiplexer();
  protected CmBacnet func_275 = new CmBacnet();

  // default constructor
  public BCmERC_Wheel()
  {
  }

  public void Start()
  {
    func_256.Start();
    func_153.Start();
    func_162.Start();
    func_234.Start();
    func_165.Start();
    func_275.Start();
  }
}
