/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    FDA_MotorizedFireDamper
Macro id:      5803615717805785328
Macro version: 58
Last change:   28.11.2016 - 10:53
Access Level:  2
Inputs:
  [1] EndSwNormalPos
  [2] EndSwFirePos
  [3] MaintenanceRun
  [4] SmokeAlarm
  [5] FireStatus
  [6] Reset
  [7] FireAlarm
  [8] PlantMode
Outputs:
  [1] FireStatus
  [2] DamperCmd
  [3] MaintRunStatus
  [4] MaintRunFailed
Parameter:
  [1] FDMP-01: runtime to fire position
  [2] FDMP-02: runtime to normal position
  [3] FDMP-03: end switches enable
  [4] DISP-01: month of maintenance run
  [5] DISP-02: day of maintenance run
  [6] DISP-03: hour of maintenance run
  [7] DISP-04: minute of maintenance run
Description:
Fire dampers prevent fire and smoke from spreading through ventilation systems. 
They may be equipped with a thermal release mechanism.
Certified high reliable safety systems perform fire detection and the control of fire dampers.
The fire damper monitors fire alarm inputs. The fire alarms will be signalized with the dampers end switches. The dampers end switches are normally closed contacts by default. Since fire damper end switches have usually changeover contacts, the user can change the contact types of the end switches. 

Motor driven fire/ smoke dampers can be open or closed during fire alarm. The damper position during fire alarm depends of the area it controls, if it has to be pressurized, de-pressurized or purged.
The normal position of motorized fire damper is always the position where the motor is powered. In case of fire alarm or power failure, the damper drives to the fire position due to its spring return actuator.
Attention: Never change the contact type of the damper command output otherwise you will get wrong behavior of the motorized damper and you can damage the ducts.
That's why the fire damper has no setting for fire position which can be open or closed during fire alarm. The damper can be mechanically adjusted to normally open or closed position.
Motor driven dampers have an optional maintenance run triggered by a maintenance switch.
================================================================================*/

public class BCmFDA_MotorizedFireDamper
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmFDA_MotorizedFireDamper_output_272().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmFDA_MotorizedFireDamper_output_272().setStatus(BStatus.disabled);
    getCmFDA_MotorizedFireDamper_output_271().setStatus(BStatus.disabled);
    getCmFDA_MotorizedFireDamper_output_372().setStatus(BStatus.disabled);
    getCmFDA_MotorizedFireDamper_output_373().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmFDA_MotorizedFireDamper_output_272().setStatus(BStatus.ok);
    getCmFDA_MotorizedFireDamper_output_271().setStatus(BStatus.ok);
    getCmFDA_MotorizedFireDamper_output_372().setStatus(BStatus.ok);
    getCmFDA_MotorizedFireDamper_output_373().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [16] Function call CfIdt
    func_16.input = (float) getCmFDA_MotorizedFireDamper_parameter_358();
    func_16.Execute(  );
    setParameter(0, func_16.output[0]);

    // [17] Function call CfDelay
    func_17.inputA = getCmFDA_MotorizedFireDamper_input_256().getValue();
    func_17.inputB = getCmFDA_MotorizedFireDamper_input_256().getValue();
    func_17.Execute( this, 0 );

    // [20] Function call CfInputMultiplexer ("normal switch")
    func_20.inputSelect = BooleanToInt(func_425.outputOR);
    func_20.input[1-1] = 0F;
    func_20.input[2-1] = BooleanToFloat(func_17.outputDelayedA);
    func_20.Execute(  );

    // [440] Function call CfMultiply
    func_440.input[0] = (float) getCmFDA_MotorizedFireDamper_parameter_359();
    func_440.input[1] = 2F;
    func_440.Execute(  );

    // [441] Function call CfIdt
    func_441.input = func_440.output;
    func_441.Execute(  );
    setParameter(7, func_441.output[0]);

    // [457] Function call CfIdt
    func_457.input = (float) getCmFDA_MotorizedFireDamper_parameter_359();
    func_457.Execute(  );
    setParameter(8, func_457.output[0]);

    // [360] Function call CfIdt
    func_360.input = (float) getCmFDA_MotorizedFireDamper_parameter_358();
    func_360.Execute(  );
    setParameter(1, func_360.output[0]);

    // [362] Function call CfIdt
    func_362.input = (float) getCmFDA_MotorizedFireDamper_parameter_359();
    func_362.Execute(  );
    setParameter(2, func_362.output[0]);

    // [385] Function call CfIdt
    func_385.input = (float) getCmFDA_MotorizedFireDamper_parameter_358();
    func_385.Execute(  );
    setParameter(5, func_385.output[0]);

    // [247] Macro call CmMaintenance_Runtime
    func_247.CmMaintenance_Runtime_input_1 = getCmFDA_MotorizedFireDamper_input_295().getValue();
    func_247.CmMaintenance_Runtime_input_45 = (float) getCmFDA_MotorizedFireDamper_input_287().getValue();
    func_247.Execute( this, 1 );

    // [379] Macro call CmTimestamp_Of_Event
    func_379.CmTimestamp_Of_Event_input_1 = func_247.CmMaintenance_Runtime_output_39;
    func_379.Execute( this, 5 );
    setCmFDA_MotorizedFireDamper_parameter_374(func_379.CmTimestamp_Of_Event_output_2);
    setCmFDA_MotorizedFireDamper_parameter_375(func_379.CmTimestamp_Of_Event_output_3);
    setCmFDA_MotorizedFireDamper_parameter_376(func_379.CmTimestamp_Of_Event_output_4);
    setCmFDA_MotorizedFireDamper_parameter_377(func_379.CmTimestamp_Of_Event_output_5);

    // [412] Function call CfCompare1
    func_412.inputA = (float) getCmFDA_MotorizedFireDamper_parameter_369();
    func_412.inputB = 1F;
    func_412.Execute(  );

    // [417] Function call CfCompare1
    func_417.inputA = (float) getCmFDA_MotorizedFireDamper_parameter_369();
    func_417.inputB = 2F;
    func_417.Execute(  );

    // [420] Function call CfOr
    func_420.input[0] = func_412.outputEqual;
    func_420.input[1] = func_417.outputGreater;
    func_420.Execute(  );

    // [425] Function call CfOr
    func_425.input[0] = func_417.outputGreater;
    func_425.input[1] = func_417.outputEqual;
    func_425.Execute(  );

    // [450] Function call CfNot
    func_450.input = ControlFunction.GetStartupFlag();
    func_450.Execute(  );

    // [438] Function call CfMonoflop
    func_438.input = BooleanToFloat(func_450.output);
    func_438.Execute( this, 7 );

    // [455] Function call CfOr
    func_455.input[0] = func_438.output;
    func_455.input[1] = getCmFDA_MotorizedFireDamper_input_270().getValue();
    func_455.Execute(  );

    // [460] Function call CfIdt
    func_460.input = BooleanToFloat(func_455.outputOR);
    func_460.Execute(  );

    // [400] Function call CfMonoflop
    func_400.input = BooleanToFloat(func_455.outputOR);
    func_400.Execute( this, 8 );

    // [347] Function call CfCompare1 ("PlantMode=30Fire")
    func_347.inputA = (float) getCmFDA_MotorizedFireDamper_input_287().getValue();
    func_347.inputB = 30F;
    func_347.Execute(  );

    // [468] Function call CfNot
    func_468.input = FloatToBoolean((float) getCmFDA_MotorizedFireDamper_input_294().getValue());
    func_468.Execute(  );

    // [470] Function call CfNot
    func_470.input = getCmFDA_MotorizedFireDamper_input_289().getValue();
    func_470.Execute(  );

    // [469] Function call CfNot
    func_469.input = getCmFDA_MotorizedFireDamper_input_290().getValue();
    func_469.Execute(  );

    // [474] Function call CfAnd
    func_474.input[0] = func_470.output;
    func_474.input[1] = func_468.output;
    func_474.input[2] = func_469.output;
    func_474.input[3] = func_400.output;
    func_474.Execute(  );

    // [45] Function call CfCompare1 ("nur wenn > 0")
    func_45.inputA = (float) getCmFDA_MotorizedFireDamper_parameter_358();
    func_45.inputB = 0F;
    func_45.Execute(  );
    register_0 = BooleanToFloat(func_45.outputLess);

    // [92] Function call CfCompare1 ("nur wenn > 0")
    func_92.inputA = (float) getCmFDA_MotorizedFireDamper_parameter_359();
    func_92.inputB = 0F;
    func_92.Execute(  );

    // [388] Function call CfNot
    func_388.input = getCmFDA_MotorizedFireDamper_input_257().getValue();
    func_388.Execute(  );

    // [251] Function call CfLastValue ("maint time close running")
    func_251.input = BooleanToFloat(func_247.CmMaintenance_Runtime_output_4);
    func_251.Execute(  );

    // [254] Function call CfLastValue
    func_254.input = BooleanToFloat(func_247.CmMaintenance_Runtime_output_5);
    func_254.Execute(  );

    // [21] Function call CfInputMultiplexer ("fire switch")
    func_21.inputSelect = BooleanToInt(func_420.outputOR);
    func_21.input[1-1] = 0F;
    func_21.input[2-1] = BooleanToFloat(func_388.output);
    func_21.Execute(  );

    // [22] Function call CfInputMultiplexer ("normal switch")
    func_22.inputSelect = BooleanToInt(func_425.outputOR);
    func_22.input[1-1] = 0F;
    func_22.input[2-1] = BooleanToFloat(getCmFDA_MotorizedFireDamper_input_256().getValue());
    func_22.Execute(  );

    // [31] Function call CfAddition ("0 bis 3")
    func_31.input[0] = BooleanToFloat(func_425.outputOR);
    func_31.input[1] = BooleanToFloat(func_420.outputOR);
    func_31.input[2] = BooleanToFloat(func_420.outputOR);
    func_31.Execute(  );

    // [42] Function call CfSubtract
    func_42.input[0] = 1F;
    func_42.input[1] = func_251.outputCurrent;
    func_42.Execute(  );

    // [54] Function call CfSubtract
    func_54.input[0] = 1F;
    func_54.input[1] = func_254.outputCurrent;
    func_54.Execute(  );

    // [76] Function call CfOr ("Maint running")
    func_76.input[0] = FloatToBoolean(func_251.outputCurrent);
    func_76.input[1] = FloatToBoolean(func_254.outputCurrent);
    func_76.Execute(  );
    setCmFDA_MotorizedFireDamper_output_372(func_76.outputOR);

    // [29] Function call CfOr
    func_29.input[0] = FloatToBoolean(func_20.output);
    func_29.input[1] = FloatToBoolean(func_21.output);
    func_29.Execute(  );

    // [32] Function call CfSubtract
    func_32.input[0] = 1F;
    func_32.input[1] = func_22.output;
    func_32.Execute(  );

    // [33] Function call CfSubtract
    func_33.input[0] = 1F;
    func_33.input[1] = func_21.output;
    func_33.Execute(  );

    // [51] Function call CfOr
    func_51.input[0] = FloatToBoolean(func_22.output);
    func_51.input[1] = FloatToBoolean(func_21.output);
    func_51.Execute(  );

    // [53] Function call CfAnd ("Flanke")
    func_53.input[0] = FloatToBoolean(func_42.output);
    func_53.input[1] = FloatToBoolean(func_251.outputLast);
    func_53.input[2] = func_45.outputGreater;
    func_53.Execute(  );

    // [62] Function call CfAnd ("Flanke")
    func_62.input[0] = FloatToBoolean(func_54.output);
    func_62.input[1] = FloatToBoolean(func_254.outputLast);
    func_62.input[2] = func_92.outputGreater;
    func_62.Execute(  );

    // [41] Function call CfOr
    func_41.input[0] = FloatToBoolean(func_32.output);
    func_41.input[1] = FloatToBoolean(func_33.output);
    func_41.Execute(  );

    // [60] Function call CfInputMultiplexer ("1open enabl, 2close enabl")
    func_60.inputSelect = FloatToInt(func_31.output);
    func_60.input[1-1] = 0F;
    func_60.input[2-1] = func_22.output;
    func_60.input[3-1] = func_21.output;
    func_60.input[4-1] = BooleanToFloat(func_51.outputOR);
    func_60.Execute(  );

    // [448] Function call CfOr
    func_448.input[0] = func_438.output;
    func_448.input[1] = ControlFunction.GetStartupFlag();
    func_448.Execute(  );

    // [52] Function call CfInputMultiplexer ("4 both enabl")
    func_52.inputSelect = FloatToInt(func_31.output);
    func_52.input[1-1] = 0F;
    func_52.input[2-1] = func_32.output;
    func_52.input[3-1] = func_33.output;
    func_52.input[4-1] = BooleanToFloat(func_41.outputOR);
    func_52.Execute(  );

    // [61] Function call CfInputMultiplexer ("Flanke1 Fehler?")
    func_61.inputSelect = BooleanToInt(func_53.outputAND);
    func_61.input[1-1] = 0F;
    func_61.input[2-1] = func_52.output;
    func_61.Execute(  );

    // [68] Function call CfInputMultiplexer ("Flanke 2 Fehler?")
    func_68.inputSelect = BooleanToInt(func_62.outputAND);
    func_68.input[1-1] = func_61.output;
    func_68.input[2-1] = func_60.output;
    func_68.Execute(  );

    // [75] Function call CfRsFlipFlop
    func_75.inputSet = FloatToBoolean(func_68.output);
    func_75.inputReset = FloatToBoolean(func_460.output[0]);
    func_75.Execute(  );

    // [82] Function call CfIdt ("Maint failed")
    func_82.input = BooleanToFloat(func_75.output);
    func_82.Execute(  );
    register_0 = func_82.output[0];

    // [391] Function call CfIdt
    func_391.input = BooleanToFloat(func_75.output);
    func_391.Execute(  );
    setCmFDA_MotorizedFireDamper_output_373(FloatToBoolean(func_391.output[0]));

    // [27] Function call CfIdt ("Maint failed")
    func_27.input = register_0;
    func_27.Execute(  );

    // [30] Function call CfOr ("Maint run or failed")
    func_30.input[0] = FloatToBoolean(func_251.outputCurrent);
    func_30.input[1] = FloatToBoolean(func_254.outputLast);
    func_30.input[2] = FloatToBoolean(func_254.outputCurrent);
    func_30.input[3] = FloatToBoolean(func_27.output[0]);
    func_30.Execute(  );

    // [284] Function call CfNot
    func_284.input = func_474.outputAND;
    func_284.Execute(  );

    // [46] Function call CfAnd
    func_46.input[0] = func_284.output;
    func_46.input[1] = FloatToBoolean((float) getCmFDA_MotorizedFireDamper_input_294().getValue());
    func_46.Execute(  );

    // [435] Function call CfInputMultiplexer
    func_435.inputSelect = BooleanToInt(func_448.outputOR);
    func_435.input[1-1] = BooleanToFloat(func_29.outputOR);
    func_435.input[2-1] = 0F;
    func_435.Execute(  );

    // [38] Function call CfInputMultiplexer ("0 Alarm Maint run or fail")
    func_38.inputSelect = BooleanToInt(func_30.outputOR);
    func_38.input[1-1] = func_435.output;
    func_38.input[2-1] = 0F;
    func_38.Execute(  );

    // [59] Function call CfOr ("eigene Auslösung")
    func_59.input[0] = FloatToBoolean(func_38.output);
    func_59.input[1] = getCmFDA_MotorizedFireDamper_input_290().getValue();
    func_59.Execute(  );

    // [292] Function call CfOr
    func_292.input[0] = func_347.outputEqual;
    func_292.input[1] = getCmFDA_MotorizedFireDamper_input_289().getValue();
    func_292.input[2] = func_46.outputAND;
    func_292.Execute(  );

    // [392] Function call CfRsFlipFlop
    func_392.inputSet = func_292.outputOR;
    func_392.inputReset = func_474.outputAND;
    func_392.Execute(  );

    // [394] Function call CfOr
    func_394.input[0] = func_292.outputOR;
    func_394.input[1] = func_59.outputOR;
    func_394.Execute(  );

    // [63] Function call CfRsFlipFlop
    func_63.inputSet = func_394.outputOR;
    func_63.inputReset = func_474.outputAND;
    func_63.Execute(  );

    // [276] Function call CfLastValue
    func_276.input = BooleanToFloat(func_59.outputOR);
    func_276.Execute(  );

    // [277] Function call CfNot
    func_277.input = FloatToBoolean(func_276.outputLast);
    func_277.Execute(  );

    // [274] Function call CfLastValue
    func_274.input = BooleanToFloat(func_63.output);
    func_274.Execute(  );

    // [275] Function call CfNot
    func_275.input = FloatToBoolean(func_274.outputLast);
    func_275.Execute(  );

    // [78] Function call CfAnd ("Flankenerkennung")
    func_78.input[0] = func_275.output;
    func_78.input[1] = func_59.outputOR;
    func_78.input[2] = func_277.output;
    func_78.Execute(  );

    // [85] Function call CfInputMultiplexer ("Par selbsthaltung")
    func_85.inputSelect = BooleanToInt(func_78.outputAND);
    func_85.input[1-1] = func_88.output;
    func_85.input[2-1] = 1F;
    func_85.Execute(  );

    // [477] Function call CfAnd
    func_477.input[0] = func_29.outputNOR;
    func_477.input[1] = func_474.outputAND;
    func_477.Execute(  );

    // [88] Function call CfInputMultiplexer ("Status löschen")
    func_88.inputSelect = BooleanToInt(func_477.outputAND);
    func_88.input[1-1] = func_85.output;
    func_88.input[2-1] = 0F;
    func_88.Execute(  );

    // [79] Function call CfMultiply ("own smoke or damper triggered")
    func_79.input[0] = func_88.output;
    func_79.input[1] = 1F;
    func_79.Execute(  );

    // [80] Function call CfMultiply ("group fire detection")
    func_80.input[0] = BooleanToFloat(func_392.output);
    func_80.input[1] = 2F;
    func_80.Execute(  );

    // [71] Function call CfOr
    func_71.input[0] = func_63.output;
    func_71.input[1] = FloatToBoolean(func_251.outputCurrent);
    func_71.Execute(  );
    setCmFDA_MotorizedFireDamper_output_271(func_71.outputNOR);

    // [484] Function call CfInputMultiplexer
    func_484.inputSelect = FloatToInt(func_79.output);
    func_484.input[1-1] = func_80.output;
    func_484.input[2-1] = func_79.output;
    func_484.Execute(  );

    // [485] Function call CfInputMultiplexer
    func_485.inputSelect = BooleanToInt(getCmFDA_MotorizedFireDamper_input_270().getValue());
    func_485.input[1-1] = func_484.output;
    func_485.input[2-1] = 0F;
    func_485.Execute(  );
    setCmFDA_MotorizedFireDamper_output_272(func_485.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 0F, 0F, 0F, 0F, 40F, 0F, 1F,
    2F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  protected float register_0 = 0;
  // macro outputs
// FireStatus
  public static final Property CmFDA_MotorizedFireDamper_output_272 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmFDA_MotorizedFireDamper_output_272() { return (BStatusNumeric) get(CmFDA_MotorizedFireDamper_output_272); }
  public void setCmFDA_MotorizedFireDamper_output_272(BStatusNumeric v) { set(CmFDA_MotorizedFireDamper_output_272,v,null); }
  public void setCmFDA_MotorizedFireDamper_output_272(float v) { getCmFDA_MotorizedFireDamper_output_272().setValue(v); }
// DamperCmd
  public static final Property CmFDA_MotorizedFireDamper_output_271 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFDA_MotorizedFireDamper_output_271() { return (BStatusBoolean) get(CmFDA_MotorizedFireDamper_output_271); }
  public void setCmFDA_MotorizedFireDamper_output_271(BStatusBoolean v) { set(CmFDA_MotorizedFireDamper_output_271,v,null); }
  public void setCmFDA_MotorizedFireDamper_output_271(boolean v) { getCmFDA_MotorizedFireDamper_output_271().setValue(v); }
// MaintRunStatus
  public static final Property CmFDA_MotorizedFireDamper_output_372 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFDA_MotorizedFireDamper_output_372() { return (BStatusBoolean) get(CmFDA_MotorizedFireDamper_output_372); }
  public void setCmFDA_MotorizedFireDamper_output_372(BStatusBoolean v) { set(CmFDA_MotorizedFireDamper_output_372,v,null); }
  public void setCmFDA_MotorizedFireDamper_output_372(boolean v) { getCmFDA_MotorizedFireDamper_output_372().setValue(v); }
// MaintRunFailed
  public static final Property CmFDA_MotorizedFireDamper_output_373 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFDA_MotorizedFireDamper_output_373() { return (BStatusBoolean) get(CmFDA_MotorizedFireDamper_output_373); }
  public void setCmFDA_MotorizedFireDamper_output_373(BStatusBoolean v) { set(CmFDA_MotorizedFireDamper_output_373,v,null); }
  public void setCmFDA_MotorizedFireDamper_output_373(boolean v) { getCmFDA_MotorizedFireDamper_output_373().setValue(v); }

  // macro parameter
// FDMP-01: runtime to fire position
  public static final Property CmFDA_MotorizedFireDamper_parameter_358 = newProperty( 0, BDouble.make( 40 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(1440)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFDA_MotorizedFireDamper_parameter_358() { return getDouble(CmFDA_MotorizedFireDamper_parameter_358); }
  public void setCmFDA_MotorizedFireDamper_parameter_358(double v) { setDouble(CmFDA_MotorizedFireDamper_parameter_358,v,null); }
// FDMP-02: runtime to normal position
  public static final Property CmFDA_MotorizedFireDamper_parameter_359 = newProperty( 0, BDouble.make( 40 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(1440)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFDA_MotorizedFireDamper_parameter_359() { return getDouble(CmFDA_MotorizedFireDamper_parameter_359); }
  public void setCmFDA_MotorizedFireDamper_parameter_359(double v) { setDouble(CmFDA_MotorizedFireDamper_parameter_359,v,null); }
// FDMP-03: end switches enable
  public static final Property CmFDA_MotorizedFireDamper_parameter_369 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFDA_MotorizedFireDamper_parameter_369() { return getDouble(CmFDA_MotorizedFireDamper_parameter_369); }
  public void setCmFDA_MotorizedFireDamper_parameter_369(double v) { setDouble(CmFDA_MotorizedFireDamper_parameter_369,v,null); }
// DISP-01: month of maintenance run
  public static final Property CmFDA_MotorizedFireDamper_parameter_374 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 1 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(12)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("meter"))));
  public double getCmFDA_MotorizedFireDamper_parameter_374() { return getDouble(CmFDA_MotorizedFireDamper_parameter_374); }
  public void setCmFDA_MotorizedFireDamper_parameter_374(double v) { setDouble(CmFDA_MotorizedFireDamper_parameter_374,v,null); }
// DISP-02: day of maintenance run
  public static final Property CmFDA_MotorizedFireDamper_parameter_375 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 1 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(31)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("day"))));
  public double getCmFDA_MotorizedFireDamper_parameter_375() { return getDouble(CmFDA_MotorizedFireDamper_parameter_375); }
  public void setCmFDA_MotorizedFireDamper_parameter_375(double v) { setDouble(CmFDA_MotorizedFireDamper_parameter_375,v,null); }
// DISP-03: hour of maintenance run
  public static final Property CmFDA_MotorizedFireDamper_parameter_376 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(23)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmFDA_MotorizedFireDamper_parameter_376() { return getDouble(CmFDA_MotorizedFireDamper_parameter_376); }
  public void setCmFDA_MotorizedFireDamper_parameter_376(double v) { setDouble(CmFDA_MotorizedFireDamper_parameter_376,v,null); }
// DISP-04: minute of maintenance run
  public static final Property CmFDA_MotorizedFireDamper_parameter_377 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(59)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmFDA_MotorizedFireDamper_parameter_377() { return getDouble(CmFDA_MotorizedFireDamper_parameter_377); }
  public void setCmFDA_MotorizedFireDamper_parameter_377(double v) { setDouble(CmFDA_MotorizedFireDamper_parameter_377,v,null); }

  // macro inputs
// EndSwNormalPos
  public static final Property CmFDA_MotorizedFireDamper_input_256 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFDA_MotorizedFireDamper_input_256() { return (BStatusBoolean) get(CmFDA_MotorizedFireDamper_input_256); }
  public void setCmFDA_MotorizedFireDamper_input_256(BStatusBoolean v) { set(CmFDA_MotorizedFireDamper_input_256,v,null); }
  public void setCmFDA_MotorizedFireDamper_input_256(boolean v) { getCmFDA_MotorizedFireDamper_input_256().setValue(v); }
// EndSwFirePos
  public static final Property CmFDA_MotorizedFireDamper_input_257 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFDA_MotorizedFireDamper_input_257() { return (BStatusBoolean) get(CmFDA_MotorizedFireDamper_input_257); }
  public void setCmFDA_MotorizedFireDamper_input_257(BStatusBoolean v) { set(CmFDA_MotorizedFireDamper_input_257,v,null); }
  public void setCmFDA_MotorizedFireDamper_input_257(boolean v) { getCmFDA_MotorizedFireDamper_input_257().setValue(v); }
// MaintenanceRun
  public static final Property CmFDA_MotorizedFireDamper_input_295 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFDA_MotorizedFireDamper_input_295() { return (BStatusBoolean) get(CmFDA_MotorizedFireDamper_input_295); }
  public void setCmFDA_MotorizedFireDamper_input_295(BStatusBoolean v) { set(CmFDA_MotorizedFireDamper_input_295,v,null); }
  public void setCmFDA_MotorizedFireDamper_input_295(boolean v) { getCmFDA_MotorizedFireDamper_input_295().setValue(v); }
// SmokeAlarm
  public static final Property CmFDA_MotorizedFireDamper_input_290 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFDA_MotorizedFireDamper_input_290() { return (BStatusBoolean) get(CmFDA_MotorizedFireDamper_input_290); }
  public void setCmFDA_MotorizedFireDamper_input_290(BStatusBoolean v) { set(CmFDA_MotorizedFireDamper_input_290,v,null); }
  public void setCmFDA_MotorizedFireDamper_input_290(boolean v) { getCmFDA_MotorizedFireDamper_input_290().setValue(v); }
// FireStatus
  public static final Property CmFDA_MotorizedFireDamper_input_294 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmFDA_MotorizedFireDamper_input_294() { return (BStatusNumeric) get(CmFDA_MotorizedFireDamper_input_294); }
  public void setCmFDA_MotorizedFireDamper_input_294(BStatusNumeric v) { set(CmFDA_MotorizedFireDamper_input_294,v,null); }
  public void setCmFDA_MotorizedFireDamper_input_294(float v) { getCmFDA_MotorizedFireDamper_input_294().setValue(v); }
// Reset
  public static final Property CmFDA_MotorizedFireDamper_input_270 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFDA_MotorizedFireDamper_input_270() { return (BStatusBoolean) get(CmFDA_MotorizedFireDamper_input_270); }
  public void setCmFDA_MotorizedFireDamper_input_270(BStatusBoolean v) { set(CmFDA_MotorizedFireDamper_input_270,v,null); }
  public void setCmFDA_MotorizedFireDamper_input_270(boolean v) { getCmFDA_MotorizedFireDamper_input_270().setValue(v); }
// FireAlarm
  public static final Property CmFDA_MotorizedFireDamper_input_289 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFDA_MotorizedFireDamper_input_289() { return (BStatusBoolean) get(CmFDA_MotorizedFireDamper_input_289); }
  public void setCmFDA_MotorizedFireDamper_input_289(BStatusBoolean v) { set(CmFDA_MotorizedFireDamper_input_289,v,null); }
  public void setCmFDA_MotorizedFireDamper_input_289(boolean v) { getCmFDA_MotorizedFireDamper_input_289().setValue(v); }
// PlantMode
  public static final Property CmFDA_MotorizedFireDamper_input_287 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmFDA_MotorizedFireDamper_input_287() { return (BStatusNumeric) get(CmFDA_MotorizedFireDamper_input_287); }
  public void setCmFDA_MotorizedFireDamper_input_287(BStatusNumeric v) { set(CmFDA_MotorizedFireDamper_input_287,v,null); }
  public void setCmFDA_MotorizedFireDamper_input_287(float v) { getCmFDA_MotorizedFireDamper_input_287().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.06 [58] 28.11.2016-10:53").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5803615717805785328").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmFDA_MotorizedFireDamper.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfIdt func_16 = new CfIdt();
  protected CfDelay func_17 = new CfDelay();
  protected CfInputMultiplexer func_20 = new CfInputMultiplexer();
  protected CfMultiply func_440 = new CfMultiply();
  protected CfIdt func_441 = new CfIdt();
  protected CfIdt func_457 = new CfIdt();
  protected CfIdt func_360 = new CfIdt();
  protected CfIdt func_362 = new CfIdt();
  protected CfIdt func_385 = new CfIdt();
  protected CmMaintenance_Runtime func_247 = new CmMaintenance_Runtime();
  protected CmTimestamp_Of_Event func_379 = new CmTimestamp_Of_Event();
  protected CfCompare1 func_412 = new CfCompare1();
  protected CfCompare1 func_417 = new CfCompare1();
  protected CfOr func_420 = new CfOr();
  protected CfOr func_425 = new CfOr();
  protected CfNot func_450 = new CfNot();
  protected CfMonoflop func_438 = new CfMonoflop();
  protected CfOr func_455 = new CfOr();
  protected CfIdt func_460 = new CfIdt();
  protected CfMonoflop func_400 = new CfMonoflop();
  protected CfCompare1 func_347 = new CfCompare1();
  protected CfNot func_468 = new CfNot();
  protected CfNot func_470 = new CfNot();
  protected CfNot func_469 = new CfNot();
  protected CfAnd func_474 = new CfAnd();
  protected CfCompare1 func_45 = new CfCompare1();
  protected CfCompare1 func_92 = new CfCompare1();
  protected CfNot func_388 = new CfNot();
  protected CfLastValue func_251 = new CfLastValue();
  protected CfLastValue func_254 = new CfLastValue();
  protected CfInputMultiplexer func_21 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_22 = new CfInputMultiplexer();
  protected CfAddition func_31 = new CfAddition();
  protected CfSubtract func_42 = new CfSubtract();
  protected CfSubtract func_54 = new CfSubtract();
  protected CfOr func_76 = new CfOr();
  protected CfOr func_29 = new CfOr();
  protected CfSubtract func_32 = new CfSubtract();
  protected CfSubtract func_33 = new CfSubtract();
  protected CfOr func_51 = new CfOr();
  protected CfAnd func_53 = new CfAnd();
  protected CfAnd func_62 = new CfAnd();
  protected CfOr func_41 = new CfOr();
  protected CfInputMultiplexer func_60 = new CfInputMultiplexer();
  protected CfOr func_448 = new CfOr();
  protected CfInputMultiplexer func_52 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_61 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_68 = new CfInputMultiplexer();
  protected CfRsFlipFlop func_75 = new CfRsFlipFlop();
  protected CfIdt func_82 = new CfIdt();
  protected CfIdt func_391 = new CfIdt();
  protected CfIdt func_27 = new CfIdt();
  protected CfOr func_30 = new CfOr();
  protected CfNot func_284 = new CfNot();
  protected CfAnd func_46 = new CfAnd();
  protected CfInputMultiplexer func_435 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_38 = new CfInputMultiplexer();
  protected CfOr func_59 = new CfOr();
  protected CfOr func_292 = new CfOr();
  protected CfRsFlipFlop func_392 = new CfRsFlipFlop();
  protected CfOr func_394 = new CfOr();
  protected CfRsFlipFlop func_63 = new CfRsFlipFlop();
  protected CfLastValue func_276 = new CfLastValue();
  protected CfNot func_277 = new CfNot();
  protected CfLastValue func_274 = new CfLastValue();
  protected CfNot func_275 = new CfNot();
  protected CfAnd func_78 = new CfAnd();
  protected CfInputMultiplexer func_85 = new CfInputMultiplexer();
  protected CfAnd func_477 = new CfAnd();
  protected CfInputMultiplexer func_88 = new CfInputMultiplexer();
  protected CfMultiply func_79 = new CfMultiply();
  protected CfMultiply func_80 = new CfMultiply();
  protected CfOr func_71 = new CfOr();
  protected CfInputMultiplexer func_484 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_485 = new CfInputMultiplexer();

  // default constructor
  public BCmFDA_MotorizedFireDamper()
  {
    func_474.configure(4);
    func_31.configure(3);
    func_53.configure(3);
    func_62.configure(3);
    func_60.configure(5);
    func_52.configure(5);
    func_30.configure(4);
    func_292.configure(3);
    func_78.configure(3);
  }

  public void Start()
  {
    func_17.Start();
    func_247.Start();
    func_379.Start();
    func_438.Start();
    func_400.Start();
    func_251.Start();
    func_254.Start();
    func_75.Start();
    func_392.Start();
    func_63.Start();
    func_276.Start();
    func_274.Start();
  }
}
