/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    FDA_PassiveFireDamper
Macro id:      5911602106377175590
Macro version: 14
Last change:   13.01.2014 - 14:59
Access Level:  2
Inputs:
  [1] EndSwFirePos
  [2] Reset
Outputs:
  [1] FireStatus
Parameter:
Description:
Fire dampers prevent fire and smoke from spreading through ventilation systems. They are equipped with a thermal release mechanism.
Certified high reliable safety systems perform fire detection and the control of fire dampers.

The fire damper monitors fire alarm inputs. The fire alarm will be signalized with the dampers end switches. The dampers end switches are normally closed contacts by default. 
Fire damper end switches have usually changeover contacts.
If someone wants to use NO contacts for the damper end switches - see the chapter"programming hints".
Fire dampers may belong to a group or operate in stand-alone mode.
================================================================================*/

public class BCmFDA_PassiveFireDamper
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmFDA_PassiveFireDamper_output_4().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmFDA_PassiveFireDamper_output_4().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmFDA_PassiveFireDamper_output_4().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [5] Function call CfNot
    func_5.input = getCmFDA_PassiveFireDamper_input_2().getValue();
    func_5.Execute(  );

    // [39] Function call CfMonoflop
    func_39.input = BooleanToFloat(getCmFDA_PassiveFireDamper_input_1().getValue());
    func_39.Execute( this, 0 );

    // [14] Function call CfRsFlipFlop
    func_14.inputSet = func_5.output;
    func_14.inputReset = getCmFDA_PassiveFireDamper_input_1().getValue();
    func_14.Execute(  );

    // [13] Function call CfLastValue
    func_13.input = BooleanToFloat(func_14.output);
    func_13.Execute(  );

    // [8] Function call CfNot
    func_8.input = FloatToBoolean(func_13.outputLast);
    func_8.Execute(  );

    // [9] Function call CfAnd ("Flankenerkennung")
    func_9.input[0] = func_5.output;
    func_9.input[1] = func_8.output;
    func_9.Execute(  );

    // [10] Function call CfInputMultiplexer ("löschen")
    func_10.inputSelect = BooleanToInt(func_39.output);
    func_10.input[1-1] = func_11.output;
    func_10.input[2-1] = 0F;
    func_10.Execute(  );

    // [11] Function call CfInputMultiplexer ("Par selbsthaltung")
    func_11.inputSelect = BooleanToInt(func_9.outputAND);
    func_11.input[1-1] = func_10.output;
    func_11.input[2-1] = 1F;
    func_11.Execute(  );

    // [38] Function call CfIdt
    func_38.input = func_10.output;
    func_38.Execute(  );
    setCmFDA_PassiveFireDamper_output_4(func_38.output[0]);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    2F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// FireStatus
  public static final Property CmFDA_PassiveFireDamper_output_4 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmFDA_PassiveFireDamper_output_4() { return (BStatusNumeric) get(CmFDA_PassiveFireDamper_output_4); }
  public void setCmFDA_PassiveFireDamper_output_4(BStatusNumeric v) { set(CmFDA_PassiveFireDamper_output_4,v,null); }
  public void setCmFDA_PassiveFireDamper_output_4(float v) { getCmFDA_PassiveFireDamper_output_4().setValue(v); }

  // macro parameter

  // macro inputs
// EndSwFirePos
  public static final Property CmFDA_PassiveFireDamper_input_2 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFDA_PassiveFireDamper_input_2() { return (BStatusBoolean) get(CmFDA_PassiveFireDamper_input_2); }
  public void setCmFDA_PassiveFireDamper_input_2(BStatusBoolean v) { set(CmFDA_PassiveFireDamper_input_2,v,null); }
  public void setCmFDA_PassiveFireDamper_input_2(boolean v) { getCmFDA_PassiveFireDamper_input_2().setValue(v); }
// Reset
  public static final Property CmFDA_PassiveFireDamper_input_1 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFDA_PassiveFireDamper_input_1() { return (BStatusBoolean) get(CmFDA_PassiveFireDamper_input_1); }
  public void setCmFDA_PassiveFireDamper_input_1(BStatusBoolean v) { set(CmFDA_PassiveFireDamper_input_1,v,null); }
  public void setCmFDA_PassiveFireDamper_input_1(boolean v) { getCmFDA_PassiveFireDamper_input_1().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.03 [14] 13.01.2014-14:59").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5911602106377175590").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmFDA_PassiveFireDamper.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfNot func_5 = new CfNot();
  protected CfMonoflop func_39 = new CfMonoflop();
  protected CfRsFlipFlop func_14 = new CfRsFlipFlop();
  protected CfLastValue func_13 = new CfLastValue();
  protected CfNot func_8 = new CfNot();
  protected CfAnd func_9 = new CfAnd();
  protected CfInputMultiplexer func_10 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_11 = new CfInputMultiplexer();
  protected CfIdt func_38 = new CfIdt();

  // default constructor
  public BCmFDA_PassiveFireDamper()
  {
  }

  public void Start()
  {
    func_39.Start();
    func_14.Start();
    func_13.Start();
  }
}
