/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    FNA_1St_Fan
Macro id:      5876299363106422855
Macro version: 124
Last change:   10.01.2017 - 14:58
Access Level:  2
Inputs:
  [1] FanStageCmd
  [2] FanEnable
  [3] ManSwCond
  [4] Status
  [5] Alarm
  [6] FanBeltIn
  [7] MaintSw
  [8] Reset
  [9] PlantMode
Outputs:
  [1] Stage1Cmd
  [2] NextFanEnable
  [3] OffAlarm
  [4] OnAlarm
  [5] FailCmdAlarm
  [6] FanBeltAlarm
  [7] CommAlarm
  [8] OperationMode
Parameter:
  [1] STx-01: start-up delay
  [2] STx-02: switch off delay
  [3] NFE-01: delay next fan enable
  [4] ALM-01: maint switch NO/NC; 1 = NC
  [5] ALM-02: maint switch reset type; 0= Man/ 1= AutRes
  [6] ALM-03: fan alarm reset type; 0= Man/ 1= AutRes
  [7] ALM-04: fan belt alarm reset type; 0= Man/ 1= AutRes
  [8] ALM-05: delay status alarm
  [9] ALM-06: delay fan belt alarm
  [10] ALM-07: status alarm type 0=off 1=fail to command alarm 2=on/ off alarms
  [11] DISP-01: fan belt alarm; 1=alarm
  [12] DISP-02: fan fail cmd alarm; 1=alarm
  [13] DISP-03: fan on alarm; 1=alarm
  [14] DISP-04: fan off alarm; 1=alarm
Description:
This macro provides fan control for 1 stage (on/off) with fan alarms, delayed start-up of stages and integrated plant and fire overrides. 
The fan speed can be controlled with following inputs:
 - Fan enable 
 - Fan speed control 
 - Manual switch condition from wall modules
 - Fan maintenance switch
 - Plant mode from an air handling unit strategy
================================================================================*/

public class BCmFNA_1St_Fan
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmFNA_1St_Fan_output_9().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmFNA_1St_Fan_output_9().setStatus(BStatus.disabled);
    getCmFNA_1St_Fan_output_10().setStatus(BStatus.disabled);
    getCmFNA_1St_Fan_output_11().setStatus(BStatus.disabled);
    getCmFNA_1St_Fan_output_12().setStatus(BStatus.disabled);
    getCmFNA_1St_Fan_output_13().setStatus(BStatus.disabled);
    getCmFNA_1St_Fan_output_280().setStatus(BStatus.disabled);
    getCmFNA_1St_Fan_output_217().setStatus(BStatus.disabled);
    getCmFNA_1St_Fan_output_516().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmFNA_1St_Fan_output_9().setStatus(BStatus.ok);
    getCmFNA_1St_Fan_output_10().setStatus(BStatus.ok);
    getCmFNA_1St_Fan_output_11().setStatus(BStatus.ok);
    getCmFNA_1St_Fan_output_12().setStatus(BStatus.ok);
    getCmFNA_1St_Fan_output_13().setStatus(BStatus.ok);
    getCmFNA_1St_Fan_output_280().setStatus(BStatus.ok);
    getCmFNA_1St_Fan_output_217().setStatus(BStatus.ok);
    getCmFNA_1St_Fan_output_516().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [71] Function call CfTruncate
    func_71.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_71.Execute(  );

    // [286] Function call CfMonoflop
    func_286.input = BooleanToFloat(getCmFNA_1St_Fan_input_8().getValue());
    func_286.Execute( this, 0 );

    // [57] Function call CfWindow
    func_57.inputValue = (float) getCmFNA_1St_Fan_input_2().getValue();
    func_57.inputMinimum = 2.7F;
    func_57.inputMaximum = 3.3F;
    func_57.Execute(  );

    // [83] Function call CfInputMultiplexer
    func_83.inputSelect = BooleanToInt(func_57.output);
    func_83.input[1-1] = func_316.output;
    func_83.input[2-1] = func_384.output;
    func_83.Execute(  );

    // [56] Function call CfWindow
    func_56.inputValue = (float) getCmFNA_1St_Fan_input_2().getValue();
    func_56.inputMinimum = 0.7F;
    func_56.inputMaximum = 1.3F;
    func_56.Execute(  );

    // [80] Function call CfInputMultiplexer
    func_80.inputSelect = BooleanToInt(func_56.output);
    func_80.input[1-1] = 0F;
    func_80.input[2-1] = (float) getCmFNA_1St_Fan_input_2().getValue();
    func_80.Execute(  );

    // [316] Function call CfMaximum
    func_316.input[0] = func_80.output;
    func_316.input[1] = 1F;
    func_316.Execute(  );

    // [384] Function call CfMinimum
    func_384.input[0] = (float) getCmFNA_1St_Fan_input_308().getValue();
    func_384.input[1] = 1F;
    func_384.Execute(  );

    // [72] Function call CfTruncate
    func_72.input = (float) getCmFNA_1St_Fan_input_3().getValue();
    func_72.Execute(  );

    // [73] Function call CfCompare1
    func_73.inputA = func_72.output;
    func_73.inputB = 30F;
    func_73.Execute(  );

    // [404] Function call CfWindow
    func_404.inputValue = (float) getCmFNA_1St_Fan_parameter_47();
    func_404.inputMinimum = 0.8F;
    func_404.inputMaximum = 1.2F;
    func_404.Execute(  );

    // [407] Function call CfOr
    func_407.input[0] = func_81.CmAlarms_output_5;
    func_407.input[1] = func_105.CmMaint_Switch_Alarm_output_4;
    func_407.Execute(  );

    // [456] Function call CfOr
    func_456.input[0] = func_79.outputGreater;
    func_456.input[1] = getCmFNA_1St_Fan_output_217().getValue();
    func_456.Execute(  );

    // [470] Function call CfIdt
    func_470.input = BooleanToFloat(func_105.CmMaint_Switch_Alarm_output_4);
    func_470.Execute(  );

    // [474] Function call CfIdt
    func_474.input = BooleanToFloat(func_73.outputEqual);
    func_474.Execute(  );

    // [520] Function call CfMonoflop
    func_520.input = BooleanToFloat(func_65.outputAND);
    func_520.Execute( this, 1 );

    // [530] Function call CfIdt
    func_530.input = BooleanToFloat(func_377.CmFan_Belt_Alarm_output_23);
    func_530.Execute(  );
    setCmFNA_1St_Fan_output_280(FloatToBoolean(func_530.output[1]));

    // [403] Function call CfIdt
    func_403.input = BooleanToFloat(func_407.outputOR);
    func_403.Execute(  );
    setCmFNA_1St_Fan_output_11(FloatToBoolean(func_403.output[0]));

    // [405] Function call CfNot
    func_405.input = func_404.output;
    func_405.Execute(  );

    // [466] Function call CfIdt
    func_466.input = BooleanToFloat(getCmFNA_1St_Fan_output_280().getValue());
    func_466.Execute(  );

    // [518] Function call CfJkFlipFlop
    func_518.inputSet = func_520.output;
    func_518.inputClock = false;
    func_518.inputReset = func_370.output;
    func_518.Execute(  );

    // [441] Function call CfOr
    func_441.input[0] = FloatToBoolean(func_403.output[1]);
    func_441.input[1] = getCmFNA_1St_Fan_output_13().getValue();
    func_441.Execute(  );

    // [526] Function call CfInputMultiplexer
    func_526.inputSelect = BooleanToInt(func_518.output);
    func_526.input[1-1] = 15F;
    func_526.input[2-1] = 13F;
    func_526.Execute(  );

    // [406] Function call CfAnd
    func_406.input[0] = func_405.output;
    func_406.input[1] = func_441.outputOR;
    func_406.Execute(  );

    // [431] Function call CfOr
    func_431.input[0] = func_406.outputAND;
    func_431.input[1] = getCmFNA_1St_Fan_output_280().getValue();
    func_431.input[2] = func_105.CmMaint_Switch_Alarm_output_4;
    func_431.Execute(  );

    // [110] Macro call CmFan_Release
    func_110.CmFan_Release_input_1 = func_72.output;
    func_110.CmFan_Release_input_2 = FloatToBoolean(func_71.output);
    func_110.CmFan_Release_input_4 = func_83.output;
    func_110.CmFan_Release_input_5 = func_431.outputOR;
    func_110.Execute(  );

    // [65] Function call CfAnd
    func_65.input[0] = getCmFNA_1St_Fan_input_1().getValue();
    func_65.input[1] = func_110.CmFan_Release_output_6;
    func_65.Execute(  );

    // [372] Macro call CmIDT05
    func_372.CmIDT05_input_1 = (float) getCmFNA_1St_Fan_parameter_14();
    func_372.CmIDT05_input_2 = 0F;
    func_372.CmIDT05_input_3 = 0F;
    func_372.CmIDT05_input_4 = 0F;
    func_372.CmIDT05_input_5 = 0F;
    func_372.Execute(  );
    setParameter(2, func_372.CmIDT05_output_21);
    setParameter(4, func_372.CmIDT05_output_22);
    setParameter(3, func_372.CmIDT05_output_23);

    // [360] Function call CfOr
    func_360.input[0] = getCmFNA_1St_Fan_output_11().getValue();
    func_360.input[1] = getCmFNA_1St_Fan_output_13().getValue();
    func_360.input[2] = getCmFNA_1St_Fan_output_280().getValue();
    func_360.Execute(  );

    // [357] Function call CfInputMultiplexer
    func_357.inputSelect = BooleanToInt(func_360.outputOR);
    func_357.input[1-1] = (float) getCmFNA_1St_Fan_parameter_44();
    func_357.input[2-1] = 0F;
    func_357.Execute(  );
    setParameter(5, func_357.output);

    // [370] Function call CfDelayOnOff
    func_370.input = func_65.outputAND;
    func_370.Execute( this, 2 );

    // [335] Function call CfDelayOnOff
    func_335.input = func_370.output;
    func_335.Execute( this, 4 );

    // [101] Macro call CmRelease_Stage_1
    func_101.CmRelease_Stage_1_input_2 = FloatToBoolean(func_71.output);
    func_101.CmRelease_Stage_1_input_4 = func_335.output;
    func_101.Execute(  );

    // [459] Function call CfOr
    func_459.input[0] = func_431.outputOR;
    func_459.input[1] = false;
    func_459.Execute(  );

    // [457] Function call CfInputMultiplexer
    func_457.inputSelect = BooleanToInt(func_459.outputOR);
    func_457.input[1-1] = BooleanToFloat(func_101.CmRelease_Stage_1_output_8);
    func_457.input[2-1] = 0F;
    func_457.Execute(  );

    // [489] Function call CfInputMultiplexer
    func_489.inputSelect = BooleanToInt(func_459.outputOR);
    func_489.input[1-1] = BooleanToFloat(func_249.CmNext_Fan_Enable_output_7);
    func_489.input[2-1] = 0F;
    func_489.Execute(  );

    // [490] Function call CfInputMultiplexer
    func_490.inputSelect = BooleanToInt(func_459.outputOR);
    func_490.input[1-1] = func_526.output;
    func_490.input[2-1] = 11F;
    func_490.Execute(  );

    // [464] Function call CfInputMultiplexer
    func_464.inputSelect = FloatToInt(func_466.output[0]);
    func_464.input[1-1] = func_457.output;
    func_464.input[2-1] = 0F;
    func_464.Execute(  );

    // [491] Function call CfInputMultiplexer
    func_491.inputSelect = FloatToInt(func_466.output[0]);
    func_491.input[1-1] = func_489.output;
    func_491.input[2-1] = 0F;
    func_491.Execute(  );

    // [493] Function call CfInputMultiplexer
    func_493.inputSelect = FloatToInt(func_466.output[0]);
    func_493.input[1-1] = func_490.output;
    func_493.input[2-1] = 10F;
    func_493.Execute(  );

    // [469] Function call CfInputMultiplexer
    func_469.inputSelect = FloatToInt(func_470.output[0]);
    func_469.input[1-1] = func_464.output;
    func_469.input[2-1] = 0F;
    func_469.Execute(  );

    // [492] Function call CfInputMultiplexer
    func_492.inputSelect = FloatToInt(func_470.output[0]);
    func_492.input[1-1] = func_491.output;
    func_492.input[2-1] = 0F;
    func_492.Execute(  );

    // [494] Function call CfInputMultiplexer
    func_494.inputSelect = FloatToInt(func_470.output[0]);
    func_494.input[1-1] = func_493.output;
    func_494.input[2-1] = 5F;
    func_494.Execute(  );

    // [473] Function call CfInputMultiplexer
    func_473.inputSelect = FloatToInt(func_474.output[0]);
    func_473.input[1-1] = func_469.output;
    func_473.input[2-1] = 0F;
    func_473.Execute(  );
    setCmFNA_1St_Fan_output_9(FloatToBoolean(func_473.output));

    // [249] Macro call CmNext_Fan_Enable
    func_249.CmNext_Fan_Enable_input_1 = getCmFNA_1St_Fan_output_9().getValue();
    func_249.CmNext_Fan_Enable_input_3 = getCmFNA_1St_Fan_output_9().getValue();
    func_249.CmNext_Fan_Enable_input_6 = (float) getCmFNA_1St_Fan_parameter_251();
    func_249.Execute( this, 6 );

    // [256] Macro call CmIDT05
    func_256.CmIDT05_input_1 = (float) getCmFNA_1St_Fan_parameter_51();
    func_256.CmIDT05_input_2 = (float) getCmFNA_1St_Fan_parameter_49();
    func_256.CmIDT05_input_3 = (float) getCmFNA_1St_Fan_parameter_47();
    func_256.CmIDT05_input_4 = (float) getCmFNA_1St_Fan_parameter_528();
    func_256.CmIDT05_input_5 = (float) getCmFNA_1St_Fan_parameter_50();
    func_256.Execute(  );
    setParameter(9, func_256.CmIDT05_output_21);
    setParameter(7, func_256.CmIDT05_output_22);
    setParameter(8, func_256.CmIDT05_output_23);
    setParameter(14, func_256.CmIDT05_output_24);
    setParameter(13, func_256.CmIDT05_output_25);

    // [389] Macro call CmIDT05
    func_389.CmIDT05_input_1 = BooleanToFloat(getCmFNA_1St_Fan_output_12().getValue());
    func_389.CmIDT05_input_2 = BooleanToFloat(getCmFNA_1St_Fan_output_11().getValue());
    func_389.CmIDT05_input_3 = BooleanToFloat(getCmFNA_1St_Fan_output_13().getValue());
    func_389.CmIDT05_input_4 = BooleanToFloat(getCmFNA_1St_Fan_output_280().getValue());
    func_389.CmIDT05_input_5 = 0F;
    func_389.Execute(  );
    setCmFNA_1St_Fan_parameter_54(func_389.CmIDT05_output_21);
    setCmFNA_1St_Fan_parameter_55(func_389.CmIDT05_output_22);
    setCmFNA_1St_Fan_parameter_53(func_389.CmIDT05_output_23);
    setCmFNA_1St_Fan_parameter_52(func_389.CmIDT05_output_24);

    // [79] Function call CfCompare1
    func_79.inputA = (float) getCmFNA_1St_Fan_parameter_49();
    func_79.inputB = 0F;
    func_79.Execute(  );

    // [81] Macro call CmAlarms
    if ( func_456.outputOR)
    {
      func_81.CmAlarms_input_1 = getCmFNA_1St_Fan_output_9().getValue();
      func_81.CmAlarms_input_2 = getCmFNA_1St_Fan_input_4().getValue();
      func_81.CmAlarms_input_3 = getCmFNA_1St_Fan_input_5().getValue();
      func_81.CmAlarms_input_4 = func_286.output;
      func_81.Execute( this, 7 );
      setCmFNA_1St_Fan_output_12(func_81.CmAlarms_output_6);
      setCmFNA_1St_Fan_output_13(func_81.CmAlarms_output_7);
    }

    // [396] Function call CfOr
    func_396.input[0] = func_81.CmAlarms_output_53;
    func_396.input[1] = getCmFNA_1St_Fan_input_5().getValue();
    func_396.input[2] = FloatToBoolean(func_530.output[0]);
    func_396.input[3] = func_105.CmMaint_Switch_Alarm_output_4;
    func_396.Execute(  );
    setCmFNA_1St_Fan_output_217(func_396.outputOR);

    // [106] Function call CfCompare1
    func_106.inputA = (float) getCmFNA_1St_Fan_parameter_50();
    func_106.inputB = 0F;
    func_106.Execute(  );

    // [294] Function call CfOr
    func_294.input[0] = func_106.outputGreater;
    func_294.input[1] = getCmFNA_1St_Fan_output_280().getValue();
    func_294.Execute(  );

    // [377] Macro call CmFan_Belt_Alarm
    if ( func_294.outputOR)
    {
      func_377.CmFan_Belt_Alarm_input_20 = getCmFNA_1St_Fan_output_9().getValue();
      func_377.CmFan_Belt_Alarm_input_21 = getCmFNA_1St_Fan_input_6().getValue();
      func_377.CmFan_Belt_Alarm_input_22 = func_286.output;
      func_377.Execute( this, 13 );
    }

    // [105] Macro call CmMaint_Switch_Alarm
    func_105.CmMaint_Switch_Alarm_input_2 = getCmFNA_1St_Fan_input_7().getValue();
    func_105.CmMaint_Switch_Alarm_input_146 = FloatToBoolean((float) getCmFNA_1St_Fan_parameter_45());
    func_105.CmMaint_Switch_Alarm_input_1 = FloatToBoolean((float) getCmFNA_1St_Fan_parameter_46());
    func_105.CmMaint_Switch_Alarm_input_3 = func_286.output;
    func_105.Execute(  );

    // [495] Function call CfInputMultiplexer
    func_495.inputSelect = FloatToInt(func_474.output[0]);
    func_495.input[1-1] = func_494.output;
    func_495.input[2-1] = 2F;
    func_495.Execute(  );
    setCmFNA_1St_Fan_output_516(func_495.output);

    // [496] Function call CfInputMultiplexer
    func_496.inputSelect = FloatToInt(func_474.output[0]);
    func_496.input[1-1] = func_492.output;
    func_496.input[2-1] = 0F;
    func_496.Execute(  );
    setCmFNA_1St_Fan_output_10(FloatToBoolean(func_496.output));

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    10F, 1F, 10F, 10F, 0F, 10F, 40F, 60F,
    1F, 1F, 10F, 10F, 1F, 60F, 1F, 10F,
    15F, 0F, 2F, 0F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// Stage1Cmd
  public static final Property CmFNA_1St_Fan_output_9 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_1St_Fan_output_9() { return (BStatusBoolean) get(CmFNA_1St_Fan_output_9); }
  public void setCmFNA_1St_Fan_output_9(BStatusBoolean v) { set(CmFNA_1St_Fan_output_9,v,null); }
  public void setCmFNA_1St_Fan_output_9(boolean v) { getCmFNA_1St_Fan_output_9().setValue(v); }
// NextFanEnable
  public static final Property CmFNA_1St_Fan_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_1St_Fan_output_10() { return (BStatusBoolean) get(CmFNA_1St_Fan_output_10); }
  public void setCmFNA_1St_Fan_output_10(BStatusBoolean v) { set(CmFNA_1St_Fan_output_10,v,null); }
  public void setCmFNA_1St_Fan_output_10(boolean v) { getCmFNA_1St_Fan_output_10().setValue(v); }
// OffAlarm
  public static final Property CmFNA_1St_Fan_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_1St_Fan_output_11() { return (BStatusBoolean) get(CmFNA_1St_Fan_output_11); }
  public void setCmFNA_1St_Fan_output_11(BStatusBoolean v) { set(CmFNA_1St_Fan_output_11,v,null); }
  public void setCmFNA_1St_Fan_output_11(boolean v) { getCmFNA_1St_Fan_output_11().setValue(v); }
// OnAlarm
  public static final Property CmFNA_1St_Fan_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_1St_Fan_output_12() { return (BStatusBoolean) get(CmFNA_1St_Fan_output_12); }
  public void setCmFNA_1St_Fan_output_12(BStatusBoolean v) { set(CmFNA_1St_Fan_output_12,v,null); }
  public void setCmFNA_1St_Fan_output_12(boolean v) { getCmFNA_1St_Fan_output_12().setValue(v); }
// FailCmdAlarm
  public static final Property CmFNA_1St_Fan_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_1St_Fan_output_13() { return (BStatusBoolean) get(CmFNA_1St_Fan_output_13); }
  public void setCmFNA_1St_Fan_output_13(BStatusBoolean v) { set(CmFNA_1St_Fan_output_13,v,null); }
  public void setCmFNA_1St_Fan_output_13(boolean v) { getCmFNA_1St_Fan_output_13().setValue(v); }
// FanBeltAlarm
  public static final Property CmFNA_1St_Fan_output_280 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_1St_Fan_output_280() { return (BStatusBoolean) get(CmFNA_1St_Fan_output_280); }
  public void setCmFNA_1St_Fan_output_280(BStatusBoolean v) { set(CmFNA_1St_Fan_output_280,v,null); }
  public void setCmFNA_1St_Fan_output_280(boolean v) { getCmFNA_1St_Fan_output_280().setValue(v); }
// CommAlarm
  public static final Property CmFNA_1St_Fan_output_217 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_1St_Fan_output_217() { return (BStatusBoolean) get(CmFNA_1St_Fan_output_217); }
  public void setCmFNA_1St_Fan_output_217(BStatusBoolean v) { set(CmFNA_1St_Fan_output_217,v,null); }
  public void setCmFNA_1St_Fan_output_217(boolean v) { getCmFNA_1St_Fan_output_217().setValue(v); }
// OperationMode
  public static final Property CmFNA_1St_Fan_output_516 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmFNA_1St_Fan_output_516() { return (BStatusNumeric) get(CmFNA_1St_Fan_output_516); }
  public void setCmFNA_1St_Fan_output_516(BStatusNumeric v) { set(CmFNA_1St_Fan_output_516,v,null); }
  public void setCmFNA_1St_Fan_output_516(float v) { getCmFNA_1St_Fan_output_516().setValue(v); }

  // macro parameter
// STx-01: start-up delay
  public static final Property CmFNA_1St_Fan_parameter_14 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_1St_Fan_parameter_14() { return getDouble(CmFNA_1St_Fan_parameter_14); }
  public void setCmFNA_1St_Fan_parameter_14(double v) { setDouble(CmFNA_1St_Fan_parameter_14,v,null); }
// STx-02: switch off delay
  public static final Property CmFNA_1St_Fan_parameter_44 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(120)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_1St_Fan_parameter_44() { return getDouble(CmFNA_1St_Fan_parameter_44); }
  public void setCmFNA_1St_Fan_parameter_44(double v) { setDouble(CmFNA_1St_Fan_parameter_44,v,null); }
// NFE-01: delay next fan enable
  public static final Property CmFNA_1St_Fan_parameter_251 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_1St_Fan_parameter_251() { return getDouble(CmFNA_1St_Fan_parameter_251); }
  public void setCmFNA_1St_Fan_parameter_251(double v) { setDouble(CmFNA_1St_Fan_parameter_251,v,null); }
// ALM-01: maint switch NO/NC; 1 = NC
  public static final Property CmFNA_1St_Fan_parameter_45 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_1St_Fan_parameter_45() { return getDouble(CmFNA_1St_Fan_parameter_45); }
  public void setCmFNA_1St_Fan_parameter_45(double v) { setDouble(CmFNA_1St_Fan_parameter_45,v,null); }
// ALM-02: maint switch reset type; 0= Man/ 1= AutRes
  public static final Property CmFNA_1St_Fan_parameter_46 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_1St_Fan_parameter_46() { return getDouble(CmFNA_1St_Fan_parameter_46); }
  public void setCmFNA_1St_Fan_parameter_46(double v) { setDouble(CmFNA_1St_Fan_parameter_46,v,null); }
// ALM-03: fan alarm reset type; 0= Man/ 1= AutRes
  public static final Property CmFNA_1St_Fan_parameter_47 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_1St_Fan_parameter_47() { return getDouble(CmFNA_1St_Fan_parameter_47); }
  public void setCmFNA_1St_Fan_parameter_47(double v) { setDouble(CmFNA_1St_Fan_parameter_47,v,null); }
// ALM-04: fan belt alarm reset type; 0= Man/ 1= AutRes
  public static final Property CmFNA_1St_Fan_parameter_528 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_1St_Fan_parameter_528() { return getDouble(CmFNA_1St_Fan_parameter_528); }
  public void setCmFNA_1St_Fan_parameter_528(double v) { setDouble(CmFNA_1St_Fan_parameter_528,v,null); }
// ALM-05: delay status alarm
  public static final Property CmFNA_1St_Fan_parameter_49 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_1St_Fan_parameter_49() { return getDouble(CmFNA_1St_Fan_parameter_49); }
  public void setCmFNA_1St_Fan_parameter_49(double v) { setDouble(CmFNA_1St_Fan_parameter_49,v,null); }
// ALM-06: delay fan belt alarm
  public static final Property CmFNA_1St_Fan_parameter_50 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_1St_Fan_parameter_50() { return getDouble(CmFNA_1St_Fan_parameter_50); }
  public void setCmFNA_1St_Fan_parameter_50(double v) { setDouble(CmFNA_1St_Fan_parameter_50,v,null); }
// ALM-07: status alarm type 0=off 1=fail to command alarm 2=on/ off alarms
  public static final Property CmFNA_1St_Fan_parameter_51 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_1St_Fan_parameter_51() { return getDouble(CmFNA_1St_Fan_parameter_51); }
  public void setCmFNA_1St_Fan_parameter_51(double v) { setDouble(CmFNA_1St_Fan_parameter_51,v,null); }
// DISP-01: fan belt alarm; 1=alarm
  public static final Property CmFNA_1St_Fan_parameter_52 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_1St_Fan_parameter_52() { return getDouble(CmFNA_1St_Fan_parameter_52); }
  public void setCmFNA_1St_Fan_parameter_52(double v) { setDouble(CmFNA_1St_Fan_parameter_52,v,null); }
// DISP-02: fan fail cmd alarm; 1=alarm
  public static final Property CmFNA_1St_Fan_parameter_53 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_1St_Fan_parameter_53() { return getDouble(CmFNA_1St_Fan_parameter_53); }
  public void setCmFNA_1St_Fan_parameter_53(double v) { setDouble(CmFNA_1St_Fan_parameter_53,v,null); }
// DISP-03: fan on alarm; 1=alarm
  public static final Property CmFNA_1St_Fan_parameter_54 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_1St_Fan_parameter_54() { return getDouble(CmFNA_1St_Fan_parameter_54); }
  public void setCmFNA_1St_Fan_parameter_54(double v) { setDouble(CmFNA_1St_Fan_parameter_54,v,null); }
// DISP-04: fan off alarm; 1=alarm
  public static final Property CmFNA_1St_Fan_parameter_55 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_1St_Fan_parameter_55() { return getDouble(CmFNA_1St_Fan_parameter_55); }
  public void setCmFNA_1St_Fan_parameter_55(double v) { setDouble(CmFNA_1St_Fan_parameter_55,v,null); }

  // macro inputs
// FanStageCmd
  public static final Property CmFNA_1St_Fan_input_308 = newProperty( Flags.SUMMARY, new BStatusNumeric( 1 ), null);
  public BStatusNumeric getCmFNA_1St_Fan_input_308() { return (BStatusNumeric) get(CmFNA_1St_Fan_input_308); }
  public void setCmFNA_1St_Fan_input_308(BStatusNumeric v) { set(CmFNA_1St_Fan_input_308,v,null); }
  public void setCmFNA_1St_Fan_input_308(float v) { getCmFNA_1St_Fan_input_308().setValue(v); }
// FanEnable
  public static final Property CmFNA_1St_Fan_input_1 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmFNA_1St_Fan_input_1() { return (BStatusBoolean) get(CmFNA_1St_Fan_input_1); }
  public void setCmFNA_1St_Fan_input_1(BStatusBoolean v) { set(CmFNA_1St_Fan_input_1,v,null); }
  public void setCmFNA_1St_Fan_input_1(boolean v) { getCmFNA_1St_Fan_input_1().setValue(v); }
// ManSwCond
  public static final Property CmFNA_1St_Fan_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 3 ), null);
  public BStatusNumeric getCmFNA_1St_Fan_input_2() { return (BStatusNumeric) get(CmFNA_1St_Fan_input_2); }
  public void setCmFNA_1St_Fan_input_2(BStatusNumeric v) { set(CmFNA_1St_Fan_input_2,v,null); }
  public void setCmFNA_1St_Fan_input_2(float v) { getCmFNA_1St_Fan_input_2().setValue(v); }
// Status
  public static final Property CmFNA_1St_Fan_input_4 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFNA_1St_Fan_input_4() { return (BStatusBoolean) get(CmFNA_1St_Fan_input_4); }
  public void setCmFNA_1St_Fan_input_4(BStatusBoolean v) { set(CmFNA_1St_Fan_input_4,v,null); }
  public void setCmFNA_1St_Fan_input_4(boolean v) { getCmFNA_1St_Fan_input_4().setValue(v); }
// Alarm
  public static final Property CmFNA_1St_Fan_input_5 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFNA_1St_Fan_input_5() { return (BStatusBoolean) get(CmFNA_1St_Fan_input_5); }
  public void setCmFNA_1St_Fan_input_5(BStatusBoolean v) { set(CmFNA_1St_Fan_input_5,v,null); }
  public void setCmFNA_1St_Fan_input_5(boolean v) { getCmFNA_1St_Fan_input_5().setValue(v); }
// FanBeltIn
  public static final Property CmFNA_1St_Fan_input_6 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFNA_1St_Fan_input_6() { return (BStatusBoolean) get(CmFNA_1St_Fan_input_6); }
  public void setCmFNA_1St_Fan_input_6(BStatusBoolean v) { set(CmFNA_1St_Fan_input_6,v,null); }
  public void setCmFNA_1St_Fan_input_6(boolean v) { getCmFNA_1St_Fan_input_6().setValue(v); }
// MaintSw
  public static final Property CmFNA_1St_Fan_input_7 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmFNA_1St_Fan_input_7() { return (BStatusBoolean) get(CmFNA_1St_Fan_input_7); }
  public void setCmFNA_1St_Fan_input_7(BStatusBoolean v) { set(CmFNA_1St_Fan_input_7,v,null); }
  public void setCmFNA_1St_Fan_input_7(boolean v) { getCmFNA_1St_Fan_input_7().setValue(v); }
// Reset
  public static final Property CmFNA_1St_Fan_input_8 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFNA_1St_Fan_input_8() { return (BStatusBoolean) get(CmFNA_1St_Fan_input_8); }
  public void setCmFNA_1St_Fan_input_8(BStatusBoolean v) { set(CmFNA_1St_Fan_input_8,v,null); }
  public void setCmFNA_1St_Fan_input_8(boolean v) { getCmFNA_1St_Fan_input_8().setValue(v); }
// PlantMode
  public static final Property CmFNA_1St_Fan_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmFNA_1St_Fan_input_3() { return (BStatusNumeric) get(CmFNA_1St_Fan_input_3); }
  public void setCmFNA_1St_Fan_input_3(BStatusNumeric v) { set(CmFNA_1St_Fan_input_3,v,null); }
  public void setCmFNA_1St_Fan_input_3(float v) { getCmFNA_1St_Fan_input_3().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.10 [124] 10.01.2017-14:58").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5876299363106422855").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmFNA_1St_Fan.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfTruncate func_71 = new CfTruncate();
  protected CfMonoflop func_286 = new CfMonoflop();
  protected CfWindow func_57 = new CfWindow();
  protected CfInputMultiplexer func_83 = new CfInputMultiplexer();
  protected CfWindow func_56 = new CfWindow();
  protected CfInputMultiplexer func_80 = new CfInputMultiplexer();
  protected CfMaximum func_316 = new CfMaximum();
  protected CfMinimum func_384 = new CfMinimum();
  protected CfTruncate func_72 = new CfTruncate();
  protected CfCompare1 func_73 = new CfCompare1();
  protected CfWindow func_404 = new CfWindow();
  protected CfOr func_407 = new CfOr();
  protected CfOr func_456 = new CfOr();
  protected CfIdt func_470 = new CfIdt();
  protected CfIdt func_474 = new CfIdt();
  protected CfMonoflop func_520 = new CfMonoflop();
  protected CfIdt func_530 = new CfIdt();
  protected CfIdt func_403 = new CfIdt();
  protected CfNot func_405 = new CfNot();
  protected CfIdt func_466 = new CfIdt();
  protected CfJkFlipFlop func_518 = new CfJkFlipFlop();
  protected CfOr func_441 = new CfOr();
  protected CfInputMultiplexer func_526 = new CfInputMultiplexer();
  protected CfAnd func_406 = new CfAnd();
  protected CfOr func_431 = new CfOr();
  protected CmFan_Release func_110 = new CmFan_Release();
  protected CfAnd func_65 = new CfAnd();
  protected CmIDT05 func_372 = new CmIDT05();
  protected CfOr func_360 = new CfOr();
  protected CfInputMultiplexer func_357 = new CfInputMultiplexer();
  protected CfDelayOnOff func_370 = new CfDelayOnOff();
  protected CfDelayOnOff func_335 = new CfDelayOnOff();
  protected CmRelease_Stage_1 func_101 = new CmRelease_Stage_1();
  protected CfOr func_459 = new CfOr();
  protected CfInputMultiplexer func_457 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_489 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_490 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_464 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_491 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_493 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_469 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_492 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_494 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_473 = new CfInputMultiplexer();
  protected CmNext_Fan_Enable func_249 = new CmNext_Fan_Enable();
  protected CmIDT05 func_256 = new CmIDT05();
  protected CmIDT05 func_389 = new CmIDT05();
  protected CfCompare1 func_79 = new CfCompare1();
  protected CmAlarms func_81 = new CmAlarms();
  protected CfOr func_396 = new CfOr();
  protected CfCompare1 func_106 = new CfCompare1();
  protected CfOr func_294 = new CfOr();
  protected CmFan_Belt_Alarm func_377 = new CmFan_Belt_Alarm();
  protected CmMaint_Switch_Alarm func_105 = new CmMaint_Switch_Alarm();
  protected CfInputMultiplexer func_495 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_496 = new CfInputMultiplexer();

  // default constructor
  public BCmFNA_1St_Fan()
  {
    func_530.configure(2);
    func_403.configure(2);
    func_431.configure(3);
    func_360.configure(3);
    func_396.configure(4);
  }

  public void Start()
  {
    func_286.Start();
    func_520.Start();
    func_518.Start();
    func_110.Start();
    func_372.Start();
    func_370.Start();
    func_335.Start();
    func_101.Start();
    func_249.Start();
    func_256.Start();
    func_389.Start();
    func_81.Start();
    func_377.Start();
    func_105.Start();
  }
}
