/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    FNA_1St_FanSimple
Macro id:      5889304373993931469
Macro version: 42
Last change:   10.01.2017 - 14:58
Access Level:  2
Inputs:
  [1] FanStageCmd
  [2] FanEnable
  [3] ManSwCond
  [4] Status
  [5] Alarm
  [6] FanBeltIn
  [7] MaintSw
  [8] Reset
  [9] PlantMode
Outputs:
  [1] Stage1Cmd
  [2] NextFanEnable
  [3] FailCmdAlarm
  [4] FanBeltAlarm
  [5] CommAlarm
  [6] OperationMode
Parameter:
  [1] STx-01: start-up delay
  [2] STx-02: switch off delay
  [3] NFE-01: delay next fan enable
  [4] ALM-01: maint switch NO/NC; 1 = NC
  [5] ALM-02: maint switch reset type; 0= Man/ 1 = AutRes
  [6] ALM-03: fan alarm reset type 0=Man/ 1=AutRes
  [7] ALM-04: fan belt alarm reset type; 0= Man/ 1= AutRes
  [8] ALM-05: delay status alarm
  [9] ALM-06: delay fan belt alarm
  [10] DISP-01: fan belt alarm; 1=alarm
  [11] DISP-02: fan fail cmd alarm; 1=alarm
Description:
This macro provides fan control for 1 stage (on/off) with fan alarms, delayed start-up of stages and integrated plant and fire overrides. 
The fan speed can be controlled with following inputs:
 - Fan enable
 - Fan speed control
 - Manual switch condition from wall modules
 - Fan maintenance switch
 - Plant mode from an air handling unit strategy
================================================================================*/

public class BCmFNA_1St_FanSimple
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmFNA_1St_FanSimple_output_9().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmFNA_1St_FanSimple_output_9().setStatus(BStatus.disabled);
    getCmFNA_1St_FanSimple_output_10().setStatus(BStatus.disabled);
    getCmFNA_1St_FanSimple_output_13().setStatus(BStatus.disabled);
    getCmFNA_1St_FanSimple_output_280().setStatus(BStatus.disabled);
    getCmFNA_1St_FanSimple_output_217().setStatus(BStatus.disabled);
    getCmFNA_1St_FanSimple_output_480().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmFNA_1St_FanSimple_output_9().setStatus(BStatus.ok);
    getCmFNA_1St_FanSimple_output_10().setStatus(BStatus.ok);
    getCmFNA_1St_FanSimple_output_13().setStatus(BStatus.ok);
    getCmFNA_1St_FanSimple_output_280().setStatus(BStatus.ok);
    getCmFNA_1St_FanSimple_output_217().setStatus(BStatus.ok);
    getCmFNA_1St_FanSimple_output_480().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [71] Function call CfTruncate
    func_71.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_71.Execute(  );

    // [286] Function call CfMonoflop
    func_286.input = BooleanToFloat(getCmFNA_1St_FanSimple_input_8().getValue());
    func_286.Execute( this, 0 );

    // [57] Function call CfWindow
    func_57.inputValue = (float) getCmFNA_1St_FanSimple_input_2().getValue();
    func_57.inputMinimum = 2.7F;
    func_57.inputMaximum = 3.3F;
    func_57.Execute(  );

    // [83] Function call CfInputMultiplexer
    func_83.inputSelect = BooleanToInt(func_57.output);
    func_83.input[1-1] = func_316.output;
    func_83.input[2-1] = func_385.output;
    func_83.Execute(  );

    // [56] Function call CfWindow
    func_56.inputValue = (float) getCmFNA_1St_FanSimple_input_2().getValue();
    func_56.inputMinimum = 0.7F;
    func_56.inputMaximum = 1.3F;
    func_56.Execute(  );

    // [80] Function call CfInputMultiplexer
    func_80.inputSelect = BooleanToInt(func_56.output);
    func_80.input[1-1] = 0F;
    func_80.input[2-1] = (float) getCmFNA_1St_FanSimple_input_2().getValue();
    func_80.Execute(  );

    // [316] Function call CfMaximum
    func_316.input[0] = func_80.output;
    func_316.input[1] = 1F;
    func_316.Execute(  );

    // [385] Function call CfMinimum
    func_385.input[0] = (float) getCmFNA_1St_FanSimple_input_308().getValue();
    func_385.input[1] = 1F;
    func_385.Execute(  );

    // [72] Function call CfTruncate
    func_72.input = (float) getCmFNA_1St_FanSimple_input_3().getValue();
    func_72.Execute(  );

    // [73] Function call CfCompare1
    func_73.inputA = func_72.output;
    func_73.inputB = 30F;
    func_73.Execute(  );

    // [399] Function call CfWindow
    func_399.inputValue = (float) getCmFNA_1St_FanSimple_parameter_47();
    func_399.inputMinimum = 0.8F;
    func_399.inputMaximum = 1.2F;
    func_399.Execute(  );

    // [403] Function call CfOr
    func_403.input[0] = getCmFNA_1St_FanSimple_output_13().getValue();
    func_403.input[1] = FloatToBoolean(func_90.output[0]);
    func_403.Execute(  );

    // [434] Function call CfOr
    func_434.input[0] = func_79.outputGreater;
    func_434.input[1] = FloatToBoolean(func_90.output[0]);
    func_434.Execute(  );

    // [442] Function call CfIdt
    func_442.input = BooleanToFloat(getCmFNA_1St_FanSimple_output_280().getValue());
    func_442.Execute(  );

    // [448] Function call CfIdt
    func_448.input = BooleanToFloat(func_105.CmMaint_Switch_Alarm_output_4);
    func_448.Execute(  );

    // [452] Function call CfIdt
    func_452.input = BooleanToFloat(func_73.outputEqual);
    func_452.Execute(  );

    // [524] Function call CfMonoflop
    func_524.input = BooleanToFloat(func_65.outputAND);
    func_524.Execute( this, 1 );

    // [402] Function call CfNot
    func_402.input = func_399.output;
    func_402.Execute(  );

    // [528] Function call CfJkFlipFlop
    func_528.inputSet = func_524.output;
    func_528.inputClock = false;
    func_528.inputReset = func_370.output;
    func_528.Execute(  );

    // [404] Function call CfAnd
    func_404.input[0] = func_402.output;
    func_404.input[1] = func_403.outputOR;
    func_404.Execute(  );

    // [521] Function call CfInputMultiplexer
    func_521.inputSelect = BooleanToInt(func_528.output);
    func_521.input[1-1] = 15F;
    func_521.input[2-1] = 13F;
    func_521.Execute(  );

    // [405] Function call CfOr
    func_405.input[0] = func_404.outputAND;
    func_405.input[1] = getCmFNA_1St_FanSimple_output_280().getValue();
    func_405.input[2] = func_105.CmMaint_Switch_Alarm_output_4;
    func_405.Execute(  );

    // [110] Macro call CmFan_Release
    func_110.CmFan_Release_input_1 = func_72.output;
    func_110.CmFan_Release_input_2 = FloatToBoolean(func_71.output);
    func_110.CmFan_Release_input_4 = func_83.output;
    func_110.CmFan_Release_input_5 = func_405.outputOR;
    func_110.Execute(  );

    // [65] Function call CfAnd
    func_65.input[0] = getCmFNA_1St_FanSimple_input_1().getValue();
    func_65.input[1] = func_110.CmFan_Release_output_6;
    func_65.Execute(  );

    // [372] Macro call CmIDT05
    func_372.CmIDT05_input_1 = (float) getCmFNA_1St_FanSimple_parameter_14();
    func_372.CmIDT05_input_2 = 0F;
    func_372.CmIDT05_input_3 = 0F;
    func_372.CmIDT05_input_4 = 0F;
    func_372.CmIDT05_input_5 = 0F;
    func_372.Execute(  );
    setParameter(2, func_372.CmIDT05_output_21);
    setParameter(4, func_372.CmIDT05_output_22);
    setParameter(3, func_372.CmIDT05_output_23);

    // [360] Function call CfOr
    func_360.input[0] = getCmFNA_1St_FanSimple_output_280().getValue();
    func_360.input[1] = getCmFNA_1St_FanSimple_output_13().getValue();
    func_360.Execute(  );

    // [357] Function call CfInputMultiplexer
    func_357.inputSelect = BooleanToInt(func_360.outputOR);
    func_357.input[1-1] = (float) getCmFNA_1St_FanSimple_parameter_44();
    func_357.input[2-1] = 0F;
    func_357.Execute(  );
    setParameter(5, func_357.output);

    // [370] Function call CfDelayOnOff
    func_370.input = func_65.outputAND;
    func_370.Execute( this, 2 );

    // [335] Function call CfDelayOnOff
    func_335.input = func_370.output;
    func_335.Execute( this, 4 );

    // [101] Macro call CmRelease_Stage_1
    func_101.CmRelease_Stage_1_input_2 = FloatToBoolean(func_71.output);
    func_101.CmRelease_Stage_1_input_4 = func_335.output;
    func_101.Execute(  );

    // [438] Function call CfIdt
    func_438.input = BooleanToFloat(func_405.outputOR);
    func_438.Execute(  );

    // [440] Function call CfInputMultiplexer
    func_440.inputSelect = FloatToInt(func_438.output[0]);
    func_440.input[1-1] = BooleanToFloat(func_101.CmRelease_Stage_1_output_8);
    func_440.input[2-1] = 0F;
    func_440.Execute(  );

    // [481] Function call CfInputMultiplexer
    func_481.inputSelect = FloatToInt(func_438.output[0]);
    func_481.input[1-1] = BooleanToFloat(func_249.CmNext_Fan_Enable_output_7);
    func_481.input[2-1] = 0F;
    func_481.Execute(  );

    // [485] Function call CfInputMultiplexer
    func_485.inputSelect = FloatToInt(func_438.output[0]);
    func_485.input[1-1] = func_521.output;
    func_485.input[2-1] = 11F;
    func_485.Execute(  );

    // [444] Function call CfInputMultiplexer
    func_444.inputSelect = FloatToInt(func_442.output[0]);
    func_444.input[1-1] = func_440.output;
    func_444.input[2-1] = 0F;
    func_444.Execute(  );

    // [482] Function call CfInputMultiplexer
    func_482.inputSelect = FloatToInt(func_442.output[0]);
    func_482.input[1-1] = func_481.output;
    func_482.input[2-1] = 0F;
    func_482.Execute(  );

    // [486] Function call CfInputMultiplexer
    func_486.inputSelect = FloatToInt(func_442.output[0]);
    func_486.input[1-1] = func_485.output;
    func_486.input[2-1] = 10F;
    func_486.Execute(  );

    // [447] Function call CfInputMultiplexer
    func_447.inputSelect = FloatToInt(func_448.output[0]);
    func_447.input[1-1] = func_444.output;
    func_447.input[2-1] = 0F;
    func_447.Execute(  );

    // [483] Function call CfInputMultiplexer
    func_483.inputSelect = FloatToInt(func_448.output[0]);
    func_483.input[1-1] = func_482.output;
    func_483.input[2-1] = 0F;
    func_483.Execute(  );

    // [487] Function call CfInputMultiplexer
    func_487.inputSelect = FloatToInt(func_448.output[0]);
    func_487.input[1-1] = func_486.output;
    func_487.input[2-1] = 5F;
    func_487.Execute(  );

    // [451] Function call CfInputMultiplexer
    func_451.inputSelect = FloatToInt(func_452.output[0]);
    func_451.input[1-1] = func_447.output;
    func_451.input[2-1] = 0F;
    func_451.Execute(  );
    setCmFNA_1St_FanSimple_output_9(FloatToBoolean(func_451.output));

    // [249] Macro call CmNext_Fan_Enable
    func_249.CmNext_Fan_Enable_input_1 = getCmFNA_1St_FanSimple_output_9().getValue();
    func_249.CmNext_Fan_Enable_input_3 = getCmFNA_1St_FanSimple_output_9().getValue();
    func_249.CmNext_Fan_Enable_input_6 = (float) getCmFNA_1St_FanSimple_parameter_251();
    func_249.Execute( this, 6 );

    // [256] Macro call CmIDT05
    func_256.CmIDT05_input_1 = 1F;
    func_256.CmIDT05_input_2 = (float) getCmFNA_1St_FanSimple_parameter_49();
    func_256.CmIDT05_input_3 = (float) getCmFNA_1St_FanSimple_parameter_47();
    func_256.CmIDT05_input_4 = (float) getCmFNA_1St_FanSimple_parameter_529();
    func_256.CmIDT05_input_5 = (float) getCmFNA_1St_FanSimple_parameter_50();
    func_256.Execute(  );
    setParameter(9, func_256.CmIDT05_output_21);
    setParameter(7, func_256.CmIDT05_output_22);
    setParameter(8, func_256.CmIDT05_output_23);
    setParameter(14, func_256.CmIDT05_output_24);
    setParameter(13, func_256.CmIDT05_output_25);

    // [79] Function call CfCompare1
    func_79.inputA = (float) getCmFNA_1St_FanSimple_parameter_49();
    func_79.inputB = 0F;
    func_79.Execute(  );

    // [81] Macro call CmAlarms
    if ( func_434.outputOR)
    {
      func_81.CmAlarms_input_1 = getCmFNA_1St_FanSimple_output_9().getValue();
      func_81.CmAlarms_input_2 = getCmFNA_1St_FanSimple_input_4().getValue();
      func_81.CmAlarms_input_3 = getCmFNA_1St_FanSimple_input_5().getValue();
      func_81.CmAlarms_input_4 = func_286.output;
      func_81.Execute( this, 7 );
    }

    // [91] Function call CfIdt
    func_91.input = BooleanToFloat(func_81.CmAlarms_output_7);
    func_91.Execute(  );
    setCmFNA_1St_FanSimple_output_13(FloatToBoolean(func_91.output[0]));
    setCmFNA_1St_FanSimple_parameter_53(func_91.output[1]);

    // [90] Function call CfIdt
    func_90.input = BooleanToFloat(func_81.CmAlarms_output_53);
    func_90.Execute(  );

    // [324] Function call CfOr
    func_324.input[0] = FloatToBoolean(func_90.output[1]);
    func_324.input[1] = getCmFNA_1St_FanSimple_input_5().getValue();
    func_324.input[2] = func_105.CmMaint_Switch_Alarm_output_4;
    func_324.input[3] = FloatToBoolean(func_98.output[2]);
    func_324.Execute(  );
    setCmFNA_1St_FanSimple_output_217(func_324.outputOR);

    // [106] Function call CfCompare1
    func_106.inputA = (float) getCmFNA_1St_FanSimple_parameter_50();
    func_106.inputB = 0F;
    func_106.Execute(  );

    // [294] Function call CfOr
    func_294.input[0] = func_106.outputGreater;
    func_294.input[1] = getCmFNA_1St_FanSimple_output_280().getValue();
    func_294.Execute(  );

    // [377] Macro call CmFan_Belt_Alarm
    if ( func_294.outputOR)
    {
      func_377.CmFan_Belt_Alarm_input_20 = getCmFNA_1St_FanSimple_output_9().getValue();
      func_377.CmFan_Belt_Alarm_input_21 = getCmFNA_1St_FanSimple_input_6().getValue();
      func_377.CmFan_Belt_Alarm_input_22 = func_286.output;
      func_377.Execute( this, 13 );
    }

    // [98] Function call CfIdt
    func_98.input = BooleanToFloat(func_377.CmFan_Belt_Alarm_output_23);
    func_98.Execute(  );
    setCmFNA_1St_FanSimple_output_280(FloatToBoolean(func_98.output[0]));
    setCmFNA_1St_FanSimple_parameter_52(func_98.output[1]);

    // [105] Macro call CmMaint_Switch_Alarm
    func_105.CmMaint_Switch_Alarm_input_2 = getCmFNA_1St_FanSimple_input_7().getValue();
    func_105.CmMaint_Switch_Alarm_input_146 = FloatToBoolean((float) getCmFNA_1St_FanSimple_parameter_45());
    func_105.CmMaint_Switch_Alarm_input_1 = FloatToBoolean((float) getCmFNA_1St_FanSimple_parameter_46());
    func_105.CmMaint_Switch_Alarm_input_3 = func_286.output;
    func_105.Execute(  );

    // [484] Function call CfInputMultiplexer
    func_484.inputSelect = FloatToInt(func_452.output[0]);
    func_484.input[1-1] = func_483.output;
    func_484.input[2-1] = 0F;
    func_484.Execute(  );
    setCmFNA_1St_FanSimple_output_10(FloatToBoolean(func_484.output));

    // [488] Function call CfInputMultiplexer
    func_488.inputSelect = FloatToInt(func_452.output[0]);
    func_488.input[1-1] = func_487.output;
    func_488.input[2-1] = 2F;
    func_488.Execute(  );
    setCmFNA_1St_FanSimple_output_480(func_488.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    10F, 1F, 10F, 10F, 0F, 10F, 40F, 60F,
    1F, 1F, 10F, 10F, 1F, 60F, 1F, 10F,
    15F, 0F, 2F, 0F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// Stage1Cmd
  public static final Property CmFNA_1St_FanSimple_output_9 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_1St_FanSimple_output_9() { return (BStatusBoolean) get(CmFNA_1St_FanSimple_output_9); }
  public void setCmFNA_1St_FanSimple_output_9(BStatusBoolean v) { set(CmFNA_1St_FanSimple_output_9,v,null); }
  public void setCmFNA_1St_FanSimple_output_9(boolean v) { getCmFNA_1St_FanSimple_output_9().setValue(v); }
// NextFanEnable
  public static final Property CmFNA_1St_FanSimple_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_1St_FanSimple_output_10() { return (BStatusBoolean) get(CmFNA_1St_FanSimple_output_10); }
  public void setCmFNA_1St_FanSimple_output_10(BStatusBoolean v) { set(CmFNA_1St_FanSimple_output_10,v,null); }
  public void setCmFNA_1St_FanSimple_output_10(boolean v) { getCmFNA_1St_FanSimple_output_10().setValue(v); }
// FailCmdAlarm
  public static final Property CmFNA_1St_FanSimple_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_1St_FanSimple_output_13() { return (BStatusBoolean) get(CmFNA_1St_FanSimple_output_13); }
  public void setCmFNA_1St_FanSimple_output_13(BStatusBoolean v) { set(CmFNA_1St_FanSimple_output_13,v,null); }
  public void setCmFNA_1St_FanSimple_output_13(boolean v) { getCmFNA_1St_FanSimple_output_13().setValue(v); }
// FanBeltAlarm
  public static final Property CmFNA_1St_FanSimple_output_280 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_1St_FanSimple_output_280() { return (BStatusBoolean) get(CmFNA_1St_FanSimple_output_280); }
  public void setCmFNA_1St_FanSimple_output_280(BStatusBoolean v) { set(CmFNA_1St_FanSimple_output_280,v,null); }
  public void setCmFNA_1St_FanSimple_output_280(boolean v) { getCmFNA_1St_FanSimple_output_280().setValue(v); }
// CommAlarm
  public static final Property CmFNA_1St_FanSimple_output_217 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_1St_FanSimple_output_217() { return (BStatusBoolean) get(CmFNA_1St_FanSimple_output_217); }
  public void setCmFNA_1St_FanSimple_output_217(BStatusBoolean v) { set(CmFNA_1St_FanSimple_output_217,v,null); }
  public void setCmFNA_1St_FanSimple_output_217(boolean v) { getCmFNA_1St_FanSimple_output_217().setValue(v); }
// OperationMode
  public static final Property CmFNA_1St_FanSimple_output_480 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmFNA_1St_FanSimple_output_480() { return (BStatusNumeric) get(CmFNA_1St_FanSimple_output_480); }
  public void setCmFNA_1St_FanSimple_output_480(BStatusNumeric v) { set(CmFNA_1St_FanSimple_output_480,v,null); }
  public void setCmFNA_1St_FanSimple_output_480(float v) { getCmFNA_1St_FanSimple_output_480().setValue(v); }

  // macro parameter
// STx-01: start-up delay
  public static final Property CmFNA_1St_FanSimple_parameter_14 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_1St_FanSimple_parameter_14() { return getDouble(CmFNA_1St_FanSimple_parameter_14); }
  public void setCmFNA_1St_FanSimple_parameter_14(double v) { setDouble(CmFNA_1St_FanSimple_parameter_14,v,null); }
// STx-02: switch off delay
  public static final Property CmFNA_1St_FanSimple_parameter_44 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(120)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_1St_FanSimple_parameter_44() { return getDouble(CmFNA_1St_FanSimple_parameter_44); }
  public void setCmFNA_1St_FanSimple_parameter_44(double v) { setDouble(CmFNA_1St_FanSimple_parameter_44,v,null); }
// NFE-01: delay next fan enable
  public static final Property CmFNA_1St_FanSimple_parameter_251 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_1St_FanSimple_parameter_251() { return getDouble(CmFNA_1St_FanSimple_parameter_251); }
  public void setCmFNA_1St_FanSimple_parameter_251(double v) { setDouble(CmFNA_1St_FanSimple_parameter_251,v,null); }
// ALM-01: maint switch NO/NC; 1 = NC
  public static final Property CmFNA_1St_FanSimple_parameter_45 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_1St_FanSimple_parameter_45() { return getDouble(CmFNA_1St_FanSimple_parameter_45); }
  public void setCmFNA_1St_FanSimple_parameter_45(double v) { setDouble(CmFNA_1St_FanSimple_parameter_45,v,null); }
// ALM-02: maint switch reset type; 0= Man/ 1 = AutRes
  public static final Property CmFNA_1St_FanSimple_parameter_46 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_1St_FanSimple_parameter_46() { return getDouble(CmFNA_1St_FanSimple_parameter_46); }
  public void setCmFNA_1St_FanSimple_parameter_46(double v) { setDouble(CmFNA_1St_FanSimple_parameter_46,v,null); }
// ALM-03: fan alarm reset type 0=Man/ 1=AutRes
  public static final Property CmFNA_1St_FanSimple_parameter_47 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_1St_FanSimple_parameter_47() { return getDouble(CmFNA_1St_FanSimple_parameter_47); }
  public void setCmFNA_1St_FanSimple_parameter_47(double v) { setDouble(CmFNA_1St_FanSimple_parameter_47,v,null); }
// ALM-04: fan belt alarm reset type; 0= Man/ 1= AutRes
  public static final Property CmFNA_1St_FanSimple_parameter_529 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_1St_FanSimple_parameter_529() { return getDouble(CmFNA_1St_FanSimple_parameter_529); }
  public void setCmFNA_1St_FanSimple_parameter_529(double v) { setDouble(CmFNA_1St_FanSimple_parameter_529,v,null); }
// ALM-05: delay status alarm
  public static final Property CmFNA_1St_FanSimple_parameter_49 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_1St_FanSimple_parameter_49() { return getDouble(CmFNA_1St_FanSimple_parameter_49); }
  public void setCmFNA_1St_FanSimple_parameter_49(double v) { setDouble(CmFNA_1St_FanSimple_parameter_49,v,null); }
// ALM-06: delay fan belt alarm
  public static final Property CmFNA_1St_FanSimple_parameter_50 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_1St_FanSimple_parameter_50() { return getDouble(CmFNA_1St_FanSimple_parameter_50); }
  public void setCmFNA_1St_FanSimple_parameter_50(double v) { setDouble(CmFNA_1St_FanSimple_parameter_50,v,null); }
// DISP-01: fan belt alarm; 1=alarm
  public static final Property CmFNA_1St_FanSimple_parameter_52 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_1St_FanSimple_parameter_52() { return getDouble(CmFNA_1St_FanSimple_parameter_52); }
  public void setCmFNA_1St_FanSimple_parameter_52(double v) { setDouble(CmFNA_1St_FanSimple_parameter_52,v,null); }
// DISP-02: fan fail cmd alarm; 1=alarm
  public static final Property CmFNA_1St_FanSimple_parameter_53 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_1St_FanSimple_parameter_53() { return getDouble(CmFNA_1St_FanSimple_parameter_53); }
  public void setCmFNA_1St_FanSimple_parameter_53(double v) { setDouble(CmFNA_1St_FanSimple_parameter_53,v,null); }

  // macro inputs
// FanStageCmd
  public static final Property CmFNA_1St_FanSimple_input_308 = newProperty( Flags.SUMMARY, new BStatusNumeric( 1 ), null);
  public BStatusNumeric getCmFNA_1St_FanSimple_input_308() { return (BStatusNumeric) get(CmFNA_1St_FanSimple_input_308); }
  public void setCmFNA_1St_FanSimple_input_308(BStatusNumeric v) { set(CmFNA_1St_FanSimple_input_308,v,null); }
  public void setCmFNA_1St_FanSimple_input_308(float v) { getCmFNA_1St_FanSimple_input_308().setValue(v); }
// FanEnable
  public static final Property CmFNA_1St_FanSimple_input_1 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmFNA_1St_FanSimple_input_1() { return (BStatusBoolean) get(CmFNA_1St_FanSimple_input_1); }
  public void setCmFNA_1St_FanSimple_input_1(BStatusBoolean v) { set(CmFNA_1St_FanSimple_input_1,v,null); }
  public void setCmFNA_1St_FanSimple_input_1(boolean v) { getCmFNA_1St_FanSimple_input_1().setValue(v); }
// ManSwCond
  public static final Property CmFNA_1St_FanSimple_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 3 ), null);
  public BStatusNumeric getCmFNA_1St_FanSimple_input_2() { return (BStatusNumeric) get(CmFNA_1St_FanSimple_input_2); }
  public void setCmFNA_1St_FanSimple_input_2(BStatusNumeric v) { set(CmFNA_1St_FanSimple_input_2,v,null); }
  public void setCmFNA_1St_FanSimple_input_2(float v) { getCmFNA_1St_FanSimple_input_2().setValue(v); }
// Status
  public static final Property CmFNA_1St_FanSimple_input_4 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFNA_1St_FanSimple_input_4() { return (BStatusBoolean) get(CmFNA_1St_FanSimple_input_4); }
  public void setCmFNA_1St_FanSimple_input_4(BStatusBoolean v) { set(CmFNA_1St_FanSimple_input_4,v,null); }
  public void setCmFNA_1St_FanSimple_input_4(boolean v) { getCmFNA_1St_FanSimple_input_4().setValue(v); }
// Alarm
  public static final Property CmFNA_1St_FanSimple_input_5 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFNA_1St_FanSimple_input_5() { return (BStatusBoolean) get(CmFNA_1St_FanSimple_input_5); }
  public void setCmFNA_1St_FanSimple_input_5(BStatusBoolean v) { set(CmFNA_1St_FanSimple_input_5,v,null); }
  public void setCmFNA_1St_FanSimple_input_5(boolean v) { getCmFNA_1St_FanSimple_input_5().setValue(v); }
// FanBeltIn
  public static final Property CmFNA_1St_FanSimple_input_6 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFNA_1St_FanSimple_input_6() { return (BStatusBoolean) get(CmFNA_1St_FanSimple_input_6); }
  public void setCmFNA_1St_FanSimple_input_6(BStatusBoolean v) { set(CmFNA_1St_FanSimple_input_6,v,null); }
  public void setCmFNA_1St_FanSimple_input_6(boolean v) { getCmFNA_1St_FanSimple_input_6().setValue(v); }
// MaintSw
  public static final Property CmFNA_1St_FanSimple_input_7 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmFNA_1St_FanSimple_input_7() { return (BStatusBoolean) get(CmFNA_1St_FanSimple_input_7); }
  public void setCmFNA_1St_FanSimple_input_7(BStatusBoolean v) { set(CmFNA_1St_FanSimple_input_7,v,null); }
  public void setCmFNA_1St_FanSimple_input_7(boolean v) { getCmFNA_1St_FanSimple_input_7().setValue(v); }
// Reset
  public static final Property CmFNA_1St_FanSimple_input_8 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFNA_1St_FanSimple_input_8() { return (BStatusBoolean) get(CmFNA_1St_FanSimple_input_8); }
  public void setCmFNA_1St_FanSimple_input_8(BStatusBoolean v) { set(CmFNA_1St_FanSimple_input_8,v,null); }
  public void setCmFNA_1St_FanSimple_input_8(boolean v) { getCmFNA_1St_FanSimple_input_8().setValue(v); }
// PlantMode
  public static final Property CmFNA_1St_FanSimple_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmFNA_1St_FanSimple_input_3() { return (BStatusNumeric) get(CmFNA_1St_FanSimple_input_3); }
  public void setCmFNA_1St_FanSimple_input_3(BStatusNumeric v) { set(CmFNA_1St_FanSimple_input_3,v,null); }
  public void setCmFNA_1St_FanSimple_input_3(float v) { getCmFNA_1St_FanSimple_input_3().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.10 [42] 10.01.2017-14:58").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5889304373993931469").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmFNA_1St_FanSimple.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfTruncate func_71 = new CfTruncate();
  protected CfMonoflop func_286 = new CfMonoflop();
  protected CfWindow func_57 = new CfWindow();
  protected CfInputMultiplexer func_83 = new CfInputMultiplexer();
  protected CfWindow func_56 = new CfWindow();
  protected CfInputMultiplexer func_80 = new CfInputMultiplexer();
  protected CfMaximum func_316 = new CfMaximum();
  protected CfMinimum func_385 = new CfMinimum();
  protected CfTruncate func_72 = new CfTruncate();
  protected CfCompare1 func_73 = new CfCompare1();
  protected CfWindow func_399 = new CfWindow();
  protected CfOr func_403 = new CfOr();
  protected CfOr func_434 = new CfOr();
  protected CfIdt func_442 = new CfIdt();
  protected CfIdt func_448 = new CfIdt();
  protected CfIdt func_452 = new CfIdt();
  protected CfMonoflop func_524 = new CfMonoflop();
  protected CfNot func_402 = new CfNot();
  protected CfJkFlipFlop func_528 = new CfJkFlipFlop();
  protected CfAnd func_404 = new CfAnd();
  protected CfInputMultiplexer func_521 = new CfInputMultiplexer();
  protected CfOr func_405 = new CfOr();
  protected CmFan_Release func_110 = new CmFan_Release();
  protected CfAnd func_65 = new CfAnd();
  protected CmIDT05 func_372 = new CmIDT05();
  protected CfOr func_360 = new CfOr();
  protected CfInputMultiplexer func_357 = new CfInputMultiplexer();
  protected CfDelayOnOff func_370 = new CfDelayOnOff();
  protected CfDelayOnOff func_335 = new CfDelayOnOff();
  protected CmRelease_Stage_1 func_101 = new CmRelease_Stage_1();
  protected CfIdt func_438 = new CfIdt();
  protected CfInputMultiplexer func_440 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_481 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_485 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_444 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_482 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_486 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_447 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_483 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_487 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_451 = new CfInputMultiplexer();
  protected CmNext_Fan_Enable func_249 = new CmNext_Fan_Enable();
  protected CmIDT05 func_256 = new CmIDT05();
  protected CfCompare1 func_79 = new CfCompare1();
  protected CmAlarms func_81 = new CmAlarms();
  protected CfIdt func_91 = new CfIdt();
  protected CfIdt func_90 = new CfIdt();
  protected CfOr func_324 = new CfOr();
  protected CfCompare1 func_106 = new CfCompare1();
  protected CfOr func_294 = new CfOr();
  protected CmFan_Belt_Alarm func_377 = new CmFan_Belt_Alarm();
  protected CfIdt func_98 = new CfIdt();
  protected CmMaint_Switch_Alarm func_105 = new CmMaint_Switch_Alarm();
  protected CfInputMultiplexer func_484 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_488 = new CfInputMultiplexer();

  // default constructor
  public BCmFNA_1St_FanSimple()
  {
    func_405.configure(3);
    func_91.configure(2);
    func_90.configure(2);
    func_324.configure(4);
    func_98.configure(3);
  }

  public void Start()
  {
    func_286.Start();
    func_524.Start();
    func_528.Start();
    func_110.Start();
    func_372.Start();
    func_370.Start();
    func_335.Start();
    func_101.Start();
    func_249.Start();
    func_256.Start();
    func_81.Start();
    func_377.Start();
    func_105.Start();
  }
}
