/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    FNA_2St_Fan
Macro id:      5797336175954886782
Macro version: 203
Last change:   10.01.2017 - 14:58
Access Level:  2
Inputs:
  [1] FanStageCmd
  [2] FanEnable
  [3] ManSwCond
  [4] Status1
  [5] Status2
  [6] Alarm1
  [7] Alarm2
  [8] FanBeltIn
  [9] MaintSw
  [10] Reset
  [11] PlantMode
Outputs:
  [1] Stage1Cmd
  [2] Stage2Cmd
  [3] NextFanEnable
  [4] OffAlarm
  [5] OnAlarm
  [6] FailCmdAlarm
  [7] FanBeltAlarm
  [8] CommAlarm
  [9] OperationMode
Parameter:
  [1] SYS-01: serial/ parallel contacts ST1/ST2 0=serial
  [2] STx-01: delay from off to low speed
  [3] STx-02: delay from low to high speed
  [4] STx-03: delay from high to low speed
  [5] NFE-01: delay next fan enable
  [6] ALM-01: maint switch NO/NC; 1 = NC
  [7] ALM-02: maint switch reset type; 0= Man/ 1 = AutRes
  [8] ALM-03: fan alarm reset type 0=Man/ 1=AutRes
  [9] ALM-04: fan belt alarm reset type; 0= Man/ 1= AutRes
  [10] ALM-05: delay status alarm
  [11] ALM-06: delay fan belt alarm
  [12] ALM-07: status alarm type 0=off 1=fail to command alarm 2=on/ off alarms
  [13] DISP-01: fan belt alarm; 1=alarm
  [14] DISP-02: fan fail cmd alarm; 1=alarm
  [15] DISP-03: fan on alarm; 1=alarm
  [16] DISP-04: fan off alarm; 1=alarm
Description:
This macro provides fan control for 1 stage (on/ off) or 2 stages (off/ low/ high) with fan alarms, delayed start-up of stages and integrated plant and fire overrides. 
The fan speed can be controlled with following inputs:
 - Fan enable
 - Fan speed control
 - Manual switch condition from wall modules
 - Fan maintenance switch
 - Plant mode from an air handling unit strategy
================================================================================*/

public class BCmFNA_2St_Fan
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmFNA_2St_Fan_output_10().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmFNA_2St_Fan_output_10().setStatus(BStatus.disabled);
    getCmFNA_2St_Fan_output_11().setStatus(BStatus.disabled);
    getCmFNA_2St_Fan_output_12().setStatus(BStatus.disabled);
    getCmFNA_2St_Fan_output_14().setStatus(BStatus.disabled);
    getCmFNA_2St_Fan_output_13().setStatus(BStatus.disabled);
    getCmFNA_2St_Fan_output_1695().setStatus(BStatus.disabled);
    getCmFNA_2St_Fan_output_15().setStatus(BStatus.disabled);
    getCmFNA_2St_Fan_output_1499().setStatus(BStatus.disabled);
    getCmFNA_2St_Fan_output_2191().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmFNA_2St_Fan_output_10().setStatus(BStatus.ok);
    getCmFNA_2St_Fan_output_11().setStatus(BStatus.ok);
    getCmFNA_2St_Fan_output_12().setStatus(BStatus.ok);
    getCmFNA_2St_Fan_output_14().setStatus(BStatus.ok);
    getCmFNA_2St_Fan_output_13().setStatus(BStatus.ok);
    getCmFNA_2St_Fan_output_1695().setStatus(BStatus.ok);
    getCmFNA_2St_Fan_output_15().setStatus(BStatus.ok);
    getCmFNA_2St_Fan_output_1499().setStatus(BStatus.ok);
    getCmFNA_2St_Fan_output_2191().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [1531] Function call CfWindow
    func_1531.inputValue = (float) getCmFNA_2St_Fan_input_1498().getValue();
    func_1531.inputMinimum = 2.7F;
    func_1531.inputMaximum = 3.3F;
    func_1531.Execute(  );

    // [1530] Function call CfWindow
    func_1530.inputValue = (float) getCmFNA_2St_Fan_input_1498().getValue();
    func_1530.inputMinimum = 0.7F;
    func_1530.inputMaximum = 2.3F;
    func_1530.Execute(  );

    // [1513] Function call CfInputMultiplexer
    func_1513.inputSelect = BooleanToInt(func_1530.output);
    func_1513.input[1-1] = 0F;
    func_1513.input[2-1] = (float) getCmFNA_2St_Fan_input_1498().getValue();
    func_1513.Execute(  );

    // [1714] Function call CfMinimum
    func_1714.input[0] = (float) getCmFNA_2St_Fan_input_1().getValue();
    func_1714.input[1] = 2F;
    func_1714.Execute(  );

    // [1532] Function call CfInputMultiplexer
    func_1532.inputSelect = BooleanToInt(func_1531.output);
    func_1532.input[1-1] = func_1513.output;
    func_1532.input[2-1] = func_1714.output;
    func_1532.Execute(  );

    // [1835] Function call CfTruncate
    func_1835.input = (float) getCmFNA_2St_Fan_input_7().getValue();
    func_1835.Execute(  );

    // [856] Function call CfCompare1
    func_856.inputA = func_1835.output;
    func_856.inputB = 30F;
    func_856.Execute(  );

    // [1993] Function call CfDelayOnOff
    func_1993.input = func_1174.CmRelease_Stage_2_output_5;
    func_1993.Execute( this, 0 );

    // [1995] Function call CfIdt
    func_1995.input = 1F;
    func_1995.Execute(  );
    setParameter(1, func_1995.output[0]);

    // [1998] Function call CfIdt
    func_1998.input = 0F;
    func_1998.Execute(  );
    setParameter(0, func_1998.output[0]);

    // [1999] Function call CfIdt
    func_1999.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_1999.Execute(  );

    // [2047] Function call CfMonoflop
    func_2047.input = BooleanToFloat(getCmFNA_2St_Fan_input_9().getValue());
    func_2047.Execute( this, 2 );

    // [2065] Function call CfOr
    func_2065.input[0] = func_1551.outputOR;
    func_2065.input[1] = getCmFNA_2St_Fan_input_1496().getValue();
    func_2065.input[2] = getCmFNA_2St_Fan_input_1497().getValue();
    func_2065.input[3] = func_1149.CmMaint_Switch_Alarm_output_4;
    func_2065.input[4] = getCmFNA_2St_Fan_output_15().getValue();
    func_2065.Execute(  );
    setCmFNA_2St_Fan_output_1499(func_2065.outputOR);

    // [2078] Function call CfWindow
    func_2078.inputValue = (float) getCmFNA_2St_Fan_parameter_26();
    func_2078.inputMinimum = 0.8F;
    func_2078.inputMaximum = 1.2F;
    func_2078.Execute(  );

    // [2079] Function call CfOr
    func_2079.input[0] = FloatToBoolean(func_1562.output[0]);
    func_2079.input[1] = func_1149.CmMaint_Switch_Alarm_output_4;
    func_2079.Execute(  );

    // [2123] Function call CfInputMultiplexer
    func_2123.inputSelect = BooleanToInt(func_1391.CmDelay_Stage_1_output_5);
    func_2123.input[1-1] = BooleanToFloat(func_1168.CmRelease_Stage_1_output_9);
    func_2123.input[2-1] = 0F;
    func_2123.Execute(  );

    // [2130] Function call CfIdt
    func_2130.input = BooleanToFloat(getCmFNA_2St_Fan_output_15().getValue());
    func_2130.Execute(  );

    // [2132] Function call CfIdt
    func_2132.input = BooleanToFloat(func_1149.CmMaint_Switch_Alarm_output_4);
    func_2132.Execute(  );

    // [2133] Function call CfIdt
    func_2133.input = BooleanToFloat(func_856.outputEqual);
    func_2133.Execute(  );

    // [2155] Function call CfInputMultiplexer
    func_2155.inputSelect = BooleanToInt(func_1391.CmDelay_Stage_1_output_5);
    func_2155.input[1-1] = 15F;
    func_2155.input[2-1] = 13F;
    func_2155.Execute(  );

    // [2080] Function call CfIdt
    func_2080.input = BooleanToFloat(func_2079.outputOR);
    func_2080.Execute(  );
    setCmFNA_2St_Fan_output_14(FloatToBoolean(func_2080.output[0]));

    // [2081] Function call CfNot
    func_2081.input = func_2078.output;
    func_2081.Execute(  );

    // [2121] Function call CfOr
    func_2121.input[0] = func_1776.outputGreater;
    func_2121.input[1] = getCmFNA_2St_Fan_output_1499().getValue();
    func_2121.Execute(  );

    // [2126] Function call CfInputMultiplexer
    func_2126.inputSelect = BooleanToInt(func_1424.outputAND);
    func_2126.input[1-1] = func_2123.output;
    func_2126.input[2-1] = 0F;
    func_2126.Execute(  );

    // [2156] Function call CfInputMultiplexer
    func_2156.inputSelect = BooleanToInt(func_1424.outputAND);
    func_2156.input[1-1] = func_2155.output;
    func_2156.input[2-1] = 12F;
    func_2156.Execute(  );

    // [2082] Function call CfOr
    func_2082.input[0] = FloatToBoolean(func_2080.output[1]);
    func_2082.input[1] = getCmFNA_2St_Fan_output_1695().getValue();
    func_2082.Execute(  );

    // [2083] Function call CfAnd
    func_2083.input[0] = func_2081.output;
    func_2083.input[1] = func_2082.outputOR;
    func_2083.Execute(  );

    // [2084] Function call CfOr
    func_2084.input[0] = func_2083.outputAND;
    func_2084.input[1] = getCmFNA_2St_Fan_output_15().getValue();
    func_2084.input[2] = func_1149.CmMaint_Switch_Alarm_output_4;
    func_2084.Execute(  );

    // [1151] Macro call CmFan_Release
    func_1151.CmFan_Release_input_1 = func_1835.output;
    func_1151.CmFan_Release_input_2 = FloatToBoolean(func_1999.output[0]);
    func_1151.CmFan_Release_input_4 = func_1532.output;
    func_1151.CmFan_Release_input_5 = func_2084.outputOR;
    func_1151.Execute(  );

    // [1910] Function call CfAnd
    func_1910.input[0] = getCmFNA_2St_Fan_input_1495().getValue();
    func_1910.input[1] = func_1151.CmFan_Release_output_6;
    func_1910.Execute(  );

    // [1168] Macro call CmRelease_Stage_1
    func_1168.CmRelease_Stage_1_input_2 = FloatToBoolean(func_1999.output[0]);
    func_1168.CmRelease_Stage_1_input_4 = func_1910.outputAND;
    func_1168.Execute(  );

    // [2034] Function call CfNot
    func_2034.input = func_1391.CmDelay_Stage_1_output_5;
    func_2034.Execute(  );

    // [2031] Function call CfAnd
    func_2031.input[0] = func_2034.output;
    func_2031.input[1] = func_1910.outputAND;
    func_2031.Execute(  );

    // [1174] Macro call CmRelease_Stage_2
    func_1174.CmRelease_Stage_2_input_1 = func_1532.output;
    func_1174.CmRelease_Stage_2_input_3 = func_2031.outputAND;
    func_1174.CmRelease_Stage_2_input_46 = (float) getCmFNA_2St_Fan_parameter_18();
    func_1174.Execute( this, 3 );

    // [1391] Macro call CmDelay_Stage_1
    func_1391.CmDelay_Stage_1_input_1 = func_1174.CmRelease_Stage_2_output_5;
    func_1391.CmDelay_Stage_1_input_2 = func_1910.outputAND;
    func_1391.CmDelay_Stage_1_input_3 = (float) getCmFNA_2St_Fan_parameter_17();
    func_1391.CmDelay_Stage_1_input_4 = (float) getCmFNA_2St_Fan_parameter_19();
    func_1391.Execute( this, 8 );

    // [2005] Function call CfIdt
    func_2005.input = 0F;
    func_2005.Execute(  );
    setParameter(10, func_2005.output[0]);

    // [2006] Function call CfIdt
    func_2006.input = 1F;
    func_2006.Execute(  );
    setParameter(11, func_2006.output[0]);

    // [2131] Function call CfIdt
    func_2131.input = BooleanToFloat(func_2084.outputOR);
    func_2131.Execute(  );

    // [2138] Function call CfInputMultiplexer
    func_2138.inputSelect = FloatToInt(func_2131.output[0]);
    func_2138.input[1-1] = func_2126.output;
    func_2138.input[2-1] = 0F;
    func_2138.Execute(  );

    // [2157] Function call CfInputMultiplexer
    func_2157.inputSelect = FloatToInt(func_2131.output[0]);
    func_2157.input[1-1] = func_2156.output;
    func_2157.input[2-1] = 11F;
    func_2157.Execute(  );

    // [2161] Function call CfInputMultiplexer
    func_2161.inputSelect = FloatToInt(func_2131.output[0]);
    func_2161.input[1-1] = BooleanToFloat(func_1174.CmRelease_Stage_2_output_45);
    func_2161.input[2-1] = 0F;
    func_2161.Execute(  );

    // [2182] Function call CfInputMultiplexer
    func_2182.inputSelect = FloatToInt(func_2131.output[0]);
    func_2182.input[1-1] = BooleanToFloat(func_1178.CmNext_Fan_Enable_output_7);
    func_2182.input[2-1] = 0F;
    func_2182.Execute(  );

    // [2139] Function call CfInputMultiplexer
    func_2139.inputSelect = FloatToInt(func_2130.output[0]);
    func_2139.input[1-1] = func_2138.output;
    func_2139.input[2-1] = 0F;
    func_2139.Execute(  );

    // [2158] Function call CfInputMultiplexer
    func_2158.inputSelect = FloatToInt(func_2130.output[0]);
    func_2158.input[1-1] = func_2157.output;
    func_2158.input[2-1] = 10F;
    func_2158.Execute(  );

    // [2162] Function call CfInputMultiplexer
    func_2162.inputSelect = FloatToInt(func_2130.output[0]);
    func_2162.input[1-1] = func_2161.output;
    func_2162.input[2-1] = 0F;
    func_2162.Execute(  );

    // [2176] Function call CfInputMultiplexer
    func_2176.inputSelect = FloatToInt(func_2130.output[0]);
    func_2176.input[1-1] = func_2182.output;
    func_2176.input[2-1] = 0F;
    func_2176.Execute(  );

    // [2141] Function call CfInputMultiplexer
    func_2141.inputSelect = FloatToInt(func_2132.output[0]);
    func_2141.input[1-1] = func_2139.output;
    func_2141.input[2-1] = 0F;
    func_2141.Execute(  );

    // [2159] Function call CfInputMultiplexer
    func_2159.inputSelect = FloatToInt(func_2132.output[0]);
    func_2159.input[1-1] = func_2158.output;
    func_2159.input[2-1] = 5F;
    func_2159.Execute(  );

    // [2163] Function call CfInputMultiplexer
    func_2163.inputSelect = FloatToInt(func_2132.output[0]);
    func_2163.input[1-1] = func_2162.output;
    func_2163.input[2-1] = 0F;
    func_2163.Execute(  );

    // [2177] Function call CfInputMultiplexer
    func_2177.inputSelect = FloatToInt(func_2132.output[0]);
    func_2177.input[1-1] = func_2176.output;
    func_2177.input[2-1] = 0F;
    func_2177.Execute(  );

    // [2143] Function call CfInputMultiplexer
    func_2143.inputSelect = FloatToInt(func_2133.output[0]);
    func_2143.input[1-1] = func_2141.output;
    func_2143.input[2-1] = 0F;
    func_2143.Execute(  );
    setCmFNA_2St_Fan_output_10(FloatToBoolean(func_2143.output));

    // [1949] Function call CfOr
    func_1949.input[0] = getCmFNA_2St_Fan_output_10().getValue();
    func_1949.input[1] = func_1174.CmRelease_Stage_2_output_5;
    func_1949.Execute(  );

    // [1946] Function call CfDelayOnOff
    func_1946.input = func_1949.outputOR;
    func_1946.Execute( this, 10 );

    // [1178] Macro call CmNext_Fan_Enable
    func_1178.CmNext_Fan_Enable_input_1 = func_1910.outputAND;
    func_1178.CmNext_Fan_Enable_input_3 = func_1946.output;
    func_1178.CmNext_Fan_Enable_input_6 = (float) getCmFNA_2St_Fan_parameter_22();
    func_1178.Execute( this, 12 );

    // [1424] Function call CfAnd
    func_1424.input[0] = FloatToBoolean((float) getCmFNA_2St_Fan_parameter_20());
    func_1424.input[1] = func_1993.output;
    func_1424.Execute(  );

    // [1564] Function call CfIdt
    func_1564.input = (float) getCmFNA_2St_Fan_parameter_23();
    func_1564.Execute(  );
    setParameter(15, func_1564.output[0]);
    setParameter(21, func_1564.output[1]);

    // [1566] Function call CfIdt
    func_1566.input = (float) getCmFNA_2St_Fan_parameter_24();
    func_1566.Execute(  );
    setParameter(13, func_1566.output[0]);
    setParameter(19, func_1566.output[1]);

    // [1608] Function call CfIdt
    func_1608.input = (float) getCmFNA_2St_Fan_parameter_26();
    func_1608.Execute(  );
    setParameter(14, func_1608.output[0]);
    setParameter(20, func_1608.output[1]);

    // [1776] Function call CfCompare1
    func_1776.inputA = (float) getCmFNA_2St_Fan_parameter_24();
    func_1776.inputB = 0F;
    func_1776.Execute(  );

    // [1524] Macro call CmAlarms
    if ( func_2121.outputOR)
    {
      func_1524.CmAlarms_input_1 = getCmFNA_2St_Fan_output_10().getValue();
      func_1524.CmAlarms_input_2 = getCmFNA_2St_Fan_input_3().getValue();
      func_1524.CmAlarms_input_3 = getCmFNA_2St_Fan_input_1496().getValue();
      func_1524.CmAlarms_input_4 = func_2047.output;
      func_1524.Execute( this, 13 );
    }

    // [1537] Macro call CmAlarms
    if ( func_2121.outputOR)
    {
      func_1537.CmAlarms_input_1 = func_1174.CmRelease_Stage_2_output_5;
      func_1537.CmAlarms_input_2 = getCmFNA_2St_Fan_input_4().getValue();
      func_1537.CmAlarms_input_3 = getCmFNA_2St_Fan_input_1497().getValue();
      func_1537.CmAlarms_input_4 = func_2047.output;
      func_1537.Execute( this, 19 );
    }

    // [1543] Function call CfOr
    func_1543.input[0] = func_1524.CmAlarms_output_5;
    func_1543.input[1] = func_1537.CmAlarms_output_5;
    func_1543.Execute(  );

    // [1562] Function call CfIdt
    func_1562.input = BooleanToFloat(func_1543.outputOR);
    func_1562.Execute(  );
    setCmFNA_2St_Fan_parameter_28(func_1562.output[1]);

    // [1545] Function call CfOr
    func_1545.input[0] = func_1524.CmAlarms_output_6;
    func_1545.input[1] = func_1537.CmAlarms_output_6;
    func_1545.Execute(  );

    // [1563] Function call CfIdt
    func_1563.input = BooleanToFloat(func_1545.outputOR);
    func_1563.Execute(  );
    setCmFNA_2St_Fan_output_13(FloatToBoolean(func_1563.output[0]));
    setCmFNA_2St_Fan_parameter_27(func_1563.output[1]);

    // [1548] Function call CfOr
    func_1548.input[0] = func_1524.CmAlarms_output_7;
    func_1548.input[1] = func_1537.CmAlarms_output_7;
    func_1548.Execute(  );

    // [1746] Function call CfIdt
    func_1746.input = BooleanToFloat(func_1548.outputOR);
    func_1746.Execute(  );
    setCmFNA_2St_Fan_output_1695(FloatToBoolean(func_1746.output[0]));
    setCmFNA_2St_Fan_parameter_1733(func_1746.output[1]);

    // [1551] Function call CfOr
    func_1551.input[0] = func_1524.CmAlarms_output_53;
    func_1551.input[1] = func_1537.CmAlarms_output_53;
    func_1551.Execute(  );

    // [2067] Macro call CmIDT05
    func_2067.CmIDT05_input_1 = (float) getCmFNA_2St_Fan_parameter_21();
    func_2067.CmIDT05_input_2 = (float) getCmFNA_2St_Fan_parameter_2219();
    func_2067.CmIDT05_input_3 = BooleanToFloat(getCmFNA_2St_Fan_output_15().getValue());
    func_2067.CmIDT05_input_4 = 0F;
    func_2067.CmIDT05_input_5 = 0F;
    func_2067.Execute(  );
    setParameter(25, func_2067.CmIDT05_output_21);
    setParameter(26, func_2067.CmIDT05_output_22);
    setCmFNA_2St_Fan_parameter_29(func_2067.CmIDT05_output_23);

    // [1656] Function call CfNot
    func_1656.input = FloatToBoolean(func_1562.output[0]);
    func_1656.Execute(  );

    // [1650] Function call CfOr
    func_1650.input[0] = getCmFNA_2St_Fan_output_10().getValue();
    func_1650.input[1] = func_1174.CmRelease_Stage_2_output_5;
    func_1650.Execute(  );

    // [1646] Function call CfAnd
    func_1646.input[0] = func_1656.output;
    func_1646.input[1] = func_1650.outputOR;
    func_1646.Execute(  );

    // [1092] Function call CfCompare1
    func_1092.inputA = (float) getCmFNA_2St_Fan_parameter_21();
    func_1092.inputB = 0F;
    func_1092.Execute(  );

    // [2043] Function call CfOr
    func_2043.input[0] = func_1092.outputGreater;
    func_2043.input[1] = getCmFNA_2St_Fan_output_15().getValue();
    func_2043.Execute(  );

    // [1804] Macro call CmFan_Belt_Alarm
    if ( func_2043.outputOR)
    {
      func_1804.CmFan_Belt_Alarm_input_20 = func_1646.outputAND;
      func_1804.CmFan_Belt_Alarm_input_21 = getCmFNA_2St_Fan_input_2().getValue();
      func_1804.CmFan_Belt_Alarm_input_22 = func_2047.output;
      func_1804.Execute( this, 25 );
      setCmFNA_2St_Fan_output_15(func_1804.CmFan_Belt_Alarm_output_23);
    }

    // [1149] Macro call CmMaint_Switch_Alarm
    func_1149.CmMaint_Switch_Alarm_input_2 = getCmFNA_2St_Fan_input_5().getValue();
    func_1149.CmMaint_Switch_Alarm_input_146 = FloatToBoolean((float) getCmFNA_2St_Fan_parameter_1516());
    func_1149.CmMaint_Switch_Alarm_input_1 = FloatToBoolean((float) getCmFNA_2St_Fan_parameter_1607());
    func_1149.CmMaint_Switch_Alarm_input_3 = func_2047.output;
    func_1149.Execute(  );

    // [2160] Function call CfInputMultiplexer
    func_2160.inputSelect = FloatToInt(func_2133.output[0]);
    func_2160.input[1-1] = func_2159.output;
    func_2160.input[2-1] = 2F;
    func_2160.Execute(  );
    setCmFNA_2St_Fan_output_2191(func_2160.output);

    // [2168] Function call CfInputMultiplexer
    func_2168.inputSelect = FloatToInt(func_2133.output[0]);
    func_2168.input[1-1] = func_2163.output;
    func_2168.input[2-1] = 0F;
    func_2168.Execute(  );
    setCmFNA_2St_Fan_output_11(FloatToBoolean(func_2168.output));

    // [2183] Function call CfInputMultiplexer
    func_2183.inputSelect = FloatToInt(func_2133.output[0]);
    func_2183.input[1-1] = func_2177.output;
    func_2183.input[2-1] = 0F;
    func_2183.Execute(  );
    setCmFNA_2St_Fan_output_12(FloatToBoolean(func_2183.output));

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    10F, 10F, 10F, 10F, 1F, 10F, 0F, 1F,
    1F, 1F, 0F, 2F, 40F, 60F, 1F, 1F,
    10F, 10F, 1F, 60F, 1F, 1F, 10F, 10F,
    1F, 60F, 1F, 10F, 15F, 0F, 2F, 0F,
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// Stage1Cmd
  public static final Property CmFNA_2St_Fan_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_Fan_output_10() { return (BStatusBoolean) get(CmFNA_2St_Fan_output_10); }
  public void setCmFNA_2St_Fan_output_10(BStatusBoolean v) { set(CmFNA_2St_Fan_output_10,v,null); }
  public void setCmFNA_2St_Fan_output_10(boolean v) { getCmFNA_2St_Fan_output_10().setValue(v); }
// Stage2Cmd
  public static final Property CmFNA_2St_Fan_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_Fan_output_11() { return (BStatusBoolean) get(CmFNA_2St_Fan_output_11); }
  public void setCmFNA_2St_Fan_output_11(BStatusBoolean v) { set(CmFNA_2St_Fan_output_11,v,null); }
  public void setCmFNA_2St_Fan_output_11(boolean v) { getCmFNA_2St_Fan_output_11().setValue(v); }
// NextFanEnable
  public static final Property CmFNA_2St_Fan_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_Fan_output_12() { return (BStatusBoolean) get(CmFNA_2St_Fan_output_12); }
  public void setCmFNA_2St_Fan_output_12(BStatusBoolean v) { set(CmFNA_2St_Fan_output_12,v,null); }
  public void setCmFNA_2St_Fan_output_12(boolean v) { getCmFNA_2St_Fan_output_12().setValue(v); }
// OffAlarm
  public static final Property CmFNA_2St_Fan_output_14 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_Fan_output_14() { return (BStatusBoolean) get(CmFNA_2St_Fan_output_14); }
  public void setCmFNA_2St_Fan_output_14(BStatusBoolean v) { set(CmFNA_2St_Fan_output_14,v,null); }
  public void setCmFNA_2St_Fan_output_14(boolean v) { getCmFNA_2St_Fan_output_14().setValue(v); }
// OnAlarm
  public static final Property CmFNA_2St_Fan_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_Fan_output_13() { return (BStatusBoolean) get(CmFNA_2St_Fan_output_13); }
  public void setCmFNA_2St_Fan_output_13(BStatusBoolean v) { set(CmFNA_2St_Fan_output_13,v,null); }
  public void setCmFNA_2St_Fan_output_13(boolean v) { getCmFNA_2St_Fan_output_13().setValue(v); }
// FailCmdAlarm
  public static final Property CmFNA_2St_Fan_output_1695 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_Fan_output_1695() { return (BStatusBoolean) get(CmFNA_2St_Fan_output_1695); }
  public void setCmFNA_2St_Fan_output_1695(BStatusBoolean v) { set(CmFNA_2St_Fan_output_1695,v,null); }
  public void setCmFNA_2St_Fan_output_1695(boolean v) { getCmFNA_2St_Fan_output_1695().setValue(v); }
// FanBeltAlarm
  public static final Property CmFNA_2St_Fan_output_15 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_Fan_output_15() { return (BStatusBoolean) get(CmFNA_2St_Fan_output_15); }
  public void setCmFNA_2St_Fan_output_15(BStatusBoolean v) { set(CmFNA_2St_Fan_output_15,v,null); }
  public void setCmFNA_2St_Fan_output_15(boolean v) { getCmFNA_2St_Fan_output_15().setValue(v); }
// CommAlarm
  public static final Property CmFNA_2St_Fan_output_1499 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_Fan_output_1499() { return (BStatusBoolean) get(CmFNA_2St_Fan_output_1499); }
  public void setCmFNA_2St_Fan_output_1499(BStatusBoolean v) { set(CmFNA_2St_Fan_output_1499,v,null); }
  public void setCmFNA_2St_Fan_output_1499(boolean v) { getCmFNA_2St_Fan_output_1499().setValue(v); }
// OperationMode
  public static final Property CmFNA_2St_Fan_output_2191 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmFNA_2St_Fan_output_2191() { return (BStatusNumeric) get(CmFNA_2St_Fan_output_2191); }
  public void setCmFNA_2St_Fan_output_2191(BStatusNumeric v) { set(CmFNA_2St_Fan_output_2191,v,null); }
  public void setCmFNA_2St_Fan_output_2191(float v) { getCmFNA_2St_Fan_output_2191().setValue(v); }

  // macro parameter
// SYS-01: serial/ parallel contacts ST1/ST2 0=serial
  public static final Property CmFNA_2St_Fan_parameter_20 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_Fan_parameter_20() { return getDouble(CmFNA_2St_Fan_parameter_20); }
  public void setCmFNA_2St_Fan_parameter_20(double v) { setDouble(CmFNA_2St_Fan_parameter_20,v,null); }
// STx-01: delay from off to low speed
  public static final Property CmFNA_2St_Fan_parameter_17 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_Fan_parameter_17() { return getDouble(CmFNA_2St_Fan_parameter_17); }
  public void setCmFNA_2St_Fan_parameter_17(double v) { setDouble(CmFNA_2St_Fan_parameter_17,v,null); }
// STx-02: delay from low to high speed
  public static final Property CmFNA_2St_Fan_parameter_18 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(60)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_Fan_parameter_18() { return getDouble(CmFNA_2St_Fan_parameter_18); }
  public void setCmFNA_2St_Fan_parameter_18(double v) { setDouble(CmFNA_2St_Fan_parameter_18,v,null); }
// STx-03: delay from high to low speed
  public static final Property CmFNA_2St_Fan_parameter_19 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(120)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_Fan_parameter_19() { return getDouble(CmFNA_2St_Fan_parameter_19); }
  public void setCmFNA_2St_Fan_parameter_19(double v) { setDouble(CmFNA_2St_Fan_parameter_19,v,null); }
// NFE-01: delay next fan enable
  public static final Property CmFNA_2St_Fan_parameter_22 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_Fan_parameter_22() { return getDouble(CmFNA_2St_Fan_parameter_22); }
  public void setCmFNA_2St_Fan_parameter_22(double v) { setDouble(CmFNA_2St_Fan_parameter_22,v,null); }
// ALM-01: maint switch NO/NC; 1 = NC
  public static final Property CmFNA_2St_Fan_parameter_1516 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_Fan_parameter_1516() { return getDouble(CmFNA_2St_Fan_parameter_1516); }
  public void setCmFNA_2St_Fan_parameter_1516(double v) { setDouble(CmFNA_2St_Fan_parameter_1516,v,null); }
// ALM-02: maint switch reset type; 0= Man/ 1 = AutRes
  public static final Property CmFNA_2St_Fan_parameter_1607 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_Fan_parameter_1607() { return getDouble(CmFNA_2St_Fan_parameter_1607); }
  public void setCmFNA_2St_Fan_parameter_1607(double v) { setDouble(CmFNA_2St_Fan_parameter_1607,v,null); }
// ALM-03: fan alarm reset type 0=Man/ 1=AutRes
  public static final Property CmFNA_2St_Fan_parameter_26 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_Fan_parameter_26() { return getDouble(CmFNA_2St_Fan_parameter_26); }
  public void setCmFNA_2St_Fan_parameter_26(double v) { setDouble(CmFNA_2St_Fan_parameter_26,v,null); }
// ALM-04: fan belt alarm reset type; 0= Man/ 1= AutRes
  public static final Property CmFNA_2St_Fan_parameter_2219 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_Fan_parameter_2219() { return getDouble(CmFNA_2St_Fan_parameter_2219); }
  public void setCmFNA_2St_Fan_parameter_2219(double v) { setDouble(CmFNA_2St_Fan_parameter_2219,v,null); }
// ALM-05: delay status alarm
  public static final Property CmFNA_2St_Fan_parameter_24 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_Fan_parameter_24() { return getDouble(CmFNA_2St_Fan_parameter_24); }
  public void setCmFNA_2St_Fan_parameter_24(double v) { setDouble(CmFNA_2St_Fan_parameter_24,v,null); }
// ALM-06: delay fan belt alarm
  public static final Property CmFNA_2St_Fan_parameter_21 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_Fan_parameter_21() { return getDouble(CmFNA_2St_Fan_parameter_21); }
  public void setCmFNA_2St_Fan_parameter_21(double v) { setDouble(CmFNA_2St_Fan_parameter_21,v,null); }
// ALM-07: status alarm type 0=off 1=fail to command alarm 2=on/ off alarms
  public static final Property CmFNA_2St_Fan_parameter_23 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_Fan_parameter_23() { return getDouble(CmFNA_2St_Fan_parameter_23); }
  public void setCmFNA_2St_Fan_parameter_23(double v) { setDouble(CmFNA_2St_Fan_parameter_23,v,null); }
// DISP-01: fan belt alarm; 1=alarm
  public static final Property CmFNA_2St_Fan_parameter_29 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_Fan_parameter_29() { return getDouble(CmFNA_2St_Fan_parameter_29); }
  public void setCmFNA_2St_Fan_parameter_29(double v) { setDouble(CmFNA_2St_Fan_parameter_29,v,null); }
// DISP-02: fan fail cmd alarm; 1=alarm
  public static final Property CmFNA_2St_Fan_parameter_1733 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_Fan_parameter_1733() { return getDouble(CmFNA_2St_Fan_parameter_1733); }
  public void setCmFNA_2St_Fan_parameter_1733(double v) { setDouble(CmFNA_2St_Fan_parameter_1733,v,null); }
// DISP-03: fan on alarm; 1=alarm
  public static final Property CmFNA_2St_Fan_parameter_27 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_Fan_parameter_27() { return getDouble(CmFNA_2St_Fan_parameter_27); }
  public void setCmFNA_2St_Fan_parameter_27(double v) { setDouble(CmFNA_2St_Fan_parameter_27,v,null); }
// DISP-04: fan off alarm; 1=alarm
  public static final Property CmFNA_2St_Fan_parameter_28 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_Fan_parameter_28() { return getDouble(CmFNA_2St_Fan_parameter_28); }
  public void setCmFNA_2St_Fan_parameter_28(double v) { setDouble(CmFNA_2St_Fan_parameter_28,v,null); }

  // macro inputs
// FanStageCmd
  public static final Property CmFNA_2St_Fan_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 1 ), null);
  public BStatusNumeric getCmFNA_2St_Fan_input_1() { return (BStatusNumeric) get(CmFNA_2St_Fan_input_1); }
  public void setCmFNA_2St_Fan_input_1(BStatusNumeric v) { set(CmFNA_2St_Fan_input_1,v,null); }
  public void setCmFNA_2St_Fan_input_1(float v) { getCmFNA_2St_Fan_input_1().setValue(v); }
// FanEnable
  public static final Property CmFNA_2St_Fan_input_1495 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmFNA_2St_Fan_input_1495() { return (BStatusBoolean) get(CmFNA_2St_Fan_input_1495); }
  public void setCmFNA_2St_Fan_input_1495(BStatusBoolean v) { set(CmFNA_2St_Fan_input_1495,v,null); }
  public void setCmFNA_2St_Fan_input_1495(boolean v) { getCmFNA_2St_Fan_input_1495().setValue(v); }
// ManSwCond
  public static final Property CmFNA_2St_Fan_input_1498 = newProperty( Flags.SUMMARY, new BStatusNumeric( 3 ), null);
  public BStatusNumeric getCmFNA_2St_Fan_input_1498() { return (BStatusNumeric) get(CmFNA_2St_Fan_input_1498); }
  public void setCmFNA_2St_Fan_input_1498(BStatusNumeric v) { set(CmFNA_2St_Fan_input_1498,v,null); }
  public void setCmFNA_2St_Fan_input_1498(float v) { getCmFNA_2St_Fan_input_1498().setValue(v); }
// Status1
  public static final Property CmFNA_2St_Fan_input_3 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFNA_2St_Fan_input_3() { return (BStatusBoolean) get(CmFNA_2St_Fan_input_3); }
  public void setCmFNA_2St_Fan_input_3(BStatusBoolean v) { set(CmFNA_2St_Fan_input_3,v,null); }
  public void setCmFNA_2St_Fan_input_3(boolean v) { getCmFNA_2St_Fan_input_3().setValue(v); }
// Status2
  public static final Property CmFNA_2St_Fan_input_4 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFNA_2St_Fan_input_4() { return (BStatusBoolean) get(CmFNA_2St_Fan_input_4); }
  public void setCmFNA_2St_Fan_input_4(BStatusBoolean v) { set(CmFNA_2St_Fan_input_4,v,null); }
  public void setCmFNA_2St_Fan_input_4(boolean v) { getCmFNA_2St_Fan_input_4().setValue(v); }
// Alarm1
  public static final Property CmFNA_2St_Fan_input_1496 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFNA_2St_Fan_input_1496() { return (BStatusBoolean) get(CmFNA_2St_Fan_input_1496); }
  public void setCmFNA_2St_Fan_input_1496(BStatusBoolean v) { set(CmFNA_2St_Fan_input_1496,v,null); }
  public void setCmFNA_2St_Fan_input_1496(boolean v) { getCmFNA_2St_Fan_input_1496().setValue(v); }
// Alarm2
  public static final Property CmFNA_2St_Fan_input_1497 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFNA_2St_Fan_input_1497() { return (BStatusBoolean) get(CmFNA_2St_Fan_input_1497); }
  public void setCmFNA_2St_Fan_input_1497(BStatusBoolean v) { set(CmFNA_2St_Fan_input_1497,v,null); }
  public void setCmFNA_2St_Fan_input_1497(boolean v) { getCmFNA_2St_Fan_input_1497().setValue(v); }
// FanBeltIn
  public static final Property CmFNA_2St_Fan_input_2 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFNA_2St_Fan_input_2() { return (BStatusBoolean) get(CmFNA_2St_Fan_input_2); }
  public void setCmFNA_2St_Fan_input_2(BStatusBoolean v) { set(CmFNA_2St_Fan_input_2,v,null); }
  public void setCmFNA_2St_Fan_input_2(boolean v) { getCmFNA_2St_Fan_input_2().setValue(v); }
// MaintSw
  public static final Property CmFNA_2St_Fan_input_5 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmFNA_2St_Fan_input_5() { return (BStatusBoolean) get(CmFNA_2St_Fan_input_5); }
  public void setCmFNA_2St_Fan_input_5(BStatusBoolean v) { set(CmFNA_2St_Fan_input_5,v,null); }
  public void setCmFNA_2St_Fan_input_5(boolean v) { getCmFNA_2St_Fan_input_5().setValue(v); }
// Reset
  public static final Property CmFNA_2St_Fan_input_9 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFNA_2St_Fan_input_9() { return (BStatusBoolean) get(CmFNA_2St_Fan_input_9); }
  public void setCmFNA_2St_Fan_input_9(BStatusBoolean v) { set(CmFNA_2St_Fan_input_9,v,null); }
  public void setCmFNA_2St_Fan_input_9(boolean v) { getCmFNA_2St_Fan_input_9().setValue(v); }
// PlantMode
  public static final Property CmFNA_2St_Fan_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmFNA_2St_Fan_input_7() { return (BStatusNumeric) get(CmFNA_2St_Fan_input_7); }
  public void setCmFNA_2St_Fan_input_7(BStatusNumeric v) { set(CmFNA_2St_Fan_input_7,v,null); }
  public void setCmFNA_2St_Fan_input_7(float v) { getCmFNA_2St_Fan_input_7().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.10 [203] 10.01.2017-14:58").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5797336175954886782").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmFNA_2St_Fan.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfWindow func_1531 = new CfWindow();
  protected CfWindow func_1530 = new CfWindow();
  protected CfInputMultiplexer func_1513 = new CfInputMultiplexer();
  protected CfMinimum func_1714 = new CfMinimum();
  protected CfInputMultiplexer func_1532 = new CfInputMultiplexer();
  protected CfTruncate func_1835 = new CfTruncate();
  protected CfCompare1 func_856 = new CfCompare1();
  protected CfDelayOnOff func_1993 = new CfDelayOnOff();
  protected CfIdt func_1995 = new CfIdt();
  protected CfIdt func_1998 = new CfIdt();
  protected CfIdt func_1999 = new CfIdt();
  protected CfMonoflop func_2047 = new CfMonoflop();
  protected CfOr func_2065 = new CfOr();
  protected CfWindow func_2078 = new CfWindow();
  protected CfOr func_2079 = new CfOr();
  protected CfInputMultiplexer func_2123 = new CfInputMultiplexer();
  protected CfIdt func_2130 = new CfIdt();
  protected CfIdt func_2132 = new CfIdt();
  protected CfIdt func_2133 = new CfIdt();
  protected CfInputMultiplexer func_2155 = new CfInputMultiplexer();
  protected CfIdt func_2080 = new CfIdt();
  protected CfNot func_2081 = new CfNot();
  protected CfOr func_2121 = new CfOr();
  protected CfInputMultiplexer func_2126 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2156 = new CfInputMultiplexer();
  protected CfOr func_2082 = new CfOr();
  protected CfAnd func_2083 = new CfAnd();
  protected CfOr func_2084 = new CfOr();
  protected CmFan_Release func_1151 = new CmFan_Release();
  protected CfAnd func_1910 = new CfAnd();
  protected CmRelease_Stage_1 func_1168 = new CmRelease_Stage_1();
  protected CfNot func_2034 = new CfNot();
  protected CfAnd func_2031 = new CfAnd();
  protected CmRelease_Stage_2 func_1174 = new CmRelease_Stage_2();
  protected CmDelay_Stage_1 func_1391 = new CmDelay_Stage_1();
  protected CfIdt func_2005 = new CfIdt();
  protected CfIdt func_2006 = new CfIdt();
  protected CfIdt func_2131 = new CfIdt();
  protected CfInputMultiplexer func_2138 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2157 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2161 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2182 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2139 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2158 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2162 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2176 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2141 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2159 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2163 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2177 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2143 = new CfInputMultiplexer();
  protected CfOr func_1949 = new CfOr();
  protected CfDelayOnOff func_1946 = new CfDelayOnOff();
  protected CmNext_Fan_Enable func_1178 = new CmNext_Fan_Enable();
  protected CfAnd func_1424 = new CfAnd();
  protected CfIdt func_1564 = new CfIdt();
  protected CfIdt func_1566 = new CfIdt();
  protected CfIdt func_1608 = new CfIdt();
  protected CfCompare1 func_1776 = new CfCompare1();
  protected CmAlarms func_1524 = new CmAlarms();
  protected CmAlarms func_1537 = new CmAlarms();
  protected CfOr func_1543 = new CfOr();
  protected CfIdt func_1562 = new CfIdt();
  protected CfOr func_1545 = new CfOr();
  protected CfIdt func_1563 = new CfIdt();
  protected CfOr func_1548 = new CfOr();
  protected CfIdt func_1746 = new CfIdt();
  protected CfOr func_1551 = new CfOr();
  protected CmIDT05 func_2067 = new CmIDT05();
  protected CfNot func_1656 = new CfNot();
  protected CfOr func_1650 = new CfOr();
  protected CfAnd func_1646 = new CfAnd();
  protected CfCompare1 func_1092 = new CfCompare1();
  protected CfOr func_2043 = new CfOr();
  protected CmFan_Belt_Alarm func_1804 = new CmFan_Belt_Alarm();
  protected CmMaint_Switch_Alarm func_1149 = new CmMaint_Switch_Alarm();
  protected CfInputMultiplexer func_2160 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2168 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2183 = new CfInputMultiplexer();

  // default constructor
  public BCmFNA_2St_Fan()
  {
    func_2065.configure(5);
    func_2080.configure(2);
    func_2084.configure(3);
    func_1564.configure(2);
    func_1566.configure(2);
    func_1608.configure(2);
    func_1562.configure(2);
    func_1563.configure(2);
    func_1746.configure(2);
  }

  public void Start()
  {
    func_1993.Start();
    func_2047.Start();
    func_1151.Start();
    func_1168.Start();
    func_1174.Start();
    func_1391.Start();
    func_1946.Start();
    func_1178.Start();
    func_1524.Start();
    func_1537.Start();
    func_2067.Start();
    func_1804.Start();
    func_1149.Start();
  }
}
