/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    FNA_2St_FanSimple
Macro id:      5875495387799748802
Macro version: 86
Last change:   10.01.2017 - 14:59
Access Level:  2
Inputs:
  [1] FanStageCmd
  [2] FanEnable
  [3] ManSwCond
  [4] Status1
  [5] Status2
  [6] Alarm1
  [7] Alarm2
  [8] FanBeltIn
  [9] MaintSw
  [10] Reset
  [11] PlantMode
Outputs:
  [1] Stage1Cmd
  [2] Stage2Cmd
  [3] NextFanEnable
  [4] FailCmdAlarm
  [5] FanBeltAlarm
  [6] CommAlarm
  [7] OperationMode
Parameter:
  [1] SYS-01: serial/ parallel contacts ST1/ST2 0=serial
  [2] STx-01: delay from off to low speed
  [3] STx-02: delay from low to high speed
  [4] STx-03: delay from high to low speed
  [5] NFE-01: delay next fan enable
  [6] ALM-01: maint switch NO/NC; 1 = NC
  [7] ALM-02: maint switch reset type; 0= Man/ 1 = AutRes
  [8] ALM-03: fan alarm reset type 0=Man/ 1=AutRes
  [9] ALM-04: fan belt alarm reset type; 0= Man/ 1= AutRes
  [10] ALM-05: delay status alarm
  [11] ALM-06: delay fan belt alarm
  [12] DISP-01: fan belt alarm; 1 = alarm
  [13] DISP-02: fan fail cmd alarm; 1=alarm
Description:
This macro provides fan control for 1 stage (on/ off) or 2 stages (off/ low/ high) with fan alarms, delayed start-up of stages and integrated plant and fire overrides. 
The fan speed can be controlled with following inputs:
 - Fan enable
 - Fan speed control
 - Manual switch condition from wall modules
 - Fan maintenance switch
 - Plant mode from an air handling unit strategy
================================================================================*/

public class BCmFNA_2St_FanSimple
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmFNA_2St_FanSimple_output_21().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmFNA_2St_FanSimple_output_21().setStatus(BStatus.disabled);
    getCmFNA_2St_FanSimple_output_22().setStatus(BStatus.disabled);
    getCmFNA_2St_FanSimple_output_23().setStatus(BStatus.disabled);
    getCmFNA_2St_FanSimple_output_24().setStatus(BStatus.disabled);
    getCmFNA_2St_FanSimple_output_25().setStatus(BStatus.disabled);
    getCmFNA_2St_FanSimple_output_26().setStatus(BStatus.disabled);
    getCmFNA_2St_FanSimple_output_630().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmFNA_2St_FanSimple_output_21().setStatus(BStatus.ok);
    getCmFNA_2St_FanSimple_output_22().setStatus(BStatus.ok);
    getCmFNA_2St_FanSimple_output_23().setStatus(BStatus.ok);
    getCmFNA_2St_FanSimple_output_24().setStatus(BStatus.ok);
    getCmFNA_2St_FanSimple_output_25().setStatus(BStatus.ok);
    getCmFNA_2St_FanSimple_output_26().setStatus(BStatus.ok);
    getCmFNA_2St_FanSimple_output_630().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [212] Function call CfTruncate
    func_212.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_212.Execute(  );

    // [199] Function call CfWindow
    func_199.inputValue = (float) getCmFNA_2St_FanSimple_input_12().getValue();
    func_199.inputMinimum = 2.7F;
    func_199.inputMaximum = 3.3F;
    func_199.Execute(  );

    // [198] Function call CfWindow
    func_198.inputValue = (float) getCmFNA_2St_FanSimple_input_12().getValue();
    func_198.inputMinimum = 0.7F;
    func_198.inputMaximum = 2.3F;
    func_198.Execute(  );

    // [215] Function call CfInputMultiplexer
    func_215.inputSelect = BooleanToInt(func_198.output);
    func_215.input[1-1] = 0F;
    func_215.input[2-1] = (float) getCmFNA_2St_FanSimple_input_12().getValue();
    func_215.Execute(  );

    // [203] Function call CfMinimum
    func_203.input[0] = (float) getCmFNA_2St_FanSimple_input_11().getValue();
    func_203.input[1] = 2F;
    func_203.Execute(  );

    // [218] Function call CfInputMultiplexer
    func_218.inputSelect = BooleanToInt(func_199.output);
    func_218.input[1-1] = func_215.output;
    func_218.input[2-1] = func_203.output;
    func_218.Execute(  );

    // [205] Function call CfTruncate
    func_205.input = (float) getCmFNA_2St_FanSimple_input_13().getValue();
    func_205.Execute(  );

    // [213] Function call CfCompare1
    func_213.inputA = func_205.output;
    func_213.inputB = 30F;
    func_213.Execute(  );

    // [481] Function call CfMonoflop
    func_481.input = BooleanToFloat(getCmFNA_2St_FanSimple_input_20().getValue());
    func_481.Execute( this, 0 );

    // [508] Function call CfWindow
    func_508.inputValue = (float) getCmFNA_2St_FanSimple_parameter_163();
    func_508.inputMinimum = 0.8F;
    func_508.inputMaximum = 1.2F;
    func_508.Execute(  );

    // [509] Function call CfOr
    func_509.input[0] = getCmFNA_2St_FanSimple_output_24().getValue();
    func_509.input[1] = FloatToBoolean(func_227.output[0]);
    func_509.Execute(  );

    // [526] Function call CfOr
    func_526.input[0] = func_204.outputGreater;
    func_526.input[1] = FloatToBoolean(func_227.output[0]);
    func_526.Execute(  );

    // [541] Function call CfInputMultiplexer
    func_541.inputSelect = BooleanToInt(func_207.CmDelay_Stage_1_output_5);
    func_541.input[1-1] = BooleanToFloat(func_229.CmRelease_Stage_1_output_9);
    func_541.input[2-1] = 0F;
    func_541.Execute(  );

    // [542] Function call CfIdt
    func_542.input = BooleanToFloat(getCmFNA_2St_FanSimple_output_25().getValue());
    func_542.Execute(  );

    // [543] Function call CfIdt
    func_543.input = BooleanToFloat(func_190.CmMaint_Switch_Alarm_output_4);
    func_543.Execute(  );

    // [544] Function call CfIdt
    func_544.input = BooleanToFloat(func_213.outputEqual);
    func_544.Execute(  );

    // [545] Function call CfInputMultiplexer
    func_545.inputSelect = BooleanToInt(func_207.CmDelay_Stage_1_output_5);
    func_545.input[1-1] = 15F;
    func_545.input[2-1] = 13F;
    func_545.Execute(  );

    // [510] Function call CfNot
    func_510.input = func_508.output;
    func_510.Execute(  );

    // [546] Function call CfInputMultiplexer
    func_546.inputSelect = BooleanToInt(func_188.outputAND);
    func_546.input[1-1] = func_541.output;
    func_546.input[2-1] = 0F;
    func_546.Execute(  );

    // [547] Function call CfInputMultiplexer
    func_547.inputSelect = BooleanToInt(func_188.outputAND);
    func_547.input[1-1] = func_545.output;
    func_547.input[2-1] = 12F;
    func_547.Execute(  );

    // [511] Function call CfAnd
    func_511.input[0] = func_510.output;
    func_511.input[1] = func_509.outputOR;
    func_511.Execute(  );

    // [512] Function call CfOr
    func_512.input[0] = func_511.outputAND;
    func_512.input[1] = getCmFNA_2St_FanSimple_output_25().getValue();
    func_512.input[2] = func_190.CmMaint_Switch_Alarm_output_4;
    func_512.Execute(  );

    // [232] Macro call CmFan_Release
    func_232.CmFan_Release_input_1 = func_205.output;
    func_232.CmFan_Release_input_2 = FloatToBoolean(func_212.output);
    func_232.CmFan_Release_input_4 = func_218.output;
    func_232.CmFan_Release_input_5 = func_512.outputOR;
    func_232.Execute(  );

    // [206] Function call CfAnd
    func_206.input[0] = getCmFNA_2St_FanSimple_input_10().getValue();
    func_206.input[1] = func_232.CmFan_Release_output_6;
    func_206.Execute(  );

    // [229] Macro call CmRelease_Stage_1
    func_229.CmRelease_Stage_1_input_2 = FloatToBoolean(func_212.output);
    func_229.CmRelease_Stage_1_input_4 = func_206.outputAND;
    func_229.Execute(  );

    // [455] Function call CfNot
    func_455.input = func_207.CmDelay_Stage_1_output_5;
    func_455.Execute(  );

    // [454] Function call CfAnd
    func_454.input[0] = func_455.output;
    func_454.input[1] = func_206.outputAND;
    func_454.Execute(  );

    // [230] Macro call CmRelease_Stage_2
    func_230.CmRelease_Stage_2_input_1 = func_218.output;
    func_230.CmRelease_Stage_2_input_3 = func_454.outputAND;
    func_230.CmRelease_Stage_2_input_46 = (float) getCmFNA_2St_FanSimple_parameter_29();
    func_230.Execute( this, 1 );

    // [207] Macro call CmDelay_Stage_1
    func_207.CmDelay_Stage_1_input_1 = func_230.CmRelease_Stage_2_output_5;
    func_207.CmDelay_Stage_1_input_2 = func_206.outputAND;
    func_207.CmDelay_Stage_1_input_3 = (float) getCmFNA_2St_FanSimple_parameter_28();
    func_207.CmDelay_Stage_1_input_4 = (float) getCmFNA_2St_FanSimple_parameter_30();
    func_207.Execute( this, 6 );

    // [447] Function call CfIdt
    func_447.input = 0F;
    func_447.Execute(  );
    setParameter(8, func_447.output[0]);

    // [446] Function call CfIdt
    func_446.input = 2F;
    func_446.Execute(  );
    setParameter(9, func_446.output[0]);

    // [548] Function call CfIdt
    func_548.input = BooleanToFloat(func_512.outputOR);
    func_548.Execute(  );

    // [549] Function call CfInputMultiplexer
    func_549.inputSelect = FloatToInt(func_548.output[0]);
    func_549.input[1-1] = func_546.output;
    func_549.input[2-1] = 0F;
    func_549.Execute(  );

    // [550] Function call CfInputMultiplexer
    func_550.inputSelect = FloatToInt(func_548.output[0]);
    func_550.input[1-1] = func_547.output;
    func_550.input[2-1] = 11F;
    func_550.Execute(  );

    // [551] Function call CfInputMultiplexer
    func_551.inputSelect = FloatToInt(func_548.output[0]);
    func_551.input[1-1] = BooleanToFloat(func_230.CmRelease_Stage_2_output_45);
    func_551.input[2-1] = 0F;
    func_551.Execute(  );

    // [554] Function call CfInputMultiplexer
    func_554.inputSelect = FloatToInt(func_548.output[0]);
    func_554.input[1-1] = BooleanToFloat(func_233.CmNext_Fan_Enable_output_7);
    func_554.input[2-1] = 0F;
    func_554.Execute(  );

    // [555] Function call CfInputMultiplexer
    func_555.inputSelect = FloatToInt(func_542.output[0]);
    func_555.input[1-1] = func_549.output;
    func_555.input[2-1] = 0F;
    func_555.Execute(  );

    // [556] Function call CfInputMultiplexer
    func_556.inputSelect = FloatToInt(func_542.output[0]);
    func_556.input[1-1] = func_550.output;
    func_556.input[2-1] = 10F;
    func_556.Execute(  );

    // [557] Function call CfInputMultiplexer
    func_557.inputSelect = FloatToInt(func_542.output[0]);
    func_557.input[1-1] = func_551.output;
    func_557.input[2-1] = 0F;
    func_557.Execute(  );

    // [559] Function call CfInputMultiplexer
    func_559.inputSelect = FloatToInt(func_542.output[0]);
    func_559.input[1-1] = func_554.output;
    func_559.input[2-1] = 0F;
    func_559.Execute(  );

    // [561] Function call CfInputMultiplexer
    func_561.inputSelect = FloatToInt(func_543.output[0]);
    func_561.input[1-1] = func_555.output;
    func_561.input[2-1] = 0F;
    func_561.Execute(  );

    // [562] Function call CfInputMultiplexer
    func_562.inputSelect = FloatToInt(func_543.output[0]);
    func_562.input[1-1] = func_556.output;
    func_562.input[2-1] = 5F;
    func_562.Execute(  );

    // [563] Function call CfInputMultiplexer
    func_563.inputSelect = FloatToInt(func_543.output[0]);
    func_563.input[1-1] = func_557.output;
    func_563.input[2-1] = 0F;
    func_563.Execute(  );

    // [565] Function call CfInputMultiplexer
    func_565.inputSelect = FloatToInt(func_543.output[0]);
    func_565.input[1-1] = func_559.output;
    func_565.input[2-1] = 0F;
    func_565.Execute(  );

    // [567] Function call CfInputMultiplexer
    func_567.inputSelect = FloatToInt(func_544.output[0]);
    func_567.input[1-1] = func_561.output;
    func_567.input[2-1] = 0F;
    func_567.Execute(  );
    setCmFNA_2St_FanSimple_output_21(FloatToBoolean(func_567.output));

    // [436] Function call CfOr
    func_436.input[0] = getCmFNA_2St_FanSimple_output_21().getValue();
    func_436.input[1] = func_230.CmRelease_Stage_2_output_5;
    func_436.Execute(  );

    // [437] Function call CfDelayOnOff
    func_437.input = func_436.outputOR;
    func_437.Execute( this, 8 );

    // [233] Macro call CmNext_Fan_Enable
    func_233.CmNext_Fan_Enable_input_1 = func_206.outputAND;
    func_233.CmNext_Fan_Enable_input_3 = func_437.output;
    func_233.CmNext_Fan_Enable_input_6 = (float) getCmFNA_2St_FanSimple_parameter_31();
    func_233.Execute( this, 10 );

    // [419] Function call CfIdt
    func_419.input = 0F;
    func_419.Execute(  );
    setParameter(11, func_419.output[0]);

    // [418] Function call CfIdt
    func_418.input = 1F;
    func_418.Execute(  );
    setParameter(12, func_418.output[0]);

    // [416] Function call CfDelayOnOff
    func_416.input = func_230.CmRelease_Stage_2_output_5;
    func_416.Execute( this, 11 );

    // [188] Function call CfAnd
    func_188.input[0] = FloatToBoolean((float) getCmFNA_2St_FanSimple_parameter_160());
    func_188.input[1] = func_416.output;
    func_188.Execute(  );

    // [200] Function call CfIdt
    func_200.input = 1F;
    func_200.Execute(  );
    setParameter(15, func_200.output[0]);
    setParameter(21, func_200.output[1]);

    // [201] Function call CfIdt
    func_201.input = (float) getCmFNA_2St_FanSimple_parameter_165();
    func_201.Execute(  );
    setParameter(13, func_201.output[0]);
    setParameter(19, func_201.output[1]);

    // [202] Function call CfIdt
    func_202.input = (float) getCmFNA_2St_FanSimple_parameter_163();
    func_202.Execute(  );
    setParameter(14, func_202.output[0]);
    setParameter(20, func_202.output[1]);

    // [204] Function call CfCompare1
    func_204.inputA = (float) getCmFNA_2St_FanSimple_parameter_165();
    func_204.inputB = 0F;
    func_204.Execute(  );

    // [220] Macro call CmAlarms
    if ( func_526.outputOR)
    {
      func_220.CmAlarms_input_1 = getCmFNA_2St_FanSimple_output_21().getValue();
      func_220.CmAlarms_input_2 = getCmFNA_2St_FanSimple_input_14().getValue();
      func_220.CmAlarms_input_3 = getCmFNA_2St_FanSimple_input_16().getValue();
      func_220.CmAlarms_input_4 = func_481.output;
      func_220.Execute( this, 13 );
    }

    // [216] Macro call CmAlarms
    if ( func_526.outputOR)
    {
      func_216.CmAlarms_input_1 = func_230.CmRelease_Stage_2_output_5;
      func_216.CmAlarms_input_2 = getCmFNA_2St_FanSimple_input_15().getValue();
      func_216.CmAlarms_input_3 = getCmFNA_2St_FanSimple_input_17().getValue();
      func_216.CmAlarms_input_4 = func_481.output;
      func_216.Execute( this, 19 );
    }

    // [223] Function call CfOr
    func_223.input[0] = func_220.CmAlarms_output_7;
    func_223.input[1] = func_216.CmAlarms_output_7;
    func_223.Execute(  );

    // [224] Function call CfOr
    func_224.input[0] = func_220.CmAlarms_output_53;
    func_224.input[1] = func_216.CmAlarms_output_53;
    func_224.Execute(  );

    // [227] Function call CfIdt
    func_227.input = BooleanToFloat(func_224.outputOR);
    func_227.Execute(  );

    // [228] Function call CfIdt
    func_228.input = BooleanToFloat(func_223.outputOR);
    func_228.Execute(  );
    setCmFNA_2St_FanSimple_output_24(FloatToBoolean(func_228.output[0]));
    setCmFNA_2St_FanSimple_parameter_169(func_228.output[1]);

    // [387] Function call CfOr
    func_387.input[0] = FloatToBoolean(func_227.output[1]);
    func_387.input[1] = func_190.CmMaint_Switch_Alarm_output_4;
    func_387.input[2] = getCmFNA_2St_FanSimple_input_16().getValue();
    func_387.input[3] = getCmFNA_2St_FanSimple_input_17().getValue();
    func_387.input[4] = getCmFNA_2St_FanSimple_output_25().getValue();
    func_387.Execute(  );
    setCmFNA_2St_FanSimple_output_26(func_387.outputOR);

    // [491] Macro call CmIDT05
    func_491.CmIDT05_input_1 = (float) getCmFNA_2St_FanSimple_parameter_166();
    func_491.CmIDT05_input_2 = (float) getCmFNA_2St_FanSimple_parameter_633();
    func_491.CmIDT05_input_3 = BooleanToFloat(getCmFNA_2St_FanSimple_output_25().getValue());
    func_491.CmIDT05_input_4 = 0F;
    func_491.CmIDT05_input_5 = 0F;
    func_491.Execute(  );
    setParameter(25, func_491.CmIDT05_output_21);
    setParameter(26, func_491.CmIDT05_output_22);
    setCmFNA_2St_FanSimple_parameter_38(func_491.CmIDT05_output_23);

    // [182] Function call CfNot
    func_182.input = func_512.outputOR;
    func_182.Execute(  );

    // [172] Function call CfOr
    func_172.input[0] = getCmFNA_2St_FanSimple_output_21().getValue();
    func_172.input[1] = func_230.CmRelease_Stage_2_output_5;
    func_172.Execute(  );

    // [183] Function call CfAnd
    func_183.input[0] = func_182.output;
    func_183.input[1] = func_172.outputOR;
    func_183.Execute(  );

    // [191] Function call CfCompare1
    func_191.inputA = (float) getCmFNA_2St_FanSimple_parameter_166();
    func_191.inputB = 0F;
    func_191.Execute(  );

    // [485] Function call CfOr
    func_485.input[0] = func_191.outputGreater;
    func_485.input[1] = getCmFNA_2St_FanSimple_output_25().getValue();
    func_485.Execute(  );

    // [333] Macro call CmFan_Belt_Alarm
    if ( func_485.outputOR)
    {
      func_333.CmFan_Belt_Alarm_input_20 = func_183.outputAND;
      func_333.CmFan_Belt_Alarm_input_21 = getCmFNA_2St_FanSimple_input_18().getValue();
      func_333.CmFan_Belt_Alarm_input_22 = func_481.output;
      func_333.Execute( this, 25 );
      setCmFNA_2St_FanSimple_output_25(func_333.CmFan_Belt_Alarm_output_23);
    }

    // [190] Macro call CmMaint_Switch_Alarm
    func_190.CmMaint_Switch_Alarm_input_2 = getCmFNA_2St_FanSimple_input_19().getValue();
    func_190.CmMaint_Switch_Alarm_input_146 = FloatToBoolean((float) getCmFNA_2St_FanSimple_parameter_161());
    func_190.CmMaint_Switch_Alarm_input_1 = FloatToBoolean((float) getCmFNA_2St_FanSimple_parameter_162());
    func_190.CmMaint_Switch_Alarm_input_3 = func_481.output;
    func_190.Execute(  );

    // [568] Function call CfInputMultiplexer
    func_568.inputSelect = FloatToInt(func_544.output[0]);
    func_568.input[1-1] = func_562.output;
    func_568.input[2-1] = 2F;
    func_568.Execute(  );
    setCmFNA_2St_FanSimple_output_630(func_568.output);

    // [570] Function call CfInputMultiplexer
    func_570.inputSelect = FloatToInt(func_544.output[0]);
    func_570.input[1-1] = func_563.output;
    func_570.input[2-1] = 0F;
    func_570.Execute(  );
    setCmFNA_2St_FanSimple_output_22(FloatToBoolean(func_570.output));

    // [572] Function call CfInputMultiplexer
    func_572.inputSelect = FloatToInt(func_544.output[0]);
    func_572.input[1-1] = func_565.output;
    func_572.input[2-1] = 0F;
    func_572.Execute(  );
    setCmFNA_2St_FanSimple_output_23(FloatToBoolean(func_572.output));

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    10F, 10F, 1F, 10F, 10F, 10F, 1F, 1F,
    0F, 2F, 40F, 10F, 10F, 60F, 1F, 1F,
    10F, 10F, 1F, 60F, 1F, 1F, 10F, 10F,
    1F, 60F, 1F, 10F, 15F, 0F, 2F, 0F,
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// Stage1Cmd
  public static final Property CmFNA_2St_FanSimple_output_21 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_FanSimple_output_21() { return (BStatusBoolean) get(CmFNA_2St_FanSimple_output_21); }
  public void setCmFNA_2St_FanSimple_output_21(BStatusBoolean v) { set(CmFNA_2St_FanSimple_output_21,v,null); }
  public void setCmFNA_2St_FanSimple_output_21(boolean v) { getCmFNA_2St_FanSimple_output_21().setValue(v); }
// Stage2Cmd
  public static final Property CmFNA_2St_FanSimple_output_22 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_FanSimple_output_22() { return (BStatusBoolean) get(CmFNA_2St_FanSimple_output_22); }
  public void setCmFNA_2St_FanSimple_output_22(BStatusBoolean v) { set(CmFNA_2St_FanSimple_output_22,v,null); }
  public void setCmFNA_2St_FanSimple_output_22(boolean v) { getCmFNA_2St_FanSimple_output_22().setValue(v); }
// NextFanEnable
  public static final Property CmFNA_2St_FanSimple_output_23 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_FanSimple_output_23() { return (BStatusBoolean) get(CmFNA_2St_FanSimple_output_23); }
  public void setCmFNA_2St_FanSimple_output_23(BStatusBoolean v) { set(CmFNA_2St_FanSimple_output_23,v,null); }
  public void setCmFNA_2St_FanSimple_output_23(boolean v) { getCmFNA_2St_FanSimple_output_23().setValue(v); }
// FailCmdAlarm
  public static final Property CmFNA_2St_FanSimple_output_24 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_FanSimple_output_24() { return (BStatusBoolean) get(CmFNA_2St_FanSimple_output_24); }
  public void setCmFNA_2St_FanSimple_output_24(BStatusBoolean v) { set(CmFNA_2St_FanSimple_output_24,v,null); }
  public void setCmFNA_2St_FanSimple_output_24(boolean v) { getCmFNA_2St_FanSimple_output_24().setValue(v); }
// FanBeltAlarm
  public static final Property CmFNA_2St_FanSimple_output_25 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_FanSimple_output_25() { return (BStatusBoolean) get(CmFNA_2St_FanSimple_output_25); }
  public void setCmFNA_2St_FanSimple_output_25(BStatusBoolean v) { set(CmFNA_2St_FanSimple_output_25,v,null); }
  public void setCmFNA_2St_FanSimple_output_25(boolean v) { getCmFNA_2St_FanSimple_output_25().setValue(v); }
// CommAlarm
  public static final Property CmFNA_2St_FanSimple_output_26 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_FanSimple_output_26() { return (BStatusBoolean) get(CmFNA_2St_FanSimple_output_26); }
  public void setCmFNA_2St_FanSimple_output_26(BStatusBoolean v) { set(CmFNA_2St_FanSimple_output_26,v,null); }
  public void setCmFNA_2St_FanSimple_output_26(boolean v) { getCmFNA_2St_FanSimple_output_26().setValue(v); }
// OperationMode
  public static final Property CmFNA_2St_FanSimple_output_630 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmFNA_2St_FanSimple_output_630() { return (BStatusNumeric) get(CmFNA_2St_FanSimple_output_630); }
  public void setCmFNA_2St_FanSimple_output_630(BStatusNumeric v) { set(CmFNA_2St_FanSimple_output_630,v,null); }
  public void setCmFNA_2St_FanSimple_output_630(float v) { getCmFNA_2St_FanSimple_output_630().setValue(v); }

  // macro parameter
// SYS-01: serial/ parallel contacts ST1/ST2 0=serial
  public static final Property CmFNA_2St_FanSimple_parameter_160 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_FanSimple_parameter_160() { return getDouble(CmFNA_2St_FanSimple_parameter_160); }
  public void setCmFNA_2St_FanSimple_parameter_160(double v) { setDouble(CmFNA_2St_FanSimple_parameter_160,v,null); }
// STx-01: delay from off to low speed
  public static final Property CmFNA_2St_FanSimple_parameter_28 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_FanSimple_parameter_28() { return getDouble(CmFNA_2St_FanSimple_parameter_28); }
  public void setCmFNA_2St_FanSimple_parameter_28(double v) { setDouble(CmFNA_2St_FanSimple_parameter_28,v,null); }
// STx-02: delay from low to high speed
  public static final Property CmFNA_2St_FanSimple_parameter_29 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(60)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_FanSimple_parameter_29() { return getDouble(CmFNA_2St_FanSimple_parameter_29); }
  public void setCmFNA_2St_FanSimple_parameter_29(double v) { setDouble(CmFNA_2St_FanSimple_parameter_29,v,null); }
// STx-03: delay from high to low speed
  public static final Property CmFNA_2St_FanSimple_parameter_30 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(120)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_FanSimple_parameter_30() { return getDouble(CmFNA_2St_FanSimple_parameter_30); }
  public void setCmFNA_2St_FanSimple_parameter_30(double v) { setDouble(CmFNA_2St_FanSimple_parameter_30,v,null); }
// NFE-01: delay next fan enable
  public static final Property CmFNA_2St_FanSimple_parameter_31 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_FanSimple_parameter_31() { return getDouble(CmFNA_2St_FanSimple_parameter_31); }
  public void setCmFNA_2St_FanSimple_parameter_31(double v) { setDouble(CmFNA_2St_FanSimple_parameter_31,v,null); }
// ALM-01: maint switch NO/NC; 1 = NC
  public static final Property CmFNA_2St_FanSimple_parameter_161 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_FanSimple_parameter_161() { return getDouble(CmFNA_2St_FanSimple_parameter_161); }
  public void setCmFNA_2St_FanSimple_parameter_161(double v) { setDouble(CmFNA_2St_FanSimple_parameter_161,v,null); }
// ALM-02: maint switch reset type; 0= Man/ 1 = AutRes
  public static final Property CmFNA_2St_FanSimple_parameter_162 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_FanSimple_parameter_162() { return getDouble(CmFNA_2St_FanSimple_parameter_162); }
  public void setCmFNA_2St_FanSimple_parameter_162(double v) { setDouble(CmFNA_2St_FanSimple_parameter_162,v,null); }
// ALM-03: fan alarm reset type 0=Man/ 1=AutRes
  public static final Property CmFNA_2St_FanSimple_parameter_163 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_FanSimple_parameter_163() { return getDouble(CmFNA_2St_FanSimple_parameter_163); }
  public void setCmFNA_2St_FanSimple_parameter_163(double v) { setDouble(CmFNA_2St_FanSimple_parameter_163,v,null); }
// ALM-04: fan belt alarm reset type; 0= Man/ 1= AutRes
  public static final Property CmFNA_2St_FanSimple_parameter_633 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_FanSimple_parameter_633() { return getDouble(CmFNA_2St_FanSimple_parameter_633); }
  public void setCmFNA_2St_FanSimple_parameter_633(double v) { setDouble(CmFNA_2St_FanSimple_parameter_633,v,null); }
// ALM-05: delay status alarm
  public static final Property CmFNA_2St_FanSimple_parameter_165 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_FanSimple_parameter_165() { return getDouble(CmFNA_2St_FanSimple_parameter_165); }
  public void setCmFNA_2St_FanSimple_parameter_165(double v) { setDouble(CmFNA_2St_FanSimple_parameter_165,v,null); }
// ALM-06: delay fan belt alarm
  public static final Property CmFNA_2St_FanSimple_parameter_166 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_FanSimple_parameter_166() { return getDouble(CmFNA_2St_FanSimple_parameter_166); }
  public void setCmFNA_2St_FanSimple_parameter_166(double v) { setDouble(CmFNA_2St_FanSimple_parameter_166,v,null); }
// DISP-01: fan belt alarm; 1 = alarm
  public static final Property CmFNA_2St_FanSimple_parameter_38 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_FanSimple_parameter_38() { return getDouble(CmFNA_2St_FanSimple_parameter_38); }
  public void setCmFNA_2St_FanSimple_parameter_38(double v) { setDouble(CmFNA_2St_FanSimple_parameter_38,v,null); }
// DISP-02: fan fail cmd alarm; 1=alarm
  public static final Property CmFNA_2St_FanSimple_parameter_169 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_FanSimple_parameter_169() { return getDouble(CmFNA_2St_FanSimple_parameter_169); }
  public void setCmFNA_2St_FanSimple_parameter_169(double v) { setDouble(CmFNA_2St_FanSimple_parameter_169,v,null); }

  // macro inputs
// FanStageCmd
  public static final Property CmFNA_2St_FanSimple_input_11 = newProperty( Flags.SUMMARY, new BStatusNumeric( 1 ), null);
  public BStatusNumeric getCmFNA_2St_FanSimple_input_11() { return (BStatusNumeric) get(CmFNA_2St_FanSimple_input_11); }
  public void setCmFNA_2St_FanSimple_input_11(BStatusNumeric v) { set(CmFNA_2St_FanSimple_input_11,v,null); }
  public void setCmFNA_2St_FanSimple_input_11(float v) { getCmFNA_2St_FanSimple_input_11().setValue(v); }
// FanEnable
  public static final Property CmFNA_2St_FanSimple_input_10 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmFNA_2St_FanSimple_input_10() { return (BStatusBoolean) get(CmFNA_2St_FanSimple_input_10); }
  public void setCmFNA_2St_FanSimple_input_10(BStatusBoolean v) { set(CmFNA_2St_FanSimple_input_10,v,null); }
  public void setCmFNA_2St_FanSimple_input_10(boolean v) { getCmFNA_2St_FanSimple_input_10().setValue(v); }
// ManSwCond
  public static final Property CmFNA_2St_FanSimple_input_12 = newProperty( Flags.SUMMARY, new BStatusNumeric( 3 ), null);
  public BStatusNumeric getCmFNA_2St_FanSimple_input_12() { return (BStatusNumeric) get(CmFNA_2St_FanSimple_input_12); }
  public void setCmFNA_2St_FanSimple_input_12(BStatusNumeric v) { set(CmFNA_2St_FanSimple_input_12,v,null); }
  public void setCmFNA_2St_FanSimple_input_12(float v) { getCmFNA_2St_FanSimple_input_12().setValue(v); }
// Status1
  public static final Property CmFNA_2St_FanSimple_input_14 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFNA_2St_FanSimple_input_14() { return (BStatusBoolean) get(CmFNA_2St_FanSimple_input_14); }
  public void setCmFNA_2St_FanSimple_input_14(BStatusBoolean v) { set(CmFNA_2St_FanSimple_input_14,v,null); }
  public void setCmFNA_2St_FanSimple_input_14(boolean v) { getCmFNA_2St_FanSimple_input_14().setValue(v); }
// Status2
  public static final Property CmFNA_2St_FanSimple_input_15 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFNA_2St_FanSimple_input_15() { return (BStatusBoolean) get(CmFNA_2St_FanSimple_input_15); }
  public void setCmFNA_2St_FanSimple_input_15(BStatusBoolean v) { set(CmFNA_2St_FanSimple_input_15,v,null); }
  public void setCmFNA_2St_FanSimple_input_15(boolean v) { getCmFNA_2St_FanSimple_input_15().setValue(v); }
// Alarm1
  public static final Property CmFNA_2St_FanSimple_input_16 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFNA_2St_FanSimple_input_16() { return (BStatusBoolean) get(CmFNA_2St_FanSimple_input_16); }
  public void setCmFNA_2St_FanSimple_input_16(BStatusBoolean v) { set(CmFNA_2St_FanSimple_input_16,v,null); }
  public void setCmFNA_2St_FanSimple_input_16(boolean v) { getCmFNA_2St_FanSimple_input_16().setValue(v); }
// Alarm2
  public static final Property CmFNA_2St_FanSimple_input_17 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFNA_2St_FanSimple_input_17() { return (BStatusBoolean) get(CmFNA_2St_FanSimple_input_17); }
  public void setCmFNA_2St_FanSimple_input_17(BStatusBoolean v) { set(CmFNA_2St_FanSimple_input_17,v,null); }
  public void setCmFNA_2St_FanSimple_input_17(boolean v) { getCmFNA_2St_FanSimple_input_17().setValue(v); }
// FanBeltIn
  public static final Property CmFNA_2St_FanSimple_input_18 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFNA_2St_FanSimple_input_18() { return (BStatusBoolean) get(CmFNA_2St_FanSimple_input_18); }
  public void setCmFNA_2St_FanSimple_input_18(BStatusBoolean v) { set(CmFNA_2St_FanSimple_input_18,v,null); }
  public void setCmFNA_2St_FanSimple_input_18(boolean v) { getCmFNA_2St_FanSimple_input_18().setValue(v); }
// MaintSw
  public static final Property CmFNA_2St_FanSimple_input_19 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmFNA_2St_FanSimple_input_19() { return (BStatusBoolean) get(CmFNA_2St_FanSimple_input_19); }
  public void setCmFNA_2St_FanSimple_input_19(BStatusBoolean v) { set(CmFNA_2St_FanSimple_input_19,v,null); }
  public void setCmFNA_2St_FanSimple_input_19(boolean v) { getCmFNA_2St_FanSimple_input_19().setValue(v); }
// Reset
  public static final Property CmFNA_2St_FanSimple_input_20 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFNA_2St_FanSimple_input_20() { return (BStatusBoolean) get(CmFNA_2St_FanSimple_input_20); }
  public void setCmFNA_2St_FanSimple_input_20(BStatusBoolean v) { set(CmFNA_2St_FanSimple_input_20,v,null); }
  public void setCmFNA_2St_FanSimple_input_20(boolean v) { getCmFNA_2St_FanSimple_input_20().setValue(v); }
// PlantMode
  public static final Property CmFNA_2St_FanSimple_input_13 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmFNA_2St_FanSimple_input_13() { return (BStatusNumeric) get(CmFNA_2St_FanSimple_input_13); }
  public void setCmFNA_2St_FanSimple_input_13(BStatusNumeric v) { set(CmFNA_2St_FanSimple_input_13,v,null); }
  public void setCmFNA_2St_FanSimple_input_13(float v) { getCmFNA_2St_FanSimple_input_13().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.10 [86] 10.01.2017-14:59").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5875495387799748802").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmFNA_2St_FanSimple.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfTruncate func_212 = new CfTruncate();
  protected CfWindow func_199 = new CfWindow();
  protected CfWindow func_198 = new CfWindow();
  protected CfInputMultiplexer func_215 = new CfInputMultiplexer();
  protected CfMinimum func_203 = new CfMinimum();
  protected CfInputMultiplexer func_218 = new CfInputMultiplexer();
  protected CfTruncate func_205 = new CfTruncate();
  protected CfCompare1 func_213 = new CfCompare1();
  protected CfMonoflop func_481 = new CfMonoflop();
  protected CfWindow func_508 = new CfWindow();
  protected CfOr func_509 = new CfOr();
  protected CfOr func_526 = new CfOr();
  protected CfInputMultiplexer func_541 = new CfInputMultiplexer();
  protected CfIdt func_542 = new CfIdt();
  protected CfIdt func_543 = new CfIdt();
  protected CfIdt func_544 = new CfIdt();
  protected CfInputMultiplexer func_545 = new CfInputMultiplexer();
  protected CfNot func_510 = new CfNot();
  protected CfInputMultiplexer func_546 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_547 = new CfInputMultiplexer();
  protected CfAnd func_511 = new CfAnd();
  protected CfOr func_512 = new CfOr();
  protected CmFan_Release func_232 = new CmFan_Release();
  protected CfAnd func_206 = new CfAnd();
  protected CmRelease_Stage_1 func_229 = new CmRelease_Stage_1();
  protected CfNot func_455 = new CfNot();
  protected CfAnd func_454 = new CfAnd();
  protected CmRelease_Stage_2 func_230 = new CmRelease_Stage_2();
  protected CmDelay_Stage_1 func_207 = new CmDelay_Stage_1();
  protected CfIdt func_447 = new CfIdt();
  protected CfIdt func_446 = new CfIdt();
  protected CfIdt func_548 = new CfIdt();
  protected CfInputMultiplexer func_549 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_550 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_551 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_554 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_555 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_556 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_557 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_559 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_561 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_562 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_563 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_565 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_567 = new CfInputMultiplexer();
  protected CfOr func_436 = new CfOr();
  protected CfDelayOnOff func_437 = new CfDelayOnOff();
  protected CmNext_Fan_Enable func_233 = new CmNext_Fan_Enable();
  protected CfIdt func_419 = new CfIdt();
  protected CfIdt func_418 = new CfIdt();
  protected CfDelayOnOff func_416 = new CfDelayOnOff();
  protected CfAnd func_188 = new CfAnd();
  protected CfIdt func_200 = new CfIdt();
  protected CfIdt func_201 = new CfIdt();
  protected CfIdt func_202 = new CfIdt();
  protected CfCompare1 func_204 = new CfCompare1();
  protected CmAlarms func_220 = new CmAlarms();
  protected CmAlarms func_216 = new CmAlarms();
  protected CfOr func_223 = new CfOr();
  protected CfOr func_224 = new CfOr();
  protected CfIdt func_227 = new CfIdt();
  protected CfIdt func_228 = new CfIdt();
  protected CfOr func_387 = new CfOr();
  protected CmIDT05 func_491 = new CmIDT05();
  protected CfNot func_182 = new CfNot();
  protected CfOr func_172 = new CfOr();
  protected CfAnd func_183 = new CfAnd();
  protected CfCompare1 func_191 = new CfCompare1();
  protected CfOr func_485 = new CfOr();
  protected CmFan_Belt_Alarm func_333 = new CmFan_Belt_Alarm();
  protected CmMaint_Switch_Alarm func_190 = new CmMaint_Switch_Alarm();
  protected CfInputMultiplexer func_568 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_570 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_572 = new CfInputMultiplexer();

  // default constructor
  public BCmFNA_2St_FanSimple()
  {
    func_512.configure(3);
    func_200.configure(2);
    func_201.configure(2);
    func_202.configure(2);
    func_227.configure(2);
    func_228.configure(2);
    func_387.configure(5);
  }

  public void Start()
  {
    func_481.Start();
    func_232.Start();
    func_229.Start();
    func_230.Start();
    func_207.Start();
    func_437.Start();
    func_233.Start();
    func_416.Start();
    func_220.Start();
    func_216.Start();
    func_491.Start();
    func_333.Start();
    func_190.Start();
  }
}
