/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    FNB_ModFan
Macro id:      5816330357287420612
Macro version: 94
Last change:   10.01.2017 - 14:59
Access Level:  2
Inputs:
  [1] FanSpeedControl
  [2] FanEnable
  [3] ManSwCond
  [4] Status
  [5] Alarm
  [6] FanBeltIn
  [7] MaintSw
  [8] Reset
  [9] PlantMode
Outputs:
  [1] FanCmd
  [2] FanSpeedControl
  [3] NextFanEnable
  [4] OffAlarm
  [5] OnAlarm
  [6] FailCmdAlarm
  [7] FanBeltAlarm
  [8] CommAlarm
  [9] OperationMode
Parameter:
  [1] FOF-01; delay fan start
  [2] NFE-01; delay next fan enable
  [3] FSC-01; control signal increase per minute
  [4] FSC-02; control signal decrease per minute
  [5] FSC-03; minimum fan speed control signal
  [6] FSC-04; maximum fan speed control signal
  [7] ALM-01; maint switch NO/NC; 1=NC
  [8] ALM-02; maint switch reset type; 0 = manual/ 1 = auto
  [9] ALM-03; fan alarm reset type; 0 = manual/ 1 = auto
  [10] ALM-04: fan belt alarm reset type; 0= Man/ 1= AutRes
  [11] ALM-05 delay status alarm; 0 = disable
  [12] ALM-06; delay fan belt alarm; 0 = disable
  [13] ALM-07; status alarm type; 0 = off; 1 = fail to command alarm; 2 = on/ off alarms
  [14] DISP-01; fan belt alarm; 1= alarm
  [15] DISP-02; fail cmd alarm; 1 = alarm
  [16] DISP-03; fan on alarm; 1= alarm
  [17] DISP-04; fan off alarm; 1= alarm
Description:
The macro "FNB_ModFan" is for modulating control of a variable fan speed is an output module. It provides variable fan speed control with fan alarms, delayed start-up of associated equipment and integrated features for plant overrides. The module is also applicable for e.g. variable speed pump control.
================================================================================*/

public class BCmFNB_ModFan
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmFNB_ModFan_output_10().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmFNB_ModFan_output_10().setStatus(BStatus.disabled);
    getCmFNB_ModFan_output_1462().setStatus(BStatus.disabled);
    getCmFNB_ModFan_output_12().setStatus(BStatus.disabled);
    getCmFNB_ModFan_output_14().setStatus(BStatus.disabled);
    getCmFNB_ModFan_output_13().setStatus(BStatus.disabled);
    getCmFNB_ModFan_output_1532().setStatus(BStatus.disabled);
    getCmFNB_ModFan_output_15().setStatus(BStatus.disabled);
    getCmFNB_ModFan_output_1589().setStatus(BStatus.disabled);
    getCmFNB_ModFan_output_1739().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmFNB_ModFan_output_10().setStatus(BStatus.ok);
    getCmFNB_ModFan_output_1462().setStatus(BStatus.ok);
    getCmFNB_ModFan_output_12().setStatus(BStatus.ok);
    getCmFNB_ModFan_output_14().setStatus(BStatus.ok);
    getCmFNB_ModFan_output_13().setStatus(BStatus.ok);
    getCmFNB_ModFan_output_1532().setStatus(BStatus.ok);
    getCmFNB_ModFan_output_15().setStatus(BStatus.ok);
    getCmFNB_ModFan_output_1589().setStatus(BStatus.ok);
    getCmFNB_ModFan_output_1739().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [1521] Function call CfMonoflop
    func_1521.input = BooleanToFloat(getCmFNB_ModFan_input_9().getValue());
    func_1521.Execute( this, 0 );

    // [1548] Macro call CmIDT05
    func_1548.CmIDT05_input_1 = (float) getCmFNB_ModFan_parameter_24();
    func_1548.CmIDT05_input_2 = (float) getCmFNB_ModFan_parameter_1515();
    func_1548.CmIDT05_input_3 = (float) getCmFNB_ModFan_parameter_23();
    func_1548.CmIDT05_input_4 = (float) getCmFNB_ModFan_parameter_21();
    func_1548.CmIDT05_input_5 = (float) getCmFNB_ModFan_parameter_1742();
    func_1548.Execute(  );
    setParameter(5, func_1548.CmIDT05_output_21);
    setParameter(6, func_1548.CmIDT05_output_22);
    setParameter(7, func_1548.CmIDT05_output_23);
    setParameter(11, func_1548.CmIDT05_output_24);
    setParameter(12, func_1548.CmIDT05_output_25);

    // [1570] Macro call CmIDT05
    func_1570.CmIDT05_input_1 = (float) getCmFNB_ModFan_parameter_1448();
    func_1570.CmIDT05_input_2 = (float) getCmFNB_ModFan_parameter_1449();
    func_1570.CmIDT05_input_3 = (float) getCmFNB_ModFan_parameter_20();
    func_1570.CmIDT05_input_4 = (float) getCmFNB_ModFan_parameter_1466();
    func_1570.CmIDT05_input_5 = 0F;
    func_1570.Execute(  );
    setParameter(18, func_1570.CmIDT05_output_21);
    setParameter(19, func_1570.CmIDT05_output_22);
    setParameter(20, func_1570.CmIDT05_output_23);
    setParameter(21, func_1570.CmIDT05_output_24);

    // [1574] Function call CfCompare1
    func_1574.inputA = (float) getCmFNB_ModFan_parameter_24();
    func_1574.inputB = 0F;
    func_1574.Execute(  );

    // [1583] Function call CfCompare1
    func_1583.inputA = (float) getCmFNB_ModFan_parameter_21();
    func_1583.inputB = 0F;
    func_1583.Execute(  );

    // [1605] Macro call CmManual_Switch_Command
    func_1605.CmManual_Switch_Command_input_1 = (float) getCmFNB_ModFan_input_1607().getValue();
    func_1605.CmManual_Switch_Command_input_2 = (float) getCmFNB_ModFan_input_1().getValue();
    func_1605.Execute( this, 1 );

    // [1609] Macro call CmIDT05
    func_1609.CmIDT05_input_1 = (float) getCmFNB_ModFan_parameter_20();
    func_1609.CmIDT05_input_2 = (float) getCmFNB_ModFan_parameter_1466();
    func_1609.CmIDT05_input_3 = 0F;
    func_1609.CmIDT05_input_4 = 0F;
    func_1609.CmIDT05_input_5 = 0F;
    func_1609.Execute(  );
    setParameter(1, func_1609.CmIDT05_output_21);
    setParameter(2, func_1609.CmIDT05_output_22);

    // [1618] Function call CfAnd
    func_1618.input[0] = getCmFNB_ModFan_input_1616().getValue();
    func_1618.input[1] = func_1151.CmFan_Release_output_6;
    func_1618.Execute(  );

    // [1391] Macro call CmDelay_Stage_1
    func_1391.CmDelay_Stage_1_input_1 = false;
    func_1391.CmDelay_Stage_1_input_2 = func_1618.outputAND;
    func_1391.CmDelay_Stage_1_input_3 = (float) getCmFNB_ModFan_parameter_17();
    func_1391.CmDelay_Stage_1_input_4 = 0F;
    func_1391.Execute( this, 3 );

    // [37] Function call CfTruncate
    func_37.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_37.Execute(  );

    // [40] Function call CfTruncate
    func_40.input = (float) getCmFNB_ModFan_input_7().getValue();
    func_40.Execute(  );

    // [856] Function call CfCompare1
    func_856.inputA = func_40.output;
    func_856.inputB = 30F;
    func_856.Execute(  );

    // [1168] Macro call CmRelease_Stage_1
    func_1168.CmRelease_Stage_1_input_2 = FloatToBoolean(func_37.output);
    func_1168.CmRelease_Stage_1_input_4 = func_1618.outputAND;
    func_1168.Execute(  );

    // [1149] Macro call CmMaint_Switch_Alarm
    func_1149.CmMaint_Switch_Alarm_input_2 = getCmFNB_ModFan_input_5().getValue();
    func_1149.CmMaint_Switch_Alarm_input_146 = FloatToBoolean((float) getCmFNB_ModFan_parameter_26());
    func_1149.CmMaint_Switch_Alarm_input_1 = FloatToBoolean((float) getCmFNB_ModFan_parameter_1514());
    func_1149.CmMaint_Switch_Alarm_input_3 = func_1521.output;
    func_1149.Execute(  );

    // [1627] Function call CfIdt
    func_1627.input = BooleanToFloat(func_419.outputOR);
    func_1627.Execute(  );
    setCmFNB_ModFan_output_14(FloatToBoolean(func_1627.output[0]));

    // [1629] Function call CfWindow
    func_1629.inputValue = (float) getCmFNB_ModFan_parameter_1515();
    func_1629.inputMinimum = 0.8F;
    func_1629.inputMaximum = 1.2F;
    func_1629.Execute(  );

    // [1659] Function call CfInputMultiplexer
    func_1659.inputSelect = BooleanToInt(func_1391.CmDelay_Stage_1_output_5);
    func_1659.input[1-1] = BooleanToFloat(func_1168.CmRelease_Stage_1_output_9);
    func_1659.input[2-1] = 0F;
    func_1659.Execute(  );

    // [1668] Function call CfIdt
    func_1668.input = 0;
    func_1668.Execute(  );

    // [1676] Function call CfIdt
    func_1676.input = BooleanToFloat(func_856.outputEqual);
    func_1676.Execute(  );

    // [1679] Function call CfInputMultiplexer
    func_1679.inputSelect = BooleanToInt(func_1391.CmDelay_Stage_1_output_5);
    func_1679.input[1-1] = 15F;
    func_1679.input[2-1] = 13F;
    func_1679.Execute(  );

    // [1749] Function call CfIdt
    func_1749.input = BooleanToFloat(func_1149.CmMaint_Switch_Alarm_output_4);
    func_1749.Execute(  );

    // [1641] Function call CfNot
    func_1641.input = func_1629.output;
    func_1641.Execute(  );

    // [1672] Function call CfIdt
    func_1672.input = func_1749.output[1];
    func_1672.Execute(  );

    // [1746] Function call CfIdt
    func_1746.input = BooleanToFloat(func_1534.CmFan_Belt_Alarm_output_23);
    func_1746.Execute(  );
    setCmFNB_ModFan_output_15(FloatToBoolean(func_1746.output[1]));

    // [1580] Function call CfOr
    func_1580.input[0] = func_1583.outputGreater;
    func_1580.input[1] = getCmFNB_ModFan_output_15().getValue();
    func_1580.Execute(  );

    // [1661] Function call CfOr
    func_1661.input[0] = func_1647.outputOR;
    func_1661.input[1] = getCmFNB_ModFan_input_1531().getValue();
    func_1661.Execute(  );

    // [1664] Function call CfInputMultiplexer
    func_1664.inputSelect = BooleanToInt(func_1661.outputOR);
    func_1664.input[1-1] = func_1659.output;
    func_1664.input[2-1] = 0F;
    func_1664.Execute(  );

    // [1680] Function call CfInputMultiplexer
    func_1680.inputSelect = BooleanToInt(func_1661.outputOR);
    func_1680.input[1-1] = func_1679.output;
    func_1680.input[2-1] = 11F;
    func_1680.Execute(  );

    // [1723] Function call CfInputMultiplexer
    func_1723.inputSelect = BooleanToInt(func_1661.outputOR);
    func_1723.input[1-1] = BooleanToFloat(func_1178.CmNext_Fan_Enable_output_7);
    func_1723.input[2-1] = 0F;
    func_1723.Execute(  );

    // [1666] Function call CfInputMultiplexer
    func_1666.inputSelect = FloatToInt(func_1668.output[0]);
    func_1666.input[1-1] = func_1664.output;
    func_1666.input[2-1] = 0F;
    func_1666.Execute(  );

    // [1681] Function call CfInputMultiplexer
    func_1681.inputSelect = FloatToInt(func_1668.output[0]);
    func_1681.input[1-1] = func_1680.output;
    func_1681.input[2-1] = 10F;
    func_1681.Execute(  );

    // [1720] Function call CfInputMultiplexer
    func_1720.inputSelect = FloatToInt(func_1668.output[0]);
    func_1720.input[1-1] = func_1723.output;
    func_1720.input[2-1] = 0F;
    func_1720.Execute(  );

    // [1671] Function call CfInputMultiplexer
    func_1671.inputSelect = FloatToInt(func_1672.output[0]);
    func_1671.input[1-1] = func_1666.output;
    func_1671.input[2-1] = 0F;
    func_1671.Execute(  );

    // [1682] Function call CfInputMultiplexer
    func_1682.inputSelect = FloatToInt(func_1672.output[0]);
    func_1682.input[1-1] = func_1681.output;
    func_1682.input[2-1] = 5F;
    func_1682.Execute(  );

    // [1721] Function call CfInputMultiplexer
    func_1721.inputSelect = FloatToInt(func_1672.output[0]);
    func_1721.input[1-1] = func_1720.output;
    func_1721.input[2-1] = 0F;
    func_1721.Execute(  );

    // [1675] Function call CfInputMultiplexer
    func_1675.inputSelect = FloatToInt(func_1676.output[0]);
    func_1675.input[1-1] = func_1671.output;
    func_1675.input[2-1] = 0F;
    func_1675.Execute(  );
    setCmFNB_ModFan_output_10(FloatToBoolean(func_1675.output));

    // [1683] Function call CfInputMultiplexer
    func_1683.inputSelect = FloatToInt(func_1676.output[0]);
    func_1683.input[1-1] = func_1682.output;
    func_1683.input[2-1] = 2F;
    func_1683.Execute(  );
    setCmFNB_ModFan_output_1739(func_1683.output);

    // [1722] Function call CfInputMultiplexer
    func_1722.inputSelect = FloatToInt(func_1676.output[0]);
    func_1722.input[1-1] = func_1721.output;
    func_1722.input[2-1] = 0F;
    func_1722.Execute(  );
    setCmFNB_ModFan_output_12(FloatToBoolean(func_1722.output));

    // [1528] Macro call CmAlarms
    if ( func_1574.outputGreater)
    {
      func_1528.CmAlarms_input_1 = getCmFNB_ModFan_output_10().getValue();
      func_1528.CmAlarms_input_2 = getCmFNB_ModFan_input_3().getValue();
      func_1528.CmAlarms_input_3 = getCmFNB_ModFan_input_1531().getValue();
      func_1528.CmAlarms_input_4 = func_1521.output;
      func_1528.Execute( this, 5 );
      setCmFNB_ModFan_output_13(func_1528.CmAlarms_output_6);
      setCmFNB_ModFan_output_1532(func_1528.CmAlarms_output_7);
    }

    // [419] Function call CfOr
    func_419.input[0] = func_1528.CmAlarms_output_5;
    func_419.input[1] = FloatToBoolean(func_1749.output[1]);
    func_419.Execute(  );

    // [1534] Macro call CmFan_Belt_Alarm
    if ( func_1580.outputOR)
    {
      func_1534.CmFan_Belt_Alarm_input_20 = getCmFNB_ModFan_output_10().getValue();
      func_1534.CmFan_Belt_Alarm_input_21 = getCmFNB_ModFan_input_2().getValue();
      func_1534.CmFan_Belt_Alarm_input_22 = func_1521.output;
      func_1534.Execute( this, 11 );
    }

    // [1566] Macro call CmModulation
    func_1566.CmModulation_input_1 = getCmFNB_ModFan_output_10().getValue();
    func_1566.CmModulation_input_2 = func_1605.CmManual_Switch_Command_output_3;
    func_1566.Execute( this, 18 );

    // [1550] Macro call CmIDT05
    func_1550.CmIDT05_input_1 = BooleanToFloat(getCmFNB_ModFan_output_13().getValue());
    func_1550.CmIDT05_input_2 = BooleanToFloat(getCmFNB_ModFan_output_14().getValue());
    func_1550.CmIDT05_input_3 = BooleanToFloat(getCmFNB_ModFan_output_1532().getValue());
    func_1550.CmIDT05_input_4 = BooleanToFloat(getCmFNB_ModFan_output_15().getValue());
    func_1550.CmIDT05_input_5 = 0F;
    func_1550.Execute(  );
    setCmFNB_ModFan_parameter_27(func_1550.CmIDT05_output_21);
    setCmFNB_ModFan_parameter_28(func_1550.CmIDT05_output_22);
    setCmFNB_ModFan_parameter_1533(func_1550.CmIDT05_output_23);
    setCmFNB_ModFan_parameter_29(func_1550.CmIDT05_output_24);

    // [1654] Function call CfOr
    func_1654.input[0] = FloatToBoolean(func_1627.output[1]);
    func_1654.input[1] = getCmFNB_ModFan_output_1532().getValue();
    func_1654.Execute(  );

    // [1690] Function call CfInputMultiplexer
    func_1690.inputSelect = BooleanToInt(func_1661.outputOR);
    func_1690.input[1-1] = func_1566.CmModulation_output_3;
    func_1690.input[2-1] = 0F;
    func_1690.Execute(  );

    // [1743] Function call CfOr
    func_1743.input[0] = func_1528.CmAlarms_output_53;
    func_1743.input[1] = FloatToBoolean(func_1746.output[0]);
    func_1743.input[2] = FloatToBoolean(func_1749.output[0]);
    func_1743.Execute(  );
    setCmFNB_ModFan_output_1589(func_1743.outputOR);

    // [1631] Function call CfAnd
    func_1631.input[0] = func_1641.output;
    func_1631.input[1] = func_1654.outputOR;
    func_1631.Execute(  );

    // [1691] Function call CfInputMultiplexer
    func_1691.inputSelect = FloatToInt(func_1668.output[0]);
    func_1691.input[1-1] = func_1690.output;
    func_1691.input[2-1] = 0F;
    func_1691.Execute(  );

    // [1647] Function call CfOr
    func_1647.input[0] = func_1631.outputAND;
    func_1647.input[1] = getCmFNB_ModFan_output_15().getValue();
    func_1647.input[2] = FloatToBoolean(func_1749.output[1]);
    func_1647.input[3] = getCmFNB_ModFan_input_1531().getValue();
    func_1647.Execute(  );

    // [1151] Macro call CmFan_Release
    func_1151.CmFan_Release_input_1 = func_40.output;
    func_1151.CmFan_Release_input_2 = FloatToBoolean(func_37.output);
    func_1151.CmFan_Release_input_4 = 1F;
    func_1151.CmFan_Release_input_5 = func_1647.outputOR;
    func_1151.Execute(  );

    // [1178] Macro call CmNext_Fan_Enable
    func_1178.CmNext_Fan_Enable_input_1 = func_1618.outputAND;
    func_1178.CmNext_Fan_Enable_input_3 = getCmFNB_ModFan_output_10().getValue();
    func_1178.CmNext_Fan_Enable_input_6 = (float) getCmFNB_ModFan_parameter_22();
    func_1178.Execute( this, 28 );

    // [1692] Function call CfInputMultiplexer
    func_1692.inputSelect = FloatToInt(func_1672.output[0]);
    func_1692.input[1-1] = func_1691.output;
    func_1692.input[2-1] = 0F;
    func_1692.Execute(  );

    // [1693] Function call CfInputMultiplexer
    func_1693.inputSelect = FloatToInt(func_1676.output[0]);
    func_1693.input[1-1] = func_1692.output;
    func_1693.input[2-1] = 0F;
    func_1693.Execute(  );
    setCmFNB_ModFan_output_1462(func_1693.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    1F, 0F, 0F, 1F, 1F, 60F, 1F, 1F,
    10F, 10F, 1F, 60F, 1F, 10F, 15F, 0F,
    2F, 0F, 0F, 0F, 0F, 0F, 0F, 1F,
    10F, 10F, 100F, 0F, 40F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// FanCmd
  public static final Property CmFNB_ModFan_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNB_ModFan_output_10() { return (BStatusBoolean) get(CmFNB_ModFan_output_10); }
  public void setCmFNB_ModFan_output_10(BStatusBoolean v) { set(CmFNB_ModFan_output_10,v,null); }
  public void setCmFNB_ModFan_output_10(boolean v) { getCmFNB_ModFan_output_10().setValue(v); }
// FanSpeedControl
  public static final Property CmFNB_ModFan_output_1462 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("percent")));
  public BStatusNumeric getCmFNB_ModFan_output_1462() { return (BStatusNumeric) get(CmFNB_ModFan_output_1462); }
  public void setCmFNB_ModFan_output_1462(BStatusNumeric v) { set(CmFNB_ModFan_output_1462,v,null); }
  public void setCmFNB_ModFan_output_1462(float v) { getCmFNB_ModFan_output_1462().setValue(v); }
// NextFanEnable
  public static final Property CmFNB_ModFan_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNB_ModFan_output_12() { return (BStatusBoolean) get(CmFNB_ModFan_output_12); }
  public void setCmFNB_ModFan_output_12(BStatusBoolean v) { set(CmFNB_ModFan_output_12,v,null); }
  public void setCmFNB_ModFan_output_12(boolean v) { getCmFNB_ModFan_output_12().setValue(v); }
// OffAlarm
  public static final Property CmFNB_ModFan_output_14 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNB_ModFan_output_14() { return (BStatusBoolean) get(CmFNB_ModFan_output_14); }
  public void setCmFNB_ModFan_output_14(BStatusBoolean v) { set(CmFNB_ModFan_output_14,v,null); }
  public void setCmFNB_ModFan_output_14(boolean v) { getCmFNB_ModFan_output_14().setValue(v); }
// OnAlarm
  public static final Property CmFNB_ModFan_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNB_ModFan_output_13() { return (BStatusBoolean) get(CmFNB_ModFan_output_13); }
  public void setCmFNB_ModFan_output_13(BStatusBoolean v) { set(CmFNB_ModFan_output_13,v,null); }
  public void setCmFNB_ModFan_output_13(boolean v) { getCmFNB_ModFan_output_13().setValue(v); }
// FailCmdAlarm
  public static final Property CmFNB_ModFan_output_1532 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNB_ModFan_output_1532() { return (BStatusBoolean) get(CmFNB_ModFan_output_1532); }
  public void setCmFNB_ModFan_output_1532(BStatusBoolean v) { set(CmFNB_ModFan_output_1532,v,null); }
  public void setCmFNB_ModFan_output_1532(boolean v) { getCmFNB_ModFan_output_1532().setValue(v); }
// FanBeltAlarm
  public static final Property CmFNB_ModFan_output_15 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNB_ModFan_output_15() { return (BStatusBoolean) get(CmFNB_ModFan_output_15); }
  public void setCmFNB_ModFan_output_15(BStatusBoolean v) { set(CmFNB_ModFan_output_15,v,null); }
  public void setCmFNB_ModFan_output_15(boolean v) { getCmFNB_ModFan_output_15().setValue(v); }
// CommAlarm
  public static final Property CmFNB_ModFan_output_1589 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNB_ModFan_output_1589() { return (BStatusBoolean) get(CmFNB_ModFan_output_1589); }
  public void setCmFNB_ModFan_output_1589(BStatusBoolean v) { set(CmFNB_ModFan_output_1589,v,null); }
  public void setCmFNB_ModFan_output_1589(boolean v) { getCmFNB_ModFan_output_1589().setValue(v); }
// OperationMode
  public static final Property CmFNB_ModFan_output_1739 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmFNB_ModFan_output_1739() { return (BStatusNumeric) get(CmFNB_ModFan_output_1739); }
  public void setCmFNB_ModFan_output_1739(BStatusNumeric v) { set(CmFNB_ModFan_output_1739,v,null); }
  public void setCmFNB_ModFan_output_1739(float v) { getCmFNB_ModFan_output_1739().setValue(v); }

  // macro parameter
// FOF-01; delay fan start
  public static final Property CmFNB_ModFan_parameter_17 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNB_ModFan_parameter_17() { return getDouble(CmFNB_ModFan_parameter_17); }
  public void setCmFNB_ModFan_parameter_17(double v) { setDouble(CmFNB_ModFan_parameter_17,v,null); }
// NFE-01; delay next fan enable
  public static final Property CmFNB_ModFan_parameter_22 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNB_ModFan_parameter_22() { return getDouble(CmFNB_ModFan_parameter_22); }
  public void setCmFNB_ModFan_parameter_22(double v) { setDouble(CmFNB_ModFan_parameter_22,v,null); }
// FSC-01; control signal increase per minute
  public static final Property CmFNB_ModFan_parameter_1448 = newProperty( 0, BDouble.make( 25 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmFNB_ModFan_parameter_1448() { return getDouble(CmFNB_ModFan_parameter_1448); }
  public void setCmFNB_ModFan_parameter_1448(double v) { setDouble(CmFNB_ModFan_parameter_1448,v,null); }
// FSC-02; control signal decrease per minute
  public static final Property CmFNB_ModFan_parameter_1449 = newProperty( 0, BDouble.make( 25 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmFNB_ModFan_parameter_1449() { return getDouble(CmFNB_ModFan_parameter_1449); }
  public void setCmFNB_ModFan_parameter_1449(double v) { setDouble(CmFNB_ModFan_parameter_1449,v,null); }
// FSC-03; minimum fan speed control signal
  public static final Property CmFNB_ModFan_parameter_20 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmFNB_ModFan_parameter_20() { return getDouble(CmFNB_ModFan_parameter_20); }
  public void setCmFNB_ModFan_parameter_20(double v) { setDouble(CmFNB_ModFan_parameter_20,v,null); }
// FSC-04; maximum fan speed control signal
  public static final Property CmFNB_ModFan_parameter_1466 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmFNB_ModFan_parameter_1466() { return getDouble(CmFNB_ModFan_parameter_1466); }
  public void setCmFNB_ModFan_parameter_1466(double v) { setDouble(CmFNB_ModFan_parameter_1466,v,null); }
// ALM-01; maint switch NO/NC; 1=NC
  public static final Property CmFNB_ModFan_parameter_26 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNB_ModFan_parameter_26() { return getDouble(CmFNB_ModFan_parameter_26); }
  public void setCmFNB_ModFan_parameter_26(double v) { setDouble(CmFNB_ModFan_parameter_26,v,null); }
// ALM-02; maint switch reset type; 0 = manual/ 1 = auto
  public static final Property CmFNB_ModFan_parameter_1514 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNB_ModFan_parameter_1514() { return getDouble(CmFNB_ModFan_parameter_1514); }
  public void setCmFNB_ModFan_parameter_1514(double v) { setDouble(CmFNB_ModFan_parameter_1514,v,null); }
// ALM-03; fan alarm reset type; 0 = manual/ 1 = auto
  public static final Property CmFNB_ModFan_parameter_1515 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNB_ModFan_parameter_1515() { return getDouble(CmFNB_ModFan_parameter_1515); }
  public void setCmFNB_ModFan_parameter_1515(double v) { setDouble(CmFNB_ModFan_parameter_1515,v,null); }
// ALM-04: fan belt alarm reset type; 0= Man/ 1= AutRes
  public static final Property CmFNB_ModFan_parameter_1742 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNB_ModFan_parameter_1742() { return getDouble(CmFNB_ModFan_parameter_1742); }
  public void setCmFNB_ModFan_parameter_1742(double v) { setDouble(CmFNB_ModFan_parameter_1742,v,null); }
// ALM-05 delay status alarm; 0 = disable
  public static final Property CmFNB_ModFan_parameter_24 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNB_ModFan_parameter_24() { return getDouble(CmFNB_ModFan_parameter_24); }
  public void setCmFNB_ModFan_parameter_24(double v) { setDouble(CmFNB_ModFan_parameter_24,v,null); }
// ALM-06; delay fan belt alarm; 0 = disable
  public static final Property CmFNB_ModFan_parameter_21 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNB_ModFan_parameter_21() { return getDouble(CmFNB_ModFan_parameter_21); }
  public void setCmFNB_ModFan_parameter_21(double v) { setDouble(CmFNB_ModFan_parameter_21,v,null); }
// ALM-07; status alarm type; 0 = off; 1 = fail to command alarm; 2 = on/ off alarms
  public static final Property CmFNB_ModFan_parameter_23 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNB_ModFan_parameter_23() { return getDouble(CmFNB_ModFan_parameter_23); }
  public void setCmFNB_ModFan_parameter_23(double v) { setDouble(CmFNB_ModFan_parameter_23,v,null); }
// DISP-01; fan belt alarm; 1= alarm
  public static final Property CmFNB_ModFan_parameter_29 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNB_ModFan_parameter_29() { return getDouble(CmFNB_ModFan_parameter_29); }
  public void setCmFNB_ModFan_parameter_29(double v) { setDouble(CmFNB_ModFan_parameter_29,v,null); }
// DISP-02; fail cmd alarm; 1 = alarm
  public static final Property CmFNB_ModFan_parameter_1533 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNB_ModFan_parameter_1533() { return getDouble(CmFNB_ModFan_parameter_1533); }
  public void setCmFNB_ModFan_parameter_1533(double v) { setDouble(CmFNB_ModFan_parameter_1533,v,null); }
// DISP-03; fan on alarm; 1= alarm
  public static final Property CmFNB_ModFan_parameter_27 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNB_ModFan_parameter_27() { return getDouble(CmFNB_ModFan_parameter_27); }
  public void setCmFNB_ModFan_parameter_27(double v) { setDouble(CmFNB_ModFan_parameter_27,v,null); }
// DISP-04; fan off alarm; 1= alarm
  public static final Property CmFNB_ModFan_parameter_28 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNB_ModFan_parameter_28() { return getDouble(CmFNB_ModFan_parameter_28); }
  public void setCmFNB_ModFan_parameter_28(double v) { setDouble(CmFNB_ModFan_parameter_28,v,null); }

  // macro inputs
// FanSpeedControl
  public static final Property CmFNB_ModFan_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("percent")));
  public BStatusNumeric getCmFNB_ModFan_input_1() { return (BStatusNumeric) get(CmFNB_ModFan_input_1); }
  public void setCmFNB_ModFan_input_1(BStatusNumeric v) { set(CmFNB_ModFan_input_1,v,null); }
  public void setCmFNB_ModFan_input_1(float v) { getCmFNB_ModFan_input_1().setValue(v); }
// FanEnable
  public static final Property CmFNB_ModFan_input_1616 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmFNB_ModFan_input_1616() { return (BStatusBoolean) get(CmFNB_ModFan_input_1616); }
  public void setCmFNB_ModFan_input_1616(BStatusBoolean v) { set(CmFNB_ModFan_input_1616,v,null); }
  public void setCmFNB_ModFan_input_1616(boolean v) { getCmFNB_ModFan_input_1616().setValue(v); }
// ManSwCond
  public static final Property CmFNB_ModFan_input_1607 = newProperty( Flags.SUMMARY, new BStatusNumeric( 3 ), null);
  public BStatusNumeric getCmFNB_ModFan_input_1607() { return (BStatusNumeric) get(CmFNB_ModFan_input_1607); }
  public void setCmFNB_ModFan_input_1607(BStatusNumeric v) { set(CmFNB_ModFan_input_1607,v,null); }
  public void setCmFNB_ModFan_input_1607(float v) { getCmFNB_ModFan_input_1607().setValue(v); }
// Status
  public static final Property CmFNB_ModFan_input_3 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFNB_ModFan_input_3() { return (BStatusBoolean) get(CmFNB_ModFan_input_3); }
  public void setCmFNB_ModFan_input_3(BStatusBoolean v) { set(CmFNB_ModFan_input_3,v,null); }
  public void setCmFNB_ModFan_input_3(boolean v) { getCmFNB_ModFan_input_3().setValue(v); }
// Alarm
  public static final Property CmFNB_ModFan_input_1531 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFNB_ModFan_input_1531() { return (BStatusBoolean) get(CmFNB_ModFan_input_1531); }
  public void setCmFNB_ModFan_input_1531(BStatusBoolean v) { set(CmFNB_ModFan_input_1531,v,null); }
  public void setCmFNB_ModFan_input_1531(boolean v) { getCmFNB_ModFan_input_1531().setValue(v); }
// FanBeltIn
  public static final Property CmFNB_ModFan_input_2 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFNB_ModFan_input_2() { return (BStatusBoolean) get(CmFNB_ModFan_input_2); }
  public void setCmFNB_ModFan_input_2(BStatusBoolean v) { set(CmFNB_ModFan_input_2,v,null); }
  public void setCmFNB_ModFan_input_2(boolean v) { getCmFNB_ModFan_input_2().setValue(v); }
// MaintSw
  public static final Property CmFNB_ModFan_input_5 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmFNB_ModFan_input_5() { return (BStatusBoolean) get(CmFNB_ModFan_input_5); }
  public void setCmFNB_ModFan_input_5(BStatusBoolean v) { set(CmFNB_ModFan_input_5,v,null); }
  public void setCmFNB_ModFan_input_5(boolean v) { getCmFNB_ModFan_input_5().setValue(v); }
// Reset
  public static final Property CmFNB_ModFan_input_9 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFNB_ModFan_input_9() { return (BStatusBoolean) get(CmFNB_ModFan_input_9); }
  public void setCmFNB_ModFan_input_9(BStatusBoolean v) { set(CmFNB_ModFan_input_9,v,null); }
  public void setCmFNB_ModFan_input_9(boolean v) { getCmFNB_ModFan_input_9().setValue(v); }
// PlantMode
  public static final Property CmFNB_ModFan_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmFNB_ModFan_input_7() { return (BStatusNumeric) get(CmFNB_ModFan_input_7); }
  public void setCmFNB_ModFan_input_7(BStatusNumeric v) { set(CmFNB_ModFan_input_7,v,null); }
  public void setCmFNB_ModFan_input_7(float v) { getCmFNB_ModFan_input_7().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.10 [94] 10.01.2017-14:59").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5816330357287420612").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmFNB_ModFan.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfMonoflop func_1521 = new CfMonoflop();
  protected CmIDT05 func_1548 = new CmIDT05();
  protected CmIDT05 func_1570 = new CmIDT05();
  protected CfCompare1 func_1574 = new CfCompare1();
  protected CfCompare1 func_1583 = new CfCompare1();
  protected CmManual_Switch_Command func_1605 = new CmManual_Switch_Command();
  protected CmIDT05 func_1609 = new CmIDT05();
  protected CfAnd func_1618 = new CfAnd();
  protected CmDelay_Stage_1 func_1391 = new CmDelay_Stage_1();
  protected CfTruncate func_37 = new CfTruncate();
  protected CfTruncate func_40 = new CfTruncate();
  protected CfCompare1 func_856 = new CfCompare1();
  protected CmRelease_Stage_1 func_1168 = new CmRelease_Stage_1();
  protected CmMaint_Switch_Alarm func_1149 = new CmMaint_Switch_Alarm();
  protected CfIdt func_1627 = new CfIdt();
  protected CfWindow func_1629 = new CfWindow();
  protected CfInputMultiplexer func_1659 = new CfInputMultiplexer();
  protected CfIdt func_1668 = new CfIdt();
  protected CfIdt func_1676 = new CfIdt();
  protected CfInputMultiplexer func_1679 = new CfInputMultiplexer();
  protected CfIdt func_1749 = new CfIdt();
  protected CfNot func_1641 = new CfNot();
  protected CfIdt func_1672 = new CfIdt();
  protected CfIdt func_1746 = new CfIdt();
  protected CfOr func_1580 = new CfOr();
  protected CfOr func_1661 = new CfOr();
  protected CfInputMultiplexer func_1664 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1680 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1723 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1666 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1681 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1720 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1671 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1682 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1721 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1675 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1683 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1722 = new CfInputMultiplexer();
  protected CmAlarms func_1528 = new CmAlarms();
  protected CfOr func_419 = new CfOr();
  protected CmFan_Belt_Alarm func_1534 = new CmFan_Belt_Alarm();
  protected CmModulation func_1566 = new CmModulation();
  protected CmIDT05 func_1550 = new CmIDT05();
  protected CfOr func_1654 = new CfOr();
  protected CfInputMultiplexer func_1690 = new CfInputMultiplexer();
  protected CfOr func_1743 = new CfOr();
  protected CfAnd func_1631 = new CfAnd();
  protected CfInputMultiplexer func_1691 = new CfInputMultiplexer();
  protected CfOr func_1647 = new CfOr();
  protected CmFan_Release func_1151 = new CmFan_Release();
  protected CmNext_Fan_Enable func_1178 = new CmNext_Fan_Enable();
  protected CfInputMultiplexer func_1692 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1693 = new CfInputMultiplexer();

  // default constructor
  public BCmFNB_ModFan()
  {
    func_1627.configure(2);
    func_1749.configure(2);
    func_1746.configure(2);
    func_1743.configure(3);
    func_1647.configure(4);
  }

  public void Start()
  {
    func_1521.Start();
    func_1548.Start();
    func_1570.Start();
    func_1605.Start();
    func_1609.Start();
    func_1391.Start();
    func_1168.Start();
    func_1149.Start();
    func_1528.Start();
    func_1534.Start();
    func_1566.Start();
    func_1550.Start();
    func_1151.Start();
    func_1178.Start();
  }
}
