/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    HUA_RelHumSpray
Macro id:      5929330531045998936
Macro version: 90
Last change:   20.03.2018 - 11:29
Access Level:  2
Inputs:
  [1] RoomRetRelHum
  [2] SupplyAirRelHum
  [3] RoomRelHumSp
  [4] RelHumSpAdj
  [5] FanBeltIn
  [6] FilteredOATemp
  [7] LowWaterLevel
  [8] PumpStatus
  [9] PumpAlarm
  [10] SAT_ContrDev
  [11] Reset
  [12] PlantMode
Outputs:
  [1] HumidControl
  [2] DehumCtrlSig
  [3] SprayPmpCmd
  [4] HumidityMode
  [5] WaterLevelAlarm
  [6] OffAlarm
  [7] OnAlarm
  [8] FailCmdAlarm
  [9] CommAlarm
Parameter:
  [1] SYS-01: smoothing filter nubers of samples
  [2] SYS-02: smoothing filter sample period
  [3] SYS-03: delay after fan start
  [4] OAT-01: high limit for humidification
  [5] OAT-02: low limit for dehumidification
  [6] WC-01: start point OAT winter compensation
  [7] WC-02: end point OAT winter compensation
  [8] SC-01: start point OAT summer compensation
  [9] SC-02: end point OAT summer compensation
  [10] RAH-01: min. room humidity setpoint during winter
  [11] RAH-02: max. room humidity setpoint during summer
  [12] SAH-01: max. setpoint supply air relative humidity
  [13] SAH-02: P-band maximum setpoint control
  [14] HUM-01: P-band humidification control
  [15] HUM-02: Relative humidity control signal increase per minute
  [16] DEH-01: P-band dehumidification control
  [17] DEH-02: Relative dehumidity control signal increase per minute
  [18] HUMDEH-01: I-time humidify / dehumidify control
  [19] HUMDEH-02: comfort zone between humidify / dehumidify
  [20] HULIM-01: supply air temp. control deviation for max humidification signal
  [21] HULIM-02: supply air temp. control deviation for min humidification signal
  [22] HULIM-03: max humidification signal
  [23] HULIM-04: min humidification signal
  [24] DHLIM-01: supply air temp. control deviation for max dehumidification signal
  [25] DHLIM-02: supply air temp. control deviation for min dehumidification signa
  [26] DHLIM-03: max dehumidification signal
  [27] DHLIM-04: min dehumidification signal
  [28] ALM-01: delay status alarm; 0 = disable
  [29] ALM-02: alarm reset type; 0 = man, 1 = auto
  [30] ALM-03: status alarm type; 0 = no alarm, 1 = fail to command alarms, 2 = on/off alarms
  [31] DISP-01: calculated setpoint humidification
  [32] DISP-02: calculated setpoint dehumidification
Description:
The macro "HUA_RelHumSpray" for spray humidifiers provides room- or return air relative humidity P- or PI-control with adjustable comfort zone for humidifying and de-humidifying. 
To prevent the risk of wet ducts, the module provides maximum limitation of the supply air relative humidity.
The macro includes plant mode overrides.
It generates a coded signal “HumidityMode”, which is connected to other modules, enables those modules to save energy. E.g. stop cooling during humidification.
================================================================================*/

public class BCmHUA_RelHumSpray
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmHUA_RelHumSpray_output_10().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmHUA_RelHumSpray_output_10().setStatus(BStatus.disabled);
    getCmHUA_RelHumSpray_output_11().setStatus(BStatus.disabled);
    getCmHUA_RelHumSpray_output_12().setStatus(BStatus.disabled);
    getCmHUA_RelHumSpray_output_15().setStatus(BStatus.disabled);
    getCmHUA_RelHumSpray_output_16().setStatus(BStatus.disabled);
    getCmHUA_RelHumSpray_output_14().setStatus(BStatus.disabled);
    getCmHUA_RelHumSpray_output_13().setStatus(BStatus.disabled);
    getCmHUA_RelHumSpray_output_1794().setStatus(BStatus.disabled);
    getCmHUA_RelHumSpray_output_1795().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmHUA_RelHumSpray_output_10().setStatus(BStatus.ok);
    getCmHUA_RelHumSpray_output_11().setStatus(BStatus.ok);
    getCmHUA_RelHumSpray_output_12().setStatus(BStatus.ok);
    getCmHUA_RelHumSpray_output_15().setStatus(BStatus.ok);
    getCmHUA_RelHumSpray_output_16().setStatus(BStatus.ok);
    getCmHUA_RelHumSpray_output_14().setStatus(BStatus.ok);
    getCmHUA_RelHumSpray_output_13().setStatus(BStatus.ok);
    getCmHUA_RelHumSpray_output_1794().setStatus(BStatus.ok);
    getCmHUA_RelHumSpray_output_1795().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [53] Function call CfTruncate
    func_53.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_53.Execute(  );

    // [66] Function call CfMultiply
    func_66.input[0] = 100F;
    func_66.input[1] = (float) getCmHUA_RelHumSpray_parameter_32();
    func_66.Execute(  );

    // [67] Function call CfAddition
    func_67.input[0] = (float) getCmHUA_RelHumSpray_parameter_32();
    func_67.input[1] = (float) getCmHUA_RelHumSpray_parameter_34();
    func_67.Execute(  );

    // [70] Function call CfAddition
    func_70.input[0] = (float) getCmHUA_RelHumSpray_input_9().getValue();
    func_70.input[1] = (float) getCmHUA_RelHumSpray_input_3().getValue();
    func_70.Execute(  );

    // [71] Function call CfCompare1
    func_71.inputA = (float) getCmHUA_RelHumSpray_input_3().getValue();
    func_71.inputB = 999F;
    func_71.Execute(  );

    // [81] Function call CfDivide
    func_81.inputA = func_66.output;
    func_81.inputB = func_67.output;
    func_81.Execute(  );

    // [84] Function call CfInputMultiplexer
    func_84.inputSelect = BooleanToInt(func_71.outputEqual);
    func_84.input[1-1] = func_70.output;
    func_84.input[2-1] = (float) getCmHUA_RelHumSpray_input_9().getValue();
    func_84.Execute(  );

    // [120] Function call CfSubtract
    func_120.input[0] = (float) getCmHUA_RelHumSpray_parameter_28();
    func_120.input[1] = (float) getCmHUA_RelHumSpray_input_1789().getValue();
    func_120.Execute(  );

    // [121] Function call CfDivide
    func_121.inputA = 100F;
    func_121.inputB = (float) getCmHUA_RelHumSpray_parameter_29();
    func_121.Execute(  );

    // [126] Function call CfMultiply
    func_126.input[0] = func_120.output;
    func_126.input[1] = func_121.output;
    func_126.Execute(  );

    // [140] Function call CfCompare1
    func_140.inputA = (float) getCmHUA_RelHumSpray_input_1789().getValue();
    func_140.inputB = 999F;
    func_140.Execute(  );

    // [1354] Function call CfNot
    func_1354.input = func_2109.outputOR;
    func_1354.Execute(  );

    // [1355] Function call CfNot
    func_1355.input = FloatToBoolean(func_53.output);
    func_1355.Execute(  );

    // [1377] Macro call CmSUWI_Compensation
    func_1377.CmSUWI_Compensation_input_1 = (float) getCmHUA_RelHumSpray_input_7().getValue();
    func_1377.CmSUWI_Compensation_input_86 = func_84.output;
    func_1377.Execute( this, 0 );

    // [1560] Function call CfLimit
    func_1560.input = func_126.output;
    func_1560.Execute( this, 6 );

    // [144] Function call CfInputMultiplexer
    func_144.inputSelect = BooleanToInt(func_140.outputLess);
    func_144.input[1-1] = 100F;
    func_144.input[2-1] = func_1560.output;
    func_144.Execute(  );

    // [1772] Macro call CmEnable_HumDehum
    func_1772.CmEnable_HumDehum_input_51 = getCmHUA_RelHumSpray_input_6().getValue();
    func_1772.CmEnable_HumDehum_input_63 = func_2109.outputOR;
    func_1772.CmEnable_HumDehum_input_52 = (float) getCmHUA_RelHumSpray_input_7().getValue();
    func_1772.CmEnable_HumDehum_input_53 = func_445.output;
    func_1772.CmEnable_HumDehum_input_54 = func_446.output;
    func_1772.CmEnable_HumDehum_input_55 = (float) getCmHUA_RelHumSpray_parameter_18();
    func_1772.CmEnable_HumDehum_input_56 = (float) getCmHUA_RelHumSpray_parameter_19();
    func_1772.CmEnable_HumDehum_input_57 = (float) getCmHUA_RelHumSpray_parameter_38();
    func_1772.CmEnable_HumDehum_input_122 = (float) getCmHUA_RelHumSpray_input_8().getValue();
    func_1772.Execute( this, 8 );

    // [1839] Macro call CmIDT10
    func_1839.CmIDT10_input_1 = (float) getCmHUA_RelHumSpray_parameter_1798();
    func_1839.CmIDT10_input_2 = (float) getCmHUA_RelHumSpray_parameter_1799();
    func_1839.CmIDT10_input_3 = (float) getCmHUA_RelHumSpray_parameter_1800();
    func_1839.CmIDT10_input_4 = 5F;
    func_1839.CmIDT10_input_5 = (float) getCmHUA_RelHumSpray_parameter_1801();
    func_1839.CmIDT10_input_6 = (float) getCmHUA_RelHumSpray_parameter_1802();
    func_1839.CmIDT10_input_7 = (float) getCmHUA_RelHumSpray_parameter_1803();
    func_1839.CmIDT10_input_8 = (float) getCmHUA_RelHumSpray_parameter_1804();
    func_1839.CmIDT10_input_9 = (float) getCmHUA_RelHumSpray_parameter_1805();
    func_1839.CmIDT10_input_10 = (float) getCmHUA_RelHumSpray_parameter_1806();
    func_1839.Execute(  );
    setParameter(94, func_1839.CmIDT10_output_21);
    setParameter(95, func_1839.CmIDT10_output_22);
    setParameter(96, func_1839.CmIDT10_output_23);
    setParameter(15, func_1839.CmIDT10_output_24);
    setParameter(16, func_1839.CmIDT10_output_25);
    setParameter(17, func_1839.CmIDT10_output_26);
    setParameter(18, func_1839.CmIDT10_output_27);
    setParameter(19, func_1839.CmIDT10_output_28);
    setParameter(20, func_1839.CmIDT10_output_29);
    setParameter(21, func_1839.CmIDT10_output_30);

    // [1850] Function call CfMonoflop
    func_1850.input = BooleanToFloat(getCmHUA_RelHumSpray_input_1792().getValue());
    func_1850.Execute( this, 15 );

    // [1880] Function call CfCompare1
    func_1880.inputA = (float) getCmHUA_RelHumSpray_parameter_37();
    func_1880.inputB = 0F;
    func_1880.Execute(  );

    // [1917] Macro call CmMax_Lim_HumDehum
    func_1917.CmMax_Lim_HumDehum_input_1 = (float) getCmHUA_RelHumSpray_input_1791().getValue();
    func_1917.Execute( this, 16 );

    // [1923] Macro call CmIDT10
    func_1923.CmIDT10_input_1 = (float) getCmHUA_RelHumSpray_parameter_1807();
    func_1923.CmIDT10_input_2 = (float) getCmHUA_RelHumSpray_parameter_1808();
    func_1923.CmIDT10_input_3 = 10000F;
    func_1923.CmIDT10_input_4 = 10000F;
    func_1923.CmIDT10_input_5 = (float) getCmHUA_RelHumSpray_parameter_33();
    func_1923.CmIDT10_input_6 = (float) getCmHUA_RelHumSpray_parameter_35();
    func_1923.CmIDT10_input_7 = (float) getCmHUA_RelHumSpray_parameter_20();
    func_1923.CmIDT10_input_8 = (float) getCmHUA_RelHumSpray_parameter_21();
    func_1923.CmIDT10_input_9 = (float) getCmHUA_RelHumSpray_parameter_26();
    func_1923.CmIDT10_input_10 = (float) getCmHUA_RelHumSpray_parameter_27();
    func_1923.Execute(  );
    setParameter(22, func_1923.CmIDT10_output_21);
    setParameter(23, func_1923.CmIDT10_output_22);
    setParameter(73, func_1923.CmIDT10_output_23);
    setParameter(83, func_1923.CmIDT10_output_24);
    setParameter(72, func_1923.CmIDT10_output_25);
    setParameter(82, func_1923.CmIDT10_output_26);
    setParameter(0, func_1923.CmIDT10_output_27);
    setParameter(1, func_1923.CmIDT10_output_28);
    setParameter(4, func_1923.CmIDT10_output_29);
    setParameter(5, func_1923.CmIDT10_output_30);

    // [1936] Function call CfWindow
    func_1936.inputValue = (float) getCmHUA_RelHumSpray_parameter_1796();
    func_1936.inputMinimum = 0.8F;
    func_1936.inputMaximum = 200F;
    func_1936.Execute(  );

    // [1988] Macro call CmIDT10
    func_1988.CmIDT10_input_1 = (float) getCmHUA_RelHumSpray_parameter_24();
    func_1988.CmIDT10_input_2 = (float) getCmHUA_RelHumSpray_parameter_25();
    func_1988.CmIDT10_input_3 = (float) getCmHUA_RelHumSpray_parameter_1796();
    func_1988.CmIDT10_input_4 = (float) getCmHUA_RelHumSpray_parameter_1797();
    func_1988.CmIDT10_input_5 = (float) getCmHUA_RelHumSpray_parameter_1796();
    func_1988.CmIDT10_input_6 = (float) getCmHUA_RelHumSpray_parameter_1797();
    func_1988.CmIDT10_input_7 = 0F;
    func_1988.CmIDT10_input_8 = 0F;
    func_1988.CmIDT10_input_9 = 0F;
    func_1988.CmIDT10_input_10 = 5F;
    func_1988.Execute(  );
    setParameter(2, func_1988.CmIDT10_output_21);
    setParameter(3, func_1988.CmIDT10_output_22);
    setParameter(74, func_1988.CmIDT10_output_23);
    setParameter(75, func_1988.CmIDT10_output_24);
    setParameter(84, func_1988.CmIDT10_output_25);
    setParameter(85, func_1988.CmIDT10_output_26);
    func_1850.regTimer = FloatToLong(func_1988.CmIDT10_output_30);

    // [1994] Function call CfWindow
    func_1994.inputValue = (float) getCmHUA_RelHumSpray_input_8().getValue();
    func_1994.inputMinimum = 3.8F;
    func_1994.inputMaximum = 5.2F;
    func_1994.Execute(  );

    // [2077] Macro call CmIDT05
    func_2077.CmIDT05_input_1 = 2F;
    func_2077.CmIDT05_input_2 = 5F;
    func_2077.CmIDT05_input_3 = 0F;
    func_2077.CmIDT05_input_4 = 0F;
    func_2077.CmIDT05_input_5 = 0F;
    func_2077.Execute(  );
    setParameter(93, func_2077.CmIDT05_output_21);
    setParameter(46, func_2077.CmIDT05_output_22);

    // [2085] Function call CfMonoflop
    func_2085.input = BooleanToFloat(func_566.outputAND);
    func_2085.Execute( this, 46 );

    // [2086] Function call CfNot
    func_2086.input = getCmHUA_RelHumSpray_input_4().getValue();
    func_2086.Execute(  );

    // [2116] Function call CfDelayOnOff
    func_2116.input = func_453.output1;
    func_2116.Execute( this, 47 );

    // [2117] Macro call CmIDT05
    func_2117.CmIDT05_input_1 = 2F;
    func_2117.CmIDT05_input_2 = 0F;
    func_2117.CmIDT05_input_3 = 2F;
    func_2117.CmIDT05_input_4 = 0F;
    func_2117.CmIDT05_input_5 = 0F;
    func_2117.Execute(  );
    setParameter(92, func_2117.CmIDT05_output_21);
    setParameter(47, func_2117.CmIDT05_output_22);
    setParameter(48, func_2117.CmIDT05_output_23);

    // [2128] Function call CfOr
    func_2128.input[0] = func_1833.CmAlarms_output_5;
    func_2128.input[1] = func_2109.outputOR;
    func_2128.Execute(  );

    // [2156] Function call CfNot
    func_2156.input = func_2101.output;
    func_2156.Execute(  );

    // [2163] Function call CfCompare1
    func_2163.inputA = (float) getCmHUA_RelHumSpray_input_7().getValue();
    func_2163.inputB = 999F;
    func_2163.Execute(  );

    // [1921] Function call CfMinimum
    func_1921.input[0] = func_1772.CmEnable_HumDehum_output_64;
    func_1921.input[1] = func_1917.CmMax_Lim_HumDehum_output_2;
    func_1921.Execute(  );

    // [1922] Function call CfMinimum
    func_1922.input[0] = func_1917.CmMax_Lim_HumDehum_output_3;
    func_1922.input[1] = func_1772.CmEnable_HumDehum_output_65;
    func_1922.Execute(  );
    setCmHUA_RelHumSpray_output_11(func_1922.output);

    // [2003] Function call CfAnd
    func_2003.input[0] = func_1936.output;
    func_2003.input[1] = func_1994.output;
    func_2003.Execute(  );

    // [2066] Function call CfJkFlipFlop
    func_2066.inputSet = func_2085.output;
    func_2066.inputClock = false;
    func_2066.inputReset = func_2086.output;
    func_2066.Execute(  );
    setCmHUA_RelHumSpray_output_16(func_2066.output);

    // [2115] Function call CfInputMultiplexer
    func_2115.inputSelect = BooleanToInt(func_1833.CmAlarms_output_5);
    func_2115.input[1-1] = BooleanToFloat(func_2116.output);
    func_2115.input[2-1] = 1F;
    func_2115.Execute(  );

    // [2159] Function call CfNot
    func_2159.input = func_1772.CmEnable_HumDehum_output_92;
    func_2159.Execute(  );

    // [2160] Function call CfNot
    func_2160.input = func_1772.CmEnable_HumDehum_output_93;
    func_2160.Execute(  );

    // [2165] Function call CfInputMultiplexer
    func_2165.inputSelect = BooleanToInt(func_2163.outputEqual);
    func_2165.input[1-1] = func_1377.CmSUWI_Compensation_output_85;
    func_2165.input[2-1] = func_84.output;
    func_2165.Execute(  );

    // [1338] Macro call CmCntr_with_Comfortzone
    func_1338.CmCntr_with_Comfortzone_input_80 = (float) getCmHUA_RelHumSpray_parameter_37();
    func_1338.CmCntr_with_Comfortzone_input_81 = (float) getCmHUA_RelHumSpray_parameter_32();
    func_1338.CmCntr_with_Comfortzone_input_82 = (float) getCmHUA_RelHumSpray_parameter_34();
    func_1338.CmCntr_with_Comfortzone_input_83 = (float) getCmHUA_RelHumSpray_input_1().getValue();
    func_1338.CmCntr_with_Comfortzone_input_84 = func_2165.output;
    func_1338.Execute(  );

    // [1647] Macro call CmCntr_without_Comfortzone
    func_1647.CmCntr_without_Comfortzone_input_46 = func_2165.output;
    func_1647.CmCntr_without_Comfortzone_input_47 = (float) getCmHUA_RelHumSpray_input_1().getValue();
    func_1647.CmCntr_without_Comfortzone_input_49 = func_81.output;
    func_1647.CmCntr_without_Comfortzone_input_50 = (float) getCmHUA_RelHumSpray_parameter_32();
    func_1647.CmCntr_without_Comfortzone_input_51 = (float) getCmHUA_RelHumSpray_parameter_34();
    func_1647.CmCntr_without_Comfortzone_input_52 = (float) getCmHUA_RelHumSpray_parameter_36();
    func_1647.Execute( this, 49 );

    // [1743] Function call CfInputMultiplexer
    func_1743.inputSelect = BooleanToInt(getCmHUA_RelHumSpray_output_14().getValue());
    func_1743.input[1-1] = func_1921.output;
    func_1743.input[2-1] = 0F;
    func_1743.Execute(  );
    setCmHUA_RelHumSpray_output_10(func_1743.output);

    // [1942] Function call CfIdt
    func_1942.input = BooleanToFloat(func_2003.outputAND);
    func_1942.Execute(  );

    // [2043] Function call CfInputMultiplexer
    func_2043.inputSelect = BooleanToInt(func_2159.output);
    func_2043.input[1-1] = func_431.output;
    func_2043.input[2-1] = 0F;
    func_2043.Execute(  );

    // [1574] Macro call CmHumidity_Mode
    func_1574.CmHumidity_Mode_input_29 = (float) getCmHUA_RelHumSpray_output_10().getValue();
    func_1574.CmHumidity_Mode_input_30 = (float) getCmHUA_RelHumSpray_output_11().getValue();
    func_1574.Execute( this, 70 );
    setCmHUA_RelHumSpray_output_15(func_1574.CmHumidity_Mode_output_31);

    // [1879] Function call CfInputMultiplexer
    func_1879.inputSelect = BooleanToInt(func_1880.outputGreater);
    func_1879.input[1-1] = func_1647.CmCntr_without_Comfortzone_output_74;
    func_1879.input[2-1] = func_1338.CmCntr_with_Comfortzone_output_86;
    func_1879.Execute(  );

    // [1882] Function call CfInputMultiplexer
    func_1882.inputSelect = BooleanToInt(func_1880.outputGreater);
    func_1882.input[1-1] = func_1647.CmCntr_without_Comfortzone_output_54;
    func_1882.input[2-1] = func_1338.CmCntr_with_Comfortzone_output_90;
    func_1882.Execute(  );

    // [1884] Function call CfInputMultiplexer
    func_1884.inputSelect = BooleanToInt(func_1880.outputGreater);
    func_1884.input[1-1] = func_1647.CmCntr_without_Comfortzone_output_53;
    func_1884.input[2-1] = func_1338.CmCntr_with_Comfortzone_output_89;
    func_1884.Execute(  );

    // [431] Function call CfMinimum
    func_431.input[0] = func_1884.output;
    func_431.input[1] = func_144.output;
    func_431.Execute(  );

    // [1886] Function call CfInputMultiplexer
    func_1886.inputSelect = BooleanToInt(func_1880.outputGreater);
    func_1886.input[1-1] = func_1647.CmCntr_without_Comfortzone_output_75;
    func_1886.input[2-1] = func_1338.CmCntr_with_Comfortzone_output_87;
    func_1886.Execute(  );

    // [2132] Function call CfInputMultiplexer
    func_2132.inputSelect = BooleanToInt(func_2128.outputOR);
    func_2132.input[1-1] = func_2043.output;
    func_2132.input[2-1] = 0F;
    func_2132.Execute(  );

    // [1634] Function call CfValueRamp
    func_1634.inputValue = func_2132.output;
    func_1634.Execute( this, 72 );

    // [1932] Macro call CmSmoothing_Filter
    func_1932.CmSmoothing_Filter_input_1 = FloatToBoolean(func_1942.output[0]);
    func_1932.CmSmoothing_Filter_input_2 = func_2132.output;
    func_1932.Execute( this, 74 );

    // [441] Function call CfInputMultiplexer
    func_441.inputSelect = FloatToInt(func_1942.output[1]);
    func_441.input[1-1] = func_2132.output;
    func_441.input[2-1] = func_1932.CmSmoothing_Filter_output_3;
    func_441.Execute(  );

    // [2042] Function call CfInputMultiplexer
    func_2042.inputSelect = BooleanToInt(func_2160.output);
    func_2042.input[1-1] = func_1882.output;
    func_2042.input[2-1] = 0F;
    func_2042.Execute(  );

    // [2044] Function call CfInputMultiplexer
    func_2044.inputSelect = BooleanToInt(func_1772.CmEnable_HumDehum_output_116);
    func_2044.input[1-1] = func_1886.output;
    func_2044.input[2-1] = 999F;
    func_2044.Execute(  );
    setCmHUA_RelHumSpray_parameter_44(func_2044.output);

    // [2045] Function call CfInputMultiplexer
    func_2045.inputSelect = BooleanToInt(func_1772.CmEnable_HumDehum_output_115);
    func_2045.input[1-1] = func_1879.output;
    func_2045.input[2-1] = 999F;
    func_2045.Execute(  );
    setCmHUA_RelHumSpray_parameter_43(func_2045.output);

    // [2146] Function call CfInputMultiplexer
    func_2146.inputSelect = BooleanToInt(func_2128.outputOR);
    func_2146.input[1-1] = func_2042.output;
    func_2146.input[2-1] = 0F;
    func_2146.Execute(  );

    // [1639] Function call CfValueRamp
    func_1639.inputValue = func_2146.output;
    func_1639.Execute( this, 82 );

    // [1933] Macro call CmSmoothing_Filter
    func_1933.CmSmoothing_Filter_input_1 = FloatToBoolean(func_1942.output[2]);
    func_1933.CmSmoothing_Filter_input_2 = func_2146.output;
    func_1933.Execute( this, 84 );

    // [443] Function call CfInputMultiplexer
    func_443.inputSelect = FloatToInt(func_1942.output[1]);
    func_443.input[1-1] = func_2146.output;
    func_443.input[2-1] = func_1933.CmSmoothing_Filter_output_3;
    func_443.Execute(  );

    // [445] Function call CfMinimum
    func_445.input[0] = func_1634.output;
    func_445.input[1] = func_441.output;
    func_445.Execute(  );

    // [446] Function call CfMinimum
    func_446.input[0] = func_1639.output;
    func_446.input[1] = func_443.output;
    func_446.Execute(  );

    // [453] Function call CfHysteresis
    func_453.inputX = (float) getCmHUA_RelHumSpray_output_10().getValue();
    func_453.inputW = 3F;
    func_453.Execute( this, 92 );

    // [465] Function call CfAnd
    func_465.input[0] = func_1355.output;
    func_465.input[1] = func_1354.output;
    func_465.input[2] = FloatToBoolean(func_2115.output);
    func_465.Execute(  );
    setCmHUA_RelHumSpray_output_12(func_465.outputAND);

    // [556] Function call CfHysteresis
    func_556.inputX = func_1772.CmEnable_HumDehum_output_64;
    func_556.inputW = 3F;
    func_556.Execute( this, 93 );

    // [566] Function call CfAnd
    func_566.input[0] = getCmHUA_RelHumSpray_input_4().getValue();
    func_566.input[1] = func_556.output1;
    func_566.Execute(  );

    // [1833] Macro call CmAlarms
    func_1833.CmAlarms_input_1 = getCmHUA_RelHumSpray_output_12().getValue();
    func_1833.CmAlarms_input_2 = getCmHUA_RelHumSpray_input_1790().getValue();
    func_1833.CmAlarms_input_3 = getCmHUA_RelHumSpray_input_5().getValue();
    func_1833.CmAlarms_input_4 = func_1850.output;
    func_1833.Execute( this, 94 );
    setCmHUA_RelHumSpray_output_13(func_1833.CmAlarms_output_6);
    setCmHUA_RelHumSpray_output_1794(func_1833.CmAlarms_output_7);
    setCmHUA_RelHumSpray_output_1795(func_1833.CmAlarms_output_53);

    // [2091] Function call CfIdt
    func_2091.input = BooleanToFloat(func_1833.CmAlarms_output_5);
    func_2091.Execute(  );
    setCmHUA_RelHumSpray_output_14(FloatToBoolean(func_2091.output[0]));

    // [2101] Function call CfWindow
    func_2101.inputValue = (float) getCmHUA_RelHumSpray_parameter_1799();
    func_2101.inputMinimum = 0.8F;
    func_2101.inputMaximum = 1.2F;
    func_2101.Execute(  );

    // [2098] Function call CfAnd
    func_2098.input[0] = FloatToBoolean(func_2091.output[1]);
    func_2098.input[1] = func_2156.output;
    func_2098.Execute(  );

    // [2109] Function call CfOr
    func_2109.input[0] = func_2098.outputAND;
    func_2109.input[1] = getCmHUA_RelHumSpray_input_5().getValue();
    func_2109.input[2] = getCmHUA_RelHumSpray_output_16().getValue();
    func_2109.input[3] = getCmHUA_RelHumSpray_output_13().getValue();
    func_2109.Execute(  );

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    30F, 60F, -10F, 10F, 22F, 32F, 100F, 0F,
    14F, 15F, 300F, 0F, 0F, 300F, 300F, 1F,
    0F, 0F, 0F, 0F, 0F, 0F, 0F, 0F,
    0F, 100F, 0F, 100F, 0F, 0F, 50F, 50F,
    50F, 100F, 100F, 0F, 100F, 0F, 100F, 0F,
    0F, 50F, 50F, 50F, 100F, 100F, 1F, 10F,
    10F, 4F, 6F, 0F, 3F, 0F, 1000F, 100F,
    0F, 100F, 0F, 100F, 44F, 0F, 47F, 0F,
    100F, 100F, 0F, 0F, 100F, 100F, 0F, 0F,
    10F, 1000F, 0F, 0F, 0F, 10F, 20F, 0F,
    1F, 0F, 10F, 1000F, 0F, 0F, 0F, 10F,
    20F, 0F, 1F, 0F, 0F, 0F, 60F, 1F,
    1F, 10F, 10F, 1F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// HumidControl
  public static final Property CmHUA_RelHumSpray_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("percent")));
  public BStatusNumeric getCmHUA_RelHumSpray_output_10() { return (BStatusNumeric) get(CmHUA_RelHumSpray_output_10); }
  public void setCmHUA_RelHumSpray_output_10(BStatusNumeric v) { set(CmHUA_RelHumSpray_output_10,v,null); }
  public void setCmHUA_RelHumSpray_output_10(float v) { getCmHUA_RelHumSpray_output_10().setValue(v); }
// DehumCtrlSig
  public static final Property CmHUA_RelHumSpray_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("percent")));
  public BStatusNumeric getCmHUA_RelHumSpray_output_11() { return (BStatusNumeric) get(CmHUA_RelHumSpray_output_11); }
  public void setCmHUA_RelHumSpray_output_11(BStatusNumeric v) { set(CmHUA_RelHumSpray_output_11,v,null); }
  public void setCmHUA_RelHumSpray_output_11(float v) { getCmHUA_RelHumSpray_output_11().setValue(v); }
// SprayPmpCmd
  public static final Property CmHUA_RelHumSpray_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmHUA_RelHumSpray_output_12() { return (BStatusBoolean) get(CmHUA_RelHumSpray_output_12); }
  public void setCmHUA_RelHumSpray_output_12(BStatusBoolean v) { set(CmHUA_RelHumSpray_output_12,v,null); }
  public void setCmHUA_RelHumSpray_output_12(boolean v) { getCmHUA_RelHumSpray_output_12().setValue(v); }
// HumidityMode
  public static final Property CmHUA_RelHumSpray_output_15 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmHUA_RelHumSpray_output_15() { return (BStatusNumeric) get(CmHUA_RelHumSpray_output_15); }
  public void setCmHUA_RelHumSpray_output_15(BStatusNumeric v) { set(CmHUA_RelHumSpray_output_15,v,null); }
  public void setCmHUA_RelHumSpray_output_15(float v) { getCmHUA_RelHumSpray_output_15().setValue(v); }
// WaterLevelAlarm
  public static final Property CmHUA_RelHumSpray_output_16 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmHUA_RelHumSpray_output_16() { return (BStatusBoolean) get(CmHUA_RelHumSpray_output_16); }
  public void setCmHUA_RelHumSpray_output_16(BStatusBoolean v) { set(CmHUA_RelHumSpray_output_16,v,null); }
  public void setCmHUA_RelHumSpray_output_16(boolean v) { getCmHUA_RelHumSpray_output_16().setValue(v); }
// OffAlarm
  public static final Property CmHUA_RelHumSpray_output_14 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmHUA_RelHumSpray_output_14() { return (BStatusBoolean) get(CmHUA_RelHumSpray_output_14); }
  public void setCmHUA_RelHumSpray_output_14(BStatusBoolean v) { set(CmHUA_RelHumSpray_output_14,v,null); }
  public void setCmHUA_RelHumSpray_output_14(boolean v) { getCmHUA_RelHumSpray_output_14().setValue(v); }
// OnAlarm
  public static final Property CmHUA_RelHumSpray_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmHUA_RelHumSpray_output_13() { return (BStatusBoolean) get(CmHUA_RelHumSpray_output_13); }
  public void setCmHUA_RelHumSpray_output_13(BStatusBoolean v) { set(CmHUA_RelHumSpray_output_13,v,null); }
  public void setCmHUA_RelHumSpray_output_13(boolean v) { getCmHUA_RelHumSpray_output_13().setValue(v); }
// FailCmdAlarm
  public static final Property CmHUA_RelHumSpray_output_1794 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmHUA_RelHumSpray_output_1794() { return (BStatusBoolean) get(CmHUA_RelHumSpray_output_1794); }
  public void setCmHUA_RelHumSpray_output_1794(BStatusBoolean v) { set(CmHUA_RelHumSpray_output_1794,v,null); }
  public void setCmHUA_RelHumSpray_output_1794(boolean v) { getCmHUA_RelHumSpray_output_1794().setValue(v); }
// CommAlarm
  public static final Property CmHUA_RelHumSpray_output_1795 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmHUA_RelHumSpray_output_1795() { return (BStatusBoolean) get(CmHUA_RelHumSpray_output_1795); }
  public void setCmHUA_RelHumSpray_output_1795(BStatusBoolean v) { set(CmHUA_RelHumSpray_output_1795,v,null); }
  public void setCmHUA_RelHumSpray_output_1795(boolean v) { getCmHUA_RelHumSpray_output_1795().setValue(v); }

  // macro parameter
// SYS-01: smoothing filter nubers of samples
  public static final Property CmHUA_RelHumSpray_parameter_1796 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(200)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmHUA_RelHumSpray_parameter_1796() { return getDouble(CmHUA_RelHumSpray_parameter_1796); }
  public void setCmHUA_RelHumSpray_parameter_1796(double v) { setDouble(CmHUA_RelHumSpray_parameter_1796,v,null); }
// SYS-02: smoothing filter sample period
  public static final Property CmHUA_RelHumSpray_parameter_1797 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmHUA_RelHumSpray_parameter_1797() { return getDouble(CmHUA_RelHumSpray_parameter_1797); }
  public void setCmHUA_RelHumSpray_parameter_1797(double v) { setDouble(CmHUA_RelHumSpray_parameter_1797,v,null); }
// SYS-03: delay after fan start
  public static final Property CmHUA_RelHumSpray_parameter_38 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmHUA_RelHumSpray_parameter_38() { return getDouble(CmHUA_RelHumSpray_parameter_38); }
  public void setCmHUA_RelHumSpray_parameter_38(double v) { setDouble(CmHUA_RelHumSpray_parameter_38,v,null); }
// OAT-01: high limit for humidification
  public static final Property CmHUA_RelHumSpray_parameter_18 = newProperty( 0, BDouble.make( 14 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmHUA_RelHumSpray_parameter_18() { return getDouble(CmHUA_RelHumSpray_parameter_18); }
  public void setCmHUA_RelHumSpray_parameter_18(double v) { setDouble(CmHUA_RelHumSpray_parameter_18,v,null); }
// OAT-02: low limit for dehumidification
  public static final Property CmHUA_RelHumSpray_parameter_19 = newProperty( 0, BDouble.make( 15 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmHUA_RelHumSpray_parameter_19() { return getDouble(CmHUA_RelHumSpray_parameter_19); }
  public void setCmHUA_RelHumSpray_parameter_19(double v) { setDouble(CmHUA_RelHumSpray_parameter_19,v,null); }
// WC-01: start point OAT winter compensation
  public static final Property CmHUA_RelHumSpray_parameter_24 = newProperty( 0, BDouble.make( -10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmHUA_RelHumSpray_parameter_24() { return getDouble(CmHUA_RelHumSpray_parameter_24); }
  public void setCmHUA_RelHumSpray_parameter_24(double v) { setDouble(CmHUA_RelHumSpray_parameter_24,v,null); }
// WC-02: end point OAT winter compensation
  public static final Property CmHUA_RelHumSpray_parameter_25 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmHUA_RelHumSpray_parameter_25() { return getDouble(CmHUA_RelHumSpray_parameter_25); }
  public void setCmHUA_RelHumSpray_parameter_25(double v) { setDouble(CmHUA_RelHumSpray_parameter_25,v,null); }
// SC-01: start point OAT summer compensation
  public static final Property CmHUA_RelHumSpray_parameter_26 = newProperty( 0, BDouble.make( 22 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmHUA_RelHumSpray_parameter_26() { return getDouble(CmHUA_RelHumSpray_parameter_26); }
  public void setCmHUA_RelHumSpray_parameter_26(double v) { setDouble(CmHUA_RelHumSpray_parameter_26,v,null); }
// SC-02: end point OAT summer compensation
  public static final Property CmHUA_RelHumSpray_parameter_27 = newProperty( 0, BDouble.make( 32 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmHUA_RelHumSpray_parameter_27() { return getDouble(CmHUA_RelHumSpray_parameter_27); }
  public void setCmHUA_RelHumSpray_parameter_27(double v) { setDouble(CmHUA_RelHumSpray_parameter_27,v,null); }
// RAH-01: min. room humidity setpoint during winter
  public static final Property CmHUA_RelHumSpray_parameter_20 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSpray_parameter_20() { return getDouble(CmHUA_RelHumSpray_parameter_20); }
  public void setCmHUA_RelHumSpray_parameter_20(double v) { setDouble(CmHUA_RelHumSpray_parameter_20,v,null); }
// RAH-02: max. room humidity setpoint during summer
  public static final Property CmHUA_RelHumSpray_parameter_21 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSpray_parameter_21() { return getDouble(CmHUA_RelHumSpray_parameter_21); }
  public void setCmHUA_RelHumSpray_parameter_21(double v) { setDouble(CmHUA_RelHumSpray_parameter_21,v,null); }
// SAH-01: max. setpoint supply air relative humidity
  public static final Property CmHUA_RelHumSpray_parameter_28 = newProperty( 0, BDouble.make( 90 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSpray_parameter_28() { return getDouble(CmHUA_RelHumSpray_parameter_28); }
  public void setCmHUA_RelHumSpray_parameter_28(double v) { setDouble(CmHUA_RelHumSpray_parameter_28,v,null); }
// SAH-02: P-band maximum setpoint control
  public static final Property CmHUA_RelHumSpray_parameter_29 = newProperty( 0, BDouble.make( 12 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(5000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSpray_parameter_29() { return getDouble(CmHUA_RelHumSpray_parameter_29); }
  public void setCmHUA_RelHumSpray_parameter_29(double v) { setDouble(CmHUA_RelHumSpray_parameter_29,v,null); }
// HUM-01: P-band humidification control
  public static final Property CmHUA_RelHumSpray_parameter_32 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0.1)), BFacets.make(BFacets.MAX, BDouble.make(5000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSpray_parameter_32() { return getDouble(CmHUA_RelHumSpray_parameter_32); }
  public void setCmHUA_RelHumSpray_parameter_32(double v) { setDouble(CmHUA_RelHumSpray_parameter_32,v,null); }
// HUM-02: Relative humidity control signal increase per minute
  public static final Property CmHUA_RelHumSpray_parameter_33 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmHUA_RelHumSpray_parameter_33() { return getDouble(CmHUA_RelHumSpray_parameter_33); }
  public void setCmHUA_RelHumSpray_parameter_33(double v) { setDouble(CmHUA_RelHumSpray_parameter_33,v,null); }
// DEH-01: P-band dehumidification control
  public static final Property CmHUA_RelHumSpray_parameter_34 = newProperty( 0, BDouble.make( 6 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0.1)), BFacets.make(BFacets.MAX, BDouble.make(5000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSpray_parameter_34() { return getDouble(CmHUA_RelHumSpray_parameter_34); }
  public void setCmHUA_RelHumSpray_parameter_34(double v) { setDouble(CmHUA_RelHumSpray_parameter_34,v,null); }
// DEH-02: Relative dehumidity control signal increase per minute
  public static final Property CmHUA_RelHumSpray_parameter_35 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmHUA_RelHumSpray_parameter_35() { return getDouble(CmHUA_RelHumSpray_parameter_35); }
  public void setCmHUA_RelHumSpray_parameter_35(double v) { setDouble(CmHUA_RelHumSpray_parameter_35,v,null); }
// HUMDEH-01: I-time humidify / dehumidify control
  public static final Property CmHUA_RelHumSpray_parameter_36 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmHUA_RelHumSpray_parameter_36() { return getDouble(CmHUA_RelHumSpray_parameter_36); }
  public void setCmHUA_RelHumSpray_parameter_36(double v) { setDouble(CmHUA_RelHumSpray_parameter_36,v,null); }
// HUMDEH-02: comfort zone between humidify / dehumidify
  public static final Property CmHUA_RelHumSpray_parameter_37 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(40)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSpray_parameter_37() { return getDouble(CmHUA_RelHumSpray_parameter_37); }
  public void setCmHUA_RelHumSpray_parameter_37(double v) { setDouble(CmHUA_RelHumSpray_parameter_37,v,null); }
// HULIM-01: supply air temp. control deviation for max humidification signal
  public static final Property CmHUA_RelHumSpray_parameter_1801 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-30)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmHUA_RelHumSpray_parameter_1801() { return getDouble(CmHUA_RelHumSpray_parameter_1801); }
  public void setCmHUA_RelHumSpray_parameter_1801(double v) { setDouble(CmHUA_RelHumSpray_parameter_1801,v,null); }
// HULIM-02: supply air temp. control deviation for min humidification signal
  public static final Property CmHUA_RelHumSpray_parameter_1802 = newProperty( 0, BDouble.make( -10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-30)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmHUA_RelHumSpray_parameter_1802() { return getDouble(CmHUA_RelHumSpray_parameter_1802); }
  public void setCmHUA_RelHumSpray_parameter_1802(double v) { setDouble(CmHUA_RelHumSpray_parameter_1802,v,null); }
// HULIM-03: max humidification signal
  public static final Property CmHUA_RelHumSpray_parameter_1803 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmHUA_RelHumSpray_parameter_1803() { return getDouble(CmHUA_RelHumSpray_parameter_1803); }
  public void setCmHUA_RelHumSpray_parameter_1803(double v) { setDouble(CmHUA_RelHumSpray_parameter_1803,v,null); }
// HULIM-04: min humidification signal
  public static final Property CmHUA_RelHumSpray_parameter_1804 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmHUA_RelHumSpray_parameter_1804() { return getDouble(CmHUA_RelHumSpray_parameter_1804); }
  public void setCmHUA_RelHumSpray_parameter_1804(double v) { setDouble(CmHUA_RelHumSpray_parameter_1804,v,null); }
// DHLIM-01: supply air temp. control deviation for max dehumidification signal
  public static final Property CmHUA_RelHumSpray_parameter_1805 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-30)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmHUA_RelHumSpray_parameter_1805() { return getDouble(CmHUA_RelHumSpray_parameter_1805); }
  public void setCmHUA_RelHumSpray_parameter_1805(double v) { setDouble(CmHUA_RelHumSpray_parameter_1805,v,null); }
// DHLIM-02: supply air temp. control deviation for min dehumidification signa
  public static final Property CmHUA_RelHumSpray_parameter_1806 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-30)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmHUA_RelHumSpray_parameter_1806() { return getDouble(CmHUA_RelHumSpray_parameter_1806); }
  public void setCmHUA_RelHumSpray_parameter_1806(double v) { setDouble(CmHUA_RelHumSpray_parameter_1806,v,null); }
// DHLIM-03: max dehumidification signal
  public static final Property CmHUA_RelHumSpray_parameter_1807 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmHUA_RelHumSpray_parameter_1807() { return getDouble(CmHUA_RelHumSpray_parameter_1807); }
  public void setCmHUA_RelHumSpray_parameter_1807(double v) { setDouble(CmHUA_RelHumSpray_parameter_1807,v,null); }
// DHLIM-04: min dehumidification signal
  public static final Property CmHUA_RelHumSpray_parameter_1808 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmHUA_RelHumSpray_parameter_1808() { return getDouble(CmHUA_RelHumSpray_parameter_1808); }
  public void setCmHUA_RelHumSpray_parameter_1808(double v) { setDouble(CmHUA_RelHumSpray_parameter_1808,v,null); }
// ALM-01: delay status alarm; 0 = disable
  public static final Property CmHUA_RelHumSpray_parameter_1798 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmHUA_RelHumSpray_parameter_1798() { return getDouble(CmHUA_RelHumSpray_parameter_1798); }
  public void setCmHUA_RelHumSpray_parameter_1798(double v) { setDouble(CmHUA_RelHumSpray_parameter_1798,v,null); }
// ALM-02: alarm reset type; 0 = man, 1 = auto
  public static final Property CmHUA_RelHumSpray_parameter_1799 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmHUA_RelHumSpray_parameter_1799() { return getDouble(CmHUA_RelHumSpray_parameter_1799); }
  public void setCmHUA_RelHumSpray_parameter_1799(double v) { setDouble(CmHUA_RelHumSpray_parameter_1799,v,null); }
// ALM-03: status alarm type; 0 = no alarm, 1 = fail to command alarms, 2 = on/off alarms
  public static final Property CmHUA_RelHumSpray_parameter_1800 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmHUA_RelHumSpray_parameter_1800() { return getDouble(CmHUA_RelHumSpray_parameter_1800); }
  public void setCmHUA_RelHumSpray_parameter_1800(double v) { setDouble(CmHUA_RelHumSpray_parameter_1800,v,null); }
// DISP-01: calculated setpoint humidification
  public static final Property CmHUA_RelHumSpray_parameter_43 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSpray_parameter_43() { return getDouble(CmHUA_RelHumSpray_parameter_43); }
  public void setCmHUA_RelHumSpray_parameter_43(double v) { setDouble(CmHUA_RelHumSpray_parameter_43,v,null); }
// DISP-02: calculated setpoint dehumidification
  public static final Property CmHUA_RelHumSpray_parameter_44 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSpray_parameter_44() { return getDouble(CmHUA_RelHumSpray_parameter_44); }
  public void setCmHUA_RelHumSpray_parameter_44(double v) { setDouble(CmHUA_RelHumSpray_parameter_44,v,null); }

  // macro inputs
// RoomRetRelHum
  public static final Property CmHUA_RelHumSpray_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmHUA_RelHumSpray_input_1() { return (BStatusNumeric) get(CmHUA_RelHumSpray_input_1); }
  public void setCmHUA_RelHumSpray_input_1(BStatusNumeric v) { set(CmHUA_RelHumSpray_input_1,v,null); }
  public void setCmHUA_RelHumSpray_input_1(float v) { getCmHUA_RelHumSpray_input_1().setValue(v); }
// SupplyAirRelHum
  public static final Property CmHUA_RelHumSpray_input_1789 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmHUA_RelHumSpray_input_1789() { return (BStatusNumeric) get(CmHUA_RelHumSpray_input_1789); }
  public void setCmHUA_RelHumSpray_input_1789(BStatusNumeric v) { set(CmHUA_RelHumSpray_input_1789,v,null); }
  public void setCmHUA_RelHumSpray_input_1789(float v) { getCmHUA_RelHumSpray_input_1789().setValue(v); }
// RoomRelHumSp
  public static final Property CmHUA_RelHumSpray_input_9 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmHUA_RelHumSpray_input_9() { return (BStatusNumeric) get(CmHUA_RelHumSpray_input_9); }
  public void setCmHUA_RelHumSpray_input_9(BStatusNumeric v) { set(CmHUA_RelHumSpray_input_9,v,null); }
  public void setCmHUA_RelHumSpray_input_9(float v) { getCmHUA_RelHumSpray_input_9().setValue(v); }
// RelHumSpAdj
  public static final Property CmHUA_RelHumSpray_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmHUA_RelHumSpray_input_3() { return (BStatusNumeric) get(CmHUA_RelHumSpray_input_3); }
  public void setCmHUA_RelHumSpray_input_3(BStatusNumeric v) { set(CmHUA_RelHumSpray_input_3,v,null); }
  public void setCmHUA_RelHumSpray_input_3(float v) { getCmHUA_RelHumSpray_input_3().setValue(v); }
// FanBeltIn
  public static final Property CmHUA_RelHumSpray_input_6 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmHUA_RelHumSpray_input_6() { return (BStatusBoolean) get(CmHUA_RelHumSpray_input_6); }
  public void setCmHUA_RelHumSpray_input_6(BStatusBoolean v) { set(CmHUA_RelHumSpray_input_6,v,null); }
  public void setCmHUA_RelHumSpray_input_6(boolean v) { getCmHUA_RelHumSpray_input_6().setValue(v); }
// FilteredOATemp
  public static final Property CmHUA_RelHumSpray_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmHUA_RelHumSpray_input_7() { return (BStatusNumeric) get(CmHUA_RelHumSpray_input_7); }
  public void setCmHUA_RelHumSpray_input_7(BStatusNumeric v) { set(CmHUA_RelHumSpray_input_7,v,null); }
  public void setCmHUA_RelHumSpray_input_7(float v) { getCmHUA_RelHumSpray_input_7().setValue(v); }
// LowWaterLevel
  public static final Property CmHUA_RelHumSpray_input_4 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmHUA_RelHumSpray_input_4() { return (BStatusBoolean) get(CmHUA_RelHumSpray_input_4); }
  public void setCmHUA_RelHumSpray_input_4(BStatusBoolean v) { set(CmHUA_RelHumSpray_input_4,v,null); }
  public void setCmHUA_RelHumSpray_input_4(boolean v) { getCmHUA_RelHumSpray_input_4().setValue(v); }
// PumpStatus
  public static final Property CmHUA_RelHumSpray_input_1790 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmHUA_RelHumSpray_input_1790() { return (BStatusBoolean) get(CmHUA_RelHumSpray_input_1790); }
  public void setCmHUA_RelHumSpray_input_1790(BStatusBoolean v) { set(CmHUA_RelHumSpray_input_1790,v,null); }
  public void setCmHUA_RelHumSpray_input_1790(boolean v) { getCmHUA_RelHumSpray_input_1790().setValue(v); }
// PumpAlarm
  public static final Property CmHUA_RelHumSpray_input_5 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmHUA_RelHumSpray_input_5() { return (BStatusBoolean) get(CmHUA_RelHumSpray_input_5); }
  public void setCmHUA_RelHumSpray_input_5(BStatusBoolean v) { set(CmHUA_RelHumSpray_input_5,v,null); }
  public void setCmHUA_RelHumSpray_input_5(boolean v) { getCmHUA_RelHumSpray_input_5().setValue(v); }
// SAT_ContrDev
  public static final Property CmHUA_RelHumSpray_input_1791 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmHUA_RelHumSpray_input_1791() { return (BStatusNumeric) get(CmHUA_RelHumSpray_input_1791); }
  public void setCmHUA_RelHumSpray_input_1791(BStatusNumeric v) { set(CmHUA_RelHumSpray_input_1791,v,null); }
  public void setCmHUA_RelHumSpray_input_1791(float v) { getCmHUA_RelHumSpray_input_1791().setValue(v); }
// Reset
  public static final Property CmHUA_RelHumSpray_input_1792 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmHUA_RelHumSpray_input_1792() { return (BStatusBoolean) get(CmHUA_RelHumSpray_input_1792); }
  public void setCmHUA_RelHumSpray_input_1792(BStatusBoolean v) { set(CmHUA_RelHumSpray_input_1792,v,null); }
  public void setCmHUA_RelHumSpray_input_1792(boolean v) { getCmHUA_RelHumSpray_input_1792().setValue(v); }
// PlantMode
  public static final Property CmHUA_RelHumSpray_input_8 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmHUA_RelHumSpray_input_8() { return (BStatusNumeric) get(CmHUA_RelHumSpray_input_8); }
  public void setCmHUA_RelHumSpray_input_8(BStatusNumeric v) { set(CmHUA_RelHumSpray_input_8,v,null); }
  public void setCmHUA_RelHumSpray_input_8(float v) { getCmHUA_RelHumSpray_input_8().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.08 [90] 20.03.2018-11:29").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5929330531045998936").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmHUA_RelHumSpray.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private long    FloatToLong   (float   value) { return (long) value;  }
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfTruncate func_53 = new CfTruncate();
  protected CfMultiply func_66 = new CfMultiply();
  protected CfAddition func_67 = new CfAddition();
  protected CfAddition func_70 = new CfAddition();
  protected CfCompare1 func_71 = new CfCompare1();
  protected CfDivide func_81 = new CfDivide();
  protected CfInputMultiplexer func_84 = new CfInputMultiplexer();
  protected CfSubtract func_120 = new CfSubtract();
  protected CfDivide func_121 = new CfDivide();
  protected CfMultiply func_126 = new CfMultiply();
  protected CfCompare1 func_140 = new CfCompare1();
  protected CfNot func_1354 = new CfNot();
  protected CfNot func_1355 = new CfNot();
  protected CmSUWI_Compensation func_1377 = new CmSUWI_Compensation();
  protected CfLimit func_1560 = new CfLimit();
  protected CfInputMultiplexer func_144 = new CfInputMultiplexer();
  protected CmEnable_HumDehum func_1772 = new CmEnable_HumDehum();
  protected CmIDT10 func_1839 = new CmIDT10();
  protected CfMonoflop func_1850 = new CfMonoflop();
  protected CfCompare1 func_1880 = new CfCompare1();
  protected CmMax_Lim_HumDehum func_1917 = new CmMax_Lim_HumDehum();
  protected CmIDT10 func_1923 = new CmIDT10();
  protected CfWindow func_1936 = new CfWindow();
  protected CmIDT10 func_1988 = new CmIDT10();
  protected CfWindow func_1994 = new CfWindow();
  protected CmIDT05 func_2077 = new CmIDT05();
  protected CfMonoflop func_2085 = new CfMonoflop();
  protected CfNot func_2086 = new CfNot();
  protected CfDelayOnOff func_2116 = new CfDelayOnOff();
  protected CmIDT05 func_2117 = new CmIDT05();
  protected CfOr func_2128 = new CfOr();
  protected CfNot func_2156 = new CfNot();
  protected CfCompare1 func_2163 = new CfCompare1();
  protected CfMinimum func_1921 = new CfMinimum();
  protected CfMinimum func_1922 = new CfMinimum();
  protected CfAnd func_2003 = new CfAnd();
  protected CfJkFlipFlop func_2066 = new CfJkFlipFlop();
  protected CfInputMultiplexer func_2115 = new CfInputMultiplexer();
  protected CfNot func_2159 = new CfNot();
  protected CfNot func_2160 = new CfNot();
  protected CfInputMultiplexer func_2165 = new CfInputMultiplexer();
  protected CmCntr_with_Comfortzone func_1338 = new CmCntr_with_Comfortzone();
  protected CmCntr_without_Comfortzone func_1647 = new CmCntr_without_Comfortzone();
  protected CfInputMultiplexer func_1743 = new CfInputMultiplexer();
  protected CfIdt func_1942 = new CfIdt();
  protected CfInputMultiplexer func_2043 = new CfInputMultiplexer();
  protected CmHumidity_Mode func_1574 = new CmHumidity_Mode();
  protected CfInputMultiplexer func_1879 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1882 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1884 = new CfInputMultiplexer();
  protected CfMinimum func_431 = new CfMinimum();
  protected CfInputMultiplexer func_1886 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2132 = new CfInputMultiplexer();
  protected CfValueRamp func_1634 = new CfValueRamp();
  protected CmSmoothing_Filter func_1932 = new CmSmoothing_Filter();
  protected CfInputMultiplexer func_441 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2042 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2044 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2045 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2146 = new CfInputMultiplexer();
  protected CfValueRamp func_1639 = new CfValueRamp();
  protected CmSmoothing_Filter func_1933 = new CmSmoothing_Filter();
  protected CfInputMultiplexer func_443 = new CfInputMultiplexer();
  protected CfMinimum func_445 = new CfMinimum();
  protected CfMinimum func_446 = new CfMinimum();
  protected CfHysteresis func_453 = new CfHysteresis();
  protected CfAnd func_465 = new CfAnd();
  protected CfHysteresis func_556 = new CfHysteresis();
  protected CfAnd func_566 = new CfAnd();
  protected CmAlarms func_1833 = new CmAlarms();
  protected CfIdt func_2091 = new CfIdt();
  protected CfWindow func_2101 = new CfWindow();
  protected CfAnd func_2098 = new CfAnd();
  protected CfOr func_2109 = new CfOr();

  // default constructor
  public BCmHUA_RelHumSpray()
  {
    func_1942.configure(3);
    func_465.configure(3);
    func_2091.configure(2);
    func_2109.configure(4);
  }

  public void Start()
  {
    func_1377.Start();
    func_1772.Start();
    func_1839.Start();
    func_1850.Start();
    func_1917.Start();
    func_1923.Start();
    func_1988.Start();
    func_2077.Start();
    func_2085.Start();
    func_2116.Start();
    func_2117.Start();
    func_2066.Start();
    func_1338.Start();
    func_1647.Start();
    func_1574.Start();
    func_1634.Start();
    func_1932.Start();
    func_1639.Start();
    func_1933.Start();
    func_453.Start();
    func_556.Start();
    func_1833.Start();
  }
}
