/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    HUA_RelHumSteam
Macro id:      5924513030926762518
Macro version: 71
Last change:   05.05.2020 - 14:37
Access Level:  2
Inputs:
  [1] RoomRetRelHum
  [2] SupplyAirRelHum
  [3] RoomRelHumSp
  [4] RelHumSpAdj
  [5] FanBeltIn
  [6] FilteredOATemp
  [7] MaxHygrostat
  [8] SteamGenStatus
  [9] SteamGenAlarm
  [10] SAT_ContrDev
  [11] Reset
  [12] PlantMode
Outputs:
  [1] HumidControl
  [2] DehumCtrlSig
  [3] SteamGenEnable
  [4] HumidityMode
  [5] HighHumAlarm
  [6] OffAlarm
  [7] OnAlarm
  [8] FailCmdAlarm
  [9] CommAlarm
Parameter:
  [1] SYS-01: smoothing filter nubers of samples
  [2] SYS-02: smoothing filter sample period
  [3] SYS-03: delay after fan start
  [4] OAT-01: high limit for humidification
  [5] OAT-02: low limit for dehumidification
  [6] WC-01: start point OAT winter compensation
  [7] WC-02: end point OAT winter compensation
  [8] SC-01: start point OAT summer compensation
  [9] SC-02: end point OAT summer compensation
  [10] RAH-01: min. room humidity setpoint during winter
  [11] RAH-02: max. room humidity setpoint during summer
  [12] SAH-01: max. setpoint supply air relative humidity
  [13] SAH-02: P-band maximum setpoint control
  [14] HUM-01: P-band humidification control
  [15] HUM-02: Relative humidity control signal increase per minute
  [16] DEH-01: P-band dehumidification control
  [17] DEH-02: Relative dehumidity control signal increase per minute
  [18] HUMDEH-01: I-time humidify / dehumidify control
  [19] HUMDEH-02: comfort zone between humidify / dehumidify
  [20] HULIM-01: supply air temp. control deviation for max humidification signal
  [21] HULIM-02: supply air temp. control deviation for min humidification signal
  [22] HULIM-03: max humidification signal
  [23] HULIM-04: min humidification signal
  [24] DHLIM-01: supply air temp. control deviation for max dehumidification signal
  [25] DHLIM-02: supply air temp. control deviation for min dehumidification signa
  [26] DHLIM-03: max dehumidification signal
  [27] DHLIM-04: min dehumidification signal
  [28] ALM-01: delay status alarm; 0 = disable
  [29] ALM-02: alarm reset type; 0 = man, 1 = auto
  [30] ALM-03: status alarm type; 0 = no alarm, 1 = fail to command alarms, 2 = on/off alarms
  [31] DISP-01: calculated room/ return setpoint humidification
  [32] DISP-02: calculated room/ return setpoint dehumidification
  [33] DISP-03: calculated supply setpoint humidification
  [34] HU-01: supply air min. humidity set point
  [35] HU-02: supply air max. humidity set point
  [36] HU-03: supply air humidity control P-band
  [37] HU-04: supply air humidity control I-time
Description:
The macro "HUA_RelHumSteam" for steam humidifiers provides room- or return air relative humidity P- or PI-control with adjustable comfort zone for humidifying and de-humidifying. .
To prevent the risk of wet ducts, the module provides maximum limitation of the supply air relative humidity.
The macro includes plant mode overrides.
It generates a coded signal “HumidityMode”, which if connected to other modules, enables those modules to save energy. E.g. stop cooling during humidification.
================================================================================*/

public class BCmHUA_RelHumSteam
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmHUA_RelHumSteam_output_10().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmHUA_RelHumSteam_output_10().setStatus(BStatus.disabled);
    getCmHUA_RelHumSteam_output_11().setStatus(BStatus.disabled);
    getCmHUA_RelHumSteam_output_12().setStatus(BStatus.disabled);
    getCmHUA_RelHumSteam_output_15().setStatus(BStatus.disabled);
    getCmHUA_RelHumSteam_output_16().setStatus(BStatus.disabled);
    getCmHUA_RelHumSteam_output_14().setStatus(BStatus.disabled);
    getCmHUA_RelHumSteam_output_13().setStatus(BStatus.disabled);
    getCmHUA_RelHumSteam_output_1794().setStatus(BStatus.disabled);
    getCmHUA_RelHumSteam_output_1795().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmHUA_RelHumSteam_output_10().setStatus(BStatus.ok);
    getCmHUA_RelHumSteam_output_11().setStatus(BStatus.ok);
    getCmHUA_RelHumSteam_output_12().setStatus(BStatus.ok);
    getCmHUA_RelHumSteam_output_15().setStatus(BStatus.ok);
    getCmHUA_RelHumSteam_output_16().setStatus(BStatus.ok);
    getCmHUA_RelHumSteam_output_14().setStatus(BStatus.ok);
    getCmHUA_RelHumSteam_output_13().setStatus(BStatus.ok);
    getCmHUA_RelHumSteam_output_1794().setStatus(BStatus.ok);
    getCmHUA_RelHumSteam_output_1795().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [53] Function call CfTruncate
    func_53.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_53.Execute(  );

    // [66] Function call CfMultiply
    func_66.input[0] = 100F;
    func_66.input[1] = (float) getCmHUA_RelHumSteam_parameter_32();
    func_66.Execute(  );

    // [67] Function call CfAddition
    func_67.input[0] = (float) getCmHUA_RelHumSteam_parameter_32();
    func_67.input[1] = (float) getCmHUA_RelHumSteam_parameter_34();
    func_67.Execute(  );

    // [70] Function call CfAddition
    func_70.input[0] = (float) getCmHUA_RelHumSteam_input_9().getValue();
    func_70.input[1] = (float) getCmHUA_RelHumSteam_input_3().getValue();
    func_70.Execute(  );

    // [71] Function call CfCompare1
    func_71.inputA = (float) getCmHUA_RelHumSteam_input_3().getValue();
    func_71.inputB = 999F;
    func_71.Execute(  );

    // [81] Function call CfDivide
    func_81.inputA = func_66.output;
    func_81.inputB = func_67.output;
    func_81.Execute(  );

    // [84] Function call CfInputMultiplexer
    func_84.inputSelect = BooleanToInt(func_71.outputEqual);
    func_84.input[1-1] = func_70.output;
    func_84.input[2-1] = (float) getCmHUA_RelHumSteam_input_9().getValue();
    func_84.Execute(  );

    // [120] Function call CfSubtract
    func_120.input[0] = (float) getCmHUA_RelHumSteam_parameter_28();
    func_120.input[1] = (float) getCmHUA_RelHumSteam_input_1789().getValue();
    func_120.Execute(  );

    // [121] Function call CfDivide
    func_121.inputA = 100F;
    func_121.inputB = (float) getCmHUA_RelHumSteam_parameter_29();
    func_121.Execute(  );

    // [126] Function call CfMultiply
    func_126.input[0] = func_120.output;
    func_126.input[1] = func_121.output;
    func_126.Execute(  );

    // [140] Function call CfCompare1
    func_140.inputA = (float) getCmHUA_RelHumSteam_input_1789().getValue();
    func_140.inputB = 999F;
    func_140.Execute(  );

    // [1354] Function call CfNot
    func_1354.input = getCmHUA_RelHumSteam_input_5().getValue();
    func_1354.Execute(  );

    // [1355] Function call CfNot
    func_1355.input = FloatToBoolean(func_53.output);
    func_1355.Execute(  );

    // [1377] Macro call CmSUWI_Compensation
    func_1377.CmSUWI_Compensation_input_1 = (float) getCmHUA_RelHumSteam_input_7().getValue();
    func_1377.CmSUWI_Compensation_input_86 = func_84.output;
    func_1377.Execute( this, 0 );

    // [1560] Function call CfLimit
    func_1560.input = func_126.output;
    func_1560.Execute( this, 6 );

    // [144] Function call CfInputMultiplexer
    func_144.inputSelect = BooleanToInt(func_140.outputLess);
    func_144.input[1-1] = 100F;
    func_144.input[2-1] = func_1560.output;
    func_144.Execute(  );

    // [1839] Macro call CmIDT10
    func_1839.CmIDT10_input_1 = (float) getCmHUA_RelHumSteam_parameter_1798();
    func_1839.CmIDT10_input_2 = (float) getCmHUA_RelHumSteam_parameter_1799();
    func_1839.CmIDT10_input_3 = (float) getCmHUA_RelHumSteam_parameter_1800();
    func_1839.CmIDT10_input_4 = 5F;
    func_1839.CmIDT10_input_5 = (float) getCmHUA_RelHumSteam_parameter_1801();
    func_1839.CmIDT10_input_6 = (float) getCmHUA_RelHumSteam_parameter_1802();
    func_1839.CmIDT10_input_7 = (float) getCmHUA_RelHumSteam_parameter_1803();
    func_1839.CmIDT10_input_8 = (float) getCmHUA_RelHumSteam_parameter_1804();
    func_1839.CmIDT10_input_9 = (float) getCmHUA_RelHumSteam_parameter_1805();
    func_1839.CmIDT10_input_10 = (float) getCmHUA_RelHumSteam_parameter_1806();
    func_1839.Execute(  );
    setParameter(42, func_1839.CmIDT10_output_21);
    setParameter(43, func_1839.CmIDT10_output_22);
    setParameter(44, func_1839.CmIDT10_output_23);
    setParameter(8, func_1839.CmIDT10_output_24);
    setParameter(9, func_1839.CmIDT10_output_25);
    setParameter(10, func_1839.CmIDT10_output_26);
    setParameter(11, func_1839.CmIDT10_output_27);
    setParameter(12, func_1839.CmIDT10_output_28);
    setParameter(13, func_1839.CmIDT10_output_29);
    setParameter(14, func_1839.CmIDT10_output_30);

    // [1850] Function call CfMonoflop
    func_1850.input = BooleanToFloat(getCmHUA_RelHumSteam_input_1792().getValue());
    func_1850.Execute( this, 8 );

    // [1880] Function call CfCompare1
    func_1880.inputA = (float) getCmHUA_RelHumSteam_parameter_37();
    func_1880.inputB = 0F;
    func_1880.Execute(  );

    // [1917] Macro call CmMax_Lim_HumDehum
    func_1917.CmMax_Lim_HumDehum_input_1 = (float) getCmHUA_RelHumSteam_input_1791().getValue();
    func_1917.Execute( this, 9 );

    // [1923] Macro call CmIDT10
    func_1923.CmIDT10_input_1 = (float) getCmHUA_RelHumSteam_parameter_1807();
    func_1923.CmIDT10_input_2 = (float) getCmHUA_RelHumSteam_parameter_1808();
    func_1923.CmIDT10_input_3 = 10000F;
    func_1923.CmIDT10_input_4 = 10000F;
    func_1923.CmIDT10_input_5 = (float) getCmHUA_RelHumSteam_parameter_33();
    func_1923.CmIDT10_input_6 = (float) getCmHUA_RelHumSteam_parameter_35();
    func_1923.CmIDT10_input_7 = (float) getCmHUA_RelHumSteam_parameter_20();
    func_1923.CmIDT10_input_8 = (float) getCmHUA_RelHumSteam_parameter_21();
    func_1923.CmIDT10_input_9 = (float) getCmHUA_RelHumSteam_parameter_26();
    func_1923.CmIDT10_input_10 = (float) getCmHUA_RelHumSteam_parameter_27();
    func_1923.Execute(  );
    setParameter(15, func_1923.CmIDT10_output_21);
    setParameter(16, func_1923.CmIDT10_output_22);
    setParameter(77, func_1923.CmIDT10_output_23);
    setParameter(96, func_1923.CmIDT10_output_24);
    setParameter(76, func_1923.CmIDT10_output_25);
    setParameter(95, func_1923.CmIDT10_output_26);
    setParameter(0, func_1923.CmIDT10_output_27);
    setParameter(1, func_1923.CmIDT10_output_28);
    setParameter(4, func_1923.CmIDT10_output_29);
    setParameter(5, func_1923.CmIDT10_output_30);

    // [1936] Function call CfWindow
    func_1936.inputValue = (float) getCmHUA_RelHumSteam_parameter_1796();
    func_1936.inputMinimum = 0.8F;
    func_1936.inputMaximum = 200F;
    func_1936.Execute(  );

    // [1988] Macro call CmIDT10
    func_1988.CmIDT10_input_1 = (float) getCmHUA_RelHumSteam_parameter_24();
    func_1988.CmIDT10_input_2 = (float) getCmHUA_RelHumSteam_parameter_25();
    func_1988.CmIDT10_input_3 = (float) getCmHUA_RelHumSteam_parameter_1796();
    func_1988.CmIDT10_input_4 = (float) getCmHUA_RelHumSteam_parameter_1797();
    func_1988.CmIDT10_input_5 = (float) getCmHUA_RelHumSteam_parameter_1796();
    func_1988.CmIDT10_input_6 = (float) getCmHUA_RelHumSteam_parameter_1797();
    func_1988.CmIDT10_input_7 = (float) getCmHUA_RelHumSteam_parameter_2207();
    func_1988.CmIDT10_input_8 = (float) getCmHUA_RelHumSteam_parameter_2208();
    func_1988.CmIDT10_input_9 = 0F;
    func_1988.CmIDT10_input_10 = 5F;
    func_1988.Execute(  );
    setParameter(2, func_1988.CmIDT10_output_21);
    setParameter(3, func_1988.CmIDT10_output_22);
    setParameter(78, func_1988.CmIDT10_output_23);
    setParameter(79, func_1988.CmIDT10_output_24);
    setParameter(97, func_1988.CmIDT10_output_25);
    setParameter(98, func_1988.CmIDT10_output_26);
    setParameter(71, func_1988.CmIDT10_output_27);
    setParameter(73, func_1988.CmIDT10_output_28);
    func_1850.regTimer = FloatToLong(func_1988.CmIDT10_output_30);

    // [1994] Function call CfWindow
    func_1994.inputValue = (float) getCmHUA_RelHumSteam_input_8().getValue();
    func_1994.inputMinimum = 3.8F;
    func_1994.inputMaximum = 5.2F;
    func_1994.Execute(  );

    // [2082] Function call CfMonoflop
    func_2082.input = BooleanToFloat(func_566.outputAND);
    func_2082.Execute( this, 39 );

    // [2088] Function call CfNot
    func_2088.input = getCmHUA_RelHumSteam_input_4().getValue();
    func_2088.Execute(  );

    // [2089] Function call CfIdt
    func_2089.input = 5F;
    func_2089.Execute(  );
    setParameter(39, func_2089.output[0]);

    // [2094] Function call CfDelayOnOff
    func_2094.input = func_453.output1;
    func_2094.Execute( this, 40 );

    // [2100] Macro call CmIDT05
    func_2100.CmIDT05_input_1 = 2F;
    func_2100.CmIDT05_input_2 = 0F;
    func_2100.CmIDT05_input_3 = 2F;
    func_2100.CmIDT05_input_4 = 0F;
    func_2100.CmIDT05_input_5 = 0F;
    func_2100.Execute(  );
    setParameter(105, func_2100.CmIDT05_output_21);
    setParameter(40, func_2100.CmIDT05_output_22);
    setParameter(41, func_2100.CmIDT05_output_23);

    // [2119] Function call CfWindow
    func_2119.inputValue = (float) getCmHUA_RelHumSteam_parameter_1799();
    func_2119.inputMinimum = 0.8F;
    func_2119.inputMaximum = 1.2F;
    func_2119.Execute(  );

    // [2156] Function call CfCompare1
    func_2156.inputA = (float) getCmHUA_RelHumSteam_input_7().getValue();
    func_2156.inputB = 999F;
    func_2156.Execute(  );

    // [2182] Function call CfSubtract
    func_2182.input[0] = (float) getCmHUA_RelHumSteam_parameter_28();
    func_2182.input[1] = (float) getCmHUA_RelHumSteam_input_1789().getValue();
    func_2182.Execute(  );

    // [2186] Function call CfDivide
    func_2186.inputA = 100F;
    func_2186.inputB = (float) getCmHUA_RelHumSteam_parameter_29();
    func_2186.Execute(  );

    // [2195] Function call CfCompare1
    func_2195.inputA = (float) getCmHUA_RelHumSteam_input_1789().getValue();
    func_2195.inputB = 999F;
    func_2195.Execute(  );

    // [1833] Macro call CmAlarms
    func_1833.CmAlarms_input_1 = getCmHUA_RelHumSteam_output_12().getValue();
    func_1833.CmAlarms_input_2 = getCmHUA_RelHumSteam_input_1790().getValue();
    func_1833.CmAlarms_input_3 = getCmHUA_RelHumSteam_input_5().getValue();
    func_1833.CmAlarms_input_4 = func_1850.output;
    func_1833.Execute( this, 42 );
    setCmHUA_RelHumSteam_output_13(func_1833.CmAlarms_output_6);
    setCmHUA_RelHumSteam_output_1794(func_1833.CmAlarms_output_7);
    setCmHUA_RelHumSteam_output_1795(func_1833.CmAlarms_output_53);

    // [2003] Function call CfAnd
    func_2003.input[0] = func_1936.output;
    func_2003.input[1] = func_1994.output;
    func_2003.Execute(  );

    // [2084] Function call CfJkFlipFlop
    func_2084.inputSet = func_2082.output;
    func_2084.inputClock = false;
    func_2084.inputReset = func_2088.output;
    func_2084.Execute(  );
    setCmHUA_RelHumSteam_output_16(func_2084.output);

    // [2117] Function call CfNot
    func_2117.input = func_2119.output;
    func_2117.Execute(  );

    // [2155] Function call CfInputMultiplexer
    func_2155.inputSelect = BooleanToInt(func_2156.outputEqual);
    func_2155.input[1-1] = func_1377.CmSUWI_Compensation_output_85;
    func_2155.input[2-1] = func_84.output;
    func_2155.Execute(  );

    // [2184] Function call CfMultiply
    func_2184.input[0] = func_2182.output;
    func_2184.input[1] = func_2186.output;
    func_2184.Execute(  );

    // [1338] Macro call CmCntr_with_Comfortzone
    func_1338.CmCntr_with_Comfortzone_input_80 = (float) getCmHUA_RelHumSteam_parameter_37();
    func_1338.CmCntr_with_Comfortzone_input_81 = (float) getCmHUA_RelHumSteam_parameter_32();
    func_1338.CmCntr_with_Comfortzone_input_82 = (float) getCmHUA_RelHumSteam_parameter_34();
    func_1338.CmCntr_with_Comfortzone_input_83 = (float) getCmHUA_RelHumSteam_input_1().getValue();
    func_1338.CmCntr_with_Comfortzone_input_84 = func_2155.output;
    func_1338.Execute(  );

    // [1647] Macro call CmCntr_without_Comfortzone
    func_1647.CmCntr_without_Comfortzone_input_46 = func_2155.output;
    func_1647.CmCntr_without_Comfortzone_input_47 = (float) getCmHUA_RelHumSteam_input_1().getValue();
    func_1647.CmCntr_without_Comfortzone_input_49 = func_81.output;
    func_1647.CmCntr_without_Comfortzone_input_50 = (float) getCmHUA_RelHumSteam_parameter_32();
    func_1647.CmCntr_without_Comfortzone_input_51 = (float) getCmHUA_RelHumSteam_parameter_34();
    func_1647.CmCntr_without_Comfortzone_input_52 = (float) getCmHUA_RelHumSteam_parameter_36();
    func_1647.Execute( this, 48 );

    // [1900] Function call CfOr
    func_1900.input[0] = getCmHUA_RelHumSteam_input_5().getValue();
    func_1900.input[1] = getCmHUA_RelHumSteam_output_16().getValue();
    func_1900.Execute(  );

    // [1942] Function call CfIdt
    func_1942.input = BooleanToFloat(func_2003.outputAND);
    func_1942.Execute(  );

    // [2109] Function call CfInputMultiplexer
    func_2109.inputSelect = BooleanToInt(func_1833.CmAlarms_output_5);
    func_2109.input[1-1] = BooleanToFloat(func_2094.output);
    func_2109.input[2-1] = 1F;
    func_2109.Execute(  );

    // [2118] Function call CfIdt
    func_2118.input = BooleanToFloat(func_1833.CmAlarms_output_5);
    func_2118.Execute(  );
    setCmHUA_RelHumSteam_output_14(FloatToBoolean(func_2118.output[0]));

    // [2188] Function call CfLimit
    func_2188.input = func_2184.output;
    func_2188.Execute( this, 69 );

    // [1879] Function call CfInputMultiplexer
    func_1879.inputSelect = BooleanToInt(func_1880.outputGreater);
    func_1879.input[1-1] = func_1647.CmCntr_without_Comfortzone_output_74;
    func_1879.input[2-1] = func_1338.CmCntr_with_Comfortzone_output_86;
    func_1879.Execute(  );

    // [1882] Function call CfInputMultiplexer
    func_1882.inputSelect = BooleanToInt(func_1880.outputGreater);
    func_1882.input[1-1] = func_1647.CmCntr_without_Comfortzone_output_54;
    func_1882.input[2-1] = func_1338.CmCntr_with_Comfortzone_output_90;
    func_1882.Execute(  );

    // [1884] Function call CfInputMultiplexer
    func_1884.inputSelect = BooleanToInt(func_1880.outputGreater);
    func_1884.input[1-1] = func_1647.CmCntr_without_Comfortzone_output_53;
    func_1884.input[2-1] = func_1338.CmCntr_with_Comfortzone_output_89;
    func_1884.Execute(  );

    // [1886] Function call CfInputMultiplexer
    func_1886.inputSelect = BooleanToInt(func_1880.outputGreater);
    func_1886.input[1-1] = func_1647.CmCntr_without_Comfortzone_output_75;
    func_1886.input[2-1] = func_1338.CmCntr_with_Comfortzone_output_87;
    func_1886.Execute(  );

    // [2120] Function call CfAnd
    func_2120.input[0] = FloatToBoolean(func_2118.output[1]);
    func_2120.input[1] = func_2117.output;
    func_2120.Execute(  );

    // [2121] Function call CfOr
    func_2121.input[0] = func_2120.outputAND;
    func_2121.input[1] = getCmHUA_RelHumSteam_input_5().getValue();
    func_2121.input[2] = getCmHUA_RelHumSteam_output_16().getValue();
    func_2121.input[3] = getCmHUA_RelHumSteam_output_13().getValue();
    func_2121.Execute(  );

    // [2199] Function call CfLinearConverter
    func_2199.inputValue = func_1884.output;
    func_2199.inputInLimit1 = 0F;
    func_2199.inputInLimit2 = 100F;
    func_2199.inputOutLimit1 = (float) getCmHUA_RelHumSteam_parameter_2205();
    func_2199.inputOutLimit2 = (float) getCmHUA_RelHumSteam_parameter_2206();
    func_2199.Execute(  );

    // [2147] Function call CfOr
    func_2147.input[0] = func_1833.CmAlarms_output_5;
    func_2147.input[1] = func_2121.outputOR;
    func_2147.Execute(  );

    // [2191] Function call CfIdt
    func_2191.input = func_2199.output;
    func_2191.Execute(  );
    setCmHUA_RelHumSteam_parameter_2204(func_2191.output[0]);

    // [2201] Function call CfPidPlus
    func_2201.inputX = (float) getCmHUA_RelHumSteam_input_1789().getValue();
    func_2201.inputW = func_2199.output;
    func_2201.inputIntegralOn = true;
    func_2201.Execute( this, 71 );

    // [2189] Function call CfMinimum
    func_2189.input[0] = func_2201.output;
    func_2189.input[1] = func_2188.output;
    func_2189.Execute(  );

    // [2193] Function call CfInputMultiplexer
    func_2193.inputSelect = BooleanToInt(func_2195.outputLess);
    func_2193.input[1-1] = func_1884.output;
    func_2193.input[2-1] = func_2189.output;
    func_2193.Execute(  );

    // [2142] Function call CfInputMultiplexer
    func_2142.inputSelect = BooleanToInt(func_2147.outputOR);
    func_2142.input[1-1] = func_2049.output;
    func_2142.input[2-1] = 0F;
    func_2142.Execute(  );

    // [1634] Function call CfValueRamp
    func_1634.inputValue = func_2142.output;
    func_1634.Execute( this, 76 );

    // [1932] Macro call CmSmoothing_Filter
    func_1932.CmSmoothing_Filter_input_1 = FloatToBoolean(func_1942.output[0]);
    func_1932.CmSmoothing_Filter_input_2 = func_2142.output;
    func_1932.Execute( this, 78 );

    // [441] Function call CfInputMultiplexer
    func_441.inputSelect = FloatToInt(func_1942.output[1]);
    func_441.input[1-1] = func_2142.output;
    func_441.input[2-1] = func_1932.CmSmoothing_Filter_output_3;
    func_441.Execute(  );

    // [2074] Function call CfMinimum
    func_2074.input[0] = func_1634.output;
    func_2074.input[1] = func_441.output;
    func_2074.Execute(  );

    // [1772] Macro call CmEnable_HumDehum
    func_1772.CmEnable_HumDehum_input_51 = getCmHUA_RelHumSteam_input_6().getValue();
    func_1772.CmEnable_HumDehum_input_63 = func_1900.outputOR;
    func_1772.CmEnable_HumDehum_input_52 = (float) getCmHUA_RelHumSteam_input_7().getValue();
    func_1772.CmEnable_HumDehum_input_53 = func_2074.output;
    func_1772.CmEnable_HumDehum_input_54 = func_2079.output;
    func_1772.CmEnable_HumDehum_input_55 = (float) getCmHUA_RelHumSteam_parameter_18();
    func_1772.CmEnable_HumDehum_input_56 = (float) getCmHUA_RelHumSteam_parameter_19();
    func_1772.CmEnable_HumDehum_input_57 = (float) getCmHUA_RelHumSteam_parameter_38();
    func_1772.CmEnable_HumDehum_input_122 = (float) getCmHUA_RelHumSteam_input_8().getValue();
    func_1772.Execute( this, 86 );

    // [1921] Function call CfMinimum
    func_1921.input[0] = func_1772.CmEnable_HumDehum_output_64;
    func_1921.input[1] = func_1917.CmMax_Lim_HumDehum_output_2;
    func_1921.Execute(  );

    // [1922] Function call CfMinimum
    func_1922.input[0] = func_1917.CmMax_Lim_HumDehum_output_3;
    func_1922.input[1] = func_1772.CmEnable_HumDehum_output_65;
    func_1922.Execute(  );
    setCmHUA_RelHumSteam_output_11(func_1922.output);

    // [2068] Function call CfInputMultiplexer
    func_2068.inputSelect = BooleanToInt(func_1772.CmEnable_HumDehum_output_116);
    func_2068.input[1-1] = func_1886.output;
    func_2068.input[2-1] = 999F;
    func_2068.Execute(  );
    setCmHUA_RelHumSteam_parameter_44(func_2068.output);

    // [2069] Function call CfInputMultiplexer
    func_2069.inputSelect = BooleanToInt(func_1772.CmEnable_HumDehum_output_115);
    func_2069.input[1-1] = func_1879.output;
    func_2069.input[2-1] = 999F;
    func_2069.Execute(  );
    setCmHUA_RelHumSteam_parameter_43(func_2069.output);

    // [2150] Function call CfNot
    func_2150.input = func_1772.CmEnable_HumDehum_output_92;
    func_2150.Execute(  );

    // [2152] Function call CfNot
    func_2152.input = func_1772.CmEnable_HumDehum_output_93;
    func_2152.Execute(  );

    // [1743] Function call CfInputMultiplexer
    func_1743.inputSelect = BooleanToInt(getCmHUA_RelHumSteam_output_14().getValue());
    func_1743.input[1-1] = func_1921.output;
    func_1743.input[2-1] = 0F;
    func_1743.Execute(  );
    setCmHUA_RelHumSteam_output_10(func_1743.output);

    // [2049] Function call CfInputMultiplexer
    func_2049.inputSelect = BooleanToInt(func_2150.output);
    func_2049.input[1-1] = func_2193.output;
    func_2049.input[2-1] = 0F;
    func_2049.Execute(  );

    // [2050] Function call CfInputMultiplexer
    func_2050.inputSelect = BooleanToInt(func_2152.output);
    func_2050.input[1-1] = func_1882.output;
    func_2050.input[2-1] = 0F;
    func_2050.Execute(  );

    // [1574] Macro call CmHumidity_Mode
    func_1574.CmHumidity_Mode_input_29 = (float) getCmHUA_RelHumSteam_output_10().getValue();
    func_1574.CmHumidity_Mode_input_30 = (float) getCmHUA_RelHumSteam_output_11().getValue();
    func_1574.Execute( this, 93 );
    setCmHUA_RelHumSteam_output_15(func_1574.CmHumidity_Mode_output_31);

    // [2144] Function call CfInputMultiplexer
    func_2144.inputSelect = BooleanToInt(func_2147.outputOR);
    func_2144.input[1-1] = func_2050.output;
    func_2144.input[2-1] = 0F;
    func_2144.Execute(  );

    // [1639] Function call CfValueRamp
    func_1639.inputValue = func_2144.output;
    func_1639.Execute( this, 95 );

    // [1933] Macro call CmSmoothing_Filter
    func_1933.CmSmoothing_Filter_input_1 = FloatToBoolean(func_1942.output[2]);
    func_1933.CmSmoothing_Filter_input_2 = func_2144.output;
    func_1933.Execute( this, 97 );

    // [443] Function call CfInputMultiplexer
    func_443.inputSelect = FloatToInt(func_1942.output[1]);
    func_443.input[1-1] = func_2144.output;
    func_443.input[2-1] = func_1933.CmSmoothing_Filter_output_3;
    func_443.Execute(  );

    // [453] Function call CfHysteresis
    func_453.inputX = func_2074.output;
    func_453.inputW = 3F;
    func_453.Execute( this, 105 );

    // [465] Function call CfAnd
    func_465.input[0] = func_1355.output;
    func_465.input[1] = func_1354.output;
    func_465.input[2] = FloatToBoolean(func_2109.output);
    func_465.Execute(  );
    setCmHUA_RelHumSteam_output_12(func_465.outputAND);

    // [555] Function call CfIdt
    func_555.input = 2F;
    func_555.Execute(  );
    setParameter(106, func_555.output[0]);

    // [556] Function call CfHysteresis
    func_556.inputX = func_2074.output;
    func_556.inputW = 3F;
    func_556.Execute( this, 106 );

    // [566] Function call CfAnd
    func_566.input[0] = getCmHUA_RelHumSteam_input_4().getValue();
    func_566.input[1] = func_556.output1;
    func_566.Execute(  );

    // [2079] Function call CfMinimum
    func_2079.input[0] = func_1639.output;
    func_2079.input[1] = func_443.output;
    func_2079.Execute(  );

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    30F, 60F, -10F, 10F, 22F, 32F, 100F, 0F,
    1F, 0F, 0F, 0F, 0F, 0F, 0F, 0F,
    0F, 0F, 100F, 0F, 100F, 0F, 0F, 50F,
    50F, 50F, 100F, 100F, 0F, 100F, 0F, 100F,
    0F, 0F, 50F, 50F, 50F, 100F, 100F, 1F,
    10F, 10F, 60F, 1F, 1F, 10F, 10F, 1F,
    4F, 6F, 0F, 3F, 0F, 1000F, 100F, 0F,
    100F, 0F, 100F, 44F, 0F, 47F, 0F, 100F,
    100F, 0F, 0F, 100F, 100F, 100F, 0F, 3F,
    0F, 1000F, 100F, 0F, 10F, 1000F, 0F, 0F,
    0F, 10F, 20F, 0F, 1F, 0F, 14F, 15F,
    300F, 0F, 0F, 300F, 300F, 0F, 0F, 10F,
    1000F, 0F, 0F, 0F, 10F, 20F, 0F, 1F,
    0F, 0F, 0F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// HumidControl
  public static final Property CmHUA_RelHumSteam_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("percent")));
  public BStatusNumeric getCmHUA_RelHumSteam_output_10() { return (BStatusNumeric) get(CmHUA_RelHumSteam_output_10); }
  public void setCmHUA_RelHumSteam_output_10(BStatusNumeric v) { set(CmHUA_RelHumSteam_output_10,v,null); }
  public void setCmHUA_RelHumSteam_output_10(float v) { getCmHUA_RelHumSteam_output_10().setValue(v); }
// DehumCtrlSig
  public static final Property CmHUA_RelHumSteam_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("percent")));
  public BStatusNumeric getCmHUA_RelHumSteam_output_11() { return (BStatusNumeric) get(CmHUA_RelHumSteam_output_11); }
  public void setCmHUA_RelHumSteam_output_11(BStatusNumeric v) { set(CmHUA_RelHumSteam_output_11,v,null); }
  public void setCmHUA_RelHumSteam_output_11(float v) { getCmHUA_RelHumSteam_output_11().setValue(v); }
// SteamGenEnable
  public static final Property CmHUA_RelHumSteam_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmHUA_RelHumSteam_output_12() { return (BStatusBoolean) get(CmHUA_RelHumSteam_output_12); }
  public void setCmHUA_RelHumSteam_output_12(BStatusBoolean v) { set(CmHUA_RelHumSteam_output_12,v,null); }
  public void setCmHUA_RelHumSteam_output_12(boolean v) { getCmHUA_RelHumSteam_output_12().setValue(v); }
// HumidityMode
  public static final Property CmHUA_RelHumSteam_output_15 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmHUA_RelHumSteam_output_15() { return (BStatusNumeric) get(CmHUA_RelHumSteam_output_15); }
  public void setCmHUA_RelHumSteam_output_15(BStatusNumeric v) { set(CmHUA_RelHumSteam_output_15,v,null); }
  public void setCmHUA_RelHumSteam_output_15(float v) { getCmHUA_RelHumSteam_output_15().setValue(v); }
// HighHumAlarm
  public static final Property CmHUA_RelHumSteam_output_16 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmHUA_RelHumSteam_output_16() { return (BStatusBoolean) get(CmHUA_RelHumSteam_output_16); }
  public void setCmHUA_RelHumSteam_output_16(BStatusBoolean v) { set(CmHUA_RelHumSteam_output_16,v,null); }
  public void setCmHUA_RelHumSteam_output_16(boolean v) { getCmHUA_RelHumSteam_output_16().setValue(v); }
// OffAlarm
  public static final Property CmHUA_RelHumSteam_output_14 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmHUA_RelHumSteam_output_14() { return (BStatusBoolean) get(CmHUA_RelHumSteam_output_14); }
  public void setCmHUA_RelHumSteam_output_14(BStatusBoolean v) { set(CmHUA_RelHumSteam_output_14,v,null); }
  public void setCmHUA_RelHumSteam_output_14(boolean v) { getCmHUA_RelHumSteam_output_14().setValue(v); }
// OnAlarm
  public static final Property CmHUA_RelHumSteam_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmHUA_RelHumSteam_output_13() { return (BStatusBoolean) get(CmHUA_RelHumSteam_output_13); }
  public void setCmHUA_RelHumSteam_output_13(BStatusBoolean v) { set(CmHUA_RelHumSteam_output_13,v,null); }
  public void setCmHUA_RelHumSteam_output_13(boolean v) { getCmHUA_RelHumSteam_output_13().setValue(v); }
// FailCmdAlarm
  public static final Property CmHUA_RelHumSteam_output_1794 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmHUA_RelHumSteam_output_1794() { return (BStatusBoolean) get(CmHUA_RelHumSteam_output_1794); }
  public void setCmHUA_RelHumSteam_output_1794(BStatusBoolean v) { set(CmHUA_RelHumSteam_output_1794,v,null); }
  public void setCmHUA_RelHumSteam_output_1794(boolean v) { getCmHUA_RelHumSteam_output_1794().setValue(v); }
// CommAlarm
  public static final Property CmHUA_RelHumSteam_output_1795 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmHUA_RelHumSteam_output_1795() { return (BStatusBoolean) get(CmHUA_RelHumSteam_output_1795); }
  public void setCmHUA_RelHumSteam_output_1795(BStatusBoolean v) { set(CmHUA_RelHumSteam_output_1795,v,null); }
  public void setCmHUA_RelHumSteam_output_1795(boolean v) { getCmHUA_RelHumSteam_output_1795().setValue(v); }

  // macro parameter
// SYS-01: smoothing filter nubers of samples
  public static final Property CmHUA_RelHumSteam_parameter_1796 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(200)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmHUA_RelHumSteam_parameter_1796() { return getDouble(CmHUA_RelHumSteam_parameter_1796); }
  public void setCmHUA_RelHumSteam_parameter_1796(double v) { setDouble(CmHUA_RelHumSteam_parameter_1796,v,null); }
// SYS-02: smoothing filter sample period
  public static final Property CmHUA_RelHumSteam_parameter_1797 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmHUA_RelHumSteam_parameter_1797() { return getDouble(CmHUA_RelHumSteam_parameter_1797); }
  public void setCmHUA_RelHumSteam_parameter_1797(double v) { setDouble(CmHUA_RelHumSteam_parameter_1797,v,null); }
// SYS-03: delay after fan start
  public static final Property CmHUA_RelHumSteam_parameter_38 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmHUA_RelHumSteam_parameter_38() { return getDouble(CmHUA_RelHumSteam_parameter_38); }
  public void setCmHUA_RelHumSteam_parameter_38(double v) { setDouble(CmHUA_RelHumSteam_parameter_38,v,null); }
// OAT-01: high limit for humidification
  public static final Property CmHUA_RelHumSteam_parameter_18 = newProperty( 0, BDouble.make( 14 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmHUA_RelHumSteam_parameter_18() { return getDouble(CmHUA_RelHumSteam_parameter_18); }
  public void setCmHUA_RelHumSteam_parameter_18(double v) { setDouble(CmHUA_RelHumSteam_parameter_18,v,null); }
// OAT-02: low limit for dehumidification
  public static final Property CmHUA_RelHumSteam_parameter_19 = newProperty( 0, BDouble.make( 15 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmHUA_RelHumSteam_parameter_19() { return getDouble(CmHUA_RelHumSteam_parameter_19); }
  public void setCmHUA_RelHumSteam_parameter_19(double v) { setDouble(CmHUA_RelHumSteam_parameter_19,v,null); }
// WC-01: start point OAT winter compensation
  public static final Property CmHUA_RelHumSteam_parameter_24 = newProperty( 0, BDouble.make( -10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmHUA_RelHumSteam_parameter_24() { return getDouble(CmHUA_RelHumSteam_parameter_24); }
  public void setCmHUA_RelHumSteam_parameter_24(double v) { setDouble(CmHUA_RelHumSteam_parameter_24,v,null); }
// WC-02: end point OAT winter compensation
  public static final Property CmHUA_RelHumSteam_parameter_25 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmHUA_RelHumSteam_parameter_25() { return getDouble(CmHUA_RelHumSteam_parameter_25); }
  public void setCmHUA_RelHumSteam_parameter_25(double v) { setDouble(CmHUA_RelHumSteam_parameter_25,v,null); }
// SC-01: start point OAT summer compensation
  public static final Property CmHUA_RelHumSteam_parameter_26 = newProperty( 0, BDouble.make( 22 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmHUA_RelHumSteam_parameter_26() { return getDouble(CmHUA_RelHumSteam_parameter_26); }
  public void setCmHUA_RelHumSteam_parameter_26(double v) { setDouble(CmHUA_RelHumSteam_parameter_26,v,null); }
// SC-02: end point OAT summer compensation
  public static final Property CmHUA_RelHumSteam_parameter_27 = newProperty( 0, BDouble.make( 32 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmHUA_RelHumSteam_parameter_27() { return getDouble(CmHUA_RelHumSteam_parameter_27); }
  public void setCmHUA_RelHumSteam_parameter_27(double v) { setDouble(CmHUA_RelHumSteam_parameter_27,v,null); }
// RAH-01: min. room humidity setpoint during winter
  public static final Property CmHUA_RelHumSteam_parameter_20 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSteam_parameter_20() { return getDouble(CmHUA_RelHumSteam_parameter_20); }
  public void setCmHUA_RelHumSteam_parameter_20(double v) { setDouble(CmHUA_RelHumSteam_parameter_20,v,null); }
// RAH-02: max. room humidity setpoint during summer
  public static final Property CmHUA_RelHumSteam_parameter_21 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSteam_parameter_21() { return getDouble(CmHUA_RelHumSteam_parameter_21); }
  public void setCmHUA_RelHumSteam_parameter_21(double v) { setDouble(CmHUA_RelHumSteam_parameter_21,v,null); }
// SAH-01: max. setpoint supply air relative humidity
  public static final Property CmHUA_RelHumSteam_parameter_28 = newProperty( 0, BDouble.make( 90 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSteam_parameter_28() { return getDouble(CmHUA_RelHumSteam_parameter_28); }
  public void setCmHUA_RelHumSteam_parameter_28(double v) { setDouble(CmHUA_RelHumSteam_parameter_28,v,null); }
// SAH-02: P-band maximum setpoint control
  public static final Property CmHUA_RelHumSteam_parameter_29 = newProperty( 0, BDouble.make( 12 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(5000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSteam_parameter_29() { return getDouble(CmHUA_RelHumSteam_parameter_29); }
  public void setCmHUA_RelHumSteam_parameter_29(double v) { setDouble(CmHUA_RelHumSteam_parameter_29,v,null); }
// HUM-01: P-band humidification control
  public static final Property CmHUA_RelHumSteam_parameter_32 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0.1)), BFacets.make(BFacets.MAX, BDouble.make(5000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSteam_parameter_32() { return getDouble(CmHUA_RelHumSteam_parameter_32); }
  public void setCmHUA_RelHumSteam_parameter_32(double v) { setDouble(CmHUA_RelHumSteam_parameter_32,v,null); }
// HUM-02: Relative humidity control signal increase per minute
  public static final Property CmHUA_RelHumSteam_parameter_33 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmHUA_RelHumSteam_parameter_33() { return getDouble(CmHUA_RelHumSteam_parameter_33); }
  public void setCmHUA_RelHumSteam_parameter_33(double v) { setDouble(CmHUA_RelHumSteam_parameter_33,v,null); }
// DEH-01: P-band dehumidification control
  public static final Property CmHUA_RelHumSteam_parameter_34 = newProperty( 0, BDouble.make( 6 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0.1)), BFacets.make(BFacets.MAX, BDouble.make(5000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSteam_parameter_34() { return getDouble(CmHUA_RelHumSteam_parameter_34); }
  public void setCmHUA_RelHumSteam_parameter_34(double v) { setDouble(CmHUA_RelHumSteam_parameter_34,v,null); }
// DEH-02: Relative dehumidity control signal increase per minute
  public static final Property CmHUA_RelHumSteam_parameter_35 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmHUA_RelHumSteam_parameter_35() { return getDouble(CmHUA_RelHumSteam_parameter_35); }
  public void setCmHUA_RelHumSteam_parameter_35(double v) { setDouble(CmHUA_RelHumSteam_parameter_35,v,null); }
// HUMDEH-01: I-time humidify / dehumidify control
  public static final Property CmHUA_RelHumSteam_parameter_36 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmHUA_RelHumSteam_parameter_36() { return getDouble(CmHUA_RelHumSteam_parameter_36); }
  public void setCmHUA_RelHumSteam_parameter_36(double v) { setDouble(CmHUA_RelHumSteam_parameter_36,v,null); }
// HUMDEH-02: comfort zone between humidify / dehumidify
  public static final Property CmHUA_RelHumSteam_parameter_37 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(40)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSteam_parameter_37() { return getDouble(CmHUA_RelHumSteam_parameter_37); }
  public void setCmHUA_RelHumSteam_parameter_37(double v) { setDouble(CmHUA_RelHumSteam_parameter_37,v,null); }
// HULIM-01: supply air temp. control deviation for max humidification signal
  public static final Property CmHUA_RelHumSteam_parameter_1801 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-30)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmHUA_RelHumSteam_parameter_1801() { return getDouble(CmHUA_RelHumSteam_parameter_1801); }
  public void setCmHUA_RelHumSteam_parameter_1801(double v) { setDouble(CmHUA_RelHumSteam_parameter_1801,v,null); }
// HULIM-02: supply air temp. control deviation for min humidification signal
  public static final Property CmHUA_RelHumSteam_parameter_1802 = newProperty( 0, BDouble.make( -10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-30)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmHUA_RelHumSteam_parameter_1802() { return getDouble(CmHUA_RelHumSteam_parameter_1802); }
  public void setCmHUA_RelHumSteam_parameter_1802(double v) { setDouble(CmHUA_RelHumSteam_parameter_1802,v,null); }
// HULIM-03: max humidification signal
  public static final Property CmHUA_RelHumSteam_parameter_1803 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmHUA_RelHumSteam_parameter_1803() { return getDouble(CmHUA_RelHumSteam_parameter_1803); }
  public void setCmHUA_RelHumSteam_parameter_1803(double v) { setDouble(CmHUA_RelHumSteam_parameter_1803,v,null); }
// HULIM-04: min humidification signal
  public static final Property CmHUA_RelHumSteam_parameter_1804 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmHUA_RelHumSteam_parameter_1804() { return getDouble(CmHUA_RelHumSteam_parameter_1804); }
  public void setCmHUA_RelHumSteam_parameter_1804(double v) { setDouble(CmHUA_RelHumSteam_parameter_1804,v,null); }
// DHLIM-01: supply air temp. control deviation for max dehumidification signal
  public static final Property CmHUA_RelHumSteam_parameter_1805 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-30)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmHUA_RelHumSteam_parameter_1805() { return getDouble(CmHUA_RelHumSteam_parameter_1805); }
  public void setCmHUA_RelHumSteam_parameter_1805(double v) { setDouble(CmHUA_RelHumSteam_parameter_1805,v,null); }
// DHLIM-02: supply air temp. control deviation for min dehumidification signa
  public static final Property CmHUA_RelHumSteam_parameter_1806 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-30)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmHUA_RelHumSteam_parameter_1806() { return getDouble(CmHUA_RelHumSteam_parameter_1806); }
  public void setCmHUA_RelHumSteam_parameter_1806(double v) { setDouble(CmHUA_RelHumSteam_parameter_1806,v,null); }
// DHLIM-03: max dehumidification signal
  public static final Property CmHUA_RelHumSteam_parameter_1807 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmHUA_RelHumSteam_parameter_1807() { return getDouble(CmHUA_RelHumSteam_parameter_1807); }
  public void setCmHUA_RelHumSteam_parameter_1807(double v) { setDouble(CmHUA_RelHumSteam_parameter_1807,v,null); }
// DHLIM-04: min dehumidification signal
  public static final Property CmHUA_RelHumSteam_parameter_1808 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmHUA_RelHumSteam_parameter_1808() { return getDouble(CmHUA_RelHumSteam_parameter_1808); }
  public void setCmHUA_RelHumSteam_parameter_1808(double v) { setDouble(CmHUA_RelHumSteam_parameter_1808,v,null); }
// ALM-01: delay status alarm; 0 = disable
  public static final Property CmHUA_RelHumSteam_parameter_1798 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmHUA_RelHumSteam_parameter_1798() { return getDouble(CmHUA_RelHumSteam_parameter_1798); }
  public void setCmHUA_RelHumSteam_parameter_1798(double v) { setDouble(CmHUA_RelHumSteam_parameter_1798,v,null); }
// ALM-02: alarm reset type; 0 = man, 1 = auto
  public static final Property CmHUA_RelHumSteam_parameter_1799 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmHUA_RelHumSteam_parameter_1799() { return getDouble(CmHUA_RelHumSteam_parameter_1799); }
  public void setCmHUA_RelHumSteam_parameter_1799(double v) { setDouble(CmHUA_RelHumSteam_parameter_1799,v,null); }
// ALM-03: status alarm type; 0 = no alarm, 1 = fail to command alarms, 2 = on/off alarms
  public static final Property CmHUA_RelHumSteam_parameter_1800 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmHUA_RelHumSteam_parameter_1800() { return getDouble(CmHUA_RelHumSteam_parameter_1800); }
  public void setCmHUA_RelHumSteam_parameter_1800(double v) { setDouble(CmHUA_RelHumSteam_parameter_1800,v,null); }
// DISP-01: calculated room/ return setpoint humidification
  public static final Property CmHUA_RelHumSteam_parameter_43 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSteam_parameter_43() { return getDouble(CmHUA_RelHumSteam_parameter_43); }
  public void setCmHUA_RelHumSteam_parameter_43(double v) { setDouble(CmHUA_RelHumSteam_parameter_43,v,null); }
// DISP-02: calculated room/ return setpoint dehumidification
  public static final Property CmHUA_RelHumSteam_parameter_44 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSteam_parameter_44() { return getDouble(CmHUA_RelHumSteam_parameter_44); }
  public void setCmHUA_RelHumSteam_parameter_44(double v) { setDouble(CmHUA_RelHumSteam_parameter_44,v,null); }
// DISP-03: calculated supply setpoint humidification
  public static final Property CmHUA_RelHumSteam_parameter_2204 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSteam_parameter_2204() { return getDouble(CmHUA_RelHumSteam_parameter_2204); }
  public void setCmHUA_RelHumSteam_parameter_2204(double v) { setDouble(CmHUA_RelHumSteam_parameter_2204,v,null); }
// HU-01: supply air min. humidity set point
  public static final Property CmHUA_RelHumSteam_parameter_2205 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSteam_parameter_2205() { return getDouble(CmHUA_RelHumSteam_parameter_2205); }
  public void setCmHUA_RelHumSteam_parameter_2205(double v) { setDouble(CmHUA_RelHumSteam_parameter_2205,v,null); }
// HU-02: supply air max. humidity set point
  public static final Property CmHUA_RelHumSteam_parameter_2206 = newProperty( 0, BDouble.make( 50 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSteam_parameter_2206() { return getDouble(CmHUA_RelHumSteam_parameter_2206); }
  public void setCmHUA_RelHumSteam_parameter_2206(double v) { setDouble(CmHUA_RelHumSteam_parameter_2206,v,null); }
// HU-03: supply air humidity control P-band
  public static final Property CmHUA_RelHumSteam_parameter_2207 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(5000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent relative humidity"))));
  public double getCmHUA_RelHumSteam_parameter_2207() { return getDouble(CmHUA_RelHumSteam_parameter_2207); }
  public void setCmHUA_RelHumSteam_parameter_2207(double v) { setDouble(CmHUA_RelHumSteam_parameter_2207,v,null); }
// HU-04: supply air humidity control I-time
  public static final Property CmHUA_RelHumSteam_parameter_2208 = newProperty( 0, BDouble.make( 400 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmHUA_RelHumSteam_parameter_2208() { return getDouble(CmHUA_RelHumSteam_parameter_2208); }
  public void setCmHUA_RelHumSteam_parameter_2208(double v) { setDouble(CmHUA_RelHumSteam_parameter_2208,v,null); }

  // macro inputs
// RoomRetRelHum
  public static final Property CmHUA_RelHumSteam_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmHUA_RelHumSteam_input_1() { return (BStatusNumeric) get(CmHUA_RelHumSteam_input_1); }
  public void setCmHUA_RelHumSteam_input_1(BStatusNumeric v) { set(CmHUA_RelHumSteam_input_1,v,null); }
  public void setCmHUA_RelHumSteam_input_1(float v) { getCmHUA_RelHumSteam_input_1().setValue(v); }
// SupplyAirRelHum
  public static final Property CmHUA_RelHumSteam_input_1789 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmHUA_RelHumSteam_input_1789() { return (BStatusNumeric) get(CmHUA_RelHumSteam_input_1789); }
  public void setCmHUA_RelHumSteam_input_1789(BStatusNumeric v) { set(CmHUA_RelHumSteam_input_1789,v,null); }
  public void setCmHUA_RelHumSteam_input_1789(float v) { getCmHUA_RelHumSteam_input_1789().setValue(v); }
// RoomRelHumSp
  public static final Property CmHUA_RelHumSteam_input_9 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmHUA_RelHumSteam_input_9() { return (BStatusNumeric) get(CmHUA_RelHumSteam_input_9); }
  public void setCmHUA_RelHumSteam_input_9(BStatusNumeric v) { set(CmHUA_RelHumSteam_input_9,v,null); }
  public void setCmHUA_RelHumSteam_input_9(float v) { getCmHUA_RelHumSteam_input_9().setValue(v); }
// RelHumSpAdj
  public static final Property CmHUA_RelHumSteam_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmHUA_RelHumSteam_input_3() { return (BStatusNumeric) get(CmHUA_RelHumSteam_input_3); }
  public void setCmHUA_RelHumSteam_input_3(BStatusNumeric v) { set(CmHUA_RelHumSteam_input_3,v,null); }
  public void setCmHUA_RelHumSteam_input_3(float v) { getCmHUA_RelHumSteam_input_3().setValue(v); }
// FanBeltIn
  public static final Property CmHUA_RelHumSteam_input_6 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmHUA_RelHumSteam_input_6() { return (BStatusBoolean) get(CmHUA_RelHumSteam_input_6); }
  public void setCmHUA_RelHumSteam_input_6(BStatusBoolean v) { set(CmHUA_RelHumSteam_input_6,v,null); }
  public void setCmHUA_RelHumSteam_input_6(boolean v) { getCmHUA_RelHumSteam_input_6().setValue(v); }
// FilteredOATemp
  public static final Property CmHUA_RelHumSteam_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmHUA_RelHumSteam_input_7() { return (BStatusNumeric) get(CmHUA_RelHumSteam_input_7); }
  public void setCmHUA_RelHumSteam_input_7(BStatusNumeric v) { set(CmHUA_RelHumSteam_input_7,v,null); }
  public void setCmHUA_RelHumSteam_input_7(float v) { getCmHUA_RelHumSteam_input_7().setValue(v); }
// MaxHygrostat
  public static final Property CmHUA_RelHumSteam_input_4 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmHUA_RelHumSteam_input_4() { return (BStatusBoolean) get(CmHUA_RelHumSteam_input_4); }
  public void setCmHUA_RelHumSteam_input_4(BStatusBoolean v) { set(CmHUA_RelHumSteam_input_4,v,null); }
  public void setCmHUA_RelHumSteam_input_4(boolean v) { getCmHUA_RelHumSteam_input_4().setValue(v); }
// SteamGenStatus
  public static final Property CmHUA_RelHumSteam_input_1790 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmHUA_RelHumSteam_input_1790() { return (BStatusBoolean) get(CmHUA_RelHumSteam_input_1790); }
  public void setCmHUA_RelHumSteam_input_1790(BStatusBoolean v) { set(CmHUA_RelHumSteam_input_1790,v,null); }
  public void setCmHUA_RelHumSteam_input_1790(boolean v) { getCmHUA_RelHumSteam_input_1790().setValue(v); }
// SteamGenAlarm
  public static final Property CmHUA_RelHumSteam_input_5 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmHUA_RelHumSteam_input_5() { return (BStatusBoolean) get(CmHUA_RelHumSteam_input_5); }
  public void setCmHUA_RelHumSteam_input_5(BStatusBoolean v) { set(CmHUA_RelHumSteam_input_5,v,null); }
  public void setCmHUA_RelHumSteam_input_5(boolean v) { getCmHUA_RelHumSteam_input_5().setValue(v); }
// SAT_ContrDev
  public static final Property CmHUA_RelHumSteam_input_1791 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmHUA_RelHumSteam_input_1791() { return (BStatusNumeric) get(CmHUA_RelHumSteam_input_1791); }
  public void setCmHUA_RelHumSteam_input_1791(BStatusNumeric v) { set(CmHUA_RelHumSteam_input_1791,v,null); }
  public void setCmHUA_RelHumSteam_input_1791(float v) { getCmHUA_RelHumSteam_input_1791().setValue(v); }
// Reset
  public static final Property CmHUA_RelHumSteam_input_1792 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmHUA_RelHumSteam_input_1792() { return (BStatusBoolean) get(CmHUA_RelHumSteam_input_1792); }
  public void setCmHUA_RelHumSteam_input_1792(BStatusBoolean v) { set(CmHUA_RelHumSteam_input_1792,v,null); }
  public void setCmHUA_RelHumSteam_input_1792(boolean v) { getCmHUA_RelHumSteam_input_1792().setValue(v); }
// PlantMode
  public static final Property CmHUA_RelHumSteam_input_8 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmHUA_RelHumSteam_input_8() { return (BStatusNumeric) get(CmHUA_RelHumSteam_input_8); }
  public void setCmHUA_RelHumSteam_input_8(BStatusNumeric v) { set(CmHUA_RelHumSteam_input_8,v,null); }
  public void setCmHUA_RelHumSteam_input_8(float v) { getCmHUA_RelHumSteam_input_8().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.10 [71] 05.05.2020-14:37").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5924513030926762518").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmHUA_RelHumSteam.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private long    FloatToLong   (float   value) { return (long) value;  }
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfTruncate func_53 = new CfTruncate();
  protected CfMultiply func_66 = new CfMultiply();
  protected CfAddition func_67 = new CfAddition();
  protected CfAddition func_70 = new CfAddition();
  protected CfCompare1 func_71 = new CfCompare1();
  protected CfDivide func_81 = new CfDivide();
  protected CfInputMultiplexer func_84 = new CfInputMultiplexer();
  protected CfSubtract func_120 = new CfSubtract();
  protected CfDivide func_121 = new CfDivide();
  protected CfMultiply func_126 = new CfMultiply();
  protected CfCompare1 func_140 = new CfCompare1();
  protected CfNot func_1354 = new CfNot();
  protected CfNot func_1355 = new CfNot();
  protected CmSUWI_Compensation func_1377 = new CmSUWI_Compensation();
  protected CfLimit func_1560 = new CfLimit();
  protected CfInputMultiplexer func_144 = new CfInputMultiplexer();
  protected CmIDT10 func_1839 = new CmIDT10();
  protected CfMonoflop func_1850 = new CfMonoflop();
  protected CfCompare1 func_1880 = new CfCompare1();
  protected CmMax_Lim_HumDehum func_1917 = new CmMax_Lim_HumDehum();
  protected CmIDT10 func_1923 = new CmIDT10();
  protected CfWindow func_1936 = new CfWindow();
  protected CmIDT10 func_1988 = new CmIDT10();
  protected CfWindow func_1994 = new CfWindow();
  protected CfMonoflop func_2082 = new CfMonoflop();
  protected CfNot func_2088 = new CfNot();
  protected CfIdt func_2089 = new CfIdt();
  protected CfDelayOnOff func_2094 = new CfDelayOnOff();
  protected CmIDT05 func_2100 = new CmIDT05();
  protected CfWindow func_2119 = new CfWindow();
  protected CfCompare1 func_2156 = new CfCompare1();
  protected CfSubtract func_2182 = new CfSubtract();
  protected CfDivide func_2186 = new CfDivide();
  protected CfCompare1 func_2195 = new CfCompare1();
  protected CmAlarms func_1833 = new CmAlarms();
  protected CfAnd func_2003 = new CfAnd();
  protected CfJkFlipFlop func_2084 = new CfJkFlipFlop();
  protected CfNot func_2117 = new CfNot();
  protected CfInputMultiplexer func_2155 = new CfInputMultiplexer();
  protected CfMultiply func_2184 = new CfMultiply();
  protected CmCntr_with_Comfortzone func_1338 = new CmCntr_with_Comfortzone();
  protected CmCntr_without_Comfortzone func_1647 = new CmCntr_without_Comfortzone();
  protected CfOr func_1900 = new CfOr();
  protected CfIdt func_1942 = new CfIdt();
  protected CfInputMultiplexer func_2109 = new CfInputMultiplexer();
  protected CfIdt func_2118 = new CfIdt();
  protected CfLimit func_2188 = new CfLimit();
  protected CfInputMultiplexer func_1879 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1882 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1884 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1886 = new CfInputMultiplexer();
  protected CfAnd func_2120 = new CfAnd();
  protected CfOr func_2121 = new CfOr();
  protected CfLinearConverter func_2199 = new CfLinearConverter();
  protected CfOr func_2147 = new CfOr();
  protected CfIdt func_2191 = new CfIdt();
  protected CfPidPlus func_2201 = new CfPidPlus();
  protected CfMinimum func_2189 = new CfMinimum();
  protected CfInputMultiplexer func_2193 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2142 = new CfInputMultiplexer();
  protected CfValueRamp func_1634 = new CfValueRamp();
  protected CmSmoothing_Filter func_1932 = new CmSmoothing_Filter();
  protected CfInputMultiplexer func_441 = new CfInputMultiplexer();
  protected CfMinimum func_2074 = new CfMinimum();
  protected CmEnable_HumDehum func_1772 = new CmEnable_HumDehum();
  protected CfMinimum func_1921 = new CfMinimum();
  protected CfMinimum func_1922 = new CfMinimum();
  protected CfInputMultiplexer func_2068 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2069 = new CfInputMultiplexer();
  protected CfNot func_2150 = new CfNot();
  protected CfNot func_2152 = new CfNot();
  protected CfInputMultiplexer func_1743 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2049 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2050 = new CfInputMultiplexer();
  protected CmHumidity_Mode func_1574 = new CmHumidity_Mode();
  protected CfInputMultiplexer func_2144 = new CfInputMultiplexer();
  protected CfValueRamp func_1639 = new CfValueRamp();
  protected CmSmoothing_Filter func_1933 = new CmSmoothing_Filter();
  protected CfInputMultiplexer func_443 = new CfInputMultiplexer();
  protected CfHysteresis func_453 = new CfHysteresis();
  protected CfAnd func_465 = new CfAnd();
  protected CfIdt func_555 = new CfIdt();
  protected CfHysteresis func_556 = new CfHysteresis();
  protected CfAnd func_566 = new CfAnd();
  protected CfMinimum func_2079 = new CfMinimum();

  // default constructor
  public BCmHUA_RelHumSteam()
  {
    func_1942.configure(3);
    func_2118.configure(2);
    func_2121.configure(4);
    func_465.configure(3);
  }

  public void Start()
  {
    func_1377.Start();
    func_1839.Start();
    func_1850.Start();
    func_1917.Start();
    func_1923.Start();
    func_1988.Start();
    func_2082.Start();
    func_2094.Start();
    func_2100.Start();
    func_1833.Start();
    func_2084.Start();
    func_1338.Start();
    func_1647.Start();
    func_2201.Start();
    func_1634.Start();
    func_1932.Start();
    func_1772.Start();
    func_1574.Start();
    func_1639.Start();
    func_1933.Start();
    func_453.Start();
    func_556.Start();
  }
}
