/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    PSA_PlantMode
Macro id:      5891524858615955537
Macro version: 78
Last change:   21.09.2017 - 11:05
Access Level:  2
Inputs:
  [1] Occ_Period
  [2] Occ_External
  [3] CalcRoomTmpSp
  [4] RoomRetAirTemp
  [5] FilteredOAtemp
  [6] ManSwCond
  [7] DayExtension
  [8] FrostThermostat
  [9] FanFailCmdAlarm
  [10] Reset
  [11] HumidityMode
  [12] FireAlarm
  [13] NIPUEnable
Outputs:
  [1] PlantMode
  [2] Disp_PlantMode
Parameter:
  [1] AHU-01: plant on delay
  [2] SYS-01: manual switch configuration
  [3] DEX-01: extended operation
  [4] NIPU-01: time before occupied period
  [5] NIPU-02: outside air temperature low limit
  [6] NIPU-03: room temp. shift;  "0"  ->  room temp. = room temp. setpoint
  [7] NIPU-04: difference between RMT and OAT
  [8] NIPU-05: switching differential NIPU-02, -03, -04
  [9] NIPU-06: switch on delay
  [10] NIPU-07: switch off delay
  [11] STOP-01: delayed switched-off type
  [12] STOP-02: delayed switched-off time
  [13] NIC-01: room temperature to start heating
  [14] NIC-02: room temperature to start cooling
  [15] DUC-01: duty cycle; 1=enable
  [16] DUC-02: dutycycling comfort zone
  [17] DUC-03: maximum off time (% of duty cycle period)
  [18] DUC-04: minimum off time (% of duty cycle period)
  [19] DUC-05: duty cycle period
  [20] DUC-06: duty cycle mode; 1=he, 2=co, 3=he and co
  [21] ALM-01: reset type frost alarm 0=man; 1= auto
  [22] ALM-02: reset type fan failure alarm 0=man; 1=auto; 2=auto fan on
  [23] ALM-03: reset type fire alarm 0=man; 1=auto
Description:
This macro is an override module providing  the plant  mode strategy for air handling units.
The module has inputs for room temperature, fan off alarm, day extended operation, frost thermostat, and auto/manual switch.
The "PSA_PlantMode" generates a coded signal with a value range between 0...30. 
This output is connected to other modules to perform their plant mode overrides.
The air handling strategy provides the following functions: 

Configuration
 - Manual overrides 
 - Extended Operation Button 

Energy Saving Functions
 - Night Cycle 
 - Night Purge Duty Cycling 
 - Duty cycling 

Protection Functions 
 - Frost Protection And Frost Recovery 
 - AHU Stops At Fan Off Alarm 
 - Delayed Switch Off 

Overrides 
 - Plant Mode
================================================================================*/

public class BCmPSA_PlantMode
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmPSA_PlantMode_output_13().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmPSA_PlantMode_output_13().setStatus(BStatus.disabled);
    getCmPSA_PlantMode_output_252().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmPSA_PlantMode_output_13().setStatus(BStatus.ok);
    getCmPSA_PlantMode_output_252().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [56] Function call CfMonoflop
    func_56.input = BooleanToFloat(getCmPSA_PlantMode_input_12().getValue());
    func_56.Execute( this, 0 );

    // [105] Macro call CmIDT20
    func_105.CmIDT20_input_1 = (float) getCmPSA_PlantMode_parameter_45();
    func_105.CmIDT20_input_2 = (float) getCmPSA_PlantMode_parameter_46();
    func_105.CmIDT20_input_3 = (float) getCmPSA_PlantMode_parameter_34();
    func_105.CmIDT20_input_4 = (float) getCmPSA_PlantMode_parameter_36();
    func_105.CmIDT20_input_5 = (float) getCmPSA_PlantMode_parameter_37();
    func_105.CmIDT20_input_6 = (float) getCmPSA_PlantMode_parameter_38();
    func_105.CmIDT20_input_7 = (float) getCmPSA_PlantMode_parameter_39();
    func_105.CmIDT20_input_8 = (float) getCmPSA_PlantMode_parameter_41();
    func_105.CmIDT20_input_9 = (float) getCmPSA_PlantMode_parameter_42();
    func_105.CmIDT20_input_10 = 0F;
    func_105.CmIDT20_input_11 = (float) getCmPSA_PlantMode_parameter_15();
    func_105.CmIDT20_input_12 = (float) getCmPSA_PlantMode_parameter_43();
    func_105.CmIDT20_input_13 = (float) getCmPSA_PlantMode_parameter_44();
    func_105.CmIDT20_input_14 = (float) getCmPSA_PlantMode_parameter_25();
    func_105.CmIDT20_input_15 = (float) getCmPSA_PlantMode_parameter_26();
    func_105.CmIDT20_input_16 = (float) getCmPSA_PlantMode_parameter_27();
    func_105.CmIDT20_input_17 = (float) getCmPSA_PlantMode_parameter_28();
    func_105.CmIDT20_input_18 = (float) getCmPSA_PlantMode_parameter_29();
    func_105.CmIDT20_input_19 = (float) getCmPSA_PlantMode_parameter_30();
    func_105.CmIDT20_input_20 = 0F;
    func_105.Execute(  );
    setParameter(5, func_105.CmIDT20_output_21);
    setParameter(6, func_105.CmIDT20_output_22);
    setParameter(9, func_105.CmIDT20_output_23);
    setParameter(10, func_105.CmIDT20_output_24);
    setParameter(11, func_105.CmIDT20_output_25);
    setParameter(12, func_105.CmIDT20_output_26);
    setParameter(13, func_105.CmIDT20_output_27);
    setParameter(14, func_105.CmIDT20_output_28);
    setParameter(15, func_105.CmIDT20_output_29);
    setParameter(22, func_105.CmIDT20_output_31);
    setParameter(24, func_105.CmIDT20_output_32);
    setParameter(25, func_105.CmIDT20_output_33);
    setParameter(28, func_105.CmIDT20_output_34);
    setParameter(29, func_105.CmIDT20_output_35);
    setParameter(30, func_105.CmIDT20_output_36);
    setParameter(31, func_105.CmIDT20_output_37);
    setParameter(32, func_105.CmIDT20_output_38);
    setParameter(33, func_105.CmIDT20_output_39);

    // [127] Macro call CmIDT10
    func_127.CmIDT10_input_1 = (float) getCmPSA_PlantMode_parameter_47();
    func_127.CmIDT10_input_2 = (float) getCmPSA_PlantMode_parameter_48();
    func_127.CmIDT10_input_3 = (float) getCmPSA_PlantMode_parameter_242();
    func_127.CmIDT10_input_4 = (float) getCmPSA_PlantMode_parameter_14();
    func_127.CmIDT10_input_5 = (float) getCmPSA_PlantMode_parameter_16();
    func_127.CmIDT10_input_6 = 0F;
    func_127.CmIDT10_input_7 = 0F;
    func_127.CmIDT10_input_8 = 0F;
    func_127.CmIDT10_input_9 = 0F;
    func_127.CmIDT10_input_10 = 0F;
    func_127.Execute(  );
    setParameter(40, func_127.CmIDT10_output_21);
    setParameter(41, func_127.CmIDT10_output_22);
    setParameter(42, func_127.CmIDT10_output_23);
    setParameter(1, func_127.CmIDT10_output_24);
    setParameter(2, func_127.CmIDT10_output_25);

    // [152] Macro call CmPlant_Mode_0
    func_152.CmPlant_Mode_0_input_1 = ControlFunction.GetStartupFlag();
    func_152.CmPlant_Mode_0_input_18 = (float) getCmPSA_PlantMode_input_5().getValue();
    func_152.Execute( this, 1 );

    // [75] Macro call CmPlant_Mode_2
    func_75.CmPlant_Mode_2_input_1 = (float) getCmPSA_PlantMode_input_2().getValue();
    func_75.CmPlant_Mode_2_input_27 = (float) getCmPSA_PlantMode_input_3().getValue();
    func_75.Execute( this, 5 );

    // [99] Macro call CmPlant_Mode_3
    func_99.CmPlant_Mode_3_input_16 = (float) getCmPSA_PlantMode_input_4().getValue();
    func_99.CmPlant_Mode_3_input_2 = (float) getCmPSA_PlantMode_input_3().getValue();
    func_99.CmPlant_Mode_3_input_17 = (float) getCmPSA_PlantMode_input_2().getValue();
    func_99.CmPlant_Mode_3_input_1 = getCmPSA_PlantMode_input_1().getValue();
    func_99.CmPlant_Mode_3_input_230 = getCmPSA_PlantMode_input_257().getValue();
    func_99.Execute( this, 9 );

    // [65] Macro call CmPlant_Mode_4
    func_65.CmPlant_Mode_4_input_7 = (float) getCmPSA_PlantMode_input_5().getValue();
    func_65.CmPlant_Mode_4_input_1 = getCmPSA_PlantMode_input_1().getValue();
    func_65.CmPlant_Mode_4_input_21 = (float) getCmPSA_PlantMode_input_74().getValue();
    func_65.Execute(  );

    // [69] Macro call CmPlant_Mode_5
    func_69.CmPlant_Mode_5_input_1 = (float) getCmPSA_PlantMode_input_5().getValue();
    func_69.CmPlant_Mode_5_input_2 = (float) getCmPSA_PlantMode_input_7().getValue();
    func_69.CmPlant_Mode_5_input_52 = (float) getCmPSA_PlantMode_input_74().getValue();
    func_69.Execute( this, 22 );

    // [72] Macro call CmPlant_Mode_6
    func_72.CmPlant_Mode_6_input_1 = (float) getCmPSA_PlantMode_input_6().getValue();
    func_72.CmPlant_Mode_6_input_27 = func_75.CmPlant_Mode_2_output_2;
    func_72.CmPlant_Mode_6_input_28 = func_65.CmPlant_Mode_4_output_2;
    func_72.CmPlant_Mode_6_input_29 = func_69.CmPlant_Mode_5_output_3;
    func_72.CmPlant_Mode_6_input_30 = func_101.CmPlant_Mode_11_output_3;
    func_72.Execute( this, 24 );

    // [181] Function call CfOr
    func_181.input[0] = func_65.CmPlant_Mode_4_output_2;
    func_181.input[1] = func_69.CmPlant_Mode_5_output_3;
    func_181.Execute(  );

    // [101] Macro call CmPlant_Mode_11
    if ( func_181.outputOR)
    {
      func_101.CmPlant_Mode_11_input_1 = (float) getCmPSA_PlantMode_input_3().getValue();
      func_101.CmPlant_Mode_11_input_2 = (float) getCmPSA_PlantMode_input_2().getValue();
      func_101.Execute( this, 28 );
    }

    // [53] Macro call CmPlant_Mode_20
    func_53.CmPlant_Mode_20_input_1 = getCmPSA_PlantMode_input_9().getValue();
    func_53.CmPlant_Mode_20_input_2 = func_56.output;
    func_53.Execute( this, 40 );

    // [61] Macro call CmPlant_Mode_21
    func_61.CmPlant_Mode_21_input_1 = getCmPSA_PlantMode_input_10().getValue();
    func_61.CmPlant_Mode_21_input_2 = func_56.output;
    func_61.Execute( this, 41 );

    // [58] Macro call CmPlant_Mode_30
    func_58.CmPlant_Mode_30_input_1 = getCmPSA_PlantMode_input_11().getValue();
    func_58.CmPlant_Mode_30_input_2 = func_56.output;
    func_58.Execute( this, 42 );

    // [246] Macro call CmPlant_Mode
    func_246.CmPlant_Mode_input_1 = func_152.CmPlant_Mode_0_output_4;
    func_246.CmPlant_Mode_input_70 = false;
    func_246.CmPlant_Mode_input_83 = false;
    func_246.CmPlant_Mode_input_2 = func_75.CmPlant_Mode_2_output_2;
    func_246.CmPlant_Mode_input_3 = func_99.CmPlant_Mode_3_output_3;
    func_246.CmPlant_Mode_input_4 = func_65.CmPlant_Mode_4_output_2;
    func_246.CmPlant_Mode_input_5 = func_69.CmPlant_Mode_5_output_3;
    func_246.CmPlant_Mode_input_6 = func_72.CmPlant_Mode_6_output_2;
    func_246.CmPlant_Mode_input_7 = func_101.CmPlant_Mode_11_output_3;
    func_246.CmPlant_Mode_input_8 = func_53.CmPlant_Mode_20_output_4;
    func_246.CmPlant_Mode_input_9 = func_61.CmPlant_Mode_21_output_3;
    func_246.CmPlant_Mode_input_10 = func_58.CmPlant_Mode_30_output_3;
    func_246.CmPlant_Mode_input_12 = getCmPSA_PlantMode_input_1().getValue();
    func_246.CmPlant_Mode_input_80 = (float) getCmPSA_PlantMode_input_74().getValue();
    func_246.Execute( this, 43 );
    setCmPSA_PlantMode_output_13(func_246.CmPlant_Mode_output_11);

    // [253] Function call CfAddition
    func_253.input[0] = (float) getCmPSA_PlantMode_output_13().getValue();
    func_253.input[1] = 1F;
    func_253.Execute(  );
    setCmPSA_PlantMode_output_252(func_253.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    10F, 0F, 0F, 10F, 10F, 0F, 5F, 0F,
    0F, 0F, 0F, 0F, 0F, 0F, 0F, 0F,
    25F, 15F, 0F, 1F, 10F, 10F, 0F, 1F,
    0F, 0F, 10F, 10F, 0F, 0F, 0F, 0F,
    0F, 0F, 3F, 50F, 5F, 30F, 3F, 1F,
    0F, 0F, 0F, 10F, 10F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// PlantMode
  public static final Property CmPSA_PlantMode_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPSA_PlantMode_output_13() { return (BStatusNumeric) get(CmPSA_PlantMode_output_13); }
  public void setCmPSA_PlantMode_output_13(BStatusNumeric v) { set(CmPSA_PlantMode_output_13,v,null); }
  public void setCmPSA_PlantMode_output_13(float v) { getCmPSA_PlantMode_output_13().setValue(v); }
// Disp_PlantMode
  public static final Property CmPSA_PlantMode_output_252 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPSA_PlantMode_output_252() { return (BStatusNumeric) get(CmPSA_PlantMode_output_252); }
  public void setCmPSA_PlantMode_output_252(BStatusNumeric v) { set(CmPSA_PlantMode_output_252,v,null); }
  public void setCmPSA_PlantMode_output_252(float v) { getCmPSA_PlantMode_output_252().setValue(v); }

  // macro parameter
// AHU-01: plant on delay
  public static final Property CmPSA_PlantMode_parameter_14 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(900)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPSA_PlantMode_parameter_14() { return getDouble(CmPSA_PlantMode_parameter_14); }
  public void setCmPSA_PlantMode_parameter_14(double v) { setDouble(CmPSA_PlantMode_parameter_14,v,null); }
// SYS-01: manual switch configuration
  public static final Property CmPSA_PlantMode_parameter_16 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPSA_PlantMode_parameter_16() { return getDouble(CmPSA_PlantMode_parameter_16); }
  public void setCmPSA_PlantMode_parameter_16(double v) { setDouble(CmPSA_PlantMode_parameter_16,v,null); }
// DEX-01: extended operation
  public static final Property CmPSA_PlantMode_parameter_15 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(120)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmPSA_PlantMode_parameter_15() { return getDouble(CmPSA_PlantMode_parameter_15); }
  public void setCmPSA_PlantMode_parameter_15(double v) { setDouble(CmPSA_PlantMode_parameter_15,v,null); }
// NIPU-01: time before occupied period
  public static final Property CmPSA_PlantMode_parameter_34 = newProperty( 0, BDouble.make( 6 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(10)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmPSA_PlantMode_parameter_34() { return getDouble(CmPSA_PlantMode_parameter_34); }
  public void setCmPSA_PlantMode_parameter_34(double v) { setDouble(CmPSA_PlantMode_parameter_34,v,null); }
// NIPU-02: outside air temperature low limit
  public static final Property CmPSA_PlantMode_parameter_36 = newProperty( 0, BDouble.make( 12 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(5)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmPSA_PlantMode_parameter_36() { return getDouble(CmPSA_PlantMode_parameter_36); }
  public void setCmPSA_PlantMode_parameter_36(double v) { setDouble(CmPSA_PlantMode_parameter_36,v,null); }
// NIPU-03: room temp. shift;  "0"  ->  room temp. = room temp. setpoint
  public static final Property CmPSA_PlantMode_parameter_37 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-30)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmPSA_PlantMode_parameter_37() { return getDouble(CmPSA_PlantMode_parameter_37); }
  public void setCmPSA_PlantMode_parameter_37(double v) { setDouble(CmPSA_PlantMode_parameter_37,v,null); }
// NIPU-04: difference between RMT and OAT
  public static final Property CmPSA_PlantMode_parameter_38 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(10)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmPSA_PlantMode_parameter_38() { return getDouble(CmPSA_PlantMode_parameter_38); }
  public void setCmPSA_PlantMode_parameter_38(double v) { setDouble(CmPSA_PlantMode_parameter_38,v,null); }
// NIPU-05: switching differential NIPU-02, -03, -04
  public static final Property CmPSA_PlantMode_parameter_39 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(10)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmPSA_PlantMode_parameter_39() { return getDouble(CmPSA_PlantMode_parameter_39); }
  public void setCmPSA_PlantMode_parameter_39(double v) { setDouble(CmPSA_PlantMode_parameter_39,v,null); }
// NIPU-06: switch on delay
  public static final Property CmPSA_PlantMode_parameter_41 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPSA_PlantMode_parameter_41() { return getDouble(CmPSA_PlantMode_parameter_41); }
  public void setCmPSA_PlantMode_parameter_41(double v) { setDouble(CmPSA_PlantMode_parameter_41,v,null); }
// NIPU-07: switch off delay
  public static final Property CmPSA_PlantMode_parameter_42 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPSA_PlantMode_parameter_42() { return getDouble(CmPSA_PlantMode_parameter_42); }
  public void setCmPSA_PlantMode_parameter_42(double v) { setDouble(CmPSA_PlantMode_parameter_42,v,null); }
// STOP-01: delayed switched-off type
  public static final Property CmPSA_PlantMode_parameter_43 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPSA_PlantMode_parameter_43() { return getDouble(CmPSA_PlantMode_parameter_43); }
  public void setCmPSA_PlantMode_parameter_43(double v) { setDouble(CmPSA_PlantMode_parameter_43,v,null); }
// STOP-02: delayed switched-off time
  public static final Property CmPSA_PlantMode_parameter_44 = newProperty( 0, BDouble.make( 180 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPSA_PlantMode_parameter_44() { return getDouble(CmPSA_PlantMode_parameter_44); }
  public void setCmPSA_PlantMode_parameter_44(double v) { setDouble(CmPSA_PlantMode_parameter_44,v,null); }
// NIC-01: room temperature to start heating
  public static final Property CmPSA_PlantMode_parameter_45 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-30)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmPSA_PlantMode_parameter_45() { return getDouble(CmPSA_PlantMode_parameter_45); }
  public void setCmPSA_PlantMode_parameter_45(double v) { setDouble(CmPSA_PlantMode_parameter_45,v,null); }
// NIC-02: room temperature to start cooling
  public static final Property CmPSA_PlantMode_parameter_46 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(5)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmPSA_PlantMode_parameter_46() { return getDouble(CmPSA_PlantMode_parameter_46); }
  public void setCmPSA_PlantMode_parameter_46(double v) { setDouble(CmPSA_PlantMode_parameter_46,v,null); }
// DUC-01: duty cycle; 1=enable
  public static final Property CmPSA_PlantMode_parameter_25 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPSA_PlantMode_parameter_25() { return getDouble(CmPSA_PlantMode_parameter_25); }
  public void setCmPSA_PlantMode_parameter_25(double v) { setDouble(CmPSA_PlantMode_parameter_25,v,null); }
// DUC-02: dutycycling comfort zone
  public static final Property CmPSA_PlantMode_parameter_26 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(10)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmPSA_PlantMode_parameter_26() { return getDouble(CmPSA_PlantMode_parameter_26); }
  public void setCmPSA_PlantMode_parameter_26(double v) { setDouble(CmPSA_PlantMode_parameter_26,v,null); }
// DUC-03: maximum off time (% of duty cycle period)
  public static final Property CmPSA_PlantMode_parameter_27 = newProperty( 0, BDouble.make( 50 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmPSA_PlantMode_parameter_27() { return getDouble(CmPSA_PlantMode_parameter_27); }
  public void setCmPSA_PlantMode_parameter_27(double v) { setDouble(CmPSA_PlantMode_parameter_27,v,null); }
// DUC-04: minimum off time (% of duty cycle period)
  public static final Property CmPSA_PlantMode_parameter_28 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmPSA_PlantMode_parameter_28() { return getDouble(CmPSA_PlantMode_parameter_28); }
  public void setCmPSA_PlantMode_parameter_28(double v) { setDouble(CmPSA_PlantMode_parameter_28,v,null); }
// DUC-05: duty cycle period
  public static final Property CmPSA_PlantMode_parameter_29 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(5)), BFacets.make(BFacets.MAX, BDouble.make(60)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmPSA_PlantMode_parameter_29() { return getDouble(CmPSA_PlantMode_parameter_29); }
  public void setCmPSA_PlantMode_parameter_29(double v) { setDouble(CmPSA_PlantMode_parameter_29,v,null); }
// DUC-06: duty cycle mode; 1=he, 2=co, 3=he and co
  public static final Property CmPSA_PlantMode_parameter_30 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPSA_PlantMode_parameter_30() { return getDouble(CmPSA_PlantMode_parameter_30); }
  public void setCmPSA_PlantMode_parameter_30(double v) { setDouble(CmPSA_PlantMode_parameter_30,v,null); }
// ALM-01: reset type frost alarm 0=man; 1= auto
  public static final Property CmPSA_PlantMode_parameter_47 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPSA_PlantMode_parameter_47() { return getDouble(CmPSA_PlantMode_parameter_47); }
  public void setCmPSA_PlantMode_parameter_47(double v) { setDouble(CmPSA_PlantMode_parameter_47,v,null); }
// ALM-02: reset type fan failure alarm 0=man; 1=auto; 2=auto fan on
  public static final Property CmPSA_PlantMode_parameter_48 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPSA_PlantMode_parameter_48() { return getDouble(CmPSA_PlantMode_parameter_48); }
  public void setCmPSA_PlantMode_parameter_48(double v) { setDouble(CmPSA_PlantMode_parameter_48,v,null); }
// ALM-03: reset type fire alarm 0=man; 1=auto
  public static final Property CmPSA_PlantMode_parameter_242 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPSA_PlantMode_parameter_242() { return getDouble(CmPSA_PlantMode_parameter_242); }
  public void setCmPSA_PlantMode_parameter_242(double v) { setDouble(CmPSA_PlantMode_parameter_242,v,null); }

  // macro inputs
// Occ_Period
  public static final Property CmPSA_PlantMode_input_1 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmPSA_PlantMode_input_1() { return (BStatusBoolean) get(CmPSA_PlantMode_input_1); }
  public void setCmPSA_PlantMode_input_1(BStatusBoolean v) { set(CmPSA_PlantMode_input_1,v,null); }
  public void setCmPSA_PlantMode_input_1(boolean v) { getCmPSA_PlantMode_input_1().setValue(v); }
// Occ_External
  public static final Property CmPSA_PlantMode_input_74 = newProperty( Flags.SUMMARY, new BStatusNumeric( 3 ), null);
  public BStatusNumeric getCmPSA_PlantMode_input_74() { return (BStatusNumeric) get(CmPSA_PlantMode_input_74); }
  public void setCmPSA_PlantMode_input_74(BStatusNumeric v) { set(CmPSA_PlantMode_input_74,v,null); }
  public void setCmPSA_PlantMode_input_74(float v) { getCmPSA_PlantMode_input_74().setValue(v); }
// CalcRoomTmpSp
  public static final Property CmPSA_PlantMode_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmPSA_PlantMode_input_2() { return (BStatusNumeric) get(CmPSA_PlantMode_input_2); }
  public void setCmPSA_PlantMode_input_2(BStatusNumeric v) { set(CmPSA_PlantMode_input_2,v,null); }
  public void setCmPSA_PlantMode_input_2(float v) { getCmPSA_PlantMode_input_2().setValue(v); }
// RoomRetAirTemp
  public static final Property CmPSA_PlantMode_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmPSA_PlantMode_input_3() { return (BStatusNumeric) get(CmPSA_PlantMode_input_3); }
  public void setCmPSA_PlantMode_input_3(BStatusNumeric v) { set(CmPSA_PlantMode_input_3,v,null); }
  public void setCmPSA_PlantMode_input_3(float v) { getCmPSA_PlantMode_input_3().setValue(v); }
// FilteredOAtemp
  public static final Property CmPSA_PlantMode_input_4 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmPSA_PlantMode_input_4() { return (BStatusNumeric) get(CmPSA_PlantMode_input_4); }
  public void setCmPSA_PlantMode_input_4(BStatusNumeric v) { set(CmPSA_PlantMode_input_4,v,null); }
  public void setCmPSA_PlantMode_input_4(float v) { getCmPSA_PlantMode_input_4().setValue(v); }
// ManSwCond
  public static final Property CmPSA_PlantMode_input_5 = newProperty( Flags.SUMMARY, new BStatusNumeric( 3 ), null);
  public BStatusNumeric getCmPSA_PlantMode_input_5() { return (BStatusNumeric) get(CmPSA_PlantMode_input_5); }
  public void setCmPSA_PlantMode_input_5(BStatusNumeric v) { set(CmPSA_PlantMode_input_5,v,null); }
  public void setCmPSA_PlantMode_input_5(float v) { getCmPSA_PlantMode_input_5().setValue(v); }
// DayExtension
  public static final Property CmPSA_PlantMode_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmPSA_PlantMode_input_7() { return (BStatusNumeric) get(CmPSA_PlantMode_input_7); }
  public void setCmPSA_PlantMode_input_7(BStatusNumeric v) { set(CmPSA_PlantMode_input_7,v,null); }
  public void setCmPSA_PlantMode_input_7(float v) { getCmPSA_PlantMode_input_7().setValue(v); }
// FrostThermostat
  public static final Property CmPSA_PlantMode_input_9 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPSA_PlantMode_input_9() { return (BStatusBoolean) get(CmPSA_PlantMode_input_9); }
  public void setCmPSA_PlantMode_input_9(BStatusBoolean v) { set(CmPSA_PlantMode_input_9,v,null); }
  public void setCmPSA_PlantMode_input_9(boolean v) { getCmPSA_PlantMode_input_9().setValue(v); }
// FanFailCmdAlarm
  public static final Property CmPSA_PlantMode_input_10 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPSA_PlantMode_input_10() { return (BStatusBoolean) get(CmPSA_PlantMode_input_10); }
  public void setCmPSA_PlantMode_input_10(BStatusBoolean v) { set(CmPSA_PlantMode_input_10,v,null); }
  public void setCmPSA_PlantMode_input_10(boolean v) { getCmPSA_PlantMode_input_10().setValue(v); }
// Reset
  public static final Property CmPSA_PlantMode_input_12 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPSA_PlantMode_input_12() { return (BStatusBoolean) get(CmPSA_PlantMode_input_12); }
  public void setCmPSA_PlantMode_input_12(BStatusBoolean v) { set(CmPSA_PlantMode_input_12,v,null); }
  public void setCmPSA_PlantMode_input_12(boolean v) { getCmPSA_PlantMode_input_12().setValue(v); }
// HumidityMode
  public static final Property CmPSA_PlantMode_input_6 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmPSA_PlantMode_input_6() { return (BStatusNumeric) get(CmPSA_PlantMode_input_6); }
  public void setCmPSA_PlantMode_input_6(BStatusNumeric v) { set(CmPSA_PlantMode_input_6,v,null); }
  public void setCmPSA_PlantMode_input_6(float v) { getCmPSA_PlantMode_input_6().setValue(v); }
// FireAlarm
  public static final Property CmPSA_PlantMode_input_11 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPSA_PlantMode_input_11() { return (BStatusBoolean) get(CmPSA_PlantMode_input_11); }
  public void setCmPSA_PlantMode_input_11(BStatusBoolean v) { set(CmPSA_PlantMode_input_11,v,null); }
  public void setCmPSA_PlantMode_input_11(boolean v) { getCmPSA_PlantMode_input_11().setValue(v); }
// NIPUEnable
  public static final Property CmPSA_PlantMode_input_257 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmPSA_PlantMode_input_257() { return (BStatusBoolean) get(CmPSA_PlantMode_input_257); }
  public void setCmPSA_PlantMode_input_257(BStatusBoolean v) { set(CmPSA_PlantMode_input_257,v,null); }
  public void setCmPSA_PlantMode_input_257(boolean v) { getCmPSA_PlantMode_input_257().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.08 [78] 21.09.2017-11:05").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5891524858615955537").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmPSA_PlantMode.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public TuncosInformation getTuncosInfo(int tuncosId)
  {
    TuncosInformation tuncos = null;
    try
    {
      Property prop = null;
      switch (tuncosId)
      {
      case 25: prop = CmPSA_PlantMode_input_1; break;
      }
      if (prop != null)
        tuncos = super.getTuncos(prop);
    }
    catch (Exception x)
    {
    }
    return tuncos;
  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }

  // class variables
  protected CfMonoflop func_56 = new CfMonoflop();
  protected CmIDT20 func_105 = new CmIDT20();
  protected CmIDT10 func_127 = new CmIDT10();
  protected CmPlant_Mode_0 func_152 = new CmPlant_Mode_0();
  protected CmPlant_Mode_2 func_75 = new CmPlant_Mode_2();
  protected CmPlant_Mode_3 func_99 = new CmPlant_Mode_3();
  protected CmPlant_Mode_4 func_65 = new CmPlant_Mode_4();
  protected CmPlant_Mode_5 func_69 = new CmPlant_Mode_5();
  protected CmPlant_Mode_6 func_72 = new CmPlant_Mode_6();
  protected CfOr func_181 = new CfOr();
  protected CmPlant_Mode_11 func_101 = new CmPlant_Mode_11();
  protected CmPlant_Mode_20 func_53 = new CmPlant_Mode_20();
  protected CmPlant_Mode_21 func_61 = new CmPlant_Mode_21();
  protected CmPlant_Mode_30 func_58 = new CmPlant_Mode_30();
  protected CmPlant_Mode func_246 = new CmPlant_Mode();
  protected CfAddition func_253 = new CfAddition();

  // default constructor
  public BCmPSA_PlantMode()
  {
  }

  public void Start()
  {
    func_56.Start();
    func_105.Start();
    func_127.Start();
    func_152.Start();
    func_75.Start();
    func_99.Start();
    func_65.Start();
    func_69.Start();
    func_72.Start();
    func_101.Start();
    func_53.Start();
    func_61.Start();
    func_58.Start();
    func_246.Start();
  }
}
