/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    SCB_ElectricHeater
Macro id:      6265555571722682710
Macro version: 5
Last change:   20.03.2018 - 11:49
Access Level:  2
Inputs:
  [1] HeatCtrlSig
  [2] MaxLimSensor
  [3] EmergencyStop
  [4] FanBeltIn
  [5] PlantMode
Outputs:
  [1] Stage1Cmd
  [2] Stage2Cmd
  [3] Stage3Cmd
  [4] Stage4Cmd
  [5] HeatControl
  [6] SeqSignal
  [7] DamperEnable
  [8] HeatEnable
Parameter:
  [1] LIM-01 Limitation control: setpoint
  [2] LIM-02 Limitation control: P-band
  [3] LIM-03 Limitation control: I-time
  [4] STx-01: blocking on time
  [5] STx-02: blocking off time
  [6] SYS-01: Total number of digital stages
  [7] SYS-02: Enable analog output
  [8] SYS-03: Stage differential
  [9] SYS-04: Conversation mode
  [10] SYS-05: Delay after initialise
  [11] DISP-01: Total number of stages
  [12] DISP-02: Requested stages
  [13] DISP-03: Actual stages
Description:
The "SCB_ElectricHeater" is a four stages output step-controller module. With this module, four steps can be controlled in a linear or binary mode. If more steps are needed, an add-on module for step-controller can be connected to this SCB_ElectricHeater. Additional outputs "DamperEnable and HeatEnable" are available.
================================================================================*/

public class BCmSCB_ElectricHeater
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmSCB_ElectricHeater_output_6().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmSCB_ElectricHeater_output_6().setStatus(BStatus.disabled);
    getCmSCB_ElectricHeater_output_86().setStatus(BStatus.disabled);
    getCmSCB_ElectricHeater_output_87().setStatus(BStatus.disabled);
    getCmSCB_ElectricHeater_output_88().setStatus(BStatus.disabled);
    getCmSCB_ElectricHeater_output_89().setStatus(BStatus.disabled);
    getCmSCB_ElectricHeater_output_90().setStatus(BStatus.disabled);
    getCmSCB_ElectricHeater_output_219().setStatus(BStatus.disabled);
    getCmSCB_ElectricHeater_output_220().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmSCB_ElectricHeater_output_6().setStatus(BStatus.ok);
    getCmSCB_ElectricHeater_output_86().setStatus(BStatus.ok);
    getCmSCB_ElectricHeater_output_87().setStatus(BStatus.ok);
    getCmSCB_ElectricHeater_output_88().setStatus(BStatus.ok);
    getCmSCB_ElectricHeater_output_89().setStatus(BStatus.ok);
    getCmSCB_ElectricHeater_output_90().setStatus(BStatus.ok);
    getCmSCB_ElectricHeater_output_219().setStatus(BStatus.ok);
    getCmSCB_ElectricHeater_output_220().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [179] Macro call CmIDT20
    func_179.CmIDT20_input_1 = (float) getCmSCB_ElectricHeater_parameter_21();
    func_179.CmIDT20_input_2 = (float) getCmSCB_ElectricHeater_parameter_12();
    func_179.CmIDT20_input_3 = (float) getCmSCB_ElectricHeater_parameter_13();
    func_179.CmIDT20_input_4 = (float) getCmSCB_ElectricHeater_parameter_14();
    func_179.CmIDT20_input_5 = (float) getCmSCB_ElectricHeater_parameter_15();
    func_179.CmIDT20_input_6 = (float) getCmSCB_ElectricHeater_parameter_16();
    func_179.CmIDT20_input_7 = (float) getCmSCB_ElectricHeater_parameter_17();
    func_179.CmIDT20_input_8 = (float) getCmSCB_ElectricHeater_parameter_18();
    func_179.CmIDT20_input_9 = (float) getCmSCB_ElectricHeater_parameter_19();
    func_179.CmIDT20_input_10 = (float) getCmSCB_ElectricHeater_parameter_17();
    func_179.CmIDT20_input_11 = (float) getCmSCB_ElectricHeater_parameter_18();
    func_179.CmIDT20_input_12 = (float) getCmSCB_ElectricHeater_parameter_19();
    func_179.CmIDT20_input_13 = getParameter(38);
    func_179.CmIDT20_input_14 = (float) getCmSCB_ElectricHeater_parameter_18();
    func_179.CmIDT20_input_15 = (float) getCmSCB_ElectricHeater_parameter_20();
    func_179.CmIDT20_input_16 = (float) getCmSCB_ElectricHeater_parameter_17();
    func_179.CmIDT20_input_17 = getParameter(41);
    func_179.CmIDT20_input_18 = (float) getCmSCB_ElectricHeater_parameter_18();
    func_179.CmIDT20_input_19 = 0F;
    func_179.CmIDT20_input_20 = 0F;
    func_179.Execute(  );
    setParameter(0, func_179.CmIDT20_output_21);
    setParameter(3, func_179.CmIDT20_output_22);
    setParameter(4, func_179.CmIDT20_output_23);
    setParameter(5, func_179.CmIDT20_output_24);
    setParameter(21, func_179.CmIDT20_output_25);
    setParameter(22, func_179.CmIDT20_output_26);
    setParameter(23, func_179.CmIDT20_output_27);
    setParameter(24, func_179.CmIDT20_output_28);
    setParameter(25, func_179.CmIDT20_output_29);
    setParameter(35, func_179.CmIDT20_output_30);
    setParameter(36, func_179.CmIDT20_output_31);
    setParameter(37, func_179.CmIDT20_output_32);
    setCmSCB_ElectricHeater_parameter_22(func_179.CmIDT20_output_33);
    setParameter(39, func_179.CmIDT20_output_34);
    setParameter(40, func_179.CmIDT20_output_35);
    setParameter(43, func_179.CmIDT20_output_36);
    setCmSCB_ElectricHeater_parameter_24(func_179.CmIDT20_output_37);
    setParameter(42, func_179.CmIDT20_output_38);

    // [202] Macro call CmIDT05
    func_202.CmIDT05_input_1 = 0F;
    func_202.CmIDT05_input_2 = 0F;
    func_202.CmIDT05_input_3 = (float) getCmSCB_ElectricHeater_parameter_17();
    func_202.CmIDT05_input_4 = (float) getCmSCB_ElectricHeater_parameter_18();
    func_202.CmIDT05_input_5 = (float) getCmSCB_ElectricHeater_parameter_19();
    func_202.Execute(  );
    setParameter(28, func_202.CmIDT05_output_21);
    setParameter(29, func_202.CmIDT05_output_22);
    setParameter(30, func_202.CmIDT05_output_23);
    setParameter(31, func_202.CmIDT05_output_24);
    setParameter(32, func_202.CmIDT05_output_25);

    // [210] Macro call CmIDT05
    func_210.CmIDT05_input_1 = (float) getCmSCB_ElectricHeater_parameter_24();
    func_210.CmIDT05_input_2 = (float) getCmSCB_ElectricHeater_parameter_18();
    func_210.CmIDT05_input_3 = (float) getCmSCB_ElectricHeater_parameter_20();
    func_210.CmIDT05_input_4 = 0F;
    func_210.CmIDT05_input_5 = 0F;
    func_210.Execute(  );
    setParameter(49, func_210.CmIDT05_output_21);
    setParameter(50, func_210.CmIDT05_output_22);
    setParameter(51, func_210.CmIDT05_output_23);

    // [83] Macro call CmStart_Heater_Cooler
    func_83.CmStart_Heater_Cooler_input_3 = getCmSCB_ElectricHeater_input_3().getValue();
    func_83.CmStart_Heater_Cooler_input_4 = getCmSCB_ElectricHeater_input_4().getValue();
    func_83.CmStart_Heater_Cooler_input_5 = (float) getCmSCB_ElectricHeater_input_5().getValue();
    func_83.Execute( this, 0 );

    // [176] Macro call CmEHT_Control
    func_176.CmEHT_Control_input_84 = (float) getCmSCB_ElectricHeater_input_84().getValue();
    func_176.CmEHT_Control_input_85 = (float) getCmSCB_ElectricHeater_input_85().getValue();
    func_176.Execute( this, 3 );

    // [136] Macro call CmStep_Controller
    func_136.CmStep_Controller_input_292 = func_83.CmStart_Heater_Cooler_output_6;
    func_136.CmStep_Controller_input_84 = func_176.CmEHT_Control_output_89;
    func_136.Execute( this, 21 );

    // [200] Macro call CmStep_Controller
    func_200.CmStep_Controller_input_292 = func_83.CmStart_Heater_Cooler_output_6;
    func_200.CmStep_Controller_input_84 = func_176.CmEHT_Control_output_89;
    func_200.Execute( this, 28 );
    setCmSCB_ElectricHeater_parameter_23(func_200.CmStep_Controller_output_262);

    // [124] Macro call CmAnalog_Sequence
    func_124.CmAnalog_Sequence_input_162 = func_136.CmStep_Controller_output_262;
    func_124.CmAnalog_Sequence_input_84 = func_176.CmEHT_Control_output_89;
    func_124.CmAnalog_Sequence_input_213 = func_83.CmStart_Heater_Cooler_output_6;
    func_124.Execute( this, 35 );

    // [153] Macro call CmSaw_tooth
    func_153.CmSaw_tooth_input_84 = func_124.CmAnalog_Sequence_output_89;
    func_153.CmSaw_tooth_input_99 = func_124.CmAnalog_Sequence_output_139;
    func_153.CmSaw_tooth_input_102 = func_124.CmAnalog_Sequence_output_175;
    func_153.CmSaw_tooth_input_110 = func_124.CmAnalog_Sequence_output_182;
    func_153.CmSaw_tooth_input_100 = func_136.CmStep_Controller_output_262;
    func_153.Execute( this, 39 );

    // [166] Macro call CmOutput_Switch
    func_166.CmOutput_Switch_input_84 = func_153.CmSaw_tooth_output_89;
    func_166.CmOutput_Switch_input_5 = func_136.CmStep_Controller_output_262;
    func_166.CmOutput_Switch_input_187 = func_83.CmStart_Heater_Cooler_output_6;
    func_166.CmOutput_Switch_input_238 = true;
    func_166.Execute( this, 40 );
    setCmSCB_ElectricHeater_output_6(func_166.CmOutput_Switch_output_6);
    setCmSCB_ElectricHeater_output_86(func_166.CmOutput_Switch_output_86);
    setCmSCB_ElectricHeater_output_87(func_166.CmOutput_Switch_output_87);
    setCmSCB_ElectricHeater_output_88(func_166.CmOutput_Switch_output_88);
    setCmSCB_ElectricHeater_output_89(func_166.CmOutput_Switch_output_89);

    // [208] Macro call CmSequencing
    func_208.Execute( this, 49 );
    setCmSCB_ElectricHeater_output_90(func_208.CmSequencing_output_1);

    // [221] Macro call CmElectric_Damper_Enable
    func_221.CmElectric_Damper_Enable_input_1 = (float) getCmSCB_ElectricHeater_input_5().getValue();
    func_221.CmElectric_Damper_Enable_input_2 = getCmSCB_ElectricHeater_input_3().getValue();
    func_221.Execute(  );
    setCmSCB_ElectricHeater_output_219(func_221.CmElectric_Damper_Enable_output_3);

    // [223] Function call CfIdt
    func_223.input = BooleanToFloat(func_83.CmStart_Heater_Cooler_output_6);
    func_223.Execute(  );
    setCmSCB_ElectricHeater_output_220(FloatToBoolean(func_223.output[0]));

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    15F, 10F, 1F, 35F, 10F, 0F, 3F, 0F,
    1000F, 100F, 0F, 3F, 0F, 1000F, 100F, 0F,
    3F, 0F, 1000F, 100F, 0F, 20F, 20F, 4F,
    0F, 50F, 1F, 1F, 20F, 20F, 4F, 0F,
    50F, 1F, 1F, 4F, 0F, 50F, 0F, 0F,
    0F, 0F, 0F, 0F, 1F, 2F, 2F, 2F,
    2F, 0F, 0F, 0F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// Stage1Cmd
  public static final Property CmSCB_ElectricHeater_output_6 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSCB_ElectricHeater_output_6() { return (BStatusBoolean) get(CmSCB_ElectricHeater_output_6); }
  public void setCmSCB_ElectricHeater_output_6(BStatusBoolean v) { set(CmSCB_ElectricHeater_output_6,v,null); }
  public void setCmSCB_ElectricHeater_output_6(boolean v) { getCmSCB_ElectricHeater_output_6().setValue(v); }
// Stage2Cmd
  public static final Property CmSCB_ElectricHeater_output_86 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSCB_ElectricHeater_output_86() { return (BStatusBoolean) get(CmSCB_ElectricHeater_output_86); }
  public void setCmSCB_ElectricHeater_output_86(BStatusBoolean v) { set(CmSCB_ElectricHeater_output_86,v,null); }
  public void setCmSCB_ElectricHeater_output_86(boolean v) { getCmSCB_ElectricHeater_output_86().setValue(v); }
// Stage3Cmd
  public static final Property CmSCB_ElectricHeater_output_87 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSCB_ElectricHeater_output_87() { return (BStatusBoolean) get(CmSCB_ElectricHeater_output_87); }
  public void setCmSCB_ElectricHeater_output_87(BStatusBoolean v) { set(CmSCB_ElectricHeater_output_87,v,null); }
  public void setCmSCB_ElectricHeater_output_87(boolean v) { getCmSCB_ElectricHeater_output_87().setValue(v); }
// Stage4Cmd
  public static final Property CmSCB_ElectricHeater_output_88 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSCB_ElectricHeater_output_88() { return (BStatusBoolean) get(CmSCB_ElectricHeater_output_88); }
  public void setCmSCB_ElectricHeater_output_88(BStatusBoolean v) { set(CmSCB_ElectricHeater_output_88,v,null); }
  public void setCmSCB_ElectricHeater_output_88(boolean v) { getCmSCB_ElectricHeater_output_88().setValue(v); }
// HeatControl
  public static final Property CmSCB_ElectricHeater_output_89 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSCB_ElectricHeater_output_89() { return (BStatusNumeric) get(CmSCB_ElectricHeater_output_89); }
  public void setCmSCB_ElectricHeater_output_89(BStatusNumeric v) { set(CmSCB_ElectricHeater_output_89,v,null); }
  public void setCmSCB_ElectricHeater_output_89(float v) { getCmSCB_ElectricHeater_output_89().setValue(v); }
// SeqSignal
  public static final Property CmSCB_ElectricHeater_output_90 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSCB_ElectricHeater_output_90() { return (BStatusNumeric) get(CmSCB_ElectricHeater_output_90); }
  public void setCmSCB_ElectricHeater_output_90(BStatusNumeric v) { set(CmSCB_ElectricHeater_output_90,v,null); }
  public void setCmSCB_ElectricHeater_output_90(float v) { getCmSCB_ElectricHeater_output_90().setValue(v); }
// DamperEnable
  public static final Property CmSCB_ElectricHeater_output_219 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSCB_ElectricHeater_output_219() { return (BStatusBoolean) get(CmSCB_ElectricHeater_output_219); }
  public void setCmSCB_ElectricHeater_output_219(BStatusBoolean v) { set(CmSCB_ElectricHeater_output_219,v,null); }
  public void setCmSCB_ElectricHeater_output_219(boolean v) { getCmSCB_ElectricHeater_output_219().setValue(v); }
// HeatEnable
  public static final Property CmSCB_ElectricHeater_output_220 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSCB_ElectricHeater_output_220() { return (BStatusBoolean) get(CmSCB_ElectricHeater_output_220); }
  public void setCmSCB_ElectricHeater_output_220(BStatusBoolean v) { set(CmSCB_ElectricHeater_output_220,v,null); }
  public void setCmSCB_ElectricHeater_output_220(boolean v) { getCmSCB_ElectricHeater_output_220().setValue(v); }

  // macro parameter
// LIM-01 Limitation control: setpoint
  public static final Property CmSCB_ElectricHeater_parameter_12 = newProperty( 0, BDouble.make( 35 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmSCB_ElectricHeater_parameter_12() { return getDouble(CmSCB_ElectricHeater_parameter_12); }
  public void setCmSCB_ElectricHeater_parameter_12(double v) { setDouble(CmSCB_ElectricHeater_parameter_12,v,null); }
// LIM-02 Limitation control: P-band
  public static final Property CmSCB_ElectricHeater_parameter_13 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(5000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmSCB_ElectricHeater_parameter_13() { return getDouble(CmSCB_ElectricHeater_parameter_13); }
  public void setCmSCB_ElectricHeater_parameter_13(double v) { setDouble(CmSCB_ElectricHeater_parameter_13,v,null); }
// LIM-03 Limitation control: I-time
  public static final Property CmSCB_ElectricHeater_parameter_14 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSCB_ElectricHeater_parameter_14() { return getDouble(CmSCB_ElectricHeater_parameter_14); }
  public void setCmSCB_ElectricHeater_parameter_14(double v) { setDouble(CmSCB_ElectricHeater_parameter_14,v,null); }
// STx-01: blocking on time
  public static final Property CmSCB_ElectricHeater_parameter_15 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSCB_ElectricHeater_parameter_15() { return getDouble(CmSCB_ElectricHeater_parameter_15); }
  public void setCmSCB_ElectricHeater_parameter_15(double v) { setDouble(CmSCB_ElectricHeater_parameter_15,v,null); }
// STx-02: blocking off time
  public static final Property CmSCB_ElectricHeater_parameter_16 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSCB_ElectricHeater_parameter_16() { return getDouble(CmSCB_ElectricHeater_parameter_16); }
  public void setCmSCB_ElectricHeater_parameter_16(double v) { setDouble(CmSCB_ElectricHeater_parameter_16,v,null); }
// SYS-01: Total number of digital stages
  public static final Property CmSCB_ElectricHeater_parameter_17 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(100)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSCB_ElectricHeater_parameter_17() { return getDouble(CmSCB_ElectricHeater_parameter_17); }
  public void setCmSCB_ElectricHeater_parameter_17(double v) { setDouble(CmSCB_ElectricHeater_parameter_17,v,null); }
// SYS-02: Enable analog output
  public static final Property CmSCB_ElectricHeater_parameter_18 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSCB_ElectricHeater_parameter_18() { return getDouble(CmSCB_ElectricHeater_parameter_18); }
  public void setCmSCB_ElectricHeater_parameter_18(double v) { setDouble(CmSCB_ElectricHeater_parameter_18,v,null); }
// SYS-03: Stage differential
  public static final Property CmSCB_ElectricHeater_parameter_19 = newProperty( 0, BDouble.make( 50 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmSCB_ElectricHeater_parameter_19() { return getDouble(CmSCB_ElectricHeater_parameter_19); }
  public void setCmSCB_ElectricHeater_parameter_19(double v) { setDouble(CmSCB_ElectricHeater_parameter_19,v,null); }
// SYS-04: Conversation mode
  public static final Property CmSCB_ElectricHeater_parameter_20 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSCB_ElectricHeater_parameter_20() { return getDouble(CmSCB_ElectricHeater_parameter_20); }
  public void setCmSCB_ElectricHeater_parameter_20(double v) { setDouble(CmSCB_ElectricHeater_parameter_20,v,null); }
// SYS-05: Delay after initialise
  public static final Property CmSCB_ElectricHeater_parameter_21 = newProperty( 0, BDouble.make( 15 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSCB_ElectricHeater_parameter_21() { return getDouble(CmSCB_ElectricHeater_parameter_21); }
  public void setCmSCB_ElectricHeater_parameter_21(double v) { setDouble(CmSCB_ElectricHeater_parameter_21,v,null); }
// DISP-01: Total number of stages
  public static final Property CmSCB_ElectricHeater_parameter_22 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(100)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSCB_ElectricHeater_parameter_22() { return getDouble(CmSCB_ElectricHeater_parameter_22); }
  public void setCmSCB_ElectricHeater_parameter_22(double v) { setDouble(CmSCB_ElectricHeater_parameter_22,v,null); }
// DISP-02: Requested stages
  public static final Property CmSCB_ElectricHeater_parameter_23 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(100)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSCB_ElectricHeater_parameter_23() { return getDouble(CmSCB_ElectricHeater_parameter_23); }
  public void setCmSCB_ElectricHeater_parameter_23(double v) { setDouble(CmSCB_ElectricHeater_parameter_23,v,null); }
// DISP-03: Actual stages
  public static final Property CmSCB_ElectricHeater_parameter_24 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(100)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSCB_ElectricHeater_parameter_24() { return getDouble(CmSCB_ElectricHeater_parameter_24); }
  public void setCmSCB_ElectricHeater_parameter_24(double v) { setDouble(CmSCB_ElectricHeater_parameter_24,v,null); }

  // macro inputs
// HeatCtrlSig
  public static final Property CmSCB_ElectricHeater_input_84 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmSCB_ElectricHeater_input_84() { return (BStatusNumeric) get(CmSCB_ElectricHeater_input_84); }
  public void setCmSCB_ElectricHeater_input_84(BStatusNumeric v) { set(CmSCB_ElectricHeater_input_84,v,null); }
  public void setCmSCB_ElectricHeater_input_84(float v) { getCmSCB_ElectricHeater_input_84().setValue(v); }
// MaxLimSensor
  public static final Property CmSCB_ElectricHeater_input_85 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmSCB_ElectricHeater_input_85() { return (BStatusNumeric) get(CmSCB_ElectricHeater_input_85); }
  public void setCmSCB_ElectricHeater_input_85(BStatusNumeric v) { set(CmSCB_ElectricHeater_input_85,v,null); }
  public void setCmSCB_ElectricHeater_input_85(float v) { getCmSCB_ElectricHeater_input_85().setValue(v); }
// EmergencyStop
  public static final Property CmSCB_ElectricHeater_input_3 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmSCB_ElectricHeater_input_3() { return (BStatusBoolean) get(CmSCB_ElectricHeater_input_3); }
  public void setCmSCB_ElectricHeater_input_3(BStatusBoolean v) { set(CmSCB_ElectricHeater_input_3,v,null); }
  public void setCmSCB_ElectricHeater_input_3(boolean v) { getCmSCB_ElectricHeater_input_3().setValue(v); }
// FanBeltIn
  public static final Property CmSCB_ElectricHeater_input_4 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmSCB_ElectricHeater_input_4() { return (BStatusBoolean) get(CmSCB_ElectricHeater_input_4); }
  public void setCmSCB_ElectricHeater_input_4(BStatusBoolean v) { set(CmSCB_ElectricHeater_input_4,v,null); }
  public void setCmSCB_ElectricHeater_input_4(boolean v) { getCmSCB_ElectricHeater_input_4().setValue(v); }
// PlantMode
  public static final Property CmSCB_ElectricHeater_input_5 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmSCB_ElectricHeater_input_5() { return (BStatusNumeric) get(CmSCB_ElectricHeater_input_5); }
  public void setCmSCB_ElectricHeater_input_5(BStatusNumeric v) { set(CmSCB_ElectricHeater_input_5,v,null); }
  public void setCmSCB_ElectricHeater_input_5(float v) { getCmSCB_ElectricHeater_input_5().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.02 [5] 20.03.2018-11:49").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6265555571722682710").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmSCB_ElectricHeater.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmIDT20 func_179 = new CmIDT20();
  protected CmIDT05 func_202 = new CmIDT05();
  protected CmIDT05 func_210 = new CmIDT05();
  protected CmStart_Heater_Cooler func_83 = new CmStart_Heater_Cooler();
  protected CmEHT_Control func_176 = new CmEHT_Control();
  protected CmStep_Controller func_136 = new CmStep_Controller();
  protected CmStep_Controller func_200 = new CmStep_Controller();
  protected CmAnalog_Sequence func_124 = new CmAnalog_Sequence();
  protected CmSaw_tooth func_153 = new CmSaw_tooth();
  protected CmOutput_Switch func_166 = new CmOutput_Switch();
  protected CmSequencing func_208 = new CmSequencing();
  protected CmElectric_Damper_Enable func_221 = new CmElectric_Damper_Enable();
  protected CfIdt func_223 = new CfIdt();

  // default constructor
  public BCmSCB_ElectricHeater()
  {
  }

  public void Start()
  {
    func_179.Start();
    func_202.Start();
    func_210.Start();
    func_83.Start();
    func_176.Start();
    func_136.Start();
    func_200.Start();
    func_124.Start();
    func_153.Start();
    func_166.Start();
    func_208.Start();
    func_221.Start();
  }
}
