/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    SCB_StepExtension
Macro id:      5932656993668957134
Macro version: 15
Last change:   13.01.2014 - 12:49
Access Level:  2
Inputs:
  [1] SeqSignal
Outputs:
  [1] Stage1Cmd
  [2] Stage2Cmd
  [3] Stage3Cmd
  [4] Stage4Cmd
  [5] SeqSignal
Parameter:
Description:
The "SCB_StepExtension" is for the main step-controller module Electric Heater / Direct Expansion Cooler. With this add-on module four linear or binary steps can be added to the step-controller module.

Each add on module for step-controller adds up to four output stages to the step-controller Electric Heater / Direct Expansion Cooler . Within the main step-controller module Electric Heater / Direct Expansion Cooler, the definition can be made, whether the outputs will be controlled in a linear or in a binary way. The module has only one input Sequencing Signal.The outputs of the module are respectively: Stage1, Stage2, Stage3, Stage4 and Sequencing Signal for next add on module for step-controller.
================================================================================*/

public class BCmSCB_StepExtension
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmSCB_StepExtension_output_3().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmSCB_StepExtension_output_3().setStatus(BStatus.disabled);
    getCmSCB_StepExtension_output_4().setStatus(BStatus.disabled);
    getCmSCB_StepExtension_output_5().setStatus(BStatus.disabled);
    getCmSCB_StepExtension_output_6().setStatus(BStatus.disabled);
    getCmSCB_StepExtension_output_2().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmSCB_StepExtension_output_3().setStatus(BStatus.ok);
    getCmSCB_StepExtension_output_4().setStatus(BStatus.ok);
    getCmSCB_StepExtension_output_5().setStatus(BStatus.ok);
    getCmSCB_StepExtension_output_6().setStatus(BStatus.ok);
    getCmSCB_StepExtension_output_2().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [15] Function call CfCompare1
    func_15.inputA = (float) getCmSCB_StepExtension_input_1().getValue();
    func_15.inputB = 0F;
    func_15.Execute(  );

    // [20] Function call CfMultiply
    func_20.input[0] = (float) getCmSCB_StepExtension_input_1().getValue();
    func_20.input[1] = -1F;
    func_20.Execute(  );

    // [38] Function call CfInputMultiplexer
    func_38.inputSelect = BooleanToInt(func_15.outputLess);
    func_38.input[1-1] = 4F;
    func_38.input[2-1] = 16F;
    func_38.Execute(  );

    // [27] Macro call CmIDT10
    func_27.CmIDT10_input_1 = (float) getCmSCB_StepExtension_input_1().getValue();
    func_27.CmIDT10_input_2 = func_38.output;
    func_27.CmIDT10_input_3 = 0F;
    func_27.CmIDT10_input_4 = BooleanToFloat(func_15.outputLess);
    func_27.CmIDT10_input_5 = (float) getCmSCB_StepExtension_input_1().getValue();
    func_27.CmIDT10_input_6 = 0F;
    func_27.CmIDT10_input_7 = BooleanToFloat(func_15.outputLess);
    func_27.CmIDT10_input_8 = 0F;
    func_27.CmIDT10_input_9 = 0F;
    func_27.CmIDT10_input_10 = 0F;
    func_27.Execute(  );
    setParameter(4, func_27.CmIDT10_output_21);
    setParameter(6, func_27.CmIDT10_output_22);
    setParameter(5, func_27.CmIDT10_output_23);
    setParameter(3, func_27.CmIDT10_output_24);
    setParameter(0, func_27.CmIDT10_output_25);
    setParameter(1, func_27.CmIDT10_output_26);
    setParameter(2, func_27.CmIDT10_output_27);

    // [18] Function call CfInputMultiplexer
    func_18.inputSelect = BooleanToInt(func_15.outputLess);
    func_18.input[1-1] = (float) getCmSCB_StepExtension_input_1().getValue();
    func_18.input[2-1] = func_20.output;
    func_18.Execute(  );

    // [16] Macro call CmSequencing
    func_16.Execute( this, 0 );
    setCmSCB_StepExtension_output_2(func_16.CmSequencing_output_1);

    // [9] Macro call CmOutput_Switch
    func_9.CmOutput_Switch_input_84 = 0F;
    func_9.CmOutput_Switch_input_5 = func_18.output;
    func_9.CmOutput_Switch_input_187 = true;
    func_9.CmOutput_Switch_input_238 = false;
    func_9.Execute( this, 3 );
    setCmSCB_StepExtension_output_3(func_9.CmOutput_Switch_output_6);
    setCmSCB_StepExtension_output_4(func_9.CmOutput_Switch_output_86);
    setCmSCB_StepExtension_output_5(func_9.CmOutput_Switch_output_87);
    setCmSCB_StepExtension_output_6(func_9.CmOutput_Switch_output_88);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 0F, 0F, 0F, 0F, 0F, 0F, 1F,
    2F, 2F, 2F, 2F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// Stage1Cmd
  public static final Property CmSCB_StepExtension_output_3 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSCB_StepExtension_output_3() { return (BStatusBoolean) get(CmSCB_StepExtension_output_3); }
  public void setCmSCB_StepExtension_output_3(BStatusBoolean v) { set(CmSCB_StepExtension_output_3,v,null); }
  public void setCmSCB_StepExtension_output_3(boolean v) { getCmSCB_StepExtension_output_3().setValue(v); }
// Stage2Cmd
  public static final Property CmSCB_StepExtension_output_4 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSCB_StepExtension_output_4() { return (BStatusBoolean) get(CmSCB_StepExtension_output_4); }
  public void setCmSCB_StepExtension_output_4(BStatusBoolean v) { set(CmSCB_StepExtension_output_4,v,null); }
  public void setCmSCB_StepExtension_output_4(boolean v) { getCmSCB_StepExtension_output_4().setValue(v); }
// Stage3Cmd
  public static final Property CmSCB_StepExtension_output_5 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSCB_StepExtension_output_5() { return (BStatusBoolean) get(CmSCB_StepExtension_output_5); }
  public void setCmSCB_StepExtension_output_5(BStatusBoolean v) { set(CmSCB_StepExtension_output_5,v,null); }
  public void setCmSCB_StepExtension_output_5(boolean v) { getCmSCB_StepExtension_output_5().setValue(v); }
// Stage4Cmd
  public static final Property CmSCB_StepExtension_output_6 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSCB_StepExtension_output_6() { return (BStatusBoolean) get(CmSCB_StepExtension_output_6); }
  public void setCmSCB_StepExtension_output_6(BStatusBoolean v) { set(CmSCB_StepExtension_output_6,v,null); }
  public void setCmSCB_StepExtension_output_6(boolean v) { getCmSCB_StepExtension_output_6().setValue(v); }
// SeqSignal
  public static final Property CmSCB_StepExtension_output_2 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSCB_StepExtension_output_2() { return (BStatusNumeric) get(CmSCB_StepExtension_output_2); }
  public void setCmSCB_StepExtension_output_2(BStatusNumeric v) { set(CmSCB_StepExtension_output_2,v,null); }
  public void setCmSCB_StepExtension_output_2(float v) { getCmSCB_StepExtension_output_2().setValue(v); }

  // macro parameter

  // macro inputs
// SeqSignal
  public static final Property CmSCB_StepExtension_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmSCB_StepExtension_input_1() { return (BStatusNumeric) get(CmSCB_StepExtension_input_1); }
  public void setCmSCB_StepExtension_input_1(BStatusNumeric v) { set(CmSCB_StepExtension_input_1,v,null); }
  public void setCmSCB_StepExtension_input_1(float v) { getCmSCB_StepExtension_input_1().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.03 [15] 13.01.2014-12:49").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5932656993668957134").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmSCB_StepExtension.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

  // class variables
  protected CfCompare1 func_15 = new CfCompare1();
  protected CfMultiply func_20 = new CfMultiply();
  protected CfInputMultiplexer func_38 = new CfInputMultiplexer();
  protected CmIDT10 func_27 = new CmIDT10();
  protected CfInputMultiplexer func_18 = new CfInputMultiplexer();
  protected CmSequencing func_16 = new CmSequencing();
  protected CmOutput_Switch func_9 = new CmOutput_Switch();

  // default constructor
  public BCmSCB_StepExtension()
  {
  }

  public void Start()
  {
    func_27.Start();
    func_16.Start();
    func_9.Start();
  }
}
