/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    SPA_StatPressControl
Macro id:      5800258799215313336
Macro version: 48
Last change:   15.01.2019 - 09:54
Access Level:  2
Inputs:
  [1] PressSensor
  [2] DuctPressSp
  [3] FanEnableSig
  [4] DamperCtrlSig
  [5] HighLimPressSens
  [6] DispSupplyFlow
  [7] FireMode
  [8] PlantMode
Outputs:
  [1] FanSpeedCtrl
Parameter:
  [1] DSP-01: setpoint increase / decrease
  [2] DSP-02: P-band static pressure control
  [3] DSP-03: I-time static pressure control
  [4] DSH-01: setpoint high limit static pressure control
  [5] DSH-02: P-band high limit static pressure control
  [6] DSH-03: I-time high limit static pressure control
  [7] SAF-01: predefined flow during 100% recirc.
  [8] SAF-02: P-band flow balance control
  [9] SAF-03: I-time flow balance control
  [10] FSC-01: output signal increase per min
  [11] SYS-01: filter time; 0=disable
  [12] DISP-01: status of FNE
  [13] DISP-02: level of FSC
  [14] DISP-03: actual DSP_Sp
Description:
The Macro "SPA_StatPressControl" is a control module providing duct static pressure filtering and control as an input for the variable fan speed control module. The module has integrated features for plant overrides.

The SPA_StatPressControl module provides filtering of the duct static pressure and an analogue output for the variable fan speed control module. The duct static pressure is filtered to provide a smoothed value, which is used to eliminate sudden duct static pressure variations and thus provides a more stable operation of the duct static pressure control. A duct static high limit sensor prevents the ducts against damage, caused by too high pressures.

The module has analogue inputs for a duct static pressure sensor, a duct static high pressure limit sensor, a damper control signal and a digital input for the fan enable signal. It has an analogue output for fan speed command.

The module incorporates plant mode overrides and program initialise from the power failure module.
================================================================================*/

public class BCmSPA_StatPressControl
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmSPA_StatPressControl_output_7().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmSPA_StatPressControl_output_7().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmSPA_StatPressControl_output_7().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [122] Macro call CmIDT20
    func_122.CmIDT20_input_1 = (float) getCmSPA_StatPressControl_parameter_52();
    func_122.CmIDT20_input_2 = (float) getCmSPA_StatPressControl_parameter_53();
    func_122.CmIDT20_input_3 = (float) getCmSPA_StatPressControl_parameter_61();
    func_122.CmIDT20_input_4 = (float) getCmSPA_StatPressControl_parameter_61();
    func_122.CmIDT20_input_5 = (float) getCmSPA_StatPressControl_parameter_53();
    func_122.CmIDT20_input_6 = (float) getCmSPA_StatPressControl_parameter_59();
    func_122.CmIDT20_input_7 = (float) getCmSPA_StatPressControl_parameter_54();
    func_122.CmIDT20_input_8 = (float) getCmSPA_StatPressControl_parameter_55();
    func_122.CmIDT20_input_9 = (float) getCmSPA_StatPressControl_parameter_56();
    func_122.CmIDT20_input_10 = (float) getCmSPA_StatPressControl_parameter_60();
    func_122.CmIDT20_input_11 = (float) getCmSPA_StatPressControl_parameter_57();
    func_122.CmIDT20_input_12 = (float) getCmSPA_StatPressControl_parameter_58();
    func_122.CmIDT20_input_13 = (float) getCmSPA_StatPressControl_parameter_59();
    func_122.CmIDT20_input_14 = (float) getCmSPA_StatPressControl_parameter_51();
    func_122.CmIDT20_input_15 = 0F;
    func_122.CmIDT20_input_16 = 0F;
    func_122.CmIDT20_input_17 = 0F;
    func_122.CmIDT20_input_18 = 0F;
    func_122.CmIDT20_input_19 = 0F;
    func_122.CmIDT20_input_20 = 0F;
    func_122.Execute(  );
    setParameter(12, func_122.CmIDT20_output_21);
    setParameter(13, func_122.CmIDT20_output_22);
    setParameter(1, func_122.CmIDT20_output_23);
    setParameter(4, func_122.CmIDT20_output_24);
    setParameter(7, func_122.CmIDT20_output_25);
    setParameter(8, func_122.CmIDT20_output_26);
    setParameter(19, func_122.CmIDT20_output_27);
    setParameter(20, func_122.CmIDT20_output_28);
    setParameter(21, func_122.CmIDT20_output_29);
    setParameter(27, func_122.CmIDT20_output_30);
    setParameter(28, func_122.CmIDT20_output_31);
    setParameter(29, func_122.CmIDT20_output_32);
    setParameter(30, func_122.CmIDT20_output_33);
    setParameter(11, func_122.CmIDT20_output_34);

    // [105] Function call CfIdt
    func_105.input = BooleanToFloat(getCmSPA_StatPressControl_input_35().getValue());
    func_105.Execute(  );
    setCmSPA_StatPressControl_parameter_62(func_105.output[0]);

    // [67] Macro call CmCycleTime
    func_67.Execute( this, 0 );

    // [28] Macro call CmE_Filter
    func_28.CmE_Filter_input_23 = (float) getCmSPA_StatPressControl_input_32().getValue();
    func_28.CmE_Filter_input_47 = func_67.CmCycleTime_output_1;
    func_28.CmE_Filter_input_67 = 20000F;
    func_28.Execute( this, 1 );

    // [29] Macro call CmE_Filter
    func_29.CmE_Filter_input_23 = (float) getCmSPA_StatPressControl_input_33().getValue();
    func_29.CmE_Filter_input_47 = func_67.CmCycleTime_output_1;
    func_29.CmE_Filter_input_67 = 20000F;
    func_29.Execute( this, 4 );

    // [100] Macro call CmEnables
    func_100.CmEnables_input_3 = func_1.CmRelease_output_5;
    func_100.CmEnables_input_27 = (float) getCmSPA_StatPressControl_input_33().getValue();
    func_100.Execute( this, 7 );

    // [1] Macro call CmRelease
    func_1.CmRelease_input_2 = (float) getCmSPA_StatPressControl_input_37().getValue();
    func_1.CmRelease_input_3 = (float) getCmSPA_StatPressControl_input_36().getValue();
    func_1.CmRelease_input_4 = getCmSPA_StatPressControl_input_35().getValue();
    func_1.Execute(  );

    // [109] Macro call CmSetpoint_Ramp
    func_109.CmSetpoint_Ramp_input_7 = func_1.CmRelease_output_5;
    func_109.CmSetpoint_Ramp_input_10 = 0F;
    func_109.CmSetpoint_Ramp_input_19 = (float) getCmSPA_StatPressControl_input_38().getValue();
    func_109.Execute( this, 11 );

    // [24] Macro call CmControl_Signal
    func_24.CmControl_Signal_input_11 = func_109.CmSetpoint_Ramp_output_20;
    func_24.CmControl_Signal_input_12 = func_28.CmE_Filter_output_24;
    func_24.CmControl_Signal_input_14 = func_1.CmRelease_output_5;
    func_24.CmControl_Signal_input_15 = func_100.CmEnables_output_13;
    func_24.CmControl_Signal_input_31 = 0F;
    func_24.CmControl_Signal_input_32 = 100F;
    func_24.Execute( this, 12 );

    // [116] Macro call CmHigh_limit_pressure_control
    func_116.CmHigh_limit_pressure_control_input_9 = func_100.CmEnables_output_28;
    func_116.CmHigh_limit_pressure_control_input_27 = func_29.CmE_Filter_output_24;
    func_116.Execute( this, 19 );

    // [15] Macro call CmFanspeed_ramp_up
    func_15.CmFanspeed_ramp_up_input_1 = func_1.CmRelease_output_5;
    func_15.Execute( this, 27 );

    // [14] Macro call CmFlow_Balancing
    func_14.CmFlow_Balancing_input_50 = (float) getCmSPA_StatPressControl_input_34().getValue();
    func_14.CmFlow_Balancing_input_54 = (float) getCmSPA_StatPressControl_input_36().getValue();
    func_14.CmFlow_Balancing_input_73 = func_100.CmEnables_output_26;
    func_14.CmFlow_Balancing_input_79 = (float) getCmSPA_StatPressControl_input_39().getValue();
    func_14.Execute( this, 28 );

    // [8] Function call CfMinimum
    func_8.input[0] = func_24.CmControl_Signal_output_13;
    func_8.input[1] = func_116.CmHigh_limit_pressure_control_output_10;
    func_8.input[2] = func_15.CmFanspeed_ramp_up_output_3;
    func_8.input[3] = func_14.CmFlow_Balancing_output_65;
    func_8.Execute(  );

    // [3] Function call CfInputMultiplexer
    func_3.inputSelect = BooleanToInt(func_1.CmRelease_output_5);
    func_3.input[1-1] = 0F;
    func_3.input[2-1] = func_8.output;
    func_3.Execute(  );

    // [5] Function call CfIdt
    func_5.input = func_3.output;
    func_5.Execute(  );
    setCmSPA_StatPressControl_output_7(func_5.output[0]);

    // [108] Function call CfIdt
    func_108.input = func_3.output;
    func_108.Execute(  );
    setCmSPA_StatPressControl_parameter_63(func_108.output[0]);

    // [112] Function call CfIdt
    func_112.input = func_109.CmSetpoint_Ramp_output_20;
    func_112.Execute(  );
    setCmSPA_StatPressControl_parameter_64(func_112.output[0]);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    1F, 25F, 5F, 10F, 60F, 5F, 10F, 0F,
    0F, 10F, 10F, 2500F, 0F, 0F, 3F, 0F,
    1000F, 100F, 0F, 10000F, 1000F, 0F, 3F, 0F,
    1000F, 100F, 0F, 25F, 50000F, 1000F, 0F, 0F,
    0F, 3F, 0F, 1000F, 100F, 0F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// FanSpeedCtrl
  public static final Property CmSPA_StatPressControl_output_7 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSPA_StatPressControl_output_7() { return (BStatusNumeric) get(CmSPA_StatPressControl_output_7); }
  public void setCmSPA_StatPressControl_output_7(BStatusNumeric v) { set(CmSPA_StatPressControl_output_7,v,null); }
  public void setCmSPA_StatPressControl_output_7(float v) { getCmSPA_StatPressControl_output_7().setValue(v); }

  // macro parameter
// DSP-01: setpoint increase / decrease
  public static final Property CmSPA_StatPressControl_parameter_51 = newProperty( 0, BDouble.make( 2500 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(10000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("pascal"))));
  public double getCmSPA_StatPressControl_parameter_51() { return getDouble(CmSPA_StatPressControl_parameter_51); }
  public void setCmSPA_StatPressControl_parameter_51(double v) { setDouble(CmSPA_StatPressControl_parameter_51,v,null); }
// DSP-02: P-band static pressure control
  public static final Property CmSPA_StatPressControl_parameter_52 = newProperty( 0, BDouble.make( 1000 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("pascal"))));
  public double getCmSPA_StatPressControl_parameter_52() { return getDouble(CmSPA_StatPressControl_parameter_52); }
  public void setCmSPA_StatPressControl_parameter_52(double v) { setDouble(CmSPA_StatPressControl_parameter_52,v,null); }
// DSP-03: I-time static pressure control
  public static final Property CmSPA_StatPressControl_parameter_53 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSPA_StatPressControl_parameter_53() { return getDouble(CmSPA_StatPressControl_parameter_53); }
  public void setCmSPA_StatPressControl_parameter_53(double v) { setDouble(CmSPA_StatPressControl_parameter_53,v,null); }
// DSH-01: setpoint high limit static pressure control
  public static final Property CmSPA_StatPressControl_parameter_54 = newProperty( 0, BDouble.make( 10000 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("pascal"))));
  public double getCmSPA_StatPressControl_parameter_54() { return getDouble(CmSPA_StatPressControl_parameter_54); }
  public void setCmSPA_StatPressControl_parameter_54(double v) { setDouble(CmSPA_StatPressControl_parameter_54,v,null); }
// DSH-02: P-band high limit static pressure control
  public static final Property CmSPA_StatPressControl_parameter_55 = newProperty( 0, BDouble.make( 1000 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("pascal"))));
  public double getCmSPA_StatPressControl_parameter_55() { return getDouble(CmSPA_StatPressControl_parameter_55); }
  public void setCmSPA_StatPressControl_parameter_55(double v) { setDouble(CmSPA_StatPressControl_parameter_55,v,null); }
// DSH-03: I-time high limit static pressure control
  public static final Property CmSPA_StatPressControl_parameter_56 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSPA_StatPressControl_parameter_56() { return getDouble(CmSPA_StatPressControl_parameter_56); }
  public void setCmSPA_StatPressControl_parameter_56(double v) { setDouble(CmSPA_StatPressControl_parameter_56,v,null); }
// SAF-01: predefined flow during 100% recirc.
  public static final Property CmSPA_StatPressControl_parameter_57 = newProperty( 0, BDouble.make( 50000 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(300000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("cubic meters per hour"))));
  public double getCmSPA_StatPressControl_parameter_57() { return getDouble(CmSPA_StatPressControl_parameter_57); }
  public void setCmSPA_StatPressControl_parameter_57(double v) { setDouble(CmSPA_StatPressControl_parameter_57,v,null); }
// SAF-02: P-band flow balance control
  public static final Property CmSPA_StatPressControl_parameter_58 = newProperty( 0, BDouble.make( 1000 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("cubic meters per hour"))));
  public double getCmSPA_StatPressControl_parameter_58() { return getDouble(CmSPA_StatPressControl_parameter_58); }
  public void setCmSPA_StatPressControl_parameter_58(double v) { setDouble(CmSPA_StatPressControl_parameter_58,v,null); }
// SAF-03: I-time flow balance control
  public static final Property CmSPA_StatPressControl_parameter_59 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSPA_StatPressControl_parameter_59() { return getDouble(CmSPA_StatPressControl_parameter_59); }
  public void setCmSPA_StatPressControl_parameter_59(double v) { setDouble(CmSPA_StatPressControl_parameter_59,v,null); }
// FSC-01: output signal increase per min
  public static final Property CmSPA_StatPressControl_parameter_60 = newProperty( 0, BDouble.make( 25 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmSPA_StatPressControl_parameter_60() { return getDouble(CmSPA_StatPressControl_parameter_60); }
  public void setCmSPA_StatPressControl_parameter_60(double v) { setDouble(CmSPA_StatPressControl_parameter_60,v,null); }
// SYS-01: filter time; 0=disable
  public static final Property CmSPA_StatPressControl_parameter_61 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSPA_StatPressControl_parameter_61() { return getDouble(CmSPA_StatPressControl_parameter_61); }
  public void setCmSPA_StatPressControl_parameter_61(double v) { setDouble(CmSPA_StatPressControl_parameter_61,v,null); }
// DISP-01: status of FNE
  public static final Property CmSPA_StatPressControl_parameter_62 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSPA_StatPressControl_parameter_62() { return getDouble(CmSPA_StatPressControl_parameter_62); }
  public void setCmSPA_StatPressControl_parameter_62(double v) { setDouble(CmSPA_StatPressControl_parameter_62,v,null); }
// DISP-02: level of FSC
  public static final Property CmSPA_StatPressControl_parameter_63 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmSPA_StatPressControl_parameter_63() { return getDouble(CmSPA_StatPressControl_parameter_63); }
  public void setCmSPA_StatPressControl_parameter_63(double v) { setDouble(CmSPA_StatPressControl_parameter_63,v,null); }
// DISP-03: actual DSP_Sp
  public static final Property CmSPA_StatPressControl_parameter_64 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("pascal"))));
  public double getCmSPA_StatPressControl_parameter_64() { return getDouble(CmSPA_StatPressControl_parameter_64); }
  public void setCmSPA_StatPressControl_parameter_64(double v) { setDouble(CmSPA_StatPressControl_parameter_64,v,null); }

  // macro inputs
// PressSensor
  public static final Property CmSPA_StatPressControl_input_32 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmSPA_StatPressControl_input_32() { return (BStatusNumeric) get(CmSPA_StatPressControl_input_32); }
  public void setCmSPA_StatPressControl_input_32(BStatusNumeric v) { set(CmSPA_StatPressControl_input_32,v,null); }
  public void setCmSPA_StatPressControl_input_32(float v) { getCmSPA_StatPressControl_input_32().setValue(v); }
// DuctPressSp
  public static final Property CmSPA_StatPressControl_input_38 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmSPA_StatPressControl_input_38() { return (BStatusNumeric) get(CmSPA_StatPressControl_input_38); }
  public void setCmSPA_StatPressControl_input_38(BStatusNumeric v) { set(CmSPA_StatPressControl_input_38,v,null); }
  public void setCmSPA_StatPressControl_input_38(float v) { getCmSPA_StatPressControl_input_38().setValue(v); }
// FanEnableSig
  public static final Property CmSPA_StatPressControl_input_35 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmSPA_StatPressControl_input_35() { return (BStatusBoolean) get(CmSPA_StatPressControl_input_35); }
  public void setCmSPA_StatPressControl_input_35(BStatusBoolean v) { set(CmSPA_StatPressControl_input_35,v,null); }
  public void setCmSPA_StatPressControl_input_35(boolean v) { getCmSPA_StatPressControl_input_35().setValue(v); }
// DamperCtrlSig
  public static final Property CmSPA_StatPressControl_input_34 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmSPA_StatPressControl_input_34() { return (BStatusNumeric) get(CmSPA_StatPressControl_input_34); }
  public void setCmSPA_StatPressControl_input_34(BStatusNumeric v) { set(CmSPA_StatPressControl_input_34,v,null); }
  public void setCmSPA_StatPressControl_input_34(float v) { getCmSPA_StatPressControl_input_34().setValue(v); }
// HighLimPressSens
  public static final Property CmSPA_StatPressControl_input_33 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmSPA_StatPressControl_input_33() { return (BStatusNumeric) get(CmSPA_StatPressControl_input_33); }
  public void setCmSPA_StatPressControl_input_33(BStatusNumeric v) { set(CmSPA_StatPressControl_input_33,v,null); }
  public void setCmSPA_StatPressControl_input_33(float v) { getCmSPA_StatPressControl_input_33().setValue(v); }
// DispSupplyFlow
  public static final Property CmSPA_StatPressControl_input_39 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmSPA_StatPressControl_input_39() { return (BStatusNumeric) get(CmSPA_StatPressControl_input_39); }
  public void setCmSPA_StatPressControl_input_39(BStatusNumeric v) { set(CmSPA_StatPressControl_input_39,v,null); }
  public void setCmSPA_StatPressControl_input_39(float v) { getCmSPA_StatPressControl_input_39().setValue(v); }
// FireMode
  public static final Property CmSPA_StatPressControl_input_37 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmSPA_StatPressControl_input_37() { return (BStatusNumeric) get(CmSPA_StatPressControl_input_37); }
  public void setCmSPA_StatPressControl_input_37(BStatusNumeric v) { set(CmSPA_StatPressControl_input_37,v,null); }
  public void setCmSPA_StatPressControl_input_37(float v) { getCmSPA_StatPressControl_input_37().setValue(v); }
// PlantMode
  public static final Property CmSPA_StatPressControl_input_36 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmSPA_StatPressControl_input_36() { return (BStatusNumeric) get(CmSPA_StatPressControl_input_36); }
  public void setCmSPA_StatPressControl_input_36(BStatusNumeric v) { set(CmSPA_StatPressControl_input_36,v,null); }
  public void setCmSPA_StatPressControl_input_36(float v) { getCmSPA_StatPressControl_input_36().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.07 [48] 15.01.2019-09:54").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5800258799215313336").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmSPA_StatPressControl.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

  // class variables
  protected CmIDT20 func_122 = new CmIDT20();
  protected CfIdt func_105 = new CfIdt();
  protected CmCycleTime func_67 = new CmCycleTime();
  protected CmE_Filter func_28 = new CmE_Filter();
  protected CmE_Filter func_29 = new CmE_Filter();
  protected CmEnables func_100 = new CmEnables();
  protected CmRelease func_1 = new CmRelease();
  protected CmSetpoint_Ramp func_109 = new CmSetpoint_Ramp();
  protected CmControl_Signal func_24 = new CmControl_Signal();
  protected CmHigh_limit_pressure_control func_116 = new CmHigh_limit_pressure_control();
  protected CmFanspeed_ramp_up func_15 = new CmFanspeed_ramp_up();
  protected CmFlow_Balancing func_14 = new CmFlow_Balancing();
  protected CfMinimum func_8 = new CfMinimum();
  protected CfInputMultiplexer func_3 = new CfInputMultiplexer();
  protected CfIdt func_5 = new CfIdt();
  protected CfIdt func_108 = new CfIdt();
  protected CfIdt func_112 = new CfIdt();

  // default constructor
  public BCmSPA_StatPressControl()
  {
    func_8.configure(4);
  }

  public void Start()
  {
    func_122.Start();
    func_67.Start();
    func_28.Start();
    func_29.Start();
    func_100.Start();
    func_1.Start();
    func_109.Start();
    func_24.Start();
    func_116.Start();
    func_15.Start();
    func_14.Start();
  }
}
