/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    AHU Setpoint Ramp
Macro id:      5893328593247797766
Macro version: 17
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] FrostRecovery
  [2] SupplyTSP
Outputs:
  [1] SupplyTSP
Parameter:
  [1] START-02: supply air temperature setpoint raise
  [2] START-03: SAT control raised setpoint decrease time
Description:

================================================================================*/

public class CmAHU_Setpoint_Ramp
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [51] Function call CfMonoflop
    func_51.input = BooleanToFloat(CmAHU_Setpoint_Ramp_input_1);
    func_51.Execute( env, parameterOffset + 2 );

    // [22] Function call CfInputMultiplexer
    func_22.inputSelect = BooleanToInt(func_51.output);
    func_22.input[1-1] = 0F;
    func_22.input[2-1] = env.getParameter(parameterOffset);
    func_22.Execute(  );

    // [58] Function call CfMaximum
    func_58.input[0] = env.getParameter(parameterOffset + 1);
    func_58.input[1] = 1F;
    func_58.Execute(  );

    // [26] Function call CfDivide
    func_26.inputA = func_58.output;
    func_26.inputB = 60F;
    func_26.Execute(  );

    // [28] Function call CfDivide
    func_28.inputA = env.getParameter(parameterOffset);
    func_28.inputB = func_26.output;
    func_28.Execute(  );

    // [16] Function call CfValueRamp2
    func_16.inputValue = func_22.output;
    func_16.inputRisingSlope = -1F;
    func_16.inputFallingSlope = func_28.output;
    func_16.Execute( env );

    // [41] Function call CfCompare2
    func_41.inputA = env.getParameter(parameterOffset);
    func_41.inputB = 0F;
    func_41.Execute(  );

    // [43] Function call CfCompare2
    func_43.inputA = env.getParameter(parameterOffset + 1);
    func_43.inputB = 0F;
    func_43.Execute(  );

    // [54] Function call CfNot
    func_54.input = CmAHU_Setpoint_Ramp_input_1;
    func_54.Execute(  );

    // [46] Function call CfOr
    func_46.input[0] = func_41.outputEqualOrLess;
    func_46.input[1] = func_43.outputEqualOrLess;
    func_46.input[2] = func_54.output;
    func_46.Execute(  );

    // [31] Function call CfInputMultiplexer
    func_31.inputSelect = BooleanToInt(func_46.outputOR);
    func_31.input[1-1] = func_16.output;
    func_31.input[2-1] = 0F;
    func_31.Execute(  );

    // [49] Function call CfAddition
    func_49.input[0] = func_31.output;
    func_49.input[1] = CmAHU_Setpoint_Ramp_input_47;
    func_49.Execute(  );
    CmAHU_Setpoint_Ramp_output_48 = func_49.output;

  }
// macro register which are written multiple times
// macro inputs
public boolean CmAHU_Setpoint_Ramp_input_1; // FrostRecovery
public float CmAHU_Setpoint_Ramp_input_47; // SupplyTSP
// macro outputs
public float CmAHU_Setpoint_Ramp_output_48; // SupplyTSP
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfMonoflop func_51 = new CfMonoflop();
protected CfInputMultiplexer func_22 = new CfInputMultiplexer();
protected CfMaximum func_58 = new CfMaximum();
protected CfDivide func_26 = new CfDivide();
protected CfDivide func_28 = new CfDivide();
protected CfValueRamp2 func_16 = new CfValueRamp2();
protected CfCompare2 func_41 = new CfCompare2();
protected CfCompare2 func_43 = new CfCompare2();
protected CfNot func_54 = new CfNot();
protected CfOr func_46 = new CfOr();
protected CfInputMultiplexer func_31 = new CfInputMultiplexer();
protected CfAddition func_49 = new CfAddition();

// default constructor
public CmAHU_Setpoint_Ramp()
{
  func_46.configure(3);
}

  public void Start()
  {
    func_51.Start();
    func_16.Start();
  }
}
