/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    AHU Startup
Macro id:      5892940823607116260
Macro version: 24
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] FanEnable
  [2] PlantMode
  [3] FilteredOATemp
Outputs:
  [1] FrostRecovery
  [2] Release
  [3] FanRelease
Parameter:
  [1] START-01: limit OAT to start frost  protection
  [2] START-03: SAT control raised setpoint decrease time
Description:

================================================================================*/

public class CmAHU_Startup
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [69] Function call CfIdt
    func_69.input = env.getParameter(parameterOffset + 1);
    func_69.Execute(  );
    env.setParameter(parameterOffset + 2, func_69.output[0]);

    // [4] Function call CfNot
    func_4.input = ControlFunction.GetStartupFlag();
    func_4.Execute(  );

    // [18] Function call CfWindow
    func_18.inputValue = CmAHU_Startup_input_15;
    func_18.inputMinimum = 1F;
    func_18.inputMaximum = 6F;
    func_18.Execute(  );

    // [1] Function call CfAnd
    func_1.input[0] = func_4.output;
    func_1.input[1] = func_95.outputOR;
    func_1.Execute(  );
    CmAHU_Startup_output_34 = func_1.outputAND;

    // [77] Function call CfAnd
    func_77.input[0] = CmAHU_Startup_output_34;
    func_77.input[1] = CmAHU_Startup_input_14;
    func_77.Execute(  );
    CmAHU_Startup_output_79 = func_77.outputAND;

    // [21] Function call CfCompare1
    func_21.inputA = CmAHU_Startup_input_15;
    func_21.inputB = 20F;
    func_21.Execute(  );

    // [23] Function call CfLastValue
    func_23.input = BooleanToFloat(func_21.outputEqual);
    func_23.Execute(  );

    // [26] Function call CfNot
    func_26.input = FloatToBoolean(func_23.outputCurrent);
    func_26.Execute(  );

    // [28] Function call CfAnd
    func_28.input[0] = func_4.output;
    func_28.input[1] = func_95.outputOR;
    func_28.input[2] = func_26.output;
    func_28.input[3] = FloatToBoolean(func_23.outputLast);
    func_28.Execute(  );

    // [37] Function call CfLastValue
    func_37.input = BooleanToFloat(func_95.outputOR);
    func_37.Execute(  );

    // [38] Function call CfCompare1
    func_38.inputA = func_37.outputCurrent;
    func_38.inputB = func_37.outputLast;
    func_38.Execute(  );

    // [45] Function call CfCompare2
    func_45.inputA = CmAHU_Startup_input_16;
    func_45.inputB = env.getParameter(parameterOffset);
    func_45.Execute(  );

    // [42] Function call CfAnd
    func_42.input[0] = func_38.outputGreater;
    func_42.input[1] = func_95.outputOR;
    func_42.input[2] = func_45.outputEqualOrLess;
    func_42.Execute(  );

    // [49] Function call CfOr
    func_49.input[0] = func_28.outputAND;
    func_49.input[1] = func_42.outputAND;
    func_49.Execute(  );

    // [61] Function call CfOr
    func_61.input[0] = func_21.outputEqual;
    func_61.input[1] = func_58.outputDelayedA;
    func_61.input[2] = ControlFunction.GetStartupFlag();
    func_61.Execute(  );

    // [57] Function call CfJkFlipFlop
    func_57.inputSet = func_49.outputOR;
    func_57.inputClock = false;
    func_57.inputReset = func_61.outputOR;
    func_57.Execute(  );

    // [65] Function call CfIdt
    func_65.input = BooleanToFloat(func_57.output);
    func_65.Execute(  );
    CmAHU_Startup_output_35 = FloatToBoolean(func_65.output[0]);

    // [58] Function call CfDelay
    func_58.inputA = FloatToBoolean(func_65.output[1]);
    func_58.inputB = false;
    func_58.Execute( env, parameterOffset + 2 );

    // [95] Function call CfOr
    func_95.input[0] = func_18.output;
    func_95.input[1] = func_18.output;
    func_95.Execute(  );

    // [96] Function call CfCompare1
    func_96.inputA = CmAHU_Startup_input_15;
    func_96.inputB = 11F;
    func_96.Execute(  );

  }
// macro register which are written multiple times
// macro inputs
public boolean CmAHU_Startup_input_14; // FanEnable
public float CmAHU_Startup_input_15; // PlantMode
public float CmAHU_Startup_input_16; // FilteredOATemp
// macro outputs
public boolean CmAHU_Startup_output_35; // FrostRecovery
public boolean CmAHU_Startup_output_34; // Release
public boolean CmAHU_Startup_output_79; // FanRelease
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfIdt func_69 = new CfIdt();
protected CfNot func_4 = new CfNot();
protected CfWindow func_18 = new CfWindow();
protected CfAnd func_1 = new CfAnd();
protected CfAnd func_77 = new CfAnd();
protected CfCompare1 func_21 = new CfCompare1();
protected CfLastValue func_23 = new CfLastValue();
protected CfNot func_26 = new CfNot();
protected CfAnd func_28 = new CfAnd();
protected CfLastValue func_37 = new CfLastValue();
protected CfCompare1 func_38 = new CfCompare1();
protected CfCompare2 func_45 = new CfCompare2();
protected CfAnd func_42 = new CfAnd();
protected CfOr func_49 = new CfOr();
protected CfOr func_61 = new CfOr();
protected CfJkFlipFlop func_57 = new CfJkFlipFlop();
protected CfIdt func_65 = new CfIdt();
protected CfDelay func_58 = new CfDelay();
protected CfOr func_95 = new CfOr();
protected CfCompare1 func_96 = new CfCompare1();

// default constructor
public CmAHU_Startup()
{
  func_28.configure(4);
  func_42.configure(3);
  func_61.configure(3);
  func_65.configure(2);
}

  public void Start()
  {
    func_23.Start();
    func_37.Start();
    func_57.Start();
    func_58.Start();
  }
}
