/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Analog Sequence
Macro id:      5925668596065764051
Macro version: 59
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] Stages
  [2] ControlIn
  [3] Release
Outputs:
  [1] ControlSignal
  [2] Stages
  [3] Hysteresis
  [4] CtrlInStage
Parameter:
  [1] SYS-01: Total number of digital stages
  [2] SYS-02: Enable analog output
  [3] SYS-03: Stage differential
  [4] DISP-01: Total number of stages
Description:

================================================================================*/

public class CmAnalog_Sequence
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [123] Function call CfCompare1
    func_123.inputA = env.getParameter(parameterOffset + 1);
    func_123.inputB = 1F;
    func_123.Execute(  );

    // [121] Function call CfAddition
    func_121.input[0] = env.getParameter(parameterOffset);
    func_121.input[1] = BooleanToFloat(func_123.outputEqual);
    func_121.Execute(  );
    env.setParameter(parameterOffset + 3, func_121.output);

    // [91] Function call CfDivide
    func_91.inputA = 100F;
    func_91.inputB = env.getParameter(parameterOffset + 3);
    func_91.Execute(  );

    // [198] Function call CfSubtract
    func_198.input[0] = env.getParameter(parameterOffset + 3);
    func_198.input[1] = 1F;
    func_198.Execute(  );

    // [199] Function call CfMultiply
    func_199.input[0] = func_91.output;
    func_199.input[1] = func_198.output;
    func_199.Execute(  );

    // [153] Function call CfMultiply
    func_153.input[0] = func_91.output;
    func_153.input[1] = env.getParameter(parameterOffset + 2);
    func_153.Execute(  );

    // [151] Function call CfDivide
    func_151.inputA = func_153.output;
    func_151.inputB = 100F;
    func_151.Execute(  );

    // [176] Function call CfSubtract
    func_176.input[0] = func_91.output;
    func_176.input[1] = func_151.output;
    func_176.Execute(  );
    CmAnalog_Sequence_output_175 = func_176.output;

    // [155] Function call CfAddition
    func_155.input[0] = func_91.output;
    func_155.input[1] = CmAnalog_Sequence_output_175;
    func_155.Execute(  );

    // [93] Function call CfDivide
    func_93.inputA = CmAnalog_Sequence_input_84;
    func_93.inputB = func_155.output;
    func_93.Execute(  );

    // [97] Function call CfAddition
    func_97.input[0] = func_93.output;
    func_97.input[1] = 1F;
    func_97.Execute(  );

    // [100] Function call CfCompare2
    func_100.inputA = CmAnalog_Sequence_input_84;
    func_100.inputB = 0F;
    func_100.Execute(  );

    // [99] Function call CfMinimum
    func_99.input[0] = func_97.output;
    func_99.input[1] = env.getParameter(parameterOffset + 3);
    func_99.Execute(  );

    // [103] Function call CfInputMultiplexer
    func_103.inputSelect = BooleanToInt(func_100.outputEqualOrLess);
    func_103.input[1-1] = func_99.output;
    func_103.input[2-1] = 0F;
    func_103.Execute(  );

    // [95] Function call CfTruncate
    func_95.input = func_103.output;
    func_95.Execute(  );
    CmAnalog_Sequence_output_139 = func_95.output;

    // [185] Function call CfSubtract
    func_185.input[0] = CmAnalog_Sequence_input_162;
    func_185.input[1] = 1F;
    func_185.Execute(  );

    // [159] Function call CfAddition
    func_159.input[0] = CmAnalog_Sequence_input_162;
    func_159.input[1] = 1F;
    func_159.Execute(  );

    // [107] Function call CfMultiply
    func_107.input[0] = func_91.output;
    func_107.input[1] = CmAnalog_Sequence_input_162;
    func_107.Execute(  );

    // [111] Function call CfMultiply
    func_111.input[0] = func_159.output;
    func_111.input[1] = func_91.output;
    func_111.Execute(  );

    // [195] Function call CfMinimum
    func_195.input[0] = func_199.output;
    func_195.input[1] = func_107.output;
    func_195.Execute(  );

    // [197] Function call CfMinimum
    func_197.input[0] = 100F;
    func_197.input[1] = func_111.output;
    func_197.Execute(  );

    // [109] Function call CfLinearConverter
    func_109.inputValue = CmAnalog_Sequence_input_84;
    func_109.inputInLimit1 = func_195.output;
    func_109.inputInLimit2 = func_197.output;
    func_109.inputOutLimit1 = 0F;
    func_109.inputOutLimit2 = 100F;
    func_109.Execute(  );

    // [180] Function call CfSubtract
    func_180.input[0] = CmAnalog_Sequence_input_84;
    func_180.input[1] = func_107.output;
    func_180.Execute(  );
    CmAnalog_Sequence_output_182 = func_180.output;

    // [215] Function call CfInputMultiplexer
    func_215.inputSelect = BooleanToInt(CmAnalog_Sequence_input_213);
    func_215.input[1-1] = 0F;
    func_215.input[2-1] = func_109.output;
    func_215.Execute(  );
    CmAnalog_Sequence_output_89 = func_215.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmAnalog_Sequence_input_162; // Stages
public float CmAnalog_Sequence_input_84; // ControlIn
public boolean CmAnalog_Sequence_input_213; // Release
// macro outputs
public float CmAnalog_Sequence_output_89; // ControlSignal
public float CmAnalog_Sequence_output_139; // Stages
public float CmAnalog_Sequence_output_175; // Hysteresis
public float CmAnalog_Sequence_output_182; // CtrlInStage
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfCompare1 func_123 = new CfCompare1();
protected CfAddition func_121 = new CfAddition();
protected CfDivide func_91 = new CfDivide();
protected CfSubtract func_198 = new CfSubtract();
protected CfMultiply func_199 = new CfMultiply();
protected CfMultiply func_153 = new CfMultiply();
protected CfDivide func_151 = new CfDivide();
protected CfSubtract func_176 = new CfSubtract();
protected CfAddition func_155 = new CfAddition();
protected CfDivide func_93 = new CfDivide();
protected CfAddition func_97 = new CfAddition();
protected CfCompare2 func_100 = new CfCompare2();
protected CfMinimum func_99 = new CfMinimum();
protected CfInputMultiplexer func_103 = new CfInputMultiplexer();
protected CfTruncate func_95 = new CfTruncate();
protected CfSubtract func_185 = new CfSubtract();
protected CfAddition func_159 = new CfAddition();
protected CfMultiply func_107 = new CfMultiply();
protected CfMultiply func_111 = new CfMultiply();
protected CfMinimum func_195 = new CfMinimum();
protected CfMinimum func_197 = new CfMinimum();
protected CfLinearConverter func_109 = new CfLinearConverter();
protected CfSubtract func_180 = new CfSubtract();
protected CfInputMultiplexer func_215 = new CfInputMultiplexer();

// default constructor
public CmAnalog_Sequence()
{
}

  public void Start()
  {
  }
}
