/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    CO2 Control
Macro id:      5892943729619108226
Macro version: 21
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] FanSpeed
  [2] DmpControl
  [3] CO2_Sensor
Outputs:
  [1] FanSpeed
  [2] DmpControl
Parameter:
  [1] CO2-01: air quality setpoint
  [2] CO2-02: air quality P-band
  [3] CO2-03: sequence start point air quality override dampers
  [4] CO2-04: sequence end point air quality override dampers
  [5] CO2-05: sequence start point air quality override fan speed
  [6] CO2-06: sequence end point air quality override fan speed
Description:

================================================================================*/

public class CmCO2_Control
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [27] Macro call CmIDT05
    func_27.CmIDT05_input_1 = 0F;
    func_27.CmIDT05_input_2 = env.getParameter(parameterOffset + 1);
    func_27.CmIDT05_input_3 = 100F;
    func_27.CmIDT05_input_4 = 0F;
    func_27.CmIDT05_input_5 = 0F;
    func_27.Execute(  );
    env.setParameter(parameterOffset + 10, func_27.CmIDT05_output_21);
    env.setParameter(parameterOffset + 6, func_27.CmIDT05_output_22);
    env.setParameter(parameterOffset + 9, func_27.CmIDT05_output_23);
    env.setParameter(parameterOffset + 8, func_27.CmIDT05_output_24);
    env.setParameter(parameterOffset + 7, func_27.CmIDT05_output_25);

    // [22] Function call CfDivide
    func_22.inputA = env.getParameter(parameterOffset + 1);
    func_22.inputB = 2F;
    func_22.Execute(  );

    // [21] Function call CfSubtract
    func_21.input[0] = env.getParameter(parameterOffset);
    func_21.input[1] = func_22.output;
    func_21.Execute(  );

    // [25] Function call CfMaximum
    func_25.input[0] = func_21.output;
    func_25.input[1] = 0F;
    func_25.Execute(  );

    // [8] Function call CfPidPlus
    func_8.inputX = func_25.output;
    func_8.inputW = CmCO2_Control_input_7;
    func_8.inputIntegralOn = false;
    func_8.Execute( env, parameterOffset + 6 );

    // [20] Function call CfCompare2
    func_20.inputA = env.getParameter(parameterOffset);
    func_20.inputB = 0F;
    func_20.Execute(  );

    // [43] Function call CfCompare2
    func_43.inputA = CmCO2_Control_input_7;
    func_43.inputB = 0F;
    func_43.Execute(  );

    // [42] Function call CfOr
    func_42.input[0] = func_20.outputEqualOrLess;
    func_42.input[1] = func_43.outputEqualOrLess;
    func_42.Execute(  );

    // [12] Function call CfLinearConverter
    func_12.inputValue = func_8.output;
    func_12.inputInLimit1 = env.getParameter(parameterOffset + 4);
    func_12.inputInLimit2 = env.getParameter(parameterOffset + 5);
    func_12.inputOutLimit1 = 0F;
    func_12.inputOutLimit2 = 100F;
    func_12.Execute(  );

    // [50] Function call CfLinearConverter
    func_50.inputValue = func_8.output;
    func_50.inputInLimit1 = env.getParameter(parameterOffset + 2);
    func_50.inputInLimit2 = env.getParameter(parameterOffset + 3);
    func_50.inputOutLimit1 = 0F;
    func_50.inputOutLimit2 = 100F;
    func_50.Execute(  );

    // [14] Function call CfInputMultiplexer
    func_14.inputSelect = BooleanToInt(func_42.outputOR);
    func_14.input[1-1] = func_12.output;
    func_14.input[2-1] = 0F;
    func_14.Execute(  );

    // [46] Function call CfInputMultiplexer
    func_46.inputSelect = BooleanToInt(func_42.outputOR);
    func_46.input[1-1] = func_50.output;
    func_46.input[2-1] = 0F;
    func_46.Execute(  );

    // [72] Function call CfMaximum
    func_72.input[0] = env.getParameter(parameterOffset + 4);
    func_72.input[1] = env.getParameter(parameterOffset + 5);
    func_72.Execute(  );

    // [75] Function call CfMaximum
    func_75.input[0] = env.getParameter(parameterOffset + 2);
    func_75.input[1] = env.getParameter(parameterOffset + 3);
    func_75.Execute(  );

    // [70] Function call CfInputMultiplexer
    func_70.inputSelect = FloatToInt(func_72.output);
    func_70.input[1-1] = 0F;
    func_70.input[2-1] = func_14.output;
    func_70.Execute(  );

    // [71] Function call CfInputMultiplexer
    func_71.inputSelect = FloatToInt(func_75.output);
    func_71.input[1-1] = 0F;
    func_71.input[2-1] = func_46.output;
    func_71.Execute(  );

    // [10] Function call CfMaximum
    func_10.input[0] = CmCO2_Control_input_1;
    func_10.input[1] = func_70.output;
    func_10.Execute(  );
    CmCO2_Control_output_2 = func_10.output;

    // [45] Function call CfMaximum
    func_45.input[0] = CmCO2_Control_input_51;
    func_45.input[1] = func_71.output;
    func_45.Execute(  );
    CmCO2_Control_output_52 = func_45.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmCO2_Control_input_1; // FanSpeed
public float CmCO2_Control_input_51; // DmpControl
public float CmCO2_Control_input_7; // CO2_Sensor
// macro outputs
public float CmCO2_Control_output_2; // FanSpeed
public float CmCO2_Control_output_52; // DmpControl
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }

// class variables
protected CmIDT05 func_27 = new CmIDT05();
protected CfDivide func_22 = new CfDivide();
protected CfSubtract func_21 = new CfSubtract();
protected CfMaximum func_25 = new CfMaximum();
protected CfPidPlus func_8 = new CfPidPlus();
protected CfCompare2 func_20 = new CfCompare2();
protected CfCompare2 func_43 = new CfCompare2();
protected CfOr func_42 = new CfOr();
protected CfLinearConverter func_12 = new CfLinearConverter();
protected CfLinearConverter func_50 = new CfLinearConverter();
protected CfInputMultiplexer func_14 = new CfInputMultiplexer();
protected CfInputMultiplexer func_46 = new CfInputMultiplexer();
protected CfMaximum func_72 = new CfMaximum();
protected CfMaximum func_75 = new CfMaximum();
protected CfInputMultiplexer func_70 = new CfInputMultiplexer();
protected CfInputMultiplexer func_71 = new CfInputMultiplexer();
protected CfMaximum func_10 = new CfMaximum();
protected CfMaximum func_45 = new CfMaximum();

// default constructor
public CmCO2_Control()
{
}

  public void Start()
  {
    func_27.Start();
    func_8.Start();
  }
}
