/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Cascaded Control
Macro id:      5897107835505869783
Macro version: 30
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] RoomAirTempSP
  [2] ContrPtAdj
  [3] RoomRetAirTemp
  [4] FilteredOATemp
  [5] Ienable
  [6] MinSAT_SpShift
Outputs:
  [1] SupplyTSP
  [2] CalcRoomTmpSP
Parameter:
  [1] WCS-01: start point OAT winter comp. SAT
  [2] WCS-02: end  point OAT winter comp. SAT
  [3] WCS-03: supply air temperature setpoint  raise
  [4] SAT-01: supply air temperature low setpoint
  [5] SAT-02: supply air temperature high setpoint
  [6] RMT-01: room temperature control P-band
  [7] RMT-02: room temperature control I-time
  [8] RMT-03: span for SAT-setpoint shift
Description:

================================================================================*/

public class CmCascaded_Control
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [48] Macro call CmIDT05
    func_48.CmIDT05_input_1 = env.getParameter(parameterOffset + 5);
    func_48.CmIDT05_input_2 = env.getParameter(parameterOffset + 6);
    func_48.CmIDT05_input_3 = 0F;
    func_48.CmIDT05_input_4 = 0F;
    func_48.CmIDT05_input_5 = 100F;
    func_48.Execute(  );
    env.setParameter(parameterOffset + 8, func_48.CmIDT05_output_21);
    env.setParameter(parameterOffset + 10, func_48.CmIDT05_output_22);
    env.setParameter(parameterOffset + 9, func_48.CmIDT05_output_23);
    env.setParameter(parameterOffset + 12, func_48.CmIDT05_output_24);
    env.setParameter(parameterOffset + 11, func_48.CmIDT05_output_25);

    // [58] Macro call CmIDT05
    func_58.CmIDT05_input_1 = env.getParameter(parameterOffset);
    func_58.CmIDT05_input_2 = env.getParameter(parameterOffset + 1);
    func_58.CmIDT05_input_3 = env.getParameter(parameterOffset + 2);
    func_58.CmIDT05_input_4 = 0F;
    func_58.CmIDT05_input_5 = 0F;
    func_58.Execute(  );
    env.setParameter(parameterOffset + 13, func_58.CmIDT05_output_21);
    env.setParameter(parameterOffset + 14, func_58.CmIDT05_output_22);
    env.setParameter(parameterOffset + 15, func_58.CmIDT05_output_23);

    // [5] Function call CfCompare1
    func_5.inputA = CmCascaded_Control_input_1;
    func_5.inputB = 999F;
    func_5.Execute(  );

    // [11] Function call CfAddition
    func_11.input[0] = CmCascaded_Control_input_4;
    func_11.input[1] = CmCascaded_Control_input_1;
    func_11.Execute(  );

    // [6] Function call CfInputMultiplexer
    func_6.inputSelect = BooleanToInt(func_5.outputLess);
    func_6.input[1-1] = 999F;
    func_6.input[2-1] = func_11.output;
    func_6.Execute(  );

    // [17] Function call CfPidPlus
    func_17.inputX = CmCascaded_Control_input_13;
    func_17.inputW = func_6.output;
    func_17.inputIntegralOn = CmCascaded_Control_input_18;
    func_17.Execute( env, parameterOffset + 8 );

    // [33] Function call CfSubtract
    func_33.input[0] = 100F;
    func_33.input[1] = env.getParameter(parameterOffset + 7);
    func_33.Execute(  );

    // [34] Function call CfDivide
    func_34.inputA = func_33.output;
    func_34.inputB = 2F;
    func_34.Execute(  );

    // [37] Function call CfSubtract
    func_37.input[0] = 100F;
    func_37.input[1] = func_34.output;
    func_37.Execute(  );

    // [61] Function call CfSubtract
    func_61.input[0] = env.getParameter(parameterOffset + 3);
    func_61.input[1] = CmCascaded_Control_input_60;
    func_61.Execute(  );

    // [31] Function call CfLinearConverter
    func_31.inputValue = func_17.output;
    func_31.inputInLimit1 = func_34.output;
    func_31.inputInLimit2 = func_37.output;
    func_31.inputOutLimit1 = func_61.output;
    func_31.inputOutLimit2 = env.getParameter(parameterOffset + 4);
    func_31.Execute(  );

    // [15] Function call CfInputMultiplexer
    func_15.inputSelect = BooleanToInt(func_5.outputLess);
    func_15.input[1-1] = 0F;
    func_15.input[2-1] = func_31.output;
    func_15.Execute(  );

    // [20] Macro call CmWinter_Compensation
    func_20.CmWinter_Compensation_input_4 = func_15.output;
    func_20.CmWinter_Compensation_input_5 = CmCascaded_Control_input_23;
    func_20.Execute( env, parameterOffset +13 );
    CmCascaded_Control_output_3 = func_20.CmWinter_Compensation_output_6;

    // [54] Function call CfIdt
    func_54.input = func_6.output;
    func_54.Execute(  );
    CmCascaded_Control_output_56 = func_54.output[0];

  }
// macro register which are written multiple times
// macro inputs
public float CmCascaded_Control_input_1; // RoomAirTempSP
public float CmCascaded_Control_input_4; // ContrPtAdj
public float CmCascaded_Control_input_13; // RoomRetAirTemp
public float CmCascaded_Control_input_23; // FilteredOATemp
public boolean CmCascaded_Control_input_18; // Ienable
public float CmCascaded_Control_input_60; // MinSAT_SpShift
// macro outputs
public float CmCascaded_Control_output_3; // SupplyTSP
public float CmCascaded_Control_output_56; // CalcRoomTmpSP
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CmIDT05 func_48 = new CmIDT05();
protected CmIDT05 func_58 = new CmIDT05();
protected CfCompare1 func_5 = new CfCompare1();
protected CfAddition func_11 = new CfAddition();
protected CfInputMultiplexer func_6 = new CfInputMultiplexer();
protected CfPidPlus func_17 = new CfPidPlus();
protected CfSubtract func_33 = new CfSubtract();
protected CfDivide func_34 = new CfDivide();
protected CfSubtract func_37 = new CfSubtract();
protected CfSubtract func_61 = new CfSubtract();
protected CfLinearConverter func_31 = new CfLinearConverter();
protected CfInputMultiplexer func_15 = new CfInputMultiplexer();
protected CmWinter_Compensation func_20 = new CmWinter_Compensation();
protected CfIdt func_54 = new CfIdt();

// default constructor
public CmCascaded_Control()
{
}

  public void Start()
  {
    func_48.Start();
    func_58.Start();
    func_17.Start();
    func_20.Start();
  }
}
