/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Cascaded Control Comf
Macro id:      5903378029796655436
Macro version: 39
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] RoomAirTempSP
  [2] ContrPtAdj
  [3] RoomRetAirTemp
  [4] FilteredOATemp
  [5] Ienable
  [6] MinSAT_SpShift
Outputs:
  [1] SupplyTSPCool
  [2] CalcRoomTmpSP
  [3] SupplyTSPHeat
Parameter:
  [1] WCS-01: start point OAT winter comp. SAT
  [2] WCS-02: end  point OAT winter comp. SAT
  [3] WCS-03: supply air temperature setpoint  raise
  [4] SAT-01: supply air temperature low setpoint
  [5] SAT-02: supply air temperature high setpoint
  [6] RMT-01: room temperature control P-band
  [7] RMT-02: room temperature control I-time
  [8] RMT-03: span for SAT-setpoint shift
  [9] RMT-05: room temperature comfort zone
Description:

================================================================================*/

public class CmCascaded_Control_Comf
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [80] Macro call CmIDT20
    func_80.CmIDT20_input_1 = env.getParameter(parameterOffset);
    func_80.CmIDT20_input_2 = env.getParameter(parameterOffset + 1);
    func_80.CmIDT20_input_3 = env.getParameter(parameterOffset + 2);
    func_80.CmIDT20_input_4 = env.getParameter(parameterOffset);
    func_80.CmIDT20_input_5 = env.getParameter(parameterOffset + 1);
    func_80.CmIDT20_input_6 = env.getParameter(parameterOffset + 2);
    func_80.CmIDT20_input_7 = 0F;
    func_80.CmIDT20_input_8 = env.getParameter(parameterOffset + 6);
    func_80.CmIDT20_input_9 = 100F;
    func_80.CmIDT20_input_10 = 0F;
    func_80.CmIDT20_input_11 = env.getParameter(parameterOffset + 5);
    func_80.CmIDT20_input_12 = 0F;
    func_80.CmIDT20_input_13 = env.getParameter(parameterOffset + 6);
    func_80.CmIDT20_input_14 = 100F;
    func_80.CmIDT20_input_15 = 0F;
    func_80.CmIDT20_input_16 = env.getParameter(parameterOffset + 5);
    func_80.CmIDT20_input_17 = 0F;
    func_80.CmIDT20_input_18 = 0F;
    func_80.CmIDT20_input_19 = 0F;
    func_80.CmIDT20_input_20 = 0F;
    func_80.Execute(  );
    env.setParameter(parameterOffset + 9, func_80.CmIDT20_output_21);
    env.setParameter(parameterOffset + 10, func_80.CmIDT20_output_22);
    env.setParameter(parameterOffset + 11, func_80.CmIDT20_output_23);
    env.setParameter(parameterOffset + 12, func_80.CmIDT20_output_24);
    env.setParameter(parameterOffset + 13, func_80.CmIDT20_output_25);
    env.setParameter(parameterOffset + 14, func_80.CmIDT20_output_26);

    // [5] Function call CfCompare1
    func_5.inputA = CmCascaded_Control_Comf_input_1;
    func_5.inputB = 999F;
    func_5.Execute(  );

    // [11] Function call CfAddition
    func_11.input[0] = CmCascaded_Control_Comf_input_4;
    func_11.input[1] = CmCascaded_Control_Comf_input_1;
    func_11.Execute(  );

    // [6] Function call CfInputMultiplexer
    func_6.inputSelect = BooleanToInt(func_5.outputLess);
    func_6.input[1-1] = 999F;
    func_6.input[2-1] = func_11.output;
    func_6.Execute(  );

    // [54] Function call CfIdt
    func_54.input = func_6.output;
    func_54.Execute(  );
    CmCascaded_Control_Comf_output_56 = func_54.output[0];

    // [66] Function call CfAddition
    func_66.input[0] = func_6.output;
    func_66.input[1] = func_64.output;
    func_66.Execute(  );

    // [64] Function call CfDivide
    func_64.inputA = env.getParameter(parameterOffset + 8);
    func_64.inputB = 2F;
    func_64.Execute(  );

    // [68] Function call CfSubtract
    func_68.input[0] = func_6.output;
    func_68.input[1] = func_64.output;
    func_68.Execute(  );

    // [34] Function call CfDivide
    func_34.inputA = env.getParameter(parameterOffset + 5);
    func_34.inputB = 2F;
    func_34.Execute(  );

    // [110] Function call CfDivide
    func_110.inputA = env.getParameter(parameterOffset + 7);
    func_110.inputB = 100F;
    func_110.Execute(  );

    // [113] Function call CfMultiply
    func_113.input[0] = func_34.output;
    func_113.input[1] = func_110.output;
    func_113.Execute(  );

    // [134] Function call CfSubtract
    func_134.input[0] = env.getParameter(parameterOffset + 3);
    func_134.input[1] = CmCascaded_Control_Comf_input_136;
    func_134.Execute(  );

    // [101] Function call CfSubtract
    func_101.input[0] = CmCascaded_Control_Comf_input_13;
    func_101.input[1] = func_66.output;
    func_101.Execute(  );

    // [103] Function call CfSubtract
    func_103.input[0] = func_68.output;
    func_103.input[1] = CmCascaded_Control_Comf_input_13;
    func_103.Execute(  );

    // [106] Function call CfLinearConverter
    func_106.inputValue = func_101.output;
    func_106.inputInLimit1 = 0F;
    func_106.inputInLimit2 = func_113.output;
    func_106.inputOutLimit1 = env.getParameter(parameterOffset + 4);
    func_106.inputOutLimit2 = func_134.output;
    func_106.Execute(  );

    // [107] Function call CfLinearConverter
    func_107.inputValue = func_103.output;
    func_107.inputInLimit1 = 0F;
    func_107.inputInLimit2 = func_113.output;
    func_107.inputOutLimit1 = func_134.output;
    func_107.inputOutLimit2 = env.getParameter(parameterOffset + 4);
    func_107.Execute(  );

    // [15] Function call CfInputMultiplexer
    func_15.inputSelect = BooleanToInt(func_5.outputLess);
    func_15.input[1-1] = 0F;
    func_15.input[2-1] = func_106.output;
    func_15.Execute(  );

    // [72] Function call CfInputMultiplexer
    func_72.inputSelect = BooleanToInt(func_5.outputLess);
    func_72.input[1-1] = 0F;
    func_72.input[2-1] = func_107.output;
    func_72.Execute(  );

    // [20] Macro call CmWinter_Compensation
    func_20.CmWinter_Compensation_input_4 = func_15.output;
    func_20.CmWinter_Compensation_input_5 = CmCascaded_Control_Comf_input_23;
    func_20.Execute( env, parameterOffset +9 );
    CmCascaded_Control_Comf_output_3 = func_20.CmWinter_Compensation_output_6;

    // [77] Macro call CmWinter_Compensation
    func_77.CmWinter_Compensation_input_4 = func_72.output;
    func_77.CmWinter_Compensation_input_5 = CmCascaded_Control_Comf_input_23;
    func_77.Execute( env, parameterOffset +12 );
    CmCascaded_Control_Comf_output_78 = func_77.CmWinter_Compensation_output_6;

  }
// macro register which are written multiple times
// macro inputs
public float CmCascaded_Control_Comf_input_1; // RoomAirTempSP
public float CmCascaded_Control_Comf_input_4; // ContrPtAdj
public float CmCascaded_Control_Comf_input_13; // RoomRetAirTemp
public float CmCascaded_Control_Comf_input_23; // FilteredOATemp
public boolean CmCascaded_Control_Comf_input_18; // Ienable(not used)
public float CmCascaded_Control_Comf_input_136; // MinSAT_SpShift
// macro outputs
public float CmCascaded_Control_Comf_output_3; // SupplyTSPCool
public float CmCascaded_Control_Comf_output_56; // CalcRoomTmpSP
public float CmCascaded_Control_Comf_output_78; // SupplyTSPHeat
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CmIDT20 func_80 = new CmIDT20();
protected CfCompare1 func_5 = new CfCompare1();
protected CfAddition func_11 = new CfAddition();
protected CfInputMultiplexer func_6 = new CfInputMultiplexer();
protected CfIdt func_54 = new CfIdt();
protected CfAddition func_66 = new CfAddition();
protected CfDivide func_64 = new CfDivide();
protected CfSubtract func_68 = new CfSubtract();
protected CfDivide func_34 = new CfDivide();
protected CfDivide func_110 = new CfDivide();
protected CfMultiply func_113 = new CfMultiply();
protected CfSubtract func_134 = new CfSubtract();
protected CfSubtract func_101 = new CfSubtract();
protected CfSubtract func_103 = new CfSubtract();
protected CfLinearConverter func_106 = new CfLinearConverter();
protected CfLinearConverter func_107 = new CfLinearConverter();
protected CfInputMultiplexer func_15 = new CfInputMultiplexer();
protected CfInputMultiplexer func_72 = new CfInputMultiplexer();
protected CmWinter_Compensation func_20 = new CmWinter_Compensation();
protected CmWinter_Compensation func_77 = new CmWinter_Compensation();

// default constructor
public CmCascaded_Control_Comf()
{
}

  public void Start()
  {
    func_80.Start();
    func_20.Start();
    func_77.Start();
  }
}
