/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Cntr with Comfortzone
Macro id:      5852165667945448002
Macro version: 30
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] comfort zone between humidify / dehumidify
  [2] P-band humidification control
  [3] P-band dehumidification control
  [4] Return air humidity
  [5] Setpoint
Outputs:
  [1] DISP: calculated setpoint humidification
  [2] DISP: calculated setpoint dehumidification
  [3] humidity control signal
  [4] dehumidity control signsl
Parameter:
Description:

================================================================================*/

public class CmCntr_with_Comfortzone
{
  void Execute( )

  {
    // [21] Function call CfDivide
    func_21.inputA = CmCntr_with_Comfortzone_input_80;
    func_21.inputB = 2F;
    func_21.Execute(  );

    // [24] Function call CfMaximum
    func_24.input[0] = CmCntr_with_Comfortzone_input_81;
    func_24.input[1] = 1F;
    func_24.Execute(  );

    // [25] Function call CfMaximum
    func_25.input[0] = 1F;
    func_25.input[1] = CmCntr_with_Comfortzone_input_82;
    func_25.Execute(  );

    // [22] Function call CfSubtract
    func_22.input[0] = CmCntr_with_Comfortzone_input_84;
    func_22.input[1] = func_21.output;
    func_22.Execute(  );

    // [23] Function call CfAddition
    func_23.input[0] = CmCntr_with_Comfortzone_input_84;
    func_23.input[1] = func_21.output;
    func_23.Execute(  );

    // [29] Function call CfDivide
    func_29.inputA = 100F;
    func_29.inputB = func_24.output;
    func_29.Execute(  );

    // [31] Function call CfDivide
    func_31.inputA = 100F;
    func_31.inputB = func_25.output;
    func_31.Execute(  );

    // [26] Function call CfIdt
    func_26.input = func_22.output;
    func_26.Execute(  );
    CmCntr_with_Comfortzone_output_86 = func_26.output[0];

    // [27] Function call CfIdt
    func_27.input = func_23.output;
    func_27.Execute(  );
    CmCntr_with_Comfortzone_output_87 = func_27.output[0];

    // [28] Function call CfSubtract
    func_28.input[0] = func_22.output;
    func_28.input[1] = CmCntr_with_Comfortzone_input_83;
    func_28.Execute(  );

    // [30] Function call CfSubtract
    func_30.input[0] = CmCntr_with_Comfortzone_input_83;
    func_30.input[1] = func_23.output;
    func_30.Execute(  );

    // [32] Function call CfMultiply
    func_32.input[0] = func_28.output;
    func_32.input[1] = func_29.output;
    func_32.Execute(  );

    // [33] Function call CfMultiply
    func_33.input[0] = func_30.output;
    func_33.input[1] = func_31.output;
    func_33.Execute(  );

    // [34] Function call CfAddition
    func_34.input[0] = func_32.output;
    func_34.input[1] = 0F;
    func_34.Execute(  );

    // [35] Function call CfAddition
    func_35.input[0] = 0F;
    func_35.input[1] = func_33.output;
    func_35.Execute(  );

    // [36] Function call CfMaximum
    func_36.input[0] = func_34.output;
    func_36.input[1] = 0F;
    func_36.Execute(  );

    // [37] Function call CfMaximum
    func_37.input[0] = 0F;
    func_37.input[1] = func_35.output;
    func_37.Execute(  );

    // [38] Function call CfMinimum
    func_38.input[0] = func_36.output;
    func_38.input[1] = 100F;
    func_38.Execute(  );
    CmCntr_with_Comfortzone_output_89 = func_38.output;

    // [39] Function call CfMinimum
    func_39.input[0] = 100F;
    func_39.input[1] = func_37.output;
    func_39.Execute(  );
    CmCntr_with_Comfortzone_output_90 = func_39.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmCntr_with_Comfortzone_input_80; // comfort zone between humidify / dehumidify
public float CmCntr_with_Comfortzone_input_81; // P-band humidification control
public float CmCntr_with_Comfortzone_input_82; // P-band dehumidification control
public float CmCntr_with_Comfortzone_input_83; // Return air humidity
public float CmCntr_with_Comfortzone_input_84; // Setpoint
// macro outputs
public float CmCntr_with_Comfortzone_output_86; // DISP: calculated setpoint humidification
public float CmCntr_with_Comfortzone_output_87; // DISP: calculated setpoint dehumidification
public float CmCntr_with_Comfortzone_output_89; // humidity control signal
public float CmCntr_with_Comfortzone_output_90; // dehumidity control signsl
// helper functions

// class variables
protected CfDivide func_21 = new CfDivide();
protected CfMaximum func_24 = new CfMaximum();
protected CfMaximum func_25 = new CfMaximum();
protected CfSubtract func_22 = new CfSubtract();
protected CfAddition func_23 = new CfAddition();
protected CfDivide func_29 = new CfDivide();
protected CfDivide func_31 = new CfDivide();
protected CfIdt func_26 = new CfIdt();
protected CfIdt func_27 = new CfIdt();
protected CfSubtract func_28 = new CfSubtract();
protected CfSubtract func_30 = new CfSubtract();
protected CfMultiply func_32 = new CfMultiply();
protected CfMultiply func_33 = new CfMultiply();
protected CfAddition func_34 = new CfAddition();
protected CfAddition func_35 = new CfAddition();
protected CfMaximum func_36 = new CfMaximum();
protected CfMaximum func_37 = new CfMaximum();
protected CfMinimum func_38 = new CfMinimum();
protected CfMinimum func_39 = new CfMinimum();

// default constructor
public CmCntr_with_Comfortzone()
{
}

  public void Start()
  {
  }
}
