/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Cntr without Comfortzone
Macro id:      5854499176999551395
Macro version: 30
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] Setpoint in summer or winter compensation
  [2] Return air humidity
  [3] R78 percentage P humidification
  [4] P16 HUM: P-band humidification control
  [5] P18 DEH: P-band dehumidification control
  [6] P20 HUM/DEH: I-time humidify / dehumidify control
Outputs:
  [1] DISP: calculated setpoint humidification
  [2] DISP: calculated setpoint dehumidification
  [3] humidity control signal
  [4] dehumidity control signal
Parameter:
  [1] P16 HUM: P-band humidification control
  [2] P18 DEH: P-band dehumidification control
  [3] P20 HUM/DEH: I-time humidify / dehumidify control
Description:

================================================================================*/

public class CmCntr_without_Comfortzone
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [21] Function call CfAddition
    func_21.input[0] = CmCntr_without_Comfortzone_input_50;
    func_21.input[1] = CmCntr_without_Comfortzone_input_51;
    func_21.Execute(  );
    env.setParameter(parameterOffset + 3, func_21.output);

    // [22] Function call CfIdt
    func_22.input = CmCntr_without_Comfortzone_input_52;
    func_22.Execute(  );
    env.setParameter(parameterOffset + 5, func_22.output[0]);

    // [60] Function call CfIdt
    func_60.input = CmCntr_without_Comfortzone_input_49;
    func_60.Execute(  );
    env.setParameter(parameterOffset + 11, func_60.output[0]);
    env.setParameter(parameterOffset + 13, func_60.output[1]);

    // [66] Function call CfIdt
    func_66.input = 0F;
    func_66.Execute(  );
    env.setParameter(parameterOffset + 9, func_66.output[0]);
    env.setParameter(parameterOffset + 12, func_66.output[1]);
    env.setParameter(parameterOffset + 14, func_66.output[2]);

    // [70] Function call CfIdt
    func_70.input = 100F;
    func_70.Execute(  );
    env.setParameter(parameterOffset + 10, func_70.output[0]);
    env.setParameter(parameterOffset + 15, func_70.output[1]);
    env.setParameter(parameterOffset + 16, func_70.output[2]);

    // [77] Function call CfIdt
    func_77.input = CmCntr_without_Comfortzone_input_46;
    func_77.Execute(  );
    CmCntr_without_Comfortzone_output_74 = func_77.output[0];
    CmCntr_without_Comfortzone_output_75 = func_77.output[1];

    // [23] Function call CfPidPlus
    func_23.inputX = func_77.output[2];
    func_23.inputW = CmCntr_without_Comfortzone_input_47;
    func_23.Execute( env, parameterOffset + 3 );

    // [56] Function call CfSequence
    func_56.input = func_23.output;
    func_56.Execute( env, parameterOffset + 8 );
    CmCntr_without_Comfortzone_output_53 = func_56.output1;
    CmCntr_without_Comfortzone_output_54 = func_56.output2;

  }
// macro register which are written multiple times
// macro inputs
public float CmCntr_without_Comfortzone_input_46; // Setpoint in summer or winter compensation
public float CmCntr_without_Comfortzone_input_47; // Return air humidity
public float CmCntr_without_Comfortzone_input_49; // R78 percentage P humidification
public float CmCntr_without_Comfortzone_input_50; // P16 HUM: P-band humidification control
public float CmCntr_without_Comfortzone_input_51; // P18 DEH: P-band dehumidification control
public float CmCntr_without_Comfortzone_input_52; // P20 HUM/DEH: I-time humidify / dehumidify control
// macro outputs
public float CmCntr_without_Comfortzone_output_74; // DISP: calculated setpoint humidification
public float CmCntr_without_Comfortzone_output_75; // DISP: calculated setpoint dehumidification
public float CmCntr_without_Comfortzone_output_53; // humidity control signal
public float CmCntr_without_Comfortzone_output_54; // dehumidity control signal
// helper functions

// class variables
protected CfAddition func_21 = new CfAddition();
protected CfIdt func_22 = new CfIdt();
protected CfIdt func_60 = new CfIdt();
protected CfIdt func_66 = new CfIdt();
protected CfIdt func_70 = new CfIdt();
protected CfIdt func_77 = new CfIdt();
protected CfPidPlus func_23 = new CfPidPlus();
protected CfSequence func_56 = new CfSequence();

// default constructor
public CmCntr_without_Comfortzone()
{
  func_60.configure(2);
  func_66.configure(3);
  func_70.configure(3);
  func_77.configure(3);
}

  public void Start()
  {
    func_23.Start();
  }
}
