/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    ComfZone Control
Macro id:      5901849041143071568
Macro version: 121
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] SupplyAirTemp
  [2] RoomRetAirTemp
  [3] ContrPtAdj
  [4] FanEnable
  [5] FilteredOATemp
  [6] PlantMode
  [7] RoomAirTempSP
  [8] CalcRoomTmpSP
  [9] MinSAT_SpShift
Outputs:
  [1] OptimEnable 
  [2] CalcRoomTmpSP
  [3] CalcSupAirTmpSP_Low
  [4] CalcSupAirTmpSP_High
  [5] Release
  [6] FanRelease
  [7] FrostRecovery
  [8] Y-SAT-C
  [9] Y-SAT-H
Parameter:
  [1] START-01: limit OAT to start frost  protection
  [2] START-02: supply air temperature setpoint raise
  [3] START-03: SAT control raised setpoint decrease time
  [4] SCR-01: start point OAT summer comp. RT
  [5] SCR-02: end point OAT summer comp. RT
  [6] SCR-03: room temperature setpoint raise
  [7] SAT-01: supply air temperature low setpoint
  [8] SAT-02: supply air temperature high setpoint
  [9] SAT-03: supply air temp. control P-band
  [10] SAT-04: supply air temp. control I-time
  [11] WCS-01: start point OAT winter comp. SAT
  [12] WCS-02: end  point OAT winter comp. SAT
  [13] WCS-03: supply air temperature setpoint  raise
  [14] RMT-01: room temperature control P-band
  [15] RMT-02: room temperature control I-time
  [16] RMT-03: span for SAT-setpoint shift
  [17] RMT-05: room temperature comfort zone
Description:

================================================================================*/

public class CmComfZone_Control
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [275] Macro call CmIDT20
    func_275.CmIDT20_input_1 = env.getParameter(parameterOffset + 3);
    func_275.CmIDT20_input_2 = env.getParameter(parameterOffset + 4);
    func_275.CmIDT20_input_3 = env.getParameter(parameterOffset + 5);
    func_275.CmIDT20_input_4 = env.getParameter(parameterOffset);
    func_275.CmIDT20_input_5 = env.getParameter(parameterOffset + 2);
    func_275.CmIDT20_input_6 = env.getParameter(parameterOffset + 1);
    func_275.CmIDT20_input_7 = env.getParameter(parameterOffset + 2);
    func_275.CmIDT20_input_8 = env.getParameter(parameterOffset + 6);
    func_275.CmIDT20_input_9 = env.getParameter(parameterOffset + 7);
    func_275.CmIDT20_input_10 = env.getParameter(parameterOffset + 1);
    func_275.CmIDT20_input_11 = env.getParameter(parameterOffset + 2);
    func_275.CmIDT20_input_12 = env.getParameter(parameterOffset + 6);
    func_275.CmIDT20_input_13 = env.getParameter(parameterOffset + 7);
    func_275.CmIDT20_input_14 = env.getParameter(parameterOffset + 8);
    func_275.CmIDT20_input_15 = env.getParameter(parameterOffset + 9);
    func_275.CmIDT20_input_16 = env.getParameter(parameterOffset + 8);
    func_275.CmIDT20_input_17 = env.getParameter(parameterOffset + 9);
    func_275.CmIDT20_input_18 = 0F;
    func_275.CmIDT20_input_19 = 0F;
    func_275.CmIDT20_input_20 = 0F;
    func_275.Execute(  );
    env.setParameter(parameterOffset + 17, func_275.CmIDT20_output_21);
    env.setParameter(parameterOffset + 18, func_275.CmIDT20_output_22);
    env.setParameter(parameterOffset + 19, func_275.CmIDT20_output_23);
    env.setParameter(parameterOffset + 40, func_275.CmIDT20_output_24);
    env.setParameter(parameterOffset + 41, func_275.CmIDT20_output_25);
    env.setParameter(parameterOffset + 35, func_275.CmIDT20_output_26);
    env.setParameter(parameterOffset + 36, func_275.CmIDT20_output_27);
    env.setParameter(parameterOffset + 38, func_275.CmIDT20_output_28);
    env.setParameter(parameterOffset + 39, func_275.CmIDT20_output_29);
    env.setParameter(parameterOffset + 51, func_275.CmIDT20_output_30);
    env.setParameter(parameterOffset + 52, func_275.CmIDT20_output_31);
    env.setParameter(parameterOffset + 54, func_275.CmIDT20_output_32);
    env.setParameter(parameterOffset + 55, func_275.CmIDT20_output_33);
    env.setParameter(parameterOffset + 44, func_275.CmIDT20_output_35);
    env.setParameter(parameterOffset + 57, func_275.CmIDT20_output_37);

    // [297] Macro call CmIDT10
    func_297.CmIDT10_input_1 = env.getParameter(parameterOffset + 13);
    func_297.CmIDT10_input_2 = env.getParameter(parameterOffset + 14);
    func_297.CmIDT10_input_3 = env.getParameter(parameterOffset + 15);
    func_297.CmIDT10_input_4 = env.getParameter(parameterOffset + 16);
    func_297.CmIDT10_input_5 = env.getParameter(parameterOffset + 6);
    func_297.CmIDT10_input_6 = env.getParameter(parameterOffset + 7);
    func_297.CmIDT10_input_7 = env.getParameter(parameterOffset + 10);
    func_297.CmIDT10_input_8 = env.getParameter(parameterOffset + 11);
    func_297.CmIDT10_input_9 = env.getParameter(parameterOffset + 12);
    func_297.CmIDT10_input_10 = env.getParameter(parameterOffset + 16);
    func_297.Execute(  );
    env.setParameter(parameterOffset + 25, func_297.CmIDT10_output_21);
    env.setParameter(parameterOffset + 26, func_297.CmIDT10_output_22);
    env.setParameter(parameterOffset + 27, func_297.CmIDT10_output_23);
    env.setParameter(parameterOffset + 28, func_297.CmIDT10_output_24);
    env.setParameter(parameterOffset + 23, func_297.CmIDT10_output_25);
    env.setParameter(parameterOffset + 24, func_297.CmIDT10_output_26);
    env.setParameter(parameterOffset + 20, func_297.CmIDT10_output_27);
    env.setParameter(parameterOffset + 21, func_297.CmIDT10_output_28);
    env.setParameter(parameterOffset + 22, func_297.CmIDT10_output_29);
    env.setParameter(parameterOffset + 64, func_297.CmIDT10_output_30);

    // [328] Function call CfDivide
    func_328.inputA = env.getParameter(parameterOffset + 8);
    func_328.inputB = 2F;
    func_328.Execute(  );

    // [329] Function call CfIdt
    func_329.input = func_328.output;
    func_329.Execute(  );
    env.setParameter(parameterOffset + 43, func_329.output[0]);
    env.setParameter(parameterOffset + 56, func_329.output[1]);

    // [135] Macro call CmSummer_Compensation
    func_135.CmSummer_Compensation_input_4 = CmComfZone_Control_input_151;
    func_135.CmSummer_Compensation_input_23 = CmComfZone_Control_input_172;
    func_135.CmSummer_Compensation_input_5 = CmComfZone_Control_input_5;
    func_135.Execute( env, parameterOffset +17 );

    // [82] Macro call CmControl_Point_Adjustment
    func_82.CmControl_Point_Adjustment_input_7 = CmComfZone_Control_input_3;
    func_82.Execute(  );

    // [265] Macro call CmCascaded_Control_Comf
    func_265.CmCascaded_Control_Comf_input_1 = func_135.CmSummer_Compensation_output_6;
    func_265.CmCascaded_Control_Comf_input_4 = func_82.CmControl_Point_Adjustment_output_10;
    func_265.CmCascaded_Control_Comf_input_13 = CmComfZone_Control_input_172;
    func_265.CmCascaded_Control_Comf_input_23 = CmComfZone_Control_input_5;
    func_265.CmCascaded_Control_Comf_input_18 = true;
    func_265.CmCascaded_Control_Comf_input_136 = CmComfZone_Control_input_319;
    func_265.Execute( env, parameterOffset +20 );
    CmComfZone_Control_output_174 = func_265.CmCascaded_Control_Comf_output_56;

    // [325] Function call CfDivide
    func_325.inputA = env.getParameter(parameterOffset + 8);
    func_325.inputB = 4F;
    func_325.Execute(  );

    // [322] Function call CfAddition
    func_322.input[0] = CmComfZone_Control_input_1;
    func_322.input[1] = func_325.output;
    func_322.Execute(  );

    // [324] Function call CfSubtract
    func_324.input[0] = CmComfZone_Control_input_1;
    func_324.input[1] = func_325.output;
    func_324.Execute(  );

    // [43] Macro call CmAHU_Setpoint_Ramp
    func_43.CmAHU_Setpoint_Ramp_input_1 = CmComfZone_Control_output_258;
    func_43.CmAHU_Setpoint_Ramp_input_47 = func_265.CmCascaded_Control_Comf_output_3;
    func_43.Execute( env, parameterOffset +35 );

    // [118] Macro call CmLimit_SAT
    func_118.CmLimit_SAT_input_1 = func_43.CmAHU_Setpoint_Ramp_output_48;
    func_118.CmLimit_SAT_input_14 = CmComfZone_Control_input_319;
    func_118.Execute( env, parameterOffset +38 );
    CmComfZone_Control_output_16 = func_118.CmLimit_SAT_output_2;

    // [40] Macro call CmAHU_Startup
    func_40.CmAHU_Startup_input_14 = CmComfZone_Control_input_4;
    func_40.CmAHU_Startup_input_15 = CmComfZone_Control_input_6;
    func_40.CmAHU_Startup_input_16 = CmComfZone_Control_input_5;
    func_40.Execute( env, parameterOffset +40 );
    CmComfZone_Control_output_258 = func_40.CmAHU_Startup_output_35;
    CmComfZone_Control_output_256 = func_40.CmAHU_Startup_output_79;

    // [260] Function call CfIdt
    func_260.input = BooleanToFloat(func_40.CmAHU_Startup_output_34);
    func_260.Execute(  );
    CmComfZone_Control_output_255 = FloatToBoolean(func_260.output[0]);

    // [204] Macro call CmSupply_PID
    func_204.CmSupply_PID_input_13 = func_118.CmLimit_SAT_output_3;
    func_204.CmSupply_PID_input_14 = func_322.output;
    func_204.CmSupply_PID_input_15 = func_40.CmAHU_Startup_output_34;
    func_204.Execute( env, parameterOffset +43 );
    CmComfZone_Control_output_257 = func_204.CmSupply_PID_output_22;

    // [269] Macro call CmAHU_Setpoint_Ramp
    func_269.CmAHU_Setpoint_Ramp_input_1 = CmComfZone_Control_output_258;
    func_269.CmAHU_Setpoint_Ramp_input_47 = func_265.CmCascaded_Control_Comf_output_78;
    func_269.Execute( env, parameterOffset +51 );

    // [270] Macro call CmLimit_SAT
    func_270.CmLimit_SAT_input_1 = func_269.CmAHU_Setpoint_Ramp_output_48;
    func_270.CmLimit_SAT_input_14 = CmComfZone_Control_input_319;
    func_270.Execute( env, parameterOffset +54 );
    CmComfZone_Control_output_253 = func_270.CmLimit_SAT_output_2;

    // [273] Macro call CmSupply_PID
    func_273.CmSupply_PID_input_13 = func_270.CmLimit_SAT_output_3;
    func_273.CmSupply_PID_input_14 = func_324.output;
    func_273.CmSupply_PID_input_15 = func_40.CmAHU_Startup_output_34;
    func_273.Execute( env, parameterOffset +56 );
    CmComfZone_Control_output_274 = func_273.CmSupply_PID_output_22;

    // [317] Macro call CmAHU_Optim_Enable
    func_317.CmAHU_Optim_Enable_input_8 = CmComfZone_Control_input_172;
    func_317.CmAHU_Optim_Enable_input_9 = CmComfZone_Control_input_316;
    func_317.Execute( env, parameterOffset +64 );
    CmComfZone_Control_output_252 = func_317.CmAHU_Optim_Enable_output_10;

  }
// macro register which are written multiple times
// macro inputs
public float CmComfZone_Control_input_1; // SupplyAirTemp
public float CmComfZone_Control_input_172; // RoomRetAirTemp
public float CmComfZone_Control_input_3; // ContrPtAdj
public boolean CmComfZone_Control_input_4; // FanEnable
public float CmComfZone_Control_input_5; // FilteredOATemp
public float CmComfZone_Control_input_6; // PlantMode
public float CmComfZone_Control_input_151; // RoomAirTempSP
public float CmComfZone_Control_input_316; // CalcRoomTmpSP
public float CmComfZone_Control_input_319; // MinSAT_SpShift
// macro outputs
public float CmComfZone_Control_output_252; // OptimEnable 
public float CmComfZone_Control_output_174; // CalcRoomTmpSP
public float CmComfZone_Control_output_16; // CalcSupAirTmpSP_Low
public float CmComfZone_Control_output_253; // CalcSupAirTmpSP_High
public boolean CmComfZone_Control_output_255; // Release
public boolean CmComfZone_Control_output_256; // FanRelease
public boolean CmComfZone_Control_output_258; // FrostRecovery
public float CmComfZone_Control_output_257; // Y-SAT-C
public float CmComfZone_Control_output_274; // Y-SAT-H
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CmIDT20 func_275 = new CmIDT20();
protected CmIDT10 func_297 = new CmIDT10();
protected CfDivide func_328 = new CfDivide();
protected CfIdt func_329 = new CfIdt();
protected CmSummer_Compensation func_135 = new CmSummer_Compensation();
protected CmControl_Point_Adjustment func_82 = new CmControl_Point_Adjustment();
protected CmCascaded_Control_Comf func_265 = new CmCascaded_Control_Comf();
protected CfDivide func_325 = new CfDivide();
protected CfAddition func_322 = new CfAddition();
protected CfSubtract func_324 = new CfSubtract();
protected CmAHU_Setpoint_Ramp func_43 = new CmAHU_Setpoint_Ramp();
protected CmLimit_SAT func_118 = new CmLimit_SAT();
protected CmAHU_Startup func_40 = new CmAHU_Startup();
protected CfIdt func_260 = new CfIdt();
protected CmSupply_PID func_204 = new CmSupply_PID();
protected CmAHU_Setpoint_Ramp func_269 = new CmAHU_Setpoint_Ramp();
protected CmLimit_SAT func_270 = new CmLimit_SAT();
protected CmSupply_PID func_273 = new CmSupply_PID();
protected CmAHU_Optim_Enable func_317 = new CmAHU_Optim_Enable();

// default constructor
public CmComfZone_Control()
{
  func_329.configure(2);
}

  public void Start()
  {
    func_275.Start();
    func_297.Start();
    func_135.Start();
    func_82.Start();
    func_265.Start();
    func_43.Start();
    func_118.Start();
    func_40.Start();
    func_204.Start();
    func_269.Start();
    func_270.Start();
    func_273.Start();
    func_317.Start();
  }
}
