/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    ComfZone Sequence
Macro id:      5903418287894561173
Macro version: 121
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] Y-SAT-C
  [2] Y-SAT-H
  [3] FilteredOATemp
  [4] HumidityMode
  [5] CalcRoomTmpSP
  [6] RoomRetAirTemp
  [7] ERCreverse
  [8] EnableDamper
Outputs:
  [1] HeatControl
  [2] CoolControl
  [3] ERCControl
  [4] DmpControl
Parameter:
  [1] OAT-01: limit OAT;  heater closed
  [2] OAT-02: limit OAT;  cooler closed
  [3] SAT-05: sequence start point heating valve
  [4] SAT-06: sequence end point heating valve
  [5] SAT-07: sequence start point dampers
  [6] SAT-08: sequence end point dampers
  [7] SAT-09: sequence start point energy recovery
  [8] SAT-10 :sequence end point energy recovery
  [9] SAT-11: sequence start point cooling valve
  [10] SAT-12: sequence end point cooling valve
  [11] RMT-05: room temperature comfort zone
  [12] RMT-06: sequence start point dampers
  [13] RMT-07: sequence end point dampers
  [14] RMT-08: sequence start point energy recovery
  [15] RMT-09: sequence end point energy recovery
Description:

================================================================================*/

public class CmComfZone_Sequence
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [295] Macro call CmIDT20
    func_295.CmIDT20_input_1 = env.getParameter(parameterOffset + 2);
    func_295.CmIDT20_input_2 = env.getParameter(parameterOffset + 3);
    func_295.CmIDT20_input_3 = env.getParameter(parameterOffset + 6);
    func_295.CmIDT20_input_4 = env.getParameter(parameterOffset + 7);
    func_295.CmIDT20_input_5 = env.getParameter(parameterOffset + 8);
    func_295.CmIDT20_input_6 = env.getParameter(parameterOffset + 9);
    func_295.CmIDT20_input_7 = env.getParameter(parameterOffset + 2);
    func_295.CmIDT20_input_8 = env.getParameter(parameterOffset + 3);
    func_295.CmIDT20_input_9 = env.getParameter(parameterOffset + 6);
    func_295.CmIDT20_input_10 = env.getParameter(parameterOffset + 7);
    func_295.CmIDT20_input_11 = env.getParameter(parameterOffset + 8);
    func_295.CmIDT20_input_12 = env.getParameter(parameterOffset + 9);
    func_295.CmIDT20_input_13 = env.getParameter(parameterOffset);
    func_295.CmIDT20_input_14 = env.getParameter(parameterOffset + 1);
    func_295.CmIDT20_input_15 = env.getParameter(parameterOffset);
    func_295.CmIDT20_input_16 = env.getParameter(parameterOffset + 1);
    func_295.CmIDT20_input_17 = env.getParameter(parameterOffset + 4);
    func_295.CmIDT20_input_18 = env.getParameter(parameterOffset + 5);
    func_295.CmIDT20_input_19 = env.getParameter(parameterOffset + 4);
    func_295.CmIDT20_input_20 = env.getParameter(parameterOffset + 5);
    func_295.Execute(  );
    env.setParameter(parameterOffset + 19, func_295.CmIDT20_output_21);
    env.setParameter(parameterOffset + 20, func_295.CmIDT20_output_22);
    env.setParameter(parameterOffset + 21, func_295.CmIDT20_output_23);
    env.setParameter(parameterOffset + 22, func_295.CmIDT20_output_24);
    env.setParameter(parameterOffset + 23, func_295.CmIDT20_output_25);
    env.setParameter(parameterOffset + 24, func_295.CmIDT20_output_26);
    env.setParameter(parameterOffset + 25, func_295.CmIDT20_output_27);
    env.setParameter(parameterOffset + 26, func_295.CmIDT20_output_28);
    env.setParameter(parameterOffset + 27, func_295.CmIDT20_output_29);
    env.setParameter(parameterOffset + 28, func_295.CmIDT20_output_30);
    env.setParameter(parameterOffset + 29, func_295.CmIDT20_output_31);
    env.setParameter(parameterOffset + 30, func_295.CmIDT20_output_32);
    env.setParameter(parameterOffset + 31, func_295.CmIDT20_output_33);
    env.setParameter(parameterOffset + 32, func_295.CmIDT20_output_34);
    env.setParameter(parameterOffset + 33, func_295.CmIDT20_output_35);
    env.setParameter(parameterOffset + 34, func_295.CmIDT20_output_36);
    env.setParameter(parameterOffset + 17, func_295.CmIDT20_output_37);
    env.setParameter(parameterOffset + 18, func_295.CmIDT20_output_38);
    env.setParameter(parameterOffset + 15, func_295.CmIDT20_output_39);
    env.setParameter(parameterOffset + 16, func_295.CmIDT20_output_40);

    // [366] Function call CfDivide
    func_366.inputA = env.getParameter(parameterOffset + 10);
    func_366.inputB = 2F;
    func_366.Execute(  );

    // [368] Function call CfSubtract
    func_368.input[0] = CmComfZone_Sequence_input_355;
    func_368.input[1] = func_366.output;
    func_368.Execute(  );

    // [367] Function call CfAddition
    func_367.input[0] = CmComfZone_Sequence_input_355;
    func_367.input[1] = func_366.output;
    func_367.Execute(  );

    // [365] Function call CfLinearConverter
    func_365.inputValue = CmComfZone_Sequence_input_362;
    func_365.inputInLimit1 = func_368.output;
    func_365.inputInLimit2 = func_367.output;
    func_365.inputOutLimit1 = 0F;
    func_365.inputOutLimit2 = 100F;
    func_365.Execute(  );

    // [378] Function call CfInputMultiplexer
    func_378.inputSelect = BooleanToInt(CmComfZone_Sequence_input_279);
    func_378.input[1-1] = 0F;
    func_378.input[2-1] = 100F;
    func_378.Execute(  );

    // [379] Function call CfInputMultiplexer
    func_379.inputSelect = BooleanToInt(CmComfZone_Sequence_input_279);
    func_379.input[1-1] = 100F;
    func_379.input[2-1] = 0F;
    func_379.Execute(  );

    // [363] Function call CfLinearConverter
    func_363.inputValue = func_365.output;
    func_363.inputInLimit1 = env.getParameter(parameterOffset + 11);
    func_363.inputInLimit2 = env.getParameter(parameterOffset + 12);
    func_363.inputOutLimit1 = func_378.output;
    func_363.inputOutLimit2 = func_379.output;
    func_363.Execute(  );

    // [377] Function call CfLinearConverter
    func_377.inputValue = func_365.output;
    func_377.inputInLimit1 = env.getParameter(parameterOffset + 13);
    func_377.inputInLimit2 = env.getParameter(parameterOffset + 14);
    func_377.inputOutLimit1 = func_379.output;
    func_377.inputOutLimit2 = func_378.output;
    func_377.Execute(  );

    // [425] Function call CfLinearConverter
    func_425.inputValue = func_365.output;
    func_425.inputInLimit1 = 0F;
    func_425.inputInLimit2 = 100F;
    func_425.inputOutLimit1 = func_379.output;
    func_425.inputOutLimit2 = func_378.output;
    func_425.Execute(  );

    // [426] Function call CfInputMultiplexer
    func_426.inputSelect = BooleanToInt(CmComfZone_Sequence_input_345);
    func_426.input[1-1] = func_425.output;
    func_426.input[2-1] = func_377.output;
    func_426.Execute(  );

    // [337] Macro call CmDamper_Sequence
    func_337.CmDamper_Sequence_input_1 = CmComfZone_Sequence_input_280;
    func_337.CmDamper_Sequence_input_37 = CmComfZone_Sequence_input_279;
    func_337.Execute( env, parameterOffset +15 );

    // [336] Macro call CmDamper_Sequence
    func_336.CmDamper_Sequence_input_1 = CmComfZone_Sequence_input_281;
    func_336.CmDamper_Sequence_input_37 = CmComfZone_Sequence_input_279;
    func_336.Execute( env, parameterOffset +17 );

    // [393] Function call CfMaximum
    func_393.input[0] = func_363.output;
    func_393.input[1] = func_336.CmDamper_Sequence_output_2;
    func_393.Execute(  );

    // [394] Function call CfMinimum
    func_394.input[0] = func_337.CmDamper_Sequence_output_2;
    func_394.input[1] = func_393.output;
    func_394.Execute(  );
    CmComfZone_Sequence_output_346 = func_394.output;

    // [104] Macro call CmOutput_Sequence
    func_104.CmOutput_Sequence_input_1 = CmComfZone_Sequence_input_281;
    func_104.CmOutput_Sequence_input_37 = CmComfZone_Sequence_input_279;
    func_104.Execute( env, parameterOffset +19 );

    // [232] Macro call CmOutput_Sequence
    func_232.CmOutput_Sequence_input_1 = CmComfZone_Sequence_input_280;
    func_232.CmOutput_Sequence_input_37 = CmComfZone_Sequence_input_279;
    func_232.Execute( env, parameterOffset +25 );

    // [113] Macro call CmOAT_Limits
    func_113.CmOAT_Limits_input_16 = CmComfZone_Sequence_input_5;
    func_113.CmOAT_Limits_input_21 = CmComfZone_Sequence_input_7;
    func_113.CmOAT_Limits_input_1 = func_104.CmOutput_Sequence_output_2;
    func_113.CmOAT_Limits_input_2 = func_104.CmOutput_Sequence_output_3;
    func_113.Execute( env, parameterOffset +31 );

    // [233] Macro call CmOAT_Limits
    func_233.CmOAT_Limits_input_16 = CmComfZone_Sequence_input_5;
    func_233.CmOAT_Limits_input_21 = CmComfZone_Sequence_input_7;
    func_233.CmOAT_Limits_input_1 = func_232.CmOutput_Sequence_output_2;
    func_233.CmOAT_Limits_input_2 = func_232.CmOutput_Sequence_output_3;
    func_233.Execute( env, parameterOffset +33 );

    // [395] Function call CfMaximum
    func_395.input[0] = func_426.output;
    func_395.input[1] = func_232.CmOutput_Sequence_output_4;
    func_395.Execute(  );

    // [396] Function call CfMinimum
    func_396.input[0] = func_104.CmOutput_Sequence_output_4;
    func_396.input[1] = func_395.output;
    func_396.Execute(  );
    CmComfZone_Sequence_output_13 = func_396.output;

    // [236] Function call CfMinimum
    func_236.input[0] = func_113.CmOAT_Limits_output_3;
    func_236.input[1] = func_233.CmOAT_Limits_output_3;
    func_236.Execute(  );
    CmComfZone_Sequence_output_11 = func_236.output;

    // [238] Function call CfMinimum
    func_238.input[0] = func_113.CmOAT_Limits_output_4;
    func_238.input[1] = func_233.CmOAT_Limits_output_4;
    func_238.Execute(  );
    CmComfZone_Sequence_output_12 = func_238.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmComfZone_Sequence_input_281; // Y-SAT-C
public float CmComfZone_Sequence_input_280; // Y-SAT-H
public float CmComfZone_Sequence_input_5; // FilteredOATemp
public float CmComfZone_Sequence_input_7; // HumidityMode
public float CmComfZone_Sequence_input_355; // CalcRoomTmpSP
public float CmComfZone_Sequence_input_362; // RoomRetAirTemp
public boolean CmComfZone_Sequence_input_279; // ERCreverse
public boolean CmComfZone_Sequence_input_345; // EnableDamper
// macro outputs
public float CmComfZone_Sequence_output_11; // HeatControl
public float CmComfZone_Sequence_output_12; // CoolControl
public float CmComfZone_Sequence_output_13; // ERCControl
public float CmComfZone_Sequence_output_346; // DmpControl
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CmIDT20 func_295 = new CmIDT20();
protected CfDivide func_366 = new CfDivide();
protected CfSubtract func_368 = new CfSubtract();
protected CfAddition func_367 = new CfAddition();
protected CfLinearConverter func_365 = new CfLinearConverter();
protected CfInputMultiplexer func_378 = new CfInputMultiplexer();
protected CfInputMultiplexer func_379 = new CfInputMultiplexer();
protected CfLinearConverter func_363 = new CfLinearConverter();
protected CfLinearConverter func_377 = new CfLinearConverter();
protected CfLinearConverter func_425 = new CfLinearConverter();
protected CfInputMultiplexer func_426 = new CfInputMultiplexer();
protected CmDamper_Sequence func_337 = new CmDamper_Sequence();
protected CmDamper_Sequence func_336 = new CmDamper_Sequence();
protected CfMaximum func_393 = new CfMaximum();
protected CfMinimum func_394 = new CfMinimum();
protected CmOutput_Sequence func_104 = new CmOutput_Sequence();
protected CmOutput_Sequence func_232 = new CmOutput_Sequence();
protected CmOAT_Limits func_113 = new CmOAT_Limits();
protected CmOAT_Limits func_233 = new CmOAT_Limits();
protected CfMaximum func_395 = new CfMaximum();
protected CfMinimum func_396 = new CfMinimum();
protected CfMinimum func_236 = new CfMinimum();
protected CfMinimum func_238 = new CfMinimum();

// default constructor
public CmComfZone_Sequence()
{
}

  public void Start()
  {
    func_295.Start();
    func_337.Start();
    func_336.Start();
    func_104.Start();
    func_232.Start();
    func_113.Start();
    func_233.Start();
  }
}
