/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Control Signal
Macro id:      5800241585308303817
Macro version: 15
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] PressureSetpoint
  [2] PressureSensor
  [3] Release
  [4] IntegralEnable
  [5] MinOutputSignal
  [6] MaxOutputSignal
Outputs:
  [1] PressureControl
Parameter:
  [1] DSP-02: Pband static pressure control
  [2] DSP-03: Itime static pressure control
Description:

================================================================================*/

public class CmControl_Signal
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [34] Function call CfIdt
    func_34.input = CmControl_Signal_input_31;
    func_34.Execute(  );
    env.setParameter(parameterOffset + 6, func_34.output[0]);

    // [35] Function call CfIdt
    func_35.input = CmControl_Signal_input_32;
    func_35.Execute(  );
    env.setParameter(parameterOffset + 5, func_35.output[0]);

    // [28] Function call CfIdt
    func_28.input = env.getParameter(parameterOffset);
    func_28.Execute(  );
    env.setParameter(parameterOffset + 2, func_28.output[0]);

    // [33] Function call CfIdt
    func_33.input = env.getParameter(parameterOffset + 1);
    func_33.Execute(  );
    env.setParameter(parameterOffset + 4, func_33.output[0]);

    // [20] Function call CfIdt
    func_20.input = CmControl_Signal_input_12;
    func_20.Execute(  );

    // [21] Function call CfIdt
    func_21.input = CmControl_Signal_input_11;
    func_21.Execute(  );

    // [24] Function call CfIdt
    func_24.input = BooleanToFloat(CmControl_Signal_input_14);
    func_24.Execute(  );

    // [25] Function call CfIdt
    func_25.input = BooleanToFloat(CmControl_Signal_input_15);
    func_25.Execute(  );

    // [16] Function call CfAnd
    func_16.input[0] = FloatToBoolean(func_24.output[0]);
    func_16.input[1] = FloatToBoolean(func_25.output[0]);
    func_16.Execute(  );

    // [1] Function call CfPidPlus
    func_1.inputX = func_20.output[0];
    func_1.inputW = func_21.output[0];
    func_1.inputIntegralOn = func_16.outputAND;
    func_1.Execute( env, parameterOffset + 2 );

    // [36] Function call CfInputMultiplexer
    func_36.inputSelect = FloatToInt(func_24.output[0]);
    func_36.input[1-1] = 0F;
    func_36.input[2-1] = func_1.output;
    func_36.Execute(  );

    // [38] Function call CfIdt
    func_38.input = func_36.output;
    func_38.Execute(  );
    CmControl_Signal_output_13 = func_38.output[0];

  }
// macro register which are written multiple times
// macro inputs
public float CmControl_Signal_input_11; // PressureSetpoint
public float CmControl_Signal_input_12; // PressureSensor
public boolean CmControl_Signal_input_14; // Release
public boolean CmControl_Signal_input_15; // IntegralEnable
public float CmControl_Signal_input_31; // MinOutputSignal
public float CmControl_Signal_input_32; // MaxOutputSignal
// macro outputs
public float CmControl_Signal_output_13; // PressureControl
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfIdt func_34 = new CfIdt();
protected CfIdt func_35 = new CfIdt();
protected CfIdt func_28 = new CfIdt();
protected CfIdt func_33 = new CfIdt();
protected CfIdt func_20 = new CfIdt();
protected CfIdt func_21 = new CfIdt();
protected CfIdt func_24 = new CfIdt();
protected CfIdt func_25 = new CfIdt();
protected CfAnd func_16 = new CfAnd();
protected CfPidPlus func_1 = new CfPidPlus();
protected CfInputMultiplexer func_36 = new CfInputMultiplexer();
protected CfIdt func_38 = new CfIdt();

// default constructor
public CmControl_Signal()
{
}

  public void Start()
  {
    func_1.Start();
  }
}
