/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Control Water
Macro id:      5880370286847590887
Macro version: 33
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] EnRecSignal
  [2] LowInletAirTemp
  [3] RetAirTemp
  [4] EnRecTemp
  [5] FilteredOATemp
  [6] Enable
Outputs:
  [1] EnRecControl
Parameter:
  [1] ERS-01: minimum energy recovery control signal
  [2] ERS-02: maximum energy recovery control signal
  [3] ERS-03: difference IAT, RAT control signal sequence start
  [4] ERS-04: difference IAT, RAT control signal sequence stop
  [5] ERT-01: energy recovery temperature low setpoint
  [6] ERT-02: energy recovery temperature high setpoint
  [7] OAT-01: outside air temperature minimum value
  [8] OAT-02: outside air temperature maximum value
  [9] ERT-03: P-band energy recovery temperature control
  [10] ERP-01: wheel start-up delay
  [11] DISP-01: calc. setpoint energy recovery temperature
Description:

================================================================================*/

public class CmControl_Water
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [53] Function call CfIdt
    func_53.input = env.getParameter(parameterOffset + 9);
    func_53.Execute(  );
    env.setParameter(parameterOffset + 11, func_53.output[0]);

    // [51] Macro call CmIDT10
    func_51.CmIDT10_input_1 = env.getParameter(parameterOffset);
    func_51.CmIDT10_input_2 = env.getParameter(parameterOffset + 1);
    func_51.CmIDT10_input_3 = env.getParameter(parameterOffset + 2);
    func_51.CmIDT10_input_4 = env.getParameter(parameterOffset + 3);
    func_51.CmIDT10_input_5 = env.getParameter(parameterOffset + 4);
    func_51.CmIDT10_input_6 = env.getParameter(parameterOffset + 5);
    func_51.CmIDT10_input_7 = env.getParameter(parameterOffset + 8);
    func_51.CmIDT10_input_8 = env.getParameter(parameterOffset + 6);
    func_51.CmIDT10_input_9 = env.getParameter(parameterOffset + 7);
    func_51.CmIDT10_input_10 = env.getParameter(parameterOffset);
    func_51.Execute(  );
    env.setParameter(parameterOffset + 12, func_51.CmIDT10_output_21);
    env.setParameter(parameterOffset + 13, func_51.CmIDT10_output_22);
    env.setParameter(parameterOffset + 14, func_51.CmIDT10_output_23);
    env.setParameter(parameterOffset + 15, func_51.CmIDT10_output_24);
    env.setParameter(parameterOffset + 18, func_51.CmIDT10_output_25);
    env.setParameter(parameterOffset + 19, func_51.CmIDT10_output_26);
    env.setParameter(parameterOffset + 20, func_51.CmIDT10_output_27);
    env.setParameter(parameterOffset + 21, func_51.CmIDT10_output_28);
    env.setParameter(parameterOffset + 22, func_51.CmIDT10_output_29);
    env.setParameter(parameterOffset + 16, func_51.CmIDT10_output_30);

    // [50] Function call CfIdt
    func_50.input = env.getParameter(parameterOffset + 1);
    func_50.Execute(  );
    env.setParameter(parameterOffset + 17, func_50.output[0]);

    // [54] Function call CfOr
    func_54.input[0] = ControlFunction.GetStartupFlag();
    func_54.input[1] = false;
    func_54.Execute(  );

    // [55] Function call CfDelay
    func_55.inputA = func_54.outputNOR;
    func_55.inputB = func_54.outputNOR;
    func_55.Execute( env, parameterOffset + 11 );

    // [56] Function call CfAnd
    func_56.input[0] = func_55.outputDelayedA;
    func_56.input[1] = CmControl_Water_input_48;
    func_56.Execute(  );

    // [3] Macro call CmEnergy_Recovery_Signal
    func_3.CmEnergy_Recovery_Signal_input_1 = CmControl_Water_input_10;
    func_3.CmEnergy_Recovery_Signal_input_2 = CmControl_Water_input_11;
    func_3.CmEnergy_Recovery_Signal_input_3 = CmControl_Water_input_12;
    func_3.CmEnergy_Recovery_Signal_input_62 = 0F;
    func_3.Execute( env, parameterOffset +12 );

    // [37] Macro call CmReturn_Water_Control
    func_37.CmReturn_Water_Control_input_1 = CmControl_Water_input_41;
    func_37.CmReturn_Water_Control_input_11 = CmControl_Water_input_43;
    func_37.CmReturn_Water_Control_input_57 = true;
    func_37.Execute( env, parameterOffset +16 );
    env.setParameter(parameterOffset + 10, func_37.CmReturn_Water_Control_output_10);

    // [5] Function call CfMaximum
    func_5.input[0] = func_3.CmEnergy_Recovery_Signal_output_4;
    func_5.input[1] = env.getParameter(parameterOffset);
    func_5.input[2] = func_37.CmReturn_Water_Control_output_24;
    func_5.Execute(  );

    // [7] Function call CfMinimum
    func_7.input[0] = func_5.output;
    func_7.input[1] = env.getParameter(parameterOffset + 1);
    func_7.Execute(  );

    // [46] Function call CfInputMultiplexer
    func_46.inputSelect = BooleanToInt(func_56.outputAND);
    func_46.input[1-1] = 0F;
    func_46.input[2-1] = func_7.output;
    func_46.Execute(  );
    CmControl_Water_output_9 = func_46.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmControl_Water_input_10; // EnRecSignal
public float CmControl_Water_input_11; // LowInletAirTemp
public float CmControl_Water_input_12; // RetAirTemp
public float CmControl_Water_input_41; // EnRecTemp
public float CmControl_Water_input_43; // FilteredOATemp
public boolean CmControl_Water_input_48; // Enable
// macro outputs
public float CmControl_Water_output_9; // EnRecControl
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfIdt func_53 = new CfIdt();
protected CmIDT10 func_51 = new CmIDT10();
protected CfIdt func_50 = new CfIdt();
protected CfOr func_54 = new CfOr();
protected CfDelay func_55 = new CfDelay();
protected CfAnd func_56 = new CfAnd();
protected CmEnergy_Recovery_Signal func_3 = new CmEnergy_Recovery_Signal();
protected CmReturn_Water_Control func_37 = new CmReturn_Water_Control();
protected CfMaximum func_5 = new CfMaximum();
protected CfMinimum func_7 = new CfMinimum();
protected CfInputMultiplexer func_46 = new CfInputMultiplexer();

// default constructor
public CmControl_Water()
{
  func_5.configure(3);
}

  public void Start()
  {
    func_51.Start();
    func_55.Start();
    func_3.Start();
    func_37.Start();
  }
}
