/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Control Wheel
Macro id:      5878558555946091464
Macro version: 28
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] EnRecSignal
  [2] LowInletAirTemp
  [3] RetAirTemp
  [4] Enable
Outputs:
  [1] EnRecControl
Parameter:
  [1] ERS-01: minimum energy recovery control signal
  [2] ERS-02: maximum energy recovery control signal
  [3] ERS-03: difference IAT, RAT control signal sequence start
  [4] ERS-04: difference IAT, RAT control signal sequence stop
  [5] ERP-01: wheel start-up delay
  [6] DISP-01: calc. setpoint energy recovery temperature
Description:

================================================================================*/

public class CmControl_Wheel
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [39] Macro call CmIDT05
    func_39.CmIDT05_input_1 = env.getParameter(parameterOffset);
    func_39.CmIDT05_input_2 = env.getParameter(parameterOffset + 1);
    func_39.CmIDT05_input_3 = env.getParameter(parameterOffset + 2);
    func_39.CmIDT05_input_4 = env.getParameter(parameterOffset + 3);
    func_39.CmIDT05_input_5 = 999F;
    func_39.Execute(  );
    env.setParameter(parameterOffset + 7, func_39.CmIDT05_output_21);
    env.setParameter(parameterOffset + 8, func_39.CmIDT05_output_22);
    env.setParameter(parameterOffset + 9, func_39.CmIDT05_output_23);
    env.setParameter(parameterOffset + 10, func_39.CmIDT05_output_24);
    env.setParameter(parameterOffset + 5, func_39.CmIDT05_output_25);

    // [58] Function call CfIdt
    func_58.input = env.getParameter(parameterOffset + 4);
    func_58.Execute(  );
    env.setParameter(parameterOffset + 6, func_58.output[0]);

    // [47] Function call CfOr
    func_47.input[0] = ControlFunction.GetStartupFlag();
    func_47.input[1] = false;
    func_47.Execute(  );

    // [48] Function call CfDelay
    func_48.inputA = func_47.outputNOR;
    func_48.inputB = func_47.outputNOR;
    func_48.Execute( env, parameterOffset + 6 );

    // [53] Function call CfAnd
    func_53.input[0] = func_48.outputDelayedA;
    func_53.input[1] = CmControl_Wheel_input_26;
    func_53.Execute(  );

    // [3] Macro call CmEnergy_Recovery_Signal
    func_3.CmEnergy_Recovery_Signal_input_1 = CmControl_Wheel_input_10;
    func_3.CmEnergy_Recovery_Signal_input_2 = CmControl_Wheel_input_11;
    func_3.CmEnergy_Recovery_Signal_input_3 = CmControl_Wheel_input_12;
    func_3.CmEnergy_Recovery_Signal_input_62 = 0F;
    func_3.Execute( env, parameterOffset +7 );

    // [5] Function call CfMaximum
    func_5.input[0] = func_3.CmEnergy_Recovery_Signal_output_4;
    func_5.input[1] = env.getParameter(parameterOffset + 7);
    func_5.Execute(  );

    // [7] Function call CfMinimum
    func_7.input[0] = func_5.output;
    func_7.input[1] = env.getParameter(parameterOffset + 8);
    func_7.Execute(  );

    // [24] Function call CfInputMultiplexer
    func_24.inputSelect = BooleanToInt(func_53.outputAND);
    func_24.input[1-1] = 0F;
    func_24.input[2-1] = func_7.output;
    func_24.Execute(  );
    CmControl_Wheel_output_9 = func_24.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmControl_Wheel_input_10; // EnRecSignal
public float CmControl_Wheel_input_11; // LowInletAirTemp
public float CmControl_Wheel_input_12; // RetAirTemp
public boolean CmControl_Wheel_input_26; // Enable
// macro outputs
public float CmControl_Wheel_output_9; // EnRecControl
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CmIDT05 func_39 = new CmIDT05();
protected CfIdt func_58 = new CfIdt();
protected CfOr func_47 = new CfOr();
protected CfDelay func_48 = new CfDelay();
protected CfAnd func_53 = new CfAnd();
protected CmEnergy_Recovery_Signal func_3 = new CmEnergy_Recovery_Signal();
protected CfMaximum func_5 = new CfMaximum();
protected CfMinimum func_7 = new CfMinimum();
protected CfInputMultiplexer func_24 = new CfInputMultiplexer();

// default constructor
public CmControl_Wheel()
{
}

  public void Start()
  {
    func_39.Start();
    func_48.Start();
    func_3.Start();
  }
}
