/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Cooling Control
Macro id:      5767181800387379227
Macro version: 45
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] CoolingSignalStrat
  [2] HumidityMode
  [3] EnableCooling
  [4] DehumSignal
Outputs:
  [1] Valve_Y
Parameter:
  [1] CLG-01: valve increase per minute
  [2] CLG-02: valve minimum position
  [3] CLG-03: valve maximum position
Description:

================================================================================*/

public class CmCooling_Control
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [109] Function call CfCompare1
    func_109.inputA = env.getParameter(parameterOffset);
    func_109.inputB = 100F;
    func_109.Execute(  );

    // [106] Function call CfInputMultiplexer
    func_106.inputSelect = BooleanToInt(func_109.outputLess);
    func_106.input[1-1] = 999999F;
    func_106.input[2-1] = env.getParameter(parameterOffset);
    func_106.Execute(  );

    // [85] Function call CfIdt
    func_85.input = func_106.output;
    func_85.Execute(  );
    env.setParameter(parameterOffset + 3, func_85.output[0]);

    // [135] Function call CfCompare1
    func_135.inputA = CmCooling_Control_input_134;
    func_135.inputB = 2F;
    func_135.Execute(  );

    // [139] Function call CfInputMultiplexer
    func_139.inputSelect = BooleanToInt(func_135.outputGreater);
    func_139.input[1-1] = 0F;
    func_139.input[2-1] = CmCooling_Control_input_134;
    func_139.Execute(  );

    // [124] Function call CfDecimalPlaces
    func_124.input = func_139.output;
    func_124.Execute(  );

    // [125] Function call CfMultiply
    func_125.input[0] = func_124.output;
    func_125.input[1] = 100F;
    func_125.Execute(  );

    // [42] Function call CfMaximum
    func_42.input[0] = env.getParameter(parameterOffset + 1);
    func_42.input[1] = CmCooling_Control_input_48;
    func_42.input[2] = CmCooling_Control_input_146;
    func_42.input[3] = func_125.output;
    func_42.Execute(  );

    // [158] Function call CfMaximum
    func_158.input[0] = func_125.output;
    func_158.input[1] = CmCooling_Control_input_48;
    func_158.input[2] = CmCooling_Control_input_146;
    func_158.Execute(  );

    // [79] Function call CfCompare1
    func_79.inputA = func_158.output;
    func_79.inputB = 0.2F;
    func_79.Execute(  );

    // [31] Function call CfCompare1
    func_31.inputA = 0F;
    func_31.inputB = BooleanToFloat(CmCooling_Control_input_143);
    func_31.Execute(  );

    // [149] Function call CfAnd
    func_149.input[0] = func_79.outputGreater;
    func_149.input[1] = func_31.outputLess;
    func_149.Execute(  );

    // [100] Function call CfInputMultiplexer
    func_100.inputSelect = BooleanToInt(func_149.outputAND);
    func_100.input[1-1] = 0F;
    func_100.input[2-1] = env.getParameter(parameterOffset + 2);
    func_100.Execute(  );

    // [93] Function call CfNot
    func_93.input = FloatToBoolean(func_100.output);
    func_93.Execute(  );

    // [55] Function call CfValueRamp
    func_55.inputValue = func_100.output;
    func_55.inputDisable = func_93.output;
    func_55.Execute( env, parameterOffset + 3 );

    // [21] Function call CfMinimum
    func_21.input[0] = func_42.output;
    func_21.input[1] = env.getParameter(parameterOffset + 2);
    func_21.input[2] = func_55.output;
    func_21.Execute(  );

    // [101] Function call CfMultiply
    func_101.input[0] = func_21.output;
    func_101.input[1] = BooleanToFloat(func_31.outputLess);
    func_101.Execute(  );
    CmCooling_Control_output_36 = func_101.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmCooling_Control_input_48; // CoolingSignalStrat
public float CmCooling_Control_input_134; // HumidityMode
public boolean CmCooling_Control_input_143; // EnableCooling
public float CmCooling_Control_input_146; // DehumSignal
// macro outputs
public float CmCooling_Control_output_36; // Valve_Y
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfCompare1 func_109 = new CfCompare1();
protected CfInputMultiplexer func_106 = new CfInputMultiplexer();
protected CfIdt func_85 = new CfIdt();
protected CfCompare1 func_135 = new CfCompare1();
protected CfInputMultiplexer func_139 = new CfInputMultiplexer();
protected CfDecimalPlaces func_124 = new CfDecimalPlaces();
protected CfMultiply func_125 = new CfMultiply();
protected CfMaximum func_42 = new CfMaximum();
protected CfMaximum func_158 = new CfMaximum();
protected CfCompare1 func_79 = new CfCompare1();
protected CfCompare1 func_31 = new CfCompare1();
protected CfAnd func_149 = new CfAnd();
protected CfInputMultiplexer func_100 = new CfInputMultiplexer();
protected CfNot func_93 = new CfNot();
protected CfValueRamp func_55 = new CfValueRamp();
protected CfMinimum func_21 = new CfMinimum();
protected CfMultiply func_101 = new CfMultiply();

// default constructor
public CmCooling_Control()
{
  func_42.configure(4);
  func_158.configure(3);
  func_21.configure(3);
}

  public void Start()
  {
    func_55.Start();
  }
}
