/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Damper Control Signal
Macro id:      5885912053398372578
Macro version: 37
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] PlantMode
  [2] OutsideAirTemp
  [3] MixedAirTemp
  [4] DamperControlSignal
  [5] DamperEnable
  [6] DamperMinPos
  [7] MixedAirTempUnused
Outputs:
  [1] OutsideAirDamper
  [2] ExaustAirDamper
  [3] MixedAirDamper
Parameter:
  [1] MAT-01 min mixed air temp setpiont
  [2] MAT-02 max mixed air temp setpoint
  [3] MAT-03 mixed air temp control P-band
  [4] OAT-01 min limit outside air temp
  [5] OAT-02 max limit outside air temp
  [6] DMS-01 Y-min Pos damper signal
  [7] DMS-02 Y-max Pos damper signal
  [8] DISP-01 display setpoint mixed air temp
Description:

================================================================================*/

public class CmDamper_Control_Signal
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [12] Function call CfMaximum
    func_12.input[0] = env.getParameter(parameterOffset + 2);
    func_12.input[1] = 1F;
    func_12.Execute(  );

    // [13] Function call CfRamp
    func_13.input = CmDamper_Control_Signal_input_66;
    func_13.Execute( env, parameterOffset + 8 );

    // [14] Function call CfIdt
    func_14.input = env.getParameter(parameterOffset + 3);
    func_14.Execute(  );
    env.setParameter(parameterOffset + 12, func_14.output[0]);
    env.setParameter(parameterOffset + 10, func_14.output[1]);

    // [15] Function call CfIdt
    func_15.input = env.getParameter(parameterOffset + 4);
    func_15.Execute(  );
    env.setParameter(parameterOffset + 14, func_15.output[0]);
    env.setParameter(parameterOffset + 15, func_15.output[1]);

    // [16] Function call CfIdt
    func_16.input = env.getParameter(parameterOffset);
    func_16.Execute(  );
    env.setParameter(parameterOffset + 16, func_16.output[0]);
    env.setParameter(parameterOffset + 18, func_16.output[1]);

    // [17] Function call CfIdt
    func_17.input = env.getParameter(parameterOffset + 1);
    func_17.Execute(  );
    env.setParameter(parameterOffset + 13, func_17.output[0]);

    // [100] Macro call CmIDT20
    func_100.CmIDT20_input_1 = 100F;
    func_100.CmIDT20_input_2 = 0F;
    func_100.CmIDT20_input_3 = 100F;
    func_100.CmIDT20_input_4 = -1F;
    func_100.CmIDT20_input_5 = -1F;
    func_100.CmIDT20_input_6 = env.getParameter(parameterOffset + 5);
    func_100.CmIDT20_input_7 = env.getParameter(parameterOffset + 5);
    func_100.CmIDT20_input_8 = env.getParameter(parameterOffset + 6);
    func_100.CmIDT20_input_9 = 0F;
    func_100.CmIDT20_input_10 = 0F;
    func_100.CmIDT20_input_11 = 100F;
    func_100.CmIDT20_input_12 = 0F;
    func_100.CmIDT20_input_13 = 0F;
    func_100.CmIDT20_input_14 = 0F;
    func_100.CmIDT20_input_15 = 0F;
    func_100.CmIDT20_input_16 = 0F;
    func_100.CmIDT20_input_17 = 0F;
    func_100.CmIDT20_input_18 = 0F;
    func_100.CmIDT20_input_19 = 0F;
    func_100.CmIDT20_input_20 = 0F;
    func_100.Execute(  );
    env.setParameter(parameterOffset + 31, func_100.CmIDT20_output_21);
    env.setParameter(parameterOffset + 30, func_100.CmIDT20_output_22);
    env.setParameter(parameterOffset + 33, func_100.CmIDT20_output_23);
    env.setParameter(parameterOffset + 32, func_100.CmIDT20_output_24);
    env.setParameter(parameterOffset + 34, func_100.CmIDT20_output_25);
    env.setParameter(parameterOffset + 35, func_100.CmIDT20_output_26);
    env.setParameter(parameterOffset + 38, func_100.CmIDT20_output_27);
    env.setParameter(parameterOffset + 40, func_100.CmIDT20_output_28);
    env.setParameter(parameterOffset + 36, func_100.CmIDT20_output_29);
    env.setParameter(parameterOffset + 37, func_100.CmIDT20_output_30);
    env.setParameter(parameterOffset + 39, func_100.CmIDT20_output_31);

    // [125] Function call CfCompare1
    func_125.inputA = env.getParameter(parameterOffset + 3);
    func_125.inputB = -50F;
    func_125.Execute(  );

    // [133] Function call CfCompare1
    func_133.inputA = env.getParameter(parameterOffset + 4);
    func_133.inputB = -50F;
    func_133.Execute(  );

    // [153] Function call CfRamp
    func_153.input = CmDamper_Control_Signal_input_66;
    func_153.Execute( env, parameterOffset + 19 );

    // [162] Macro call CmIDT20
    func_162.CmIDT20_input_1 = 100F;
    func_162.CmIDT20_input_2 = 0F;
    func_162.CmIDT20_input_3 = 100F;
    func_162.CmIDT20_input_4 = -100F;
    func_162.CmIDT20_input_5 = env.getParameter(parameterOffset + 3);
    func_162.CmIDT20_input_6 = env.getParameter(parameterOffset + 5);
    func_162.CmIDT20_input_7 = env.getParameter(parameterOffset + 6);
    func_162.CmIDT20_input_8 = env.getParameter(parameterOffset + 6);
    func_162.CmIDT20_input_9 = env.getParameter(parameterOffset + 4);
    func_162.CmIDT20_input_10 = env.getParameter(parameterOffset + 4);
    func_162.CmIDT20_input_11 = 100F;
    func_162.CmIDT20_input_12 = 0F;
    func_162.CmIDT20_input_13 = 0F;
    func_162.CmIDT20_input_14 = 0F;
    func_162.CmIDT20_input_15 = 0F;
    func_162.CmIDT20_input_16 = 0F;
    func_162.CmIDT20_input_17 = 0F;
    func_162.CmIDT20_input_18 = 0F;
    func_162.CmIDT20_input_19 = 0F;
    func_162.CmIDT20_input_20 = 0F;
    func_162.Execute(  );
    env.setParameter(parameterOffset + 20, func_162.CmIDT20_output_21);
    env.setParameter(parameterOffset + 19, func_162.CmIDT20_output_22);
    env.setParameter(parameterOffset + 22, func_162.CmIDT20_output_23);
    env.setParameter(parameterOffset + 21, func_162.CmIDT20_output_24);
    env.setParameter(parameterOffset + 23, func_162.CmIDT20_output_25);
    env.setParameter(parameterOffset + 24, func_162.CmIDT20_output_26);
    env.setParameter(parameterOffset + 27, func_162.CmIDT20_output_27);
    env.setParameter(parameterOffset + 29, func_162.CmIDT20_output_28);
    env.setParameter(parameterOffset + 25, func_162.CmIDT20_output_29);
    env.setParameter(parameterOffset + 26, func_162.CmIDT20_output_30);
    env.setParameter(parameterOffset + 28, func_162.CmIDT20_output_31);

    // [174] Function call CfCompare1
    func_174.inputA = env.getParameter(parameterOffset);
    func_174.inputB = env.getParameter(parameterOffset + 1);
    func_174.Execute(  );

    // [209] Function call CfMaximum
    func_209.input[0] = env.getParameter(parameterOffset + 5);
    func_209.input[1] = CmDamper_Control_Signal_input_68;
    func_209.Execute(  );

    // [229] Function call CfWindow
    func_229.inputValue = CmDamper_Control_Signal_input_68;
    func_229.inputMinimum = -1.2F;
    func_229.inputMaximum = -0.8F;
    func_229.Execute(  );

    // [235] Function call CfMaximum
    func_235.input[0] = CmDamper_Control_Signal_input_68;
    func_235.input[1] = env.getParameter(parameterOffset + 5);
    func_235.Execute(  );

    // [21] Function call CfDivide
    func_21.inputA = 100F;
    func_21.inputB = func_12.output;
    func_21.Execute(  );

    // [134] Function call CfAnd
    func_134.input[0] = func_125.outputEqual;
    func_134.input[1] = func_133.outputEqual;
    func_134.Execute(  );

    // [160] Function call CfMinimum
    func_160.input[0] = func_153.output;
    func_160.input[1] = CmDamper_Control_Signal_input_68;
    func_160.Execute(  );

    // [183] Function call CfInputMultiplexer
    func_183.inputSelect = BooleanToInt(func_174.outputEqual);
    func_183.input[1-1] = func_13.output;
    func_183.input[2-1] = env.getParameter(parameterOffset);
    func_183.Execute(  );

    // [222] Function call CfMinimum
    func_222.input[0] = func_209.output;
    func_222.input[1] = env.getParameter(parameterOffset + 6);
    func_222.Execute(  );

    // [19] Function call CfIdt
    func_19.input = func_183.output;
    func_19.Execute(  );
    env.setParameter(parameterOffset + 7, func_19.output[0]);

    // [20] Function call CfSubtract
    func_20.input[0] = CmDamper_Control_Signal_input_67;
    func_20.input[1] = func_183.output;
    func_20.Execute(  );

    // [136] Function call CfInputMultiplexer
    func_136.inputSelect = BooleanToInt(func_134.outputAND);
    func_136.input[1-1] = func_160.output;
    func_136.input[2-1] = func_222.output;
    func_136.Execute(  );

    // [22] Function call CfMultiply
    func_22.input[0] = func_20.output;
    func_22.input[1] = func_21.output;
    func_22.Execute(  );

    // [23] Function call CfAddition
    func_23.input[0] = func_22.output;
    func_23.input[1] = 50F;
    func_23.Execute(  );

    // [24] Function call CfMinimum
    func_24.input[0] = func_23.output;
    func_24.input[1] = CmDamper_Control_Signal_input_68;
    func_24.Execute(  );

    // [27] Function call CfRamp
    func_27.input = func_24.output;
    func_27.Execute( env, parameterOffset + 30 );

    // [25] Function call CfInputMultiplexer
    func_25.inputSelect = BooleanToInt(CmDamper_Control_Signal_input_69);
    func_25.input[1-1] = func_27.output;
    func_25.input[2-1] = func_136.output;
    func_25.Execute(  );

    // [26] Function call CfInputMultiplexer
    func_26.inputSelect = BooleanToInt(CmDamper_Control_Signal_input_70);
    func_26.input[1-1] = 0F;
    func_26.input[2-1] = func_25.output;
    func_26.Execute(  );

    // [84] Function call CfInputMultiplexer
    func_84.inputSelect = BooleanToInt(CmDamper_Control_Signal_input_83);
    func_84.input[1-1] = func_26.output;
    func_84.input[2-1] = func_235.output;
    func_84.Execute(  );

    // [227] Function call CfInputMultiplexer
    func_227.inputSelect = BooleanToInt(func_229.output);
    func_227.input[1-1] = func_84.output;
    func_227.input[2-1] = 0F;
    func_227.Execute(  );

    // [230] Function call CfMinimum
    func_230.input[0] = func_227.output;
    func_230.input[1] = 100F;
    func_230.Execute(  );

    // [232] Function call CfMaximum
    func_232.input[0] = func_230.output;
    func_232.input[1] = 0F;
    func_232.Execute(  );

    // [28] Function call CfInputMultiplexer
    func_28.inputSelect = FloatToInt(CmDamper_Control_Signal_input_65);
    func_28.input[1-1] = 0F;
    func_28.input[2-1] = 0F;
    func_28.input[3-1] = 0F;
    func_28.input[4-1] = 100F;
    func_28.input[5-1] = func_232.output;
    func_28.input[6-1] = func_232.output;
    func_28.input[7-1] = 0F;
    func_28.input[8-1] = 0F;
    func_28.input[9-1] = 0F;
    func_28.input[10-1] = 0F;
    func_28.input[11-1] = 0F;
    func_28.input[12-1] = 0F;
    func_28.input[13-1] = 0F;
    func_28.Execute(  );
    CmDamper_Control_Signal_output_71 = func_28.output;

    // [29] Function call CfInputMultiplexer
    func_29.inputSelect = FloatToInt(CmDamper_Control_Signal_input_65);
    func_29.input[1-1] = 0F;
    func_29.input[2-1] = 0F;
    func_29.input[3-1] = 0F;
    func_29.input[4-1] = 100F;
    func_29.input[5-1] = func_232.output;
    func_29.input[6-1] = func_232.output;
    func_29.input[7-1] = 0F;
    func_29.input[8-1] = 0F;
    func_29.input[9-1] = 0F;
    func_29.input[10-1] = 0F;
    func_29.input[11-1] = 0F;
    func_29.input[12-1] = 0F;
    func_29.input[13-1] = 0F;
    func_29.Execute(  );
    CmDamper_Control_Signal_output_72 = func_29.output;

    // [30] Function call CfSubtract
    func_30.input[0] = 100F;
    func_30.input[1] = func_232.output;
    func_30.Execute(  );

    // [31] Function call CfInputMultiplexer
    func_31.inputSelect = FloatToInt(CmDamper_Control_Signal_input_65);
    func_31.input[1-1] = 100F;
    func_31.input[2-1] = 100F;
    func_31.input[3-1] = 100F;
    func_31.input[4-1] = 0F;
    func_31.input[5-1] = func_30.output;
    func_31.input[6-1] = func_30.output;
    func_31.input[7-1] = 100F;
    func_31.input[8-1] = 100F;
    func_31.input[9-1] = 100F;
    func_31.input[10-1] = 100F;
    func_31.input[11-1] = 100F;
    func_31.input[12-1] = 100F;
    func_31.input[13-1] = 100F;
    func_31.Execute(  );
    CmDamper_Control_Signal_output_73 = func_31.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmDamper_Control_Signal_input_65; // PlantMode
public float CmDamper_Control_Signal_input_66; // OutsideAirTemp
public float CmDamper_Control_Signal_input_67; // MixedAirTemp
public float CmDamper_Control_Signal_input_68; // DamperControlSignal
public boolean CmDamper_Control_Signal_input_70; // DamperEnable
public boolean CmDamper_Control_Signal_input_83; // DamperMinPos
public boolean CmDamper_Control_Signal_input_69; // MixedAirTempUnused
// macro outputs
public float CmDamper_Control_Signal_output_71; // OutsideAirDamper
public float CmDamper_Control_Signal_output_72; // ExaustAirDamper
public float CmDamper_Control_Signal_output_73; // MixedAirDamper
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }

// class variables
protected CfMaximum func_12 = new CfMaximum();
protected CfRamp func_13 = new CfRamp();
protected CfIdt func_14 = new CfIdt();
protected CfIdt func_15 = new CfIdt();
protected CfIdt func_16 = new CfIdt();
protected CfIdt func_17 = new CfIdt();
protected CmIDT20 func_100 = new CmIDT20();
protected CfCompare1 func_125 = new CfCompare1();
protected CfCompare1 func_133 = new CfCompare1();
protected CfRamp func_153 = new CfRamp();
protected CmIDT20 func_162 = new CmIDT20();
protected CfCompare1 func_174 = new CfCompare1();
protected CfMaximum func_209 = new CfMaximum();
protected CfWindow func_229 = new CfWindow();
protected CfMaximum func_235 = new CfMaximum();
protected CfDivide func_21 = new CfDivide();
protected CfAnd func_134 = new CfAnd();
protected CfMinimum func_160 = new CfMinimum();
protected CfInputMultiplexer func_183 = new CfInputMultiplexer();
protected CfMinimum func_222 = new CfMinimum();
protected CfIdt func_19 = new CfIdt();
protected CfSubtract func_20 = new CfSubtract();
protected CfInputMultiplexer func_136 = new CfInputMultiplexer();
protected CfMultiply func_22 = new CfMultiply();
protected CfAddition func_23 = new CfAddition();
protected CfMinimum func_24 = new CfMinimum();
protected CfRamp func_27 = new CfRamp();
protected CfInputMultiplexer func_25 = new CfInputMultiplexer();
protected CfInputMultiplexer func_26 = new CfInputMultiplexer();
protected CfInputMultiplexer func_84 = new CfInputMultiplexer();
protected CfInputMultiplexer func_227 = new CfInputMultiplexer();
protected CfMinimum func_230 = new CfMinimum();
protected CfMaximum func_232 = new CfMaximum();
protected CfInputMultiplexer func_28 = new CfInputMultiplexer();
protected CfInputMultiplexer func_29 = new CfInputMultiplexer();
protected CfSubtract func_30 = new CfSubtract();
protected CfInputMultiplexer func_31 = new CfInputMultiplexer();

// default constructor
public CmDamper_Control_Signal()
{
  func_14.configure(2);
  func_15.configure(2);
  func_16.configure(2);
  func_28.configure(14);
  func_29.configure(14);
  func_31.configure(14);
}

  public void Start()
  {
    func_100.Start();
    func_162.Start();
  }
}
