/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Demand As A Function Of The Actual Valve Position
Macro id:      5793138480869539887
Macro version: 17
Last change:   20.03.2015 - 08:49
Access Level:  2
Inputs:
  [1] ValvePosition
Outputs:
  [1] Setpoint
Parameter:
  [1] calculated heating setpoint supply temp. min. setpoint
  [2] calculated heating setpoint supply temp. max. setpoint
  [3] calculated heating setpoint supply temp. start point
  [4] heat demand increase/ decrease value
  [5] heating valve pos. diff. to calculate heating setpoint
Description:
When the heating valve is open more than 50% plus the value defined by parameter
"PositionDifferenceForCalculating", the calculated heating setpoint will be ramped up 
by the value defined by "IncreaseDecreaseValue" (K/min).
When the heating valve is open less that 50% minus the value defined by parameter 
"PositionDifferenceForCalculating", the calculated heating setpoint will be ramped 
down by the value defined by "IncreaseDecreaseValue".
During the time the valve position remains in the higher or lower zone, the setpoint 
will be continuously ramped up or ramped down. When the valve position returns 
into the zone between the minimum / maximum value, the setpoint remains unchanged.
If the heating valve closes to 0%, the setpoint is set to 0°C.
When the heating valve starts to control after a closed position, the calculated 
heating setpoint is reset to its start value, which is defined in parameter 
"SetpointStartpoint".
When the valve is in the control mode, the calculated heating setpoint remains 
within the minimum and maximum values defined by "MinSetpoint" and "MaxSetpoint"

set input ValveExercise to 0 when not used
================================================================================*/

public class CmDemand_As_A_Function_Of_The_Actual_Valve_Position
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [111] Function call CfIdt
    func_111.input = 60F;
    func_111.Execute(  );
    env.setParameter(parameterOffset + 6, func_111.output[0]);
    env.setParameter(parameterOffset + 7, func_111.output[1]);

    // [19] Function call CfHysteresis
    func_19.inputX = CmDemand_As_A_Function_Of_The_Actual_Valve_Position_input_6;
    func_19.inputW = 3F;
    func_19.Execute( env, parameterOffset + 5 );

    // [33] Function call CfSubtract
    func_33.input[0] = 50F;
    func_33.input[1] = env.getParameter(parameterOffset + 4);
    func_33.Execute(  );

    // [37] Function call CfAddition
    func_37.input[0] = 50F;
    func_37.input[1] = env.getParameter(parameterOffset + 4);
    func_37.Execute(  );

    // [34] Function call CfCompare1
    func_34.inputA = func_33.output;
    func_34.inputB = CmDemand_As_A_Function_Of_The_Actual_Valve_Position_input_6;
    func_34.Execute(  );

    // [35] Function call CfCompare1
    func_35.inputA = CmDemand_As_A_Function_Of_The_Actual_Valve_Position_input_6;
    func_35.inputB = func_37.output;
    func_35.Execute(  );

    // [71] Function call CfOr
    func_71.input[0] = func_35.outputGreater;
    func_71.input[1] = func_35.outputEqual;
    func_71.Execute(  );

    // [74] Function call CfOr
    func_74.input[0] = func_34.outputGreater;
    func_74.input[1] = func_34.outputEqual;
    func_74.Execute(  );

    // [45] Function call CfDelay
    func_45.inputA = func_42.outputAND;
    func_45.inputB = func_45.outputAlarm;
    func_45.Execute( env, parameterOffset + 6 );

    // [77] Function call CfNot
    func_77.input = func_45.outputDelayedA;
    func_77.Execute(  );

    // [42] Function call CfAnd
    func_42.input[0] = func_71.outputOR;
    func_42.input[1] = func_77.output;
    func_42.Execute(  );

    // [48] Function call CfDelay
    func_48.inputA = func_40.outputAND;
    func_48.inputB = func_48.outputAlarm;
    func_48.Execute( env, parameterOffset + 7 );

    // [90] Function call CfNot
    func_90.input = func_48.outputDelayedA;
    func_90.Execute(  );

    // [40] Function call CfAnd
    func_40.input[0] = func_74.outputOR;
    func_40.input[1] = func_90.output;
    func_40.Execute(  );

    // [61] Function call CfInputMultiplexer
    func_61.inputSelect = FloatToInt(CmDemand_As_A_Function_Of_The_Actual_Valve_Position_output_7);
    func_61.input[1-1] = env.getParameter(parameterOffset + 2);
    func_61.input[2-1] = CmDemand_As_A_Function_Of_The_Actual_Valve_Position_output_7;
    func_61.Execute(  );

    // [60] Function call CfAddition
    func_60.input[0] = func_61.output;
    func_60.input[1] = env.getParameter(parameterOffset + 3);
    func_60.Execute(  );

    // [62] Function call CfSubtract
    func_62.input[0] = func_61.output;
    func_62.input[1] = env.getParameter(parameterOffset + 3);
    func_62.Execute(  );

    // [57] Function call CfInputMultiplexer
    func_57.inputSelect = BooleanToInt(func_48.outputDelayedA);
    func_57.input[1-1] = func_61.output;
    func_57.input[2-1] = func_62.output;
    func_57.Execute(  );

    // [26] Function call CfInputMultiplexer
    func_26.inputSelect = BooleanToInt(func_45.outputDelayedA);
    func_26.input[1-1] = func_57.output;
    func_26.input[2-1] = func_60.output;
    func_26.Execute(  );

    // [23] Function call CfMinimum
    func_23.input[0] = func_26.output;
    func_23.input[1] = env.getParameter(parameterOffset + 1);
    func_23.Execute(  );

    // [22] Function call CfMaximum
    func_22.input[0] = func_23.output;
    func_22.input[1] = env.getParameter(parameterOffset);
    func_22.Execute(  );

    // [8] Function call CfInputMultiplexer
    func_8.inputSelect = BooleanToInt(func_19.output1);
    func_8.input[1-1] = 0F;
    func_8.input[2-1] = func_22.output;
    func_8.Execute(  );
    CmDemand_As_A_Function_Of_The_Actual_Valve_Position_output_7 = func_8.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmDemand_As_A_Function_Of_The_Actual_Valve_Position_input_6; // ValvePosition
// macro outputs
public float CmDemand_As_A_Function_Of_The_Actual_Valve_Position_output_7; // Setpoint
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }

// class variables
protected CfIdt func_111 = new CfIdt();
protected CfHysteresis func_19 = new CfHysteresis();
protected CfSubtract func_33 = new CfSubtract();
protected CfAddition func_37 = new CfAddition();
protected CfCompare1 func_34 = new CfCompare1();
protected CfCompare1 func_35 = new CfCompare1();
protected CfOr func_71 = new CfOr();
protected CfOr func_74 = new CfOr();
protected CfDelay func_45 = new CfDelay();
protected CfNot func_77 = new CfNot();
protected CfAnd func_42 = new CfAnd();
protected CfDelay func_48 = new CfDelay();
protected CfNot func_90 = new CfNot();
protected CfAnd func_40 = new CfAnd();
protected CfInputMultiplexer func_61 = new CfInputMultiplexer();
protected CfAddition func_60 = new CfAddition();
protected CfSubtract func_62 = new CfSubtract();
protected CfInputMultiplexer func_57 = new CfInputMultiplexer();
protected CfInputMultiplexer func_26 = new CfInputMultiplexer();
protected CfMinimum func_23 = new CfMinimum();
protected CfMaximum func_22 = new CfMaximum();
protected CfInputMultiplexer func_8 = new CfInputMultiplexer();

// default constructor
public CmDemand_As_A_Function_Of_The_Actual_Valve_Position()
{
  func_111.configure(2);
}

  public void Start()
  {
    func_19.Start();
    func_45.Start();
    func_48.Start();
  }
}
