/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Discharge Air Temperature Control
Macro id:      5802022136035934756
Macro version: 19
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] DATSensor
  [2] FilteredOAT
  [3] PlantMode1,2,4,5,6,30
  [4] Incr/DecrFrostRecovery
  [5] OAT>LimitOAT-03
Outputs:
  [1] DATControl
  [2] DATsetpoint
Parameter:
  [1] SYS-01: heating coil type selection
  [2] DAT-01: discharge air temperature control
  [3] DAT-02: discharge air temperature low setpoint
  [4] DAT-03: discharge air temperature high setpoint
  [5] DAT-04: discharge air temperature P-band
  [6] DAT-05: discharge air temperature I-time
  [7] OAT-01: outside air temperature minimum limit
  [8] OAT-02: outside air temperature maximum limit
Description:

================================================================================*/

public class CmDischarge_Air_Temperature_Control
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [220] Function call CfIdt
    func_220.input = env.getParameter(parameterOffset + 4);
    func_220.Execute(  );
    env.setParameter(parameterOffset + 8, func_220.output[0]);

    // [221] Function call CfIdt
    func_221.input = env.getParameter(parameterOffset + 5);
    func_221.Execute(  );
    env.setParameter(parameterOffset + 10, func_221.output[0]);

    // [222] Function call CfCompare1
    func_222.inputA = env.getParameter(parameterOffset);
    func_222.inputB = 2F;
    func_222.Execute(  );

    // [223] Function call CfSubtract
    func_223.input[0] = env.getParameter(parameterOffset + 3);
    func_223.input[1] = env.getParameter(parameterOffset + 2);
    func_223.Execute(  );

    // [224] Function call CfSubtract
    func_224.input[0] = CmDischarge_Air_Temperature_Control_input_245;
    func_224.input[1] = env.getParameter(parameterOffset + 7);
    func_224.Execute(  );

    // [225] Function call CfSubtract
    func_225.input[0] = env.getParameter(parameterOffset + 6);
    func_225.input[1] = env.getParameter(parameterOffset + 7);
    func_225.Execute(  );

    // [239] Function call CfCompare1
    func_239.inputA = CmDischarge_Air_Temperature_Control_input_244;
    func_239.inputB = 999F;
    func_239.Execute(  );

    // [240] Function call CfCompare1
    func_240.inputA = env.getParameter(parameterOffset + 1);
    func_240.inputB = 2F;
    func_240.Execute(  );

    // [241] Function call CfCompare1
    func_241.inputA = env.getParameter(parameterOffset + 1);
    func_241.inputB = 1F;
    func_241.Execute(  );

    // [257] Function call CfNot
    func_257.input = FloatToBoolean(CmDischarge_Air_Temperature_Control_input_246);
    func_257.Execute(  );

    // [226] Function call CfAnd
    func_226.input[0] = FloatToBoolean(CmDischarge_Air_Temperature_Control_input_246);
    func_226.input[1] = func_240.outputEqual;
    func_226.Execute(  );

    // [227] Function call CfMinimum
    func_227.input[0] = func_225.output;
    func_227.input[1] = -0.008F;
    func_227.Execute(  );

    // [228] Function call CfAnd
    func_228.input[0] = func_257.output;
    func_228.input[1] = func_241.outputEqual;
    func_228.Execute(  );

    // [238] Function call CfAnd
    func_238.input[0] = func_240.outputEqual;
    func_238.input[1] = CmDischarge_Air_Temperature_Control_input_259;
    func_238.input[2] = func_257.output;
    func_238.Execute(  );

    // [229] Function call CfDivide
    func_229.inputA = func_224.output;
    func_229.inputB = func_227.output;
    func_229.Execute(  );

    // [230] Function call CfMaximum
    func_230.input[0] = BooleanToFloat(func_239.outputEqual);
    func_230.input[1] = BooleanToFloat(func_222.outputEqual);
    func_230.input[2] = BooleanToFloat(func_226.outputAND);
    func_230.input[3] = BooleanToFloat(func_238.outputAND);
    func_230.input[4] = BooleanToFloat(func_228.outputAND);
    func_230.Execute(  );

    // [231] Function call CfMultiply
    func_231.input[0] = func_229.output;
    func_231.input[1] = func_223.output;
    func_231.Execute(  );

    // [232] Function call CfAddition
    func_232.input[0] = func_231.output;
    func_232.input[1] = env.getParameter(parameterOffset + 2);
    func_232.Execute(  );

    // [233] Function call CfMaximum
    func_233.input[0] = func_232.output;
    func_233.input[1] = env.getParameter(parameterOffset + 2);
    func_233.Execute(  );

    // [234] Function call CfMinimum
    func_234.input[0] = func_233.output;
    func_234.input[1] = env.getParameter(parameterOffset + 3);
    func_234.Execute(  );

    // [235] Function call CfAddition
    func_235.input[0] = func_234.output;
    func_235.input[1] = CmDischarge_Air_Temperature_Control_input_247;
    func_235.Execute(  );

    // [236] Function call CfPidPlus
    func_236.inputX = CmDischarge_Air_Temperature_Control_input_244;
    func_236.inputW = func_235.output;
    func_236.inputIntegralOn = true;
    func_236.Execute( env, parameterOffset + 8 );

    // [272] Function call CfIdt
    func_272.input = func_235.output;
    func_272.Execute(  );
    CmDischarge_Air_Temperature_Control_output_271 = func_272.output[0];

    // [237] Function call CfInputMultiplexer
    func_237.inputSelect = FloatToInt(func_230.output);
    func_237.input[1-1] = func_236.output;
    func_237.input[2-1] = 0F;
    func_237.Execute(  );
    CmDischarge_Air_Temperature_Control_output_243 = func_237.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmDischarge_Air_Temperature_Control_input_244; // DATSensor
public float CmDischarge_Air_Temperature_Control_input_245; // FilteredOAT
public float CmDischarge_Air_Temperature_Control_input_246; // PlantMode1,2,4,5,6,30
public float CmDischarge_Air_Temperature_Control_input_247; // Incr/DecrFrostRecovery
public boolean CmDischarge_Air_Temperature_Control_input_259; // OAT>LimitOAT-03
// macro outputs
public float CmDischarge_Air_Temperature_Control_output_243; // DATControl
public float CmDischarge_Air_Temperature_Control_output_271; // DATsetpoint
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfIdt func_220 = new CfIdt();
protected CfIdt func_221 = new CfIdt();
protected CfCompare1 func_222 = new CfCompare1();
protected CfSubtract func_223 = new CfSubtract();
protected CfSubtract func_224 = new CfSubtract();
protected CfSubtract func_225 = new CfSubtract();
protected CfCompare1 func_239 = new CfCompare1();
protected CfCompare1 func_240 = new CfCompare1();
protected CfCompare1 func_241 = new CfCompare1();
protected CfNot func_257 = new CfNot();
protected CfAnd func_226 = new CfAnd();
protected CfMinimum func_227 = new CfMinimum();
protected CfAnd func_228 = new CfAnd();
protected CfAnd func_238 = new CfAnd();
protected CfDivide func_229 = new CfDivide();
protected CfMaximum func_230 = new CfMaximum();
protected CfMultiply func_231 = new CfMultiply();
protected CfAddition func_232 = new CfAddition();
protected CfMaximum func_233 = new CfMaximum();
protected CfMinimum func_234 = new CfMinimum();
protected CfAddition func_235 = new CfAddition();
protected CfPidPlus func_236 = new CfPidPlus();
protected CfIdt func_272 = new CfIdt();
protected CfInputMultiplexer func_237 = new CfInputMultiplexer();

// default constructor
public CmDischarge_Air_Temperature_Control()
{
  func_238.configure(3);
  func_230.configure(5);
}

  public void Start()
  {
    func_236.Start();
  }
}
