/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Enable Cooling
Macro id:      5766116139318903423
Macro version: 20
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] PlantMode
  [2] HumidityMode
Outputs:
  [1] CoolingEnable
Parameter:
  [1] HUM-01: cooling off during humidity
Description:
- Humidity mode
An internal datapoint (Humidity_Mode) from the humidity control module is decoded 
to override the cooling valve output signal to 0% if the Humidity_Mode equals “1” 
and parameter P15 is set to “1”. 
This prevents cooling and humidification at the same time.


- Plant mode
An internal datapoint (Plant_Mode) from the control strategy module is decoded to 
provide the required cooling valve output signal.

Plant_Mode	Code	Cooling Valve
Off	                0	closed
Optimum start	1	auto
Night cycle	2	auto
Night purge	3	closed
Occupied period	4	auto
Extended operation	5	auto
Delayed switch off	6	auto
Duty cycling 	11	closed
Power demand        12	closed		
Frost protection	20	closed
Fan failure	21	closed		
Fire override	30	closed

- Cooling disable based on outside temperature
If the filtered outside air temperature is below a certain value, e.g. 10…14 °C and there is
no need for either cooling or dehumidification, the valve can be forced to a closed 
position. The value has a fixed differential of 1K.
Note: To disable this function set input OATCoolingLimit to a value of  -50°C.

-CoolingDisable input
default "0", when "1" cooling is disabled
================================================================================*/

public class CmEnable_Cooling
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [53] Function call CfEqual
    func_53.input = FloatToInt(CmEnable_Cooling_input_3);
    func_53.inputCompare[1-1] = 1;
    func_53.inputCompare[2-1] = 2;
    func_53.inputCompare[3-1] = 4;
    func_53.inputCompare[4-1] = 5;
    func_53.inputCompare[5-1] = 6;
    func_53.Execute(  );

    // [69] Function call CfTruncate
    func_69.input = CmEnable_Cooling_input_4;
    func_69.Execute(  );

    // [70] Function call CfCompare1
    func_70.inputA = func_69.output;
    func_70.inputB = 1F;
    func_70.Execute(  );

    // [63] Function call CfAnd
    func_63.input[0] = FloatToBoolean(env.getParameter(parameterOffset));
    func_63.input[1] = func_70.outputEqual;
    func_63.Execute(  );

    // [41] Function call CfAnd
    func_41.input[0] = func_53.output;
    func_41.input[1] = func_63.outputNAND;
    func_41.Execute(  );
    CmEnable_Cooling_output_54 = func_41.outputAND;

  }
// macro register which are written multiple times
// macro inputs
public float CmEnable_Cooling_input_3; // PlantMode
public float CmEnable_Cooling_input_4; // HumidityMode
// macro outputs
public boolean CmEnable_Cooling_output_54; // CoolingEnable
// helper functions
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfEqual func_53 = new CfEqual();
protected CfTruncate func_69 = new CfTruncate();
protected CfCompare1 func_70 = new CfCompare1();
protected CfAnd func_63 = new CfAnd();
protected CfAnd func_41 = new CfAnd();

// default constructor
public CmEnable_Cooling()
{
  func_53.configure(6);
}

  public void Start()
  {
  }
}
