/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Enable Hum/Dehum
Macro id:      5855110382377500898
Macro version: 23
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] Airflow switch
  [2] Shutdown alarm
  [3] Outside air temperature
  [4] Humidity control signal
  [5] Dehumidity control signal
  [6] OAT high limit for humidification
  [7] OAT low limit for dehumidification
  [8] Delay after fan start
  [9] PlantMode
Outputs:
  [1] Humidity control signal
  [2] Dehumidity control signal
  [3] Enable Humidity
  [4] Enable Dehumidity
  [5] disable hum setp
  [6] disable dehum setp
Parameter:
  [1] P02 OAT high limit for humidification
  [2] P03 OAT low limit for dehumidification
  [3] P22 FDP: delay after fan start
Description:

================================================================================*/

public class CmEnable_HumDehum
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [12] Function call CfIdt
    func_12.input = 1F;
    func_12.Execute(  );
    env.setParameter(parameterOffset + 3, func_12.output[0]);
    env.setParameter(parameterOffset + 4, func_12.output[1]);

    // [13] Function call CfHysteresis
    func_13.inputX = CmEnable_HumDehum_input_55;
    func_13.inputW = CmEnable_HumDehum_input_52;
    func_13.Execute( env, parameterOffset + 3 );

    // [14] Function call CfHysteresis
    func_14.inputX = CmEnable_HumDehum_input_52;
    func_14.inputW = CmEnable_HumDehum_input_56;
    func_14.Execute( env, parameterOffset + 4 );

    // [15] Function call CfCompare1
    func_15.inputA = CmEnable_HumDehum_input_53;
    func_15.inputB = 1F;
    func_15.Execute(  );

    // [16] Function call CfCompare1
    func_16.inputA = CmEnable_HumDehum_input_54;
    func_16.inputB = 1F;
    func_16.Execute(  );

    // [19] Function call CfIdt
    func_19.input = CmEnable_HumDehum_input_57;
    func_19.Execute(  );
    env.setParameter(parameterOffset + 5, func_19.output[0]);
    env.setParameter(parameterOffset + 6, func_19.output[1]);

    // [61] Function call CfIdt
    func_61.input = BooleanToFloat(CmEnable_HumDehum_input_51);
    func_61.Execute(  );

    // [67] Function call CfNot
    func_67.input = CmEnable_HumDehum_input_63;
    func_67.Execute(  );

    // [101] Function call CfCompare1
    func_101.inputA = CmEnable_HumDehum_input_52;
    func_101.inputB = 999F;
    func_101.Execute(  );

    // [120] Function call CfWindow
    func_120.inputValue = CmEnable_HumDehum_input_122;
    func_120.inputMinimum = 3.9F;
    func_120.inputMaximum = 5.1F;
    func_120.Execute(  );

    // [99] Function call CfInputMultiplexer
    func_99.inputSelect = BooleanToInt(func_101.outputEqual);
    func_99.input[1-1] = BooleanToFloat(func_13.output1);
    func_99.input[2-1] = 1F;
    func_99.Execute(  );

    // [111] Function call CfInputMultiplexer
    func_111.inputSelect = BooleanToInt(func_101.outputEqual);
    func_111.input[1-1] = BooleanToFloat(func_14.output1);
    func_111.input[2-1] = 1F;
    func_111.Execute(  );

    // [17] Function call CfAnd
    func_17.input[0] = func_67.output;
    func_17.input[1] = FloatToBoolean(func_99.output);
    func_17.input[2] = FloatToBoolean(func_61.output[0]);
    func_17.input[3] = func_16.outputLess;
    func_17.input[4] = func_120.output;
    func_17.Execute(  );

    // [18] Function call CfAnd
    func_18.input[0] = FloatToBoolean(func_61.output[0]);
    func_18.input[1] = FloatToBoolean(func_111.output);
    func_18.input[2] = func_15.outputLess;
    func_18.input[3] = func_120.output;
    func_18.Execute(  );

    // [112] Function call CfAnd
    func_112.input[0] = FloatToBoolean(func_61.output[0]);
    func_112.input[1] = FloatToBoolean(func_111.output);
    func_112.Execute(  );
    CmEnable_HumDehum_output_116 = func_112.outputNAND;

    // [117] Function call CfAnd
    func_117.input[0] = func_67.output;
    func_117.input[1] = FloatToBoolean(func_61.output[0]);
    func_117.input[2] = FloatToBoolean(func_99.output);
    func_117.Execute(  );
    CmEnable_HumDehum_output_115 = func_117.outputNAND;

    // [20] Function call CfDelay
    func_20.inputA = func_17.outputAND;
    func_20.inputB = func_17.outputAND;
    func_20.Execute( env, parameterOffset + 5 );

    // [21] Function call CfDelay
    func_21.inputA = func_18.outputAND;
    func_21.inputB = func_18.outputAND;
    func_21.Execute( env, parameterOffset + 6 );

    // [94] Function call CfIdt
    func_94.input = BooleanToFloat(func_20.outputDelayedA);
    func_94.Execute(  );
    CmEnable_HumDehum_output_92 = FloatToBoolean(func_94.output[1]);

    // [97] Function call CfIdt
    func_97.input = BooleanToFloat(func_21.outputDelayedA);
    func_97.Execute(  );
    CmEnable_HumDehum_output_93 = FloatToBoolean(func_97.output[1]);

    // [76] Function call CfInputMultiplexer
    func_76.inputSelect = FloatToInt(func_94.output[0]);
    func_76.input[1-1] = 0F;
    func_76.input[2-1] = CmEnable_HumDehum_input_53;
    func_76.Execute(  );
    CmEnable_HumDehum_output_64 = func_76.output;

    // [79] Function call CfInputMultiplexer
    func_79.inputSelect = FloatToInt(func_97.output[0]);
    func_79.input[1-1] = 0F;
    func_79.input[2-1] = CmEnable_HumDehum_input_54;
    func_79.Execute(  );
    CmEnable_HumDehum_output_65 = func_79.output;

  }
// macro register which are written multiple times
// macro inputs
public boolean CmEnable_HumDehum_input_51; // Airflow switch
public boolean CmEnable_HumDehum_input_63; // Shutdown alarm
public float CmEnable_HumDehum_input_52; // Outside air temperature
public float CmEnable_HumDehum_input_53; // Humidity control signal
public float CmEnable_HumDehum_input_54; // Dehumidity control signal
public float CmEnable_HumDehum_input_55; // OAT high limit for humidification
public float CmEnable_HumDehum_input_56; // OAT low limit for dehumidification
public float CmEnable_HumDehum_input_57; // Delay after fan start
public float CmEnable_HumDehum_input_122; // PlantMode
// macro outputs
public float CmEnable_HumDehum_output_64; // Humidity control signal
public float CmEnable_HumDehum_output_65; // Dehumidity control signal
public boolean CmEnable_HumDehum_output_92; // Enable Humidity
public boolean CmEnable_HumDehum_output_93; // Enable Dehumidity
public boolean CmEnable_HumDehum_output_115; // disable hum setp
public boolean CmEnable_HumDehum_output_116; // disable dehum setp
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfIdt func_12 = new CfIdt();
protected CfHysteresis func_13 = new CfHysteresis();
protected CfHysteresis func_14 = new CfHysteresis();
protected CfCompare1 func_15 = new CfCompare1();
protected CfCompare1 func_16 = new CfCompare1();
protected CfIdt func_19 = new CfIdt();
protected CfIdt func_61 = new CfIdt();
protected CfNot func_67 = new CfNot();
protected CfCompare1 func_101 = new CfCompare1();
protected CfWindow func_120 = new CfWindow();
protected CfInputMultiplexer func_99 = new CfInputMultiplexer();
protected CfInputMultiplexer func_111 = new CfInputMultiplexer();
protected CfAnd func_17 = new CfAnd();
protected CfAnd func_18 = new CfAnd();
protected CfAnd func_112 = new CfAnd();
protected CfAnd func_117 = new CfAnd();
protected CfDelay func_20 = new CfDelay();
protected CfDelay func_21 = new CfDelay();
protected CfIdt func_94 = new CfIdt();
protected CfIdt func_97 = new CfIdt();
protected CfInputMultiplexer func_76 = new CfInputMultiplexer();
protected CfInputMultiplexer func_79 = new CfInputMultiplexer();

// default constructor
public CmEnable_HumDehum()
{
  func_12.configure(2);
  func_19.configure(2);
  func_17.configure(5);
  func_18.configure(4);
  func_117.configure(3);
  func_94.configure(2);
  func_97.configure(2);
}

  public void Start()
  {
    func_13.Start();
    func_14.Start();
    func_20.Start();
    func_21.Start();
  }
}
