/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Enable Optimization
Macro id:      5922317166351221088
Macro version: 17
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] Occ_Period
  [2] OptimEnable
  [3] OptimMode
  [4] ManSwCond
  [5] EnableHeating
  [6] EnableCooling
Outputs:
  [1] EnOptimStartHeatingSP
  [2] EnOptimStartCoolingSP
  [3] EnOptimStop
Parameter:
  [1] OPT-01: optimum start heating; 1 = enable
  [2] OPT-02: optimum stop heating; 1 = enable
  [3] OPT-03: optimum start cooling; 1 = enable
  [4] OPT-04: optimum stop cooling; 1 = enable
Description:

================================================================================*/

public class CmEnable_Optimization
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [11] Function call CfNextSchedule
    func_11.input = CmEnable_Optimization_input_1;
    func_11.Execute( env, parameterOffset + 4 );

    // [20] Function call CfNextSchedule
    func_20.input = CmEnable_Optimization_input_1;
    func_20.Execute( env, parameterOffset + 5 );

    // [22] Function call CfOr
    func_22.input[0] = FloatToBoolean(env.getParameter(parameterOffset + 1));
    func_22.input[1] = FloatToBoolean(env.getParameter(parameterOffset + 3));
    func_22.Execute(  );

    // [36] Function call CfWindow
    func_36.inputValue = CmEnable_Optimization_input_2;
    func_36.inputMinimum = 998.8F;
    func_36.inputMaximum = 999.2F;
    func_36.Execute(  );

    // [52] Function call CfWindow
    func_52.inputValue = CmEnable_Optimization_input_3;
    func_52.inputMinimum = 0.8F;
    func_52.inputMaximum = 1.2F;
    func_52.Execute(  );

    // [54] Function call CfWindow
    func_54.inputValue = CmEnable_Optimization_input_3;
    func_54.inputMinimum = -0.2F;
    func_54.inputMaximum = 0.2F;
    func_54.Execute(  );

    // [58] Function call CfWindow
    func_58.inputValue = CmEnable_Optimization_input_2;
    func_58.inputMinimum = 998.8F;
    func_58.inputMaximum = 999.2F;
    func_58.Execute(  );

    // [61] Function call CfWindow
    func_61.inputValue = CmEnable_Optimization_input_2;
    func_61.inputMinimum = 0.8F;
    func_61.inputMaximum = 2.2F;
    func_61.Execute(  );

    // [72] Function call CfWindow
    func_72.inputValue = CmEnable_Optimization_input_2;
    func_72.inputMinimum = 0.8F;
    func_72.inputMaximum = 2.2F;
    func_72.Execute(  );

    // [84] Function call CfWindow
    func_84.inputValue = CmEnable_Optimization_input_81;
    func_84.inputMinimum = -0.2F;
    func_84.inputMaximum = 0.2F;
    func_84.Execute(  );

    // [87] Function call CfWindow
    func_87.inputValue = CmEnable_Optimization_input_81;
    func_87.inputMinimum = -0.2F;
    func_87.inputMaximum = 0.2F;
    func_87.Execute(  );

    // [91] Function call CfWindow
    func_91.inputValue = CmEnable_Optimization_input_81;
    func_91.inputMinimum = -0.2F;
    func_91.inputMaximum = 0.2F;
    func_91.Execute(  );

    // [31] Function call CfNot
    func_31.input = FloatToBoolean(func_20.outputNextValue);
    func_31.Execute(  );

    // [62] Function call CfOr
    func_62.input[0] = func_61.output;
    func_62.input[1] = func_58.output;
    func_62.Execute(  );

    // [73] Function call CfOr
    func_73.input[0] = func_72.output;
    func_73.input[1] = func_36.output;
    func_73.Execute(  );

    // [85] Function call CfNot
    func_85.input = func_84.output;
    func_85.Execute(  );

    // [88] Function call CfNot
    func_88.input = func_87.output;
    func_88.Execute(  );

    // [92] Function call CfNot
    func_92.input = func_91.output;
    func_92.Execute(  );

    // [98] Function call CfAnd
    func_98.input[0] = func_52.output;
    func_98.input[1] = CmEnable_Optimization_input_96;
    func_98.Execute(  );

    // [102] Function call CfAnd
    func_102.input[0] = func_54.output;
    func_102.input[1] = CmEnable_Optimization_input_97;
    func_102.Execute(  );

    // [21] Function call CfAnd
    func_21.input[0] = func_62.outputOR;
    func_21.input[1] = func_31.output;
    func_21.Execute(  );

    // [39] Function call CfAnd
    func_39.input[0] = func_73.outputOR;
    func_39.input[1] = FloatToBoolean(func_11.outputNextValue);
    func_39.Execute(  );

    // [42] Function call CfAnd
    func_42.input[0] = func_22.outputOR;
    func_42.input[1] = func_21.outputAND;
    func_42.input[2] = func_92.output;
    func_42.Execute(  );
    CmEnable_Optimization_output_48 = func_42.outputAND;

    // [51] Function call CfAnd
    func_51.input[0] = func_98.outputAND;
    func_51.input[1] = FloatToBoolean(env.getParameter(parameterOffset));
    func_51.input[2] = func_39.outputAND;
    func_51.input[3] = func_85.output;
    func_51.Execute(  );
    CmEnable_Optimization_output_5 = func_51.outputAND;

    // [55] Function call CfAnd
    func_55.input[0] = func_102.outputAND;
    func_55.input[1] = FloatToBoolean(env.getParameter(parameterOffset + 2));
    func_55.input[2] = func_39.outputAND;
    func_55.input[3] = func_88.output;
    func_55.Execute(  );
    CmEnable_Optimization_output_6 = func_55.outputAND;

  }
// macro register which are written multiple times
// macro inputs
public float CmEnable_Optimization_input_1; // Occ_Period
public float CmEnable_Optimization_input_2; // OptimEnable
public float CmEnable_Optimization_input_3; // OptimMode
public float CmEnable_Optimization_input_81; // ManSwCond
public boolean CmEnable_Optimization_input_96; // EnableHeating
public boolean CmEnable_Optimization_input_97; // EnableCooling
// macro outputs
public boolean CmEnable_Optimization_output_5; // EnOptimStartHeatingSP
public boolean CmEnable_Optimization_output_6; // EnOptimStartCoolingSP
public boolean CmEnable_Optimization_output_48; // EnOptimStop
// helper functions
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfNextSchedule func_11 = new CfNextSchedule();
protected CfNextSchedule func_20 = new CfNextSchedule();
protected CfOr func_22 = new CfOr();
protected CfWindow func_36 = new CfWindow();
protected CfWindow func_52 = new CfWindow();
protected CfWindow func_54 = new CfWindow();
protected CfWindow func_58 = new CfWindow();
protected CfWindow func_61 = new CfWindow();
protected CfWindow func_72 = new CfWindow();
protected CfWindow func_84 = new CfWindow();
protected CfWindow func_87 = new CfWindow();
protected CfWindow func_91 = new CfWindow();
protected CfNot func_31 = new CfNot();
protected CfOr func_62 = new CfOr();
protected CfOr func_73 = new CfOr();
protected CfNot func_85 = new CfNot();
protected CfNot func_88 = new CfNot();
protected CfNot func_92 = new CfNot();
protected CfAnd func_98 = new CfAnd();
protected CfAnd func_102 = new CfAnd();
protected CfAnd func_21 = new CfAnd();
protected CfAnd func_39 = new CfAnd();
protected CfAnd func_42 = new CfAnd();
protected CfAnd func_51 = new CfAnd();
protected CfAnd func_55 = new CfAnd();

// default constructor
public CmEnable_Optimization()
{
  func_42.configure(3);
  func_51.configure(4);
  func_55.configure(4);
}

  public void Start()
  {
  }
}
