/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Enables
Macro id:      5800547172726342010
Macro version: 14
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] Release
  [2] HighPressureSensor
Outputs:
  [1] PressureSensor_I_Enable
  [2] Recirc_I_Enable
  [3] HighPressureSensor_999
Parameter:
  [1] DSP-03: Itime static pressure control
  [2] SAF-03: Itime flow balance control
Description:

================================================================================*/

public class CmEnables
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [14] Function call CfIdt
    func_14.input = env.getParameter(parameterOffset);
    func_14.Execute(  );
    env.setParameter(parameterOffset + 2, func_14.output[0]);

    // [18] Function call CfIdt
    func_18.input = env.getParameter(parameterOffset + 1);
    func_18.Execute(  );
    env.setParameter(parameterOffset + 3, func_18.output[0]);

    // [6] Function call CfIdt
    func_6.input = BooleanToFloat(CmEnables_input_3);
    func_6.Execute(  );

    // [8] Function call CfDelay
    func_8.inputA = FloatToBoolean(func_6.output[0]);
    func_8.inputB = FloatToBoolean(func_6.output[0]);
    func_8.Execute( env, parameterOffset + 2 );

    // [11] Function call CfIdt
    func_11.input = BooleanToFloat(func_8.outputDelayedA);
    func_11.Execute(  );
    CmEnables_output_13 = FloatToBoolean(func_11.output[0]);

    // [19] Function call CfIdt
    func_19.input = BooleanToFloat(CmEnables_input_3);
    func_19.Execute(  );

    // [20] Function call CfDelay
    func_20.inputA = FloatToBoolean(func_19.output[0]);
    func_20.inputB = FloatToBoolean(func_19.output[0]);
    func_20.Execute( env, parameterOffset + 3 );

    // [21] Function call CfIdt
    func_21.input = BooleanToFloat(func_20.outputDelayedA);
    func_21.Execute(  );
    CmEnables_output_26 = FloatToBoolean(func_21.output[0]);

    // [29] Function call CfIdt
    func_29.input = CmEnables_input_27;
    func_29.Execute(  );

    // [31] Function call CfCompare1
    func_31.inputA = func_29.output[0];
    func_31.inputB = 999F;
    func_31.Execute(  );

    // [40] Function call CfAnd
    func_40.input[0] = func_31.outputEqual;
    func_40.input[1] = func_37.outputOR;
    func_40.Execute(  );

    // [37] Function call CfOr
    func_37.input[0] = ControlFunction.GetStartupFlag();
    func_37.input[1] = func_40.outputAND;
    func_37.Execute(  );

    // [36] Function call CfIdt
    func_36.input = BooleanToFloat(func_37.outputOR);
    func_36.Execute(  );
    CmEnables_output_28 = FloatToBoolean(func_36.output[0]);

  }
// macro register which are written multiple times
// macro inputs
public boolean CmEnables_input_3; // Release
public float CmEnables_input_27; // HighPressureSensor
// macro outputs
public boolean CmEnables_output_13; // PressureSensor_I_Enable
public boolean CmEnables_output_26; // Recirc_I_Enable
public boolean CmEnables_output_28; // HighPressureSensor_999
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfIdt func_14 = new CfIdt();
protected CfIdt func_18 = new CfIdt();
protected CfIdt func_6 = new CfIdt();
protected CfDelay func_8 = new CfDelay();
protected CfIdt func_11 = new CfIdt();
protected CfIdt func_19 = new CfIdt();
protected CfDelay func_20 = new CfDelay();
protected CfIdt func_21 = new CfIdt();
protected CfIdt func_29 = new CfIdt();
protected CfCompare1 func_31 = new CfCompare1();
protected CfAnd func_40 = new CfAnd();
protected CfOr func_37 = new CfOr();
protected CfIdt func_36 = new CfIdt();

// default constructor
public CmEnables()
{
}

  public void Start()
  {
    func_8.Start();
    func_20.Start();
  }
}
