/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Energy Recovery Signal
Macro id:      5867333301370356152
Macro version: 19
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] EnRecSignal
  [2] LowInletAirTemp
  [3] RetAirTemp
  [4] FailOutput
Outputs:
  [1] EnRecovSignal_Y
Parameter:
  [1] ERS-01: minimum energy recovery control signal
  [2] ERS-02: maximum energy recovery control signal
  [3] ERS-03: difference IAT, RAT control signal sequence start
  [4] ERS-04: difference IAT, RAT control signal sequence stop
Description:

================================================================================*/

public class CmEnergy_Recovery_Signal
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [26] Function call CfSubtract
    func_26.input[0] = CmEnergy_Recovery_Signal_input_2;
    func_26.input[1] = CmEnergy_Recovery_Signal_input_3;
    func_26.Execute(  );

    // [9] Function call CfCompare1
    func_9.inputA = CmEnergy_Recovery_Signal_input_1;
    func_9.inputB = 999F;
    func_9.Execute(  );

    // [38] Function call CfCompare1
    func_38.inputA = CmEnergy_Recovery_Signal_input_3;
    func_38.inputB = 999F;
    func_38.Execute(  );

    // [15] Function call CfLinearConverter
    func_15.inputValue = func_26.output;
    func_15.inputInLimit1 = env.getParameter(parameterOffset + 2);
    func_15.inputInLimit2 = env.getParameter(parameterOffset + 3);
    func_15.inputOutLimit1 = env.getParameter(parameterOffset);
    func_15.inputOutLimit2 = env.getParameter(parameterOffset + 1);
    func_15.Execute(  );

    // [17] Function call CfLinearConverter
    func_17.inputValue = CmEnergy_Recovery_Signal_input_1;
    func_17.inputInLimit1 = 0F;
    func_17.inputInLimit2 = 100F;
    func_17.inputOutLimit1 = env.getParameter(parameterOffset);
    func_17.inputOutLimit2 = env.getParameter(parameterOffset + 1);
    func_17.Execute(  );

    // [52] Function call CfCompare1
    func_52.inputA = CmEnergy_Recovery_Signal_input_2;
    func_52.inputB = 700F;
    func_52.Execute(  );

    // [57] Function call CfOr
    func_57.input[0] = func_38.outputEqual;
    func_57.input[1] = func_52.outputGreater;
    func_57.Execute(  );

    // [59] Function call CfInputMultiplexer
    func_59.inputSelect = BooleanToInt(func_57.outputOR);
    func_59.input[1-1] = func_15.output;
    func_59.input[2-1] = CmEnergy_Recovery_Signal_input_62;
    func_59.Execute(  );

    // [50] Function call CfInputMultiplexer
    func_50.inputSelect = BooleanToInt(func_9.outputEqual);
    func_50.input[1-1] = func_17.output;
    func_50.input[2-1] = func_59.output;
    func_50.Execute(  );
    CmEnergy_Recovery_Signal_output_4 = func_50.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmEnergy_Recovery_Signal_input_1; // EnRecSignal
public float CmEnergy_Recovery_Signal_input_2; // LowInletAirTemp
public float CmEnergy_Recovery_Signal_input_3; // RetAirTemp
public float CmEnergy_Recovery_Signal_input_62; // FailOutput
// macro outputs
public float CmEnergy_Recovery_Signal_output_4; // EnRecovSignal_Y
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfSubtract func_26 = new CfSubtract();
protected CfCompare1 func_9 = new CfCompare1();
protected CfCompare1 func_38 = new CfCompare1();
protected CfLinearConverter func_15 = new CfLinearConverter();
protected CfLinearConverter func_17 = new CfLinearConverter();
protected CfCompare1 func_52 = new CfCompare1();
protected CfOr func_57 = new CfOr();
protected CfInputMultiplexer func_59 = new CfInputMultiplexer();
protected CfInputMultiplexer func_50 = new CfInputMultiplexer();

// default constructor
public CmEnergy_Recovery_Signal()
{
}

  public void Start()
  {
  }
}
