/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    HeatingCoolingSP
Macro id:      5922242350065648155
Macro version: 19
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] CalcRoomSP
  [2] RoomRetAirTemp
Outputs:
  [1] CoolingSP
  [2] HeatingSP
Parameter:
  [1] OPT-05: comfort zone around on calculated room setpoint
  [2] OPT-06: comfort zone diff. for boost termination
Description:

================================================================================*/

public class CmHeatingCoolingSP
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [2] Function call CfDivide
    func_2.inputA = env.getParameter(parameterOffset);
    func_2.inputB = 2F;
    func_2.Execute(  );

    // [3] Function call CfAddition
    func_3.input[0] = CmHeatingCoolingSP_input_12;
    func_3.input[1] = func_2.output;
    func_3.Execute(  );

    // [4] Function call CfSubtract
    func_4.input[0] = CmHeatingCoolingSP_input_12;
    func_4.input[1] = func_2.output;
    func_4.Execute(  );

    // [83] Function call CfCompare2
    func_83.inputA = func_2.output;
    func_83.inputB = env.getParameter(parameterOffset + 1);
    func_83.Execute(  );

    // [18] Function call CfAddition
    func_18.input[0] = func_4.output;
    func_18.input[1] = env.getParameter(parameterOffset + 1);
    func_18.Execute(  );

    // [21] Function call CfSubtract
    func_21.input[0] = func_3.output;
    func_21.input[1] = env.getParameter(parameterOffset + 1);
    func_21.Execute(  );

    // [45] Function call CfCompare1
    func_45.inputA = CmHeatingCoolingSP_input_13;
    func_45.inputB = func_4.output;
    func_45.Execute(  );

    // [56] Function call CfCompare1
    func_56.inputA = CmHeatingCoolingSP_input_13;
    func_56.inputB = func_3.output;
    func_56.Execute(  );

    // [87] Function call CfCompare2
    func_87.inputA = CmHeatingCoolingSP_input_13;
    func_87.inputB = func_21.output;
    func_87.Execute(  );

    // [88] Function call CfCompare2
    func_88.inputA = CmHeatingCoolingSP_input_13;
    func_88.inputB = func_18.output;
    func_88.Execute(  );

    // [50] Function call CfMonoflop
    func_50.input = BooleanToFloat(func_88.outputEqualOrGreater);
    func_50.Execute( env, parameterOffset + 2 );

    // [62] Function call CfMonoflop
    func_62.input = BooleanToFloat(func_87.outputEqualOrLess);
    func_62.Execute( env, parameterOffset + 3 );

    // [43] Function call CfJkFlipFlop
    func_43.inputSet = func_45.outputLess;
    func_43.inputClock = false;
    func_43.inputReset = func_50.output;
    func_43.Execute(  );

    // [59] Function call CfJkFlipFlop
    func_59.inputSet = func_56.outputGreater;
    func_59.inputClock = false;
    func_59.inputReset = func_62.output;
    func_59.Execute(  );

    // [49] Function call CfInputMultiplexer
    func_49.inputSelect = BooleanToInt(func_43.output);
    func_49.input[1-1] = CmHeatingCoolingSP_input_13;
    func_49.input[2-1] = func_18.output;
    func_49.Execute(  );

    // [68] Function call CfInputMultiplexer
    func_68.inputSelect = BooleanToInt(func_59.output);
    func_68.input[1-1] = CmHeatingCoolingSP_input_13;
    func_68.input[2-1] = func_21.output;
    func_68.Execute(  );

    // [103] Function call CfInputMultiplexer
    func_103.inputSelect = BooleanToInt(func_83.outputEqualOrLess);
    func_103.input[1-1] = func_49.output;
    func_103.input[2-1] = CmHeatingCoolingSP_input_13;
    func_103.Execute(  );
    CmHeatingCoolingSP_output_34 = func_103.output;

    // [104] Function call CfInputMultiplexer
    func_104.inputSelect = BooleanToInt(func_83.outputEqualOrLess);
    func_104.input[1-1] = func_68.output;
    func_104.input[2-1] = CmHeatingCoolingSP_input_13;
    func_104.Execute(  );
    CmHeatingCoolingSP_output_35 = func_104.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmHeatingCoolingSP_input_12; // CalcRoomSP
public float CmHeatingCoolingSP_input_13; // RoomRetAirTemp
// macro outputs
public float CmHeatingCoolingSP_output_35; // CoolingSP
public float CmHeatingCoolingSP_output_34; // HeatingSP
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfDivide func_2 = new CfDivide();
protected CfAddition func_3 = new CfAddition();
protected CfSubtract func_4 = new CfSubtract();
protected CfCompare2 func_83 = new CfCompare2();
protected CfAddition func_18 = new CfAddition();
protected CfSubtract func_21 = new CfSubtract();
protected CfCompare1 func_45 = new CfCompare1();
protected CfCompare1 func_56 = new CfCompare1();
protected CfCompare2 func_87 = new CfCompare2();
protected CfCompare2 func_88 = new CfCompare2();
protected CfMonoflop func_50 = new CfMonoflop();
protected CfMonoflop func_62 = new CfMonoflop();
protected CfJkFlipFlop func_43 = new CfJkFlipFlop();
protected CfJkFlipFlop func_59 = new CfJkFlipFlop();
protected CfInputMultiplexer func_49 = new CfInputMultiplexer();
protected CfInputMultiplexer func_68 = new CfInputMultiplexer();
protected CfInputMultiplexer func_103 = new CfInputMultiplexer();
protected CfInputMultiplexer func_104 = new CfInputMultiplexer();

// default constructor
public CmHeatingCoolingSP()
{
}

  public void Start()
  {
    func_50.Start();
    func_62.Start();
    func_43.Start();
    func_59.Start();
  }
}
