/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Heating Signal Setup
Macro id:      5787266059943805434
Macro version: 22
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] RWTsensorDisabled
  [2] OAT< LimitOAT-03
  [3] FrostThermostat
  [4] PlantMode
  [5] DischargeAirTemp
  [6] DMEoutput
Outputs:
  [1] ValvePositionSetup
  [2] SetpointRaise
Parameter:
  [1] FEZ-01: frost protection RWT/ DAT setpoint raise
  [2] FEZ-02: raised setpoint decrease during frost recovery
  [3] FEZ-03: valve position during frost protection
  [4] FEZ-04: valve raised position decrease during frost recovery
Description:
RWTSensorDisabled set to 1 when no RWT sensor is connected

================================================================================*/

public class CmHeating_Signal_Setup
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [33] Function call CfEqual
    func_33.input = FloatToInt(CmHeating_Signal_Setup_input_32);
    func_33.inputCompare[1-1] = 20;
    func_33.Execute(  );

    // [50] Function call CfEqual
    func_50.input = FloatToInt(CmHeating_Signal_Setup_input_32);
    func_50.inputCompare[1-1] = 1;
    func_50.inputCompare[2-1] = 2;
    func_50.inputCompare[3-1] = 4;
    func_50.inputCompare[4-1] = 5;
    func_50.inputCompare[5-1] = 6;
    func_50.inputCompare[6-1] = 30;
    func_50.Execute(  );

    // [55] Function call CfIdt
    func_55.input = BooleanToFloat(CmHeating_Signal_Setup_input_25);
    func_55.Execute(  );

    // [62] Function call CfCompare1
    func_62.inputA = CmHeating_Signal_Setup_input_24;
    func_62.inputB = 999F;
    func_62.Execute(  );

    // [83] Function call CfNot
    func_83.input = CmHeating_Signal_Setup_input_66;
    func_83.Execute(  );

    // [86] Function call CfOr
    func_86.input[0] = func_33.output;
    func_86.input[1] = CmHeating_Signal_Setup_input_31;
    func_86.Execute(  );

    // [90] Function call CfNot
    func_90.input = func_50.output;
    func_90.Execute(  );

    // [41] Function call CfLastValue
    func_41.input = BooleanToFloat(func_86.outputOR);
    func_41.Execute(  );

    // [48] Function call CfLastValue
    func_48.input = BooleanToFloat(func_90.output);
    func_48.Execute(  );

    // [16] Function call CfAnd
    func_16.input[0] = func_62.outputEqual;
    func_16.input[1] = FloatToBoolean(func_55.output[0]);
    func_16.input[2] = FloatToBoolean(func_41.outputLast);
    func_16.input[3] = func_86.outputNOR;
    func_16.Execute(  );

    // [18] Function call CfAnd
    func_18.input[0] = func_62.outputEqual;
    func_18.input[1] = FloatToBoolean(func_55.output[0]);
    func_18.input[2] = CmHeating_Signal_Setup_input_29;
    func_18.input[3] = FloatToBoolean(func_48.outputLast);
    func_18.input[4] = func_50.output;
    func_18.Execute(  );

    // [14] Function call CfOr
    func_14.input[0] = func_16.outputAND;
    func_14.input[1] = func_18.outputAND;
    func_14.Execute(  );

    // [89] Function call CfInputMultiplexer
    func_89.inputSelect = BooleanToInt(func_14.outputOR);
    func_89.input[1-1] = 0F;
    func_89.input[2-1] = env.getParameter(parameterOffset + 2);
    func_89.Execute(  );

    // [10] Function call CfValueRamp2
    func_10.inputValue = func_89.output;
    func_10.inputRisingSlope = 0F;
    func_10.inputFallingSlope = env.getParameter(parameterOffset + 3);
    func_10.Execute( env );

    // [4] Function call CfMaximum
    func_4.input[0] = func_10.output;
    func_4.input[1] = 0F;
    func_4.Execute(  );
    CmHeating_Signal_Setup_output_1 = func_4.output;

    // [71] Function call CfOr
    func_71.input[0] = CmHeating_Signal_Setup_input_31;
    func_71.input[1] = func_33.output;
    func_71.input[2] = func_74.outputAND;
    func_71.Execute(  );

    // [74] Function call CfAnd
    func_74.input[0] = func_83.output;
    func_74.input[1] = func_50.output;
    func_74.input[2] = func_71.outputOR;
    func_74.Execute(  );

    // [78] Function call CfInputMultiplexer
    func_78.inputSelect = BooleanToInt(func_71.outputOR);
    func_78.input[1-1] = 0F;
    func_78.input[2-1] = env.getParameter(parameterOffset);
    func_78.Execute(  );

    // [79] Function call CfValueRamp2
    func_79.inputValue = func_78.output;
    func_79.inputRisingSlope = 0F;
    func_79.inputFallingSlope = env.getParameter(parameterOffset + 1);
    func_79.Execute( env );

    // [81] Function call CfMaximum
    func_81.input[0] = func_79.output;
    func_81.input[1] = 0F;
    func_81.Execute(  );
    CmHeating_Signal_Setup_output_68 = func_81.output;

  }
// macro register which are written multiple times
// macro inputs
public boolean CmHeating_Signal_Setup_input_25; // RWTsensorDisabled
public boolean CmHeating_Signal_Setup_input_29; // OAT< LimitOAT-03
public boolean CmHeating_Signal_Setup_input_31; // FrostThermostat
public float CmHeating_Signal_Setup_input_32; // PlantMode
public float CmHeating_Signal_Setup_input_24; // DischargeAirTemp
public boolean CmHeating_Signal_Setup_input_66; // DMEoutput
// macro outputs
public float CmHeating_Signal_Setup_output_1; // ValvePositionSetup
public float CmHeating_Signal_Setup_output_68; // SetpointRaise
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfEqual func_33 = new CfEqual();
protected CfEqual func_50 = new CfEqual();
protected CfIdt func_55 = new CfIdt();
protected CfCompare1 func_62 = new CfCompare1();
protected CfNot func_83 = new CfNot();
protected CfOr func_86 = new CfOr();
protected CfNot func_90 = new CfNot();
protected CfLastValue func_41 = new CfLastValue();
protected CfLastValue func_48 = new CfLastValue();
protected CfAnd func_16 = new CfAnd();
protected CfAnd func_18 = new CfAnd();
protected CfOr func_14 = new CfOr();
protected CfInputMultiplexer func_89 = new CfInputMultiplexer();
protected CfValueRamp2 func_10 = new CfValueRamp2();
protected CfMaximum func_4 = new CfMaximum();
protected CfOr func_71 = new CfOr();
protected CfAnd func_74 = new CfAnd();
protected CfInputMultiplexer func_78 = new CfInputMultiplexer();
protected CfValueRamp2 func_79 = new CfValueRamp2();
protected CfMaximum func_81 = new CfMaximum();

// default constructor
public CmHeating_Signal_Setup()
{
  func_33.configure(2);
  func_50.configure(7);
  func_16.configure(4);
  func_18.configure(5);
  func_71.configure(3);
  func_74.configure(3);
}

  public void Start()
  {
    func_41.Start();
    func_48.Start();
    func_10.Start();
    func_79.Start();
  }
}
