/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Max Lim Hum/Dehum
Macro id:      5928967976599421609
Macro version: 15
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] SAT_ContrDev
Outputs:
  [1] Max Humidity Signal
  [2] Max Dehumidity Signal
Parameter:
  [1] HULIM-01: supply air temp. control deviation for maximum humidification signal
  [2] HULIM-02: supply air temp. control deviation for minimum humidification signal
  [3] HULIM-03: maximum humidification signal
  [4] HULIM-04: minimum humidification signal
  [5] DHLIM-01: supply air temp. control deviation for maximum de-humidification signal
  [6] DHLIM-02: supply air temp. control deviation for minimum de-humidification signal
  [7] DHLIM-03: maximum de-humidification signal
  [8] DHLIM-04: minimum de-humidification signal
Description:

================================================================================*/

public class CmMax_Lim_HumDehum
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [14] Function call CfRamp
    func_14.input = CmMax_Lim_HumDehum_input_1;
    func_14.Execute( env, parameterOffset + 8 );
    CmMax_Lim_HumDehum_output_3 = func_14.output;

    // [15] Function call CfRamp
    func_15.input = CmMax_Lim_HumDehum_input_1;
    func_15.Execute( env, parameterOffset + 19 );
    CmMax_Lim_HumDehum_output_2 = func_15.output;

    // [17] Macro call CmIDT20
    func_17.CmIDT20_input_1 = 30F;
    func_17.CmIDT20_input_2 = -30F;
    func_17.CmIDT20_input_3 = 100F;
    func_17.CmIDT20_input_4 = 0F;
    func_17.CmIDT20_input_5 = env.getParameter(parameterOffset);
    func_17.CmIDT20_input_6 = env.getParameter(parameterOffset);
    func_17.CmIDT20_input_7 = env.getParameter(parameterOffset + 2);
    func_17.CmIDT20_input_8 = 30F;
    func_17.CmIDT20_input_9 = env.getParameter(parameterOffset + 1);
    func_17.CmIDT20_input_10 = env.getParameter(parameterOffset + 2);
    func_17.CmIDT20_input_11 = env.getParameter(parameterOffset + 3);
    func_17.CmIDT20_input_12 = 30F;
    func_17.CmIDT20_input_13 = -30F;
    func_17.CmIDT20_input_14 = 100F;
    func_17.CmIDT20_input_15 = 0F;
    func_17.CmIDT20_input_16 = env.getParameter(parameterOffset + 5);
    func_17.CmIDT20_input_17 = env.getParameter(parameterOffset + 5);
    func_17.CmIDT20_input_18 = env.getParameter(parameterOffset + 7);
    func_17.CmIDT20_input_19 = env.getParameter(parameterOffset + 4);
    func_17.CmIDT20_input_20 = 30F;
    func_17.Execute(  );
    env.setParameter(parameterOffset + 22, func_17.CmIDT20_output_21);
    env.setParameter(parameterOffset + 21, func_17.CmIDT20_output_22);
    env.setParameter(parameterOffset + 20, func_17.CmIDT20_output_23);
    env.setParameter(parameterOffset + 19, func_17.CmIDT20_output_24);
    env.setParameter(parameterOffset + 25, func_17.CmIDT20_output_25);
    env.setParameter(parameterOffset + 26, func_17.CmIDT20_output_26);
    env.setParameter(parameterOffset + 27, func_17.CmIDT20_output_27);
    env.setParameter(parameterOffset + 28, func_17.CmIDT20_output_28);
    env.setParameter(parameterOffset + 23, func_17.CmIDT20_output_29);
    env.setParameter(parameterOffset + 29, func_17.CmIDT20_output_30);
    env.setParameter(parameterOffset + 24, func_17.CmIDT20_output_31);
    env.setParameter(parameterOffset + 11, func_17.CmIDT20_output_32);
    env.setParameter(parameterOffset + 10, func_17.CmIDT20_output_33);
    env.setParameter(parameterOffset + 9, func_17.CmIDT20_output_34);
    env.setParameter(parameterOffset + 8, func_17.CmIDT20_output_35);
    env.setParameter(parameterOffset + 14, func_17.CmIDT20_output_36);
    env.setParameter(parameterOffset + 15, func_17.CmIDT20_output_37);
    env.setParameter(parameterOffset + 16, func_17.CmIDT20_output_38);
    env.setParameter(parameterOffset + 12, func_17.CmIDT20_output_39);
    env.setParameter(parameterOffset + 17, func_17.CmIDT20_output_40);

    // [36] Macro call CmIDT05
    func_36.CmIDT05_input_1 = env.getParameter(parameterOffset + 6);
    func_36.CmIDT05_input_2 = env.getParameter(parameterOffset + 7);
    func_36.CmIDT05_input_3 = 0F;
    func_36.CmIDT05_input_4 = 0F;
    func_36.CmIDT05_input_5 = 0F;
    func_36.Execute(  );
    env.setParameter(parameterOffset + 13, func_36.CmIDT05_output_21);
    env.setParameter(parameterOffset + 18, func_36.CmIDT05_output_22);

  }
// macro register which are written multiple times
// macro inputs
public float CmMax_Lim_HumDehum_input_1; // SAT_ContrDev
// macro outputs
public float CmMax_Lim_HumDehum_output_2; // Max Humidity Signal
public float CmMax_Lim_HumDehum_output_3; // Max Dehumidity Signal
// helper functions

// class variables
protected CfRamp func_14 = new CfRamp();
protected CfRamp func_15 = new CfRamp();
protected CmIDT20 func_17 = new CmIDT20();
protected CmIDT05 func_36 = new CmIDT05();

// default constructor
public CmMax_Lim_HumDehum()
{
}

  public void Start()
  {
    func_17.Start();
    func_36.Start();
  }
}
