/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Plant Mode 1
Macro id:      5914915690720002252
Macro version: 74
Last change:   12.01.2017 - 12:58
Access Level:  2
Inputs:
  [1] CalcRoomSP
  [2] RoomRetAirTemp
  [3] FilteredOAtemp
  [4] OptimEnable
  [5] Occ_Period
  [6] ManSwCond
Outputs:
  [1] OptimumStart
  [2] OptimumStop
Parameter:
  [1] OPT-01: optimum start heating; 1 = enable
  [2] OPT-02: optimum stop heating; 1 = enable
  [3] OPT-03: optimum start cooling; 1 = enable
  [4] OPT-04: optimum stop cooling; 1 = enable
  [5] OPT-05: comfort zone around on calculated room setpoint
  [6] OPT-06: comfort zone diff. for boost termination
  [7] OPT-07: long period filter time htg-/ clg-mode
  [8] OPT-08: long period filter switch-point htg-/ clg-mode
  [9] EOV-01: minimum preheat time for heating
  [10] EOV-02: preheat factor
  [11] EOV-03: minimum OAT for optimum stop (htg mode)
  [12] EOV-04: optimum stop factor for heating
  [13] EOV-05: minimum pre-cool time for cooling
  [14] EOV-06: pre-cool factor
  [15] EOV-07: maximum OAT for optimum stop (clg mode)
  [16] EOV-08: optimum stop factor for cooling
  [17] EOV-09: adaptation: 0= enable; 1= disable; 2= new start
  [18] DISP-01: start time optimum start
  [19] DISP-02: end time optimum start
  [20] DISP-03: date last optimum start
Description:

================================================================================*/

public class CmPlant_Mode_1
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [301] Macro call CmIDT10
    func_301.CmIDT10_input_1 = 5F;
    func_301.CmIDT10_input_2 = 5F;
    func_301.CmIDT10_input_3 = env.getParameter(parameterOffset + 7);
    func_301.CmIDT10_input_4 = env.getParameter(parameterOffset + 8);
    func_301.CmIDT10_input_5 = env.getParameter(parameterOffset + 9);
    func_301.CmIDT10_input_6 = env.getParameter(parameterOffset + 10);
    func_301.CmIDT10_input_7 = env.getParameter(parameterOffset + 11);
    func_301.CmIDT10_input_8 = env.getParameter(parameterOffset + 12);
    func_301.CmIDT10_input_9 = env.getParameter(parameterOffset + 13);
    func_301.CmIDT10_input_10 = env.getParameter(parameterOffset + 14);
    func_301.Execute(  );
    env.setParameter(parameterOffset + 51, func_301.CmIDT10_output_21);
    env.setParameter(parameterOffset + 52, func_301.CmIDT10_output_22);
    env.setParameter(parameterOffset + 27, func_301.CmIDT10_output_23);
    env.setParameter(parameterOffset + 41, func_301.CmIDT10_output_24);
    env.setParameter(parameterOffset + 42, func_301.CmIDT10_output_25);
    env.setParameter(parameterOffset + 43, func_301.CmIDT10_output_26);
    env.setParameter(parameterOffset + 44, func_301.CmIDT10_output_27);
    env.setParameter(parameterOffset + 45, func_301.CmIDT10_output_28);
    env.setParameter(parameterOffset + 46, func_301.CmIDT10_output_29);
    env.setParameter(parameterOffset + 47, func_301.CmIDT10_output_30);

    // [316] Macro call CmIDT10
    func_316.CmIDT10_input_1 = env.getParameter(parameterOffset + 15);
    func_316.CmIDT10_input_2 = env.getParameter(parameterOffset + 16);
    func_316.CmIDT10_input_3 = env.getParameter(parameterOffset + 6);
    func_316.CmIDT10_input_4 = env.getParameter(parameterOffset);
    func_316.CmIDT10_input_5 = env.getParameter(parameterOffset + 1);
    func_316.CmIDT10_input_6 = env.getParameter(parameterOffset + 2);
    func_316.CmIDT10_input_7 = env.getParameter(parameterOffset + 3);
    func_316.CmIDT10_input_8 = env.getParameter(parameterOffset + 4);
    func_316.CmIDT10_input_9 = env.getParameter(parameterOffset + 5);
    func_316.CmIDT10_input_10 = 0F;
    func_316.Execute(  );
    env.setParameter(parameterOffset + 48, func_316.CmIDT10_output_21);
    env.setParameter(parameterOffset + 49, func_316.CmIDT10_output_22);
    env.setParameter(parameterOffset + 21, func_316.CmIDT10_output_23);
    env.setParameter(parameterOffset + 31, func_316.CmIDT10_output_24);
    env.setParameter(parameterOffset + 32, func_316.CmIDT10_output_25);
    env.setParameter(parameterOffset + 33, func_316.CmIDT10_output_26);
    env.setParameter(parameterOffset + 34, func_316.CmIDT10_output_27);
    env.setParameter(parameterOffset + 37, func_316.CmIDT10_output_28);
    env.setParameter(parameterOffset + 38, func_316.CmIDT10_output_29);

    // [312] Macro call CmRAA_OATempFilter
    func_312.CmRAA_OATempFilter_input_2 = CmPlant_Mode_1_input_4;
    func_312.CmRAA_OATempFilter_input_3 = 0F;
    func_312.Execute( env, parameterOffset +20 );

    // [582] Macro call CmModeAutoChangeover
    func_582.CmModeAutoChangeover_input_2 = func_312.CmRAA_OATempFilter_output_4;
    func_582.CmModeAutoChangeover_input_3 = CmPlant_Mode_1_input_286;
    func_582.Execute( env, parameterOffset +27 );

    // [583] Macro call CmEnable_Optimization
    func_583.CmEnable_Optimization_input_1 = BooleanToFloat(CmPlant_Mode_1_input_287);
    func_583.CmEnable_Optimization_input_2 = CmPlant_Mode_1_input_286;
    func_583.CmEnable_Optimization_input_3 = func_584.output[1];
    func_583.CmEnable_Optimization_input_81 = CmPlant_Mode_1_input_648;
    func_583.CmEnable_Optimization_input_96 = func_582.CmModeAutoChangeover_output_52;
    func_583.CmEnable_Optimization_input_97 = func_582.CmModeAutoChangeover_output_53;
    func_583.Execute( env, parameterOffset +31 );

    // [578] Macro call CmHeatingCoolingSP
    func_578.CmHeatingCoolingSP_input_12 = CmPlant_Mode_1_input_2;
    func_578.CmHeatingCoolingSP_input_13 = CmPlant_Mode_1_input_3;
    func_578.Execute( env, parameterOffset +37 );

    // [584] Function call CfIdt
    func_584.input = func_582.CmModeAutoChangeover_output_5;
    func_584.Execute(  );

    // [336] Function call CfInputMultiplexer
    func_336.inputSelect = BooleanToInt(func_583.CmEnable_Optimization_output_6);
    func_336.input[1-1] = func_586.output;
    func_336.input[2-1] = func_578.CmHeatingCoolingSP_output_35;
    func_336.Execute(  );

    // [337] Function call CfInputMultiplexer
    func_337.inputSelect = BooleanToInt(func_583.CmEnable_Optimization_output_5);
    func_337.input[1-1] = func_336.output;
    func_337.input[2-1] = func_578.CmHeatingCoolingSP_output_34;
    func_337.Execute(  );

    // [586] Function call CfInputMultiplexer
    func_586.inputSelect = BooleanToInt(func_583.CmEnable_Optimization_output_48);
    func_586.input[1-1] = CmPlant_Mode_1_input_3;
    func_586.input[2-1] = CmPlant_Mode_1_input_2;
    func_586.Execute(  );

    // [282] Function call CfEov
    func_282.inputOccupancy = CmPlant_Mode_1_input_287;
    func_282.inputRoomSetpoint = func_337.output;
    func_282.inputRoomTemperature = CmPlant_Mode_1_input_3;
    func_282.inputOutdoorTemperature = CmPlant_Mode_1_input_4;
    func_282.inputEovMode = FloatToInt(func_584.output[0]);
    func_282.Execute( env, parameterOffset + 41 );
    CmPlant_Mode_1_output_13 = func_282.outputOptOn;
    CmPlant_Mode_1_output_409 = func_282.outputOptOff;

    // [424] Function call CfMonoflop
    func_424.input = BooleanToFloat(CmPlant_Mode_1_output_13);
    func_424.Execute( env, parameterOffset + 51 );

    // [497] Function call CfNot
    func_497.input = CmPlant_Mode_1_output_13;
    func_497.Execute(  );

    // [422] Function call CfInputMultiplexer
    func_422.inputSelect = BooleanToInt(func_424.output);
    func_422.input[1-1] = env.getParameter(parameterOffset + 19);
    func_422.input[2-1] = IntToFloat(ControlFunction.GetDayAndMonth());
    func_422.Execute(  );
    env.setParameter(parameterOffset + 19, func_422.output);

    // [437] Function call CfInputMultiplexer
    func_437.inputSelect = BooleanToInt(func_424.output);
    func_437.input[1-1] = env.getParameter(parameterOffset + 17);
    func_437.input[2-1] = IntToFloat(ControlFunction.GetHoursAndMinutes());
    func_437.Execute(  );
    env.setParameter(parameterOffset + 17, func_437.output);

    // [498] Function call CfMonoflop
    func_498.input = BooleanToFloat(func_497.output);
    func_498.Execute( env, parameterOffset + 52 );

    // [495] Function call CfInputMultiplexer
    func_495.inputSelect = BooleanToInt(func_498.output);
    func_495.input[1-1] = env.getParameter(parameterOffset + 18);
    func_495.input[2-1] = IntToFloat(ControlFunction.GetHoursAndMinutes());
    func_495.Execute(  );
    env.setParameter(parameterOffset + 18, func_495.output);

  }
// macro register which are written multiple times
// macro inputs
public float CmPlant_Mode_1_input_2; // CalcRoomSP
public float CmPlant_Mode_1_input_3; // RoomRetAirTemp
public float CmPlant_Mode_1_input_4; // FilteredOAtemp
public float CmPlant_Mode_1_input_286; // OptimEnable
public boolean CmPlant_Mode_1_input_287; // Occ_Period
public float CmPlant_Mode_1_input_648; // ManSwCond
// macro outputs
public boolean CmPlant_Mode_1_output_13; // OptimumStart
public boolean CmPlant_Mode_1_output_409; // OptimumStop
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private float   IntToFloat    (int     value) { return (float) value; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }

// class variables
protected CmIDT10 func_301 = new CmIDT10();
protected CmIDT10 func_316 = new CmIDT10();
protected CmRAA_OATempFilter func_312 = new CmRAA_OATempFilter();
protected CmModeAutoChangeover func_582 = new CmModeAutoChangeover();
protected CmEnable_Optimization func_583 = new CmEnable_Optimization();
protected CmHeatingCoolingSP func_578 = new CmHeatingCoolingSP();
protected CfIdt func_584 = new CfIdt();
protected CfInputMultiplexer func_336 = new CfInputMultiplexer();
protected CfInputMultiplexer func_337 = new CfInputMultiplexer();
protected CfInputMultiplexer func_586 = new CfInputMultiplexer();
protected CfEov func_282 = new CfEov();
protected CfMonoflop func_424 = new CfMonoflop();
protected CfNot func_497 = new CfNot();
protected CfInputMultiplexer func_422 = new CfInputMultiplexer();
protected CfInputMultiplexer func_437 = new CfInputMultiplexer();
protected CfMonoflop func_498 = new CfMonoflop();
protected CfInputMultiplexer func_495 = new CfInputMultiplexer();

// default constructor
public CmPlant_Mode_1()
{
  func_584.configure(2);
}

  public void Start()
  {
    func_301.Start();
    func_316.Start();
    func_312.Start();
    func_582.Start();
    func_583.Start();
    func_578.Start();
    func_282.Start();
    func_424.Start();
    func_498.Start();
  }
}
