/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Plant Mode 11
Macro id:      5911203543935615950
Macro version: 19
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] RoomRetAirTemp
  [2] CalcRoomSP
Outputs:
  [1] PlantMode11
Parameter:
  [1] DUC-01: duty cycle; 1= enable
  [2] DUC-02: duty cycling comfort zone
  [3] DUC-03: maximum off time (% of duty cycle period)
  [4] DUC-04: minimum off time (% of duty cycle period)
  [5] DUC-05: duty cycle period
  [6] DUC-06: duty cicle mode; 1= heating; 2= cooling; 3= heating and cooling
Description:

================================================================================*/

public class CmPlant_Mode_11
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [52] Macro call CmIDT10
    func_52.CmIDT10_input_1 = 0F;
    func_52.CmIDT10_input_2 = env.getParameter(parameterOffset + 4);
    func_52.CmIDT10_input_3 = env.getParameter(parameterOffset + 5);
    func_52.CmIDT10_input_4 = 0F;
    func_52.CmIDT10_input_5 = env.getParameter(parameterOffset + 2);
    func_52.CmIDT10_input_6 = env.getParameter(parameterOffset + 3);
    func_52.CmIDT10_input_7 = 0F;
    func_52.CmIDT10_input_8 = 0F;
    func_52.CmIDT10_input_9 = 0F;
    func_52.CmIDT10_input_10 = 0F;
    func_52.Execute(  );
    env.setParameter(parameterOffset + 9, func_52.CmIDT10_output_22);
    env.setParameter(parameterOffset + 10, func_52.CmIDT10_output_23);
    env.setParameter(parameterOffset + 11, func_52.CmIDT10_output_24);
    env.setParameter(parameterOffset + 7, func_52.CmIDT10_output_25);
    env.setParameter(parameterOffset + 8, func_52.CmIDT10_output_26);

    // [58] Function call CfDutyCycle
    func_58.inputTempZoneHigh = CmPlant_Mode_11_input_1;
    func_58.inputTempZoneLow = CmPlant_Mode_11_input_1;
    func_58.inputFanStatus = 1;
    func_58.inputTempSetpoint = CmPlant_Mode_11_input_2;
    func_58.Execute( env, parameterOffset + 6 );

    // [75] Function call CfWindow
    func_75.inputValue = env.getParameter(parameterOffset);
    func_75.inputMinimum = 0.8F;
    func_75.inputMaximum = 1.2F;
    func_75.Execute(  );

    // [82] Function call CfDivide
    func_82.inputA = env.getParameter(parameterOffset + 1);
    func_82.inputB = 2F;
    func_82.Execute(  );
    env.setParameter(parameterOffset + 6, func_82.output);

    // [73] Function call CfNot
    func_73.input = func_58.outputFanState;
    func_73.Execute(  );

    // [76] Function call CfAnd
    func_76.input[0] = func_75.output;
    func_76.input[1] = func_73.output;
    func_76.Execute(  );
    CmPlant_Mode_11_output_3 = func_76.outputAND;

  }
// macro register which are written multiple times
// macro inputs
public float CmPlant_Mode_11_input_1; // RoomRetAirTemp
public float CmPlant_Mode_11_input_2; // CalcRoomSP
// macro outputs
public boolean CmPlant_Mode_11_output_3; // PlantMode11
// helper functions

// class variables
protected CmIDT10 func_52 = new CmIDT10();
protected CfDutyCycle func_58 = new CfDutyCycle();
protected CfWindow func_75 = new CfWindow();
protected CfDivide func_82 = new CfDivide();
protected CfNot func_73 = new CfNot();
protected CfAnd func_76 = new CfAnd();

// default constructor
public CmPlant_Mode_11()
{
}

  public void Start()
  {
    func_52.Start();
    func_58.Start();
  }
}
