/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    RAA_OATempFilter
Macro id:      5819115172918198775
Macro version: 16
Last change:   19.12.2016 - 09:00
Access Level:  2
Inputs:
  [1] Temperature 1
  [2] Temperature 2
Outputs:
  [1] FilteredOATemp
Parameter:
  [1] SYS-01: selection for SYS-02 - 0=min; 1=h
  [2] SYS-02: filter time; 0=disable
  [3] SYS-03: filter input configuration
Description:
The "RAA_OATempFilter" macro provides a smoothed output from a varying analog input. Typically this can be applied to the outside air temperature sensor in order to eliminate sudden temperature variations and thus provide for a more stable operation of the control system. This module can be also used for different sensors or analogue signals.
================================================================================*/

public class CmRAA_OATempFilter
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [627] Macro call CmCycle_time
    func_627.Execute( env, parameterOffset +3 );

    // [23] Function call CfMinimum
    func_23.input[0] = CmRAA_OATempFilter_input_2;
    func_23.input[1] = CmRAA_OATempFilter_input_3;
    func_23.Execute(  );

    // [24] Function call CfMaximum
    func_24.input[0] = CmRAA_OATempFilter_input_2;
    func_24.input[1] = CmRAA_OATempFilter_input_3;
    func_24.Execute(  );

    // [413] Function call CfAverage
    func_413.input[0] = CmRAA_OATempFilter_input_2;
    func_413.input[1] = CmRAA_OATempFilter_input_3;
    func_413.ExecuteArithmeticAverage( );
    // [35] Function call CfInputMultiplexer
    func_35.inputSelect = FloatToInt(env.getParameter(parameterOffset + 2));
    func_35.input[1-1] = CmRAA_OATempFilter_input_2;
    func_35.input[2-1] = func_23.output;
    func_35.input[3-1] = func_24.output;
    func_35.input[4-1] = func_413.outputA;
    func_35.Execute(  );

    // [39] Function call CfInputMultiplexer
    func_39.inputSelect = FloatToInt(env.getParameter(parameterOffset));
    func_39.input[1-1] = 60F;
    func_39.input[2-1] = 3600F;
    func_39.Execute(  );

    // [43] Function call CfMultiply
    func_43.input[0] = func_39.output;
    func_43.input[1] = env.getParameter(parameterOffset + 1);
    func_43.Execute(  );

    // [546] Function call CfLastValue
    func_546.input = env.getParameter(parameterOffset + 1);
    func_546.Execute(  );

    // [672] Function call CfCompare1
    func_672.inputA = func_546.outputCurrent;
    func_672.inputB = func_546.outputLast;
    func_672.Execute(  );

    // [548] Function call CfLastValue
    func_548.input = env.getParameter(parameterOffset);
    func_548.Execute(  );

    // [547] Function call CfSubtract
    func_547.input[0] = func_548.outputCurrent;
    func_547.input[1] = func_548.outputLast;
    func_547.Execute(  );

    // [549] Function call CfAbsolute
    func_549.input = func_547.output;
    func_549.Execute(  );

    // [554] Function call CfLastValue
    func_554.input = env.getParameter(parameterOffset + 2);
    func_554.Execute(  );

    // [553] Function call CfSubtract
    func_553.input[0] = func_554.outputCurrent;
    func_553.input[1] = func_554.outputLast;
    func_553.Execute(  );

    // [555] Function call CfAbsolute
    func_555.input = func_553.output;
    func_555.Execute(  );

    // [565] Function call CfOr
    func_565.input[0] = func_672.outputGreater;
    func_565.input[1] = func_672.outputLess;
    func_565.input[2] = FloatToBoolean(func_549.outputAbs);
    func_565.input[3] = FloatToBoolean(func_555.outputAbs);
    func_565.input[4] = FloatToBoolean(func_655.outputLast);
    func_565.Execute(  );

    // [629] Function call CfAddition
    func_629.input[0] = func_627.CmCycle_time_output_13;
    func_629.input[1] = 2F;
    func_629.Execute(  );

    // [600] Function call CfIdt
    func_600.input = func_629.output;
    func_600.Execute(  );
    env.setParameter(parameterOffset + 5, func_600.output[0]);

    // [595] Function call CfMonoflop
    func_595.input = BooleanToFloat(func_565.outputOR);
    func_595.Execute( env, parameterOffset + 5 );

    // [655] Function call CfLastValue
    func_655.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_655.Execute(  );

    // [667] Function call CfCompare1
    func_667.inputA = env.getParameter(parameterOffset + 1);
    func_667.inputB = 0.1F;
    func_667.Execute(  );

    // [664] Function call CfOr
    func_664.input[0] = func_595.output;
    func_664.input[1] = func_667.outputLess;
    func_664.Execute(  );

    // [567] Function call CfInputMultiplexer
    func_567.inputSelect = BooleanToInt(func_664.outputOR);
    func_567.input[1-1] = func_43.output;
    func_567.input[2-1] = func_627.CmCycle_time_output_13;
    func_567.Execute(  );

    // [570] Function call CfIdt
    func_570.input = func_567.output;
    func_570.Execute(  );
    env.setParameter(parameterOffset + 6, func_570.output[0]);

    // [594] Function call CfSubtract
    func_594.input[0] = func_35.output;
    func_594.input[1] = CmRAA_OATempFilter_output_4;
    func_594.Execute(  );

    // [593] Function call CfIntegral
    func_593.inputX = func_594.output;
    func_593.inputMax = 100F;
    func_593.Execute( env, parameterOffset + 6 );
    CmRAA_OATempFilter_output_4 = func_593.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmRAA_OATempFilter_input_2; // Temperature 1
public float CmRAA_OATempFilter_input_3; // Temperature 2
// macro outputs
public float CmRAA_OATempFilter_output_4; // FilteredOATemp
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CmCycle_time func_627 = new CmCycle_time();
protected CfMinimum func_23 = new CfMinimum();
protected CfMaximum func_24 = new CfMaximum();
protected CfAverage func_413 = new CfAverage();
protected CfInputMultiplexer func_35 = new CfInputMultiplexer();
protected CfInputMultiplexer func_39 = new CfInputMultiplexer();
protected CfMultiply func_43 = new CfMultiply();
protected CfLastValue func_546 = new CfLastValue();
protected CfCompare1 func_672 = new CfCompare1();
protected CfLastValue func_548 = new CfLastValue();
protected CfSubtract func_547 = new CfSubtract();
protected CfAbsolute func_549 = new CfAbsolute();
protected CfLastValue func_554 = new CfLastValue();
protected CfSubtract func_553 = new CfSubtract();
protected CfAbsolute func_555 = new CfAbsolute();
protected CfOr func_565 = new CfOr();
protected CfAddition func_629 = new CfAddition();
protected CfIdt func_600 = new CfIdt();
protected CfMonoflop func_595 = new CfMonoflop();
protected CfLastValue func_655 = new CfLastValue();
protected CfCompare1 func_667 = new CfCompare1();
protected CfOr func_664 = new CfOr();
protected CfInputMultiplexer func_567 = new CfInputMultiplexer();
protected CfIdt func_570 = new CfIdt();
protected CfSubtract func_594 = new CfSubtract();
protected CfIntegral func_593 = new CfIntegral();

// default constructor
public CmRAA_OATempFilter()
{
  func_35.configure(5);
  func_565.configure(5);
}

  public void Start()
  {
    func_627.Start();
    func_546.Start();
    func_548.Start();
    func_554.Start();
    func_595.Start();
    func_655.Start();
    func_593.Start();
  }
}
