/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Return Water Control
Macro id:      5867340499875005112
Macro version: 25
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] EnRecTemp
  [2] FilteredOATemp
  [3] Reverse
Outputs:
  [1] ControlSignal
  [2] DISP-01: calc. setpoint energy recovery temperature
Parameter:
  [1] ERS-01: minimum energy recovery control signal
  [2] ERS-02: maximum energy recovery control signal
  [3] ERT-01: energy recovery temperature low setpoint
  [4] ERT-02: energy recovery temperature high setpoint
  [5] ERT-03: P-band energy recovery temperature control
  [6] OAT-01: outside air temperature minimum value
  [7] OAT-02: outside air temperature maximum value
Description:

================================================================================*/

public class CmReturn_Water_Control
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [32] Function call CfLinearConverter
    func_32.inputValue = CmReturn_Water_Control_input_11;
    func_32.inputInLimit1 = env.getParameter(parameterOffset + 5);
    func_32.inputInLimit2 = env.getParameter(parameterOffset + 6);
    func_32.inputOutLimit1 = env.getParameter(parameterOffset + 2);
    func_32.inputOutLimit2 = env.getParameter(parameterOffset + 3);
    func_32.Execute(  );

    // [48] Function call CfDivide
    func_48.inputA = env.getParameter(parameterOffset + 4);
    func_48.inputB = 2F;
    func_48.Execute(  );

    // [50] Function call CfSubtract
    func_50.input[0] = func_32.output;
    func_50.input[1] = func_48.output;
    func_50.Execute(  );

    // [49] Function call CfAddition
    func_49.input[0] = func_32.output;
    func_49.input[1] = func_48.output;
    func_49.Execute(  );

    // [75] Function call CfCompare1
    func_75.inputA = CmReturn_Water_Control_input_11;
    func_75.inputB = 999F;
    func_75.Execute(  );

    // [79] Function call CfInputMultiplexer
    func_79.inputSelect = BooleanToInt(func_75.outputEqual);
    func_79.input[1-1] = func_32.output;
    func_79.input[2-1] = 999F;
    func_79.Execute(  );

    // [73] Function call CfIdt
    func_73.input = func_79.output;
    func_73.Execute(  );
    CmReturn_Water_Control_output_10 = func_73.output[0];

    // [33] Function call CfLinearConverter
    func_33.inputValue = CmReturn_Water_Control_input_1;
    func_33.inputInLimit1 = func_50.output;
    func_33.inputInLimit2 = func_49.output;
    func_33.inputOutLimit1 = env.getParameter(parameterOffset);
    func_33.inputOutLimit2 = env.getParameter(parameterOffset + 1);
    func_33.Execute(  );

    // [34] Function call CfLinearConverter
    func_34.inputValue = CmReturn_Water_Control_input_1;
    func_34.inputInLimit1 = func_50.output;
    func_34.inputInLimit2 = func_49.output;
    func_34.inputOutLimit1 = env.getParameter(parameterOffset + 1);
    func_34.inputOutLimit2 = env.getParameter(parameterOffset);
    func_34.Execute(  );

    // [39] Function call CfInputMultiplexer
    func_39.inputSelect = BooleanToInt(CmReturn_Water_Control_input_57);
    func_39.input[1-1] = func_33.output;
    func_39.input[2-1] = func_34.output;
    func_39.Execute(  );
    CmReturn_Water_Control_output_24 = func_39.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmReturn_Water_Control_input_1; // EnRecTemp
public float CmReturn_Water_Control_input_11; // FilteredOATemp
public boolean CmReturn_Water_Control_input_57; // Reverse
// macro outputs
public float CmReturn_Water_Control_output_24; // ControlSignal
public float CmReturn_Water_Control_output_10; // DISP-01: calc. setpoint energy recovery temperature
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfLinearConverter func_32 = new CfLinearConverter();
protected CfDivide func_48 = new CfDivide();
protected CfSubtract func_50 = new CfSubtract();
protected CfAddition func_49 = new CfAddition();
protected CfCompare1 func_75 = new CfCompare1();
protected CfInputMultiplexer func_79 = new CfInputMultiplexer();
protected CfIdt func_73 = new CfIdt();
protected CfLinearConverter func_33 = new CfLinearConverter();
protected CfLinearConverter func_34 = new CfLinearConverter();
protected CfInputMultiplexer func_39 = new CfInputMultiplexer();

// default constructor
public CmReturn_Water_Control()
{
}

  public void Start()
  {
  }
}
