/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Return Water Setpoint Control
Macro id:      5802048807273234726
Macro version: 31
Last change:   22.03.2018 - 12:27
Access Level:  2
Inputs:
  [1] RWTSensor
  [2] FilteredOAT
  [3] OAT>LimitOAT-03
  [4] Incr/DecrFrostRecovery
  [5] PlantMode
  [6] PlantMode1,2,4,5,6,30
  [7] DamperEnable
Outputs:
  [1] RWTControl
  [2] DamperEnableByRWT
  [3] RWTsetpoint
Parameter:
  [1] RWT-01: return water temp SP shift un-occupied period
  [2] RWT-02: return water temperature low setpoint
  [3] RWT-03: return water temperature high setpoint
  [4] RWT-04: return water temperature P-band
  [5] OAT-01: outside air temperature minimum limit
  [6] OAT-02: outside air temperature maximum limit
  [7] RWT-05: return water temperature control
Description:

================================================================================*/

public class CmReturn_Water_Setpoint_Control
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [19] Function call CfSubtract
    func_19.input[0] = env.getParameter(parameterOffset + 2);
    func_19.input[1] = env.getParameter(parameterOffset + 1);
    func_19.Execute(  );

    // [20] Function call CfSubtract
    func_20.input[0] = CmReturn_Water_Setpoint_Control_input_1;
    func_20.input[1] = env.getParameter(parameterOffset + 5);
    func_20.Execute(  );

    // [21] Function call CfSubtract
    func_21.input[0] = env.getParameter(parameterOffset + 4);
    func_21.input[1] = env.getParameter(parameterOffset + 5);
    func_21.Execute(  );

    // [132] Function call CfCompare1
    func_132.inputA = CmReturn_Water_Setpoint_Control_input_139;
    func_132.inputB = 0F;
    func_132.Execute(  );

    // [155] Function call CfCompare1
    func_155.inputA = env.getParameter(parameterOffset + 6);
    func_155.inputB = 2F;
    func_155.Execute(  );

    // [163] Function call CfNot
    func_163.input = CmReturn_Water_Setpoint_Control_input_151;
    func_163.Execute(  );

    // [171] Function call CfCompare1
    func_171.inputA = env.getParameter(parameterOffset + 6);
    func_171.inputB = 1F;
    func_171.Execute(  );

    // [24] Function call CfMinimum
    func_24.input[0] = func_21.output;
    func_24.input[1] = -0.001F;
    func_24.Execute(  );

    // [160] Function call CfAnd
    func_160.input[0] = func_155.outputEqual;
    func_160.input[1] = CmReturn_Water_Setpoint_Control_input_90;
    func_160.input[2] = func_163.output;
    func_160.Execute(  );

    // [170] Function call CfAnd
    func_170.input[0] = func_163.output;
    func_170.input[1] = func_171.outputEqual;
    func_170.Execute(  );

    // [172] Function call CfAnd
    func_172.input[0] = CmReturn_Water_Setpoint_Control_input_151;
    func_172.input[1] = func_155.outputEqual;
    func_172.Execute(  );

    // [26] Function call CfDivide
    func_26.inputA = func_20.output;
    func_26.inputB = func_24.output;
    func_26.Execute(  );

    // [80] Function call CfCompare1
    func_80.inputA = CmReturn_Water_Setpoint_Control_input_2;
    func_80.inputB = 999F;
    func_80.Execute(  );

    // [189] Function call CfOr
    func_189.input[0] = func_172.outputAND;
    func_189.input[1] = func_160.outputAND;
    func_189.input[2] = func_170.outputAND;
    func_189.Execute(  );

    // [28] Function call CfMultiply
    func_28.input[0] = func_26.output;
    func_28.input[1] = func_19.output;
    func_28.Execute(  );

    // [29] Function call CfAddition
    func_29.input[0] = func_28.output;
    func_29.input[1] = env.getParameter(parameterOffset + 1);
    func_29.Execute(  );

    // [30] Function call CfMaximum
    func_30.input[0] = func_29.output;
    func_30.input[1] = env.getParameter(parameterOffset + 1);
    func_30.Execute(  );

    // [130] Function call CfInputMultiplexer
    func_130.inputSelect = BooleanToInt(func_132.outputEqual);
    func_130.input[1-1] = 0F;
    func_130.input[2-1] = env.getParameter(parameterOffset);
    func_130.Execute(  );

    // [31] Function call CfMinimum
    func_31.input[0] = env.getParameter(parameterOffset + 2);
    func_31.input[1] = func_30.output;
    func_31.Execute(  );

    // [197] Function call CfDivide
    func_197.inputA = env.getParameter(parameterOffset + 3);
    func_197.inputB = 2F;
    func_197.Execute(  );

    // [32] Function call CfAddition
    func_32.input[0] = func_31.output;
    func_32.input[1] = CmReturn_Water_Setpoint_Control_input_4;
    func_32.input[2] = func_130.output;
    func_32.Execute(  );

    // [124] Function call CfIdt
    func_124.input = env.getParameter(parameterOffset + 3);
    func_124.Execute(  );
    env.setParameter(parameterOffset + 7, func_124.output[0]);

    // [123] Function call CfPidPlus
    func_123.inputX = CmReturn_Water_Setpoint_Control_input_2;
    func_123.inputW = func_32.output;
    func_123.inputIntegralOn = false;
    func_123.Execute( env, parameterOffset + 7 );

    // [192] Function call CfSubtract
    func_192.input[0] = func_32.output;
    func_192.input[1] = func_197.output;
    func_192.Execute(  );

    // [102] Function call CfCompare1
    func_102.inputA = CmReturn_Water_Setpoint_Control_input_2;
    func_102.inputB = func_192.output;
    func_102.Execute(  );

    // [34] Function call CfInputMultiplexer
    func_34.inputSelect = BooleanToInt(func_189.outputOR);
    func_34.input[1-1] = func_123.output;
    func_34.input[2-1] = 0F;
    func_34.Execute(  );
    CmReturn_Water_Setpoint_Control_output_5 = func_34.output;

    // [203] Function call CfAnd
    func_203.input[0] = CmReturn_Water_Setpoint_Control_input_151;
    func_203.input[1] = CmReturn_Water_Setpoint_Control_input_201;
    func_203.Execute(  );

    // [199] Function call CfOr
    func_199.input[0] = func_80.outputEqual;
    func_199.input[1] = func_102.outputGreater;
    func_199.input[2] = func_203.outputAND;
    func_199.Execute(  );

    // [127] Function call CfIdt
    func_127.input = func_32.output;
    func_127.Execute(  );
    CmReturn_Water_Setpoint_Control_output_126 = func_127.output[0];

    // [86] Function call CfIdt
    func_86.input = BooleanToFloat(func_199.outputOR);
    func_86.Execute(  );
    CmReturn_Water_Setpoint_Control_output_6 = FloatToBoolean(func_86.output[0]);

  }
// macro register which are written multiple times
// macro inputs
public float CmReturn_Water_Setpoint_Control_input_2; // RWTSensor
public float CmReturn_Water_Setpoint_Control_input_1; // FilteredOAT
public boolean CmReturn_Water_Setpoint_Control_input_90; // OAT>LimitOAT-03
public float CmReturn_Water_Setpoint_Control_input_4; // Incr/DecrFrostRecovery
public float CmReturn_Water_Setpoint_Control_input_139; // PlantMode
public boolean CmReturn_Water_Setpoint_Control_input_151; // PlantMode1,2,4,5,6,30
public boolean CmReturn_Water_Setpoint_Control_input_201; // DamperEnable
// macro outputs
public float CmReturn_Water_Setpoint_Control_output_5; // RWTControl
public boolean CmReturn_Water_Setpoint_Control_output_6; // DamperEnableByRWT
public float CmReturn_Water_Setpoint_Control_output_126; // RWTsetpoint
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfSubtract func_19 = new CfSubtract();
protected CfSubtract func_20 = new CfSubtract();
protected CfSubtract func_21 = new CfSubtract();
protected CfCompare1 func_132 = new CfCompare1();
protected CfCompare1 func_155 = new CfCompare1();
protected CfNot func_163 = new CfNot();
protected CfCompare1 func_171 = new CfCompare1();
protected CfMinimum func_24 = new CfMinimum();
protected CfAnd func_160 = new CfAnd();
protected CfAnd func_170 = new CfAnd();
protected CfAnd func_172 = new CfAnd();
protected CfDivide func_26 = new CfDivide();
protected CfCompare1 func_80 = new CfCompare1();
protected CfOr func_189 = new CfOr();
protected CfMultiply func_28 = new CfMultiply();
protected CfAddition func_29 = new CfAddition();
protected CfMaximum func_30 = new CfMaximum();
protected CfInputMultiplexer func_130 = new CfInputMultiplexer();
protected CfMinimum func_31 = new CfMinimum();
protected CfDivide func_197 = new CfDivide();
protected CfAddition func_32 = new CfAddition();
protected CfIdt func_124 = new CfIdt();
protected CfPidPlus func_123 = new CfPidPlus();
protected CfSubtract func_192 = new CfSubtract();
protected CfCompare1 func_102 = new CfCompare1();
protected CfInputMultiplexer func_34 = new CfInputMultiplexer();
protected CfAnd func_203 = new CfAnd();
protected CfOr func_199 = new CfOr();
protected CfIdt func_127 = new CfIdt();
protected CfIdt func_86 = new CfIdt();

// default constructor
public CmReturn_Water_Setpoint_Control()
{
  func_160.configure(3);
  func_189.configure(3);
  func_32.configure(3);
  func_199.configure(3);
}

  public void Start()
  {
    func_123.Start();
  }
}
