/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    SU/WI Compensation
Macro id:      5854025529202574045
Macro version: 12
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] Outside air temperature
  [2] Setpoint relative room humidity
Outputs:
  [1] Setpoint in summer or winter compensation
Parameter:
  [1] Min. room humidity setpoint during winter
  [2] Max. room humidity setpoint during summer
  [3] Start point OAT winter compensation
  [4] End point OAT winter compensation
  [5] Start point OAT summer compensation
  [6] End point OAT summer compensation
Description:

================================================================================*/

public class CmSUWI_Compensation
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [11] Function call CfSubtract
    func_11.input[0] = env.getParameter(parameterOffset + 5);
    func_11.input[1] = env.getParameter(parameterOffset + 4);
    func_11.Execute(  );

    // [12] Function call CfSubtract
    func_12.input[0] = CmSUWI_Compensation_input_1;
    func_12.input[1] = env.getParameter(parameterOffset + 4);
    func_12.Execute(  );

    // [15] Function call CfCompare1
    func_15.inputA = CmSUWI_Compensation_input_1;
    func_15.inputB = env.getParameter(parameterOffset + 3);
    func_15.Execute(  );

    // [17] Function call CfCompare1
    func_17.inputA = CmSUWI_Compensation_input_1;
    func_17.inputB = env.getParameter(parameterOffset + 4);
    func_17.Execute(  );

    // [27] Function call CfSubtract
    func_27.input[0] = env.getParameter(parameterOffset + 1);
    func_27.input[1] = CmSUWI_Compensation_input_86;
    func_27.Execute(  );

    // [28] Function call CfSubtract
    func_28.input[0] = CmSUWI_Compensation_input_1;
    func_28.input[1] = env.getParameter(parameterOffset + 2);
    func_28.Execute(  );

    // [31] Function call CfSubtract
    func_31.input[0] = CmSUWI_Compensation_input_86;
    func_31.input[1] = env.getParameter(parameterOffset);
    func_31.Execute(  );

    // [33] Function call CfSubtract
    func_33.input[0] = env.getParameter(parameterOffset + 3);
    func_33.input[1] = env.getParameter(parameterOffset + 2);
    func_33.Execute(  );

    // [13] Function call CfMaximum
    func_13.input[0] = func_11.output;
    func_13.input[1] = 0.008F;
    func_13.Execute(  );

    // [16] Function call CfNot
    func_16.input = func_15.outputLess;
    func_16.Execute(  );

    // [18] Function call CfNot
    func_18.input = func_17.outputLess;
    func_18.Execute(  );

    // [29] Function call CfMaximum
    func_29.input[0] = func_33.output;
    func_29.input[1] = 0.008F;
    func_29.Execute(  );

    // [25] Function call CfDivide
    func_25.inputA = func_12.output;
    func_25.inputB = func_13.output;
    func_25.Execute(  );

    // [30] Function call CfDivide
    func_30.inputA = func_28.output;
    func_30.inputB = func_29.output;
    func_30.Execute(  );

    // [26] Function call CfMultiply
    func_26.input[0] = func_25.output;
    func_26.input[1] = func_27.output;
    func_26.Execute(  );

    // [32] Function call CfMultiply
    func_32.input[0] = func_30.output;
    func_32.input[1] = func_31.output;
    func_32.Execute(  );

    // [14] Function call CfAddition
    func_14.input[0] = func_32.output;
    func_14.input[1] = env.getParameter(parameterOffset);
    func_14.Execute(  );

    // [19] Function call CfAddition
    func_19.input[0] = func_26.output;
    func_19.input[1] = CmSUWI_Compensation_input_86;
    func_19.Execute(  );

    // [23] Function call CfMaximum
    func_23.input[0] = func_19.output;
    func_23.input[1] = CmSUWI_Compensation_input_86;
    func_23.Execute(  );

    // [24] Function call CfMaximum
    func_24.input[0] = func_14.output;
    func_24.input[1] = env.getParameter(parameterOffset);
    func_24.Execute(  );

    // [21] Function call CfMinimum
    func_21.input[0] = func_24.output;
    func_21.input[1] = CmSUWI_Compensation_input_86;
    func_21.Execute(  );

    // [22] Function call CfMinimum
    func_22.input[0] = func_23.output;
    func_22.input[1] = env.getParameter(parameterOffset + 1);
    func_22.Execute(  );

    // [20] Function call CfInputMultiplexer
    func_20.inputSelect = BooleanToInt(func_16.output);
    func_20.input[1-1] = func_21.output;
    func_20.input[2-1] = CmSUWI_Compensation_input_86;
    func_20.Execute(  );

    // [34] Function call CfInputMultiplexer
    func_34.inputSelect = BooleanToInt(func_18.output);
    func_34.input[1-1] = func_20.output;
    func_34.input[2-1] = func_22.output;
    func_34.Execute(  );
    CmSUWI_Compensation_output_85 = func_34.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmSUWI_Compensation_input_1; // Outside air temperature
public float CmSUWI_Compensation_input_86; // Setpoint relative room humidity
// macro outputs
public float CmSUWI_Compensation_output_85; // Setpoint in summer or winter compensation
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfSubtract func_11 = new CfSubtract();
protected CfSubtract func_12 = new CfSubtract();
protected CfCompare1 func_15 = new CfCompare1();
protected CfCompare1 func_17 = new CfCompare1();
protected CfSubtract func_27 = new CfSubtract();
protected CfSubtract func_28 = new CfSubtract();
protected CfSubtract func_31 = new CfSubtract();
protected CfSubtract func_33 = new CfSubtract();
protected CfMaximum func_13 = new CfMaximum();
protected CfNot func_16 = new CfNot();
protected CfNot func_18 = new CfNot();
protected CfMaximum func_29 = new CfMaximum();
protected CfDivide func_25 = new CfDivide();
protected CfDivide func_30 = new CfDivide();
protected CfMultiply func_26 = new CfMultiply();
protected CfMultiply func_32 = new CfMultiply();
protected CfAddition func_14 = new CfAddition();
protected CfAddition func_19 = new CfAddition();
protected CfMaximum func_23 = new CfMaximum();
protected CfMaximum func_24 = new CfMaximum();
protected CfMinimum func_21 = new CfMinimum();
protected CfMinimum func_22 = new CfMinimum();
protected CfInputMultiplexer func_20 = new CfInputMultiplexer();
protected CfInputMultiplexer func_34 = new CfInputMultiplexer();

// default constructor
public CmSUWI_Compensation()
{
}

  public void Start()
  {
  }
}
