/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 19:17
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.air_conditioning;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Timestamp Of Event
Macro id:      5803586584647303807
Macro version: 10
Last change:   17.12.2015 - 12:50
Access Level:  2
Inputs:
  [1] event
Outputs:
  [1] year
  [2] month
  [3] day
  [4] hour
  [5] minute
Parameter:
  [1] runtime damper to fire
Description:
output of the timestamp of a event in year, month, day, hours and minutes
================================================================================*/

public class CmTimestamp_Of_Event
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [8] Function call CfDivide
    func_8.inputA = IntToFloat(ControlFunction.GetHoursAndMinutes());
    func_8.inputB = 100F;
    func_8.Execute(  );

    // [9] Function call CfDivide
    func_9.inputA = IntToFloat(ControlFunction.GetDayAndMonth());
    func_9.inputB = 100F;
    func_9.Execute(  );

    // [57] Function call CfIdt
    func_57.input = env.getParameter(parameterOffset);
    func_57.Execute(  );
    env.setParameter(parameterOffset + 1, func_57.output[0]);

    // [63] Function call CfLastValue
    func_63.input = BooleanToFloat(CmTimestamp_Of_Event_input_1);
    func_63.Execute(  );

    // [10] Function call CfTruncate
    func_10.input = func_8.output;
    func_10.Execute(  );

    // [11] Function call CfTruncate
    func_11.input = func_9.output;
    func_11.Execute(  );

    // [64] Function call CfSubtract
    func_64.input[0] = func_63.outputLast;
    func_64.input[1] = func_63.outputCurrent;
    func_64.Execute(  );

    // [13] Function call CfMultiply
    func_13.input[0] = func_10.output;
    func_13.input[1] = 100F;
    func_13.Execute(  );

    // [14] Function call CfMultiply
    func_14.input[0] = func_11.output;
    func_14.input[1] = 100F;
    func_14.Execute(  );

    // [16] Function call CfMonoflop
    func_16.input = func_64.output;
    func_16.Execute( env, parameterOffset + 1 );

    // [17] Function call CfSubtract
    func_17.input[0] = IntToFloat(ControlFunction.GetHoursAndMinutes());
    func_17.input[1] = func_13.output;
    func_17.Execute(  );

    // [18] Function call CfSubtract
    func_18.input[0] = IntToFloat(ControlFunction.GetDayAndMonth());
    func_18.input[1] = func_14.output;
    func_18.Execute(  );

    // [21] Function call CfInputMultiplexer ("Std")
    func_21.inputSelect = BooleanToInt(func_16.output);
    func_21.input[1-1] = CmTimestamp_Of_Event_output_4;
    func_21.input[2-1] = func_10.output;
    func_21.Execute(  );
    CmTimestamp_Of_Event_output_4 = func_21.output;

    // [22] Function call CfInputMultiplexer ("Monat")
    func_22.inputSelect = BooleanToInt(func_16.output);
    func_22.input[1-1] = CmTimestamp_Of_Event_output_2;
    func_22.input[2-1] = func_11.output;
    func_22.Execute(  );
    CmTimestamp_Of_Event_output_2 = func_22.output;

    // [60] Function call CfInputMultiplexer
    func_60.inputSelect = BooleanToInt(func_16.output);
    func_60.input[1-1] = CmTimestamp_Of_Event_output_59;
    func_60.input[2-1] = IntToFloat(ControlFunction.GetYear());
    func_60.Execute(  );
    CmTimestamp_Of_Event_output_59 = func_60.output;

    // [19] Function call CfInputMultiplexer ("Min")
    func_19.inputSelect = BooleanToInt(func_16.output);
    func_19.input[1-1] = CmTimestamp_Of_Event_output_5;
    func_19.input[2-1] = func_17.output;
    func_19.Execute(  );
    CmTimestamp_Of_Event_output_5 = func_19.output;

    // [20] Function call CfInputMultiplexer ("Tag")
    func_20.inputSelect = BooleanToInt(func_16.output);
    func_20.input[1-1] = CmTimestamp_Of_Event_output_3;
    func_20.input[2-1] = func_18.output;
    func_20.Execute(  );
    CmTimestamp_Of_Event_output_3 = func_20.output;

  }
// macro register which are written multiple times
// macro inputs
public boolean CmTimestamp_Of_Event_input_1; // event
// macro outputs
public float CmTimestamp_Of_Event_output_59; // year
public float CmTimestamp_Of_Event_output_2; // month
public float CmTimestamp_Of_Event_output_3; // day
public float CmTimestamp_Of_Event_output_4; // hour
public float CmTimestamp_Of_Event_output_5; // minute
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private float   IntToFloat    (int     value) { return (float) value; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfDivide func_8 = new CfDivide();
protected CfDivide func_9 = new CfDivide();
protected CfIdt func_57 = new CfIdt();
protected CfLastValue func_63 = new CfLastValue();
protected CfTruncate func_10 = new CfTruncate();
protected CfTruncate func_11 = new CfTruncate();
protected CfSubtract func_64 = new CfSubtract();
protected CfMultiply func_13 = new CfMultiply();
protected CfMultiply func_14 = new CfMultiply();
protected CfMonoflop func_16 = new CfMonoflop();
protected CfSubtract func_17 = new CfSubtract();
protected CfSubtract func_18 = new CfSubtract();
protected CfInputMultiplexer func_21 = new CfInputMultiplexer();
protected CfInputMultiplexer func_22 = new CfInputMultiplexer();
protected CfInputMultiplexer func_60 = new CfInputMultiplexer();
protected CfInputMultiplexer func_19 = new CfInputMultiplexer();
protected CfInputMultiplexer func_20 = new CfInputMultiplexer();

// default constructor
public CmTimestamp_Of_Event()
{
}

  public void Start()
  {
    func_63.Start();
    func_16.Start();
  }
}
