/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:27
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.chiller;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    CAA_AddOnModule
Macro id:      6238832135525892138
Macro version: 18
Last change:   25.04.2017 - 14:23
Access Level:  2
Inputs:
  [1] LeavingTemp
  [2] EnteringTemp
  [3] SensorInput
  [4] ElectricPower
  [5] ChcaaComm
  [6] Enable
Outputs:
  [1] ChillCapacity
  [2] ChillCapyPercent
  [3] COP
  [4] ComBypValveCtrl
  [5] DispAvgCap
  [6] ChcaaComm
Parameter:
  [1] CH-01: specific heat of medium
  [2] CH-02: total chiller capacity
  [3] KW-01: nominal electric power of the chiller
  [4] CDP-01: input signal 0=lin; 1=dp
  [5] CDP-02: conversion constant
  [6] CBV-01: chiller flow setpoint
  [7] CBV-02: P-band common bypass valve control
  [8] SYS-01: chiller capacity calculation based on 0=cap 1=power
  [9] SYS-02: communication signal chiller power
  [10] DISP-01: actual flow chiller
  [11] DISP-02: number of hours run in the chiller capacity range of [0…30]%
  [12] DISP-03: number of hours run in the chiller capacity range of [30…90] %
  [13] DISP-04: number of hours run in the chiller capacity range of [90…100] %
Description:
The CAA is an add-on module for the chiller 
output module. This module calculates the actual chiller 
capacity, the chiller capacity percentage, average chiller 
capacity of the operating chillers, chiller electrical demand 
and the chiller operating coefficient. The module provides 
average chiller capacity percentage and modulating control 
of the common bypass valve.


================================================================================*/

public class BCmCAA_AddOnModule
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmCAA_AddOnModule_output_7().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmCAA_AddOnModule_output_7().setStatus(BStatus.disabled);
    getCmCAA_AddOnModule_output_8().setStatus(BStatus.disabled);
    getCmCAA_AddOnModule_output_10().setStatus(BStatus.disabled);
    getCmCAA_AddOnModule_output_11().setStatus(BStatus.disabled);
    getCmCAA_AddOnModule_output_13().setStatus(BStatus.disabled);
    getCmCAA_AddOnModule_output_12().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmCAA_AddOnModule_output_7().setStatus(BStatus.ok);
    getCmCAA_AddOnModule_output_8().setStatus(BStatus.ok);
    getCmCAA_AddOnModule_output_10().setStatus(BStatus.ok);
    getCmCAA_AddOnModule_output_11().setStatus(BStatus.ok);
    getCmCAA_AddOnModule_output_13().setStatus(BStatus.ok);
    getCmCAA_AddOnModule_output_12().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [524] Function call CfCompare1
    func_524.inputA = (float) getCmCAA_AddOnModule_input_3().getValue();
    func_524.inputB = 999F;
    func_524.Execute(  );

    // [526] Function call CfNot
    func_526.input = func_524.outputEqual;
    func_526.Execute(  );

    // [527] Function call CfOr
    func_527.input[0] = FloatToBoolean(func_522.output);
    func_527.input[1] = func_526.output;
    func_527.Execute(  );

    // [522] Function call CfInputMultiplexer
    func_522.inputSelect = BooleanToInt(ControlFunction.GetStartupFlag());
    func_522.input[1-1] = BooleanToFloat(func_527.outputOR);
    func_522.input[2-1] = 0F;
    func_522.Execute(  );

    // [79] Function call CfCompare1
    func_79.inputA = BooleanToFloat(getCmCAA_AddOnModule_input_5().getValue());
    func_79.inputB = 0F;
    func_79.Execute(  );

    // [88] Function call CfCompare1
    func_88.inputA = func_522.output;
    func_88.inputB = 0F;
    func_88.Execute(  );

    // [90] Function call CfSquareRoot
    func_90.input = (float) getCmCAA_AddOnModule_input_3().getValue();
    func_90.Execute(  );

    // [92] Function call CfInputMultiplexer
    func_92.inputSelect = FloatToInt((float) getCmCAA_AddOnModule_parameter_21());
    func_92.input[1-1] = (float) getCmCAA_AddOnModule_input_3().getValue();
    func_92.input[2-1] = func_90.output;
    func_92.Execute(  );

    // [535] Function call CfOr
    func_535.input[0] = func_79.outputEqual;
    func_535.input[1] = func_88.outputEqual;
    func_535.Execute(  );

    // [94] Function call CfMultiply
    func_94.input[0] = func_92.output;
    func_94.input[1] = (float) getCmCAA_AddOnModule_parameter_22();
    func_94.Execute(  );

    // [534] Function call CfInputMultiplexer
    func_534.inputSelect = BooleanToInt(func_535.outputOR);
    func_534.input[1-1] = func_94.output;
    func_534.input[2-1] = 0F;
    func_534.Execute(  );

    // [96] Function call CfIdt
    func_96.input = func_534.output;
    func_96.Execute(  );

    // [533] Function call CfIdt
    func_533.input = func_534.output;
    func_533.Execute(  );
    setCmCAA_AddOnModule_parameter_26(func_533.output[0]);

    // [100] Function call CfMaximum
    func_100.input[0] = (float) getCmCAA_AddOnModule_parameter_24();
    func_100.input[1] = 1F;
    func_100.Execute(  );

    // [102] Function call CfSubtract
    func_102.input[0] = func_96.output[0];
    func_102.input[1] = (float) getCmCAA_AddOnModule_parameter_23();
    func_102.Execute(  );

    // [103] Function call CfDivide
    func_103.inputA = 100F;
    func_103.inputB = func_100.output;
    func_103.Execute(  );

    // [105] Function call CfMultiply
    func_105.input[0] = func_102.output;
    func_105.input[1] = func_103.output;
    func_105.Execute(  );

    // [107] Function call CfAddition
    func_107.input[0] = func_105.output;
    func_107.input[1] = 50F;
    func_107.Execute(  );

    // [109] Function call CfMaximum
    func_109.input[0] = func_107.output;
    func_109.input[1] = 0F;
    func_109.Execute(  );

    // [111] Function call CfMinimum
    func_111.input[0] = func_109.output;
    func_111.input[1] = 100F;
    func_111.Execute(  );

    // [553] Function call CfCompare1
    func_553.inputA = BooleanToFloat(getCmCAA_AddOnModule_input_5().getValue());
    func_553.inputB = 0F;
    func_553.Execute(  );

    // [552] Function call CfCompare1
    func_552.inputA = func_522.output;
    func_552.inputB = 0F;
    func_552.Execute(  );

    // [554] Function call CfOr
    func_554.input[0] = func_553.outputEqual;
    func_554.input[1] = func_552.outputEqual;
    func_554.Execute(  );

    // [549] Function call CfInputMultiplexer
    func_549.inputSelect = BooleanToInt(func_554.outputOR);
    func_549.input[1-1] = func_111.output;
    func_549.input[2-1] = 100F;
    func_549.Execute(  );
    setCmCAA_AddOnModule_output_11(func_549.output);

    // [120] Function call CfCompare1
    func_120.inputA = (float) getCmCAA_AddOnModule_input_2().getValue();
    func_120.inputB = 999F;
    func_120.Execute(  );

    // [122] Function call CfCompare1
    func_122.inputA = (float) getCmCAA_AddOnModule_input_1().getValue();
    func_122.inputB = 999F;
    func_122.Execute(  );

    // [124] Function call CfCompare1
    func_124.inputA = (float) getCmCAA_AddOnModule_input_2().getValue();
    func_124.inputB = (float) getCmCAA_AddOnModule_input_1().getValue();
    func_124.Execute(  );

    // [573] Function call CfCompare1
    func_573.inputA = BooleanToFloat(getCmCAA_AddOnModule_input_5().getValue());
    func_573.inputB = 0F;
    func_573.Execute(  );

    // [578] Function call CfCompare1
    func_578.inputA = func_522.output;
    func_578.inputB = 0F;
    func_578.Execute(  );

    // [126] Function call CfSubtract
    func_126.input[0] = (float) getCmCAA_AddOnModule_input_2().getValue();
    func_126.input[1] = (float) getCmCAA_AddOnModule_input_1().getValue();
    func_126.Execute(  );

    // [135] Function call CfMultiply
    func_135.input[0] = func_126.output;
    func_135.input[1] = (float) getCmCAA_AddOnModule_parameter_15();
    func_135.input[2] = func_96.output[0];
    func_135.Execute(  );

    // [137] Function call CfDivide
    func_137.inputA = func_135.output;
    func_137.inputB = 1000F;
    func_137.Execute(  );

    // [146] Function call CfCompare1
    func_146.inputA = (float) getCmCAA_AddOnModule_parameter_25();
    func_146.inputB = 0F;
    func_146.Execute(  );

    // [150] Function call CfMultiply
    func_150.input[0] = (float) getCmCAA_AddOnModule_input_4().getValue();
    func_150.input[1] = (float) getCmCAA_AddOnModule_parameter_16();
    func_150.Execute(  );

    // [151] Function call CfMaximum
    func_151.input[0] = (float) getCmCAA_AddOnModule_parameter_17();
    func_151.input[1] = 1F;
    func_151.Execute(  );

    // [155] Function call CfDivide
    func_155.inputA = func_150.output;
    func_155.inputB = func_151.output;
    func_155.Execute(  );

    // [731] Function call CfMultiply
    func_731.input[0] = func_155.output;
    func_731.input[1] = BooleanToFloat(func_573.outputGreater);
    func_731.Execute(  );

    // [574] Function call CfOr
    func_574.input[0] = func_573.outputEqual;
    func_574.input[1] = func_122.outputEqual;
    func_574.input[2] = func_124.outputLess;
    func_574.input[3] = func_120.outputEqual;
    func_574.input[4] = func_578.outputEqual;
    func_574.Execute(  );

    // [721] Function call CfMultiply
    func_721.input[0] = func_137.output;
    func_721.input[1] = BooleanToFloat(func_574.outputNOR);
    func_721.Execute(  );

    // [575] Function call CfInputMultiplexer
    func_575.inputSelect = BooleanToInt(func_146.outputEqual);
    func_575.input[1-1] = func_731.output;
    func_575.input[2-1] = func_721.output;
    func_575.Execute(  );

    // [157] Function call CfIdt
    func_157.input = func_575.output;
    func_157.Execute(  );

    // [571] Function call CfIdt
    func_571.input = func_575.output;
    func_571.Execute(  );
    setCmCAA_AddOnModule_output_7(func_571.output[0]);

    // [661] Function call CfDivide
    func_661.inputA = func_157.output[0];
    func_661.inputB = (float) getCmCAA_AddOnModule_input_4().getValue();
    func_661.Execute(  );

    // [663] Function call CfMaximum
    func_663.input[0] = func_661.output;
    func_663.input[1] = 0F;
    func_663.Execute(  );

    // [732] Function call CfCompare1
    func_732.inputA = (float) getCmCAA_AddOnModule_input_4().getValue();
    func_732.inputB = 0F;
    func_732.Execute(  );

    // [736] Function call CfInputMultiplexer
    func_736.inputSelect = BooleanToInt(func_732.outputEqual);
    func_736.input[1-1] = func_663.output;
    func_736.input[2-1] = 0F;
    func_736.Execute(  );
    setCmCAA_AddOnModule_output_10(func_736.output);

    // [162] Function call CfMultiply
    func_162.input[0] = func_157.output[0];
    func_162.input[1] = 100F;
    func_162.Execute(  );

    // [163] Function call CfMaximum
    func_163.input[0] = (float) getCmCAA_AddOnModule_parameter_16();
    func_163.input[1] = 1F;
    func_163.Execute(  );

    // [165] Function call CfDivide
    func_165.inputA = func_162.output;
    func_165.inputB = func_163.output;
    func_165.Execute(  );

    // [586] Function call CfCompare1
    func_586.inputA = BooleanToFloat(getCmCAA_AddOnModule_input_5().getValue());
    func_586.inputB = 0F;
    func_586.Execute(  );

    // [589] Function call CfInputMultiplexer
    func_589.inputSelect = BooleanToInt(func_586.outputEqual);
    func_589.input[1-1] = func_165.output;
    func_589.input[2-1] = 0F;
    func_589.Execute(  );

    // [583] Function call CfIdt
    func_583.input = func_589.output;
    func_583.Execute(  );
    setCmCAA_AddOnModule_output_8(func_583.output[0]);

    // [192] Function call CfDivide
    func_192.inputA = (float) getCmCAA_AddOnModule_input_6().getValue();
    func_192.inputB = 100F;
    func_192.Execute(  );

    // [194] Function call CfTruncate
    func_194.input = func_192.output;
    func_194.Execute(  );

    // [196] Function call CfIdt
    func_196.input = func_194.output;
    func_196.Execute(  );

    // [198] Function call CfMultiply
    func_198.input[0] = func_194.output;
    func_198.input[1] = 100F;
    func_198.Execute(  );

    // [200] Function call CfSubtract
    func_200.input[0] = (float) getCmCAA_AddOnModule_input_6().getValue();
    func_200.input[1] = func_198.output;
    func_200.Execute(  );

    // [204] Function call CfIdt
    func_204.input = func_196.output[0];
    func_204.Execute(  );

    // [205] Function call CfTruncate
    func_205.input = func_589.output;
    func_205.Execute(  );

    // [208] Function call CfAddition
    func_208.input[0] = func_204.output[0];
    func_208.input[1] = func_205.output;
    func_208.Execute(  );

    // [209] Function call CfAddition
    func_209.input[0] = func_200.output;
    func_209.input[1] = 1F;
    func_209.Execute(  );

    // [211] Function call CfCompare1
    func_211.inputA = BooleanToFloat(getCmCAA_AddOnModule_input_5().getValue());
    func_211.inputB = 0F;
    func_211.Execute(  );

    // [614] Function call CfInputMultiplexer
    func_614.inputSelect = BooleanToInt(func_211.outputGreater);
    func_614.input[1-1] = func_204.output[0];
    func_614.input[2-1] = func_208.output;
    func_614.Execute(  );

    // [223] Function call CfMultiply
    func_223.input[0] = func_614.output;
    func_223.input[1] = 100F;
    func_223.Execute(  );

    // [615] Function call CfInputMultiplexer
    func_615.inputSelect = BooleanToInt(func_211.outputGreater);
    func_615.input[1-1] = func_200.output;
    func_615.input[2-1] = func_209.output;
    func_615.Execute(  );

    // [227] Function call CfAddition
    func_227.input[0] = func_615.output;
    func_227.input[1] = func_223.output;
    func_227.Execute(  );

    // [233] Function call CfIdt
    func_233.input = func_227.output;
    func_233.Execute(  );
    setCmCAA_AddOnModule_output_12(func_233.output[0]);

    // [239] Function call CfCompare1
    func_239.inputA = (float) getCmCAA_AddOnModule_parameter_697();
    func_239.inputB = 0F;
    func_239.Execute(  );

    // [242] Function call CfCompare1
    func_242.inputA = func_615.output;
    func_242.inputB = 0F;
    func_242.Execute(  );

    // [244] Function call CfDivide
    func_244.inputA = func_614.output;
    func_244.inputB = func_615.output;
    func_244.Execute(  );

    // [620] Function call CfInputMultiplexer
    func_620.inputSelect = BooleanToInt(func_242.outputEqual);
    func_620.input[1-1] = func_244.output;
    func_620.input[2-1] = (float) getCmCAA_AddOnModule_output_13().getValue();
    func_620.Execute(  );

    // [619] Function call CfInputMultiplexer
    func_619.inputSelect = BooleanToInt(func_239.outputEqual);
    func_619.input[1-1] = func_620.output;
    func_619.input[2-1] = 0F;
    func_619.Execute(  );
    setCmCAA_AddOnModule_output_13(func_619.output);

    // [684] Function call CfIdt
    func_684.input = (float) getCmCAA_AddOnModule_output_8().getValue();
    func_684.Execute(  );

    // [664] Function call CfCompare2
    func_664.inputA = func_684.output[0];
    func_664.inputB = 30F;
    func_664.Execute(  );

    // [667] Function call CfCompare2
    func_667.inputA = func_684.output[0];
    func_667.inputB = 90F;
    func_667.Execute(  );

    // [680] Function call CfNot
    func_680.input = func_664.outputEqualOrLess;
    func_680.Execute(  );

    // [679] Function call CfNot
    func_679.input = func_667.outputEqualOrGreater;
    func_679.Execute(  );

    // [682] Function call CfAnd
    func_682.input[0] = func_680.output;
    func_682.input[1] = func_679.output;
    func_682.Execute(  );

    // [670] Function call CfTimeCounter
    func_670.inputSignal = func_664.outputEqualOrLess;
    func_670.inputReset = false;
    func_670.Execute(  );
    setCmCAA_AddOnModule_parameter_658(IntToFloat(func_670.outputHours));

    // [673] Function call CfTimeCounter
    func_673.inputSignal = func_682.outputAND;
    func_673.inputReset = false;
    func_673.Execute(  );
    setCmCAA_AddOnModule_parameter_659(IntToFloat(func_673.outputHours));

    // [676] Function call CfTimeCounter
    func_676.inputSignal = func_667.outputEqualOrGreater;
    func_676.inputReset = false;
    func_676.Execute(  );
    setCmCAA_AddOnModule_parameter_660(IntToFloat(func_676.outputHours));

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// ChillCapacity
  public static final Property CmCAA_AddOnModule_output_7 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCAA_AddOnModule_output_7() { return (BStatusNumeric) get(CmCAA_AddOnModule_output_7); }
  public void setCmCAA_AddOnModule_output_7(BStatusNumeric v) { set(CmCAA_AddOnModule_output_7,v,null); }
  public void setCmCAA_AddOnModule_output_7(float v) { getCmCAA_AddOnModule_output_7().setValue(v); }
// ChillCapyPercent
  public static final Property CmCAA_AddOnModule_output_8 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCAA_AddOnModule_output_8() { return (BStatusNumeric) get(CmCAA_AddOnModule_output_8); }
  public void setCmCAA_AddOnModule_output_8(BStatusNumeric v) { set(CmCAA_AddOnModule_output_8,v,null); }
  public void setCmCAA_AddOnModule_output_8(float v) { getCmCAA_AddOnModule_output_8().setValue(v); }
// COP
  public static final Property CmCAA_AddOnModule_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCAA_AddOnModule_output_10() { return (BStatusNumeric) get(CmCAA_AddOnModule_output_10); }
  public void setCmCAA_AddOnModule_output_10(BStatusNumeric v) { set(CmCAA_AddOnModule_output_10,v,null); }
  public void setCmCAA_AddOnModule_output_10(float v) { getCmCAA_AddOnModule_output_10().setValue(v); }
// ComBypValveCtrl
  public static final Property CmCAA_AddOnModule_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCAA_AddOnModule_output_11() { return (BStatusNumeric) get(CmCAA_AddOnModule_output_11); }
  public void setCmCAA_AddOnModule_output_11(BStatusNumeric v) { set(CmCAA_AddOnModule_output_11,v,null); }
  public void setCmCAA_AddOnModule_output_11(float v) { getCmCAA_AddOnModule_output_11().setValue(v); }
// DispAvgCap
  public static final Property CmCAA_AddOnModule_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCAA_AddOnModule_output_13() { return (BStatusNumeric) get(CmCAA_AddOnModule_output_13); }
  public void setCmCAA_AddOnModule_output_13(BStatusNumeric v) { set(CmCAA_AddOnModule_output_13,v,null); }
  public void setCmCAA_AddOnModule_output_13(float v) { getCmCAA_AddOnModule_output_13().setValue(v); }
// ChcaaComm
  public static final Property CmCAA_AddOnModule_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCAA_AddOnModule_output_12() { return (BStatusNumeric) get(CmCAA_AddOnModule_output_12); }
  public void setCmCAA_AddOnModule_output_12(BStatusNumeric v) { set(CmCAA_AddOnModule_output_12,v,null); }
  public void setCmCAA_AddOnModule_output_12(float v) { getCmCAA_AddOnModule_output_12().setValue(v); }

  // macro parameter
// CH-01: specific heat of medium
  public static final Property CmCAA_AddOnModule_parameter_15 = newProperty( 0, BDouble.make( 4184 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(99999)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCAA_AddOnModule_parameter_15() { return getDouble(CmCAA_AddOnModule_parameter_15); }
  public void setCmCAA_AddOnModule_parameter_15(double v) { setDouble(CmCAA_AddOnModule_parameter_15,v,null); }
// CH-02: total chiller capacity
  public static final Property CmCAA_AddOnModule_parameter_16 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(999999)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kilowatt"))));
  public double getCmCAA_AddOnModule_parameter_16() { return getDouble(CmCAA_AddOnModule_parameter_16); }
  public void setCmCAA_AddOnModule_parameter_16(double v) { setDouble(CmCAA_AddOnModule_parameter_16,v,null); }
// KW-01: nominal electric power of the chiller
  public static final Property CmCAA_AddOnModule_parameter_17 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(9999)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kilowatt"))));
  public double getCmCAA_AddOnModule_parameter_17() { return getDouble(CmCAA_AddOnModule_parameter_17); }
  public void setCmCAA_AddOnModule_parameter_17(double v) { setDouble(CmCAA_AddOnModule_parameter_17,v,null); }
// CDP-01: input signal 0=lin; 1=dp
  public static final Property CmCAA_AddOnModule_parameter_21 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCAA_AddOnModule_parameter_21() { return getDouble(CmCAA_AddOnModule_parameter_21); }
  public void setCmCAA_AddOnModule_parameter_21(double v) { setDouble(CmCAA_AddOnModule_parameter_21,v,null); }
// CDP-02: conversion constant
  public static final Property CmCAA_AddOnModule_parameter_22 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(9999)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCAA_AddOnModule_parameter_22() { return getDouble(CmCAA_AddOnModule_parameter_22); }
  public void setCmCAA_AddOnModule_parameter_22(double v) { setDouble(CmCAA_AddOnModule_parameter_22,v,null); }
// CBV-01: chiller flow setpoint
  public static final Property CmCAA_AddOnModule_parameter_23 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(9999)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmCAA_AddOnModule_parameter_23() { return getDouble(CmCAA_AddOnModule_parameter_23); }
  public void setCmCAA_AddOnModule_parameter_23(double v) { setDouble(CmCAA_AddOnModule_parameter_23,v,null); }
// CBV-02: P-band common bypass valve control
  public static final Property CmCAA_AddOnModule_parameter_24 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(9999)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmCAA_AddOnModule_parameter_24() { return getDouble(CmCAA_AddOnModule_parameter_24); }
  public void setCmCAA_AddOnModule_parameter_24(double v) { setDouble(CmCAA_AddOnModule_parameter_24,v,null); }
// SYS-01: chiller capacity calculation based on 0=cap 1=power
  public static final Property CmCAA_AddOnModule_parameter_25 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCAA_AddOnModule_parameter_25() { return getDouble(CmCAA_AddOnModule_parameter_25); }
  public void setCmCAA_AddOnModule_parameter_25(double v) { setDouble(CmCAA_AddOnModule_parameter_25,v,null); }
// SYS-02: communication signal chiller power
  public static final Property CmCAA_AddOnModule_parameter_697 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCAA_AddOnModule_parameter_697() { return getDouble(CmCAA_AddOnModule_parameter_697); }
  public void setCmCAA_AddOnModule_parameter_697(double v) { setDouble(CmCAA_AddOnModule_parameter_697,v,null); }
// DISP-01: actual flow chiller
  public static final Property CmCAA_AddOnModule_parameter_26 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCAA_AddOnModule_parameter_26() { return getDouble(CmCAA_AddOnModule_parameter_26); }
  public void setCmCAA_AddOnModule_parameter_26(double v) { setDouble(CmCAA_AddOnModule_parameter_26,v,null); }
// DISP-02: number of hours run in the chiller capacity range of [0…30]%
  public static final Property CmCAA_AddOnModule_parameter_658 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmCAA_AddOnModule_parameter_658() { return getDouble(CmCAA_AddOnModule_parameter_658); }
  public void setCmCAA_AddOnModule_parameter_658(double v) { setDouble(CmCAA_AddOnModule_parameter_658,v,null); }
// DISP-03: number of hours run in the chiller capacity range of [30…90] %
  public static final Property CmCAA_AddOnModule_parameter_659 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmCAA_AddOnModule_parameter_659() { return getDouble(CmCAA_AddOnModule_parameter_659); }
  public void setCmCAA_AddOnModule_parameter_659(double v) { setDouble(CmCAA_AddOnModule_parameter_659,v,null); }
// DISP-04: number of hours run in the chiller capacity range of [90…100] %
  public static final Property CmCAA_AddOnModule_parameter_660 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmCAA_AddOnModule_parameter_660() { return getDouble(CmCAA_AddOnModule_parameter_660); }
  public void setCmCAA_AddOnModule_parameter_660(double v) { setDouble(CmCAA_AddOnModule_parameter_660,v,null); }

  // macro inputs
// LeavingTemp
  public static final Property CmCAA_AddOnModule_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmCAA_AddOnModule_input_1() { return (BStatusNumeric) get(CmCAA_AddOnModule_input_1); }
  public void setCmCAA_AddOnModule_input_1(BStatusNumeric v) { set(CmCAA_AddOnModule_input_1,v,null); }
  public void setCmCAA_AddOnModule_input_1(float v) { getCmCAA_AddOnModule_input_1().setValue(v); }
// EnteringTemp
  public static final Property CmCAA_AddOnModule_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmCAA_AddOnModule_input_2() { return (BStatusNumeric) get(CmCAA_AddOnModule_input_2); }
  public void setCmCAA_AddOnModule_input_2(BStatusNumeric v) { set(CmCAA_AddOnModule_input_2,v,null); }
  public void setCmCAA_AddOnModule_input_2(float v) { getCmCAA_AddOnModule_input_2().setValue(v); }
// SensorInput
  public static final Property CmCAA_AddOnModule_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmCAA_AddOnModule_input_3() { return (BStatusNumeric) get(CmCAA_AddOnModule_input_3); }
  public void setCmCAA_AddOnModule_input_3(BStatusNumeric v) { set(CmCAA_AddOnModule_input_3,v,null); }
  public void setCmCAA_AddOnModule_input_3(float v) { getCmCAA_AddOnModule_input_3().setValue(v); }
// ElectricPower
  public static final Property CmCAA_AddOnModule_input_4 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmCAA_AddOnModule_input_4() { return (BStatusNumeric) get(CmCAA_AddOnModule_input_4); }
  public void setCmCAA_AddOnModule_input_4(BStatusNumeric v) { set(CmCAA_AddOnModule_input_4,v,null); }
  public void setCmCAA_AddOnModule_input_4(float v) { getCmCAA_AddOnModule_input_4().setValue(v); }
// ChcaaComm
  public static final Property CmCAA_AddOnModule_input_6 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmCAA_AddOnModule_input_6() { return (BStatusNumeric) get(CmCAA_AddOnModule_input_6); }
  public void setCmCAA_AddOnModule_input_6(BStatusNumeric v) { set(CmCAA_AddOnModule_input_6,v,null); }
  public void setCmCAA_AddOnModule_input_6(float v) { getCmCAA_AddOnModule_input_6().setValue(v); }
// Enable
  public static final Property CmCAA_AddOnModule_input_5 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmCAA_AddOnModule_input_5() { return (BStatusBoolean) get(CmCAA_AddOnModule_input_5); }
  public void setCmCAA_AddOnModule_input_5(BStatusBoolean v) { set(CmCAA_AddOnModule_input_5,v,null); }
  public void setCmCAA_AddOnModule_input_5(boolean v) { getCmCAA_AddOnModule_input_5().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.02 [18] 25.04.2017-14:23").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6238832135525892138").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmCAA_AddOnModule.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private float   IntToFloat    (int     value) { return (float) value; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfCompare1 func_524 = new CfCompare1();
  protected CfNot func_526 = new CfNot();
  protected CfOr func_527 = new CfOr();
  protected CfInputMultiplexer func_522 = new CfInputMultiplexer();
  protected CfCompare1 func_79 = new CfCompare1();
  protected CfCompare1 func_88 = new CfCompare1();
  protected CfSquareRoot func_90 = new CfSquareRoot();
  protected CfInputMultiplexer func_92 = new CfInputMultiplexer();
  protected CfOr func_535 = new CfOr();
  protected CfMultiply func_94 = new CfMultiply();
  protected CfInputMultiplexer func_534 = new CfInputMultiplexer();
  protected CfIdt func_96 = new CfIdt();
  protected CfIdt func_533 = new CfIdt();
  protected CfMaximum func_100 = new CfMaximum();
  protected CfSubtract func_102 = new CfSubtract();
  protected CfDivide func_103 = new CfDivide();
  protected CfMultiply func_105 = new CfMultiply();
  protected CfAddition func_107 = new CfAddition();
  protected CfMaximum func_109 = new CfMaximum();
  protected CfMinimum func_111 = new CfMinimum();
  protected CfCompare1 func_553 = new CfCompare1();
  protected CfCompare1 func_552 = new CfCompare1();
  protected CfOr func_554 = new CfOr();
  protected CfInputMultiplexer func_549 = new CfInputMultiplexer();
  protected CfCompare1 func_120 = new CfCompare1();
  protected CfCompare1 func_122 = new CfCompare1();
  protected CfCompare1 func_124 = new CfCompare1();
  protected CfCompare1 func_573 = new CfCompare1();
  protected CfCompare1 func_578 = new CfCompare1();
  protected CfSubtract func_126 = new CfSubtract();
  protected CfMultiply func_135 = new CfMultiply();
  protected CfDivide func_137 = new CfDivide();
  protected CfCompare1 func_146 = new CfCompare1();
  protected CfMultiply func_150 = new CfMultiply();
  protected CfMaximum func_151 = new CfMaximum();
  protected CfDivide func_155 = new CfDivide();
  protected CfMultiply func_731 = new CfMultiply();
  protected CfOr func_574 = new CfOr();
  protected CfMultiply func_721 = new CfMultiply();
  protected CfInputMultiplexer func_575 = new CfInputMultiplexer();
  protected CfIdt func_157 = new CfIdt();
  protected CfIdt func_571 = new CfIdt();
  protected CfDivide func_661 = new CfDivide();
  protected CfMaximum func_663 = new CfMaximum();
  protected CfCompare1 func_732 = new CfCompare1();
  protected CfInputMultiplexer func_736 = new CfInputMultiplexer();
  protected CfMultiply func_162 = new CfMultiply();
  protected CfMaximum func_163 = new CfMaximum();
  protected CfDivide func_165 = new CfDivide();
  protected CfCompare1 func_586 = new CfCompare1();
  protected CfInputMultiplexer func_589 = new CfInputMultiplexer();
  protected CfIdt func_583 = new CfIdt();
  protected CfDivide func_192 = new CfDivide();
  protected CfTruncate func_194 = new CfTruncate();
  protected CfIdt func_196 = new CfIdt();
  protected CfMultiply func_198 = new CfMultiply();
  protected CfSubtract func_200 = new CfSubtract();
  protected CfIdt func_204 = new CfIdt();
  protected CfTruncate func_205 = new CfTruncate();
  protected CfAddition func_208 = new CfAddition();
  protected CfAddition func_209 = new CfAddition();
  protected CfCompare1 func_211 = new CfCompare1();
  protected CfInputMultiplexer func_614 = new CfInputMultiplexer();
  protected CfMultiply func_223 = new CfMultiply();
  protected CfInputMultiplexer func_615 = new CfInputMultiplexer();
  protected CfAddition func_227 = new CfAddition();
  protected CfIdt func_233 = new CfIdt();
  protected CfCompare1 func_239 = new CfCompare1();
  protected CfCompare1 func_242 = new CfCompare1();
  protected CfDivide func_244 = new CfDivide();
  protected CfInputMultiplexer func_620 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_619 = new CfInputMultiplexer();
  protected CfIdt func_684 = new CfIdt();
  protected CfCompare2 func_664 = new CfCompare2();
  protected CfCompare2 func_667 = new CfCompare2();
  protected CfNot func_680 = new CfNot();
  protected CfNot func_679 = new CfNot();
  protected CfAnd func_682 = new CfAnd();
  protected CfTimeCounter func_670 = new CfTimeCounter();
  protected CfTimeCounter func_673 = new CfTimeCounter();
  protected CfTimeCounter func_676 = new CfTimeCounter();

  // default constructor
  public BCmCAA_AddOnModule()
  {
    func_135.configure(3);
    func_574.configure(5);
  }

  public void Start()
  {
    func_670.Start();
    func_673.Start();
    func_676.Start();
  }
}
