/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:27
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.chiller;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    CHA_ChillerCmd
Macro id:      6238454830386381374
Macro version: 39
Last change:   17.08.2016 - 14:18
Access Level:  2
Inputs:
  [1] CdVlvPmpStatus
  [2] CdVlvPmpAlarm
  [3] ChWatVlvPmpStatus
  [4] ChWatVlvPmpAlarm
  [5] ChillerStatus
  [6] ChillerAlarm
  [7] ChillerComAlarm
  [8] OperCdPump
  [9] OperChwPump
  [10] ReqCdPump
  [11] ReqChwPump
  [12] Reset
  [13] Enable
Outputs:
  [1] CdValvePmpCmd
  [2] ChWatValvePmpCmd
  [3] ChillCmd
  [4] ChillComAlarm
  [5] ReqCdPump
  [6] ReqChwPump
Parameter:
  [1] STRT-01: Startup delay condenser pump >0 with confirmation
  [2] STRT-02: Startup delay condenser valve >0 with confirmation
  [3] STRT-03: Startup delay chilled water pump >0 with confirmation
  [4] STRT-04: Startup delay chilled water valve >0 with confirmation
  [5] STRT-05: Startup delay chiller
  [6] SHTD-01: Shutdown delay chiller
  [7] SHTD-02: Shutdown delay condenser pump
  [8] SHTD-03: Shutdown delay condenser valve
  [9] SHTD-04: Shutdown delay chilled water pump
  [10] SHTD-05: Shutdown delay chilled water valve
  [11] ALM-01: alarm delay condenser valve; 0=disable
  [12] ALM-02: alarm delay condenser pump; 0=disable
  [13] ALM-03: alarm delay chilled water valve; 0=disable
  [14] ALM-04: alarm delay chilled water pump; 0=disable
  [15] ALM-05: alarm delay chiller; 0=disable
  [16] ALM-06: reset <0=lim auto 0=man 1=auto
  [17] SYS-01: min. On time
  [18] SYS-02: min. Off time
  [19] SYS-03: chiller recycle time
  [20] DISP-01: condenser valve alarm
  [21] DISP-02: condenser pump alarm
  [22] DISP-03: chilled water valve alarm
  [23] DISP-04: chilled water pump alarm
  [24] DISP-05: chiller status alarm
  [25] DISP-06: chiller common alarm (input)
  [26] DISP-07: chiller remaining recycle time
  [27] DISP-08: unavailable flag
  [28] DISP-09: chiller off alarm
  [29] DISP-10: chiller on alarm
  [30] DISP-11 ALM-06 countdown
Description:
The CHA_ChillerCmd is a chiller output module for 
controlling the startup and shutdown sequence of single 
chiller with the related equipment: condenser valve and 
pump, chilled water valve and pump and chiller.

================================================================================*/

public class BCmCHA_ChillerCmd
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmCHA_ChillerCmd_output_11().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmCHA_ChillerCmd_output_11().setStatus(BStatus.disabled);
    getCmCHA_ChillerCmd_output_12().setStatus(BStatus.disabled);
    getCmCHA_ChillerCmd_output_13().setStatus(BStatus.disabled);
    getCmCHA_ChillerCmd_output_14().setStatus(BStatus.disabled);
    getCmCHA_ChillerCmd_output_15().setStatus(BStatus.disabled);
    getCmCHA_ChillerCmd_output_16().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmCHA_ChillerCmd_output_11().setStatus(BStatus.ok);
    getCmCHA_ChillerCmd_output_12().setStatus(BStatus.ok);
    getCmCHA_ChillerCmd_output_13().setStatus(BStatus.ok);
    getCmCHA_ChillerCmd_output_14().setStatus(BStatus.ok);
    getCmCHA_ChillerCmd_output_15().setStatus(BStatus.ok);
    getCmCHA_ChillerCmd_output_16().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [48] Function call CfTruncate
    func_48.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_48.Execute(  );

    // [61] Function call CfIdt
    func_61.input = (float) getCmCHA_ChillerCmd_input_8().getValue();
    func_61.Execute(  );

    // [62] Function call CfIdt
    func_62.input = (float) getCmCHA_ChillerCmd_input_6().getValue();
    func_62.Execute(  );

    // [63] Function call CfIdt
    func_63.input = (float) getCmCHA_ChillerCmd_input_9().getValue();
    func_63.Execute(  );

    // [64] Function call CfIdt
    func_64.input = (float) getCmCHA_ChillerCmd_input_7().getValue();
    func_64.Execute(  );

    // [65] Function call CfSubtract
    func_65.input[0] = (float) getCmCHA_ChillerCmd_parameter_18();
    func_65.input[1] = 0F;
    func_65.Execute(  );

    // [66] Function call CfAbsolute
    func_66.input = func_65.output;
    func_66.Execute(  );

    // [67] Function call CfSubtract
    func_67.input[0] = (float) getCmCHA_ChillerCmd_parameter_19();
    func_67.input[1] = 0F;
    func_67.Execute(  );

    // [68] Function call CfAbsolute
    func_68.input = func_67.output;
    func_68.Execute(  );

    // [69] Function call CfSubtract
    func_69.input[0] = (float) getCmCHA_ChillerCmd_parameter_20();
    func_69.input[1] = 0F;
    func_69.Execute(  );

    // [70] Function call CfAbsolute
    func_70.input = func_69.output;
    func_70.Execute(  );

    // [71] Function call CfSubtract
    func_71.input[0] = (float) getCmCHA_ChillerCmd_parameter_21();
    func_71.input[1] = 0F;
    func_71.Execute(  );

    // [72] Function call CfAbsolute
    func_72.input = func_71.output;
    func_72.Execute(  );

    // [73] Function call CfSubtract
    func_73.input[0] = (float) getCmCHA_ChillerCmd_parameter_24();
    func_73.input[1] = 0F;
    func_73.Execute(  );

    // [74] Function call CfAbsolute
    func_74.input = func_73.output;
    func_74.Execute(  );

    // [75] Function call CfSubtract
    func_75.input[0] = (float) getCmCHA_ChillerCmd_parameter_25();
    func_75.input[1] = 0F;
    func_75.Execute(  );

    // [76] Function call CfAbsolute
    func_76.input = func_75.output;
    func_76.Execute(  );

    // [77] Function call CfSubtract
    func_77.input[0] = (float) getCmCHA_ChillerCmd_parameter_26();
    func_77.input[1] = 0F;
    func_77.Execute(  );

    // [78] Function call CfAbsolute
    func_78.input = func_77.output;
    func_78.Execute(  );

    // [79] Function call CfSubtract
    func_79.input[0] = (float) getCmCHA_ChillerCmd_parameter_27();
    func_79.input[1] = 0F;
    func_79.Execute(  );

    // [80] Function call CfAbsolute
    func_80.input = func_79.output;
    func_80.Execute(  );

    // [2247] Function call CfLastValue
    func_2247.input = BooleanToFloat(getCmCHA_ChillerCmd_input_10().getValue());
    func_2247.Execute(  );

    // [82] Function call CfAnd
    func_82.input[0] = FloatToBoolean(func_2247.outputCurrent);
    func_82.input[1] = FloatToBoolean(func_2247.outputLast);
    func_82.Execute(  );

    // [1680] Function call CfCompare1
    func_1680.inputA = 1F;
    func_1680.inputB = (float) getCmCHA_ChillerCmd_parameter_33();
    func_1680.Execute(  );

    // [2249] Function call CfCompare1
    func_2249.inputA = 0F;
    func_2249.inputB = (float) getCmCHA_ChillerCmd_parameter_2256();
    func_2249.Execute(  );

    // [88] Function call CfIdt
    func_88.input = BooleanToFloat(func_1845.output);
    func_88.Execute(  );

    // [89] Function call CfIdt
    func_89.input = func_106.output[0];
    func_89.Execute(  );

    // [90] Function call CfIdt
    func_90.input = BooleanToFloat(func_1861.output);
    func_90.Execute(  );

    // [91] Function call CfIdt
    func_91.input = func_111.output[0];
    func_91.Execute(  );

    // [92] Function call CfIdt
    func_92.input = func_66.outputAbs;
    func_92.Execute(  );

    // [93] Function call CfIdt
    func_93.input = func_68.outputAbs;
    func_93.Execute(  );

    // [94] Function call CfIdt
    func_94.input = func_70.outputAbs;
    func_94.Execute(  );

    // [95] Function call CfIdt
    func_95.input = func_72.outputAbs;
    func_95.Execute(  );

    // [96] Function call CfIdt
    func_96.input = func_74.outputAbs;
    func_96.Execute(  );

    // [97] Function call CfIdt
    func_97.input = func_76.outputAbs;
    func_97.Execute(  );

    // [98] Function call CfIdt
    func_98.input = func_78.outputAbs;
    func_98.Execute(  );

    // [99] Function call CfIdt
    func_99.input = func_80.outputAbs;
    func_99.Execute(  );

    // [101] Function call CfOr
    func_101.input[0] = func_82.outputAND;
    func_101.input[1] = func_1680.outputEqual;
    func_101.input[2] = func_2249.outputGreater;
    func_101.Execute(  );

    // [106] Function call CfIdt
    func_106.input = func_88.output[0];
    func_106.Execute(  );

    // [107] Function call CfRound
    func_107.input = func_88.output[0];
    func_107.Execute(  );

    // [108] Function call CfSubtract
    func_108.input[0] = 1F;
    func_108.input[1] = func_88.output[0];
    func_108.Execute(  );

    // [109] Function call CfRound
    func_109.input = func_89.output[0];
    func_109.Execute(  );

    // [110] Function call CfSubtract
    func_110.input[0] = 1F;
    func_110.input[1] = func_89.output[0];
    func_110.Execute(  );

    // [111] Function call CfIdt
    func_111.input = func_90.output[0];
    func_111.Execute(  );

    // [112] Function call CfRound
    func_112.input = func_90.output[0];
    func_112.Execute(  );

    // [113] Function call CfSubtract
    func_113.input[0] = 1F;
    func_113.input[1] = func_90.output[0];
    func_113.Execute(  );

    // [114] Function call CfRound
    func_114.input = func_91.output[0];
    func_114.Execute(  );

    // [115] Function call CfSubtract
    func_115.input[0] = 1F;
    func_115.input[1] = func_91.output[0];
    func_115.Execute(  );

    // [120] Function call CfIdt
    func_120.input = func_446.output[0];
    func_120.Execute(  );

    // [121] Function call CfIdt
    func_121.input = BooleanToFloat(func_101.outputOR);
    func_121.Execute(  );

    // [1677] Function call CfCompare2
    func_1677.inputA = func_62.output[0];
    func_1677.inputB = func_1409.output;
    func_1677.Execute(  );

    // [122] Function call CfIdt
    func_122.input = BooleanToFloat(func_1677.outputEqualOrGreater);
    func_122.Execute(  );

    // [1676] Function call CfCompare2
    func_1676.inputA = func_64.output[0];
    func_1676.inputB = func_1407.output;
    func_1676.Execute(  );

    // [123] Function call CfIdt
    func_123.input = BooleanToFloat(func_1676.outputEqualOrGreater);
    func_123.Execute(  );

    // [124] Function call CfAnd
    func_124.input[0] = FloatToBoolean(func_108.output);
    func_124.input[1] = FloatToBoolean(func_109.output);
    func_124.Execute(  );

    // [125] Function call CfAnd
    func_125.input[0] = FloatToBoolean(func_107.output);
    func_125.input[1] = FloatToBoolean(func_110.output);
    func_125.Execute(  );

    // [126] Function call CfAnd
    func_126.input[0] = FloatToBoolean(func_113.output);
    func_126.input[1] = FloatToBoolean(func_114.output);
    func_126.Execute(  );

    // [127] Function call CfAnd
    func_127.input[0] = FloatToBoolean(func_112.output);
    func_127.input[1] = FloatToBoolean(func_115.output);
    func_127.Execute(  );

    // [1679] Function call CfNot
    func_1679.input = getCmCHA_ChillerCmd_output_14().getValue();
    func_1679.Execute(  );

    // [1678] Function call CfNot
    func_1678.input = FloatToBoolean(func_48.output);
    func_1678.Execute(  );

    // [131] Function call CfOr
    func_131.input[0] = getCmCHA_ChillerCmd_input_5().getValue();
    func_131.input[1] = FloatToBoolean(func_120.output[0]);
    func_131.Execute(  );

    // [132] Function call CfIdt
    func_132.input = BooleanToFloat(func_124.outputAND);
    func_132.Execute(  );

    // [133] Function call CfIdt
    func_133.input = BooleanToFloat(func_125.outputAND);
    func_133.Execute(  );

    // [134] Function call CfIdt
    func_134.input = BooleanToFloat(func_126.outputAND);
    func_134.Execute(  );

    // [135] Function call CfIdt
    func_135.input = BooleanToFloat(func_127.outputAND);
    func_135.Execute(  );

    // [137] Function call CfAnd
    func_137.input[0] = func_1678.output;
    func_137.input[1] = func_1679.output;
    func_137.input[2] = func_131.outputOR;
    func_137.Execute(  );

    // [139] Function call CfIdt
    func_139.input = BooleanToFloat(func_137.outputAND);
    func_139.Execute(  );

    // [141] Function call CfIdt
    func_141.input = func_93.output[0];
    func_141.Execute(  );

    // [142] Function call CfIdt
    func_142.input = func_92.output[0];
    func_142.Execute(  );

    // [150] Function call CfCompare1
    func_150.inputA = func_141.output[0];
    func_150.inputB = func_142.output[0];
    func_150.Execute(  );

    // [154] Function call CfIdt
    func_154.input = func_139.output[0];
    func_154.Execute(  );

    // [173] Function call CfIdt
    func_173.input = func_122.output[0];
    func_173.Execute(  );

    // [1780] Function call CfCompare2
    func_1780.inputA = 0F;
    func_1780.inputB = (float) getCmCHA_ChillerCmd_parameter_18();
    func_1780.Execute(  );

    // [201] Function call CfOr
    func_201.input[0] = func_1780.outputEqualOrGreater;
    func_201.input[1] = func_150.outputLess;
    func_201.input[2] = FloatToBoolean(func_173.output[0]);
    func_201.Execute(  );

    // [203] Function call CfIdt
    func_203.input = func_93.output[0];
    func_203.Execute(  );
    setParameter(0, func_203.output[0]);

    // [204] Function call CfDelay
    func_204.inputA = FloatToBoolean(func_154.output[0]);
    func_204.inputB = FloatToBoolean(func_154.output[0]);
    func_204.Execute( this, 0 );

    // [206] Function call CfIdt
    func_206.input = func_97.output[0];
    func_206.Execute(  );
    setParameter(1, func_206.output[0]);

    // [1781] Function call CfNot
    func_1781.input = FloatToBoolean(func_154.output[0]);
    func_1781.Execute(  );

    // [207] Function call CfDelay
    func_207.inputA = func_1781.output;
    func_207.inputB = func_1781.output;
    func_207.Execute( this, 1 );

    // [230] Function call CfAnd
    func_230.input[0] = func_201.outputOR;
    func_230.input[1] = func_204.outputDelayedA;
    func_230.Execute(  );

    // [231] Function call CfOr
    func_231.input[0] = func_207.outputDelayedA;
    func_231.input[1] = FloatToBoolean(func_48.output);
    func_231.Execute(  );

    // [239] Function call CfRsFlipFlop
    func_239.inputSet = func_230.outputAND;
    func_239.inputReset = func_231.outputOR;
    func_239.Execute(  );

    // [244] Function call CfIdt
    func_244.input = BooleanToFloat(func_239.output);
    func_244.Execute(  );

    // [1795] Function call CfIdt
    func_1795.input = func_95.output[0];
    func_1795.Execute(  );

    // [1796] Function call CfIdt
    func_1796.input = func_94.output[0];
    func_1796.Execute(  );

    // [1805] Function call CfCompare1
    func_1805.inputA = func_1795.output[0];
    func_1805.inputB = func_1796.output[0];
    func_1805.Execute(  );

    // [1807] Function call CfCompare2
    func_1807.inputA = 0F;
    func_1807.inputB = (float) getCmCHA_ChillerCmd_parameter_20();
    func_1807.Execute(  );

    // [1806] Function call CfIdt
    func_1806.input = func_123.output[0];
    func_1806.Execute(  );

    // [1808] Function call CfOr
    func_1808.input[0] = func_1807.outputEqualOrGreater;
    func_1808.input[1] = func_1805.outputLess;
    func_1808.input[2] = FloatToBoolean(func_1806.output[0]);
    func_1808.Execute(  );

    // [1809] Function call CfIdt
    func_1809.input = func_95.output[0];
    func_1809.Execute(  );
    setParameter(2, func_1809.output[0]);

    // [1799] Function call CfIdt
    func_1799.input = func_99.output[0];
    func_1799.Execute(  );
    setParameter(3, func_1799.output[0]);

    // [1797] Function call CfIdt
    func_1797.input = func_139.output[0];
    func_1797.Execute(  );

    // [1798] Function call CfDelay
    func_1798.inputA = FloatToBoolean(func_1797.output[0]);
    func_1798.inputB = FloatToBoolean(func_1797.output[0]);
    func_1798.Execute( this, 2 );

    // [1800] Function call CfNot
    func_1800.input = FloatToBoolean(func_1797.output[0]);
    func_1800.Execute(  );

    // [1801] Function call CfDelay
    func_1801.inputA = func_1800.output;
    func_1801.inputB = func_1800.output;
    func_1801.Execute( this, 3 );

    // [1802] Function call CfAnd
    func_1802.input[0] = func_1808.outputOR;
    func_1802.input[1] = func_1798.outputDelayedA;
    func_1802.Execute(  );

    // [1810] Function call CfOr
    func_1810.input[0] = func_1801.outputDelayedA;
    func_1810.input[1] = FloatToBoolean(func_48.output);
    func_1810.Execute(  );

    // [1803] Function call CfRsFlipFlop
    func_1803.inputSet = func_1802.outputAND;
    func_1803.inputReset = func_1810.outputOR;
    func_1803.Execute(  );

    // [1841] Function call CfIdt
    func_1841.input = func_92.output[0];
    func_1841.Execute(  );

    // [1842] Function call CfIdt
    func_1842.input = func_93.output[0];
    func_1842.Execute(  );

    // [1837] Function call CfCompare1
    func_1837.inputA = func_1841.output[0];
    func_1837.inputB = func_1842.output[0];
    func_1837.Execute(  );

    // [1840] Function call CfCompare2
    func_1840.inputA = 0F;
    func_1840.inputB = (float) getCmCHA_ChillerCmd_parameter_19();
    func_1840.Execute(  );

    // [1843] Function call CfIdt
    func_1843.input = func_298.output[0];
    func_1843.Execute(  );

    // [1838] Function call CfOr
    func_1838.input[0] = func_1840.outputEqualOrGreater;
    func_1838.input[1] = func_1837.outputLess;
    func_1838.input[2] = FloatToBoolean(func_1843.output[0]);
    func_1838.Execute(  );

    // [1844] Function call CfIdt
    func_1844.input = func_92.output[0];
    func_1844.Execute(  );
    setParameter(4, func_1844.output[0]);

    // [1846] Function call CfIdt
    func_1846.input = func_96.output[0];
    func_1846.Execute(  );
    setParameter(5, func_1846.output[0]);

    // [1832] Function call CfIdt
    func_1832.input = func_139.output[0];
    func_1832.Execute(  );

    // [1833] Function call CfDelay
    func_1833.inputA = FloatToBoolean(func_1832.output[0]);
    func_1833.inputB = FloatToBoolean(func_1832.output[0]);
    func_1833.Execute( this, 4 );

    // [1834] Function call CfNot
    func_1834.input = FloatToBoolean(func_1832.output[0]);
    func_1834.Execute(  );

    // [1835] Function call CfDelay
    func_1835.inputA = func_1834.output;
    func_1835.inputB = func_1834.output;
    func_1835.Execute( this, 5 );

    // [1836] Function call CfAnd
    func_1836.input[0] = func_1838.outputOR;
    func_1836.input[1] = func_1833.outputDelayedA;
    func_1836.Execute(  );

    // [1839] Function call CfOr
    func_1839.input[0] = func_1835.outputDelayedA;
    func_1839.input[1] = FloatToBoolean(func_48.output);
    func_1839.Execute(  );

    // [1845] Function call CfRsFlipFlop
    func_1845.inputSet = func_1836.outputAND;
    func_1845.inputReset = func_1839.outputOR;
    func_1845.Execute(  );

    // [1855] Function call CfIdt
    func_1855.input = func_94.output[0];
    func_1855.Execute(  );

    // [1856] Function call CfIdt
    func_1856.input = func_95.output[0];
    func_1856.Execute(  );

    // [1852] Function call CfCompare1
    func_1852.inputA = func_1855.output[0];
    func_1852.inputB = func_1856.output[0];
    func_1852.Execute(  );

    // [1857] Function call CfCompare2
    func_1857.inputA = 0F;
    func_1857.inputB = (float) getCmCHA_ChillerCmd_parameter_21();
    func_1857.Execute(  );

    // [1858] Function call CfIdt
    func_1858.input = func_300.output[0];
    func_1858.Execute(  );

    // [1853] Function call CfOr
    func_1853.input[0] = func_1857.outputEqualOrGreater;
    func_1853.input[1] = func_1852.outputLess;
    func_1853.input[2] = FloatToBoolean(func_1858.output[0]);
    func_1853.Execute(  );

    // [1859] Function call CfIdt
    func_1859.input = func_94.output[0];
    func_1859.Execute(  );
    setParameter(6, func_1859.output[0]);

    // [1860] Function call CfIdt
    func_1860.input = func_98.output[0];
    func_1860.Execute(  );
    setParameter(7, func_1860.output[0]);

    // [1847] Function call CfIdt
    func_1847.input = func_139.output[0];
    func_1847.Execute(  );

    // [1848] Function call CfDelay
    func_1848.inputA = FloatToBoolean(func_1847.output[0]);
    func_1848.inputB = FloatToBoolean(func_1847.output[0]);
    func_1848.Execute( this, 6 );

    // [1849] Function call CfNot
    func_1849.input = FloatToBoolean(func_1847.output[0]);
    func_1849.Execute(  );

    // [1850] Function call CfDelay
    func_1850.inputA = func_1849.output;
    func_1850.inputB = func_1849.output;
    func_1850.Execute( this, 7 );

    // [1851] Function call CfAnd
    func_1851.input[0] = func_1853.outputOR;
    func_1851.input[1] = func_1848.outputDelayedA;
    func_1851.Execute(  );

    // [1854] Function call CfOr
    func_1854.input[0] = func_1850.outputDelayedA;
    func_1854.input[1] = FloatToBoolean(func_48.output);
    func_1854.Execute(  );

    // [1861] Function call CfRsFlipFlop
    func_1861.inputSet = func_1851.outputAND;
    func_1861.inputReset = func_1854.outputOR;
    func_1861.Execute(  );

    // [275] Function call CfIdt
    func_275.input = func_122.output[0];
    func_275.Execute(  );

    // [282] Function call CfIdt
    func_282.input = func_123.output[0];
    func_282.Execute(  );

    // [1531] Function call CfCompare2
    func_1531.inputA = 0F;
    func_1531.inputB = (float) getCmCHA_ChillerCmd_parameter_19();
    func_1531.Execute(  );

    // [284] Function call CfOr
    func_284.input[0] = func_1531.outputEqualOrGreater;
    func_284.input[1] = getCmCHA_ChillerCmd_input_1351().getValue();
    func_284.input[2] = getCmCHA_ChillerCmd_input_1().getValue();
    func_284.Execute(  );

    // [285] Function call CfIdt
    func_285.input = func_244.output[0];
    func_285.Execute(  );

    // [286] Function call CfIdt
    func_286.input = BooleanToFloat(func_1845.output);
    func_286.Execute(  );

    // [1533] Function call CfCompare2
    func_1533.inputA = 0F;
    func_1533.inputB = (float) getCmCHA_ChillerCmd_parameter_18();
    func_1533.Execute(  );

    // [287] Function call CfOr
    func_287.input[0] = func_1533.outputEqualOrGreater;
    func_287.input[1] = FloatToBoolean(func_275.output[0]);
    func_287.Execute(  );

    // [1534] Function call CfCompare2
    func_1534.inputA = 0F;
    func_1534.inputB = (float) getCmCHA_ChillerCmd_parameter_21();
    func_1534.Execute(  );

    // [288] Function call CfOr
    func_288.input[0] = func_1534.outputEqualOrGreater;
    func_288.input[1] = getCmCHA_ChillerCmd_input_1352().getValue();
    func_288.input[2] = getCmCHA_ChillerCmd_input_2().getValue();
    func_288.Execute(  );

    // [289] Function call CfIdt
    func_289.input = BooleanToFloat(func_1803.output);
    func_289.Execute(  );

    // [290] Function call CfIdt
    func_290.input = BooleanToFloat(func_1861.output);
    func_290.Execute(  );

    // [1536] Function call CfCompare2
    func_1536.inputA = 0F;
    func_1536.inputB = (float) getCmCHA_ChillerCmd_parameter_20();
    func_1536.Execute(  );

    // [291] Function call CfOr
    func_291.input[0] = func_1536.outputEqualOrGreater;
    func_291.input[1] = FloatToBoolean(func_282.output[0]);
    func_291.Execute(  );

    // [293] Function call CfAnd
    func_293.input[0] = func_284.outputOR;
    func_293.input[1] = FloatToBoolean(func_285.output[0]);
    func_293.Execute(  );

    // [294] Function call CfAnd
    func_294.input[0] = FloatToBoolean(func_286.output[0]);
    func_294.input[1] = func_287.outputOR;
    func_294.Execute(  );

    // [295] Function call CfAnd
    func_295.input[0] = func_288.outputOR;
    func_295.input[1] = FloatToBoolean(func_289.output[0]);
    func_295.Execute(  );

    // [296] Function call CfAnd
    func_296.input[0] = FloatToBoolean(func_290.output[0]);
    func_296.input[1] = func_291.outputOR;
    func_296.Execute(  );

    // [298] Function call CfIdt
    func_298.input = BooleanToFloat(func_293.outputAND);
    func_298.Execute(  );

    // [299] Function call CfIdt
    func_299.input = BooleanToFloat(func_294.outputAND);
    func_299.Execute(  );

    // [300] Function call CfIdt
    func_300.input = BooleanToFloat(func_295.outputAND);
    func_300.Execute(  );

    // [301] Function call CfIdt
    func_301.input = BooleanToFloat(func_296.outputAND);
    func_301.Execute(  );

    // [303] Function call CfIdt
    func_303.input = func_61.output[0];
    func_303.Execute(  );

    // [305] Function call CfIdt
    func_305.input = func_133.output[0];
    func_305.Execute(  );

    // [306] Function call CfAddition
    func_306.input[0] = func_303.output[0];
    func_306.input[1] = 1F;
    func_306.Execute(  );

    // [308] Function call CfCompare1
    func_308.inputA = func_305.output[0];
    func_308.inputB = 0F;
    func_308.Execute(  );

    // [1396] Function call CfInputMultiplexer
    func_1396.inputSelect = BooleanToInt(func_308.outputEqual);
    func_1396.input[1-1] = func_306.output;
    func_1396.input[2-1] = (float) getCmCHA_ChillerCmd_input_8().getValue();
    func_1396.Execute(  );

    // [1398] Function call CfInputMultiplexer
    func_1398.inputSelect = BooleanToInt(func_308.outputEqual);
    func_1398.input[1-1] = func_306.output;
    func_1398.input[2-1] = func_1409.output;
    func_1398.Execute(  );

    // [314] Function call CfIdt
    func_314.input = func_63.output[0];
    func_314.Execute(  );

    // [316] Function call CfIdt
    func_316.input = func_135.output[0];
    func_316.Execute(  );

    // [317] Function call CfAddition
    func_317.input[0] = func_314.output[0];
    func_317.input[1] = 1F;
    func_317.Execute(  );

    // [319] Function call CfCompare1
    func_319.inputA = func_316.output[0];
    func_319.inputB = 0F;
    func_319.Execute(  );

    // [1400] Function call CfInputMultiplexer
    func_1400.inputSelect = BooleanToInt(func_319.outputEqual);
    func_1400.input[1-1] = func_317.output;
    func_1400.input[2-1] = (float) getCmCHA_ChillerCmd_input_9().getValue();
    func_1400.Execute(  );

    // [1401] Function call CfInputMultiplexer
    func_1401.inputSelect = BooleanToInt(func_319.outputEqual);
    func_1401.input[1-1] = func_317.output;
    func_1401.input[2-1] = func_1407.output;
    func_1401.Execute(  );

    // [325] Function call CfIdt
    func_325.input = func_61.output[0];
    func_325.Execute(  );

    // [327] Function call CfIdt
    func_327.input = func_132.output[0];
    func_327.Execute(  );

    // [328] Function call CfSubtract
    func_328.input[0] = func_325.output[0];
    func_328.input[1] = 1F;
    func_328.Execute(  );

    // [330] Function call CfCompare1
    func_330.inputA = func_327.output[0];
    func_330.inputB = 0F;
    func_330.Execute(  );

    // [1402] Function call CfInputMultiplexer
    func_1402.inputSelect = BooleanToInt(func_330.outputEqual);
    func_1402.input[1-1] = func_328.output;
    func_1402.input[2-1] = func_1396.output;
    func_1402.Execute(  );

    // [1403] Function call CfInputMultiplexer
    func_1403.inputSelect = BooleanToInt(func_330.outputEqual);
    func_1403.input[1-1] = 0F;
    func_1403.input[2-1] = func_1398.output;
    func_1403.Execute(  );

    // [336] Function call CfIdt
    func_336.input = func_63.output[0];
    func_336.Execute(  );

    // [338] Function call CfIdt
    func_338.input = func_134.output[0];
    func_338.Execute(  );

    // [339] Function call CfSubtract
    func_339.input[0] = func_336.output[0];
    func_339.input[1] = 1F;
    func_339.Execute(  );

    // [341] Function call CfCompare1
    func_341.inputA = func_338.output[0];
    func_341.inputB = 0F;
    func_341.Execute(  );

    // [1404] Function call CfInputMultiplexer
    func_1404.inputSelect = BooleanToInt(func_341.outputEqual);
    func_1404.input[1-1] = func_339.output;
    func_1404.input[2-1] = func_1400.output;
    func_1404.Execute(  );

    // [1405] Function call CfInputMultiplexer
    func_1405.inputSelect = BooleanToInt(func_341.outputEqual);
    func_1405.input[1-1] = 0F;
    func_1405.input[2-1] = func_1401.output;
    func_1405.Execute(  );

    // [349] Function call CfCompare1
    func_349.inputA = func_48.output;
    func_349.inputB = 0F;
    func_349.Execute(  );

    // [1408] Function call CfInputMultiplexer
    func_1408.inputSelect = BooleanToInt(func_349.outputEqual);
    func_1408.input[1-1] = 0F;
    func_1408.input[2-1] = func_1402.output;
    func_1408.Execute(  );
    setCmCHA_ChillerCmd_output_15(func_1408.output);

    // [1409] Function call CfInputMultiplexer
    func_1409.inputSelect = BooleanToInt(func_349.outputEqual);
    func_1409.input[1-1] = 0F;
    func_1409.input[2-1] = func_1403.output;
    func_1409.Execute(  );

    // [1406] Function call CfInputMultiplexer
    func_1406.inputSelect = BooleanToInt(func_349.outputEqual);
    func_1406.input[1-1] = 0F;
    func_1406.input[2-1] = func_1404.output;
    func_1406.Execute(  );
    setCmCHA_ChillerCmd_output_16(func_1406.output);

    // [1407] Function call CfInputMultiplexer
    func_1407.inputSelect = BooleanToInt(func_349.outputEqual);
    func_1407.input[1-1] = 0F;
    func_1407.input[2-1] = func_1405.output;
    func_1407.Execute(  );

    // [357] Function call CfIdt
    func_357.input = func_139.output[0];
    func_357.Execute(  );

    // [359] Function call CfRound
    func_359.input = func_357.output[0];
    func_359.Execute(  );

    // [360] Function call CfSubtract
    func_360.input[0] = 1F;
    func_360.input[1] = func_357.output[0];
    func_360.Execute(  );

    // [361] Function call CfIdt
    func_361.input = func_390.output[0];
    func_361.Execute(  );

    // [363] Function call CfIdt
    func_363.input = (float) getCmCHA_ChillerCmd_parameter_22();
    func_363.Execute(  );
    setParameter(8, func_363.output[0]);

    // [364] Function call CfDelay
    func_364.inputA = FloatToBoolean(func_359.output);
    func_364.inputB = FloatToBoolean(func_359.output);
    func_364.Execute( this, 8 );

    // [365] Function call CfRound
    func_365.input = func_361.output[0];
    func_365.Execute(  );

    // [366] Function call CfSubtract
    func_366.input[0] = 1F;
    func_366.input[1] = func_361.output[0];
    func_366.Execute(  );

    // [367] Function call CfIdt
    func_367.input = (float) getCmCHA_ChillerCmd_parameter_23();
    func_367.Execute(  );
    setParameter(9, func_367.output[0]);

    // [368] Function call CfDelay
    func_368.inputA = FloatToBoolean(func_360.output);
    func_368.inputB = FloatToBoolean(func_360.output);
    func_368.Execute( this, 9 );

    // [370] Function call CfIdt
    func_370.input = BooleanToFloat(func_552.outputOR);
    func_370.Execute(  );

    // [371] Function call CfIdt
    func_371.input = func_560.output[0];
    func_371.Execute(  );

    // [373] Function call CfAnd
    func_373.input[0] = func_364.outputDelayedA;
    func_373.input[1] = FloatToBoolean(func_366.output);
    func_373.Execute(  );

    // [374] Function call CfAnd
    func_374.input[0] = FloatToBoolean(func_365.output);
    func_374.input[1] = func_368.outputDelayedA;
    func_374.Execute(  );

    // [375] Function call CfIdt
    func_375.input = func_48.output;
    func_375.Execute(  );

    // [376] Function call CfOr
    func_376.input[0] = getCmCHA_ChillerCmd_output_14().getValue();
    func_376.input[1] = FloatToBoolean(func_370.output[0]);
    func_376.input[2] = FloatToBoolean(func_371.output[0]);
    func_376.Execute(  );

    // [2408] Function call CfLastValue
    func_2408.input = BooleanToFloat(getCmCHA_ChillerCmd_output_14().getValue());
    func_2408.Execute(  );

    // [2410] Function call CfCompare1
    func_2410.inputA = func_2408.outputCurrent;
    func_2410.inputB = func_2408.outputLast;
    func_2410.Execute(  );

    // [378] Function call CfOr
    func_378.input[0] = func_374.outputAND;
    func_378.input[1] = FloatToBoolean(func_375.output[0]);
    func_378.input[2] = func_2410.outputLess;
    func_378.Execute(  );

    // [380] Function call CfRsFlipFlop
    func_380.inputSet = func_373.outputAND;
    func_380.inputReset = func_378.outputOR;
    func_380.Execute(  );

    // [381] Function call CfIdt
    func_381.input = func_298.output[0];
    func_381.Execute(  );

    // [382] Function call CfIdt
    func_382.input = func_300.output[0];
    func_382.Execute(  );

    // [383] Function call CfIdt
    func_383.input = func_299.output[0];
    func_383.Execute(  );

    // [384] Function call CfIdt
    func_384.input = func_301.output[0];
    func_384.Execute(  );

    // [385] Function call CfSubtract
    func_385.input[0] = 1F;
    func_385.input[1] = BooleanToFloat(func_376.outputOR);
    func_385.Execute(  );

    // [387] Function call CfAnd
    func_387.input[0] = func_380.output;
    func_387.input[1] = FloatToBoolean(func_381.output[0]);
    func_387.input[2] = FloatToBoolean(func_382.output[0]);
    func_387.input[3] = FloatToBoolean(func_383.output[0]);
    func_387.input[4] = FloatToBoolean(func_384.output[0]);
    func_387.input[5] = FloatToBoolean(func_385.output);
    func_387.Execute(  );

    // [388] Function call CfIdt
    func_388.input = func_390.output[0];
    func_388.Execute(  );

    // [390] Function call CfIdt
    func_390.input = BooleanToFloat(func_387.outputAND);
    func_390.Execute(  );

    // [392] Function call CfSubtract
    func_392.input[0] = 1F;
    func_392.input[1] = BooleanToFloat(func_387.outputAND);
    func_392.Execute(  );

    // [394] Function call CfSubtract
    func_394.input[0] = 1F;
    func_394.input[1] = func_388.output[0];
    func_394.Execute(  );

    // [396] Function call CfAnd
    func_396.input[0] = func_387.outputAND;
    func_396.input[1] = FloatToBoolean(func_394.output);
    func_396.Execute(  );

    // [397] Function call CfAnd
    func_397.input[0] = FloatToBoolean(func_392.output);
    func_397.input[1] = FloatToBoolean(func_388.output[0]);
    func_397.Execute(  );

    // [398] Function call CfIdt
    func_398.input = func_445.output[0];
    func_398.Execute(  );

    // [399] Function call CfIdt
    func_399.input = func_446.output[0];
    func_399.Execute(  );

    // [400] Function call CfIdt
    func_400.input = func_447.output[0];
    func_400.Execute(  );

    // [403] Function call CfSubtract
    func_403.input[0] = 1F;
    func_403.input[1] = BooleanToFloat(func_397.outputAND);
    func_403.Execute(  );

    // [405] Function call CfSubtract
    func_405.input[0] = 1F;
    func_405.input[1] = func_398.output[0];
    func_405.Execute(  );

    // [409] Function call CfSubtract
    func_409.input[0] = 1F;
    func_409.input[1] = BooleanToFloat(func_396.outputAND);
    func_409.Execute(  );

    // [411] Function call CfSubtract
    func_411.input[0] = 1F;
    func_411.input[1] = func_399.output[0];
    func_411.Execute(  );

    // [413] Function call CfSubtract
    func_413.input[0] = 1F;
    func_413.input[1] = BooleanToFloat(func_396.outputAND);
    func_413.Execute(  );

    // [415] Function call CfSubtract
    func_415.input[0] = 1F;
    func_415.input[1] = func_400.output[0];
    func_415.Execute(  );

    // [2438] Function call CfCompare1
    func_2438.inputA = (float) getCmCHA_ChillerCmd_parameter_35();
    func_2438.inputB = 0.1F;
    func_2438.Execute(  );

    // [417] Function call CfAnd
    func_417.input[0] = func_2438.outputGreater;
    func_417.input[1] = func_397.outputAND;
    func_417.input[2] = FloatToBoolean(func_405.output);
    func_417.Execute(  );

    // [418] Function call CfAnd
    func_418.input[0] = FloatToBoolean(func_403.output);
    func_418.input[1] = FloatToBoolean(func_398.output[0]);
    func_418.Execute(  );

    // [2439] Function call CfCompare1
    func_2439.inputA = (float) getCmCHA_ChillerCmd_parameter_34();
    func_2439.inputB = 0.1F;
    func_2439.Execute(  );

    // [420] Function call CfAnd
    func_420.input[0] = func_2439.outputGreater;
    func_420.input[1] = func_396.outputAND;
    func_420.input[2] = FloatToBoolean(func_411.output);
    func_420.Execute(  );

    // [421] Function call CfAnd
    func_421.input[0] = FloatToBoolean(func_409.output);
    func_421.input[1] = FloatToBoolean(func_399.output[0]);
    func_421.Execute(  );

    // [2441] Function call CfCompare1
    func_2441.inputA = (float) getCmCHA_ChillerCmd_parameter_36();
    func_2441.inputB = 0.1F;
    func_2441.Execute(  );

    // [422] Function call CfAnd
    func_422.input[0] = func_2441.outputGreater;
    func_422.input[1] = func_396.outputAND;
    func_422.input[2] = FloatToBoolean(func_415.output);
    func_422.Execute(  );

    // [423] Function call CfAnd
    func_423.input[0] = FloatToBoolean(func_413.output);
    func_423.input[1] = FloatToBoolean(func_400.output[0]);
    func_423.Execute(  );

    // [425] Function call CfIdt
    func_425.input = (float) getCmCHA_ChillerCmd_parameter_35();
    func_425.Execute(  );
    setParameter(10, func_425.output[0]);

    // [426] Function call CfDelay
    func_426.inputA = func_418.outputAND;
    func_426.inputB = func_418.outputAND;
    func_426.Execute( this, 10 );

    // [427] Function call CfIdt
    func_427.input = func_48.output;
    func_427.Execute(  );

    // [2340] Function call CfResetTimer
    func_2340.input = func_396.outputAND;
    func_2340.Execute(  );
    if ( func_2340.outputValid) func_2338.regStartTicks = func_2340.output;

    // [2338] Function call CfTimer
    func_2338.Execute(  );

    // [428] Function call CfSubtract
    func_428.input[0] = (float) getCmCHA_ChillerCmd_parameter_36();
    func_428.input[1] = IntToFloat(func_2338.output);
    func_428.Execute(  );

    // [429] Function call CfIdt
    func_429.input = func_447.output[0];
    func_429.Execute(  );

    // [430] Function call CfIdt
    func_430.input = (float) getCmCHA_ChillerCmd_parameter_34();
    func_430.Execute(  );
    setParameter(11, func_430.output[0]);

    // [431] Function call CfDelay
    func_431.inputA = func_421.outputAND;
    func_431.inputB = func_421.outputAND;
    func_431.Execute( this, 11 );

    // [432] Function call CfIdt
    func_432.input = (float) getCmCHA_ChillerCmd_parameter_36();
    func_432.Execute(  );
    setParameter(12, func_432.output[0]);

    // [433] Function call CfDelay
    func_433.inputA = func_423.outputAND;
    func_433.inputB = func_423.outputAND;
    func_433.Execute( this, 12 );

    // [435] Function call CfOr
    func_435.input[0] = func_426.outputDelayedA;
    func_435.input[1] = FloatToBoolean(func_427.output[0]);
    func_435.Execute(  );

    // [436] Function call CfInputMultiplexer
    func_436.inputSelect = FloatToInt(func_429.output[0]);
    func_436.input[1-1] = 0F;
    func_436.input[2-1] = func_428.output;
    func_436.Execute(  );

    // [437] Function call CfOr
    func_437.input[0] = func_431.outputDelayedA;
    func_437.input[1] = FloatToBoolean(func_427.output[0]);
    func_437.Execute(  );

    // [438] Function call CfOr
    func_438.input[0] = func_433.outputDelayedA;
    func_438.input[1] = FloatToBoolean(func_427.output[0]);
    func_438.Execute(  );

    // [440] Function call CfRsFlipFlop
    func_440.inputSet = func_417.outputAND;
    func_440.inputReset = func_435.outputOR;
    func_440.Execute(  );

    // [441] Function call CfIdt
    func_441.input = func_436.output;
    func_441.Execute(  );

    // [442] Function call CfRsFlipFlop
    func_442.inputSet = func_420.outputAND;
    func_442.inputReset = func_437.outputOR;
    func_442.Execute(  );

    // [443] Function call CfRsFlipFlop
    func_443.inputSet = func_422.outputAND;
    func_443.inputReset = func_438.outputOR;
    func_443.Execute(  );

    // [445] Function call CfIdt
    func_445.input = BooleanToFloat(func_440.output);
    func_445.Execute(  );

    // [446] Function call CfIdt
    func_446.input = BooleanToFloat(func_442.output);
    func_446.Execute(  );

    // [447] Function call CfIdt
    func_447.input = BooleanToFloat(func_443.output);
    func_447.Execute(  );

    // [1986] Function call CfCompare1
    func_1986.inputA = (float) getCmCHA_ChillerCmd_parameter_28();
    func_1986.inputB = 0F;
    func_1986.Execute(  );

    // [473] Function call CfIdt
    func_473.input = func_123.output[0];
    func_473.Execute(  );

    // [474] Function call CfIdt
    func_474.input = func_560.output[0];
    func_474.Execute(  );

    // [475] Function call CfCompare1
    func_475.inputA = 1F;
    func_475.inputB = (float) getCmCHA_ChillerCmd_parameter_31();
    func_475.Execute(  );

    // [478] Function call CfIdt
    func_478.input = func_122.output[0];
    func_478.Execute(  );

    // [479] Function call CfIdt
    func_479.input = BooleanToFloat(func_552.outputOR);
    func_479.Execute(  );

    // [480] Function call CfCompare1
    func_480.inputA = 1F;
    func_480.inputB = (float) getCmCHA_ChillerCmd_parameter_29();
    func_480.Execute(  );

    // [1997] Function call CfNot
    func_1997.input = func_549.outputOR;
    func_1997.Execute(  );

    // [1998] Function call CfNot
    func_1998.input = FloatToBoolean(func_121.output[0]);
    func_1998.Execute(  );

    // [492] Function call CfOr
    func_492.input[0] = func_1997.output;
    func_492.input[1] = func_1998.output;
    func_492.Execute(  );

    // [2325] Function call CfOr
    func_2325.input[0] = func_1997.output;
    func_2325.input[1] = FloatToBoolean(func_121.output[0]);
    func_2325.Execute(  );

    // [494] Function call CfAnd
    func_494.input[0] = func_549.outputOR;
    func_494.input[1] = func_1998.output;
    func_494.Execute(  );

    // [501] Function call CfSubtract
    func_501.input[0] = 1F;
    func_501.input[1] = func_473.output[0];
    func_501.Execute(  );

    // [502] Function call CfRound
    func_502.input = func_474.output[0];
    func_502.Execute(  );

    // [503] Function call CfSubtract
    func_503.input[0] = 1F;
    func_503.input[1] = func_474.output[0];
    func_503.Execute(  );

    // [506] Function call CfSubtract
    func_506.input[0] = 1F;
    func_506.input[1] = func_478.output[0];
    func_506.Execute(  );

    // [507] Function call CfRound
    func_507.input = func_479.output[0];
    func_507.Execute(  );

    // [508] Function call CfSubtract
    func_508.input[0] = 1F;
    func_508.input[1] = func_479.output[0];
    func_508.Execute(  );

    // [2074] Function call CfNot
    func_2074.input = FloatToBoolean(func_121.output[0]);
    func_2074.Execute(  );

    // [2327] Function call CfNot
    func_2327.input = FloatToBoolean(func_562.output[0]);
    func_2327.Execute(  );

    // [514] Function call CfOr
    func_514.input[0] = func_2327.output;
    func_514.input[1] = func_2074.output;
    func_514.Execute(  );

    // [2329] Function call CfOr
    func_2329.input[0] = func_2327.output;
    func_2329.input[1] = FloatToBoolean(func_121.output[0]);
    func_2329.Execute(  );

    // [516] Function call CfAnd
    func_516.input[0] = getCmCHA_ChillerCmd_input_1353().getValue();
    func_516.input[1] = func_2329.outputOR;
    func_516.Execute(  );

    // [1992] Function call CfNot
    func_1992.input = getCmCHA_ChillerCmd_input_1().getValue();
    func_1992.Execute(  );

    // [520] Function call CfAnd
    func_520.input[0] = func_1986.outputGreater;
    func_520.input[1] = getCmCHA_ChillerCmd_output_11().getValue();
    func_520.input[2] = func_1992.output;
    func_520.input[3] = func_492.outputOR;
    func_520.Execute(  );

    // [521] Function call CfAnd
    func_521.input[0] = getCmCHA_ChillerCmd_input_1351().getValue();
    func_521.input[1] = func_2325.outputOR;
    func_521.Execute(  );

    // [524] Function call CfAnd
    func_524.input[0] = FloatToBoolean(func_501.output);
    func_524.input[1] = FloatToBoolean(func_503.output);
    func_524.input[2] = func_475.outputLess;
    func_524.Execute(  );

    // [2067] Function call CfNot
    func_2067.input = FloatToBoolean(func_121.output[0]);
    func_2067.Execute(  );

    // [525] Function call CfAnd
    func_525.input[0] = FloatToBoolean(func_502.output);
    func_525.input[1] = func_2067.output;
    func_525.Execute(  );

    // [526] Function call CfAnd
    func_526.input[0] = FloatToBoolean(func_506.output);
    func_526.input[1] = FloatToBoolean(func_508.output);
    func_526.input[2] = func_480.outputLess;
    func_526.Execute(  );

    // [2068] Function call CfNot
    func_2068.input = FloatToBoolean(func_121.output[0]);
    func_2068.Execute(  );

    // [527] Function call CfAnd
    func_527.input[0] = FloatToBoolean(func_507.output);
    func_527.input[1] = func_2068.output;
    func_527.Execute(  );

    // [2328] Function call CfCompare1
    func_2328.inputA = (float) getCmCHA_ChillerCmd_parameter_32();
    func_2328.inputB = 0F;
    func_2328.Execute(  );

    // [2326] Function call CfNot
    func_2326.input = getCmCHA_ChillerCmd_input_3().getValue();
    func_2326.Execute(  );

    // [528] Function call CfAnd
    func_528.input[0] = func_2328.outputGreater;
    func_528.input[1] = FloatToBoolean(func_390.output[0]);
    func_528.input[2] = func_2326.output;
    func_528.input[3] = func_514.outputOR;
    func_528.Execute(  );

    // [529] Function call CfAnd
    func_529.input[0] = FloatToBoolean(func_562.output[0]);
    func_529.input[1] = func_2074.output;
    func_529.Execute(  );

    // [532] Function call CfIdt
    func_532.input = BooleanToFloat(func_556.outputOR);
    func_532.Execute(  );

    // [535] Function call CfIdt
    func_535.input = (float) getCmCHA_ChillerCmd_parameter_28();
    func_535.Execute(  );
    setParameter(13, func_535.output[0]);

    // [536] Function call CfDelay
    func_536.inputA = func_520.outputAND;
    func_536.inputB = func_520.outputAND;
    func_536.Execute( this, 13 );

    // [539] Function call CfIdt
    func_539.input = (float) getCmCHA_ChillerCmd_parameter_31();
    func_539.Execute(  );
    setParameter(14, func_539.output[0]);

    // [540] Function call CfDelay
    func_540.inputA = func_524.outputAND;
    func_540.inputB = func_524.outputAND;
    func_540.Execute( this, 14 );

    // [541] Function call CfIdt
    func_541.input = (float) getCmCHA_ChillerCmd_parameter_29();
    func_541.Execute(  );
    setParameter(15, func_541.output[0]);

    // [542] Function call CfDelay
    func_542.inputA = func_526.outputAND;
    func_542.inputB = func_526.outputAND;
    func_542.Execute( this, 15 );

    // [543] Function call CfIdt
    func_543.input = (float) getCmCHA_ChillerCmd_parameter_32();
    func_543.Execute(  );
    setParameter(16, func_543.output[0]);
    setParameter(17, func_543.output[1]);

    // [2070] Function call CfNot
    func_2070.input = FloatToBoolean(func_390.output[0]);
    func_2070.Execute(  );

    // [544] Function call CfDelay
    func_544.inputA = func_528.outputAND;
    func_544.inputB = func_528.outputAND;
    func_544.Execute( this, 16 );

    // [545] Function call CfAnd
    func_545.input[0] = func_2328.outputGreater;
    func_545.input[1] = func_2070.output;
    func_545.input[2] = getCmCHA_ChillerCmd_input_3().getValue();
    func_545.Execute(  );

    // [2069] Function call CfNot
    func_2069.input = FloatToBoolean(func_121.output[0]);
    func_2069.Execute(  );

    // [546] Function call CfAnd
    func_546.input[0] = FloatToBoolean(func_532.output[0]);
    func_546.input[1] = func_2069.output;
    func_546.Execute(  );

    // [549] Function call CfOr
    func_549.input[0] = func_536.outputDelayedA;
    func_549.input[1] = func_494.outputAND;
    func_549.input[2] = func_521.outputAND;
    func_549.Execute(  );

    // [551] Function call CfOr
    func_551.input[0] = func_540.outputDelayedA;
    func_551.input[1] = func_525.outputAND;
    func_551.Execute(  );

    // [552] Function call CfOr
    func_552.input[0] = func_542.outputDelayedA;
    func_552.input[1] = func_527.outputAND;
    func_552.Execute(  );

    // [553] Function call CfOr
    func_553.input[0] = func_544.outputDelayedA;
    func_553.input[1] = func_529.outputAND;
    func_553.input[2] = func_516.outputAND;
    func_553.Execute(  );

    // [555] Function call CfDelay
    func_555.inputA = func_545.outputAND;
    func_555.inputB = func_545.outputAND;
    func_555.Execute( this, 17 );

    // [556] Function call CfOr
    func_556.input[0] = func_546.outputAND;
    func_556.input[1] = getCmCHA_ChillerCmd_input_4().getValue();
    func_556.Execute(  );

    // [2017] Function call CfCompare1
    func_2017.inputA = (float) getCmCHA_ChillerCmd_parameter_30();
    func_2017.inputB = 0F;
    func_2017.Execute(  );

    // [2030] Function call CfNot
    func_2030.input = func_2028.outputOR;
    func_2030.Execute(  );

    // [2033] Function call CfNot
    func_2033.input = FloatToBoolean(func_121.output[0]);
    func_2033.Execute(  );

    // [2019] Function call CfOr
    func_2019.input[0] = func_2030.output;
    func_2019.input[1] = FloatToBoolean(func_121.output[0]);
    func_2019.Execute(  );

    // [2018] Function call CfNot
    func_2018.input = getCmCHA_ChillerCmd_input_2().getValue();
    func_2018.Execute(  );

    // [2022] Function call CfAnd
    func_2022.input[0] = func_2028.outputOR;
    func_2022.input[1] = func_2033.output;
    func_2022.Execute(  );

    // [2034] Function call CfOr
    func_2034.input[0] = func_2030.output;
    func_2034.input[1] = func_2033.output;
    func_2034.Execute(  );

    // [2023] Function call CfAnd
    func_2023.input[0] = func_2017.outputGreater;
    func_2023.input[1] = getCmCHA_ChillerCmd_output_12().getValue();
    func_2023.input[2] = func_2018.output;
    func_2023.input[3] = func_2034.outputOR;
    func_2023.Execute(  );

    // [2026] Function call CfIdt
    func_2026.input = (float) getCmCHA_ChillerCmd_parameter_30();
    func_2026.Execute(  );
    setParameter(18, func_2026.output[0]);

    // [2027] Function call CfDelay
    func_2027.inputA = func_2023.outputAND;
    func_2027.inputB = func_2023.outputAND;
    func_2027.Execute( this, 18 );

    // [2025] Function call CfAnd
    func_2025.input[0] = getCmCHA_ChillerCmd_input_1352().getValue();
    func_2025.input[1] = func_2019.outputOR;
    func_2025.Execute(  );

    // [2028] Function call CfOr
    func_2028.input[0] = func_2027.outputDelayedA;
    func_2028.input[1] = func_2022.outputAND;
    func_2028.input[2] = func_2025.outputAND;
    func_2028.Execute(  );

    // [560] Function call CfIdt
    func_560.input = BooleanToFloat(func_551.outputOR);
    func_560.Execute(  );

    // [562] Function call CfIdt
    func_562.input = BooleanToFloat(func_553.outputOR);
    func_562.Execute(  );

    // [563] Function call CfIdt
    func_563.input = BooleanToFloat(func_555.outputDelayedA);
    func_563.Execute(  );

    // [566] Function call CfIdt
    func_566.input = func_445.output[0];
    func_566.Execute(  );

    // [567] Function call CfIdt
    func_567.input = func_447.output[0];
    func_567.Execute(  );

    // [568] Function call CfIdt
    func_568.input = func_390.output[0];
    func_568.Execute(  );

    // [570] Function call CfOr
    func_570.input[0] = FloatToBoolean(func_566.output[0]);
    func_570.input[1] = FloatToBoolean(func_567.output[0]);
    func_570.Execute(  );

    // [571] Function call CfSubtract
    func_571.input[0] = 1F;
    func_571.input[1] = func_568.output[0];
    func_571.Execute(  );

    // [573] Function call CfIdt
    func_573.input = BooleanToFloat(func_549.outputOR);
    func_573.Execute(  );

    // [574] Function call CfIdt
    func_574.input = BooleanToFloat(func_2028.outputOR);
    func_574.Execute(  );

    // [575] Function call CfIdt
    func_575.input = func_562.output[0];
    func_575.Execute(  );

    // [576] Function call CfIdt
    func_576.input = BooleanToFloat(func_556.outputOR);
    func_576.Execute(  );

    // [577] Function call CfAnd
    func_577.input[0] = func_570.outputOR;
    func_577.input[1] = FloatToBoolean(func_571.output);
    func_577.Execute(  );

    // [579] Function call CfOr
    func_579.input[0] = FloatToBoolean(func_573.output[0]);
    func_579.input[1] = FloatToBoolean(func_574.output[0]);
    func_579.input[2] = FloatToBoolean(func_575.output[0]);
    func_579.input[3] = FloatToBoolean(func_576.output[0]);
    func_579.input[4] = func_577.outputAND;
    func_579.input[5] = FloatToBoolean(func_560.output[0]);
    func_579.input[6] = func_552.outputOR;
    func_579.Execute(  );

    // [583] Function call CfIdt
    func_583.input = func_244.output[0];
    func_583.Execute(  );

    // [584] Function call CfIdt
    func_584.input = BooleanToFloat(func_1803.output);
    func_584.Execute(  );

    // [585] Function call CfIdt
    func_585.input = func_562.output[0];
    func_585.Execute(  );

    // [586] Function call CfIdt
    func_586.input = func_563.output[0];
    func_586.Execute(  );

    // [590] Function call CfIdt
    func_590.input = BooleanToFloat(func_549.outputOR);
    func_590.Execute(  );
    setCmCHA_ChillerCmd_parameter_37(func_590.output[0]);

    // [591] Function call CfIdt
    func_591.input = BooleanToFloat(func_552.outputOR);
    func_591.Execute(  );
    setCmCHA_ChillerCmd_parameter_38(func_591.output[0]);

    // [592] Function call CfIdt
    func_592.input = BooleanToFloat(func_2028.outputOR);
    func_592.Execute(  );
    setCmCHA_ChillerCmd_parameter_39(func_592.output[0]);

    // [593] Function call CfIdt
    func_593.input = func_560.output[0];
    func_593.Execute(  );
    setCmCHA_ChillerCmd_parameter_40(func_593.output[0]);

    // [594] Function call CfOr
    func_594.input[0] = FloatToBoolean(func_585.output[0]);
    func_594.input[1] = FloatToBoolean(func_586.output[0]);
    func_594.Execute(  );

    // [595] Function call CfIdt
    func_595.input = BooleanToFloat(func_556.outputOR);
    func_595.Execute(  );
    setCmCHA_ChillerCmd_parameter_42(func_595.output[0]);

    // [596] Function call CfIdt
    func_596.input = func_441.output[0];
    func_596.Execute(  );
    setCmCHA_ChillerCmd_parameter_43(func_596.output[0]);

    // [597] Function call CfIdt
    func_597.input = BooleanToFloat(func_579.outputOR);
    func_597.Execute(  );
    setCmCHA_ChillerCmd_parameter_44(func_597.output[0]);
    setCmCHA_ChillerCmd_output_14(FloatToBoolean(func_597.output[1]));

    // [599] Function call CfIdt
    func_599.input = func_583.output[0];
    func_599.Execute(  );
    setCmCHA_ChillerCmd_output_11(FloatToBoolean(func_599.output[0]));

    // [600] Function call CfIdt
    func_600.input = func_584.output[0];
    func_600.Execute(  );
    setCmCHA_ChillerCmd_output_12(FloatToBoolean(func_600.output[0]));

    // [601] Function call CfIdt
    func_601.input = func_390.output[0];
    func_601.Execute(  );
    setCmCHA_ChillerCmd_output_13(FloatToBoolean(func_601.output[0]));

    // [2447] Macro call CmLimited_auto_reset
    func_2447.CmLimited_auto_reset_input_1 = getCmCHA_ChillerCmd_output_14().getValue();
    func_2447.CmLimited_auto_reset_input_2 = (float) getCmCHA_ChillerCmd_parameter_33();
    func_2447.CmLimited_auto_reset_input_3 = (float) getCmCHA_ChillerCmd_parameter_2256();
    func_2447.CmLimited_auto_reset_input_4 = getCmCHA_ChillerCmd_input_10().getValue();
    func_2447.Execute(  );
    setCmCHA_ChillerCmd_parameter_2256(func_2447.CmLimited_auto_reset_output_5);

    // [606] Function call CfIdt
    func_606.input = BooleanToFloat(func_594.outputOR);
    func_606.Execute(  );
    setCmCHA_ChillerCmd_parameter_41(func_606.output[0]);

    // [610] Function call CfIdt
    func_610.input = func_585.output[0];
    func_610.Execute(  );
    setCmCHA_ChillerCmd_parameter_45(func_610.output[0]);

    // [611] Function call CfIdt
    func_611.input = func_586.output[0];
    func_611.Execute(  );
    setCmCHA_ChillerCmd_parameter_46(func_611.output[0]);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 0F, 0F, 0F, 0F, 0F, 0F, 0F,
    120F, 0F, 600F, 300F, 1200F, 120F, 0F, 0F,
    60F, 60F, 120F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// CdValvePmpCmd
  public static final Property CmCHA_ChillerCmd_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmCHA_ChillerCmd_output_11() { return (BStatusBoolean) get(CmCHA_ChillerCmd_output_11); }
  public void setCmCHA_ChillerCmd_output_11(BStatusBoolean v) { set(CmCHA_ChillerCmd_output_11,v,null); }
  public void setCmCHA_ChillerCmd_output_11(boolean v) { getCmCHA_ChillerCmd_output_11().setValue(v); }
// ChWatValvePmpCmd
  public static final Property CmCHA_ChillerCmd_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmCHA_ChillerCmd_output_12() { return (BStatusBoolean) get(CmCHA_ChillerCmd_output_12); }
  public void setCmCHA_ChillerCmd_output_12(BStatusBoolean v) { set(CmCHA_ChillerCmd_output_12,v,null); }
  public void setCmCHA_ChillerCmd_output_12(boolean v) { getCmCHA_ChillerCmd_output_12().setValue(v); }
// ChillCmd
  public static final Property CmCHA_ChillerCmd_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmCHA_ChillerCmd_output_13() { return (BStatusBoolean) get(CmCHA_ChillerCmd_output_13); }
  public void setCmCHA_ChillerCmd_output_13(BStatusBoolean v) { set(CmCHA_ChillerCmd_output_13,v,null); }
  public void setCmCHA_ChillerCmd_output_13(boolean v) { getCmCHA_ChillerCmd_output_13().setValue(v); }
// ChillComAlarm
  public static final Property CmCHA_ChillerCmd_output_14 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmCHA_ChillerCmd_output_14() { return (BStatusBoolean) get(CmCHA_ChillerCmd_output_14); }
  public void setCmCHA_ChillerCmd_output_14(BStatusBoolean v) { set(CmCHA_ChillerCmd_output_14,v,null); }
  public void setCmCHA_ChillerCmd_output_14(boolean v) { getCmCHA_ChillerCmd_output_14().setValue(v); }
// ReqCdPump
  public static final Property CmCHA_ChillerCmd_output_15 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCHA_ChillerCmd_output_15() { return (BStatusNumeric) get(CmCHA_ChillerCmd_output_15); }
  public void setCmCHA_ChillerCmd_output_15(BStatusNumeric v) { set(CmCHA_ChillerCmd_output_15,v,null); }
  public void setCmCHA_ChillerCmd_output_15(float v) { getCmCHA_ChillerCmd_output_15().setValue(v); }
// ReqChwPump
  public static final Property CmCHA_ChillerCmd_output_16 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCHA_ChillerCmd_output_16() { return (BStatusNumeric) get(CmCHA_ChillerCmd_output_16); }
  public void setCmCHA_ChillerCmd_output_16(BStatusNumeric v) { set(CmCHA_ChillerCmd_output_16,v,null); }
  public void setCmCHA_ChillerCmd_output_16(float v) { getCmCHA_ChillerCmd_output_16().setValue(v); }

  // macro parameter
// STRT-01: Startup delay condenser pump >0 with confirmation
  public static final Property CmCHA_ChillerCmd_parameter_18 = newProperty( 0, BDouble.make( -10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-3600)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_18() { return getDouble(CmCHA_ChillerCmd_parameter_18); }
  public void setCmCHA_ChillerCmd_parameter_18(double v) { setDouble(CmCHA_ChillerCmd_parameter_18,v,null); }
// STRT-02: Startup delay condenser valve >0 with confirmation
  public static final Property CmCHA_ChillerCmd_parameter_19 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-3600)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_19() { return getDouble(CmCHA_ChillerCmd_parameter_19); }
  public void setCmCHA_ChillerCmd_parameter_19(double v) { setDouble(CmCHA_ChillerCmd_parameter_19,v,null); }
// STRT-03: Startup delay chilled water pump >0 with confirmation
  public static final Property CmCHA_ChillerCmd_parameter_20 = newProperty( 0, BDouble.make( -10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-3600)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_20() { return getDouble(CmCHA_ChillerCmd_parameter_20); }
  public void setCmCHA_ChillerCmd_parameter_20(double v) { setDouble(CmCHA_ChillerCmd_parameter_20,v,null); }
// STRT-04: Startup delay chilled water valve >0 with confirmation
  public static final Property CmCHA_ChillerCmd_parameter_21 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-3600)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_21() { return getDouble(CmCHA_ChillerCmd_parameter_21); }
  public void setCmCHA_ChillerCmd_parameter_21(double v) { setDouble(CmCHA_ChillerCmd_parameter_21,v,null); }
// STRT-05: Startup delay chiller
  public static final Property CmCHA_ChillerCmd_parameter_22 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_22() { return getDouble(CmCHA_ChillerCmd_parameter_22); }
  public void setCmCHA_ChillerCmd_parameter_22(double v) { setDouble(CmCHA_ChillerCmd_parameter_22,v,null); }
// SHTD-01: Shutdown delay chiller
  public static final Property CmCHA_ChillerCmd_parameter_23 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_23() { return getDouble(CmCHA_ChillerCmd_parameter_23); }
  public void setCmCHA_ChillerCmd_parameter_23(double v) { setDouble(CmCHA_ChillerCmd_parameter_23,v,null); }
// SHTD-02: Shutdown delay condenser pump
  public static final Property CmCHA_ChillerCmd_parameter_24 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_24() { return getDouble(CmCHA_ChillerCmd_parameter_24); }
  public void setCmCHA_ChillerCmd_parameter_24(double v) { setDouble(CmCHA_ChillerCmd_parameter_24,v,null); }
// SHTD-03: Shutdown delay condenser valve
  public static final Property CmCHA_ChillerCmd_parameter_25 = newProperty( 0, BDouble.make( 420 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_25() { return getDouble(CmCHA_ChillerCmd_parameter_25); }
  public void setCmCHA_ChillerCmd_parameter_25(double v) { setDouble(CmCHA_ChillerCmd_parameter_25,v,null); }
// SHTD-04: Shutdown delay chilled water pump
  public static final Property CmCHA_ChillerCmd_parameter_26 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_26() { return getDouble(CmCHA_ChillerCmd_parameter_26); }
  public void setCmCHA_ChillerCmd_parameter_26(double v) { setDouble(CmCHA_ChillerCmd_parameter_26,v,null); }
// SHTD-05: Shutdown delay chilled water valve
  public static final Property CmCHA_ChillerCmd_parameter_27 = newProperty( 0, BDouble.make( 420 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_27() { return getDouble(CmCHA_ChillerCmd_parameter_27); }
  public void setCmCHA_ChillerCmd_parameter_27(double v) { setDouble(CmCHA_ChillerCmd_parameter_27,v,null); }
// ALM-01: alarm delay condenser valve; 0=disable
  public static final Property CmCHA_ChillerCmd_parameter_28 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(300)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_28() { return getDouble(CmCHA_ChillerCmd_parameter_28); }
  public void setCmCHA_ChillerCmd_parameter_28(double v) { setDouble(CmCHA_ChillerCmd_parameter_28,v,null); }
// ALM-02: alarm delay condenser pump; 0=disable
  public static final Property CmCHA_ChillerCmd_parameter_29 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(300)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_29() { return getDouble(CmCHA_ChillerCmd_parameter_29); }
  public void setCmCHA_ChillerCmd_parameter_29(double v) { setDouble(CmCHA_ChillerCmd_parameter_29,v,null); }
// ALM-03: alarm delay chilled water valve; 0=disable
  public static final Property CmCHA_ChillerCmd_parameter_30 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(300)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_30() { return getDouble(CmCHA_ChillerCmd_parameter_30); }
  public void setCmCHA_ChillerCmd_parameter_30(double v) { setDouble(CmCHA_ChillerCmd_parameter_30,v,null); }
// ALM-04: alarm delay chilled water pump; 0=disable
  public static final Property CmCHA_ChillerCmd_parameter_31 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(300)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_31() { return getDouble(CmCHA_ChillerCmd_parameter_31); }
  public void setCmCHA_ChillerCmd_parameter_31(double v) { setDouble(CmCHA_ChillerCmd_parameter_31,v,null); }
// ALM-05: alarm delay chiller; 0=disable
  public static final Property CmCHA_ChillerCmd_parameter_32 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(300)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_32() { return getDouble(CmCHA_ChillerCmd_parameter_32); }
  public void setCmCHA_ChillerCmd_parameter_32(double v) { setDouble(CmCHA_ChillerCmd_parameter_32,v,null); }
// ALM-06: reset <0=lim auto 0=man 1=auto
  public static final Property CmCHA_ChillerCmd_parameter_33 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(-1000)) ));
  public double getCmCHA_ChillerCmd_parameter_33() { return getDouble(CmCHA_ChillerCmd_parameter_33); }
  public void setCmCHA_ChillerCmd_parameter_33(double v) { setDouble(CmCHA_ChillerCmd_parameter_33,v,null); }
// SYS-01: min. On time
  public static final Property CmCHA_ChillerCmd_parameter_34 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1800)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_34() { return getDouble(CmCHA_ChillerCmd_parameter_34); }
  public void setCmCHA_ChillerCmd_parameter_34(double v) { setDouble(CmCHA_ChillerCmd_parameter_34,v,null); }
// SYS-02: min. Off time
  public static final Property CmCHA_ChillerCmd_parameter_35 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1800)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_35() { return getDouble(CmCHA_ChillerCmd_parameter_35); }
  public void setCmCHA_ChillerCmd_parameter_35(double v) { setDouble(CmCHA_ChillerCmd_parameter_35,v,null); }
// SYS-03: chiller recycle time
  public static final Property CmCHA_ChillerCmd_parameter_36 = newProperty( 0, BDouble.make( 1200 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1800)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_36() { return getDouble(CmCHA_ChillerCmd_parameter_36); }
  public void setCmCHA_ChillerCmd_parameter_36(double v) { setDouble(CmCHA_ChillerCmd_parameter_36,v,null); }
// DISP-01: condenser valve alarm
  public static final Property CmCHA_ChillerCmd_parameter_37 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCHA_ChillerCmd_parameter_37() { return getDouble(CmCHA_ChillerCmd_parameter_37); }
  public void setCmCHA_ChillerCmd_parameter_37(double v) { setDouble(CmCHA_ChillerCmd_parameter_37,v,null); }
// DISP-02: condenser pump alarm
  public static final Property CmCHA_ChillerCmd_parameter_38 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCHA_ChillerCmd_parameter_38() { return getDouble(CmCHA_ChillerCmd_parameter_38); }
  public void setCmCHA_ChillerCmd_parameter_38(double v) { setDouble(CmCHA_ChillerCmd_parameter_38,v,null); }
// DISP-03: chilled water valve alarm
  public static final Property CmCHA_ChillerCmd_parameter_39 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCHA_ChillerCmd_parameter_39() { return getDouble(CmCHA_ChillerCmd_parameter_39); }
  public void setCmCHA_ChillerCmd_parameter_39(double v) { setDouble(CmCHA_ChillerCmd_parameter_39,v,null); }
// DISP-04: chilled water pump alarm
  public static final Property CmCHA_ChillerCmd_parameter_40 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCHA_ChillerCmd_parameter_40() { return getDouble(CmCHA_ChillerCmd_parameter_40); }
  public void setCmCHA_ChillerCmd_parameter_40(double v) { setDouble(CmCHA_ChillerCmd_parameter_40,v,null); }
// DISP-05: chiller status alarm
  public static final Property CmCHA_ChillerCmd_parameter_41 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCHA_ChillerCmd_parameter_41() { return getDouble(CmCHA_ChillerCmd_parameter_41); }
  public void setCmCHA_ChillerCmd_parameter_41(double v) { setDouble(CmCHA_ChillerCmd_parameter_41,v,null); }
// DISP-06: chiller common alarm (input)
  public static final Property CmCHA_ChillerCmd_parameter_42 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCHA_ChillerCmd_parameter_42() { return getDouble(CmCHA_ChillerCmd_parameter_42); }
  public void setCmCHA_ChillerCmd_parameter_42(double v) { setDouble(CmCHA_ChillerCmd_parameter_42,v,null); }
// DISP-07: chiller remaining recycle time
  public static final Property CmCHA_ChillerCmd_parameter_43 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCHA_ChillerCmd_parameter_43() { return getDouble(CmCHA_ChillerCmd_parameter_43); }
  public void setCmCHA_ChillerCmd_parameter_43(double v) { setDouble(CmCHA_ChillerCmd_parameter_43,v,null); }
// DISP-08: unavailable flag
  public static final Property CmCHA_ChillerCmd_parameter_44 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCHA_ChillerCmd_parameter_44() { return getDouble(CmCHA_ChillerCmd_parameter_44); }
  public void setCmCHA_ChillerCmd_parameter_44(double v) { setDouble(CmCHA_ChillerCmd_parameter_44,v,null); }
// DISP-09: chiller off alarm
  public static final Property CmCHA_ChillerCmd_parameter_45 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCHA_ChillerCmd_parameter_45() { return getDouble(CmCHA_ChillerCmd_parameter_45); }
  public void setCmCHA_ChillerCmd_parameter_45(double v) { setDouble(CmCHA_ChillerCmd_parameter_45,v,null); }
// DISP-10: chiller on alarm
  public static final Property CmCHA_ChillerCmd_parameter_46 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCHA_ChillerCmd_parameter_46() { return getDouble(CmCHA_ChillerCmd_parameter_46); }
  public void setCmCHA_ChillerCmd_parameter_46(double v) { setDouble(CmCHA_ChillerCmd_parameter_46,v,null); }
// DISP-11 ALM-06 countdown
  public static final Property CmCHA_ChillerCmd_parameter_2256 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCHA_ChillerCmd_parameter_2256() { return getDouble(CmCHA_ChillerCmd_parameter_2256); }
  public void setCmCHA_ChillerCmd_parameter_2256(double v) { setDouble(CmCHA_ChillerCmd_parameter_2256,v,null); }

  // macro inputs
// CdVlvPmpStatus
  public static final Property CmCHA_ChillerCmd_input_1 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmCHA_ChillerCmd_input_1() { return (BStatusBoolean) get(CmCHA_ChillerCmd_input_1); }
  public void setCmCHA_ChillerCmd_input_1(BStatusBoolean v) { set(CmCHA_ChillerCmd_input_1,v,null); }
  public void setCmCHA_ChillerCmd_input_1(boolean v) { getCmCHA_ChillerCmd_input_1().setValue(v); }
// CdVlvPmpAlarm
  public static final Property CmCHA_ChillerCmd_input_1351 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmCHA_ChillerCmd_input_1351() { return (BStatusBoolean) get(CmCHA_ChillerCmd_input_1351); }
  public void setCmCHA_ChillerCmd_input_1351(BStatusBoolean v) { set(CmCHA_ChillerCmd_input_1351,v,null); }
  public void setCmCHA_ChillerCmd_input_1351(boolean v) { getCmCHA_ChillerCmd_input_1351().setValue(v); }
// ChWatVlvPmpStatus
  public static final Property CmCHA_ChillerCmd_input_2 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmCHA_ChillerCmd_input_2() { return (BStatusBoolean) get(CmCHA_ChillerCmd_input_2); }
  public void setCmCHA_ChillerCmd_input_2(BStatusBoolean v) { set(CmCHA_ChillerCmd_input_2,v,null); }
  public void setCmCHA_ChillerCmd_input_2(boolean v) { getCmCHA_ChillerCmd_input_2().setValue(v); }
// ChWatVlvPmpAlarm
  public static final Property CmCHA_ChillerCmd_input_1352 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmCHA_ChillerCmd_input_1352() { return (BStatusBoolean) get(CmCHA_ChillerCmd_input_1352); }
  public void setCmCHA_ChillerCmd_input_1352(BStatusBoolean v) { set(CmCHA_ChillerCmd_input_1352,v,null); }
  public void setCmCHA_ChillerCmd_input_1352(boolean v) { getCmCHA_ChillerCmd_input_1352().setValue(v); }
// ChillerStatus
  public static final Property CmCHA_ChillerCmd_input_3 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmCHA_ChillerCmd_input_3() { return (BStatusBoolean) get(CmCHA_ChillerCmd_input_3); }
  public void setCmCHA_ChillerCmd_input_3(BStatusBoolean v) { set(CmCHA_ChillerCmd_input_3,v,null); }
  public void setCmCHA_ChillerCmd_input_3(boolean v) { getCmCHA_ChillerCmd_input_3().setValue(v); }
// ChillerAlarm
  public static final Property CmCHA_ChillerCmd_input_1353 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmCHA_ChillerCmd_input_1353() { return (BStatusBoolean) get(CmCHA_ChillerCmd_input_1353); }
  public void setCmCHA_ChillerCmd_input_1353(BStatusBoolean v) { set(CmCHA_ChillerCmd_input_1353,v,null); }
  public void setCmCHA_ChillerCmd_input_1353(boolean v) { getCmCHA_ChillerCmd_input_1353().setValue(v); }
// ChillerComAlarm
  public static final Property CmCHA_ChillerCmd_input_4 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmCHA_ChillerCmd_input_4() { return (BStatusBoolean) get(CmCHA_ChillerCmd_input_4); }
  public void setCmCHA_ChillerCmd_input_4(BStatusBoolean v) { set(CmCHA_ChillerCmd_input_4,v,null); }
  public void setCmCHA_ChillerCmd_input_4(boolean v) { getCmCHA_ChillerCmd_input_4().setValue(v); }
// OperCdPump
  public static final Property CmCHA_ChillerCmd_input_6 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmCHA_ChillerCmd_input_6() { return (BStatusNumeric) get(CmCHA_ChillerCmd_input_6); }
  public void setCmCHA_ChillerCmd_input_6(BStatusNumeric v) { set(CmCHA_ChillerCmd_input_6,v,null); }
  public void setCmCHA_ChillerCmd_input_6(float v) { getCmCHA_ChillerCmd_input_6().setValue(v); }
// OperChwPump
  public static final Property CmCHA_ChillerCmd_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmCHA_ChillerCmd_input_7() { return (BStatusNumeric) get(CmCHA_ChillerCmd_input_7); }
  public void setCmCHA_ChillerCmd_input_7(BStatusNumeric v) { set(CmCHA_ChillerCmd_input_7,v,null); }
  public void setCmCHA_ChillerCmd_input_7(float v) { getCmCHA_ChillerCmd_input_7().setValue(v); }
// ReqCdPump
  public static final Property CmCHA_ChillerCmd_input_8 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmCHA_ChillerCmd_input_8() { return (BStatusNumeric) get(CmCHA_ChillerCmd_input_8); }
  public void setCmCHA_ChillerCmd_input_8(BStatusNumeric v) { set(CmCHA_ChillerCmd_input_8,v,null); }
  public void setCmCHA_ChillerCmd_input_8(float v) { getCmCHA_ChillerCmd_input_8().setValue(v); }
// ReqChwPump
  public static final Property CmCHA_ChillerCmd_input_9 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmCHA_ChillerCmd_input_9() { return (BStatusNumeric) get(CmCHA_ChillerCmd_input_9); }
  public void setCmCHA_ChillerCmd_input_9(BStatusNumeric v) { set(CmCHA_ChillerCmd_input_9,v,null); }
  public void setCmCHA_ChillerCmd_input_9(float v) { getCmCHA_ChillerCmd_input_9().setValue(v); }
// Reset
  public static final Property CmCHA_ChillerCmd_input_10 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmCHA_ChillerCmd_input_10() { return (BStatusBoolean) get(CmCHA_ChillerCmd_input_10); }
  public void setCmCHA_ChillerCmd_input_10(BStatusBoolean v) { set(CmCHA_ChillerCmd_input_10,v,null); }
  public void setCmCHA_ChillerCmd_input_10(boolean v) { getCmCHA_ChillerCmd_input_10().setValue(v); }
// Enable
  public static final Property CmCHA_ChillerCmd_input_5 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmCHA_ChillerCmd_input_5() { return (BStatusBoolean) get(CmCHA_ChillerCmd_input_5); }
  public void setCmCHA_ChillerCmd_input_5(BStatusBoolean v) { set(CmCHA_ChillerCmd_input_5,v,null); }
  public void setCmCHA_ChillerCmd_input_5(boolean v) { getCmCHA_ChillerCmd_input_5().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.01 [39] 17.08.2016-14:18").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6238454830386381374").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmCHA_ChillerCmd.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private float   IntToFloat    (int     value) { return (float) value; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfTruncate func_48 = new CfTruncate();
  protected CfIdt func_61 = new CfIdt();
  protected CfIdt func_62 = new CfIdt();
  protected CfIdt func_63 = new CfIdt();
  protected CfIdt func_64 = new CfIdt();
  protected CfSubtract func_65 = new CfSubtract();
  protected CfAbsolute func_66 = new CfAbsolute();
  protected CfSubtract func_67 = new CfSubtract();
  protected CfAbsolute func_68 = new CfAbsolute();
  protected CfSubtract func_69 = new CfSubtract();
  protected CfAbsolute func_70 = new CfAbsolute();
  protected CfSubtract func_71 = new CfSubtract();
  protected CfAbsolute func_72 = new CfAbsolute();
  protected CfSubtract func_73 = new CfSubtract();
  protected CfAbsolute func_74 = new CfAbsolute();
  protected CfSubtract func_75 = new CfSubtract();
  protected CfAbsolute func_76 = new CfAbsolute();
  protected CfSubtract func_77 = new CfSubtract();
  protected CfAbsolute func_78 = new CfAbsolute();
  protected CfSubtract func_79 = new CfSubtract();
  protected CfAbsolute func_80 = new CfAbsolute();
  protected CfLastValue func_2247 = new CfLastValue();
  protected CfAnd func_82 = new CfAnd();
  protected CfCompare1 func_1680 = new CfCompare1();
  protected CfCompare1 func_2249 = new CfCompare1();
  protected CfIdt func_88 = new CfIdt();
  protected CfIdt func_89 = new CfIdt();
  protected CfIdt func_90 = new CfIdt();
  protected CfIdt func_91 = new CfIdt();
  protected CfIdt func_92 = new CfIdt();
  protected CfIdt func_93 = new CfIdt();
  protected CfIdt func_94 = new CfIdt();
  protected CfIdt func_95 = new CfIdt();
  protected CfIdt func_96 = new CfIdt();
  protected CfIdt func_97 = new CfIdt();
  protected CfIdt func_98 = new CfIdt();
  protected CfIdt func_99 = new CfIdt();
  protected CfOr func_101 = new CfOr();
  protected CfIdt func_106 = new CfIdt();
  protected CfRound func_107 = new CfRound();
  protected CfSubtract func_108 = new CfSubtract();
  protected CfRound func_109 = new CfRound();
  protected CfSubtract func_110 = new CfSubtract();
  protected CfIdt func_111 = new CfIdt();
  protected CfRound func_112 = new CfRound();
  protected CfSubtract func_113 = new CfSubtract();
  protected CfRound func_114 = new CfRound();
  protected CfSubtract func_115 = new CfSubtract();
  protected CfIdt func_120 = new CfIdt();
  protected CfIdt func_121 = new CfIdt();
  protected CfCompare2 func_1677 = new CfCompare2();
  protected CfIdt func_122 = new CfIdt();
  protected CfCompare2 func_1676 = new CfCompare2();
  protected CfIdt func_123 = new CfIdt();
  protected CfAnd func_124 = new CfAnd();
  protected CfAnd func_125 = new CfAnd();
  protected CfAnd func_126 = new CfAnd();
  protected CfAnd func_127 = new CfAnd();
  protected CfNot func_1679 = new CfNot();
  protected CfNot func_1678 = new CfNot();
  protected CfOr func_131 = new CfOr();
  protected CfIdt func_132 = new CfIdt();
  protected CfIdt func_133 = new CfIdt();
  protected CfIdt func_134 = new CfIdt();
  protected CfIdt func_135 = new CfIdt();
  protected CfAnd func_137 = new CfAnd();
  protected CfIdt func_139 = new CfIdt();
  protected CfIdt func_141 = new CfIdt();
  protected CfIdt func_142 = new CfIdt();
  protected CfCompare1 func_150 = new CfCompare1();
  protected CfIdt func_154 = new CfIdt();
  protected CfIdt func_173 = new CfIdt();
  protected CfCompare2 func_1780 = new CfCompare2();
  protected CfOr func_201 = new CfOr();
  protected CfIdt func_203 = new CfIdt();
  protected CfDelay func_204 = new CfDelay();
  protected CfIdt func_206 = new CfIdt();
  protected CfNot func_1781 = new CfNot();
  protected CfDelay func_207 = new CfDelay();
  protected CfAnd func_230 = new CfAnd();
  protected CfOr func_231 = new CfOr();
  protected CfRsFlipFlop func_239 = new CfRsFlipFlop();
  protected CfIdt func_244 = new CfIdt();
  protected CfIdt func_1795 = new CfIdt();
  protected CfIdt func_1796 = new CfIdt();
  protected CfCompare1 func_1805 = new CfCompare1();
  protected CfCompare2 func_1807 = new CfCompare2();
  protected CfIdt func_1806 = new CfIdt();
  protected CfOr func_1808 = new CfOr();
  protected CfIdt func_1809 = new CfIdt();
  protected CfIdt func_1799 = new CfIdt();
  protected CfIdt func_1797 = new CfIdt();
  protected CfDelay func_1798 = new CfDelay();
  protected CfNot func_1800 = new CfNot();
  protected CfDelay func_1801 = new CfDelay();
  protected CfAnd func_1802 = new CfAnd();
  protected CfOr func_1810 = new CfOr();
  protected CfRsFlipFlop func_1803 = new CfRsFlipFlop();
  protected CfIdt func_1841 = new CfIdt();
  protected CfIdt func_1842 = new CfIdt();
  protected CfCompare1 func_1837 = new CfCompare1();
  protected CfCompare2 func_1840 = new CfCompare2();
  protected CfIdt func_1843 = new CfIdt();
  protected CfOr func_1838 = new CfOr();
  protected CfIdt func_1844 = new CfIdt();
  protected CfIdt func_1846 = new CfIdt();
  protected CfIdt func_1832 = new CfIdt();
  protected CfDelay func_1833 = new CfDelay();
  protected CfNot func_1834 = new CfNot();
  protected CfDelay func_1835 = new CfDelay();
  protected CfAnd func_1836 = new CfAnd();
  protected CfOr func_1839 = new CfOr();
  protected CfRsFlipFlop func_1845 = new CfRsFlipFlop();
  protected CfIdt func_1855 = new CfIdt();
  protected CfIdt func_1856 = new CfIdt();
  protected CfCompare1 func_1852 = new CfCompare1();
  protected CfCompare2 func_1857 = new CfCompare2();
  protected CfIdt func_1858 = new CfIdt();
  protected CfOr func_1853 = new CfOr();
  protected CfIdt func_1859 = new CfIdt();
  protected CfIdt func_1860 = new CfIdt();
  protected CfIdt func_1847 = new CfIdt();
  protected CfDelay func_1848 = new CfDelay();
  protected CfNot func_1849 = new CfNot();
  protected CfDelay func_1850 = new CfDelay();
  protected CfAnd func_1851 = new CfAnd();
  protected CfOr func_1854 = new CfOr();
  protected CfRsFlipFlop func_1861 = new CfRsFlipFlop();
  protected CfIdt func_275 = new CfIdt();
  protected CfIdt func_282 = new CfIdt();
  protected CfCompare2 func_1531 = new CfCompare2();
  protected CfOr func_284 = new CfOr();
  protected CfIdt func_285 = new CfIdt();
  protected CfIdt func_286 = new CfIdt();
  protected CfCompare2 func_1533 = new CfCompare2();
  protected CfOr func_287 = new CfOr();
  protected CfCompare2 func_1534 = new CfCompare2();
  protected CfOr func_288 = new CfOr();
  protected CfIdt func_289 = new CfIdt();
  protected CfIdt func_290 = new CfIdt();
  protected CfCompare2 func_1536 = new CfCompare2();
  protected CfOr func_291 = new CfOr();
  protected CfAnd func_293 = new CfAnd();
  protected CfAnd func_294 = new CfAnd();
  protected CfAnd func_295 = new CfAnd();
  protected CfAnd func_296 = new CfAnd();
  protected CfIdt func_298 = new CfIdt();
  protected CfIdt func_299 = new CfIdt();
  protected CfIdt func_300 = new CfIdt();
  protected CfIdt func_301 = new CfIdt();
  protected CfIdt func_303 = new CfIdt();
  protected CfIdt func_305 = new CfIdt();
  protected CfAddition func_306 = new CfAddition();
  protected CfCompare1 func_308 = new CfCompare1();
  protected CfInputMultiplexer func_1396 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1398 = new CfInputMultiplexer();
  protected CfIdt func_314 = new CfIdt();
  protected CfIdt func_316 = new CfIdt();
  protected CfAddition func_317 = new CfAddition();
  protected CfCompare1 func_319 = new CfCompare1();
  protected CfInputMultiplexer func_1400 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1401 = new CfInputMultiplexer();
  protected CfIdt func_325 = new CfIdt();
  protected CfIdt func_327 = new CfIdt();
  protected CfSubtract func_328 = new CfSubtract();
  protected CfCompare1 func_330 = new CfCompare1();
  protected CfInputMultiplexer func_1402 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1403 = new CfInputMultiplexer();
  protected CfIdt func_336 = new CfIdt();
  protected CfIdt func_338 = new CfIdt();
  protected CfSubtract func_339 = new CfSubtract();
  protected CfCompare1 func_341 = new CfCompare1();
  protected CfInputMultiplexer func_1404 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1405 = new CfInputMultiplexer();
  protected CfCompare1 func_349 = new CfCompare1();
  protected CfInputMultiplexer func_1408 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1409 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1406 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1407 = new CfInputMultiplexer();
  protected CfIdt func_357 = new CfIdt();
  protected CfRound func_359 = new CfRound();
  protected CfSubtract func_360 = new CfSubtract();
  protected CfIdt func_361 = new CfIdt();
  protected CfIdt func_363 = new CfIdt();
  protected CfDelay func_364 = new CfDelay();
  protected CfRound func_365 = new CfRound();
  protected CfSubtract func_366 = new CfSubtract();
  protected CfIdt func_367 = new CfIdt();
  protected CfDelay func_368 = new CfDelay();
  protected CfIdt func_370 = new CfIdt();
  protected CfIdt func_371 = new CfIdt();
  protected CfAnd func_373 = new CfAnd();
  protected CfAnd func_374 = new CfAnd();
  protected CfIdt func_375 = new CfIdt();
  protected CfOr func_376 = new CfOr();
  protected CfLastValue func_2408 = new CfLastValue();
  protected CfCompare1 func_2410 = new CfCompare1();
  protected CfOr func_378 = new CfOr();
  protected CfRsFlipFlop func_380 = new CfRsFlipFlop();
  protected CfIdt func_381 = new CfIdt();
  protected CfIdt func_382 = new CfIdt();
  protected CfIdt func_383 = new CfIdt();
  protected CfIdt func_384 = new CfIdt();
  protected CfSubtract func_385 = new CfSubtract();
  protected CfAnd func_387 = new CfAnd();
  protected CfIdt func_388 = new CfIdt();
  protected CfIdt func_390 = new CfIdt();
  protected CfSubtract func_392 = new CfSubtract();
  protected CfSubtract func_394 = new CfSubtract();
  protected CfAnd func_396 = new CfAnd();
  protected CfAnd func_397 = new CfAnd();
  protected CfIdt func_398 = new CfIdt();
  protected CfIdt func_399 = new CfIdt();
  protected CfIdt func_400 = new CfIdt();
  protected CfSubtract func_403 = new CfSubtract();
  protected CfSubtract func_405 = new CfSubtract();
  protected CfSubtract func_409 = new CfSubtract();
  protected CfSubtract func_411 = new CfSubtract();
  protected CfSubtract func_413 = new CfSubtract();
  protected CfSubtract func_415 = new CfSubtract();
  protected CfCompare1 func_2438 = new CfCompare1();
  protected CfAnd func_417 = new CfAnd();
  protected CfAnd func_418 = new CfAnd();
  protected CfCompare1 func_2439 = new CfCompare1();
  protected CfAnd func_420 = new CfAnd();
  protected CfAnd func_421 = new CfAnd();
  protected CfCompare1 func_2441 = new CfCompare1();
  protected CfAnd func_422 = new CfAnd();
  protected CfAnd func_423 = new CfAnd();
  protected CfIdt func_425 = new CfIdt();
  protected CfDelay func_426 = new CfDelay();
  protected CfIdt func_427 = new CfIdt();
  protected CfResetTimer func_2340 = new CfResetTimer();
  protected CfTimer func_2338 = new CfTimer();
  protected CfSubtract func_428 = new CfSubtract();
  protected CfIdt func_429 = new CfIdt();
  protected CfIdt func_430 = new CfIdt();
  protected CfDelay func_431 = new CfDelay();
  protected CfIdt func_432 = new CfIdt();
  protected CfDelay func_433 = new CfDelay();
  protected CfOr func_435 = new CfOr();
  protected CfInputMultiplexer func_436 = new CfInputMultiplexer();
  protected CfOr func_437 = new CfOr();
  protected CfOr func_438 = new CfOr();
  protected CfRsFlipFlop func_440 = new CfRsFlipFlop();
  protected CfIdt func_441 = new CfIdt();
  protected CfRsFlipFlop func_442 = new CfRsFlipFlop();
  protected CfRsFlipFlop func_443 = new CfRsFlipFlop();
  protected CfIdt func_445 = new CfIdt();
  protected CfIdt func_446 = new CfIdt();
  protected CfIdt func_447 = new CfIdt();
  protected CfCompare1 func_1986 = new CfCompare1();
  protected CfIdt func_473 = new CfIdt();
  protected CfIdt func_474 = new CfIdt();
  protected CfCompare1 func_475 = new CfCompare1();
  protected CfIdt func_478 = new CfIdt();
  protected CfIdt func_479 = new CfIdt();
  protected CfCompare1 func_480 = new CfCompare1();
  protected CfNot func_1997 = new CfNot();
  protected CfNot func_1998 = new CfNot();
  protected CfOr func_492 = new CfOr();
  protected CfOr func_2325 = new CfOr();
  protected CfAnd func_494 = new CfAnd();
  protected CfSubtract func_501 = new CfSubtract();
  protected CfRound func_502 = new CfRound();
  protected CfSubtract func_503 = new CfSubtract();
  protected CfSubtract func_506 = new CfSubtract();
  protected CfRound func_507 = new CfRound();
  protected CfSubtract func_508 = new CfSubtract();
  protected CfNot func_2074 = new CfNot();
  protected CfNot func_2327 = new CfNot();
  protected CfOr func_514 = new CfOr();
  protected CfOr func_2329 = new CfOr();
  protected CfAnd func_516 = new CfAnd();
  protected CfNot func_1992 = new CfNot();
  protected CfAnd func_520 = new CfAnd();
  protected CfAnd func_521 = new CfAnd();
  protected CfAnd func_524 = new CfAnd();
  protected CfNot func_2067 = new CfNot();
  protected CfAnd func_525 = new CfAnd();
  protected CfAnd func_526 = new CfAnd();
  protected CfNot func_2068 = new CfNot();
  protected CfAnd func_527 = new CfAnd();
  protected CfCompare1 func_2328 = new CfCompare1();
  protected CfNot func_2326 = new CfNot();
  protected CfAnd func_528 = new CfAnd();
  protected CfAnd func_529 = new CfAnd();
  protected CfIdt func_532 = new CfIdt();
  protected CfIdt func_535 = new CfIdt();
  protected CfDelay func_536 = new CfDelay();
  protected CfIdt func_539 = new CfIdt();
  protected CfDelay func_540 = new CfDelay();
  protected CfIdt func_541 = new CfIdt();
  protected CfDelay func_542 = new CfDelay();
  protected CfIdt func_543 = new CfIdt();
  protected CfNot func_2070 = new CfNot();
  protected CfDelay func_544 = new CfDelay();
  protected CfAnd func_545 = new CfAnd();
  protected CfNot func_2069 = new CfNot();
  protected CfAnd func_546 = new CfAnd();
  protected CfOr func_549 = new CfOr();
  protected CfOr func_551 = new CfOr();
  protected CfOr func_552 = new CfOr();
  protected CfOr func_553 = new CfOr();
  protected CfDelay func_555 = new CfDelay();
  protected CfOr func_556 = new CfOr();
  protected CfCompare1 func_2017 = new CfCompare1();
  protected CfNot func_2030 = new CfNot();
  protected CfNot func_2033 = new CfNot();
  protected CfOr func_2019 = new CfOr();
  protected CfNot func_2018 = new CfNot();
  protected CfAnd func_2022 = new CfAnd();
  protected CfOr func_2034 = new CfOr();
  protected CfAnd func_2023 = new CfAnd();
  protected CfIdt func_2026 = new CfIdt();
  protected CfDelay func_2027 = new CfDelay();
  protected CfAnd func_2025 = new CfAnd();
  protected CfOr func_2028 = new CfOr();
  protected CfIdt func_560 = new CfIdt();
  protected CfIdt func_562 = new CfIdt();
  protected CfIdt func_563 = new CfIdt();
  protected CfIdt func_566 = new CfIdt();
  protected CfIdt func_567 = new CfIdt();
  protected CfIdt func_568 = new CfIdt();
  protected CfOr func_570 = new CfOr();
  protected CfSubtract func_571 = new CfSubtract();
  protected CfIdt func_573 = new CfIdt();
  protected CfIdt func_574 = new CfIdt();
  protected CfIdt func_575 = new CfIdt();
  protected CfIdt func_576 = new CfIdt();
  protected CfAnd func_577 = new CfAnd();
  protected CfOr func_579 = new CfOr();
  protected CfIdt func_583 = new CfIdt();
  protected CfIdt func_584 = new CfIdt();
  protected CfIdt func_585 = new CfIdt();
  protected CfIdt func_586 = new CfIdt();
  protected CfIdt func_590 = new CfIdt();
  protected CfIdt func_591 = new CfIdt();
  protected CfIdt func_592 = new CfIdt();
  protected CfIdt func_593 = new CfIdt();
  protected CfOr func_594 = new CfOr();
  protected CfIdt func_595 = new CfIdt();
  protected CfIdt func_596 = new CfIdt();
  protected CfIdt func_597 = new CfIdt();
  protected CfIdt func_599 = new CfIdt();
  protected CfIdt func_600 = new CfIdt();
  protected CfIdt func_601 = new CfIdt();
  protected CmLimited_auto_reset func_2447 = new CmLimited_auto_reset();
  protected CfIdt func_606 = new CfIdt();
  protected CfIdt func_610 = new CfIdt();
  protected CfIdt func_611 = new CfIdt();

  // default constructor
  public BCmCHA_ChillerCmd()
  {
    func_101.configure(3);
    func_137.configure(3);
    func_201.configure(3);
    func_1808.configure(3);
    func_1838.configure(3);
    func_1853.configure(3);
    func_284.configure(3);
    func_288.configure(3);
    func_376.configure(3);
    func_378.configure(3);
    func_387.configure(6);
    func_417.configure(3);
    func_420.configure(3);
    func_422.configure(3);
    func_520.configure(4);
    func_524.configure(3);
    func_526.configure(3);
    func_528.configure(4);
    func_543.configure(2);
    func_545.configure(3);
    func_549.configure(3);
    func_553.configure(3);
    func_2023.configure(4);
    func_2028.configure(3);
    func_579.configure(7);
    func_597.configure(2);
  }

  public void Start()
  {
    func_2247.Start();
    func_204.Start();
    func_207.Start();
    func_239.Start();
    func_1798.Start();
    func_1801.Start();
    func_1803.Start();
    func_1833.Start();
    func_1835.Start();
    func_1845.Start();
    func_1848.Start();
    func_1850.Start();
    func_1861.Start();
    func_364.Start();
    func_368.Start();
    func_2408.Start();
    func_380.Start();
    func_426.Start();
    func_431.Start();
    func_433.Start();
    func_440.Start();
    func_442.Start();
    func_443.Start();
    func_536.Start();
    func_540.Start();
    func_542.Start();
    func_544.Start();
    func_555.Start();
    func_2027.Start();
    func_2447.Start();
  }
}
