/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:27
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.chiller;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    GPA_GroupSelect
Macro id:      6238454894812987534
Macro version: 14
Last change:   21.07.2016 - 08:20
Access Level:  2
Inputs:
  [1] EnFreeCooling
  [2] EnPeakLoadChill
  [3] SeqFeedback1
  [4] SeqFeedback2
  [5] SeqFeedback3
  [6] Req_NoLoads
Outputs:
  [1] FreeCooling
  [2] PeakLoadChill
  [3] ChillGroup1
  [4] ChillGroup2
  [5] ChillGroup3
Parameter:
  [1] LPK-01: light peak chiller config
  [2] LPK-02: LPK enabled during free cooling
  [3] FRCG-01: GP1 enabled during free cooling
  [4] FRCG-02: GP2 enabled during free cooling
  [5] FRCG-03: GP3 enabled during free cooling
  [6] SEQ-01: sequence group 123
  [7] CFG-01: number of chillers group 1
  [8] CFG-02: number of chillers group 2
  [9] CFG-03: number of chillers group 3
Description:
GPA is a chiller group priority module.
The module provides services for free-cooling / ice storage, 
light load / peak load chiller and 3 chiller groups.
================================================================================*/

public class BCmGPA_GroupSelect
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmGPA_GroupSelect_output_7().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmGPA_GroupSelect_output_7().setStatus(BStatus.disabled);
    getCmGPA_GroupSelect_output_8().setStatus(BStatus.disabled);
    getCmGPA_GroupSelect_output_9().setStatus(BStatus.disabled);
    getCmGPA_GroupSelect_output_10().setStatus(BStatus.disabled);
    getCmGPA_GroupSelect_output_11().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmGPA_GroupSelect_output_7().setStatus(BStatus.ok);
    getCmGPA_GroupSelect_output_8().setStatus(BStatus.ok);
    getCmGPA_GroupSelect_output_9().setStatus(BStatus.ok);
    getCmGPA_GroupSelect_output_10().setStatus(BStatus.ok);
    getCmGPA_GroupSelect_output_11().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [23] Function call CfTruncate
    func_23.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_23.Execute(  );

    // [32] Function call CfIdt
    func_32.input = func_23.output;
    func_32.Execute(  );

    // [64] Function call CfIdt
    func_64.input = func_32.output[0];
    func_64.Execute(  );

    // [67] Function call CfSubtract
    func_67.input[0] = 1F;
    func_67.input[1] = func_64.output[0];
    func_67.Execute(  );

    // [71] Function call CfSubtract
    func_71.input[0] = (float) getCmGPA_GroupSelect_input_6().getValue();
    func_71.input[1] = 1F;
    func_71.Execute(  );

    // [572] Function call CfCompare2
    func_572.inputA = (float) getCmGPA_GroupSelect_input_6().getValue();
    func_572.inputB = 1F;
    func_572.Execute(  );

    // [73] Function call CfAnd
    func_73.input[0] = FloatToBoolean(func_67.output);
    func_73.input[1] = getCmGPA_GroupSelect_input_1().getValue();
    func_73.input[2] = func_572.outputEqualOrGreater;
    func_73.Execute(  );

    // [76] Function call CfInputMultiplexer
    func_76.inputSelect = BooleanToInt(func_73.outputAND);
    func_76.input[1-1] = (float) getCmGPA_GroupSelect_input_6().getValue();
    func_76.input[2-1] = func_71.output;
    func_76.Execute(  );

    // [576] Function call CfIdt
    func_576.input = BooleanToFloat(func_73.outputAND);
    func_576.Execute(  );
    setCmGPA_GroupSelect_output_7(FloatToBoolean(func_576.output[0]));

    // [78] Function call CfIdt
    func_78.input = func_76.output;
    func_78.Execute(  );

    // [82] Function call CfCompare1
    func_82.inputA = func_76.output;
    func_82.inputB = 1F;
    func_82.Execute(  );

    // [86] Function call CfIdt
    func_86.input = func_217.output[0];
    func_86.Execute(  );

    // [88] Function call CfDivide
    func_88.inputA = func_76.output;
    func_88.inputB = 2F;
    func_88.Execute(  );

    // [89] Function call CfIdt
    func_89.input = func_32.output[0];
    func_89.Execute(  );

    // [97] Function call CfTruncate
    func_97.input = func_88.output;
    func_97.Execute(  );

    // [98] Function call CfSubtract
    func_98.input[0] = func_76.output;
    func_98.input[1] = 1F;
    func_98.Execute(  );

    // [100] Function call CfSubtract
    func_100.input[0] = 1F;
    func_100.input[1] = func_89.output[0];
    func_100.Execute(  );

    // [650] Function call CfNot
    func_650.input = getCmGPA_GroupSelect_output_7().getValue();
    func_650.Execute(  );

    // [589] Function call CfCompare1
    func_589.inputA = (float) getCmGPA_GroupSelect_parameter_14();
    func_589.inputB = 1F;
    func_589.Execute(  );

    // [102] Function call CfOr
    func_102.input[0] = func_650.output;
    func_102.input[1] = func_589.outputEqual;
    func_102.Execute(  );

    // [105] Function call CfSplit
    func_105.input = FloatToInt(func_76.output);
    func_105.Execute( this, 0 );

    // [588] Function call CfCompare2
    func_588.inputA = func_86.output[0];
    func_588.inputB = 1F;
    func_588.Execute(  );

    // [106] Function call CfOr
    func_106.input[0] = func_82.outputEqual;
    func_106.input[1] = func_588.outputEqualOrGreater;
    func_106.Execute(  );

    // [591] Function call CfCompare1
    func_591.inputA = (float) getCmGPA_GroupSelect_parameter_13();
    func_591.inputB = 1F;
    func_591.Execute(  );

    // [108] Function call CfInputMultiplexer
    func_108.inputSelect = BooleanToInt(func_591.outputEqual);
    func_108.input[1-1] = func_98.output;
    func_108.input[2-1] = func_97.output;
    func_108.Execute(  );

    // [110] Function call CfAnd
    func_110.input[0] = FloatToBoolean(func_100.output);
    func_110.input[1] = getCmGPA_GroupSelect_input_2().getValue();
    func_110.input[2] = func_102.outputOR;
    func_110.Execute(  );

    // [590] Function call CfCompare2
    func_590.inputA = func_76.output;
    func_590.inputB = 1F;
    func_590.Execute(  );

    // [111] Function call CfInputMultiplexer
    func_111.inputSelect = FloatToInt((float) getCmGPA_GroupSelect_parameter_13());
    func_111.input[1-1] = BooleanToFloat(func_106.outputOR);
    func_111.input[2-1] = IntToFloat(func_105.output[0]);
    func_111.input[3-1] = BooleanToFloat(func_590.outputEqualOrGreater);
    func_111.Execute(  );

    // [113] Function call CfInputMultiplexer
    func_113.inputSelect = BooleanToInt(func_110.outputAND);
    func_113.input[1-1] = func_78.output[0];
    func_113.input[2-1] = func_108.output;
    func_113.Execute(  );

    // [114] Function call CfAnd
    func_114.input[0] = func_110.outputAND;
    func_114.input[1] = FloatToBoolean(func_111.output);
    func_114.Execute(  );
    setCmGPA_GroupSelect_output_8(func_114.outputAND);

    // [116] Function call CfIdt
    func_116.input = func_113.output;
    func_116.Execute(  );

    // [120] Function call CfSplit
    func_120.input = FloatToInt((float) getCmGPA_GroupSelect_parameter_18());
    func_120.Execute( this, 2 );

    // [122] Function call CfIdt
    func_122.input = IntToFloat(func_120.output[0]);
    func_122.Execute(  );

    // [123] Function call CfIdt
    func_123.input = IntToFloat(func_120.output[1]);
    func_123.Execute(  );

    // [124] Function call CfIdt
    func_124.input = IntToFloat(func_120.output[2]);
    func_124.Execute(  );

    // [126] Function call CfIdt
    func_126.input = func_124.output[0];
    func_126.Execute(  );

    // [127] Function call CfIdt
    func_127.input = func_123.output[0];
    func_127.Execute(  );

    // [128] Function call CfIdt
    func_128.input = func_122.output[0];
    func_128.Execute(  );

    // [130] Function call CfOutputMultiplexer
    func_130.inputSelect = FloatToInt(func_126.output[0]);
    func_130.inputValue = (float) getCmGPA_GroupSelect_parameter_15();
    func_130.Execute( this, 5 );
    if ( func_130.outputValid[0]) register_31 = func_130.output[0];
    if ( func_130.outputValid[1]) register_32 = func_130.output[1];
    if ( func_130.outputValid[2]) register_33 = func_130.output[2];
    if ( func_130.outputValid[3]) register_34 = func_130.output[3];

    // [131] Function call CfOutputMultiplexer
    func_131.inputSelect = FloatToInt(func_127.output[0]);
    func_131.inputValue = (float) getCmGPA_GroupSelect_parameter_16();
    func_131.Execute( this, 6 );
    if ( func_131.outputValid[0]) register_31 = func_131.output[0];
    if ( func_131.outputValid[1]) register_32 = func_131.output[1];
    if ( func_131.outputValid[2]) register_33 = func_131.output[2];
    if ( func_131.outputValid[3]) register_34 = func_131.output[3];

    // [132] Function call CfOutputMultiplexer
    func_132.inputSelect = FloatToInt(func_128.output[0]);
    func_132.inputValue = (float) getCmGPA_GroupSelect_parameter_17();
    func_132.Execute( this, 7 );
    if ( func_132.outputValid[0]) register_31 = func_132.output[0];
    if ( func_132.outputValid[1]) register_32 = func_132.output[1];
    if ( func_132.outputValid[2]) register_33 = func_132.output[2];
    if ( func_132.outputValid[3]) register_34 = func_132.output[3];

    // [133] Function call CfOutputMultiplexer
    func_133.inputSelect = FloatToInt(func_126.output[0]);
    func_133.inputValue = (float) getCmGPA_GroupSelect_parameter_19();
    func_133.Execute( this, 8 );
    if ( func_133.outputValid[0]) register_31 = func_133.output[0];
    if ( func_133.outputValid[1]) register_35 = func_133.output[1];
    if ( func_133.outputValid[2]) register_36 = func_133.output[2];
    if ( func_133.outputValid[3]) register_37 = func_133.output[3];

    // [134] Function call CfOutputMultiplexer
    func_134.inputSelect = FloatToInt(func_127.output[0]);
    func_134.inputValue = (float) getCmGPA_GroupSelect_parameter_20();
    func_134.Execute( this, 9 );
    if ( func_134.outputValid[0]) register_31 = func_134.output[0];
    if ( func_134.outputValid[1]) register_35 = func_134.output[1];
    if ( func_134.outputValid[2]) register_36 = func_134.output[2];
    if ( func_134.outputValid[3]) register_37 = func_134.output[3];

    // [135] Function call CfOutputMultiplexer
    func_135.inputSelect = FloatToInt(func_128.output[0]);
    func_135.inputValue = (float) getCmGPA_GroupSelect_parameter_21();
    func_135.Execute( this, 10 );
    if ( func_135.outputValid[0]) register_31 = func_135.output[0];
    if ( func_135.outputValid[1]) register_35 = func_135.output[1];
    if ( func_135.outputValid[2]) register_36 = func_135.output[2];
    if ( func_135.outputValid[3]) register_37 = func_135.output[3];

    // [592] Function call CfAddition
    func_592.input[0] = func_113.output;
    func_592.input[1] = BooleanToFloat(getCmGPA_GroupSelect_input_3().getValue());
    func_592.input[2] = BooleanToFloat(getCmGPA_GroupSelect_input_4().getValue());
    func_592.input[3] = BooleanToFloat(getCmGPA_GroupSelect_input_5().getValue());
    func_592.Execute(  );

    // [593] Function call CfIdt
    func_593.input = func_592.output;
    func_593.Execute(  );

    // [639] Function call CfNot
    func_639.input = FloatToBoolean(func_32.output[0]);
    func_639.Execute(  );

    // [663] Function call CfNot
    func_663.input = getCmGPA_GroupSelect_output_7().getValue();
    func_663.Execute(  );

    // [164] Function call CfOr
    func_164.input[0] = FloatToBoolean(register_32);
    func_164.input[1] = func_663.output;
    func_164.Execute(  );

    // [168] Function call CfMinimum
    func_168.input[0] = register_35;
    func_168.input[1] = func_593.output[0];
    func_168.Execute(  );

    // [642] Function call CfCompare2
    func_642.inputA = func_116.output[0];
    func_642.inputB = 1F;
    func_642.Execute(  );

    // [169] Function call CfAnd
    func_169.input[0] = func_639.output;
    func_169.input[1] = func_164.outputOR;
    func_169.input[2] = func_642.outputEqualOrGreater;
    func_169.Execute(  );

    // [172] Function call CfInputMultiplexer
    func_172.inputSelect = BooleanToInt(func_169.outputAND);
    func_172.input[1-1] = BooleanToFloat(func_169.outputAND);
    func_172.input[2-1] = func_168.output;
    func_172.Execute(  );

    // [175] Function call CfSubtract
    func_175.input[0] = func_593.output[0];
    func_175.input[1] = func_172.output;
    func_175.Execute(  );

    // [176] Function call CfIdt
    func_176.input = func_172.output;
    func_176.Execute(  );

    // [664] Function call CfNot
    func_664.input = getCmGPA_GroupSelect_output_7().getValue();
    func_664.Execute(  );

    // [184] Function call CfOr
    func_184.input[0] = FloatToBoolean(register_33);
    func_184.input[1] = func_664.output;
    func_184.Execute(  );

    // [188] Function call CfMinimum
    func_188.input[0] = register_36;
    func_188.input[1] = func_175.output;
    func_188.Execute(  );

    // [641] Function call CfNot
    func_641.input = FloatToBoolean(func_32.output[0]);
    func_641.Execute(  );

    // [640] Function call CfCompare2
    func_640.inputA = func_175.output;
    func_640.inputB = 1F;
    func_640.Execute(  );

    // [189] Function call CfAnd
    func_189.input[0] = func_640.outputEqualOrGreater;
    func_189.input[1] = func_641.output;
    func_189.input[2] = func_184.outputOR;
    func_189.Execute(  );

    // [192] Function call CfInputMultiplexer
    func_192.inputSelect = BooleanToInt(func_189.outputAND);
    func_192.input[1-1] = BooleanToFloat(func_189.outputAND);
    func_192.input[2-1] = func_188.output;
    func_192.Execute(  );

    // [195] Function call CfSubtract
    func_195.input[0] = func_175.output;
    func_195.input[1] = func_192.output;
    func_195.Execute(  );

    // [196] Function call CfIdt
    func_196.input = func_192.output;
    func_196.Execute(  );

    // [644] Function call CfNot
    func_644.input = FloatToBoolean(func_32.output[0]);
    func_644.Execute(  );

    // [667] Function call CfNot
    func_667.input = getCmGPA_GroupSelect_output_7().getValue();
    func_667.Execute(  );

    // [204] Function call CfOr
    func_204.input[0] = FloatToBoolean(register_34);
    func_204.input[1] = func_667.output;
    func_204.Execute(  );

    // [643] Function call CfCompare2
    func_643.inputA = func_195.output;
    func_643.inputB = 1F;
    func_643.Execute(  );

    // [208] Function call CfMinimum
    func_208.input[0] = register_37;
    func_208.input[1] = func_195.output;
    func_208.Execute(  );

    // [209] Function call CfAnd
    func_209.input[0] = func_644.output;
    func_209.input[1] = func_204.outputOR;
    func_209.input[2] = func_643.outputEqualOrGreater;
    func_209.Execute(  );

    // [212] Function call CfInputMultiplexer
    func_212.inputSelect = BooleanToInt(func_209.outputAND);
    func_212.input[1-1] = BooleanToFloat(func_209.outputAND);
    func_212.input[2-1] = func_208.output;
    func_212.Execute(  );

    // [214] Function call CfSubtract
    func_214.input[0] = func_195.output;
    func_214.input[1] = func_212.output;
    func_214.Execute(  );

    // [215] Function call CfIdt
    func_215.input = func_212.output;
    func_215.Execute(  );

    // [217] Function call CfIdt
    func_217.input = func_214.output;
    func_217.Execute(  );

    // [218] Function call CfIdt
    func_218.input = func_124.output[0];
    func_218.Execute(  );

    // [219] Function call CfIdt
    func_219.input = func_123.output[0];
    func_219.Execute(  );

    // [220] Function call CfIdt
    func_220.input = func_122.output[0];
    func_220.Execute(  );

    // [224] Function call CfInputMultiplexer
    func_224.inputSelect = FloatToInt(func_218.output[0]);
    func_224.input[1-1] = register_31;
    func_224.input[2-1] = func_176.output[0];
    func_224.input[3-1] = func_196.output[0];
    func_224.input[4-1] = func_215.output[0];
    func_224.Execute(  );
    setCmGPA_GroupSelect_output_9(func_224.output);

    // [225] Function call CfInputMultiplexer
    func_225.inputSelect = FloatToInt(func_219.output[0]);
    func_225.input[1-1] = register_31;
    func_225.input[2-1] = func_176.output[0];
    func_225.input[3-1] = func_196.output[0];
    func_225.input[4-1] = func_215.output[0];
    func_225.Execute(  );
    setCmGPA_GroupSelect_output_10(func_225.output);

    // [226] Function call CfInputMultiplexer
    func_226.inputSelect = FloatToInt(func_220.output[0]);
    func_226.input[1-1] = register_31;
    func_226.input[2-1] = func_176.output[0];
    func_226.input[3-1] = func_196.output[0];
    func_226.input[4-1] = func_215.output[0];
    func_226.Execute(  );
    setCmGPA_GroupSelect_output_11(func_226.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    2F, 2F, 10F, 10F, 10F, 0F, 0F, 0F,
    0F, 0F, 0F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  protected float register_31 = 0;
  protected float register_32 = 0;
  protected float register_33 = 0;
  protected float register_34 = 0;
  protected float register_35 = 0;
  protected float register_36 = 0;
  protected float register_37 = 0;
  // macro outputs
// FreeCooling
  public static final Property CmGPA_GroupSelect_output_7 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmGPA_GroupSelect_output_7() { return (BStatusBoolean) get(CmGPA_GroupSelect_output_7); }
  public void setCmGPA_GroupSelect_output_7(BStatusBoolean v) { set(CmGPA_GroupSelect_output_7,v,null); }
  public void setCmGPA_GroupSelect_output_7(boolean v) { getCmGPA_GroupSelect_output_7().setValue(v); }
// PeakLoadChill
  public static final Property CmGPA_GroupSelect_output_8 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmGPA_GroupSelect_output_8() { return (BStatusBoolean) get(CmGPA_GroupSelect_output_8); }
  public void setCmGPA_GroupSelect_output_8(BStatusBoolean v) { set(CmGPA_GroupSelect_output_8,v,null); }
  public void setCmGPA_GroupSelect_output_8(boolean v) { getCmGPA_GroupSelect_output_8().setValue(v); }
// ChillGroup1
  public static final Property CmGPA_GroupSelect_output_9 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmGPA_GroupSelect_output_9() { return (BStatusNumeric) get(CmGPA_GroupSelect_output_9); }
  public void setCmGPA_GroupSelect_output_9(BStatusNumeric v) { set(CmGPA_GroupSelect_output_9,v,null); }
  public void setCmGPA_GroupSelect_output_9(float v) { getCmGPA_GroupSelect_output_9().setValue(v); }
// ChillGroup2
  public static final Property CmGPA_GroupSelect_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmGPA_GroupSelect_output_10() { return (BStatusNumeric) get(CmGPA_GroupSelect_output_10); }
  public void setCmGPA_GroupSelect_output_10(BStatusNumeric v) { set(CmGPA_GroupSelect_output_10,v,null); }
  public void setCmGPA_GroupSelect_output_10(float v) { getCmGPA_GroupSelect_output_10().setValue(v); }
// ChillGroup3
  public static final Property CmGPA_GroupSelect_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmGPA_GroupSelect_output_11() { return (BStatusNumeric) get(CmGPA_GroupSelect_output_11); }
  public void setCmGPA_GroupSelect_output_11(BStatusNumeric v) { set(CmGPA_GroupSelect_output_11,v,null); }
  public void setCmGPA_GroupSelect_output_11(float v) { getCmGPA_GroupSelect_output_11().setValue(v); }

  // macro parameter
// LPK-01: light peak chiller config
  public static final Property CmGPA_GroupSelect_parameter_13 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmGPA_GroupSelect_parameter_13() { return getDouble(CmGPA_GroupSelect_parameter_13); }
  public void setCmGPA_GroupSelect_parameter_13(double v) { setDouble(CmGPA_GroupSelect_parameter_13,v,null); }
// LPK-02: LPK enabled during free cooling
  public static final Property CmGPA_GroupSelect_parameter_14 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmGPA_GroupSelect_parameter_14() { return getDouble(CmGPA_GroupSelect_parameter_14); }
  public void setCmGPA_GroupSelect_parameter_14(double v) { setDouble(CmGPA_GroupSelect_parameter_14,v,null); }
// FRCG-01: GP1 enabled during free cooling
  public static final Property CmGPA_GroupSelect_parameter_15 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmGPA_GroupSelect_parameter_15() { return getDouble(CmGPA_GroupSelect_parameter_15); }
  public void setCmGPA_GroupSelect_parameter_15(double v) { setDouble(CmGPA_GroupSelect_parameter_15,v,null); }
// FRCG-02: GP2 enabled during free cooling
  public static final Property CmGPA_GroupSelect_parameter_16 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmGPA_GroupSelect_parameter_16() { return getDouble(CmGPA_GroupSelect_parameter_16); }
  public void setCmGPA_GroupSelect_parameter_16(double v) { setDouble(CmGPA_GroupSelect_parameter_16,v,null); }
// FRCG-03: GP3 enabled during free cooling
  public static final Property CmGPA_GroupSelect_parameter_17 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmGPA_GroupSelect_parameter_17() { return getDouble(CmGPA_GroupSelect_parameter_17); }
  public void setCmGPA_GroupSelect_parameter_17(double v) { setDouble(CmGPA_GroupSelect_parameter_17,v,null); }
// SEQ-01: sequence group 123
  public static final Property CmGPA_GroupSelect_parameter_18 = newProperty( 0, BDouble.make( 123 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(321)), BFacets.make(BFacets.MIN, BDouble.make(123)) ));
  public double getCmGPA_GroupSelect_parameter_18() { return getDouble(CmGPA_GroupSelect_parameter_18); }
  public void setCmGPA_GroupSelect_parameter_18(double v) { setDouble(CmGPA_GroupSelect_parameter_18,v,null); }
// CFG-01: number of chillers group 1
  public static final Property CmGPA_GroupSelect_parameter_19 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmGPA_GroupSelect_parameter_19() { return getDouble(CmGPA_GroupSelect_parameter_19); }
  public void setCmGPA_GroupSelect_parameter_19(double v) { setDouble(CmGPA_GroupSelect_parameter_19,v,null); }
// CFG-02: number of chillers group 2
  public static final Property CmGPA_GroupSelect_parameter_20 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmGPA_GroupSelect_parameter_20() { return getDouble(CmGPA_GroupSelect_parameter_20); }
  public void setCmGPA_GroupSelect_parameter_20(double v) { setDouble(CmGPA_GroupSelect_parameter_20,v,null); }
// CFG-03: number of chillers group 3
  public static final Property CmGPA_GroupSelect_parameter_21 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmGPA_GroupSelect_parameter_21() { return getDouble(CmGPA_GroupSelect_parameter_21); }
  public void setCmGPA_GroupSelect_parameter_21(double v) { setDouble(CmGPA_GroupSelect_parameter_21,v,null); }

  // macro inputs
// EnFreeCooling
  public static final Property CmGPA_GroupSelect_input_1 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmGPA_GroupSelect_input_1() { return (BStatusBoolean) get(CmGPA_GroupSelect_input_1); }
  public void setCmGPA_GroupSelect_input_1(BStatusBoolean v) { set(CmGPA_GroupSelect_input_1,v,null); }
  public void setCmGPA_GroupSelect_input_1(boolean v) { getCmGPA_GroupSelect_input_1().setValue(v); }
// EnPeakLoadChill
  public static final Property CmGPA_GroupSelect_input_2 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmGPA_GroupSelect_input_2() { return (BStatusBoolean) get(CmGPA_GroupSelect_input_2); }
  public void setCmGPA_GroupSelect_input_2(BStatusBoolean v) { set(CmGPA_GroupSelect_input_2,v,null); }
  public void setCmGPA_GroupSelect_input_2(boolean v) { getCmGPA_GroupSelect_input_2().setValue(v); }
// SeqFeedback1
  public static final Property CmGPA_GroupSelect_input_3 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmGPA_GroupSelect_input_3() { return (BStatusBoolean) get(CmGPA_GroupSelect_input_3); }
  public void setCmGPA_GroupSelect_input_3(BStatusBoolean v) { set(CmGPA_GroupSelect_input_3,v,null); }
  public void setCmGPA_GroupSelect_input_3(boolean v) { getCmGPA_GroupSelect_input_3().setValue(v); }
// SeqFeedback2
  public static final Property CmGPA_GroupSelect_input_4 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmGPA_GroupSelect_input_4() { return (BStatusBoolean) get(CmGPA_GroupSelect_input_4); }
  public void setCmGPA_GroupSelect_input_4(BStatusBoolean v) { set(CmGPA_GroupSelect_input_4,v,null); }
  public void setCmGPA_GroupSelect_input_4(boolean v) { getCmGPA_GroupSelect_input_4().setValue(v); }
// SeqFeedback3
  public static final Property CmGPA_GroupSelect_input_5 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmGPA_GroupSelect_input_5() { return (BStatusBoolean) get(CmGPA_GroupSelect_input_5); }
  public void setCmGPA_GroupSelect_input_5(BStatusBoolean v) { set(CmGPA_GroupSelect_input_5,v,null); }
  public void setCmGPA_GroupSelect_input_5(boolean v) { getCmGPA_GroupSelect_input_5().setValue(v); }
// Req_NoLoads
  public static final Property CmGPA_GroupSelect_input_6 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmGPA_GroupSelect_input_6() { return (BStatusNumeric) get(CmGPA_GroupSelect_input_6); }
  public void setCmGPA_GroupSelect_input_6(BStatusNumeric v) { set(CmGPA_GroupSelect_input_6,v,null); }
  public void setCmGPA_GroupSelect_input_6(float v) { getCmGPA_GroupSelect_input_6().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.01 [14] 21.07.2016-08:20").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6238454894812987534").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmGPA_GroupSelect.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private float   IntToFloat    (int     value) { return (float) value; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfTruncate func_23 = new CfTruncate();
  protected CfIdt func_32 = new CfIdt();
  protected CfIdt func_64 = new CfIdt();
  protected CfSubtract func_67 = new CfSubtract();
  protected CfSubtract func_71 = new CfSubtract();
  protected CfCompare2 func_572 = new CfCompare2();
  protected CfAnd func_73 = new CfAnd();
  protected CfInputMultiplexer func_76 = new CfInputMultiplexer();
  protected CfIdt func_576 = new CfIdt();
  protected CfIdt func_78 = new CfIdt();
  protected CfCompare1 func_82 = new CfCompare1();
  protected CfIdt func_86 = new CfIdt();
  protected CfDivide func_88 = new CfDivide();
  protected CfIdt func_89 = new CfIdt();
  protected CfTruncate func_97 = new CfTruncate();
  protected CfSubtract func_98 = new CfSubtract();
  protected CfSubtract func_100 = new CfSubtract();
  protected CfNot func_650 = new CfNot();
  protected CfCompare1 func_589 = new CfCompare1();
  protected CfOr func_102 = new CfOr();
  protected CfSplit func_105 = new CfSplit();
  protected CfCompare2 func_588 = new CfCompare2();
  protected CfOr func_106 = new CfOr();
  protected CfCompare1 func_591 = new CfCompare1();
  protected CfInputMultiplexer func_108 = new CfInputMultiplexer();
  protected CfAnd func_110 = new CfAnd();
  protected CfCompare2 func_590 = new CfCompare2();
  protected CfInputMultiplexer func_111 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_113 = new CfInputMultiplexer();
  protected CfAnd func_114 = new CfAnd();
  protected CfIdt func_116 = new CfIdt();
  protected CfSplit func_120 = new CfSplit();
  protected CfIdt func_122 = new CfIdt();
  protected CfIdt func_123 = new CfIdt();
  protected CfIdt func_124 = new CfIdt();
  protected CfIdt func_126 = new CfIdt();
  protected CfIdt func_127 = new CfIdt();
  protected CfIdt func_128 = new CfIdt();
  protected CfOutputMultiplexer func_130 = new CfOutputMultiplexer();
  protected CfOutputMultiplexer func_131 = new CfOutputMultiplexer();
  protected CfOutputMultiplexer func_132 = new CfOutputMultiplexer();
  protected CfOutputMultiplexer func_133 = new CfOutputMultiplexer();
  protected CfOutputMultiplexer func_134 = new CfOutputMultiplexer();
  protected CfOutputMultiplexer func_135 = new CfOutputMultiplexer();
  protected CfAddition func_592 = new CfAddition();
  protected CfIdt func_593 = new CfIdt();
  protected CfNot func_639 = new CfNot();
  protected CfNot func_663 = new CfNot();
  protected CfOr func_164 = new CfOr();
  protected CfMinimum func_168 = new CfMinimum();
  protected CfCompare2 func_642 = new CfCompare2();
  protected CfAnd func_169 = new CfAnd();
  protected CfInputMultiplexer func_172 = new CfInputMultiplexer();
  protected CfSubtract func_175 = new CfSubtract();
  protected CfIdt func_176 = new CfIdt();
  protected CfNot func_664 = new CfNot();
  protected CfOr func_184 = new CfOr();
  protected CfMinimum func_188 = new CfMinimum();
  protected CfNot func_641 = new CfNot();
  protected CfCompare2 func_640 = new CfCompare2();
  protected CfAnd func_189 = new CfAnd();
  protected CfInputMultiplexer func_192 = new CfInputMultiplexer();
  protected CfSubtract func_195 = new CfSubtract();
  protected CfIdt func_196 = new CfIdt();
  protected CfNot func_644 = new CfNot();
  protected CfNot func_667 = new CfNot();
  protected CfOr func_204 = new CfOr();
  protected CfCompare2 func_643 = new CfCompare2();
  protected CfMinimum func_208 = new CfMinimum();
  protected CfAnd func_209 = new CfAnd();
  protected CfInputMultiplexer func_212 = new CfInputMultiplexer();
  protected CfSubtract func_214 = new CfSubtract();
  protected CfIdt func_215 = new CfIdt();
  protected CfIdt func_217 = new CfIdt();
  protected CfIdt func_218 = new CfIdt();
  protected CfIdt func_219 = new CfIdt();
  protected CfIdt func_220 = new CfIdt();
  protected CfInputMultiplexer func_224 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_225 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_226 = new CfInputMultiplexer();

  // default constructor
  public BCmGPA_GroupSelect()
  {
    func_73.configure(3);
    func_110.configure(3);
    func_111.configure(4);
    func_120.configure(3);
    func_130.configure(4);
    func_131.configure(4);
    func_132.configure(4);
    func_133.configure(4);
    func_134.configure(4);
    func_135.configure(4);
    func_592.configure(4);
    func_169.configure(3);
    func_189.configure(3);
    func_209.configure(3);
    func_224.configure(5);
    func_225.configure(5);
    func_226.configure(5);
  }

  public void Start()
  {
  }
}
