/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:27
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.chiller;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    LCA_LoadCalc
Macro id:      6238454963533513176
Macro version: 19
Last change:   25.05.2016 - 11:57
Access Level:  2
Inputs:
  [1] SysSupplyTemp
  [2] SysSupplyTempSp
  [3] SysReturnTemp
  [4] SysReturnTempSp
  [5] AvgCap
  [6] Req_Load
  [7] PowerDemandOff
  [8] Enable
Outputs:
  [1] Req_Loads
Parameter:
  [1] SRT-01: P-band SRT Control
  [2] SRT-02: I-time SRT Control; 0 = disable
  [3] ACP-01: high limit increase chillers
  [4] ACP-02: low limit decrease chillers
  [5] PDO-01: max number of chillers
  [6] PDO-02: decrease number of chillers
  [7] SYS-01: number of chillers
  [8] SYS-02: increase delay
  [9] SYS-03: decrease delay
  [10] SYS-04: calculation method
  [11] SYS-05: input signal for number of loads
Description:
The LCA_LoadCalc macro can be used to calculate the number of 
chillers to fulfill building cooling load demand. The 
calculation type can be selected by configuration 
parameters and can be based on :-
- Chilled water system return temperature 
- Chilled water system supply and return temperature 
- Average Chiller capacity 
- Custom CARE input
The result of calculation is an integer value from 0 to n, 
whereby n is the requested no. of chillers.
================================================================================*/

public class BCmLCA_LoadCalc
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmLCA_LoadCalc_output_9().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmLCA_LoadCalc_output_9().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmLCA_LoadCalc_output_9().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [909] Function call CfCompare2
    func_909.inputA = (float) getCmLCA_LoadCalc_input_1().getValue();
    func_909.inputB = 999F;
    func_909.Execute(  );

    // [910] Function call CfCompare2
    func_910.inputA = (float) getCmLCA_LoadCalc_input_2().getValue();
    func_910.inputB = 999F;
    func_910.Execute(  );

    // [26] Function call CfIdt
    func_26.input = (float) getCmLCA_LoadCalc_input_4().getValue();
    func_26.Execute(  );

    // [906] Function call CfNot
    func_906.input = ControlFunction.GetStartupFlag();
    func_906.Execute(  );

    // [27] Function call CfIdt
    func_27.input = BooleanToFloat(getCmLCA_LoadCalc_input_5().getValue());
    func_27.Execute(  );

    // [68] Function call CfAnd
    func_68.input[0] = func_906.output;
    func_68.input[1] = getCmLCA_LoadCalc_input_6().getValue();
    func_68.Execute(  );

    // [912] Function call CfCompare2
    func_912.inputA = (float) getCmLCA_LoadCalc_input_3().getValue();
    func_912.inputB = 999F;
    func_912.Execute(  );

    // [913] Function call CfCompare2
    func_913.inputA = (float) getCmLCA_LoadCalc_input_4().getValue();
    func_913.inputB = 999F;
    func_913.Execute(  );

    // [41] Function call CfIdt
    func_41.input = func_55.output[0];
    func_41.Execute(  );

    // [42] Function call CfIdt
    func_42.input = func_27.output[0];
    func_42.Execute(  );

    // [43] Function call CfIdt
    func_43.input = func_907.output[0];
    func_43.Execute(  );

    // [55] Function call CfIdt
    func_55.input = func_42.output[0];
    func_55.Execute(  );

    // [56] Function call CfRound
    func_56.input = func_41.output[0];
    func_56.Execute(  );

    // [57] Function call CfSubtract
    func_57.input[0] = 1F;
    func_57.input[1] = func_41.output[0];
    func_57.Execute(  );

    // [58] Function call CfRound
    func_58.input = func_42.output[0];
    func_58.Execute(  );

    // [59] Function call CfSubtract
    func_59.input[0] = 1F;
    func_59.input[1] = func_42.output[0];
    func_59.Execute(  );

    // [60] Function call CfAddition
    func_60.input[0] = func_43.output[0];
    func_60.input[1] = 1F;
    func_60.Execute(  );

    // [61] Function call CfSubtract
    func_61.input[0] = func_43.output[0];
    func_61.input[1] = 1F;
    func_61.Execute(  );

    // [62] Function call CfMaximum
    func_62.input[0] = 1F;
    func_62.input[1] = (float) getCmLCA_LoadCalc_parameter_17();
    func_62.Execute(  );

    // [69] Function call CfAnd
    func_69.input[0] = FloatToBoolean(func_56.output);
    func_69.input[1] = FloatToBoolean(func_59.output);
    func_69.Execute(  );

    // [70] Function call CfAnd
    func_70.input[0] = FloatToBoolean(func_57.output);
    func_70.input[1] = FloatToBoolean(func_58.output);
    func_70.Execute(  );

    // [71] Function call CfDivide
    func_71.inputA = func_60.output;
    func_71.inputB = func_62.output;
    func_71.Execute(  );

    // [72] Function call CfDivide
    func_72.inputA = func_61.output;
    func_72.inputB = func_62.output;
    func_72.Execute(  );

    // [75] Function call CfIdt
    func_75.input = BooleanToFloat(func_69.outputAND);
    func_75.Execute(  );

    // [76] Function call CfIdt
    func_76.input = BooleanToFloat(func_70.outputAND);
    func_76.Execute(  );

    // [77] Function call CfMultiply
    func_77.input[0] = func_71.output;
    func_77.input[1] = 100F;
    func_77.Execute(  );

    // [78] Function call CfMultiply
    func_78.input[0] = func_72.output;
    func_78.input[1] = 99F;
    func_78.Execute(  );

    // [81] Function call CfIdt
    func_81.input = func_77.output;
    func_81.Execute(  );

    // [82] Function call CfIdt
    func_82.input = func_78.output;
    func_82.Execute(  );

    // [1040] Function call CfNot
    func_1040.input = func_913.outputEqualOrGreater;
    func_1040.Execute(  );

    // [1079] Function call CfAnd
    func_1079.input[0] = func_1040.output;
    func_1079.input[1] = func_68.outputAND;
    func_1079.Execute(  );

    // [1034] Macro call CmLoadCalc_NLoad
    if ( func_1079.outputAND)
    {
      func_1034.CmLoadCalc_NLoad_input_1 = func_26.output[0];
      func_1034.CmLoadCalc_NLoad_input_92 = (float) getCmLCA_LoadCalc_input_4().getValue();
      func_1034.CmLoadCalc_NLoad_input_95 = func_907.output[0];
      func_1034.CmLoadCalc_NLoad_input_97 = func_82.output[0];
      func_1034.CmLoadCalc_NLoad_input_99 = func_81.output[0];
      func_1034.Execute(  );
    }

    // [1089] Function call CfAnd
    func_1089.input[0] = func_913.outputEqualOrGreater;
    func_1089.input[1] = func_68.outputAND;
    func_1089.Execute(  );

    // [1087] Macro call CmLoadCalc_PI_control
    if ( func_1089.outputAND)
    {
      func_1087.CmLoadCalc_PI_control_input_248 = (float) getCmLCA_LoadCalc_input_2().getValue();
      func_1087.CmLoadCalc_PI_control_input_249 = (float) getCmLCA_LoadCalc_input_8().getValue();
      func_1087.CmLoadCalc_PI_control_input_250 = (float) getCmLCA_LoadCalc_input_1().getValue();
      func_1087.CmLoadCalc_PI_control_input_251 = (float) getCmLCA_LoadCalc_input_7().getValue();
      func_1087.CmLoadCalc_PI_control_input_268 = (float) getCmLCA_LoadCalc_input_3().getValue();
      func_1087.CmLoadCalc_PI_control_input_252 = (float) getCmLCA_LoadCalc_parameter_11();
      func_1087.CmLoadCalc_PI_control_input_253 = (float) getCmLCA_LoadCalc_parameter_12();
      func_1087.CmLoadCalc_PI_control_input_301 = (float) getCmLCA_LoadCalc_parameter_13();
      func_1087.CmLoadCalc_PI_control_input_302 = (float) getCmLCA_LoadCalc_parameter_14();
      func_1087.CmLoadCalc_PI_control_input_328 = (float) getCmLCA_LoadCalc_parameter_18();
      func_1087.CmLoadCalc_PI_control_input_329 = (float) getCmLCA_LoadCalc_parameter_19();
      func_1087.CmLoadCalc_PI_control_input_276 = func_910.outputEqualOrGreater;
      func_1087.CmLoadCalc_PI_control_input_277 = func_909.outputEqualOrGreater;
      func_1087.CmLoadCalc_PI_control_input_308 = func_912.outputEqualOrGreater;
      func_1087.CmLoadCalc_PI_control_input_281 = func_907.output[0];
      func_1087.CmLoadCalc_PI_control_input_295 = func_81.output[0];
      func_1087.CmLoadCalc_PI_control_input_296 = func_82.output[0];
      func_1087.CmLoadCalc_PI_control_input_330 = FloatToBoolean(func_347.output[0]);
      func_1087.Execute( this, 0 );
    }

    // [282] Function call CfIdt
    func_282.input = func_1087.CmLoadCalc_PI_control_output_254;
    func_282.Execute(  );

    // [283] Function call CfIdt
    func_283.input = func_1087.CmLoadCalc_PI_control_output_255;
    func_283.Execute(  );

    // [284] Function call CfIdt
    func_284.input = func_1087.CmLoadCalc_PI_control_output_256;
    func_284.Execute(  );

    // [285] Function call CfIdt
    func_285.input = func_1034.CmLoadCalc_NLoad_output_2;
    func_285.Execute(  );

    // [286] Function call CfIdt
    func_286.input = func_1034.CmLoadCalc_NLoad_output_3;
    func_286.Execute(  );

    // [287] Function call CfIdt
    func_287.input = func_1034.CmLoadCalc_NLoad_output_4;
    func_287.Execute(  );

    // [289] Function call CfInputMultiplexer
    func_289.inputSelect = FloatToInt((float) getCmLCA_LoadCalc_parameter_20());
    func_289.input[1-1] = func_282.output[0];
    func_289.input[2-1] = func_283.output[0];
    func_289.input[3-1] = func_284.output[0];
    func_289.Execute(  );

    // [290] Function call CfInputMultiplexer
    func_290.inputSelect = FloatToInt((float) getCmLCA_LoadCalc_parameter_21());
    func_290.input[1-1] = func_285.output[0];
    func_290.input[2-1] = func_286.output[0];
    func_290.input[3-1] = func_287.output[0];
    func_290.Execute(  );

    // [291] Function call CfIdt
    func_291.input = BooleanToFloat(func_913.outputEqualOrGreater);
    func_291.Execute(  );

    // [293] Function call CfInputMultiplexer
    func_293.inputSelect = FloatToInt(func_291.output[0]);
    func_293.input[1-1] = func_290.output;
    func_293.input[2-1] = func_289.output;
    func_293.Execute(  );

    // [294] Function call CfIdt
    func_294.input = register_109;
    func_294.Execute(  );

    // [296] Function call CfIdt
    func_296.input = func_293.output;
    func_296.Execute(  );

    // [297] Function call CfCompare1
    func_297.inputA = func_293.output;
    func_297.inputB = func_294.output[0];
    func_297.Execute(  );

    // [299] Function call CfCompare1
    func_299.inputA = func_294.output[0];
    func_299.inputB = (float) getCmLCA_LoadCalc_parameter_17();
    func_299.Execute(  );

    // [302] Function call CfCompare1
    func_302.inputA = func_294.output[0];
    func_302.inputB = func_293.output;
    func_302.Execute(  );

    // [304] Function call CfCompare1
    func_304.inputA = 0F;
    func_304.inputB = func_294.output[0];
    func_304.Execute(  );

    // [308] Function call CfIdt
    func_308.input = func_907.output[0];
    func_308.Execute(  );

    // [1090] Function call CfNot
    func_1090.input = func_376.output;
    func_1090.Execute(  );

    // [317] Function call CfAnd
    func_317.input[0] = func_297.outputLess;
    func_317.input[1] = func_1090.output;
    func_317.input[2] = func_304.outputLess;
    func_317.Execute(  );

    // [1091] Function call CfNot
    func_1091.input = func_375.output;
    func_1091.Execute(  );

    // [318] Function call CfAnd
    func_318.input[0] = func_299.outputLess;
    func_318.input[1] = func_302.outputLess;
    func_318.input[2] = func_1091.output;
    func_318.Execute(  );

    // [1095] Function call CfSubtract
    func_1095.input[0] = func_308.output[0];
    func_1095.input[1] = 1F;
    func_1095.Execute(  );

    // [320] Function call CfAddition
    func_320.input[0] = func_308.output[0];
    func_320.input[1] = 1F;
    func_320.Execute(  );

    // [321] Function call CfInputMultiplexer
    func_321.inputSelect = BooleanToInt(func_317.outputAND);
    func_321.input[1-1] = func_308.output[0];
    func_321.input[2-1] = func_1095.output;
    func_321.Execute(  );

    // [323] Function call CfInputMultiplexer
    func_323.inputSelect = BooleanToInt(func_318.outputAND);
    func_323.input[1-1] = func_321.output;
    func_323.input[2-1] = func_320.output;
    func_323.Execute(  );

    // [324] Function call CfIdt
    func_324.input = BooleanToFloat(func_68.outputAND);
    func_324.Execute(  );

    // [326] Function call CfIdt
    func_326.input = register_109;
    func_326.Execute(  );

    // [327] Function call CfInputMultiplexer
    func_327.inputSelect = FloatToInt(func_324.output[0]);
    func_327.input[1-1] = func_324.output[0];
    func_327.input[2-1] = func_323.output;
    func_327.Execute(  );

    // [330] Function call CfIdt
    func_330.input = func_327.output;
    func_330.Execute(  );
    register_109 = func_330.output[0];

    // [331] Function call CfCompare1
    func_331.inputA = func_327.output;
    func_331.inputB = func_326.output[0];
    func_331.Execute(  );

    // [333] Function call CfCompare1
    func_333.inputA = func_326.output[0];
    func_333.inputB = func_327.output;
    func_333.Execute(  );

    // [336] Function call CfIdt
    func_336.input = func_27.output[0];
    func_336.Execute(  );

    // [341] Function call CfOr
    func_341.input[0] = FloatToBoolean(func_336.output[0]);
    func_341.input[1] = func_333.outputLess;
    func_341.Execute(  );

    // [343] Function call CfOr
    func_343.input[0] = func_331.outputLess;
    func_343.input[1] = func_333.outputLess;
    func_343.Execute(  );

    // [1093] Function call CfNot
    func_1093.input = FloatToBoolean(func_75.output[0]);
    func_1093.Execute(  );

    // [345] Function call CfAnd
    func_345.input[0] = func_341.outputOR;
    func_345.input[1] = func_1093.output;
    func_345.Execute(  );

    // [346] Function call CfIdt
    func_346.input = BooleanToFloat(func_375.output);
    func_346.Execute(  );

    // [347] Function call CfIdt
    func_347.input = BooleanToFloat(func_343.outputOR);
    func_347.Execute(  );

    // [348] Function call CfIdt
    func_348.input = BooleanToFloat(func_376.output);
    func_348.Execute(  );

    // [350] Function call CfRound
    func_350.input = BooleanToFloat(func_345.outputAND);
    func_350.Execute(  );

    // [351] Function call CfSubtract
    func_351.input[0] = 1F;
    func_351.input[1] = BooleanToFloat(func_345.outputAND);
    func_351.Execute(  );

    // [352] Function call CfRound
    func_352.input = func_346.output[0];
    func_352.Execute(  );

    // [353] Function call CfSubtract
    func_353.input[0] = 1F;
    func_353.input[1] = func_346.output[0];
    func_353.Execute(  );

    // [355] Function call CfSubtract
    func_355.input[0] = 1F;
    func_355.input[1] = BooleanToFloat(func_331.outputLess);
    func_355.Execute(  );

    // [356] Function call CfRound
    func_356.input = func_348.output[0];
    func_356.Execute(  );

    // [357] Function call CfSubtract
    func_357.input[0] = 1F;
    func_357.input[1] = func_348.output[0];
    func_357.Execute(  );

    // [359] Function call CfAnd
    func_359.input[0] = FloatToBoolean(func_350.output);
    func_359.input[1] = FloatToBoolean(func_353.output);
    func_359.Execute(  );

    // [360] Function call CfAnd
    func_360.input[0] = FloatToBoolean(func_351.output);
    func_360.input[1] = FloatToBoolean(func_352.output);
    func_360.Execute(  );

    // [361] Function call CfAnd
    func_361.input[0] = func_331.outputLess;
    func_361.input[1] = FloatToBoolean(func_357.output);
    func_361.Execute(  );

    // [362] Function call CfAnd
    func_362.input[0] = FloatToBoolean(func_355.output);
    func_362.input[1] = FloatToBoolean(func_356.output);
    func_362.Execute(  );

    // [364] Function call CfIdt
    func_364.input = (float) getCmLCA_LoadCalc_parameter_18();
    func_364.Execute(  );
    setParameter(7, func_364.output[0]);

    // [365] Function call CfDelay
    func_365.inputA = func_360.outputAND;
    func_365.inputB = func_360.outputAND;
    func_365.Execute( this, 7 );

    // [366] Function call CfIdt
    func_366.input = func_75.output[0];
    func_366.Execute(  );

    // [367] Function call CfIdt
    func_367.input = (float) getCmLCA_LoadCalc_parameter_19();
    func_367.Execute(  );
    setParameter(8, func_367.output[0]);

    // [368] Function call CfDelay
    func_368.inputA = func_362.outputAND;
    func_368.inputB = func_362.outputAND;
    func_368.Execute( this, 8 );

    // [370] Function call CfIdt
    func_370.input = func_27.output[0];
    func_370.Execute(  );

    // [372] Function call CfOr
    func_372.input[0] = func_365.outputDelayedA;
    func_372.input[1] = FloatToBoolean(func_366.output[0]);
    func_372.input[2] = ControlFunction.GetStartupFlag();
    func_372.Execute(  );

    // [373] Function call CfOr
    func_373.input[0] = func_368.outputDelayedA;
    func_373.input[1] = ControlFunction.GetStartupFlag();
    func_373.input[2] = FloatToBoolean(func_370.output[0]);
    func_373.Execute(  );

    // [375] Function call CfRsFlipFlop
    func_375.inputSet = func_359.outputAND;
    func_375.inputReset = func_372.outputOR;
    func_375.Execute(  );

    // [376] Function call CfRsFlipFlop
    func_376.inputSet = func_361.outputAND;
    func_376.inputReset = func_373.outputOR;
    func_376.Execute(  );

    // [382] Function call CfIdt
    func_382.input = register_109;
    func_382.Execute(  );

    // [384] Function call CfSubtract
    func_384.input[0] = func_382.output[0];
    func_384.input[1] = (float) getCmLCA_LoadCalc_parameter_16();
    func_384.Execute(  );

    // [385] Function call CfIdt
    func_385.input = func_76.output[0];
    func_385.Execute(  );

    // [387] Function call CfInputMultiplexer
    func_387.inputSelect = FloatToInt(func_385.output[0]);
    func_387.input[1-1] = func_382.output[0];
    func_387.input[2-1] = func_384.output;
    func_387.Execute(  );

    // [389] Function call CfMinimum
    func_389.input[0] = func_387.output;
    func_389.input[1] = (float) getCmLCA_LoadCalc_parameter_15();
    func_389.Execute(  );

    // [390] Function call CfIdt
    func_390.input = func_27.output[0];
    func_390.Execute(  );

    // [392] Function call CfInputMultiplexer
    func_392.inputSelect = FloatToInt(func_390.output[0]);
    func_392.input[1-1] = func_387.output;
    func_392.input[2-1] = func_389.output;
    func_392.Execute(  );

    // [394] Function call CfMinimum
    func_394.input[0] = func_392.output;
    func_394.input[1] = (float) getCmLCA_LoadCalc_parameter_17();
    func_394.Execute(  );

    // [396] Function call CfMaximum
    func_396.input[0] = func_394.output;
    func_396.input[1] = 0F;
    func_396.Execute(  );

    // [397] Function call CfIdt
    func_397.input = BooleanToFloat(func_68.outputAND);
    func_397.Execute(  );

    // [399] Function call CfInputMultiplexer
    func_399.inputSelect = FloatToInt(func_397.output[0]);
    func_399.input[1-1] = func_397.output[0];
    func_399.input[2-1] = func_396.output;
    func_399.Execute(  );

    // [402] Function call CfIdt
    func_402.input = func_399.output;
    func_402.Execute(  );
    register_109 = func_402.output[0];

    // [405] Function call CfIdt
    func_405.input = func_399.output;
    func_405.Execute(  );
    setCmLCA_LoadCalc_output_9(func_405.output[0]);

    // [907] Function call CfIdt
    func_907.input = func_399.output;
    func_907.Execute(  );

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    3F, 0F, 1000F, 100F, 0F, 1200F, 600F, 1200F,
    600F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  protected float register_109 = 0;
  // macro outputs
// Req_Loads
  public static final Property CmLCA_LoadCalc_output_9 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmLCA_LoadCalc_output_9() { return (BStatusNumeric) get(CmLCA_LoadCalc_output_9); }
  public void setCmLCA_LoadCalc_output_9(BStatusNumeric v) { set(CmLCA_LoadCalc_output_9,v,null); }
  public void setCmLCA_LoadCalc_output_9(float v) { getCmLCA_LoadCalc_output_9().setValue(v); }

  // macro parameter
// SRT-01: P-band SRT Control
  public static final Property CmLCA_LoadCalc_parameter_11 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0.1)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmLCA_LoadCalc_parameter_11() { return getDouble(CmLCA_LoadCalc_parameter_11); }
  public void setCmLCA_LoadCalc_parameter_11(double v) { setDouble(CmLCA_LoadCalc_parameter_11,v,null); }
// SRT-02: I-time SRT Control; 0 = disable
  public static final Property CmLCA_LoadCalc_parameter_12 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmLCA_LoadCalc_parameter_12() { return getDouble(CmLCA_LoadCalc_parameter_12); }
  public void setCmLCA_LoadCalc_parameter_12(double v) { setDouble(CmLCA_LoadCalc_parameter_12,v,null); }
// ACP-01: high limit increase chillers
  public static final Property CmLCA_LoadCalc_parameter_13 = newProperty( 0, BDouble.make( 80 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmLCA_LoadCalc_parameter_13() { return getDouble(CmLCA_LoadCalc_parameter_13); }
  public void setCmLCA_LoadCalc_parameter_13(double v) { setDouble(CmLCA_LoadCalc_parameter_13,v,null); }
// ACP-02: low limit decrease chillers
  public static final Property CmLCA_LoadCalc_parameter_14 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmLCA_LoadCalc_parameter_14() { return getDouble(CmLCA_LoadCalc_parameter_14); }
  public void setCmLCA_LoadCalc_parameter_14(double v) { setDouble(CmLCA_LoadCalc_parameter_14,v,null); }
// PDO-01: max number of chillers
  public static final Property CmLCA_LoadCalc_parameter_15 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmLCA_LoadCalc_parameter_15() { return getDouble(CmLCA_LoadCalc_parameter_15); }
  public void setCmLCA_LoadCalc_parameter_15(double v) { setDouble(CmLCA_LoadCalc_parameter_15,v,null); }
// PDO-02: decrease number of chillers
  public static final Property CmLCA_LoadCalc_parameter_16 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmLCA_LoadCalc_parameter_16() { return getDouble(CmLCA_LoadCalc_parameter_16); }
  public void setCmLCA_LoadCalc_parameter_16(double v) { setDouble(CmLCA_LoadCalc_parameter_16,v,null); }
// SYS-01: number of chillers
  public static final Property CmLCA_LoadCalc_parameter_17 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmLCA_LoadCalc_parameter_17() { return getDouble(CmLCA_LoadCalc_parameter_17); }
  public void setCmLCA_LoadCalc_parameter_17(double v) { setDouble(CmLCA_LoadCalc_parameter_17,v,null); }
// SYS-02: increase delay
  public static final Property CmLCA_LoadCalc_parameter_18 = newProperty( 0, BDouble.make( 1200 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(65000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmLCA_LoadCalc_parameter_18() { return getDouble(CmLCA_LoadCalc_parameter_18); }
  public void setCmLCA_LoadCalc_parameter_18(double v) { setDouble(CmLCA_LoadCalc_parameter_18,v,null); }
// SYS-03: decrease delay
  public static final Property CmLCA_LoadCalc_parameter_19 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(65000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmLCA_LoadCalc_parameter_19() { return getDouble(CmLCA_LoadCalc_parameter_19); }
  public void setCmLCA_LoadCalc_parameter_19(double v) { setDouble(CmLCA_LoadCalc_parameter_19,v,null); }
// SYS-04: calculation method
  public static final Property CmLCA_LoadCalc_parameter_20 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmLCA_LoadCalc_parameter_20() { return getDouble(CmLCA_LoadCalc_parameter_20); }
  public void setCmLCA_LoadCalc_parameter_20(double v) { setDouble(CmLCA_LoadCalc_parameter_20,v,null); }
// SYS-05: input signal for number of loads
  public static final Property CmLCA_LoadCalc_parameter_21 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmLCA_LoadCalc_parameter_21() { return getDouble(CmLCA_LoadCalc_parameter_21); }
  public void setCmLCA_LoadCalc_parameter_21(double v) { setDouble(CmLCA_LoadCalc_parameter_21,v,null); }

  // macro inputs
// SysSupplyTemp
  public static final Property CmLCA_LoadCalc_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmLCA_LoadCalc_input_1() { return (BStatusNumeric) get(CmLCA_LoadCalc_input_1); }
  public void setCmLCA_LoadCalc_input_1(BStatusNumeric v) { set(CmLCA_LoadCalc_input_1,v,null); }
  public void setCmLCA_LoadCalc_input_1(float v) { getCmLCA_LoadCalc_input_1().setValue(v); }
// SysSupplyTempSp
  public static final Property CmLCA_LoadCalc_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmLCA_LoadCalc_input_7() { return (BStatusNumeric) get(CmLCA_LoadCalc_input_7); }
  public void setCmLCA_LoadCalc_input_7(BStatusNumeric v) { set(CmLCA_LoadCalc_input_7,v,null); }
  public void setCmLCA_LoadCalc_input_7(float v) { getCmLCA_LoadCalc_input_7().setValue(v); }
// SysReturnTemp
  public static final Property CmLCA_LoadCalc_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmLCA_LoadCalc_input_2() { return (BStatusNumeric) get(CmLCA_LoadCalc_input_2); }
  public void setCmLCA_LoadCalc_input_2(BStatusNumeric v) { set(CmLCA_LoadCalc_input_2,v,null); }
  public void setCmLCA_LoadCalc_input_2(float v) { getCmLCA_LoadCalc_input_2().setValue(v); }
// SysReturnTempSp
  public static final Property CmLCA_LoadCalc_input_8 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmLCA_LoadCalc_input_8() { return (BStatusNumeric) get(CmLCA_LoadCalc_input_8); }
  public void setCmLCA_LoadCalc_input_8(BStatusNumeric v) { set(CmLCA_LoadCalc_input_8,v,null); }
  public void setCmLCA_LoadCalc_input_8(float v) { getCmLCA_LoadCalc_input_8().setValue(v); }
// AvgCap
  public static final Property CmLCA_LoadCalc_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmLCA_LoadCalc_input_3() { return (BStatusNumeric) get(CmLCA_LoadCalc_input_3); }
  public void setCmLCA_LoadCalc_input_3(BStatusNumeric v) { set(CmLCA_LoadCalc_input_3,v,null); }
  public void setCmLCA_LoadCalc_input_3(float v) { getCmLCA_LoadCalc_input_3().setValue(v); }
// Req_Load
  public static final Property CmLCA_LoadCalc_input_4 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmLCA_LoadCalc_input_4() { return (BStatusNumeric) get(CmLCA_LoadCalc_input_4); }
  public void setCmLCA_LoadCalc_input_4(BStatusNumeric v) { set(CmLCA_LoadCalc_input_4,v,null); }
  public void setCmLCA_LoadCalc_input_4(float v) { getCmLCA_LoadCalc_input_4().setValue(v); }
// PowerDemandOff
  public static final Property CmLCA_LoadCalc_input_5 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmLCA_LoadCalc_input_5() { return (BStatusBoolean) get(CmLCA_LoadCalc_input_5); }
  public void setCmLCA_LoadCalc_input_5(BStatusBoolean v) { set(CmLCA_LoadCalc_input_5,v,null); }
  public void setCmLCA_LoadCalc_input_5(boolean v) { getCmLCA_LoadCalc_input_5().setValue(v); }
// Enable
  public static final Property CmLCA_LoadCalc_input_6 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmLCA_LoadCalc_input_6() { return (BStatusBoolean) get(CmLCA_LoadCalc_input_6); }
  public void setCmLCA_LoadCalc_input_6(BStatusBoolean v) { set(CmLCA_LoadCalc_input_6,v,null); }
  public void setCmLCA_LoadCalc_input_6(boolean v) { getCmLCA_LoadCalc_input_6().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.01 [19] 25.05.2016-11:57").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6238454963533513176").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmLCA_LoadCalc.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfCompare2 func_909 = new CfCompare2();
  protected CfCompare2 func_910 = new CfCompare2();
  protected CfIdt func_26 = new CfIdt();
  protected CfNot func_906 = new CfNot();
  protected CfIdt func_27 = new CfIdt();
  protected CfAnd func_68 = new CfAnd();
  protected CfCompare2 func_912 = new CfCompare2();
  protected CfCompare2 func_913 = new CfCompare2();
  protected CfIdt func_41 = new CfIdt();
  protected CfIdt func_42 = new CfIdt();
  protected CfIdt func_43 = new CfIdt();
  protected CfIdt func_55 = new CfIdt();
  protected CfRound func_56 = new CfRound();
  protected CfSubtract func_57 = new CfSubtract();
  protected CfRound func_58 = new CfRound();
  protected CfSubtract func_59 = new CfSubtract();
  protected CfAddition func_60 = new CfAddition();
  protected CfSubtract func_61 = new CfSubtract();
  protected CfMaximum func_62 = new CfMaximum();
  protected CfAnd func_69 = new CfAnd();
  protected CfAnd func_70 = new CfAnd();
  protected CfDivide func_71 = new CfDivide();
  protected CfDivide func_72 = new CfDivide();
  protected CfIdt func_75 = new CfIdt();
  protected CfIdt func_76 = new CfIdt();
  protected CfMultiply func_77 = new CfMultiply();
  protected CfMultiply func_78 = new CfMultiply();
  protected CfIdt func_81 = new CfIdt();
  protected CfIdt func_82 = new CfIdt();
  protected CfNot func_1040 = new CfNot();
  protected CfAnd func_1079 = new CfAnd();
  protected CmLoadCalc_NLoad func_1034 = new CmLoadCalc_NLoad();
  protected CfAnd func_1089 = new CfAnd();
  protected CmLoadCalc_PI_control func_1087 = new CmLoadCalc_PI_control();
  protected CfIdt func_282 = new CfIdt();
  protected CfIdt func_283 = new CfIdt();
  protected CfIdt func_284 = new CfIdt();
  protected CfIdt func_285 = new CfIdt();
  protected CfIdt func_286 = new CfIdt();
  protected CfIdt func_287 = new CfIdt();
  protected CfInputMultiplexer func_289 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_290 = new CfInputMultiplexer();
  protected CfIdt func_291 = new CfIdt();
  protected CfInputMultiplexer func_293 = new CfInputMultiplexer();
  protected CfIdt func_294 = new CfIdt();
  protected CfIdt func_296 = new CfIdt();
  protected CfCompare1 func_297 = new CfCompare1();
  protected CfCompare1 func_299 = new CfCompare1();
  protected CfCompare1 func_302 = new CfCompare1();
  protected CfCompare1 func_304 = new CfCompare1();
  protected CfIdt func_308 = new CfIdt();
  protected CfNot func_1090 = new CfNot();
  protected CfAnd func_317 = new CfAnd();
  protected CfNot func_1091 = new CfNot();
  protected CfAnd func_318 = new CfAnd();
  protected CfSubtract func_1095 = new CfSubtract();
  protected CfAddition func_320 = new CfAddition();
  protected CfInputMultiplexer func_321 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_323 = new CfInputMultiplexer();
  protected CfIdt func_324 = new CfIdt();
  protected CfIdt func_326 = new CfIdt();
  protected CfInputMultiplexer func_327 = new CfInputMultiplexer();
  protected CfIdt func_330 = new CfIdt();
  protected CfCompare1 func_331 = new CfCompare1();
  protected CfCompare1 func_333 = new CfCompare1();
  protected CfIdt func_336 = new CfIdt();
  protected CfOr func_341 = new CfOr();
  protected CfOr func_343 = new CfOr();
  protected CfNot func_1093 = new CfNot();
  protected CfAnd func_345 = new CfAnd();
  protected CfIdt func_346 = new CfIdt();
  protected CfIdt func_347 = new CfIdt();
  protected CfIdt func_348 = new CfIdt();
  protected CfRound func_350 = new CfRound();
  protected CfSubtract func_351 = new CfSubtract();
  protected CfRound func_352 = new CfRound();
  protected CfSubtract func_353 = new CfSubtract();
  protected CfSubtract func_355 = new CfSubtract();
  protected CfRound func_356 = new CfRound();
  protected CfSubtract func_357 = new CfSubtract();
  protected CfAnd func_359 = new CfAnd();
  protected CfAnd func_360 = new CfAnd();
  protected CfAnd func_361 = new CfAnd();
  protected CfAnd func_362 = new CfAnd();
  protected CfIdt func_364 = new CfIdt();
  protected CfDelay func_365 = new CfDelay();
  protected CfIdt func_366 = new CfIdt();
  protected CfIdt func_367 = new CfIdt();
  protected CfDelay func_368 = new CfDelay();
  protected CfIdt func_370 = new CfIdt();
  protected CfOr func_372 = new CfOr();
  protected CfOr func_373 = new CfOr();
  protected CfRsFlipFlop func_375 = new CfRsFlipFlop();
  protected CfRsFlipFlop func_376 = new CfRsFlipFlop();
  protected CfIdt func_382 = new CfIdt();
  protected CfSubtract func_384 = new CfSubtract();
  protected CfIdt func_385 = new CfIdt();
  protected CfInputMultiplexer func_387 = new CfInputMultiplexer();
  protected CfMinimum func_389 = new CfMinimum();
  protected CfIdt func_390 = new CfIdt();
  protected CfInputMultiplexer func_392 = new CfInputMultiplexer();
  protected CfMinimum func_394 = new CfMinimum();
  protected CfMaximum func_396 = new CfMaximum();
  protected CfIdt func_397 = new CfIdt();
  protected CfInputMultiplexer func_399 = new CfInputMultiplexer();
  protected CfIdt func_402 = new CfIdt();
  protected CfIdt func_405 = new CfIdt();
  protected CfIdt func_907 = new CfIdt();

  // default constructor
  public BCmLCA_LoadCalc()
  {
    func_289.configure(4);
    func_290.configure(4);
    func_317.configure(3);
    func_318.configure(3);
    func_372.configure(3);
    func_373.configure(3);
  }

  public void Start()
  {
    func_1034.Start();
    func_1087.Start();
    func_365.Start();
    func_368.Start();
    func_375.Start();
    func_376.Start();
  }
}
