/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:27
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.chiller;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    SQB_ChillSeqAddOn
Macro id:      6238453967094808613
Macro version: 56
Last change:   04.08.2016 - 08:02
Access Level:  2
Inputs:
  [1] Load1_Status
  [2] Load1_Alarm
  [3] Load2_Status
  [4] Load2_Alarm
  [5] Load3_Status
  [6] Load3_Alarm
  [7] CommInput
  [8] Reset
Outputs:
  [1] Load1Cmd
  [2] Load2Cmd
  [3] Load3Cmd
  [4] CommOutput
  [5] Load1_AlarmOut
  [6] Load2_AlarmOut
  [7] Load3_AlarmOut
Parameter:
  [1] SYS-01: module number
  [2] ALM-01: alarm delay load1
  [3] ALM-02: alarm delay load2
  [4] ALM-03: alarm delay load3
  [5] ALM-04: manual/ auto reset
Description:
The macro SQB_ChillSeqAddOn is an add-on module for the main 
sequencer module. The add-on module is able to control three additional loads.
================================================================================*/

public class BCmSQB_ChillSeqAddOn
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmSQB_ChillSeqAddOn_output_6().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmSQB_ChillSeqAddOn_output_6().setStatus(BStatus.disabled);
    getCmSQB_ChillSeqAddOn_output_7().setStatus(BStatus.disabled);
    getCmSQB_ChillSeqAddOn_output_8().setStatus(BStatus.disabled);
    getCmSQB_ChillSeqAddOn_output_9().setStatus(BStatus.disabled);
    getCmSQB_ChillSeqAddOn_output_1497().setStatus(BStatus.disabled);
    getCmSQB_ChillSeqAddOn_output_1498().setStatus(BStatus.disabled);
    getCmSQB_ChillSeqAddOn_output_1499().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmSQB_ChillSeqAddOn_output_6().setStatus(BStatus.ok);
    getCmSQB_ChillSeqAddOn_output_7().setStatus(BStatus.ok);
    getCmSQB_ChillSeqAddOn_output_8().setStatus(BStatus.ok);
    getCmSQB_ChillSeqAddOn_output_9().setStatus(BStatus.ok);
    getCmSQB_ChillSeqAddOn_output_1497().setStatus(BStatus.ok);
    getCmSQB_ChillSeqAddOn_output_1498().setStatus(BStatus.ok);
    getCmSQB_ChillSeqAddOn_output_1499().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [44] Function call CfSplit
    func_44.input = FloatToInt((float) getCmSQB_ChillSeqAddOn_input_4().getValue());
    func_44.Execute( this, 0 );

    // [47] Function call CfIdt
    func_47.input = IntToFloat(func_44.output[0]);
    func_47.Execute(  );

    // [48] Function call CfMultiply
    func_48.input[0] = 10F;
    func_48.input[1] = IntToFloat(func_44.output[2]);
    func_48.Execute(  );

    // [49] Function call CfIdt
    func_49.input = IntToFloat(func_44.output[3]);
    func_49.Execute(  );

    // [51] Function call CfAddition
    func_51.input[0] = IntToFloat(func_44.output[1]);
    func_51.input[1] = func_48.output;
    func_51.Execute(  );

    // [1233] Macro call CmFlank_Pulse
    func_1233.CmFlank_Pulse_input_10 = getCmSQB_ChillSeqAddOn_input_5().getValue();
    func_1233.Execute(  );

    // [1249] Macro call CmAlarm_LD
    func_1249.CmAlarm_LD_input_2 = FloatToBoolean((float) getCmSQB_ChillSeqAddOn_parameter_15());
    func_1249.CmAlarm_LD_input_3 = FloatToBoolean(func_177.output[0]);
    func_1249.CmAlarm_LD_input_91 = getCmSQB_ChillSeqAddOn_input_1().getValue();
    func_1249.CmAlarm_LD_input_121 = getCmSQB_ChillSeqAddOn_input_1494().getValue();
    func_1249.CmAlarm_LD_input_104 = getCmSQB_ChillSeqAddOn_output_6().getValue();
    func_1249.CmAlarm_LD_input_122 = (float) getCmSQB_ChillSeqAddOn_parameter_12();
    func_1249.CmAlarm_LD_input_1 = func_1233.CmFlank_Pulse_output_11;
    func_1249.CmAlarm_LD_input_105 = false;
    func_1249.Execute( this, 4 );

    // [177] Function call CfIdt
    func_177.input = BooleanToFloat(func_1249.CmAlarm_LD_output_4);
    func_177.Execute(  );

    // [1525] Function call CfIdt
    func_1525.input = BooleanToFloat(func_1249.CmAlarm_LD_output_4);
    func_1525.Execute(  );
    setCmSQB_ChillSeqAddOn_output_1497(FloatToBoolean(func_1525.output[0]));

    // [1252] Macro call CmAlarm_LD
    func_1252.CmAlarm_LD_input_2 = FloatToBoolean((float) getCmSQB_ChillSeqAddOn_parameter_15());
    func_1252.CmAlarm_LD_input_3 = FloatToBoolean(func_179.output[0]);
    func_1252.CmAlarm_LD_input_91 = getCmSQB_ChillSeqAddOn_input_2().getValue();
    func_1252.CmAlarm_LD_input_121 = getCmSQB_ChillSeqAddOn_input_1495().getValue();
    func_1252.CmAlarm_LD_input_104 = getCmSQB_ChillSeqAddOn_output_7().getValue();
    func_1252.CmAlarm_LD_input_122 = (float) getCmSQB_ChillSeqAddOn_parameter_13();
    func_1252.CmAlarm_LD_input_1 = func_1233.CmFlank_Pulse_output_11;
    func_1252.CmAlarm_LD_input_105 = false;
    func_1252.Execute( this, 5 );

    // [179] Function call CfIdt
    func_179.input = BooleanToFloat(func_1252.CmAlarm_LD_output_4);
    func_179.Execute(  );

    // [1526] Function call CfIdt
    func_1526.input = BooleanToFloat(func_1252.CmAlarm_LD_output_4);
    func_1526.Execute(  );
    setCmSQB_ChillSeqAddOn_output_1498(FloatToBoolean(func_1526.output[0]));

    // [1254] Macro call CmAlarm_LD
    func_1254.CmAlarm_LD_input_2 = FloatToBoolean((float) getCmSQB_ChillSeqAddOn_parameter_15());
    func_1254.CmAlarm_LD_input_3 = FloatToBoolean(func_181.output[0]);
    func_1254.CmAlarm_LD_input_91 = getCmSQB_ChillSeqAddOn_input_3().getValue();
    func_1254.CmAlarm_LD_input_121 = getCmSQB_ChillSeqAddOn_input_1496().getValue();
    func_1254.CmAlarm_LD_input_104 = getCmSQB_ChillSeqAddOn_output_8().getValue();
    func_1254.CmAlarm_LD_input_122 = (float) getCmSQB_ChillSeqAddOn_parameter_14();
    func_1254.CmAlarm_LD_input_1 = func_1233.CmFlank_Pulse_output_11;
    func_1254.CmAlarm_LD_input_105 = false;
    func_1254.Execute( this, 6 );

    // [181] Function call CfIdt
    func_181.input = BooleanToFloat(func_1254.CmAlarm_LD_output_4);
    func_181.Execute(  );

    // [1527] Function call CfIdt
    func_1527.input = BooleanToFloat(func_1254.CmAlarm_LD_output_4);
    func_1527.Execute(  );
    setCmSQB_ChillSeqAddOn_output_1499(FloatToBoolean(func_1527.output[0]));

    // [1442] Macro call CmLD_Cmd
    func_1442.CmLD_Cmd_input_1 = func_47.output[0];
    func_1442.CmLD_Cmd_input_2 = (float) getCmSQB_ChillSeqAddOn_parameter_11();
    func_1442.CmLD_Cmd_input_3 = func_51.output;
    func_1442.CmLD_Cmd_input_4 = func_49.output[0];
    func_1442.CmLD_Cmd_input_5 = FloatToBoolean(func_177.output[0]);
    func_1442.CmLD_Cmd_input_84 = 1F;
    func_1442.Execute(  );
    setCmSQB_ChillSeqAddOn_output_6(func_1442.CmLD_Cmd_output_7);

    // [1445] Macro call CmLD_Cmd
    func_1445.CmLD_Cmd_input_1 = func_47.output[0];
    func_1445.CmLD_Cmd_input_2 = (float) getCmSQB_ChillSeqAddOn_parameter_11();
    func_1445.CmLD_Cmd_input_3 = func_51.output;
    func_1445.CmLD_Cmd_input_4 = func_49.output[0];
    func_1445.CmLD_Cmd_input_5 = FloatToBoolean(func_181.output[0]);
    func_1445.CmLD_Cmd_input_84 = 3F;
    func_1445.Execute(  );
    setCmSQB_ChillSeqAddOn_output_8(func_1445.CmLD_Cmd_output_7);

    // [1444] Macro call CmLD_Cmd
    func_1444.CmLD_Cmd_input_1 = func_47.output[0];
    func_1444.CmLD_Cmd_input_2 = (float) getCmSQB_ChillSeqAddOn_parameter_11();
    func_1444.CmLD_Cmd_input_3 = func_51.output;
    func_1444.CmLD_Cmd_input_4 = func_49.output[0];
    func_1444.CmLD_Cmd_input_5 = FloatToBoolean(func_179.output[0]);
    func_1444.CmLD_Cmd_input_84 = 2F;
    func_1444.Execute(  );
    setCmSQB_ChillSeqAddOn_output_7(func_1444.CmLD_Cmd_output_7);

    // [1437] Macro call CmLD_RTIncr
    func_1437.CmLD_RTIncr_input_1 = func_1394.CmRuntime_LD_output_3;
    func_1437.CmLD_RTIncr_input_2 = func_1472.CmCommSignal_COU_output_6;
    func_1437.Execute(  );

    // [1439] Macro call CmLD_RTIncr
    func_1439.CmLD_RTIncr_input_1 = func_1393.CmRuntime_LD_output_3;
    func_1439.CmLD_RTIncr_input_2 = func_1471.CmCommSignal_COU_output_6;
    func_1439.Execute(  );

    // [1440] Macro call CmLD_RTIncr
    func_1440.CmLD_RTIncr_input_1 = func_1391.CmRuntime_LD_output_3;
    func_1440.CmLD_RTIncr_input_2 = func_1470.CmCommSignal_COU_output_6;
    func_1440.Execute(  );

    // [1433] Macro call CmSendflag
    func_1433.CmSendflag_input_1 = ControlFunction.GetStartupFlag();
    func_1433.CmSendflag_input_2 = FloatToBoolean(func_177.output[0]);
    func_1433.CmSendflag_input_3 = func_1437.CmLD_RTIncr_output_3;
    func_1433.CmSendflag_input_17 = func_1472.CmCommSignal_COU_output_6;
    func_1433.Execute(  );

    // [1435] Macro call CmSendflag
    func_1435.CmSendflag_input_1 = ControlFunction.GetStartupFlag();
    func_1435.CmSendflag_input_2 = FloatToBoolean(func_179.output[0]);
    func_1435.CmSendflag_input_3 = func_1439.CmLD_RTIncr_output_3;
    func_1435.CmSendflag_input_17 = func_1471.CmCommSignal_COU_output_6;
    func_1435.Execute(  );

    // [1436] Macro call CmSendflag
    func_1436.CmSendflag_input_1 = ControlFunction.GetStartupFlag();
    func_1436.CmSendflag_input_2 = FloatToBoolean(func_181.output[0]);
    func_1436.CmSendflag_input_3 = func_1440.CmLD_RTIncr_output_3;
    func_1436.CmSendflag_input_17 = func_1470.CmCommSignal_COU_output_6;
    func_1436.Execute(  );

    // [365] Function call CfMultiply
    func_365.input[0] = (float) getCmSQB_ChillSeqAddOn_parameter_11();
    func_365.input[1] = 3F;
    func_365.Execute(  );

    // [367] Function call CfIdt
    func_367.input = func_51.output;
    func_367.Execute(  );

    // [368] Function call CfAddition
    func_368.input[0] = func_365.output;
    func_368.input[1] = 1F;
    func_368.Execute(  );

    // [369] Function call CfAddition
    func_369.input[0] = func_365.output;
    func_369.input[1] = 3F;
    func_369.Execute(  );

    // [1389] Function call CfCompare2
    func_1389.inputA = func_367.output[0];
    func_1389.inputB = func_368.output;
    func_1389.Execute(  );

    // [1390] Function call CfCompare2
    func_1390.inputA = func_369.output;
    func_1390.inputB = func_367.output[0];
    func_1390.Execute(  );

    // [377] Function call CfAnd
    func_377.input[0] = func_1389.outputEqualOrGreater;
    func_377.input[1] = func_1390.outputEqualOrGreater;
    func_377.Execute(  );

    // [379] Function call CfInputMultiplexer
    func_379.inputSelect = BooleanToInt(func_377.outputAND);
    func_379.input[1-1] = (float) getCmSQB_ChillSeqAddOn_input_4().getValue();
    func_379.input[2-1] = 0F;
    func_379.Execute(  );

    // [1472] Macro call CmCommSignal_COU
    func_1472.CmCommSignal_COU_input_1 = func_379.output;
    func_1472.CmCommSignal_COU_input_2 = func_1433.CmSendflag_output_4;
    func_1472.CmCommSignal_COU_input_3 = FloatToBoolean(func_177.output[0]);
    func_1472.CmCommSignal_COU_input_4 = func_1437.CmLD_RTIncr_output_3;
    func_1472.CmCommSignal_COU_input_5 = (float) getCmSQB_ChillSeqAddOn_parameter_11();
    func_1472.CmCommSignal_COU_input_29 = 1F;
    func_1472.Execute( this, 7 );

    // [1471] Macro call CmCommSignal_COU
    func_1471.CmCommSignal_COU_input_1 = func_1472.CmCommSignal_COU_output_7;
    func_1471.CmCommSignal_COU_input_2 = func_1435.CmSendflag_output_4;
    func_1471.CmCommSignal_COU_input_3 = FloatToBoolean(func_179.output[0]);
    func_1471.CmCommSignal_COU_input_4 = func_1439.CmLD_RTIncr_output_3;
    func_1471.CmCommSignal_COU_input_5 = (float) getCmSQB_ChillSeqAddOn_parameter_11();
    func_1471.CmCommSignal_COU_input_29 = 2F;
    func_1471.Execute( this, 12 );

    // [1470] Macro call CmCommSignal_COU
    func_1470.CmCommSignal_COU_input_1 = func_1471.CmCommSignal_COU_output_7;
    func_1470.CmCommSignal_COU_input_2 = func_1436.CmSendflag_output_4;
    func_1470.CmCommSignal_COU_input_3 = FloatToBoolean(func_181.output[0]);
    func_1470.CmCommSignal_COU_input_4 = func_1440.CmLD_RTIncr_output_3;
    func_1470.CmCommSignal_COU_input_5 = (float) getCmSQB_ChillSeqAddOn_parameter_11();
    func_1470.CmCommSignal_COU_input_29 = 3F;
    func_1470.Execute( this, 17 );
    setCmSQB_ChillSeqAddOn_output_9(func_1470.CmCommSignal_COU_output_7);

    // [454] Function call CfSubtract
    func_454.input[0] = func_1545.output[0];
    func_454.input[1] = IntToFloat(ControlFunction.GetMinuteAfterMidnight());
    func_454.Execute(  );

    // [1545] Function call CfIdt
    func_1545.input = IntToFloat(ControlFunction.GetMinuteAfterMidnight());
    func_1545.Execute(  );

    // [455] Function call CfAbsolute
    func_455.input = func_454.output;
    func_455.Execute(  );

    // [1490] Function call CfInputMultiplexer
    func_1490.inputSelect = 0;
    func_1490.input[1-1] = 60F;
    func_1490.input[2-1] = 3F;
    func_1490.Execute(  );

    // [1550] Function call CfLastValue
    func_1550.input = (float) getCmSQB_ChillSeqAddOn_parameter_11();
    func_1550.Execute(  );

    // [1552] Function call CfCompare1
    func_1552.inputA = func_1550.outputCurrent;
    func_1552.inputB = func_1550.outputLast;
    func_1552.Execute(  );

    // [1556] Function call CfNot
    func_1556.input = func_1552.outputEqual;
    func_1556.Execute(  );

    // [1394] Macro call CmRuntime_LD
    func_1394.CmRuntime_LD_input_1 = func_455.outputAbs;
    func_1394.CmRuntime_LD_input_2 = getCmSQB_ChillSeqAddOn_output_6().getValue();
    func_1394.CmRuntime_LD_input_44 = func_1490.output;
    func_1394.CmRuntime_LD_input_48 = func_1556.output;
    func_1394.Execute(  );

    // [1393] Macro call CmRuntime_LD
    func_1393.CmRuntime_LD_input_1 = func_455.outputAbs;
    func_1393.CmRuntime_LD_input_2 = getCmSQB_ChillSeqAddOn_output_7().getValue();
    func_1393.CmRuntime_LD_input_44 = func_1490.output;
    func_1393.CmRuntime_LD_input_48 = func_1556.output;
    func_1393.Execute(  );

    // [1391] Macro call CmRuntime_LD
    func_1391.CmRuntime_LD_input_1 = func_455.outputAbs;
    func_1391.CmRuntime_LD_input_2 = getCmSQB_ChillSeqAddOn_output_8().getValue();
    func_1391.CmRuntime_LD_input_44 = func_1490.output;
    func_1391.CmRuntime_LD_input_48 = func_1556.output;
    func_1391.Execute(  );

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    10F, 10F, 10F, 10F, 60F, 60F, 60F, 1F,
    10F, 100F, 10F, 2F, 1F, 10F, 100F, 10F,
    2F, 1F, 10F, 100F, 10F, 2F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// Load1Cmd
  public static final Property CmSQB_ChillSeqAddOn_output_6 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSQB_ChillSeqAddOn_output_6() { return (BStatusBoolean) get(CmSQB_ChillSeqAddOn_output_6); }
  public void setCmSQB_ChillSeqAddOn_output_6(BStatusBoolean v) { set(CmSQB_ChillSeqAddOn_output_6,v,null); }
  public void setCmSQB_ChillSeqAddOn_output_6(boolean v) { getCmSQB_ChillSeqAddOn_output_6().setValue(v); }
// Load2Cmd
  public static final Property CmSQB_ChillSeqAddOn_output_7 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSQB_ChillSeqAddOn_output_7() { return (BStatusBoolean) get(CmSQB_ChillSeqAddOn_output_7); }
  public void setCmSQB_ChillSeqAddOn_output_7(BStatusBoolean v) { set(CmSQB_ChillSeqAddOn_output_7,v,null); }
  public void setCmSQB_ChillSeqAddOn_output_7(boolean v) { getCmSQB_ChillSeqAddOn_output_7().setValue(v); }
// Load3Cmd
  public static final Property CmSQB_ChillSeqAddOn_output_8 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSQB_ChillSeqAddOn_output_8() { return (BStatusBoolean) get(CmSQB_ChillSeqAddOn_output_8); }
  public void setCmSQB_ChillSeqAddOn_output_8(BStatusBoolean v) { set(CmSQB_ChillSeqAddOn_output_8,v,null); }
  public void setCmSQB_ChillSeqAddOn_output_8(boolean v) { getCmSQB_ChillSeqAddOn_output_8().setValue(v); }
// CommOutput
  public static final Property CmSQB_ChillSeqAddOn_output_9 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSQB_ChillSeqAddOn_output_9() { return (BStatusNumeric) get(CmSQB_ChillSeqAddOn_output_9); }
  public void setCmSQB_ChillSeqAddOn_output_9(BStatusNumeric v) { set(CmSQB_ChillSeqAddOn_output_9,v,null); }
  public void setCmSQB_ChillSeqAddOn_output_9(float v) { getCmSQB_ChillSeqAddOn_output_9().setValue(v); }
// Load1_AlarmOut
  public static final Property CmSQB_ChillSeqAddOn_output_1497 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSQB_ChillSeqAddOn_output_1497() { return (BStatusBoolean) get(CmSQB_ChillSeqAddOn_output_1497); }
  public void setCmSQB_ChillSeqAddOn_output_1497(BStatusBoolean v) { set(CmSQB_ChillSeqAddOn_output_1497,v,null); }
  public void setCmSQB_ChillSeqAddOn_output_1497(boolean v) { getCmSQB_ChillSeqAddOn_output_1497().setValue(v); }
// Load2_AlarmOut
  public static final Property CmSQB_ChillSeqAddOn_output_1498 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSQB_ChillSeqAddOn_output_1498() { return (BStatusBoolean) get(CmSQB_ChillSeqAddOn_output_1498); }
  public void setCmSQB_ChillSeqAddOn_output_1498(BStatusBoolean v) { set(CmSQB_ChillSeqAddOn_output_1498,v,null); }
  public void setCmSQB_ChillSeqAddOn_output_1498(boolean v) { getCmSQB_ChillSeqAddOn_output_1498().setValue(v); }
// Load3_AlarmOut
  public static final Property CmSQB_ChillSeqAddOn_output_1499 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSQB_ChillSeqAddOn_output_1499() { return (BStatusBoolean) get(CmSQB_ChillSeqAddOn_output_1499); }
  public void setCmSQB_ChillSeqAddOn_output_1499(BStatusBoolean v) { set(CmSQB_ChillSeqAddOn_output_1499,v,null); }
  public void setCmSQB_ChillSeqAddOn_output_1499(boolean v) { getCmSQB_ChillSeqAddOn_output_1499().setValue(v); }

  // macro parameter
// SYS-01: module number
  public static final Property CmSQB_ChillSeqAddOn_parameter_11 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmSQB_ChillSeqAddOn_parameter_11() { return getDouble(CmSQB_ChillSeqAddOn_parameter_11); }
  public void setCmSQB_ChillSeqAddOn_parameter_11(double v) { setDouble(CmSQB_ChillSeqAddOn_parameter_11,v,null); }
// ALM-01: alarm delay load1
  public static final Property CmSQB_ChillSeqAddOn_parameter_12 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSQB_ChillSeqAddOn_parameter_12() { return getDouble(CmSQB_ChillSeqAddOn_parameter_12); }
  public void setCmSQB_ChillSeqAddOn_parameter_12(double v) { setDouble(CmSQB_ChillSeqAddOn_parameter_12,v,null); }
// ALM-02: alarm delay load2
  public static final Property CmSQB_ChillSeqAddOn_parameter_13 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSQB_ChillSeqAddOn_parameter_13() { return getDouble(CmSQB_ChillSeqAddOn_parameter_13); }
  public void setCmSQB_ChillSeqAddOn_parameter_13(double v) { setDouble(CmSQB_ChillSeqAddOn_parameter_13,v,null); }
// ALM-03: alarm delay load3
  public static final Property CmSQB_ChillSeqAddOn_parameter_14 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSQB_ChillSeqAddOn_parameter_14() { return getDouble(CmSQB_ChillSeqAddOn_parameter_14); }
  public void setCmSQB_ChillSeqAddOn_parameter_14(double v) { setDouble(CmSQB_ChillSeqAddOn_parameter_14,v,null); }
// ALM-04: manual/ auto reset
  public static final Property CmSQB_ChillSeqAddOn_parameter_15 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQB_ChillSeqAddOn_parameter_15() { return getDouble(CmSQB_ChillSeqAddOn_parameter_15); }
  public void setCmSQB_ChillSeqAddOn_parameter_15(double v) { setDouble(CmSQB_ChillSeqAddOn_parameter_15,v,null); }

  // macro inputs
// Load1_Status
  public static final Property CmSQB_ChillSeqAddOn_input_1 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmSQB_ChillSeqAddOn_input_1() { return (BStatusBoolean) get(CmSQB_ChillSeqAddOn_input_1); }
  public void setCmSQB_ChillSeqAddOn_input_1(BStatusBoolean v) { set(CmSQB_ChillSeqAddOn_input_1,v,null); }
  public void setCmSQB_ChillSeqAddOn_input_1(boolean v) { getCmSQB_ChillSeqAddOn_input_1().setValue(v); }
// Load1_Alarm
  public static final Property CmSQB_ChillSeqAddOn_input_1494 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmSQB_ChillSeqAddOn_input_1494() { return (BStatusBoolean) get(CmSQB_ChillSeqAddOn_input_1494); }
  public void setCmSQB_ChillSeqAddOn_input_1494(BStatusBoolean v) { set(CmSQB_ChillSeqAddOn_input_1494,v,null); }
  public void setCmSQB_ChillSeqAddOn_input_1494(boolean v) { getCmSQB_ChillSeqAddOn_input_1494().setValue(v); }
// Load2_Status
  public static final Property CmSQB_ChillSeqAddOn_input_2 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmSQB_ChillSeqAddOn_input_2() { return (BStatusBoolean) get(CmSQB_ChillSeqAddOn_input_2); }
  public void setCmSQB_ChillSeqAddOn_input_2(BStatusBoolean v) { set(CmSQB_ChillSeqAddOn_input_2,v,null); }
  public void setCmSQB_ChillSeqAddOn_input_2(boolean v) { getCmSQB_ChillSeqAddOn_input_2().setValue(v); }
// Load2_Alarm
  public static final Property CmSQB_ChillSeqAddOn_input_1495 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmSQB_ChillSeqAddOn_input_1495() { return (BStatusBoolean) get(CmSQB_ChillSeqAddOn_input_1495); }
  public void setCmSQB_ChillSeqAddOn_input_1495(BStatusBoolean v) { set(CmSQB_ChillSeqAddOn_input_1495,v,null); }
  public void setCmSQB_ChillSeqAddOn_input_1495(boolean v) { getCmSQB_ChillSeqAddOn_input_1495().setValue(v); }
// Load3_Status
  public static final Property CmSQB_ChillSeqAddOn_input_3 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmSQB_ChillSeqAddOn_input_3() { return (BStatusBoolean) get(CmSQB_ChillSeqAddOn_input_3); }
  public void setCmSQB_ChillSeqAddOn_input_3(BStatusBoolean v) { set(CmSQB_ChillSeqAddOn_input_3,v,null); }
  public void setCmSQB_ChillSeqAddOn_input_3(boolean v) { getCmSQB_ChillSeqAddOn_input_3().setValue(v); }
// Load3_Alarm
  public static final Property CmSQB_ChillSeqAddOn_input_1496 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmSQB_ChillSeqAddOn_input_1496() { return (BStatusBoolean) get(CmSQB_ChillSeqAddOn_input_1496); }
  public void setCmSQB_ChillSeqAddOn_input_1496(BStatusBoolean v) { set(CmSQB_ChillSeqAddOn_input_1496,v,null); }
  public void setCmSQB_ChillSeqAddOn_input_1496(boolean v) { getCmSQB_ChillSeqAddOn_input_1496().setValue(v); }
// CommInput
  public static final Property CmSQB_ChillSeqAddOn_input_4 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmSQB_ChillSeqAddOn_input_4() { return (BStatusNumeric) get(CmSQB_ChillSeqAddOn_input_4); }
  public void setCmSQB_ChillSeqAddOn_input_4(BStatusNumeric v) { set(CmSQB_ChillSeqAddOn_input_4,v,null); }
  public void setCmSQB_ChillSeqAddOn_input_4(float v) { getCmSQB_ChillSeqAddOn_input_4().setValue(v); }
// Reset
  public static final Property CmSQB_ChillSeqAddOn_input_5 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmSQB_ChillSeqAddOn_input_5() { return (BStatusBoolean) get(CmSQB_ChillSeqAddOn_input_5); }
  public void setCmSQB_ChillSeqAddOn_input_5(BStatusBoolean v) { set(CmSQB_ChillSeqAddOn_input_5,v,null); }
  public void setCmSQB_ChillSeqAddOn_input_5(boolean v) { getCmSQB_ChillSeqAddOn_input_5().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.01 [56] 04.08.2016-08:02").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6238453967094808613").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmSQB_ChillSeqAddOn.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private float   IntToFloat    (int     value) { return (float) value; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfSplit func_44 = new CfSplit();
  protected CfIdt func_47 = new CfIdt();
  protected CfMultiply func_48 = new CfMultiply();
  protected CfIdt func_49 = new CfIdt();
  protected CfAddition func_51 = new CfAddition();
  protected CmFlank_Pulse func_1233 = new CmFlank_Pulse();
  protected CmAlarm_LD func_1249 = new CmAlarm_LD();
  protected CfIdt func_177 = new CfIdt();
  protected CfIdt func_1525 = new CfIdt();
  protected CmAlarm_LD func_1252 = new CmAlarm_LD();
  protected CfIdt func_179 = new CfIdt();
  protected CfIdt func_1526 = new CfIdt();
  protected CmAlarm_LD func_1254 = new CmAlarm_LD();
  protected CfIdt func_181 = new CfIdt();
  protected CfIdt func_1527 = new CfIdt();
  protected CmLD_Cmd func_1442 = new CmLD_Cmd();
  protected CmLD_Cmd func_1445 = new CmLD_Cmd();
  protected CmLD_Cmd func_1444 = new CmLD_Cmd();
  protected CmLD_RTIncr func_1437 = new CmLD_RTIncr();
  protected CmLD_RTIncr func_1439 = new CmLD_RTIncr();
  protected CmLD_RTIncr func_1440 = new CmLD_RTIncr();
  protected CmSendflag func_1433 = new CmSendflag();
  protected CmSendflag func_1435 = new CmSendflag();
  protected CmSendflag func_1436 = new CmSendflag();
  protected CfMultiply func_365 = new CfMultiply();
  protected CfIdt func_367 = new CfIdt();
  protected CfAddition func_368 = new CfAddition();
  protected CfAddition func_369 = new CfAddition();
  protected CfCompare2 func_1389 = new CfCompare2();
  protected CfCompare2 func_1390 = new CfCompare2();
  protected CfAnd func_377 = new CfAnd();
  protected CfInputMultiplexer func_379 = new CfInputMultiplexer();
  protected CmCommSignal_COU func_1472 = new CmCommSignal_COU();
  protected CmCommSignal_COU func_1471 = new CmCommSignal_COU();
  protected CmCommSignal_COU func_1470 = new CmCommSignal_COU();
  protected CfSubtract func_454 = new CfSubtract();
  protected CfIdt func_1545 = new CfIdt();
  protected CfAbsolute func_455 = new CfAbsolute();
  protected CfInputMultiplexer func_1490 = new CfInputMultiplexer();
  protected CfLastValue func_1550 = new CfLastValue();
  protected CfCompare1 func_1552 = new CfCompare1();
  protected CfNot func_1556 = new CfNot();
  protected CmRuntime_LD func_1394 = new CmRuntime_LD();
  protected CmRuntime_LD func_1393 = new CmRuntime_LD();
  protected CmRuntime_LD func_1391 = new CmRuntime_LD();

  // default constructor
  public BCmSQB_ChillSeqAddOn()
  {
    func_44.configure(4);
  }

  public void Start()
  {
    func_1233.Start();
    func_1249.Start();
    func_1252.Start();
    func_1254.Start();
    func_1442.Start();
    func_1445.Start();
    func_1444.Start();
    func_1437.Start();
    func_1439.Start();
    func_1440.Start();
    func_1433.Start();
    func_1435.Start();
    func_1436.Start();
    func_1472.Start();
    func_1471.Start();
    func_1470.Start();
    func_1550.Start();
    func_1394.Start();
    func_1393.Start();
    func_1391.Start();
  }
}
