/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:27
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.chiller;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    WBA_WetBulbTemp
Macro id:      6238442895216476946
Macro version: 6
Last change:   20.04.2016 - 11:23
Access Level:  2
Inputs:
  [1] OATemp
  [2] OARelHum
Outputs:
  [1] WetBulbTemp
Parameter:
Description:
The outside air wet-bulb temperature is calculated by an 
approximation formula using the outside air dry-bulb 
temperature and the outside air relative humidity.

The absolute error in calculation is less than 1K.
================================================================================*/

public class BCmWBA_WetBulbTemp
  extends BControlFunctionSupport
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmWBA_WetBulbTemp_output_3().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmWBA_WetBulbTemp_output_3().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmWBA_WetBulbTemp_output_3().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [12] Function call CfMultiply
    func_12.input[0] = 0.042611F;
    func_12.input[1] = (float) getCmWBA_WetBulbTemp_input_2().getValue();
    func_12.Execute(  );

    // [13] Function call CfMultiply
    func_13.input[0] = (float) getCmWBA_WetBulbTemp_input_2().getValue();
    func_13.input[1] = 0.005F;
    func_13.input[2] = (float) getCmWBA_WetBulbTemp_input_1().getValue();
    func_13.Execute(  );

    // [14] Function call CfMultiply
    func_14.input[0] = (float) getCmWBA_WetBulbTemp_input_1().getValue();
    func_14.input[1] = 0.55F;
    func_14.Execute(  );

    // [15] Function call CfNegate
    func_15.input = 4.57444F;
    func_15.Execute(  );

    // [17] Function call CfAddition
    func_17.input[0] = func_12.output;
    func_17.input[1] = func_13.output;
    func_17.input[2] = func_14.output;
    func_17.input[3] = func_15.output;
    func_17.Execute(  );
    setCmWBA_WetBulbTemp_output_3(func_17.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// WetBulbTemp
  public static final Property CmWBA_WetBulbTemp_output_3 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmWBA_WetBulbTemp_output_3() { return (BStatusNumeric) get(CmWBA_WetBulbTemp_output_3); }
  public void setCmWBA_WetBulbTemp_output_3(BStatusNumeric v) { set(CmWBA_WetBulbTemp_output_3,v,null); }
  public void setCmWBA_WetBulbTemp_output_3(float v) { getCmWBA_WetBulbTemp_output_3().setValue(v); }

  // macro parameter

  // macro inputs
// OATemp
  public static final Property CmWBA_WetBulbTemp_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmWBA_WetBulbTemp_input_1() { return (BStatusNumeric) get(CmWBA_WetBulbTemp_input_1); }
  public void setCmWBA_WetBulbTemp_input_1(BStatusNumeric v) { set(CmWBA_WetBulbTemp_input_1,v,null); }
  public void setCmWBA_WetBulbTemp_input_1(float v) { getCmWBA_WetBulbTemp_input_1().setValue(v); }
// OARelHum
  public static final Property CmWBA_WetBulbTemp_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmWBA_WetBulbTemp_input_2() { return (BStatusNumeric) get(CmWBA_WetBulbTemp_input_2); }
  public void setCmWBA_WetBulbTemp_input_2(BStatusNumeric v) { set(CmWBA_WetBulbTemp_input_2,v,null); }
  public void setCmWBA_WetBulbTemp_input_2(float v) { getCmWBA_WetBulbTemp_input_2().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.01 [6] 20.04.2016-11:23").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6238442895216476946").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmWBA_WetBulbTemp.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions

  // class variables
  protected CfMultiply func_12 = new CfMultiply();
  protected CfMultiply func_13 = new CfMultiply();
  protected CfMultiply func_14 = new CfMultiply();
  protected CfNegate func_15 = new CfNegate();
  protected CfAddition func_17 = new CfAddition();

  // default constructor
  public BCmWBA_WetBulbTemp()
  {
    func_13.configure(3);
    func_17.configure(4);
  }

  public void Start()
  {
  }
}
