/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:24
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.energy_management;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    DDA_DEGDAYS
Macro id:      6033402344635367432
Macro version: 35
Last change:   14.01.2015 - 10:20
Access Level:  2
Inputs:
  [1] OATemp
Outputs:
  [1] HtgDegreeDays
  [2] DegreeDays
  [3] ClgDegreeDays
Parameter:
  [1] HDD-01: high limit heating degree days calculation
  [2] CDD-01: low limit cooling degree days calculation
  [3] RMT-01: room temperature setpoint
  [4] SYS-01: set consumption values; 1 = set
  [5] INI-01: initialize heating degree days
  [6] INI-02: initialize degree days
  [7] INI-03: initialize cooling degree days
Description:
The degree day macro calculates degree days for display and trending purposes. Degree days are commonly used for energy consumption calculations. The module produces heating degree days, degree days as well as cooling degree days.
The macro provides the cumulated degree days since start of the application.
The initial degree day can be set with parameters.
For display purposes the heating and cooling degree days for the actual and previous day, week and month can be calculated using TTA_Statistics macros.
================================================================================*/

public class BCmDDA_DEGDAYS
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmDDA_DEGDAYS_output_4().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmDDA_DEGDAYS_output_4().setStatus(BStatus.disabled);
    getCmDDA_DEGDAYS_output_478().setStatus(BStatus.disabled);
    getCmDDA_DEGDAYS_output_5().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmDDA_DEGDAYS_output_4().setStatus(BStatus.ok);
    getCmDDA_DEGDAYS_output_478().setStatus(BStatus.ok);
    getCmDDA_DEGDAYS_output_5().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [16] Function call CfIdt
    func_16.input = (float) getCmDDA_DEGDAYS_input_2().getValue();
    func_16.Execute(  );

    // [24] Function call CfSubtract
    func_24.input[0] = 1F;
    func_24.input[1] = func_24.output;
    func_24.Execute(  );

    // [387] Function call CfIdt
    func_387.input = (float) getCmDDA_DEGDAYS_parameter_9();
    func_387.Execute(  );

    // [57] Function call CfIdt
    func_57.input = IntToFloat(ControlFunction.GetHoursAndMinutes());
    func_57.Execute(  );

    // [59] Function call CfIdt
    func_59.input = IntToFloat(ControlFunction.GetWeekday());
    func_59.Execute(  );

    // [421] Function call CfIdt
    func_421.input = (float) getCmDDA_DEGDAYS_parameter_8();
    func_421.Execute(  );

    // [422] Function call CfIdt
    func_422.input = (float) getCmDDA_DEGDAYS_parameter_7();
    func_422.Execute(  );

    // [25] Function call CfDivide
    func_25.inputA = IntToFloat(ControlFunction.GetDayAndMonth());
    func_25.inputB = 100F;
    func_25.Execute(  );

    // [33] Function call CfDifferential
    func_33.input = func_24.output;
    func_33.Execute( this, 0 );

    // [34] Function call CfTruncate
    func_34.input = func_25.output;
    func_34.Execute(  );

    // [40] Function call CfAbsolute
    func_40.input = func_33.output;
    func_40.Execute(  );

    // [41] Function call CfMultiply
    func_41.input[0] = func_34.output;
    func_41.input[1] = 100F;
    func_41.Execute(  );

    // [44] Function call CfSubtract
    func_44.input[0] = func_387.output[0];
    func_44.input[1] = func_16.output[0];
    func_44.Execute(  );

    // [45] Function call CfAbsolute
    func_45.input = func_44.output;
    func_45.Execute(  );

    // [46] Function call CfDivide
    func_46.inputA = 1F;
    func_46.inputB = func_40.outputAbs;
    func_46.Execute(  );

    // [49] Function call CfSubtract
    func_49.input[0] = IntToFloat(ControlFunction.GetDayAndMonth());
    func_49.input[1] = func_41.output;
    func_49.Execute(  );

    // [54] Function call CfMultiply
    func_54.input[0] = func_45.outputAbs;
    func_54.input[1] = func_46.output;
    func_54.Execute(  );

    // [431] Function call CfDivide
    func_431.inputA = func_57.output[0];
    func_431.inputB = 100F;
    func_431.Execute(  );

    // [430] Function call CfTruncate
    func_430.input = func_431.output;
    func_430.Execute(  );

    // [449] Function call CfSubtract
    func_449.input[0] = func_422.output[0];
    func_449.input[1] = func_16.output[0];
    func_449.Execute(  );

    // [453] Function call CfSubtract
    func_453.input[0] = func_421.output[0];
    func_453.input[1] = func_16.output[0];
    func_453.Execute(  );

    // [432] Function call CfMultiply
    func_432.input[0] = func_430.output;
    func_432.input[1] = 100F;
    func_432.Execute(  );

    // [448] Function call CfAbsolute
    func_448.input = func_449.output;
    func_448.Execute(  );

    // [452] Function call CfAbsolute
    func_452.input = func_453.output;
    func_452.Execute(  );

    // [433] Function call CfSubtract
    func_433.input[0] = func_57.output[0];
    func_433.input[1] = func_432.output;
    func_433.Execute(  );

    // [450] Function call CfMultiply
    func_450.input[0] = func_448.outputAbs;
    func_450.input[1] = func_46.output;
    func_450.Execute(  );

    // [454] Function call CfMultiply
    func_454.input[0] = func_452.outputAbs;
    func_454.input[1] = func_46.output;
    func_454.Execute(  );

    // [64] Function call CfCompare1
    func_64.inputA = func_16.output[0];
    func_64.inputB = func_387.output[0];
    func_64.Execute(  );

    // [398] Macro call CmAddition_conditional
    if ( func_64.outputLess)
    {
      func_398.CmAddition_conditional_input_1 = func_497.output;
      func_398.CmAddition_conditional_input_2 = func_69.output;
      func_398.CmAddition_conditional_input_3 = 0F;
      func_398.CmAddition_conditional_input_4 = 0F;
      func_398.Execute(  );
    }

    // [87] Function call CfCompare1
    func_87.inputA = func_16.output[0];
    func_87.inputB = func_421.output[0];
    func_87.Execute(  );

    // [395] Macro call CmAddition_conditional
    if ( func_87.outputGreater)
    {
      func_395.CmAddition_conditional_input_1 = func_498.output;
      func_395.CmAddition_conditional_input_2 = func_455.output;
      func_395.CmAddition_conditional_input_3 = 0F;
      func_395.CmAddition_conditional_input_4 = 0F;
      func_395.Execute(  );
    }

    // [111] Function call CfCompare1
    func_111.inputA = func_433.output;
    func_111.inputB = 0F;
    func_111.Execute(  );

    // [114] Function call CfNot
    func_114.input = func_122.output;
    func_114.Execute(  );

    // [118] Function call CfAnd
    func_118.input[0] = func_111.outputEqual;
    func_118.input[1] = func_114.output;
    func_118.Execute(  );

    // [122] Function call CfMonoflop
    func_122.input = BooleanToFloat(func_118.outputAND);
    func_122.Execute( this, 1 );

    // [444] Function call CfCompare1
    func_444.inputA = func_16.output[0];
    func_444.inputB = func_422.output[0];
    func_444.Execute(  );

    // [443] Macro call CmAddition_conditional
    if ( func_444.outputLess)
    {
      func_443.CmAddition_conditional_input_1 = func_496.output;
      func_443.CmAddition_conditional_input_2 = func_451.output;
      func_443.CmAddition_conditional_input_3 = 0F;
      func_443.CmAddition_conditional_input_4 = 0F;
      func_443.Execute(  );
    }

    // [409] Macro call CmIDT05
    if ( func_118.outputAND)
    {
      func_409.CmIDT05_input_1 = func_496.output;
      func_409.CmIDT05_input_2 = func_497.output;
      func_409.CmIDT05_input_3 = func_498.output;
      func_409.CmIDT05_input_4 = 0F;
      func_409.CmIDT05_input_5 = 0F;
      func_409.Execute(  );
      setCmDDA_DEGDAYS_output_4(func_409.CmIDT05_output_21);
      setCmDDA_DEGDAYS_output_478(func_409.CmIDT05_output_22);
      setCmDDA_DEGDAYS_output_5(func_409.CmIDT05_output_23);
    }

    // [69] Function call CfDivide
    func_69.inputA = func_54.output;
    func_69.inputB = 86400F;
    func_69.Execute(  );

    // [511] Function call CfIdt
    func_511.input = (float) getCmDDA_DEGDAYS_parameter_13();
    func_511.Execute(  );

    // [497] Function call CfInputMultiplexer
    func_497.inputSelect = FloatToInt(func_511.output[0]);
    func_497.input[1-1] = func_398.CmAddition_conditional_output_5;
    func_497.input[2-1] = (float) getCmDDA_DEGDAYS_parameter_11();
    func_497.Execute(  );

    // [451] Function call CfDivide
    func_451.inputA = func_450.output;
    func_451.inputB = 86400F;
    func_451.Execute(  );

    // [496] Function call CfInputMultiplexer
    func_496.inputSelect = FloatToInt(func_511.output[0]);
    func_496.input[1-1] = func_443.CmAddition_conditional_output_5;
    func_496.input[2-1] = (float) getCmDDA_DEGDAYS_parameter_10();
    func_496.Execute(  );

    // [455] Function call CfDivide
    func_455.inputA = func_454.output;
    func_455.inputB = 86400F;
    func_455.Execute(  );

    // [498] Function call CfInputMultiplexer
    func_498.inputSelect = FloatToInt(func_511.output[0]);
    func_498.input[1-1] = func_395.CmAddition_conditional_output_5;
    func_498.input[2-1] = (float) getCmDDA_DEGDAYS_parameter_12();
    func_498.Execute(  );

    // [510] Function call CfMonoflop
    func_510.input = func_511.output[0];
    func_510.Execute( this, 2 );

    // [499] Macro call CmIDT05
    if ( func_510.output)
    {
      func_499.CmIDT05_input_1 = 0F;
      func_499.CmIDT05_input_2 = 0F;
      func_499.CmIDT05_input_3 = 0F;
      func_499.CmIDT05_input_4 = 0F;
      func_499.CmIDT05_input_5 = 0F;
      func_499.Execute(  );
      setCmDDA_DEGDAYS_parameter_13(func_499.CmIDT05_output_21);
    }

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    1F, 3500F, 1F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// HtgDegreeDays
  public static final Property CmDDA_DEGDAYS_output_4 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("degree days celsius")));
  public BStatusNumeric getCmDDA_DEGDAYS_output_4() { return (BStatusNumeric) get(CmDDA_DEGDAYS_output_4); }
  public void setCmDDA_DEGDAYS_output_4(BStatusNumeric v) { set(CmDDA_DEGDAYS_output_4,v,null); }
  public void setCmDDA_DEGDAYS_output_4(float v) { getCmDDA_DEGDAYS_output_4().setValue(v); }
// DegreeDays
  public static final Property CmDDA_DEGDAYS_output_478 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("degree days celsius")));
  public BStatusNumeric getCmDDA_DEGDAYS_output_478() { return (BStatusNumeric) get(CmDDA_DEGDAYS_output_478); }
  public void setCmDDA_DEGDAYS_output_478(BStatusNumeric v) { set(CmDDA_DEGDAYS_output_478,v,null); }
  public void setCmDDA_DEGDAYS_output_478(float v) { getCmDDA_DEGDAYS_output_478().setValue(v); }
// ClgDegreeDays
  public static final Property CmDDA_DEGDAYS_output_5 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("degree days celsius")));
  public BStatusNumeric getCmDDA_DEGDAYS_output_5() { return (BStatusNumeric) get(CmDDA_DEGDAYS_output_5); }
  public void setCmDDA_DEGDAYS_output_5(BStatusNumeric v) { set(CmDDA_DEGDAYS_output_5,v,null); }
  public void setCmDDA_DEGDAYS_output_5(float v) { getCmDDA_DEGDAYS_output_5().setValue(v); }

  // macro parameter
// HDD-01: high limit heating degree days calculation
  public static final Property CmDDA_DEGDAYS_parameter_7 = newProperty( 0, BDouble.make( 15 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmDDA_DEGDAYS_parameter_7() { return getDouble(CmDDA_DEGDAYS_parameter_7); }
  public void setCmDDA_DEGDAYS_parameter_7(double v) { setDouble(CmDDA_DEGDAYS_parameter_7,v,null); }
// CDD-01: low limit cooling degree days calculation
  public static final Property CmDDA_DEGDAYS_parameter_8 = newProperty( 0, BDouble.make( 22 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmDDA_DEGDAYS_parameter_8() { return getDouble(CmDDA_DEGDAYS_parameter_8); }
  public void setCmDDA_DEGDAYS_parameter_8(double v) { setDouble(CmDDA_DEGDAYS_parameter_8,v,null); }
// RMT-01: room temperature setpoint
  public static final Property CmDDA_DEGDAYS_parameter_9 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmDDA_DEGDAYS_parameter_9() { return getDouble(CmDDA_DEGDAYS_parameter_9); }
  public void setCmDDA_DEGDAYS_parameter_9(double v) { setDouble(CmDDA_DEGDAYS_parameter_9,v,null); }
// SYS-01: set consumption values; 1 = set
  public static final Property CmDDA_DEGDAYS_parameter_13 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmDDA_DEGDAYS_parameter_13() { return getDouble(CmDDA_DEGDAYS_parameter_13); }
  public void setCmDDA_DEGDAYS_parameter_13(double v) { setDouble(CmDDA_DEGDAYS_parameter_13,v,null); }
// INI-01: initialize heating degree days
  public static final Property CmDDA_DEGDAYS_parameter_10 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(999999)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("degree days celsius"))));
  public double getCmDDA_DEGDAYS_parameter_10() { return getDouble(CmDDA_DEGDAYS_parameter_10); }
  public void setCmDDA_DEGDAYS_parameter_10(double v) { setDouble(CmDDA_DEGDAYS_parameter_10,v,null); }
// INI-02: initialize degree days
  public static final Property CmDDA_DEGDAYS_parameter_11 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(999999)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("degree days celsius"))));
  public double getCmDDA_DEGDAYS_parameter_11() { return getDouble(CmDDA_DEGDAYS_parameter_11); }
  public void setCmDDA_DEGDAYS_parameter_11(double v) { setDouble(CmDDA_DEGDAYS_parameter_11,v,null); }
// INI-03: initialize cooling degree days
  public static final Property CmDDA_DEGDAYS_parameter_12 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(999999)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("degree days celsius"))));
  public double getCmDDA_DEGDAYS_parameter_12() { return getDouble(CmDDA_DEGDAYS_parameter_12); }
  public void setCmDDA_DEGDAYS_parameter_12(double v) { setDouble(CmDDA_DEGDAYS_parameter_12,v,null); }

  // macro inputs
// OATemp
  public static final Property CmDDA_DEGDAYS_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmDDA_DEGDAYS_input_2() { return (BStatusNumeric) get(CmDDA_DEGDAYS_input_2); }
  public void setCmDDA_DEGDAYS_input_2(BStatusNumeric v) { set(CmDDA_DEGDAYS_input_2,v,null); }
  public void setCmDDA_DEGDAYS_input_2(float v) { getCmDDA_DEGDAYS_input_2().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.01 [35] 14.01.2015-10:20").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6033402344635367432").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmDDA_DEGDAYS.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private float   IntToFloat    (int     value) { return (float) value; }
  private int     FloatToInt    (float   value) { return (int) value;   }

  // class variables
  protected CfIdt func_16 = new CfIdt();
  protected CfSubtract func_24 = new CfSubtract();
  protected CfIdt func_387 = new CfIdt();
  protected CfIdt func_57 = new CfIdt();
  protected CfIdt func_59 = new CfIdt();
  protected CfIdt func_421 = new CfIdt();
  protected CfIdt func_422 = new CfIdt();
  protected CfDivide func_25 = new CfDivide();
  protected CfDifferential func_33 = new CfDifferential();
  protected CfTruncate func_34 = new CfTruncate();
  protected CfAbsolute func_40 = new CfAbsolute();
  protected CfMultiply func_41 = new CfMultiply();
  protected CfSubtract func_44 = new CfSubtract();
  protected CfAbsolute func_45 = new CfAbsolute();
  protected CfDivide func_46 = new CfDivide();
  protected CfSubtract func_49 = new CfSubtract();
  protected CfMultiply func_54 = new CfMultiply();
  protected CfDivide func_431 = new CfDivide();
  protected CfTruncate func_430 = new CfTruncate();
  protected CfSubtract func_449 = new CfSubtract();
  protected CfSubtract func_453 = new CfSubtract();
  protected CfMultiply func_432 = new CfMultiply();
  protected CfAbsolute func_448 = new CfAbsolute();
  protected CfAbsolute func_452 = new CfAbsolute();
  protected CfSubtract func_433 = new CfSubtract();
  protected CfMultiply func_450 = new CfMultiply();
  protected CfMultiply func_454 = new CfMultiply();
  protected CfCompare1 func_64 = new CfCompare1();
  protected CmAddition_conditional func_398 = new CmAddition_conditional();
  protected CfCompare1 func_87 = new CfCompare1();
  protected CmAddition_conditional func_395 = new CmAddition_conditional();
  protected CfCompare1 func_111 = new CfCompare1();
  protected CfNot func_114 = new CfNot();
  protected CfAnd func_118 = new CfAnd();
  protected CfMonoflop func_122 = new CfMonoflop();
  protected CfCompare1 func_444 = new CfCompare1();
  protected CmAddition_conditional func_443 = new CmAddition_conditional();
  protected CmIDT05 func_409 = new CmIDT05();
  protected CfDivide func_69 = new CfDivide();
  protected CfIdt func_511 = new CfIdt();
  protected CfInputMultiplexer func_497 = new CfInputMultiplexer();
  protected CfDivide func_451 = new CfDivide();
  protected CfInputMultiplexer func_496 = new CfInputMultiplexer();
  protected CfDivide func_455 = new CfDivide();
  protected CfInputMultiplexer func_498 = new CfInputMultiplexer();
  protected CfMonoflop func_510 = new CfMonoflop();
  protected CmIDT05 func_499 = new CmIDT05();

  // default constructor
  public BCmDDA_DEGDAYS()
  {
  }

  public void Start()
  {
    func_33.Start();
    func_398.Start();
    func_395.Start();
    func_122.Start();
    func_443.Start();
    func_409.Start();
    func_510.Start();
    func_499.Start();
  }
}
