/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:24
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.energy_management;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    TTB_PulseCounter
Macro id:      6312677298203001312
Macro version: 19
Last change:   11.08.2016 - 11:29
Access Level:  2
Inputs:
  [1] EnergPrevMeter
  [2] PowerPrevMeter
  [3] TotalizerIn
Outputs:
  [1] TotalCumEnergy
  [2] TotEnAllMeters
  [3] MomentaryUse
  [4] TotPowAllMeters
Parameter:
  [1] CNT-01: scaling factor
  [2] MEU-01: time interval for momentary use calculation
  [3] MEU-02: time unit for momentary energy use; 0 = second; 1= hour
  [4] SYS-01: set consumption values; 1 = set
  [5] INI-01: counter start value
Description:
The module calculates the energy consumption derived from the input connected to a “totalizer”.
The consumption since download will be displayed via the output “TotalCumEnergy”. This output has no engineering unit since it can be energy, total volume or any other measured and cumulated value. You can set the correct engineering unit of the datapoints connected at the outputs.
The momentary usage is displayed via the physical output “MomentaryUse”. This output has no engineering unit since it can be power, flow or any other momentary value. You can set the correct engineering unit of the datapoints connected at the outputs.
Several pulse counter modules can be used in cascade to obtain the sum of all the connected totalizers. 
The macro offer a possibility to update the total cumulated energy. After the update the macro will continue to accumulate the new consumption to the old value.
================================================================================*/

public class BCmTTB_PulseCounter
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmTTB_PulseCounter_output_4().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmTTB_PulseCounter_output_4().setStatus(BStatus.disabled);
    getCmTTB_PulseCounter_output_5().setStatus(BStatus.disabled);
    getCmTTB_PulseCounter_output_6().setStatus(BStatus.disabled);
    getCmTTB_PulseCounter_output_7().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmTTB_PulseCounter_output_4().setStatus(BStatus.ok);
    getCmTTB_PulseCounter_output_5().setStatus(BStatus.ok);
    getCmTTB_PulseCounter_output_6().setStatus(BStatus.ok);
    getCmTTB_PulseCounter_output_7().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [266] Macro call CmIDT05
    func_266.CmIDT05_input_1 = (float) getCmTTB_PulseCounter_parameter_8();
    func_266.CmIDT05_input_2 = 0F;
    func_266.CmIDT05_input_3 = (float) getCmTTB_PulseCounter_parameter_11();
    func_266.CmIDT05_input_4 = 0F;
    func_266.CmIDT05_input_5 = (float) getCmTTB_PulseCounter_parameter_10();
    func_266.Execute(  );
    setParameter(0, func_266.CmIDT05_output_21);
    setParameter(2, func_266.CmIDT05_output_23);
    setParameter(1, func_266.CmIDT05_output_25);

    // [275] Macro call CmTotalCumValue
    func_275.CmTotalCumValue_input_62 = (float) getCmTTB_PulseCounter_input_293().getValue();
    func_275.Execute( this, 0 );

    // [41] Function call CfCycle
    func_41.input = true;
    func_41.Execute( this, 3 );

    // [39] Function call CfAnd
    func_39.input[0] = func_41.output;
    func_39.input[1] = func_39.outputNAND;
    func_39.Execute(  );

    // [35] Function call CfOr
    func_35.input[0] = ControlFunction.GetStartupFlag();
    func_35.input[1] = func_39.outputAND;
    func_35.Execute(  );

    // [25] Macro call CmStorage
    if ( func_35.outputOR)
    {
      func_25.CmStorage_input_1 = func_275.CmTotalCumValue_output_64;
      func_25.CmStorage_input_2 = LongToFloat(func_28.regRuntimeMilliSec);
      func_25.Execute( this, 5 );
    }

    // [28] Function call CfTimeCounter
    func_28.inputSignal = true;
    func_28.inputReset = func_35.outputOR;
    func_28.Execute(  );

    // [269] Function call CfMultiply
    func_269.input[0] = func_25.CmStorage_output_3;
    func_269.input[1] = 3600F;
    func_269.Execute(  );

    // [58] Function call CfMultiply
    func_58.input[0] = 72F;
    func_58.input[1] = func_25.CmStorage_output_5;
    func_58.Execute(  );

    // [59] Function call CfSubtract
    func_59.input[0] = (float) getCmTTB_PulseCounter_parameter_9();
    func_59.input[1] = func_58.output;
    func_59.Execute(  );

    // [329] Function call CfMultiply
    func_329.input[0] = func_58.output;
    func_329.input[1] = 2F;
    func_329.Execute(  );
    setParameter(7, func_329.output);

    // [45] Function call CfDivide
    func_45.inputA = func_59.output;
    func_45.inputB = 72F;
    func_45.Execute(  );

    // [312] Function call CfMaximum
    func_312.input[0] = func_45.output;
    func_312.input[1] = 1F;
    func_312.Execute(  );
    setParameter(4, func_312.output);

    // [271] Function call CfInputMultiplexer
    func_271.inputSelect = FloatToInt((float) getCmTTB_PulseCounter_parameter_268());
    func_271.input[1-1] = func_25.CmStorage_output_3;
    func_271.input[2-1] = func_269.output;
    func_271.Execute(  );

    // [325] Macro call CmFlank_Pulse
    func_325.CmFlank_Pulse_input_10 = ControlFunction.GetStartupFlag();
    func_325.Execute(  );

    // [318] Function call CfOr
    func_318.input[0] = func_325.CmFlank_Pulse_output_12;
    func_318.input[1] = FloatToBoolean((float) getCmTTB_PulseCounter_parameter_10());
    func_318.Execute(  );

    // [314] Function call CfMonoflop
    func_314.input = BooleanToFloat(func_318.outputOR);
    func_314.Execute( this, 7 );

    // [321] Function call CfInputMultiplexer
    func_321.inputSelect = BooleanToInt(func_314.output);
    func_321.input[1-1] = func_271.output;
    func_321.input[2-1] = 0F;
    func_321.Execute(  );
    setCmTTB_PulseCounter_output_6(func_321.output);

    // [182] Macro call CmIDT05
    if ( func_304.outputOR)
    {
      func_182.CmIDT05_input_1 = 0F;
      func_182.CmIDT05_input_2 = 0F;
      func_182.CmIDT05_input_3 = 0F;
      func_182.CmIDT05_input_4 = 0F;
      func_182.CmIDT05_input_5 = 0F;
      func_182.Execute(  );
      setCmTTB_PulseCounter_parameter_10(func_182.CmIDT05_output_21);
      setCmTTB_PulseCounter_parameter_11(func_182.CmIDT05_output_22);
    }

    // [304] Function call CfOr
    func_304.input[0] = func_181.output;
    func_304.input[1] = func_300.outputLess;
    func_304.Execute(  );

    // [181] Function call CfMonoflop
    func_181.input = (float) getCmTTB_PulseCounter_parameter_10();
    func_181.Execute( this, 8 );

    // [205] Function call CfAddition
    func_205.input[0] = (float) getCmTTB_PulseCounter_output_6().getValue();
    func_205.input[1] = (float) getCmTTB_PulseCounter_input_3().getValue();
    func_205.Execute(  );
    setCmTTB_PulseCounter_output_7(func_205.output);

    // [204] Function call CfAddition
    func_204.input[0] = func_275.CmTotalCumValue_output_64;
    func_204.input[1] = (float) getCmTTB_PulseCounter_input_2().getValue();
    func_204.Execute(  );
    setCmTTB_PulseCounter_output_5(func_204.output);

    // [197] Function call CfIdt
    func_197.input = func_275.CmTotalCumValue_output_64;
    func_197.Execute(  );
    setCmTTB_PulseCounter_output_4(func_197.output[0]);

    // [297] Function call CfLastValue
    func_297.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_297.Execute(  );

    // [300] Function call CfCompare1
    func_300.inputA = func_297.outputCurrent;
    func_300.inputB = func_297.outputLast;
    func_300.Execute(  );

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    1F, 0F, 0F, 1F, 20F, 10F, 0F, 1F,
    1F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// TotalCumEnergy
  public static final Property CmTTB_PulseCounter_output_4 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmTTB_PulseCounter_output_4() { return (BStatusNumeric) get(CmTTB_PulseCounter_output_4); }
  public void setCmTTB_PulseCounter_output_4(BStatusNumeric v) { set(CmTTB_PulseCounter_output_4,v,null); }
  public void setCmTTB_PulseCounter_output_4(float v) { getCmTTB_PulseCounter_output_4().setValue(v); }
// TotEnAllMeters
  public static final Property CmTTB_PulseCounter_output_5 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmTTB_PulseCounter_output_5() { return (BStatusNumeric) get(CmTTB_PulseCounter_output_5); }
  public void setCmTTB_PulseCounter_output_5(BStatusNumeric v) { set(CmTTB_PulseCounter_output_5,v,null); }
  public void setCmTTB_PulseCounter_output_5(float v) { getCmTTB_PulseCounter_output_5().setValue(v); }
// MomentaryUse
  public static final Property CmTTB_PulseCounter_output_6 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmTTB_PulseCounter_output_6() { return (BStatusNumeric) get(CmTTB_PulseCounter_output_6); }
  public void setCmTTB_PulseCounter_output_6(BStatusNumeric v) { set(CmTTB_PulseCounter_output_6,v,null); }
  public void setCmTTB_PulseCounter_output_6(float v) { getCmTTB_PulseCounter_output_6().setValue(v); }
// TotPowAllMeters
  public static final Property CmTTB_PulseCounter_output_7 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmTTB_PulseCounter_output_7() { return (BStatusNumeric) get(CmTTB_PulseCounter_output_7); }
  public void setCmTTB_PulseCounter_output_7(BStatusNumeric v) { set(CmTTB_PulseCounter_output_7,v,null); }
  public void setCmTTB_PulseCounter_output_7(float v) { getCmTTB_PulseCounter_output_7().setValue(v); }

  // macro parameter
// CNT-01: scaling factor
  public static final Property CmTTB_PulseCounter_parameter_8 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(100000)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmTTB_PulseCounter_parameter_8() { return getDouble(CmTTB_PulseCounter_parameter_8); }
  public void setCmTTB_PulseCounter_parameter_8(double v) { setDouble(CmTTB_PulseCounter_parameter_8,v,null); }
// MEU-01: time interval for momentary use calculation
  public static final Property CmTTB_PulseCounter_parameter_9 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(150)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmTTB_PulseCounter_parameter_9() { return getDouble(CmTTB_PulseCounter_parameter_9); }
  public void setCmTTB_PulseCounter_parameter_9(double v) { setDouble(CmTTB_PulseCounter_parameter_9,v,null); }
// MEU-02: time unit for momentary energy use; 0 = second; 1= hour
  public static final Property CmTTB_PulseCounter_parameter_268 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmTTB_PulseCounter_parameter_268() { return getDouble(CmTTB_PulseCounter_parameter_268); }
  public void setCmTTB_PulseCounter_parameter_268(double v) { setDouble(CmTTB_PulseCounter_parameter_268,v,null); }
// SYS-01: set consumption values; 1 = set
  public static final Property CmTTB_PulseCounter_parameter_10 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmTTB_PulseCounter_parameter_10() { return getDouble(CmTTB_PulseCounter_parameter_10); }
  public void setCmTTB_PulseCounter_parameter_10(double v) { setDouble(CmTTB_PulseCounter_parameter_10,v,null); }
// INI-01: counter start value
  public static final Property CmTTB_PulseCounter_parameter_11 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(4E+09)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmTTB_PulseCounter_parameter_11() { return getDouble(CmTTB_PulseCounter_parameter_11); }
  public void setCmTTB_PulseCounter_parameter_11(double v) { setDouble(CmTTB_PulseCounter_parameter_11,v,null); }

  // macro inputs
// EnergPrevMeter
  public static final Property CmTTB_PulseCounter_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmTTB_PulseCounter_input_2() { return (BStatusNumeric) get(CmTTB_PulseCounter_input_2); }
  public void setCmTTB_PulseCounter_input_2(BStatusNumeric v) { set(CmTTB_PulseCounter_input_2,v,null); }
  public void setCmTTB_PulseCounter_input_2(float v) { getCmTTB_PulseCounter_input_2().setValue(v); }
// PowerPrevMeter
  public static final Property CmTTB_PulseCounter_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmTTB_PulseCounter_input_3() { return (BStatusNumeric) get(CmTTB_PulseCounter_input_3); }
  public void setCmTTB_PulseCounter_input_3(BStatusNumeric v) { set(CmTTB_PulseCounter_input_3,v,null); }
  public void setCmTTB_PulseCounter_input_3(float v) { getCmTTB_PulseCounter_input_3().setValue(v); }
// TotalizerIn
  public static final Property CmTTB_PulseCounter_input_293 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmTTB_PulseCounter_input_293() { return (BStatusNumeric) get(CmTTB_PulseCounter_input_293); }
  public void setCmTTB_PulseCounter_input_293(BStatusNumeric v) { set(CmTTB_PulseCounter_input_293,v,null); }
  public void setCmTTB_PulseCounter_input_293(float v) { getCmTTB_PulseCounter_input_293().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.01 [19] 11.08.2016-11:29").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6312677298203001312").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmTTB_PulseCounter.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private float   LongToFloat   (long    value) { return (float) value; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmIDT05 func_266 = new CmIDT05();
  protected CmTotalCumValue func_275 = new CmTotalCumValue();
  protected CfCycle func_41 = new CfCycle();
  protected CfAnd func_39 = new CfAnd();
  protected CfOr func_35 = new CfOr();
  protected CmStorage func_25 = new CmStorage();
  protected CfTimeCounter func_28 = new CfTimeCounter();
  protected CfMultiply func_269 = new CfMultiply();
  protected CfMultiply func_58 = new CfMultiply();
  protected CfSubtract func_59 = new CfSubtract();
  protected CfMultiply func_329 = new CfMultiply();
  protected CfDivide func_45 = new CfDivide();
  protected CfMaximum func_312 = new CfMaximum();
  protected CfInputMultiplexer func_271 = new CfInputMultiplexer();
  protected CmFlank_Pulse func_325 = new CmFlank_Pulse();
  protected CfOr func_318 = new CfOr();
  protected CfMonoflop func_314 = new CfMonoflop();
  protected CfInputMultiplexer func_321 = new CfInputMultiplexer();
  protected CmIDT05 func_182 = new CmIDT05();
  protected CfOr func_304 = new CfOr();
  protected CfMonoflop func_181 = new CfMonoflop();
  protected CfAddition func_205 = new CfAddition();
  protected CfAddition func_204 = new CfAddition();
  protected CfIdt func_197 = new CfIdt();
  protected CfLastValue func_297 = new CfLastValue();
  protected CfCompare1 func_300 = new CfCompare1();

  // default constructor
  public BCmTTB_PulseCounter()
  {
  }

  public void Start()
  {
    func_266.Start();
    func_275.Start();
    func_41.Start();
    func_25.Start();
    func_28.Start();
    func_325.Start();
    func_314.Start();
    func_182.Start();
    func_181.Start();
    func_297.Start();
  }
}
