/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:24
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.energy_management;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    TTB_Statistics
Macro id:      6225525653730492684
Macro version: 4
Last change:   19.02.2019 - 15:24
Access Level:  2
Inputs:
  [1] EnergyIn
  [2] PowerIn
Outputs:
  [1] Cons_ActDay
  [2] Cons_ActWeek
  [3] Cons_ActMonth
  [4] Cons_ActYear
  [5] Cons_PrevDay
  [6] Cons_PrevWeek
  [7] Cons_PrevMonth
  [8] Cons_PrevYear
Parameter:
  [1] INI-01: actual day consumption
  [2] INI-02: actual week consumption
  [3] INI-03: actual month consumption
  [4] INI-04: actual year consumption
  [5] INI-05: previous day consumption
  [6] INI-06: previous week consumption
  [7] INI-07: previous month consumption
  [8] INI-08: previous year consumption
  [9] SYS-01: exponent weekly
  [10] SYS-02: exponent monthly
  [11] SYS-03: exponent yearly
  [12] SYS-04: set consumption values; 1 = set
  [13] SYS-05: Inputselection; 0=Energy 1=Power
  [14] SYS-06: the week starts: 0;1=Saturday, 2=Sunday, 3=Monday
Description:
The module calculates the consumption for the following periods:
•	actual day
•	actual week
•	actual month
•	actual year
•	previous day
•	previous week
•	previous month 
•	previous year
When a meter has to be replaced, the historical values of the previous meter can be initialized for the new meter. The macro will continue to accumulate the new consumption to the old historical values.

================================================================================*/

public class BCmTTB_Statistics
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmTTB_Statistics_output_7().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmTTB_Statistics_output_7().setStatus(BStatus.disabled);
    getCmTTB_Statistics_output_618().setStatus(BStatus.disabled);
    getCmTTB_Statistics_output_5().setStatus(BStatus.disabled);
    getCmTTB_Statistics_output_273().setStatus(BStatus.disabled);
    getCmTTB_Statistics_output_6().setStatus(BStatus.disabled);
    getCmTTB_Statistics_output_619().setStatus(BStatus.disabled);
    getCmTTB_Statistics_output_8().setStatus(BStatus.disabled);
    getCmTTB_Statistics_output_274().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmTTB_Statistics_output_7().setStatus(BStatus.ok);
    getCmTTB_Statistics_output_618().setStatus(BStatus.ok);
    getCmTTB_Statistics_output_5().setStatus(BStatus.ok);
    getCmTTB_Statistics_output_273().setStatus(BStatus.ok);
    getCmTTB_Statistics_output_6().setStatus(BStatus.ok);
    getCmTTB_Statistics_output_619().setStatus(BStatus.ok);
    getCmTTB_Statistics_output_8().setStatus(BStatus.ok);
    getCmTTB_Statistics_output_274().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [510] Function call CfDelayOnOff
    func_510.input = ControlFunction.GetStartupFlag();
    func_510.Execute( this, 0 );

    // [511] Function call CfNot
    func_511.input = func_510.output;
    func_511.Execute(  );

    // [491] Macro call CmIDT05
    if ( ControlFunction.GetStartupFlag())
    {
      func_491.CmIDT05_input_1 = func_513.output;
      func_491.CmIDT05_input_2 = func_514.output;
      func_491.CmIDT05_input_3 = func_522.output;
      func_491.CmIDT05_input_4 = func_675.output;
      func_491.CmIDT05_input_5 = 0F;
      func_491.Execute(  );
      register_6 = func_491.CmIDT05_output_21;
      register_8 = func_491.CmIDT05_output_22;
      register_11 = func_491.CmIDT05_output_23;
      register_7 = func_491.CmIDT05_output_24;
    }

    // [593] Function call CfLastValue
    func_593.input = BooleanToFloat(func_580.output);
    func_593.Execute(  );

    // [611] Function call CfDivide
    func_611.inputA = (float) getCmTTB_Statistics_input_602().getValue();
    func_611.inputB = 360F;
    func_611.Execute(  );

    // [617] Function call CfInputMultiplexer
    func_617.inputSelect = FloatToInt((float) getCmTTB_Statistics_parameter_603());
    func_617.input[1-1] = 0F;
    func_617.input[2-1] = 1E+20F;
    func_617.Execute(  );

    // [596] Function call CfCompare1
    func_596.inputA = func_593.outputCurrent;
    func_596.inputB = func_593.outputLast;
    func_596.Execute(  );

    // [612] Function call CfIntegral
    func_612.inputX = func_611.output;
    func_612.inputMax = func_617.output;
    func_612.Execute( this, 2 );

    // [610] Function call CfInputMultiplexer
    func_610.inputSelect = FloatToInt((float) getCmTTB_Statistics_parameter_603());
    func_610.input[1-1] = (float) getCmTTB_Statistics_input_1().getValue();
    func_610.input[2-1] = func_612.output;
    func_610.Execute(  );

    // [513] Function call CfSubtract
    func_513.input[0] = func_610.output;
    func_513.input[1] = (float) getCmTTB_Statistics_parameter_16();
    func_513.Execute(  );

    // [675] Function call CfSubtract
    func_675.input[0] = func_610.output;
    func_675.input[1] = (float) getCmTTB_Statistics_parameter_620();
    func_675.Execute(  );

    // [514] Function call CfSubtract
    func_514.input[0] = func_610.output;
    func_514.input[1] = (float) getCmTTB_Statistics_parameter_11();
    func_514.Execute(  );

    // [522] Function call CfSubtract
    func_522.input[0] = func_610.output;
    func_522.input[1] = (float) getCmTTB_Statistics_parameter_275();
    func_522.Execute(  );

    // [523] Macro call CmIDT05
    if ( ControlFunction.GetStartupFlag())
    {
      func_523.CmIDT05_input_1 = (float) getCmTTB_Statistics_parameter_17();
      func_523.CmIDT05_input_2 = (float) getCmTTB_Statistics_parameter_12();
      func_523.CmIDT05_input_3 = (float) getCmTTB_Statistics_parameter_276();
      func_523.CmIDT05_input_4 = (float) getCmTTB_Statistics_parameter_621();
      func_523.CmIDT05_input_5 = 0F;
      func_523.Execute(  );
      register_13 = func_523.CmIDT05_output_21;
      register_16 = func_523.CmIDT05_output_22;
      register_17 = func_523.CmIDT05_output_23;
      register_14 = func_523.CmIDT05_output_24;
    }

    // [500] Macro call CmIDT05
    if ( func_511.output)
    {
      func_500.CmIDT05_input_1 = func_409.output;
      func_500.CmIDT05_input_2 = func_409.output;
      func_500.CmIDT05_input_3 = func_409.output;
      func_500.CmIDT05_input_4 = func_409.output;
      func_500.CmIDT05_input_5 = 0F;
      func_500.Execute(  );
      setCmTTB_Statistics_output_7(func_500.CmIDT05_output_22);
    }

    // [551] Macro call CmIDT05
    if ( func_511.output)
    {
      func_551.CmIDT05_input_1 = func_414.output;
      func_551.CmIDT05_input_2 = func_414.output;
      func_551.CmIDT05_input_3 = 0F;
      func_551.CmIDT05_input_4 = 0F;
      func_551.CmIDT05_input_5 = 0F;
      func_551.Execute(  );
    }

    // [558] Macro call CmIDT05
    if ( func_511.output)
    {
      func_558.CmIDT05_input_1 = func_420.output;
      func_558.CmIDT05_input_2 = func_420.output;
      func_558.CmIDT05_input_3 = 0F;
      func_558.CmIDT05_input_4 = 0F;
      func_558.CmIDT05_input_5 = 0F;
      func_558.Execute(  );
    }

    // [645] Macro call CmIDT05
    if ( func_511.output)
    {
      func_645.CmIDT05_input_1 = func_647.output;
      func_645.CmIDT05_input_2 = func_647.output;
      func_645.CmIDT05_input_3 = 0F;
      func_645.CmIDT05_input_4 = 0F;
      func_645.CmIDT05_input_5 = 0F;
      func_645.Execute(  );
    }

    // [291] Macro call CmIDT05
    if ( func_596.outputLess)
    {
      func_291.CmIDT05_input_1 = 0F;
      func_291.CmIDT05_input_2 = 0F;
      func_291.CmIDT05_input_3 = 0F;
      func_291.CmIDT05_input_4 = 0F;
      func_291.CmIDT05_input_5 = 0F;
      func_291.Execute(  );
      setCmTTB_Statistics_parameter_279(func_291.CmIDT05_output_21);
    }

    // [324] Function call CfSubtract
    func_324.input[0] = func_610.output;
    func_324.input[1] = (float) getCmTTB_Statistics_parameter_16();
    func_324.Execute(  );

    // [671] Function call CfSubtract
    func_671.input[0] = func_610.output;
    func_671.input[1] = (float) getCmTTB_Statistics_parameter_620();
    func_671.Execute(  );

    // [325] Function call CfSubtract
    func_325.input[0] = func_610.output;
    func_325.input[1] = (float) getCmTTB_Statistics_parameter_11();
    func_325.Execute(  );

    // [327] Function call CfSubtract
    func_327.input[0] = func_610.output;
    func_327.input[1] = (float) getCmTTB_Statistics_parameter_275();
    func_327.Execute(  );

    // [320] Macro call CmIDT05
    if ( func_580.output)
    {
      func_320.CmIDT05_input_1 = func_324.output;
      func_320.CmIDT05_input_2 = func_325.output;
      func_320.CmIDT05_input_3 = func_327.output;
      func_320.CmIDT05_input_4 = func_671.output;
      func_320.CmIDT05_input_5 = 0F;
      func_320.Execute(  );
      register_6 = func_320.CmIDT05_output_21;
      register_8 = func_320.CmIDT05_output_22;
      register_11 = func_320.CmIDT05_output_23;
      register_7 = func_320.CmIDT05_output_24;
    }

    // [333] Macro call CmIDT05
    if ( func_580.output)
    {
      func_333.CmIDT05_input_1 = (float) getCmTTB_Statistics_parameter_17();
      func_333.CmIDT05_input_2 = (float) getCmTTB_Statistics_parameter_12();
      func_333.CmIDT05_input_3 = (float) getCmTTB_Statistics_parameter_276();
      func_333.CmIDT05_input_4 = (float) getCmTTB_Statistics_parameter_621();
      func_333.CmIDT05_input_5 = 0F;
      func_333.Execute(  );
      register_13 = func_333.CmIDT05_output_21;
      register_16 = func_333.CmIDT05_output_22;
      register_17 = func_333.CmIDT05_output_23;
      register_14 = func_333.CmIDT05_output_24;
    }

    // [348] Function call CfIdt
    func_348.input = IntToFloat(ControlFunction.GetHoursAndMinutes());
    func_348.Execute(  );

    // [683] Function call CfIdt
    func_683.input = IntToFloat(ControlFunction.GetWeekday());
    func_683.Execute(  );

    // [349] Function call CfIdt
    func_349.input = IntToFloat(ControlFunction.GetDayAndMonth());
    func_349.Execute(  );

    // [350] Function call CfDivide
    func_350.inputA = IntToFloat(ControlFunction.GetDayAndMonth());
    func_350.inputB = 100F;
    func_350.Execute(  );

    // [351] Function call CfTruncate
    func_351.input = func_350.output;
    func_351.Execute(  );

    // [352] Function call CfMultiply
    func_352.input[0] = func_351.output;
    func_352.input[1] = 100F;
    func_352.Execute(  );

    // [353] Function call CfSubtract
    func_353.input[0] = IntToFloat(ControlFunction.GetDayAndMonth());
    func_353.input[1] = func_352.output;
    func_353.Execute(  );

    // [370] Function call CfCompare1
    func_370.inputA = func_348.output[0];
    func_370.inputB = 0F;
    func_370.Execute(  );

    // [396] Function call CfCompare1
    func_396.inputA = func_349.output[0];
    func_396.inputB = 101F;
    func_396.Execute(  );

    // [371] Function call CfLastValue
    func_371.input = BooleanToFloat(func_370.outputEqual);
    func_371.Execute(  );

    // [395] Function call CfLastValue
    func_395.input = BooleanToFloat(func_396.outputEqual);
    func_395.Execute(  );

    // [374] Function call CfCompare1
    func_374.inputA = func_371.outputCurrent;
    func_374.inputB = func_371.outputLast;
    func_374.Execute(  );

    // [685] Function call CfInputMultiplexer
    func_685.inputSelect = FloatToInt((float) getCmTTB_Statistics_parameter_682());
    func_685.input[1-1] = 6F;
    func_685.input[2-1] = 6F;
    func_685.input[3-1] = 7F;
    func_685.input[4-1] = 1F;
    func_685.Execute(  );

    // [627] Function call CfCompare1
    func_627.inputA = func_683.output[0];
    func_627.inputB = func_685.output;
    func_627.Execute(  );

    // [644] Function call CfLastValue
    func_644.input = BooleanToFloat(func_627.outputEqual);
    func_644.Execute(  );

    // [642] Function call CfCompare1
    func_642.inputA = func_644.outputCurrent;
    func_642.inputB = func_644.outputLast;
    func_642.Execute(  );

    // [643] Function call CfAnd
    func_643.input[0] = func_374.outputGreater;
    func_643.input[1] = func_642.outputGreater;
    func_643.Execute(  );

    // [397] Function call CfCompare1
    func_397.inputA = func_395.outputCurrent;
    func_397.inputB = func_395.outputLast;
    func_397.Execute(  );

    // [383] Function call CfCompare1
    func_383.inputA = func_353.output;
    func_383.inputB = 1F;
    func_383.Execute(  );

    // [384] Function call CfLastValue
    func_384.input = BooleanToFloat(func_383.outputEqual);
    func_384.Execute(  );

    // [382] Function call CfCompare1
    func_382.inputA = func_384.outputCurrent;
    func_382.inputB = func_384.outputLast;
    func_382.Execute(  );

    // [392] Function call CfAnd
    func_392.input[0] = func_374.outputGreater;
    func_392.input[1] = func_382.outputGreater;
    func_392.Execute(  );

    // [398] Function call CfAnd
    func_398.input[0] = func_392.outputAND;
    func_398.input[1] = func_397.outputGreater;
    func_398.Execute(  );

    // [418] Function call CfPower
    func_418.inputX = 10F;
    func_418.inputY = (float) getCmTTB_Statistics_parameter_277();
    func_418.Execute(  );

    // [423] Function call CfPower
    func_423.inputX = 10F;
    func_423.inputY = (float) getCmTTB_Statistics_parameter_278();
    func_423.Execute(  );

    // [646] Function call CfPower
    func_646.inputX = 10F;
    func_646.inputY = (float) getCmTTB_Statistics_parameter_622();
    func_646.Execute(  );

    // [416] Function call CfDivide
    func_416.inputA = func_551.CmIDT05_output_22;
    func_416.inputB = func_418.output;
    func_416.Execute(  );

    // [451] Function call CfIdt
    func_451.input = func_416.output;
    func_451.Execute(  );
    setCmTTB_Statistics_output_5(func_451.output[0]);

    // [409] Function call CfSubtract
    func_409.input[0] = func_610.output;
    func_409.input[1] = register_6;
    func_409.Execute(  );

    // [414] Function call CfSubtract
    func_414.input[0] = func_610.output;
    func_414.input[1] = register_8;
    func_414.Execute(  );

    // [420] Function call CfSubtract
    func_420.input[0] = func_610.output;
    func_420.input[1] = register_11;
    func_420.Execute(  );

    // [647] Function call CfSubtract
    func_647.input[0] = func_610.output;
    func_647.input[1] = register_7;
    func_647.Execute(  );

    // [422] Function call CfDivide
    func_422.inputA = func_558.CmIDT05_output_22;
    func_422.inputB = func_423.output;
    func_422.Execute(  );

    // [456] Function call CfIdt
    func_456.input = func_422.output;
    func_456.Execute(  );
    setCmTTB_Statistics_output_273(func_456.output[0]);

    // [648] Function call CfDivide
    func_648.inputA = func_645.CmIDT05_output_22;
    func_648.inputB = func_646.output;
    func_648.Execute(  );

    // [649] Function call CfIdt
    func_649.input = func_648.output;
    func_649.Execute(  );
    setCmTTB_Statistics_output_618(func_649.output[0]);

    // [435] Macro call CmIDT05
    if ( func_374.outputGreater)
    {
      func_435.CmIDT05_input_1 = func_500.CmIDT05_output_23;
      func_435.CmIDT05_input_2 = func_500.CmIDT05_output_24;
      func_435.CmIDT05_input_3 = 0F;
      func_435.CmIDT05_input_4 = 0F;
      func_435.CmIDT05_input_5 = 0F;
      func_435.Execute(  );
      register_13 = func_435.CmIDT05_output_21;
      setCmTTB_Statistics_parameter_17(func_435.CmIDT05_output_22);
    }

    // [442] Function call CfIdt
    func_442.input = register_13;
    func_442.Execute(  );
    setCmTTB_Statistics_output_6(func_442.output[0]);

    // [444] Macro call CmIDT05
    if ( func_392.outputAND)
    {
      func_444.CmIDT05_input_1 = func_451.output[1];
      func_444.CmIDT05_input_2 = func_451.output[1];
      func_444.CmIDT05_input_3 = 0F;
      func_444.CmIDT05_input_4 = 0F;
      func_444.CmIDT05_input_5 = 0F;
      func_444.Execute(  );
      register_16 = func_444.CmIDT05_output_21;
      setCmTTB_Statistics_parameter_12(func_444.CmIDT05_output_22);
    }

    // [457] Macro call CmIDT05
    if ( func_398.outputAND)
    {
      func_457.CmIDT05_input_1 = func_456.output[1];
      func_457.CmIDT05_input_2 = func_456.output[1];
      func_457.CmIDT05_input_3 = 0F;
      func_457.CmIDT05_input_4 = 0F;
      func_457.CmIDT05_input_5 = 0F;
      func_457.Execute(  );
      register_17 = func_457.CmIDT05_output_21;
      setCmTTB_Statistics_parameter_276(func_457.CmIDT05_output_22);
    }

    // [650] Macro call CmIDT05
    if ( func_643.outputAND)
    {
      func_650.CmIDT05_input_1 = func_649.output[1];
      func_650.CmIDT05_input_2 = func_649.output[1];
      func_650.CmIDT05_input_3 = 0F;
      func_650.CmIDT05_input_4 = 0F;
      func_650.CmIDT05_input_5 = 0F;
      func_650.Execute(  );
      register_14 = func_650.CmIDT05_output_21;
      setCmTTB_Statistics_parameter_621(func_650.CmIDT05_output_22);
    }

    // [484] Function call CfDivide
    func_484.inputA = register_17;
    func_484.inputB = func_483.output;
    func_484.Execute(  );
    setCmTTB_Statistics_output_274(func_484.output);

    // [651] Function call CfDivide
    func_651.inputA = register_14;
    func_651.inputB = func_652.output;
    func_651.Execute(  );
    setCmTTB_Statistics_output_619(func_651.output);

    // [483] Function call CfPower
    func_483.inputX = 10F;
    func_483.inputY = (float) getCmTTB_Statistics_parameter_278();
    func_483.Execute(  );

    // [652] Function call CfPower
    func_652.inputX = 10F;
    func_652.inputY = (float) getCmTTB_Statistics_parameter_622();
    func_652.Execute(  );

    // [487] Function call CfPower
    func_487.inputX = 10F;
    func_487.inputY = (float) getCmTTB_Statistics_parameter_277();
    func_487.Execute(  );

    // [488] Function call CfDivide
    func_488.inputA = register_16;
    func_488.inputB = func_487.output;
    func_488.Execute(  );
    setCmTTB_Statistics_output_8(func_488.output);

    // [466] Macro call CmIDT05
    if ( func_374.outputGreater)
    {
      func_466.CmIDT05_input_1 = func_610.output;
      func_466.CmIDT05_input_2 = 0F;
      func_466.CmIDT05_input_3 = 0F;
      func_466.CmIDT05_input_4 = 0F;
      func_466.CmIDT05_input_5 = 0F;
      func_466.Execute(  );
      register_6 = func_466.CmIDT05_output_21;
    }

    // [676] Macro call CmIDT05
    if ( func_643.outputAND)
    {
      func_676.CmIDT05_input_1 = func_610.output;
      func_676.CmIDT05_input_2 = 0F;
      func_676.CmIDT05_input_3 = 0F;
      func_676.CmIDT05_input_4 = 0F;
      func_676.CmIDT05_input_5 = 0F;
      func_676.Execute(  );
      register_7 = func_676.CmIDT05_output_21;
    }

    // [472] Macro call CmIDT05
    if ( func_392.outputAND)
    {
      func_472.CmIDT05_input_1 = func_610.output;
      func_472.CmIDT05_input_2 = 0F;
      func_472.CmIDT05_input_3 = 0F;
      func_472.CmIDT05_input_4 = 0F;
      func_472.CmIDT05_input_5 = 0F;
      func_472.Execute(  );
      register_8 = func_472.CmIDT05_output_21;
    }

    // [477] Macro call CmIDT05
    if ( func_398.outputAND)
    {
      func_477.CmIDT05_input_1 = func_610.output;
      func_477.CmIDT05_input_2 = 0F;
      func_477.CmIDT05_input_3 = 0F;
      func_477.CmIDT05_input_4 = 0F;
      func_477.CmIDT05_input_5 = 0F;
      func_477.Execute(  );
      register_11 = func_477.CmIDT05_output_21;
    }

    // [580] Function call CfMonoflop
    func_580.input = (float) getCmTTB_Statistics_parameter_279();
    func_580.Execute( this, 3 );

    // [576] Function call CfNot
    func_576.input = func_580.output;
    func_576.Execute(  );

    // [590] Function call CfAnd
    func_590.input[0] = func_576.output;
    func_590.input[1] = func_511.output;
    func_590.Execute(  );

    // [572] Macro call CmIDT05
    if ( func_590.outputAND)
    {
      func_572.CmIDT05_input_1 = func_500.CmIDT05_output_21;
      func_572.CmIDT05_input_2 = func_551.CmIDT05_output_21;
      func_572.CmIDT05_input_3 = func_558.CmIDT05_output_21;
      func_572.CmIDT05_input_4 = func_645.CmIDT05_output_21;
      func_572.CmIDT05_input_5 = 0F;
      func_572.Execute(  );
      setCmTTB_Statistics_parameter_16(func_572.CmIDT05_output_21);
      setCmTTB_Statistics_parameter_11(func_572.CmIDT05_output_22);
      setCmTTB_Statistics_parameter_275(func_572.CmIDT05_output_23);
      setCmTTB_Statistics_parameter_620(func_572.CmIDT05_output_24);
    }

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 10F, 10F, 1F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  protected float register_6 = 0;
  protected float register_7 = 0;
  protected float register_8 = 0;
  protected float register_11 = 0;
  protected float register_13 = 0;
  protected float register_14 = 0;
  protected float register_16 = 0;
  protected float register_17 = 0;
  // macro outputs
// Cons_ActDay
  public static final Property CmTTB_Statistics_output_7 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmTTB_Statistics_output_7() { return (BStatusNumeric) get(CmTTB_Statistics_output_7); }
  public void setCmTTB_Statistics_output_7(BStatusNumeric v) { set(CmTTB_Statistics_output_7,v,null); }
  public void setCmTTB_Statistics_output_7(float v) { getCmTTB_Statistics_output_7().setValue(v); }
// Cons_ActWeek
  public static final Property CmTTB_Statistics_output_618 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmTTB_Statistics_output_618() { return (BStatusNumeric) get(CmTTB_Statistics_output_618); }
  public void setCmTTB_Statistics_output_618(BStatusNumeric v) { set(CmTTB_Statistics_output_618,v,null); }
  public void setCmTTB_Statistics_output_618(float v) { getCmTTB_Statistics_output_618().setValue(v); }
// Cons_ActMonth
  public static final Property CmTTB_Statistics_output_5 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmTTB_Statistics_output_5() { return (BStatusNumeric) get(CmTTB_Statistics_output_5); }
  public void setCmTTB_Statistics_output_5(BStatusNumeric v) { set(CmTTB_Statistics_output_5,v,null); }
  public void setCmTTB_Statistics_output_5(float v) { getCmTTB_Statistics_output_5().setValue(v); }
// Cons_ActYear
  public static final Property CmTTB_Statistics_output_273 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmTTB_Statistics_output_273() { return (BStatusNumeric) get(CmTTB_Statistics_output_273); }
  public void setCmTTB_Statistics_output_273(BStatusNumeric v) { set(CmTTB_Statistics_output_273,v,null); }
  public void setCmTTB_Statistics_output_273(float v) { getCmTTB_Statistics_output_273().setValue(v); }
// Cons_PrevDay
  public static final Property CmTTB_Statistics_output_6 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmTTB_Statistics_output_6() { return (BStatusNumeric) get(CmTTB_Statistics_output_6); }
  public void setCmTTB_Statistics_output_6(BStatusNumeric v) { set(CmTTB_Statistics_output_6,v,null); }
  public void setCmTTB_Statistics_output_6(float v) { getCmTTB_Statistics_output_6().setValue(v); }
// Cons_PrevWeek
  public static final Property CmTTB_Statistics_output_619 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmTTB_Statistics_output_619() { return (BStatusNumeric) get(CmTTB_Statistics_output_619); }
  public void setCmTTB_Statistics_output_619(BStatusNumeric v) { set(CmTTB_Statistics_output_619,v,null); }
  public void setCmTTB_Statistics_output_619(float v) { getCmTTB_Statistics_output_619().setValue(v); }
// Cons_PrevMonth
  public static final Property CmTTB_Statistics_output_8 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmTTB_Statistics_output_8() { return (BStatusNumeric) get(CmTTB_Statistics_output_8); }
  public void setCmTTB_Statistics_output_8(BStatusNumeric v) { set(CmTTB_Statistics_output_8,v,null); }
  public void setCmTTB_Statistics_output_8(float v) { getCmTTB_Statistics_output_8().setValue(v); }
// Cons_PrevYear
  public static final Property CmTTB_Statistics_output_274 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmTTB_Statistics_output_274() { return (BStatusNumeric) get(CmTTB_Statistics_output_274); }
  public void setCmTTB_Statistics_output_274(BStatusNumeric v) { set(CmTTB_Statistics_output_274,v,null); }
  public void setCmTTB_Statistics_output_274(float v) { getCmTTB_Statistics_output_274().setValue(v); }

  // macro parameter
// INI-01: actual day consumption
  public static final Property CmTTB_Statistics_parameter_16 = newProperty( 0, BDouble.make( 0 ), BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)));
  public double getCmTTB_Statistics_parameter_16() { return getDouble(CmTTB_Statistics_parameter_16); }
  public void setCmTTB_Statistics_parameter_16(double v) { setDouble(CmTTB_Statistics_parameter_16,v,null); }
// INI-02: actual week consumption
  public static final Property CmTTB_Statistics_parameter_620 = newProperty( 0, BDouble.make( 0 ), BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)));
  public double getCmTTB_Statistics_parameter_620() { return getDouble(CmTTB_Statistics_parameter_620); }
  public void setCmTTB_Statistics_parameter_620(double v) { setDouble(CmTTB_Statistics_parameter_620,v,null); }
// INI-03: actual month consumption
  public static final Property CmTTB_Statistics_parameter_11 = newProperty( 0, BDouble.make( 0 ), BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)));
  public double getCmTTB_Statistics_parameter_11() { return getDouble(CmTTB_Statistics_parameter_11); }
  public void setCmTTB_Statistics_parameter_11(double v) { setDouble(CmTTB_Statistics_parameter_11,v,null); }
// INI-04: actual year consumption
  public static final Property CmTTB_Statistics_parameter_275 = newProperty( 0, BDouble.make( 0 ), BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)));
  public double getCmTTB_Statistics_parameter_275() { return getDouble(CmTTB_Statistics_parameter_275); }
  public void setCmTTB_Statistics_parameter_275(double v) { setDouble(CmTTB_Statistics_parameter_275,v,null); }
// INI-05: previous day consumption
  public static final Property CmTTB_Statistics_parameter_17 = newProperty( 0, BDouble.make( 0 ), BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)));
  public double getCmTTB_Statistics_parameter_17() { return getDouble(CmTTB_Statistics_parameter_17); }
  public void setCmTTB_Statistics_parameter_17(double v) { setDouble(CmTTB_Statistics_parameter_17,v,null); }
// INI-06: previous week consumption
  public static final Property CmTTB_Statistics_parameter_621 = newProperty( 0, BDouble.make( 0 ), BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)));
  public double getCmTTB_Statistics_parameter_621() { return getDouble(CmTTB_Statistics_parameter_621); }
  public void setCmTTB_Statistics_parameter_621(double v) { setDouble(CmTTB_Statistics_parameter_621,v,null); }
// INI-07: previous month consumption
  public static final Property CmTTB_Statistics_parameter_12 = newProperty( 0, BDouble.make( 0 ), BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)));
  public double getCmTTB_Statistics_parameter_12() { return getDouble(CmTTB_Statistics_parameter_12); }
  public void setCmTTB_Statistics_parameter_12(double v) { setDouble(CmTTB_Statistics_parameter_12,v,null); }
// INI-08: previous year consumption
  public static final Property CmTTB_Statistics_parameter_276 = newProperty( 0, BDouble.make( 0 ), BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)));
  public double getCmTTB_Statistics_parameter_276() { return getDouble(CmTTB_Statistics_parameter_276); }
  public void setCmTTB_Statistics_parameter_276(double v) { setDouble(CmTTB_Statistics_parameter_276,v,null); }
// SYS-01: exponent weekly
  public static final Property CmTTB_Statistics_parameter_622 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(6)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmTTB_Statistics_parameter_622() { return getDouble(CmTTB_Statistics_parameter_622); }
  public void setCmTTB_Statistics_parameter_622(double v) { setDouble(CmTTB_Statistics_parameter_622,v,null); }
// SYS-02: exponent monthly
  public static final Property CmTTB_Statistics_parameter_277 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(6)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmTTB_Statistics_parameter_277() { return getDouble(CmTTB_Statistics_parameter_277); }
  public void setCmTTB_Statistics_parameter_277(double v) { setDouble(CmTTB_Statistics_parameter_277,v,null); }
// SYS-03: exponent yearly
  public static final Property CmTTB_Statistics_parameter_278 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(6)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmTTB_Statistics_parameter_278() { return getDouble(CmTTB_Statistics_parameter_278); }
  public void setCmTTB_Statistics_parameter_278(double v) { setDouble(CmTTB_Statistics_parameter_278,v,null); }
// SYS-04: set consumption values; 1 = set
  public static final Property CmTTB_Statistics_parameter_279 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmTTB_Statistics_parameter_279() { return getDouble(CmTTB_Statistics_parameter_279); }
  public void setCmTTB_Statistics_parameter_279(double v) { setDouble(CmTTB_Statistics_parameter_279,v,null); }
// SYS-05: Inputselection; 0=Energy 1=Power
  public static final Property CmTTB_Statistics_parameter_603 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmTTB_Statistics_parameter_603() { return getDouble(CmTTB_Statistics_parameter_603); }
  public void setCmTTB_Statistics_parameter_603(double v) { setDouble(CmTTB_Statistics_parameter_603,v,null); }
// SYS-06: the week starts: 0;1=Saturday, 2=Sunday, 3=Monday
  public static final Property CmTTB_Statistics_parameter_682 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmTTB_Statistics_parameter_682() { return getDouble(CmTTB_Statistics_parameter_682); }
  public void setCmTTB_Statistics_parameter_682(double v) { setDouble(CmTTB_Statistics_parameter_682,v,null); }

  // macro inputs
// EnergyIn
  public static final Property CmTTB_Statistics_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmTTB_Statistics_input_1() { return (BStatusNumeric) get(CmTTB_Statistics_input_1); }
  public void setCmTTB_Statistics_input_1(BStatusNumeric v) { set(CmTTB_Statistics_input_1,v,null); }
  public void setCmTTB_Statistics_input_1(float v) { getCmTTB_Statistics_input_1().setValue(v); }
// PowerIn
  public static final Property CmTTB_Statistics_input_602 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmTTB_Statistics_input_602() { return (BStatusNumeric) get(CmTTB_Statistics_input_602); }
  public void setCmTTB_Statistics_input_602(BStatusNumeric v) { set(CmTTB_Statistics_input_602,v,null); }
  public void setCmTTB_Statistics_input_602(float v) { getCmTTB_Statistics_input_602().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.03 [4] 19.02.2019-15:24").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6225525653730492684").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmTTB_Statistics.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private float   IntToFloat    (int     value) { return (float) value; }
  private int     FloatToInt    (float   value) { return (int) value;   }

  // class variables
  protected CfDelayOnOff func_510 = new CfDelayOnOff();
  protected CfNot func_511 = new CfNot();
  protected CmIDT05 func_491 = new CmIDT05();
  protected CfLastValue func_593 = new CfLastValue();
  protected CfDivide func_611 = new CfDivide();
  protected CfInputMultiplexer func_617 = new CfInputMultiplexer();
  protected CfCompare1 func_596 = new CfCompare1();
  protected CfIntegral func_612 = new CfIntegral();
  protected CfInputMultiplexer func_610 = new CfInputMultiplexer();
  protected CfSubtract func_513 = new CfSubtract();
  protected CfSubtract func_675 = new CfSubtract();
  protected CfSubtract func_514 = new CfSubtract();
  protected CfSubtract func_522 = new CfSubtract();
  protected CmIDT05 func_523 = new CmIDT05();
  protected CmIDT05 func_500 = new CmIDT05();
  protected CmIDT05 func_551 = new CmIDT05();
  protected CmIDT05 func_558 = new CmIDT05();
  protected CmIDT05 func_645 = new CmIDT05();
  protected CmIDT05 func_291 = new CmIDT05();
  protected CfSubtract func_324 = new CfSubtract();
  protected CfSubtract func_671 = new CfSubtract();
  protected CfSubtract func_325 = new CfSubtract();
  protected CfSubtract func_327 = new CfSubtract();
  protected CmIDT05 func_320 = new CmIDT05();
  protected CmIDT05 func_333 = new CmIDT05();
  protected CfIdt func_348 = new CfIdt();
  protected CfIdt func_683 = new CfIdt();
  protected CfIdt func_349 = new CfIdt();
  protected CfDivide func_350 = new CfDivide();
  protected CfTruncate func_351 = new CfTruncate();
  protected CfMultiply func_352 = new CfMultiply();
  protected CfSubtract func_353 = new CfSubtract();
  protected CfCompare1 func_370 = new CfCompare1();
  protected CfCompare1 func_396 = new CfCompare1();
  protected CfLastValue func_371 = new CfLastValue();
  protected CfLastValue func_395 = new CfLastValue();
  protected CfCompare1 func_374 = new CfCompare1();
  protected CfInputMultiplexer func_685 = new CfInputMultiplexer();
  protected CfCompare1 func_627 = new CfCompare1();
  protected CfLastValue func_644 = new CfLastValue();
  protected CfCompare1 func_642 = new CfCompare1();
  protected CfAnd func_643 = new CfAnd();
  protected CfCompare1 func_397 = new CfCompare1();
  protected CfCompare1 func_383 = new CfCompare1();
  protected CfLastValue func_384 = new CfLastValue();
  protected CfCompare1 func_382 = new CfCompare1();
  protected CfAnd func_392 = new CfAnd();
  protected CfAnd func_398 = new CfAnd();
  protected CfPower func_418 = new CfPower();
  protected CfPower func_423 = new CfPower();
  protected CfPower func_646 = new CfPower();
  protected CfDivide func_416 = new CfDivide();
  protected CfIdt func_451 = new CfIdt();
  protected CfSubtract func_409 = new CfSubtract();
  protected CfSubtract func_414 = new CfSubtract();
  protected CfSubtract func_420 = new CfSubtract();
  protected CfSubtract func_647 = new CfSubtract();
  protected CfDivide func_422 = new CfDivide();
  protected CfIdt func_456 = new CfIdt();
  protected CfDivide func_648 = new CfDivide();
  protected CfIdt func_649 = new CfIdt();
  protected CmIDT05 func_435 = new CmIDT05();
  protected CfIdt func_442 = new CfIdt();
  protected CmIDT05 func_444 = new CmIDT05();
  protected CmIDT05 func_457 = new CmIDT05();
  protected CmIDT05 func_650 = new CmIDT05();
  protected CfDivide func_484 = new CfDivide();
  protected CfDivide func_651 = new CfDivide();
  protected CfPower func_483 = new CfPower();
  protected CfPower func_652 = new CfPower();
  protected CfPower func_487 = new CfPower();
  protected CfDivide func_488 = new CfDivide();
  protected CmIDT05 func_466 = new CmIDT05();
  protected CmIDT05 func_676 = new CmIDT05();
  protected CmIDT05 func_472 = new CmIDT05();
  protected CmIDT05 func_477 = new CmIDT05();
  protected CfMonoflop func_580 = new CfMonoflop();
  protected CfNot func_576 = new CfNot();
  protected CfAnd func_590 = new CfAnd();
  protected CmIDT05 func_572 = new CmIDT05();

  // default constructor
  public BCmTTB_Statistics()
  {
    func_685.configure(5);
    func_451.configure(2);
    func_456.configure(2);
    func_649.configure(2);
  }

  public void Start()
  {
    func_510.Start();
    func_491.Start();
    func_593.Start();
    func_612.Start();
    func_523.Start();
    func_500.Start();
    func_551.Start();
    func_558.Start();
    func_645.Start();
    func_291.Start();
    func_320.Start();
    func_333.Start();
    func_371.Start();
    func_395.Start();
    func_644.Start();
    func_384.Start();
    func_435.Start();
    func_444.Start();
    func_457.Start();
    func_650.Start();
    func_466.Start();
    func_676.Start();
    func_472.Start();
    func_477.Start();
    func_580.Start();
    func_572.Start();
  }
}
