/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:24
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.energy_management;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Flow
Macro id:      6172052881129079116
Macro version: 13
Last change:   30.09.2015 - 15:32
Access Level:  2
Inputs:
  [1] Flow
  [2] PumpCmd
  [3] PumpCtrl
  [4] CFG-xx
  [5] CFG-xxx
  [6] CFG-01
  [7] PMP-06
  [8] PMP-07
Outputs:
  [1] eff.Flow
  [2] EnergyPmp
Parameter:
  [1] PMP-06: pump nominal electrical power
  [2] CFG-02: solar pump configuration; 1 = on/off; 2 = variable speed
Description:

================================================================================*/

public class CmFlow
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [5] Function call CfCompare1
    func_5.inputA = CmFlow_input_29;
    func_5.inputB = 999F;
    func_5.Execute(  );

    // [6] Function call CfInputMultiplexer
    func_6.inputSelect = FloatToInt(CmFlow_input_33);
    func_6.input[1-1] = 3.6F;
    func_6.input[2-1] = 3.6F;
    func_6.input[3-1] = 1F;
    func_6.Execute(  );

    // [47] Function call CfCompare1
    func_47.inputA = CmFlow_input_31;
    func_47.inputB = 999F;
    func_47.Execute(  );

    // [50] Function call CfCompare1
    func_50.inputA = BooleanToFloat(CmFlow_input_30);
    func_50.inputB = 999F;
    func_50.Execute(  );

    // [87] Function call CfDivide
    func_87.inputA = CmFlow_input_31;
    func_87.inputB = 100F;
    func_87.Execute(  );

    // [48] Function call CfOr
    func_48.input[0] = func_50.outputEqual;
    func_48.input[1] = CmFlow_input_30;
    func_48.Execute(  );

    // [89] Function call CfMultiply
    func_89.input[0] = func_87.output;
    func_89.input[1] = func_87.output;
    func_89.Execute(  );

    // [9] Function call CfInputMultiplexer
    func_9.inputSelect = BooleanToInt(func_48.outputOR);
    func_9.input[1-1] = 0F;
    func_9.input[2-1] = func_87.output;
    func_9.Execute(  );

    // [90] Function call CfMultiply
    func_90.input[0] = func_89.output;
    func_90.input[1] = func_87.output;
    func_90.Execute(  );

    // [10] Function call CfMultiply
    func_10.input[0] = func_9.output;
    func_10.input[1] = CmFlow_input_34;
    func_10.Execute(  );

    // [91] Function call CfMultiply
    func_91.input[0] = func_90.output;
    func_91.input[1] = CmFlow_input_65;
    func_91.Execute(  );

    // [11] Function call CfInputMultiplexer
    func_11.inputSelect = BooleanToInt(func_5.outputEqual);
    func_11.input[1-1] = CmFlow_input_29;
    func_11.input[2-1] = func_10.output;
    func_11.Execute(  );

    // [92] Function call CfInputMultiplexer
    func_92.inputSelect = BooleanToInt(func_47.outputLess);
    func_92.input[1-1] = CmFlow_input_65;
    func_92.input[2-1] = func_91.output;
    func_92.Execute(  );
    CmFlow_output_66 = func_92.output;

    // [12] Function call CfMultiply
    func_12.input[0] = func_11.output;
    func_12.input[1] = func_6.output;
    func_12.Execute(  );
    CmFlow_output_37 = func_12.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmFlow_input_29; // Flow
public boolean CmFlow_input_30; // PumpCmd
public float CmFlow_input_31; // PumpCtrl
public float CmFlow_input_32; // CFG-xx(not used)
public float CmFlow_input_39; // CFG-xxx(not used)
public float CmFlow_input_33; // CFG-01
public float CmFlow_input_65; // PMP-06
public float CmFlow_input_34; // PMP-07
// macro outputs
public float CmFlow_output_37; // eff.Flow
public float CmFlow_output_66; // EnergyPmp
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }

// class variables
protected CfCompare1 func_5 = new CfCompare1();
protected CfInputMultiplexer func_6 = new CfInputMultiplexer();
protected CfCompare1 func_47 = new CfCompare1();
protected CfCompare1 func_50 = new CfCompare1();
protected CfDivide func_87 = new CfDivide();
protected CfOr func_48 = new CfOr();
protected CfMultiply func_89 = new CfMultiply();
protected CfInputMultiplexer func_9 = new CfInputMultiplexer();
protected CfMultiply func_90 = new CfMultiply();
protected CfMultiply func_10 = new CfMultiply();
protected CfMultiply func_91 = new CfMultiply();
protected CfInputMultiplexer func_11 = new CfInputMultiplexer();
protected CfInputMultiplexer func_92 = new CfInputMultiplexer();
protected CfMultiply func_12 = new CfMultiply();

// default constructor
public CmFlow()
{
  func_6.configure(4);
}

  public void Start()
  {
  }
}
