/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:24
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.energy_management;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Heat_Output
Macro id:      6171991837006365359
Macro version: 5
Last change:   18.12.2015 - 07:50
Access Level:  2
Inputs:
  [1] Flow
  [2] WarmTemp
  [3] ColdTemp
Outputs:
  [1] HeatOut
Parameter:
  [1] P02 DISP act.Flow
  [2] P03 DISP act.Heat
  [3] P08 DISP Avg.Temp.
  [4] P09 CONF Cp 0°C
  [5] P10 CONF Cp 20°C
  [6] P11 CONF Cp 60°C
  [7] P12 CONF Cp 100°C
  [8] P13 CONF Cp 200°C
  [9] P14 DISP act. Cp
  [10] P15 CONF rho 0°C
  [11] P16 CONF rho 20°C
  [12] P17 CONF rho 60°C
  [13] P18 CONF rho 100°C
  [14] P19 CONF rho 200°C
  [15] P20 DISP act. rho
  [16] P25 intern Stup
Description:
Calculates heat Output
================================================================================*/

public class CmHeat_Output
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [57] Function call CfIdt ("Cp 200")
    func_57.input = env.getParameter(parameterOffset + 7);
    func_57.Execute(  );
    env.setParameter(parameterOffset + 26, func_57.output[0]);

    // [58] Function call CfIdt ("Cp 100")
    func_58.input = env.getParameter(parameterOffset + 6);
    func_58.Execute(  );
    env.setParameter(parameterOffset + 24, func_58.output[0]);

    // [59] Function call CfIdt ("Cp 60")
    func_59.input = env.getParameter(parameterOffset + 5);
    func_59.Execute(  );
    env.setParameter(parameterOffset + 21, func_59.output[0]);
    env.setParameter(parameterOffset + 37, func_59.output[1]);

    // [60] Function call CfIdt ("Cp 20")
    func_60.input = env.getParameter(parameterOffset + 4);
    func_60.Execute(  );
    env.setParameter(parameterOffset + 35, func_60.output[0]);

    // [61] Function call CfIdt ("Cp 0")
    func_61.input = env.getParameter(parameterOffset + 3);
    func_61.Execute(  );
    env.setParameter(parameterOffset + 32, func_61.output[0]);

    // [55] Function call CfRamp
    func_55.input = env.getParameter(parameterOffset + 2);
    func_55.Execute( env, parameterOffset + 16 );

    // [56] Function call CfRamp
    func_56.input = env.getParameter(parameterOffset + 2);
    func_56.Execute( env, parameterOffset + 27 );

    // [54] Function call CfInputMultiplexer
    func_54.inputSelect = BooleanToInt(func_37.outputGreater);
    func_54.input[1-1] = func_56.output;
    func_54.input[2-1] = func_55.output;
    func_54.Execute(  );
    env.setParameter(parameterOffset + 8, func_54.output);

    // [47] Function call CfIdt ("rho 60")
    func_47.input = env.getParameter(parameterOffset + 11);
    func_47.Execute(  );
    env.setParameter(parameterOffset + 43, func_47.output[0]);
    env.setParameter(parameterOffset + 59, func_47.output[1]);

    // [48] Function call CfIdt ("rho 100")
    func_48.input = env.getParameter(parameterOffset + 12);
    func_48.Execute(  );
    env.setParameter(parameterOffset + 46, func_48.output[0]);

    // [49] Function call CfIdt ("rho 200")
    func_49.input = env.getParameter(parameterOffset + 13);
    func_49.Execute(  );
    env.setParameter(parameterOffset + 48, func_49.output[0]);

    // [50] Function call CfIdt ("rho 20")
    func_50.input = env.getParameter(parameterOffset + 10);
    func_50.Execute(  );
    env.setParameter(parameterOffset + 57, func_50.output[0]);

    // [51] Function call CfIdt ("rho 0")
    func_51.input = env.getParameter(parameterOffset + 9);
    func_51.Execute(  );
    env.setParameter(parameterOffset + 54, func_51.output[0]);

    // [34] Function call CfRamp
    func_34.input = env.getParameter(parameterOffset + 2);
    func_34.Execute( env, parameterOffset + 38 );

    // [37] Function call CfCompare1
    func_37.inputA = env.getParameter(parameterOffset + 2);
    func_37.inputB = 60F;
    func_37.Execute(  );

    // [42] Function call CfRamp
    func_42.input = env.getParameter(parameterOffset + 2);
    func_42.Execute( env, parameterOffset + 49 );

    // [40] Function call CfInputMultiplexer
    func_40.inputSelect = BooleanToInt(func_37.outputGreater);
    func_40.input[1-1] = func_42.output;
    func_40.input[2-1] = func_34.output;
    func_40.Execute(  );
    env.setParameter(parameterOffset + 14, func_40.output);

    // [52] Function call CfAverage
    func_52.input[0] = CmHeat_Output_input_2;
    func_52.input[1] = CmHeat_Output_input_3;
    func_52.ExecuteArithmeticAverage( );
    env.setParameter(parameterOffset + 2, func_52.outputA);
    // [119] Function call CfIdt
    func_119.input = CmHeat_Output_input_1;
    func_119.Execute(  );
    env.setParameter(parameterOffset, func_119.output[0]);

    // [76] Function call CfSubtract
    func_76.input[0] = CmHeat_Output_input_2;
    func_76.input[1] = CmHeat_Output_input_3;
    func_76.Execute(  );

    // [77] Function call CfMaximum
    func_77.input[0] = func_76.output;
    func_77.input[1] = 0F;
    func_77.Execute(  );

    // [74] Function call CfMultiply ("Wärme")
    func_74.input[0] = CmHeat_Output_input_1;
    func_74.input[1] = env.getParameter(parameterOffset + 14);
    func_74.input[2] = env.getParameter(parameterOffset + 8);
    func_74.input[3] = func_77.output;
    func_74.Execute(  );

    // [75] Function call CfDivide
    func_75.inputA = func_74.output;
    func_75.inputB = 3600F;
    func_75.Execute(  );
    env.setParameter(parameterOffset + 1, func_75.output);

    // [164] Function call CfIdt
    func_164.input = env.getParameter(parameterOffset + 1);
    func_164.Execute(  );
    CmHeat_Output_output_4 = func_164.output[0];

  }
// macro register which are written multiple times
// macro inputs
public float CmHeat_Output_input_1; // Flow
public float CmHeat_Output_input_2; // WarmTemp
public float CmHeat_Output_input_3; // ColdTemp
// macro outputs
public float CmHeat_Output_output_4; // HeatOut
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfIdt func_57 = new CfIdt();
protected CfIdt func_58 = new CfIdt();
protected CfIdt func_59 = new CfIdt();
protected CfIdt func_60 = new CfIdt();
protected CfIdt func_61 = new CfIdt();
protected CfRamp func_55 = new CfRamp();
protected CfRamp func_56 = new CfRamp();
protected CfInputMultiplexer func_54 = new CfInputMultiplexer();
protected CfIdt func_47 = new CfIdt();
protected CfIdt func_48 = new CfIdt();
protected CfIdt func_49 = new CfIdt();
protected CfIdt func_50 = new CfIdt();
protected CfIdt func_51 = new CfIdt();
protected CfRamp func_34 = new CfRamp();
protected CfCompare1 func_37 = new CfCompare1();
protected CfRamp func_42 = new CfRamp();
protected CfInputMultiplexer func_40 = new CfInputMultiplexer();
protected CfAverage func_52 = new CfAverage();
protected CfIdt func_119 = new CfIdt();
protected CfSubtract func_76 = new CfSubtract();
protected CfMaximum func_77 = new CfMaximum();
protected CfMultiply func_74 = new CfMultiply();
protected CfDivide func_75 = new CfDivide();
protected CfIdt func_164 = new CfIdt();

// default constructor
public CmHeat_Output()
{
  func_59.configure(2);
  func_47.configure(2);
  func_74.configure(4);
}

  public void Start()
  {
  }
}
