/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 03.12.2020 12:02
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.general;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    PFA_StartUp
Macro id:      5800204512737099864
Macro version: 16
Last change:   16.02.2015 - 10:30
Access Level:  2
Inputs:
Outputs:
Parameter:
  [1] SYS-01: Startup time
Description:
The PFA_StartUp macro is a general purpose module which provides initializing of other macros and a delayed start-up of the eagle-controller after a power failure or a download. 

Because each plant can be separately stopped and started, we recommend to use this macro always within each plant.
================================================================================*/

public class BCmPFA_StartUp
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
  }

  public void setOutputStatusOk()
  {
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [22] Function call CfIdt
    func_22.input = (float) getCmPFA_StartUp_parameter_21();
    func_22.Execute(  );
    setParameter(0, func_22.output[0]);

    // [17] Function call CfDelayOnOff
    func_17.input = ControlFunction.GetStartupFlag();
    func_17.Execute( this, 0 );

    // [19] Function call CfInputMultiplexer
    func_19.inputSelect = BooleanToInt(func_17.output);
    func_19.input[1-1] = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_19.input[2-1] = 0F;
    func_19.Execute(  );
    ControlFunction.SetStartupFlag(FloatToBoolean(func_19.output));

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    10F, 0F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs

  // macro parameter
// SYS-01: Startup time
  public static final Property CmPFA_StartUp_parameter_21 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPFA_StartUp_parameter_21() { return getDouble(CmPFA_StartUp_parameter_21); }
  public void setCmPFA_StartUp_parameter_21(double v) { setDouble(CmPFA_StartUp_parameter_21,v,null); }

  // macro inputs

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.03 [16] 16.02.2015-10:30").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5800204512737099864").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmPFA_StartUp.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfIdt func_22 = new CfIdt();
  protected CfDelayOnOff func_17 = new CfDelayOnOff();
  protected CfInputMultiplexer func_19 = new CfInputMultiplexer();

  // default constructor
  public BCmPFA_StartUp()
  {
  }

  public void Start()
  {
    func_17.Start();
  }
}
