/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 03.12.2020 12:02
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.general;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    PPA_TwinPumpCmd
Macro id:      6069730413574619866
Macro version: 245
Last change:   20.12.2019 - 14:36
Access Level:  2
Inputs:
  [1] ManSwCond
  [2] Enable2Pumps
  [3] Status1
  [4] Status2
  [5] Alarm1
  [6] Alarm2
  [7] PowerDmdOff
  [8] Reset
  [9] PumpEnable
Outputs:
  [1] Pmp1Cmd
  [2] Pmp2Cmd
  [3] PumpPref
  [4] OffAlarm1
  [5] OffAlarm2
  [6] OnAlarm1
  [7] OnAlarm2
  [8] FailCmdAlarm1
  [9] FailCmdAlarm2
  [10] CommAlarm
  [11] OperationMode
Parameter:
  [1] CMD-01: pump start-up delay
  [2] CMD-02: pump switch off delay
  [3] SYS-01: type of preference change
  [4] SYS-02: period of preference change
  [5] SYS-03: day of preference change
  [6] SYS-04: time of preference change (hhmm)
  [7] SYS-05: difference in run-times between pumps
  [8] SYS-06: take over type
  [9] SYS-07: take over time
  [10] SYS-08: type of switch
  [11] ALM-01: delay status alarm
  [12] ALM-02: alarm reset type <0limauto 0=manu 1=auto
  [13] ALM-03: status alarm type
  [14] PEX-01: pump exercise period
  [15] PEX-02: pump exercise time
  [16] PEX-03: pump exercise type
  [17] DISP-01: hours run since preference change: pump PC1
  [18] DISP-02: hours run since preference change: pump PC2
  [19] DISP-03: ALM-02 countdown
Description:
This macro provides twin pump control.

It offers:
- pump control
- automatic, alarm and manual change over
- on- and off-alarms
- fail to command alarm
- pump exercise
================================================================================*/

public class BCmPPA_TwinPumpCmd
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmPPA_TwinPumpCmd_output_12().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmPPA_TwinPumpCmd_output_12().setStatus(BStatus.disabled);
    getCmPPA_TwinPumpCmd_output_13().setStatus(BStatus.disabled);
    getCmPPA_TwinPumpCmd_output_1439().setStatus(BStatus.disabled);
    getCmPPA_TwinPumpCmd_output_15().setStatus(BStatus.disabled);
    getCmPPA_TwinPumpCmd_output_16().setStatus(BStatus.disabled);
    getCmPPA_TwinPumpCmd_output_17().setStatus(BStatus.disabled);
    getCmPPA_TwinPumpCmd_output_18().setStatus(BStatus.disabled);
    getCmPPA_TwinPumpCmd_output_19().setStatus(BStatus.disabled);
    getCmPPA_TwinPumpCmd_output_20().setStatus(BStatus.disabled);
    getCmPPA_TwinPumpCmd_output_21().setStatus(BStatus.disabled);
    getCmPPA_TwinPumpCmd_output_981().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmPPA_TwinPumpCmd_output_12().setStatus(BStatus.ok);
    getCmPPA_TwinPumpCmd_output_13().setStatus(BStatus.ok);
    getCmPPA_TwinPumpCmd_output_1439().setStatus(BStatus.ok);
    getCmPPA_TwinPumpCmd_output_15().setStatus(BStatus.ok);
    getCmPPA_TwinPumpCmd_output_16().setStatus(BStatus.ok);
    getCmPPA_TwinPumpCmd_output_17().setStatus(BStatus.ok);
    getCmPPA_TwinPumpCmd_output_18().setStatus(BStatus.ok);
    getCmPPA_TwinPumpCmd_output_19().setStatus(BStatus.ok);
    getCmPPA_TwinPumpCmd_output_20().setStatus(BStatus.ok);
    getCmPPA_TwinPumpCmd_output_21().setStatus(BStatus.ok);
    getCmPPA_TwinPumpCmd_output_981().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [112] Function call CfTruncate
    func_112.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_112.Execute(  );

    // [1865] Function call CfIdt
    func_1865.input = 30F;
    func_1865.Execute(  );
    setParameter(0, func_1865.output[0]);

    // [1864] Function call CfMonoflop
    func_1864.input = func_112.output;
    func_1864.Execute( this, 0 );

    // [1877] Function call CfOr
    func_1877.input[0] = FloatToBoolean(func_112.output);
    func_1877.input[1] = func_1864.output;
    func_1877.Execute(  );

    // [128] Macro call CmIDT20
    func_128.CmIDT20_input_1 = (float) getCmPPA_TwinPumpCmd_parameter_37();
    func_128.CmIDT20_input_2 = (float) getCmPPA_TwinPumpCmd_parameter_38();
    func_128.CmIDT20_input_3 = (float) getCmPPA_TwinPumpCmd_parameter_39();
    func_128.CmIDT20_input_4 = (float) getCmPPA_TwinPumpCmd_parameter_31();
    func_128.CmIDT20_input_5 = (float) getCmPPA_TwinPumpCmd_parameter_32();
    func_128.CmIDT20_input_6 = (float) getCmPPA_TwinPumpCmd_parameter_26();
    func_128.CmIDT20_input_7 = (float) getCmPPA_TwinPumpCmd_parameter_33();
    func_128.CmIDT20_input_8 = (float) getCmPPA_TwinPumpCmd_parameter_24();
    func_128.CmIDT20_input_9 = (float) getCmPPA_TwinPumpCmd_parameter_25();
    func_128.CmIDT20_input_10 = (float) getCmPPA_TwinPumpCmd_parameter_28();
    func_128.CmIDT20_input_11 = (float) getCmPPA_TwinPumpCmd_parameter_27();
    func_128.CmIDT20_input_12 = (float) getCmPPA_TwinPumpCmd_parameter_29();
    func_128.CmIDT20_input_13 = (float) getCmPPA_TwinPumpCmd_parameter_30();
    func_128.CmIDT20_input_14 = getParameter(62);
    func_128.CmIDT20_input_15 = getParameter(63);
    func_128.CmIDT20_input_16 = (float) getCmPPA_TwinPumpCmd_parameter_25();
    func_128.CmIDT20_input_17 = (float) getCmPPA_TwinPumpCmd_parameter_32();
    func_128.CmIDT20_input_18 = 0F;
    func_128.CmIDT20_input_19 = (float) getCmPPA_TwinPumpCmd_parameter_32();
    func_128.CmIDT20_input_20 = 0F;
    func_128.Execute(  );
    setParameter(66, func_128.CmIDT20_output_21);
    setParameter(67, func_128.CmIDT20_output_22);
    setParameter(68, func_128.CmIDT20_output_23);
    setParameter(69, func_128.CmIDT20_output_24);
    setParameter(70, func_128.CmIDT20_output_25);
    setParameter(58, func_128.CmIDT20_output_26);
    setParameter(15, func_128.CmIDT20_output_27);
    setParameter(55, func_128.CmIDT20_output_30);
    setParameter(54, func_128.CmIDT20_output_31);
    setParameter(56, func_128.CmIDT20_output_32);
    setParameter(61, func_128.CmIDT20_output_33);
    setCmPPA_TwinPumpCmd_parameter_40(func_128.CmIDT20_output_34);
    setCmPPA_TwinPumpCmd_parameter_41(func_128.CmIDT20_output_35);
    setParameter(26, func_128.CmIDT20_output_37);
    setParameter(27, func_128.CmIDT20_output_38);
    setParameter(37, func_128.CmIDT20_output_39);
    setParameter(38, func_128.CmIDT20_output_40);

    // [2031] Function call CfInputMultiplexer
    func_2031.inputSelect = BooleanToInt(func_2015.output);
    func_2031.input[1-1] = (float) getCmPPA_TwinPumpCmd_input_1().getValue();
    func_2031.input[2-1] = func_2031.output;
    func_2031.Execute(  );

    // [2036] Function call CfIdt
    func_2036.input = func_2031.output;
    func_2036.Execute(  );

    // [682] Function call CfWindow
    func_682.inputValue = func_2036.output[0];
    func_682.inputMinimum = 1.8F;
    func_682.inputMaximum = 2.2F;
    func_682.Execute(  );

    // [683] Function call CfWindow
    func_683.inputValue = (float) getCmPPA_TwinPumpCmd_parameter_33();
    func_683.inputMinimum = 0.8F;
    func_683.inputMaximum = 1.2F;
    func_683.Execute(  );

    // [693] Function call CfWindow
    func_693.inputValue = func_2036.output[0];
    func_693.inputMinimum = 2.8F;
    func_693.inputMaximum = 3.2F;
    func_693.Execute(  );

    // [684] Function call CfAnd
    func_684.input[0] = func_683.output;
    func_684.input[1] = func_682.output;
    func_684.Execute(  );

    // [695] Function call CfAnd
    func_695.input[0] = func_683.output;
    func_695.input[1] = func_693.output;
    func_695.Execute(  );

    // [692] Function call CfInputMultiplexer
    func_692.inputSelect = BooleanToInt(func_684.outputAND);
    func_692.input[1-1] = register_11;
    func_692.input[2-1] = 1F;
    func_692.Execute(  );

    // [702] Function call CfWindow
    func_702.inputValue = func_2036.output[0];
    func_702.inputMinimum = 3.8F;
    func_702.inputMaximum = 4.2F;
    func_702.Execute(  );

    // [703] Function call CfAnd
    func_703.input[0] = func_683.output;
    func_703.input[1] = func_702.output;
    func_703.Execute(  );

    // [699] Function call CfInputMultiplexer
    func_699.inputSelect = BooleanToInt(func_695.outputAND);
    func_699.input[1-1] = func_692.output;
    func_699.input[2-1] = 2F;
    func_699.Execute(  );

    // [704] Function call CfInputMultiplexer
    func_704.inputSelect = BooleanToInt(func_703.outputAND);
    func_704.input[1-1] = func_699.output;
    func_704.input[2-1] = 3F;
    func_704.Execute(  );
    register_11 = func_704.output;

    // [53] Function call CfIdt
    func_53.input = func_1599.output;
    func_53.Execute(  );
    setParameter(3, func_53.output[0]);
    setParameter(9, func_53.output[1]);

    // [54] Function call CfIdt
    func_54.input = (float) getCmPPA_TwinPumpCmd_parameter_35();
    func_54.Execute(  );
    setParameter(1, func_54.output[0]);
    setParameter(7, func_54.output[1]);

    // [55] Function call CfIdt
    func_55.input = func_1632.output;
    func_55.Execute(  );
    setParameter(2, func_55.output[0]);
    setParameter(8, func_55.output[1]);

    // [56] Function call CfCompare1
    func_56.inputA = (float) getCmPPA_TwinPumpCmd_parameter_35();
    func_56.inputB = 0F;
    func_56.Execute(  );

    // [52] Function call CfOr
    func_52.input[0] = func_56.outputGreater;
    func_52.input[1] = getCmPPA_TwinPumpCmd_output_21().getValue();
    func_52.input[2] = getCmPPA_TwinPumpCmd_input_6().getValue();
    func_52.input[3] = getCmPPA_TwinPumpCmd_input_7().getValue();
    func_52.Execute(  );

    // [57] Macro call CmAlarms
    if ( func_52.outputOR)
    {
      func_57.CmAlarms_input_1 = getCmPPA_TwinPumpCmd_output_12().getValue();
      func_57.CmAlarms_input_2 = getCmPPA_TwinPumpCmd_input_4().getValue();
      func_57.CmAlarms_input_3 = getCmPPA_TwinPumpCmd_input_6().getValue();
      func_57.CmAlarms_input_4 = func_1637.outputOR;
      func_57.Execute( this, 1 );
    }

    // [58] Macro call CmAlarms
    if ( func_52.outputOR)
    {
      func_58.CmAlarms_input_1 = getCmPPA_TwinPumpCmd_output_13().getValue();
      func_58.CmAlarms_input_2 = getCmPPA_TwinPumpCmd_input_5().getValue();
      func_58.CmAlarms_input_3 = getCmPPA_TwinPumpCmd_input_7().getValue();
      func_58.CmAlarms_input_4 = func_1637.outputOR;
      func_58.Execute( this, 7 );
    }

    // [1008] Function call CfOr
    func_1008.input[0] = func_57.CmAlarms_output_53;
    func_1008.input[1] = func_58.CmAlarms_output_53;
    func_1008.Execute(  );
    setCmPPA_TwinPumpCmd_output_21(func_1008.outputOR);

    // [407] Function call CfIdt
    func_407.input = func_1567.output[0];
    func_407.Execute(  );

    // [425] Function call CfIdt
    func_425.input = func_1591.output[0];
    func_425.Execute(  );

    // [1866] Function call CfInputMultiplexer
    func_1866.inputSelect = BooleanToInt(func_1877.outputOR);
    func_1866.input[1-1] = BooleanToFloat(getCmPPA_TwinPumpCmd_input_10().getValue());
    func_1866.input[2-1] = 0F;
    func_1866.Execute(  );

    // [1867] Function call CfInputMultiplexer
    func_1867.inputSelect = BooleanToInt(func_1877.outputOR);
    func_1867.input[1-1] = BooleanToFloat(getCmPPA_TwinPumpCmd_input_3().getValue());
    func_1867.input[2-1] = 0F;
    func_1867.Execute(  );

    // [2043] Function call CfWindow
    func_2043.inputValue = func_2036.output[0];
    func_2043.inputMinimum = 4.8F;
    func_2043.inputMaximum = 5.2F;
    func_2043.Execute(  );

    // [2045] Function call CfAnd
    func_2045.input[0] = func_1174.output;
    func_2045.input[1] = func_2043.output;
    func_2045.Execute(  );

    // [2048] Function call CfAnd
    func_2048.input[0] = func_1046.output;
    func_2048.input[1] = func_2043.output;
    func_2048.Execute(  );

    // [2053] Function call CfInputMultiplexer
    func_2053.inputSelect = BooleanToInt(func_2045.outputAND);
    func_2053.input[1-1] = (float) getCmPPA_TwinPumpCmd_parameter_24();
    func_2053.input[2-1] = 0F;
    func_2053.Execute(  );
    setParameter(13, func_2053.output);

    // [2054] Function call CfInputMultiplexer
    func_2054.inputSelect = BooleanToInt(func_2048.outputAND);
    func_2054.input[1-1] = (float) getCmPPA_TwinPumpCmd_parameter_25();
    func_2054.input[2-1] = 0F;
    func_2054.Execute(  );
    setParameter(14, func_2054.output);

    // [505] Macro call CmPumpEnable
    func_505.CmPumpEnable_input_55 = register_11;
    func_505.CmPumpEnable_input_315 = func_2031.output;
    func_505.CmPumpEnable_input_51 = FloatToBoolean(func_1866.output);
    func_505.CmPumpEnable_input_300 = FloatToBoolean(func_1867.output);
    func_505.CmPumpEnable_input_56 = false;
    func_505.CmPumpEnable_input_57 = false;
    func_505.CmPumpEnable_input_58 = false;
    func_505.CmPumpEnable_input_59 = false;
    func_505.CmPumpEnable_input_223 = getCmPPA_TwinPumpCmd_input_8().getValue();
    func_505.CmPumpEnable_input_216 = func_888.outputOR;
    func_505.CmPumpEnable_input_217 = func_887.outputOR;
    func_505.CmPumpEnable_input_214 = func_158.CmTwinPumpMaintRun_output_4;
    func_505.CmPumpEnable_input_215 = func_158.CmTwinPumpMaintRun_output_5;
    func_505.CmPumpEnable_input_218 = func_858.outputOR;
    func_505.CmPumpEnable_input_219 = func_849.outputOR;
    func_505.Execute( this, 13 );

    // [541] Function call CfWindow
    func_541.inputValue = func_2036.output[0];
    func_541.inputMinimum = 2.8F;
    func_541.inputMaximum = 3.2F;
    func_541.Execute(  );

    // [532] Function call CfAnd
    func_532.input[0] = func_524.output;
    func_532.input[1] = func_541.output;
    func_532.Execute(  );

    // [528] Function call CfWindow
    func_528.inputValue = func_2036.output[0];
    func_528.inputMinimum = 1.8F;
    func_528.inputMaximum = 2.2F;
    func_528.Execute(  );

    // [540] Function call CfAnd
    func_540.input[0] = func_528.output;
    func_540.input[1] = func_524.output;
    func_540.Execute(  );

    // [545] Function call CfWindow
    func_545.inputValue = func_2036.output[0];
    func_545.inputMinimum = 3.8F;
    func_545.inputMaximum = 4.2F;
    func_545.Execute(  );

    // [881] Function call CfWindow
    func_881.inputValue = (float) getCmPPA_TwinPumpCmd_parameter_33();
    func_881.inputMinimum = -0.2F;
    func_881.inputMaximum = 0.2F;
    func_881.Execute(  );

    // [544] Function call CfAnd
    func_544.input[0] = func_881.output;
    func_544.input[1] = func_545.output;
    func_544.Execute(  );

    // [524] Function call CfWindow
    func_524.inputValue = (float) getCmPPA_TwinPumpCmd_parameter_33();
    func_524.inputMinimum = -0.2F;
    func_524.inputMaximum = 0.2F;
    func_524.Execute(  );

    // [888] Function call CfOr
    func_888.input[0] = func_540.outputAND;
    func_888.input[1] = func_544.outputAND;
    func_888.Execute(  );

    // [887] Function call CfOr
    func_887.input[0] = func_544.outputAND;
    func_887.input[1] = func_532.outputAND;
    func_887.Execute(  );

    // [849] Function call CfOr
    func_849.input[0] = func_833.outputAND;
    func_849.input[1] = func_852.outputAND;
    func_849.Execute(  );

    // [851] Function call CfWindow
    func_851.inputValue = func_2036.output[0];
    func_851.inputMinimum = 1.8F;
    func_851.inputMaximum = 2.2F;
    func_851.Execute(  );

    // [860] Function call CfWindow
    func_860.inputValue = func_2036.output[0];
    func_860.inputMinimum = 2.8F;
    func_860.inputMaximum = 3.2F;
    func_860.Execute(  );

    // [861] Function call CfAnd
    func_861.input[0] = func_860.output;
    func_861.input[1] = func_831.output;
    func_861.Execute(  );

    // [858] Function call CfOr
    func_858.input[0] = func_861.outputAND;
    func_858.input[1] = func_833.outputAND;
    func_858.Execute(  );

    // [852] Function call CfAnd
    func_852.input[0] = func_831.output;
    func_852.input[1] = func_851.output;
    func_852.Execute(  );

    // [833] Function call CfAnd
    func_833.input[0] = func_558.output;
    func_833.input[1] = func_831.output;
    func_833.Execute(  );

    // [831] Function call CfWindow
    func_831.inputValue = (float) getCmPPA_TwinPumpCmd_parameter_33();
    func_831.inputMinimum = -0.2F;
    func_831.inputMaximum = 0.2F;
    func_831.Execute(  );

    // [558] Function call CfWindow
    func_558.inputValue = func_2036.output[0];
    func_558.inputMinimum = -0.2F;
    func_558.inputMaximum = 1.2F;
    func_558.Execute(  );

    // [1046] Function call CfWindow
    func_1046.inputValue = (float) getCmPPA_TwinPumpCmd_parameter_31();
    func_1046.inputMinimum = 0.8F;
    func_1046.inputMaximum = 1.2F;
    func_1046.Execute(  );

    // [1174] Function call CfWindow
    func_1174.inputValue = (float) getCmPPA_TwinPumpCmd_parameter_31();
    func_1174.inputMinimum = -0.2F;
    func_1174.inputMaximum = 0.2F;
    func_1174.Execute(  );

    // [1210] Function call CfAddition
    func_1210.input[0] = (float) getCmPPA_TwinPumpCmd_parameter_32();
    func_1210.input[1] = (float) getCmPPA_TwinPumpCmd_parameter_24();
    func_1210.Execute(  );

    // [1098] Function call CfAddition
    func_1098.input[0] = func_1210.output;
    func_1098.input[1] = func_1552.output;
    func_1098.Execute(  );

    // [1099] Function call CfIdt
    func_1099.input = func_1098.output;
    func_1099.Execute(  );
    setParameter(32, func_1099.output[0]);
    setParameter(43, func_1099.output[1]);
    setParameter(25, func_1099.output[2]);
    setParameter(36, func_1099.output[3]);
    setParameter(92, func_1099.output[4]);

    // [1251] Function call CfIdt
    func_1251.input = func_1361.output;
    func_1251.Execute(  );
    setParameter(24, func_1251.output[0]);
    setParameter(35, func_1251.output[1]);

    // [1022] Function call CfLastValue
    func_1022.input = BooleanToFloat(func_505.CmPumpEnable_output_53);
    func_1022.Execute(  );

    // [1026] Function call CfCompare1
    func_1026.inputA = func_1022.outputCurrent;
    func_1026.inputB = func_1022.outputLast;
    func_1026.Execute(  );

    // [1248] Function call CfMonoflop
    func_1248.input = BooleanToFloat(func_1026.outputGreater);
    func_1248.Execute( this, 24 );

    // [1204] Function call CfMonoflop
    func_1204.input = BooleanToFloat(func_1026.outputGreater);
    func_1204.Execute( this, 25 );

    // [1488] Function call CfInputMultiplexer
    func_1488.inputSelect = BooleanToInt(func_505.CmPumpEnable_output_53);
    func_1488.input[1-1] = 0F;
    func_1488.input[2-1] = BooleanToFloat(func_1204.output);
    func_1488.Execute(  );

    // [1178] Function call CfDelayOnOff
    func_1178.input = FloatToBoolean(func_1488.output);
    func_1178.Execute( this, 26 );

    // [1940] Function call CfDelayOnOff
    func_1940.input = getCmPPA_TwinPumpCmd_output_13().getValue();
    func_1940.Execute( this, 28 );

    // [2006] Function call CfAnd
    func_2006.input[0] = func_1174.output;
    func_2006.input[1] = func_1940.output;
    func_2006.Execute(  );

    // [1175] Function call CfInputMultiplexer
    func_1175.inputSelect = BooleanToInt(func_2006.outputAND);
    func_1175.input[1-1] = BooleanToFloat(func_1248.output);
    func_1175.input[2-1] = BooleanToFloat(func_1178.output);
    func_1175.Execute(  );

    // [1213] Function call CfMonoflop
    func_1213.input = func_1175.output;
    func_1213.Execute( this, 30 );

    // [1037] Function call CfJkFlipFlop
    func_1037.inputSet = func_1213.output;
    func_1037.inputClock = false;
    func_1037.inputReset = FloatToBoolean(func_1044.output);
    func_1037.Execute(  );

    // [1038] Function call CfMonoflop
    func_1038.input = BooleanToFloat(func_1026.outputLess);
    func_1038.Execute( this, 31 );

    // [1056] Function call CfMonoflop
    func_1056.input = BooleanToFloat(func_1026.outputLess);
    func_1056.Execute( this, 32 );

    // [1055] Function call CfDelayOnOff
    func_1055.input = func_1056.output;
    func_1055.Execute( this, 33 );

    // [1044] Function call CfInputMultiplexer
    func_1044.inputSelect = BooleanToInt(func_1046.output);
    func_1044.input[1-1] = BooleanToFloat(func_1038.output);
    func_1044.input[2-1] = BooleanToFloat(func_1055.output);
    func_1044.Execute(  );

    // [1070] Function call CfLastValue
    func_1070.input = BooleanToFloat(func_505.CmPumpEnable_output_54);
    func_1070.Execute(  );

    // [1071] Function call CfCompare1
    func_1071.inputA = func_1070.outputCurrent;
    func_1071.inputB = func_1070.outputLast;
    func_1071.Execute(  );

    // [1253] Function call CfMonoflop
    func_1253.input = BooleanToFloat(func_1071.outputGreater);
    func_1253.Execute( this, 35 );

    // [1209] Function call CfMonoflop
    func_1209.input = BooleanToFloat(func_1071.outputGreater);
    func_1209.Execute( this, 36 );

    // [1486] Function call CfInputMultiplexer
    func_1486.inputSelect = BooleanToInt(func_505.CmPumpEnable_output_54);
    func_1486.input[1-1] = 0F;
    func_1486.input[2-1] = BooleanToFloat(func_1209.output);
    func_1486.Execute(  );

    // [1180] Function call CfDelayOnOff
    func_1180.input = FloatToBoolean(func_1486.output);
    func_1180.Execute( this, 37 );

    // [1943] Function call CfDelayOnOff
    func_1943.input = getCmPPA_TwinPumpCmd_output_12().getValue();
    func_1943.Execute( this, 39 );

    // [2011] Function call CfAnd
    func_2011.input[0] = func_1174.output;
    func_2011.input[1] = func_1943.output;
    func_2011.Execute(  );

    // [1181] Function call CfInputMultiplexer
    func_1181.inputSelect = BooleanToInt(func_2011.outputAND);
    func_1181.input[1-1] = BooleanToFloat(func_1253.output);
    func_1181.input[2-1] = BooleanToFloat(func_1180.output);
    func_1181.Execute(  );

    // [1216] Function call CfMonoflop
    func_1216.input = func_1181.output;
    func_1216.Execute( this, 41 );

    // [1076] Function call CfJkFlipFlop
    func_1076.inputSet = func_1216.output;
    func_1076.inputClock = false;
    func_1076.inputReset = FloatToBoolean(func_1069.output);
    func_1076.Execute(  );

    // [1949] Function call CfWindow
    func_1949.inputValue = (float) getCmPPA_TwinPumpCmd_parameter_33();
    func_1949.inputMinimum = -0.2F;
    func_1949.inputMaximum = 0.2F;
    func_1949.Execute(  );

    // [1950] Function call CfWindow
    func_1950.inputValue = func_2036.output[0];
    func_1950.inputMinimum = -0.2F;
    func_1950.inputMaximum = 4.2F;
    func_1950.Execute(  );

    // [1951] Function call CfAnd
    func_1951.input[0] = func_1949.output;
    func_1951.input[1] = func_1950.output;
    func_1951.Execute(  );

    // [1959] Function call CfOr
    func_1959.input[0] = FloatToBoolean(func_1567.output[0]);
    func_1959.input[1] = FloatToBoolean(func_1573.output[2]);
    func_1959.input[2] = getCmPPA_TwinPumpCmd_output_19().getValue();
    func_1959.input[3] = func_57.CmAlarms_output_98;
    func_1959.Execute(  );

    // [1958] Function call CfAnd
    func_1958.input[0] = func_1951.outputNAND;
    func_1958.input[1] = func_1959.outputOR;
    func_1958.input[2] = func_1037.output;
    func_1958.Execute(  );

    // [1962] Function call CfInputMultiplexer
    func_1962.inputSelect = BooleanToInt(func_1958.outputAND);
    func_1962.input[1-1] = BooleanToFloat(func_1076.output);
    func_1962.input[2-1] = BooleanToFloat(func_1958.outputAND);
    func_1962.Execute(  );

    // [1999] Function call CfAnd
    func_1999.input[0] = func_1951.outputNAND;
    func_1999.input[1] = func_1970.outputOR;
    func_1999.Execute(  );

    // [1964] Function call CfAnd
    func_1964.input[0] = FloatToBoolean(func_1962.output);
    func_1964.input[1] = func_1999.outputNAND;
    func_1964.Execute(  );
    setCmPPA_TwinPumpCmd_output_13(func_1964.outputAND);

    // [1970] Function call CfOr
    func_1970.input[0] = FloatToBoolean(func_1591.output[0]);
    func_1970.input[1] = FloatToBoolean(func_1590.output[2]);
    func_1970.input[2] = getCmPPA_TwinPumpCmd_output_20().getValue();
    func_1970.input[3] = func_58.CmAlarms_output_98;
    func_1970.Execute(  );

    // [1969] Function call CfAnd
    func_1969.input[0] = func_1951.outputNAND;
    func_1969.input[1] = func_1970.outputOR;
    func_1969.input[2] = func_1076.output;
    func_1969.Execute(  );

    // [1971] Function call CfInputMultiplexer
    func_1971.inputSelect = BooleanToInt(func_1969.outputAND);
    func_1971.input[1-1] = BooleanToFloat(func_1037.output);
    func_1971.input[2-1] = BooleanToFloat(func_1969.outputAND);
    func_1971.Execute(  );

    // [2003] Function call CfAnd
    func_2003.input[0] = func_1951.outputNAND;
    func_2003.input[1] = func_1959.outputOR;
    func_2003.Execute(  );

    // [1972] Function call CfAnd
    func_1972.input[0] = func_2003.outputNAND;
    func_1972.input[1] = FloatToBoolean(func_1971.output);
    func_1972.Execute(  );
    setCmPPA_TwinPumpCmd_output_12(func_1972.outputAND);

    // [1074] Function call CfMonoflop
    func_1074.input = BooleanToFloat(func_1071.outputLess);
    func_1074.Execute( this, 42 );

    // [1072] Function call CfMonoflop
    func_1072.input = BooleanToFloat(func_1071.outputLess);
    func_1072.Execute( this, 43 );

    // [1073] Function call CfDelayOnOff
    func_1073.input = func_1072.output;
    func_1073.Execute( this, 44 );

    // [1069] Function call CfInputMultiplexer
    func_1069.inputSelect = BooleanToInt(func_1046.output);
    func_1069.input[1-1] = BooleanToFloat(func_1074.output);
    func_1069.input[2-1] = BooleanToFloat(func_1073.output);
    func_1069.Execute(  );

    // [1400] Function call CfWindow
    func_1400.inputValue = func_2036.output[0];
    func_1400.inputMinimum = -0.2F;
    func_1400.inputMaximum = 1.2F;
    func_1400.Execute(  );

    // [1404] Function call CfWindow
    func_1404.inputValue = func_2036.output[0];
    func_1404.inputMinimum = 1.8F;
    func_1404.inputMaximum = 3.2F;
    func_1404.Execute(  );

    // [1408] Function call CfWindow
    func_1408.inputValue = func_2036.output[0];
    func_1408.inputMinimum = 3.8F;
    func_1408.inputMaximum = 4.2F;
    func_1408.Execute(  );

    // [1412] Function call CfOr
    func_1412.input[0] = FloatToBoolean(func_1567.output[0]);
    func_1412.input[1] = getCmPPA_TwinPumpCmd_output_17().getValue();
    func_1412.input[2] = getCmPPA_TwinPumpCmd_output_19().getValue();
    func_1412.input[3] = FloatToBoolean(func_1591.output[0]);
    func_1412.input[4] = getCmPPA_TwinPumpCmd_output_18().getValue();
    func_1412.input[5] = getCmPPA_TwinPumpCmd_output_20().getValue();
    func_1412.input[6] = getCmPPA_TwinPumpCmd_output_21().getValue();
    func_1412.Execute(  );

    // [1422] Function call CfOr
    func_1422.input[0] = func_1408.output;
    func_1422.input[1] = getCmPPA_TwinPumpCmd_input_3().getValue();
    func_1422.Execute(  );

    // [1398] Function call CfInputMultiplexer
    func_1398.inputSelect = BooleanToInt(func_158.CmTwinPumpMaintRun_output_4);
    func_1398.input[1-1] = 15F;
    func_1398.input[2-1] = 11F;
    func_1398.Execute(  );

    // [1399] Function call CfInputMultiplexer
    func_1399.inputSelect = BooleanToInt(func_158.CmTwinPumpMaintRun_output_5);
    func_1399.input[1-1] = func_1398.output;
    func_1399.input[2-1] = 11F;
    func_1399.Execute(  );

    // [1401] Function call CfInputMultiplexer
    func_1401.inputSelect = BooleanToInt(func_1400.output);
    func_1401.input[1-1] = func_1399.output;
    func_1401.input[2-1] = 7F;
    func_1401.Execute(  );

    // [1405] Function call CfInputMultiplexer
    func_1405.inputSelect = BooleanToInt(func_1404.output);
    func_1405.input[1-1] = func_1401.output;
    func_1405.input[2-1] = 12F;
    func_1405.Execute(  );

    // [1409] Function call CfInputMultiplexer
    func_1409.inputSelect = BooleanToInt(func_1422.outputOR);
    func_1409.input[1-1] = func_1405.output;
    func_1409.input[2-1] = 13F;
    func_1409.Execute(  );

    // [1420] Function call CfInputMultiplexer
    func_1420.inputSelect = BooleanToInt(func_1412.outputOR);
    func_1420.input[1-1] = func_1409.output;
    func_1420.input[2-1] = 8F;
    func_1420.Execute(  );
    setCmPPA_TwinPumpCmd_output_981(func_1420.output);

    // [118] Macro call CmDateTimePulse
    func_118.Execute( this, 46 );

    // [150] Function call CfWindow
    func_150.inputValue = (float) getCmPPA_TwinPumpCmd_parameter_39();
    func_150.inputMinimum = 0.8F;
    func_150.inputMaximum = 2.2F;
    func_150.Execute(  );

    // [497] Function call CfWindow
    func_497.inputValue = (float) getCmPPA_TwinPumpCmd_parameter_26();
    func_497.inputMinimum = 0.8F;
    func_497.inputMaximum = 2.2F;
    func_497.Execute(  );

    // [1567] Function call CfIdt
    func_1567.input = BooleanToFloat(func_57.CmAlarms_output_5);
    func_1567.Execute(  );

    // [1573] Function call CfIdt
    func_1573.input = BooleanToFloat(func_57.CmAlarms_output_6);
    func_1573.Execute(  );

    // [1590] Function call CfIdt
    func_1590.input = BooleanToFloat(func_58.CmAlarms_output_6);
    func_1590.Execute(  );

    // [1591] Function call CfIdt
    func_1591.input = BooleanToFloat(func_58.CmAlarms_output_5);
    func_1591.Execute(  );

    // [1594] Function call CfWindow
    func_1594.inputValue = (float) getCmPPA_TwinPumpCmd_parameter_34();
    func_1594.inputMinimum = 0.8F;
    func_1594.inputMaximum = 1.2F;
    func_1594.Execute(  );

    // [1599] Function call CfInputMultiplexer
    func_1599.inputSelect = FloatToInt((float) getCmPPA_TwinPumpCmd_parameter_34());
    func_1599.input[1-1] = 0F;
    func_1599.input[2-1] = 2F;
    func_1599.input[3-1] = 2F;
    func_1599.Execute(  );

    // [1619] Function call CfWindow
    func_1619.inputValue = (float) getCmPPA_TwinPumpCmd_parameter_34();
    func_1619.inputMinimum = 0.8F;
    func_1619.inputMaximum = 1.2F;
    func_1619.Execute(  );

    // [1632] Function call CfInputMultiplexer
    func_1632.inputSelect = FloatToInt((float) getCmPPA_TwinPumpCmd_parameter_36());
    func_1632.input[1-1] = 0F;
    func_1632.input[2-1] = 1F;
    func_1632.Execute(  );

    // [1650] Function call CfLastValue
    func_1650.input = BooleanToFloat(getCmPPA_TwinPumpCmd_input_10().getValue());
    func_1650.Execute(  );

    // [1667] Function call CfLastValue
    func_1667.input = BooleanToFloat(getCmPPA_TwinPumpCmd_input_4().getValue());
    func_1667.Execute(  );

    // [1673] Function call CfLastValue
    func_1673.input = BooleanToFloat(getCmPPA_TwinPumpCmd_input_5().getValue());
    func_1673.Execute(  );

    // [1744] Function call CfWindow
    func_1744.inputValue = func_2036.output[0];
    func_1744.inputMinimum = -0.2F;
    func_1744.inputMaximum = 1.2F;
    func_1744.Execute(  );

    // [1574] Function call CfOr
    func_1574.input[0] = FloatToBoolean(func_1567.output[1]);
    func_1574.input[1] = FloatToBoolean(func_1573.output[0]);
    func_1574.Execute(  );

    // [1592] Function call CfOr
    func_1592.input[0] = FloatToBoolean(func_1591.output[1]);
    func_1592.input[1] = FloatToBoolean(func_1590.output[0]);
    func_1592.Execute(  );

    // [1617] Function call CfInputMultiplexer
    func_1617.inputSelect = BooleanToInt(func_1594.output);
    func_1617.input[1-1] = func_1590.output[1];
    func_1617.input[2-1] = 0F;
    func_1617.Execute(  );
    setCmPPA_TwinPumpCmd_output_18(FloatToBoolean(func_1617.output));

    // [1618] Function call CfInputMultiplexer
    func_1618.inputSelect = BooleanToInt(func_1594.output);
    func_1618.input[1-1] = func_1573.output[1];
    func_1618.input[2-1] = 0F;
    func_1618.Execute(  );
    setCmPPA_TwinPumpCmd_output_17(FloatToBoolean(func_1618.output));

    // [1620] Function call CfInputMultiplexer
    func_1620.inputSelect = BooleanToInt(func_1619.output);
    func_1620.input[1-1] = func_407.output[1];
    func_1620.input[2-1] = 0F;
    func_1620.Execute(  );
    setCmPPA_TwinPumpCmd_output_15(FloatToBoolean(func_1620.output));

    // [1621] Function call CfInputMultiplexer
    func_1621.inputSelect = BooleanToInt(func_1619.output);
    func_1621.input[1-1] = func_425.output[1];
    func_1621.input[2-1] = 0F;
    func_1621.Execute(  );
    setCmPPA_TwinPumpCmd_output_16(FloatToBoolean(func_1621.output));

    // [1651] Function call CfCompare1
    func_1651.inputA = func_1650.outputCurrent;
    func_1651.inputB = func_1650.outputLast;
    func_1651.Execute(  );

    // [1668] Function call CfCompare1
    func_1668.inputA = func_1667.outputCurrent;
    func_1668.inputB = func_1667.outputLast;
    func_1668.Execute(  );

    // [1672] Function call CfCompare1
    func_1672.inputA = func_1673.outputCurrent;
    func_1672.inputB = func_1673.outputLast;
    func_1672.Execute(  );

    // [1746] Function call CfMonoflop
    func_1746.input = BooleanToFloat(func_1744.output);
    func_1746.Execute( this, 53 );

    // [1575] Function call CfAnd
    func_1575.input[0] = func_1594.output;
    func_1575.input[1] = func_1574.outputOR;
    func_1575.Execute(  );
    setCmPPA_TwinPumpCmd_output_19(func_1575.outputAND);

    // [1593] Function call CfAnd
    func_1593.input[0] = func_1594.output;
    func_1593.input[1] = func_1592.outputOR;
    func_1593.Execute(  );
    setCmPPA_TwinPumpCmd_output_20(func_1593.outputAND);

    // [1681] Function call CfAnd
    func_1681.input[0] = FloatToBoolean(func_1573.output[2]);
    func_1681.input[1] = func_1668.outputLess;
    func_1681.Execute(  );

    // [1682] Function call CfAnd
    func_1682.input[0] = FloatToBoolean(func_1590.output[2]);
    func_1682.input[1] = func_1672.outputLess;
    func_1682.Execute(  );

    // [494] Macro call CmLeadPumpAutoMode
    func_494.CmLeadPumpAutoMode_input_89 = func_1877.outputOR;
    func_494.CmLeadPumpAutoMode_input_94 = func_118.CmDateTimePulse_output_216;
    func_494.CmLeadPumpAutoMode_input_95 = func_118.CmDateTimePulse_output_215;
    func_494.CmLeadPumpAutoMode_input_223 = func_492.CmPumpRuntimeChange_output_54;
    func_494.Execute( this, 54 );
    register_11 = func_494.CmLeadPumpAutoMode_output_92;

    // [492] Macro call CmPumpRuntimeChange
    if ( func_497.output)
    {
      func_492.CmPumpRuntimeChange_input_53 = register_11;
      func_492.CmPumpRuntimeChange_input_56 = getCmPPA_TwinPumpCmd_output_12().getValue();
      func_492.CmPumpRuntimeChange_input_57 = getCmPPA_TwinPumpCmd_input_4().getValue();
      func_492.CmPumpRuntimeChange_input_58 = getCmPPA_TwinPumpCmd_output_13().getValue();
      func_492.CmPumpRuntimeChange_input_59 = getCmPPA_TwinPumpCmd_input_5().getValue();
      func_492.Execute( this, 61 );
    }

    // [1440] Function call CfInputMultiplexer
    func_1440.inputSelect = FloatToInt(register_11);
    func_1440.input[1-1] = 0F;
    func_1440.input[2-1] = 12F;
    func_1440.input[3-1] = 21F;
    func_1440.Execute(  );
    setCmPPA_TwinPumpCmd_output_1439(func_1440.output);

    // [1645] Function call CfOr
    func_1645.input[0] = func_494.CmLeadPumpAutoMode_output_280;
    func_1645.input[1] = func_1651.outputLess;
    func_1645.input[2] = func_1681.outputAND;
    func_1645.input[3] = func_1682.outputAND;
    func_1645.input[4] = func_1746.output;
    func_1645.Execute(  );

    // [1851] Function call CfCompare1
    func_1851.inputA = 1F;
    func_1851.inputB = (float) getCmPPA_TwinPumpCmd_parameter_36();
    func_1851.Execute(  );

    // [1640] Function call CfAnd
    func_1640.input[0] = getCmPPA_TwinPumpCmd_output_21().getValue();
    func_1640.input[1] = func_1851.outputEqual;
    func_1640.input[2] = func_1645.outputOR;
    func_1640.Execute(  );

    // [1842] Function call CfLastValue
    func_1842.input = BooleanToFloat(getCmPPA_TwinPumpCmd_input_9().getValue());
    func_1842.Execute(  );

    // [1845] Function call CfAnd
    func_1845.input[0] = FloatToBoolean(func_1842.outputCurrent);
    func_1845.input[1] = FloatToBoolean(func_1842.outputLast);
    func_1845.Execute(  );

    // [1841] Macro call CmLimited_auto_reset
    func_1841.CmLimited_auto_reset_input_1 = getCmPPA_TwinPumpCmd_output_21().getValue();
    func_1841.CmLimited_auto_reset_input_2 = (float) getCmPPA_TwinPumpCmd_parameter_36();
    func_1841.CmLimited_auto_reset_input_3 = (float) getCmPPA_TwinPumpCmd_parameter_1840();
    func_1841.CmLimited_auto_reset_input_4 = getCmPPA_TwinPumpCmd_input_9().getValue();
    func_1841.Execute(  );
    setCmPPA_TwinPumpCmd_parameter_1840(func_1841.CmLimited_auto_reset_output_5);

    // [1853] Function call CfCompare1
    func_1853.inputA = 0F;
    func_1853.inputB = (float) getCmPPA_TwinPumpCmd_parameter_1840();
    func_1853.Execute(  );

    // [1637] Function call CfOr
    func_1637.input[0] = func_1845.outputAND;
    func_1637.input[1] = func_1640.outputAND;
    func_1637.input[2] = func_1853.outputGreater;
    func_1637.Execute(  );

    // [158] Macro call CmTwinPumpMaintRun
    if ( func_163.outputOR)
    {
      func_158.CmTwinPumpMaintRun_input_1 = getCmPPA_TwinPumpCmd_output_12().getValue();
      func_158.CmTwinPumpMaintRun_input_22 = getCmPPA_TwinPumpCmd_input_4().getValue();
      func_158.CmTwinPumpMaintRun_input_2 = getCmPPA_TwinPumpCmd_output_13().getValue();
      func_158.CmTwinPumpMaintRun_input_23 = getCmPPA_TwinPumpCmd_input_5().getValue();
      func_158.CmTwinPumpMaintRun_input_3 = register_11;
      func_158.Execute( this, 66 );
    }

    // [163] Function call CfOr
    func_163.input[0] = func_150.output;
    func_163.input[1] = func_158.CmTwinPumpMaintRun_output_4;
    func_163.input[2] = func_158.CmTwinPumpMaintRun_output_5;
    func_163.input[3] = func_158.CmTwinPumpMaintRun_output_79;
    func_163.input[4] = func_158.CmTwinPumpMaintRun_output_80;
    func_163.Execute(  );

    // [1536] Function call CfWindow
    func_1536.inputValue = func_2036.output[0];
    func_1536.inputMinimum = -0.2F;
    func_1536.inputMaximum = 0.2F;
    func_1536.Execute(  );

    // [1551] Macro call CmCycleTime
    func_1551.Execute(  );

    // [1705] Function call CfLastValue
    func_1705.input = BooleanToFloat(getCmPPA_TwinPumpCmd_input_10().getValue());
    func_1705.Execute(  );

    // [1749] Function call CfWindow
    func_1749.inputValue = func_2036.output[0];
    func_1749.inputMinimum = 3.8F;
    func_1749.inputMaximum = 4.2F;
    func_1749.Execute(  );

    // [1548] Function call CfMonoflop
    func_1548.input = BooleanToFloat(func_1536.output);
    func_1548.Execute( this, 89 );

    // [1552] Function call CfMultiply
    func_1552.input[0] = 2F;
    func_1552.input[1] = func_1551.CmCycleTime_output_1;
    func_1552.Execute(  );

    // [1708] Function call CfCompare1
    func_1708.inputA = func_1705.outputCurrent;
    func_1708.inputB = func_1705.outputLast;
    func_1708.Execute(  );

    // [1753] Function call CfDelayOnOff
    func_1753.input = func_1749.output;
    func_1753.Execute( this, 90 );

    // [1361] Function call CfAddition
    func_1361.input[0] = func_1552.output;
    func_1361.input[1] = (float) getCmPPA_TwinPumpCmd_parameter_24();
    func_1361.Execute(  );

    // [1545] Function call CfOr
    func_1545.input[0] = func_1548.output;
    func_1545.input[1] = func_1708.outputLess;
    func_1545.input[2] = func_1753.output;
    func_1545.Execute(  );

    // [1549] Function call CfAddition
    func_1549.input[0] = (float) getCmPPA_TwinPumpCmd_parameter_25();
    func_1549.input[1] = func_1552.output;
    func_1549.Execute(  );

    // [1535] Function call CfAnd
    func_1535.input[0] = func_1046.output;
    func_1535.input[1] = func_1545.outputOR;
    func_1535.Execute(  );

    // [1754] Function call CfIdt
    func_1754.input = func_1549.output;
    func_1754.Execute(  );
    setParameter(91, func_1754.output[1]);

    // [1945] Function call CfAddition
    func_1945.input[0] = func_1552.output;
    func_1945.input[1] = (float) getCmPPA_TwinPumpCmd_parameter_32();
    func_1945.Execute(  );

    // [1948] Function call CfIdt
    func_1948.input = func_1945.output;
    func_1948.Execute(  );
    setParameter(29, func_1948.output[0]);
    setParameter(40, func_1948.output[1]);

    // [1547] Function call CfInputMultiplexer
    func_1547.inputSelect = BooleanToInt(func_1535.outputAND);
    func_1547.input[1-1] = func_1210.output;
    func_1547.input[2-1] = 0F;
    func_1547.Execute(  );

    // [1546] Function call CfIdt
    func_1546.input = func_1547.output;
    func_1546.Execute(  );
    setParameter(33, func_1546.output[0]);
    setParameter(44, func_1546.output[1]);

    // [2018] Function call CfLastValue
    func_2018.input = (float) getCmPPA_TwinPumpCmd_input_1().getValue();
    func_2018.Execute(  );

    // [2021] Function call CfCompare1
    func_2021.inputA = func_2018.outputCurrent;
    func_2021.inputB = func_2018.outputLast;
    func_2021.Execute(  );

    // [2025] Function call CfNot
    func_2025.input = func_2021.outputEqual;
    func_2025.Execute(  );

    // [2015] Function call CfMonoflop
    func_2015.input = BooleanToFloat(func_2025.output);
    func_2015.Execute( this, 92 );

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    30F, 60F, 1F, 1F, 10F, 10F, 1F, 60F,
    1F, 1F, 10F, 10F, 1F, 0F, 0F, 0F,
    0F, 5F, 0F, 5F, 10F, 10F, 10F, 10F,
    1F, 1F, 10F, 10F, 0F, 10F, 2F, 1F,
    3F, 10F, 0F, 1F, 1F, 10F, 10F, 0F,
    10F, 2F, 1F, 3F, 10F, 0F, 1F, 1F,
    1000F, 10F, 501F, 901F, 10F, 5F, 1F, 3F,
    1000F, 0F, 0F, 5F, 5F, 100F, 0F, 0F,
    0F, 5F, 168F, 120F, 1F, 0F, 10F, 0F,
    0F, 168F, 120F, 1800F, 0F, 120F, 0F, 0F,
    168F, 120F, 1800F, 0F, 120F, 2F, 0F, 2F,
    0F, 3F, 0F, 10F, 3F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  protected float register_11 = 0;
  // macro outputs
// Pmp1Cmd
  public static final Property CmPPA_TwinPumpCmd_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_output_12() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_output_12); }
  public void setCmPPA_TwinPumpCmd_output_12(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_output_12,v,null); }
  public void setCmPPA_TwinPumpCmd_output_12(boolean v) { getCmPPA_TwinPumpCmd_output_12().setValue(v); }
// Pmp2Cmd
  public static final Property CmPPA_TwinPumpCmd_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_output_13() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_output_13); }
  public void setCmPPA_TwinPumpCmd_output_13(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_output_13,v,null); }
  public void setCmPPA_TwinPumpCmd_output_13(boolean v) { getCmPPA_TwinPumpCmd_output_13().setValue(v); }
// PumpPref
  public static final Property CmPPA_TwinPumpCmd_output_1439 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPPA_TwinPumpCmd_output_1439() { return (BStatusNumeric) get(CmPPA_TwinPumpCmd_output_1439); }
  public void setCmPPA_TwinPumpCmd_output_1439(BStatusNumeric v) { set(CmPPA_TwinPumpCmd_output_1439,v,null); }
  public void setCmPPA_TwinPumpCmd_output_1439(float v) { getCmPPA_TwinPumpCmd_output_1439().setValue(v); }
// OffAlarm1
  public static final Property CmPPA_TwinPumpCmd_output_15 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_output_15() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_output_15); }
  public void setCmPPA_TwinPumpCmd_output_15(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_output_15,v,null); }
  public void setCmPPA_TwinPumpCmd_output_15(boolean v) { getCmPPA_TwinPumpCmd_output_15().setValue(v); }
// OffAlarm2
  public static final Property CmPPA_TwinPumpCmd_output_16 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_output_16() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_output_16); }
  public void setCmPPA_TwinPumpCmd_output_16(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_output_16,v,null); }
  public void setCmPPA_TwinPumpCmd_output_16(boolean v) { getCmPPA_TwinPumpCmd_output_16().setValue(v); }
// OnAlarm1
  public static final Property CmPPA_TwinPumpCmd_output_17 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_output_17() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_output_17); }
  public void setCmPPA_TwinPumpCmd_output_17(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_output_17,v,null); }
  public void setCmPPA_TwinPumpCmd_output_17(boolean v) { getCmPPA_TwinPumpCmd_output_17().setValue(v); }
// OnAlarm2
  public static final Property CmPPA_TwinPumpCmd_output_18 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_output_18() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_output_18); }
  public void setCmPPA_TwinPumpCmd_output_18(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_output_18,v,null); }
  public void setCmPPA_TwinPumpCmd_output_18(boolean v) { getCmPPA_TwinPumpCmd_output_18().setValue(v); }
// FailCmdAlarm1
  public static final Property CmPPA_TwinPumpCmd_output_19 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_output_19() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_output_19); }
  public void setCmPPA_TwinPumpCmd_output_19(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_output_19,v,null); }
  public void setCmPPA_TwinPumpCmd_output_19(boolean v) { getCmPPA_TwinPumpCmd_output_19().setValue(v); }
// FailCmdAlarm2
  public static final Property CmPPA_TwinPumpCmd_output_20 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_output_20() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_output_20); }
  public void setCmPPA_TwinPumpCmd_output_20(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_output_20,v,null); }
  public void setCmPPA_TwinPumpCmd_output_20(boolean v) { getCmPPA_TwinPumpCmd_output_20().setValue(v); }
// CommAlarm
  public static final Property CmPPA_TwinPumpCmd_output_21 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_output_21() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_output_21); }
  public void setCmPPA_TwinPumpCmd_output_21(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_output_21,v,null); }
  public void setCmPPA_TwinPumpCmd_output_21(boolean v) { getCmPPA_TwinPumpCmd_output_21().setValue(v); }
// OperationMode
  public static final Property CmPPA_TwinPumpCmd_output_981 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPPA_TwinPumpCmd_output_981() { return (BStatusNumeric) get(CmPPA_TwinPumpCmd_output_981); }
  public void setCmPPA_TwinPumpCmd_output_981(BStatusNumeric v) { set(CmPPA_TwinPumpCmd_output_981,v,null); }
  public void setCmPPA_TwinPumpCmd_output_981(float v) { getCmPPA_TwinPumpCmd_output_981().setValue(v); }

  // macro parameter
// CMD-01: pump start-up delay
  public static final Property CmPPA_TwinPumpCmd_parameter_24 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPPA_TwinPumpCmd_parameter_24() { return getDouble(CmPPA_TwinPumpCmd_parameter_24); }
  public void setCmPPA_TwinPumpCmd_parameter_24(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_24,v,null); }
// CMD-02: pump switch off delay
  public static final Property CmPPA_TwinPumpCmd_parameter_25 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPPA_TwinPumpCmd_parameter_25() { return getDouble(CmPPA_TwinPumpCmd_parameter_25); }
  public void setCmPPA_TwinPumpCmd_parameter_25(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_25,v,null); }
// SYS-01: type of preference change
  public static final Property CmPPA_TwinPumpCmd_parameter_26 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPPA_TwinPumpCmd_parameter_26() { return getDouble(CmPPA_TwinPumpCmd_parameter_26); }
  public void setCmPPA_TwinPumpCmd_parameter_26(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_26,v,null); }
// SYS-02: period of preference change
  public static final Property CmPPA_TwinPumpCmd_parameter_27 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPPA_TwinPumpCmd_parameter_27() { return getDouble(CmPPA_TwinPumpCmd_parameter_27); }
  public void setCmPPA_TwinPumpCmd_parameter_27(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_27,v,null); }
// SYS-03: day of preference change
  public static final Property CmPPA_TwinPumpCmd_parameter_28 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(31)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmPPA_TwinPumpCmd_parameter_28() { return getDouble(CmPPA_TwinPumpCmd_parameter_28); }
  public void setCmPPA_TwinPumpCmd_parameter_28(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_28,v,null); }
// SYS-04: time of preference change (hhmm)
  public static final Property CmPPA_TwinPumpCmd_parameter_29 = newProperty( 0, BDouble.make( 1000 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2359)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPPA_TwinPumpCmd_parameter_29() { return getDouble(CmPPA_TwinPumpCmd_parameter_29); }
  public void setCmPPA_TwinPumpCmd_parameter_29(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_29,v,null); }
// SYS-05: difference in run-times between pumps
  public static final Property CmPPA_TwinPumpCmd_parameter_30 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(999999)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmPPA_TwinPumpCmd_parameter_30() { return getDouble(CmPPA_TwinPumpCmd_parameter_30); }
  public void setCmPPA_TwinPumpCmd_parameter_30(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_30,v,null); }
// SYS-06: take over type
  public static final Property CmPPA_TwinPumpCmd_parameter_31 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPPA_TwinPumpCmd_parameter_31() { return getDouble(CmPPA_TwinPumpCmd_parameter_31); }
  public void setCmPPA_TwinPumpCmd_parameter_31(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_31,v,null); }
// SYS-07: take over time
  public static final Property CmPPA_TwinPumpCmd_parameter_32 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPPA_TwinPumpCmd_parameter_32() { return getDouble(CmPPA_TwinPumpCmd_parameter_32); }
  public void setCmPPA_TwinPumpCmd_parameter_32(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_32,v,null); }
// SYS-08: type of switch
  public static final Property CmPPA_TwinPumpCmd_parameter_33 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPPA_TwinPumpCmd_parameter_33() { return getDouble(CmPPA_TwinPumpCmd_parameter_33); }
  public void setCmPPA_TwinPumpCmd_parameter_33(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_33,v,null); }
// ALM-01: delay status alarm
  public static final Property CmPPA_TwinPumpCmd_parameter_35 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPPA_TwinPumpCmd_parameter_35() { return getDouble(CmPPA_TwinPumpCmd_parameter_35); }
  public void setCmPPA_TwinPumpCmd_parameter_35(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_35,v,null); }
// ALM-02: alarm reset type <0limauto 0=manu 1=auto
  public static final Property CmPPA_TwinPumpCmd_parameter_36 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(-1000)) ));
  public double getCmPPA_TwinPumpCmd_parameter_36() { return getDouble(CmPPA_TwinPumpCmd_parameter_36); }
  public void setCmPPA_TwinPumpCmd_parameter_36(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_36,v,null); }
// ALM-03: status alarm type
  public static final Property CmPPA_TwinPumpCmd_parameter_34 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPPA_TwinPumpCmd_parameter_34() { return getDouble(CmPPA_TwinPumpCmd_parameter_34); }
  public void setCmPPA_TwinPumpCmd_parameter_34(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_34,v,null); }
// PEX-01: pump exercise period
  public static final Property CmPPA_TwinPumpCmd_parameter_37 = newProperty( 0, BDouble.make( 168 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmPPA_TwinPumpCmd_parameter_37() { return getDouble(CmPPA_TwinPumpCmd_parameter_37); }
  public void setCmPPA_TwinPumpCmd_parameter_37(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_37,v,null); }
// PEX-02: pump exercise time
  public static final Property CmPPA_TwinPumpCmd_parameter_38 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPPA_TwinPumpCmd_parameter_38() { return getDouble(CmPPA_TwinPumpCmd_parameter_38); }
  public void setCmPPA_TwinPumpCmd_parameter_38(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_38,v,null); }
// PEX-03: pump exercise type
  public static final Property CmPPA_TwinPumpCmd_parameter_39 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPPA_TwinPumpCmd_parameter_39() { return getDouble(CmPPA_TwinPumpCmd_parameter_39); }
  public void setCmPPA_TwinPumpCmd_parameter_39(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_39,v,null); }
// DISP-01: hours run since preference change: pump PC1
  public static final Property CmPPA_TwinPumpCmd_parameter_40 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmPPA_TwinPumpCmd_parameter_40() { return getDouble(CmPPA_TwinPumpCmd_parameter_40); }
  public void setCmPPA_TwinPumpCmd_parameter_40(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_40,v,null); }
// DISP-02: hours run since preference change: pump PC2
  public static final Property CmPPA_TwinPumpCmd_parameter_41 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmPPA_TwinPumpCmd_parameter_41() { return getDouble(CmPPA_TwinPumpCmd_parameter_41); }
  public void setCmPPA_TwinPumpCmd_parameter_41(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_41,v,null); }
// DISP-03: ALM-02 countdown
  public static final Property CmPPA_TwinPumpCmd_parameter_1840 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPPA_TwinPumpCmd_parameter_1840() { return getDouble(CmPPA_TwinPumpCmd_parameter_1840); }
  public void setCmPPA_TwinPumpCmd_parameter_1840(double v) { setDouble(CmPPA_TwinPumpCmd_parameter_1840,v,null); }

  // macro inputs
// ManSwCond
  public static final Property CmPPA_TwinPumpCmd_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 5 ), null);
  public BStatusNumeric getCmPPA_TwinPumpCmd_input_1() { return (BStatusNumeric) get(CmPPA_TwinPumpCmd_input_1); }
  public void setCmPPA_TwinPumpCmd_input_1(BStatusNumeric v) { set(CmPPA_TwinPumpCmd_input_1,v,null); }
  public void setCmPPA_TwinPumpCmd_input_1(float v) { getCmPPA_TwinPumpCmd_input_1().setValue(v); }
// Enable2Pumps
  public static final Property CmPPA_TwinPumpCmd_input_3 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_input_3() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_input_3); }
  public void setCmPPA_TwinPumpCmd_input_3(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_input_3,v,null); }
  public void setCmPPA_TwinPumpCmd_input_3(boolean v) { getCmPPA_TwinPumpCmd_input_3().setValue(v); }
// Status1
  public static final Property CmPPA_TwinPumpCmd_input_4 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_input_4() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_input_4); }
  public void setCmPPA_TwinPumpCmd_input_4(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_input_4,v,null); }
  public void setCmPPA_TwinPumpCmd_input_4(boolean v) { getCmPPA_TwinPumpCmd_input_4().setValue(v); }
// Status2
  public static final Property CmPPA_TwinPumpCmd_input_5 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_input_5() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_input_5); }
  public void setCmPPA_TwinPumpCmd_input_5(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_input_5,v,null); }
  public void setCmPPA_TwinPumpCmd_input_5(boolean v) { getCmPPA_TwinPumpCmd_input_5().setValue(v); }
// Alarm1
  public static final Property CmPPA_TwinPumpCmd_input_6 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_input_6() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_input_6); }
  public void setCmPPA_TwinPumpCmd_input_6(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_input_6,v,null); }
  public void setCmPPA_TwinPumpCmd_input_6(boolean v) { getCmPPA_TwinPumpCmd_input_6().setValue(v); }
// Alarm2
  public static final Property CmPPA_TwinPumpCmd_input_7 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_input_7() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_input_7); }
  public void setCmPPA_TwinPumpCmd_input_7(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_input_7,v,null); }
  public void setCmPPA_TwinPumpCmd_input_7(boolean v) { getCmPPA_TwinPumpCmd_input_7().setValue(v); }
// PowerDmdOff
  public static final Property CmPPA_TwinPumpCmd_input_8 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_input_8() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_input_8); }
  public void setCmPPA_TwinPumpCmd_input_8(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_input_8,v,null); }
  public void setCmPPA_TwinPumpCmd_input_8(boolean v) { getCmPPA_TwinPumpCmd_input_8().setValue(v); }
// Reset
  public static final Property CmPPA_TwinPumpCmd_input_9 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_input_9() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_input_9); }
  public void setCmPPA_TwinPumpCmd_input_9(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_input_9,v,null); }
  public void setCmPPA_TwinPumpCmd_input_9(boolean v) { getCmPPA_TwinPumpCmd_input_9().setValue(v); }
// PumpEnable
  public static final Property CmPPA_TwinPumpCmd_input_10 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmPPA_TwinPumpCmd_input_10() { return (BStatusBoolean) get(CmPPA_TwinPumpCmd_input_10); }
  public void setCmPPA_TwinPumpCmd_input_10(BStatusBoolean v) { set(CmPPA_TwinPumpCmd_input_10,v,null); }
  public void setCmPPA_TwinPumpCmd_input_10(boolean v) { getCmPPA_TwinPumpCmd_input_10().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.06 [245] 20.12.2019-14:36").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6069730413574619866").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmPPA_TwinPumpCmd.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfTruncate func_112 = new CfTruncate();
  protected CfIdt func_1865 = new CfIdt();
  protected CfMonoflop func_1864 = new CfMonoflop();
  protected CfOr func_1877 = new CfOr();
  protected CmIDT20 func_128 = new CmIDT20();
  protected CfInputMultiplexer func_2031 = new CfInputMultiplexer();
  protected CfIdt func_2036 = new CfIdt();
  protected CfWindow func_682 = new CfWindow();
  protected CfWindow func_683 = new CfWindow();
  protected CfWindow func_693 = new CfWindow();
  protected CfAnd func_684 = new CfAnd();
  protected CfAnd func_695 = new CfAnd();
  protected CfInputMultiplexer func_692 = new CfInputMultiplexer();
  protected CfWindow func_702 = new CfWindow();
  protected CfAnd func_703 = new CfAnd();
  protected CfInputMultiplexer func_699 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_704 = new CfInputMultiplexer();
  protected CfIdt func_53 = new CfIdt();
  protected CfIdt func_54 = new CfIdt();
  protected CfIdt func_55 = new CfIdt();
  protected CfCompare1 func_56 = new CfCompare1();
  protected CfOr func_52 = new CfOr();
  protected CmAlarms func_57 = new CmAlarms();
  protected CmAlarms func_58 = new CmAlarms();
  protected CfOr func_1008 = new CfOr();
  protected CfIdt func_407 = new CfIdt();
  protected CfIdt func_425 = new CfIdt();
  protected CfInputMultiplexer func_1866 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1867 = new CfInputMultiplexer();
  protected CfWindow func_2043 = new CfWindow();
  protected CfAnd func_2045 = new CfAnd();
  protected CfAnd func_2048 = new CfAnd();
  protected CfInputMultiplexer func_2053 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2054 = new CfInputMultiplexer();
  protected CmPumpEnable func_505 = new CmPumpEnable();
  protected CfWindow func_541 = new CfWindow();
  protected CfAnd func_532 = new CfAnd();
  protected CfWindow func_528 = new CfWindow();
  protected CfAnd func_540 = new CfAnd();
  protected CfWindow func_545 = new CfWindow();
  protected CfWindow func_881 = new CfWindow();
  protected CfAnd func_544 = new CfAnd();
  protected CfWindow func_524 = new CfWindow();
  protected CfOr func_888 = new CfOr();
  protected CfOr func_887 = new CfOr();
  protected CfOr func_849 = new CfOr();
  protected CfWindow func_851 = new CfWindow();
  protected CfWindow func_860 = new CfWindow();
  protected CfAnd func_861 = new CfAnd();
  protected CfOr func_858 = new CfOr();
  protected CfAnd func_852 = new CfAnd();
  protected CfAnd func_833 = new CfAnd();
  protected CfWindow func_831 = new CfWindow();
  protected CfWindow func_558 = new CfWindow();
  protected CfWindow func_1046 = new CfWindow();
  protected CfWindow func_1174 = new CfWindow();
  protected CfAddition func_1210 = new CfAddition();
  protected CfAddition func_1098 = new CfAddition();
  protected CfIdt func_1099 = new CfIdt();
  protected CfIdt func_1251 = new CfIdt();
  protected CfLastValue func_1022 = new CfLastValue();
  protected CfCompare1 func_1026 = new CfCompare1();
  protected CfMonoflop func_1248 = new CfMonoflop();
  protected CfMonoflop func_1204 = new CfMonoflop();
  protected CfInputMultiplexer func_1488 = new CfInputMultiplexer();
  protected CfDelayOnOff func_1178 = new CfDelayOnOff();
  protected CfDelayOnOff func_1940 = new CfDelayOnOff();
  protected CfAnd func_2006 = new CfAnd();
  protected CfInputMultiplexer func_1175 = new CfInputMultiplexer();
  protected CfMonoflop func_1213 = new CfMonoflop();
  protected CfJkFlipFlop func_1037 = new CfJkFlipFlop();
  protected CfMonoflop func_1038 = new CfMonoflop();
  protected CfMonoflop func_1056 = new CfMonoflop();
  protected CfDelayOnOff func_1055 = new CfDelayOnOff();
  protected CfInputMultiplexer func_1044 = new CfInputMultiplexer();
  protected CfLastValue func_1070 = new CfLastValue();
  protected CfCompare1 func_1071 = new CfCompare1();
  protected CfMonoflop func_1253 = new CfMonoflop();
  protected CfMonoflop func_1209 = new CfMonoflop();
  protected CfInputMultiplexer func_1486 = new CfInputMultiplexer();
  protected CfDelayOnOff func_1180 = new CfDelayOnOff();
  protected CfDelayOnOff func_1943 = new CfDelayOnOff();
  protected CfAnd func_2011 = new CfAnd();
  protected CfInputMultiplexer func_1181 = new CfInputMultiplexer();
  protected CfMonoflop func_1216 = new CfMonoflop();
  protected CfJkFlipFlop func_1076 = new CfJkFlipFlop();
  protected CfWindow func_1949 = new CfWindow();
  protected CfWindow func_1950 = new CfWindow();
  protected CfAnd func_1951 = new CfAnd();
  protected CfOr func_1959 = new CfOr();
  protected CfAnd func_1958 = new CfAnd();
  protected CfInputMultiplexer func_1962 = new CfInputMultiplexer();
  protected CfAnd func_1999 = new CfAnd();
  protected CfAnd func_1964 = new CfAnd();
  protected CfOr func_1970 = new CfOr();
  protected CfAnd func_1969 = new CfAnd();
  protected CfInputMultiplexer func_1971 = new CfInputMultiplexer();
  protected CfAnd func_2003 = new CfAnd();
  protected CfAnd func_1972 = new CfAnd();
  protected CfMonoflop func_1074 = new CfMonoflop();
  protected CfMonoflop func_1072 = new CfMonoflop();
  protected CfDelayOnOff func_1073 = new CfDelayOnOff();
  protected CfInputMultiplexer func_1069 = new CfInputMultiplexer();
  protected CfWindow func_1400 = new CfWindow();
  protected CfWindow func_1404 = new CfWindow();
  protected CfWindow func_1408 = new CfWindow();
  protected CfOr func_1412 = new CfOr();
  protected CfOr func_1422 = new CfOr();
  protected CfInputMultiplexer func_1398 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1399 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1401 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1405 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1409 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1420 = new CfInputMultiplexer();
  protected CmDateTimePulse func_118 = new CmDateTimePulse();
  protected CfWindow func_150 = new CfWindow();
  protected CfWindow func_497 = new CfWindow();
  protected CfIdt func_1567 = new CfIdt();
  protected CfIdt func_1573 = new CfIdt();
  protected CfIdt func_1590 = new CfIdt();
  protected CfIdt func_1591 = new CfIdt();
  protected CfWindow func_1594 = new CfWindow();
  protected CfInputMultiplexer func_1599 = new CfInputMultiplexer();
  protected CfWindow func_1619 = new CfWindow();
  protected CfInputMultiplexer func_1632 = new CfInputMultiplexer();
  protected CfLastValue func_1650 = new CfLastValue();
  protected CfLastValue func_1667 = new CfLastValue();
  protected CfLastValue func_1673 = new CfLastValue();
  protected CfWindow func_1744 = new CfWindow();
  protected CfOr func_1574 = new CfOr();
  protected CfOr func_1592 = new CfOr();
  protected CfInputMultiplexer func_1617 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1618 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1620 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1621 = new CfInputMultiplexer();
  protected CfCompare1 func_1651 = new CfCompare1();
  protected CfCompare1 func_1668 = new CfCompare1();
  protected CfCompare1 func_1672 = new CfCompare1();
  protected CfMonoflop func_1746 = new CfMonoflop();
  protected CfAnd func_1575 = new CfAnd();
  protected CfAnd func_1593 = new CfAnd();
  protected CfAnd func_1681 = new CfAnd();
  protected CfAnd func_1682 = new CfAnd();
  protected CmLeadPumpAutoMode func_494 = new CmLeadPumpAutoMode();
  protected CmPumpRuntimeChange func_492 = new CmPumpRuntimeChange();
  protected CfInputMultiplexer func_1440 = new CfInputMultiplexer();
  protected CfOr func_1645 = new CfOr();
  protected CfCompare1 func_1851 = new CfCompare1();
  protected CfAnd func_1640 = new CfAnd();
  protected CfLastValue func_1842 = new CfLastValue();
  protected CfAnd func_1845 = new CfAnd();
  protected CmLimited_auto_reset func_1841 = new CmLimited_auto_reset();
  protected CfCompare1 func_1853 = new CfCompare1();
  protected CfOr func_1637 = new CfOr();
  protected CmTwinPumpMaintRun func_158 = new CmTwinPumpMaintRun();
  protected CfOr func_163 = new CfOr();
  protected CfWindow func_1536 = new CfWindow();
  protected CmCycleTime func_1551 = new CmCycleTime();
  protected CfLastValue func_1705 = new CfLastValue();
  protected CfWindow func_1749 = new CfWindow();
  protected CfMonoflop func_1548 = new CfMonoflop();
  protected CfMultiply func_1552 = new CfMultiply();
  protected CfCompare1 func_1708 = new CfCompare1();
  protected CfDelayOnOff func_1753 = new CfDelayOnOff();
  protected CfAddition func_1361 = new CfAddition();
  protected CfOr func_1545 = new CfOr();
  protected CfAddition func_1549 = new CfAddition();
  protected CfAnd func_1535 = new CfAnd();
  protected CfIdt func_1754 = new CfIdt();
  protected CfAddition func_1945 = new CfAddition();
  protected CfIdt func_1948 = new CfIdt();
  protected CfInputMultiplexer func_1547 = new CfInputMultiplexer();
  protected CfIdt func_1546 = new CfIdt();
  protected CfLastValue func_2018 = new CfLastValue();
  protected CfCompare1 func_2021 = new CfCompare1();
  protected CfNot func_2025 = new CfNot();
  protected CfMonoflop func_2015 = new CfMonoflop();

  // default constructor
  public BCmPPA_TwinPumpCmd()
  {
    func_53.configure(2);
    func_54.configure(2);
    func_55.configure(2);
    func_52.configure(4);
    func_407.configure(2);
    func_425.configure(2);
    func_1099.configure(5);
    func_1251.configure(2);
    func_1959.configure(4);
    func_1958.configure(3);
    func_1970.configure(4);
    func_1969.configure(3);
    func_1412.configure(7);
    func_1567.configure(2);
    func_1573.configure(3);
    func_1590.configure(3);
    func_1591.configure(2);
    func_1599.configure(4);
    func_1440.configure(4);
    func_1645.configure(5);
    func_1640.configure(3);
    func_1637.configure(3);
    func_163.configure(5);
    func_1545.configure(3);
    func_1754.configure(2);
    func_1948.configure(2);
    func_1546.configure(2);
  }

  public void Start()
  {
    func_1864.Start();
    func_128.Start();
    func_57.Start();
    func_58.Start();
    func_505.Start();
    func_1022.Start();
    func_1248.Start();
    func_1204.Start();
    func_1178.Start();
    func_1940.Start();
    func_1213.Start();
    func_1037.Start();
    func_1038.Start();
    func_1056.Start();
    func_1055.Start();
    func_1070.Start();
    func_1253.Start();
    func_1209.Start();
    func_1180.Start();
    func_1943.Start();
    func_1216.Start();
    func_1076.Start();
    func_1074.Start();
    func_1072.Start();
    func_1073.Start();
    func_118.Start();
    func_1650.Start();
    func_1667.Start();
    func_1673.Start();
    func_1746.Start();
    func_494.Start();
    func_492.Start();
    func_1842.Start();
    func_1841.Start();
    func_158.Start();
    func_1551.Start();
    func_1705.Start();
    func_1548.Start();
    func_1753.Start();
    func_2018.Start();
    func_2015.Start();
  }
}
