/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 03.12.2020 12:02
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.general;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    PUA_PumpCmd
Macro id:      5864418301440951259
Macro version: 110
Last change:   10.01.2017 - 14:42
Access Level:  2
Inputs:
  [1] Status
  [2] Alarm
  [3] Reset
  [4] PumpEnable
Outputs:
  [1] PumpCmd
  [2] OffAlarm
  [3] OnAlarm
  [4] FailCmdAlarm
  [5] CommAlarm
Parameter:
  [1] CMD-01: pump start-up delay
  [2] CMD-02: pump switch off delay
  [3] ALM-01: delay status alarm
  [4] ALM-02: pump reset type
  [5] ALM-03: status alarm type
  [6] PEX-01: pump/ valve exercise period
  [7] PEX-02: pump/valve exercise time
Description:
This macro provides pump control.
It offers: 

 - on- and off-alarms 
 - pump exercise
================================================================================*/

public class BCmPUA_PumpCmd
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmPUA_PumpCmd_output_231().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmPUA_PumpCmd_output_231().setStatus(BStatus.disabled);
    getCmPUA_PumpCmd_output_27().setStatus(BStatus.disabled);
    getCmPUA_PumpCmd_output_28().setStatus(BStatus.disabled);
    getCmPUA_PumpCmd_output_29().setStatus(BStatus.disabled);
    getCmPUA_PumpCmd_output_36().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmPUA_PumpCmd_output_231().setStatus(BStatus.ok);
    getCmPUA_PumpCmd_output_27().setStatus(BStatus.ok);
    getCmPUA_PumpCmd_output_28().setStatus(BStatus.ok);
    getCmPUA_PumpCmd_output_29().setStatus(BStatus.ok);
    getCmPUA_PumpCmd_output_36().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [150] Macro call CmIDT10
    func_150.CmIDT10_input_1 = (float) getCmPUA_PumpCmd_parameter_9();
    func_150.CmIDT10_input_2 = (float) getCmPUA_PumpCmd_parameter_10();
    func_150.CmIDT10_input_3 = 1F;
    func_150.CmIDT10_input_4 = (float) getCmPUA_PumpCmd_parameter_6();
    func_150.CmIDT10_input_5 = (float) getCmPUA_PumpCmd_parameter_7();
    func_150.CmIDT10_input_6 = (float) getCmPUA_PumpCmd_parameter_5();
    func_150.CmIDT10_input_7 = 0F;
    func_150.CmIDT10_input_8 = (float) getCmPUA_PumpCmd_parameter_233();
    func_150.CmIDT10_input_9 = (float) getCmPUA_PumpCmd_parameter_236();
    func_150.CmIDT10_input_10 = 0F;
    func_150.Execute(  );
    setParameter(13, func_150.CmIDT10_output_21);
    setParameter(14, func_150.CmIDT10_output_22);
    setParameter(15, func_150.CmIDT10_output_23);
    setParameter(7, func_150.CmIDT10_output_24);
    setParameter(8, func_150.CmIDT10_output_25);
    setParameter(9, func_150.CmIDT10_output_26);
    setParameter(0, func_150.CmIDT10_output_27);
    setParameter(1, func_150.CmIDT10_output_28);
    setParameter(5, func_150.CmIDT10_output_29);
    setParameter(6, func_150.CmIDT10_output_30);

    // [234] Function call CfDelayOnOff
    func_234.input = getCmPUA_PumpCmd_input_232().getValue();
    func_234.Execute( this, 0 );

    // [125] Function call CfNot
    func_125.input = FloatToBoolean((float) getCmPUA_PumpCmd_parameter_7());
    func_125.Execute(  );

    // [89] Function call CfOr
    func_89.input[0] = getCmPUA_PumpCmd_output_28().getValue();
    func_89.input[1] = getCmPUA_PumpCmd_output_27().getValue();
    func_89.input[2] = getCmPUA_PumpCmd_output_29().getValue();
    func_89.Execute(  );

    // [133] Function call CfAnd
    func_133.input[0] = func_89.outputOR;
    func_133.input[1] = func_125.output;
    func_133.Execute(  );

    // [254] Function call CfAnd
    func_254.input[0] = getCmPUA_PumpCmd_output_36().getValue();
    func_254.input[1] = func_125.output;
    func_254.Execute(  );

    // [261] Function call CfLastValue
    func_261.input = (float) getCmPUA_PumpCmd_parameter_7();
    func_261.Execute(  );

    // [304] Function call CfWindow
    func_304.inputValue = (float) getCmPUA_PumpCmd_parameter_6();
    func_304.inputMinimum = -0.1F;
    func_304.inputMaximum = 0.1F;
    func_304.Execute(  );

    // [267] Function call CfCompare1
    func_267.inputA = func_261.outputCurrent;
    func_267.inputB = func_261.outputLast;
    func_267.Execute(  );

    // [305] Function call CfMonoflop
    func_305.input = BooleanToFloat(func_304.output);
    func_305.Execute( this, 2 );

    // [271] Function call CfMonoflop
    func_271.input = BooleanToFloat(func_267.outputGreater);
    func_271.Execute( this, 3 );

    // [306] Function call CfOr
    func_306.input[0] = func_267.outputLess;
    func_306.input[1] = func_305.output;
    func_306.input[2] = getCmPUA_PumpCmd_input_34().getValue();
    func_306.Execute(  );

    // [237] Function call CfMonoflop
    func_237.input = BooleanToFloat(func_306.outputOR);
    func_237.Execute( this, 4 );

    // [272] Function call CfOr
    func_272.input[0] = func_271.output;
    func_272.input[1] = func_237.output;
    func_272.Execute(  );

    // [295] Function call CfAnd
    func_295.input[0] = getCmPUA_PumpCmd_output_36().getValue();
    func_295.input[1] = func_237.output;
    func_295.Execute(  );

    // [296] Function call CfNot
    func_296.input = func_237.output;
    func_296.Execute(  );

    // [257] Function call CfJkFlipFlop
    func_257.inputSet = func_254.outputAND;
    func_257.inputClock = false;
    func_257.inputReset = func_272.outputOR;
    func_257.Execute(  );

    // [297] Function call CfJkFlipFlop
    func_297.inputSet = func_295.outputAND;
    func_297.inputClock = false;
    func_297.inputReset = func_296.output;
    func_297.Execute(  );

    // [300] Function call CfInputMultiplexer
    func_300.inputSelect = BooleanToInt(func_295.outputAND);
    func_300.input[1-1] = BooleanToFloat(func_146.CmPumpValve_Exercise_output_133);
    func_300.input[2-1] = 0F;
    func_300.Execute(  );

    // [259] Function call CfInputMultiplexer
    func_259.inputSelect = BooleanToInt(func_257.output);
    func_259.input[1-1] = BooleanToFloat(func_234.output);
    func_259.input[2-1] = 0F;
    func_259.Execute(  );

    // [298] Function call CfOr
    func_298.input[0] = func_297.output;
    func_298.input[1] = func_257.output;
    func_298.Execute(  );

    // [278] Function call CfDelayOnOff
    func_278.input = FloatToBoolean(func_259.output);
    func_278.Execute( this, 5 );

    // [299] Function call CfInputMultiplexer
    func_299.inputSelect = BooleanToInt(func_298.outputOR);
    func_299.input[1-1] = BooleanToFloat(getCmPUA_PumpCmd_input_32().getValue());
    func_299.input[2-1] = 0F;
    func_299.Execute(  );

    // [13] Macro call CmAlarms
    func_13.CmAlarms_input_1 = FloatToBoolean(func_300.output);
    func_13.CmAlarms_input_2 = FloatToBoolean(func_299.output);
    func_13.CmAlarms_input_3 = getCmPUA_PumpCmd_input_33().getValue();
    func_13.CmAlarms_input_4 = func_237.output;
    func_13.Execute( this, 7 );
    setCmPUA_PumpCmd_output_27(func_13.CmAlarms_output_5);
    setCmPUA_PumpCmd_output_28(func_13.CmAlarms_output_6);
    setCmPUA_PumpCmd_output_29(func_13.CmAlarms_output_7);
    setCmPUA_PumpCmd_output_36(func_13.CmAlarms_output_53);

    // [128] Function call CfAnd
    func_128.input[0] = func_125.output;
    func_128.input[1] = func_13.CmAlarms_output_98;
    func_128.Execute(  );

    // [146] Macro call CmPumpValve_Exercise
    func_146.CmPumpValve_Exercise_input_18 = func_278.output;
    func_146.CmPumpValve_Exercise_input_19 = 1F;
    func_146.Execute( this, 13 );

    // [227] Function call CfOr
    func_227.input[0] = func_128.outputAND;
    func_227.input[1] = func_133.outputAND;
    func_227.Execute(  );

    // [229] Function call CfInputMultiplexer
    func_229.inputSelect = BooleanToInt(func_227.outputOR);
    func_229.input[1-1] = BooleanToFloat(func_146.CmPumpValve_Exercise_output_133);
    func_229.input[2-1] = 0F;
    func_229.Execute(  );
    setCmPUA_PumpCmd_output_231(FloatToBoolean(func_229.output));

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 10F, 2F, 5F, 10F, 0F, 10F, 60F,
    1F, 1F, 10F, 10F, 1F, 168F, 120F, 3F,
    1F, 0F, 0F, 168F, 120F, 1800F, 0F, 120F,
    0F, 0F, 168F, 120F, 1800F, 0F, 120F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// PumpCmd
  public static final Property CmPUA_PumpCmd_output_231 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPUA_PumpCmd_output_231() { return (BStatusBoolean) get(CmPUA_PumpCmd_output_231); }
  public void setCmPUA_PumpCmd_output_231(BStatusBoolean v) { set(CmPUA_PumpCmd_output_231,v,null); }
  public void setCmPUA_PumpCmd_output_231(boolean v) { getCmPUA_PumpCmd_output_231().setValue(v); }
// OffAlarm
  public static final Property CmPUA_PumpCmd_output_27 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPUA_PumpCmd_output_27() { return (BStatusBoolean) get(CmPUA_PumpCmd_output_27); }
  public void setCmPUA_PumpCmd_output_27(BStatusBoolean v) { set(CmPUA_PumpCmd_output_27,v,null); }
  public void setCmPUA_PumpCmd_output_27(boolean v) { getCmPUA_PumpCmd_output_27().setValue(v); }
// OnAlarm
  public static final Property CmPUA_PumpCmd_output_28 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPUA_PumpCmd_output_28() { return (BStatusBoolean) get(CmPUA_PumpCmd_output_28); }
  public void setCmPUA_PumpCmd_output_28(BStatusBoolean v) { set(CmPUA_PumpCmd_output_28,v,null); }
  public void setCmPUA_PumpCmd_output_28(boolean v) { getCmPUA_PumpCmd_output_28().setValue(v); }
// FailCmdAlarm
  public static final Property CmPUA_PumpCmd_output_29 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPUA_PumpCmd_output_29() { return (BStatusBoolean) get(CmPUA_PumpCmd_output_29); }
  public void setCmPUA_PumpCmd_output_29(BStatusBoolean v) { set(CmPUA_PumpCmd_output_29,v,null); }
  public void setCmPUA_PumpCmd_output_29(boolean v) { getCmPUA_PumpCmd_output_29().setValue(v); }
// CommAlarm
  public static final Property CmPUA_PumpCmd_output_36 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPUA_PumpCmd_output_36() { return (BStatusBoolean) get(CmPUA_PumpCmd_output_36); }
  public void setCmPUA_PumpCmd_output_36(BStatusBoolean v) { set(CmPUA_PumpCmd_output_36,v,null); }
  public void setCmPUA_PumpCmd_output_36(boolean v) { getCmPUA_PumpCmd_output_36().setValue(v); }

  // macro parameter
// CMD-01: pump start-up delay
  public static final Property CmPUA_PumpCmd_parameter_236 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPUA_PumpCmd_parameter_236() { return getDouble(CmPUA_PumpCmd_parameter_236); }
  public void setCmPUA_PumpCmd_parameter_236(double v) { setDouble(CmPUA_PumpCmd_parameter_236,v,null); }
// CMD-02: pump switch off delay
  public static final Property CmPUA_PumpCmd_parameter_233 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPUA_PumpCmd_parameter_233() { return getDouble(CmPUA_PumpCmd_parameter_233); }
  public void setCmPUA_PumpCmd_parameter_233(double v) { setDouble(CmPUA_PumpCmd_parameter_233,v,null); }
// ALM-01: delay status alarm
  public static final Property CmPUA_PumpCmd_parameter_6 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPUA_PumpCmd_parameter_6() { return getDouble(CmPUA_PumpCmd_parameter_6); }
  public void setCmPUA_PumpCmd_parameter_6(double v) { setDouble(CmPUA_PumpCmd_parameter_6,v,null); }
// ALM-02: pump reset type
  public static final Property CmPUA_PumpCmd_parameter_7 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPUA_PumpCmd_parameter_7() { return getDouble(CmPUA_PumpCmd_parameter_7); }
  public void setCmPUA_PumpCmd_parameter_7(double v) { setDouble(CmPUA_PumpCmd_parameter_7,v,null); }
// ALM-03: status alarm type
  public static final Property CmPUA_PumpCmd_parameter_5 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPUA_PumpCmd_parameter_5() { return getDouble(CmPUA_PumpCmd_parameter_5); }
  public void setCmPUA_PumpCmd_parameter_5(double v) { setDouble(CmPUA_PumpCmd_parameter_5,v,null); }
// PEX-01: pump/ valve exercise period
  public static final Property CmPUA_PumpCmd_parameter_9 = newProperty( 0, BDouble.make( 168 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmPUA_PumpCmd_parameter_9() { return getDouble(CmPUA_PumpCmd_parameter_9); }
  public void setCmPUA_PumpCmd_parameter_9(double v) { setDouble(CmPUA_PumpCmd_parameter_9,v,null); }
// PEX-02: pump/valve exercise time
  public static final Property CmPUA_PumpCmd_parameter_10 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPUA_PumpCmd_parameter_10() { return getDouble(CmPUA_PumpCmd_parameter_10); }
  public void setCmPUA_PumpCmd_parameter_10(double v) { setDouble(CmPUA_PumpCmd_parameter_10,v,null); }

  // macro inputs
// Status
  public static final Property CmPUA_PumpCmd_input_32 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmPUA_PumpCmd_input_32() { return (BStatusBoolean) get(CmPUA_PumpCmd_input_32); }
  public void setCmPUA_PumpCmd_input_32(BStatusBoolean v) { set(CmPUA_PumpCmd_input_32,v,null); }
  public void setCmPUA_PumpCmd_input_32(boolean v) { getCmPUA_PumpCmd_input_32().setValue(v); }
// Alarm
  public static final Property CmPUA_PumpCmd_input_33 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPUA_PumpCmd_input_33() { return (BStatusBoolean) get(CmPUA_PumpCmd_input_33); }
  public void setCmPUA_PumpCmd_input_33(BStatusBoolean v) { set(CmPUA_PumpCmd_input_33,v,null); }
  public void setCmPUA_PumpCmd_input_33(boolean v) { getCmPUA_PumpCmd_input_33().setValue(v); }
// Reset
  public static final Property CmPUA_PumpCmd_input_34 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPUA_PumpCmd_input_34() { return (BStatusBoolean) get(CmPUA_PumpCmd_input_34); }
  public void setCmPUA_PumpCmd_input_34(BStatusBoolean v) { set(CmPUA_PumpCmd_input_34,v,null); }
  public void setCmPUA_PumpCmd_input_34(boolean v) { getCmPUA_PumpCmd_input_34().setValue(v); }
// PumpEnable
  public static final Property CmPUA_PumpCmd_input_232 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmPUA_PumpCmd_input_232() { return (BStatusBoolean) get(CmPUA_PumpCmd_input_232); }
  public void setCmPUA_PumpCmd_input_232(BStatusBoolean v) { set(CmPUA_PumpCmd_input_232,v,null); }
  public void setCmPUA_PumpCmd_input_232(boolean v) { getCmPUA_PumpCmd_input_232().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.10 [110] 10.01.2017-14:42").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5864418301440951259").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmPUA_PumpCmd.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmIDT10 func_150 = new CmIDT10();
  protected CfDelayOnOff func_234 = new CfDelayOnOff();
  protected CfNot func_125 = new CfNot();
  protected CfOr func_89 = new CfOr();
  protected CfAnd func_133 = new CfAnd();
  protected CfAnd func_254 = new CfAnd();
  protected CfLastValue func_261 = new CfLastValue();
  protected CfWindow func_304 = new CfWindow();
  protected CfCompare1 func_267 = new CfCompare1();
  protected CfMonoflop func_305 = new CfMonoflop();
  protected CfMonoflop func_271 = new CfMonoflop();
  protected CfOr func_306 = new CfOr();
  protected CfMonoflop func_237 = new CfMonoflop();
  protected CfOr func_272 = new CfOr();
  protected CfAnd func_295 = new CfAnd();
  protected CfNot func_296 = new CfNot();
  protected CfJkFlipFlop func_257 = new CfJkFlipFlop();
  protected CfJkFlipFlop func_297 = new CfJkFlipFlop();
  protected CfInputMultiplexer func_300 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_259 = new CfInputMultiplexer();
  protected CfOr func_298 = new CfOr();
  protected CfDelayOnOff func_278 = new CfDelayOnOff();
  protected CfInputMultiplexer func_299 = new CfInputMultiplexer();
  protected CmAlarms func_13 = new CmAlarms();
  protected CfAnd func_128 = new CfAnd();
  protected CmPumpValve_Exercise func_146 = new CmPumpValve_Exercise();
  protected CfOr func_227 = new CfOr();
  protected CfInputMultiplexer func_229 = new CfInputMultiplexer();

  // default constructor
  public BCmPUA_PumpCmd()
  {
    func_89.configure(3);
    func_306.configure(3);
  }

  public void Start()
  {
    func_150.Start();
    func_234.Start();
    func_261.Start();
    func_305.Start();
    func_271.Start();
    func_237.Start();
    func_257.Start();
    func_297.Start();
    func_278.Start();
    func_13.Start();
    func_146.Start();
  }
}
