/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 03.12.2020 12:02
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.general;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    PUA_PumpCmdSimple
Macro id:      5878133584890429924
Macro version: 110
Last change:   10.01.2017 - 14:43
Access Level:  2
Inputs:
  [1] Status
  [2] Alarm
  [3] Reset
  [4] PumpEnable
Outputs:
  [1] PumpCmd
  [2] FailCmdAlarm
  [3] CommAlarm
Parameter:
  [1] CMD-01: pump start-up delay
  [2] CMD-02: pump switch off delay
  [3] ALM-01: delay status alarm
  [4] ALM-02: pump reset type
  [5] PEX-01: pump/ valve exercise period
  [6] PEX-02: pump/valve exercise time
Description:
This macro provides pump control.
It offers: 

 - fail to command alarm 
 - pump exercise
================================================================================*/

public class BCmPUA_PumpCmdSimple
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmPUA_PumpCmdSimple_output_187().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmPUA_PumpCmdSimple_output_187().setStatus(BStatus.disabled);
    getCmPUA_PumpCmdSimple_output_29().setStatus(BStatus.disabled);
    getCmPUA_PumpCmdSimple_output_36().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmPUA_PumpCmdSimple_output_187().setStatus(BStatus.ok);
    getCmPUA_PumpCmdSimple_output_29().setStatus(BStatus.ok);
    getCmPUA_PumpCmdSimple_output_36().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [154] Macro call CmIDT10
    func_154.CmIDT10_input_1 = (float) getCmPUA_PumpCmdSimple_parameter_152();
    func_154.CmIDT10_input_2 = (float) getCmPUA_PumpCmdSimple_parameter_153();
    func_154.CmIDT10_input_3 = 1F;
    func_154.CmIDT10_input_4 = (float) getCmPUA_PumpCmdSimple_parameter_6();
    func_154.CmIDT10_input_5 = (float) getCmPUA_PumpCmdSimple_parameter_7();
    func_154.CmIDT10_input_6 = 1F;
    func_154.CmIDT10_input_7 = 0F;
    func_154.CmIDT10_input_8 = (float) getCmPUA_PumpCmdSimple_parameter_195();
    func_154.CmIDT10_input_9 = (float) getCmPUA_PumpCmdSimple_parameter_201();
    func_154.CmIDT10_input_10 = 0F;
    func_154.Execute(  );
    setParameter(13, func_154.CmIDT10_output_21);
    setParameter(14, func_154.CmIDT10_output_22);
    setParameter(15, func_154.CmIDT10_output_23);
    setParameter(7, func_154.CmIDT10_output_24);
    setParameter(8, func_154.CmIDT10_output_25);
    setParameter(9, func_154.CmIDT10_output_26);
    setParameter(0, func_154.CmIDT10_output_27);
    setParameter(1, func_154.CmIDT10_output_28);
    setParameter(5, func_154.CmIDT10_output_29);
    setParameter(6, func_154.CmIDT10_output_30);

    // [125] Function call CfNot
    func_125.input = FloatToBoolean((float) getCmPUA_PumpCmdSimple_parameter_7());
    func_125.Execute(  );

    // [214] Function call CfDelayOnOff
    func_214.input = getCmPUA_PumpCmdSimple_input_194().getValue();
    func_214.Execute( this, 0 );

    // [215] Function call CfAnd
    func_215.input[0] = getCmPUA_PumpCmdSimple_output_36().getValue();
    func_215.input[1] = func_125.output;
    func_215.Execute(  );

    // [216] Function call CfLastValue
    func_216.input = (float) getCmPUA_PumpCmdSimple_parameter_7();
    func_216.Execute(  );

    // [288] Function call CfWindow
    func_288.inputValue = (float) getCmPUA_PumpCmdSimple_parameter_6();
    func_288.inputMinimum = -0.1F;
    func_288.inputMaximum = 0.1F;
    func_288.Execute(  );

    // [217] Function call CfCompare1
    func_217.inputA = func_216.outputCurrent;
    func_217.inputB = func_216.outputLast;
    func_217.Execute(  );

    // [293] Function call CfMonoflop
    func_293.input = BooleanToFloat(func_288.output);
    func_293.Execute( this, 2 );

    // [218] Function call CfMonoflop
    func_218.input = BooleanToFloat(func_217.outputGreater);
    func_218.Execute( this, 3 );

    // [284] Function call CfOr
    func_284.input[0] = func_217.outputLess;
    func_284.input[1] = func_293.output;
    func_284.input[2] = getCmPUA_PumpCmdSimple_input_34().getValue();
    func_284.Execute(  );

    // [199] Function call CfMonoflop
    func_199.input = BooleanToFloat(func_284.outputOR);
    func_199.Execute( this, 4 );

    // [219] Function call CfOr
    func_219.input[0] = func_218.output;
    func_219.input[1] = func_199.output;
    func_219.Execute(  );

    // [256] Function call CfAnd
    func_256.input[0] = getCmPUA_PumpCmdSimple_output_36().getValue();
    func_256.input[1] = func_199.output;
    func_256.Execute(  );

    // [269] Function call CfNot
    func_269.input = func_199.output;
    func_269.Execute(  );

    // [220] Function call CfJkFlipFlop
    func_220.inputSet = func_215.outputAND;
    func_220.inputClock = false;
    func_220.inputReset = func_219.outputOR;
    func_220.Execute(  );

    // [259] Function call CfInputMultiplexer
    func_259.inputSelect = BooleanToInt(func_256.outputAND);
    func_259.input[1-1] = BooleanToFloat(func_148.CmPumpValve_Exercise_output_133);
    func_259.input[2-1] = 0F;
    func_259.Execute(  );

    // [267] Function call CfJkFlipFlop
    func_267.inputSet = func_256.outputAND;
    func_267.inputClock = false;
    func_267.inputReset = func_269.output;
    func_267.Execute(  );

    // [221] Function call CfInputMultiplexer
    func_221.inputSelect = BooleanToInt(func_220.output);
    func_221.input[1-1] = BooleanToFloat(func_214.output);
    func_221.input[2-1] = 0F;
    func_221.Execute(  );

    // [283] Function call CfOr
    func_283.input[0] = func_267.output;
    func_283.input[1] = func_220.output;
    func_283.Execute(  );

    // [222] Function call CfDelayOnOff
    func_222.input = FloatToBoolean(func_221.output);
    func_222.Execute( this, 5 );

    // [254] Function call CfInputMultiplexer
    func_254.inputSelect = BooleanToInt(func_283.outputOR);
    func_254.input[1-1] = BooleanToFloat(getCmPUA_PumpCmdSimple_input_32().getValue());
    func_254.input[2-1] = 0F;
    func_254.Execute(  );

    // [13] Macro call CmAlarms
    func_13.CmAlarms_input_1 = FloatToBoolean(func_259.output);
    func_13.CmAlarms_input_2 = FloatToBoolean(func_254.output);
    func_13.CmAlarms_input_3 = getCmPUA_PumpCmdSimple_input_33().getValue();
    func_13.CmAlarms_input_4 = func_199.output;
    func_13.Execute( this, 7 );
    setCmPUA_PumpCmdSimple_output_29(func_13.CmAlarms_output_7);
    setCmPUA_PumpCmdSimple_output_36(func_13.CmAlarms_output_53);

    // [128] Function call CfAnd
    func_128.input[0] = func_125.output;
    func_128.input[1] = func_13.CmAlarms_output_98;
    func_128.Execute(  );

    // [133] Function call CfAnd
    func_133.input[0] = getCmPUA_PumpCmdSimple_output_29().getValue();
    func_133.input[1] = func_125.output;
    func_133.Execute(  );

    // [148] Macro call CmPumpValve_Exercise
    func_148.CmPumpValve_Exercise_input_18 = func_222.output;
    func_148.CmPumpValve_Exercise_input_19 = 1F;
    func_148.Execute( this, 13 );

    // [193] Function call CfOr
    func_193.input[0] = func_133.outputAND;
    func_193.input[1] = func_128.outputAND;
    func_193.Execute(  );

    // [188] Function call CfInputMultiplexer
    func_188.inputSelect = BooleanToInt(func_193.outputOR);
    func_188.input[1-1] = BooleanToFloat(func_148.CmPumpValve_Exercise_output_133);
    func_188.input[2-1] = 0F;
    func_188.Execute(  );
    setCmPUA_PumpCmdSimple_output_187(FloatToBoolean(func_188.output));

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 10F, 2F, 5F, 5F, 0F, 10F, 60F,
    1F, 1F, 10F, 10F, 1F, 168F, 120F, 3F,
    0F, 0F, 0F, 168F, 120F, 10F, 0F, 1F,
    0F, 0F, 168F, 120F, 10F, 0F, 1F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// PumpCmd
  public static final Property CmPUA_PumpCmdSimple_output_187 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPUA_PumpCmdSimple_output_187() { return (BStatusBoolean) get(CmPUA_PumpCmdSimple_output_187); }
  public void setCmPUA_PumpCmdSimple_output_187(BStatusBoolean v) { set(CmPUA_PumpCmdSimple_output_187,v,null); }
  public void setCmPUA_PumpCmdSimple_output_187(boolean v) { getCmPUA_PumpCmdSimple_output_187().setValue(v); }
// FailCmdAlarm
  public static final Property CmPUA_PumpCmdSimple_output_29 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPUA_PumpCmdSimple_output_29() { return (BStatusBoolean) get(CmPUA_PumpCmdSimple_output_29); }
  public void setCmPUA_PumpCmdSimple_output_29(BStatusBoolean v) { set(CmPUA_PumpCmdSimple_output_29,v,null); }
  public void setCmPUA_PumpCmdSimple_output_29(boolean v) { getCmPUA_PumpCmdSimple_output_29().setValue(v); }
// CommAlarm
  public static final Property CmPUA_PumpCmdSimple_output_36 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPUA_PumpCmdSimple_output_36() { return (BStatusBoolean) get(CmPUA_PumpCmdSimple_output_36); }
  public void setCmPUA_PumpCmdSimple_output_36(BStatusBoolean v) { set(CmPUA_PumpCmdSimple_output_36,v,null); }
  public void setCmPUA_PumpCmdSimple_output_36(boolean v) { getCmPUA_PumpCmdSimple_output_36().setValue(v); }

  // macro parameter
// CMD-01: pump start-up delay
  public static final Property CmPUA_PumpCmdSimple_parameter_201 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPUA_PumpCmdSimple_parameter_201() { return getDouble(CmPUA_PumpCmdSimple_parameter_201); }
  public void setCmPUA_PumpCmdSimple_parameter_201(double v) { setDouble(CmPUA_PumpCmdSimple_parameter_201,v,null); }
// CMD-02: pump switch off delay
  public static final Property CmPUA_PumpCmdSimple_parameter_195 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPUA_PumpCmdSimple_parameter_195() { return getDouble(CmPUA_PumpCmdSimple_parameter_195); }
  public void setCmPUA_PumpCmdSimple_parameter_195(double v) { setDouble(CmPUA_PumpCmdSimple_parameter_195,v,null); }
// ALM-01: delay status alarm
  public static final Property CmPUA_PumpCmdSimple_parameter_6 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPUA_PumpCmdSimple_parameter_6() { return getDouble(CmPUA_PumpCmdSimple_parameter_6); }
  public void setCmPUA_PumpCmdSimple_parameter_6(double v) { setDouble(CmPUA_PumpCmdSimple_parameter_6,v,null); }
// ALM-02: pump reset type
  public static final Property CmPUA_PumpCmdSimple_parameter_7 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPUA_PumpCmdSimple_parameter_7() { return getDouble(CmPUA_PumpCmdSimple_parameter_7); }
  public void setCmPUA_PumpCmdSimple_parameter_7(double v) { setDouble(CmPUA_PumpCmdSimple_parameter_7,v,null); }
// PEX-01: pump/ valve exercise period
  public static final Property CmPUA_PumpCmdSimple_parameter_152 = newProperty( 0, BDouble.make( 168 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmPUA_PumpCmdSimple_parameter_152() { return getDouble(CmPUA_PumpCmdSimple_parameter_152); }
  public void setCmPUA_PumpCmdSimple_parameter_152(double v) { setDouble(CmPUA_PumpCmdSimple_parameter_152,v,null); }
// PEX-02: pump/valve exercise time
  public static final Property CmPUA_PumpCmdSimple_parameter_153 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPUA_PumpCmdSimple_parameter_153() { return getDouble(CmPUA_PumpCmdSimple_parameter_153); }
  public void setCmPUA_PumpCmdSimple_parameter_153(double v) { setDouble(CmPUA_PumpCmdSimple_parameter_153,v,null); }

  // macro inputs
// Status
  public static final Property CmPUA_PumpCmdSimple_input_32 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmPUA_PumpCmdSimple_input_32() { return (BStatusBoolean) get(CmPUA_PumpCmdSimple_input_32); }
  public void setCmPUA_PumpCmdSimple_input_32(BStatusBoolean v) { set(CmPUA_PumpCmdSimple_input_32,v,null); }
  public void setCmPUA_PumpCmdSimple_input_32(boolean v) { getCmPUA_PumpCmdSimple_input_32().setValue(v); }
// Alarm
  public static final Property CmPUA_PumpCmdSimple_input_33 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPUA_PumpCmdSimple_input_33() { return (BStatusBoolean) get(CmPUA_PumpCmdSimple_input_33); }
  public void setCmPUA_PumpCmdSimple_input_33(BStatusBoolean v) { set(CmPUA_PumpCmdSimple_input_33,v,null); }
  public void setCmPUA_PumpCmdSimple_input_33(boolean v) { getCmPUA_PumpCmdSimple_input_33().setValue(v); }
// Reset
  public static final Property CmPUA_PumpCmdSimple_input_34 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPUA_PumpCmdSimple_input_34() { return (BStatusBoolean) get(CmPUA_PumpCmdSimple_input_34); }
  public void setCmPUA_PumpCmdSimple_input_34(BStatusBoolean v) { set(CmPUA_PumpCmdSimple_input_34,v,null); }
  public void setCmPUA_PumpCmdSimple_input_34(boolean v) { getCmPUA_PumpCmdSimple_input_34().setValue(v); }
// PumpEnable
  public static final Property CmPUA_PumpCmdSimple_input_194 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmPUA_PumpCmdSimple_input_194() { return (BStatusBoolean) get(CmPUA_PumpCmdSimple_input_194); }
  public void setCmPUA_PumpCmdSimple_input_194(BStatusBoolean v) { set(CmPUA_PumpCmdSimple_input_194,v,null); }
  public void setCmPUA_PumpCmdSimple_input_194(boolean v) { getCmPUA_PumpCmdSimple_input_194().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.10 [110] 10.01.2017-14:43").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5878133584890429924").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmPUA_PumpCmdSimple.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmIDT10 func_154 = new CmIDT10();
  protected CfNot func_125 = new CfNot();
  protected CfDelayOnOff func_214 = new CfDelayOnOff();
  protected CfAnd func_215 = new CfAnd();
  protected CfLastValue func_216 = new CfLastValue();
  protected CfWindow func_288 = new CfWindow();
  protected CfCompare1 func_217 = new CfCompare1();
  protected CfMonoflop func_293 = new CfMonoflop();
  protected CfMonoflop func_218 = new CfMonoflop();
  protected CfOr func_284 = new CfOr();
  protected CfMonoflop func_199 = new CfMonoflop();
  protected CfOr func_219 = new CfOr();
  protected CfAnd func_256 = new CfAnd();
  protected CfNot func_269 = new CfNot();
  protected CfJkFlipFlop func_220 = new CfJkFlipFlop();
  protected CfInputMultiplexer func_259 = new CfInputMultiplexer();
  protected CfJkFlipFlop func_267 = new CfJkFlipFlop();
  protected CfInputMultiplexer func_221 = new CfInputMultiplexer();
  protected CfOr func_283 = new CfOr();
  protected CfDelayOnOff func_222 = new CfDelayOnOff();
  protected CfInputMultiplexer func_254 = new CfInputMultiplexer();
  protected CmAlarms func_13 = new CmAlarms();
  protected CfAnd func_128 = new CfAnd();
  protected CfAnd func_133 = new CfAnd();
  protected CmPumpValve_Exercise func_148 = new CmPumpValve_Exercise();
  protected CfOr func_193 = new CfOr();
  protected CfInputMultiplexer func_188 = new CfInputMultiplexer();

  // default constructor
  public BCmPUA_PumpCmdSimple()
  {
    func_284.configure(3);
  }

  public void Start()
  {
    func_154.Start();
    func_214.Start();
    func_216.Start();
    func_293.Start();
    func_218.Start();
    func_199.Start();
    func_220.Start();
    func_267.Start();
    func_222.Start();
    func_13.Start();
    func_148.Start();
  }
}
