/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 03.12.2020 12:02
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.general;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    PVE_Exercise
Macro id:      4840639374755720097
Macro version: 72
Last change:   03.03.2016 - 14:55
Access Level:  2
Inputs:
  [1] ExerciseIn
Outputs:
  [1] Exercise
Parameter:
  [1] PEX-01: pump/ valve exercise period
  [2] PEX-02: pump/valve exercise time
Description:
This macro provides for stopped pump and/ or closed valve exercise in time intervalls.
================================================================================*/

public class BCmPVE_Exercise
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmPVE_Exercise_output_205().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmPVE_Exercise_output_205().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmPVE_Exercise_output_205().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [182] Macro call CmIDT05
    func_182.CmIDT05_input_1 = (float) getCmPVE_Exercise_parameter_43();
    func_182.CmIDT05_input_2 = (float) getCmPVE_Exercise_parameter_50();
    func_182.CmIDT05_input_3 = 0F;
    func_182.CmIDT05_input_4 = 0F;
    func_182.CmIDT05_input_5 = 0F;
    func_182.Execute(  );
    setParameter(2, func_182.CmIDT05_output_21);
    setParameter(3, func_182.CmIDT05_output_22);

    // [179] Macro call CmExercise
    func_179.CmExercise_input_10 = (float) getCmPVE_Exercise_input_207().getValue();
    func_179.Execute( this, 0 );

    // [213] Function call CfInputMultiplexer
    func_213.inputSelect = BooleanToInt(func_179.CmExercise_output_23);
    func_213.input[1-1] = (float) getCmPVE_Exercise_input_207().getValue();
    func_213.input[2-1] = 100F;
    func_213.Execute(  );
    setCmPVE_Exercise_output_205(func_213.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 0F, 168F, 120F, 10F, 0F, 1F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// Exercise
  public static final Property CmPVE_Exercise_output_205 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPVE_Exercise_output_205() { return (BStatusNumeric) get(CmPVE_Exercise_output_205); }
  public void setCmPVE_Exercise_output_205(BStatusNumeric v) { set(CmPVE_Exercise_output_205,v,null); }
  public void setCmPVE_Exercise_output_205(float v) { getCmPVE_Exercise_output_205().setValue(v); }

  // macro parameter
// PEX-01: pump/ valve exercise period
  public static final Property CmPVE_Exercise_parameter_43 = newProperty( 0, BDouble.make( 168 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0.02)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmPVE_Exercise_parameter_43() { return getDouble(CmPVE_Exercise_parameter_43); }
  public void setCmPVE_Exercise_parameter_43(double v) { setDouble(CmPVE_Exercise_parameter_43,v,null); }
// PEX-02: pump/valve exercise time
  public static final Property CmPVE_Exercise_parameter_50 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPVE_Exercise_parameter_50() { return getDouble(CmPVE_Exercise_parameter_50); }
  public void setCmPVE_Exercise_parameter_50(double v) { setDouble(CmPVE_Exercise_parameter_50,v,null); }

  // macro inputs
// ExerciseIn
  public static final Property CmPVE_Exercise_input_207 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmPVE_Exercise_input_207() { return (BStatusNumeric) get(CmPVE_Exercise_input_207); }
  public void setCmPVE_Exercise_input_207(BStatusNumeric v) { set(CmPVE_Exercise_input_207,v,null); }
  public void setCmPVE_Exercise_input_207(float v) { getCmPVE_Exercise_input_207().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.06 [72] 03.03.2016-14:55").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "4840639374755720097").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmPVE_Exercise.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

  // class variables
  protected CmIDT05 func_182 = new CmIDT05();
  protected CmExercise func_179 = new CmExercise();
  protected CfInputMultiplexer func_213 = new CfInputMultiplexer();

  // default constructor
  public BCmPVE_Exercise()
  {
  }

  public void Start()
  {
    func_182.Start();
    func_179.Start();
  }
}
