/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 03.12.2020 12:02
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.general;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    RAA_OATempFilter
Macro id:      5819115172918198775
Macro version: 16
Last change:   19.12.2016 - 09:00
Access Level:  2
Inputs:
  [1] Temperature 1
  [2] Temperature 2
Outputs:
  [1] FilteredOATemp
Parameter:
  [1] SYS-01: selection for SYS-02 - 0=min; 1=h
  [2] SYS-02: filter time; 0=disable
  [3] SYS-03: filter input configuration
Description:
The "RAA_OATempFilter" macro provides a smoothed output from a varying analog input. Typically this can be applied to the outside air temperature sensor in order to eliminate sudden temperature variations and thus provide for a more stable operation of the control system. This module can be also used for different sensors or analogue signals.
================================================================================*/

public class BCmRAA_OATempFilter
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmRAA_OATempFilter_output_4().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmRAA_OATempFilter_output_4().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmRAA_OATempFilter_output_4().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [627] Macro call CmCycle_time
    func_627.Execute( this, 0 );

    // [23] Function call CfMinimum
    func_23.input[0] = (float) getCmRAA_OATempFilter_input_2().getValue();
    func_23.input[1] = (float) getCmRAA_OATempFilter_input_3().getValue();
    func_23.Execute(  );

    // [24] Function call CfMaximum
    func_24.input[0] = (float) getCmRAA_OATempFilter_input_2().getValue();
    func_24.input[1] = (float) getCmRAA_OATempFilter_input_3().getValue();
    func_24.Execute(  );

    // [413] Function call CfAverage
    func_413.input[0] = (float) getCmRAA_OATempFilter_input_2().getValue();
    func_413.input[1] = (float) getCmRAA_OATempFilter_input_3().getValue();
    func_413.ExecuteArithmeticAverage( );
    // [35] Function call CfInputMultiplexer
    func_35.inputSelect = FloatToInt((float) getCmRAA_OATempFilter_parameter_8());
    func_35.input[1-1] = (float) getCmRAA_OATempFilter_input_2().getValue();
    func_35.input[2-1] = func_23.output;
    func_35.input[3-1] = func_24.output;
    func_35.input[4-1] = func_413.outputA;
    func_35.Execute(  );

    // [39] Function call CfInputMultiplexer
    func_39.inputSelect = FloatToInt((float) getCmRAA_OATempFilter_parameter_6());
    func_39.input[1-1] = 60F;
    func_39.input[2-1] = 3600F;
    func_39.Execute(  );

    // [43] Function call CfMultiply
    func_43.input[0] = func_39.output;
    func_43.input[1] = (float) getCmRAA_OATempFilter_parameter_7();
    func_43.Execute(  );

    // [546] Function call CfLastValue
    func_546.input = (float) getCmRAA_OATempFilter_parameter_7();
    func_546.Execute(  );

    // [672] Function call CfCompare1
    func_672.inputA = func_546.outputCurrent;
    func_672.inputB = func_546.outputLast;
    func_672.Execute(  );

    // [548] Function call CfLastValue
    func_548.input = (float) getCmRAA_OATempFilter_parameter_6();
    func_548.Execute(  );

    // [547] Function call CfSubtract
    func_547.input[0] = func_548.outputCurrent;
    func_547.input[1] = func_548.outputLast;
    func_547.Execute(  );

    // [549] Function call CfAbsolute
    func_549.input = func_547.output;
    func_549.Execute(  );

    // [554] Function call CfLastValue
    func_554.input = (float) getCmRAA_OATempFilter_parameter_8();
    func_554.Execute(  );

    // [553] Function call CfSubtract
    func_553.input[0] = func_554.outputCurrent;
    func_553.input[1] = func_554.outputLast;
    func_553.Execute(  );

    // [555] Function call CfAbsolute
    func_555.input = func_553.output;
    func_555.Execute(  );

    // [565] Function call CfOr
    func_565.input[0] = func_672.outputGreater;
    func_565.input[1] = func_672.outputLess;
    func_565.input[2] = FloatToBoolean(func_549.outputAbs);
    func_565.input[3] = FloatToBoolean(func_555.outputAbs);
    func_565.input[4] = FloatToBoolean(func_655.outputLast);
    func_565.Execute(  );

    // [629] Function call CfAddition
    func_629.input[0] = func_627.CmCycle_time_output_13;
    func_629.input[1] = 2F;
    func_629.Execute(  );

    // [600] Function call CfIdt
    func_600.input = func_629.output;
    func_600.Execute(  );
    setParameter(2, func_600.output[0]);

    // [595] Function call CfMonoflop
    func_595.input = BooleanToFloat(func_565.outputOR);
    func_595.Execute( this, 2 );

    // [655] Function call CfLastValue
    func_655.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_655.Execute(  );

    // [667] Function call CfCompare1
    func_667.inputA = (float) getCmRAA_OATempFilter_parameter_7();
    func_667.inputB = 0.1F;
    func_667.Execute(  );

    // [664] Function call CfOr
    func_664.input[0] = func_595.output;
    func_664.input[1] = func_667.outputLess;
    func_664.Execute(  );

    // [567] Function call CfInputMultiplexer
    func_567.inputSelect = BooleanToInt(func_664.outputOR);
    func_567.input[1-1] = func_43.output;
    func_567.input[2-1] = func_627.CmCycle_time_output_13;
    func_567.Execute(  );

    // [570] Function call CfIdt
    func_570.input = func_567.output;
    func_570.Execute(  );
    setParameter(3, func_570.output[0]);

    // [594] Function call CfSubtract
    func_594.input[0] = func_35.output;
    func_594.input[1] = (float) getCmRAA_OATempFilter_output_4().getValue();
    func_594.Execute(  );

    // [593] Function call CfIntegral
    func_593.inputX = func_594.output;
    func_593.inputMax = 100F;
    func_593.Execute( this, 3 );
    setCmRAA_OATempFilter_output_4(func_593.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 2F, 10F, 10F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// FilteredOATemp
  public static final Property CmRAA_OATempFilter_output_4 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmRAA_OATempFilter_output_4() { return (BStatusNumeric) get(CmRAA_OATempFilter_output_4); }
  public void setCmRAA_OATempFilter_output_4(BStatusNumeric v) { set(CmRAA_OATempFilter_output_4,v,null); }
  public void setCmRAA_OATempFilter_output_4(float v) { getCmRAA_OATempFilter_output_4().setValue(v); }

  // macro parameter
// SYS-01: selection for SYS-02 - 0=min; 1=h
  public static final Property CmRAA_OATempFilter_parameter_6 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmRAA_OATempFilter_parameter_6() { return getDouble(CmRAA_OATempFilter_parameter_6); }
  public void setCmRAA_OATempFilter_parameter_6(double v) { setDouble(CmRAA_OATempFilter_parameter_6,v,null); }
// SYS-02: filter time; 0=disable
  public static final Property CmRAA_OATempFilter_parameter_7 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(500)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmRAA_OATempFilter_parameter_7() { return getDouble(CmRAA_OATempFilter_parameter_7); }
  public void setCmRAA_OATempFilter_parameter_7(double v) { setDouble(CmRAA_OATempFilter_parameter_7,v,null); }
// SYS-03: filter input configuration
  public static final Property CmRAA_OATempFilter_parameter_8 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmRAA_OATempFilter_parameter_8() { return getDouble(CmRAA_OATempFilter_parameter_8); }
  public void setCmRAA_OATempFilter_parameter_8(double v) { setDouble(CmRAA_OATempFilter_parameter_8,v,null); }

  // macro inputs
// Temperature 1
  public static final Property CmRAA_OATempFilter_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmRAA_OATempFilter_input_2() { return (BStatusNumeric) get(CmRAA_OATempFilter_input_2); }
  public void setCmRAA_OATempFilter_input_2(BStatusNumeric v) { set(CmRAA_OATempFilter_input_2,v,null); }
  public void setCmRAA_OATempFilter_input_2(float v) { getCmRAA_OATempFilter_input_2().setValue(v); }
// Temperature 2
  public static final Property CmRAA_OATempFilter_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmRAA_OATempFilter_input_3() { return (BStatusNumeric) get(CmRAA_OATempFilter_input_3); }
  public void setCmRAA_OATempFilter_input_3(BStatusNumeric v) { set(CmRAA_OATempFilter_input_3,v,null); }
  public void setCmRAA_OATempFilter_input_3(float v) { getCmRAA_OATempFilter_input_3().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.06 [16] 19.12.2016-09:00").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5819115172918198775").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmRAA_OATempFilter.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmCycle_time func_627 = new CmCycle_time();
  protected CfMinimum func_23 = new CfMinimum();
  protected CfMaximum func_24 = new CfMaximum();
  protected CfAverage func_413 = new CfAverage();
  protected CfInputMultiplexer func_35 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_39 = new CfInputMultiplexer();
  protected CfMultiply func_43 = new CfMultiply();
  protected CfLastValue func_546 = new CfLastValue();
  protected CfCompare1 func_672 = new CfCompare1();
  protected CfLastValue func_548 = new CfLastValue();
  protected CfSubtract func_547 = new CfSubtract();
  protected CfAbsolute func_549 = new CfAbsolute();
  protected CfLastValue func_554 = new CfLastValue();
  protected CfSubtract func_553 = new CfSubtract();
  protected CfAbsolute func_555 = new CfAbsolute();
  protected CfOr func_565 = new CfOr();
  protected CfAddition func_629 = new CfAddition();
  protected CfIdt func_600 = new CfIdt();
  protected CfMonoflop func_595 = new CfMonoflop();
  protected CfLastValue func_655 = new CfLastValue();
  protected CfCompare1 func_667 = new CfCompare1();
  protected CfOr func_664 = new CfOr();
  protected CfInputMultiplexer func_567 = new CfInputMultiplexer();
  protected CfIdt func_570 = new CfIdt();
  protected CfSubtract func_594 = new CfSubtract();
  protected CfIntegral func_593 = new CfIntegral();

  // default constructor
  public BCmRAA_OATempFilter()
  {
    func_35.configure(5);
    func_565.configure(5);
  }

  public void Start()
  {
    func_627.Start();
    func_546.Start();
    func_548.Start();
    func_554.Start();
    func_595.Start();
    func_655.Start();
    func_593.Start();
  }
}
