/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 03.12.2020 12:02
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.general;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    RSB_TF22
Macro id:      5823610827843830119
Macro version: 39
Last change:   26.02.2015 - 15:05
Access Level:  2
Inputs:
  [1] Wallmodule
Outputs:
  [1] ContrPtAdj
  [2] ManSwCond
  [3] ManSwAlarm
  [4] LEDControl
Parameter:
  [1] CPA-01: output range low limit
  [2] CPA-02: output range high limit
  [3] SYS-01: max. extended day operation
  [4] SYS-02: max. extended night operation
  [5] DISP-01: MSC alarm
  [6] DISP-02: wire break alarm
Description:
The wall module macro has one analog input for decoding the CLCM3T111/ TF22 manual switch and setpoint adjustment values.

I/O configuration:   AI 0...10V with pull-up
Characteristic:        Xlw_Conv_Percent_0to10V

The operation modes of the manual switch are:
 - Day 
 - Night 
 - Auto 

There hardware output for the LED gives feedback about the status of the wall modules settings.
There are communication signal outputs for 
 - control point adjustment (CPA), 
 - manual switch condition (operation mode), 
 - manual switch alarm
================================================================================*/

public class BCmRSB_TF22
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmRSB_TF22_output_3().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmRSB_TF22_output_3().setStatus(BStatus.disabled);
    getCmRSB_TF22_output_4().setStatus(BStatus.disabled);
    getCmRSB_TF22_output_26().setStatus(BStatus.disabled);
    getCmRSB_TF22_output_2().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmRSB_TF22_output_3().setStatus(BStatus.ok);
    getCmRSB_TF22_output_4().setStatus(BStatus.ok);
    getCmRSB_TF22_output_26().setStatus(BStatus.ok);
    getCmRSB_TF22_output_2().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [16] Function call CfCompare1 ("wirebreak alarm")
    func_16.inputA = (float) getCmRSB_TF22_input_1().getValue();
    func_16.inputB = 7F;
    func_16.Execute(  );

    // [20] Macro call CmCPA_Calculation
    func_20.CmCPA_Calculation_input_1 = (float) getCmRSB_TF22_input_1().getValue();
    func_20.CmCPA_Calculation_input_3 = (float) getCmRSB_TF22_parameter_7();
    func_20.Execute(  );

    // [33] Function call CfIdt
    func_33.input = BooleanToFloat(func_16.outputGreater);
    func_33.Execute(  );
    setCmRSB_TF22_parameter_11(func_33.output[0]);

    // [93] Macro call CmSwitch_Back_To_Auto_And_LED_Control
    func_93.CmSwitch_Back_To_Auto_And_LED_Control_input_27 = func_20.CmCPA_Calculation_output_54;
    func_93.CmSwitch_Back_To_Auto_And_LED_Control_input_28 = (float) getCmRSB_TF22_parameter_8();
    func_93.CmSwitch_Back_To_Auto_And_LED_Control_input_29 = (float) getCmRSB_TF22_parameter_9();
    func_93.Execute( this, 0 );
    setCmRSB_TF22_output_2(func_93.CmSwitch_Back_To_Auto_And_LED_Control_output_10);

    // [100] Function call CfInputMultiplexer ("Selbsthaltung")
    func_100.inputSelect = BooleanToInt(func_16.outputGreater);
    func_100.input[1-1] = func_20.CmCPA_Calculation_output_4;
    func_100.input[2-1] = func_100.output;
    func_100.Execute(  );

    // [35] Function call CfCompare1
    func_35.inputA = func_93.CmSwitch_Back_To_Auto_And_LED_Control_output_11;
    func_35.inputB = 3F;
    func_35.Execute(  );

    // [85] Function call CfIdt
    func_85.input = func_93.CmSwitch_Back_To_Auto_And_LED_Control_output_11;
    func_85.Execute(  );
    setCmRSB_TF22_output_4(func_85.output[0]);

    // [23] Function call CfOr
    func_23.input[0] = func_35.outputGreater;
    func_23.input[1] = func_35.outputLess;
    func_23.input[2] = func_20.CmCPA_Calculation_output_53;
    func_23.Execute(  );

    // [27] Function call CfOr
    func_27.input[0] = func_16.outputGreater;
    func_27.input[1] = func_23.outputOR;
    func_27.Execute(  );
    setCmRSB_TF22_output_26(func_27.outputOR);

    // [32] Function call CfIdt
    func_32.input = BooleanToFloat(func_23.outputOR);
    func_32.Execute(  );
    setCmRSB_TF22_parameter_10(func_32.output[0]);

    // [45] Macro call CmSTARTUP_Detection
    if ( func_56.outputOR)
    {
      func_45.CmSTARTUP_Detection_input_1 = ControlFunction.GetStartupFlag();
      func_45.Execute(  );
    }

    // [40] Function call CfInputMultiplexer ("send -999 while first 5 cycles")
    func_40.inputSelect = FloatToInt(func_45.CmSTARTUP_Detection_output_2);
    func_40.input[1-1] = func_100.output;
    func_40.input[2-1] = -999F;
    func_40.Execute(  );
    setCmRSB_TF22_output_3(func_40.output);

    // [56] Function call CfOr
    func_56.input[0] = FloatToBoolean(func_45.CmSTARTUP_Detection_output_2);
    func_56.input[1] = ControlFunction.GetStartupFlag();
    func_56.Execute(  );

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    1F, 1F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// ContrPtAdj
  public static final Property CmRSB_TF22_output_3 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmRSB_TF22_output_3() { return (BStatusNumeric) get(CmRSB_TF22_output_3); }
  public void setCmRSB_TF22_output_3(BStatusNumeric v) { set(CmRSB_TF22_output_3,v,null); }
  public void setCmRSB_TF22_output_3(float v) { getCmRSB_TF22_output_3().setValue(v); }
// ManSwCond
  public static final Property CmRSB_TF22_output_4 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmRSB_TF22_output_4() { return (BStatusNumeric) get(CmRSB_TF22_output_4); }
  public void setCmRSB_TF22_output_4(BStatusNumeric v) { set(CmRSB_TF22_output_4,v,null); }
  public void setCmRSB_TF22_output_4(float v) { getCmRSB_TF22_output_4().setValue(v); }
// ManSwAlarm
  public static final Property CmRSB_TF22_output_26 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmRSB_TF22_output_26() { return (BStatusBoolean) get(CmRSB_TF22_output_26); }
  public void setCmRSB_TF22_output_26(BStatusBoolean v) { set(CmRSB_TF22_output_26,v,null); }
  public void setCmRSB_TF22_output_26(boolean v) { getCmRSB_TF22_output_26().setValue(v); }
// LEDControl
  public static final Property CmRSB_TF22_output_2 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmRSB_TF22_output_2() { return (BStatusNumeric) get(CmRSB_TF22_output_2); }
  public void setCmRSB_TF22_output_2(BStatusNumeric v) { set(CmRSB_TF22_output_2,v,null); }
  public void setCmRSB_TF22_output_2(float v) { getCmRSB_TF22_output_2().setValue(v); }

  // macro parameter
// CPA-01: output range low limit(not used)
  public static final Property CmRSB_TF22_parameter_6 = newProperty( 0, BDouble.make( -7 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-10)), BFacets.make(BFacets.MAX, BDouble.make(10)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmRSB_TF22_parameter_6() { return getDouble(CmRSB_TF22_parameter_6); }
  public void setCmRSB_TF22_parameter_6(double v) { setDouble(CmRSB_TF22_parameter_6,v,null); }
// CPA-02: output range high limit
  public static final Property CmRSB_TF22_parameter_7 = newProperty( 0, BDouble.make( 7 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-10)), BFacets.make(BFacets.MAX, BDouble.make(10)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmRSB_TF22_parameter_7() { return getDouble(CmRSB_TF22_parameter_7); }
  public void setCmRSB_TF22_parameter_7(double v) { setDouble(CmRSB_TF22_parameter_7,v,null); }
// SYS-01: max. extended day operation
  public static final Property CmRSB_TF22_parameter_8 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(480)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmRSB_TF22_parameter_8() { return getDouble(CmRSB_TF22_parameter_8); }
  public void setCmRSB_TF22_parameter_8(double v) { setDouble(CmRSB_TF22_parameter_8,v,null); }
// SYS-02: max. extended night operation
  public static final Property CmRSB_TF22_parameter_9 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(480)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmRSB_TF22_parameter_9() { return getDouble(CmRSB_TF22_parameter_9); }
  public void setCmRSB_TF22_parameter_9(double v) { setDouble(CmRSB_TF22_parameter_9,v,null); }
// DISP-01: MSC alarm
  public static final Property CmRSB_TF22_parameter_10 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmRSB_TF22_parameter_10() { return getDouble(CmRSB_TF22_parameter_10); }
  public void setCmRSB_TF22_parameter_10(double v) { setDouble(CmRSB_TF22_parameter_10,v,null); }
// DISP-02: wire break alarm
  public static final Property CmRSB_TF22_parameter_11 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmRSB_TF22_parameter_11() { return getDouble(CmRSB_TF22_parameter_11); }
  public void setCmRSB_TF22_parameter_11(double v) { setDouble(CmRSB_TF22_parameter_11,v,null); }

  // macro inputs
// Wallmodule
  public static final Property CmRSB_TF22_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmRSB_TF22_input_1() { return (BStatusNumeric) get(CmRSB_TF22_input_1); }
  public void setCmRSB_TF22_input_1(BStatusNumeric v) { set(CmRSB_TF22_input_1,v,null); }
  public void setCmRSB_TF22_input_1(float v) { getCmRSB_TF22_input_1().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.05 [39] 26.02.2015-15:05").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5823610827843830119").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmRSB_TF22.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfCompare1 func_16 = new CfCompare1();
  protected CmCPA_Calculation func_20 = new CmCPA_Calculation();
  protected CfIdt func_33 = new CfIdt();
  protected CmSwitch_Back_To_Auto_And_LED_Control func_93 = new CmSwitch_Back_To_Auto_And_LED_Control();
  protected CfInputMultiplexer func_100 = new CfInputMultiplexer();
  protected CfCompare1 func_35 = new CfCompare1();
  protected CfIdt func_85 = new CfIdt();
  protected CfOr func_23 = new CfOr();
  protected CfOr func_27 = new CfOr();
  protected CfIdt func_32 = new CfIdt();
  protected CmSTARTUP_Detection func_45 = new CmSTARTUP_Detection();
  protected CfInputMultiplexer func_40 = new CfInputMultiplexer();
  protected CfOr func_56 = new CfOr();

  // default constructor
  public BCmRSB_TF22()
  {
    func_23.configure(3);
  }

  public void Start()
  {
    func_20.Start();
    func_93.Start();
    func_45.Start();
  }
}
