/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 03.12.2020 12:02
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.general;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    RSC_T7460
Macro id:      5839916508319319015
Macro version: 58
Last change:   07.09.2017 - 16:07
Access Level:  2
Inputs:
  [1] SetpointAdjustm
  [2] ManualOverride
  [3] FanSpeedCtrlSig
Outputs:
  [1] ContrPtAdj
  [2] FanSpeedCtrlSig
  [3] ManSwCond
  [4] ManSwAlarm
  [5] LEDControl
Parameter:
  [1] CPA-01: output range low limit
  [2] CPA-02: output range high limit
  [3] CPA-03: conversion; 0=linear, 1=stepwise
  [4] SYS-01: extend period day operation
  [5] SYS-02: extend period night operation
  [6] SYS-03: number of stages
  [7] SYS-04: type 0=LED; 1=LCD
  [8] DISP-01: manual switch operated alarm
  [9] DISP-02: wire break alarm
Description:
The macro is a general-purpose module, which provides the interface between the Wall Module device T7770, T7460, T7560 respectively the CentraLine modules CLCM* without the CLCM3T111 and, for instance, the heating circuit macro.

Inputs		IO configuration 		Characteristic

SetpointAdjustment	AI 0...10V with pull-up	Xlw_Conv_Percent_0to10V

ManualOverride	AI 0...10V with pull-up	Xlw_Conv_Percent_0to10V


================================================================================*/

public class BCmRSC_T7460
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmRSC_T7460_output_4().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmRSC_T7460_output_4().setStatus(BStatus.disabled);
    getCmRSC_T7460_output_5().setStatus(BStatus.disabled);
    getCmRSC_T7460_output_6().setStatus(BStatus.disabled);
    getCmRSC_T7460_output_7().setStatus(BStatus.disabled);
    getCmRSC_T7460_output_8().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmRSC_T7460_output_4().setStatus(BStatus.ok);
    getCmRSC_T7460_output_5().setStatus(BStatus.ok);
    getCmRSC_T7460_output_6().setStatus(BStatus.ok);
    getCmRSC_T7460_output_7().setStatus(BStatus.ok);
    getCmRSC_T7460_output_8().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [84] Macro call CmIDT10
    func_84.CmIDT10_input_1 = (float) getCmRSC_T7460_parameter_10();
    func_84.CmIDT10_input_2 = (float) getCmRSC_T7460_parameter_11();
    func_84.CmIDT10_input_3 = (float) getCmRSC_T7460_parameter_12();
    func_84.CmIDT10_input_4 = (float) getCmRSC_T7460_parameter_13();
    func_84.CmIDT10_input_5 = (float) getCmRSC_T7460_parameter_14();
    func_84.CmIDT10_input_6 = (float) getCmRSC_T7460_parameter_15();
    func_84.CmIDT10_input_7 = (float) getCmRSC_T7460_parameter_16();
    func_84.CmIDT10_input_8 = BooleanToFloat(func_75.CmAlarm_output_14);
    func_84.CmIDT10_input_9 = BooleanToFloat(func_75.CmAlarm_output_13);
    func_84.CmIDT10_input_10 = (float) getCmRSC_T7460_parameter_14();
    func_84.Execute(  );
    setParameter(9, func_84.CmIDT10_output_21);
    setParameter(10, func_84.CmIDT10_output_22);
    setParameter(11, func_84.CmIDT10_output_23);
    setParameter(5, func_84.CmIDT10_output_24);
    setParameter(1, func_84.CmIDT10_output_25);
    setParameter(0, func_84.CmIDT10_output_26);
    setParameter(15, func_84.CmIDT10_output_27);
    setCmRSC_T7460_parameter_17(func_84.CmIDT10_output_28);
    setCmRSC_T7460_parameter_18(func_84.CmIDT10_output_29);
    setParameter(6, func_84.CmIDT10_output_30);

    // [117] Function call CfIdt
    func_117.input = (float) getCmRSC_T7460_parameter_13();
    func_117.Execute(  );
    setParameter(2, func_117.output[0]);

    // [102] Function call CfMultiply
    func_102.input[0] = (float) getCmRSC_T7460_input_2().getValue();
    func_102.input[1] = 10F;
    func_102.Execute(  );

    // [106] Function call CfMultiply
    func_106.input[0] = (float) getCmRSC_T7460_input_1().getValue();
    func_106.input[1] = 10F;
    func_106.Execute(  );

    // [67] Macro call CmStartup_Count
    func_67.Execute(  );

    // [34] Macro call CmInput_Levels
    func_34.CmInput_Levels_input_1 = func_102.output;
    func_34.Execute( this, 0 );

    // [36] Macro call CmSwitch_Off_Timer
    func_36.CmSwitch_Off_Timer_input_1 = func_34.CmInput_Levels_output_124;
    func_36.Execute( this, 1 );

    // [63] Macro call CmExtended_Operations
    func_63.CmExtended_Operations_input_11 = func_34.CmInput_Levels_output_153;
    func_63.CmExtended_Operations_input_13 = func_36.CmSwitch_Off_Timer_output_44;
    func_63.CmExtended_Operations_input_14 = func_102.output;
    func_63.Execute( this, 5 );
    setCmRSC_T7460_output_6(func_63.CmExtended_Operations_output_25);

    // [77] Function call CfEqual
    func_77.input = FloatToInt(func_36.CmSwitch_Off_Timer_output_44);
    func_77.inputCompare[1-1] = 3;
    func_77.inputCompare[2-1] = 999;
    func_77.Execute(  );

    // [65] Macro call CmCPA_Control_Signal
    func_65.CmCPA_Control_Signal_input_1 = func_106.output;
    func_65.CmCPA_Control_Signal_input_38 = func_67.CmStartup_Count_output_14;
    func_65.CmCPA_Control_Signal_input_40 = (float) getCmRSC_T7460_output_6().getValue();
    func_65.Execute( this, 9 );
    setCmRSC_T7460_output_4(func_65.CmCPA_Control_Signal_output_30);

    // [71] Macro call CmLED
    func_71.CmLED_input_1 = (float) getCmRSC_T7460_output_6().getValue();
    func_71.Execute( this, 15 );
    setCmRSC_T7460_output_8(func_71.CmLED_output_3);

    // [75] Macro call CmAlarm
    func_75.CmAlarm_input_3 = func_106.output;
    func_75.CmAlarm_input_4 = func_102.output;
    func_75.CmAlarm_input_6 = (float) getCmRSC_T7460_output_6().getValue();
    func_75.Execute( this, 16 );
    setCmRSC_T7460_output_7(func_75.CmAlarm_output_12);

    // [119] Function call CfMinimum
    func_119.input[0] = 3F;
    func_119.input[1] = func_36.CmSwitch_Off_Timer_output_44;
    func_119.Execute(  );

    // [79] Function call CfInputMultiplexer
    func_79.inputSelect = BooleanToInt(func_77.output);
    func_79.input[1-1] = func_119.output;
    func_79.input[2-1] = (float) getCmRSC_T7460_input_3().getValue();
    func_79.Execute(  );
    setCmRSC_T7460_output_5(func_79.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    2F, 120F, 120F, 1F, 1F, 120F, 120F, 1F,
    1F, -5F, 5F, 1F, -5F, 5F, 1F, 0F,
    10F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// ContrPtAdj
  public static final Property CmRSC_T7460_output_4 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmRSC_T7460_output_4() { return (BStatusNumeric) get(CmRSC_T7460_output_4); }
  public void setCmRSC_T7460_output_4(BStatusNumeric v) { set(CmRSC_T7460_output_4,v,null); }
  public void setCmRSC_T7460_output_4(float v) { getCmRSC_T7460_output_4().setValue(v); }
// FanSpeedCtrlSig
  public static final Property CmRSC_T7460_output_5 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmRSC_T7460_output_5() { return (BStatusNumeric) get(CmRSC_T7460_output_5); }
  public void setCmRSC_T7460_output_5(BStatusNumeric v) { set(CmRSC_T7460_output_5,v,null); }
  public void setCmRSC_T7460_output_5(float v) { getCmRSC_T7460_output_5().setValue(v); }
// ManSwCond
  public static final Property CmRSC_T7460_output_6 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmRSC_T7460_output_6() { return (BStatusNumeric) get(CmRSC_T7460_output_6); }
  public void setCmRSC_T7460_output_6(BStatusNumeric v) { set(CmRSC_T7460_output_6,v,null); }
  public void setCmRSC_T7460_output_6(float v) { getCmRSC_T7460_output_6().setValue(v); }
// ManSwAlarm
  public static final Property CmRSC_T7460_output_7 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmRSC_T7460_output_7() { return (BStatusBoolean) get(CmRSC_T7460_output_7); }
  public void setCmRSC_T7460_output_7(BStatusBoolean v) { set(CmRSC_T7460_output_7,v,null); }
  public void setCmRSC_T7460_output_7(boolean v) { getCmRSC_T7460_output_7().setValue(v); }
// LEDControl
  public static final Property CmRSC_T7460_output_8 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmRSC_T7460_output_8() { return (BStatusNumeric) get(CmRSC_T7460_output_8); }
  public void setCmRSC_T7460_output_8(BStatusNumeric v) { set(CmRSC_T7460_output_8,v,null); }
  public void setCmRSC_T7460_output_8(float v) { getCmRSC_T7460_output_8().setValue(v); }

  // macro parameter
// CPA-01: output range low limit
  public static final Property CmRSC_T7460_parameter_10 = newProperty( 0, BDouble.make( -5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-10)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmRSC_T7460_parameter_10() { return getDouble(CmRSC_T7460_parameter_10); }
  public void setCmRSC_T7460_parameter_10(double v) { setDouble(CmRSC_T7460_parameter_10,v,null); }
// CPA-02: output range high limit
  public static final Property CmRSC_T7460_parameter_11 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-10)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmRSC_T7460_parameter_11() { return getDouble(CmRSC_T7460_parameter_11); }
  public void setCmRSC_T7460_parameter_11(double v) { setDouble(CmRSC_T7460_parameter_11,v,null); }
// CPA-03: conversion; 0=linear, 1=stepwise
  public static final Property CmRSC_T7460_parameter_12 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmRSC_T7460_parameter_12() { return getDouble(CmRSC_T7460_parameter_12); }
  public void setCmRSC_T7460_parameter_12(double v) { setDouble(CmRSC_T7460_parameter_12,v,null); }
// SYS-01: extend period day operation
  public static final Property CmRSC_T7460_parameter_13 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(480)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmRSC_T7460_parameter_13() { return getDouble(CmRSC_T7460_parameter_13); }
  public void setCmRSC_T7460_parameter_13(double v) { setDouble(CmRSC_T7460_parameter_13,v,null); }
// SYS-02: extend period night operation
  public static final Property CmRSC_T7460_parameter_14 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(480)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmRSC_T7460_parameter_14() { return getDouble(CmRSC_T7460_parameter_14); }
  public void setCmRSC_T7460_parameter_14(double v) { setDouble(CmRSC_T7460_parameter_14,v,null); }
// SYS-03: number of stages
  public static final Property CmRSC_T7460_parameter_15 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(2)) ));
  public double getCmRSC_T7460_parameter_15() { return getDouble(CmRSC_T7460_parameter_15); }
  public void setCmRSC_T7460_parameter_15(double v) { setDouble(CmRSC_T7460_parameter_15,v,null); }
// SYS-04: type 0=LED; 1=LCD
  public static final Property CmRSC_T7460_parameter_16 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmRSC_T7460_parameter_16() { return getDouble(CmRSC_T7460_parameter_16); }
  public void setCmRSC_T7460_parameter_16(double v) { setDouble(CmRSC_T7460_parameter_16,v,null); }
// DISP-01: manual switch operated alarm
  public static final Property CmRSC_T7460_parameter_17 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmRSC_T7460_parameter_17() { return getDouble(CmRSC_T7460_parameter_17); }
  public void setCmRSC_T7460_parameter_17(double v) { setDouble(CmRSC_T7460_parameter_17,v,null); }
// DISP-02: wire break alarm
  public static final Property CmRSC_T7460_parameter_18 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmRSC_T7460_parameter_18() { return getDouble(CmRSC_T7460_parameter_18); }
  public void setCmRSC_T7460_parameter_18(double v) { setDouble(CmRSC_T7460_parameter_18,v,null); }

  // macro inputs
// SetpointAdjustm
  public static final Property CmRSC_T7460_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmRSC_T7460_input_1() { return (BStatusNumeric) get(CmRSC_T7460_input_1); }
  public void setCmRSC_T7460_input_1(BStatusNumeric v) { set(CmRSC_T7460_input_1,v,null); }
  public void setCmRSC_T7460_input_1(float v) { getCmRSC_T7460_input_1().setValue(v); }
// ManualOverride
  public static final Property CmRSC_T7460_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmRSC_T7460_input_2() { return (BStatusNumeric) get(CmRSC_T7460_input_2); }
  public void setCmRSC_T7460_input_2(BStatusNumeric v) { set(CmRSC_T7460_input_2,v,null); }
  public void setCmRSC_T7460_input_2(float v) { getCmRSC_T7460_input_2().setValue(v); }
// FanSpeedCtrlSig
  public static final Property CmRSC_T7460_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmRSC_T7460_input_3() { return (BStatusNumeric) get(CmRSC_T7460_input_3); }
  public void setCmRSC_T7460_input_3(BStatusNumeric v) { set(CmRSC_T7460_input_3,v,null); }
  public void setCmRSC_T7460_input_3(float v) { getCmRSC_T7460_input_3().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.09 [58] 07.09.2017-16:07").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5839916508319319015").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmRSC_T7460.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }

  // class variables
  protected CmIDT10 func_84 = new CmIDT10();
  protected CfIdt func_117 = new CfIdt();
  protected CfMultiply func_102 = new CfMultiply();
  protected CfMultiply func_106 = new CfMultiply();
  protected CmStartup_Count func_67 = new CmStartup_Count();
  protected CmInput_Levels func_34 = new CmInput_Levels();
  protected CmSwitch_Off_Timer func_36 = new CmSwitch_Off_Timer();
  protected CmExtended_Operations func_63 = new CmExtended_Operations();
  protected CfEqual func_77 = new CfEqual();
  protected CmCPA_Control_Signal func_65 = new CmCPA_Control_Signal();
  protected CmLED func_71 = new CmLED();
  protected CmAlarm func_75 = new CmAlarm();
  protected CfMinimum func_119 = new CfMinimum();
  protected CfInputMultiplexer func_79 = new CfInputMultiplexer();

  // default constructor
  public BCmRSC_T7460()
  {
  }

  public void Start()
  {
    func_84.Start();
    func_67.Start();
    func_34.Start();
    func_36.Start();
    func_63.Start();
    func_65.Start();
    func_71.Start();
    func_75.Start();
  }
}
