/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 03.12.2020 12:02
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.general;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    CPA Calculation
Macro id:      5821401936608363307
Macro version: 17
Last change:   14.10.2013 - 12:38
Access Level:  2
Inputs:
  [1] InputWallmodul
  [2] P3 CPA high range limit
Outputs:
  [1] CPA
  [2] MSC
  [3] MSC invalid
Parameter:
Description:
calculates the offset of setpoint from input of a wallmodul like TF26/ TF22, CLCM3T111
in 0,5 K steps limited through range limits.

MSC invalid means the input is not in range for any calculation. wrong wallmodule?
================================================================================*/

public class CmCPA_Calculation
{
  void Execute( )

  {
    // [31] Function call CfCompare1 ("night")
    func_31.inputA = CmCPA_Calculation_input_1;
    func_31.inputB = 1F;
    func_31.Execute(  );

    // [38] Function call CfWindow
    func_38.inputValue = CmCPA_Calculation_input_1;
    func_38.inputMinimum = 1.5F;
    func_38.inputMaximum = 3.5F;
    func_38.Execute(  );

    // [40] Function call CfWindow
    func_40.inputValue = CmCPA_Calculation_input_1;
    func_40.inputMinimum = 4.9F;
    func_40.inputMaximum = 6.9F;
    func_40.Execute(  );

    // [41] Function call CfMultiply ("middle manu")
    func_41.input[0] = BooleanToFloat(func_38.output);
    func_41.input[1] = 2.49F;
    func_41.Execute(  );

    // [42] Function call CfMultiply ("middle auto")
    func_42.input[0] = BooleanToFloat(func_40.output);
    func_42.input[1] = 5.89F;
    func_42.Execute(  );

    // [61] Function call CfOr
    func_61.input[0] = func_31.outputLess;
    func_61.input[1] = func_38.output;
    func_61.input[2] = func_40.output;
    func_61.Execute(  );
    CmCPA_Calculation_output_53 = func_61.outputNOR;

    // [66] Function call CfInputMultiplexer
    func_66.inputSelect = BooleanToInt(func_40.output);
    func_66.input[1-1] = 999F;
    func_66.input[2-1] = 3F;
    func_66.Execute(  );

    // [82] Function call CfOr
    func_82.input[0] = func_38.output;
    func_82.input[1] = func_40.output;
    func_82.Execute(  );

    // [44] Function call CfMaximum
    func_44.input[0] = func_41.output;
    func_44.input[1] = func_42.output;
    func_44.Execute(  );

    // [64] Function call CfInputMultiplexer
    func_64.inputSelect = BooleanToInt(func_38.output);
    func_64.input[1-1] = func_66.output;
    func_64.input[2-1] = 1F;
    func_64.Execute(  );

    // [5] Function call CfSubtract
    func_5.input[0] = func_44.output;
    func_5.input[1] = CmCPA_Calculation_input_1;
    func_5.Execute(  );

    // [62] Function call CfInputMultiplexer
    func_62.inputSelect = BooleanToInt(func_31.outputLess);
    func_62.input[1-1] = func_64.output;
    func_62.input[2-1] = 0F;
    func_62.Execute(  );
    CmCPA_Calculation_output_54 = func_62.output;

    // [7] Function call CfDivide
    func_7.inputA = func_5.output;
    func_7.inputB = 0.88F;
    func_7.Execute(  );

    // [9] Function call CfMultiply
    func_9.input[0] = func_7.output;
    func_9.input[1] = CmCPA_Calculation_input_3;
    func_9.Execute(  );

    // [11] Function call CfTruncate
    func_11.input = func_9.output;
    func_11.Execute(  );

    // [13] Function call CfDecimalPlaces
    func_13.input = func_9.output;
    func_13.Execute(  );

    // [74] Function call CfCompare1
    func_74.inputA = func_9.output;
    func_74.inputB = 0F;
    func_74.Execute(  );

    // [77] Function call CfInputMultiplexer
    func_77.inputSelect = BooleanToInt(func_74.outputLess);
    func_77.input[1-1] = 0.5F;
    func_77.input[2-1] = -0.5F;
    func_77.Execute(  );

    // [105] Function call CfAbsolute
    func_105.input = func_13.output;
    func_105.Execute(  );

    // [15] Function call CfCompare1
    func_15.inputA = func_105.outputAbs;
    func_15.inputB = 0.25F;
    func_15.Execute(  );

    // [19] Function call CfCompare1
    func_19.inputA = func_105.outputAbs;
    func_19.inputB = 0.75F;
    func_19.Execute(  );

    // [23] Function call CfInputMultiplexer
    func_23.inputSelect = BooleanToInt(func_15.outputLess);
    func_23.input[1-1] = func_77.output;
    func_23.input[2-1] = 0F;
    func_23.Execute(  );

    // [25] Function call CfInputMultiplexer
    func_25.inputSelect = BooleanToInt(func_19.outputLess);
    func_25.input[1-1] = func_77.output;
    func_25.input[2-1] = 0F;
    func_25.Execute(  );

    // [27] Function call CfAddition
    func_27.input[0] = func_11.output;
    func_27.input[1] = func_23.output;
    func_27.input[2] = func_25.output;
    func_27.Execute(  );

    // [79] Function call CfInputMultiplexer
    func_79.inputSelect = BooleanToInt(func_82.outputOR);
    func_79.input[1-1] = 0F;
    func_79.input[2-1] = func_27.output;
    func_79.Execute(  );
    CmCPA_Calculation_output_4 = func_79.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmCPA_Calculation_input_1; // InputWallmodul
public float CmCPA_Calculation_input_3; // P3 CPA high range limit
// macro outputs
public float CmCPA_Calculation_output_4; // CPA
public float CmCPA_Calculation_output_54; // MSC
public boolean CmCPA_Calculation_output_53; // MSC invalid
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfCompare1 func_31 = new CfCompare1();
protected CfWindow func_38 = new CfWindow();
protected CfWindow func_40 = new CfWindow();
protected CfMultiply func_41 = new CfMultiply();
protected CfMultiply func_42 = new CfMultiply();
protected CfOr func_61 = new CfOr();
protected CfInputMultiplexer func_66 = new CfInputMultiplexer();
protected CfOr func_82 = new CfOr();
protected CfMaximum func_44 = new CfMaximum();
protected CfInputMultiplexer func_64 = new CfInputMultiplexer();
protected CfSubtract func_5 = new CfSubtract();
protected CfInputMultiplexer func_62 = new CfInputMultiplexer();
protected CfDivide func_7 = new CfDivide();
protected CfMultiply func_9 = new CfMultiply();
protected CfTruncate func_11 = new CfTruncate();
protected CfDecimalPlaces func_13 = new CfDecimalPlaces();
protected CfCompare1 func_74 = new CfCompare1();
protected CfInputMultiplexer func_77 = new CfInputMultiplexer();
protected CfAbsolute func_105 = new CfAbsolute();
protected CfCompare1 func_15 = new CfCompare1();
protected CfCompare1 func_19 = new CfCompare1();
protected CfInputMultiplexer func_23 = new CfInputMultiplexer();
protected CfInputMultiplexer func_25 = new CfInputMultiplexer();
protected CfAddition func_27 = new CfAddition();
protected CfInputMultiplexer func_79 = new CfInputMultiplexer();

// default constructor
public CmCPA_Calculation()
{
  func_61.configure(3);
  func_27.configure(3);
}

  public void Start()
  {
  }
}
