/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 03.12.2020 12:02
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.general;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    LeadPumpAutoMode
Macro id:      6078156455409615684
Macro version: 39
Last change:   24.02.2015 - 18:55
Access Level:  2
Inputs:
  [1] Startup
  [2] Cur day of week
  [3] Cur day of month
  [4] Runtimechange
Outputs:
  [1] Lead pump auto
  [2] PumpPrefChange
Parameter:
  [1] period of preference change
  [2] day of preference change
  [3] time of preference change (hhmm)
  [4] take over time
  [5] type of pref change
Description:

================================================================================*/

public class CmLeadPumpAutoMode
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [9] Function call CfWindow
    func_9.inputValue = env.getParameter(parameterOffset);
    func_9.inputMinimum = 0.8F;
    func_9.inputMaximum = 1.2F;
    func_9.Execute(  );

    // [10] Function call CfCompare1
    func_10.inputA = IntToFloat(ControlFunction.GetHoursAndMinutes());
    func_10.inputB = env.getParameter(parameterOffset + 2);
    func_10.Execute(  );

    // [12] Function call CfWindow
    func_12.inputValue = env.getParameter(parameterOffset);
    func_12.inputMinimum = 1.8F;
    func_12.inputMaximum = 2.2F;
    func_12.Execute(  );

    // [13] Function call CfCompare1
    func_13.inputA = CmLeadPumpAutoMode_input_94;
    func_13.inputB = env.getParameter(parameterOffset + 1);
    func_13.Execute(  );

    // [16] Function call CfWindow
    func_16.inputValue = env.getParameter(parameterOffset);
    func_16.inputMinimum = 2.8F;
    func_16.inputMaximum = 3.2F;
    func_16.Execute(  );

    // [17] Function call CfCompare1
    func_17.inputA = CmLeadPumpAutoMode_input_95;
    func_17.inputB = env.getParameter(parameterOffset + 1);
    func_17.Execute(  );

    // [11] Function call CfAnd
    func_11.input[0] = func_9.output;
    func_11.input[1] = func_10.outputEqual;
    func_11.Execute(  );

    // [15] Function call CfAnd
    func_15.input[0] = func_12.output;
    func_15.input[1] = func_13.outputEqual;
    func_15.input[2] = func_10.outputEqual;
    func_15.Execute(  );

    // [19] Function call CfAnd
    func_19.input[0] = func_16.output;
    func_19.input[1] = func_17.outputEqual;
    func_19.input[2] = func_10.outputEqual;
    func_19.Execute(  );

    // [22] Function call CfOr
    func_22.input[0] = func_11.outputAND;
    func_22.input[1] = func_15.outputAND;
    func_22.input[2] = func_19.outputAND;
    func_22.Execute(  );

    // [225] Function call CfCompare1
    func_225.inputA = env.getParameter(parameterOffset + 4);
    func_225.inputB = 1F;
    func_225.Execute(  );

    // [247] Function call CfRsFlipFlop
    func_247.inputSet = CmLeadPumpAutoMode_input_223;
    func_247.inputReset = func_192.outputGreater;
    func_247.Execute(  );

    // [254] Function call CfAddition
    func_254.input[0] = env.getParameter(parameterOffset + 3);
    func_254.input[1] = 5F;
    func_254.Execute(  );

    // [279] Function call CfIdt
    func_279.input = func_221.output;
    func_279.Execute(  );
    CmLeadPumpAutoMode_output_92 = func_279.output[0];

    // [248] Function call CfAnd
    func_248.input[0] = func_22.outputOR;
    func_248.input[1] = func_247.output;
    func_248.Execute(  );

    // [249] Function call CfInputMultiplexer
    func_249.inputSelect = BooleanToInt(func_225.outputLess);
    func_249.input[1-1] = 0F;
    func_249.input[2-1] = BooleanToFloat(func_22.outputOR);
    func_249.Execute(  );

    // [255] Function call CfIdt
    func_255.input = func_254.output;
    func_255.Execute(  );
    env.setParameter(parameterOffset + 5, func_255.output[0]);
    env.setParameter(parameterOffset + 6, func_255.output[1]);

    // [256] Function call CfCompare1
    func_256.inputA = func_279.output[1];
    func_256.inputB = 1F;
    func_256.Execute(  );

    // [257] Function call CfCompare1
    func_257.inputA = func_279.output[2];
    func_257.inputB = 2F;
    func_257.Execute(  );

    // [246] Function call CfInputMultiplexer
    func_246.inputSelect = BooleanToInt(func_225.outputEqual);
    func_246.input[1-1] = func_249.output;
    func_246.input[2-1] = BooleanToFloat(func_248.outputAND);
    func_246.Execute(  );

    // [258] Function call CfMonoflop
    func_258.input = BooleanToFloat(func_256.outputEqual);
    func_258.Execute( env, parameterOffset + 5 );

    // [259] Function call CfMonoflop
    func_259.input = BooleanToFloat(func_257.outputEqual);
    func_259.Execute( env, parameterOffset + 6 );

    // [251] Function call CfInputMultiplexer
    func_251.inputSelect = BooleanToInt(func_225.outputGreater);
    func_251.input[1-1] = func_246.output;
    func_251.input[2-1] = BooleanToFloat(CmLeadPumpAutoMode_input_223);
    func_251.Execute(  );

    // [189] Function call CfLastValue
    func_189.input = func_251.output;
    func_189.Execute(  );

    // [192] Function call CfCompare1
    func_192.inputA = func_189.outputCurrent;
    func_192.inputB = func_189.outputLast;
    func_192.Execute(  );

    // [215] Function call CfAnd
    func_215.input[0] = func_192.outputGreater;
    func_215.input[1] = func_218.output;
    func_215.input[2] = func_216.outputNAND;
    func_215.Execute(  );

    // [210] Function call CfRsFlipFlop
    func_210.inputSet = func_215.outputAND;
    func_210.inputReset = func_216.outputAND;
    func_210.Execute(  );

    // [216] Function call CfAnd
    func_216.input[0] = func_192.outputGreater;
    func_216.input[1] = func_210.output;
    func_216.input[2] = func_215.outputNAND;
    func_216.Execute(  );

    // [218] Function call CfNot
    func_218.input = func_210.output;
    func_218.Execute(  );

    // [221] Function call CfAddition
    func_221.input[0] = BooleanToFloat(func_210.output);
    func_221.input[1] = 1F;
    func_221.Execute(  );

    // [260] Function call CfOr
    func_260.input[0] = func_258.output;
    func_260.input[1] = func_259.output;
    func_260.Execute(  );
    CmLeadPumpAutoMode_output_280 = func_260.outputOR;

  }
// macro register which are written multiple times
// macro inputs
public boolean CmLeadPumpAutoMode_input_89; // Startup(not used)
public float CmLeadPumpAutoMode_input_94; // Cur day of week
public float CmLeadPumpAutoMode_input_95; // Cur day of month
public boolean CmLeadPumpAutoMode_input_223; // Runtimechange
// macro outputs
public float CmLeadPumpAutoMode_output_92; // Lead pump auto
public boolean CmLeadPumpAutoMode_output_280; // PumpPrefChange
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private float   IntToFloat    (int     value) { return (float) value; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfWindow func_9 = new CfWindow();
protected CfCompare1 func_10 = new CfCompare1();
protected CfWindow func_12 = new CfWindow();
protected CfCompare1 func_13 = new CfCompare1();
protected CfWindow func_16 = new CfWindow();
protected CfCompare1 func_17 = new CfCompare1();
protected CfAnd func_11 = new CfAnd();
protected CfAnd func_15 = new CfAnd();
protected CfAnd func_19 = new CfAnd();
protected CfOr func_22 = new CfOr();
protected CfCompare1 func_225 = new CfCompare1();
protected CfRsFlipFlop func_247 = new CfRsFlipFlop();
protected CfAddition func_254 = new CfAddition();
protected CfIdt func_279 = new CfIdt();
protected CfAnd func_248 = new CfAnd();
protected CfInputMultiplexer func_249 = new CfInputMultiplexer();
protected CfIdt func_255 = new CfIdt();
protected CfCompare1 func_256 = new CfCompare1();
protected CfCompare1 func_257 = new CfCompare1();
protected CfInputMultiplexer func_246 = new CfInputMultiplexer();
protected CfMonoflop func_258 = new CfMonoflop();
protected CfMonoflop func_259 = new CfMonoflop();
protected CfInputMultiplexer func_251 = new CfInputMultiplexer();
protected CfLastValue func_189 = new CfLastValue();
protected CfCompare1 func_192 = new CfCompare1();
protected CfAnd func_215 = new CfAnd();
protected CfRsFlipFlop func_210 = new CfRsFlipFlop();
protected CfAnd func_216 = new CfAnd();
protected CfNot func_218 = new CfNot();
protected CfAddition func_221 = new CfAddition();
protected CfOr func_260 = new CfOr();

// default constructor
public CmLeadPumpAutoMode()
{
  func_15.configure(3);
  func_19.configure(3);
  func_22.configure(3);
  func_279.configure(3);
  func_255.configure(2);
  func_215.configure(3);
  func_216.configure(3);
}

  public void Start()
  {
    func_247.Start();
    func_258.Start();
    func_259.Start();
    func_189.Start();
    func_210.Start();
  }
}
