/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 03.12.2020 12:02
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.general;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    PositionChange
Macro id:      6344918260672103207
Macro version: 10
Last change:   14.11.2016 - 14:43
Access Level:  2
Inputs:
  [1] Runtime
  [2] Enable
Outputs:
  [1] PosChangeEff
  [2] PosChange
Parameter:
  [1] Sys01_Negate
  [2] Number of RACL loops
Description:
Calcuates the position change in the motor model based on the cycle time of the controller. 

Enable and Enalbe 2 are connected with an AND statement. Only if both a true the position changes. 

PosChangeEff [%] will show the PosChange based on the last RACL loop. 
PosChange will show always the potential PosChange. This value is an average of the last 4 RACL loops. 

INPUT: 
Runtime  [sec]
Enable2 (is it run in last execution)
Enable (for disabling macro)


OUT: 
PosChangeEff [%]
Poschange [%]

================================================================================*/

public class CmPositionChange
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [43] Function call CfAddition ("Reset at ResetValue")
    func_43.input[0] = 1F;
    func_43.input[1] = func_44.output;
    func_43.Execute(  );

    // [45] Function call CfCompare1
    func_45.inputA = func_43.output;
    func_45.inputB = 4F;
    func_45.Execute(  );

    // [47] Function call CfOr
    func_47.input[0] = func_45.outputGreater;
    func_47.input[1] = func_45.outputEqual;
    func_47.Execute(  );

    // [44] Function call CfInputMultiplexer
    func_44.inputSelect = BooleanToInt(func_47.outputOR);
    func_44.input[1-1] = func_43.output;
    func_44.input[2-1] = 0F;
    func_44.Execute(  );

    // [27] Macro call CmCycle_time
    func_27.Execute( env, parameterOffset +2 );

    // [4] Function call CfMultiply
    func_4.input[0] = 100F;
    func_4.input[1] = func_27.CmCycle_time_output_13;
    func_4.Execute(  );

    // [6] Function call CfDivide
    func_6.inputA = func_4.output;
    func_6.inputB = CmPositionChange_input_1;
    func_6.Execute(  );

    // [21] Function call CfNegate
    func_21.input = func_6.output;
    func_21.Execute(  );

    // [18] Function call CfInputMultiplexer
    func_18.inputSelect = FloatToInt(env.getParameter(parameterOffset));
    func_18.input[1-1] = func_6.output;
    func_18.input[2-1] = func_21.output;
    func_18.Execute(  );

    // [9] Function call CfInputMultiplexer
    func_9.inputSelect = BooleanToInt(CmPositionChange_input_10);
    func_9.input[1-1] = 0F;
    func_9.input[2-1] = func_18.output;
    func_9.Execute(  );
    CmPositionChange_output_2 = func_9.output;

    // [66] Function call CfSubtract
    func_66.input[0] = func_43.output;
    func_66.input[1] = 1F;
    func_66.Execute(  );

    // [56] Function call CfOutputMultiplexer
    func_56.inputSelect = FloatToInt(func_66.output);
    func_56.inputValue = func_18.output;
    func_56.Execute( env, parameterOffset + 4 );

    // [35] Function call CfAverage
    func_35.input[0] = func_56.output[0];
    func_35.input[1] = func_56.output[1];
    func_35.input[2] = func_56.output[2];
    func_35.input[3] = func_56.output[3];
    func_35.ExecuteArithmeticAverage( );
    // [26] Function call CfIdt
    func_26.input = func_35.outputA;
    func_26.Execute(  );
    CmPositionChange_output_23 = func_26.output[0];

  }
// macro register which are written multiple times
// macro inputs
public float CmPositionChange_input_1; // Runtime
public boolean CmPositionChange_input_10; // Enable
// macro outputs
public float CmPositionChange_output_2; // PosChangeEff
public float CmPositionChange_output_23; // PosChange
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }

// class variables
protected CfAddition func_43 = new CfAddition();
protected CfCompare1 func_45 = new CfCompare1();
protected CfOr func_47 = new CfOr();
protected CfInputMultiplexer func_44 = new CfInputMultiplexer();
protected CmCycle_time func_27 = new CmCycle_time();
protected CfMultiply func_4 = new CfMultiply();
protected CfDivide func_6 = new CfDivide();
protected CfNegate func_21 = new CfNegate();
protected CfInputMultiplexer func_18 = new CfInputMultiplexer();
protected CfInputMultiplexer func_9 = new CfInputMultiplexer();
protected CfSubtract func_66 = new CfSubtract();
protected CfOutputMultiplexer func_56 = new CfOutputMultiplexer();
protected CfAverage func_35 = new CfAverage();
protected CfIdt func_26 = new CfIdt();

// default constructor
public CmPositionChange()
{
  func_56.configure(4);
  func_35.configure(4);
}

  public void Start()
  {
    func_27.Start();
  }
}
