/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 03.12.2020 12:02
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.general;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    PumpRuntimeChange
Macro id:      6078152742765855332
Macro version: 12
Last change:   12.01.2015 - 09:11
Access Level:  2
Inputs:
  [1] Lead pump auto
  [2] Pump1 Cmd
  [3] Pump1 status
  [4] Pump2 Cmd
  [5] Pump2 status
Outputs:
  [1] pump runtime change
Parameter:
  [1] difference in run-times between pumps
  [2] hours run since preference change: pump PC1
  [3] hours run since preference change: pump PC2
  [4] take over time
Description:

================================================================================*/

public class CmPumpRuntimeChange
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [7] Function call CfWindow
    func_7.inputValue = CmPumpRuntimeChange_input_53;
    func_7.inputMinimum = 0.8F;
    func_7.inputMaximum = 1.2F;
    func_7.Execute(  );

    // [16] Function call CfOr
    func_16.input[0] = CmPumpRuntimeChange_input_56;
    func_16.input[1] = CmPumpRuntimeChange_input_57;
    func_16.Execute(  );

    // [17] Function call CfOr
    func_17.input[0] = CmPumpRuntimeChange_input_58;
    func_17.input[1] = CmPumpRuntimeChange_input_59;
    func_17.Execute(  );

    // [20] Function call CfWindow
    func_20.inputValue = CmPumpRuntimeChange_input_53;
    func_20.inputMinimum = 1.8F;
    func_20.inputMaximum = 2.2F;
    func_20.Execute(  );

    // [6] Function call CfTimeCounter
    func_6.inputSignal = func_16.outputOR;
    func_6.inputReset = func_8.outputAND;
    func_6.Execute(  );

    // [18] Function call CfIdt
    func_18.input = IntToFloat(func_6.outputHours);
    func_18.Execute(  );
    env.setParameter(parameterOffset + 1, func_18.output[0]);

    // [14] Function call CfTimeCounter
    func_14.inputSignal = func_17.outputOR;
    func_14.inputReset = func_15.outputAND;
    func_14.Execute(  );

    // [9] Function call CfMaximum
    func_9.input[0] = IntToFloat(func_6.outputHours);
    func_9.input[1] = IntToFloat(func_14.outputHours);
    func_9.Execute(  );

    // [13] Function call CfMinimum
    func_13.input[0] = IntToFloat(func_6.outputHours);
    func_13.input[1] = IntToFloat(func_14.outputHours);
    func_13.Execute(  );

    // [19] Function call CfIdt
    func_19.input = IntToFloat(func_14.outputHours);
    func_19.Execute(  );
    env.setParameter(parameterOffset + 2, func_19.output[0]);

    // [10] Function call CfSubtract
    func_10.input[0] = func_9.output;
    func_10.input[1] = func_13.output;
    func_10.Execute(  );

    // [11] Function call CfCompare1
    func_11.inputA = func_10.output;
    func_11.inputB = env.getParameter(parameterOffset);
    func_11.Execute(  );

    // [12] Function call CfMonoflop
    func_12.input = BooleanToFloat(func_11.outputGreater);
    func_12.Execute( env, parameterOffset + 4 );
    CmPumpRuntimeChange_output_54 = func_12.output;

    // [8] Function call CfAnd
    func_8.input[0] = func_7.output;
    func_8.input[1] = CmPumpRuntimeChange_output_54;
    func_8.Execute(  );

    // [15] Function call CfAnd
    func_15.input[0] = func_20.output;
    func_15.input[1] = CmPumpRuntimeChange_output_54;
    func_15.Execute(  );

    // [61] Function call CfAddition
    func_61.input[0] = env.getParameter(parameterOffset + 3);
    func_61.input[1] = 5F;
    func_61.Execute(  );
    env.setParameter(parameterOffset + 4, func_61.output);

  }
// macro register which are written multiple times
// macro inputs
public float CmPumpRuntimeChange_input_53; // Lead pump auto
public boolean CmPumpRuntimeChange_input_56; // Pump1 Cmd
public boolean CmPumpRuntimeChange_input_57; // Pump1 status
public boolean CmPumpRuntimeChange_input_58; // Pump2 Cmd
public boolean CmPumpRuntimeChange_input_59; // Pump2 status
// macro outputs
public boolean CmPumpRuntimeChange_output_54; // pump runtime change
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private float   IntToFloat    (int     value) { return (float) value; }

// class variables
protected CfWindow func_7 = new CfWindow();
protected CfOr func_16 = new CfOr();
protected CfOr func_17 = new CfOr();
protected CfWindow func_20 = new CfWindow();
protected CfTimeCounter func_6 = new CfTimeCounter();
protected CfIdt func_18 = new CfIdt();
protected CfTimeCounter func_14 = new CfTimeCounter();
protected CfMaximum func_9 = new CfMaximum();
protected CfMinimum func_13 = new CfMinimum();
protected CfIdt func_19 = new CfIdt();
protected CfSubtract func_10 = new CfSubtract();
protected CfCompare1 func_11 = new CfCompare1();
protected CfMonoflop func_12 = new CfMonoflop();
protected CfAnd func_8 = new CfAnd();
protected CfAnd func_15 = new CfAnd();
protected CfAddition func_61 = new CfAddition();

// default constructor
public CmPumpRuntimeChange()
{
}

  public void Start()
  {
    func_6.Start();
    func_14.Start();
    func_12.Start();
  }
}
