/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 03.12.2020 12:02
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.general;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Switch Back To Auto And LED Control
Macro id:      5841482640962617469
Macro version: 29
Last change:   26.02.2015 - 15:03
Access Level:  2
Inputs:
  [1] MSC input
  [2] P04 day extension
  [3] P05 night extension
Outputs:
  [1] LED
  [2] MSC
Parameter:
Description:
- Automatic switch back from manual to auto operation after programmable time
The duration of the extended day / night operation can be limited by parameter 4 / 
parameter 5. Parameter 4 determines the extension period of the day switch command 
and parameter 5 determines the extension period of the night switch command. 

When the manual switch position of the TF26 is set to ‘day’, the MSC output is set to ‘1’,
 indicating the extended day operation and the extend day timer is started. When the 
extended day timer exceeds the value of P4, the MSC output is set back to auto. 
To restart the day extend timer, the switch must be set back to auto and then to day 
again.
When the manual switch position of the TF26 is set to ‘night’, the MSC output is set to 
‘0’, indicating the extended night operation and the extend night timer is started. When 
the extended night timer exceeds the value of P5, the MSC output is set back to auto. 
To restart the night extend timer, the switch must be set back to auto and then to night 
again.
Note: To disable the automatic switch back from manual day operation to automatic 
operation set the P4 to 0.
To disable the automatic switch back from manual night operation to automatic 
operation set the P5 to 0.


- Display manual switch operation at the TF26 led.
The LED of the TF26 represents the actual MSC output status:
MSC status	LED
Auto	              OFF
Night	              Blinking with the period of  the RACL cycle time
Day	              ON


- Manual switch alarm
The MSA output is a digital output, which indicates whether the TF26 manual switch 
is manually operated (not in the automatic position). It will also indicate an alarm in 
case of wire break detection. The origin of the alarm can be read by the display 
parameters P6 and P7. The MSA output can be used for indication purposes at the 
PC-central. 


- Display parameter
Display parameter P6 shows an alarm when the TF26 is set to ‘DAY’ or ‘NIGHT’ 
operation 
Display parameter P7 shows an alarm in case of a wire breakage.

================================================================================*/

public class CmSwitch_Back_To_Auto_And_LED_Control
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [64] Function call CfCompare1
    func_64.inputA = CmSwitch_Back_To_Auto_And_LED_Control_input_27;
    func_64.inputB = 1F;
    func_64.Execute(  );

    // [55] Function call CfCompare1
    func_55.inputA = CmSwitch_Back_To_Auto_And_LED_Control_input_27;
    func_55.inputB = 0F;
    func_55.Execute(  );

    // [139] Function call CfMultiply
    func_139.input[0] = CmSwitch_Back_To_Auto_And_LED_Control_input_28;
    func_139.input[1] = 60F;
    func_139.Execute(  );

    // [102] Function call CfIdt
    func_102.input = func_139.output;
    func_102.Execute(  );
    env.setParameter(parameterOffset, func_102.output[0]);

    // [142] Function call CfMultiply
    func_142.input[0] = CmSwitch_Back_To_Auto_And_LED_Control_input_29;
    func_142.input[1] = 60F;
    func_142.Execute(  );

    // [110] Function call CfIdt
    func_110.input = func_142.output;
    func_110.Execute(  );
    env.setParameter(parameterOffset + 1, func_110.output[0]);

    // [164] Function call CfInputMultiplexer
    func_164.inputSelect = BooleanToInt(ControlFunction.GetStartupFlag());
    func_164.input[1-1] = BooleanToFloat(func_64.outputEqual);
    func_164.input[2-1] = 0F;
    func_164.Execute(  );

    // [167] Function call CfInputMultiplexer
    func_167.inputSelect = BooleanToInt(ControlFunction.GetStartupFlag());
    func_167.input[1-1] = BooleanToFloat(func_55.outputEqual);
    func_167.input[2-1] = 0F;
    func_167.Execute(  );

    // [179] Function call CfCompare1
    func_179.inputA = CmSwitch_Back_To_Auto_And_LED_Control_input_29;
    func_179.inputB = 0F;
    func_179.Execute(  );

    // [186] Function call CfCompare1
    func_186.inputA = CmSwitch_Back_To_Auto_And_LED_Control_input_28;
    func_186.inputB = 0F;
    func_186.Execute(  );

    // [145] Function call CfMonoflop
    func_145.input = func_164.output;
    func_145.Execute( env, parameterOffset );

    // [146] Function call CfMonoflop
    func_146.input = func_167.output;
    func_146.Execute( env, parameterOffset + 1 );

    // [176] Function call CfAnd
    func_176.input[0] = func_55.outputEqual;
    func_176.input[1] = func_179.outputEqual;
    func_176.Execute(  );

    // [183] Function call CfAnd
    func_183.input[0] = func_186.outputEqual;
    func_183.input[1] = func_64.outputEqual;
    func_183.Execute(  );

    // [147] Function call CfAnd
    func_147.input[0] = FloatToBoolean(func_139.output);
    func_147.input[1] = func_64.outputEqual;
    func_147.input[2] = func_145.output;
    func_147.Execute(  );

    // [148] Function call CfAnd
    func_148.input[0] = FloatToBoolean(func_142.output);
    func_148.input[1] = func_55.outputEqual;
    func_148.input[2] = func_146.output;
    func_148.Execute(  );

    // [170] Function call CfOr
    func_170.input[0] = func_183.outputAND;
    func_170.input[1] = func_147.outputAND;
    func_170.Execute(  );

    // [173] Function call CfOr
    func_173.input[0] = func_148.outputAND;
    func_173.input[1] = func_176.outputAND;
    func_173.Execute(  );

    // [7] Function call CfInputMultiplexer ("manu 0")
    func_7.inputSelect = BooleanToInt(func_173.outputOR);
    func_7.input[1-1] = 3F;
    func_7.input[2-1] = 0F;
    func_7.Execute(  );

    // [5] Function call CfInputMultiplexer ("manu 1")
    func_5.inputSelect = BooleanToInt(func_170.outputOR);
    func_5.input[1-1] = func_7.output;
    func_5.input[2-1] = 1F;
    func_5.Execute(  );

    // [23] Function call CfNot
    func_23.input = FloatToBoolean(func_25.output[0]);
    func_23.Execute(  );

    // [16] Function call CfCompare1
    func_16.inputA = func_5.output;
    func_16.inputB = 0F;
    func_16.Execute(  );

    // [13] Function call CfInputMultiplexer ("toggle")
    func_13.inputSelect = BooleanToInt(func_23.output);
    func_13.input[1-1] = 0F;
    func_13.input[2-1] = 100F;
    func_13.Execute(  );

    // [25] Function call CfIdt
    func_25.input = BooleanToFloat(func_23.output);
    func_25.Execute(  );

    // [18] Function call CfCompare1
    func_18.inputA = func_5.output;
    func_18.inputB = 3F;
    func_18.Execute(  );

    // [3] Function call CfInputMultiplexer
    func_3.inputSelect = BooleanToInt(func_16.outputEqual);
    func_3.input[1-1] = 100F;
    func_3.input[2-1] = func_13.output;
    func_3.Execute(  );

    // [12] Function call CfIdt
    func_12.input = func_5.output;
    func_12.Execute(  );
    CmSwitch_Back_To_Auto_And_LED_Control_output_11 = func_12.output[0];

    // [1] Function call CfInputMultiplexer
    func_1.inputSelect = BooleanToInt(func_18.outputEqual);
    func_1.input[1-1] = func_3.output;
    func_1.input[2-1] = 0F;
    func_1.Execute(  );
    CmSwitch_Back_To_Auto_And_LED_Control_output_10 = func_1.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmSwitch_Back_To_Auto_And_LED_Control_input_27; // MSC input
public float CmSwitch_Back_To_Auto_And_LED_Control_input_28; // P04 day extension
public float CmSwitch_Back_To_Auto_And_LED_Control_input_29; // P05 night extension
// macro outputs
public float CmSwitch_Back_To_Auto_And_LED_Control_output_10; // LED
public float CmSwitch_Back_To_Auto_And_LED_Control_output_11; // MSC
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfCompare1 func_64 = new CfCompare1();
protected CfCompare1 func_55 = new CfCompare1();
protected CfMultiply func_139 = new CfMultiply();
protected CfIdt func_102 = new CfIdt();
protected CfMultiply func_142 = new CfMultiply();
protected CfIdt func_110 = new CfIdt();
protected CfInputMultiplexer func_164 = new CfInputMultiplexer();
protected CfInputMultiplexer func_167 = new CfInputMultiplexer();
protected CfCompare1 func_179 = new CfCompare1();
protected CfCompare1 func_186 = new CfCompare1();
protected CfMonoflop func_145 = new CfMonoflop();
protected CfMonoflop func_146 = new CfMonoflop();
protected CfAnd func_176 = new CfAnd();
protected CfAnd func_183 = new CfAnd();
protected CfAnd func_147 = new CfAnd();
protected CfAnd func_148 = new CfAnd();
protected CfOr func_170 = new CfOr();
protected CfOr func_173 = new CfOr();
protected CfInputMultiplexer func_7 = new CfInputMultiplexer();
protected CfInputMultiplexer func_5 = new CfInputMultiplexer();
protected CfNot func_23 = new CfNot();
protected CfCompare1 func_16 = new CfCompare1();
protected CfInputMultiplexer func_13 = new CfInputMultiplexer();
protected CfIdt func_25 = new CfIdt();
protected CfCompare1 func_18 = new CfCompare1();
protected CfInputMultiplexer func_3 = new CfInputMultiplexer();
protected CfIdt func_12 = new CfIdt();
protected CfInputMultiplexer func_1 = new CfInputMultiplexer();

// default constructor
public CmSwitch_Back_To_Auto_And_LED_Control()
{
  func_147.configure(3);
  func_148.configure(3);
}

  public void Start()
  {
    func_145.Start();
    func_146.Start();
  }
}
