/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    BOA_StagedBoiler
Macro id:      5977211126592570267
Macro version: 211
Last change:   05.03.2018 - 10:05
Access Level:  2
Inputs:
  [1] SupplyTemp
  [2] RetTemp
  [3] RetTempSp
  [4] ManSwCond
  [5] PumpStatus
  [6] ValveEndSwitch
  [7] BurnerAlarm
  [8] AlarmIn
  [9] PumpAlarm
  [10] Reset
Outputs:
  [1] Stage1Cmd
  [2] Stage2Cmd
  [3] ValveControl
  [4] ButFlyVlv
  [5] PumpCmd
  [6] VESAlarm
  [7] DispBlrPower
  [8] DispPosNumber
  [9] OperationMode
  [10] StageReqMode
Parameter:
  [1] CFG-01: heat generator group
  [2] BST-01: maximum boiler supply temperature stage 1
  [3] BST-02: maximum boiler supply temperature stage 2
  [4] BST-04: minimum boiler supply temperature
  [5] BRT-01: P-band boiler return temperature
  [6] BRT-02: I-time boiler return temperature
  [7] BPU-01: pump off delay
  [8] BPU-02: temperature difference pump stop
  [9] ST1-01: capacity stage 1
  [10] ST1-02: minimum on time stage 1
  [11] ST1-03: minimum off time stage 1
  [12] ST1-04: switch on delay next stage or boiler
  [13] ST1-05: switch off delay next stage or boiler
  [14] ST2-01: capacity stage 2
  [15] ST2-02: minimum on time stage 2
  [16] ST2-03: minimum off time stage 2
  [17] ST2-04: switch on delay next stage or boiler
  [18] ST2-05: switch off delay next stage or boiler
  [19] SYS-01: position number
  [20] SYS-02: configuration boiler type
  [21] SYS-03: heat generator water volume
  [22] SYS-04: maximum boiler runtime
  [23] SYS-05: total cool down; 1 = yes
  [24] SYS-06: automatic/ manual reset; 0 = auto
  [25] SYS-07: switch off boiler stages at alarm
  [26] DISP-01: blocking signal
  [27] DISP-02: calculated boiler capacity
  [28] DISP-03: operation mode
  [29] DISP-04: hours before cyclic changeover
Description:
The BOA_StagedBoiler macro provides 1 or 2 stages on/off boiler control with adjustable delays and optional boiler return temperature limitation. The macro can be used for standalone and multiple boilers always in combination with the heating control strategy macro.
The boiler has different start and stop procedure depending on the configurations for large and small water volume and the return temperature control mode.
When a boiler stage switches on it starts its minimum on time and the blocking time to switch on the next stage or boiler.
When a boiler stage switches off it starts its minimum off time and the blocking time to switch off the next stage or boiler.
The macro also controls the boiler pump and valve.
If you need status and alarm inputs for the pump, you have to add an extra pump macro and connect the pump datapoint to both macro outputs. The pump command macro also provides pump exercise. 
All the communication signals with other heat generators and the heating strategy will be connected automatically via global registers. The user has the option to assign a heat generator to one of three heat generator groups with different sequences depending on outside air temperature or a manual switch.
================================================================================*/

public class BCmBOA_StagedBoiler
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmBOA_StagedBoiler_output_73().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmBOA_StagedBoiler_output_73().setStatus(BStatus.disabled);
    getCmBOA_StagedBoiler_output_74().setStatus(BStatus.disabled);
    getCmBOA_StagedBoiler_output_105().setStatus(BStatus.disabled);
    getCmBOA_StagedBoiler_output_284().setStatus(BStatus.disabled);
    getCmBOA_StagedBoiler_output_286().setStatus(BStatus.disabled);
    getCmBOA_StagedBoiler_output_76().setStatus(BStatus.disabled);
    getCmBOA_StagedBoiler_output_109().setStatus(BStatus.disabled);
    getCmBOA_StagedBoiler_output_111().setStatus(BStatus.disabled);
    getCmBOA_StagedBoiler_output_110().setStatus(BStatus.disabled);
    getCmBOA_StagedBoiler_output_503().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmBOA_StagedBoiler_output_73().setStatus(BStatus.ok);
    getCmBOA_StagedBoiler_output_74().setStatus(BStatus.ok);
    getCmBOA_StagedBoiler_output_105().setStatus(BStatus.ok);
    getCmBOA_StagedBoiler_output_284().setStatus(BStatus.ok);
    getCmBOA_StagedBoiler_output_286().setStatus(BStatus.ok);
    getCmBOA_StagedBoiler_output_76().setStatus(BStatus.ok);
    getCmBOA_StagedBoiler_output_109().setStatus(BStatus.ok);
    getCmBOA_StagedBoiler_output_111().setStatus(BStatus.ok);
    getCmBOA_StagedBoiler_output_110().setStatus(BStatus.ok);
    getCmBOA_StagedBoiler_output_503().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [132] Macro call CmIDT05
    func_132.CmIDT05_input_1 = (float) getCmBOA_StagedBoiler_parameter_99();
    func_132.CmIDT05_input_2 = 2F;
    func_132.CmIDT05_input_3 = (float) getCmBOA_StagedBoiler_parameter_82();
    func_132.CmIDT05_input_4 = (float) getCmBOA_StagedBoiler_parameter_80();
    func_132.CmIDT05_input_5 = (float) getCmBOA_StagedBoiler_parameter_81();
    func_132.Execute(  );
    setParameter(1, func_132.CmIDT05_output_21);
    setParameter(0, func_132.CmIDT05_output_22);
    setParameter(208, func_132.CmIDT05_output_23);
    setParameter(72, func_132.CmIDT05_output_24);
    setParameter(73, func_132.CmIDT05_output_25);

    // [261] Macro call CmIDT20
    func_261.CmIDT20_input_1 = (float) getCmBOA_StagedBoiler_parameter_84();
    func_261.CmIDT20_input_2 = (float) getCmBOA_StagedBoiler_parameter_85();
    func_261.CmIDT20_input_3 = (float) getCmBOA_StagedBoiler_parameter_86();
    func_261.CmIDT20_input_4 = (float) getCmBOA_StagedBoiler_parameter_87();
    func_261.CmIDT20_input_5 = (float) getCmBOA_StagedBoiler_parameter_82();
    func_261.CmIDT20_input_6 = (float) getCmBOA_StagedBoiler_parameter_97();
    func_261.CmIDT20_input_7 = (float) getCmBOA_StagedBoiler_parameter_98();
    func_261.CmIDT20_input_8 = (float) getCmBOA_StagedBoiler_parameter_88();
    func_261.CmIDT20_input_9 = (float) getCmBOA_StagedBoiler_parameter_89();
    func_261.CmIDT20_input_10 = (float) getCmBOA_StagedBoiler_parameter_90();
    func_261.CmIDT20_input_11 = (float) getCmBOA_StagedBoiler_parameter_91();
    func_261.CmIDT20_input_12 = (float) getCmBOA_StagedBoiler_parameter_93();
    func_261.CmIDT20_input_13 = (float) getCmBOA_StagedBoiler_parameter_94();
    func_261.CmIDT20_input_14 = (float) getCmBOA_StagedBoiler_parameter_95();
    func_261.CmIDT20_input_15 = (float) getCmBOA_StagedBoiler_parameter_96();
    func_261.CmIDT20_input_16 = (float) getCmBOA_StagedBoiler_parameter_39();
    func_261.CmIDT20_input_17 = (float) getCmBOA_StagedBoiler_parameter_41();
    func_261.CmIDT20_input_18 = (float) getCmBOA_StagedBoiler_parameter_11();
    func_261.CmIDT20_input_19 = (float) getCmBOA_StagedBoiler_parameter_39();
    func_261.CmIDT20_input_20 = (float) getCmBOA_StagedBoiler_parameter_41();
    func_261.Execute(  );
    setParameter(19, func_261.CmIDT20_output_21);
    setParameter(20, func_261.CmIDT20_output_22);
    setParameter(17, func_261.CmIDT20_output_23);
    setParameter(18, func_261.CmIDT20_output_24);
    setParameter(16, func_261.CmIDT20_output_25);
    setParameter(13, func_261.CmIDT20_output_26);
    setParameter(14, func_261.CmIDT20_output_27);
    setParameter(62, func_261.CmIDT20_output_28);
    setParameter(66, func_261.CmIDT20_output_29);
    setParameter(63, func_261.CmIDT20_output_30);
    setParameter(67, func_261.CmIDT20_output_31);
    setParameter(64, func_261.CmIDT20_output_32);
    setParameter(68, func_261.CmIDT20_output_33);
    setParameter(65, func_261.CmIDT20_output_34);
    setParameter(69, func_261.CmIDT20_output_35);
    setParameter(70, func_261.CmIDT20_output_36);
    setParameter(71, func_261.CmIDT20_output_37);
    setCmBOA_StagedBoiler_output_111(func_261.CmIDT20_output_38);
    setParameter(206, func_261.CmIDT20_output_39);
    setParameter(207, func_261.CmIDT20_output_40);

    // [358] Macro call CmIDT05
    func_358.CmIDT05_input_1 = (float) getCmBOA_StagedBoiler_parameter_238();
    func_358.CmIDT05_input_2 = (float) getCmBOA_StagedBoiler_parameter_100();
    func_358.CmIDT05_input_3 = (float) getCmBOA_StagedBoiler_parameter_238();
    func_358.CmIDT05_input_4 = (float) getCmBOA_StagedBoiler_parameter_11();
    func_358.CmIDT05_input_5 = (float) getCmBOA_StagedBoiler_parameter_97();
    func_358.Execute(  );
    setParameter(213, func_358.CmIDT05_output_21);
    setParameter(15, func_358.CmIDT05_output_22);
    setParameter(9, func_358.CmIDT05_output_23);
    setParameter(21, func_358.CmIDT05_output_24);
    setParameter(200, func_358.CmIDT05_output_25);

    // [450] Function call CfIdt
    func_450.input = (float) getCmBOA_StagedBoiler_parameter_449();
    func_450.Execute(  );
    setParameter(10, func_450.output[0]);

    // [473] Function call CfIdt
    func_473.input = (float) getCmBOA_StagedBoiler_parameter_86();
    func_473.Execute(  );
    setParameter(11, func_473.output[0]);

    // [552] Function call CfIdt
    func_552.input = (float) getCmBOA_StagedBoiler_parameter_449();
    func_552.Execute(  );
    setParameter(203, func_552.output[0]);

    // [151] Function call CfHysteresis
    func_151.inputX = (float) getCmBOA_StagedBoiler_output_105().getValue();
    func_151.inputW = 3F;
    func_151.Execute( this, 0 );

    // [145] Function call CfOr
    func_145.input[0] = func_216.CmBoiler_Demand_output_636;
    func_145.input[1] = func_216.CmBoiler_Demand_output_637;
    func_145.input[2] = func_151.output1;
    func_145.Execute(  );

    // [121] Macro call CmLaufzeit
    func_121.CmLaufzeit_input_1 = func_145.outputOR;
    func_121.CmLaufzeit_input_47 = (float) getCmBOA_StagedBoiler_parameter_19();
    func_121.CmLaufzeit_input_79 = func_58.CmChange_Position_output_205;
    func_121.Execute( this, 1 );
    setParameter(7, BooleanToFloat(func_121.CmLaufzeit_output_2));
    setCmBOA_StagedBoiler_parameter_104(func_121.CmLaufzeit_output_37);

    // [57] Macro call CmConfig_Boiler
    func_57.CmConfig_Boiler_input_71 = (float) getCmBOA_StagedBoiler_parameter_11();
    func_57.CmConfig_Boiler_input_68 = (float) getCmBOA_StagedBoiler_parameter_19();
    func_57.Execute( this, 2 );

    // [58] Macro call CmChange_Position
    func_58.CmChange_Position_input_81 = func_57.CmConfig_Boiler_output_58;
    func_58.CmChange_Position_input_82 = func_57.CmConfig_Boiler_output_59;
    func_58.CmChange_Position_input_150 = func_57.CmConfig_Boiler_output_142;
    func_58.Execute( this, 4 );
    setCmBOA_StagedBoiler_parameter_11(func_58.CmChange_Position_output_94);

    // [379] Function call CfCompare1
    func_379.inputA = (float) getCmBOA_StagedBoiler_input_115().getValue();
    func_379.inputB = 3F;
    func_379.Execute(  );

    // [464] Macro call Cmalarm_handling_outputs
    func_464.Cmalarm_handling_outputs_input_1 = getCmBOA_StagedBoiler_input_118().getValue();
    func_464.Cmalarm_handling_outputs_input_2 = getCmBOA_StagedBoiler_input_119().getValue();
    func_464.Cmalarm_handling_outputs_input_3 = getCmBOA_StagedBoiler_input_404().getValue();
    func_464.Cmalarm_handling_outputs_input_4 = getCmBOA_StagedBoiler_input_120().getValue();
    func_464.Execute( this, 9 );

    // [239] Macro call CmPump_and_Valve
    func_239.CmPump_and_Valve_input_9 = (float) getCmBOA_StagedBoiler_parameter_11();
    func_239.CmPump_and_Valve_input_8 = (float) getCmBOA_StagedBoiler_parameter_19();
    func_239.CmPump_and_Valve_input_10 = func_294.outputOR;
    func_239.CmPump_and_Valve_input_16 = (float) getCmBOA_StagedBoiler_input_112().getValue();
    func_239.CmPump_and_Valve_input_17 = (float) getCmBOA_StagedBoiler_input_113().getValue();
    func_239.CmPump_and_Valve_input_81 = (float) getCmBOA_StagedBoiler_input_245().getValue();
    func_239.CmPump_and_Valve_input_18 = (float) getCmBOA_StagedBoiler_input_117().getValue();
    func_239.CmPump_and_Valve_input_19 = (float) getCmBOA_StagedBoiler_input_116().getValue();
    func_239.CmPump_and_Valve_input_191 = func_216.CmBoiler_Demand_output_675;
    func_239.CmPump_and_Valve_input_206 = (float) getCmBOA_StagedBoiler_input_115().getValue();
    func_239.CmPump_and_Valve_input_268 = func_464.Cmalarm_handling_outputs_output_6;
    func_239.CmPump_and_Valve_input_286 = getCmBOA_StagedBoiler_output_73().getValue();
    func_239.CmPump_and_Valve_input_287 = false;
    func_239.Execute( this, 13 );
    setCmBOA_StagedBoiler_output_286(func_239.CmPump_and_Valve_output_20);
    setCmBOA_StagedBoiler_output_105(func_239.CmPump_and_Valve_output_21);

    // [216] Macro call CmBoiler_Demand
    func_216.CmBoiler_Demand_input_671 = (float) getCmBOA_StagedBoiler_input_112().getValue();
    func_216.CmBoiler_Demand_input_677 = (float) getCmBOA_StagedBoiler_input_113().getValue();
    func_216.CmBoiler_Demand_input_1 = (float) getCmBOA_StagedBoiler_parameter_11();
    func_216.CmBoiler_Demand_input_2 = (float) getCmBOA_StagedBoiler_parameter_19();
    func_216.CmBoiler_Demand_input_201 = func_464.Cmalarm_handling_outputs_output_5;
    func_216.CmBoiler_Demand_input_674 = getCmBOA_StagedBoiler_input_120().getValue();
    func_216.CmBoiler_Demand_input_444 = func_239.CmPump_and_Valve_output_39;
    func_216.CmBoiler_Demand_input_686 = func_379.outputLess;
    func_216.CmBoiler_Demand_input_746 = func_239.CmPump_and_Valve_output_242;
    func_216.Execute( this, 62 );
    setCmBOA_StagedBoiler_parameter_101(func_216.CmBoiler_Demand_output_680);

    // [189] Macro call CmSwitch_Boiler_Stages_Seq
    func_189.CmSwitch_Boiler_Stages_Seq_input_189 = func_216.CmBoiler_Demand_output_636;
    func_189.CmSwitch_Boiler_Stages_Seq_input_190 = BooleanToFloat(func_216.CmBoiler_Demand_output_637);
    func_189.CmSwitch_Boiler_Stages_Seq_input_192 = (float) getCmBOA_StagedBoiler_parameter_19();
    func_189.CmSwitch_Boiler_Stages_Seq_input_193 = (float) getCmBOA_StagedBoiler_parameter_11();
    func_189.CmSwitch_Boiler_Stages_Seq_input_218 = func_216.CmBoiler_Demand_output_131;
    func_189.CmSwitch_Boiler_Stages_Seq_input_328 = (float) getCmBOA_StagedBoiler_parameter_41();
    func_189.CmSwitch_Boiler_Stages_Seq_input_356 = (float) getCmBOA_StagedBoiler_input_115().getValue();
    func_189.CmSwitch_Boiler_Stages_Seq_input_383 = (float) getCmBOA_StagedBoiler_input_113().getValue();
    func_189.CmSwitch_Boiler_Stages_Seq_input_384 = (float) getCmBOA_StagedBoiler_input_245().getValue();
    func_189.Execute( this, 200 );

    // [558] Function call CfIdt
    func_558.input = BooleanToFloat(func_189.CmSwitch_Boiler_Stages_Seq_output_348);
    func_558.Execute(  );
    setCmBOA_StagedBoiler_output_73(FloatToBoolean(func_558.output[1]));

    // [561] Function call CfIdt
    func_561.input = BooleanToFloat(func_189.CmSwitch_Boiler_Stages_Seq_output_349);
    func_561.Execute(  );
    setCmBOA_StagedBoiler_output_74(FloatToBoolean(func_561.output[1]));

    // [297] Function call CfCompare2
    func_297.inputA = (float) getCmBOA_StagedBoiler_parameter_39();
    func_297.inputB = 0F;
    func_297.Execute(  );

    // [294] Function call CfOr
    func_294.input[0] = func_297.outputEqualOrLess;
    func_294.input[1] = func_464.Cmalarm_handling_outputs_output_5;
    func_294.input[2] = getCmBOA_StagedBoiler_output_76().getValue();
    func_294.input[3] = func_464.Cmalarm_handling_outputs_output_6;
    func_294.Execute(  );

    // [408] Function call CfOr
    func_408.input[0] = func_294.outputOR;
    func_408.input[1] = func_464.Cmalarm_handling_outputs_output_7;
    func_408.input[2] = func_191.CmAlarm_output_145;
    func_408.Execute(  );

    // [504] Function call CfSubtract
    func_504.input[0] = (float) getCmBOA_StagedBoiler_parameter_11();
    func_504.input[1] = 1F;
    func_504.Execute(  );

    // [505] Macro call CmGet_Group_Reg_Bit
    func_505.CmGet_Group_Reg_Bit_input_1 = 1007F;
    func_505.CmGet_Group_Reg_Bit_input_2 = func_504.output;
    func_505.CmGet_Group_Reg_Bit_input_30 = (float) getCmBOA_StagedBoiler_parameter_19();
    func_505.Execute(  );

    // [506] Function call CfOr
    func_506.input[0] = func_294.outputOR;
    func_506.input[1] = func_505.CmGet_Group_Reg_Bit_output_38;
    func_506.Execute(  );

    // [507] Function call CfRsFlipFlop
    func_507.inputSet = func_294.outputOR;
    func_507.inputReset = func_506.outputNOR;
    func_507.Execute(  );

    // [191] Macro call CmAlarm
    if ( func_408.outputOR)
    {
      func_191.CmAlarm_input_15 = (float) getCmBOA_StagedBoiler_parameter_11();
      func_191.CmAlarm_input_16 = (float) getCmBOA_StagedBoiler_parameter_19();
      func_191.CmAlarm_input_23 = func_294.outputOR;
      func_191.CmAlarm_input_148 = func_464.Cmalarm_handling_outputs_output_7;
      func_191.CmAlarm_input_156 = func_507.output;
      func_191.Execute( this, 203 );
    }

    // [308] Macro call Cmboiler_capacity
    func_308.Cmboiler_capacity_input_1 = FloatToBoolean(func_558.output[0]);
    func_308.Cmboiler_capacity_input_2 = FloatToBoolean(func_561.output[0]);
    func_308.Cmboiler_capacity_input_3 = 0F;
    func_308.Cmboiler_capacity_input_40 = (float) getCmBOA_StagedBoiler_parameter_19();
    func_308.Cmboiler_capacity_input_55 = (float) getCmBOA_StagedBoiler_input_245().getValue();
    func_308.Cmboiler_capacity_input_81 = func_294.outputOR;
    func_308.Execute( this, 206 );
    setCmBOA_StagedBoiler_output_109(func_308.Cmboiler_capacity_output_4);
    setCmBOA_StagedBoiler_parameter_102(func_308.Cmboiler_capacity_output_79);

    // [368] Function call CfCompare2
    func_368.inputA = (float) getCmBOA_StagedBoiler_input_115().getValue();
    func_368.inputB = 3F;
    func_368.Execute(  );

    // [322] Macro call CmBlr_Operation_Mode
    func_322.CmBlr_Operation_Mode_input_1 = true;
    func_322.CmBlr_Operation_Mode_input_2 = func_239.CmPump_and_Valve_output_224;
    func_322.CmBlr_Operation_Mode_input_3 = func_368.outputEqualOrLess;
    func_322.CmBlr_Operation_Mode_input_5 = func_216.CmBoiler_Demand_output_685;
    func_322.CmBlr_Operation_Mode_input_4 = func_216.CmBoiler_Demand_output_675;
    func_322.CmBlr_Operation_Mode_input_6 = getCmBOA_StagedBoiler_output_76().getValue();
    func_322.CmBlr_Operation_Mode_input_7 = getCmBOA_StagedBoiler_input_404().getValue();
    func_322.CmBlr_Operation_Mode_input_8 = func_464.Cmalarm_handling_outputs_output_7;
    func_322.Execute(  );
    setCmBOA_StagedBoiler_parameter_103(func_322.CmBlr_Operation_Mode_output_9);

    // [356] Macro call CmVES_Alarm
    func_356.CmVES_Alarm_input_1 = getCmBOA_StagedBoiler_output_284().getValue();
    func_356.CmVES_Alarm_input_2 = (float) getCmBOA_StagedBoiler_input_117().getValue();
    func_356.CmVES_Alarm_input_7 = getCmBOA_StagedBoiler_input_120().getValue();
    func_356.Execute( this, 213 );
    setCmBOA_StagedBoiler_output_76(func_356.CmVES_Alarm_output_3);

    // [391] Function call CfIdt
    func_391.input = (float) getCmBOA_StagedBoiler_parameter_103();
    func_391.Execute(  );
    setCmBOA_StagedBoiler_output_110(func_391.output[0]);

    // [433] Function call CfOr
    func_433.input[0] = func_239.CmPump_and_Valve_output_103;
    func_433.input[1] = getCmBOA_StagedBoiler_output_76().getValue();
    func_433.Execute(  );
    setCmBOA_StagedBoiler_output_284(func_433.outputOR);

    // [548] Macro call CmStageRequestMode
    func_548.CmStageRequestMode_input_1 = (float) getCmBOA_StagedBoiler_parameter_11();
    func_548.CmStageRequestMode_input_2 = (float) getCmBOA_StagedBoiler_parameter_19();
    func_548.Execute(  );
    setCmBOA_StagedBoiler_output_503(func_548.CmStageRequestMode_output_3);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    2F, 0F, 0F, 0F, 0F, 0F, 0F, 0F,
    0F, 0F, 0F, 2F, 30F, 1F, 1F, 1F,
    5F, 300F, 5F, 12F, 0F, 0F, 60F, 1F,
    1F, 3F, 85F, 100F, 5F, 1F, 12F, 0F,
    1F, 0F, 12F, 0F, 3F, 0F, 1000F, 100F,
    0F, 1F, 120F, 0F, 0F, 3F, 0F, 1000F,
    100F, 0F, 120F, 300F, 5F, 1F, 0F, 10F,
    1F, 10F, 1F, 10F, 0F, 10F, 240F, 600F,
    240F, 300F, 240F, 300F, 240F, 300F, 10F, 10F,
    90F, 85F, 100F, 240F, 600F, 240F, 300F, 240F,
    300F, 240F, 300F, 10F, 10F, 10F, 1F, 10F,
    1F, 10F, 1F, 10F, 1F, 10F, 1F, 10F,
    1F, 10F, 1F, 10F, 1F, 240F, 600F, 240F,
    300F, 240F, 300F, 240F, 300F, 10F, 10F, 1F,
    10F, 1F, 10F, 1F, 2F, 2F, 2F, 2F,
    2F, 2F, 2F, 2F, 2F, 2F, 2F, 2F,
    2F, 2F, 2F, 2F, 10F, 1F, 10F, 1F,
    2F, 2F, 2F, 2F, 2F, 2F, 2F, 2F,
    2F, 2F, 2F, 2F, 2F, 2F, 2F, 2F,
    10F, 1F, 10F, 1F, 10F, 1F, 10F, 1F,
    240F, 600F, 240F, 300F, 240F, 300F, 240F, 300F,
    10F, 10F, 10F, 1F, 10F, 1F, 10F, 1F,
    10F, 1F, 10F, 1F, 10F, 1F, 10F, 1F,
    10F, 1F, 10F, 10F, 90F, 85F, 240F, 100F,
    240F, 240F, 0F, 10F, 1F, 0F, 10F, 1F,
    0F, 1F, 2F, 0F, 0F, 10F, 10F, 10F,
    10F, 0F, 3F, 0F, 3F, 0F, 120F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// Stage1Cmd
  public static final Property CmBOA_StagedBoiler_output_73 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOA_StagedBoiler_output_73() { return (BStatusBoolean) get(CmBOA_StagedBoiler_output_73); }
  public void setCmBOA_StagedBoiler_output_73(BStatusBoolean v) { set(CmBOA_StagedBoiler_output_73,v,null); }
  public void setCmBOA_StagedBoiler_output_73(boolean v) { getCmBOA_StagedBoiler_output_73().setValue(v); }
// Stage2Cmd
  public static final Property CmBOA_StagedBoiler_output_74 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOA_StagedBoiler_output_74() { return (BStatusBoolean) get(CmBOA_StagedBoiler_output_74); }
  public void setCmBOA_StagedBoiler_output_74(BStatusBoolean v) { set(CmBOA_StagedBoiler_output_74,v,null); }
  public void setCmBOA_StagedBoiler_output_74(boolean v) { getCmBOA_StagedBoiler_output_74().setValue(v); }
// ValveControl
  public static final Property CmBOA_StagedBoiler_output_105 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("percent")));
  public BStatusNumeric getCmBOA_StagedBoiler_output_105() { return (BStatusNumeric) get(CmBOA_StagedBoiler_output_105); }
  public void setCmBOA_StagedBoiler_output_105(BStatusNumeric v) { set(CmBOA_StagedBoiler_output_105,v,null); }
  public void setCmBOA_StagedBoiler_output_105(float v) { getCmBOA_StagedBoiler_output_105().setValue(v); }
// ButFlyVlv
  public static final Property CmBOA_StagedBoiler_output_284 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOA_StagedBoiler_output_284() { return (BStatusBoolean) get(CmBOA_StagedBoiler_output_284); }
  public void setCmBOA_StagedBoiler_output_284(BStatusBoolean v) { set(CmBOA_StagedBoiler_output_284,v,null); }
  public void setCmBOA_StagedBoiler_output_284(boolean v) { getCmBOA_StagedBoiler_output_284().setValue(v); }
// PumpCmd
  public static final Property CmBOA_StagedBoiler_output_286 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOA_StagedBoiler_output_286() { return (BStatusBoolean) get(CmBOA_StagedBoiler_output_286); }
  public void setCmBOA_StagedBoiler_output_286(BStatusBoolean v) { set(CmBOA_StagedBoiler_output_286,v,null); }
  public void setCmBOA_StagedBoiler_output_286(boolean v) { getCmBOA_StagedBoiler_output_286().setValue(v); }
// VESAlarm
  public static final Property CmBOA_StagedBoiler_output_76 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOA_StagedBoiler_output_76() { return (BStatusBoolean) get(CmBOA_StagedBoiler_output_76); }
  public void setCmBOA_StagedBoiler_output_76(BStatusBoolean v) { set(CmBOA_StagedBoiler_output_76,v,null); }
  public void setCmBOA_StagedBoiler_output_76(boolean v) { getCmBOA_StagedBoiler_output_76().setValue(v); }
// DispBlrPower
  public static final Property CmBOA_StagedBoiler_output_109 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("kilowatt")));
  public BStatusNumeric getCmBOA_StagedBoiler_output_109() { return (BStatusNumeric) get(CmBOA_StagedBoiler_output_109); }
  public void setCmBOA_StagedBoiler_output_109(BStatusNumeric v) { set(CmBOA_StagedBoiler_output_109,v,null); }
  public void setCmBOA_StagedBoiler_output_109(float v) { getCmBOA_StagedBoiler_output_109().setValue(v); }
// DispPosNumber
  public static final Property CmBOA_StagedBoiler_output_111 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBOA_StagedBoiler_output_111() { return (BStatusNumeric) get(CmBOA_StagedBoiler_output_111); }
  public void setCmBOA_StagedBoiler_output_111(BStatusNumeric v) { set(CmBOA_StagedBoiler_output_111,v,null); }
  public void setCmBOA_StagedBoiler_output_111(float v) { getCmBOA_StagedBoiler_output_111().setValue(v); }
// OperationMode
  public static final Property CmBOA_StagedBoiler_output_110 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBOA_StagedBoiler_output_110() { return (BStatusNumeric) get(CmBOA_StagedBoiler_output_110); }
  public void setCmBOA_StagedBoiler_output_110(BStatusNumeric v) { set(CmBOA_StagedBoiler_output_110,v,null); }
  public void setCmBOA_StagedBoiler_output_110(float v) { getCmBOA_StagedBoiler_output_110().setValue(v); }
// StageReqMode
  public static final Property CmBOA_StagedBoiler_output_503 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBOA_StagedBoiler_output_503() { return (BStatusNumeric) get(CmBOA_StagedBoiler_output_503); }
  public void setCmBOA_StagedBoiler_output_503(BStatusNumeric v) { set(CmBOA_StagedBoiler_output_503,v,null); }
  public void setCmBOA_StagedBoiler_output_503(float v) { getCmBOA_StagedBoiler_output_503().setValue(v); }

  // macro parameter
// CFG-01: heat generator group
  public static final Property CmBOA_StagedBoiler_parameter_19 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmBOA_StagedBoiler_parameter_19() { return getDouble(CmBOA_StagedBoiler_parameter_19); }
  public void setCmBOA_StagedBoiler_parameter_19(double v) { setDouble(CmBOA_StagedBoiler_parameter_19,v,null); }
// BST-01: maximum boiler supply temperature stage 1
  public static final Property CmBOA_StagedBoiler_parameter_80 = newProperty( 0, BDouble.make( 90 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(50)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOA_StagedBoiler_parameter_80() { return getDouble(CmBOA_StagedBoiler_parameter_80); }
  public void setCmBOA_StagedBoiler_parameter_80(double v) { setDouble(CmBOA_StagedBoiler_parameter_80,v,null); }
// BST-02: maximum boiler supply temperature stage 2
  public static final Property CmBOA_StagedBoiler_parameter_81 = newProperty( 0, BDouble.make( 85 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(50)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOA_StagedBoiler_parameter_81() { return getDouble(CmBOA_StagedBoiler_parameter_81); }
  public void setCmBOA_StagedBoiler_parameter_81(double v) { setDouble(CmBOA_StagedBoiler_parameter_81,v,null); }
// BST-04: minimum boiler supply temperature
  public static final Property CmBOA_StagedBoiler_parameter_82 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOA_StagedBoiler_parameter_82() { return getDouble(CmBOA_StagedBoiler_parameter_82); }
  public void setCmBOA_StagedBoiler_parameter_82(double v) { setDouble(CmBOA_StagedBoiler_parameter_82,v,null); }
// BRT-01: P-band boiler return temperature
  public static final Property CmBOA_StagedBoiler_parameter_84 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOA_StagedBoiler_parameter_84() { return getDouble(CmBOA_StagedBoiler_parameter_84); }
  public void setCmBOA_StagedBoiler_parameter_84(double v) { setDouble(CmBOA_StagedBoiler_parameter_84,v,null); }
// BRT-02: I-time boiler return temperature
  public static final Property CmBOA_StagedBoiler_parameter_85 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOA_StagedBoiler_parameter_85() { return getDouble(CmBOA_StagedBoiler_parameter_85); }
  public void setCmBOA_StagedBoiler_parameter_85(double v) { setDouble(CmBOA_StagedBoiler_parameter_85,v,null); }
// BPU-01: pump off delay
  public static final Property CmBOA_StagedBoiler_parameter_86 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOA_StagedBoiler_parameter_86() { return getDouble(CmBOA_StagedBoiler_parameter_86); }
  public void setCmBOA_StagedBoiler_parameter_86(double v) { setDouble(CmBOA_StagedBoiler_parameter_86,v,null); }
// BPU-02: temperature difference pump stop
  public static final Property CmBOA_StagedBoiler_parameter_87 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOA_StagedBoiler_parameter_87() { return getDouble(CmBOA_StagedBoiler_parameter_87); }
  public void setCmBOA_StagedBoiler_parameter_87(double v) { setDouble(CmBOA_StagedBoiler_parameter_87,v,null); }
// ST1-01: capacity stage 1
  public static final Property CmBOA_StagedBoiler_parameter_39 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1000000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kilowatt"))));
  public double getCmBOA_StagedBoiler_parameter_39() { return getDouble(CmBOA_StagedBoiler_parameter_39); }
  public void setCmBOA_StagedBoiler_parameter_39(double v) { setDouble(CmBOA_StagedBoiler_parameter_39,v,null); }
// ST1-02: minimum on time stage 1
  public static final Property CmBOA_StagedBoiler_parameter_88 = newProperty( 0, BDouble.make( 240 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOA_StagedBoiler_parameter_88() { return getDouble(CmBOA_StagedBoiler_parameter_88); }
  public void setCmBOA_StagedBoiler_parameter_88(double v) { setDouble(CmBOA_StagedBoiler_parameter_88,v,null); }
// ST1-03: minimum off time stage 1
  public static final Property CmBOA_StagedBoiler_parameter_89 = newProperty( 0, BDouble.make( 240 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOA_StagedBoiler_parameter_89() { return getDouble(CmBOA_StagedBoiler_parameter_89); }
  public void setCmBOA_StagedBoiler_parameter_89(double v) { setDouble(CmBOA_StagedBoiler_parameter_89,v,null); }
// ST1-04: switch on delay next stage or boiler
  public static final Property CmBOA_StagedBoiler_parameter_90 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOA_StagedBoiler_parameter_90() { return getDouble(CmBOA_StagedBoiler_parameter_90); }
  public void setCmBOA_StagedBoiler_parameter_90(double v) { setDouble(CmBOA_StagedBoiler_parameter_90,v,null); }
// ST1-05: switch off delay next stage or boiler
  public static final Property CmBOA_StagedBoiler_parameter_91 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOA_StagedBoiler_parameter_91() { return getDouble(CmBOA_StagedBoiler_parameter_91); }
  public void setCmBOA_StagedBoiler_parameter_91(double v) { setDouble(CmBOA_StagedBoiler_parameter_91,v,null); }
// ST2-01: capacity stage 2
  public static final Property CmBOA_StagedBoiler_parameter_41 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1000000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kilowatt"))));
  public double getCmBOA_StagedBoiler_parameter_41() { return getDouble(CmBOA_StagedBoiler_parameter_41); }
  public void setCmBOA_StagedBoiler_parameter_41(double v) { setDouble(CmBOA_StagedBoiler_parameter_41,v,null); }
// ST2-02: minimum on time stage 2
  public static final Property CmBOA_StagedBoiler_parameter_93 = newProperty( 0, BDouble.make( 240 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOA_StagedBoiler_parameter_93() { return getDouble(CmBOA_StagedBoiler_parameter_93); }
  public void setCmBOA_StagedBoiler_parameter_93(double v) { setDouble(CmBOA_StagedBoiler_parameter_93,v,null); }
// ST2-03: minimum off time stage 2
  public static final Property CmBOA_StagedBoiler_parameter_94 = newProperty( 0, BDouble.make( 240 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOA_StagedBoiler_parameter_94() { return getDouble(CmBOA_StagedBoiler_parameter_94); }
  public void setCmBOA_StagedBoiler_parameter_94(double v) { setDouble(CmBOA_StagedBoiler_parameter_94,v,null); }
// ST2-04: switch on delay next stage or boiler
  public static final Property CmBOA_StagedBoiler_parameter_95 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOA_StagedBoiler_parameter_95() { return getDouble(CmBOA_StagedBoiler_parameter_95); }
  public void setCmBOA_StagedBoiler_parameter_95(double v) { setDouble(CmBOA_StagedBoiler_parameter_95,v,null); }
// ST2-05: switch off delay next stage or boiler
  public static final Property CmBOA_StagedBoiler_parameter_96 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOA_StagedBoiler_parameter_96() { return getDouble(CmBOA_StagedBoiler_parameter_96); }
  public void setCmBOA_StagedBoiler_parameter_96(double v) { setDouble(CmBOA_StagedBoiler_parameter_96,v,null); }
// SYS-01: position number
  public static final Property CmBOA_StagedBoiler_parameter_11 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(16)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmBOA_StagedBoiler_parameter_11() { return getDouble(CmBOA_StagedBoiler_parameter_11); }
  public void setCmBOA_StagedBoiler_parameter_11(double v) { setDouble(CmBOA_StagedBoiler_parameter_11,v,null); }
// SYS-02: configuration boiler type
  public static final Property CmBOA_StagedBoiler_parameter_97 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmBOA_StagedBoiler_parameter_97() { return getDouble(CmBOA_StagedBoiler_parameter_97); }
  public void setCmBOA_StagedBoiler_parameter_97(double v) { setDouble(CmBOA_StagedBoiler_parameter_97,v,null); }
// SYS-03: heat generator water volume
  public static final Property CmBOA_StagedBoiler_parameter_98 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmBOA_StagedBoiler_parameter_98() { return getDouble(CmBOA_StagedBoiler_parameter_98); }
  public void setCmBOA_StagedBoiler_parameter_98(double v) { setDouble(CmBOA_StagedBoiler_parameter_98,v,null); }
// SYS-04: maximum boiler runtime
  public static final Property CmBOA_StagedBoiler_parameter_99 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1000000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmBOA_StagedBoiler_parameter_99() { return getDouble(CmBOA_StagedBoiler_parameter_99); }
  public void setCmBOA_StagedBoiler_parameter_99(double v) { setDouble(CmBOA_StagedBoiler_parameter_99,v,null); }
// SYS-05: total cool down; 1 = yes
  public static final Property CmBOA_StagedBoiler_parameter_100 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOA_StagedBoiler_parameter_100() { return getDouble(CmBOA_StagedBoiler_parameter_100); }
  public void setCmBOA_StagedBoiler_parameter_100(double v) { setDouble(CmBOA_StagedBoiler_parameter_100,v,null); }
// SYS-06: automatic/ manual reset; 0 = auto
  public static final Property CmBOA_StagedBoiler_parameter_238 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOA_StagedBoiler_parameter_238() { return getDouble(CmBOA_StagedBoiler_parameter_238); }
  public void setCmBOA_StagedBoiler_parameter_238(double v) { setDouble(CmBOA_StagedBoiler_parameter_238,v,null); }
// SYS-07: switch off boiler stages at alarm
  public static final Property CmBOA_StagedBoiler_parameter_449 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOA_StagedBoiler_parameter_449() { return getDouble(CmBOA_StagedBoiler_parameter_449); }
  public void setCmBOA_StagedBoiler_parameter_449(double v) { setDouble(CmBOA_StagedBoiler_parameter_449,v,null); }
// DISP-01: blocking signal
  public static final Property CmBOA_StagedBoiler_parameter_101 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOA_StagedBoiler_parameter_101() { return getDouble(CmBOA_StagedBoiler_parameter_101); }
  public void setCmBOA_StagedBoiler_parameter_101(double v) { setDouble(CmBOA_StagedBoiler_parameter_101,v,null); }
// DISP-02: calculated boiler capacity
  public static final Property CmBOA_StagedBoiler_parameter_102 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kilowatt"))));
  public double getCmBOA_StagedBoiler_parameter_102() { return getDouble(CmBOA_StagedBoiler_parameter_102); }
  public void setCmBOA_StagedBoiler_parameter_102(double v) { setDouble(CmBOA_StagedBoiler_parameter_102,v,null); }
// DISP-03: operation mode
  public static final Property CmBOA_StagedBoiler_parameter_103 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOA_StagedBoiler_parameter_103() { return getDouble(CmBOA_StagedBoiler_parameter_103); }
  public void setCmBOA_StagedBoiler_parameter_103(double v) { setDouble(CmBOA_StagedBoiler_parameter_103,v,null); }
// DISP-04: hours before cyclic changeover
  public static final Property CmBOA_StagedBoiler_parameter_104 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmBOA_StagedBoiler_parameter_104() { return getDouble(CmBOA_StagedBoiler_parameter_104); }
  public void setCmBOA_StagedBoiler_parameter_104(double v) { setDouble(CmBOA_StagedBoiler_parameter_104,v,null); }

  // macro inputs
// SupplyTemp
  public static final Property CmBOA_StagedBoiler_input_112 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOA_StagedBoiler_input_112() { return (BStatusNumeric) get(CmBOA_StagedBoiler_input_112); }
  public void setCmBOA_StagedBoiler_input_112(BStatusNumeric v) { set(CmBOA_StagedBoiler_input_112,v,null); }
  public void setCmBOA_StagedBoiler_input_112(float v) { getCmBOA_StagedBoiler_input_112().setValue(v); }
// RetTemp
  public static final Property CmBOA_StagedBoiler_input_113 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOA_StagedBoiler_input_113() { return (BStatusNumeric) get(CmBOA_StagedBoiler_input_113); }
  public void setCmBOA_StagedBoiler_input_113(BStatusNumeric v) { set(CmBOA_StagedBoiler_input_113,v,null); }
  public void setCmBOA_StagedBoiler_input_113(float v) { getCmBOA_StagedBoiler_input_113().setValue(v); }
// RetTempSp
  public static final Property CmBOA_StagedBoiler_input_245 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOA_StagedBoiler_input_245() { return (BStatusNumeric) get(CmBOA_StagedBoiler_input_245); }
  public void setCmBOA_StagedBoiler_input_245(BStatusNumeric v) { set(CmBOA_StagedBoiler_input_245,v,null); }
  public void setCmBOA_StagedBoiler_input_245(float v) { getCmBOA_StagedBoiler_input_245().setValue(v); }
// ManSwCond
  public static final Property CmBOA_StagedBoiler_input_115 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmBOA_StagedBoiler_input_115() { return (BStatusNumeric) get(CmBOA_StagedBoiler_input_115); }
  public void setCmBOA_StagedBoiler_input_115(BStatusNumeric v) { set(CmBOA_StagedBoiler_input_115,v,null); }
  public void setCmBOA_StagedBoiler_input_115(float v) { getCmBOA_StagedBoiler_input_115().setValue(v); }
// PumpStatus
  public static final Property CmBOA_StagedBoiler_input_116 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmBOA_StagedBoiler_input_116() { return (BStatusNumeric) get(CmBOA_StagedBoiler_input_116); }
  public void setCmBOA_StagedBoiler_input_116(BStatusNumeric v) { set(CmBOA_StagedBoiler_input_116,v,null); }
  public void setCmBOA_StagedBoiler_input_116(float v) { getCmBOA_StagedBoiler_input_116().setValue(v); }
// ValveEndSwitch
  public static final Property CmBOA_StagedBoiler_input_117 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmBOA_StagedBoiler_input_117() { return (BStatusNumeric) get(CmBOA_StagedBoiler_input_117); }
  public void setCmBOA_StagedBoiler_input_117(BStatusNumeric v) { set(CmBOA_StagedBoiler_input_117,v,null); }
  public void setCmBOA_StagedBoiler_input_117(float v) { getCmBOA_StagedBoiler_input_117().setValue(v); }
// BurnerAlarm
  public static final Property CmBOA_StagedBoiler_input_118 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOA_StagedBoiler_input_118() { return (BStatusBoolean) get(CmBOA_StagedBoiler_input_118); }
  public void setCmBOA_StagedBoiler_input_118(BStatusBoolean v) { set(CmBOA_StagedBoiler_input_118,v,null); }
  public void setCmBOA_StagedBoiler_input_118(boolean v) { getCmBOA_StagedBoiler_input_118().setValue(v); }
// AlarmIn
  public static final Property CmBOA_StagedBoiler_input_119 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOA_StagedBoiler_input_119() { return (BStatusBoolean) get(CmBOA_StagedBoiler_input_119); }
  public void setCmBOA_StagedBoiler_input_119(BStatusBoolean v) { set(CmBOA_StagedBoiler_input_119,v,null); }
  public void setCmBOA_StagedBoiler_input_119(boolean v) { getCmBOA_StagedBoiler_input_119().setValue(v); }
// PumpAlarm
  public static final Property CmBOA_StagedBoiler_input_404 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOA_StagedBoiler_input_404() { return (BStatusBoolean) get(CmBOA_StagedBoiler_input_404); }
  public void setCmBOA_StagedBoiler_input_404(BStatusBoolean v) { set(CmBOA_StagedBoiler_input_404,v,null); }
  public void setCmBOA_StagedBoiler_input_404(boolean v) { getCmBOA_StagedBoiler_input_404().setValue(v); }
// Reset
  public static final Property CmBOA_StagedBoiler_input_120 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOA_StagedBoiler_input_120() { return (BStatusBoolean) get(CmBOA_StagedBoiler_input_120); }
  public void setCmBOA_StagedBoiler_input_120(BStatusBoolean v) { set(CmBOA_StagedBoiler_input_120,v,null); }
  public void setCmBOA_StagedBoiler_input_120(boolean v) { getCmBOA_StagedBoiler_input_120().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.03 [211] 05.03.2018-10:05").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5977211126592570267").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmBOA_StagedBoiler.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmIDT05 func_132 = new CmIDT05();
  protected CmIDT20 func_261 = new CmIDT20();
  protected CmIDT05 func_358 = new CmIDT05();
  protected CfIdt func_450 = new CfIdt();
  protected CfIdt func_473 = new CfIdt();
  protected CfIdt func_552 = new CfIdt();
  protected CfHysteresis func_151 = new CfHysteresis();
  protected CfOr func_145 = new CfOr();
  protected CmLaufzeit func_121 = new CmLaufzeit();
  protected CmConfig_Boiler func_57 = new CmConfig_Boiler();
  protected CmChange_Position func_58 = new CmChange_Position();
  protected CfCompare1 func_379 = new CfCompare1();
  protected Cmalarm_handling_outputs func_464 = new Cmalarm_handling_outputs();
  protected CmPump_and_Valve func_239 = new CmPump_and_Valve();
  protected CmBoiler_Demand func_216 = new CmBoiler_Demand();
  protected CmSwitch_Boiler_Stages_Seq func_189 = new CmSwitch_Boiler_Stages_Seq();
  protected CfIdt func_558 = new CfIdt();
  protected CfIdt func_561 = new CfIdt();
  protected CfCompare2 func_297 = new CfCompare2();
  protected CfOr func_294 = new CfOr();
  protected CfOr func_408 = new CfOr();
  protected CfSubtract func_504 = new CfSubtract();
  protected CmGet_Group_Reg_Bit func_505 = new CmGet_Group_Reg_Bit();
  protected CfOr func_506 = new CfOr();
  protected CfRsFlipFlop func_507 = new CfRsFlipFlop();
  protected CmAlarm func_191 = new CmAlarm();
  protected Cmboiler_capacity func_308 = new Cmboiler_capacity();
  protected CfCompare2 func_368 = new CfCompare2();
  protected CmBlr_Operation_Mode func_322 = new CmBlr_Operation_Mode();
  protected CmVES_Alarm func_356 = new CmVES_Alarm();
  protected CfIdt func_391 = new CfIdt();
  protected CfOr func_433 = new CfOr();
  protected CmStageRequestMode func_548 = new CmStageRequestMode();

  // default constructor
  public BCmBOA_StagedBoiler()
  {
    func_145.configure(3);
    func_558.configure(2);
    func_561.configure(2);
    func_294.configure(4);
    func_408.configure(3);
  }

  public void Start()
  {
    func_132.Start();
    func_261.Start();
    func_358.Start();
    func_151.Start();
    func_121.Start();
    func_57.Start();
    func_58.Start();
    func_464.Start();
    func_239.Start();
    func_216.Start();
    func_189.Start();
    func_505.Start();
    func_507.Start();
    func_191.Start();
    func_308.Start();
    func_322.Start();
    func_356.Start();
    func_548.Start();
  }
}
