/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    BOB_ModBoiler
Macro id:      6017712936937587321
Macro version: 178
Last change:   05.03.2018 - 10:06
Access Level:  2
Inputs:
  [1] SupplyTemp
  [2] RetTemp
  [3] RetTempSp
  [4] ManSwCond
  [5] PumpStatus
  [6] ValveEndSwitch
  [7] BurnerAlarm
  [8] AlarmIn
  [9] PumpAlarm
  [10] Reset
Outputs:
  [1] Stage1Cmd
  [2] ModStage
  [3] SetpointOutput
  [4] ValveControl
  [5] ButFlyVlv
  [6] PumpCmd
  [7] VESAlarm
  [8] DispBlrPower
  [9] DispPosNumber
  [10] OperationMode
  [11] StageReqMode
Parameter:
  [1] CFG-01: heat generator group
  [2] BST-01: maximum boiler supply temperature stage 1
  [3] BST-03: maximum boiler supply temp. modulating stage
  [4] BST-04: minimum boiler supply temperature
  [5] BST-05: P-band maximum supply temperature control
  [6] BRT-01: P-band boiler return temperature
  [7] BRT-02: I-time boiler return temperature
  [8] BPU-01: pump off delay
  [9] BPU-02: temperature difference pump stop
  [10] ST1-01: capacity stage 1
  [11] ST1-02: minimum on time stage 1
  [12] ST1-03: minimum off time stage 1
  [13] ST1-04: switch on delay next stage or boiler
  [14] ST1-05: switch off delay next stage or boiler
  [15] STM-01: capacity modulating stage
  [16] STM-04: blocking time to switch on the next stage or boiler
  [17] STM-05: blocking time to switch off the next stage or boiler
  [18] STM-06: minimum output modulating stage
  [19] STM-07: maximum output modulating stage
  [20] STM-08: maximum raise per minute
  [21] SPO-01: setpoint offset
  [22] SPO-02: setpoint low input
  [23] SPO-03: setpoint high intput
  [24] SPO-04: setpoint low output
  [25] SPO-05: setpoint high output
  [26] SYS-01: position number
  [27] SYS-02: configuration boiler type
  [28] SYS-03: heat generator water volume
  [29] SYS-04: maximum boiler runtime
  [30] SYS-05: total cool down; 1 = yes
  [31] SYS-06: automatic/ manual reset; 0 = auto
  [32] SYS-07: switch off boiler stages at alarm
  [33] DISP-01: blocking signal
  [34] DISP-02: calculated boiler capacity
  [35] DISP-03: operation mode
  [36] DISP-04: hours before cyclic changeover
Description:
The BOB_ModBoiler macro provides modulating control of the boiler burner and a setpoint output for external boiler controllers. The macro can be used for standalone and multiple boilers always in combination with the heating control strategy macro.
A boiler macro cannot be used without a heating strategy macro.
The boiler has different start and stop procedure depending on the configurations for large and small water volume and the return temperature control mode.
When a boiler stage switches on it starts its minimum on time and the blocking time to switch on the next stage or boiler.
When a boiler stage switches off it starts its minimum off time and the blocking time to switch off the next stage or boiler.
The macro also controls the boiler pump and valve.
If you need status and alarm inputs for the pump, you have to add an extra pump macro and connect the pump datapoint to both macro outputs. The pump command macro also provides pump exercise.
All the communication signals with other heat generators and the heating strategy will be connected automatically via global registers. The user has the option to assign a heat generator to three heat generator groups with different sequences depending on outside air temperature or a manual switch.
================================================================================*/

public class BCmBOB_ModBoiler
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmBOB_ModBoiler_output_73().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmBOB_ModBoiler_output_73().setStatus(BStatus.disabled);
    getCmBOB_ModBoiler_output_75().setStatus(BStatus.disabled);
    getCmBOB_ModBoiler_output_120().setStatus(BStatus.disabled);
    getCmBOB_ModBoiler_output_121().setStatus(BStatus.disabled);
    getCmBOB_ModBoiler_output_122().setStatus(BStatus.disabled);
    getCmBOB_ModBoiler_output_123().setStatus(BStatus.disabled);
    getCmBOB_ModBoiler_output_76().setStatus(BStatus.disabled);
    getCmBOB_ModBoiler_output_126().setStatus(BStatus.disabled);
    getCmBOB_ModBoiler_output_124().setStatus(BStatus.disabled);
    getCmBOB_ModBoiler_output_350().setStatus(BStatus.disabled);
    getCmBOB_ModBoiler_output_446().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmBOB_ModBoiler_output_73().setStatus(BStatus.ok);
    getCmBOB_ModBoiler_output_75().setStatus(BStatus.ok);
    getCmBOB_ModBoiler_output_120().setStatus(BStatus.ok);
    getCmBOB_ModBoiler_output_121().setStatus(BStatus.ok);
    getCmBOB_ModBoiler_output_122().setStatus(BStatus.ok);
    getCmBOB_ModBoiler_output_123().setStatus(BStatus.ok);
    getCmBOB_ModBoiler_output_76().setStatus(BStatus.ok);
    getCmBOB_ModBoiler_output_126().setStatus(BStatus.ok);
    getCmBOB_ModBoiler_output_124().setStatus(BStatus.ok);
    getCmBOB_ModBoiler_output_350().setStatus(BStatus.ok);
    getCmBOB_ModBoiler_output_446().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [205] Macro call CmIDT20
    func_205.CmIDT20_input_1 = (float) getCmBOB_ModBoiler_parameter_99();
    func_205.CmIDT20_input_2 = (float) getCmBOB_ModBoiler_parameter_180();
    func_205.CmIDT20_input_3 = (float) getCmBOB_ModBoiler_parameter_110();
    func_205.CmIDT20_input_4 = (float) getCmBOB_ModBoiler_parameter_187();
    func_205.CmIDT20_input_5 = (float) getCmBOB_ModBoiler_parameter_188();
    func_205.CmIDT20_input_6 = (float) getCmBOB_ModBoiler_parameter_108();
    func_205.CmIDT20_input_7 = (float) getCmBOB_ModBoiler_parameter_97();
    func_205.CmIDT20_input_8 = (float) getCmBOB_ModBoiler_parameter_98();
    func_205.CmIDT20_input_9 = (float) getCmBOB_ModBoiler_parameter_86();
    func_205.CmIDT20_input_10 = (float) getCmBOB_ModBoiler_parameter_87();
    func_205.CmIDT20_input_11 = (float) getCmBOB_ModBoiler_parameter_83();
    func_205.CmIDT20_input_12 = (float) getCmBOB_ModBoiler_parameter_84();
    func_205.CmIDT20_input_13 = (float) getCmBOB_ModBoiler_parameter_82();
    func_205.CmIDT20_input_14 = (float) getCmBOB_ModBoiler_parameter_88();
    func_205.CmIDT20_input_15 = (float) getCmBOB_ModBoiler_parameter_89();
    func_205.CmIDT20_input_16 = (float) getCmBOB_ModBoiler_parameter_90();
    func_205.CmIDT20_input_17 = (float) getCmBOB_ModBoiler_parameter_91();
    func_205.CmIDT20_input_18 = (float) getCmBOB_ModBoiler_parameter_95();
    func_205.CmIDT20_input_19 = (float) getCmBOB_ModBoiler_parameter_96();
    func_205.CmIDT20_input_20 = (float) getCmBOB_ModBoiler_parameter_11();
    func_205.Execute(  );
    setParameter(0, func_205.CmIDT20_output_21);
    setParameter(77, func_205.CmIDT20_output_22);
    setParameter(78, func_205.CmIDT20_output_23);
    setParameter(79, func_205.CmIDT20_output_24);
    setParameter(80, func_205.CmIDT20_output_25);
    setParameter(81, func_205.CmIDT20_output_26);
    setParameter(15, func_205.CmIDT20_output_27);
    setParameter(16, func_205.CmIDT20_output_28);
    setParameter(19, func_205.CmIDT20_output_29);
    setParameter(20, func_205.CmIDT20_output_30);
    setParameter(21, func_205.CmIDT20_output_31);
    setParameter(22, func_205.CmIDT20_output_32);
    setParameter(18, func_205.CmIDT20_output_33);
    setParameter(64, func_205.CmIDT20_output_34);
    setParameter(65, func_205.CmIDT20_output_35);
    setParameter(66, func_205.CmIDT20_output_36);
    setParameter(67, func_205.CmIDT20_output_37);
    setParameter(68, func_205.CmIDT20_output_38);
    setParameter(69, func_205.CmIDT20_output_39);
    setCmBOB_ModBoiler_output_124(func_205.CmIDT20_output_40);

    // [241] Macro call CmIDT10
    func_241.CmIDT10_input_1 = (float) getCmBOB_ModBoiler_parameter_105();
    func_241.CmIDT10_input_2 = (float) getCmBOB_ModBoiler_parameter_106();
    func_241.CmIDT10_input_3 = (float) getCmBOB_ModBoiler_parameter_107();
    func_241.CmIDT10_input_4 = (float) getCmBOB_ModBoiler_parameter_39();
    func_241.CmIDT10_input_5 = (float) getCmBOB_ModBoiler_parameter_41();
    func_241.CmIDT10_input_6 = (float) getCmBOB_ModBoiler_parameter_39();
    func_241.CmIDT10_input_7 = (float) getCmBOB_ModBoiler_parameter_41();
    func_241.CmIDT10_input_8 = (float) getCmBOB_ModBoiler_parameter_80();
    func_241.CmIDT10_input_9 = (float) getCmBOB_ModBoiler_parameter_81();
    func_241.CmIDT10_input_10 = (float) getCmBOB_ModBoiler_parameter_109();
    func_241.Execute(  );
    setParameter(70, func_241.CmIDT10_output_21);
    setParameter(71, func_241.CmIDT10_output_22);
    setParameter(72, func_241.CmIDT10_output_23);
    setParameter(73, func_241.CmIDT10_output_24);
    setParameter(74, func_241.CmIDT10_output_25);
    setParameter(252, func_241.CmIDT10_output_26);
    setParameter(253, func_241.CmIDT10_output_27);
    setParameter(75, func_241.CmIDT10_output_28);
    setParameter(76, func_241.CmIDT10_output_29);
    setParameter(82, func_241.CmIDT10_output_30);

    // [319] Macro call CmIDT05
    func_319.CmIDT05_input_1 = (float) getCmBOB_ModBoiler_parameter_182();
    func_319.CmIDT05_input_2 = (float) getCmBOB_ModBoiler_parameter_100();
    func_319.CmIDT05_input_3 = (float) getCmBOB_ModBoiler_parameter_82();
    func_319.CmIDT05_input_4 = (float) getCmBOB_ModBoiler_parameter_97();
    func_319.CmIDT05_input_5 = (float) getCmBOB_ModBoiler_parameter_386();
    func_319.Execute(  );
    setParameter(8, func_319.CmIDT05_output_21);
    setParameter(17, func_319.CmIDT05_output_22);
    setParameter(254, func_319.CmIDT05_output_23);
    setParameter(249, func_319.CmIDT05_output_24);
    setParameter(9, func_319.CmIDT05_output_25);

    // [410] Function call CfIdt
    func_410.input = (float) getCmBOB_ModBoiler_parameter_86();
    func_410.Execute(  );
    setParameter(10, func_410.output[0]);

    // [486] Function call CfIdt
    func_486.input = (float) getCmBOB_ModBoiler_parameter_386();
    func_486.Execute(  );
    setParameter(12, func_486.output[0]);

    // [128] Macro call CmLaufzeit
    func_128.CmLaufzeit_input_1 = func_183.CmBoiler_Demand_mod_output_604;
    func_128.CmLaufzeit_input_47 = (float) getCmBOB_ModBoiler_parameter_19();
    func_128.CmLaufzeit_input_79 = func_58.CmChange_Position_output_205;
    func_128.Execute( this, 0 );
    setParameter(6, BooleanToFloat(func_128.CmLaufzeit_output_2));
    setCmBOB_ModBoiler_parameter_104(func_128.CmLaufzeit_output_37);

    // [57] Macro call CmConfig_Boiler
    func_57.CmConfig_Boiler_input_71 = (float) getCmBOB_ModBoiler_parameter_11();
    func_57.CmConfig_Boiler_input_68 = (float) getCmBOB_ModBoiler_parameter_19();
    func_57.Execute( this, 1 );

    // [58] Macro call CmChange_Position
    func_58.CmChange_Position_input_81 = func_57.CmConfig_Boiler_output_58;
    func_58.CmChange_Position_input_82 = func_57.CmConfig_Boiler_output_59;
    func_58.CmChange_Position_input_150 = func_57.CmConfig_Boiler_output_142;
    func_58.Execute( this, 3 );
    setCmBOB_ModBoiler_parameter_11(func_58.CmChange_Position_output_94);

    // [261] Function call CfCompare2
    func_261.inputA = (float) getCmBOB_ModBoiler_parameter_39();
    func_261.inputB = 0F;
    func_261.Execute(  );

    // [265] Function call CfCompare2
    func_265.inputA = (float) getCmBOB_ModBoiler_parameter_41();
    func_265.inputB = 0F;
    func_265.Execute(  );

    // [257] Function call CfAnd
    func_257.input[0] = func_261.outputEqualOrLess;
    func_257.input[1] = func_265.outputEqualOrLess;
    func_257.Execute(  );

    // [409] Macro call Cmalarm_handling_outputs
    func_409.Cmalarm_handling_outputs_input_1 = getCmBOB_ModBoiler_input_117().getValue();
    func_409.Cmalarm_handling_outputs_input_2 = getCmBOB_ModBoiler_input_118().getValue();
    func_409.Cmalarm_handling_outputs_input_3 = getCmBOB_ModBoiler_input_352().getValue();
    func_409.Cmalarm_handling_outputs_input_4 = getCmBOB_ModBoiler_input_119().getValue();
    func_409.Execute( this, 8 );

    // [253] Function call CfOr
    func_253.input[0] = func_257.outputAND;
    func_253.input[1] = func_409.Cmalarm_handling_outputs_output_5;
    func_253.input[2] = getCmBOB_ModBoiler_output_76().getValue();
    func_253.input[3] = func_409.Cmalarm_handling_outputs_output_6;
    func_253.Execute(  );

    // [355] Function call CfOr
    func_355.input[0] = func_253.outputOR;
    func_355.input[1] = func_409.Cmalarm_handling_outputs_output_7;
    func_355.input[2] = func_167.CmAlarm_output_145;
    func_355.Execute(  );

    // [452] Function call CfSubtract
    func_452.input[0] = (float) getCmBOB_ModBoiler_parameter_11();
    func_452.input[1] = 1F;
    func_452.Execute(  );

    // [449] Macro call CmGet_Group_Reg_Bit
    func_449.CmGet_Group_Reg_Bit_input_1 = 1007F;
    func_449.CmGet_Group_Reg_Bit_input_2 = func_452.output;
    func_449.CmGet_Group_Reg_Bit_input_30 = (float) getCmBOB_ModBoiler_parameter_19();
    func_449.Execute(  );

    // [450] Function call CfOr
    func_450.input[0] = func_253.outputOR;
    func_450.input[1] = func_449.CmGet_Group_Reg_Bit_output_38;
    func_450.Execute(  );

    // [451] Function call CfRsFlipFlop
    func_451.inputSet = func_253.outputOR;
    func_451.inputReset = func_450.outputNOR;
    func_451.Execute(  );

    // [167] Macro call CmAlarm
    if ( func_355.outputOR)
    {
      func_167.CmAlarm_input_15 = (float) getCmBOB_ModBoiler_parameter_11();
      func_167.CmAlarm_input_16 = (float) getCmBOB_ModBoiler_parameter_19();
      func_167.CmAlarm_input_23 = func_253.outputOR;
      func_167.CmAlarm_input_148 = func_409.Cmalarm_handling_outputs_output_7;
      func_167.CmAlarm_input_156 = func_451.output;
      func_167.Execute( this, 12 );
    }

    // [227] Macro call CmPump_and_Valve
    func_227.CmPump_and_Valve_input_9 = (float) getCmBOB_ModBoiler_parameter_11();
    func_227.CmPump_and_Valve_input_8 = (float) getCmBOB_ModBoiler_parameter_19();
    func_227.CmPump_and_Valve_input_10 = func_253.outputOR;
    func_227.CmPump_and_Valve_input_16 = (float) getCmBOB_ModBoiler_input_111().getValue();
    func_227.CmPump_and_Valve_input_17 = (float) getCmBOB_ModBoiler_input_112().getValue();
    func_227.CmPump_and_Valve_input_81 = (float) getCmBOB_ModBoiler_input_348().getValue();
    func_227.CmPump_and_Valve_input_18 = (float) getCmBOB_ModBoiler_input_116().getValue();
    func_227.CmPump_and_Valve_input_19 = (float) getCmBOB_ModBoiler_input_115().getValue();
    func_227.CmPump_and_Valve_input_191 = func_183.CmBoiler_Demand_mod_output_594;
    func_227.CmPump_and_Valve_input_206 = (float) getCmBOB_ModBoiler_input_114().getValue();
    func_227.CmPump_and_Valve_input_268 = func_409.Cmalarm_handling_outputs_output_6;
    func_227.CmPump_and_Valve_input_286 = getCmBOB_ModBoiler_output_73().getValue();
    func_227.CmPump_and_Valve_input_287 = func_183.CmBoiler_Demand_mod_output_790;
    func_227.Execute( this, 15 );
    setCmBOB_ModBoiler_output_123(func_227.CmPump_and_Valve_output_20);
    setCmBOB_ModBoiler_output_121(func_227.CmPump_and_Valve_output_21);

    // [414] Function call CfAnd
    func_414.input[0] = FloatToBoolean((float) getCmBOB_ModBoiler_parameter_386());
    func_414.input[1] = func_409.Cmalarm_handling_outputs_output_7;
    func_414.Execute(  );

    // [183] Macro call CmBoiler_Demand_mod
    func_183.CmBoiler_Demand_mod_input_596 = getCmBOB_ModBoiler_input_119().getValue();
    func_183.CmBoiler_Demand_mod_input_593 = (float) getCmBOB_ModBoiler_input_111().getValue();
    func_183.CmBoiler_Demand_mod_input_1 = (float) getCmBOB_ModBoiler_parameter_11();
    func_183.CmBoiler_Demand_mod_input_2 = (float) getCmBOB_ModBoiler_parameter_19();
    func_183.CmBoiler_Demand_mod_input_201 = func_409.Cmalarm_handling_outputs_output_5;
    func_183.CmBoiler_Demand_mod_input_535 = func_227.CmPump_and_Valve_output_39;
    func_183.CmBoiler_Demand_mod_input_626 = (float) getCmBOB_ModBoiler_input_112().getValue();
    func_183.CmBoiler_Demand_mod_input_707 = func_227.CmPump_and_Valve_output_242;
    func_183.CmBoiler_Demand_mod_input_747 = func_414.outputNAND;
    func_183.CmBoiler_Demand_mod_input_796 = func_253.outputOR;
    func_183.Execute( this, 64 );
    setCmBOB_ModBoiler_output_120(func_183.CmBoiler_Demand_mod_output_605);
    setCmBOB_ModBoiler_parameter_101(func_183.CmBoiler_Demand_mod_output_628);

    // [169] Macro call CmSwitch_Boiler_Stages_Seq
    func_169.CmSwitch_Boiler_Stages_Seq_input_189 = func_183.CmBoiler_Demand_mod_output_604;
    func_169.CmSwitch_Boiler_Stages_Seq_input_190 = func_183.CmBoiler_Demand_mod_output_444;
    func_169.CmSwitch_Boiler_Stages_Seq_input_192 = (float) getCmBOB_ModBoiler_parameter_19();
    func_169.CmSwitch_Boiler_Stages_Seq_input_193 = (float) getCmBOB_ModBoiler_parameter_11();
    func_169.CmSwitch_Boiler_Stages_Seq_input_218 = func_183.CmBoiler_Demand_mod_output_131;
    func_169.CmSwitch_Boiler_Stages_Seq_input_328 = (float) getCmBOB_ModBoiler_parameter_41();
    func_169.CmSwitch_Boiler_Stages_Seq_input_356 = (float) getCmBOB_ModBoiler_input_114().getValue();
    func_169.CmSwitch_Boiler_Stages_Seq_input_383 = (float) getCmBOB_ModBoiler_input_112().getValue();
    func_169.CmSwitch_Boiler_Stages_Seq_input_384 = (float) getCmBOB_ModBoiler_input_348().getValue();
    func_169.Execute( this, 249 );

    // [496] Function call CfIdt
    func_496.input = BooleanToFloat(func_169.CmSwitch_Boiler_Stages_Seq_output_348);
    func_496.Execute(  );
    setCmBOB_ModBoiler_output_73(FloatToBoolean(func_496.output[1]));

    // [494] Function call CfIdt
    func_494.input = func_169.CmSwitch_Boiler_Stages_Seq_output_363;
    func_494.Execute(  );
    setCmBOB_ModBoiler_output_75(func_494.output[1]);

    // [299] Macro call Cmboiler_capacity
    func_299.Cmboiler_capacity_input_1 = FloatToBoolean(func_496.output[0]);
    func_299.Cmboiler_capacity_input_2 = false;
    func_299.Cmboiler_capacity_input_3 = func_494.output[0];
    func_299.Cmboiler_capacity_input_40 = (float) getCmBOB_ModBoiler_parameter_19();
    func_299.Cmboiler_capacity_input_55 = (float) getCmBOB_ModBoiler_input_348().getValue();
    func_299.Cmboiler_capacity_input_81 = func_253.outputOR;
    func_299.Execute( this, 252 );
    setCmBOB_ModBoiler_output_126(func_299.Cmboiler_capacity_output_4);
    setCmBOB_ModBoiler_parameter_102(func_299.Cmboiler_capacity_output_79);

    // [335] Function call CfCompare2
    func_335.inputA = (float) getCmBOB_ModBoiler_input_114().getValue();
    func_335.inputB = 3F;
    func_335.Execute(  );

    // [303] Macro call CmBlr_Operation_Mode
    func_303.CmBlr_Operation_Mode_input_1 = true;
    func_303.CmBlr_Operation_Mode_input_2 = func_227.CmPump_and_Valve_output_224;
    func_303.CmBlr_Operation_Mode_input_3 = func_335.outputEqualOrLess;
    func_303.CmBlr_Operation_Mode_input_5 = func_183.CmBoiler_Demand_mod_output_638;
    func_303.CmBlr_Operation_Mode_input_4 = func_183.CmBoiler_Demand_mod_output_594;
    func_303.CmBlr_Operation_Mode_input_6 = getCmBOB_ModBoiler_output_76().getValue();
    func_303.CmBlr_Operation_Mode_input_7 = getCmBOB_ModBoiler_input_352().getValue();
    func_303.CmBlr_Operation_Mode_input_8 = func_409.Cmalarm_handling_outputs_output_7;
    func_303.Execute(  );
    setCmBOB_ModBoiler_parameter_103(func_303.CmBlr_Operation_Mode_output_9);

    // [330] Macro call CmVES_Alarm
    func_330.CmVES_Alarm_input_1 = getCmBOB_ModBoiler_output_122().getValue();
    func_330.CmVES_Alarm_input_2 = (float) getCmBOB_ModBoiler_input_116().getValue();
    func_330.CmVES_Alarm_input_7 = getCmBOB_ModBoiler_input_119().getValue();
    func_330.Execute( this, 259 );
    setCmBOB_ModBoiler_output_76(func_330.CmVES_Alarm_output_3);

    // [349] Function call CfIdt
    func_349.input = (float) getCmBOB_ModBoiler_parameter_103();
    func_349.Execute(  );
    setCmBOB_ModBoiler_output_350(func_349.output[0]);

    // [369] Function call CfOr
    func_369.input[0] = func_227.CmPump_and_Valve_output_103;
    func_369.input[1] = getCmBOB_ModBoiler_output_76().getValue();
    func_369.Execute(  );
    setCmBOB_ModBoiler_output_122(func_369.outputOR);

    // [485] Macro call CmStageRequestMode
    func_485.CmStageRequestMode_input_1 = (float) getCmBOB_ModBoiler_parameter_11();
    func_485.CmStageRequestMode_input_2 = (float) getCmBOB_ModBoiler_parameter_19();
    func_485.Execute(  );
    setCmBOB_ModBoiler_output_446(func_485.CmStageRequestMode_output_3);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    100F, 0F, 0F, 0F, 0F, 0F, 0F, 0F,
    0F, 0F, 300F, 30F, 0F, 0F, 10F, 1F,
    1F, 1F, 5F, 12F, 1F, 1F, 0F, 0F,
    60F, 1F, 1F, 0F, 85F, 100F, 5F, 1F,
    12F, 0F, 1F, 0F, 12F, 0F, 3F, 0F,
    1000F, 100F, 0F, 1F, 120F, 0F, 0F, 3F,
    0F, 1000F, 100F, 0F, 120F, 300F, 5F, 1F,
    0F, 10F, 1F, 10F, 1F, 10F, 0F, 10F,
    10F, 12F, 10F, 12F, 10F, 12F, 0F, 100F,
    300F, 10F, 10F, 90F, 85F, 10F, 0F, 10F,
    90F, 20F, 90F, 85F, 100F, 10F, 240F, 240F,
    600F, 300F, 0F, 0F, 0F, 0F, 1F, 10F,
    20F, 10F, 1F, 10F, 1F, 0F, 100F, 25F,
    0F, 100F, 10F, 0F, 100F, 25F, 0F, 10F,
    1F, 0F, 100F, 25F, 0F, 10F, 1F, 10F,
    1F, 10F, 1F, 240F, 600F, 300F, 240F, 300F,
    300F, 10F, 10F, 0F, 100F, 25F, 1F, 10F,
    1F, 10F, 1F, 2F, 2F, 2F, 2F, 2F,
    2F, 2F, 2F, 2F, 2F, 2F, 2F, 2F,
    2F, 2F, 2F, 0F, 0F, 0F, 0F, 100F,
    25F, 0F, 10F, 1F, 2F, 2F, 2F, 2F,
    2F, 2F, 2F, 2F, 2F, 2F, 2F, 2F,
    2F, 2F, 2F, 2F, 0F, 0F, 0F, 0F,
    100F, 25F, 0F, 10F, 1F, 10F, 1F, 10F,
    1F, 10F, 20F, 240F, 240F, 600F, 300F, 600F,
    300F, 0F, 100F, 25F, 10F, 1F, 10F, 1F,
    10F, 20F, 240F, 0F, 100F, 25F, 0F, 100F,
    10F, 0F, 10F, 1F, 0F, 100F, 25F, 0F,
    10F, 1F, 10F, 1F, 10F, 1F, 10F, 20F,
    90F, 85F, 85F, 10F, 240F, 240F, 1F, 10F,
    1F, 1F, 10F, 1F, 50F, 10F, 90F, 20F,
    90F, 0F, 1F, 0F, 10F, 10F, 10F, 0F,
    3F, 0F, 3F, 0F, 120F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// Stage1Cmd
  public static final Property CmBOB_ModBoiler_output_73 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOB_ModBoiler_output_73() { return (BStatusBoolean) get(CmBOB_ModBoiler_output_73); }
  public void setCmBOB_ModBoiler_output_73(BStatusBoolean v) { set(CmBOB_ModBoiler_output_73,v,null); }
  public void setCmBOB_ModBoiler_output_73(boolean v) { getCmBOB_ModBoiler_output_73().setValue(v); }
// ModStage
  public static final Property CmBOB_ModBoiler_output_75 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("percent")));
  public BStatusNumeric getCmBOB_ModBoiler_output_75() { return (BStatusNumeric) get(CmBOB_ModBoiler_output_75); }
  public void setCmBOB_ModBoiler_output_75(BStatusNumeric v) { set(CmBOB_ModBoiler_output_75,v,null); }
  public void setCmBOB_ModBoiler_output_75(float v) { getCmBOB_ModBoiler_output_75().setValue(v); }
// SetpointOutput
  public static final Property CmBOB_ModBoiler_output_120 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOB_ModBoiler_output_120() { return (BStatusNumeric) get(CmBOB_ModBoiler_output_120); }
  public void setCmBOB_ModBoiler_output_120(BStatusNumeric v) { set(CmBOB_ModBoiler_output_120,v,null); }
  public void setCmBOB_ModBoiler_output_120(float v) { getCmBOB_ModBoiler_output_120().setValue(v); }
// ValveControl
  public static final Property CmBOB_ModBoiler_output_121 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("percent")));
  public BStatusNumeric getCmBOB_ModBoiler_output_121() { return (BStatusNumeric) get(CmBOB_ModBoiler_output_121); }
  public void setCmBOB_ModBoiler_output_121(BStatusNumeric v) { set(CmBOB_ModBoiler_output_121,v,null); }
  public void setCmBOB_ModBoiler_output_121(float v) { getCmBOB_ModBoiler_output_121().setValue(v); }
// ButFlyVlv
  public static final Property CmBOB_ModBoiler_output_122 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOB_ModBoiler_output_122() { return (BStatusBoolean) get(CmBOB_ModBoiler_output_122); }
  public void setCmBOB_ModBoiler_output_122(BStatusBoolean v) { set(CmBOB_ModBoiler_output_122,v,null); }
  public void setCmBOB_ModBoiler_output_122(boolean v) { getCmBOB_ModBoiler_output_122().setValue(v); }
// PumpCmd
  public static final Property CmBOB_ModBoiler_output_123 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOB_ModBoiler_output_123() { return (BStatusBoolean) get(CmBOB_ModBoiler_output_123); }
  public void setCmBOB_ModBoiler_output_123(BStatusBoolean v) { set(CmBOB_ModBoiler_output_123,v,null); }
  public void setCmBOB_ModBoiler_output_123(boolean v) { getCmBOB_ModBoiler_output_123().setValue(v); }
// VESAlarm
  public static final Property CmBOB_ModBoiler_output_76 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOB_ModBoiler_output_76() { return (BStatusBoolean) get(CmBOB_ModBoiler_output_76); }
  public void setCmBOB_ModBoiler_output_76(BStatusBoolean v) { set(CmBOB_ModBoiler_output_76,v,null); }
  public void setCmBOB_ModBoiler_output_76(boolean v) { getCmBOB_ModBoiler_output_76().setValue(v); }
// DispBlrPower
  public static final Property CmBOB_ModBoiler_output_126 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("kilowatt")));
  public BStatusNumeric getCmBOB_ModBoiler_output_126() { return (BStatusNumeric) get(CmBOB_ModBoiler_output_126); }
  public void setCmBOB_ModBoiler_output_126(BStatusNumeric v) { set(CmBOB_ModBoiler_output_126,v,null); }
  public void setCmBOB_ModBoiler_output_126(float v) { getCmBOB_ModBoiler_output_126().setValue(v); }
// DispPosNumber
  public static final Property CmBOB_ModBoiler_output_124 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBOB_ModBoiler_output_124() { return (BStatusNumeric) get(CmBOB_ModBoiler_output_124); }
  public void setCmBOB_ModBoiler_output_124(BStatusNumeric v) { set(CmBOB_ModBoiler_output_124,v,null); }
  public void setCmBOB_ModBoiler_output_124(float v) { getCmBOB_ModBoiler_output_124().setValue(v); }
// OperationMode
  public static final Property CmBOB_ModBoiler_output_350 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBOB_ModBoiler_output_350() { return (BStatusNumeric) get(CmBOB_ModBoiler_output_350); }
  public void setCmBOB_ModBoiler_output_350(BStatusNumeric v) { set(CmBOB_ModBoiler_output_350,v,null); }
  public void setCmBOB_ModBoiler_output_350(float v) { getCmBOB_ModBoiler_output_350().setValue(v); }
// StageReqMode
  public static final Property CmBOB_ModBoiler_output_446 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBOB_ModBoiler_output_446() { return (BStatusNumeric) get(CmBOB_ModBoiler_output_446); }
  public void setCmBOB_ModBoiler_output_446(BStatusNumeric v) { set(CmBOB_ModBoiler_output_446,v,null); }
  public void setCmBOB_ModBoiler_output_446(float v) { getCmBOB_ModBoiler_output_446().setValue(v); }

  // macro parameter
// CFG-01: heat generator group
  public static final Property CmBOB_ModBoiler_parameter_19 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmBOB_ModBoiler_parameter_19() { return getDouble(CmBOB_ModBoiler_parameter_19); }
  public void setCmBOB_ModBoiler_parameter_19(double v) { setDouble(CmBOB_ModBoiler_parameter_19,v,null); }
// BST-01: maximum boiler supply temperature stage 1
  public static final Property CmBOB_ModBoiler_parameter_80 = newProperty( 0, BDouble.make( 90 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(50)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOB_ModBoiler_parameter_80() { return getDouble(CmBOB_ModBoiler_parameter_80); }
  public void setCmBOB_ModBoiler_parameter_80(double v) { setDouble(CmBOB_ModBoiler_parameter_80,v,null); }
// BST-03: maximum boiler supply temp. modulating stage
  public static final Property CmBOB_ModBoiler_parameter_81 = newProperty( 0, BDouble.make( 85 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(50)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOB_ModBoiler_parameter_81() { return getDouble(CmBOB_ModBoiler_parameter_81); }
  public void setCmBOB_ModBoiler_parameter_81(double v) { setDouble(CmBOB_ModBoiler_parameter_81,v,null); }
// BST-04: minimum boiler supply temperature
  public static final Property CmBOB_ModBoiler_parameter_82 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOB_ModBoiler_parameter_82() { return getDouble(CmBOB_ModBoiler_parameter_82); }
  public void setCmBOB_ModBoiler_parameter_82(double v) { setDouble(CmBOB_ModBoiler_parameter_82,v,null); }
// BST-05: P-band maximum supply temperature control
  public static final Property CmBOB_ModBoiler_parameter_180 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOB_ModBoiler_parameter_180() { return getDouble(CmBOB_ModBoiler_parameter_180); }
  public void setCmBOB_ModBoiler_parameter_180(double v) { setDouble(CmBOB_ModBoiler_parameter_180,v,null); }
// BRT-01: P-band boiler return temperature
  public static final Property CmBOB_ModBoiler_parameter_83 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOB_ModBoiler_parameter_83() { return getDouble(CmBOB_ModBoiler_parameter_83); }
  public void setCmBOB_ModBoiler_parameter_83(double v) { setDouble(CmBOB_ModBoiler_parameter_83,v,null); }
// BRT-02: I-time boiler return temperature
  public static final Property CmBOB_ModBoiler_parameter_84 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOB_ModBoiler_parameter_84() { return getDouble(CmBOB_ModBoiler_parameter_84); }
  public void setCmBOB_ModBoiler_parameter_84(double v) { setDouble(CmBOB_ModBoiler_parameter_84,v,null); }
// BPU-01: pump off delay
  public static final Property CmBOB_ModBoiler_parameter_86 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOB_ModBoiler_parameter_86() { return getDouble(CmBOB_ModBoiler_parameter_86); }
  public void setCmBOB_ModBoiler_parameter_86(double v) { setDouble(CmBOB_ModBoiler_parameter_86,v,null); }
// BPU-02: temperature difference pump stop
  public static final Property CmBOB_ModBoiler_parameter_87 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOB_ModBoiler_parameter_87() { return getDouble(CmBOB_ModBoiler_parameter_87); }
  public void setCmBOB_ModBoiler_parameter_87(double v) { setDouble(CmBOB_ModBoiler_parameter_87,v,null); }
// ST1-01: capacity stage 1
  public static final Property CmBOB_ModBoiler_parameter_39 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1000000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kilowatt"))));
  public double getCmBOB_ModBoiler_parameter_39() { return getDouble(CmBOB_ModBoiler_parameter_39); }
  public void setCmBOB_ModBoiler_parameter_39(double v) { setDouble(CmBOB_ModBoiler_parameter_39,v,null); }
// ST1-02: minimum on time stage 1
  public static final Property CmBOB_ModBoiler_parameter_88 = newProperty( 0, BDouble.make( 240 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOB_ModBoiler_parameter_88() { return getDouble(CmBOB_ModBoiler_parameter_88); }
  public void setCmBOB_ModBoiler_parameter_88(double v) { setDouble(CmBOB_ModBoiler_parameter_88,v,null); }
// ST1-03: minimum off time stage 1
  public static final Property CmBOB_ModBoiler_parameter_89 = newProperty( 0, BDouble.make( 240 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOB_ModBoiler_parameter_89() { return getDouble(CmBOB_ModBoiler_parameter_89); }
  public void setCmBOB_ModBoiler_parameter_89(double v) { setDouble(CmBOB_ModBoiler_parameter_89,v,null); }
// ST1-04: switch on delay next stage or boiler
  public static final Property CmBOB_ModBoiler_parameter_90 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOB_ModBoiler_parameter_90() { return getDouble(CmBOB_ModBoiler_parameter_90); }
  public void setCmBOB_ModBoiler_parameter_90(double v) { setDouble(CmBOB_ModBoiler_parameter_90,v,null); }
// ST1-05: switch off delay next stage or boiler
  public static final Property CmBOB_ModBoiler_parameter_91 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOB_ModBoiler_parameter_91() { return getDouble(CmBOB_ModBoiler_parameter_91); }
  public void setCmBOB_ModBoiler_parameter_91(double v) { setDouble(CmBOB_ModBoiler_parameter_91,v,null); }
// STM-01: capacity modulating stage
  public static final Property CmBOB_ModBoiler_parameter_41 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1000000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kilowatt"))));
  public double getCmBOB_ModBoiler_parameter_41() { return getDouble(CmBOB_ModBoiler_parameter_41); }
  public void setCmBOB_ModBoiler_parameter_41(double v) { setDouble(CmBOB_ModBoiler_parameter_41,v,null); }
// STM-04: blocking time to switch on the next stage or boiler
  public static final Property CmBOB_ModBoiler_parameter_95 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOB_ModBoiler_parameter_95() { return getDouble(CmBOB_ModBoiler_parameter_95); }
  public void setCmBOB_ModBoiler_parameter_95(double v) { setDouble(CmBOB_ModBoiler_parameter_95,v,null); }
// STM-05: blocking time to switch off the next stage or boiler
  public static final Property CmBOB_ModBoiler_parameter_96 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOB_ModBoiler_parameter_96() { return getDouble(CmBOB_ModBoiler_parameter_96); }
  public void setCmBOB_ModBoiler_parameter_96(double v) { setDouble(CmBOB_ModBoiler_parameter_96,v,null); }
// STM-06: minimum output modulating stage
  public static final Property CmBOB_ModBoiler_parameter_105 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmBOB_ModBoiler_parameter_105() { return getDouble(CmBOB_ModBoiler_parameter_105); }
  public void setCmBOB_ModBoiler_parameter_105(double v) { setDouble(CmBOB_ModBoiler_parameter_105,v,null); }
// STM-07: maximum output modulating stage
  public static final Property CmBOB_ModBoiler_parameter_106 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmBOB_ModBoiler_parameter_106() { return getDouble(CmBOB_ModBoiler_parameter_106); }
  public void setCmBOB_ModBoiler_parameter_106(double v) { setDouble(CmBOB_ModBoiler_parameter_106,v,null); }
// STM-08: maximum raise per minute
  public static final Property CmBOB_ModBoiler_parameter_107 = newProperty( 0, BDouble.make( 25 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(2000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmBOB_ModBoiler_parameter_107() { return getDouble(CmBOB_ModBoiler_parameter_107); }
  public void setCmBOB_ModBoiler_parameter_107(double v) { setDouble(CmBOB_ModBoiler_parameter_107,v,null); }
// SPO-01: setpoint offset
  public static final Property CmBOB_ModBoiler_parameter_110 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOB_ModBoiler_parameter_110() { return getDouble(CmBOB_ModBoiler_parameter_110); }
  public void setCmBOB_ModBoiler_parameter_110(double v) { setDouble(CmBOB_ModBoiler_parameter_110,v,null); }
// SPO-02: setpoint low input
  public static final Property CmBOB_ModBoiler_parameter_187 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOB_ModBoiler_parameter_187() { return getDouble(CmBOB_ModBoiler_parameter_187); }
  public void setCmBOB_ModBoiler_parameter_187(double v) { setDouble(CmBOB_ModBoiler_parameter_187,v,null); }
// SPO-03: setpoint high intput
  public static final Property CmBOB_ModBoiler_parameter_188 = newProperty( 0, BDouble.make( 90 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOB_ModBoiler_parameter_188() { return getDouble(CmBOB_ModBoiler_parameter_188); }
  public void setCmBOB_ModBoiler_parameter_188(double v) { setDouble(CmBOB_ModBoiler_parameter_188,v,null); }
// SPO-04: setpoint low output
  public static final Property CmBOB_ModBoiler_parameter_108 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOB_ModBoiler_parameter_108() { return getDouble(CmBOB_ModBoiler_parameter_108); }
  public void setCmBOB_ModBoiler_parameter_108(double v) { setDouble(CmBOB_ModBoiler_parameter_108,v,null); }
// SPO-05: setpoint high output
  public static final Property CmBOB_ModBoiler_parameter_109 = newProperty( 0, BDouble.make( 90 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOB_ModBoiler_parameter_109() { return getDouble(CmBOB_ModBoiler_parameter_109); }
  public void setCmBOB_ModBoiler_parameter_109(double v) { setDouble(CmBOB_ModBoiler_parameter_109,v,null); }
// SYS-01: position number
  public static final Property CmBOB_ModBoiler_parameter_11 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(16)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmBOB_ModBoiler_parameter_11() { return getDouble(CmBOB_ModBoiler_parameter_11); }
  public void setCmBOB_ModBoiler_parameter_11(double v) { setDouble(CmBOB_ModBoiler_parameter_11,v,null); }
// SYS-02: configuration boiler type
  public static final Property CmBOB_ModBoiler_parameter_97 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmBOB_ModBoiler_parameter_97() { return getDouble(CmBOB_ModBoiler_parameter_97); }
  public void setCmBOB_ModBoiler_parameter_97(double v) { setDouble(CmBOB_ModBoiler_parameter_97,v,null); }
// SYS-03: heat generator water volume
  public static final Property CmBOB_ModBoiler_parameter_98 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmBOB_ModBoiler_parameter_98() { return getDouble(CmBOB_ModBoiler_parameter_98); }
  public void setCmBOB_ModBoiler_parameter_98(double v) { setDouble(CmBOB_ModBoiler_parameter_98,v,null); }
// SYS-04: maximum boiler runtime
  public static final Property CmBOB_ModBoiler_parameter_99 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1000000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmBOB_ModBoiler_parameter_99() { return getDouble(CmBOB_ModBoiler_parameter_99); }
  public void setCmBOB_ModBoiler_parameter_99(double v) { setDouble(CmBOB_ModBoiler_parameter_99,v,null); }
// SYS-05: total cool down; 1 = yes
  public static final Property CmBOB_ModBoiler_parameter_100 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOB_ModBoiler_parameter_100() { return getDouble(CmBOB_ModBoiler_parameter_100); }
  public void setCmBOB_ModBoiler_parameter_100(double v) { setDouble(CmBOB_ModBoiler_parameter_100,v,null); }
// SYS-06: automatic/ manual reset; 0 = auto
  public static final Property CmBOB_ModBoiler_parameter_182 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOB_ModBoiler_parameter_182() { return getDouble(CmBOB_ModBoiler_parameter_182); }
  public void setCmBOB_ModBoiler_parameter_182(double v) { setDouble(CmBOB_ModBoiler_parameter_182,v,null); }
// SYS-07: switch off boiler stages at alarm
  public static final Property CmBOB_ModBoiler_parameter_386 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOB_ModBoiler_parameter_386() { return getDouble(CmBOB_ModBoiler_parameter_386); }
  public void setCmBOB_ModBoiler_parameter_386(double v) { setDouble(CmBOB_ModBoiler_parameter_386,v,null); }
// DISP-01: blocking signal
  public static final Property CmBOB_ModBoiler_parameter_101 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOB_ModBoiler_parameter_101() { return getDouble(CmBOB_ModBoiler_parameter_101); }
  public void setCmBOB_ModBoiler_parameter_101(double v) { setDouble(CmBOB_ModBoiler_parameter_101,v,null); }
// DISP-02: calculated boiler capacity
  public static final Property CmBOB_ModBoiler_parameter_102 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kilowatt"))));
  public double getCmBOB_ModBoiler_parameter_102() { return getDouble(CmBOB_ModBoiler_parameter_102); }
  public void setCmBOB_ModBoiler_parameter_102(double v) { setDouble(CmBOB_ModBoiler_parameter_102,v,null); }
// DISP-03: operation mode
  public static final Property CmBOB_ModBoiler_parameter_103 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOB_ModBoiler_parameter_103() { return getDouble(CmBOB_ModBoiler_parameter_103); }
  public void setCmBOB_ModBoiler_parameter_103(double v) { setDouble(CmBOB_ModBoiler_parameter_103,v,null); }
// DISP-04: hours before cyclic changeover
  public static final Property CmBOB_ModBoiler_parameter_104 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmBOB_ModBoiler_parameter_104() { return getDouble(CmBOB_ModBoiler_parameter_104); }
  public void setCmBOB_ModBoiler_parameter_104(double v) { setDouble(CmBOB_ModBoiler_parameter_104,v,null); }

  // macro inputs
// SupplyTemp
  public static final Property CmBOB_ModBoiler_input_111 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOB_ModBoiler_input_111() { return (BStatusNumeric) get(CmBOB_ModBoiler_input_111); }
  public void setCmBOB_ModBoiler_input_111(BStatusNumeric v) { set(CmBOB_ModBoiler_input_111,v,null); }
  public void setCmBOB_ModBoiler_input_111(float v) { getCmBOB_ModBoiler_input_111().setValue(v); }
// RetTemp
  public static final Property CmBOB_ModBoiler_input_112 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOB_ModBoiler_input_112() { return (BStatusNumeric) get(CmBOB_ModBoiler_input_112); }
  public void setCmBOB_ModBoiler_input_112(BStatusNumeric v) { set(CmBOB_ModBoiler_input_112,v,null); }
  public void setCmBOB_ModBoiler_input_112(float v) { getCmBOB_ModBoiler_input_112().setValue(v); }
// RetTempSp
  public static final Property CmBOB_ModBoiler_input_348 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOB_ModBoiler_input_348() { return (BStatusNumeric) get(CmBOB_ModBoiler_input_348); }
  public void setCmBOB_ModBoiler_input_348(BStatusNumeric v) { set(CmBOB_ModBoiler_input_348,v,null); }
  public void setCmBOB_ModBoiler_input_348(float v) { getCmBOB_ModBoiler_input_348().setValue(v); }
// ManSwCond
  public static final Property CmBOB_ModBoiler_input_114 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmBOB_ModBoiler_input_114() { return (BStatusNumeric) get(CmBOB_ModBoiler_input_114); }
  public void setCmBOB_ModBoiler_input_114(BStatusNumeric v) { set(CmBOB_ModBoiler_input_114,v,null); }
  public void setCmBOB_ModBoiler_input_114(float v) { getCmBOB_ModBoiler_input_114().setValue(v); }
// PumpStatus
  public static final Property CmBOB_ModBoiler_input_115 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmBOB_ModBoiler_input_115() { return (BStatusNumeric) get(CmBOB_ModBoiler_input_115); }
  public void setCmBOB_ModBoiler_input_115(BStatusNumeric v) { set(CmBOB_ModBoiler_input_115,v,null); }
  public void setCmBOB_ModBoiler_input_115(float v) { getCmBOB_ModBoiler_input_115().setValue(v); }
// ValveEndSwitch
  public static final Property CmBOB_ModBoiler_input_116 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmBOB_ModBoiler_input_116() { return (BStatusNumeric) get(CmBOB_ModBoiler_input_116); }
  public void setCmBOB_ModBoiler_input_116(BStatusNumeric v) { set(CmBOB_ModBoiler_input_116,v,null); }
  public void setCmBOB_ModBoiler_input_116(float v) { getCmBOB_ModBoiler_input_116().setValue(v); }
// BurnerAlarm
  public static final Property CmBOB_ModBoiler_input_117 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOB_ModBoiler_input_117() { return (BStatusBoolean) get(CmBOB_ModBoiler_input_117); }
  public void setCmBOB_ModBoiler_input_117(BStatusBoolean v) { set(CmBOB_ModBoiler_input_117,v,null); }
  public void setCmBOB_ModBoiler_input_117(boolean v) { getCmBOB_ModBoiler_input_117().setValue(v); }
// AlarmIn
  public static final Property CmBOB_ModBoiler_input_118 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOB_ModBoiler_input_118() { return (BStatusBoolean) get(CmBOB_ModBoiler_input_118); }
  public void setCmBOB_ModBoiler_input_118(BStatusBoolean v) { set(CmBOB_ModBoiler_input_118,v,null); }
  public void setCmBOB_ModBoiler_input_118(boolean v) { getCmBOB_ModBoiler_input_118().setValue(v); }
// PumpAlarm
  public static final Property CmBOB_ModBoiler_input_352 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOB_ModBoiler_input_352() { return (BStatusBoolean) get(CmBOB_ModBoiler_input_352); }
  public void setCmBOB_ModBoiler_input_352(BStatusBoolean v) { set(CmBOB_ModBoiler_input_352,v,null); }
  public void setCmBOB_ModBoiler_input_352(boolean v) { getCmBOB_ModBoiler_input_352().setValue(v); }
// Reset
  public static final Property CmBOB_ModBoiler_input_119 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOB_ModBoiler_input_119() { return (BStatusBoolean) get(CmBOB_ModBoiler_input_119); }
  public void setCmBOB_ModBoiler_input_119(BStatusBoolean v) { set(CmBOB_ModBoiler_input_119,v,null); }
  public void setCmBOB_ModBoiler_input_119(boolean v) { getCmBOB_ModBoiler_input_119().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.03 [178] 05.03.2018-10:06").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6017712936937587321").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmBOB_ModBoiler.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmIDT20 func_205 = new CmIDT20();
  protected CmIDT10 func_241 = new CmIDT10();
  protected CmIDT05 func_319 = new CmIDT05();
  protected CfIdt func_410 = new CfIdt();
  protected CfIdt func_486 = new CfIdt();
  protected CmLaufzeit func_128 = new CmLaufzeit();
  protected CmConfig_Boiler func_57 = new CmConfig_Boiler();
  protected CmChange_Position func_58 = new CmChange_Position();
  protected CfCompare2 func_261 = new CfCompare2();
  protected CfCompare2 func_265 = new CfCompare2();
  protected CfAnd func_257 = new CfAnd();
  protected Cmalarm_handling_outputs func_409 = new Cmalarm_handling_outputs();
  protected CfOr func_253 = new CfOr();
  protected CfOr func_355 = new CfOr();
  protected CfSubtract func_452 = new CfSubtract();
  protected CmGet_Group_Reg_Bit func_449 = new CmGet_Group_Reg_Bit();
  protected CfOr func_450 = new CfOr();
  protected CfRsFlipFlop func_451 = new CfRsFlipFlop();
  protected CmAlarm func_167 = new CmAlarm();
  protected CmPump_and_Valve func_227 = new CmPump_and_Valve();
  protected CfAnd func_414 = new CfAnd();
  protected CmBoiler_Demand_mod func_183 = new CmBoiler_Demand_mod();
  protected CmSwitch_Boiler_Stages_Seq func_169 = new CmSwitch_Boiler_Stages_Seq();
  protected CfIdt func_496 = new CfIdt();
  protected CfIdt func_494 = new CfIdt();
  protected Cmboiler_capacity func_299 = new Cmboiler_capacity();
  protected CfCompare2 func_335 = new CfCompare2();
  protected CmBlr_Operation_Mode func_303 = new CmBlr_Operation_Mode();
  protected CmVES_Alarm func_330 = new CmVES_Alarm();
  protected CfIdt func_349 = new CfIdt();
  protected CfOr func_369 = new CfOr();
  protected CmStageRequestMode func_485 = new CmStageRequestMode();

  // default constructor
  public BCmBOB_ModBoiler()
  {
    func_253.configure(4);
    func_355.configure(3);
    func_496.configure(2);
    func_494.configure(2);
  }

  public void Start()
  {
    func_205.Start();
    func_241.Start();
    func_319.Start();
    func_128.Start();
    func_57.Start();
    func_58.Start();
    func_409.Start();
    func_449.Start();
    func_451.Start();
    func_167.Start();
    func_227.Start();
    func_183.Start();
    func_169.Start();
    func_299.Start();
    func_303.Start();
    func_330.Start();
    func_485.Start();
  }
}
