/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    BOD_HeatExch_DHW
Macro id:      5986834578679005499
Macro version: 126
Last change:   06.05.2019 - 14:54
Access Level:  2
Inputs:
  [1] SecSupTemp
  [2] DHW_TempSp
  [3] PriSupTemp
  [4] PriSupTempSp
  [5] PriRetTemp
  [6] PriRetTempSp
  [7] LegionellaEnable
  [8] CircPumpDemand
  [9] MaxThermostat
  [10] DayExtension
  [11] HolidaySwitch
  [12] SecMinPressSw
  [13] Reset
Outputs:
  [1] PriPumpCmd
  [2] ValveControl
  [3] CircPumpCmd
  [4] CalcDHWTempSp
  [5] CalcRWTempSp
  [6] CalcHeatDemand
  [7] RefilValveCmd
  [8] LegionellaActive
  [9] DHW_Failure
  [10] DHWS_Leg_Alm
  [11] OperationMode
Parameter:
  [1] SST-01: maximum supply temperature
  [2] SST-02: minimum supply temperature
  [3] SST-03: occupied / un-occupied changeover; 0 = disable
  [4] SST-04: setpoint raise to compensate losses
  [5] SST-05: maximum setpoint raise per minute
  [6] SST-06: P-band SST control
  [7] SST-07: I-time system supply temperature control
  [8] SST-08: D-time system supply temperature control
  [9] PST-01: P-band primary supply temperature control
  [10] RWT-01: return water setpoint raise during legionella
  [11] RWT-02: P-band return temperature control
  [12] PRP-01: primary pump start-up delay
  [13] PRP-02: primary pump switch off delay
  [14] SEP-02: circulation pump switch off delay
  [15] SEP-03: run circualtion pump during occupied periods and extended operation
  [16] SEP-04: circulation pump during overheat protection; 0; 1; 3 = disable; 2; 4 = enabled
  [17] VLV-01: valve position limit
  [18] VLV-02: minimum valve position
  [19] VLV-03: maximum valve postion raise per minute
  [20] VLV-04: valve open time at closed valve during  limitation control
  [21] LEG-01: anti-legionella setpoint
  [22] LEG-02: time to reach legionella setpoint; 0 = disable
  [23] LEG-03: legionella duration
  [24] DEX-01:DHW setpoint extendetd operation
  [25] DEX-02: auto reset time from extended operation
  [26] REF-01: maximum refill valve runtime
  [27] SYS-01: heat demand transmission
  [28] SYS-02: DHW_Failure enable after release
  [29] SYS-03: automatic/ manual reset; 0 = auto
  [30] DISP-01: calculated DHWS temperature setpoint
  [31] DISP-02: calculated return temperature setpoint
  [32] DISP-03: operating mode
Description:
The main control functions of the domestic hot water heat exchanger are:
·   secondary supply temperature control
·   return water temperature control
·   primary pump commands
·   circulation pump commands
·   maximum thermostat to switch off the control functions in case of overheat
·   refill valve control

================================================================================*/

public class BCmBOD_HeatExch_DHW
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmBOD_HeatExch_DHW_output_15().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmBOD_HeatExch_DHW_output_15().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DHW_output_16().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DHW_output_17().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DHW_output_18().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DHW_output_24().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DHW_output_352().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DHW_output_19().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DHW_output_20().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DHW_output_21().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DHW_output_22().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DHW_output_23().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmBOD_HeatExch_DHW_output_15().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DHW_output_16().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DHW_output_17().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DHW_output_18().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DHW_output_24().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DHW_output_352().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DHW_output_19().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DHW_output_20().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DHW_output_21().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DHW_output_22().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DHW_output_23().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [93] Macro call CmRefillValveContol
    func_93.CmRefillValveContol_input_1 = getCmBOD_HeatExch_DHW_input_12().getValue();
    func_93.Execute( this, 0 );
    setCmBOD_HeatExch_DHW_output_19(func_93.CmRefillValveContol_output_2);

    // [97] Macro call CmIDT05
    func_97.CmIDT05_input_1 = (float) getCmBOD_HeatExch_DHW_parameter_36();
    func_97.CmIDT05_input_2 = (float) getCmBOD_HeatExch_DHW_parameter_37();
    func_97.CmIDT05_input_3 = 0F;
    func_97.CmIDT05_input_4 = (float) getCmBOD_HeatExch_DHW_parameter_39();
    func_97.CmIDT05_input_5 = 0F;
    func_97.Execute(  );
    setParameter(96, func_97.CmIDT05_output_21);
    setParameter(97, func_97.CmIDT05_output_22);
    setParameter(98, func_97.CmIDT05_output_23);
    setParameter(99, func_97.CmIDT05_output_24);

    // [101] Function call CfMonoflop
    func_101.input = BooleanToFloat(getCmBOD_HeatExch_DHW_input_13().getValue());
    func_101.Execute( this, 7 );

    // [107] Function call CfAddition
    func_107.input[0] = (float) getCmBOD_HeatExch_DHW_parameter_40();
    func_107.input[1] = 0.1F;
    func_107.Execute(  );

    // [108] Function call CfIdt
    func_108.input = 600F;
    func_108.Execute(  );
    setParameter(101, func_108.output[0]);

    // [109] Function call CfIdt
    func_109.input = (float) getCmBOD_HeatExch_DHW_parameter_43();
    func_109.Execute(  );
    setParameter(100, func_109.output[0]);

    // [111] Function call CfCompare1
    func_111.inputA = (float) getCmBOD_HeatExch_DHW_parameter_43();
    func_111.inputB = 0F;
    func_111.Execute(  );

    // [367] Macro call CmIDT20
    func_367.CmIDT20_input_1 = (float) getCmBOD_HeatExch_DHW_parameter_49();
    func_367.CmIDT20_input_2 = (float) getCmBOD_HeatExch_DHW_parameter_27();
    func_367.CmIDT20_input_3 = (float) getCmBOD_HeatExch_DHW_parameter_47();
    func_367.CmIDT20_input_4 = (float) getCmBOD_HeatExch_DHW_parameter_48();
    func_367.CmIDT20_input_5 = (float) getCmBOD_HeatExch_DHW_parameter_30();
    func_367.CmIDT20_input_6 = (float) getCmBOD_HeatExch_DHW_parameter_44();
    func_367.CmIDT20_input_7 = (float) getCmBOD_HeatExch_DHW_parameter_45();
    func_367.CmIDT20_input_8 = (float) getCmBOD_HeatExch_DHW_parameter_46();
    func_367.CmIDT20_input_9 = 0F;
    func_367.CmIDT20_input_10 = (float) getCmBOD_HeatExch_DHW_parameter_50();
    func_367.CmIDT20_input_11 = (float) getCmBOD_HeatExch_DHW_parameter_52();
    func_367.CmIDT20_input_12 = (float) getCmBOD_HeatExch_DHW_parameter_28();
    func_367.CmIDT20_input_13 = (float) getCmBOD_HeatExch_DHW_parameter_34();
    func_367.CmIDT20_input_14 = (float) getCmBOD_HeatExch_DHW_parameter_35();
    func_367.CmIDT20_input_15 = (float) getCmBOD_HeatExch_DHW_parameter_40();
    func_367.CmIDT20_input_16 = (float) getCmBOD_HeatExch_DHW_parameter_33();
    func_367.CmIDT20_input_17 = (float) getCmBOD_HeatExch_DHW_parameter_40();
    func_367.CmIDT20_input_18 = (float) getCmBOD_HeatExch_DHW_parameter_25();
    func_367.CmIDT20_input_19 = (float) getCmBOD_HeatExch_DHW_parameter_26();
    func_367.CmIDT20_input_20 = 0F;
    func_367.Execute(  );
    setParameter(0, func_367.CmIDT20_output_21);
    setParameter(8, func_367.CmIDT20_output_22);
    setParameter(9, func_367.CmIDT20_output_23);
    setParameter(10, func_367.CmIDT20_output_24);
    setParameter(12, func_367.CmIDT20_output_25);
    setParameter(13, func_367.CmIDT20_output_26);
    setParameter(14, func_367.CmIDT20_output_27);
    setParameter(15, func_367.CmIDT20_output_28);
    setParameter(16, func_367.CmIDT20_output_29);
    setParameter(106, func_367.CmIDT20_output_30);
    setParameter(107, func_367.CmIDT20_output_31);
    setParameter(108, func_367.CmIDT20_output_32);
    setParameter(33, func_367.CmIDT20_output_33);
    setParameter(34, func_367.CmIDT20_output_34);
    setParameter(35, func_367.CmIDT20_output_35);
    setParameter(47, func_367.CmIDT20_output_36);
    setParameter(48, func_367.CmIDT20_output_37);
    setParameter(68, func_367.CmIDT20_output_38);
    setParameter(69, func_367.CmIDT20_output_39);
    setParameter(70, func_367.CmIDT20_output_40);

    // [402] Macro call CmIDT20
    func_402.CmIDT20_input_1 = (float) getCmBOD_HeatExch_DHW_parameter_29();
    func_402.CmIDT20_input_2 = (float) getCmBOD_HeatExch_DHW_parameter_30();
    func_402.CmIDT20_input_3 = (float) getCmBOD_HeatExch_DHW_parameter_31();
    func_402.CmIDT20_input_4 = (float) getCmBOD_HeatExch_DHW_parameter_32();
    func_402.CmIDT20_input_5 = (float) getCmBOD_HeatExch_DHW_parameter_51();
    func_402.CmIDT20_input_6 = (float) getCmBOD_HeatExch_DHW_parameter_52();
    func_402.CmIDT20_input_7 = (float) getCmBOD_HeatExch_DHW_parameter_42();
    func_402.CmIDT20_input_8 = (float) getCmBOD_HeatExch_DHW_parameter_41();
    func_402.CmIDT20_input_9 = (float) getCmBOD_HeatExch_DHW_parameter_27();
    func_402.CmIDT20_input_10 = (float) getCmBOD_HeatExch_DHW_parameter_47();
    func_402.CmIDT20_input_11 = (float) getCmBOD_HeatExch_DHW_parameter_44();
    func_402.CmIDT20_input_12 = 0F;
    func_402.CmIDT20_input_13 = 0F;
    func_402.CmIDT20_input_14 = 0F;
    func_402.CmIDT20_input_15 = 0F;
    func_402.CmIDT20_input_16 = 0F;
    func_402.CmIDT20_input_17 = 0F;
    func_402.CmIDT20_input_18 = 0F;
    func_402.CmIDT20_input_19 = 0F;
    func_402.CmIDT20_input_20 = 0F;
    func_402.Execute(  );
    setParameter(71, func_402.CmIDT20_output_21);
    setParameter(72, func_402.CmIDT20_output_22);
    setParameter(73, func_402.CmIDT20_output_23);
    setParameter(74, func_402.CmIDT20_output_24);
    setParameter(75, func_402.CmIDT20_output_25);
    setParameter(76, func_402.CmIDT20_output_26);
    setParameter(90, func_402.CmIDT20_output_27);
    setParameter(91, func_402.CmIDT20_output_28);
    setParameter(60, func_402.CmIDT20_output_29);
    setParameter(61, func_402.CmIDT20_output_30);
    setParameter(62, func_402.CmIDT20_output_31);

    // [563] Function call CfAddition
    func_563.input[0] = (float) getCmBOD_HeatExch_DHW_parameter_43();
    func_563.input[1] = 3F;
    func_563.Execute(  );
    setParameter(105, func_563.output);

    // [569] Function call CfAddition
    func_569.input[0] = (float) getCmBOD_HeatExch_DHW_parameter_43();
    func_569.input[1] = 3F;
    func_569.Execute(  );
    setParameter(102, func_569.output);

    // [620] Function call CfWindow
    func_620.inputValue = (float) getCmBOD_HeatExch_DHW_parameter_601();
    func_620.inputMinimum = 0.8F;
    func_620.inputMaximum = 1.2F;
    func_620.Execute(  );

    // [432] Macro call CmDayExtensionHEDHW
    func_432.CmDayExtensionHEDHW_input_1 = getCmBOD_HeatExch_DHW_input_10().getValue();
    func_432.CmDayExtensionHEDHW_input_2 = func_535.CmHEDHW_Setpoint_output_10;
    func_432.CmDayExtensionHEDHW_input_3 = getCmBOD_HeatExch_DHW_input_11().getValue();
    func_432.CmDayExtensionHEDHW_input_8 = (float) getCmBOD_HeatExch_DHW_input_2().getValue();
    func_432.Execute( this, 8 );

    // [603] Function call CfAnd
    func_603.input[0] = getCmBOD_HeatExch_DHW_input_7().getValue();
    func_603.input[1] = func_432.CmDayExtensionHEDHW_output_4;
    func_603.Execute(  );

    // [347] Macro call CmLegionellaProt
    func_347.CmLegionellaProt_input_1 = func_535.CmHEDHW_Setpoint_output_10;
    func_347.CmLegionellaProt_input_2 = func_432.CmDayExtensionHEDHW_output_4;
    func_347.CmLegionellaProt_input_3 = getCmBOD_HeatExch_DHW_input_6().getValue();
    func_347.CmLegionellaProt_input_5 = (float) getCmBOD_HeatExch_DHW_input_1().getValue();
    func_347.CmLegionellaProt_input_6 = 999F;
    func_347.CmLegionellaProt_input_80 = func_101.output;
    func_347.Execute( this, 12 );
    setCmBOD_HeatExch_DHW_output_20(func_347.CmLegionellaProt_output_4);
    setCmBOD_HeatExch_DHW_output_22(func_347.CmLegionellaProt_output_8);

    // [91] Macro call CmPrimRWTContHEDHW
    func_91.CmPrimRWTContHEDHW_input_1 = (float) getCmBOD_HeatExch_DHW_input_4().getValue();
    func_91.CmPrimRWTContHEDHW_input_2 = (float) getCmBOD_HeatExch_DHW_input_5().getValue();
    func_91.CmPrimRWTContHEDHW_input_21 = BooleanToFloat(getCmBOD_HeatExch_DHW_input_6().getValue());
    func_91.CmPrimRWTContHEDHW_input_22 = getCmBOD_HeatExch_DHW_output_20().getValue();
    func_91.Execute( this, 33 );

    // [92] Macro call CmPriSupTempLimitation
    func_92.CmPriSupTempLimitation_input_1 = (float) getCmBOD_HeatExch_DHW_input_3().getValue();
    func_92.CmPriSupTempLimitation_input_2 = (float) getCmBOD_HeatExch_DHW_input_14().getValue();
    func_92.CmPriSupTempLimitation_input_13 = getCmBOD_HeatExch_DHW_output_20().getValue();
    func_92.Execute( this, 47 );

    // [535] Macro call CmHEDHW_Setpoint
    func_535.CmHEDHW_Setpoint_input_1 = (float) getCmBOD_HeatExch_DHW_input_2().getValue();
    func_535.CmHEDHW_Setpoint_input_6 = func_432.CmDayExtensionHEDHW_output_4;
    func_535.CmHEDHW_Setpoint_input_7 = getCmBOD_HeatExch_DHW_input_11().getValue();
    func_535.CmHEDHW_Setpoint_input_8 = false;
    func_535.CmHEDHW_Setpoint_input_39 = getCmBOD_HeatExch_DHW_output_20().getValue();
    func_535.Execute( this, 60 );

    // [604] Function call CfOr
    func_604.input[0] = getCmBOD_HeatExch_DHW_output_20().getValue();
    func_604.input[1] = func_603.outputAND;
    func_604.Execute(  );

    // [110] Function call CfCompare1
    func_110.inputA = func_535.CmHEDHW_Setpoint_output_2;
    func_110.inputB = 10F;
    func_110.Execute(  );

    // [114] Function call CfIdt
    func_114.input = func_91.CmPrimRWTContHEDHW_output_3;
    func_114.Execute(  );
    setCmBOD_HeatExch_DHW_parameter_54(func_114.output[0]);
    setCmBOD_HeatExch_DHW_output_24(func_114.output[1]);

    // [294] Function call CfInputMultiplexer
    func_294.inputSelect = BooleanToInt(func_535.CmHEDHW_Setpoint_output_9);
    func_294.input[1-1] = 1F;
    func_294.input[2-1] = 2F;
    func_294.Execute(  );

    // [434] Macro call CmSecSTContHEDHW
    func_434.CmSecSTContHEDHW_input_1 = (float) getCmBOD_HeatExch_DHW_input_1().getValue();
    func_434.CmSecSTContHEDHW_input_2 = func_535.CmHEDHW_Setpoint_output_2;
    func_434.CmSecSTContHEDHW_input_268 = getCmBOD_HeatExch_DHW_input_11().getValue();
    func_434.CmSecSTContHEDHW_input_269 = func_432.CmDayExtensionHEDHW_output_4;
    func_434.CmSecSTContHEDHW_input_279 = func_535.CmHEDHW_Setpoint_output_10;
    func_434.CmSecSTContHEDHW_input_72 = func_101.output;
    func_434.Execute( this, 68 );
    setCmBOD_HeatExch_DHW_output_21(func_434.CmSecSTContHEDHW_output_71);

    // [621] Function call CfOr
    func_621.input[0] = func_535.CmHEDHW_Setpoint_output_9;
    func_621.input[1] = func_432.CmDayExtensionHEDHW_output_4;
    func_621.Execute(  );

    // [120] Function call CfIdt
    func_120.input = func_434.CmSecSTContHEDHW_output_18;
    func_120.Execute(  );
    setCmBOD_HeatExch_DHW_parameter_53(func_120.output[0]);
    setCmBOD_HeatExch_DHW_output_18(func_120.output[1]);

    // [473] Function call CfAnd
    func_473.input[0] = func_620.output;
    func_473.input[1] = func_621.outputOR;
    func_473.Execute(  );

    // [505] Macro call CmValveControlHEDHW
    func_505.CmValveControlHEDHW_input_1 = func_91.CmPrimRWTContHEDHW_output_44;
    func_505.CmValveControlHEDHW_input_2 = func_92.CmPriSupTempLimitation_output_3;
    func_505.CmValveControlHEDHW_input_3 = func_434.CmSecSTContHEDHW_output_3;
    func_505.Execute( this, 90 );

    // [520] Function call CfInputMultiplexer
    func_520.inputSelect = BooleanToInt(getCmBOD_HeatExch_DHW_input_11().getValue());
    func_520.input[1-1] = func_294.output;
    func_520.input[2-1] = 1F;
    func_520.Execute(  );

    // [127] Function call CfOr
    func_127.input[0] = func_505.CmValveControlHEDHW_output_24;
    func_127.input[1] = func_505.CmValveControlHEDHW_output_23;
    func_127.Execute(  );

    // [129] Function call CfCompare1
    func_129.inputA = (float) getCmBOD_HeatExch_DHW_output_18().getValue();
    func_129.inputB = (float) getCmBOD_HeatExch_DHW_parameter_27();
    func_129.Execute(  );

    // [523] Function call CfInputMultiplexer
    func_523.inputSelect = BooleanToInt(func_432.CmDayExtensionHEDHW_output_4);
    func_523.input[1-1] = func_520.output;
    func_523.input[2-1] = 2F;
    func_523.Execute(  );

    // [123] Function call CfInputMultiplexer
    func_123.inputSelect = BooleanToInt(func_505.CmValveControlHEDHW_output_24);
    func_123.input[1-1] = func_523.output;
    func_123.input[2-1] = 3F;
    func_123.Execute(  );

    // [463] Function call CfAnd
    func_463.input[0] = func_129.outputGreater;
    func_463.input[1] = func_505.CmValveControlHEDHW_output_68;
    func_463.Execute(  );

    // [546] Function call CfAnd
    func_546.input[0] = func_129.outputGreater;
    func_546.input[1] = getCmBOD_HeatExch_DHW_input_7().getValue();
    func_546.Execute(  );

    // [657] Function call CfInputMultiplexer
    func_657.inputSelect = FloatToInt((float) getCmBOD_HeatExch_DHW_parameter_602());
    func_657.input[1-1] = 0F;
    func_657.input[2-1] = 0F;
    func_657.input[3-1] = 1F;
    func_657.input[4-1] = 0F;
    func_657.input[5-1] = 1F;
    func_657.Execute(  );

    // [623] Function call CfAnd
    func_623.input[0] = FloatToBoolean(func_657.output);
    func_623.input[1] = getCmBOD_HeatExch_DHW_input_9().getValue();
    func_623.Execute(  );

    // [662] Function call CfNot
    func_662.input = getCmBOD_HeatExch_DHW_input_9().getValue();
    func_662.Execute(  );

    // [658] Function call CfAnd
    func_658.input[0] = func_662.output;
    func_658.input[1] = getCmBOD_HeatExch_DHW_input_7().getValue();
    func_658.Execute(  );

    // [548] Function call CfOr
    func_548.input[0] = func_623.outputAND;
    func_548.input[1] = func_658.outputAND;
    func_548.input[2] = func_473.outputAND;
    func_548.Execute(  );

    // [130] Function call CfInputMultiplexer
    func_130.inputSelect = BooleanToInt(func_505.CmValveControlHEDHW_output_23);
    func_130.input[1-1] = func_123.output;
    func_130.input[2-1] = 4F;
    func_130.Execute(  );

    // [342] Function call CfOr
    func_342.input[0] = func_463.outputAND;
    func_342.input[1] = func_505.CmValveControlHEDHW_output_24;
    func_342.input[2] = func_546.outputAND;
    func_342.input[3] = func_604.outputOR;
    func_342.Execute(  );

    // [652] Function call CfOr
    func_652.input[0] = getCmBOD_HeatExch_DHW_input_9().getValue();
    func_652.input[1] = getCmBOD_HeatExch_DHW_input_11().getValue();
    func_652.Execute(  );

    // [660] Function call CfNot
    func_660.input = getCmBOD_HeatExch_DHW_input_11().getValue();
    func_660.Execute(  );

    // [650] Function call CfAnd
    func_650.input[0] = func_660.output;
    func_650.input[1] = func_548.outputOR;
    func_650.Execute(  );

    // [124] Function call CfDelayOnOff
    func_124.input = func_342.outputOR;
    func_124.Execute( this, 96 );

    // [651] Function call CfOr
    func_651.input[0] = func_650.outputAND;
    func_651.input[1] = getCmBOD_HeatExch_DHW_output_20().getValue();
    func_651.Execute(  );

    // [125] Function call CfDelayOnOff
    func_125.input = func_651.outputOR;
    func_125.Execute( this, 98 );

    // [632] Function call CfInputMultiplexer
    func_632.inputSelect = BooleanToInt(func_652.outputOR);
    func_632.input[1-1] = BooleanToFloat(func_124.output);
    func_632.input[2-1] = 0F;
    func_632.Execute(  );

    // [582] Function call CfInputMultiplexer
    func_582.inputSelect = BooleanToInt(func_93.CmRefillValveContol_output_32);
    func_582.input[1-1] = func_632.output;
    func_582.input[2-1] = 0F;
    func_582.Execute(  );
    setCmBOD_HeatExch_DHW_output_15(FloatToBoolean(func_582.output));

    // [584] Function call CfInputMultiplexer
    func_584.inputSelect = BooleanToInt(func_93.CmRefillValveContol_output_32);
    func_584.input[1-1] = BooleanToFloat(func_125.output);
    func_584.input[2-1] = 0F;
    func_584.Execute(  );
    setCmBOD_HeatExch_DHW_output_17(FloatToBoolean(func_584.output));

    // [147] Function call CfAnd
    func_147.input[0] = func_562.output;
    func_147.input[1] = func_127.outputOR;
    func_147.input[2] = func_110.outputGreater;
    func_147.input[3] = func_111.outputGreater;
    func_147.Execute(  );

    // [148] Function call CfCycle
    func_148.input = func_147.outputAND;
    func_148.Execute( this, 100 );

    // [570] Function call CfDelayOnOff
    func_570.input = func_147.outputAND;
    func_570.Execute( this, 102 );

    // [567] Function call CfInputMultiplexer
    func_567.inputSelect = BooleanToInt(func_570.output);
    func_567.input[1-1] = 0F;
    func_567.input[2-1] = BooleanToFloat(func_148.output);
    func_567.Execute(  );

    // [573] Function call CfInputMultiplexer
    func_573.inputSelect = FloatToInt(func_567.output);
    func_573.input[1-1] = func_505.CmValveControlHEDHW_output_4;
    func_573.input[2-1] = (float) getCmBOD_HeatExch_DHW_parameter_42();
    func_573.Execute(  );

    // [597] Function call CfIdt
    func_597.input = func_567.output;
    func_597.Execute(  );

    // [577] Function call CfInputMultiplexer
    func_577.inputSelect = BooleanToInt(getCmBOD_HeatExch_DHW_input_9().getValue());
    func_577.input[1-1] = func_573.output;
    func_577.input[2-1] = 0F;
    func_577.Execute(  );

    // [595] Function call CfInputMultiplexer
    func_595.inputSelect = FloatToInt(func_597.output[0]);
    func_595.input[1-1] = func_130.output;
    func_595.input[2-1] = 5F;
    func_595.Execute(  );

    // [454] Function call CfInputMultiplexer
    func_454.inputSelect = BooleanToInt(func_93.CmRefillValveContol_output_4);
    func_454.input[1-1] = func_595.output;
    func_454.input[2-1] = 6F;
    func_454.Execute(  );

    // [579] Function call CfInputMultiplexer
    func_579.inputSelect = BooleanToInt(func_93.CmRefillValveContol_output_32);
    func_579.input[1-1] = func_577.output;
    func_579.input[2-1] = 0F;
    func_579.Execute(  );
    setCmBOD_HeatExch_DHW_output_16(func_579.output);

    // [140] Function call CfInputMultiplexer
    func_140.inputSelect = BooleanToInt(getCmBOD_HeatExch_DHW_output_21().getValue());
    func_140.input[1-1] = func_454.output;
    func_140.input[2-1] = 9F;
    func_140.Execute(  );

    // [146] Function call CfCompare1
    func_146.inputA = (float) getCmBOD_HeatExch_DHW_output_16().getValue();
    func_146.inputB = func_107.output;
    func_146.Execute(  );

    // [136] Function call CfInputMultiplexer
    func_136.inputSelect = BooleanToInt(getCmBOD_HeatExch_DHW_output_20().getValue());
    func_136.input[1-1] = func_140.output;
    func_136.input[2-1] = 10F;
    func_136.Execute(  );

    // [562] Function call CfDelayOnOff
    func_562.input = func_146.outputLess;
    func_562.Execute( this, 104 );

    // [139] Function call CfInputMultiplexer
    func_139.inputSelect = BooleanToInt(getCmBOD_HeatExch_DHW_output_22().getValue());
    func_139.input[1-1] = func_136.output;
    func_139.input[2-1] = 11F;
    func_139.Execute(  );

    // [141] Function call CfInputMultiplexer
    func_141.inputSelect = BooleanToInt(getCmBOD_HeatExch_DHW_input_9().getValue());
    func_141.input[1-1] = func_139.output;
    func_141.input[2-1] = 12F;
    func_141.Execute(  );

    // [449] Function call CfInputMultiplexer
    func_449.inputSelect = BooleanToInt(func_93.CmRefillValveContol_output_32);
    func_449.input[1-1] = func_141.output;
    func_449.input[2-1] = 14F;
    func_449.Execute(  );

    // [144] Function call CfIdt
    func_144.input = func_449.output;
    func_144.Execute(  );
    setCmBOD_HeatExch_DHW_output_23(func_144.output[0]);
    setCmBOD_HeatExch_DHW_parameter_55(func_144.output[1]);

    // [430] Macro call CmHeatDemandHEDHW
    func_430.CmHeatDemandHEDHW_input_1 = (float) getCmBOD_HeatExch_DHW_output_18().getValue();
    func_430.CmHeatDemandHEDHW_input_50 = (float) getCmBOD_HeatExch_DHW_output_23().getValue();
    func_430.CmHeatDemandHEDHW_input_71 = func_432.CmDayExtensionHEDHW_output_4;
    func_430.CmHeatDemandHEDHW_input_112 = getCmBOD_HeatExch_DHW_output_17().getValue();
    func_430.Execute( this, 106 );
    setCmBOD_HeatExch_DHW_output_352(func_430.CmHeatDemandHEDHW_output_3);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 0F, 0F, 3F, 33F, 30F, 0F, 5F,
    0F, 0F, 0F, 1F, 0F, 0F, 0F, 0F,
    0F, 2F, 10F, 0F, 0F, 0F, 3F, 10F,
    0F, 0F, 0F, 3F, 10F, 0F, 5F, 5F,
    0F, 0F, 0F, 0F, 0F, 20F, -50F, 50F,
    -10F, 20F, 5F, 5F, 10F, 20F, 0F, 0F,
    0F, 0F, 100F, 0F, 100F, 0F, 0F, 50F,
    50F, 50F, 100F, 100F, 0F, 0F, 0F, 0F,
    0F, 999999F, 10F, 3F, 0F, 0F, 0F, 0F,
    0F, 0F, 0F, 0F, 0F, 10F, 0F, 10F,
    0F, 3F, 0F, 1000F, 100F, 0F, 0F, 0F,
    10F, 10F, 0F, 0F, 10F, 99999F, 2F, 1F,
    10F, 10F, 10F, 10F, 20F, 0F, 0F, 0F,
    0F, 10F, 0F, 0F, 0F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// PriPumpCmd
  public static final Property CmBOD_HeatExch_DHW_output_15 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOD_HeatExch_DHW_output_15() { return (BStatusBoolean) get(CmBOD_HeatExch_DHW_output_15); }
  public void setCmBOD_HeatExch_DHW_output_15(BStatusBoolean v) { set(CmBOD_HeatExch_DHW_output_15,v,null); }
  public void setCmBOD_HeatExch_DHW_output_15(boolean v) { getCmBOD_HeatExch_DHW_output_15().setValue(v); }
// ValveControl
  public static final Property CmBOD_HeatExch_DHW_output_16 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBOD_HeatExch_DHW_output_16() { return (BStatusNumeric) get(CmBOD_HeatExch_DHW_output_16); }
  public void setCmBOD_HeatExch_DHW_output_16(BStatusNumeric v) { set(CmBOD_HeatExch_DHW_output_16,v,null); }
  public void setCmBOD_HeatExch_DHW_output_16(float v) { getCmBOD_HeatExch_DHW_output_16().setValue(v); }
// CircPumpCmd
  public static final Property CmBOD_HeatExch_DHW_output_17 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOD_HeatExch_DHW_output_17() { return (BStatusBoolean) get(CmBOD_HeatExch_DHW_output_17); }
  public void setCmBOD_HeatExch_DHW_output_17(BStatusBoolean v) { set(CmBOD_HeatExch_DHW_output_17,v,null); }
  public void setCmBOD_HeatExch_DHW_output_17(boolean v) { getCmBOD_HeatExch_DHW_output_17().setValue(v); }
// CalcDHWTempSp
  public static final Property CmBOD_HeatExch_DHW_output_18 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DHW_output_18() { return (BStatusNumeric) get(CmBOD_HeatExch_DHW_output_18); }
  public void setCmBOD_HeatExch_DHW_output_18(BStatusNumeric v) { set(CmBOD_HeatExch_DHW_output_18,v,null); }
  public void setCmBOD_HeatExch_DHW_output_18(float v) { getCmBOD_HeatExch_DHW_output_18().setValue(v); }
// CalcRWTempSp
  public static final Property CmBOD_HeatExch_DHW_output_24 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DHW_output_24() { return (BStatusNumeric) get(CmBOD_HeatExch_DHW_output_24); }
  public void setCmBOD_HeatExch_DHW_output_24(BStatusNumeric v) { set(CmBOD_HeatExch_DHW_output_24,v,null); }
  public void setCmBOD_HeatExch_DHW_output_24(float v) { getCmBOD_HeatExch_DHW_output_24().setValue(v); }
// CalcHeatDemand
  public static final Property CmBOD_HeatExch_DHW_output_352 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DHW_output_352() { return (BStatusNumeric) get(CmBOD_HeatExch_DHW_output_352); }
  public void setCmBOD_HeatExch_DHW_output_352(BStatusNumeric v) { set(CmBOD_HeatExch_DHW_output_352,v,null); }
  public void setCmBOD_HeatExch_DHW_output_352(float v) { getCmBOD_HeatExch_DHW_output_352().setValue(v); }
// RefilValveCmd
  public static final Property CmBOD_HeatExch_DHW_output_19 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOD_HeatExch_DHW_output_19() { return (BStatusBoolean) get(CmBOD_HeatExch_DHW_output_19); }
  public void setCmBOD_HeatExch_DHW_output_19(BStatusBoolean v) { set(CmBOD_HeatExch_DHW_output_19,v,null); }
  public void setCmBOD_HeatExch_DHW_output_19(boolean v) { getCmBOD_HeatExch_DHW_output_19().setValue(v); }
// LegionellaActive
  public static final Property CmBOD_HeatExch_DHW_output_20 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOD_HeatExch_DHW_output_20() { return (BStatusBoolean) get(CmBOD_HeatExch_DHW_output_20); }
  public void setCmBOD_HeatExch_DHW_output_20(BStatusBoolean v) { set(CmBOD_HeatExch_DHW_output_20,v,null); }
  public void setCmBOD_HeatExch_DHW_output_20(boolean v) { getCmBOD_HeatExch_DHW_output_20().setValue(v); }
// DHW_Failure
  public static final Property CmBOD_HeatExch_DHW_output_21 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOD_HeatExch_DHW_output_21() { return (BStatusBoolean) get(CmBOD_HeatExch_DHW_output_21); }
  public void setCmBOD_HeatExch_DHW_output_21(BStatusBoolean v) { set(CmBOD_HeatExch_DHW_output_21,v,null); }
  public void setCmBOD_HeatExch_DHW_output_21(boolean v) { getCmBOD_HeatExch_DHW_output_21().setValue(v); }
// DHWS_Leg_Alm
  public static final Property CmBOD_HeatExch_DHW_output_22 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOD_HeatExch_DHW_output_22() { return (BStatusBoolean) get(CmBOD_HeatExch_DHW_output_22); }
  public void setCmBOD_HeatExch_DHW_output_22(BStatusBoolean v) { set(CmBOD_HeatExch_DHW_output_22,v,null); }
  public void setCmBOD_HeatExch_DHW_output_22(boolean v) { getCmBOD_HeatExch_DHW_output_22().setValue(v); }
// OperationMode
  public static final Property CmBOD_HeatExch_DHW_output_23 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBOD_HeatExch_DHW_output_23() { return (BStatusNumeric) get(CmBOD_HeatExch_DHW_output_23); }
  public void setCmBOD_HeatExch_DHW_output_23(BStatusNumeric v) { set(CmBOD_HeatExch_DHW_output_23,v,null); }
  public void setCmBOD_HeatExch_DHW_output_23(float v) { getCmBOD_HeatExch_DHW_output_23().setValue(v); }

  // macro parameter
// SST-01: maximum supply temperature
  public static final Property CmBOD_HeatExch_DHW_parameter_25 = newProperty( 0, BDouble.make( 90 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(50)), BFacets.make(BFacets.MAX, BDouble.make(200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DHW_parameter_25() { return getDouble(CmBOD_HeatExch_DHW_parameter_25); }
  public void setCmBOD_HeatExch_DHW_parameter_25(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_25,v,null); }
// SST-02: minimum supply temperature
  public static final Property CmBOD_HeatExch_DHW_parameter_26 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(90)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DHW_parameter_26() { return getDouble(CmBOD_HeatExch_DHW_parameter_26); }
  public void setCmBOD_HeatExch_DHW_parameter_26(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_26,v,null); }
// SST-03: occupied / un-occupied changeover; 0 = disable
  public static final Property CmBOD_HeatExch_DHW_parameter_27 = newProperty( 0, BDouble.make( 40 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DHW_parameter_27() { return getDouble(CmBOD_HeatExch_DHW_parameter_27); }
  public void setCmBOD_HeatExch_DHW_parameter_27(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_27,v,null); }
// SST-04: setpoint raise to compensate losses
  public static final Property CmBOD_HeatExch_DHW_parameter_28 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOD_HeatExch_DHW_parameter_28() { return getDouble(CmBOD_HeatExch_DHW_parameter_28); }
  public void setCmBOD_HeatExch_DHW_parameter_28(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_28,v,null); }
// SST-05: maximum setpoint raise per minute
  public static final Property CmBOD_HeatExch_DHW_parameter_29 = newProperty( 0, BDouble.make( 25 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOD_HeatExch_DHW_parameter_29() { return getDouble(CmBOD_HeatExch_DHW_parameter_29); }
  public void setCmBOD_HeatExch_DHW_parameter_29(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_29,v,null); }
// SST-06: P-band SST control
  public static final Property CmBOD_HeatExch_DHW_parameter_30 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOD_HeatExch_DHW_parameter_30() { return getDouble(CmBOD_HeatExch_DHW_parameter_30); }
  public void setCmBOD_HeatExch_DHW_parameter_30(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_30,v,null); }
// SST-07: I-time system supply temperature control
  public static final Property CmBOD_HeatExch_DHW_parameter_31 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DHW_parameter_31() { return getDouble(CmBOD_HeatExch_DHW_parameter_31); }
  public void setCmBOD_HeatExch_DHW_parameter_31(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_31,v,null); }
// SST-08: D-time system supply temperature control
  public static final Property CmBOD_HeatExch_DHW_parameter_32 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DHW_parameter_32() { return getDouble(CmBOD_HeatExch_DHW_parameter_32); }
  public void setCmBOD_HeatExch_DHW_parameter_32(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_32,v,null); }
// PST-01: P-band primary supply temperature control
  public static final Property CmBOD_HeatExch_DHW_parameter_33 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOD_HeatExch_DHW_parameter_33() { return getDouble(CmBOD_HeatExch_DHW_parameter_33); }
  public void setCmBOD_HeatExch_DHW_parameter_33(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_33,v,null); }
// RWT-01: return water setpoint raise during legionella
  public static final Property CmBOD_HeatExch_DHW_parameter_34 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOD_HeatExch_DHW_parameter_34() { return getDouble(CmBOD_HeatExch_DHW_parameter_34); }
  public void setCmBOD_HeatExch_DHW_parameter_34(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_34,v,null); }
// RWT-02: P-band return temperature control
  public static final Property CmBOD_HeatExch_DHW_parameter_35 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOD_HeatExch_DHW_parameter_35() { return getDouble(CmBOD_HeatExch_DHW_parameter_35); }
  public void setCmBOD_HeatExch_DHW_parameter_35(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_35,v,null); }
// PRP-01: primary pump start-up delay
  public static final Property CmBOD_HeatExch_DHW_parameter_36 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DHW_parameter_36() { return getDouble(CmBOD_HeatExch_DHW_parameter_36); }
  public void setCmBOD_HeatExch_DHW_parameter_36(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_36,v,null); }
// PRP-02: primary pump switch off delay
  public static final Property CmBOD_HeatExch_DHW_parameter_37 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DHW_parameter_37() { return getDouble(CmBOD_HeatExch_DHW_parameter_37); }
  public void setCmBOD_HeatExch_DHW_parameter_37(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_37,v,null); }
// SEP-02: circulation pump switch off delay
  public static final Property CmBOD_HeatExch_DHW_parameter_39 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DHW_parameter_39() { return getDouble(CmBOD_HeatExch_DHW_parameter_39); }
  public void setCmBOD_HeatExch_DHW_parameter_39(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_39,v,null); }
// SEP-03: run circualtion pump during occupied periods and extended operation
  public static final Property CmBOD_HeatExch_DHW_parameter_601 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOD_HeatExch_DHW_parameter_601() { return getDouble(CmBOD_HeatExch_DHW_parameter_601); }
  public void setCmBOD_HeatExch_DHW_parameter_601(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_601,v,null); }
// SEP-04: circulation pump during overheat protection; 0; 1; 3 = disable; 2; 4 = enabled
  public static final Property CmBOD_HeatExch_DHW_parameter_602 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(4)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOD_HeatExch_DHW_parameter_602() { return getDouble(CmBOD_HeatExch_DHW_parameter_602); }
  public void setCmBOD_HeatExch_DHW_parameter_602(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_602,v,null); }
// VLV-01: valve position limit
  public static final Property CmBOD_HeatExch_DHW_parameter_40 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmBOD_HeatExch_DHW_parameter_40() { return getDouble(CmBOD_HeatExch_DHW_parameter_40); }
  public void setCmBOD_HeatExch_DHW_parameter_40(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_40,v,null); }
// VLV-02: minimum valve position
  public static final Property CmBOD_HeatExch_DHW_parameter_42 = newProperty( 0, BDouble.make( 40 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmBOD_HeatExch_DHW_parameter_42() { return getDouble(CmBOD_HeatExch_DHW_parameter_42); }
  public void setCmBOD_HeatExch_DHW_parameter_42(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_42,v,null); }
// VLV-03: maximum valve postion raise per minute
  public static final Property CmBOD_HeatExch_DHW_parameter_41 = newProperty( 0, BDouble.make( 70 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmBOD_HeatExch_DHW_parameter_41() { return getDouble(CmBOD_HeatExch_DHW_parameter_41); }
  public void setCmBOD_HeatExch_DHW_parameter_41(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_41,v,null); }
// VLV-04: valve open time at closed valve during  limitation control
  public static final Property CmBOD_HeatExch_DHW_parameter_43 = newProperty( 0, BDouble.make( 180 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DHW_parameter_43() { return getDouble(CmBOD_HeatExch_DHW_parameter_43); }
  public void setCmBOD_HeatExch_DHW_parameter_43(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_43,v,null); }
// LEG-01: anti-legionella setpoint
  public static final Property CmBOD_HeatExch_DHW_parameter_44 = newProperty( 0, BDouble.make( 70 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(90)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DHW_parameter_44() { return getDouble(CmBOD_HeatExch_DHW_parameter_44); }
  public void setCmBOD_HeatExch_DHW_parameter_44(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_44,v,null); }
// LEG-02: time to reach legionella setpoint; 0 = disable
  public static final Property CmBOD_HeatExch_DHW_parameter_45 = newProperty( 0, BDouble.make( 1800 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DHW_parameter_45() { return getDouble(CmBOD_HeatExch_DHW_parameter_45); }
  public void setCmBOD_HeatExch_DHW_parameter_45(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_45,v,null); }
// LEG-03: legionella duration
  public static final Property CmBOD_HeatExch_DHW_parameter_46 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DHW_parameter_46() { return getDouble(CmBOD_HeatExch_DHW_parameter_46); }
  public void setCmBOD_HeatExch_DHW_parameter_46(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_46,v,null); }
// DEX-01:DHW setpoint extendetd operation
  public static final Property CmBOD_HeatExch_DHW_parameter_47 = newProperty( 0, BDouble.make( 58 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(80)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DHW_parameter_47() { return getDouble(CmBOD_HeatExch_DHW_parameter_47); }
  public void setCmBOD_HeatExch_DHW_parameter_47(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_47,v,null); }
// DEX-02: auto reset time from extended operation
  public static final Property CmBOD_HeatExch_DHW_parameter_48 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(480)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmBOD_HeatExch_DHW_parameter_48() { return getDouble(CmBOD_HeatExch_DHW_parameter_48); }
  public void setCmBOD_HeatExch_DHW_parameter_48(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_48,v,null); }
// REF-01: maximum refill valve runtime
  public static final Property CmBOD_HeatExch_DHW_parameter_49 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DHW_parameter_49() { return getDouble(CmBOD_HeatExch_DHW_parameter_49); }
  public void setCmBOD_HeatExch_DHW_parameter_49(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_49,v,null); }
// SYS-01: heat demand transmission
  public static final Property CmBOD_HeatExch_DHW_parameter_50 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOD_HeatExch_DHW_parameter_50() { return getDouble(CmBOD_HeatExch_DHW_parameter_50); }
  public void setCmBOD_HeatExch_DHW_parameter_50(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_50,v,null); }
// SYS-02: DHW_Failure enable after release
  public static final Property CmBOD_HeatExch_DHW_parameter_51 = newProperty( 0, BDouble.make( 1800 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DHW_parameter_51() { return getDouble(CmBOD_HeatExch_DHW_parameter_51); }
  public void setCmBOD_HeatExch_DHW_parameter_51(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_51,v,null); }
// SYS-03: automatic/ manual reset; 0 = auto
  public static final Property CmBOD_HeatExch_DHW_parameter_52 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOD_HeatExch_DHW_parameter_52() { return getDouble(CmBOD_HeatExch_DHW_parameter_52); }
  public void setCmBOD_HeatExch_DHW_parameter_52(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_52,v,null); }
// DISP-01: calculated DHWS temperature setpoint
  public static final Property CmBOD_HeatExch_DHW_parameter_53 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DHW_parameter_53() { return getDouble(CmBOD_HeatExch_DHW_parameter_53); }
  public void setCmBOD_HeatExch_DHW_parameter_53(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_53,v,null); }
// DISP-02: calculated return temperature setpoint
  public static final Property CmBOD_HeatExch_DHW_parameter_54 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DHW_parameter_54() { return getDouble(CmBOD_HeatExch_DHW_parameter_54); }
  public void setCmBOD_HeatExch_DHW_parameter_54(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_54,v,null); }
// DISP-03: operating mode
  public static final Property CmBOD_HeatExch_DHW_parameter_55 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOD_HeatExch_DHW_parameter_55() { return getDouble(CmBOD_HeatExch_DHW_parameter_55); }
  public void setCmBOD_HeatExch_DHW_parameter_55(double v) { setDouble(CmBOD_HeatExch_DHW_parameter_55,v,null); }

  // macro inputs
// SecSupTemp
  public static final Property CmBOD_HeatExch_DHW_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DHW_input_1() { return (BStatusNumeric) get(CmBOD_HeatExch_DHW_input_1); }
  public void setCmBOD_HeatExch_DHW_input_1(BStatusNumeric v) { set(CmBOD_HeatExch_DHW_input_1,v,null); }
  public void setCmBOD_HeatExch_DHW_input_1(float v) { getCmBOD_HeatExch_DHW_input_1().setValue(v); }
// DHW_TempSp
  public static final Property CmBOD_HeatExch_DHW_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 60 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DHW_input_2() { return (BStatusNumeric) get(CmBOD_HeatExch_DHW_input_2); }
  public void setCmBOD_HeatExch_DHW_input_2(BStatusNumeric v) { set(CmBOD_HeatExch_DHW_input_2,v,null); }
  public void setCmBOD_HeatExch_DHW_input_2(float v) { getCmBOD_HeatExch_DHW_input_2().setValue(v); }
// PriSupTemp
  public static final Property CmBOD_HeatExch_DHW_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DHW_input_3() { return (BStatusNumeric) get(CmBOD_HeatExch_DHW_input_3); }
  public void setCmBOD_HeatExch_DHW_input_3(BStatusNumeric v) { set(CmBOD_HeatExch_DHW_input_3,v,null); }
  public void setCmBOD_HeatExch_DHW_input_3(float v) { getCmBOD_HeatExch_DHW_input_3().setValue(v); }
// PriSupTempSp
  public static final Property CmBOD_HeatExch_DHW_input_14 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DHW_input_14() { return (BStatusNumeric) get(CmBOD_HeatExch_DHW_input_14); }
  public void setCmBOD_HeatExch_DHW_input_14(BStatusNumeric v) { set(CmBOD_HeatExch_DHW_input_14,v,null); }
  public void setCmBOD_HeatExch_DHW_input_14(float v) { getCmBOD_HeatExch_DHW_input_14().setValue(v); }
// PriRetTemp
  public static final Property CmBOD_HeatExch_DHW_input_4 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DHW_input_4() { return (BStatusNumeric) get(CmBOD_HeatExch_DHW_input_4); }
  public void setCmBOD_HeatExch_DHW_input_4(BStatusNumeric v) { set(CmBOD_HeatExch_DHW_input_4,v,null); }
  public void setCmBOD_HeatExch_DHW_input_4(float v) { getCmBOD_HeatExch_DHW_input_4().setValue(v); }
// PriRetTempSp
  public static final Property CmBOD_HeatExch_DHW_input_5 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DHW_input_5() { return (BStatusNumeric) get(CmBOD_HeatExch_DHW_input_5); }
  public void setCmBOD_HeatExch_DHW_input_5(BStatusNumeric v) { set(CmBOD_HeatExch_DHW_input_5,v,null); }
  public void setCmBOD_HeatExch_DHW_input_5(float v) { getCmBOD_HeatExch_DHW_input_5().setValue(v); }
// LegionellaEnable
  public static final Property CmBOD_HeatExch_DHW_input_6 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOD_HeatExch_DHW_input_6() { return (BStatusBoolean) get(CmBOD_HeatExch_DHW_input_6); }
  public void setCmBOD_HeatExch_DHW_input_6(BStatusBoolean v) { set(CmBOD_HeatExch_DHW_input_6,v,null); }
  public void setCmBOD_HeatExch_DHW_input_6(boolean v) { getCmBOD_HeatExch_DHW_input_6().setValue(v); }
// CircPumpDemand
  public static final Property CmBOD_HeatExch_DHW_input_7 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmBOD_HeatExch_DHW_input_7() { return (BStatusBoolean) get(CmBOD_HeatExch_DHW_input_7); }
  public void setCmBOD_HeatExch_DHW_input_7(BStatusBoolean v) { set(CmBOD_HeatExch_DHW_input_7,v,null); }
  public void setCmBOD_HeatExch_DHW_input_7(boolean v) { getCmBOD_HeatExch_DHW_input_7().setValue(v); }
// MaxThermostat
  public static final Property CmBOD_HeatExch_DHW_input_9 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOD_HeatExch_DHW_input_9() { return (BStatusBoolean) get(CmBOD_HeatExch_DHW_input_9); }
  public void setCmBOD_HeatExch_DHW_input_9(BStatusBoolean v) { set(CmBOD_HeatExch_DHW_input_9,v,null); }
  public void setCmBOD_HeatExch_DHW_input_9(boolean v) { getCmBOD_HeatExch_DHW_input_9().setValue(v); }
// DayExtension
  public static final Property CmBOD_HeatExch_DHW_input_10 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOD_HeatExch_DHW_input_10() { return (BStatusBoolean) get(CmBOD_HeatExch_DHW_input_10); }
  public void setCmBOD_HeatExch_DHW_input_10(BStatusBoolean v) { set(CmBOD_HeatExch_DHW_input_10,v,null); }
  public void setCmBOD_HeatExch_DHW_input_10(boolean v) { getCmBOD_HeatExch_DHW_input_10().setValue(v); }
// HolidaySwitch
  public static final Property CmBOD_HeatExch_DHW_input_11 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOD_HeatExch_DHW_input_11() { return (BStatusBoolean) get(CmBOD_HeatExch_DHW_input_11); }
  public void setCmBOD_HeatExch_DHW_input_11(BStatusBoolean v) { set(CmBOD_HeatExch_DHW_input_11,v,null); }
  public void setCmBOD_HeatExch_DHW_input_11(boolean v) { getCmBOD_HeatExch_DHW_input_11().setValue(v); }
// SecMinPressSw
  public static final Property CmBOD_HeatExch_DHW_input_12 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOD_HeatExch_DHW_input_12() { return (BStatusBoolean) get(CmBOD_HeatExch_DHW_input_12); }
  public void setCmBOD_HeatExch_DHW_input_12(BStatusBoolean v) { set(CmBOD_HeatExch_DHW_input_12,v,null); }
  public void setCmBOD_HeatExch_DHW_input_12(boolean v) { getCmBOD_HeatExch_DHW_input_12().setValue(v); }
// Reset
  public static final Property CmBOD_HeatExch_DHW_input_13 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOD_HeatExch_DHW_input_13() { return (BStatusBoolean) get(CmBOD_HeatExch_DHW_input_13); }
  public void setCmBOD_HeatExch_DHW_input_13(BStatusBoolean v) { set(CmBOD_HeatExch_DHW_input_13,v,null); }
  public void setCmBOD_HeatExch_DHW_input_13(boolean v) { getCmBOD_HeatExch_DHW_input_13().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.04 [126] 06.05.2019-14:54").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5986834578679005499").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmBOD_HeatExch_DHW.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmRefillValveContol func_93 = new CmRefillValveContol();
  protected CmIDT05 func_97 = new CmIDT05();
  protected CfMonoflop func_101 = new CfMonoflop();
  protected CfAddition func_107 = new CfAddition();
  protected CfIdt func_108 = new CfIdt();
  protected CfIdt func_109 = new CfIdt();
  protected CfCompare1 func_111 = new CfCompare1();
  protected CmIDT20 func_367 = new CmIDT20();
  protected CmIDT20 func_402 = new CmIDT20();
  protected CfAddition func_563 = new CfAddition();
  protected CfAddition func_569 = new CfAddition();
  protected CfWindow func_620 = new CfWindow();
  protected CmDayExtensionHEDHW func_432 = new CmDayExtensionHEDHW();
  protected CfAnd func_603 = new CfAnd();
  protected CmLegionellaProt func_347 = new CmLegionellaProt();
  protected CmPrimRWTContHEDHW func_91 = new CmPrimRWTContHEDHW();
  protected CmPriSupTempLimitation func_92 = new CmPriSupTempLimitation();
  protected CmHEDHW_Setpoint func_535 = new CmHEDHW_Setpoint();
  protected CfOr func_604 = new CfOr();
  protected CfCompare1 func_110 = new CfCompare1();
  protected CfIdt func_114 = new CfIdt();
  protected CfInputMultiplexer func_294 = new CfInputMultiplexer();
  protected CmSecSTContHEDHW func_434 = new CmSecSTContHEDHW();
  protected CfOr func_621 = new CfOr();
  protected CfIdt func_120 = new CfIdt();
  protected CfAnd func_473 = new CfAnd();
  protected CmValveControlHEDHW func_505 = new CmValveControlHEDHW();
  protected CfInputMultiplexer func_520 = new CfInputMultiplexer();
  protected CfOr func_127 = new CfOr();
  protected CfCompare1 func_129 = new CfCompare1();
  protected CfInputMultiplexer func_523 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_123 = new CfInputMultiplexer();
  protected CfAnd func_463 = new CfAnd();
  protected CfAnd func_546 = new CfAnd();
  protected CfInputMultiplexer func_657 = new CfInputMultiplexer();
  protected CfAnd func_623 = new CfAnd();
  protected CfNot func_662 = new CfNot();
  protected CfAnd func_658 = new CfAnd();
  protected CfOr func_548 = new CfOr();
  protected CfInputMultiplexer func_130 = new CfInputMultiplexer();
  protected CfOr func_342 = new CfOr();
  protected CfOr func_652 = new CfOr();
  protected CfNot func_660 = new CfNot();
  protected CfAnd func_650 = new CfAnd();
  protected CfDelayOnOff func_124 = new CfDelayOnOff();
  protected CfOr func_651 = new CfOr();
  protected CfDelayOnOff func_125 = new CfDelayOnOff();
  protected CfInputMultiplexer func_632 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_582 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_584 = new CfInputMultiplexer();
  protected CfAnd func_147 = new CfAnd();
  protected CfCycle func_148 = new CfCycle();
  protected CfDelayOnOff func_570 = new CfDelayOnOff();
  protected CfInputMultiplexer func_567 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_573 = new CfInputMultiplexer();
  protected CfIdt func_597 = new CfIdt();
  protected CfInputMultiplexer func_577 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_595 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_454 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_579 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_140 = new CfInputMultiplexer();
  protected CfCompare1 func_146 = new CfCompare1();
  protected CfInputMultiplexer func_136 = new CfInputMultiplexer();
  protected CfDelayOnOff func_562 = new CfDelayOnOff();
  protected CfInputMultiplexer func_139 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_141 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_449 = new CfInputMultiplexer();
  protected CfIdt func_144 = new CfIdt();
  protected CmHeatDemandHEDHW func_430 = new CmHeatDemandHEDHW();

  // default constructor
  public BCmBOD_HeatExch_DHW()
  {
    func_114.configure(2);
    func_120.configure(2);
    func_657.configure(6);
    func_548.configure(3);
    func_342.configure(4);
    func_147.configure(4);
    func_144.configure(2);
  }

  public void Start()
  {
    func_93.Start();
    func_97.Start();
    func_101.Start();
    func_367.Start();
    func_402.Start();
    func_432.Start();
    func_347.Start();
    func_91.Start();
    func_92.Start();
    func_535.Start();
    func_434.Start();
    func_505.Start();
    func_124.Start();
    func_125.Start();
    func_148.Start();
    func_570.Start();
    func_562.Start();
    func_430.Start();
  }
}
