/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    BOD_HeatExch_DistrHtg
Macro id:      5986849731335160427
Macro version: 116
Last change:   06.05.2019 - 11:12
Access Level:  2
Inputs:
  [1] SecSupTemp
  [2] HeatDemand
  [3] PriSupTemp
  [4] PriSupTempSp
  [5] PriRetTemp
  [6] PriRetTempSp
  [7] DistrHtgSupTemp
  [8] FilteredOATemp
  [9] LegionellaActive
  [10] MaxThermostat
  [11] SafetyTherm
  [12] SecPmpStatAlm
  [13] SecMinPressSw
  [14] Reset
Outputs:
  [1] PriPumpCmd
  [2] ValveControl
  [3] SecPumpCmd
  [4] CalcSSTempSp
  [5] CalcRWTempSp
  [6] RefillValveCmd
  [7] HE-Failure
  [8] OperationMode
Parameter:
  [1] SST-01: maximum supply temperature
  [2] SST-02: minimum supply temperature
  [3] SST-04: setpoint raise to compensate losses
  [4] SST-05: maximum setpoint raise per minute
  [5] SST-06: P-band SST control
  [6] SST-07: I-time system supply temperature control
  [7] SST-08: D-time system supply temperature control
  [8] PST-01: P-band primary supply temperature contol
  [9] RWT-01: return water setpoint raise during legionella
  [10] RWT-02: P-band return temperature control
  [11] RWT-03: return water setpoint raise at high DST or low OAT
  [12] RWT-04: return water control configuration
  [13] DST-01: minimum district supply temperature
  [14] DST-02: maximum district supply temperature
  [15] DST-03: minimum district supply temperature at pump alarm
  [16] OAT-01: low limit frost protrction
  [17] OAT-02: minimum outside air temperature
  [18] OAT-03: maximum outside air temperature
  [19] PRP-01: primary pump start-up delay
  [20] PRP-02: primary pump switch off delay
  [21] SEP-01: secondary pump start-up delay
  [22] SEP-02: secondary pump switch off delay
  [23] VLV-01: valve postion limit
  [24] VLV-02: minimum valve position
  [25] VLV-03: maximum valve position raise per minute
  [26] VLV-04: valve open time at closed during limitation control
  [27] REF-01: maximum refill valve runtime
  [28] SYS-02: HE_Failure enable after release
  [29] SYS-03: automatic/ manual reset; 0 = auto
  [30] DISP-01: calculated temperature setpoint
  [31] DISP-02: calculated return temperature setpoint
  [32] DISP-03: operating mode
Description:
The main control functions of the domestic hot water heat exchanger are:
·   secondary supply temperature control
·   cascaded heat exchanger control, where the second heat exchanger is supplied from the return pipe of the heating circuit
·   return water temperature control
·   secondary pump commands
·   primary pump commands
·   frost protection
·   maximum thermostat to switch off the control functions in case of overheat
·   refill valve control
================================================================================*/

public class BCmBOD_HeatExch_DistrHtg
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmBOD_HeatExch_DistrHtg_output_14().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmBOD_HeatExch_DistrHtg_output_14().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DistrHtg_output_15().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DistrHtg_output_16().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DistrHtg_output_17().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DistrHtg_output_18().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DistrHtg_output_19().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DistrHtg_output_20().setStatus(BStatus.disabled);
    getCmBOD_HeatExch_DistrHtg_output_21().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmBOD_HeatExch_DistrHtg_output_14().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DistrHtg_output_15().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DistrHtg_output_16().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DistrHtg_output_17().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DistrHtg_output_18().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DistrHtg_output_19().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DistrHtg_output_20().setStatus(BStatus.ok);
    getCmBOD_HeatExch_DistrHtg_output_21().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [52] Macro call CmPrimary_RWT_Control
    func_52.CmPrimary_RWT_Control_input_1 = (float) getCmBOD_HeatExch_DistrHtg_input_5().getValue();
    func_52.CmPrimary_RWT_Control_input_2 = (float) getCmBOD_HeatExch_DistrHtg_input_6().getValue();
    func_52.CmPrimary_RWT_Control_input_20 = (float) getCmBOD_HeatExch_DistrHtg_input_8().getValue();
    func_52.CmPrimary_RWT_Control_input_21 = (float) getCmBOD_HeatExch_DistrHtg_input_7().getValue();
    func_52.CmPrimary_RWT_Control_input_22 = getCmBOD_HeatExch_DistrHtg_input_9().getValue();
    func_52.Execute( this, 0 );

    // [58] Macro call CmPriSupTempLimitation
    func_58.CmPriSupTempLimitation_input_1 = (float) getCmBOD_HeatExch_DistrHtg_input_3().getValue();
    func_58.CmPriSupTempLimitation_input_2 = (float) getCmBOD_HeatExch_DistrHtg_input_4().getValue();
    func_58.CmPriSupTempLimitation_input_13 = getCmBOD_HeatExch_DistrHtg_input_9().getValue();
    func_58.Execute( this, 42 );

    // [82] Macro call CmRefillValveContol
    func_82.CmRefillValveContol_input_1 = getCmBOD_HeatExch_DistrHtg_input_12().getValue();
    func_82.Execute( this, 55 );
    setCmBOD_HeatExch_DistrHtg_output_19(func_82.CmRefillValveContol_output_2);

    // [108] Function call CfCompare1
    func_108.inputA = func_468.output;
    func_108.inputB = 10F;
    func_108.Execute(  );

    // [142] Function call CfHysteresis
    func_142.inputX = func_468.output;
    func_142.inputW = 10F;
    func_142.Execute( this, 62 );

    // [144] Macro call CmIDT05
    func_144.CmIDT05_input_1 = (float) getCmBOD_HeatExch_DistrHtg_parameter_39();
    func_144.CmIDT05_input_2 = (float) getCmBOD_HeatExch_DistrHtg_parameter_40();
    func_144.CmIDT05_input_3 = (float) getCmBOD_HeatExch_DistrHtg_parameter_41();
    func_144.CmIDT05_input_4 = (float) getCmBOD_HeatExch_DistrHtg_parameter_42();
    func_144.CmIDT05_input_5 = 0F;
    func_144.Execute(  );
    setParameter(95, func_144.CmIDT05_output_21);
    setParameter(96, func_144.CmIDT05_output_22);
    setParameter(97, func_144.CmIDT05_output_23);
    setParameter(98, func_144.CmIDT05_output_24);

    // [178] Function call CfMonoflop
    func_178.input = BooleanToFloat(getCmBOD_HeatExch_DistrHtg_input_13().getValue());
    func_178.Execute( this, 63 );

    // [180] Macro call CmIDT20
    func_180.CmIDT20_input_1 = (float) getCmBOD_HeatExch_DistrHtg_parameter_30();
    func_180.CmIDT20_input_2 = (float) getCmBOD_HeatExch_DistrHtg_parameter_31();
    func_180.CmIDT20_input_3 = (float) getCmBOD_HeatExch_DistrHtg_parameter_32();
    func_180.CmIDT20_input_4 = (float) getCmBOD_HeatExch_DistrHtg_parameter_33();
    func_180.CmIDT20_input_5 = (float) getCmBOD_HeatExch_DistrHtg_parameter_37();
    func_180.CmIDT20_input_6 = (float) getCmBOD_HeatExch_DistrHtg_parameter_38();
    func_180.CmIDT20_input_7 = (float) getCmBOD_HeatExch_DistrHtg_parameter_34();
    func_180.CmIDT20_input_8 = (float) getCmBOD_HeatExch_DistrHtg_parameter_35();
    func_180.CmIDT20_input_9 = (float) getCmBOD_HeatExch_DistrHtg_parameter_29();
    func_180.CmIDT20_input_10 = (float) getCmBOD_HeatExch_DistrHtg_parameter_43();
    func_180.CmIDT20_input_11 = (float) getCmBOD_HeatExch_DistrHtg_parameter_22();
    func_180.CmIDT20_input_12 = (float) getCmBOD_HeatExch_DistrHtg_parameter_23();
    func_180.CmIDT20_input_13 = (float) getCmBOD_HeatExch_DistrHtg_parameter_24();
    func_180.CmIDT20_input_14 = (float) getCmBOD_HeatExch_DistrHtg_parameter_25();
    func_180.CmIDT20_input_15 = (float) getCmBOD_HeatExch_DistrHtg_parameter_26();
    func_180.CmIDT20_input_16 = (float) getCmBOD_HeatExch_DistrHtg_parameter_27();
    func_180.CmIDT20_input_17 = (float) getCmBOD_HeatExch_DistrHtg_parameter_28();
    func_180.CmIDT20_input_18 = (float) getCmBOD_HeatExch_DistrHtg_parameter_43();
    func_180.CmIDT20_input_19 = (float) getCmBOD_HeatExch_DistrHtg_parameter_47();
    func_180.CmIDT20_input_20 = (float) getCmBOD_HeatExch_DistrHtg_parameter_48();
    func_180.Execute(  );
    setParameter(0, func_180.CmIDT20_output_21);
    setParameter(1, func_180.CmIDT20_output_22);
    setParameter(2, func_180.CmIDT20_output_23);
    setParameter(3, func_180.CmIDT20_output_24);
    setParameter(4, func_180.CmIDT20_output_25);
    setParameter(5, func_180.CmIDT20_output_26);
    setParameter(6, func_180.CmIDT20_output_27);
    setParameter(7, func_180.CmIDT20_output_28);
    setParameter(42, func_180.CmIDT20_output_29);
    setParameter(43, func_180.CmIDT20_output_30);
    setParameter(65, func_180.CmIDT20_output_31);
    setParameter(66, func_180.CmIDT20_output_32);
    setParameter(67, func_180.CmIDT20_output_33);
    setParameter(68, func_180.CmIDT20_output_34);
    setParameter(69, func_180.CmIDT20_output_35);
    setParameter(70, func_180.CmIDT20_output_36);
    setParameter(71, func_180.CmIDT20_output_37);
    setParameter(8, func_180.CmIDT20_output_38);
    setParameter(72, func_180.CmIDT20_output_39);
    setParameter(73, func_180.CmIDT20_output_40);

    // [201] Macro call CmIDT05
    func_201.CmIDT05_input_1 = (float) getCmBOD_HeatExch_DistrHtg_parameter_46();
    func_201.CmIDT05_input_2 = (float) getCmBOD_HeatExch_DistrHtg_parameter_44();
    func_201.CmIDT05_input_3 = (float) getCmBOD_HeatExch_DistrHtg_parameter_45();
    func_201.CmIDT05_input_4 = (float) getCmBOD_HeatExch_DistrHtg_parameter_36();
    func_201.CmIDT05_input_5 = 0F;
    func_201.Execute(  );
    setParameter(55, func_201.CmIDT05_output_21);
    setParameter(90, func_201.CmIDT05_output_22);
    setParameter(91, func_201.CmIDT05_output_23);
    setParameter(74, func_201.CmIDT05_output_24);

    // [244] Function call CfAddition
    func_244.input[0] = (float) getCmBOD_HeatExch_DistrHtg_parameter_43();
    func_244.input[1] = 0.1F;
    func_244.Execute(  );

    // [245] Function call CfIdt
    func_245.input = 600F;
    func_245.Execute(  );
    setParameter(102, func_245.output[0]);

    // [252] Function call CfCompare1
    func_252.inputA = func_468.output;
    func_252.inputB = 10F;
    func_252.Execute(  );

    // [261] Function call CfCompare1
    func_261.inputA = (float) getCmBOD_HeatExch_DistrHtg_parameter_259();
    func_261.inputB = 0F;
    func_261.Execute(  );

    // [289] Function call CfHysteresis
    func_289.inputX = (float) getCmBOD_HeatExch_DistrHtg_input_8().getValue();
    func_289.inputW = (float) getCmBOD_HeatExch_DistrHtg_parameter_36();
    func_289.Execute( this, 64 );

    // [338] Function call CfIdt
    func_338.input = (float) getCmBOD_HeatExch_DistrHtg_parameter_259();
    func_338.Execute(  );
    setParameter(101, func_338.output[0]);

    // [378] Function call CfAddition
    func_378.input[0] = (float) getCmBOD_HeatExch_DistrHtg_parameter_259();
    func_378.input[1] = 3F;
    func_378.Execute(  );
    setParameter(103, func_378.output);

    // [389] Function call CfAddition
    func_389.input[0] = (float) getCmBOD_HeatExch_DistrHtg_parameter_259();
    func_389.input[1] = 3F;
    func_389.Execute(  );
    setParameter(100, func_389.output);

    // [55] Macro call CmSecSupTempControl
    func_55.CmSecSupTempControl_input_1 = (float) getCmBOD_HeatExch_DistrHtg_input_1().getValue();
    func_55.CmSecSupTempControl_input_2 = func_468.output;
    func_55.CmSecSupTempControl_input_72 = func_178.output;
    func_55.CmSecSupTempControl_input_247 = (float) getCmBOD_HeatExch_DistrHtg_input_8().getValue();
    func_55.CmSecSupTempControl_input_268 = getCmBOD_HeatExch_DistrHtg_input_464().getValue();
    func_55.Execute( this, 65 );
    setCmBOD_HeatExch_DistrHtg_output_20(func_55.CmSecSupTempControl_output_71);

    // [67] Function call CfIdt
    func_67.input = func_52.CmPrimary_RWT_Control_output_3;
    func_67.Execute(  );
    setCmBOD_HeatExch_DistrHtg_parameter_50(func_67.output[0]);
    setCmBOD_HeatExch_DistrHtg_output_18(func_67.output[1]);

    // [106] Function call CfInputMultiplexer
    func_106.inputSelect = BooleanToInt(func_108.outputLess);
    func_106.input[1-1] = 2F;
    func_106.input[2-1] = 1F;
    func_106.Execute(  );

    // [60] Macro call CmValveControl
    func_60.CmValveControl_input_1 = func_52.CmPrimary_RWT_Control_output_44;
    func_60.CmValveControl_input_2 = func_58.CmPriSupTempLimitation_output_3;
    func_60.CmValveControl_input_3 = func_55.CmSecSupTempControl_output_3;
    func_60.Execute( this, 90 );

    // [71] Function call CfIdt
    func_71.input = func_55.CmSecSupTempControl_output_18;
    func_71.Execute(  );
    setCmBOD_HeatExch_DistrHtg_parameter_49(func_71.output[0]);
    setCmBOD_HeatExch_DistrHtg_output_17(func_71.output[1]);

    // [212] Function call CfOr
    func_212.input[0] = func_142.output1;
    func_212.input[1] = func_55.CmSecSupTempControl_output_114;
    func_212.Execute(  );

    // [118] Function call CfInputMultiplexer
    func_118.inputSelect = BooleanToInt(func_60.CmValveControl_output_24);
    func_118.input[1-1] = func_106.output;
    func_118.input[2-1] = 3F;
    func_118.Execute(  );

    // [143] Function call CfDelayOnOff
    func_143.input = func_212.outputOR;
    func_143.Execute( this, 95 );

    // [151] Function call CfDelayOnOff
    func_151.input = func_212.outputOR;
    func_151.Execute( this, 97 );

    // [290] Function call CfCompare1
    func_290.inputA = (float) getCmBOD_HeatExch_DistrHtg_output_17().getValue();
    func_290.inputB = 1F;
    func_290.Execute(  );

    // [360] Function call CfOr
    func_360.input[0] = func_60.CmValveControl_output_24;
    func_360.input[1] = func_60.CmValveControl_output_23;
    func_360.Execute(  );

    // [288] Function call CfAnd
    func_288.input[0] = func_289.output2;
    func_288.input[1] = func_290.outputLess;
    func_288.Execute(  );

    // [460] Function call CfIdt
    func_460.input = BooleanToFloat(func_288.outputAND);
    func_460.Execute(  );

    // [116] Function call CfInputMultiplexer
    func_116.inputSelect = BooleanToInt(func_60.CmValveControl_output_23);
    func_116.input[1-1] = func_118.output;
    func_116.input[2-1] = 4F;
    func_116.Execute(  );

    // [453] Function call CfInputMultiplexer
    func_453.inputSelect = FloatToInt(func_462.output[0]);
    func_453.input[1-1] = func_116.output;
    func_453.input[2-1] = 5F;
    func_453.Execute(  );

    // [139] Function call CfInputMultiplexer
    func_139.inputSelect = BooleanToInt(func_82.CmRefillValveContol_output_4);
    func_139.input[1-1] = func_453.output;
    func_139.input[2-1] = 6F;
    func_139.Execute(  );

    // [122] Function call CfInputMultiplexer
    func_122.inputSelect = BooleanToInt(getCmBOD_HeatExch_DistrHtg_input_464().getValue());
    func_122.input[1-1] = func_456.output;
    func_122.input[2-1] = 8F;
    func_122.Execute(  );

    // [484] Function call CfInputMultiplexer
    func_484.inputSelect = BooleanToInt(getCmBOD_HeatExch_DistrHtg_output_20().getValue());
    func_484.input[1-1] = func_122.output;
    func_484.input[2-1] = 9F;
    func_484.Execute(  );

    // [114] Function call CfInputMultiplexer
    func_114.inputSelect = BooleanToInt(getCmBOD_HeatExch_DistrHtg_input_9().getValue());
    func_114.input[1-1] = func_484.output;
    func_114.input[2-1] = 10F;
    func_114.Execute(  );

    // [456] Function call CfInputMultiplexer
    func_456.inputSelect = FloatToInt(func_460.output[0]);
    func_456.input[1-1] = func_139.output;
    func_456.input[2-1] = 7F;
    func_456.Execute(  );

    // [124] Function call CfInputMultiplexer
    func_124.inputSelect = BooleanToInt(getCmBOD_HeatExch_DistrHtg_input_10().getValue());
    func_124.input[1-1] = func_114.output;
    func_124.input[2-1] = 12F;
    func_124.Execute(  );

    // [455] Function call CfInputMultiplexer
    func_455.inputSelect = BooleanToInt(getCmBOD_HeatExch_DistrHtg_input_11().getValue());
    func_455.input[1-1] = func_124.output;
    func_455.input[2-1] = 13F;
    func_455.Execute(  );

    // [140] Function call CfInputMultiplexer
    func_140.inputSelect = BooleanToInt(func_82.CmRefillValveContol_output_32);
    func_140.input[1-1] = func_455.output;
    func_140.input[2-1] = 14F;
    func_140.Execute(  );

    // [127] Function call CfIdt
    func_127.input = func_140.output;
    func_127.Execute(  );
    setCmBOD_HeatExch_DistrHtg_output_21(func_127.output[0]);
    setCmBOD_HeatExch_DistrHtg_parameter_51(func_127.output[1]);

    // [236] Function call CfCompare1
    func_236.inputA = (float) getCmBOD_HeatExch_DistrHtg_output_15().getValue();
    func_236.inputB = func_244.output;
    func_236.Execute(  );

    // [388] Function call CfDelayOnOff
    func_388.input = func_236.outputLess;
    func_388.Execute( this, 99 );

    // [232] Function call CfAnd
    func_232.input[0] = func_388.output;
    func_232.input[1] = func_252.outputGreater;
    func_232.input[2] = func_261.outputGreater;
    func_232.input[3] = func_360.outputOR;
    func_232.Execute(  );

    // [228] Function call CfCycle
    func_228.input = func_232.outputAND;
    func_228.Execute( this, 101 );

    // [376] Function call CfDelayOnOff
    func_376.input = func_232.outputAND;
    func_376.Execute( this, 103 );

    // [339] Function call CfInputMultiplexer
    func_339.inputSelect = BooleanToInt(func_376.output);
    func_339.input[1-1] = 0F;
    func_339.input[2-1] = BooleanToFloat(func_228.output);
    func_339.Execute(  );

    // [404] Function call CfInputMultiplexer
    func_404.inputSelect = FloatToInt(func_339.output);
    func_404.input[1-1] = func_60.CmValveControl_output_4;
    func_404.input[2-1] = (float) getCmBOD_HeatExch_DistrHtg_parameter_44();
    func_404.Execute(  );

    // [462] Function call CfIdt
    func_462.input = func_339.output;
    func_462.Execute(  );

    // [416] Function call CfInputMultiplexer
    func_416.inputSelect = BooleanToInt(func_288.outputAND);
    func_416.input[1-1] = BooleanToFloat(func_151.output);
    func_416.input[2-1] = 1F;
    func_416.Execute(  );

    // [425] Function call CfInputMultiplexer
    func_425.inputSelect = BooleanToInt(func_288.outputAND);
    func_425.input[1-1] = BooleanToFloat(func_143.output);
    func_425.input[2-1] = 1F;
    func_425.Execute(  );

    // [406] Function call CfInputMultiplexer
    func_406.inputSelect = BooleanToInt(getCmBOD_HeatExch_DistrHtg_input_10().getValue());
    func_406.input[1-1] = func_404.output;
    func_406.input[2-1] = 0F;
    func_406.Execute(  );

    // [415] Function call CfInputMultiplexer
    func_415.inputSelect = BooleanToInt(getCmBOD_HeatExch_DistrHtg_input_10().getValue());
    func_415.input[1-1] = func_416.output;
    func_415.input[2-1] = 1F;
    func_415.Execute(  );

    // [426] Function call CfInputMultiplexer
    func_426.inputSelect = BooleanToInt(getCmBOD_HeatExch_DistrHtg_input_10().getValue());
    func_426.input[1-1] = func_425.output;
    func_426.input[2-1] = 0F;
    func_426.Execute(  );

    // [408] Function call CfInputMultiplexer
    func_408.inputSelect = BooleanToInt(getCmBOD_HeatExch_DistrHtg_input_11().getValue());
    func_408.input[1-1] = func_406.output;
    func_408.input[2-1] = 0F;
    func_408.Execute(  );

    // [418] Function call CfInputMultiplexer
    func_418.inputSelect = BooleanToInt(getCmBOD_HeatExch_DistrHtg_input_11().getValue());
    func_418.input[1-1] = func_415.output;
    func_418.input[2-1] = 0F;
    func_418.Execute(  );

    // [427] Function call CfInputMultiplexer
    func_427.inputSelect = BooleanToInt(getCmBOD_HeatExch_DistrHtg_input_11().getValue());
    func_427.input[1-1] = func_426.output;
    func_427.input[2-1] = 0F;
    func_427.Execute(  );

    // [410] Function call CfInputMultiplexer
    func_410.inputSelect = BooleanToInt(func_82.CmRefillValveContol_output_32);
    func_410.input[1-1] = func_408.output;
    func_410.input[2-1] = 0F;
    func_410.Execute(  );
    setCmBOD_HeatExch_DistrHtg_output_15(func_410.output);

    // [417] Function call CfInputMultiplexer
    func_417.inputSelect = BooleanToInt(func_82.CmRefillValveContol_output_32);
    func_417.input[1-1] = func_418.output;
    func_417.input[2-1] = 0F;
    func_417.Execute(  );
    setCmBOD_HeatExch_DistrHtg_output_16(FloatToBoolean(func_417.output));

    // [424] Function call CfInputMultiplexer
    func_424.inputSelect = BooleanToInt(func_82.CmRefillValveContol_output_32);
    func_424.input[1-1] = func_427.output;
    func_424.input[2-1] = 0F;
    func_424.Execute(  );
    setCmBOD_HeatExch_DistrHtg_output_14(FloatToBoolean(func_424.output));

    // [468] Function call CfInputMultiplexer
    func_468.inputSelect = BooleanToInt(getCmBOD_HeatExch_DistrHtg_input_464().getValue());
    func_468.input[1-1] = (float) getCmBOD_HeatExch_DistrHtg_input_2().getValue();
    func_468.input[2-1] = func_466.output;
    func_468.Execute(  );

    // [466] Function call CfMinimum
    func_466.input[0] = (float) getCmBOD_HeatExch_DistrHtg_input_2().getValue();
    func_466.input[1] = (float) getCmBOD_HeatExch_DistrHtg_parameter_465();
    func_466.Execute(  );

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 0F, 0F, 0F, 0F, 0F, 0F, 0F,
    0F, 0F, 20F, -50F, 50F, -10F, 20F, 5F,
    5F, 10F, 20F, 0F, 0F, 20F, -50F, 50F,
    -10F, 20F, 5F, 5F, 10F, 20F, 0F, 0F,
    20F, -50F, 50F, -10F, 20F, 5F, 5F, 10F,
    20F, 0F, 0F, 0F, 0F, 100F, 0F, 100F,
    0F, 0F, 50F, 50F, 50F, 100F, 100F, 0F,
    0F, 0F, 3F, 3F, 30F, 0F, 2F, 5F,
    2F, 0F, 0F, 0F, 0F, 0F, 0F, 0F,
    0F, 0F, 0F, 2F, 0F, 10F, 0F, 10F,
    0F, 0F, 0F, 10F, 10F, 3F, 0F, 1000F,
    100F, 0F, 0F, 0F, 10F, 99999F, 0F, 10F,
    10F, 10F, 10F, 0F, 10F, 20F, 0F, 10F,
    0F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// PriPumpCmd
  public static final Property CmBOD_HeatExch_DistrHtg_output_14 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOD_HeatExch_DistrHtg_output_14() { return (BStatusBoolean) get(CmBOD_HeatExch_DistrHtg_output_14); }
  public void setCmBOD_HeatExch_DistrHtg_output_14(BStatusBoolean v) { set(CmBOD_HeatExch_DistrHtg_output_14,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_output_14(boolean v) { getCmBOD_HeatExch_DistrHtg_output_14().setValue(v); }
// ValveControl
  public static final Property CmBOD_HeatExch_DistrHtg_output_15 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBOD_HeatExch_DistrHtg_output_15() { return (BStatusNumeric) get(CmBOD_HeatExch_DistrHtg_output_15); }
  public void setCmBOD_HeatExch_DistrHtg_output_15(BStatusNumeric v) { set(CmBOD_HeatExch_DistrHtg_output_15,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_output_15(float v) { getCmBOD_HeatExch_DistrHtg_output_15().setValue(v); }
// SecPumpCmd
  public static final Property CmBOD_HeatExch_DistrHtg_output_16 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOD_HeatExch_DistrHtg_output_16() { return (BStatusBoolean) get(CmBOD_HeatExch_DistrHtg_output_16); }
  public void setCmBOD_HeatExch_DistrHtg_output_16(BStatusBoolean v) { set(CmBOD_HeatExch_DistrHtg_output_16,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_output_16(boolean v) { getCmBOD_HeatExch_DistrHtg_output_16().setValue(v); }
// CalcSSTempSp
  public static final Property CmBOD_HeatExch_DistrHtg_output_17 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DistrHtg_output_17() { return (BStatusNumeric) get(CmBOD_HeatExch_DistrHtg_output_17); }
  public void setCmBOD_HeatExch_DistrHtg_output_17(BStatusNumeric v) { set(CmBOD_HeatExch_DistrHtg_output_17,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_output_17(float v) { getCmBOD_HeatExch_DistrHtg_output_17().setValue(v); }
// CalcRWTempSp
  public static final Property CmBOD_HeatExch_DistrHtg_output_18 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DistrHtg_output_18() { return (BStatusNumeric) get(CmBOD_HeatExch_DistrHtg_output_18); }
  public void setCmBOD_HeatExch_DistrHtg_output_18(BStatusNumeric v) { set(CmBOD_HeatExch_DistrHtg_output_18,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_output_18(float v) { getCmBOD_HeatExch_DistrHtg_output_18().setValue(v); }
// RefillValveCmd
  public static final Property CmBOD_HeatExch_DistrHtg_output_19 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOD_HeatExch_DistrHtg_output_19() { return (BStatusBoolean) get(CmBOD_HeatExch_DistrHtg_output_19); }
  public void setCmBOD_HeatExch_DistrHtg_output_19(BStatusBoolean v) { set(CmBOD_HeatExch_DistrHtg_output_19,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_output_19(boolean v) { getCmBOD_HeatExch_DistrHtg_output_19().setValue(v); }
// HE-Failure
  public static final Property CmBOD_HeatExch_DistrHtg_output_20 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBOD_HeatExch_DistrHtg_output_20() { return (BStatusBoolean) get(CmBOD_HeatExch_DistrHtg_output_20); }
  public void setCmBOD_HeatExch_DistrHtg_output_20(BStatusBoolean v) { set(CmBOD_HeatExch_DistrHtg_output_20,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_output_20(boolean v) { getCmBOD_HeatExch_DistrHtg_output_20().setValue(v); }
// OperationMode
  public static final Property CmBOD_HeatExch_DistrHtg_output_21 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBOD_HeatExch_DistrHtg_output_21() { return (BStatusNumeric) get(CmBOD_HeatExch_DistrHtg_output_21); }
  public void setCmBOD_HeatExch_DistrHtg_output_21(BStatusNumeric v) { set(CmBOD_HeatExch_DistrHtg_output_21,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_output_21(float v) { getCmBOD_HeatExch_DistrHtg_output_21().setValue(v); }

  // macro parameter
// SST-01: maximum supply temperature
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_22 = newProperty( 0, BDouble.make( 90 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(50)), BFacets.make(BFacets.MAX, BDouble.make(200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_22() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_22); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_22(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_22,v,null); }
// SST-02: minimum supply temperature
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_23 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(90)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_23() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_23); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_23(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_23,v,null); }
// SST-04: setpoint raise to compensate losses
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_24 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_24() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_24); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_24(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_24,v,null); }
// SST-05: maximum setpoint raise per minute
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_25 = newProperty( 0, BDouble.make( 25 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_25() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_25); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_25(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_25,v,null); }
// SST-06: P-band SST control
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_26 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_26() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_26); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_26(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_26,v,null); }
// SST-07: I-time system supply temperature control
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_27 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_27() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_27); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_27(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_27,v,null); }
// SST-08: D-time system supply temperature control
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_28 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_28() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_28); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_28(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_28,v,null); }
// PST-01: P-band primary supply temperature contol
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_29 = newProperty( 0, BDouble.make( 15 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_29() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_29); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_29(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_29,v,null); }
// RWT-01: return water setpoint raise during legionella
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_30 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_30() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_30); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_30(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_30,v,null); }
// RWT-02: P-band return temperature control
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_31 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_31() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_31); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_31(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_31,v,null); }
// RWT-03: return water setpoint raise at high DST or low OAT
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_32 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_32() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_32); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_32(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_32,v,null); }
// RWT-04: return water control configuration
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_33 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmBOD_HeatExch_DistrHtg_parameter_33() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_33); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_33(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_33,v,null); }
// DST-01: minimum district supply temperature
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_34 = newProperty( 0, BDouble.make( 75 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_34() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_34); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_34(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_34,v,null); }
// DST-02: maximum district supply temperature
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_35 = newProperty( 0, BDouble.make( 115 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_35() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_35); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_35(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_35,v,null); }
// DST-03: minimum district supply temperature at pump alarm
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_465 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_465() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_465); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_465(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_465,v,null); }
// OAT-01: low limit frost protrction
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_36 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_36() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_36); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_36(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_36,v,null); }
// OAT-02: minimum outside air temperature
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_37 = newProperty( 0, BDouble.make( -10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_37() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_37); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_37(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_37,v,null); }
// OAT-03: maximum outside air temperature
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_38 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_38() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_38); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_38(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_38,v,null); }
// PRP-01: primary pump start-up delay
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_39 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_39() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_39); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_39(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_39,v,null); }
// PRP-02: primary pump switch off delay
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_40 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_40() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_40); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_40(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_40,v,null); }
// SEP-01: secondary pump start-up delay
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_41 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(800)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_41() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_41); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_41(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_41,v,null); }
// SEP-02: secondary pump switch off delay
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_42 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_42() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_42); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_42(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_42,v,null); }
// VLV-01: valve postion limit
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_43 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_43() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_43); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_43(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_43,v,null); }
// VLV-02: minimum valve position
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_44 = newProperty( 0, BDouble.make( 40 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_44() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_44); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_44(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_44,v,null); }
// VLV-03: maximum valve position raise per minute
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_45 = newProperty( 0, BDouble.make( 70 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_45() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_45); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_45(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_45,v,null); }
// VLV-04: valve open time at closed during limitation control
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_259 = newProperty( 0, BDouble.make( 180 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_259() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_259); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_259(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_259,v,null); }
// REF-01: maximum refill valve runtime
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_46 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_46() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_46); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_46(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_46,v,null); }
// SYS-02: HE_Failure enable after release
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_47 = newProperty( 0, BDouble.make( 1800 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_47() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_47); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_47(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_47,v,null); }
// SYS-03: automatic/ manual reset; 0 = auto
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_48 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOD_HeatExch_DistrHtg_parameter_48() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_48); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_48(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_48,v,null); }
// DISP-01: calculated temperature setpoint
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_49 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_49() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_49); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_49(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_49,v,null); }
// DISP-02: calculated return temperature setpoint
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_50 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBOD_HeatExch_DistrHtg_parameter_50() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_50); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_50(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_50,v,null); }
// DISP-03: operating mode
  public static final Property CmBOD_HeatExch_DistrHtg_parameter_51 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmBOD_HeatExch_DistrHtg_parameter_51() { return getDouble(CmBOD_HeatExch_DistrHtg_parameter_51); }
  public void setCmBOD_HeatExch_DistrHtg_parameter_51(double v) { setDouble(CmBOD_HeatExch_DistrHtg_parameter_51,v,null); }

  // macro inputs
// SecSupTemp
  public static final Property CmBOD_HeatExch_DistrHtg_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DistrHtg_input_1() { return (BStatusNumeric) get(CmBOD_HeatExch_DistrHtg_input_1); }
  public void setCmBOD_HeatExch_DistrHtg_input_1(BStatusNumeric v) { set(CmBOD_HeatExch_DistrHtg_input_1,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_input_1(float v) { getCmBOD_HeatExch_DistrHtg_input_1().setValue(v); }
// HeatDemand
  public static final Property CmBOD_HeatExch_DistrHtg_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DistrHtg_input_2() { return (BStatusNumeric) get(CmBOD_HeatExch_DistrHtg_input_2); }
  public void setCmBOD_HeatExch_DistrHtg_input_2(BStatusNumeric v) { set(CmBOD_HeatExch_DistrHtg_input_2,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_input_2(float v) { getCmBOD_HeatExch_DistrHtg_input_2().setValue(v); }
// PriSupTemp
  public static final Property CmBOD_HeatExch_DistrHtg_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DistrHtg_input_3() { return (BStatusNumeric) get(CmBOD_HeatExch_DistrHtg_input_3); }
  public void setCmBOD_HeatExch_DistrHtg_input_3(BStatusNumeric v) { set(CmBOD_HeatExch_DistrHtg_input_3,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_input_3(float v) { getCmBOD_HeatExch_DistrHtg_input_3().setValue(v); }
// PriSupTempSp
  public static final Property CmBOD_HeatExch_DistrHtg_input_4 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DistrHtg_input_4() { return (BStatusNumeric) get(CmBOD_HeatExch_DistrHtg_input_4); }
  public void setCmBOD_HeatExch_DistrHtg_input_4(BStatusNumeric v) { set(CmBOD_HeatExch_DistrHtg_input_4,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_input_4(float v) { getCmBOD_HeatExch_DistrHtg_input_4().setValue(v); }
// PriRetTemp
  public static final Property CmBOD_HeatExch_DistrHtg_input_5 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DistrHtg_input_5() { return (BStatusNumeric) get(CmBOD_HeatExch_DistrHtg_input_5); }
  public void setCmBOD_HeatExch_DistrHtg_input_5(BStatusNumeric v) { set(CmBOD_HeatExch_DistrHtg_input_5,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_input_5(float v) { getCmBOD_HeatExch_DistrHtg_input_5().setValue(v); }
// PriRetTempSp
  public static final Property CmBOD_HeatExch_DistrHtg_input_6 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DistrHtg_input_6() { return (BStatusNumeric) get(CmBOD_HeatExch_DistrHtg_input_6); }
  public void setCmBOD_HeatExch_DistrHtg_input_6(BStatusNumeric v) { set(CmBOD_HeatExch_DistrHtg_input_6,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_input_6(float v) { getCmBOD_HeatExch_DistrHtg_input_6().setValue(v); }
// DistrHtgSupTemp
  public static final Property CmBOD_HeatExch_DistrHtg_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DistrHtg_input_7() { return (BStatusNumeric) get(CmBOD_HeatExch_DistrHtg_input_7); }
  public void setCmBOD_HeatExch_DistrHtg_input_7(BStatusNumeric v) { set(CmBOD_HeatExch_DistrHtg_input_7,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_input_7(float v) { getCmBOD_HeatExch_DistrHtg_input_7().setValue(v); }
// FilteredOATemp
  public static final Property CmBOD_HeatExch_DistrHtg_input_8 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmBOD_HeatExch_DistrHtg_input_8() { return (BStatusNumeric) get(CmBOD_HeatExch_DistrHtg_input_8); }
  public void setCmBOD_HeatExch_DistrHtg_input_8(BStatusNumeric v) { set(CmBOD_HeatExch_DistrHtg_input_8,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_input_8(float v) { getCmBOD_HeatExch_DistrHtg_input_8().setValue(v); }
// LegionellaActive
  public static final Property CmBOD_HeatExch_DistrHtg_input_9 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOD_HeatExch_DistrHtg_input_9() { return (BStatusBoolean) get(CmBOD_HeatExch_DistrHtg_input_9); }
  public void setCmBOD_HeatExch_DistrHtg_input_9(BStatusBoolean v) { set(CmBOD_HeatExch_DistrHtg_input_9,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_input_9(boolean v) { getCmBOD_HeatExch_DistrHtg_input_9().setValue(v); }
// MaxThermostat
  public static final Property CmBOD_HeatExch_DistrHtg_input_10 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOD_HeatExch_DistrHtg_input_10() { return (BStatusBoolean) get(CmBOD_HeatExch_DistrHtg_input_10); }
  public void setCmBOD_HeatExch_DistrHtg_input_10(BStatusBoolean v) { set(CmBOD_HeatExch_DistrHtg_input_10,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_input_10(boolean v) { getCmBOD_HeatExch_DistrHtg_input_10().setValue(v); }
// SafetyTherm
  public static final Property CmBOD_HeatExch_DistrHtg_input_11 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOD_HeatExch_DistrHtg_input_11() { return (BStatusBoolean) get(CmBOD_HeatExch_DistrHtg_input_11); }
  public void setCmBOD_HeatExch_DistrHtg_input_11(BStatusBoolean v) { set(CmBOD_HeatExch_DistrHtg_input_11,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_input_11(boolean v) { getCmBOD_HeatExch_DistrHtg_input_11().setValue(v); }
// SecPmpStatAlm
  public static final Property CmBOD_HeatExch_DistrHtg_input_464 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOD_HeatExch_DistrHtg_input_464() { return (BStatusBoolean) get(CmBOD_HeatExch_DistrHtg_input_464); }
  public void setCmBOD_HeatExch_DistrHtg_input_464(BStatusBoolean v) { set(CmBOD_HeatExch_DistrHtg_input_464,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_input_464(boolean v) { getCmBOD_HeatExch_DistrHtg_input_464().setValue(v); }
// SecMinPressSw
  public static final Property CmBOD_HeatExch_DistrHtg_input_12 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOD_HeatExch_DistrHtg_input_12() { return (BStatusBoolean) get(CmBOD_HeatExch_DistrHtg_input_12); }
  public void setCmBOD_HeatExch_DistrHtg_input_12(BStatusBoolean v) { set(CmBOD_HeatExch_DistrHtg_input_12,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_input_12(boolean v) { getCmBOD_HeatExch_DistrHtg_input_12().setValue(v); }
// Reset
  public static final Property CmBOD_HeatExch_DistrHtg_input_13 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBOD_HeatExch_DistrHtg_input_13() { return (BStatusBoolean) get(CmBOD_HeatExch_DistrHtg_input_13); }
  public void setCmBOD_HeatExch_DistrHtg_input_13(BStatusBoolean v) { set(CmBOD_HeatExch_DistrHtg_input_13,v,null); }
  public void setCmBOD_HeatExch_DistrHtg_input_13(boolean v) { getCmBOD_HeatExch_DistrHtg_input_13().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.04 [116] 06.05.2019-11:12").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5986849731335160427").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmBOD_HeatExch_DistrHtg.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmPrimary_RWT_Control func_52 = new CmPrimary_RWT_Control();
  protected CmPriSupTempLimitation func_58 = new CmPriSupTempLimitation();
  protected CmRefillValveContol func_82 = new CmRefillValveContol();
  protected CfCompare1 func_108 = new CfCompare1();
  protected CfHysteresis func_142 = new CfHysteresis();
  protected CmIDT05 func_144 = new CmIDT05();
  protected CfMonoflop func_178 = new CfMonoflop();
  protected CmIDT20 func_180 = new CmIDT20();
  protected CmIDT05 func_201 = new CmIDT05();
  protected CfAddition func_244 = new CfAddition();
  protected CfIdt func_245 = new CfIdt();
  protected CfCompare1 func_252 = new CfCompare1();
  protected CfCompare1 func_261 = new CfCompare1();
  protected CfHysteresis func_289 = new CfHysteresis();
  protected CfIdt func_338 = new CfIdt();
  protected CfAddition func_378 = new CfAddition();
  protected CfAddition func_389 = new CfAddition();
  protected CmSecSupTempControl func_55 = new CmSecSupTempControl();
  protected CfIdt func_67 = new CfIdt();
  protected CfInputMultiplexer func_106 = new CfInputMultiplexer();
  protected CmValveControl func_60 = new CmValveControl();
  protected CfIdt func_71 = new CfIdt();
  protected CfOr func_212 = new CfOr();
  protected CfInputMultiplexer func_118 = new CfInputMultiplexer();
  protected CfDelayOnOff func_143 = new CfDelayOnOff();
  protected CfDelayOnOff func_151 = new CfDelayOnOff();
  protected CfCompare1 func_290 = new CfCompare1();
  protected CfOr func_360 = new CfOr();
  protected CfAnd func_288 = new CfAnd();
  protected CfIdt func_460 = new CfIdt();
  protected CfInputMultiplexer func_116 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_453 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_139 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_122 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_484 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_114 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_456 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_124 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_455 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_140 = new CfInputMultiplexer();
  protected CfIdt func_127 = new CfIdt();
  protected CfCompare1 func_236 = new CfCompare1();
  protected CfDelayOnOff func_388 = new CfDelayOnOff();
  protected CfAnd func_232 = new CfAnd();
  protected CfCycle func_228 = new CfCycle();
  protected CfDelayOnOff func_376 = new CfDelayOnOff();
  protected CfInputMultiplexer func_339 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_404 = new CfInputMultiplexer();
  protected CfIdt func_462 = new CfIdt();
  protected CfInputMultiplexer func_416 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_425 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_406 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_415 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_426 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_408 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_418 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_427 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_410 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_417 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_424 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_468 = new CfInputMultiplexer();
  protected CfMinimum func_466 = new CfMinimum();

  // default constructor
  public BCmBOD_HeatExch_DistrHtg()
  {
    func_67.configure(2);
    func_71.configure(2);
    func_127.configure(2);
    func_232.configure(4);
  }

  public void Start()
  {
    func_52.Start();
    func_58.Start();
    func_82.Start();
    func_142.Start();
    func_144.Start();
    func_178.Start();
    func_180.Start();
    func_201.Start();
    func_289.Start();
    func_55.Start();
    func_60.Start();
    func_143.Start();
    func_151.Start();
    func_388.Start();
    func_228.Start();
    func_376.Start();
  }
}
