/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    BUF_HeatBuffer
Macro id:      6124510279070908769
Macro version: 93
Last change:   17.11.2015 - 07:54
Access Level:  2
Inputs:
  [1] HeadDemandIn
  [2] BufUpperTemp
  [3] BufMid1Temp
  [4] BufMid2Temp
  [5] BufMid3Temp
  [6] BufLowerTemp
  [7] BufLoadLevel
  [8] ExtLoading
  [9] FilteredOATemp
Outputs:
  [1] HeatDemandOut
  [2] Buf_SpShift
  [3] EffLowerTemp
  [4] ChargPumpEn
  [5] ChgOverValve
  [6] BypassValve1
  [7] BypassValve2
  [8] BypassValve3
  [9] BypassValve4
  [10] BufOverheatAlm
  [11] StopHighOATemp
  [12] OperationMode
Parameter:
  [1] CFG-01: charging/ discharging control 1= charging 2= discharging
  [2] CHG-01: switch to buffer hysteresis
  [3] CHG-02: start boiler(s) hysteresis
  [4] DCHG-01: switch to buffer hysteresis
  [5] DCHG-02: switch to boiler(s) hysteresis
  [6] OVHT-01: maximum buffer upper temperature
  [7] OVHT-02: maximum buffer lower temperature
  [8] OVHT-03: alarm delay for maximum alarm (0= off)
  [9] OVHT-04: switching differential buffer alarm
  [10] OAT-01: stop buffer loading high OAT limit
  [11] SOL-01: heat demand decrease during un-controlled loading
  [12] SOL-02: switch off delay heat demand decrease after external loading
Description:
Depending on the value of the parameter CFG-01, the buffer control mode will be caharging or discharging control.

Charging control means that the buffer will be charged by the controlled heat generators as soon as it cannot provide the temperature requested by the heat consumers. In this configuration the buffer can be loaded to a certain level, depending on the number of connected sensors. The buffer lower sensor “BufLowerTemp” is mandatory for this configuration. For a staged loading you can configure up to three middle sensors and connect up to four bypass valves – see section Buffer Charging Control.

Discharging control means, that the buffer will not be charged by the controlled heat generators. It will be charged only by uncontrolled heat sources like solar panels, heat pumps, solid fuel boilers, combined heat and power plants (CHPs)… In this case the buffer will be always loaded up to the maximum upper temperature limit. The buffer lower sensor “BufLowerTemp” is optional in this case.

================================================================================*/

public class BCmBUF_HeatBuffer
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmBUF_HeatBuffer_output_60().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmBUF_HeatBuffer_output_60().setStatus(BStatus.disabled);
    getCmBUF_HeatBuffer_output_32().setStatus(BStatus.disabled);
    getCmBUF_HeatBuffer_output_23().setStatus(BStatus.disabled);
    getCmBUF_HeatBuffer_output_220().setStatus(BStatus.disabled);
    getCmBUF_HeatBuffer_output_24().setStatus(BStatus.disabled);
    getCmBUF_HeatBuffer_output_25().setStatus(BStatus.disabled);
    getCmBUF_HeatBuffer_output_26().setStatus(BStatus.disabled);
    getCmBUF_HeatBuffer_output_27().setStatus(BStatus.disabled);
    getCmBUF_HeatBuffer_output_28().setStatus(BStatus.disabled);
    getCmBUF_HeatBuffer_output_29().setStatus(BStatus.disabled);
    getCmBUF_HeatBuffer_output_30().setStatus(BStatus.disabled);
    getCmBUF_HeatBuffer_output_31().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmBUF_HeatBuffer_output_60().setStatus(BStatus.ok);
    getCmBUF_HeatBuffer_output_32().setStatus(BStatus.ok);
    getCmBUF_HeatBuffer_output_23().setStatus(BStatus.ok);
    getCmBUF_HeatBuffer_output_220().setStatus(BStatus.ok);
    getCmBUF_HeatBuffer_output_24().setStatus(BStatus.ok);
    getCmBUF_HeatBuffer_output_25().setStatus(BStatus.ok);
    getCmBUF_HeatBuffer_output_26().setStatus(BStatus.ok);
    getCmBUF_HeatBuffer_output_27().setStatus(BStatus.ok);
    getCmBUF_HeatBuffer_output_28().setStatus(BStatus.ok);
    getCmBUF_HeatBuffer_output_29().setStatus(BStatus.ok);
    getCmBUF_HeatBuffer_output_30().setStatus(BStatus.ok);
    getCmBUF_HeatBuffer_output_31().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [36] Function call CfTruncate
    func_36.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_36.Execute(  );

    // [70] Function call CfWindow
    func_70.inputValue = (float) getCmBUF_HeatBuffer_parameter_12();
    func_70.inputMinimum = 0.8F;
    func_70.inputMaximum = 1.2F;
    func_70.Execute(  );

    // [78] Function call CfWindow
    func_78.inputValue = (float) getCmBUF_HeatBuffer_parameter_12();
    func_78.inputMinimum = 1.8F;
    func_78.inputMaximum = 2.2F;
    func_78.Execute(  );

    // [103] Macro call CmIDT20
    func_103.CmIDT20_input_1 = (float) getCmBUF_HeatBuffer_parameter_21();
    func_103.CmIDT20_input_2 = (float) getCmBUF_HeatBuffer_parameter_17();
    func_103.CmIDT20_input_3 = (float) getCmBUF_HeatBuffer_parameter_18();
    func_103.CmIDT20_input_4 = (float) getCmBUF_HeatBuffer_parameter_19();
    func_103.CmIDT20_input_5 = (float) getCmBUF_HeatBuffer_parameter_20();
    func_103.CmIDT20_input_6 = (float) getCmBUF_HeatBuffer_parameter_15();
    func_103.CmIDT20_input_7 = (float) getCmBUF_HeatBuffer_parameter_16();
    func_103.CmIDT20_input_8 = (float) getCmBUF_HeatBuffer_parameter_12();
    func_103.CmIDT20_input_9 = (float) getCmBUF_HeatBuffer_parameter_13();
    func_103.CmIDT20_input_10 = (float) getCmBUF_HeatBuffer_parameter_14();
    func_103.CmIDT20_input_11 = (float) getCmBUF_HeatBuffer_parameter_15();
    func_103.CmIDT20_input_12 = (float) getCmBUF_HeatBuffer_parameter_16();
    func_103.CmIDT20_input_13 = (float) getCmBUF_HeatBuffer_parameter_22();
    func_103.CmIDT20_input_14 = (float) getCmBUF_HeatBuffer_parameter_165();
    func_103.CmIDT20_input_15 = 0F;
    func_103.CmIDT20_input_16 = 0F;
    func_103.CmIDT20_input_17 = 0F;
    func_103.CmIDT20_input_18 = 0F;
    func_103.CmIDT20_input_19 = 0F;
    func_103.CmIDT20_input_20 = 0F;
    func_103.Execute(  );
    setParameter(0, func_103.CmIDT20_output_21);
    setParameter(1, func_103.CmIDT20_output_22);
    setParameter(2, func_103.CmIDT20_output_23);
    setParameter(3, func_103.CmIDT20_output_24);
    setParameter(4, func_103.CmIDT20_output_25);
    setParameter(9, func_103.CmIDT20_output_26);
    setParameter(10, func_103.CmIDT20_output_27);
    setParameter(13, func_103.CmIDT20_output_28);
    setParameter(14, func_103.CmIDT20_output_29);
    setParameter(15, func_103.CmIDT20_output_30);
    setParameter(16, func_103.CmIDT20_output_31);
    setParameter(17, func_103.CmIDT20_output_32);
    setParameter(18, func_103.CmIDT20_output_33);
    setParameter(19, func_103.CmIDT20_output_34);

    // [64] Macro call CmBypassValve
    func_64.CmBypassValve_input_1 = func_58.CmEffLowerTemp_output_341;
    func_64.CmBypassValve_input_27 = (float) getCmBUF_HeatBuffer_input_10().getValue();
    func_64.CmBypassValve_input_54 = (float) getCmBUF_HeatBuffer_input_3().getValue();
    func_64.CmBypassValve_input_157 = (float) getCmBUF_HeatBuffer_output_23().getValue();
    func_64.CmBypassValve_input_122 = func_70.output;
    func_64.CmBypassValve_input_119 = getCmBUF_HeatBuffer_input_9().getValue();
    func_64.CmBypassValve_input_120 = func_74.CmBufHeatDemand_output_108;
    func_64.CmBypassValve_input_121 = func_74.CmBufHeatDemand_output_126;
    func_64.CmBypassValve_input_155 = func_78.output;
    func_64.Execute( this, 0 );
    setCmBUF_HeatBuffer_output_25(func_64.CmBypassValve_output_2);
    setCmBUF_HeatBuffer_output_26(func_64.CmBypassValve_output_3);
    setCmBUF_HeatBuffer_output_27(func_64.CmBypassValve_output_4);
    setCmBUF_HeatBuffer_output_28(func_64.CmBypassValve_output_5);
    setCmBUF_HeatBuffer_output_30(func_64.CmBypassValve_output_29);
    setCmBUF_HeatBuffer_output_29(func_64.CmBypassValve_output_60);

    // [76] Macro call CmBufDischargingControl
    func_76.CmBufDischargingControl_input_4 = (float) getCmBUF_HeatBuffer_input_3().getValue();
    func_76.CmBufDischargingControl_input_23 = (float) getCmBUF_HeatBuffer_output_23().getValue();
    func_76.CmBufDischargingControl_input_5 = (float) getCmBUF_HeatBuffer_input_1().getValue();
    func_76.CmBufDischargingControl_input_45 = func_74.CmBufHeatDemand_output_108;
    func_76.CmBufDischargingControl_input_46 = func_74.CmBufHeatDemand_output_126;
    func_76.CmBufDischargingControl_input_62 = func_70.output;
    func_76.CmBufDischargingControl_input_55 = func_78.output;
    func_76.Execute( this, 9 );
    setCmBUF_HeatBuffer_output_24(func_76.CmBufDischargingControl_output_1);

    // [58] Macro call CmEffLowerTemp
    func_58.CmEffLowerTemp_input_7 = (float) getCmBUF_HeatBuffer_input_8().getValue();
    func_58.CmEffLowerTemp_input_1 = (float) getCmBUF_HeatBuffer_input_7().getValue();
    func_58.CmEffLowerTemp_input_2 = (float) getCmBUF_HeatBuffer_input_4().getValue();
    func_58.CmEffLowerTemp_input_3 = (float) getCmBUF_HeatBuffer_input_5().getValue();
    func_58.CmEffLowerTemp_input_4 = (float) getCmBUF_HeatBuffer_input_6().getValue();
    func_58.CmEffLowerTemp_input_347 = (float) getCmBUF_HeatBuffer_input_3().getValue();
    func_58.Execute(  );
    setCmBUF_HeatBuffer_output_23(func_58.CmEffLowerTemp_output_5);

    // [74] Macro call CmBufHeatDemand
    func_74.CmBufHeatDemand_input_1 = (float) getCmBUF_HeatBuffer_input_1().getValue();
    func_74.CmBufHeatDemand_input_8 = (float) getCmBUF_HeatBuffer_output_23().getValue();
    func_74.CmBufHeatDemand_input_9 = (float) getCmBUF_HeatBuffer_input_3().getValue();
    func_74.CmBufHeatDemand_input_48 = getCmBUF_HeatBuffer_input_9().getValue();
    func_74.CmBufHeatDemand_input_101 = (float) getCmBUF_HeatBuffer_output_31().getValue();
    func_74.Execute( this, 13 );
    setCmBUF_HeatBuffer_output_60(func_74.CmBufHeatDemand_output_2);
    setCmBUF_HeatBuffer_output_32(func_74.CmBufHeatDemand_output_62);

    // [93] Function call CfWindow
    func_93.inputValue = BooleanToFloat(getCmBUF_HeatBuffer_output_24().getValue());
    func_93.inputMinimum = 0.8F;
    func_93.inputMaximum = 1.2F;
    func_93.Execute(  );

    // [95] Function call CfInputMultiplexer
    func_95.inputSelect = BooleanToInt(func_93.output);
    func_95.input[1-1] = 1F;
    func_95.input[2-1] = 2F;
    func_95.Execute(  );

    // [240] Function call CfCompare2
    func_240.inputA = (float) getCmBUF_HeatBuffer_output_60().getValue();
    func_240.inputB = 1F;
    func_240.Execute(  );

    // [151] Function call CfInputMultiplexer
    func_151.inputSelect = BooleanToInt(func_240.outputEqualOrGreater);
    func_151.input[1-1] = 4F;
    func_151.input[2-1] = 3F;
    func_151.Execute(  );

    // [148] Function call CfInputMultiplexer
    func_148.inputSelect = FloatToInt((float) getCmBUF_HeatBuffer_parameter_12());
    func_148.input[1-1] = 0F;
    func_148.input[2-1] = func_151.output;
    func_148.input[3-1] = func_95.output;
    func_148.Execute(  );

    // [150] Function call CfInputMultiplexer
    func_150.inputSelect = BooleanToInt(getCmBUF_HeatBuffer_output_30().getValue());
    func_150.input[1-1] = func_148.output;
    func_150.input[2-1] = 5F;
    func_150.Execute(  );

    // [149] Function call CfInputMultiplexer
    func_149.inputSelect = BooleanToInt(func_64.CmBypassValve_output_115);
    func_149.input[1-1] = func_150.output;
    func_149.input[2-1] = 6F;
    func_149.Execute(  );
    setCmBUF_HeatBuffer_output_31(func_149.output);

    // [321] Function call CfWindow
    func_321.inputValue = (float) getCmBUF_HeatBuffer_output_31().getValue();
    func_321.inputMinimum = 1.8F;
    func_321.inputMaximum = 3.2F;
    func_321.Execute(  );

    // [322] Function call CfWindow
    func_322.inputValue = (float) getCmBUF_HeatBuffer_output_31().getValue();
    func_322.inputMinimum = 4.8F;
    func_322.inputMaximum = 6.2F;
    func_322.Execute(  );

    // [320] Function call CfOr
    func_320.input[0] = func_321.output;
    func_320.input[1] = getCmBUF_HeatBuffer_input_9().getValue();
    func_320.Execute(  );

    // [323] Function call CfInputMultiplexer
    func_323.inputSelect = BooleanToInt(func_322.output);
    func_323.input[1-1] = BooleanToFloat(func_320.outputOR);
    func_323.input[2-1] = 0F;
    func_323.Execute(  );
    setCmBUF_HeatBuffer_output_220(FloatToBoolean(func_323.output));

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 0F, 0F, 0F, 0F, 0F, 0F, 10F,
    0F, 0F, 0F, 0F, 2F, 0F, 0F, 0F,
    0F, 0F, 0F, 0F, 0F, 900F, 0F, 2F,
    0F, 2F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// HeatDemandOut
  public static final Property CmBUF_HeatBuffer_output_60 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBUF_HeatBuffer_output_60() { return (BStatusNumeric) get(CmBUF_HeatBuffer_output_60); }
  public void setCmBUF_HeatBuffer_output_60(BStatusNumeric v) { set(CmBUF_HeatBuffer_output_60,v,null); }
  public void setCmBUF_HeatBuffer_output_60(float v) { getCmBUF_HeatBuffer_output_60().setValue(v); }
// Buf_SpShift
  public static final Property CmBUF_HeatBuffer_output_32 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBUF_HeatBuffer_output_32() { return (BStatusNumeric) get(CmBUF_HeatBuffer_output_32); }
  public void setCmBUF_HeatBuffer_output_32(BStatusNumeric v) { set(CmBUF_HeatBuffer_output_32,v,null); }
  public void setCmBUF_HeatBuffer_output_32(float v) { getCmBUF_HeatBuffer_output_32().setValue(v); }
// EffLowerTemp
  public static final Property CmBUF_HeatBuffer_output_23 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBUF_HeatBuffer_output_23() { return (BStatusNumeric) get(CmBUF_HeatBuffer_output_23); }
  public void setCmBUF_HeatBuffer_output_23(BStatusNumeric v) { set(CmBUF_HeatBuffer_output_23,v,null); }
  public void setCmBUF_HeatBuffer_output_23(float v) { getCmBUF_HeatBuffer_output_23().setValue(v); }
// ChargPumpEn
  public static final Property CmBUF_HeatBuffer_output_220 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_HeatBuffer_output_220() { return (BStatusBoolean) get(CmBUF_HeatBuffer_output_220); }
  public void setCmBUF_HeatBuffer_output_220(BStatusBoolean v) { set(CmBUF_HeatBuffer_output_220,v,null); }
  public void setCmBUF_HeatBuffer_output_220(boolean v) { getCmBUF_HeatBuffer_output_220().setValue(v); }
// ChgOverValve
  public static final Property CmBUF_HeatBuffer_output_24 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_HeatBuffer_output_24() { return (BStatusBoolean) get(CmBUF_HeatBuffer_output_24); }
  public void setCmBUF_HeatBuffer_output_24(BStatusBoolean v) { set(CmBUF_HeatBuffer_output_24,v,null); }
  public void setCmBUF_HeatBuffer_output_24(boolean v) { getCmBUF_HeatBuffer_output_24().setValue(v); }
// BypassValve1
  public static final Property CmBUF_HeatBuffer_output_25 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_HeatBuffer_output_25() { return (BStatusBoolean) get(CmBUF_HeatBuffer_output_25); }
  public void setCmBUF_HeatBuffer_output_25(BStatusBoolean v) { set(CmBUF_HeatBuffer_output_25,v,null); }
  public void setCmBUF_HeatBuffer_output_25(boolean v) { getCmBUF_HeatBuffer_output_25().setValue(v); }
// BypassValve2
  public static final Property CmBUF_HeatBuffer_output_26 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_HeatBuffer_output_26() { return (BStatusBoolean) get(CmBUF_HeatBuffer_output_26); }
  public void setCmBUF_HeatBuffer_output_26(BStatusBoolean v) { set(CmBUF_HeatBuffer_output_26,v,null); }
  public void setCmBUF_HeatBuffer_output_26(boolean v) { getCmBUF_HeatBuffer_output_26().setValue(v); }
// BypassValve3
  public static final Property CmBUF_HeatBuffer_output_27 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_HeatBuffer_output_27() { return (BStatusBoolean) get(CmBUF_HeatBuffer_output_27); }
  public void setCmBUF_HeatBuffer_output_27(BStatusBoolean v) { set(CmBUF_HeatBuffer_output_27,v,null); }
  public void setCmBUF_HeatBuffer_output_27(boolean v) { getCmBUF_HeatBuffer_output_27().setValue(v); }
// BypassValve4
  public static final Property CmBUF_HeatBuffer_output_28 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_HeatBuffer_output_28() { return (BStatusBoolean) get(CmBUF_HeatBuffer_output_28); }
  public void setCmBUF_HeatBuffer_output_28(BStatusBoolean v) { set(CmBUF_HeatBuffer_output_28,v,null); }
  public void setCmBUF_HeatBuffer_output_28(boolean v) { getCmBUF_HeatBuffer_output_28().setValue(v); }
// BufOverheatAlm
  public static final Property CmBUF_HeatBuffer_output_29 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_HeatBuffer_output_29() { return (BStatusBoolean) get(CmBUF_HeatBuffer_output_29); }
  public void setCmBUF_HeatBuffer_output_29(BStatusBoolean v) { set(CmBUF_HeatBuffer_output_29,v,null); }
  public void setCmBUF_HeatBuffer_output_29(boolean v) { getCmBUF_HeatBuffer_output_29().setValue(v); }
// StopHighOATemp
  public static final Property CmBUF_HeatBuffer_output_30 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_HeatBuffer_output_30() { return (BStatusBoolean) get(CmBUF_HeatBuffer_output_30); }
  public void setCmBUF_HeatBuffer_output_30(BStatusBoolean v) { set(CmBUF_HeatBuffer_output_30,v,null); }
  public void setCmBUF_HeatBuffer_output_30(boolean v) { getCmBUF_HeatBuffer_output_30().setValue(v); }
// OperationMode
  public static final Property CmBUF_HeatBuffer_output_31 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBUF_HeatBuffer_output_31() { return (BStatusNumeric) get(CmBUF_HeatBuffer_output_31); }
  public void setCmBUF_HeatBuffer_output_31(BStatusNumeric v) { set(CmBUF_HeatBuffer_output_31,v,null); }
  public void setCmBUF_HeatBuffer_output_31(float v) { getCmBUF_HeatBuffer_output_31().setValue(v); }

  // macro parameter
// CFG-01: charging/ discharging control 1= charging 2= discharging
  public static final Property CmBUF_HeatBuffer_parameter_12 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmBUF_HeatBuffer_parameter_12() { return getDouble(CmBUF_HeatBuffer_parameter_12); }
  public void setCmBUF_HeatBuffer_parameter_12(double v) { setDouble(CmBUF_HeatBuffer_parameter_12,v,null); }
// CHG-01: switch to buffer hysteresis
  public static final Property CmBUF_HeatBuffer_parameter_13 = newProperty( 0, BDouble.make( 8 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBUF_HeatBuffer_parameter_13() { return getDouble(CmBUF_HeatBuffer_parameter_13); }
  public void setCmBUF_HeatBuffer_parameter_13(double v) { setDouble(CmBUF_HeatBuffer_parameter_13,v,null); }
// CHG-02: start boiler(s) hysteresis
  public static final Property CmBUF_HeatBuffer_parameter_14 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBUF_HeatBuffer_parameter_14() { return getDouble(CmBUF_HeatBuffer_parameter_14); }
  public void setCmBUF_HeatBuffer_parameter_14(double v) { setDouble(CmBUF_HeatBuffer_parameter_14,v,null); }
// DCHG-01: switch to buffer hysteresis
  public static final Property CmBUF_HeatBuffer_parameter_15 = newProperty( 0, BDouble.make( 8 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBUF_HeatBuffer_parameter_15() { return getDouble(CmBUF_HeatBuffer_parameter_15); }
  public void setCmBUF_HeatBuffer_parameter_15(double v) { setDouble(CmBUF_HeatBuffer_parameter_15,v,null); }
// DCHG-02: switch to boiler(s) hysteresis
  public static final Property CmBUF_HeatBuffer_parameter_16 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBUF_HeatBuffer_parameter_16() { return getDouble(CmBUF_HeatBuffer_parameter_16); }
  public void setCmBUF_HeatBuffer_parameter_16(double v) { setDouble(CmBUF_HeatBuffer_parameter_16,v,null); }
// OVHT-01: maximum buffer upper temperature
  public static final Property CmBUF_HeatBuffer_parameter_17 = newProperty( 0, BDouble.make( 90 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBUF_HeatBuffer_parameter_17() { return getDouble(CmBUF_HeatBuffer_parameter_17); }
  public void setCmBUF_HeatBuffer_parameter_17(double v) { setDouble(CmBUF_HeatBuffer_parameter_17,v,null); }
// OVHT-02: maximum buffer lower temperature
  public static final Property CmBUF_HeatBuffer_parameter_18 = newProperty( 0, BDouble.make( 80 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBUF_HeatBuffer_parameter_18() { return getDouble(CmBUF_HeatBuffer_parameter_18); }
  public void setCmBUF_HeatBuffer_parameter_18(double v) { setDouble(CmBUF_HeatBuffer_parameter_18,v,null); }
// OVHT-03: alarm delay for maximum alarm (0= off)
  public static final Property CmBUF_HeatBuffer_parameter_19 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(10000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBUF_HeatBuffer_parameter_19() { return getDouble(CmBUF_HeatBuffer_parameter_19); }
  public void setCmBUF_HeatBuffer_parameter_19(double v) { setDouble(CmBUF_HeatBuffer_parameter_19,v,null); }
// OVHT-04: switching differential buffer alarm
  public static final Property CmBUF_HeatBuffer_parameter_20 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBUF_HeatBuffer_parameter_20() { return getDouble(CmBUF_HeatBuffer_parameter_20); }
  public void setCmBUF_HeatBuffer_parameter_20(double v) { setDouble(CmBUF_HeatBuffer_parameter_20,v,null); }
// OAT-01: stop buffer loading high OAT limit
  public static final Property CmBUF_HeatBuffer_parameter_21 = newProperty( 0, BDouble.make( 90 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBUF_HeatBuffer_parameter_21() { return getDouble(CmBUF_HeatBuffer_parameter_21); }
  public void setCmBUF_HeatBuffer_parameter_21(double v) { setDouble(CmBUF_HeatBuffer_parameter_21,v,null); }
// SOL-01: heat demand decrease during un-controlled loading
  public static final Property CmBUF_HeatBuffer_parameter_22 = newProperty( 0, BDouble.make( 15 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(90)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBUF_HeatBuffer_parameter_22() { return getDouble(CmBUF_HeatBuffer_parameter_22); }
  public void setCmBUF_HeatBuffer_parameter_22(double v) { setDouble(CmBUF_HeatBuffer_parameter_22,v,null); }
// SOL-02: switch off delay heat demand decrease after external loading
  public static final Property CmBUF_HeatBuffer_parameter_165 = newProperty( 0, BDouble.make( 15 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(480)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmBUF_HeatBuffer_parameter_165() { return getDouble(CmBUF_HeatBuffer_parameter_165); }
  public void setCmBUF_HeatBuffer_parameter_165(double v) { setDouble(CmBUF_HeatBuffer_parameter_165,v,null); }

  // macro inputs
// HeadDemandIn
  public static final Property CmBUF_HeatBuffer_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmBUF_HeatBuffer_input_1() { return (BStatusNumeric) get(CmBUF_HeatBuffer_input_1); }
  public void setCmBUF_HeatBuffer_input_1(BStatusNumeric v) { set(CmBUF_HeatBuffer_input_1,v,null); }
  public void setCmBUF_HeatBuffer_input_1(float v) { getCmBUF_HeatBuffer_input_1().setValue(v); }
// BufUpperTemp
  public static final Property CmBUF_HeatBuffer_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmBUF_HeatBuffer_input_3() { return (BStatusNumeric) get(CmBUF_HeatBuffer_input_3); }
  public void setCmBUF_HeatBuffer_input_3(BStatusNumeric v) { set(CmBUF_HeatBuffer_input_3,v,null); }
  public void setCmBUF_HeatBuffer_input_3(float v) { getCmBUF_HeatBuffer_input_3().setValue(v); }
// BufMid1Temp
  public static final Property CmBUF_HeatBuffer_input_4 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmBUF_HeatBuffer_input_4() { return (BStatusNumeric) get(CmBUF_HeatBuffer_input_4); }
  public void setCmBUF_HeatBuffer_input_4(BStatusNumeric v) { set(CmBUF_HeatBuffer_input_4,v,null); }
  public void setCmBUF_HeatBuffer_input_4(float v) { getCmBUF_HeatBuffer_input_4().setValue(v); }
// BufMid2Temp
  public static final Property CmBUF_HeatBuffer_input_5 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmBUF_HeatBuffer_input_5() { return (BStatusNumeric) get(CmBUF_HeatBuffer_input_5); }
  public void setCmBUF_HeatBuffer_input_5(BStatusNumeric v) { set(CmBUF_HeatBuffer_input_5,v,null); }
  public void setCmBUF_HeatBuffer_input_5(float v) { getCmBUF_HeatBuffer_input_5().setValue(v); }
// BufMid3Temp
  public static final Property CmBUF_HeatBuffer_input_6 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmBUF_HeatBuffer_input_6() { return (BStatusNumeric) get(CmBUF_HeatBuffer_input_6); }
  public void setCmBUF_HeatBuffer_input_6(BStatusNumeric v) { set(CmBUF_HeatBuffer_input_6,v,null); }
  public void setCmBUF_HeatBuffer_input_6(float v) { getCmBUF_HeatBuffer_input_6().setValue(v); }
// BufLowerTemp
  public static final Property CmBUF_HeatBuffer_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmBUF_HeatBuffer_input_7() { return (BStatusNumeric) get(CmBUF_HeatBuffer_input_7); }
  public void setCmBUF_HeatBuffer_input_7(BStatusNumeric v) { set(CmBUF_HeatBuffer_input_7,v,null); }
  public void setCmBUF_HeatBuffer_input_7(float v) { getCmBUF_HeatBuffer_input_7().setValue(v); }
// BufLoadLevel
  public static final Property CmBUF_HeatBuffer_input_8 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmBUF_HeatBuffer_input_8() { return (BStatusNumeric) get(CmBUF_HeatBuffer_input_8); }
  public void setCmBUF_HeatBuffer_input_8(BStatusNumeric v) { set(CmBUF_HeatBuffer_input_8,v,null); }
  public void setCmBUF_HeatBuffer_input_8(float v) { getCmBUF_HeatBuffer_input_8().setValue(v); }
// ExtLoading
  public static final Property CmBUF_HeatBuffer_input_9 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmBUF_HeatBuffer_input_9() { return (BStatusBoolean) get(CmBUF_HeatBuffer_input_9); }
  public void setCmBUF_HeatBuffer_input_9(BStatusBoolean v) { set(CmBUF_HeatBuffer_input_9,v,null); }
  public void setCmBUF_HeatBuffer_input_9(boolean v) { getCmBUF_HeatBuffer_input_9().setValue(v); }
// FilteredOATemp
  public static final Property CmBUF_HeatBuffer_input_10 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmBUF_HeatBuffer_input_10() { return (BStatusNumeric) get(CmBUF_HeatBuffer_input_10); }
  public void setCmBUF_HeatBuffer_input_10(BStatusNumeric v) { set(CmBUF_HeatBuffer_input_10,v,null); }
  public void setCmBUF_HeatBuffer_input_10(float v) { getCmBUF_HeatBuffer_input_10().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.01 [93] 17.11.2015-07:54").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6124510279070908769").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmBUF_HeatBuffer.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfTruncate func_36 = new CfTruncate();
  protected CfWindow func_70 = new CfWindow();
  protected CfWindow func_78 = new CfWindow();
  protected CmIDT20 func_103 = new CmIDT20();
  protected CmBypassValve func_64 = new CmBypassValve();
  protected CmBufDischargingControl func_76 = new CmBufDischargingControl();
  protected CmEffLowerTemp func_58 = new CmEffLowerTemp();
  protected CmBufHeatDemand func_74 = new CmBufHeatDemand();
  protected CfWindow func_93 = new CfWindow();
  protected CfInputMultiplexer func_95 = new CfInputMultiplexer();
  protected CfCompare2 func_240 = new CfCompare2();
  protected CfInputMultiplexer func_151 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_148 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_150 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_149 = new CfInputMultiplexer();
  protected CfWindow func_321 = new CfWindow();
  protected CfWindow func_322 = new CfWindow();
  protected CfOr func_320 = new CfOr();
  protected CfInputMultiplexer func_323 = new CfInputMultiplexer();

  // default constructor
  public BCmBUF_HeatBuffer()
  {
    func_148.configure(4);
  }

  public void Start()
  {
    func_103.Start();
    func_64.Start();
    func_76.Start();
    func_58.Start();
    func_74.Start();
  }
}
