/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    BUF_StratHeatBuffer
Macro id:      6249935902282351013
Macro version: 41
Last change:   25.02.2016 - 09:53
Access Level:  2
Inputs:
  [1] HeatDemandIn
  [2] BufSupplyTemp
  [3] BufUpperTemp
  [4] BufMid1Temp
  [5] BufMid2Temp
  [6] BufMid3Temp
  [7] BufLowerTemp
  [8] FilteredOATemp
Outputs:
  [1] HeatDemandOut
  [2] ChgOverValve
  [3] ChargPumpEn
  [4] ChgValve1
  [5] ChgValve2
  [6] ChgValve3
  [7] ChgValve4
  [8] BufOverheatAlm
  [9] StopHighOATemp
  [10] OperationMode
  [11] MaxChgLevels
  [12] ActLoadLevel
Parameter:
  [1] CHG-01: start charging
  [2] CHG-02: stop charging
  [3] DCHG-01: switch to buffer hysteresis
  [4] DCHG-02: switch to boiler(s) hysteresis
  [5] OVHT-01: maximum buffer upper temperature
  [6] OVHT-02: maximum buffer mid1 temperature
  [7] OVHT-03: maximum buffer mid2 temperature
  [8] OVHT-04: maximum buffer mid3 temperature
  [9] OVHT-05: maximum buffer lower temperature
  [10] OVHT-06: alarm delay for maximum alarm (0 = off)
  [11] OVHT-07: switching differential buffer alarm
  [12] PMP-01: pump switch off delay
  [13] PMP-02: pump run time at closed valves
  [14] PMP-03: pump restart at closed valves; 0 = disable
  [15] OAT-01: stop buffer loading high OAT limit
Description:
A system buffer is always required if you have external un-controlled heat sources as:
solar panels, heat pumps, combined heat and power plants or solid fuel boilers.
The operating mode of this system buffer can only be discharging control.
This buffer will switch the heat demand to the heat generators, but it will usually not be charged by the heat generators consuming non-regenerative fuels. 
Depending on the buffer supply temperature of the external uncontrolled heat generators, the macro offers the possibility to load the buffer at a certain level, depending on the number of connected sensors and an input for the charging level.
The macro also provides maximum temperatures for all the load levels to preserve the buffer temperature stratification.
The buffer will generate overheat alarms only if the buffer upper and lower overheat limits are exceeded.
================================================================================*/

public class BCmBUF_StratHeatBuffer
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmBUF_StratHeatBuffer_output_9().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmBUF_StratHeatBuffer_output_9().setStatus(BStatus.disabled);
    getCmBUF_StratHeatBuffer_output_10().setStatus(BStatus.disabled);
    getCmBUF_StratHeatBuffer_output_11().setStatus(BStatus.disabled);
    getCmBUF_StratHeatBuffer_output_12().setStatus(BStatus.disabled);
    getCmBUF_StratHeatBuffer_output_13().setStatus(BStatus.disabled);
    getCmBUF_StratHeatBuffer_output_14().setStatus(BStatus.disabled);
    getCmBUF_StratHeatBuffer_output_15().setStatus(BStatus.disabled);
    getCmBUF_StratHeatBuffer_output_16().setStatus(BStatus.disabled);
    getCmBUF_StratHeatBuffer_output_199().setStatus(BStatus.disabled);
    getCmBUF_StratHeatBuffer_output_17().setStatus(BStatus.disabled);
    getCmBUF_StratHeatBuffer_output_18().setStatus(BStatus.disabled);
    getCmBUF_StratHeatBuffer_output_19().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmBUF_StratHeatBuffer_output_9().setStatus(BStatus.ok);
    getCmBUF_StratHeatBuffer_output_10().setStatus(BStatus.ok);
    getCmBUF_StratHeatBuffer_output_11().setStatus(BStatus.ok);
    getCmBUF_StratHeatBuffer_output_12().setStatus(BStatus.ok);
    getCmBUF_StratHeatBuffer_output_13().setStatus(BStatus.ok);
    getCmBUF_StratHeatBuffer_output_14().setStatus(BStatus.ok);
    getCmBUF_StratHeatBuffer_output_15().setStatus(BStatus.ok);
    getCmBUF_StratHeatBuffer_output_16().setStatus(BStatus.ok);
    getCmBUF_StratHeatBuffer_output_199().setStatus(BStatus.ok);
    getCmBUF_StratHeatBuffer_output_17().setStatus(BStatus.ok);
    getCmBUF_StratHeatBuffer_output_18().setStatus(BStatus.ok);
    getCmBUF_StratHeatBuffer_output_19().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [46] Macro call CmMax_Load_Level
    func_46.CmMax_Load_Level_input_1 = (float) getCmBUF_StratHeatBuffer_input_4().getValue();
    func_46.CmMax_Load_Level_input_2 = (float) getCmBUF_StratHeatBuffer_input_5().getValue();
    func_46.CmMax_Load_Level_input_3 = (float) getCmBUF_StratHeatBuffer_input_6().getValue();
    func_46.Execute(  );
    setCmBUF_StratHeatBuffer_output_18(func_46.CmMax_Load_Level_output_5);

    // [147] Function call CfSubtract
    func_147.input[0] = (float) getCmBUF_StratHeatBuffer_input_1().getValue();
    func_147.input[1] = (float) getCmBUF_StratHeatBuffer_parameter_23();
    func_147.Execute(  );

    // [154] Function call CfAddition
    func_154.input[0] = (float) getCmBUF_StratHeatBuffer_input_1().getValue();
    func_154.input[1] = (float) getCmBUF_StratHeatBuffer_parameter_22();
    func_154.Execute(  );

    // [167] Function call CfSubtract
    func_167.input[0] = (float) getCmBUF_StratHeatBuffer_parameter_31();
    func_167.input[1] = 3F;
    func_167.Execute(  );
    setParameter(8, func_167.output);

    // [173] Function call CfIdt
    func_173.input = (float) getCmBUF_StratHeatBuffer_parameter_33();
    func_173.Execute(  );
    setParameter(10, func_173.output[0]);

    // [177] Function call CfCompare1
    func_177.inputA = (float) getCmBUF_StratHeatBuffer_parameter_33();
    func_177.inputB = 0F;
    func_177.Execute(  );

    // [182] Function call CfIdt
    func_182.input = (float) getCmBUF_StratHeatBuffer_parameter_32();
    func_182.Execute(  );
    setParameter(9, func_182.output[0]);

    // [187] Function call CfCompare1
    func_187.inputA = (float) getCmBUF_StratHeatBuffer_parameter_186();
    func_187.inputB = 90F;
    func_187.Execute(  );

    // [188] Function call CfCompare1
    func_188.inputA = (float) getCmBUF_StratHeatBuffer_input_8().getValue();
    func_188.inputB = (float) getCmBUF_StratHeatBuffer_parameter_186();
    func_188.Execute(  );

    // [216] Function call CfHysteresis
    func_216.inputX = (float) getCmBUF_StratHeatBuffer_input_3().getValue();
    func_216.inputW = (float) getCmBUF_StratHeatBuffer_parameter_24();
    func_216.Execute( this, 0 );

    // [217] Function call CfHysteresis
    func_217.inputX = (float) getCmBUF_StratHeatBuffer_input_7().getValue();
    func_217.inputW = (float) getCmBUF_StratHeatBuffer_parameter_28();
    func_217.Execute( this, 1 );

    // [229] Function call CfIdt
    func_229.input = (float) getCmBUF_StratHeatBuffer_parameter_30();
    func_229.Execute(  );
    setParameter(0, func_229.output[0]);
    setParameter(1, func_229.output[1]);

    // [232] Function call CfIdt
    func_232.input = (float) getCmBUF_StratHeatBuffer_parameter_29();
    func_232.Execute(  );
    setParameter(3, func_232.output[0]);

    // [237] Function call CfCompare1
    func_237.inputA = (float) getCmBUF_StratHeatBuffer_parameter_29();
    func_237.inputB = 0F;
    func_237.Execute(  );

    // [290] Macro call CmTempSenAvailable
    func_290.CmTempSenAvailable_input_1 = (float) getCmBUF_StratHeatBuffer_input_7().getValue();
    func_290.Execute(  );

    // [315] Macro call CmTempSenAvailable
    func_315.CmTempSenAvailable_input_1 = (float) getCmBUF_StratHeatBuffer_input_8().getValue();
    func_315.Execute(  );

    // [49] Function call CfWindow
    func_49.inputValue = (float) getCmBUF_StratHeatBuffer_output_18().getValue();
    func_49.inputMinimum = 0.8F;
    func_49.inputMaximum = 1.2F;
    func_49.Execute(  );

    // [56] Function call CfWindow
    func_56.inputValue = (float) getCmBUF_StratHeatBuffer_output_18().getValue();
    func_56.inputMinimum = 1.8F;
    func_56.inputMaximum = 2.2F;
    func_56.Execute(  );

    // [59] Function call CfWindow
    func_59.inputValue = (float) getCmBUF_StratHeatBuffer_output_18().getValue();
    func_59.inputMinimum = 2.8F;
    func_59.inputMaximum = 3.2F;
    func_59.Execute(  );

    // [67] Function call CfWindow
    func_67.inputValue = (float) getCmBUF_StratHeatBuffer_output_18().getValue();
    func_67.inputMinimum = 3.8F;
    func_67.inputMaximum = 4.2F;
    func_67.Execute(  );

    // [143] Function call CfCompare1
    func_143.inputA = (float) getCmBUF_StratHeatBuffer_input_3().getValue();
    func_143.inputB = func_147.output;
    func_143.Execute(  );

    // [151] Function call CfCompare1
    func_151.inputA = (float) getCmBUF_StratHeatBuffer_input_3().getValue();
    func_151.inputB = func_154.output;
    func_151.Execute(  );

    // [189] Function call CfAnd
    func_189.input[0] = func_187.outputLess;
    func_189.input[1] = func_188.outputGreater;
    func_189.input[2] = func_315.CmTempSenAvailable_output_2;
    func_189.Execute(  );
    setCmBUF_StratHeatBuffer_output_199(func_189.outputAND);

    // [287] Function call CfAnd
    func_287.input[0] = func_217.output1;
    func_287.input[1] = func_290.CmTempSenAvailable_output_2;
    func_287.Execute(  );

    // [35] Macro call CmCharging
    func_35.CmCharging_input_1 = (float) getCmBUF_StratHeatBuffer_input_2().getValue();
    func_35.CmCharging_input_2 = (float) getCmBUF_StratHeatBuffer_input_3().getValue();
    func_35.CmCharging_input_30 = (float) getCmBUF_StratHeatBuffer_input_7().getValue();
    func_35.CmCharging_input_7 = (float) getCmBUF_StratHeatBuffer_parameter_20();
    func_35.CmCharging_input_8 = (float) getCmBUF_StratHeatBuffer_parameter_21();
    func_35.CmCharging_input_9 = (float) getCmBUF_StratHeatBuffer_parameter_24();
    func_35.CmCharging_input_90 = func_49.output;
    func_35.Execute(  );

    // [52] Macro call CmCharging
    func_52.CmCharging_input_1 = (float) getCmBUF_StratHeatBuffer_input_2().getValue();
    func_52.CmCharging_input_2 = (float) getCmBUF_StratHeatBuffer_input_3().getValue();
    func_52.CmCharging_input_30 = (float) getCmBUF_StratHeatBuffer_input_4().getValue();
    func_52.CmCharging_input_7 = (float) getCmBUF_StratHeatBuffer_parameter_20();
    func_52.CmCharging_input_8 = (float) getCmBUF_StratHeatBuffer_parameter_21();
    func_52.CmCharging_input_9 = (float) getCmBUF_StratHeatBuffer_parameter_24();
    func_52.CmCharging_input_90 = func_56.output;
    func_52.Execute(  );

    // [54] Macro call CmCharging
    func_54.CmCharging_input_1 = (float) getCmBUF_StratHeatBuffer_input_2().getValue();
    func_54.CmCharging_input_2 = (float) getCmBUF_StratHeatBuffer_input_4().getValue();
    func_54.CmCharging_input_30 = (float) getCmBUF_StratHeatBuffer_input_7().getValue();
    func_54.CmCharging_input_7 = (float) getCmBUF_StratHeatBuffer_parameter_20();
    func_54.CmCharging_input_8 = (float) getCmBUF_StratHeatBuffer_parameter_21();
    func_54.CmCharging_input_9 = (float) getCmBUF_StratHeatBuffer_parameter_25();
    func_54.CmCharging_input_90 = func_56.output;
    func_54.Execute(  );

    // [60] Macro call CmCharging
    func_60.CmCharging_input_1 = (float) getCmBUF_StratHeatBuffer_input_2().getValue();
    func_60.CmCharging_input_2 = (float) getCmBUF_StratHeatBuffer_input_3().getValue();
    func_60.CmCharging_input_30 = (float) getCmBUF_StratHeatBuffer_input_4().getValue();
    func_60.CmCharging_input_7 = (float) getCmBUF_StratHeatBuffer_parameter_20();
    func_60.CmCharging_input_8 = (float) getCmBUF_StratHeatBuffer_parameter_21();
    func_60.CmCharging_input_9 = (float) getCmBUF_StratHeatBuffer_parameter_24();
    func_60.CmCharging_input_90 = func_59.output;
    func_60.Execute(  );

    // [61] Macro call CmCharging
    func_61.CmCharging_input_1 = (float) getCmBUF_StratHeatBuffer_input_2().getValue();
    func_61.CmCharging_input_2 = (float) getCmBUF_StratHeatBuffer_input_4().getValue();
    func_61.CmCharging_input_30 = (float) getCmBUF_StratHeatBuffer_input_5().getValue();
    func_61.CmCharging_input_7 = (float) getCmBUF_StratHeatBuffer_parameter_20();
    func_61.CmCharging_input_8 = (float) getCmBUF_StratHeatBuffer_parameter_21();
    func_61.CmCharging_input_9 = (float) getCmBUF_StratHeatBuffer_parameter_25();
    func_61.CmCharging_input_90 = func_59.output;
    func_61.Execute(  );

    // [64] Macro call CmCharging
    func_64.CmCharging_input_1 = (float) getCmBUF_StratHeatBuffer_input_2().getValue();
    func_64.CmCharging_input_2 = (float) getCmBUF_StratHeatBuffer_input_5().getValue();
    func_64.CmCharging_input_30 = (float) getCmBUF_StratHeatBuffer_input_7().getValue();
    func_64.CmCharging_input_7 = (float) getCmBUF_StratHeatBuffer_parameter_20();
    func_64.CmCharging_input_8 = (float) getCmBUF_StratHeatBuffer_parameter_21();
    func_64.CmCharging_input_9 = (float) getCmBUF_StratHeatBuffer_parameter_26();
    func_64.CmCharging_input_90 = func_59.output;
    func_64.Execute(  );

    // [65] Macro call CmCharging
    func_65.CmCharging_input_1 = (float) getCmBUF_StratHeatBuffer_input_2().getValue();
    func_65.CmCharging_input_2 = (float) getCmBUF_StratHeatBuffer_input_3().getValue();
    func_65.CmCharging_input_30 = (float) getCmBUF_StratHeatBuffer_input_4().getValue();
    func_65.CmCharging_input_7 = (float) getCmBUF_StratHeatBuffer_parameter_20();
    func_65.CmCharging_input_8 = (float) getCmBUF_StratHeatBuffer_parameter_21();
    func_65.CmCharging_input_9 = (float) getCmBUF_StratHeatBuffer_parameter_24();
    func_65.CmCharging_input_90 = func_67.output;
    func_65.Execute(  );

    // [66] Macro call CmCharging
    func_66.CmCharging_input_1 = (float) getCmBUF_StratHeatBuffer_input_2().getValue();
    func_66.CmCharging_input_2 = (float) getCmBUF_StratHeatBuffer_input_4().getValue();
    func_66.CmCharging_input_30 = (float) getCmBUF_StratHeatBuffer_input_5().getValue();
    func_66.CmCharging_input_7 = (float) getCmBUF_StratHeatBuffer_parameter_20();
    func_66.CmCharging_input_8 = (float) getCmBUF_StratHeatBuffer_parameter_21();
    func_66.CmCharging_input_9 = (float) getCmBUF_StratHeatBuffer_parameter_25();
    func_66.CmCharging_input_90 = func_67.output;
    func_66.Execute(  );

    // [68] Macro call CmCharging
    func_68.CmCharging_input_1 = (float) getCmBUF_StratHeatBuffer_input_2().getValue();
    func_68.CmCharging_input_2 = (float) getCmBUF_StratHeatBuffer_input_5().getValue();
    func_68.CmCharging_input_30 = (float) getCmBUF_StratHeatBuffer_input_6().getValue();
    func_68.CmCharging_input_7 = (float) getCmBUF_StratHeatBuffer_parameter_20();
    func_68.CmCharging_input_8 = (float) getCmBUF_StratHeatBuffer_parameter_21();
    func_68.CmCharging_input_9 = (float) getCmBUF_StratHeatBuffer_parameter_26();
    func_68.CmCharging_input_90 = func_67.output;
    func_68.Execute(  );

    // [70] Macro call CmCharging
    func_70.CmCharging_input_1 = (float) getCmBUF_StratHeatBuffer_input_2().getValue();
    func_70.CmCharging_input_2 = (float) getCmBUF_StratHeatBuffer_input_6().getValue();
    func_70.CmCharging_input_30 = (float) getCmBUF_StratHeatBuffer_input_7().getValue();
    func_70.CmCharging_input_7 = (float) getCmBUF_StratHeatBuffer_parameter_20();
    func_70.CmCharging_input_8 = (float) getCmBUF_StratHeatBuffer_parameter_21();
    func_70.CmCharging_input_9 = (float) getCmBUF_StratHeatBuffer_parameter_27();
    func_70.CmCharging_input_90 = func_67.output;
    func_70.Execute(  );

    // [157] Function call CfJkFlipFlop
    func_157.inputSet = func_143.outputLess;
    func_157.inputClock = false;
    func_157.inputReset = func_151.outputGreater;
    func_157.Execute(  );

    // [228] Function call CfOr
    func_228.input[0] = func_216.output1;
    func_228.input[1] = func_287.outputAND;
    func_228.Execute(  );

    // [89] Function call CfOr
    func_89.input[0] = func_35.CmCharging_output_3;
    func_89.input[1] = func_52.CmCharging_output_3;
    func_89.input[2] = func_60.CmCharging_output_3;
    func_89.input[3] = func_65.CmCharging_output_3;
    func_89.Execute(  );

    // [99] Function call CfOr
    func_99.input[0] = func_54.CmCharging_output_3;
    func_99.input[1] = func_61.CmCharging_output_3;
    func_99.input[2] = func_66.CmCharging_output_3;
    func_99.Execute(  );

    // [100] Function call CfOr
    func_100.input[0] = func_64.CmCharging_output_3;
    func_100.input[1] = func_68.CmCharging_output_3;
    func_100.Execute(  );

    // [297] Function call CfNot
    func_297.input = func_228.outputOR;
    func_297.Execute(  );

    // [299] Function call CfMonoflop
    func_299.input = BooleanToFloat(func_297.output);
    func_299.Execute( this, 2 );

    // [230] Function call CfIdt
    func_230.input = BooleanToFloat(func_296.output);
    func_230.Execute(  );

    // [203] Function call CfOr
    func_203.input[0] = FloatToBoolean(func_230.output[0]);
    func_203.input[1] = getCmBUF_StratHeatBuffer_output_199().getValue();
    func_203.Execute(  );

    // [235] Function call CfAnd
    func_235.input[0] = FloatToBoolean(func_230.output[1]);
    func_235.input[1] = func_237.outputGreater;
    func_235.Execute(  );

    // [257] Function call CfNot
    func_257.input = FloatToBoolean(func_230.output[0]);
    func_257.Execute(  );

    // [308] Function call CfOr
    func_308.input[0] = FloatToBoolean(func_230.output[0]);
    func_308.input[1] = getCmBUF_StratHeatBuffer_output_199().getValue();
    func_308.Execute(  );

    // [201] Function call CfInputMultiplexer
    func_201.inputSelect = BooleanToInt(func_203.outputOR);
    func_201.input[1-1] = BooleanToFloat(func_89.outputOR);
    func_201.input[2-1] = 0F;
    func_201.Execute(  );
    setCmBUF_StratHeatBuffer_output_12(FloatToBoolean(func_201.output));

    // [231] Function call CfDelayOnOff
    func_231.input = func_235.outputAND;
    func_231.Execute( this, 3 );
    setCmBUF_StratHeatBuffer_output_16(func_231.output);

    // [253] Function call CfAnd
    func_253.input[0] = func_157.output;
    func_253.input[1] = func_257.output;
    func_253.Execute(  );

    // [102] Function call CfNot
    func_102.input = getCmBUF_StratHeatBuffer_output_12().getValue();
    func_102.Execute(  );

    // [162] Function call CfInputMultiplexer
    func_162.inputSelect = BooleanToInt(func_253.outputAND);
    func_162.input[1-1] = 0F;
    func_162.input[2-1] = 1F;
    func_162.Execute(  );
    setCmBUF_StratHeatBuffer_output_10(FloatToBoolean(func_162.output));

    // [163] Function call CfInputMultiplexer
    func_163.inputSelect = BooleanToInt(func_253.outputAND);
    func_163.input[1-1] = 0F;
    func_163.input[2-1] = (float) getCmBUF_StratHeatBuffer_input_1().getValue();
    func_163.Execute(  );
    setCmBUF_StratHeatBuffer_output_9(func_163.output);

    // [281] Function call CfInputMultiplexer
    func_281.inputSelect = BooleanToInt(getCmBUF_StratHeatBuffer_output_12().getValue());
    func_281.input[1-1] = 1F;
    func_281.input[2-1] = 2F;
    func_281.Execute(  );

    // [104] Function call CfAnd
    func_104.input[0] = func_102.output;
    func_104.input[1] = func_99.outputOR;
    func_104.Execute(  );

    // [215] Function call CfAnd
    func_215.input[0] = getCmBUF_StratHeatBuffer_output_10().getValue();
    func_215.input[1] = func_228.outputOR;
    func_215.Execute(  );

    // [259] Function call CfInputMultiplexer
    func_259.inputSelect = BooleanToInt(getCmBUF_StratHeatBuffer_output_10().getValue());
    func_259.input[1-1] = 1F;
    func_259.input[2-1] = 2F;
    func_259.Execute(  );

    // [211] Function call CfInputMultiplexer
    func_211.inputSelect = BooleanToInt(func_203.outputOR);
    func_211.input[1-1] = BooleanToFloat(func_104.outputAND);
    func_211.input[2-1] = 0F;
    func_211.Execute(  );
    setCmBUF_StratHeatBuffer_output_13(FloatToBoolean(func_211.output));

    // [261] Function call CfInputMultiplexer
    func_261.inputSelect = BooleanToInt(getCmBUF_StratHeatBuffer_output_199().getValue());
    func_261.input[1-1] = func_259.output;
    func_261.input[2-1] = 5F;
    func_261.Execute(  );

    // [296] Function call CfJkFlipFlop
    func_296.inputSet = func_215.outputAND;
    func_296.inputClock = false;
    func_296.inputReset = func_299.output;
    func_296.Execute(  );

    // [111] Function call CfNot
    func_111.input = getCmBUF_StratHeatBuffer_output_13().getValue();
    func_111.Execute(  );

    // [264] Function call CfInputMultiplexer
    func_264.inputSelect = FloatToInt(func_230.output[0]);
    func_264.input[1-1] = func_261.output;
    func_264.input[2-1] = 6F;
    func_264.Execute(  );
    setCmBUF_StratHeatBuffer_output_17(func_264.output);

    // [282] Function call CfInputMultiplexer
    func_282.inputSelect = BooleanToInt(getCmBUF_StratHeatBuffer_output_13().getValue());
    func_282.input[1-1] = func_281.output;
    func_282.input[2-1] = 3F;
    func_282.Execute(  );

    // [110] Function call CfAnd
    func_110.input[0] = func_102.output;
    func_110.input[1] = func_111.output;
    func_110.input[2] = func_100.outputOR;
    func_110.Execute(  );

    // [213] Function call CfInputMultiplexer
    func_213.inputSelect = BooleanToInt(func_203.outputOR);
    func_213.input[1-1] = BooleanToFloat(func_110.outputAND);
    func_213.input[2-1] = 0F;
    func_213.Execute(  );
    setCmBUF_StratHeatBuffer_output_14(FloatToBoolean(func_213.output));

    // [122] Function call CfNot
    func_122.input = getCmBUF_StratHeatBuffer_output_14().getValue();
    func_122.Execute(  );

    // [283] Function call CfInputMultiplexer
    func_283.inputSelect = BooleanToInt(getCmBUF_StratHeatBuffer_output_14().getValue());
    func_283.input[1-1] = func_282.output;
    func_283.input[2-1] = 4F;
    func_283.Execute(  );

    // [119] Function call CfAnd
    func_119.input[0] = func_102.output;
    func_119.input[1] = func_111.output;
    func_119.input[2] = func_122.output;
    func_119.input[3] = func_70.CmCharging_output_3;
    func_119.Execute(  );

    // [212] Function call CfInputMultiplexer
    func_212.inputSelect = BooleanToInt(func_203.outputOR);
    func_212.input[1-1] = BooleanToFloat(func_119.outputAND);
    func_212.input[2-1] = 0F;
    func_212.Execute(  );
    setCmBUF_StratHeatBuffer_output_15(FloatToBoolean(func_212.output));

    // [164] Function call CfOr
    func_164.input[0] = getCmBUF_StratHeatBuffer_output_12().getValue();
    func_164.input[1] = getCmBUF_StratHeatBuffer_output_13().getValue();
    func_164.input[2] = getCmBUF_StratHeatBuffer_output_14().getValue();
    func_164.input[3] = getCmBUF_StratHeatBuffer_output_15().getValue();
    func_164.Execute(  );

    // [284] Function call CfInputMultiplexer
    func_284.inputSelect = BooleanToInt(getCmBUF_StratHeatBuffer_output_15().getValue());
    func_284.input[1-1] = func_283.output;
    func_284.input[2-1] = 4F;
    func_284.Execute(  );
    setCmBUF_StratHeatBuffer_output_19(func_284.output);

    // [165] Function call CfDelayOnOff
    func_165.input = func_164.outputOR;
    func_165.Execute( this, 5 );

    // [166] Function call CfDelayOnOff
    func_166.input = func_165.output;
    func_166.Execute( this, 7 );

    // [171] Function call CfNot
    func_171.input = func_166.output;
    func_171.Execute(  );

    // [174] Function call CfAnd
    func_174.input[0] = func_171.output;
    func_174.input[1] = func_177.outputGreater;
    func_174.input[2] = func_308.outputNOR;
    func_174.Execute(  );

    // [302] Function call CfCycle
    func_302.input = func_174.outputAND;
    func_302.Execute( this, 9 );

    // [184] Function call CfOr
    func_184.input[0] = func_166.output;
    func_184.input[1] = func_302.output;
    func_184.Execute(  );
    setCmBUF_StratHeatBuffer_output_11(func_184.outputOR);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 0F, 3F, 10F, 0F, 0F, 3F, 0F,
    3F, 20F, 0F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// HeatDemandOut
  public static final Property CmBUF_StratHeatBuffer_output_9 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBUF_StratHeatBuffer_output_9() { return (BStatusNumeric) get(CmBUF_StratHeatBuffer_output_9); }
  public void setCmBUF_StratHeatBuffer_output_9(BStatusNumeric v) { set(CmBUF_StratHeatBuffer_output_9,v,null); }
  public void setCmBUF_StratHeatBuffer_output_9(float v) { getCmBUF_StratHeatBuffer_output_9().setValue(v); }
// ChgOverValve
  public static final Property CmBUF_StratHeatBuffer_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_StratHeatBuffer_output_10() { return (BStatusBoolean) get(CmBUF_StratHeatBuffer_output_10); }
  public void setCmBUF_StratHeatBuffer_output_10(BStatusBoolean v) { set(CmBUF_StratHeatBuffer_output_10,v,null); }
  public void setCmBUF_StratHeatBuffer_output_10(boolean v) { getCmBUF_StratHeatBuffer_output_10().setValue(v); }
// ChargPumpEn
  public static final Property CmBUF_StratHeatBuffer_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_StratHeatBuffer_output_11() { return (BStatusBoolean) get(CmBUF_StratHeatBuffer_output_11); }
  public void setCmBUF_StratHeatBuffer_output_11(BStatusBoolean v) { set(CmBUF_StratHeatBuffer_output_11,v,null); }
  public void setCmBUF_StratHeatBuffer_output_11(boolean v) { getCmBUF_StratHeatBuffer_output_11().setValue(v); }
// ChgValve1
  public static final Property CmBUF_StratHeatBuffer_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_StratHeatBuffer_output_12() { return (BStatusBoolean) get(CmBUF_StratHeatBuffer_output_12); }
  public void setCmBUF_StratHeatBuffer_output_12(BStatusBoolean v) { set(CmBUF_StratHeatBuffer_output_12,v,null); }
  public void setCmBUF_StratHeatBuffer_output_12(boolean v) { getCmBUF_StratHeatBuffer_output_12().setValue(v); }
// ChgValve2
  public static final Property CmBUF_StratHeatBuffer_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_StratHeatBuffer_output_13() { return (BStatusBoolean) get(CmBUF_StratHeatBuffer_output_13); }
  public void setCmBUF_StratHeatBuffer_output_13(BStatusBoolean v) { set(CmBUF_StratHeatBuffer_output_13,v,null); }
  public void setCmBUF_StratHeatBuffer_output_13(boolean v) { getCmBUF_StratHeatBuffer_output_13().setValue(v); }
// ChgValve3
  public static final Property CmBUF_StratHeatBuffer_output_14 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_StratHeatBuffer_output_14() { return (BStatusBoolean) get(CmBUF_StratHeatBuffer_output_14); }
  public void setCmBUF_StratHeatBuffer_output_14(BStatusBoolean v) { set(CmBUF_StratHeatBuffer_output_14,v,null); }
  public void setCmBUF_StratHeatBuffer_output_14(boolean v) { getCmBUF_StratHeatBuffer_output_14().setValue(v); }
// ChgValve4
  public static final Property CmBUF_StratHeatBuffer_output_15 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_StratHeatBuffer_output_15() { return (BStatusBoolean) get(CmBUF_StratHeatBuffer_output_15); }
  public void setCmBUF_StratHeatBuffer_output_15(BStatusBoolean v) { set(CmBUF_StratHeatBuffer_output_15,v,null); }
  public void setCmBUF_StratHeatBuffer_output_15(boolean v) { getCmBUF_StratHeatBuffer_output_15().setValue(v); }
// BufOverheatAlm
  public static final Property CmBUF_StratHeatBuffer_output_16 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_StratHeatBuffer_output_16() { return (BStatusBoolean) get(CmBUF_StratHeatBuffer_output_16); }
  public void setCmBUF_StratHeatBuffer_output_16(BStatusBoolean v) { set(CmBUF_StratHeatBuffer_output_16,v,null); }
  public void setCmBUF_StratHeatBuffer_output_16(boolean v) { getCmBUF_StratHeatBuffer_output_16().setValue(v); }
// StopHighOATemp
  public static final Property CmBUF_StratHeatBuffer_output_199 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmBUF_StratHeatBuffer_output_199() { return (BStatusBoolean) get(CmBUF_StratHeatBuffer_output_199); }
  public void setCmBUF_StratHeatBuffer_output_199(BStatusBoolean v) { set(CmBUF_StratHeatBuffer_output_199,v,null); }
  public void setCmBUF_StratHeatBuffer_output_199(boolean v) { getCmBUF_StratHeatBuffer_output_199().setValue(v); }
// OperationMode
  public static final Property CmBUF_StratHeatBuffer_output_17 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBUF_StratHeatBuffer_output_17() { return (BStatusNumeric) get(CmBUF_StratHeatBuffer_output_17); }
  public void setCmBUF_StratHeatBuffer_output_17(BStatusNumeric v) { set(CmBUF_StratHeatBuffer_output_17,v,null); }
  public void setCmBUF_StratHeatBuffer_output_17(float v) { getCmBUF_StratHeatBuffer_output_17().setValue(v); }
// MaxChgLevels
  public static final Property CmBUF_StratHeatBuffer_output_18 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBUF_StratHeatBuffer_output_18() { return (BStatusNumeric) get(CmBUF_StratHeatBuffer_output_18); }
  public void setCmBUF_StratHeatBuffer_output_18(BStatusNumeric v) { set(CmBUF_StratHeatBuffer_output_18,v,null); }
  public void setCmBUF_StratHeatBuffer_output_18(float v) { getCmBUF_StratHeatBuffer_output_18().setValue(v); }
// ActLoadLevel
  public static final Property CmBUF_StratHeatBuffer_output_19 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmBUF_StratHeatBuffer_output_19() { return (BStatusNumeric) get(CmBUF_StratHeatBuffer_output_19); }
  public void setCmBUF_StratHeatBuffer_output_19(BStatusNumeric v) { set(CmBUF_StratHeatBuffer_output_19,v,null); }
  public void setCmBUF_StratHeatBuffer_output_19(float v) { getCmBUF_StratHeatBuffer_output_19().setValue(v); }

  // macro parameter
// CHG-01: start charging
  public static final Property CmBUF_StratHeatBuffer_parameter_20 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBUF_StratHeatBuffer_parameter_20() { return getDouble(CmBUF_StratHeatBuffer_parameter_20); }
  public void setCmBUF_StratHeatBuffer_parameter_20(double v) { setDouble(CmBUF_StratHeatBuffer_parameter_20,v,null); }
// CHG-02: stop charging
  public static final Property CmBUF_StratHeatBuffer_parameter_21 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBUF_StratHeatBuffer_parameter_21() { return getDouble(CmBUF_StratHeatBuffer_parameter_21); }
  public void setCmBUF_StratHeatBuffer_parameter_21(double v) { setDouble(CmBUF_StratHeatBuffer_parameter_21,v,null); }
// DCHG-01: switch to buffer hysteresis
  public static final Property CmBUF_StratHeatBuffer_parameter_22 = newProperty( 0, BDouble.make( 8 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBUF_StratHeatBuffer_parameter_22() { return getDouble(CmBUF_StratHeatBuffer_parameter_22); }
  public void setCmBUF_StratHeatBuffer_parameter_22(double v) { setDouble(CmBUF_StratHeatBuffer_parameter_22,v,null); }
// DCHG-02: switch to boiler(s) hysteresis
  public static final Property CmBUF_StratHeatBuffer_parameter_23 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBUF_StratHeatBuffer_parameter_23() { return getDouble(CmBUF_StratHeatBuffer_parameter_23); }
  public void setCmBUF_StratHeatBuffer_parameter_23(double v) { setDouble(CmBUF_StratHeatBuffer_parameter_23,v,null); }
// OVHT-01: maximum buffer upper temperature
  public static final Property CmBUF_StratHeatBuffer_parameter_24 = newProperty( 0, BDouble.make( 90 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBUF_StratHeatBuffer_parameter_24() { return getDouble(CmBUF_StratHeatBuffer_parameter_24); }
  public void setCmBUF_StratHeatBuffer_parameter_24(double v) { setDouble(CmBUF_StratHeatBuffer_parameter_24,v,null); }
// OVHT-02: maximum buffer mid1 temperature
  public static final Property CmBUF_StratHeatBuffer_parameter_25 = newProperty( 0, BDouble.make( 87 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBUF_StratHeatBuffer_parameter_25() { return getDouble(CmBUF_StratHeatBuffer_parameter_25); }
  public void setCmBUF_StratHeatBuffer_parameter_25(double v) { setDouble(CmBUF_StratHeatBuffer_parameter_25,v,null); }
// OVHT-03: maximum buffer mid2 temperature
  public static final Property CmBUF_StratHeatBuffer_parameter_26 = newProperty( 0, BDouble.make( 84 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBUF_StratHeatBuffer_parameter_26() { return getDouble(CmBUF_StratHeatBuffer_parameter_26); }
  public void setCmBUF_StratHeatBuffer_parameter_26(double v) { setDouble(CmBUF_StratHeatBuffer_parameter_26,v,null); }
// OVHT-04: maximum buffer mid3 temperature
  public static final Property CmBUF_StratHeatBuffer_parameter_27 = newProperty( 0, BDouble.make( 81 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBUF_StratHeatBuffer_parameter_27() { return getDouble(CmBUF_StratHeatBuffer_parameter_27); }
  public void setCmBUF_StratHeatBuffer_parameter_27(double v) { setDouble(CmBUF_StratHeatBuffer_parameter_27,v,null); }
// OVHT-05: maximum buffer lower temperature
  public static final Property CmBUF_StratHeatBuffer_parameter_28 = newProperty( 0, BDouble.make( 78 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBUF_StratHeatBuffer_parameter_28() { return getDouble(CmBUF_StratHeatBuffer_parameter_28); }
  public void setCmBUF_StratHeatBuffer_parameter_28(double v) { setDouble(CmBUF_StratHeatBuffer_parameter_28,v,null); }
// OVHT-06: alarm delay for maximum alarm (0 = off)
  public static final Property CmBUF_StratHeatBuffer_parameter_29 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(10000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBUF_StratHeatBuffer_parameter_29() { return getDouble(CmBUF_StratHeatBuffer_parameter_29); }
  public void setCmBUF_StratHeatBuffer_parameter_29(double v) { setDouble(CmBUF_StratHeatBuffer_parameter_29,v,null); }
// OVHT-07: switching differential buffer alarm
  public static final Property CmBUF_StratHeatBuffer_parameter_30 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmBUF_StratHeatBuffer_parameter_30() { return getDouble(CmBUF_StratHeatBuffer_parameter_30); }
  public void setCmBUF_StratHeatBuffer_parameter_30(double v) { setDouble(CmBUF_StratHeatBuffer_parameter_30,v,null); }
// PMP-01: pump switch off delay
  public static final Property CmBUF_StratHeatBuffer_parameter_31 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBUF_StratHeatBuffer_parameter_31() { return getDouble(CmBUF_StratHeatBuffer_parameter_31); }
  public void setCmBUF_StratHeatBuffer_parameter_31(double v) { setDouble(CmBUF_StratHeatBuffer_parameter_31,v,null); }
// PMP-02: pump run time at closed valves
  public static final Property CmBUF_StratHeatBuffer_parameter_32 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBUF_StratHeatBuffer_parameter_32() { return getDouble(CmBUF_StratHeatBuffer_parameter_32); }
  public void setCmBUF_StratHeatBuffer_parameter_32(double v) { setDouble(CmBUF_StratHeatBuffer_parameter_32,v,null); }
// PMP-03: pump restart at closed valves; 0 = disable
  public static final Property CmBUF_StratHeatBuffer_parameter_33 = newProperty( 0, BDouble.make( 1800 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmBUF_StratHeatBuffer_parameter_33() { return getDouble(CmBUF_StratHeatBuffer_parameter_33); }
  public void setCmBUF_StratHeatBuffer_parameter_33(double v) { setDouble(CmBUF_StratHeatBuffer_parameter_33,v,null); }
// OAT-01: stop buffer loading high OAT limit
  public static final Property CmBUF_StratHeatBuffer_parameter_186 = newProperty( 0, BDouble.make( 90 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmBUF_StratHeatBuffer_parameter_186() { return getDouble(CmBUF_StratHeatBuffer_parameter_186); }
  public void setCmBUF_StratHeatBuffer_parameter_186(double v) { setDouble(CmBUF_StratHeatBuffer_parameter_186,v,null); }

  // macro inputs
// HeatDemandIn
  public static final Property CmBUF_StratHeatBuffer_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmBUF_StratHeatBuffer_input_1() { return (BStatusNumeric) get(CmBUF_StratHeatBuffer_input_1); }
  public void setCmBUF_StratHeatBuffer_input_1(BStatusNumeric v) { set(CmBUF_StratHeatBuffer_input_1,v,null); }
  public void setCmBUF_StratHeatBuffer_input_1(float v) { getCmBUF_StratHeatBuffer_input_1().setValue(v); }
// BufSupplyTemp
  public static final Property CmBUF_StratHeatBuffer_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmBUF_StratHeatBuffer_input_2() { return (BStatusNumeric) get(CmBUF_StratHeatBuffer_input_2); }
  public void setCmBUF_StratHeatBuffer_input_2(BStatusNumeric v) { set(CmBUF_StratHeatBuffer_input_2,v,null); }
  public void setCmBUF_StratHeatBuffer_input_2(float v) { getCmBUF_StratHeatBuffer_input_2().setValue(v); }
// BufUpperTemp
  public static final Property CmBUF_StratHeatBuffer_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmBUF_StratHeatBuffer_input_3() { return (BStatusNumeric) get(CmBUF_StratHeatBuffer_input_3); }
  public void setCmBUF_StratHeatBuffer_input_3(BStatusNumeric v) { set(CmBUF_StratHeatBuffer_input_3,v,null); }
  public void setCmBUF_StratHeatBuffer_input_3(float v) { getCmBUF_StratHeatBuffer_input_3().setValue(v); }
// BufMid1Temp
  public static final Property CmBUF_StratHeatBuffer_input_4 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmBUF_StratHeatBuffer_input_4() { return (BStatusNumeric) get(CmBUF_StratHeatBuffer_input_4); }
  public void setCmBUF_StratHeatBuffer_input_4(BStatusNumeric v) { set(CmBUF_StratHeatBuffer_input_4,v,null); }
  public void setCmBUF_StratHeatBuffer_input_4(float v) { getCmBUF_StratHeatBuffer_input_4().setValue(v); }
// BufMid2Temp
  public static final Property CmBUF_StratHeatBuffer_input_5 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmBUF_StratHeatBuffer_input_5() { return (BStatusNumeric) get(CmBUF_StratHeatBuffer_input_5); }
  public void setCmBUF_StratHeatBuffer_input_5(BStatusNumeric v) { set(CmBUF_StratHeatBuffer_input_5,v,null); }
  public void setCmBUF_StratHeatBuffer_input_5(float v) { getCmBUF_StratHeatBuffer_input_5().setValue(v); }
// BufMid3Temp
  public static final Property CmBUF_StratHeatBuffer_input_6 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmBUF_StratHeatBuffer_input_6() { return (BStatusNumeric) get(CmBUF_StratHeatBuffer_input_6); }
  public void setCmBUF_StratHeatBuffer_input_6(BStatusNumeric v) { set(CmBUF_StratHeatBuffer_input_6,v,null); }
  public void setCmBUF_StratHeatBuffer_input_6(float v) { getCmBUF_StratHeatBuffer_input_6().setValue(v); }
// BufLowerTemp
  public static final Property CmBUF_StratHeatBuffer_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmBUF_StratHeatBuffer_input_7() { return (BStatusNumeric) get(CmBUF_StratHeatBuffer_input_7); }
  public void setCmBUF_StratHeatBuffer_input_7(BStatusNumeric v) { set(CmBUF_StratHeatBuffer_input_7,v,null); }
  public void setCmBUF_StratHeatBuffer_input_7(float v) { getCmBUF_StratHeatBuffer_input_7().setValue(v); }
// FilteredOATemp
  public static final Property CmBUF_StratHeatBuffer_input_8 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmBUF_StratHeatBuffer_input_8() { return (BStatusNumeric) get(CmBUF_StratHeatBuffer_input_8); }
  public void setCmBUF_StratHeatBuffer_input_8(BStatusNumeric v) { set(CmBUF_StratHeatBuffer_input_8,v,null); }
  public void setCmBUF_StratHeatBuffer_input_8(float v) { getCmBUF_StratHeatBuffer_input_8().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.01 [41] 25.02.2016-09:53").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6249935902282351013").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmBUF_StratHeatBuffer.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmMax_Load_Level func_46 = new CmMax_Load_Level();
  protected CfSubtract func_147 = new CfSubtract();
  protected CfAddition func_154 = new CfAddition();
  protected CfSubtract func_167 = new CfSubtract();
  protected CfIdt func_173 = new CfIdt();
  protected CfCompare1 func_177 = new CfCompare1();
  protected CfIdt func_182 = new CfIdt();
  protected CfCompare1 func_187 = new CfCompare1();
  protected CfCompare1 func_188 = new CfCompare1();
  protected CfHysteresis func_216 = new CfHysteresis();
  protected CfHysteresis func_217 = new CfHysteresis();
  protected CfIdt func_229 = new CfIdt();
  protected CfIdt func_232 = new CfIdt();
  protected CfCompare1 func_237 = new CfCompare1();
  protected CmTempSenAvailable func_290 = new CmTempSenAvailable();
  protected CmTempSenAvailable func_315 = new CmTempSenAvailable();
  protected CfWindow func_49 = new CfWindow();
  protected CfWindow func_56 = new CfWindow();
  protected CfWindow func_59 = new CfWindow();
  protected CfWindow func_67 = new CfWindow();
  protected CfCompare1 func_143 = new CfCompare1();
  protected CfCompare1 func_151 = new CfCompare1();
  protected CfAnd func_189 = new CfAnd();
  protected CfAnd func_287 = new CfAnd();
  protected CmCharging func_35 = new CmCharging();
  protected CmCharging func_52 = new CmCharging();
  protected CmCharging func_54 = new CmCharging();
  protected CmCharging func_60 = new CmCharging();
  protected CmCharging func_61 = new CmCharging();
  protected CmCharging func_64 = new CmCharging();
  protected CmCharging func_65 = new CmCharging();
  protected CmCharging func_66 = new CmCharging();
  protected CmCharging func_68 = new CmCharging();
  protected CmCharging func_70 = new CmCharging();
  protected CfJkFlipFlop func_157 = new CfJkFlipFlop();
  protected CfOr func_228 = new CfOr();
  protected CfOr func_89 = new CfOr();
  protected CfOr func_99 = new CfOr();
  protected CfOr func_100 = new CfOr();
  protected CfNot func_297 = new CfNot();
  protected CfMonoflop func_299 = new CfMonoflop();
  protected CfIdt func_230 = new CfIdt();
  protected CfOr func_203 = new CfOr();
  protected CfAnd func_235 = new CfAnd();
  protected CfNot func_257 = new CfNot();
  protected CfOr func_308 = new CfOr();
  protected CfInputMultiplexer func_201 = new CfInputMultiplexer();
  protected CfDelayOnOff func_231 = new CfDelayOnOff();
  protected CfAnd func_253 = new CfAnd();
  protected CfNot func_102 = new CfNot();
  protected CfInputMultiplexer func_162 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_163 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_281 = new CfInputMultiplexer();
  protected CfAnd func_104 = new CfAnd();
  protected CfAnd func_215 = new CfAnd();
  protected CfInputMultiplexer func_259 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_211 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_261 = new CfInputMultiplexer();
  protected CfJkFlipFlop func_296 = new CfJkFlipFlop();
  protected CfNot func_111 = new CfNot();
  protected CfInputMultiplexer func_264 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_282 = new CfInputMultiplexer();
  protected CfAnd func_110 = new CfAnd();
  protected CfInputMultiplexer func_213 = new CfInputMultiplexer();
  protected CfNot func_122 = new CfNot();
  protected CfInputMultiplexer func_283 = new CfInputMultiplexer();
  protected CfAnd func_119 = new CfAnd();
  protected CfInputMultiplexer func_212 = new CfInputMultiplexer();
  protected CfOr func_164 = new CfOr();
  protected CfInputMultiplexer func_284 = new CfInputMultiplexer();
  protected CfDelayOnOff func_165 = new CfDelayOnOff();
  protected CfDelayOnOff func_166 = new CfDelayOnOff();
  protected CfNot func_171 = new CfNot();
  protected CfAnd func_174 = new CfAnd();
  protected CfCycle func_302 = new CfCycle();
  protected CfOr func_184 = new CfOr();

  // default constructor
  public BCmBUF_StratHeatBuffer()
  {
    func_229.configure(2);
    func_189.configure(3);
    func_89.configure(4);
    func_99.configure(3);
    func_230.configure(2);
    func_110.configure(3);
    func_119.configure(4);
    func_164.configure(4);
    func_174.configure(3);
  }

  public void Start()
  {
    func_46.Start();
    func_216.Start();
    func_217.Start();
    func_290.Start();
    func_315.Start();
    func_35.Start();
    func_52.Start();
    func_54.Start();
    func_60.Start();
    func_61.Start();
    func_64.Start();
    func_65.Start();
    func_66.Start();
    func_68.Start();
    func_70.Start();
    func_157.Start();
    func_299.Start();
    func_231.Start();
    func_296.Start();
    func_165.Start();
    func_166.Start();
    func_302.Start();
  }
}
