/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    CSB_HtgStrategy_1gr_SST
Macro id:      6017706291678413685
Macro version: 142
Last change:   05.03.2018 - 13:30
Access Level:  2
Inputs:
  [1] SysSupplyTemp
  [2] SysRetTemp
  [3] HeatDemandIn
  [4] FilteredOATemp
  [5] EmergStop
Outputs:
  [1] DispEffHtgSp
  [2] IntContrSig
  [3] DispActPower
  [4] DispSparePower
  [5] DispBlockSignal
  [6] HeatGen_inAlarm
  [7] ActReqHeatGen
  [8] OverheatProt
  [9] CondensProt
  [10] ContinuousFlow
Parameter:
  [1] CFG-01: control mode configuration
  [2] CFG-02: maximum number of redundant heat generators
  [3] SST-01: minimum supply temperature
  [4] SST-02: maximum supply temperature
  [5] SST-03: setpoint raise
  [6] SST-04: maximum setpoint increment per minute
  [7] SST-05: minimum heat demand to start heat generators
  [8] SST-06: P-band following stages control
  [9] SST-07: I-time following stages control
  [10] SST-08: forward time expected system supply temperature (DISP-05)
  [11] SST-09: time to reach setpoint
  [12] SST-10: control region following stages
  [13] SST-11: temperature span switching on boilers
  [14] SST-12: temperature span switching off boilers
  [15] OPM-01: optimized off
  [16] OPM-02: group 1 operation mode
  [17] CYC-01: cyclic changeover sequence
  [18] OAT-01: low limit outside air temperature to enable the next boiler
  [19] OAT-02: high limit outside air temperature to disable the next boiler
  [20] OVR-01: high limit control deviation to enable the next boiler
  [21] OVR-02: low limit control deviation to disable the next boiler
  [22] OVR-03: switch on delay enable next boiler override
  [23] OVR-04 switch off delay enable next boiler override
  [24] SYS-01: continuous flow enabled
  [25] SYS-02: continuous flow time
  [26] SYS-03: leading boiler holds the setpoint output
  [27] DISP-01: number of heat generators group 1/ 123
  [28] DISP-04: calculated time to reach setpoint
  [29] DISP-05: expected system supply temperature from SST-08
Description:
The CSB_HtgStrategy_1gr_SST macro provides the control strategy for a heating system with one to 16 heat generators in one single group.
The module controls the system supply, the system return or the maximum value of the system supply and return temperatures. By switching boiler stages on and off. Heat generator stages have minimum on- and off times and blocking times to switch on and off the next stages or heat generators.
The macro controls the heat generator stages depending on the heat demand of the connected consumers,
The heating strategy also provides cyclic changeover and alarm management.
================================================================================*/

public class BCmCSB_HtgStrategy_1gr_SST
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmCSB_HtgStrategy_1gr_SST_output_137().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmCSB_HtgStrategy_1gr_SST_output_137().setStatus(BStatus.disabled);
    getCmCSB_HtgStrategy_1gr_SST_output_349().setStatus(BStatus.disabled);
    getCmCSB_HtgStrategy_1gr_SST_output_138().setStatus(BStatus.disabled);
    getCmCSB_HtgStrategy_1gr_SST_output_139().setStatus(BStatus.disabled);
    getCmCSB_HtgStrategy_1gr_SST_output_140().setStatus(BStatus.disabled);
    getCmCSB_HtgStrategy_1gr_SST_output_141().setStatus(BStatus.disabled);
    getCmCSB_HtgStrategy_1gr_SST_output_142().setStatus(BStatus.disabled);
    getCmCSB_HtgStrategy_1gr_SST_output_143().setStatus(BStatus.disabled);
    getCmCSB_HtgStrategy_1gr_SST_output_144().setStatus(BStatus.disabled);
    getCmCSB_HtgStrategy_1gr_SST_output_146().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmCSB_HtgStrategy_1gr_SST_output_137().setStatus(BStatus.ok);
    getCmCSB_HtgStrategy_1gr_SST_output_349().setStatus(BStatus.ok);
    getCmCSB_HtgStrategy_1gr_SST_output_138().setStatus(BStatus.ok);
    getCmCSB_HtgStrategy_1gr_SST_output_139().setStatus(BStatus.ok);
    getCmCSB_HtgStrategy_1gr_SST_output_140().setStatus(BStatus.ok);
    getCmCSB_HtgStrategy_1gr_SST_output_141().setStatus(BStatus.ok);
    getCmCSB_HtgStrategy_1gr_SST_output_142().setStatus(BStatus.ok);
    getCmCSB_HtgStrategy_1gr_SST_output_143().setStatus(BStatus.ok);
    getCmCSB_HtgStrategy_1gr_SST_output_144().setStatus(BStatus.ok);
    getCmCSB_HtgStrategy_1gr_SST_output_146().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [372] Macro call CmCommRegistersHeating
    func_372.CmCommRegistersHeating_input_80 = 1F;
    func_372.Execute(  );

    // [269] Macro call CmIDT20
    func_269.CmIDT20_input_1 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_234();
    func_269.CmIDT20_input_2 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_169();
    func_269.CmIDT20_input_3 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_170();
    func_269.CmIDT20_input_4 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_171();
    func_269.CmIDT20_input_5 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_172();
    func_269.CmIDT20_input_6 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_173();
    func_269.CmIDT20_input_7 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_174();
    func_269.CmIDT20_input_8 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_175();
    func_269.CmIDT20_input_9 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_176();
    func_269.CmIDT20_input_10 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_177();
    func_269.CmIDT20_input_11 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_178();
    func_269.CmIDT20_input_12 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_179();
    func_269.CmIDT20_input_13 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_181();
    func_269.CmIDT20_input_14 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_182();
    func_269.CmIDT20_input_15 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_183();
    func_269.CmIDT20_input_16 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_184();
    func_269.CmIDT20_input_17 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_185();
    func_269.CmIDT20_input_18 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_186();
    func_269.CmIDT20_input_19 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_187();
    func_269.CmIDT20_input_20 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_192();
    func_269.Execute(  );
    setParameter(9, func_269.CmIDT20_output_21);
    setParameter(10, func_269.CmIDT20_output_22);
    setParameter(11, func_269.CmIDT20_output_23);
    setParameter(12, func_269.CmIDT20_output_24);
    setParameter(13, func_269.CmIDT20_output_25);
    setParameter(14, func_269.CmIDT20_output_26);
    setParameter(15, func_269.CmIDT20_output_27);
    setParameter(16, func_269.CmIDT20_output_28);
    setParameter(17, func_269.CmIDT20_output_29);
    setParameter(18, func_269.CmIDT20_output_30);
    setParameter(19, func_269.CmIDT20_output_31);
    setParameter(20, func_269.CmIDT20_output_32);
    setParameter(8, func_269.CmIDT20_output_33);
    setParameter(21, func_269.CmIDT20_output_34);
    setParameter(22, func_269.CmIDT20_output_35);
    setParameter(23, func_269.CmIDT20_output_36);
    setParameter(24, func_269.CmIDT20_output_37);
    setParameter(25, func_269.CmIDT20_output_38);
    setParameter(26, func_269.CmIDT20_output_39);
    setParameter(72, func_269.CmIDT20_output_40);

    // [257] Macro call CmIDT10
    func_257.CmIDT10_input_1 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_190();
    func_257.CmIDT10_input_2 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_191();
    func_257.CmIDT10_input_3 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_170();
    func_257.CmIDT10_input_4 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_350();
    func_257.CmIDT10_input_5 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_350();
    func_257.CmIDT10_input_6 = 0F;
    func_257.CmIDT10_input_7 = 0F;
    func_257.CmIDT10_input_8 = 0F;
    func_257.CmIDT10_input_9 = 0F;
    func_257.CmIDT10_input_10 = 0F;
    func_257.Execute(  );
    setParameter(0, func_257.CmIDT10_output_21);
    setParameter(1, func_257.CmIDT10_output_22);
    setParameter(91, func_257.CmIDT10_output_23);
    setParameter(27, func_257.CmIDT10_output_24);
    setParameter(2, func_257.CmIDT10_output_25);

    // [254] Macro call CmContinous_Flow_G1
    func_254.CmContinous_Flow_G1_input_1 = (float) getCmCSB_HtgStrategy_1gr_SST_input_135().getValue();
    func_254.CmContinous_Flow_G1_input_2 = (float) getCmCSB_HtgStrategy_1gr_SST_input_133().getValue();
    func_254.CmContinous_Flow_G1_input_75 = 1F;
    func_254.Execute( this, 0 );
    setCmCSB_HtgStrategy_1gr_SST_output_146(func_254.CmContinous_Flow_G1_output_81);

    // [209] Macro call CmHeatGenCommands
    func_209.CmHeatGenCommands_input_1 = 0F;
    func_209.CmHeatGenCommands_input_2 = 0F;
    func_209.CmHeatGenCommands_input_67 = true;
    func_209.Execute( this, 4 );

    // [253] Macro call CmSeqOpMode
    func_253.Execute( this, 8 );

    // [218] Macro call CmHeatGenDemand
    func_218.CmHeatGenDemand_input_1 = (float) getCmCSB_HtgStrategy_1gr_SST_input_133().getValue();
    func_218.CmHeatGenDemand_input_2 = (float) getCmCSB_HtgStrategy_1gr_SST_input_131().getValue();
    func_218.CmHeatGenDemand_input_3 = (float) getCmCSB_HtgStrategy_1gr_SST_input_132().getValue();
    func_218.CmHeatGenDemand_input_67 = (float) getCmCSB_HtgStrategy_1gr_SST_input_135().getValue();
    func_218.CmHeatGenDemand_input_90 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_357();
    func_218.CmHeatGenDemand_input_91 = 1F;
    func_218.Execute( this, 9 );
    setCmCSB_HtgStrategy_1gr_SST_output_349(func_218.CmHeatGenDemand_output_4);
    setCmCSB_HtgStrategy_1gr_SST_parameter_193(func_218.CmHeatGenDemand_output_48);
    setCmCSB_HtgStrategy_1gr_SST_parameter_194(func_218.CmHeatGenDemand_output_49);
    setCmCSB_HtgStrategy_1gr_SST_output_137(func_218.CmHeatGenDemand_output_50);

    // [365] Macro call CmEmergency_Stop
    func_365.CmEmergency_Stop_input_1 = 1F;
    func_365.CmEmergency_Stop_input_4 = getCmCSB_HtgStrategy_1gr_SST_input_134().getValue();
    func_365.CmEmergency_Stop_input_30 = func_218.CmHeatGenDemand_output_5;
    func_365.Execute(  );

    // [250] Function call CfIdt
    func_250.input = func_365.CmEmergency_Stop_output_25;
    func_250.Execute(  );
    setCmCSB_HtgStrategy_1gr_SST_output_142(func_250.output[0]);

    // [315] Macro call CmSetStages
    func_315.CmSetStages_input_1 = func_365.CmEmergency_Stop_output_25;
    func_315.CmSetStages_input_35 = 1F;
    func_315.CmSetStages_input_112 = getCmCSB_HtgStrategy_1gr_SST_input_134().getValue();
    func_315.Execute( this, 72 );

    // [295] Function call CfRdGlobalRegister
    func_295.inputRegister = 1015;
    func_295.inputReset = false;
    func_295.inputResetValue = 0F;
    func_295.Execute(  );
    setCmCSB_HtgStrategy_1gr_SST_parameter_192(func_295.output);

    // [297] Function call CfWrGlobalRegister
    func_297.inputValue = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_235();
    func_297.inputRegister = 977;
    func_297.inputEnable = true;
    func_297.inputMode = 0;
    func_297.Execute(  );

    // [335] Macro call CmShow_Block_Override_Signals
    func_335.CmShow_Block_Override_Signals_input_12 = (float) getCmCSB_HtgStrategy_1gr_SST_input_131().getValue();
    func_335.CmShow_Block_Override_Signals_input_35 = false;
    func_335.CmShow_Block_Override_Signals_input_55 = 1F;
    func_335.CmShow_Block_Override_Signals_input_68 = (float) getCmCSB_HtgStrategy_1gr_SST_input_132().getValue();
    func_335.Execute( this, 91 );
    setCmCSB_HtgStrategy_1gr_SST_output_140(func_335.CmShow_Block_Override_Signals_output_2);
    setCmCSB_HtgStrategy_1gr_SST_output_143(func_335.CmShow_Block_Override_Signals_output_3);
    setCmCSB_HtgStrategy_1gr_SST_output_144(func_335.CmShow_Block_Override_Signals_output_4);

    // [327] Macro call CmShowPower
    func_327.CmShowPower_input_6 = 1F;
    func_327.Execute(  );
    setCmCSB_HtgStrategy_1gr_SST_output_138(func_327.CmShowPower_output_1);
    setCmCSB_HtgStrategy_1gr_SST_output_139(func_327.CmShowPower_output_2);

    // [420] Function call CfCompare2
    func_420.inputA = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_181();
    func_420.inputB = 2F;
    func_420.Execute(  );

    // [419] Function call CfInputMultiplexer
    func_419.inputSelect = BooleanToInt(func_420.outputEqualOrLess);
    func_419.input[1-1] = 0F;
    func_419.input[2-1] = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_180();
    func_419.Execute(  );

    // [348] Function call CfWrGlobalRegister
    func_348.inputValue = func_419.output;
    func_348.inputRegister = 972;
    func_348.inputEnable = true;
    func_348.inputMode = 0;
    func_348.Execute(  );

    // [363] Macro call CmHoldSetpointOutput
    func_363.CmHoldSetpointOutput_input_1 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_360();
    func_363.CmHoldSetpointOutput_input_3 = (float) getCmCSB_HtgStrategy_1gr_SST_parameter_350();
    func_363.CmHoldSetpointOutput_input_4 = (float) getCmCSB_HtgStrategy_1gr_SST_input_133().getValue();
    func_363.Execute(  );

    // [367] Function call CfWrGlobalRegister
    func_367.inputValue = 1F;
    func_367.inputRegister = 968;
    func_367.inputEnable = true;
    func_367.inputMode = 0;
    func_367.Execute(  );

    // [371] Function call CfWrGlobalRegister
    func_371.inputValue = 0F;
    func_371.inputRegister = 1015;
    func_371.inputEnable = true;
    func_371.inputMode = 0;
    func_371.Execute(  );

    // [399] Macro call CmHeatGenAlarm
    func_399.Execute(  );
    setCmCSB_HtgStrategy_1gr_SST_output_141(func_399.CmHeatGenAlarm_output_16);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 100F, 20F, 0F, 0F, 3F, 0F, 3F,
    1F, 3F, 50F, 90F, 5F, 25F, 10F, 0F,
    5F, 10F, 3F, 20F, 10F, -10F, 0F, 30F,
    15F, 0F, 0F, 20F, 50F, 90F, 5F, 25F,
    20F, 3F, 10F, 0F, 3F, 3F, 0F, 1000F,
    100F, 0F, 10F, 60F, 10F, 90F, 1F, 60F,
    5F, 10F, 3F, 20F, 10F, -10F, 0F, 30F,
    15F, 0F, 0F, 0F, 0F, 0F, 0F, 10F,
    10F, 0F, 0F, 0F, 0F, 10F, 10F, 10F,
    0F, 0F, 0F, 2F, 2F, 2F, 2F, 2F,
    2F, 2F, 2F, 2F, 2F, 2F, 2F, 2F,
    2F, 2F, 2F, 90F, 0F, 3F, 0F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// DispEffHtgSp
  public static final Property CmCSB_HtgStrategy_1gr_SST_output_137 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmCSB_HtgStrategy_1gr_SST_output_137() { return (BStatusNumeric) get(CmCSB_HtgStrategy_1gr_SST_output_137); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_137(BStatusNumeric v) { set(CmCSB_HtgStrategy_1gr_SST_output_137,v,null); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_137(float v) { getCmCSB_HtgStrategy_1gr_SST_output_137().setValue(v); }
// IntContrSig
  public static final Property CmCSB_HtgStrategy_1gr_SST_output_349 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("percent")));
  public BStatusNumeric getCmCSB_HtgStrategy_1gr_SST_output_349() { return (BStatusNumeric) get(CmCSB_HtgStrategy_1gr_SST_output_349); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_349(BStatusNumeric v) { set(CmCSB_HtgStrategy_1gr_SST_output_349,v,null); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_349(float v) { getCmCSB_HtgStrategy_1gr_SST_output_349().setValue(v); }
// DispActPower
  public static final Property CmCSB_HtgStrategy_1gr_SST_output_138 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("kilowatt")));
  public BStatusNumeric getCmCSB_HtgStrategy_1gr_SST_output_138() { return (BStatusNumeric) get(CmCSB_HtgStrategy_1gr_SST_output_138); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_138(BStatusNumeric v) { set(CmCSB_HtgStrategy_1gr_SST_output_138,v,null); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_138(float v) { getCmCSB_HtgStrategy_1gr_SST_output_138().setValue(v); }
// DispSparePower
  public static final Property CmCSB_HtgStrategy_1gr_SST_output_139 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("kilowatt")));
  public BStatusNumeric getCmCSB_HtgStrategy_1gr_SST_output_139() { return (BStatusNumeric) get(CmCSB_HtgStrategy_1gr_SST_output_139); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_139(BStatusNumeric v) { set(CmCSB_HtgStrategy_1gr_SST_output_139,v,null); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_139(float v) { getCmCSB_HtgStrategy_1gr_SST_output_139().setValue(v); }
// DispBlockSignal
  public static final Property CmCSB_HtgStrategy_1gr_SST_output_140 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSB_HtgStrategy_1gr_SST_output_140() { return (BStatusNumeric) get(CmCSB_HtgStrategy_1gr_SST_output_140); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_140(BStatusNumeric v) { set(CmCSB_HtgStrategy_1gr_SST_output_140,v,null); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_140(float v) { getCmCSB_HtgStrategy_1gr_SST_output_140().setValue(v); }
// HeatGen_inAlarm
  public static final Property CmCSB_HtgStrategy_1gr_SST_output_141 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSB_HtgStrategy_1gr_SST_output_141() { return (BStatusNumeric) get(CmCSB_HtgStrategy_1gr_SST_output_141); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_141(BStatusNumeric v) { set(CmCSB_HtgStrategy_1gr_SST_output_141,v,null); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_141(float v) { getCmCSB_HtgStrategy_1gr_SST_output_141().setValue(v); }
// ActReqHeatGen
  public static final Property CmCSB_HtgStrategy_1gr_SST_output_142 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSB_HtgStrategy_1gr_SST_output_142() { return (BStatusNumeric) get(CmCSB_HtgStrategy_1gr_SST_output_142); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_142(BStatusNumeric v) { set(CmCSB_HtgStrategy_1gr_SST_output_142,v,null); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_142(float v) { getCmCSB_HtgStrategy_1gr_SST_output_142().setValue(v); }
// OverheatProt
  public static final Property CmCSB_HtgStrategy_1gr_SST_output_143 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmCSB_HtgStrategy_1gr_SST_output_143() { return (BStatusBoolean) get(CmCSB_HtgStrategy_1gr_SST_output_143); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_143(BStatusBoolean v) { set(CmCSB_HtgStrategy_1gr_SST_output_143,v,null); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_143(boolean v) { getCmCSB_HtgStrategy_1gr_SST_output_143().setValue(v); }
// CondensProt
  public static final Property CmCSB_HtgStrategy_1gr_SST_output_144 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmCSB_HtgStrategy_1gr_SST_output_144() { return (BStatusBoolean) get(CmCSB_HtgStrategy_1gr_SST_output_144); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_144(BStatusBoolean v) { set(CmCSB_HtgStrategy_1gr_SST_output_144,v,null); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_144(boolean v) { getCmCSB_HtgStrategy_1gr_SST_output_144().setValue(v); }
// ContinuousFlow
  public static final Property CmCSB_HtgStrategy_1gr_SST_output_146 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmCSB_HtgStrategy_1gr_SST_output_146() { return (BStatusBoolean) get(CmCSB_HtgStrategy_1gr_SST_output_146); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_146(BStatusBoolean v) { set(CmCSB_HtgStrategy_1gr_SST_output_146,v,null); }
  public void setCmCSB_HtgStrategy_1gr_SST_output_146(boolean v) { getCmCSB_HtgStrategy_1gr_SST_output_146().setValue(v); }

  // macro parameter
// CFG-01: control mode configuration
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_234 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_234() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_234); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_234(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_234,v,null); }
// CFG-02: maximum number of redundant heat generators
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_357 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_357() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_357); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_357(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_357,v,null); }
// SST-01: minimum supply temperature
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_169 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_169() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_169); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_169(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_169,v,null); }
// SST-02: maximum supply temperature
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_170 = newProperty( 0, BDouble.make( 90 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_170() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_170); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_170(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_170,v,null); }
// SST-03: setpoint raise
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_171 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_171() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_171); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_171(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_171,v,null); }
// SST-04: maximum setpoint increment per minute
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_172 = newProperty( 0, BDouble.make( 25 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_172() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_172); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_172(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_172,v,null); }
// SST-05: minimum heat demand to start heat generators
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_350 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_350() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_350); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_350(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_350,v,null); }
// SST-06: P-band following stages control
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_173 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(2000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_173() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_173); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_173(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_173,v,null); }
// SST-07: I-time following stages control
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_174 = newProperty( 0, BDouble.make( 90 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_174() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_174); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_174(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_174,v,null); }
// SST-08: forward time expected system supply temperature (DISP-05)
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_175 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(60)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_175() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_175); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_175(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_175,v,null); }
// SST-09: time to reach setpoint
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_176 = newProperty( 0, BDouble.make( 6 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_176() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_176); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_176(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_176,v,null); }
// SST-10: control region following stages
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_177 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_177() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_177); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_177(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_177,v,null); }
// SST-11: temperature span switching on boilers
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_178 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(2)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_178() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_178); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_178(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_178,v,null); }
// SST-12: temperature span switching off boilers
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_179 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(2)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_179() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_179); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_179(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_179,v,null); }
// OPM-01: optimized off
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_180 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(2500)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_180() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_180); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_180(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_180,v,null); }
// OPM-02: group 1 operation mode
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_181 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_181() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_181); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_181(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_181,v,null); }
// CYC-01: cyclic changeover sequence
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_235 = newProperty( 0, BDouble.make( 116 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1616)), BFacets.make(BFacets.MIN, BDouble.make(102)) ));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_235() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_235); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_235(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_235,v,null); }
// OAT-01: low limit outside air temperature to enable the next boiler
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_182 = newProperty( 0, BDouble.make( -10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_182() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_182); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_182(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_182,v,null); }
// OAT-02: high limit outside air temperature to disable the next boiler
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_183 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_183() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_183); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_183(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_183,v,null); }
// OVR-01: high limit control deviation to enable the next boiler
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_184 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(10)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_184() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_184); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_184(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_184,v,null); }
// OVR-02: low limit control deviation to disable the next boiler
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_185 = newProperty( 0, BDouble.make( 15 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_185() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_185); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_185(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_185,v,null); }
// OVR-03: switch on delay enable next boiler override
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_186 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(480)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_186() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_186); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_186(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_186,v,null); }
// OVR-04 switch off delay enable next boiler override
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_187 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(480)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_187() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_187); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_187(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_187,v,null); }
// SYS-01: continuous flow enabled
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_190 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_190() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_190); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_190(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_190,v,null); }
// SYS-02: continuous flow time
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_191 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2400)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_191() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_191); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_191(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_191,v,null); }
// SYS-03: leading boiler holds the setpoint output
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_360 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_360() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_360); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_360(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_360,v,null); }
// DISP-01: number of heat generators group 1/ 123
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_192 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_192() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_192); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_192(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_192,v,null); }
// DISP-04: calculated time to reach setpoint
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_193 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_193() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_193); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_193(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_193,v,null); }
// DISP-05: expected system supply temperature from SST-08
  public static final Property CmCSB_HtgStrategy_1gr_SST_parameter_194 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSB_HtgStrategy_1gr_SST_parameter_194() { return getDouble(CmCSB_HtgStrategy_1gr_SST_parameter_194); }
  public void setCmCSB_HtgStrategy_1gr_SST_parameter_194(double v) { setDouble(CmCSB_HtgStrategy_1gr_SST_parameter_194,v,null); }

  // macro inputs
// SysSupplyTemp
  public static final Property CmCSB_HtgStrategy_1gr_SST_input_131 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmCSB_HtgStrategy_1gr_SST_input_131() { return (BStatusNumeric) get(CmCSB_HtgStrategy_1gr_SST_input_131); }
  public void setCmCSB_HtgStrategy_1gr_SST_input_131(BStatusNumeric v) { set(CmCSB_HtgStrategy_1gr_SST_input_131,v,null); }
  public void setCmCSB_HtgStrategy_1gr_SST_input_131(float v) { getCmCSB_HtgStrategy_1gr_SST_input_131().setValue(v); }
// SysRetTemp
  public static final Property CmCSB_HtgStrategy_1gr_SST_input_132 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmCSB_HtgStrategy_1gr_SST_input_132() { return (BStatusNumeric) get(CmCSB_HtgStrategy_1gr_SST_input_132); }
  public void setCmCSB_HtgStrategy_1gr_SST_input_132(BStatusNumeric v) { set(CmCSB_HtgStrategy_1gr_SST_input_132,v,null); }
  public void setCmCSB_HtgStrategy_1gr_SST_input_132(float v) { getCmCSB_HtgStrategy_1gr_SST_input_132().setValue(v); }
// HeatDemandIn
  public static final Property CmCSB_HtgStrategy_1gr_SST_input_133 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmCSB_HtgStrategy_1gr_SST_input_133() { return (BStatusNumeric) get(CmCSB_HtgStrategy_1gr_SST_input_133); }
  public void setCmCSB_HtgStrategy_1gr_SST_input_133(BStatusNumeric v) { set(CmCSB_HtgStrategy_1gr_SST_input_133,v,null); }
  public void setCmCSB_HtgStrategy_1gr_SST_input_133(float v) { getCmCSB_HtgStrategy_1gr_SST_input_133().setValue(v); }
// FilteredOATemp
  public static final Property CmCSB_HtgStrategy_1gr_SST_input_135 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmCSB_HtgStrategy_1gr_SST_input_135() { return (BStatusNumeric) get(CmCSB_HtgStrategy_1gr_SST_input_135); }
  public void setCmCSB_HtgStrategy_1gr_SST_input_135(BStatusNumeric v) { set(CmCSB_HtgStrategy_1gr_SST_input_135,v,null); }
  public void setCmCSB_HtgStrategy_1gr_SST_input_135(float v) { getCmCSB_HtgStrategy_1gr_SST_input_135().setValue(v); }
// EmergStop
  public static final Property CmCSB_HtgStrategy_1gr_SST_input_134 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmCSB_HtgStrategy_1gr_SST_input_134() { return (BStatusBoolean) get(CmCSB_HtgStrategy_1gr_SST_input_134); }
  public void setCmCSB_HtgStrategy_1gr_SST_input_134(BStatusBoolean v) { set(CmCSB_HtgStrategy_1gr_SST_input_134,v,null); }
  public void setCmCSB_HtgStrategy_1gr_SST_input_134(boolean v) { getCmCSB_HtgStrategy_1gr_SST_input_134().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.03 [142] 05.03.2018-13:30").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6017706291678413685").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmCSB_HtgStrategy_1gr_SST.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

  // class variables
  protected CmCommRegistersHeating func_372 = new CmCommRegistersHeating();
  protected CmIDT20 func_269 = new CmIDT20();
  protected CmIDT10 func_257 = new CmIDT10();
  protected CmContinous_Flow_G1 func_254 = new CmContinous_Flow_G1();
  protected CmHeatGenCommands func_209 = new CmHeatGenCommands();
  protected CmSeqOpMode func_253 = new CmSeqOpMode();
  protected CmHeatGenDemand func_218 = new CmHeatGenDemand();
  protected CmEmergency_Stop func_365 = new CmEmergency_Stop();
  protected CfIdt func_250 = new CfIdt();
  protected CmSetStages func_315 = new CmSetStages();
  protected CfRdGlobalRegister func_295 = new CfRdGlobalRegister();
  protected CfWrGlobalRegister func_297 = new CfWrGlobalRegister();
  protected CmShow_Block_Override_Signals func_335 = new CmShow_Block_Override_Signals();
  protected CmShowPower func_327 = new CmShowPower();
  protected CfCompare2 func_420 = new CfCompare2();
  protected CfInputMultiplexer func_419 = new CfInputMultiplexer();
  protected CfWrGlobalRegister func_348 = new CfWrGlobalRegister();
  protected CmHoldSetpointOutput func_363 = new CmHoldSetpointOutput();
  protected CfWrGlobalRegister func_367 = new CfWrGlobalRegister();
  protected CfWrGlobalRegister func_371 = new CfWrGlobalRegister();
  protected CmHeatGenAlarm func_399 = new CmHeatGenAlarm();

  // default constructor
  public BCmCSB_HtgStrategy_1gr_SST()
  {
  }

  public void Start()
  {
    func_372.Start();
    func_269.Start();
    func_257.Start();
    func_254.Start();
    func_209.Start();
    func_253.Start();
    func_218.Start();
    func_365.Start();
    func_315.Start();
    func_335.Start();
    func_327.Start();
    func_363.Start();
    func_399.Start();
  }
}
