/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    DHA_DHW
Macro id:      5979162542457487717
Macro version: 95
Last change:   15.01.2019 - 16:33
Access Level:  2
Inputs:
  [1] UpperTemp
  [2] LowerTemp
  [3] DHW_TempSp
  [4] SysSupplyTemp
  [5] RenEnergCharge
  [6] LegionellaEnable
  [7] CircPumpDemand
  [8] MaxThermostat
  [9] DayExtension
  [10] HolidaySwitch
  [11] OverheatProt
  [12] Reset
Outputs:
  [1] ChargPumpCmd
  [2] ValveControl
  [3] CircPumpCmd
  [4] CalcDHWTempSp
  [5] CalcHtgDemand
  [6] LegionellaActive
  [7] DHWS_Priority
  [8] DHWS_SST_Alm
  [9] DHWS_Leg_Alm
  [10] OperationMode
Parameter:
  [1] CFG-01: system configuration
  [2] UWT-01: P-band buffer temperature control
  [3] LWT-02: D-time buffer temperature control
  [4] SST-01: temp. difference primary/secondary system
  [5] SST-02: time to reach SST setpoint
  [6] SST-03: heat demand setpoint shift
  [7] PRP-01: start-up delay primary pump/ secondary pump
  [8] PRP-02: switch off delay primary pump
  [9] SEP-02: circulation pump switch off delay
  [10] SEP-03: run circulation pump during occupied periods and extended operation
  [11] SEP-04: circulation pump during overheat protection
  [12] LEG-01: anti-legionella stpoint
  [13] LEG-02: time to reach legionella setpoint
  [14] LEG-03: legionella duration
  [15] DEX-01: DHW setpoint extended operation
  [16] DEX-02: auto reset time from extended operation
  [17] SYS-01: occupied/ un-occupied changeover
  [18] SYS-02: setpoint raise at OverheatProt
  [19] SYS-03: setpoint decrease/ minute after a Heat Override
  [20] SYS-04: temperature drop for prority request
  [21] SYS-05: heat demand transmission
  [22] SYS-06: automatic/ manual reset
  [23] DISP-01: calculated DHWS temperature setpoint
  [24] DISP-02: operatiing mode
Description:
The most important domestic hot water control functions are listed below:
·   modulating or on-off control with on one single temperature sensor or an upper and a lower temperature sensor
·   protection function against cooling down
·   heat demand transmission to primary heat generators
·   direct fired DHW control
·   legionella protection increasing the buffer temperature setpoint
·   charging and secondary pump commands
·   circulation pump control
·   maximum thermostat to switch off control functions in case of too high buffer temperatures
================================================================================*/

public class BCmDHA_DHW
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmDHA_DHW_output_19().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmDHA_DHW_output_19().setStatus(BStatus.disabled);
    getCmDHA_DHW_output_20().setStatus(BStatus.disabled);
    getCmDHA_DHW_output_21().setStatus(BStatus.disabled);
    getCmDHA_DHW_output_22().setStatus(BStatus.disabled);
    getCmDHA_DHW_output_23().setStatus(BStatus.disabled);
    getCmDHA_DHW_output_24().setStatus(BStatus.disabled);
    getCmDHA_DHW_output_25().setStatus(BStatus.disabled);
    getCmDHA_DHW_output_26().setStatus(BStatus.disabled);
    getCmDHA_DHW_output_27().setStatus(BStatus.disabled);
    getCmDHA_DHW_output_28().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmDHA_DHW_output_19().setStatus(BStatus.ok);
    getCmDHA_DHW_output_20().setStatus(BStatus.ok);
    getCmDHA_DHW_output_21().setStatus(BStatus.ok);
    getCmDHA_DHW_output_22().setStatus(BStatus.ok);
    getCmDHA_DHW_output_23().setStatus(BStatus.ok);
    getCmDHA_DHW_output_24().setStatus(BStatus.ok);
    getCmDHA_DHW_output_25().setStatus(BStatus.ok);
    getCmDHA_DHW_output_26().setStatus(BStatus.ok);
    getCmDHA_DHW_output_27().setStatus(BStatus.ok);
    getCmDHA_DHW_output_28().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [50] Function call CfTruncate
    func_50.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_50.Execute(  );

    // [55] Function call CfMonoflop
    func_55.input = BooleanToFloat(getCmDHA_DHW_input_18().getValue());
    func_55.Execute( this, 0 );

    // [74] Function call CfWindow
    func_74.inputValue = (float) getCmDHA_DHW_parameter_29();
    func_74.inputMinimum = 1.8F;
    func_74.inputMaximum = 3.2F;
    func_74.Execute(  );

    // [82] Function call CfWindow
    func_82.inputValue = (float) getCmDHA_DHW_parameter_29();
    func_82.inputMinimum = 0.8F;
    func_82.inputMaximum = 1.2F;
    func_82.Execute(  );

    // [107] Function call CfWindow
    func_107.inputValue = (float) getCmDHA_DHW_parameter_29();
    func_107.inputMinimum = 1.8F;
    func_107.inputMaximum = 3.2F;
    func_107.Execute(  );

    // [108] Function call CfWindow
    func_108.inputValue = (float) getCmDHA_DHW_parameter_29();
    func_108.inputMinimum = 0.8F;
    func_108.inputMaximum = 1.2F;
    func_108.Execute(  );

    // [162] Macro call CmIDT20
    func_162.CmIDT20_input_1 = (float) getCmDHA_DHW_parameter_42();
    func_162.CmIDT20_input_2 = (float) getCmDHA_DHW_parameter_40();
    func_162.CmIDT20_input_3 = (float) getCmDHA_DHW_parameter_41();
    func_162.CmIDT20_input_4 = (float) getCmDHA_DHW_parameter_42();
    func_162.CmIDT20_input_5 = (float) getCmDHA_DHW_parameter_40();
    func_162.CmIDT20_input_6 = (float) getCmDHA_DHW_parameter_37();
    func_162.CmIDT20_input_7 = (float) getCmDHA_DHW_parameter_43();
    func_162.CmIDT20_input_8 = (float) getCmDHA_DHW_parameter_44();
    func_162.CmIDT20_input_9 = (float) getCmDHA_DHW_parameter_30();
    func_162.CmIDT20_input_10 = (float) getCmDHA_DHW_parameter_37();
    func_162.CmIDT20_input_11 = (float) getCmDHA_DHW_parameter_38();
    func_162.CmIDT20_input_12 = (float) getCmDHA_DHW_parameter_39();
    func_162.CmIDT20_input_13 = (float) getCmDHA_DHW_parameter_47();
    func_162.CmIDT20_input_14 = (float) getCmDHA_DHW_parameter_33();
    func_162.CmIDT20_input_15 = (float) getCmDHA_DHW_parameter_47();
    func_162.CmIDT20_input_16 = (float) getCmDHA_DHW_parameter_30();
    func_162.CmIDT20_input_17 = (float) getCmDHA_DHW_parameter_31();
    func_162.CmIDT20_input_18 = (float) getCmDHA_DHW_parameter_32();
    func_162.CmIDT20_input_19 = (float) getCmDHA_DHW_parameter_47();
    func_162.CmIDT20_input_20 = (float) getCmDHA_DHW_parameter_30();
    func_162.Execute(  );
    setParameter(9, func_162.CmIDT20_output_21);
    setParameter(10, func_162.CmIDT20_output_22);
    setParameter(11, func_162.CmIDT20_output_23);
    setParameter(1, func_162.CmIDT20_output_24);
    setParameter(2, func_162.CmIDT20_output_25);
    setParameter(3, func_162.CmIDT20_output_26);
    setParameter(4, func_162.CmIDT20_output_27);
    setParameter(5, func_162.CmIDT20_output_28);
    setParameter(13, func_162.CmIDT20_output_29);
    setParameter(14, func_162.CmIDT20_output_30);
    setParameter(15, func_162.CmIDT20_output_31);
    setParameter(16, func_162.CmIDT20_output_32);
    setParameter(17, func_162.CmIDT20_output_33);
    setParameter(39, func_162.CmIDT20_output_34);
    setParameter(40, func_162.CmIDT20_output_35);
    setParameter(47, func_162.CmIDT20_output_36);
    setParameter(48, func_162.CmIDT20_output_37);
    setParameter(49, func_162.CmIDT20_output_38);
    setParameter(50, func_162.CmIDT20_output_39);
    setParameter(43, func_162.CmIDT20_output_40);

    // [183] Macro call CmIDT10
    func_183.CmIDT10_input_1 = (float) getCmDHA_DHW_parameter_47();
    func_183.CmIDT10_input_2 = (float) getCmDHA_DHW_parameter_32();
    func_183.CmIDT10_input_3 = (float) getCmDHA_DHW_parameter_35();
    func_183.CmIDT10_input_4 = (float) getCmDHA_DHW_parameter_29();
    func_183.CmIDT10_input_5 = (float) getCmDHA_DHW_parameter_36();
    func_183.CmIDT10_input_6 = (float) getCmDHA_DHW_parameter_32();
    func_183.CmIDT10_input_7 = (float) getCmDHA_DHW_parameter_34();
    func_183.CmIDT10_input_8 = (float) getCmDHA_DHW_parameter_46();
    func_183.CmIDT10_input_9 = (float) getCmDHA_DHW_parameter_32();
    func_183.CmIDT10_input_10 = (float) getCmDHA_DHW_parameter_45();
    func_183.Execute(  );
    setParameter(44, func_183.CmIDT10_output_21);
    setParameter(66, func_183.CmIDT10_output_22);
    setParameter(67, func_183.CmIDT10_output_23);
    setParameter(68, func_183.CmIDT10_output_24);
    setParameter(34, func_183.CmIDT10_output_25);
    setParameter(77, func_183.CmIDT10_output_26);
    setParameter(78, func_183.CmIDT10_output_27);
    setParameter(79, func_183.CmIDT10_output_28);
    setParameter(75, func_183.CmIDT10_output_29);
    setParameter(76, func_183.CmIDT10_output_30);

    // [252] Macro call CmIDT05
    func_252.CmIDT05_input_1 = (float) getCmDHA_DHW_parameter_47();
    func_252.CmIDT05_input_2 = (float) getCmDHA_DHW_parameter_288();
    func_252.CmIDT05_input_3 = (float) getCmDHA_DHW_parameter_287();
    func_252.CmIDT05_input_4 = (float) getCmDHA_DHW_parameter_285();
    func_252.CmIDT05_input_5 = 0F;
    func_252.Execute(  );
    setParameter(80, func_252.CmIDT05_output_21);
    setParameter(35, func_252.CmIDT05_output_22);
    setParameter(36, func_252.CmIDT05_output_23);
    setParameter(69, func_252.CmIDT05_output_24);

    // [66] Macro call CmDHADHW_Setpoint
    func_66.CmDHADHW_Setpoint_input_1 = (float) getCmDHA_DHW_input_8().getValue();
    func_66.CmDHADHW_Setpoint_input_6 = func_100.CmDayExtension_DHADHW_output_4;
    func_66.CmDHADHW_Setpoint_input_7 = getCmDHA_DHW_input_16().getValue();
    func_66.CmDHADHW_Setpoint_input_8 = getCmDHA_DHW_input_17().getValue();
    func_66.CmDHADHW_Setpoint_input_39 = func_92.CmLegionellaProt_output_4;
    func_66.Execute( this, 1 );

    // [100] Macro call CmDayExtension_DHADHW
    func_100.CmDayExtension_DHADHW_input_1 = getCmDHA_DHW_input_15().getValue();
    func_100.CmDayExtension_DHADHW_input_2 = func_66.CmDHADHW_Setpoint_output_10;
    func_100.CmDayExtension_DHADHW_input_3 = getCmDHA_DHW_input_16().getValue();
    func_100.CmDayExtension_DHADHW_input_8 = (float) getCmDHA_DHW_input_8().getValue();
    func_100.Execute( this, 9 );

    // [184] Function call CfIdt
    func_184.input = func_66.CmDHADHW_Setpoint_output_2;
    func_184.Execute(  );
    setCmDHA_DHW_parameter_48(func_184.output[0]);
    setCmDHA_DHW_output_22(func_184.output[1]);

    // [206] Function call CfInputMultiplexer
    func_206.inputSelect = BooleanToInt(func_66.CmDHADHW_Setpoint_output_9);
    func_206.input[1-1] = 1F;
    func_206.input[2-1] = 2F;
    func_206.Execute(  );

    // [92] Macro call CmLegionellaProt
    func_92.CmLegionellaProt_input_1 = func_66.CmDHADHW_Setpoint_output_10;
    func_92.CmLegionellaProt_input_2 = func_100.CmDayExtension_DHADHW_output_4;
    func_92.CmLegionellaProt_input_3 = getCmDHA_DHW_input_12().getValue();
    func_92.CmLegionellaProt_input_5 = (float) getCmDHA_DHW_input_6().getValue();
    func_92.CmLegionellaProt_input_6 = (float) getCmDHA_DHW_input_7().getValue();
    func_92.CmLegionellaProt_input_80 = func_55.output;
    func_92.Execute( this, 13 );
    setCmDHA_DHW_output_27(func_92.CmLegionellaProt_output_8);

    // [64] Macro call CmCirculationPumpCmd
    func_64.CmCirculationPumpCmd_input_1 = getCmDHA_DHW_input_13().getValue();
    func_64.CmCirculationPumpCmd_input_8 = func_92.CmLegionellaProt_output_4;
    func_64.CmCirculationPumpCmd_input_13 = getCmDHA_DHW_input_16().getValue();
    func_64.CmCirculationPumpCmd_input_22 = getCmDHA_DHW_input_14().getValue();
    func_64.CmCirculationPumpCmd_input_23 = getCmDHA_DHW_input_17().getValue();
    func_64.CmCirculationPumpCmd_input_44 = func_66.CmDHADHW_Setpoint_output_9;
    func_64.CmCirculationPumpCmd_input_45 = func_100.CmDayExtension_DHADHW_output_4;
    func_64.Execute( this, 34 );
    setCmDHA_DHW_output_21(func_64.CmCirculationPumpCmd_output_2);

    // [189] Function call CfIdt
    func_189.input = BooleanToFloat(func_92.CmLegionellaProt_output_4);
    func_189.Execute(  );
    setCmDHA_DHW_output_24(FloatToBoolean(func_189.output[0]));

    // [85] Macro call CmTempFailedAlm
    func_85.CmTempFailedAlm_input_1 = (float) getCmDHA_DHW_input_9().getValue();
    func_85.CmTempFailedAlm_input_2 = func_66.CmDHADHW_Setpoint_output_2;
    func_85.CmTempFailedAlm_input_3 = func_55.output;
    func_85.CmTempFailedAlm_input_17 = func_224.outputOR;
    func_85.Execute( this, 39 );

    // [71] Macro call CmOnOff_Control
    if ( func_74.output)
    {
      func_71.CmOnOff_Control_input_1 = func_66.CmDHADHW_Setpoint_output_2;
      func_71.CmOnOff_Control_input_2 = (float) getCmDHA_DHW_input_6().getValue();
      func_71.CmOnOff_Control_input_3 = (float) getCmDHA_DHW_input_7().getValue();
      func_71.CmOnOff_Control_input_57 = func_85.CmTempFailedAlm_output_4;
      func_71.Execute( this, 43 );
    }

    // [294] Function call CfInputMultiplexer
    func_294.inputSelect = BooleanToInt(func_74.output);
    func_294.input[1-1] = 0F;
    func_294.input[2-1] = BooleanToFloat(func_71.CmOnOff_Control_output_4);
    func_294.Execute(  );

    // [79] Macro call CmContinuous_Control
    if ( func_82.output)
    {
      func_79.CmContinuous_Control_input_1 = func_66.CmDHADHW_Setpoint_output_2;
      func_79.CmContinuous_Control_input_2 = (float) getCmDHA_DHW_input_6().getValue();
      func_79.CmContinuous_Control_input_3 = (float) getCmDHA_DHW_input_7().getValue();
      func_79.CmContinuous_Control_input_39 = func_85.CmTempFailedAlm_output_4;
      func_79.Execute( this, 47 );
    }

    // [289] Function call CfInputMultiplexer
    func_289.inputSelect = BooleanToInt(func_82.output);
    func_289.input[1-1] = 0F;
    func_289.input[2-1] = func_79.CmContinuous_Control_output_4;
    func_289.Execute(  );

    // [188] Function call CfIdt
    func_188.input = BooleanToFloat(func_85.CmTempFailedAlm_output_4);
    func_188.Execute(  );
    setCmDHA_DHW_output_26(FloatToBoolean(func_188.output[0]));

    // [63] Macro call CmChargingPumpCmd
    func_63.CmChargingPumpCmd_input_1 = (float) getCmDHA_DHW_input_9().getValue();
    func_63.CmChargingPumpCmd_input_3 = (float) getCmDHA_DHW_input_6().getValue();
    func_63.CmChargingPumpCmd_input_2 = func_289.output;
    func_63.CmChargingPumpCmd_input_120 = FloatToBoolean(func_294.output);
    func_63.CmChargingPumpCmd_input_5 = func_92.CmLegionellaProt_output_4;
    func_63.CmChargingPumpCmd_input_6 = getCmDHA_DHW_input_17().getValue();
    func_63.Execute( this, 66 );

    // [282] Function call CfInputMultiplexer
    func_282.inputSelect = BooleanToInt(getCmDHA_DHW_input_14().getValue());
    func_282.input[1-1] = BooleanToFloat(func_63.CmChargingPumpCmd_output_51);
    func_282.input[2-1] = 0F;
    func_282.Execute(  );
    setCmDHA_DHW_output_19(FloatToBoolean(func_282.output));

    // [103] Macro call CmDHW_Priority
    func_103.CmDHW_Priority_input_1 = (float) getCmDHA_DHW_input_9().getValue();
    func_103.CmDHW_Priority_input_2 = (float) getCmDHA_DHW_input_6().getValue();
    func_103.CmDHW_Priority_input_3 = func_66.CmDHADHW_Setpoint_output_2;
    func_103.CmDHW_Priority_input_4 = func_289.output;
    func_103.CmDHW_Priority_input_5 = FloatToBoolean(func_294.output);
    func_103.Execute( this, 75 );
    setCmDHA_DHW_output_25(func_103.CmDHW_Priority_output_6);

    // [111] Function call CfAnd
    func_111.input[0] = func_108.output;
    func_111.input[1] = func_63.CmChargingPumpCmd_output_52;
    func_111.Execute(  );

    // [116] Function call CfAnd
    func_116.input[0] = func_107.output;
    func_116.input[1] = func_63.CmChargingPumpCmd_output_52;
    func_116.Execute(  );

    // [202] Function call CfNot
    func_202.input = func_63.CmChargingPumpCmd_output_52;
    func_202.Execute(  );

    // [224] Function call CfOr
    func_224.input[0] = getCmDHA_DHW_output_19().getValue();
    func_224.input[1] = func_85.CmTempFailedAlm_output_4;
    func_224.Execute(  );

    // [120] Function call CfInputMultiplexer
    func_120.inputSelect = BooleanToInt(func_116.outputAND);
    func_120.input[1-1] = 0F;
    func_120.input[2-1] = 100F;
    func_120.Execute(  );

    // [199] Function call CfAnd
    func_199.input[0] = func_202.output;
    func_199.input[1] = getCmDHA_DHW_output_19().getValue();
    func_199.Execute(  );

    // [114] Function call CfInputMultiplexer
    func_114.inputSelect = BooleanToInt(func_111.outputAND);
    func_114.input[1-1] = func_120.output;
    func_114.input[2-1] = func_289.output;
    func_114.Execute(  );

    // [278] Function call CfInputMultiplexer
    func_278.inputSelect = BooleanToInt(getCmDHA_DHW_input_14().getValue());
    func_278.input[1-1] = func_114.output;
    func_278.input[2-1] = 0F;
    func_278.Execute(  );
    setCmDHA_DHW_output_20(func_278.output);

    // [196] Function call CfInputMultiplexer
    func_196.inputSelect = BooleanToInt(func_199.outputAND);
    func_196.input[1-1] = func_206.output;
    func_196.input[2-1] = 6F;
    func_196.Execute(  );

    // [192] Function call CfInputMultiplexer
    func_192.inputSelect = BooleanToInt(getCmDHA_DHW_output_25().getValue());
    func_192.input[1-1] = func_196.output;
    func_192.input[2-1] = 7F;
    func_192.Execute(  );

    // [205] Function call CfInputMultiplexer
    func_205.inputSelect = BooleanToInt(getCmDHA_DHW_input_17().getValue());
    func_205.input[1-1] = func_192.output;
    func_205.input[2-1] = 8F;
    func_205.Execute(  );

    // [195] Function call CfInputMultiplexer
    func_195.inputSelect = BooleanToInt(getCmDHA_DHW_output_26().getValue());
    func_195.input[1-1] = func_205.output;
    func_195.input[2-1] = 9F;
    func_195.Execute(  );

    // [204] Function call CfInputMultiplexer
    func_204.inputSelect = BooleanToInt(func_92.CmLegionellaProt_output_4);
    func_204.input[1-1] = func_195.output;
    func_204.input[2-1] = 10F;
    func_204.Execute(  );

    // [251] Function call CfInputMultiplexer
    func_251.inputSelect = BooleanToInt(getCmDHA_DHW_output_27().getValue());
    func_251.input[1-1] = func_204.output;
    func_251.input[2-1] = 11F;
    func_251.Execute(  );

    // [190] Function call CfInputMultiplexer
    func_190.inputSelect = BooleanToInt(getCmDHA_DHW_input_14().getValue());
    func_190.input[1-1] = func_251.output;
    func_190.input[2-1] = 12F;
    func_190.Execute(  );

    // [214] Function call CfIdt
    func_214.input = func_190.output;
    func_214.Execute(  );
    setCmDHA_DHW_parameter_49(func_214.output[0]);
    setCmDHA_DHW_output_28(func_214.output[1]);

    // [90] Macro call CmHeatDemand_DHADHW
    func_90.CmHeatDemand_DHADHW_input_1 = func_66.CmDHADHW_Setpoint_output_2;
    func_90.CmHeatDemand_DHADHW_input_2 = getCmDHA_DHW_input_11().getValue();
    func_90.CmHeatDemand_DHADHW_input_7 = func_289.output;
    func_90.CmHeatDemand_DHADHW_input_8 = FloatToBoolean(func_294.output);
    func_90.CmHeatDemand_DHADHW_input_50 = (float) getCmDHA_DHW_output_28().getValue();
    func_90.CmHeatDemand_DHADHW_input_71 = func_100.CmDayExtension_DHADHW_output_4;
    func_90.Execute( this, 77 );
    setCmDHA_DHW_output_23(func_90.CmHeatDemand_DHADHW_output_3);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    10F, 0F, 0F, 0F, 0F, 0F, 999999F, 10F,
    3F, 0F, 0F, 0F, 1F, 0F, 0F, 0F,
    0F, 0F, 2F, 10F, 0F, 0F, 0F, 3F,
    10F, 0F, 0F, 0F, 3F, 10F, 0F, 5F,
    5F, 0F, 0F, 0F, 0F, 0F, 10F, 0F,
    0F, 10F, 10F, 0F, 0F, 0F, 3F, 0F,
    0F, 0F, 0F, 3F, 0F, 0F, 100F, 0F,
    3F, 0F, 1000F, 100F, 0F, 3F, 0F, 1000F,
    100F, 0F, 0F, 0F, 0F, 0F, 2F, 10F,
    0F, 0F, 10F, 0F, 0F, 0F, 0F, 0F,
    0F, 2F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// ChargPumpCmd
  public static final Property CmDHA_DHW_output_19 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDHA_DHW_output_19() { return (BStatusBoolean) get(CmDHA_DHW_output_19); }
  public void setCmDHA_DHW_output_19(BStatusBoolean v) { set(CmDHA_DHW_output_19,v,null); }
  public void setCmDHA_DHW_output_19(boolean v) { getCmDHA_DHW_output_19().setValue(v); }
// ValveControl
  public static final Property CmDHA_DHW_output_20 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmDHA_DHW_output_20() { return (BStatusNumeric) get(CmDHA_DHW_output_20); }
  public void setCmDHA_DHW_output_20(BStatusNumeric v) { set(CmDHA_DHW_output_20,v,null); }
  public void setCmDHA_DHW_output_20(float v) { getCmDHA_DHW_output_20().setValue(v); }
// CircPumpCmd
  public static final Property CmDHA_DHW_output_21 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDHA_DHW_output_21() { return (BStatusBoolean) get(CmDHA_DHW_output_21); }
  public void setCmDHA_DHW_output_21(BStatusBoolean v) { set(CmDHA_DHW_output_21,v,null); }
  public void setCmDHA_DHW_output_21(boolean v) { getCmDHA_DHW_output_21().setValue(v); }
// CalcDHWTempSp
  public static final Property CmDHA_DHW_output_22 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmDHA_DHW_output_22() { return (BStatusNumeric) get(CmDHA_DHW_output_22); }
  public void setCmDHA_DHW_output_22(BStatusNumeric v) { set(CmDHA_DHW_output_22,v,null); }
  public void setCmDHA_DHW_output_22(float v) { getCmDHA_DHW_output_22().setValue(v); }
// CalcHtgDemand
  public static final Property CmDHA_DHW_output_23 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmDHA_DHW_output_23() { return (BStatusNumeric) get(CmDHA_DHW_output_23); }
  public void setCmDHA_DHW_output_23(BStatusNumeric v) { set(CmDHA_DHW_output_23,v,null); }
  public void setCmDHA_DHW_output_23(float v) { getCmDHA_DHW_output_23().setValue(v); }
// LegionellaActive
  public static final Property CmDHA_DHW_output_24 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDHA_DHW_output_24() { return (BStatusBoolean) get(CmDHA_DHW_output_24); }
  public void setCmDHA_DHW_output_24(BStatusBoolean v) { set(CmDHA_DHW_output_24,v,null); }
  public void setCmDHA_DHW_output_24(boolean v) { getCmDHA_DHW_output_24().setValue(v); }
// DHWS_Priority
  public static final Property CmDHA_DHW_output_25 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDHA_DHW_output_25() { return (BStatusBoolean) get(CmDHA_DHW_output_25); }
  public void setCmDHA_DHW_output_25(BStatusBoolean v) { set(CmDHA_DHW_output_25,v,null); }
  public void setCmDHA_DHW_output_25(boolean v) { getCmDHA_DHW_output_25().setValue(v); }
// DHWS_SST_Alm
  public static final Property CmDHA_DHW_output_26 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDHA_DHW_output_26() { return (BStatusBoolean) get(CmDHA_DHW_output_26); }
  public void setCmDHA_DHW_output_26(BStatusBoolean v) { set(CmDHA_DHW_output_26,v,null); }
  public void setCmDHA_DHW_output_26(boolean v) { getCmDHA_DHW_output_26().setValue(v); }
// DHWS_Leg_Alm
  public static final Property CmDHA_DHW_output_27 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDHA_DHW_output_27() { return (BStatusBoolean) get(CmDHA_DHW_output_27); }
  public void setCmDHA_DHW_output_27(BStatusBoolean v) { set(CmDHA_DHW_output_27,v,null); }
  public void setCmDHA_DHW_output_27(boolean v) { getCmDHA_DHW_output_27().setValue(v); }
// OperationMode
  public static final Property CmDHA_DHW_output_28 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmDHA_DHW_output_28() { return (BStatusNumeric) get(CmDHA_DHW_output_28); }
  public void setCmDHA_DHW_output_28(BStatusNumeric v) { set(CmDHA_DHW_output_28,v,null); }
  public void setCmDHA_DHW_output_28(float v) { getCmDHA_DHW_output_28().setValue(v); }

  // macro parameter
// CFG-01: system configuration
  public static final Property CmDHA_DHW_parameter_29 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmDHA_DHW_parameter_29() { return getDouble(CmDHA_DHW_parameter_29); }
  public void setCmDHA_DHW_parameter_29(double v) { setDouble(CmDHA_DHW_parameter_29,v,null); }
// UWT-01: P-band buffer temperature control
  public static final Property CmDHA_DHW_parameter_30 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmDHA_DHW_parameter_30() { return getDouble(CmDHA_DHW_parameter_30); }
  public void setCmDHA_DHW_parameter_30(double v) { setDouble(CmDHA_DHW_parameter_30,v,null); }
// LWT-02: D-time buffer temperature control
  public static final Property CmDHA_DHW_parameter_31 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmDHA_DHW_parameter_31() { return getDouble(CmDHA_DHW_parameter_31); }
  public void setCmDHA_DHW_parameter_31(double v) { setDouble(CmDHA_DHW_parameter_31,v,null); }
// SST-01: temp. difference primary/secondary system
  public static final Property CmDHA_DHW_parameter_32 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(60)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmDHA_DHW_parameter_32() { return getDouble(CmDHA_DHW_parameter_32); }
  public void setCmDHA_DHW_parameter_32(double v) { setDouble(CmDHA_DHW_parameter_32,v,null); }
// SST-02: time to reach SST setpoint
  public static final Property CmDHA_DHW_parameter_33 = newProperty( 0, BDouble.make( 1800 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmDHA_DHW_parameter_33() { return getDouble(CmDHA_DHW_parameter_33); }
  public void setCmDHA_DHW_parameter_33(double v) { setDouble(CmDHA_DHW_parameter_33,v,null); }
// SST-03: heat demand setpoint shift
  public static final Property CmDHA_DHW_parameter_34 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(90)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmDHA_DHW_parameter_34() { return getDouble(CmDHA_DHW_parameter_34); }
  public void setCmDHA_DHW_parameter_34(double v) { setDouble(CmDHA_DHW_parameter_34,v,null); }
// PRP-01: start-up delay primary pump/ secondary pump
  public static final Property CmDHA_DHW_parameter_35 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmDHA_DHW_parameter_35() { return getDouble(CmDHA_DHW_parameter_35); }
  public void setCmDHA_DHW_parameter_35(double v) { setDouble(CmDHA_DHW_parameter_35,v,null); }
// PRP-02: switch off delay primary pump
  public static final Property CmDHA_DHW_parameter_285 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmDHA_DHW_parameter_285() { return getDouble(CmDHA_DHW_parameter_285); }
  public void setCmDHA_DHW_parameter_285(double v) { setDouble(CmDHA_DHW_parameter_285,v,null); }
// SEP-02: circulation pump switch off delay
  public static final Property CmDHA_DHW_parameter_36 = newProperty( 0, BDouble.make( 900 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmDHA_DHW_parameter_36() { return getDouble(CmDHA_DHW_parameter_36); }
  public void setCmDHA_DHW_parameter_36(double v) { setDouble(CmDHA_DHW_parameter_36,v,null); }
// SEP-03: run circulation pump during occupied periods and extended operation
  public static final Property CmDHA_DHW_parameter_287 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmDHA_DHW_parameter_287() { return getDouble(CmDHA_DHW_parameter_287); }
  public void setCmDHA_DHW_parameter_287(double v) { setDouble(CmDHA_DHW_parameter_287,v,null); }
// SEP-04: circulation pump during overheat protection
  public static final Property CmDHA_DHW_parameter_288 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(4)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmDHA_DHW_parameter_288() { return getDouble(CmDHA_DHW_parameter_288); }
  public void setCmDHA_DHW_parameter_288(double v) { setDouble(CmDHA_DHW_parameter_288,v,null); }
// LEG-01: anti-legionella stpoint
  public static final Property CmDHA_DHW_parameter_37 = newProperty( 0, BDouble.make( 70 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(90)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmDHA_DHW_parameter_37() { return getDouble(CmDHA_DHW_parameter_37); }
  public void setCmDHA_DHW_parameter_37(double v) { setDouble(CmDHA_DHW_parameter_37,v,null); }
// LEG-02: time to reach legionella setpoint
  public static final Property CmDHA_DHW_parameter_38 = newProperty( 0, BDouble.make( 1800 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmDHA_DHW_parameter_38() { return getDouble(CmDHA_DHW_parameter_38); }
  public void setCmDHA_DHW_parameter_38(double v) { setDouble(CmDHA_DHW_parameter_38,v,null); }
// LEG-03: legionella duration
  public static final Property CmDHA_DHW_parameter_39 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmDHA_DHW_parameter_39() { return getDouble(CmDHA_DHW_parameter_39); }
  public void setCmDHA_DHW_parameter_39(double v) { setDouble(CmDHA_DHW_parameter_39,v,null); }
// DEX-01: DHW setpoint extended operation
  public static final Property CmDHA_DHW_parameter_40 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(80)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmDHA_DHW_parameter_40() { return getDouble(CmDHA_DHW_parameter_40); }
  public void setCmDHA_DHW_parameter_40(double v) { setDouble(CmDHA_DHW_parameter_40,v,null); }
// DEX-02: auto reset time from extended operation
  public static final Property CmDHA_DHW_parameter_41 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(480)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmDHA_DHW_parameter_41() { return getDouble(CmDHA_DHW_parameter_41); }
  public void setCmDHA_DHW_parameter_41(double v) { setDouble(CmDHA_DHW_parameter_41,v,null); }
// SYS-01: occupied/ un-occupied changeover
  public static final Property CmDHA_DHW_parameter_42 = newProperty( 0, BDouble.make( 40 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmDHA_DHW_parameter_42() { return getDouble(CmDHA_DHW_parameter_42); }
  public void setCmDHA_DHW_parameter_42(double v) { setDouble(CmDHA_DHW_parameter_42,v,null); }
// SYS-02: setpoint raise at OverheatProt
  public static final Property CmDHA_DHW_parameter_43 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmDHA_DHW_parameter_43() { return getDouble(CmDHA_DHW_parameter_43); }
  public void setCmDHA_DHW_parameter_43(double v) { setDouble(CmDHA_DHW_parameter_43,v,null); }
// SYS-03: setpoint decrease/ minute after a Heat Override
  public static final Property CmDHA_DHW_parameter_44 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmDHA_DHW_parameter_44() { return getDouble(CmDHA_DHW_parameter_44); }
  public void setCmDHA_DHW_parameter_44(double v) { setDouble(CmDHA_DHW_parameter_44,v,null); }
// SYS-04: temperature drop for prority request
  public static final Property CmDHA_DHW_parameter_45 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmDHA_DHW_parameter_45() { return getDouble(CmDHA_DHW_parameter_45); }
  public void setCmDHA_DHW_parameter_45(double v) { setDouble(CmDHA_DHW_parameter_45,v,null); }
// SYS-05: heat demand transmission
  public static final Property CmDHA_DHW_parameter_46 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmDHA_DHW_parameter_46() { return getDouble(CmDHA_DHW_parameter_46); }
  public void setCmDHA_DHW_parameter_46(double v) { setDouble(CmDHA_DHW_parameter_46,v,null); }
// SYS-06: automatic/ manual reset
  public static final Property CmDHA_DHW_parameter_47 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmDHA_DHW_parameter_47() { return getDouble(CmDHA_DHW_parameter_47); }
  public void setCmDHA_DHW_parameter_47(double v) { setDouble(CmDHA_DHW_parameter_47,v,null); }
// DISP-01: calculated DHWS temperature setpoint
  public static final Property CmDHA_DHW_parameter_48 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmDHA_DHW_parameter_48() { return getDouble(CmDHA_DHW_parameter_48); }
  public void setCmDHA_DHW_parameter_48(double v) { setDouble(CmDHA_DHW_parameter_48,v,null); }
// DISP-02: operatiing mode
  public static final Property CmDHA_DHW_parameter_49 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmDHA_DHW_parameter_49() { return getDouble(CmDHA_DHW_parameter_49); }
  public void setCmDHA_DHW_parameter_49(double v) { setDouble(CmDHA_DHW_parameter_49,v,null); }

  // macro inputs
// UpperTemp
  public static final Property CmDHA_DHW_input_6 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmDHA_DHW_input_6() { return (BStatusNumeric) get(CmDHA_DHW_input_6); }
  public void setCmDHA_DHW_input_6(BStatusNumeric v) { set(CmDHA_DHW_input_6,v,null); }
  public void setCmDHA_DHW_input_6(float v) { getCmDHA_DHW_input_6().setValue(v); }
// LowerTemp
  public static final Property CmDHA_DHW_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmDHA_DHW_input_7() { return (BStatusNumeric) get(CmDHA_DHW_input_7); }
  public void setCmDHA_DHW_input_7(BStatusNumeric v) { set(CmDHA_DHW_input_7,v,null); }
  public void setCmDHA_DHW_input_7(float v) { getCmDHA_DHW_input_7().setValue(v); }
// DHW_TempSp
  public static final Property CmDHA_DHW_input_8 = newProperty( Flags.SUMMARY, new BStatusNumeric( 60 ), null);
  public BStatusNumeric getCmDHA_DHW_input_8() { return (BStatusNumeric) get(CmDHA_DHW_input_8); }
  public void setCmDHA_DHW_input_8(BStatusNumeric v) { set(CmDHA_DHW_input_8,v,null); }
  public void setCmDHA_DHW_input_8(float v) { getCmDHA_DHW_input_8().setValue(v); }
// SysSupplyTemp
  public static final Property CmDHA_DHW_input_9 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmDHA_DHW_input_9() { return (BStatusNumeric) get(CmDHA_DHW_input_9); }
  public void setCmDHA_DHW_input_9(BStatusNumeric v) { set(CmDHA_DHW_input_9,v,null); }
  public void setCmDHA_DHW_input_9(float v) { getCmDHA_DHW_input_9().setValue(v); }
// RenEnergCharge
  public static final Property CmDHA_DHW_input_11 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmDHA_DHW_input_11() { return (BStatusBoolean) get(CmDHA_DHW_input_11); }
  public void setCmDHA_DHW_input_11(BStatusBoolean v) { set(CmDHA_DHW_input_11,v,null); }
  public void setCmDHA_DHW_input_11(boolean v) { getCmDHA_DHW_input_11().setValue(v); }
// LegionellaEnable
  public static final Property CmDHA_DHW_input_12 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmDHA_DHW_input_12() { return (BStatusBoolean) get(CmDHA_DHW_input_12); }
  public void setCmDHA_DHW_input_12(BStatusBoolean v) { set(CmDHA_DHW_input_12,v,null); }
  public void setCmDHA_DHW_input_12(boolean v) { getCmDHA_DHW_input_12().setValue(v); }
// CircPumpDemand
  public static final Property CmDHA_DHW_input_13 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmDHA_DHW_input_13() { return (BStatusBoolean) get(CmDHA_DHW_input_13); }
  public void setCmDHA_DHW_input_13(BStatusBoolean v) { set(CmDHA_DHW_input_13,v,null); }
  public void setCmDHA_DHW_input_13(boolean v) { getCmDHA_DHW_input_13().setValue(v); }
// MaxThermostat
  public static final Property CmDHA_DHW_input_14 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmDHA_DHW_input_14() { return (BStatusBoolean) get(CmDHA_DHW_input_14); }
  public void setCmDHA_DHW_input_14(BStatusBoolean v) { set(CmDHA_DHW_input_14,v,null); }
  public void setCmDHA_DHW_input_14(boolean v) { getCmDHA_DHW_input_14().setValue(v); }
// DayExtension
  public static final Property CmDHA_DHW_input_15 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmDHA_DHW_input_15() { return (BStatusBoolean) get(CmDHA_DHW_input_15); }
  public void setCmDHA_DHW_input_15(BStatusBoolean v) { set(CmDHA_DHW_input_15,v,null); }
  public void setCmDHA_DHW_input_15(boolean v) { getCmDHA_DHW_input_15().setValue(v); }
// HolidaySwitch
  public static final Property CmDHA_DHW_input_16 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmDHA_DHW_input_16() { return (BStatusBoolean) get(CmDHA_DHW_input_16); }
  public void setCmDHA_DHW_input_16(BStatusBoolean v) { set(CmDHA_DHW_input_16,v,null); }
  public void setCmDHA_DHW_input_16(boolean v) { getCmDHA_DHW_input_16().setValue(v); }
// OverheatProt
  public static final Property CmDHA_DHW_input_17 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmDHA_DHW_input_17() { return (BStatusBoolean) get(CmDHA_DHW_input_17); }
  public void setCmDHA_DHW_input_17(BStatusBoolean v) { set(CmDHA_DHW_input_17,v,null); }
  public void setCmDHA_DHW_input_17(boolean v) { getCmDHA_DHW_input_17().setValue(v); }
// Reset
  public static final Property CmDHA_DHW_input_18 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmDHA_DHW_input_18() { return (BStatusBoolean) get(CmDHA_DHW_input_18); }
  public void setCmDHA_DHW_input_18(BStatusBoolean v) { set(CmDHA_DHW_input_18,v,null); }
  public void setCmDHA_DHW_input_18(boolean v) { getCmDHA_DHW_input_18().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.03 [95] 15.01.2019-16:33").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5979162542457487717").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmDHA_DHW.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfTruncate func_50 = new CfTruncate();
  protected CfMonoflop func_55 = new CfMonoflop();
  protected CfWindow func_74 = new CfWindow();
  protected CfWindow func_82 = new CfWindow();
  protected CfWindow func_107 = new CfWindow();
  protected CfWindow func_108 = new CfWindow();
  protected CmIDT20 func_162 = new CmIDT20();
  protected CmIDT10 func_183 = new CmIDT10();
  protected CmIDT05 func_252 = new CmIDT05();
  protected CmDHADHW_Setpoint func_66 = new CmDHADHW_Setpoint();
  protected CmDayExtension_DHADHW func_100 = new CmDayExtension_DHADHW();
  protected CfIdt func_184 = new CfIdt();
  protected CfInputMultiplexer func_206 = new CfInputMultiplexer();
  protected CmLegionellaProt func_92 = new CmLegionellaProt();
  protected CmCirculationPumpCmd func_64 = new CmCirculationPumpCmd();
  protected CfIdt func_189 = new CfIdt();
  protected CmTempFailedAlm func_85 = new CmTempFailedAlm();
  protected CmOnOff_Control func_71 = new CmOnOff_Control();
  protected CfInputMultiplexer func_294 = new CfInputMultiplexer();
  protected CmContinuous_Control func_79 = new CmContinuous_Control();
  protected CfInputMultiplexer func_289 = new CfInputMultiplexer();
  protected CfIdt func_188 = new CfIdt();
  protected CmChargingPumpCmd func_63 = new CmChargingPumpCmd();
  protected CfInputMultiplexer func_282 = new CfInputMultiplexer();
  protected CmDHW_Priority func_103 = new CmDHW_Priority();
  protected CfAnd func_111 = new CfAnd();
  protected CfAnd func_116 = new CfAnd();
  protected CfNot func_202 = new CfNot();
  protected CfOr func_224 = new CfOr();
  protected CfInputMultiplexer func_120 = new CfInputMultiplexer();
  protected CfAnd func_199 = new CfAnd();
  protected CfInputMultiplexer func_114 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_278 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_196 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_192 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_205 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_195 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_204 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_251 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_190 = new CfInputMultiplexer();
  protected CfIdt func_214 = new CfIdt();
  protected CmHeatDemand_DHADHW func_90 = new CmHeatDemand_DHADHW();

  // default constructor
  public BCmDHA_DHW()
  {
    func_184.configure(2);
    func_214.configure(2);
  }

  public void Start()
  {
    func_55.Start();
    func_162.Start();
    func_183.Start();
    func_252.Start();
    func_66.Start();
    func_100.Start();
    func_92.Start();
    func_64.Start();
    func_85.Start();
    func_71.Start();
    func_79.Start();
    func_63.Start();
    func_103.Start();
    func_90.Start();
  }
}
