/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    RSR_RoomSetpointRamp
Macro id:      6363531357383033058
Macro version: 16
Last change:   10.01.2017 - 14:47
Access Level:  2
Inputs:
  [1] RoomTempSp
  [2] CntrlPtAdj
Outputs:
  [1] RoomSpRamp
Parameter:
  [1] RMP-01: up ramp
  [2] RMP-02: down ramp
Description:
To protect the works of art in churches, museums or other historical buildings, it is often required that the room temperature does not change faster than a predefined ramp e.g. 1K/ hour.
This macro provides a room temperature setpoint ramp for heating circuits.
It is possible to set the up- and down-ramps with two different parameters.
================================================================================*/

public class BCmRSR_RoomSetpointRamp
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmRSR_RoomSetpointRamp_output_2().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmRSR_RoomSetpointRamp_output_2().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmRSR_RoomSetpointRamp_output_2().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [114] Function call CfLastValue
    func_114.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_114.Execute(  );

    // [157] Function call CfCompare1
    func_157.inputA = func_114.outputCurrent;
    func_157.inputB = func_114.outputLast;
    func_157.Execute(  );

    // [87] Function call CfMonoflop
    func_87.input = BooleanToFloat(func_157.outputLess);
    func_87.Execute( this, 0 );

    // [88] Function call CfNot
    func_88.input = func_87.output;
    func_88.Execute(  );

    // [117] Function call CfCompare1
    func_117.inputA = (float) getCmRSR_RoomSetpointRamp_parameter_3();
    func_117.inputB = 0F;
    func_117.Execute(  );

    // [118] Function call CfCompare1
    func_118.inputA = (float) getCmRSR_RoomSetpointRamp_parameter_4();
    func_118.inputB = 0F;
    func_118.Execute(  );

    // [139] Function call CfOr
    func_139.input[0] = func_117.outputGreater;
    func_139.input[1] = func_118.outputGreater;
    func_139.Execute(  );

    // [147] Function call CfAnd
    func_147.input[0] = func_88.output;
    func_147.input[1] = func_139.outputOR;
    func_147.Execute(  );

    // [7] Function call CfNextSchedule
    func_7.input = (float) getCmRSR_RoomSetpointRamp_input_45().getValue();
    func_7.Execute( this, 1 );

    // [9] Function call CfSubtract
    func_9.input[0] = (float) getCmRSR_RoomSetpointRamp_output_2().getValue();
    func_9.input[1] = func_7.outputNextValue;
    func_9.Execute(  );

    // [27] Function call CfDivide
    func_27.inputA = (float) getCmRSR_RoomSetpointRamp_parameter_3();
    func_27.inputB = 60F;
    func_27.Execute(  );

    // [31] Function call CfDivide
    func_31.inputA = (float) getCmRSR_RoomSetpointRamp_parameter_4();
    func_31.inputB = 60F;
    func_31.Execute(  );

    // [53] Function call CfDivide
    func_53.inputA = func_9.output;
    func_53.inputB = func_27.output;
    func_53.Execute(  );

    // [97] Function call CfNegate
    func_97.input = IntToFloat(func_7.outputTimeUntilChange);
    func_97.Execute(  );

    // [76] Function call CfCompare2
    func_76.inputA = func_53.output;
    func_76.inputB = func_97.output;
    func_76.Execute(  );

    // [144] Function call CfAddition
    func_144.input[0] = (float) getCmRSR_RoomSetpointRamp_input_141().getValue();
    func_144.input[1] = (float) getCmRSR_RoomSetpointRamp_input_45().getValue();
    func_144.Execute(  );

    // [142] Function call CfAddition
    func_142.input[0] = func_7.outputNextValue;
    func_142.input[1] = (float) getCmRSR_RoomSetpointRamp_input_141().getValue();
    func_142.Execute(  );

    // [90] Function call CfAnd
    func_90.input[0] = func_147.outputAND;
    func_90.input[1] = func_76.outputEqualOrLess;
    func_90.Execute(  );

    // [16] Function call CfInputMultiplexer
    func_16.inputSelect = BooleanToInt(func_90.outputAND);
    func_16.input[1-1] = func_144.output;
    func_16.input[2-1] = func_142.output;
    func_16.Execute(  );

    // [108] Function call CfInputMultiplexer
    func_108.inputSelect = BooleanToInt(func_87.output);
    func_108.input[1-1] = func_27.output;
    func_108.input[2-1] = 0F;
    func_108.Execute(  );

    // [111] Function call CfInputMultiplexer
    func_111.inputSelect = BooleanToInt(func_87.output);
    func_111.input[1-1] = func_31.output;
    func_111.input[2-1] = 0F;
    func_111.Execute(  );

    // [12] Function call CfValueRamp2
    func_12.inputValue = func_16.output;
    func_12.inputRisingSlope = func_108.output;
    func_12.inputFallingSlope = func_111.output;
    func_12.Execute( this );

    // [20] Function call CfInputMultiplexer
    func_20.inputSelect = BooleanToInt(func_147.outputAND);
    func_20.input[1-1] = 0F;
    func_20.input[2-1] = func_12.output;
    func_20.Execute(  );
    setCmRSR_RoomSetpointRamp_output_2(func_20.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    61F, 3F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// RoomSpRamp
  public static final Property CmRSR_RoomSetpointRamp_output_2 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmRSR_RoomSetpointRamp_output_2() { return (BStatusNumeric) get(CmRSR_RoomSetpointRamp_output_2); }
  public void setCmRSR_RoomSetpointRamp_output_2(BStatusNumeric v) { set(CmRSR_RoomSetpointRamp_output_2,v,null); }
  public void setCmRSR_RoomSetpointRamp_output_2(float v) { getCmRSR_RoomSetpointRamp_output_2().setValue(v); }

  // macro parameter
// RMP-01: up ramp
  public static final Property CmRSR_RoomSetpointRamp_parameter_3 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(500)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmRSR_RoomSetpointRamp_parameter_3() { return getDouble(CmRSR_RoomSetpointRamp_parameter_3); }
  public void setCmRSR_RoomSetpointRamp_parameter_3(double v) { setDouble(CmRSR_RoomSetpointRamp_parameter_3,v,null); }
// RMP-02: down ramp
  public static final Property CmRSR_RoomSetpointRamp_parameter_4 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(500)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmRSR_RoomSetpointRamp_parameter_4() { return getDouble(CmRSR_RoomSetpointRamp_parameter_4); }
  public void setCmRSR_RoomSetpointRamp_parameter_4(double v) { setDouble(CmRSR_RoomSetpointRamp_parameter_4,v,null); }

  // macro inputs
// RoomTempSp
  public static final Property CmRSR_RoomSetpointRamp_input_45 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmRSR_RoomSetpointRamp_input_45() { return (BStatusNumeric) get(CmRSR_RoomSetpointRamp_input_45); }
  public void setCmRSR_RoomSetpointRamp_input_45(BStatusNumeric v) { set(CmRSR_RoomSetpointRamp_input_45,v,null); }
  public void setCmRSR_RoomSetpointRamp_input_45(float v) { getCmRSR_RoomSetpointRamp_input_45().setValue(v); }
// CntrlPtAdj
  public static final Property CmRSR_RoomSetpointRamp_input_141 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmRSR_RoomSetpointRamp_input_141() { return (BStatusNumeric) get(CmRSR_RoomSetpointRamp_input_141); }
  public void setCmRSR_RoomSetpointRamp_input_141(BStatusNumeric v) { set(CmRSR_RoomSetpointRamp_input_141,v,null); }
  public void setCmRSR_RoomSetpointRamp_input_141(float v) { getCmRSR_RoomSetpointRamp_input_141().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.01 [16] 10.01.2017-14:47").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6363531357383033058").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmRSR_RoomSetpointRamp.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public TuncosInformation getTuncosInfo(int tuncosId)
  {
    TuncosInformation tuncos = null;
    try
    {
      Property prop = null;
      switch (tuncosId)
      {
      case 3: prop = CmRSR_RoomSetpointRamp_input_45; break;
      }
      if (prop != null)
        tuncos = super.getTuncos(prop);
    }
    catch (Exception x)
    {
    }
    return tuncos;
  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private float   IntToFloat    (int     value) { return (float) value; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

  // class variables
  protected CfLastValue func_114 = new CfLastValue();
  protected CfCompare1 func_157 = new CfCompare1();
  protected CfMonoflop func_87 = new CfMonoflop();
  protected CfNot func_88 = new CfNot();
  protected CfCompare1 func_117 = new CfCompare1();
  protected CfCompare1 func_118 = new CfCompare1();
  protected CfOr func_139 = new CfOr();
  protected CfAnd func_147 = new CfAnd();
  protected CfNextSchedule func_7 = new CfNextSchedule();
  protected CfSubtract func_9 = new CfSubtract();
  protected CfDivide func_27 = new CfDivide();
  protected CfDivide func_31 = new CfDivide();
  protected CfDivide func_53 = new CfDivide();
  protected CfNegate func_97 = new CfNegate();
  protected CfCompare2 func_76 = new CfCompare2();
  protected CfAddition func_144 = new CfAddition();
  protected CfAddition func_142 = new CfAddition();
  protected CfAnd func_90 = new CfAnd();
  protected CfInputMultiplexer func_16 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_108 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_111 = new CfInputMultiplexer();
  protected CfValueRamp2 func_12 = new CfValueRamp2();
  protected CfInputMultiplexer func_20 = new CfInputMultiplexer();

  // default constructor
  public BCmRSR_RoomSetpointRamp()
  {
  }

  public void Start()
  {
    func_114.Start();
    func_87.Start();
    func_12.Start();
  }
}
