/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    SOL_SolarControl
Macro id:      6140084252845277533
Macro version: 87
Last change:   05.03.2018 - 13:37
Access Level:  2
Inputs:
  [1] SolPanelTemp
  [2] SolarPower
  [3] FilteredOATemp
  [4] DHWUpperTemp
  [5] DHWLowerTemp
  [6] DHW_TempSp
  [7] BufLowerTemp
  [8] BufOverheatAlm
  [9] BufStopHighOAT
Outputs:
  [1] SolPumpCmd
  [2] SolPumpCtrl
  [3] ChgOverValve
  [4] RenEnergCharge
  [5] OperationMode
  [6] CalcTempDiff
Parameter:
  [1] CFG-01: solar panel configuration
  [2] CFG-02: solar pump configuration
  [3] SOLP-01: temperature difference to switch on at OAT >= 20 °C
  [4] SOLP-02: temperature difference to switch off/ over
  [5] SOLP-03: temperature difference to switch on when the OAT = -15 °C
  [6] SOLP-04: solar panel freeze protection
  [7] DHW-01: DHW maximum upper temperature protection
  [8] DHW-02: DHW maximum lower temperature protection
  [9] DHW-03: DHW priority; 1 = no priority; 2 = priority
  [10] PMP-01: pump switch off delay at 20 °C
  [11] PMP-02: pump switch off delay at -15 °C
  [12] PMP-03: pump minimum off time
  [13] PMP-04: minimum pump speed
  [14] PMP-05: maximum pump speed
  [15] PMP-06: pump nominal electrical power
Description:
The macro SOL_SolarControl provides:
- domestic hot water and/ or system buffer charging control
- on/ off  or modulating control of the solar pump 
- solar power management together with the TTB_SolarPower macro
- overheat protection of the solar panel 
- solar panel frost protection
================================================================================*/

public class BCmSOL_SolarControl
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmSOL_SolarControl_output_10().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmSOL_SolarControl_output_10().setStatus(BStatus.disabled);
    getCmSOL_SolarControl_output_11().setStatus(BStatus.disabled);
    getCmSOL_SolarControl_output_12().setStatus(BStatus.disabled);
    getCmSOL_SolarControl_output_13().setStatus(BStatus.disabled);
    getCmSOL_SolarControl_output_14().setStatus(BStatus.disabled);
    getCmSOL_SolarControl_output_15().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmSOL_SolarControl_output_10().setStatus(BStatus.ok);
    getCmSOL_SolarControl_output_11().setStatus(BStatus.ok);
    getCmSOL_SolarControl_output_12().setStatus(BStatus.ok);
    getCmSOL_SolarControl_output_13().setStatus(BStatus.ok);
    getCmSOL_SolarControl_output_14().setStatus(BStatus.ok);
    getCmSOL_SolarControl_output_15().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [353] Macro call CmIDT20
    func_353.CmIDT20_input_1 = (float) getCmSOL_SolarControl_parameter_30();
    func_353.CmIDT20_input_2 = (float) getCmSOL_SolarControl_parameter_17();
    func_353.CmIDT20_input_3 = 0F;
    func_353.CmIDT20_input_4 = 0F;
    func_353.CmIDT20_input_5 = (float) getCmSOL_SolarControl_parameter_19();
    func_353.CmIDT20_input_6 = (float) getCmSOL_SolarControl_parameter_22();
    func_353.CmIDT20_input_7 = (float) getCmSOL_SolarControl_parameter_23();
    func_353.CmIDT20_input_8 = (float) getCmSOL_SolarControl_parameter_30();
    func_353.CmIDT20_input_9 = 0F;
    func_353.CmIDT20_input_10 = 0F;
    func_353.CmIDT20_input_11 = (float) getCmSOL_SolarControl_parameter_19();
    func_353.CmIDT20_input_12 = (float) getCmSOL_SolarControl_parameter_30();
    func_353.CmIDT20_input_13 = 0F;
    func_353.CmIDT20_input_14 = 0F;
    func_353.CmIDT20_input_15 = (float) getCmSOL_SolarControl_parameter_19();
    func_353.CmIDT20_input_16 = (float) getCmSOL_SolarControl_parameter_22();
    func_353.CmIDT20_input_17 = (float) getCmSOL_SolarControl_parameter_23();
    func_353.CmIDT20_input_18 = (float) getCmSOL_SolarControl_parameter_24();
    func_353.CmIDT20_input_19 = 5F;
    func_353.CmIDT20_input_20 = 600F;
    func_353.Execute(  );
    setParameter(5, func_353.CmIDT20_output_21);
    setParameter(6, func_353.CmIDT20_output_22);
    setParameter(7, func_353.CmIDT20_output_25);
    setParameter(8, func_353.CmIDT20_output_26);
    setParameter(9, func_353.CmIDT20_output_27);
    setParameter(15, func_353.CmIDT20_output_31);
    setParameter(24, func_353.CmIDT20_output_35);
    setParameter(25, func_353.CmIDT20_output_36);
    setParameter(26, func_353.CmIDT20_output_37);
    setParameter(27, func_353.CmIDT20_output_38);
    setParameter(2, func_353.CmIDT20_output_39);
    setParameter(4, func_353.CmIDT20_output_40);

    // [492] Function call CfIdt
    func_492.input = (float) getCmSOL_SolarControl_input_1().getValue();
    func_492.Execute(  );

    // [31] Function call CfSubtract
    func_31.input[0] = 20F;
    func_31.input[1] = (float) getCmSOL_SolarControl_input_3().getValue();
    func_31.Execute(  );

    // [45] Function call CfCompare1
    func_45.inputA = (float) getCmSOL_SolarControl_parameter_18();
    func_45.inputB = (float) getCmSOL_SolarControl_parameter_19();
    func_45.Execute(  );

    // [47] Function call CfAddition
    func_47.input[0] = (float) getCmSOL_SolarControl_parameter_19();
    func_47.input[1] = 0.1F;
    func_47.Execute(  );

    // [54] Function call CfCompare1
    func_54.inputA = (float) getCmSOL_SolarControl_parameter_20();
    func_54.inputB = (float) getCmSOL_SolarControl_parameter_18();
    func_54.Execute(  );

    // [55] Function call CfAddition
    func_55.input[0] = (float) getCmSOL_SolarControl_parameter_18();
    func_55.input[1] = 0.1F;
    func_55.Execute(  );

    // [75] Function call CfCompare1
    func_75.inputA = (float) getCmSOL_SolarControl_input_3().getValue();
    func_75.inputB = 20F;
    func_75.Execute(  );

    // [173] Function call CfIdt
    func_173.input = (float) getCmSOL_SolarControl_parameter_27();
    func_173.Execute(  );
    setParameter(19, func_173.output[0]);

    // [178] Function call CfSubtract
    func_178.input[0] = 20F;
    func_178.input[1] = (float) getCmSOL_SolarControl_input_3().getValue();
    func_178.Execute(  );

    // [179] Function call CfSubtract
    func_179.input[0] = (float) getCmSOL_SolarControl_parameter_25();
    func_179.input[1] = (float) getCmSOL_SolarControl_parameter_26();
    func_179.Execute(  );

    // [183] Function call CfCompare1
    func_183.inputA = (float) getCmSOL_SolarControl_input_3().getValue();
    func_183.inputB = 20F;
    func_183.Execute(  );

    // [256] Function call CfWindow
    func_256.inputValue = (float) getCmSOL_SolarControl_parameter_16();
    func_256.inputMinimum = 0.8F;
    func_256.inputMaximum = 1.2F;
    func_256.Execute(  );

    // [260] Function call CfWindow
    func_260.inputValue = (float) getCmSOL_SolarControl_parameter_16();
    func_260.inputMinimum = 1.8F;
    func_260.inputMaximum = 3.2F;
    func_260.Execute(  );

    // [268] Function call CfWindow
    func_268.inputValue = (float) getCmSOL_SolarControl_parameter_16();
    func_268.inputMinimum = 2.8F;
    func_268.inputMaximum = 3.2F;
    func_268.Execute(  );

    // [272] Function call CfHysteresis
    func_272.inputX = (float) getCmSOL_SolarControl_input_4().getValue();
    func_272.inputW = (float) getCmSOL_SolarControl_parameter_22();
    func_272.Execute( this, 0 );

    // [275] Function call CfHysteresis
    func_275.inputX = (float) getCmSOL_SolarControl_input_5().getValue();
    func_275.inputW = (float) getCmSOL_SolarControl_parameter_23();
    func_275.Execute( this, 1 );

    // [284] Function call CfWindow
    func_284.inputValue = (float) getCmSOL_SolarControl_parameter_16();
    func_284.inputMinimum = 0.8F;
    func_284.inputMaximum = 1.2F;
    func_284.Execute(  );

    // [419] Function call CfCompare1
    func_419.inputA = (float) getCmSOL_SolarControl_parameter_21();
    func_419.inputB = -55F;
    func_419.Execute(  );

    // [46] Function call CfInputMultiplexer
    func_46.inputSelect = BooleanToInt(func_45.outputLess);
    func_46.input[1-1] = (float) getCmSOL_SolarControl_parameter_18();
    func_46.input[2-1] = func_47.output;
    func_46.Execute(  );

    // [500] Function call CfIdt
    func_500.input = func_46.output;
    func_500.Execute(  );
    setCmSOL_SolarControl_parameter_18(func_500.output[1]);

    // [56] Function call CfInputMultiplexer
    func_56.inputSelect = BooleanToInt(func_54.outputLess);
    func_56.input[1-1] = (float) getCmSOL_SolarControl_parameter_20();
    func_56.input[2-1] = func_55.output;
    func_56.Execute(  );

    // [504] Function call CfIdt
    func_504.input = func_56.output;
    func_504.Execute(  );
    setCmSOL_SolarControl_parameter_20(func_504.output[1]);

    // [87] Function call CfOr
    func_87.input[0] = func_75.outputGreater;
    func_87.input[1] = func_75.outputEqual;
    func_87.Execute(  );

    // [510] Function call CfAbsolute
    func_510.input = func_179.output;
    func_510.Execute(  );

    // [180] Function call CfMultiply
    func_180.input[0] = func_178.output;
    func_180.input[1] = func_510.outputAbs;
    func_180.Execute(  );

    // [184] Function call CfOr
    func_184.input[0] = func_183.outputGreater;
    func_184.input[1] = func_183.outputEqual;
    func_184.Execute(  );

    // [269] Function call CfOr
    func_269.input[0] = func_256.output;
    func_269.input[1] = func_268.output;
    func_269.Execute(  );

    // [575] Function call CfCompare1
    func_575.inputA = (float) getCmSOL_SolarControl_input_4().getValue();
    func_575.inputB = 990F;
    func_575.Execute(  );

    // [573] Function call CfAnd
    func_573.input[0] = func_575.outputLess;
    func_573.input[1] = func_272.output1;
    func_573.Execute(  );

    // [576] Function call CfCompare1
    func_576.inputA = (float) getCmSOL_SolarControl_input_5().getValue();
    func_576.inputB = 990F;
    func_576.Execute(  );

    // [574] Function call CfAnd
    func_574.input[0] = func_576.outputLess;
    func_574.input[1] = func_275.output1;
    func_574.Execute(  );

    // [273] Function call CfOr
    func_273.input[0] = func_573.outputAND;
    func_273.input[1] = func_574.outputAND;
    func_273.Execute(  );

    // [488] Function call CfHysteresis
    func_488.inputX = func_492.output[0];
    func_488.inputW = (float) getCmSOL_SolarControl_parameter_21();
    func_488.Execute( this, 2 );

    // [336] Function call CfAnd
    func_336.input[0] = func_419.outputGreater;
    func_336.input[1] = func_488.output2;
    func_336.Execute(  );

    // [33] Function call CfSubtract
    func_33.input[0] = func_504.output[0];
    func_33.input[1] = func_500.output[0];
    func_33.Execute(  );

    // [89] Function call CfCompare1
    func_89.inputA = func_504.output[0];
    func_89.inputB = func_500.output[0];
    func_89.Execute(  );

    // [181] Function call CfDivide
    func_181.inputA = func_180.output;
    func_181.inputB = 35F;
    func_181.Execute(  );

    // [286] Function call CfInputMultiplexer
    func_286.inputSelect = BooleanToInt(func_284.output);
    func_286.input[1-1] = 0F;
    func_286.input[2-1] = BooleanToFloat(func_273.outputOR);
    func_286.Execute(  );

    // [323] Function call CfDelayOnOff
    func_323.input = func_336.outputAND;
    func_323.Execute( this, 3 );

    // [35] Function call CfMultiply
    func_35.input[0] = func_31.output;
    func_35.input[1] = func_33.output;
    func_35.Execute(  );

    // [88] Function call CfOr
    func_88.input[0] = func_89.outputEqual;
    func_88.input[1] = func_87.outputOR;
    func_88.Execute(  );

    // [182] Function call CfAddition
    func_182.input[0] = func_181.output;
    func_182.input[1] = (float) getCmSOL_SolarControl_parameter_25();
    func_182.Execute(  );

    // [402] Function call CfIdt
    func_402.input = BooleanToFloat(func_323.output);
    func_402.Execute(  );

    // [409] Function call CfIdt
    func_409.input = func_286.output;
    func_409.Execute(  );

    // [37] Function call CfDivide
    func_37.inputA = func_35.output;
    func_37.inputB = 35F;
    func_37.Execute(  );

    // [185] Function call CfInputMultiplexer
    func_185.inputSelect = BooleanToInt(func_184.outputOR);
    func_185.input[1-1] = func_182.output;
    func_185.input[2-1] = (float) getCmSOL_SolarControl_parameter_25();
    func_185.Execute(  );

    // [288] Function call CfOr
    func_288.input[0] = FloatToBoolean(func_409.output[1]);
    func_288.input[1] = getCmSOL_SolarControl_input_8().getValue();
    func_288.input[2] = getCmSOL_SolarControl_input_9().getValue();
    func_288.Execute(  );

    // [338] Function call CfInputMultiplexer
    func_338.inputSelect = FloatToInt(func_402.output[1]);
    func_338.input[1-1] = 0F;
    func_338.input[2-1] = (float) getCmSOL_SolarControl_parameter_28();
    func_338.Execute(  );

    // [39] Function call CfAddition
    func_39.input[0] = func_37.output;
    func_39.input[1] = func_500.output[0];
    func_39.Execute(  );

    // [228] Function call CfInputMultiplexer
    func_228.inputSelect = BooleanToInt(func_288.outputOR);
    func_228.input[1-1] = func_185.output;
    func_228.input[2-1] = 0F;
    func_228.Execute(  );
    setParameter(21, func_228.output);

    // [64] Function call CfMaximum
    func_64.input[0] = func_47.output;
    func_64.input[1] = func_39.output;
    func_64.Execute(  );

    // [90] Function call CfInputMultiplexer
    func_90.inputSelect = BooleanToInt(func_88.outputOR);
    func_90.input[1-1] = func_64.output;
    func_90.input[2-1] = func_500.output[0];
    func_90.Execute(  );

    // [446] Function call CfSubtract
    func_446.input[0] = func_492.output[0];
    func_446.input[1] = (float) getCmSOL_SolarControl_input_5().getValue();
    func_446.Execute(  );

    // [452] Function call CfSubtract
    func_452.input[0] = func_492.output[0];
    func_452.input[1] = (float) getCmSOL_SolarControl_input_7().getValue();
    func_452.Execute(  );

    // [545] Function call CfCompare1
    func_545.inputA = func_542.output[0];
    func_545.inputB = 1F;
    func_545.Execute(  );

    // [453] Function call CfInputMultiplexer
    func_453.inputSelect = BooleanToInt(func_545.outputEqual);
    func_453.input[1-1] = func_446.output;
    func_453.input[2-1] = func_452.output;
    func_453.Execute(  );

    // [540] Function call CfIdt
    func_540.input = func_453.output;
    func_540.Execute(  );
    setCmSOL_SolarControl_output_15(func_540.output[0]);

    // [246] Function call CfLinearConverter
    func_246.inputValue = func_453.output;
    func_246.inputInLimit1 = func_90.output;
    func_246.inputInLimit2 = (float) getCmSOL_SolarControl_parameter_19();
    func_246.inputOutLimit1 = (float) getCmSOL_SolarControl_parameter_29();
    func_246.inputOutLimit2 = (float) getCmSOL_SolarControl_parameter_28();
    func_246.Execute(  );

    // [342] Macro call CmElectrical_Power
    func_342.CmElectrical_Power_input_1 = (float) getCmSOL_SolarControl_output_11().getValue();
    func_342.Execute( this, 5 );

    // [254] Macro call CmSOL_DHW
    if ( func_269.outputOR)
    {
      func_254.CmSOL_DHW_input_53 = func_90.output;
      func_254.CmSOL_DHW_input_55 = func_492.output[0];
      func_254.CmSOL_DHW_input_57 = (float) getCmSOL_SolarControl_input_5().getValue();
      func_254.CmSOL_DHW_input_60 = (float) getCmSOL_SolarControl_input_4().getValue();
      func_254.CmSOL_DHW_input_62 = (float) getCmSOL_SolarControl_input_2().getValue();
      func_254.CmSOL_DHW_input_76 = func_342.CmElectrical_Power_output_2;
      func_254.Execute( this, 7 );
    }

    // [257] Macro call CmSOL_Buffer
    if ( func_260.output)
    {
      func_257.CmSOL_Buffer_input_53 = func_90.output;
      func_257.CmSOL_Buffer_input_55 = func_492.output[0];
      func_257.CmSOL_Buffer_input_57 = (float) getCmSOL_SolarControl_input_7().getValue();
      func_257.CmSOL_Buffer_input_62 = (float) getCmSOL_SolarControl_input_2().getValue();
      func_257.CmSOL_Buffer_input_75 = func_342.CmElectrical_Power_output_2;
      func_257.CmSOL_Buffer_input_66 = getCmSOL_SolarControl_input_8().getValue();
      func_257.CmSOL_Buffer_input_67 = getCmSOL_SolarControl_input_9().getValue();
      func_257.Execute( this, 15 );
    }

    // [494] Function call CfInputMultiplexer
    func_494.inputSelect = BooleanToInt(func_260.output);
    func_494.input[1-1] = 0F;
    func_494.input[2-1] = BooleanToFloat(func_257.CmSOL_Buffer_output_65);
    func_494.Execute(  );

    // [496] Function call CfInputMultiplexer
    func_496.inputSelect = BooleanToInt(func_269.outputOR);
    func_496.input[1-1] = 0F;
    func_496.input[2-1] = BooleanToFloat(func_254.CmSOL_DHW_output_65);
    func_496.Execute(  );

    // [531] Function call CfInputMultiplexer
    func_531.inputSelect = BooleanToInt(func_269.outputOR);
    func_531.input[1-1] = 0F;
    func_531.input[2-1] = BooleanToFloat(func_254.CmSOL_DHW_output_115);
    func_531.Execute(  );

    // [529] Function call CfInputMultiplexer
    func_529.inputSelect = BooleanToInt(func_260.output);
    func_529.input[1-1] = 0F;
    func_529.input[2-1] = BooleanToFloat(func_257.CmSOL_Buffer_output_126);
    func_529.Execute(  );

    // [253] Function call CfOr
    func_253.input[0] = FloatToBoolean(func_496.output);
    func_253.input[1] = FloatToBoolean(func_494.output);
    func_253.Execute(  );

    // [232] Function call CfNot
    func_232.input = func_253.outputOR;
    func_232.Execute(  );

    // [231] Function call CfMonoflop
    func_231.input = BooleanToFloat(func_232.output);
    func_231.Execute( this, 19 );

    // [230] Function call CfInputMultiplexer
    func_230.inputSelect = BooleanToInt(func_231.output);
    func_230.input[1-1] = BooleanToFloat(func_253.outputOR);
    func_230.input[2-1] = 0F;
    func_230.Execute(  );

    // [517] Function call CfDelayOnOff
    func_517.input = FloatToBoolean(func_230.output);
    func_517.Execute( this, 20 );

    // [474] Function call CfIdt
    func_474.input = BooleanToFloat(func_517.output);
    func_474.Execute(  );

    // [551] Function call CfCompare1
    func_551.inputA = func_542.output[0];
    func_551.inputB = 2F;
    func_551.Execute(  );

    // [317] Function call CfAnd
    func_317.input[0] = func_551.outputEqual;
    func_317.input[1] = func_517.output;
    func_317.Execute(  );

    // [322] Function call CfOr
    func_322.input[0] = func_517.output;
    func_322.input[1] = FloatToBoolean(func_402.output[0]);
    func_322.Execute(  );

    // [416] Function call CfInputMultiplexer
    func_416.inputSelect = BooleanToInt(func_517.output);
    func_416.input[1-1] = 0F;
    func_416.input[2-1] = func_246.output;
    func_416.Execute(  );

    // [129] Function call CfDelayOnOff
    func_129.input = func_317.outputAND;
    func_129.Execute( this, 22 );
    setCmSOL_SolarControl_output_13(func_129.output);

    // [320] Function call CfIdt
    func_320.input = BooleanToFloat(func_322.outputOR);
    func_320.Execute(  );
    setCmSOL_SolarControl_output_10(FloatToBoolean(func_320.output[1]));

    // [339] Function call CfMaximum
    func_339.input[0] = func_416.output;
    func_339.input[1] = func_338.output;
    func_339.Execute(  );

    // [247] Function call CfInputMultiplexer
    func_247.inputSelect = FloatToInt(func_320.output[0]);
    func_247.input[1-1] = 0F;
    func_247.input[2-1] = func_339.output;
    func_247.Execute(  );
    setCmSOL_SolarControl_output_11(func_247.output);

    // [375] Function call CfWindow
    func_375.inputValue = (float) getCmSOL_SolarControl_parameter_16();
    func_375.inputMinimum = 2.8F;
    func_375.inputMaximum = 3.2F;
    func_375.Execute(  );

    // [311] Macro call CmSol_ChgOverValve
    if ( func_375.output)
    {
      func_311.CmSol_ChgOverValve_input_2 = func_492.output[0];
      func_311.CmSol_ChgOverValve_input_3 = (float) getCmSOL_SolarControl_input_5().getValue();
      func_311.CmSol_ChgOverValve_input_24 = (float) getCmSOL_SolarControl_input_4().getValue();
      func_311.CmSol_ChgOverValve_input_36 = (float) getCmSOL_SolarControl_input_6().getValue();
      func_311.CmSol_ChgOverValve_input_56 = (float) getCmSOL_SolarControl_input_7().getValue();
      func_311.CmSol_ChgOverValve_input_68 = getCmSOL_SolarControl_input_8().getValue();
      func_311.CmSol_ChgOverValve_input_69 = getCmSOL_SolarControl_input_9().getValue();
      func_311.Execute( this, 24 );
    }

    // [534] Function call CfInputMultiplexer
    func_534.inputSelect = BooleanToInt(func_375.output);
    func_534.input[1-1] = 0F;
    func_534.input[2-1] = BooleanToFloat(func_311.CmSol_ChgOverValve_output_1);
    func_534.Execute(  );

    // [462] Function call CfIdt
    func_462.input = func_534.output;
    func_462.Execute(  );
    setCmSOL_SolarControl_output_12(FloatToBoolean(func_462.output[0]));

    // [537] Function call CfWindow
    func_537.inputValue = (float) getCmSOL_SolarControl_parameter_16();
    func_537.inputMinimum = 1.8F;
    func_537.inputMaximum = 2.2F;
    func_537.Execute(  );

    // [535] Function call CfInputMultiplexer
    func_535.inputSelect = BooleanToInt(func_537.output);
    func_535.input[1-1] = 2F;
    func_535.input[2-1] = 1F;
    func_535.Execute(  );

    // [385] Function call CfInputMultiplexer
    func_385.inputSelect = FloatToInt(func_462.output[1]);
    func_385.input[1-1] = func_535.output;
    func_385.input[2-1] = 1F;
    func_385.Execute(  );

    // [527] Function call CfOr
    func_527.input[0] = FloatToBoolean(func_531.output);
    func_527.input[1] = FloatToBoolean(func_529.output);
    func_527.Execute(  );

    // [387] Function call CfInputMultiplexer
    func_387.inputSelect = BooleanToInt(func_527.outputOR);
    func_387.input[1-1] = func_385.output;
    func_387.input[2-1] = 3F;
    func_387.Execute(  );

    // [542] Function call CfIdt
    func_542.input = func_385.output;
    func_542.Execute(  );

    // [389] Function call CfInputMultiplexer
    func_389.inputSelect = FloatToInt(func_409.output[0]);
    func_389.input[1-1] = func_387.output;
    func_389.input[2-1] = 4F;
    func_389.Execute(  );

    // [400] Function call CfInputMultiplexer
    func_400.inputSelect = FloatToInt(func_402.output[2]);
    func_400.input[1-1] = func_389.output;
    func_400.input[2-1] = 5F;
    func_400.Execute(  );
    setCmSOL_SolarControl_output_14(func_400.output);

    // [192] Function call CfCompare1
    func_192.inputA = (float) getCmSOL_SolarControl_parameter_26();
    func_192.inputB = (float) getCmSOL_SolarControl_parameter_25();
    func_192.Execute(  );

    // [514] Function call CfInputMultiplexer
    func_514.inputSelect = BooleanToInt(func_192.outputLess);
    func_514.input[1-1] = (float) getCmSOL_SolarControl_parameter_26();
    func_514.input[2-1] = (float) getCmSOL_SolarControl_parameter_25();
    func_514.Execute(  );
    setCmSOL_SolarControl_parameter_26(func_514.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    3F, 3F, 0F, 0F, 600F, 0F, 0F, 0F,
    0F, 0F, 3F, 3F, 0F, 120F, 180F, 0F,
    0F, 120F, 180F, 1F, 0F, 600F, 0F, 900F,
    0F, 0F, 0F, 0F, 3F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// SolPumpCmd
  public static final Property CmSOL_SolarControl_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSOL_SolarControl_output_10() { return (BStatusBoolean) get(CmSOL_SolarControl_output_10); }
  public void setCmSOL_SolarControl_output_10(BStatusBoolean v) { set(CmSOL_SolarControl_output_10,v,null); }
  public void setCmSOL_SolarControl_output_10(boolean v) { getCmSOL_SolarControl_output_10().setValue(v); }
// SolPumpCtrl
  public static final Property CmSOL_SolarControl_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSOL_SolarControl_output_11() { return (BStatusNumeric) get(CmSOL_SolarControl_output_11); }
  public void setCmSOL_SolarControl_output_11(BStatusNumeric v) { set(CmSOL_SolarControl_output_11,v,null); }
  public void setCmSOL_SolarControl_output_11(float v) { getCmSOL_SolarControl_output_11().setValue(v); }
// ChgOverValve
  public static final Property CmSOL_SolarControl_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSOL_SolarControl_output_12() { return (BStatusBoolean) get(CmSOL_SolarControl_output_12); }
  public void setCmSOL_SolarControl_output_12(BStatusBoolean v) { set(CmSOL_SolarControl_output_12,v,null); }
  public void setCmSOL_SolarControl_output_12(boolean v) { getCmSOL_SolarControl_output_12().setValue(v); }
// RenEnergCharge
  public static final Property CmSOL_SolarControl_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSOL_SolarControl_output_13() { return (BStatusBoolean) get(CmSOL_SolarControl_output_13); }
  public void setCmSOL_SolarControl_output_13(BStatusBoolean v) { set(CmSOL_SolarControl_output_13,v,null); }
  public void setCmSOL_SolarControl_output_13(boolean v) { getCmSOL_SolarControl_output_13().setValue(v); }
// OperationMode
  public static final Property CmSOL_SolarControl_output_14 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSOL_SolarControl_output_14() { return (BStatusNumeric) get(CmSOL_SolarControl_output_14); }
  public void setCmSOL_SolarControl_output_14(BStatusNumeric v) { set(CmSOL_SolarControl_output_14,v,null); }
  public void setCmSOL_SolarControl_output_14(float v) { getCmSOL_SolarControl_output_14().setValue(v); }
// CalcTempDiff
  public static final Property CmSOL_SolarControl_output_15 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSOL_SolarControl_output_15() { return (BStatusNumeric) get(CmSOL_SolarControl_output_15); }
  public void setCmSOL_SolarControl_output_15(BStatusNumeric v) { set(CmSOL_SolarControl_output_15,v,null); }
  public void setCmSOL_SolarControl_output_15(float v) { getCmSOL_SolarControl_output_15().setValue(v); }

  // macro parameter
// CFG-01: solar panel configuration
  public static final Property CmSOL_SolarControl_parameter_16 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmSOL_SolarControl_parameter_16() { return getDouble(CmSOL_SolarControl_parameter_16); }
  public void setCmSOL_SolarControl_parameter_16(double v) { setDouble(CmSOL_SolarControl_parameter_16,v,null); }
// CFG-02: solar pump configuration
  public static final Property CmSOL_SolarControl_parameter_17 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmSOL_SolarControl_parameter_17() { return getDouble(CmSOL_SolarControl_parameter_17); }
  public void setCmSOL_SolarControl_parameter_17(double v) { setDouble(CmSOL_SolarControl_parameter_17,v,null); }
// SOLP-01: temperature difference to switch on at OAT >= 20 °C
  public static final Property CmSOL_SolarControl_parameter_18 = newProperty( 0, BDouble.make( 6 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-30)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmSOL_SolarControl_parameter_18() { return getDouble(CmSOL_SolarControl_parameter_18); }
  public void setCmSOL_SolarControl_parameter_18(double v) { setDouble(CmSOL_SolarControl_parameter_18,v,null); }
// SOLP-02: temperature difference to switch off/ over
  public static final Property CmSOL_SolarControl_parameter_19 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-30)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmSOL_SolarControl_parameter_19() { return getDouble(CmSOL_SolarControl_parameter_19); }
  public void setCmSOL_SolarControl_parameter_19(double v) { setDouble(CmSOL_SolarControl_parameter_19,v,null); }
// SOLP-03: temperature difference to switch on when the OAT = -15 °C
  public static final Property CmSOL_SolarControl_parameter_20 = newProperty( 0, BDouble.make( 6 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-30)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmSOL_SolarControl_parameter_20() { return getDouble(CmSOL_SolarControl_parameter_20); }
  public void setCmSOL_SolarControl_parameter_20(double v) { setDouble(CmSOL_SolarControl_parameter_20,v,null); }
// SOLP-04: solar panel freeze protection
  public static final Property CmSOL_SolarControl_parameter_21 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-55)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmSOL_SolarControl_parameter_21() { return getDouble(CmSOL_SolarControl_parameter_21); }
  public void setCmSOL_SolarControl_parameter_21(double v) { setDouble(CmSOL_SolarControl_parameter_21,v,null); }
// DHW-01: DHW maximum upper temperature protection
  public static final Property CmSOL_SolarControl_parameter_22 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(20)), BFacets.make(BFacets.MAX, BDouble.make(110)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmSOL_SolarControl_parameter_22() { return getDouble(CmSOL_SolarControl_parameter_22); }
  public void setCmSOL_SolarControl_parameter_22(double v) { setDouble(CmSOL_SolarControl_parameter_22,v,null); }
// DHW-02: DHW maximum lower temperature protection
  public static final Property CmSOL_SolarControl_parameter_23 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(20)), BFacets.make(BFacets.MAX, BDouble.make(110)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmSOL_SolarControl_parameter_23() { return getDouble(CmSOL_SolarControl_parameter_23); }
  public void setCmSOL_SolarControl_parameter_23(double v) { setDouble(CmSOL_SolarControl_parameter_23,v,null); }
// DHW-03: DHW priority; 1 = no priority; 2 = priority
  public static final Property CmSOL_SolarControl_parameter_24 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmSOL_SolarControl_parameter_24() { return getDouble(CmSOL_SolarControl_parameter_24); }
  public void setCmSOL_SolarControl_parameter_24(double v) { setDouble(CmSOL_SolarControl_parameter_24,v,null); }
// PMP-01: pump switch off delay at 20 °C
  public static final Property CmSOL_SolarControl_parameter_25 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(120)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSOL_SolarControl_parameter_25() { return getDouble(CmSOL_SolarControl_parameter_25); }
  public void setCmSOL_SolarControl_parameter_25(double v) { setDouble(CmSOL_SolarControl_parameter_25,v,null); }
// PMP-02: pump switch off delay at -15 °C
  public static final Property CmSOL_SolarControl_parameter_26 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(120)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSOL_SolarControl_parameter_26() { return getDouble(CmSOL_SolarControl_parameter_26); }
  public void setCmSOL_SolarControl_parameter_26(double v) { setDouble(CmSOL_SolarControl_parameter_26,v,null); }
// PMP-03: pump minimum off time
  public static final Property CmSOL_SolarControl_parameter_27 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(120)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSOL_SolarControl_parameter_27() { return getDouble(CmSOL_SolarControl_parameter_27); }
  public void setCmSOL_SolarControl_parameter_27(double v) { setDouble(CmSOL_SolarControl_parameter_27,v,null); }
// PMP-04: minimum pump speed
  public static final Property CmSOL_SolarControl_parameter_28 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmSOL_SolarControl_parameter_28() { return getDouble(CmSOL_SolarControl_parameter_28); }
  public void setCmSOL_SolarControl_parameter_28(double v) { setDouble(CmSOL_SolarControl_parameter_28,v,null); }
// PMP-05: maximum pump speed
  public static final Property CmSOL_SolarControl_parameter_29 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmSOL_SolarControl_parameter_29() { return getDouble(CmSOL_SolarControl_parameter_29); }
  public void setCmSOL_SolarControl_parameter_29(double v) { setDouble(CmSOL_SolarControl_parameter_29,v,null); }
// PMP-06: pump nominal electrical power
  public static final Property CmSOL_SolarControl_parameter_30 = newProperty( 0, BDouble.make( 50 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(50000)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSOL_SolarControl_parameter_30() { return getDouble(CmSOL_SolarControl_parameter_30); }
  public void setCmSOL_SolarControl_parameter_30(double v) { setDouble(CmSOL_SolarControl_parameter_30,v,null); }

  // macro inputs
// SolPanelTemp
  public static final Property CmSOL_SolarControl_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmSOL_SolarControl_input_1() { return (BStatusNumeric) get(CmSOL_SolarControl_input_1); }
  public void setCmSOL_SolarControl_input_1(BStatusNumeric v) { set(CmSOL_SolarControl_input_1,v,null); }
  public void setCmSOL_SolarControl_input_1(float v) { getCmSOL_SolarControl_input_1().setValue(v); }
// SolarPower
  public static final Property CmSOL_SolarControl_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( -999 ), null);
  public BStatusNumeric getCmSOL_SolarControl_input_2() { return (BStatusNumeric) get(CmSOL_SolarControl_input_2); }
  public void setCmSOL_SolarControl_input_2(BStatusNumeric v) { set(CmSOL_SolarControl_input_2,v,null); }
  public void setCmSOL_SolarControl_input_2(float v) { getCmSOL_SolarControl_input_2().setValue(v); }
// FilteredOATemp
  public static final Property CmSOL_SolarControl_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmSOL_SolarControl_input_3() { return (BStatusNumeric) get(CmSOL_SolarControl_input_3); }
  public void setCmSOL_SolarControl_input_3(BStatusNumeric v) { set(CmSOL_SolarControl_input_3,v,null); }
  public void setCmSOL_SolarControl_input_3(float v) { getCmSOL_SolarControl_input_3().setValue(v); }
// DHWUpperTemp
  public static final Property CmSOL_SolarControl_input_4 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmSOL_SolarControl_input_4() { return (BStatusNumeric) get(CmSOL_SolarControl_input_4); }
  public void setCmSOL_SolarControl_input_4(BStatusNumeric v) { set(CmSOL_SolarControl_input_4,v,null); }
  public void setCmSOL_SolarControl_input_4(float v) { getCmSOL_SolarControl_input_4().setValue(v); }
// DHWLowerTemp
  public static final Property CmSOL_SolarControl_input_5 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmSOL_SolarControl_input_5() { return (BStatusNumeric) get(CmSOL_SolarControl_input_5); }
  public void setCmSOL_SolarControl_input_5(BStatusNumeric v) { set(CmSOL_SolarControl_input_5,v,null); }
  public void setCmSOL_SolarControl_input_5(float v) { getCmSOL_SolarControl_input_5().setValue(v); }
// DHW_TempSp
  public static final Property CmSOL_SolarControl_input_6 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmSOL_SolarControl_input_6() { return (BStatusNumeric) get(CmSOL_SolarControl_input_6); }
  public void setCmSOL_SolarControl_input_6(BStatusNumeric v) { set(CmSOL_SolarControl_input_6,v,null); }
  public void setCmSOL_SolarControl_input_6(float v) { getCmSOL_SolarControl_input_6().setValue(v); }
// BufLowerTemp
  public static final Property CmSOL_SolarControl_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmSOL_SolarControl_input_7() { return (BStatusNumeric) get(CmSOL_SolarControl_input_7); }
  public void setCmSOL_SolarControl_input_7(BStatusNumeric v) { set(CmSOL_SolarControl_input_7,v,null); }
  public void setCmSOL_SolarControl_input_7(float v) { getCmSOL_SolarControl_input_7().setValue(v); }
// BufOverheatAlm
  public static final Property CmSOL_SolarControl_input_8 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmSOL_SolarControl_input_8() { return (BStatusBoolean) get(CmSOL_SolarControl_input_8); }
  public void setCmSOL_SolarControl_input_8(BStatusBoolean v) { set(CmSOL_SolarControl_input_8,v,null); }
  public void setCmSOL_SolarControl_input_8(boolean v) { getCmSOL_SolarControl_input_8().setValue(v); }
// BufStopHighOAT
  public static final Property CmSOL_SolarControl_input_9 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmSOL_SolarControl_input_9() { return (BStatusBoolean) get(CmSOL_SolarControl_input_9); }
  public void setCmSOL_SolarControl_input_9(BStatusBoolean v) { set(CmSOL_SolarControl_input_9,v,null); }
  public void setCmSOL_SolarControl_input_9(boolean v) { getCmSOL_SolarControl_input_9().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.02 [87] 05.03.2018-13:37").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6140084252845277533").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmSOL_SolarControl.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmIDT20 func_353 = new CmIDT20();
  protected CfIdt func_492 = new CfIdt();
  protected CfSubtract func_31 = new CfSubtract();
  protected CfCompare1 func_45 = new CfCompare1();
  protected CfAddition func_47 = new CfAddition();
  protected CfCompare1 func_54 = new CfCompare1();
  protected CfAddition func_55 = new CfAddition();
  protected CfCompare1 func_75 = new CfCompare1();
  protected CfIdt func_173 = new CfIdt();
  protected CfSubtract func_178 = new CfSubtract();
  protected CfSubtract func_179 = new CfSubtract();
  protected CfCompare1 func_183 = new CfCompare1();
  protected CfWindow func_256 = new CfWindow();
  protected CfWindow func_260 = new CfWindow();
  protected CfWindow func_268 = new CfWindow();
  protected CfHysteresis func_272 = new CfHysteresis();
  protected CfHysteresis func_275 = new CfHysteresis();
  protected CfWindow func_284 = new CfWindow();
  protected CfCompare1 func_419 = new CfCompare1();
  protected CfInputMultiplexer func_46 = new CfInputMultiplexer();
  protected CfIdt func_500 = new CfIdt();
  protected CfInputMultiplexer func_56 = new CfInputMultiplexer();
  protected CfIdt func_504 = new CfIdt();
  protected CfOr func_87 = new CfOr();
  protected CfAbsolute func_510 = new CfAbsolute();
  protected CfMultiply func_180 = new CfMultiply();
  protected CfOr func_184 = new CfOr();
  protected CfOr func_269 = new CfOr();
  protected CfCompare1 func_575 = new CfCompare1();
  protected CfAnd func_573 = new CfAnd();
  protected CfCompare1 func_576 = new CfCompare1();
  protected CfAnd func_574 = new CfAnd();
  protected CfOr func_273 = new CfOr();
  protected CfHysteresis func_488 = new CfHysteresis();
  protected CfAnd func_336 = new CfAnd();
  protected CfSubtract func_33 = new CfSubtract();
  protected CfCompare1 func_89 = new CfCompare1();
  protected CfDivide func_181 = new CfDivide();
  protected CfInputMultiplexer func_286 = new CfInputMultiplexer();
  protected CfDelayOnOff func_323 = new CfDelayOnOff();
  protected CfMultiply func_35 = new CfMultiply();
  protected CfOr func_88 = new CfOr();
  protected CfAddition func_182 = new CfAddition();
  protected CfIdt func_402 = new CfIdt();
  protected CfIdt func_409 = new CfIdt();
  protected CfDivide func_37 = new CfDivide();
  protected CfInputMultiplexer func_185 = new CfInputMultiplexer();
  protected CfOr func_288 = new CfOr();
  protected CfInputMultiplexer func_338 = new CfInputMultiplexer();
  protected CfAddition func_39 = new CfAddition();
  protected CfInputMultiplexer func_228 = new CfInputMultiplexer();
  protected CfMaximum func_64 = new CfMaximum();
  protected CfInputMultiplexer func_90 = new CfInputMultiplexer();
  protected CfSubtract func_446 = new CfSubtract();
  protected CfSubtract func_452 = new CfSubtract();
  protected CfCompare1 func_545 = new CfCompare1();
  protected CfInputMultiplexer func_453 = new CfInputMultiplexer();
  protected CfIdt func_540 = new CfIdt();
  protected CfLinearConverter func_246 = new CfLinearConverter();
  protected CmElectrical_Power func_342 = new CmElectrical_Power();
  protected CmSOL_DHW func_254 = new CmSOL_DHW();
  protected CmSOL_Buffer func_257 = new CmSOL_Buffer();
  protected CfInputMultiplexer func_494 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_496 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_531 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_529 = new CfInputMultiplexer();
  protected CfOr func_253 = new CfOr();
  protected CfNot func_232 = new CfNot();
  protected CfMonoflop func_231 = new CfMonoflop();
  protected CfInputMultiplexer func_230 = new CfInputMultiplexer();
  protected CfDelayOnOff func_517 = new CfDelayOnOff();
  protected CfIdt func_474 = new CfIdt();
  protected CfCompare1 func_551 = new CfCompare1();
  protected CfAnd func_317 = new CfAnd();
  protected CfOr func_322 = new CfOr();
  protected CfInputMultiplexer func_416 = new CfInputMultiplexer();
  protected CfDelayOnOff func_129 = new CfDelayOnOff();
  protected CfIdt func_320 = new CfIdt();
  protected CfMaximum func_339 = new CfMaximum();
  protected CfInputMultiplexer func_247 = new CfInputMultiplexer();
  protected CfWindow func_375 = new CfWindow();
  protected CmSol_ChgOverValve func_311 = new CmSol_ChgOverValve();
  protected CfInputMultiplexer func_534 = new CfInputMultiplexer();
  protected CfIdt func_462 = new CfIdt();
  protected CfWindow func_537 = new CfWindow();
  protected CfInputMultiplexer func_535 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_385 = new CfInputMultiplexer();
  protected CfOr func_527 = new CfOr();
  protected CfInputMultiplexer func_387 = new CfInputMultiplexer();
  protected CfIdt func_542 = new CfIdt();
  protected CfInputMultiplexer func_389 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_400 = new CfInputMultiplexer();
  protected CfCompare1 func_192 = new CfCompare1();
  protected CfInputMultiplexer func_514 = new CfInputMultiplexer();

  // default constructor
  public BCmSOL_SolarControl()
  {
    func_500.configure(2);
    func_504.configure(2);
    func_402.configure(3);
    func_409.configure(2);
    func_288.configure(3);
    func_320.configure(2);
    func_462.configure(2);
  }

  public void Start()
  {
    func_353.Start();
    func_272.Start();
    func_275.Start();
    func_488.Start();
    func_323.Start();
    func_342.Start();
    func_254.Start();
    func_257.Start();
    func_231.Start();
    func_517.Start();
    func_129.Start();
    func_311.Start();
  }
}
