/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    VTB_HtgCircOptim
Macro id:      6064731699718128002
Macro version: 193
Last change:   05.03.2018 - 11:28
Access Level:  2
Inputs:
  [1] MixedWaterTemp
  [2] RoomTemp
  [3] ReturnWaterTemp
  [4] FilteredOATemp
  [5] RoomTempSp
  [6] OptimEnable
  [7] ContrPtAdj
  [8] ManSwCond
  [9] PumpStatus
  [10] MaxThernostat
  [11] SummerSwitch
  [12] HolidaySwitch
  [13] DHWS_Priority
  [14] OverheatProt
  [15] CondensProt
  [16] DayExtension
  [17] RoomSpRampIn
Outputs:
  [1] ValveControl
  [2] CalcRoomTmpSp
  [3] CalcMWTmpSp
  [4] HeatDemand
  [5] CalcRetTmpSp
  [6] PumpCmd
  [7] SetpointSource
  [8] EffOpMode
  [9] LongFiltOATemp
  [10] OperationMode
Parameter:
  [1] MWT-01: minimum MWT protection
  [2] MWT-02: minimum mixed water temperature
  [3] MWT-03: maximum mixed water temperature
  [4] MWT-04: setpoint raise per minute
  [5] MWT-05: P-band MWT control
  [6] MWT-06: I-time MWT control
  [7] MWT-07: P-band minimum MWT protection
  [8] OAT-01: high limit smooth filtered long period
  [9] OAT-02: high limit smooth filtered short period
  [10] OAT-03: low limit frost protection
  [11] OAT-04: long time smooth filtering
  [12] RWT-01: min. OAT RWT control
  [13] RWT-02: max. OAT RWT control
  [14] RWT-03: low setpoint
  [15] RWT-04: high setpoint
  [16] RWT-05: P-band RWT control
  [17] RWT-06: I-time RWT control
  [18] RMT-01: room temp. compensation factor
  [19] RMT-02: minimum room temperature
  [20] RMT-03: differential minimum room temperature
  [21] RMT-04: manual occupied setpoint (day)
  [22] RMT-05: manual unoccupied setpoint (night)
  [23] RMT-06: manual setpoint summer or holiday
  [24] RMT-07: auto reset from extended operation
  [25] PREH-01: minimum preheat time
  [26] PREH-02: pre-start constant time at OAT=0°C (if RMT=999)
  [27] PREH-03: pre-start constant (if RMT=999)
  [28] PREH-04: boost factor
  [29] OOFF-01: minimum OAT for optimised stop
  [30] OOFF-02: optimum stop factor
  [31] OOFF-03: room comfort zone
  [32] RCTR-01: room control P-band
  [33] RCTR-02: room control I-time
  [34] BMOD-01: dead time short (adaptive)
  [35] BMOD-02: time constant short (adaptive)
  [36] BMOD-03: dead time long (adaptive)
  [37] BMOD-04: time constant long (adaptive)
  [38] BMOD-05: adaptation; 0 = disable; 1 = enable; 2 = new start
  [39] HCA-01: heating curve curvation
  [40] HCA-02: heating curve slope
  [41] HCA-03: heating curve slope limit
  [42] HCA-04: adaptation: 0 = none; 1 = adaptive; 2 = new start; 3 = refreshed new start; 4 = direct RMT reset
  [43] HPU-01: pump start-up delay
  [44] HPU-02: pump switch off delay
  [45] HPU-03: pump restart when valve closed; 0 = disable
  [46] SYS-01: occupied / unoccupied changeover; 0 = disable
  [47] SYS-02: heat override raise percentage; 0 = disable
  [48] SYS-03: mode DHWS priority function; 0 = disable
  [49] SYS-04: MWT setpoint decrease time
  [50] SYS-05: max. duration DHWS priority function
  [51] SYS-06: heat demand transmission
  [52] DISP-01: calculated room temperature setpoint
  [53] DISP-02: calculated mixed water temperature setpoint
  [54] DISP-03: long term smooth filtered outside air temperature
  [55] DISP-04: calculated return water temperature setpoint
  [56] DISP-05: operation mode
  [57] DISP-06: start time optimum start
  [58] DISP-07: end time optimum start
  [59] DISP-08: date last optimum start
Description:
The macro can be configured for radiator, convector and floor heating systems. Temperature control of the mixed water temperature can be configured as temperature control with night setback, temperature control with total cool-down during unoccupied periods or temperature control with total cool-down and optimum start / stop functions. The optimum start functions and the heating curve are adaptive. The module can operate with and without room temperature sensor. When a room sensor is not connected an early pre-start time can be defined, before occupied period to warm up the building. The mixed water temperature control is based on the outside air temperature and can be compensated by the room temperature.
The heating circuit provides limitations based on the outside air temperature, and the return water temperature.
Further it provides overrides for domestic hot water priority requests, condensation protection and overheat protection of heat generators.
================================================================================*/

public class BCmVTB_HtgCircOptim
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmVTB_HtgCircOptim_output_12().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmVTB_HtgCircOptim_output_12().setStatus(BStatus.disabled);
    getCmVTB_HtgCircOptim_output_1859().setStatus(BStatus.disabled);
    getCmVTB_HtgCircOptim_output_17().setStatus(BStatus.disabled);
    getCmVTB_HtgCircOptim_output_3442().setStatus(BStatus.disabled);
    getCmVTB_HtgCircOptim_output_2977().setStatus(BStatus.disabled);
    getCmVTB_HtgCircOptim_output_13().setStatus(BStatus.disabled);
    getCmVTB_HtgCircOptim_output_2550().setStatus(BStatus.disabled);
    getCmVTB_HtgCircOptim_output_14().setStatus(BStatus.disabled);
    getCmVTB_HtgCircOptim_output_16().setStatus(BStatus.disabled);
    getCmVTB_HtgCircOptim_output_1858().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmVTB_HtgCircOptim_output_12().setStatus(BStatus.ok);
    getCmVTB_HtgCircOptim_output_1859().setStatus(BStatus.ok);
    getCmVTB_HtgCircOptim_output_17().setStatus(BStatus.ok);
    getCmVTB_HtgCircOptim_output_3442().setStatus(BStatus.ok);
    getCmVTB_HtgCircOptim_output_2977().setStatus(BStatus.ok);
    getCmVTB_HtgCircOptim_output_13().setStatus(BStatus.ok);
    getCmVTB_HtgCircOptim_output_2550().setStatus(BStatus.ok);
    getCmVTB_HtgCircOptim_output_14().setStatus(BStatus.ok);
    getCmVTB_HtgCircOptim_output_16().setStatus(BStatus.ok);
    getCmVTB_HtgCircOptim_output_1858().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [2553] Function call CfTruncate
    func_2553.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_2553.Execute(  );

    // [2562] Macro call CmTempSenAvailable
    func_2562.CmTempSenAvailable_input_1 = (float) getCmVTB_HtgCircOptim_input_1().getValue();
    func_2562.Execute(  );

    // [2565] Macro call CmTempSenAvailable
    func_2565.CmTempSenAvailable_input_1 = (float) getCmVTB_HtgCircOptim_input_3().getValue();
    func_2565.Execute(  );

    // [2655] Macro call CmMinCntrFlowTemp
    func_2655.CmMinCntrFlowTemp_input_1 = (float) getCmVTB_HtgCircOptim_input_8().getValue();
    func_2655.CmMinCntrFlowTemp_input_2 = (float) getCmVTB_HtgCircOptim_input_2().getValue();
    func_2655.Execute( this, 0 );

    // [2669] Macro call Cmcaretaker
    func_2669.Cmcaretaker_input_1 = (float) getCmVTB_HtgCircOptim_input_8().getValue();
    func_2669.Cmcaretaker_input_3 = false;
    func_2669.Cmcaretaker_input_4 = getCmVTB_HtgCircOptim_input_1861().getValue();
    func_2669.Execute( this, 8 );

    // [3143] Function call CfIdt
    func_3143.input = (float) getCmVTB_HtgCircOptim_parameter_63();
    func_3143.Execute(  );
    setParameter(21, func_3143.output[0]);

    // [2700] Function call CfMonoflop
    func_2700.input = BooleanToFloat(getCmVTB_HtgCircOptim_input_1863().getValue());
    func_2700.Execute( this, 21 );

    // [2722] Function call CfCompare1
    func_2722.inputA = (float) getCmVTB_HtgCircOptim_parameter_61();
    func_2722.inputB = 2F;
    func_2722.Execute(  );

    // [2729] Function call CfCompare1
    func_2729.inputA = (float) getCmVTB_HtgCircOptim_parameter_61();
    func_2729.inputB = 4F;
    func_2729.Execute(  );

    // [2735] Function call CfCompare1
    func_2735.inputA = (float) getCmVTB_HtgCircOptim_parameter_61();
    func_2735.inputB = 0F;
    func_2735.Execute(  );

    // [2754] Function call CfMultiply
    func_2754.input[0] = (float) getCmVTB_HtgCircOptim_parameter_21();
    func_2754.input[1] = 0.01F;
    func_2754.input[2] = (float) getCmVTB_HtgCircOptim_parameter_60();
    func_2754.Execute(  );

    // [2757] Function call CfIdt
    func_2757.input = 10000F;
    func_2757.Execute(  );
    setParameter(91, func_2757.output[0]);

    // [2775] Macro call CmIDT10
    func_2775.CmIDT10_input_1 = (float) getCmVTB_HtgCircOptim_parameter_29();
    func_2775.CmIDT10_input_2 = (float) getCmVTB_HtgCircOptim_parameter_30();
    func_2775.CmIDT10_input_3 = (float) getCmVTB_HtgCircOptim_parameter_31();
    func_2775.CmIDT10_input_4 = (float) getCmVTB_HtgCircOptim_parameter_32();
    func_2775.CmIDT10_input_5 = (float) getCmVTB_HtgCircOptim_parameter_33();
    func_2775.CmIDT10_input_6 = (float) getCmVTB_HtgCircOptim_parameter_34();
    func_2775.CmIDT10_input_7 = getParameter(38);
    func_2775.CmIDT10_input_8 = getParameter(38);
    func_2775.CmIDT10_input_9 = 0F;
    func_2775.CmIDT10_input_10 = 0F;
    func_2775.Execute(  );
    setParameter(32, func_2775.CmIDT10_output_21);
    setParameter(33, func_2775.CmIDT10_output_22);
    setParameter(34, func_2775.CmIDT10_output_23);
    setParameter(35, func_2775.CmIDT10_output_24);
    setParameter(36, func_2775.CmIDT10_output_25);
    setParameter(37, func_2775.CmIDT10_output_26);
    setCmVTB_HtgCircOptim_parameter_69(func_2775.CmIDT10_output_27);
    setCmVTB_HtgCircOptim_output_2977(func_2775.CmIDT10_output_28);

    // [2786] Macro call CmIDT05
    func_2786.CmIDT05_input_1 = (float) getCmVTB_HtgCircOptim_parameter_19();
    func_2786.CmIDT05_input_2 = (float) getCmVTB_HtgCircOptim_parameter_35();
    func_2786.CmIDT05_input_3 = (float) getCmVTB_HtgCircOptim_parameter_27();
    func_2786.CmIDT05_input_4 = 0F;
    func_2786.CmIDT05_input_5 = 0F;
    func_2786.Execute(  );
    setParameter(0, func_2786.CmIDT05_output_21);
    setParameter(1, func_2786.CmIDT05_output_22);
    setParameter(2, func_2786.CmIDT05_output_23);

    // [2845] Function call CfIdt
    func_2845.input = (float) getCmVTB_HtgCircOptim_parameter_55();
    func_2845.Execute(  );
    setParameter(104, func_2845.output[0]);

    // [2850] Function call CfIdt
    func_2850.input = (float) getCmVTB_HtgCircOptim_parameter_56();
    func_2850.Execute(  );
    setParameter(105, func_2850.output[0]);

    // [2854] Function call CfHysteresis
    func_2854.inputX = (float) getCmVTB_HtgCircOptim_input_8().getValue();
    func_2854.inputW = (float) getCmVTB_HtgCircOptim_parameter_27();
    func_2854.Execute( this, 22 );

    // [2868] Function call CfInputMultiplexer
    func_2868.inputSelect = FloatToInt((float) getCmVTB_HtgCircOptim_input_1860().getValue());
    func_2868.input[1-1] = 3F;
    func_2868.input[2-1] = 3F;
    func_2868.input[3-1] = 3F;
    func_2868.input[4-1] = 4F;
    func_2868.Execute(  );

    // [2883] Function call CfInputMultiplexer
    func_2883.inputSelect = FloatToInt((float) getCmVTB_HtgCircOptim_input_1860().getValue());
    func_2883.input[1-1] = 1F;
    func_2883.input[2-1] = 2F;
    func_2883.input[3-1] = 2F;
    func_2883.input[4-1] = 3F;
    func_2883.Execute(  );

    // [2911] Function call CfOr
    func_2911.input[0] = getCmVTB_HtgCircOptim_input_5().getValue();
    func_2911.input[1] = getCmVTB_HtgCircOptim_input_1861().getValue();
    func_2911.Execute(  );

    // [3003] Macro call CmIDT05
    func_3003.CmIDT05_input_1 = (float) getCmVTB_HtgCircOptim_parameter_23();
    func_3003.CmIDT05_input_2 = (float) getCmVTB_HtgCircOptim_parameter_24();
    func_3003.CmIDT05_input_3 = 0F;
    func_3003.CmIDT05_input_4 = 0F;
    func_3003.CmIDT05_input_5 = 0F;
    func_3003.Execute(  );
    setParameter(92, func_3003.CmIDT05_output_21);
    setParameter(94, func_3003.CmIDT05_output_22);

    // [3009] Macro call CmIDT05
    func_3009.CmIDT05_input_1 = (float) getCmVTB_HtgCircOptim_parameter_25();
    func_3009.CmIDT05_input_2 = (float) getCmVTB_HtgCircOptim_parameter_26();
    func_3009.CmIDT05_input_3 = (float) getCmVTB_HtgCircOptim_parameter_28();
    func_3009.CmIDT05_input_4 = getParameter(11);
    func_3009.CmIDT05_input_5 = getParameter(11);
    func_3009.Execute(  );
    setParameter(8, func_3009.CmIDT05_output_21);
    setParameter(9, func_3009.CmIDT05_output_22);
    setParameter(10, func_3009.CmIDT05_output_23);
    setCmVTB_HtgCircOptim_output_16(func_3009.CmIDT05_output_24);

    // [3037] Macro call CmSelectionSpTemperature
    func_3037.CmSelectionSpTemperature_input_13 = (float) getCmVTB_HtgCircOptim_input_3312().getValue();
    func_3037.CmSelectionSpTemperature_input_6 = (float) getCmVTB_HtgCircOptim_input_4().getValue();
    func_3037.CmSelectionSpTemperature_input_1 = (float) getCmVTB_HtgCircOptim_input_1860().getValue();
    func_3037.CmSelectionSpTemperature_input_2 = getCmVTB_HtgCircOptim_input_1861().getValue();
    func_3037.CmSelectionSpTemperature_input_3 = getCmVTB_HtgCircOptim_input_1862().getValue();
    func_3037.CmSelectionSpTemperature_input_60 = getCmVTB_HtgCircOptim_input_1866().getValue();
    func_3037.CmSelectionSpTemperature_input_101 = (float) getCmVTB_HtgCircOptim_input_3636().getValue();
    func_3037.Execute( this, 23 );
    setCmVTB_HtgCircOptim_output_1859(func_3037.CmSelectionSpTemperature_output_5);
    setCmVTB_HtgCircOptim_parameter_71(func_3037.CmSelectionSpTemperature_output_7);

    // [3043] Macro call CmIDT05
    func_3043.CmIDT05_input_1 = (float) getCmVTB_HtgCircOptim_parameter_57();
    func_3043.CmIDT05_input_2 = (float) getCmVTB_HtgCircOptim_parameter_39();
    func_3043.CmIDT05_input_3 = (float) getCmVTB_HtgCircOptim_parameter_40();
    func_3043.CmIDT05_input_4 = (float) getCmVTB_HtgCircOptim_parameter_42();
    func_3043.CmIDT05_input_5 = (float) getCmVTB_HtgCircOptim_parameter_42();
    func_3043.Execute(  );
    setParameter(27, func_3043.CmIDT05_output_21);
    setParameter(23, func_3043.CmIDT05_output_22);
    setParameter(24, func_3043.CmIDT05_output_23);
    setParameter(26, func_3043.CmIDT05_output_24);
    setParameter(25, func_3043.CmIDT05_output_25);

    // [3158] Function call CfCompare1
    func_3158.inputA = (float) getCmVTB_HtgCircOptim_parameter_61();
    func_3158.inputB = 2F;
    func_3158.Execute(  );

    // [3170] Function call CfIdt
    func_3170.input = (float) getCmVTB_HtgCircOptim_parameter_22();
    func_3170.Execute(  );
    setParameter(90, func_3170.output[0]);

    // [3224] Function call CfIdt
    func_3224.input = (float) getCmVTB_HtgCircOptim_parameter_56();
    func_3224.Execute(  );
    setParameter(100, func_3224.output[0]);

    // [3232] Function call CfCompare1
    func_3232.inputA = (float) getCmVTB_HtgCircOptim_parameter_59();
    func_3232.inputB = 0F;
    func_3232.Execute(  );

    // [3290] Function call CfIdt
    func_3290.input = (float) getCmVTB_HtgCircOptim_parameter_59();
    func_3290.Execute(  );
    setParameter(102, func_3290.output[0]);

    // [3291] Function call CfIdt
    func_3291.input = (float) getCmVTB_HtgCircOptim_parameter_56();
    func_3291.Execute(  );
    setParameter(103, func_3291.output[0]);

    // [3342] Function call CfDelayOnOff
    func_3342.input = getCmVTB_HtgCircOptim_input_2614().getValue();
    func_3342.Execute( this, 30 );

    // [2654] Macro call CmMaxCntrReturnTemp
    func_2654.CmMaxCntrReturnTemp_input_60 = (float) getCmVTB_HtgCircOptim_input_8().getValue();
    func_2654.CmMaxCntrReturnTemp_input_61 = (float) getCmVTB_HtgCircOptim_input_3().getValue();
    func_2654.CmMaxCntrReturnTemp_input_135 = func_2565.CmTempSenAvailable_output_2;
    func_2654.Execute( this, 32 );

    // [2726] Function call CfOr
    func_2726.input[0] = func_2729.outputEqual;
    func_2726.input[1] = func_3158.outputEqual;
    func_2726.Execute(  );

    // [2870] Function call CfInputMultiplexer
    func_2870.inputSelect = BooleanToInt(getCmVTB_HtgCircOptim_input_1862().getValue());
    func_2870.input[1-1] = func_2868.output;
    func_2870.input[2-1] = 2F;
    func_2870.Execute(  );

    // [2880] Function call CfInputMultiplexer
    func_2880.inputSelect = BooleanToInt(getCmVTB_HtgCircOptim_input_1862().getValue());
    func_2880.input[1-1] = func_2883.output;
    func_2880.input[2-1] = 1F;
    func_2880.Execute(  );

    // [3016] Function call CfIdt
    func_3016.input = (float) getCmVTB_HtgCircOptim_output_16().getValue();
    func_3016.Execute(  );
    setCmVTB_HtgCircOptim_parameter_68(func_3016.output[0]);

    // [3393] Function call CfInputMultiplexer
    func_3393.inputSelect = BooleanToInt(func_3037.CmSelectionSpTemperature_output_73);
    func_3393.input[1-1] = 999F;
    func_3393.input[2-1] = (float) getCmVTB_HtgCircOptim_output_1859().getValue();
    func_3393.Execute(  );

    // [2659] Function call CfAddition
    func_2659.input[0] = func_2654.CmMaxCntrReturnTemp_output_57;
    func_2659.input[1] = 1F;
    func_2659.Execute(  );

    // [2725] Function call CfInputMultiplexer
    func_2725.inputSelect = BooleanToInt(func_2726.outputOR);
    func_2725.input[1-1] = BooleanToFloat(getCmVTB_HtgCircOptim_input_1863().getValue());
    func_2725.input[2-1] = BooleanToFloat(func_2700.output);
    func_2725.Execute(  );

    // [2869] Function call CfInputMultiplexer
    func_2869.inputSelect = BooleanToInt(getCmVTB_HtgCircOptim_input_1866().getValue());
    func_2869.input[1-1] = func_2870.output;
    func_2869.input[2-1] = 3F;
    func_2869.Execute(  );

    // [2881] Function call CfInputMultiplexer
    func_2881.inputSelect = BooleanToInt(getCmVTB_HtgCircOptim_input_1866().getValue());
    func_2881.input[1-1] = func_2880.output;
    func_2881.input[2-1] = 2F;
    func_2881.Execute(  );

    // [2702] Function call CfAnd
    func_2702.input[0] = func_2735.outputGreater;
    func_2702.input[1] = FloatToBoolean(func_2725.output);
    func_2702.input[2] = getCmVTB_HtgCircOptim_input_1863().getValue();
    func_2702.Execute(  );

    // [2878] Function call CfInputMultiplexer
    func_2878.inputSelect = BooleanToInt(getCmVTB_HtgCircOptim_input_1861().getValue());
    func_2878.input[1-1] = func_2869.output;
    func_2878.input[2-1] = 1F;
    func_2878.Execute(  );
    setCmVTB_HtgCircOptim_output_2550(func_2878.output);

    // [2882] Function call CfInputMultiplexer
    func_2882.inputSelect = BooleanToInt(getCmVTB_HtgCircOptim_input_1861().getValue());
    func_2882.input[1-1] = func_2881.output;
    func_2882.input[2-1] = 1F;
    func_2882.Execute(  );
    setCmVTB_HtgCircOptim_output_14(func_2882.output);

    // [3353] Function call CfWindow
    func_3353.inputValue = (float) getCmVTB_HtgCircOptim_output_1858().getValue();
    func_3353.inputMinimum = 0.8F;
    func_3353.inputMaximum = 1.2F;
    func_3353.Execute(  );

    // [3354] Function call CfWindow
    func_3354.inputValue = (float) getCmVTB_HtgCircOptim_output_1858().getValue();
    func_3354.inputMinimum = 4.8F;
    func_3354.inputMaximum = 7.2F;
    func_3354.Execute(  );

    // [3355] Function call CfWindow
    func_3355.inputValue = (float) getCmVTB_HtgCircOptim_output_1858().getValue();
    func_3355.inputMinimum = 8.8F;
    func_3355.inputMaximum = 11.2F;
    func_3355.Execute(  );

    // [3403] Function call CfWindow
    func_3403.inputValue = (float) getCmVTB_HtgCircOptim_output_1858().getValue();
    func_3403.inputMinimum = 1.8F;
    func_3403.inputMaximum = 4.2F;
    func_3403.Execute(  );

    // [3404] Function call CfWindow
    func_3404.inputValue = (float) getCmVTB_HtgCircOptim_output_1858().getValue();
    func_3404.inputMinimum = 7.8F;
    func_3404.inputMaximum = 8.2F;
    func_3404.Execute(  );

    // [3438] Function call CfWindow
    func_3438.inputValue = (float) getCmVTB_HtgCircOptim_output_1858().getValue();
    func_3438.inputMinimum = 4.8F;
    func_3438.inputMaximum = 5.2F;
    func_3438.Execute(  );

    // [3451] Function call CfWindow
    func_3451.inputValue = (float) getCmVTB_HtgCircOptim_output_1858().getValue();
    func_3451.inputMinimum = 4.8F;
    func_3451.inputMaximum = 5.2F;
    func_3451.Execute(  );

    // [3541] Function call CfWindow
    func_3541.inputValue = (float) getCmVTB_HtgCircOptim_output_1858().getValue();
    func_3541.inputMinimum = 0.8F;
    func_3541.inputMaximum = 1.2F;
    func_3541.Execute(  );

    // [3638] Function call CfCompare1
    func_3638.inputA = (float) getCmVTB_HtgCircOptim_input_3636().getValue();
    func_3638.inputB = 0F;
    func_3638.Execute(  );

    // [3347] Function call CfOr
    func_3347.input[0] = func_3353.output;
    func_3347.input[1] = func_3354.output;
    func_3347.input[2] = func_3355.output;
    func_3347.input[3] = getCmVTB_HtgCircOptim_input_1866().getValue();
    func_3347.input[4] = func_3638.outputGreater;
    func_3347.Execute(  );

    // [3405] Function call CfOr
    func_3405.input[0] = func_3403.output;
    func_3405.input[1] = func_3404.output;
    func_3405.Execute(  );

    // [3343] Function call CfInputMultiplexer
    func_3343.inputSelect = BooleanToInt(func_3347.outputOR);
    func_3343.input[1-1] = BooleanToFloat(func_3342.output);
    func_3343.input[2-1] = 0F;
    func_3343.Execute(  );

    // [2567] Macro call CmIDT20
    func_2567.CmIDT20_input_1 = (float) getCmVTB_HtgCircOptim_parameter_41();
    func_2567.CmIDT20_input_2 = (float) getCmVTB_HtgCircOptim_parameter_2616();
    func_2567.CmIDT20_input_3 = 2880F;
    func_2567.CmIDT20_input_4 = (float) getCmVTB_HtgCircOptim_parameter_43();
    func_2567.CmIDT20_input_5 = (float) getCmVTB_HtgCircOptim_parameter_3299();
    func_2567.CmIDT20_input_6 = (float) getCmVTB_HtgCircOptim_parameter_44();
    func_2567.CmIDT20_input_7 = (float) getCmVTB_HtgCircOptim_parameter_45();
    func_2567.CmIDT20_input_8 = (float) getCmVTB_HtgCircOptim_parameter_3300();
    func_2567.CmIDT20_input_9 = (float) getCmVTB_HtgCircOptim_parameter_46();
    func_2567.CmIDT20_input_10 = (float) getCmVTB_HtgCircOptim_parameter_47();
    func_2567.CmIDT20_input_11 = (float) getCmVTB_HtgCircOptim_parameter_48();
    func_2567.CmIDT20_input_12 = (float) getCmVTB_HtgCircOptim_parameter_49();
    func_2567.CmIDT20_input_13 = (float) getCmVTB_HtgCircOptim_parameter_50();
    func_2567.CmIDT20_input_14 = (float) getCmVTB_HtgCircOptim_parameter_3301();
    func_2567.CmIDT20_input_15 = (float) getCmVTB_HtgCircOptim_parameter_3302();
    func_2567.CmIDT20_input_16 = (float) getCmVTB_HtgCircOptim_parameter_21();
    func_2567.CmIDT20_input_17 = (float) getCmVTB_HtgCircOptim_parameter_51();
    func_2567.CmIDT20_input_18 = (float) getCmVTB_HtgCircOptim_parameter_52();
    func_2567.CmIDT20_input_19 = (float) getCmVTB_HtgCircOptim_parameter_53();
    func_2567.CmIDT20_input_20 = (float) getCmVTB_HtgCircOptim_parameter_54();
    func_2567.Execute(  );
    setParameter(53, func_2567.CmIDT20_output_21);
    setParameter(57, func_2567.CmIDT20_output_22);
    setParameter(54, func_2567.CmIDT20_output_23);
    setParameter(55, func_2567.CmIDT20_output_24);
    setParameter(74, func_2567.CmIDT20_output_25);
    setParameter(56, func_2567.CmIDT20_output_26);
    setParameter(58, func_2567.CmIDT20_output_27);
    setParameter(59, func_2567.CmIDT20_output_28);
    setParameter(60, func_2567.CmIDT20_output_29);
    setParameter(61, func_2567.CmIDT20_output_30);
    setParameter(62, func_2567.CmIDT20_output_31);
    setParameter(63, func_2567.CmIDT20_output_32);
    setParameter(64, func_2567.CmIDT20_output_33);
    setParameter(65, func_2567.CmIDT20_output_34);
    setParameter(66, func_2567.CmIDT20_output_35);
    setParameter(67, func_2567.CmIDT20_output_36);
    setParameter(68, func_2567.CmIDT20_output_37);
    setParameter(69, func_2567.CmIDT20_output_38);
    setParameter(70, func_2567.CmIDT20_output_39);
    setParameter(71, func_2567.CmIDT20_output_40);

    // [3303] Macro call CmIDT05
    func_3303.CmIDT05_input_1 = (float) getCmVTB_HtgCircOptim_parameter_64();
    func_3303.CmIDT05_input_2 = (float) getCmVTB_HtgCircOptim_parameter_27();
    func_3303.CmIDT05_input_3 = (float) getCmVTB_HtgCircOptim_parameter_36();
    func_3303.CmIDT05_input_4 = (float) getCmVTB_HtgCircOptim_parameter_37();
    func_3303.CmIDT05_input_5 = (float) getCmVTB_HtgCircOptim_parameter_38();
    func_3303.Execute(  );
    setParameter(72, func_3303.CmIDT05_output_21);
    setParameter(73, func_3303.CmIDT05_output_22);
    setParameter(75, func_3303.CmIDT05_output_23);
    setParameter(76, func_3303.CmIDT05_output_24);
    setParameter(77, func_3303.CmIDT05_output_25);

    // [3293] Function call CfEoh
    func_3293.I_ROOM_TEMP_SETPOINT = (float) getCmVTB_HtgCircOptim_input_3312().getValue();
    func_3293.I_ROOM_TEMPERATURE = (float) getCmVTB_HtgCircOptim_input_1().getValue();
    func_3293.I_ROOM_TEMPERATURE_OVERRIDE = func_3393.output;
    func_3293.I_OUTDOOR_TEMPERATURE = (float) getCmVTB_HtgCircOptim_input_8().getValue();
    func_3293.I_OPTIMIZATION_MODE = FloatToInt((float) getCmVTB_HtgCircOptim_input_3304().getValue());
    func_3293.I_HC_ADAPTION_ENABLE = FloatToBoolean(func_3343.output);
    func_3293.I_CONTROL_POINT_ADJUSTMENT = (float) getCmVTB_HtgCircOptim_input_4().getValue();
    func_3293.Execute( this, 53 );

    // [3592] Macro call CmIDT05
    func_3592.CmIDT05_input_1 = getParameter(61);
    func_3592.CmIDT05_input_2 = getParameter(63);
    func_3592.CmIDT05_input_3 = getParameter(64);
    func_3592.CmIDT05_input_4 = getParameter(69);
    func_3592.CmIDT05_input_5 = getParameter(71);
    func_3592.Execute(  );
    setCmVTB_HtgCircOptim_parameter_47(func_3592.CmIDT05_output_21);
    setCmVTB_HtgCircOptim_parameter_49(func_3592.CmIDT05_output_22);
    setCmVTB_HtgCircOptim_parameter_50(func_3592.CmIDT05_output_23);
    setCmVTB_HtgCircOptim_parameter_52(func_3592.CmIDT05_output_24);
    setCmVTB_HtgCircOptim_parameter_54(func_3592.CmIDT05_output_25);

    // [2630] Function call CfCompare1
    func_2630.inputA = IntToFloat(func_3293.O_EOH_MODE);
    func_2630.inputB = 2F;
    func_2630.Execute(  );

    // [2712] Function call CfSubtract
    func_2712.input[0] = func_3293.O_SUPPLY_WATER_TEMP;
    func_2712.input[1] = (float) getCmVTB_HtgCircOptim_parameter_20();
    func_2712.Execute(  );

    // [2740] Function call CfInputMultiplexer
    func_2740.inputSelect = BooleanToInt(func_2702.outputAND);
    func_2740.input[1-1] = func_3293.O_SUPPLY_WATER_TEMP;
    func_2740.input[2-1] = (float) getCmVTB_HtgCircOptim_parameter_20();
    func_2740.Execute(  );

    // [2755] Function call CfInputMultiplexer
    func_2755.inputSelect = BooleanToInt(getCmVTB_HtgCircOptim_input_1865().getValue());
    func_2755.input[1-1] = func_3293.O_SUPPLY_WATER_TEMP;
    func_2755.input[2-1] = (float) getCmVTB_HtgCircOptim_parameter_20();
    func_2755.Execute(  );

    // [2994] Macro call CmTimeDateLastOptim
    func_2994.CmTimeDateLastOptim_input_1 = func_3293.O_PREHEAT_ACTIVE;
    func_2994.Execute( this, 79 );
    setCmVTB_HtgCircOptim_parameter_65(func_2994.CmTimeDateLastOptim_output_2);
    setCmVTB_HtgCircOptim_parameter_67(func_2994.CmTimeDateLastOptim_output_3);
    setCmVTB_HtgCircOptim_parameter_66(func_2994.CmTimeDateLastOptim_output_4);

    // [3337] Function call CfWindow
    func_3337.inputValue = IntToFloat(func_3293.O_ROOM_CONTROL_MODE);
    func_3337.inputMinimum = 7.8F;
    func_3337.inputMaximum = 8.2F;
    func_3337.Execute(  );

    // [3601] Function call CfAnd
    func_3601.input[0] = func_2562.CmTempSenAvailable_output_2;
    func_3601.input[1] = func_3337.output;
    func_3601.Execute(  );

    // [3682] Function call CfNot
    func_3682.input = func_2562.CmTempSenAvailable_output_2;
    func_3682.Execute(  );

    // [3661] Function call CfAnd
    func_3661.input[0] = func_3337.output;
    func_3661.input[1] = func_3682.output;
    func_3661.input[2] = func_3663.output2;
    func_3661.Execute(  );

    // [3663] Function call CfHysteresis
    func_3663.inputX = (float) getCmVTB_HtgCircOptim_input_8().getValue();
    func_3663.inputW = (float) getCmVTB_HtgCircOptim_parameter_27();
    func_3663.Execute( this, 84 );

    // [3664] Function call CfOr
    func_3664.input[0] = func_3601.outputAND;
    func_3664.input[1] = func_3661.outputAND;
    func_3664.Execute(  );

    // [2633] Function call CfOr
    func_2633.input[0] = func_2630.outputEqual;
    func_2633.input[1] = func_3293.O_SETBACK_ACTIVE;
    func_2633.Execute(  );

    // [2709] Function call CfValueRamp
    func_2709.inputValue = func_2740.output;
    func_2709.Execute( this, 85 );

    // [2713] Function call CfDivide
    func_2713.inputA = func_2712.output;
    func_2713.inputB = (float) getCmVTB_HtgCircOptim_parameter_62();
    func_2713.Execute(  );

    // [3205] Function call CfAddition
    func_3205.input[0] = func_2755.output;
    func_3205.input[1] = func_2754.output;
    func_3205.Execute(  );

    // [2715] Function call CfMultiply
    func_2715.input[0] = func_2713.output;
    func_2715.input[1] = 60F;
    func_2715.Execute(  );

    // [3056] Function call CfInputMultiplexer
    func_3056.inputSelect = BooleanToInt(func_2633.outputOR);
    func_3056.input[1-1] = 1F;
    func_3056.input[2-1] = 2F;
    func_3056.Execute(  );

    // [3207] Function call CfMinimum
    func_3207.input[0] = func_3205.output;
    func_3207.input[1] = (float) getCmVTB_HtgCircOptim_parameter_21();
    func_3207.Execute(  );

    // [2628] Function call CfInputMultiplexer
    func_2628.inputSelect = FloatToInt((float) getCmVTB_HtgCircOptim_input_1860().getValue());
    func_2628.input[1-1] = 1F;
    func_2628.input[2-1] = 2F;
    func_2628.input[3-1] = 2F;
    func_2628.input[4-1] = func_3056.output;
    func_2628.Execute(  );

    // [2721] Function call CfInputMultiplexer
    func_2721.inputSelect = BooleanToInt(func_2722.outputGreater);
    func_2721.input[1-1] = 10000F;
    func_2721.input[2-1] = func_2715.output;
    func_2721.Execute(  );
    setParameter(86, func_2721.output);

    // [2742] Function call CfInputMultiplexer
    func_2742.inputSelect = BooleanToInt(getCmVTB_HtgCircOptim_input_1864().getValue());
    func_2742.input[1-1] = func_2755.output;
    func_2742.input[2-1] = func_3207.output;
    func_2742.Execute(  );

    // [3551] Function call CfSubtract
    func_3551.input[0] = func_3207.output;
    func_3551.input[1] = func_2755.output;
    func_3551.Execute(  );

    // [2625] Function call CfInputMultiplexer
    func_2625.inputSelect = BooleanToInt(getCmVTB_HtgCircOptim_input_1862().getValue());
    func_2625.input[1-1] = func_2628.output;
    func_2625.input[2-1] = 1F;
    func_2625.Execute(  );

    // [3151] Function call CfValueRamp
    func_3151.inputValue = func_2742.output;
    func_3151.Execute( this, 87 );

    // [3552] Function call CfDivide
    func_3552.inputA = func_3551.output;
    func_3552.inputB = (float) getCmVTB_HtgCircOptim_parameter_62();
    func_3552.Execute(  );

    // [2623] Function call CfInputMultiplexer
    func_2623.inputSelect = BooleanToInt(getCmVTB_HtgCircOptim_input_1866().getValue());
    func_2623.input[1-1] = func_2625.output;
    func_2623.input[2-1] = 2F;
    func_2623.Execute(  );

    // [2737] Function call CfInputMultiplexer
    func_2737.inputSelect = BooleanToInt(func_2702.outputAND);
    func_2737.input[1-1] = func_3151.output;
    func_2737.input[2-1] = func_2709.output;
    func_2737.Execute(  );

    // [3174] Function call CfCompare1
    func_3174.inputA = func_3151.output;
    func_3174.inputB = func_3293.O_SUPPLY_WATER_TEMP;
    func_3174.Execute(  );

    // [3553] Function call CfMultiply
    func_3553.input[0] = func_3552.output;
    func_3553.input[1] = 60F;
    func_3553.Execute(  );

    // [3199] Function call CfOr
    func_3199.input[0] = func_3174.outputEqual;
    func_3199.input[1] = func_3174.outputLess;
    func_3199.Execute(  );

    // [3406] Function call CfMaximum
    func_3406.input[0] = func_2737.output;
    func_3406.input[1] = (float) getCmVTB_HtgCircOptim_parameter_20();
    func_3406.Execute(  );

    // [3198] Function call CfMonoflop
    func_3198.input = BooleanToFloat(func_3199.outputOR);
    func_3198.Execute( this, 89 );

    // [3407] Function call CfInputMultiplexer
    func_3407.inputSelect = BooleanToInt(func_3405.outputOR);
    func_3407.input[1-1] = func_2737.output;
    func_3407.input[2-1] = func_3406.output;
    func_3407.Execute(  );

    // [3173] Function call CfJkFlipFlop
    func_3173.inputSet = getCmVTB_HtgCircOptim_input_1864().getValue();
    func_3173.inputClock = false;
    func_3173.inputReset = func_3198.output;
    func_3173.Execute(  );

    // [3408] Function call CfMinimum
    func_3408.input[0] = func_3407.output;
    func_3408.input[1] = (float) getCmVTB_HtgCircOptim_parameter_21();
    func_3408.Execute(  );

    // [2688] Function call CfInputMultiplexer
    func_2688.inputSelect = BooleanToInt(func_2911.outputOR);
    func_2688.input[1-1] = func_3408.output;
    func_2688.input[2-1] = 0F;
    func_2688.Execute(  );

    // [3172] Function call CfInputMultiplexer
    func_3172.inputSelect = BooleanToInt(func_3173.output);
    func_3172.input[1-1] = 10000F;
    func_3172.input[2-1] = func_3553.output;
    func_3172.Execute(  );
    setParameter(88, func_3172.output);

    // [2756] Function call CfValueRamp
    func_2756.inputValue = func_2688.output;
    func_2756.Execute( this, 90 );

    // [3449] Function call CfIdt
    func_3449.input = func_2756.output;
    func_3449.Execute(  );

    // [2761] Function call CfPidPlus
    func_2761.inputX = (float) getCmVTB_HtgCircOptim_input_2().getValue();
    func_2761.inputW = func_3449.output[1];
    func_2761.inputIntegralOn = true;
    func_2761.Execute( this, 92 );

    // [2852] Function call CfHysteresis
    func_2852.inputX = func_3449.output[1];
    func_2852.inputW = (float) getCmVTB_HtgCircOptim_output_1859().getValue();
    func_2852.Execute( this, 97 );

    // [3622] Function call CfNot
    func_3622.input = func_2669.Cmcaretaker_output_5;
    func_3622.Execute(  );

    // [3619] Function call CfAnd
    func_3619.input[0] = func_3622.output;
    func_3619.input[1] = func_2852.output1;
    func_3619.Execute(  );

    // [3210] Function call CfCompare1
    func_3210.inputA = func_3449.output[1];
    func_3210.inputB = (float) getCmVTB_HtgCircOptim_output_1859().getValue();
    func_3210.Execute(  );

    // [3450] Function call CfInputMultiplexer
    func_3450.inputSelect = BooleanToInt(func_3451.output);
    func_3450.input[1-1] = func_3449.output[0];
    func_3450.input[2-1] = (float) getCmVTB_HtgCircOptim_parameter_19();
    func_3450.Execute(  );

    // [3563] Function call CfInputMultiplexer
    func_3563.inputSelect = BooleanToInt(getCmVTB_HtgCircOptim_input_1864().getValue());
    func_3563.input[1-1] = func_3449.output[1];
    func_3563.input[2-1] = func_3293.O_SUPPLY_WATER_TEMP;
    func_3563.Execute(  );

    // [2657] Function call CfCompare1
    func_2657.inputA = func_2761.output;
    func_2657.inputB = func_2659.output;
    func_2657.Execute(  );

    // [3424] Function call CfInputMultiplexer
    func_3424.inputSelect = BooleanToInt(func_3438.output);
    func_3424.input[1-1] = func_3563.output;
    func_3424.input[2-1] = (float) getCmVTB_HtgCircOptim_parameter_19();
    func_3424.Execute(  );

    // [3443] Function call CfIdt
    func_3443.input = func_3450.output;
    func_3443.Execute(  );
    setCmVTB_HtgCircOptim_parameter_70(func_3443.output[0]);
    setCmVTB_HtgCircOptim_output_17(func_3443.output[1]);

    // [3065] Function call CfAnd
    func_3065.input[0] = func_2657.outputGreater;
    func_3065.input[1] = func_2565.CmTempSenAvailable_output_2;
    func_3065.Execute(  );

    // [2793] Macro call CmHeatDemand
    func_2793.CmHeatDemand_input_1 = func_3424.output;
    func_2793.CmHeatDemand_input_2 = (float) getCmVTB_HtgCircOptim_parameter_71();
    func_2793.CmHeatDemand_input_3 = (float) getCmVTB_HtgCircOptim_output_12().getValue();
    func_2793.CmHeatDemand_input_6 = (float) getCmVTB_HtgCircOptim_output_1858().getValue();
    func_2793.CmHeatDemand_input_55 = (float) getCmVTB_HtgCircOptim_parameter_73();
    func_2793.Execute( this, 98 );
    setCmVTB_HtgCircOptim_output_3442(func_2793.CmHeatDemand_output_4);

    // [2851] Function call CfHysteresis
    func_2851.inputX = (float) getCmVTB_HtgCircOptim_output_12().getValue();
    func_2851.inputW = 3F;
    func_2851.Execute( this, 99 );

    // [3216] Function call CfCompare1
    func_3216.inputA = (float) getCmVTB_HtgCircOptim_output_12().getValue();
    func_3216.inputB = 1F;
    func_3216.Execute(  );

    // [3222] Function call CfDelayOnOff
    func_3222.input = func_3216.outputLess;
    func_3222.Execute( this, 100 );

    // [3218] Function call CfAnd
    func_3218.input[0] = func_3232.outputGreater;
    func_3218.input[1] = func_3210.outputGreater;
    func_3218.input[2] = func_3222.output;
    func_3218.Execute(  );

    // [2848] Function call CfOr
    func_2848.input[0] = func_3619.outputAND;
    func_2848.input[1] = func_2851.output1;
    func_2848.input[2] = func_2854.output2;
    func_2848.Execute(  );

    // [3288] Function call CfCycle
    func_3288.input = func_3218.outputAND;
    func_3288.Execute( this, 102 );

    // [2849] Function call CfDelayOnOff
    func_2849.input = func_2848.outputOR;
    func_2849.Execute( this, 104 );

    // [3615] Function call CfAnd
    func_3615.input[0] = func_3288.output;
    func_3615.input[1] = func_3218.outputAND;
    func_3615.Execute(  );

    // [3289] Function call CfInputMultiplexer
    func_3289.inputSelect = BooleanToInt(func_3615.outputAND);
    func_3289.input[1-1] = BooleanToFloat(func_2849.output);
    func_3289.input[2-1] = 0F;
    func_3289.Execute(  );

    // [3564] Function call CfInputMultiplexer
    func_3564.inputSelect = BooleanToInt(func_2854.output2);
    func_3564.input[1-1] = func_3289.output;
    func_3564.input[2-1] = 1F;
    func_3564.Execute(  );

    // [3566] Function call CfInputMultiplexer
    func_3566.inputSelect = BooleanToInt(getCmVTB_HtgCircOptim_input_5().getValue());
    func_3566.input[1-1] = func_3564.output;
    func_3566.input[2-1] = 0F;
    func_3566.Execute(  );
    setCmVTB_HtgCircOptim_output_13(FloatToBoolean(func_3566.output));

    // [3569] Function call CfInputMultiplexer
    func_3569.inputSelect = BooleanToInt(func_3541.output);
    func_3569.input[1-1] = func_2761.output;
    func_3569.input[2-1] = 0F;
    func_3569.Execute(  );

    // [3570] Function call CfInputMultiplexer
    func_3570.inputSelect = BooleanToInt(func_3065.outputAND);
    func_3570.input[1-1] = func_3569.output;
    func_3570.input[2-1] = func_2654.CmMaxCntrReturnTemp_output_57;
    func_3570.Execute(  );

    // [3577] Function call CfInputMultiplexer
    func_3577.inputSelect = BooleanToInt(func_3293.O_PREHEAT_ACTIVE);
    func_3577.input[1-1] = func_2623.output;
    func_3577.input[2-1] = 3F;
    func_3577.Execute(  );

    // [3578] Function call CfInputMultiplexer
    func_3578.inputSelect = BooleanToInt(func_3293.O_SETBACK_ACTIVE);
    func_3578.input[1-1] = func_3577.output;
    func_3578.input[2-1] = 4F;
    func_3578.Execute(  );

    // [3613] Function call CfCompare1
    func_3613.inputA = func_3578.output;
    func_3613.inputB = 1F;
    func_3613.Execute(  );

    // [3612] Function call CfAnd
    func_3612.input[0] = func_3613.outputEqual;
    func_3612.input[1] = FloatToBoolean(func_2655.CmMinCntrFlowTemp_output_3);
    func_3612.Execute(  );

    // [3685] Function call CfMultiply
    func_3685.input[0] = BooleanToFloat(func_3612.outputAND);
    func_3685.input[1] = func_2655.CmMinCntrFlowTemp_output_3;
    func_3685.Execute(  );

    // [3686] Function call CfMaximum
    func_3686.input[0] = func_3685.output;
    func_3686.input[1] = func_3570.output;
    func_3686.Execute(  );

    // [3574] Function call CfInputMultiplexer
    func_3574.inputSelect = BooleanToInt(func_2669.Cmcaretaker_output_5);
    func_3574.input[1-1] = func_3686.output;
    func_3574.input[2-1] = 0F;
    func_3574.Execute(  );

    // [3575] Function call CfInputMultiplexer
    func_3575.inputSelect = BooleanToInt(getCmVTB_HtgCircOptim_input_5().getValue());
    func_3575.input[1-1] = func_3574.output;
    func_3575.input[2-1] = 0F;
    func_3575.Execute(  );
    setCmVTB_HtgCircOptim_output_12(func_3575.output);

    // [3586] Function call CfInputMultiplexer
    func_3586.inputSelect = BooleanToInt(func_3612.outputAND);
    func_3586.input[1-1] = func_3578.output;
    func_3586.input[2-1] = 5F;
    func_3586.Execute(  );

    // [3585] Function call CfInputMultiplexer
    func_3585.inputSelect = BooleanToInt(func_3065.outputAND);
    func_3585.input[1-1] = func_3586.output;
    func_3585.input[2-1] = 6F;
    func_3585.Execute(  );

    // [3587] Function call CfInputMultiplexer
    func_3587.inputSelect = BooleanToInt(func_2669.Cmcaretaker_output_5);
    func_3587.input[1-1] = func_3585.output;
    func_3587.input[2-1] = 7F;
    func_3587.Execute(  );

    // [3588] Function call CfInputMultiplexer
    func_3588.inputSelect = BooleanToInt(func_3664.outputOR);
    func_3588.input[1-1] = func_3587.output;
    func_3588.input[2-1] = 8F;
    func_3588.Execute(  );

    // [2695] Function call CfOr
    func_2695.input[0] = getCmVTB_HtgCircOptim_input_1865().getValue();
    func_2695.input[1] = func_2702.outputAND;
    func_2695.Execute(  );

    // [2647] Function call CfInputMultiplexer
    func_2647.inputSelect = BooleanToInt(func_2695.outputOR);
    func_2647.input[1-1] = func_3588.output;
    func_2647.input[2-1] = 9F;
    func_2647.Execute(  );

    // [2646] Function call CfInputMultiplexer
    func_2646.inputSelect = BooleanToInt(getCmVTB_HtgCircOptim_input_1864().getValue());
    func_2646.input[1-1] = func_2647.output;
    func_2646.input[2-1] = 10F;
    func_2646.Execute(  );

    // [3590] Function call CfInputMultiplexer
    func_3590.inputSelect = BooleanToInt(getCmVTB_HtgCircOptim_input_5().getValue());
    func_3590.input[1-1] = func_2646.output;
    func_3590.input[2-1] = 11F;
    func_3590.Execute(  );
    setCmVTB_HtgCircOptim_output_1858(func_3590.output);

    // [2998] Function call CfIdt
    func_2998.input = (float) getCmVTB_HtgCircOptim_output_1858().getValue();
    func_2998.Execute(  );
    setCmVTB_HtgCircOptim_parameter_72(func_2998.output[0]);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 0F, 0F, 3F, 0F, 0F, 100F, 0F,
    16F, 18F, 48F, 0F, -1F, -1F, 0F, 60F,
    0F, 0F, 2F, 10F, 10F, 3600F, 1F, 0F,
    0F, 0F, 0F, 0F, 0F, 10F, 10F, 0F,
    -10F, 10F, 25F, 45F, 10F, 0F, 0F, 0F,
    100F, 0F, 100F, 0F, 0F, 50F, 50F, 50F,
    100F, 100F, 10F, 0F, 0F, 60F, 2880F, 10F,
    0F, 120F, 10F, 2F, 5F, 75F, 5F, 150F,
    2F, 10F, 300F, 80F, 0F, 0F, 0F, 2F,
    16F, 2F, 1F, 4F, 13F, 2F, 73F, 0F,
    0F, 0F, 1F, 1F, 1F, 10000F, 10F, 10000F,
    10F, 3F, 10F, 10F, 3F, 0F, 1000F, 100F,
    0F, 3F, 0F, 2F, 10F, 0F, 20F, 0F,
    10F, 10F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// ValveControl
  public static final Property CmVTB_HtgCircOptim_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_output_12() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_output_12); }
  public void setCmVTB_HtgCircOptim_output_12(BStatusNumeric v) { set(CmVTB_HtgCircOptim_output_12,v,null); }
  public void setCmVTB_HtgCircOptim_output_12(float v) { getCmVTB_HtgCircOptim_output_12().setValue(v); }
// CalcRoomTmpSp
  public static final Property CmVTB_HtgCircOptim_output_1859 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_output_1859() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_output_1859); }
  public void setCmVTB_HtgCircOptim_output_1859(BStatusNumeric v) { set(CmVTB_HtgCircOptim_output_1859,v,null); }
  public void setCmVTB_HtgCircOptim_output_1859(float v) { getCmVTB_HtgCircOptim_output_1859().setValue(v); }
// CalcMWTmpSp
  public static final Property CmVTB_HtgCircOptim_output_17 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_output_17() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_output_17); }
  public void setCmVTB_HtgCircOptim_output_17(BStatusNumeric v) { set(CmVTB_HtgCircOptim_output_17,v,null); }
  public void setCmVTB_HtgCircOptim_output_17(float v) { getCmVTB_HtgCircOptim_output_17().setValue(v); }
// HeatDemand
  public static final Property CmVTB_HtgCircOptim_output_3442 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_output_3442() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_output_3442); }
  public void setCmVTB_HtgCircOptim_output_3442(BStatusNumeric v) { set(CmVTB_HtgCircOptim_output_3442,v,null); }
  public void setCmVTB_HtgCircOptim_output_3442(float v) { getCmVTB_HtgCircOptim_output_3442().setValue(v); }
// CalcRetTmpSp
  public static final Property CmVTB_HtgCircOptim_output_2977 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_output_2977() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_output_2977); }
  public void setCmVTB_HtgCircOptim_output_2977(BStatusNumeric v) { set(CmVTB_HtgCircOptim_output_2977,v,null); }
  public void setCmVTB_HtgCircOptim_output_2977(float v) { getCmVTB_HtgCircOptim_output_2977().setValue(v); }
// PumpCmd
  public static final Property CmVTB_HtgCircOptim_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmVTB_HtgCircOptim_output_13() { return (BStatusBoolean) get(CmVTB_HtgCircOptim_output_13); }
  public void setCmVTB_HtgCircOptim_output_13(BStatusBoolean v) { set(CmVTB_HtgCircOptim_output_13,v,null); }
  public void setCmVTB_HtgCircOptim_output_13(boolean v) { getCmVTB_HtgCircOptim_output_13().setValue(v); }
// SetpointSource
  public static final Property CmVTB_HtgCircOptim_output_2550 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_output_2550() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_output_2550); }
  public void setCmVTB_HtgCircOptim_output_2550(BStatusNumeric v) { set(CmVTB_HtgCircOptim_output_2550,v,null); }
  public void setCmVTB_HtgCircOptim_output_2550(float v) { getCmVTB_HtgCircOptim_output_2550().setValue(v); }
// EffOpMode
  public static final Property CmVTB_HtgCircOptim_output_14 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_output_14() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_output_14); }
  public void setCmVTB_HtgCircOptim_output_14(BStatusNumeric v) { set(CmVTB_HtgCircOptim_output_14,v,null); }
  public void setCmVTB_HtgCircOptim_output_14(float v) { getCmVTB_HtgCircOptim_output_14().setValue(v); }
// LongFiltOATemp
  public static final Property CmVTB_HtgCircOptim_output_16 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_output_16() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_output_16); }
  public void setCmVTB_HtgCircOptim_output_16(BStatusNumeric v) { set(CmVTB_HtgCircOptim_output_16,v,null); }
  public void setCmVTB_HtgCircOptim_output_16(float v) { getCmVTB_HtgCircOptim_output_16().setValue(v); }
// OperationMode
  public static final Property CmVTB_HtgCircOptim_output_1858 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_output_1858() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_output_1858); }
  public void setCmVTB_HtgCircOptim_output_1858(BStatusNumeric v) { set(CmVTB_HtgCircOptim_output_1858,v,null); }
  public void setCmVTB_HtgCircOptim_output_1858(float v) { getCmVTB_HtgCircOptim_output_1858().setValue(v); }

  // macro parameter
// MWT-01: minimum MWT protection
  public static final Property CmVTB_HtgCircOptim_parameter_19 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_19() { return getDouble(CmVTB_HtgCircOptim_parameter_19); }
  public void setCmVTB_HtgCircOptim_parameter_19(double v) { setDouble(CmVTB_HtgCircOptim_parameter_19,v,null); }
// MWT-02: minimum mixed water temperature
  public static final Property CmVTB_HtgCircOptim_parameter_20 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_20() { return getDouble(CmVTB_HtgCircOptim_parameter_20); }
  public void setCmVTB_HtgCircOptim_parameter_20(double v) { setDouble(CmVTB_HtgCircOptim_parameter_20,v,null); }
// MWT-03: maximum mixed water temperature
  public static final Property CmVTB_HtgCircOptim_parameter_21 = newProperty( 0, BDouble.make( 82 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_21() { return getDouble(CmVTB_HtgCircOptim_parameter_21); }
  public void setCmVTB_HtgCircOptim_parameter_21(double v) { setDouble(CmVTB_HtgCircOptim_parameter_21,v,null); }
// MWT-04: setpoint raise per minute
  public static final Property CmVTB_HtgCircOptim_parameter_22 = newProperty( 0, BDouble.make( 25 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(2000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("degrees kelvin per minute"))));
  public double getCmVTB_HtgCircOptim_parameter_22() { return getDouble(CmVTB_HtgCircOptim_parameter_22); }
  public void setCmVTB_HtgCircOptim_parameter_22(double v) { setDouble(CmVTB_HtgCircOptim_parameter_22,v,null); }
// MWT-05: P-band MWT control
  public static final Property CmVTB_HtgCircOptim_parameter_23 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmVTB_HtgCircOptim_parameter_23() { return getDouble(CmVTB_HtgCircOptim_parameter_23); }
  public void setCmVTB_HtgCircOptim_parameter_23(double v) { setDouble(CmVTB_HtgCircOptim_parameter_23,v,null); }
// MWT-06: I-time MWT control
  public static final Property CmVTB_HtgCircOptim_parameter_24 = newProperty( 0, BDouble.make( 24 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmVTB_HtgCircOptim_parameter_24() { return getDouble(CmVTB_HtgCircOptim_parameter_24); }
  public void setCmVTB_HtgCircOptim_parameter_24(double v) { setDouble(CmVTB_HtgCircOptim_parameter_24,v,null); }
// MWT-07: P-band minimum MWT protection
  public static final Property CmVTB_HtgCircOptim_parameter_35 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmVTB_HtgCircOptim_parameter_35() { return getDouble(CmVTB_HtgCircOptim_parameter_35); }
  public void setCmVTB_HtgCircOptim_parameter_35(double v) { setDouble(CmVTB_HtgCircOptim_parameter_35,v,null); }
// OAT-01: high limit smooth filtered long period
  public static final Property CmVTB_HtgCircOptim_parameter_25 = newProperty( 0, BDouble.make( 16 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_25() { return getDouble(CmVTB_HtgCircOptim_parameter_25); }
  public void setCmVTB_HtgCircOptim_parameter_25(double v) { setDouble(CmVTB_HtgCircOptim_parameter_25,v,null); }
// OAT-02: high limit smooth filtered short period
  public static final Property CmVTB_HtgCircOptim_parameter_26 = newProperty( 0, BDouble.make( 18 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_26() { return getDouble(CmVTB_HtgCircOptim_parameter_26); }
  public void setCmVTB_HtgCircOptim_parameter_26(double v) { setDouble(CmVTB_HtgCircOptim_parameter_26,v,null); }
// OAT-03: low limit frost protection
  public static final Property CmVTB_HtgCircOptim_parameter_27 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_27() { return getDouble(CmVTB_HtgCircOptim_parameter_27); }
  public void setCmVTB_HtgCircOptim_parameter_27(double v) { setDouble(CmVTB_HtgCircOptim_parameter_27,v,null); }
// OAT-04: long time smooth filtering
  public static final Property CmVTB_HtgCircOptim_parameter_28 = newProperty( 0, BDouble.make( 48 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(168)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmVTB_HtgCircOptim_parameter_28() { return getDouble(CmVTB_HtgCircOptim_parameter_28); }
  public void setCmVTB_HtgCircOptim_parameter_28(double v) { setDouble(CmVTB_HtgCircOptim_parameter_28,v,null); }
// RWT-01: min. OAT RWT control
  public static final Property CmVTB_HtgCircOptim_parameter_29 = newProperty( 0, BDouble.make( -10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_29() { return getDouble(CmVTB_HtgCircOptim_parameter_29); }
  public void setCmVTB_HtgCircOptim_parameter_29(double v) { setDouble(CmVTB_HtgCircOptim_parameter_29,v,null); }
// RWT-02: max. OAT RWT control
  public static final Property CmVTB_HtgCircOptim_parameter_30 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_30() { return getDouble(CmVTB_HtgCircOptim_parameter_30); }
  public void setCmVTB_HtgCircOptim_parameter_30(double v) { setDouble(CmVTB_HtgCircOptim_parameter_30,v,null); }
// RWT-03: low setpoint
  public static final Property CmVTB_HtgCircOptim_parameter_31 = newProperty( 0, BDouble.make( 65 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_31() { return getDouble(CmVTB_HtgCircOptim_parameter_31); }
  public void setCmVTB_HtgCircOptim_parameter_31(double v) { setDouble(CmVTB_HtgCircOptim_parameter_31,v,null); }
// RWT-04: high setpoint
  public static final Property CmVTB_HtgCircOptim_parameter_32 = newProperty( 0, BDouble.make( 85 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_32() { return getDouble(CmVTB_HtgCircOptim_parameter_32); }
  public void setCmVTB_HtgCircOptim_parameter_32(double v) { setDouble(CmVTB_HtgCircOptim_parameter_32,v,null); }
// RWT-05: P-band RWT control
  public static final Property CmVTB_HtgCircOptim_parameter_33 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmVTB_HtgCircOptim_parameter_33() { return getDouble(CmVTB_HtgCircOptim_parameter_33); }
  public void setCmVTB_HtgCircOptim_parameter_33(double v) { setDouble(CmVTB_HtgCircOptim_parameter_33,v,null); }
// RWT-06: I-time RWT control
  public static final Property CmVTB_HtgCircOptim_parameter_34 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmVTB_HtgCircOptim_parameter_34() { return getDouble(CmVTB_HtgCircOptim_parameter_34); }
  public void setCmVTB_HtgCircOptim_parameter_34(double v) { setDouble(CmVTB_HtgCircOptim_parameter_34,v,null); }
// RMT-01: room temp. compensation factor
  public static final Property CmVTB_HtgCircOptim_parameter_36 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(50)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmVTB_HtgCircOptim_parameter_36() { return getDouble(CmVTB_HtgCircOptim_parameter_36); }
  public void setCmVTB_HtgCircOptim_parameter_36(double v) { setDouble(CmVTB_HtgCircOptim_parameter_36,v,null); }
// RMT-02: minimum room temperature
  public static final Property CmVTB_HtgCircOptim_parameter_37 = newProperty( 0, BDouble.make( 13 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_37() { return getDouble(CmVTB_HtgCircOptim_parameter_37); }
  public void setCmVTB_HtgCircOptim_parameter_37(double v) { setDouble(CmVTB_HtgCircOptim_parameter_37,v,null); }
// RMT-03: differential minimum room temperature
  public static final Property CmVTB_HtgCircOptim_parameter_38 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(5)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmVTB_HtgCircOptim_parameter_38() { return getDouble(CmVTB_HtgCircOptim_parameter_38); }
  public void setCmVTB_HtgCircOptim_parameter_38(double v) { setDouble(CmVTB_HtgCircOptim_parameter_38,v,null); }
// RMT-04: manual occupied setpoint (day)
  public static final Property CmVTB_HtgCircOptim_parameter_39 = newProperty( 0, BDouble.make( 21 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_39() { return getDouble(CmVTB_HtgCircOptim_parameter_39); }
  public void setCmVTB_HtgCircOptim_parameter_39(double v) { setDouble(CmVTB_HtgCircOptim_parameter_39,v,null); }
// RMT-05: manual unoccupied setpoint (night)
  public static final Property CmVTB_HtgCircOptim_parameter_40 = newProperty( 0, BDouble.make( 15 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_40() { return getDouble(CmVTB_HtgCircOptim_parameter_40); }
  public void setCmVTB_HtgCircOptim_parameter_40(double v) { setDouble(CmVTB_HtgCircOptim_parameter_40,v,null); }
// RMT-06: manual setpoint summer or holiday
  public static final Property CmVTB_HtgCircOptim_parameter_42 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_42() { return getDouble(CmVTB_HtgCircOptim_parameter_42); }
  public void setCmVTB_HtgCircOptim_parameter_42(double v) { setDouble(CmVTB_HtgCircOptim_parameter_42,v,null); }
// RMT-07: auto reset from extended operation
  public static final Property CmVTB_HtgCircOptim_parameter_57 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(480)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmVTB_HtgCircOptim_parameter_57() { return getDouble(CmVTB_HtgCircOptim_parameter_57); }
  public void setCmVTB_HtgCircOptim_parameter_57(double v) { setDouble(CmVTB_HtgCircOptim_parameter_57,v,null); }
// PREH-01: minimum preheat time
  public static final Property CmVTB_HtgCircOptim_parameter_41 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1440)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmVTB_HtgCircOptim_parameter_41() { return getDouble(CmVTB_HtgCircOptim_parameter_41); }
  public void setCmVTB_HtgCircOptim_parameter_41(double v) { setDouble(CmVTB_HtgCircOptim_parameter_41,v,null); }
// PREH-02: pre-start constant time at OAT=0°C (if RMT=999)
  public static final Property CmVTB_HtgCircOptim_parameter_2616 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1440)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmVTB_HtgCircOptim_parameter_2616() { return getDouble(CmVTB_HtgCircOptim_parameter_2616); }
  public void setCmVTB_HtgCircOptim_parameter_2616(double v) { setDouble(CmVTB_HtgCircOptim_parameter_2616,v,null); }
// PREH-03: pre-start constant (if RMT=999)
  public static final Property CmVTB_HtgCircOptim_parameter_43 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmVTB_HtgCircOptim_parameter_43() { return getDouble(CmVTB_HtgCircOptim_parameter_43); }
  public void setCmVTB_HtgCircOptim_parameter_43(double v) { setDouble(CmVTB_HtgCircOptim_parameter_43,v,null); }
// PREH-04: boost factor
  public static final Property CmVTB_HtgCircOptim_parameter_3299 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(30)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmVTB_HtgCircOptim_parameter_3299() { return getDouble(CmVTB_HtgCircOptim_parameter_3299); }
  public void setCmVTB_HtgCircOptim_parameter_3299(double v) { setDouble(CmVTB_HtgCircOptim_parameter_3299,v,null); }
// OOFF-01: minimum OAT for optimised stop
  public static final Property CmVTB_HtgCircOptim_parameter_44 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_44() { return getDouble(CmVTB_HtgCircOptim_parameter_44); }
  public void setCmVTB_HtgCircOptim_parameter_44(double v) { setDouble(CmVTB_HtgCircOptim_parameter_44,v,null); }
// OOFF-02: optimum stop factor
  public static final Property CmVTB_HtgCircOptim_parameter_45 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(100)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmVTB_HtgCircOptim_parameter_45() { return getDouble(CmVTB_HtgCircOptim_parameter_45); }
  public void setCmVTB_HtgCircOptim_parameter_45(double v) { setDouble(CmVTB_HtgCircOptim_parameter_45,v,null); }
// OOFF-03: room comfort zone
  public static final Property CmVTB_HtgCircOptim_parameter_3300 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmVTB_HtgCircOptim_parameter_3300() { return getDouble(CmVTB_HtgCircOptim_parameter_3300); }
  public void setCmVTB_HtgCircOptim_parameter_3300(double v) { setDouble(CmVTB_HtgCircOptim_parameter_3300,v,null); }
// RCTR-01: room control P-band
  public static final Property CmVTB_HtgCircOptim_parameter_3301 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmVTB_HtgCircOptim_parameter_3301() { return getDouble(CmVTB_HtgCircOptim_parameter_3301); }
  public void setCmVTB_HtgCircOptim_parameter_3301(double v) { setDouble(CmVTB_HtgCircOptim_parameter_3301,v,null); }
// RCTR-02: room control I-time
  public static final Property CmVTB_HtgCircOptim_parameter_3302 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(7200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmVTB_HtgCircOptim_parameter_3302() { return getDouble(CmVTB_HtgCircOptim_parameter_3302); }
  public void setCmVTB_HtgCircOptim_parameter_3302(double v) { setDouble(CmVTB_HtgCircOptim_parameter_3302,v,null); }
// BMOD-01: dead time short (adaptive)
  public static final Property CmVTB_HtgCircOptim_parameter_46 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(60)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmVTB_HtgCircOptim_parameter_46() { return getDouble(CmVTB_HtgCircOptim_parameter_46); }
  public void setCmVTB_HtgCircOptim_parameter_46(double v) { setDouble(CmVTB_HtgCircOptim_parameter_46,v,null); }
// BMOD-02: time constant short (adaptive)
  public static final Property CmVTB_HtgCircOptim_parameter_47 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(30)), BFacets.make(BFacets.MAX, BDouble.make(1440)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmVTB_HtgCircOptim_parameter_47() { return getDouble(CmVTB_HtgCircOptim_parameter_47); }
  public void setCmVTB_HtgCircOptim_parameter_47(double v) { setDouble(CmVTB_HtgCircOptim_parameter_47,v,null); }
// BMOD-03: dead time long (adaptive)
  public static final Property CmVTB_HtgCircOptim_parameter_48 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(60)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmVTB_HtgCircOptim_parameter_48() { return getDouble(CmVTB_HtgCircOptim_parameter_48); }
  public void setCmVTB_HtgCircOptim_parameter_48(double v) { setDouble(CmVTB_HtgCircOptim_parameter_48,v,null); }
// BMOD-04: time constant long (adaptive)
  public static final Property CmVTB_HtgCircOptim_parameter_49 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(30)), BFacets.make(BFacets.MAX, BDouble.make(1440)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmVTB_HtgCircOptim_parameter_49() { return getDouble(CmVTB_HtgCircOptim_parameter_49); }
  public void setCmVTB_HtgCircOptim_parameter_49(double v) { setDouble(CmVTB_HtgCircOptim_parameter_49,v,null); }
// BMOD-05: adaptation; 0 = disable; 1 = enable; 2 = new start
  public static final Property CmVTB_HtgCircOptim_parameter_50 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmVTB_HtgCircOptim_parameter_50() { return getDouble(CmVTB_HtgCircOptim_parameter_50); }
  public void setCmVTB_HtgCircOptim_parameter_50(double v) { setDouble(CmVTB_HtgCircOptim_parameter_50,v,null); }
// HCA-01: heating curve curvation
  public static final Property CmVTB_HtgCircOptim_parameter_51 = newProperty( 0, BDouble.make( 1.33 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmVTB_HtgCircOptim_parameter_51() { return getDouble(CmVTB_HtgCircOptim_parameter_51); }
  public void setCmVTB_HtgCircOptim_parameter_51(double v) { setDouble(CmVTB_HtgCircOptim_parameter_51,v,null); }
// HCA-02: heating curve slope
  public static final Property CmVTB_HtgCircOptim_parameter_52 = newProperty( 0, BDouble.make( 1.6 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(4.5)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmVTB_HtgCircOptim_parameter_52() { return getDouble(CmVTB_HtgCircOptim_parameter_52); }
  public void setCmVTB_HtgCircOptim_parameter_52(double v) { setDouble(CmVTB_HtgCircOptim_parameter_52,v,null); }
// HCA-03: heating curve slope limit
  public static final Property CmVTB_HtgCircOptim_parameter_53 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(4.5)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmVTB_HtgCircOptim_parameter_53() { return getDouble(CmVTB_HtgCircOptim_parameter_53); }
  public void setCmVTB_HtgCircOptim_parameter_53(double v) { setDouble(CmVTB_HtgCircOptim_parameter_53,v,null); }
// HCA-04: adaptation: 0 = none; 1 = adaptive; 2 = new start; 3 = refreshed new start; 4 = direct RMT reset
  public static final Property CmVTB_HtgCircOptim_parameter_54 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(4)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmVTB_HtgCircOptim_parameter_54() { return getDouble(CmVTB_HtgCircOptim_parameter_54); }
  public void setCmVTB_HtgCircOptim_parameter_54(double v) { setDouble(CmVTB_HtgCircOptim_parameter_54,v,null); }
// HPU-01: pump start-up delay
  public static final Property CmVTB_HtgCircOptim_parameter_55 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmVTB_HtgCircOptim_parameter_55() { return getDouble(CmVTB_HtgCircOptim_parameter_55); }
  public void setCmVTB_HtgCircOptim_parameter_55(double v) { setDouble(CmVTB_HtgCircOptim_parameter_55,v,null); }
// HPU-02: pump switch off delay
  public static final Property CmVTB_HtgCircOptim_parameter_56 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmVTB_HtgCircOptim_parameter_56() { return getDouble(CmVTB_HtgCircOptim_parameter_56); }
  public void setCmVTB_HtgCircOptim_parameter_56(double v) { setDouble(CmVTB_HtgCircOptim_parameter_56,v,null); }
// HPU-03: pump restart when valve closed; 0 = disable
  public static final Property CmVTB_HtgCircOptim_parameter_59 = newProperty( 0, BDouble.make( 900 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(7200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmVTB_HtgCircOptim_parameter_59() { return getDouble(CmVTB_HtgCircOptim_parameter_59); }
  public void setCmVTB_HtgCircOptim_parameter_59(double v) { setDouble(CmVTB_HtgCircOptim_parameter_59,v,null); }
// SYS-01: occupied / unoccupied changeover; 0 = disable
  public static final Property CmVTB_HtgCircOptim_parameter_64 = newProperty( 0, BDouble.make( 16 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_64() { return getDouble(CmVTB_HtgCircOptim_parameter_64); }
  public void setCmVTB_HtgCircOptim_parameter_64(double v) { setDouble(CmVTB_HtgCircOptim_parameter_64,v,null); }
// SYS-02: heat override raise percentage; 0 = disable
  public static final Property CmVTB_HtgCircOptim_parameter_60 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(2000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmVTB_HtgCircOptim_parameter_60() { return getDouble(CmVTB_HtgCircOptim_parameter_60); }
  public void setCmVTB_HtgCircOptim_parameter_60(double v) { setDouble(CmVTB_HtgCircOptim_parameter_60,v,null); }
// SYS-03: mode DHWS priority function; 0 = disable
  public static final Property CmVTB_HtgCircOptim_parameter_61 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(4)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmVTB_HtgCircOptim_parameter_61() { return getDouble(CmVTB_HtgCircOptim_parameter_61); }
  public void setCmVTB_HtgCircOptim_parameter_61(double v) { setDouble(CmVTB_HtgCircOptim_parameter_61,v,null); }
// SYS-04: MWT setpoint decrease time
  public static final Property CmVTB_HtgCircOptim_parameter_62 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmVTB_HtgCircOptim_parameter_62() { return getDouble(CmVTB_HtgCircOptim_parameter_62); }
  public void setCmVTB_HtgCircOptim_parameter_62(double v) { setDouble(CmVTB_HtgCircOptim_parameter_62,v,null); }
// SYS-05: max. duration DHWS priority function
  public static final Property CmVTB_HtgCircOptim_parameter_63 = newProperty( 0, BDouble.make( 3600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(18000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmVTB_HtgCircOptim_parameter_63() { return getDouble(CmVTB_HtgCircOptim_parameter_63); }
  public void setCmVTB_HtgCircOptim_parameter_63(double v) { setDouble(CmVTB_HtgCircOptim_parameter_63,v,null); }
// SYS-06: heat demand transmission
  public static final Property CmVTB_HtgCircOptim_parameter_73 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmVTB_HtgCircOptim_parameter_73() { return getDouble(CmVTB_HtgCircOptim_parameter_73); }
  public void setCmVTB_HtgCircOptim_parameter_73(double v) { setDouble(CmVTB_HtgCircOptim_parameter_73,v,null); }
// DISP-01: calculated room temperature setpoint
  public static final Property CmVTB_HtgCircOptim_parameter_71 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_71() { return getDouble(CmVTB_HtgCircOptim_parameter_71); }
  public void setCmVTB_HtgCircOptim_parameter_71(double v) { setDouble(CmVTB_HtgCircOptim_parameter_71,v,null); }
// DISP-02: calculated mixed water temperature setpoint
  public static final Property CmVTB_HtgCircOptim_parameter_70 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_70() { return getDouble(CmVTB_HtgCircOptim_parameter_70); }
  public void setCmVTB_HtgCircOptim_parameter_70(double v) { setDouble(CmVTB_HtgCircOptim_parameter_70,v,null); }
// DISP-03: long term smooth filtered outside air temperature
  public static final Property CmVTB_HtgCircOptim_parameter_68 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_68() { return getDouble(CmVTB_HtgCircOptim_parameter_68); }
  public void setCmVTB_HtgCircOptim_parameter_68(double v) { setDouble(CmVTB_HtgCircOptim_parameter_68,v,null); }
// DISP-04: calculated return water temperature setpoint
  public static final Property CmVTB_HtgCircOptim_parameter_69 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmVTB_HtgCircOptim_parameter_69() { return getDouble(CmVTB_HtgCircOptim_parameter_69); }
  public void setCmVTB_HtgCircOptim_parameter_69(double v) { setDouble(CmVTB_HtgCircOptim_parameter_69,v,null); }
// DISP-05: operation mode
  public static final Property CmVTB_HtgCircOptim_parameter_72 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmVTB_HtgCircOptim_parameter_72() { return getDouble(CmVTB_HtgCircOptim_parameter_72); }
  public void setCmVTB_HtgCircOptim_parameter_72(double v) { setDouble(CmVTB_HtgCircOptim_parameter_72,v,null); }
// DISP-06: start time optimum start
  public static final Property CmVTB_HtgCircOptim_parameter_65 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmVTB_HtgCircOptim_parameter_65() { return getDouble(CmVTB_HtgCircOptim_parameter_65); }
  public void setCmVTB_HtgCircOptim_parameter_65(double v) { setDouble(CmVTB_HtgCircOptim_parameter_65,v,null); }
// DISP-07: end time optimum start
  public static final Property CmVTB_HtgCircOptim_parameter_66 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmVTB_HtgCircOptim_parameter_66() { return getDouble(CmVTB_HtgCircOptim_parameter_66); }
  public void setCmVTB_HtgCircOptim_parameter_66(double v) { setDouble(CmVTB_HtgCircOptim_parameter_66,v,null); }
// DISP-08: date last optimum start
  public static final Property CmVTB_HtgCircOptim_parameter_67 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmVTB_HtgCircOptim_parameter_67() { return getDouble(CmVTB_HtgCircOptim_parameter_67); }
  public void setCmVTB_HtgCircOptim_parameter_67(double v) { setDouble(CmVTB_HtgCircOptim_parameter_67,v,null); }

  // macro inputs
// MixedWaterTemp
  public static final Property CmVTB_HtgCircOptim_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_input_2() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_input_2); }
  public void setCmVTB_HtgCircOptim_input_2(BStatusNumeric v) { set(CmVTB_HtgCircOptim_input_2,v,null); }
  public void setCmVTB_HtgCircOptim_input_2(float v) { getCmVTB_HtgCircOptim_input_2().setValue(v); }
// RoomTemp
  public static final Property CmVTB_HtgCircOptim_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_input_1() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_input_1); }
  public void setCmVTB_HtgCircOptim_input_1(BStatusNumeric v) { set(CmVTB_HtgCircOptim_input_1,v,null); }
  public void setCmVTB_HtgCircOptim_input_1(float v) { getCmVTB_HtgCircOptim_input_1().setValue(v); }
// ReturnWaterTemp
  public static final Property CmVTB_HtgCircOptim_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_input_3() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_input_3); }
  public void setCmVTB_HtgCircOptim_input_3(BStatusNumeric v) { set(CmVTB_HtgCircOptim_input_3,v,null); }
  public void setCmVTB_HtgCircOptim_input_3(float v) { getCmVTB_HtgCircOptim_input_3().setValue(v); }
// FilteredOATemp
  public static final Property CmVTB_HtgCircOptim_input_8 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_input_8() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_input_8); }
  public void setCmVTB_HtgCircOptim_input_8(BStatusNumeric v) { set(CmVTB_HtgCircOptim_input_8,v,null); }
  public void setCmVTB_HtgCircOptim_input_8(float v) { getCmVTB_HtgCircOptim_input_8().setValue(v); }
// RoomTempSp
  public static final Property CmVTB_HtgCircOptim_input_3312 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_input_3312() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_input_3312); }
  public void setCmVTB_HtgCircOptim_input_3312(BStatusNumeric v) { set(CmVTB_HtgCircOptim_input_3312,v,null); }
  public void setCmVTB_HtgCircOptim_input_3312(float v) { getCmVTB_HtgCircOptim_input_3312().setValue(v); }
// OptimEnable
  public static final Property CmVTB_HtgCircOptim_input_3304 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_input_3304() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_input_3304); }
  public void setCmVTB_HtgCircOptim_input_3304(BStatusNumeric v) { set(CmVTB_HtgCircOptim_input_3304,v,null); }
  public void setCmVTB_HtgCircOptim_input_3304(float v) { getCmVTB_HtgCircOptim_input_3304().setValue(v); }
// ContrPtAdj
  public static final Property CmVTB_HtgCircOptim_input_4 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_input_4() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_input_4); }
  public void setCmVTB_HtgCircOptim_input_4(BStatusNumeric v) { set(CmVTB_HtgCircOptim_input_4,v,null); }
  public void setCmVTB_HtgCircOptim_input_4(float v) { getCmVTB_HtgCircOptim_input_4().setValue(v); }
// ManSwCond
  public static final Property CmVTB_HtgCircOptim_input_1860 = newProperty( Flags.SUMMARY, new BStatusNumeric( 3 ), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_input_1860() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_input_1860); }
  public void setCmVTB_HtgCircOptim_input_1860(BStatusNumeric v) { set(CmVTB_HtgCircOptim_input_1860,v,null); }
  public void setCmVTB_HtgCircOptim_input_1860(float v) { getCmVTB_HtgCircOptim_input_1860().setValue(v); }
// PumpStatus
  public static final Property CmVTB_HtgCircOptim_input_2614 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmVTB_HtgCircOptim_input_2614() { return (BStatusBoolean) get(CmVTB_HtgCircOptim_input_2614); }
  public void setCmVTB_HtgCircOptim_input_2614(BStatusBoolean v) { set(CmVTB_HtgCircOptim_input_2614,v,null); }
  public void setCmVTB_HtgCircOptim_input_2614(boolean v) { getCmVTB_HtgCircOptim_input_2614().setValue(v); }
// MaxThernostat
  public static final Property CmVTB_HtgCircOptim_input_5 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmVTB_HtgCircOptim_input_5() { return (BStatusBoolean) get(CmVTB_HtgCircOptim_input_5); }
  public void setCmVTB_HtgCircOptim_input_5(BStatusBoolean v) { set(CmVTB_HtgCircOptim_input_5,v,null); }
  public void setCmVTB_HtgCircOptim_input_5(boolean v) { getCmVTB_HtgCircOptim_input_5().setValue(v); }
// SummerSwitch
  public static final Property CmVTB_HtgCircOptim_input_1861 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmVTB_HtgCircOptim_input_1861() { return (BStatusBoolean) get(CmVTB_HtgCircOptim_input_1861); }
  public void setCmVTB_HtgCircOptim_input_1861(BStatusBoolean v) { set(CmVTB_HtgCircOptim_input_1861,v,null); }
  public void setCmVTB_HtgCircOptim_input_1861(boolean v) { getCmVTB_HtgCircOptim_input_1861().setValue(v); }
// HolidaySwitch
  public static final Property CmVTB_HtgCircOptim_input_1862 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmVTB_HtgCircOptim_input_1862() { return (BStatusBoolean) get(CmVTB_HtgCircOptim_input_1862); }
  public void setCmVTB_HtgCircOptim_input_1862(BStatusBoolean v) { set(CmVTB_HtgCircOptim_input_1862,v,null); }
  public void setCmVTB_HtgCircOptim_input_1862(boolean v) { getCmVTB_HtgCircOptim_input_1862().setValue(v); }
// DHWS_Priority
  public static final Property CmVTB_HtgCircOptim_input_1863 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmVTB_HtgCircOptim_input_1863() { return (BStatusBoolean) get(CmVTB_HtgCircOptim_input_1863); }
  public void setCmVTB_HtgCircOptim_input_1863(BStatusBoolean v) { set(CmVTB_HtgCircOptim_input_1863,v,null); }
  public void setCmVTB_HtgCircOptim_input_1863(boolean v) { getCmVTB_HtgCircOptim_input_1863().setValue(v); }
// OverheatProt
  public static final Property CmVTB_HtgCircOptim_input_1864 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmVTB_HtgCircOptim_input_1864() { return (BStatusBoolean) get(CmVTB_HtgCircOptim_input_1864); }
  public void setCmVTB_HtgCircOptim_input_1864(BStatusBoolean v) { set(CmVTB_HtgCircOptim_input_1864,v,null); }
  public void setCmVTB_HtgCircOptim_input_1864(boolean v) { getCmVTB_HtgCircOptim_input_1864().setValue(v); }
// CondensProt
  public static final Property CmVTB_HtgCircOptim_input_1865 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmVTB_HtgCircOptim_input_1865() { return (BStatusBoolean) get(CmVTB_HtgCircOptim_input_1865); }
  public void setCmVTB_HtgCircOptim_input_1865(BStatusBoolean v) { set(CmVTB_HtgCircOptim_input_1865,v,null); }
  public void setCmVTB_HtgCircOptim_input_1865(boolean v) { getCmVTB_HtgCircOptim_input_1865().setValue(v); }
// DayExtension
  public static final Property CmVTB_HtgCircOptim_input_1866 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmVTB_HtgCircOptim_input_1866() { return (BStatusBoolean) get(CmVTB_HtgCircOptim_input_1866); }
  public void setCmVTB_HtgCircOptim_input_1866(BStatusBoolean v) { set(CmVTB_HtgCircOptim_input_1866,v,null); }
  public void setCmVTB_HtgCircOptim_input_1866(boolean v) { getCmVTB_HtgCircOptim_input_1866().setValue(v); }
// RoomSpRampIn
  public static final Property CmVTB_HtgCircOptim_input_3636 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmVTB_HtgCircOptim_input_3636() { return (BStatusNumeric) get(CmVTB_HtgCircOptim_input_3636); }
  public void setCmVTB_HtgCircOptim_input_3636(BStatusNumeric v) { set(CmVTB_HtgCircOptim_input_3636,v,null); }
  public void setCmVTB_HtgCircOptim_input_3636(float v) { getCmVTB_HtgCircOptim_input_3636().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.08 [193] 05.03.2018-11:28").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6064731699718128002").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmVTB_HtgCircOptim.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public TuncosInformation getTuncosInfo(int tuncosId)
  {
    TuncosInformation tuncos = null;
    try
    {
      Property prop = null;
      switch (tuncosId)
      {
      case 73: prop = CmVTB_HtgCircOptim_input_3312; break;
      }
      if (prop != null)
        tuncos = super.getTuncos(prop);
    }
    catch (Exception x)
    {
    }
    return tuncos;
  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private float   IntToFloat    (int     value) { return (float) value; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfTruncate func_2553 = new CfTruncate();
  protected CmTempSenAvailable func_2562 = new CmTempSenAvailable();
  protected CmTempSenAvailable func_2565 = new CmTempSenAvailable();
  protected CmMinCntrFlowTemp func_2655 = new CmMinCntrFlowTemp();
  protected Cmcaretaker func_2669 = new Cmcaretaker();
  protected CfIdt func_3143 = new CfIdt();
  protected CfMonoflop func_2700 = new CfMonoflop();
  protected CfCompare1 func_2722 = new CfCompare1();
  protected CfCompare1 func_2729 = new CfCompare1();
  protected CfCompare1 func_2735 = new CfCompare1();
  protected CfMultiply func_2754 = new CfMultiply();
  protected CfIdt func_2757 = new CfIdt();
  protected CmIDT10 func_2775 = new CmIDT10();
  protected CmIDT05 func_2786 = new CmIDT05();
  protected CfIdt func_2845 = new CfIdt();
  protected CfIdt func_2850 = new CfIdt();
  protected CfHysteresis func_2854 = new CfHysteresis();
  protected CfInputMultiplexer func_2868 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2883 = new CfInputMultiplexer();
  protected CfOr func_2911 = new CfOr();
  protected CmIDT05 func_3003 = new CmIDT05();
  protected CmIDT05 func_3009 = new CmIDT05();
  protected CmSelectionSpTemperature func_3037 = new CmSelectionSpTemperature();
  protected CmIDT05 func_3043 = new CmIDT05();
  protected CfCompare1 func_3158 = new CfCompare1();
  protected CfIdt func_3170 = new CfIdt();
  protected CfIdt func_3224 = new CfIdt();
  protected CfCompare1 func_3232 = new CfCompare1();
  protected CfIdt func_3290 = new CfIdt();
  protected CfIdt func_3291 = new CfIdt();
  protected CfDelayOnOff func_3342 = new CfDelayOnOff();
  protected CmMaxCntrReturnTemp func_2654 = new CmMaxCntrReturnTemp();
  protected CfOr func_2726 = new CfOr();
  protected CfInputMultiplexer func_2870 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2880 = new CfInputMultiplexer();
  protected CfIdt func_3016 = new CfIdt();
  protected CfInputMultiplexer func_3393 = new CfInputMultiplexer();
  protected CfAddition func_2659 = new CfAddition();
  protected CfInputMultiplexer func_2725 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2869 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2881 = new CfInputMultiplexer();
  protected CfAnd func_2702 = new CfAnd();
  protected CfInputMultiplexer func_2878 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2882 = new CfInputMultiplexer();
  protected CfWindow func_3353 = new CfWindow();
  protected CfWindow func_3354 = new CfWindow();
  protected CfWindow func_3355 = new CfWindow();
  protected CfWindow func_3403 = new CfWindow();
  protected CfWindow func_3404 = new CfWindow();
  protected CfWindow func_3438 = new CfWindow();
  protected CfWindow func_3451 = new CfWindow();
  protected CfWindow func_3541 = new CfWindow();
  protected CfCompare1 func_3638 = new CfCompare1();
  protected CfOr func_3347 = new CfOr();
  protected CfOr func_3405 = new CfOr();
  protected CfInputMultiplexer func_3343 = new CfInputMultiplexer();
  protected CmIDT20 func_2567 = new CmIDT20();
  protected CmIDT05 func_3303 = new CmIDT05();
  protected CfEoh func_3293 = new CfEoh();
  protected CmIDT05 func_3592 = new CmIDT05();
  protected CfCompare1 func_2630 = new CfCompare1();
  protected CfSubtract func_2712 = new CfSubtract();
  protected CfInputMultiplexer func_2740 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2755 = new CfInputMultiplexer();
  protected CmTimeDateLastOptim func_2994 = new CmTimeDateLastOptim();
  protected CfWindow func_3337 = new CfWindow();
  protected CfAnd func_3601 = new CfAnd();
  protected CfNot func_3682 = new CfNot();
  protected CfAnd func_3661 = new CfAnd();
  protected CfHysteresis func_3663 = new CfHysteresis();
  protected CfOr func_3664 = new CfOr();
  protected CfOr func_2633 = new CfOr();
  protected CfValueRamp func_2709 = new CfValueRamp();
  protected CfDivide func_2713 = new CfDivide();
  protected CfAddition func_3205 = new CfAddition();
  protected CfMultiply func_2715 = new CfMultiply();
  protected CfInputMultiplexer func_3056 = new CfInputMultiplexer();
  protected CfMinimum func_3207 = new CfMinimum();
  protected CfInputMultiplexer func_2628 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2721 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2742 = new CfInputMultiplexer();
  protected CfSubtract func_3551 = new CfSubtract();
  protected CfInputMultiplexer func_2625 = new CfInputMultiplexer();
  protected CfValueRamp func_3151 = new CfValueRamp();
  protected CfDivide func_3552 = new CfDivide();
  protected CfInputMultiplexer func_2623 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2737 = new CfInputMultiplexer();
  protected CfCompare1 func_3174 = new CfCompare1();
  protected CfMultiply func_3553 = new CfMultiply();
  protected CfOr func_3199 = new CfOr();
  protected CfMaximum func_3406 = new CfMaximum();
  protected CfMonoflop func_3198 = new CfMonoflop();
  protected CfInputMultiplexer func_3407 = new CfInputMultiplexer();
  protected CfJkFlipFlop func_3173 = new CfJkFlipFlop();
  protected CfMinimum func_3408 = new CfMinimum();
  protected CfInputMultiplexer func_2688 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_3172 = new CfInputMultiplexer();
  protected CfValueRamp func_2756 = new CfValueRamp();
  protected CfIdt func_3449 = new CfIdt();
  protected CfPidPlus func_2761 = new CfPidPlus();
  protected CfHysteresis func_2852 = new CfHysteresis();
  protected CfNot func_3622 = new CfNot();
  protected CfAnd func_3619 = new CfAnd();
  protected CfCompare1 func_3210 = new CfCompare1();
  protected CfInputMultiplexer func_3450 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_3563 = new CfInputMultiplexer();
  protected CfCompare1 func_2657 = new CfCompare1();
  protected CfInputMultiplexer func_3424 = new CfInputMultiplexer();
  protected CfIdt func_3443 = new CfIdt();
  protected CfAnd func_3065 = new CfAnd();
  protected CmHeatDemand func_2793 = new CmHeatDemand();
  protected CfHysteresis func_2851 = new CfHysteresis();
  protected CfCompare1 func_3216 = new CfCompare1();
  protected CfDelayOnOff func_3222 = new CfDelayOnOff();
  protected CfAnd func_3218 = new CfAnd();
  protected CfOr func_2848 = new CfOr();
  protected CfCycle func_3288 = new CfCycle();
  protected CfDelayOnOff func_2849 = new CfDelayOnOff();
  protected CfAnd func_3615 = new CfAnd();
  protected CfInputMultiplexer func_3289 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_3564 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_3566 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_3569 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_3570 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_3577 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_3578 = new CfInputMultiplexer();
  protected CfCompare1 func_3613 = new CfCompare1();
  protected CfAnd func_3612 = new CfAnd();
  protected CfMultiply func_3685 = new CfMultiply();
  protected CfMaximum func_3686 = new CfMaximum();
  protected CfInputMultiplexer func_3574 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_3575 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_3586 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_3585 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_3587 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_3588 = new CfInputMultiplexer();
  protected CfOr func_2695 = new CfOr();
  protected CfInputMultiplexer func_2647 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2646 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_3590 = new CfInputMultiplexer();
  protected CfIdt func_2998 = new CfIdt();

  // default constructor
  public BCmVTB_HtgCircOptim()
  {
    func_2754.configure(3);
    func_2868.configure(5);
    func_2883.configure(5);
    func_2702.configure(3);
    func_3347.configure(5);
    func_3661.configure(3);
    func_2628.configure(5);
    func_3449.configure(2);
    func_3443.configure(2);
    func_3218.configure(3);
    func_2848.configure(3);
  }

  public void Start()
  {
    func_2562.Start();
    func_2565.Start();
    func_2655.Start();
    func_2669.Start();
    func_2700.Start();
    func_2775.Start();
    func_2786.Start();
    func_2854.Start();
    func_3003.Start();
    func_3009.Start();
    func_3037.Start();
    func_3043.Start();
    func_3342.Start();
    func_2654.Start();
    func_2567.Start();
    func_3303.Start();
    func_3293.Start();
    func_3592.Start();
    func_2994.Start();
    func_3663.Start();
    func_2709.Start();
    func_3151.Start();
    func_3198.Start();
    func_3173.Start();
    func_2756.Start();
    func_2761.Start();
    func_2852.Start();
    func_2793.Start();
    func_2851.Start();
    func_3222.Start();
    func_3288.Start();
    func_2849.Start();
  }
}
