/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Boiler Demand
Macro id:      6046584063302566423
Macro version: 163
Last change:   12.10.2016 - 10:21
Access Level:  2
Inputs:
  [1] SupplyTemp
  [2] RetTemp
  [3] boiler position
  [4] boiler group
  [5] alarm
  [6] reset
  [7] enable
  [8] ST2off
  [9] StopRed
Outputs:
  [1] Next Stage
  [2] Stage1Cmd
  [3] Stage2Cmd
  [4] Max Temp
  [5] Max Temp 2
  [6] Blocking
Parameter:
  [1] ST1-02: minimum on time stage 1
  [2] ST1-04: blocking time to switch on next stage or boiler
  [3] ST2-02: minimum on time stage 2
  [4] ST2-04: blocking time to switch on next stage or boiler
  [5] ST1-03: minimum off time stage 1
  [6] ST1-05: blocking time to switch off next stage or boiler
  [7] ST2-03: minimum off time stage 2
  [8] ST2-05: blocking time to switch off next stage or boiler
  [9] ST1-01: capacity stage 1
  [10] ST2-01: capacity stage 2
  [11] BST-01: maximum boiler supply temperature stage 1
  [12] BST-02: maximum boiler supply temperature stage 2
  [13] SYS-04: maximum boiler runtime
Description:

================================================================================*/

public class CmBoiler_Demand
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [597] Macro call CmIDT10
    func_597.CmIDT10_input_1 = env.getParameter(parameterOffset);
    func_597.CmIDT10_input_2 = env.getParameter(parameterOffset + 1);
    func_597.CmIDT10_input_3 = env.getParameter(parameterOffset + 2);
    func_597.CmIDT10_input_4 = env.getParameter(parameterOffset + 3);
    func_597.CmIDT10_input_5 = env.getParameter(parameterOffset + 4);
    func_597.CmIDT10_input_6 = env.getParameter(parameterOffset + 5);
    func_597.CmIDT10_input_7 = env.getParameter(parameterOffset + 6);
    func_597.CmIDT10_input_8 = env.getParameter(parameterOffset + 7);
    func_597.CmIDT10_input_9 = env.getParameter(parameterOffset + 4);
    func_597.CmIDT10_input_10 = env.getParameter(parameterOffset + 6);
    func_597.Execute(  );
    env.setParameter(parameterOffset + 13, func_597.CmIDT10_output_21);
    env.setParameter(parameterOffset + 14, func_597.CmIDT10_output_22);
    env.setParameter(parameterOffset + 15, func_597.CmIDT10_output_23);
    env.setParameter(parameterOffset + 16, func_597.CmIDT10_output_24);
    env.setParameter(parameterOffset + 17, func_597.CmIDT10_output_25);
    env.setParameter(parameterOffset + 18, func_597.CmIDT10_output_26);
    env.setParameter(parameterOffset + 19, func_597.CmIDT10_output_27);
    env.setParameter(parameterOffset + 20, func_597.CmIDT10_output_28);
    env.setParameter(parameterOffset + 130, func_597.CmIDT10_output_29);
    env.setParameter(parameterOffset + 131, func_597.CmIDT10_output_30);

    // [608] Macro call CmIDT10
    func_608.CmIDT10_input_1 = env.getParameter(parameterOffset);
    func_608.CmIDT10_input_2 = env.getParameter(parameterOffset + 1);
    func_608.CmIDT10_input_3 = env.getParameter(parameterOffset + 2);
    func_608.CmIDT10_input_4 = env.getParameter(parameterOffset + 3);
    func_608.CmIDT10_input_5 = env.getParameter(parameterOffset + 4);
    func_608.CmIDT10_input_6 = env.getParameter(parameterOffset + 5);
    func_608.CmIDT10_input_7 = env.getParameter(parameterOffset + 6);
    func_608.CmIDT10_input_8 = env.getParameter(parameterOffset + 7);
    func_608.CmIDT10_input_9 = env.getParameter(parameterOffset + 10);
    func_608.CmIDT10_input_10 = env.getParameter(parameterOffset + 11);
    func_608.Execute(  );
    env.setParameter(parameterOffset + 39, func_608.CmIDT10_output_21);
    env.setParameter(parameterOffset + 40, func_608.CmIDT10_output_22);
    env.setParameter(parameterOffset + 41, func_608.CmIDT10_output_23);
    env.setParameter(parameterOffset + 42, func_608.CmIDT10_output_24);
    env.setParameter(parameterOffset + 43, func_608.CmIDT10_output_25);
    env.setParameter(parameterOffset + 44, func_608.CmIDT10_output_26);
    env.setParameter(parameterOffset + 45, func_608.CmIDT10_output_27);
    env.setParameter(parameterOffset + 46, func_608.CmIDT10_output_28);
    env.setParameter(parameterOffset + 126, func_608.CmIDT10_output_29);
    env.setParameter(parameterOffset + 127, func_608.CmIDT10_output_30);

    // [785] Macro call CmIDT10
    func_785.CmIDT10_input_1 = env.getParameter(parameterOffset);
    func_785.CmIDT10_input_2 = env.getParameter(parameterOffset + 1);
    func_785.CmIDT10_input_3 = env.getParameter(parameterOffset + 2);
    func_785.CmIDT10_input_4 = env.getParameter(parameterOffset + 3);
    func_785.CmIDT10_input_5 = env.getParameter(parameterOffset + 4);
    func_785.CmIDT10_input_6 = env.getParameter(parameterOffset + 5);
    func_785.CmIDT10_input_7 = env.getParameter(parameterOffset + 6);
    func_785.CmIDT10_input_8 = env.getParameter(parameterOffset + 7);
    func_785.CmIDT10_input_9 = 0F;
    func_785.CmIDT10_input_10 = 0F;
    func_785.Execute(  );
    env.setParameter(parameterOffset + 98, func_785.CmIDT10_output_21);
    env.setParameter(parameterOffset + 99, func_785.CmIDT10_output_22);
    env.setParameter(parameterOffset + 100, func_785.CmIDT10_output_23);
    env.setParameter(parameterOffset + 101, func_785.CmIDT10_output_24);
    env.setParameter(parameterOffset + 102, func_785.CmIDT10_output_25);
    env.setParameter(parameterOffset + 103, func_785.CmIDT10_output_26);
    env.setParameter(parameterOffset + 104, func_785.CmIDT10_output_27);
    env.setParameter(parameterOffset + 105, func_785.CmIDT10_output_28);

    // [691] Macro call CmBoiler_Emergency
    func_691.CmBoiler_Emergency_input_1 = CmBoiler_Demand_input_444;
    func_691.CmBoiler_Emergency_input_20 = CmBoiler_Demand_input_2;
    func_691.CmBoiler_Emergency_input_33 = CmBoiler_Demand_input_201;
    func_691.CmBoiler_Emergency_input_49 = CmBoiler_Demand_input_1;
    func_691.Execute(  );

    // [581] Macro call CmDemand_Enable
    func_581.CmDemand_Enable_input_17 = FloatToBoolean(func_691.CmBoiler_Emergency_output_2);
    func_581.CmDemand_Enable_input_23 = CmBoiler_Demand_input_2;
    func_581.CmDemand_Enable_input_64 = CmBoiler_Demand_input_746;
    func_581.CmDemand_Enable_input_79 = CmBoiler_Demand_input_1;
    func_581.Execute(  );

    // [729] Function call CfOr
    func_729.input[0] = func_239.CmBoiler_Demand_seq_output_585;
    func_729.input[1] = func_581.CmDemand_Enable_output_18;
    func_729.Execute(  );

    // [731] Function call CfOr
    func_731.input[0] = func_581.CmDemand_Enable_output_19;
    func_731.input[1] = func_233.CmBoiler_Demand_par_output_528;
    func_731.Execute(  );

    // [779] Function call CfOr
    func_779.input[0] = func_581.CmDemand_Enable_output_84;
    func_779.input[1] = func_791.CmBoiler_Demand_OpMode2_output_9;
    func_779.Execute(  );

    // [628] Function call CfIdt
    func_628.input = env.getParameter(parameterOffset + 8);
    func_628.Execute(  );
    env.setParameter(parameterOffset + 124, func_628.output[0]);
    env.setParameter(parameterOffset + 21, func_628.output[1]);
    env.setParameter(parameterOffset + 47, func_628.output[2]);
    env.setParameter(parameterOffset + 106, func_628.output[3]);

    // [629] Function call CfIdt
    func_629.input = env.getParameter(parameterOffset + 9);
    func_629.Execute(  );
    env.setParameter(parameterOffset + 125, func_629.output[0]);
    env.setParameter(parameterOffset + 22, func_629.output[1]);
    env.setParameter(parameterOffset + 48, func_629.output[2]);
    env.setParameter(parameterOffset + 107, func_629.output[3]);

    // [239] Macro call CmBoiler_Demand_seq
    if ( func_729.outputOR)
    {
      func_239.CmBoiler_Demand_seq_input_1 = CmBoiler_Demand_input_1;
      func_239.CmBoiler_Demand_seq_input_2 = CmBoiler_Demand_input_2;
      func_239.CmBoiler_Demand_seq_input_322 = CmBoiler_Demand_input_201;
      func_239.CmBoiler_Demand_seq_input_350 = func_233.CmBoiler_Demand_par_output_256;
      func_239.CmBoiler_Demand_seq_input_313 = func_233.CmBoiler_Demand_par_output_257;
      func_239.CmBoiler_Demand_seq_input_285 = func_233.CmBoiler_Demand_par_output_281;
      func_239.CmBoiler_Demand_seq_input_338 = func_233.CmBoiler_Demand_par_output_274;
      func_239.CmBoiler_Demand_seq_input_331 = func_233.CmBoiler_Demand_par_output_265;
      func_239.CmBoiler_Demand_seq_input_316 = func_233.CmBoiler_Demand_par_output_266;
      func_239.CmBoiler_Demand_seq_input_351 = func_233.CmBoiler_Demand_par_output_273;
      func_239.CmBoiler_Demand_seq_input_341 = func_233.CmBoiler_Demand_par_output_282;
      func_239.CmBoiler_Demand_seq_input_516 = func_581.CmDemand_Enable_output_18;
      func_239.Execute( env, parameterOffset +13 );
    }

    // [233] Macro call CmBoiler_Demand_par
    if ( func_731.outputOR)
    {
      func_233.CmBoiler_Demand_par_input_1 = CmBoiler_Demand_input_1;
      func_233.CmBoiler_Demand_par_input_2 = CmBoiler_Demand_input_2;
      func_233.CmBoiler_Demand_par_input_201 = CmBoiler_Demand_input_201;
      func_233.CmBoiler_Demand_par_input_284 = func_239.CmBoiler_Demand_seq_output_297;
      func_233.CmBoiler_Demand_par_input_255 = func_239.CmBoiler_Demand_seq_output_298;
      func_233.CmBoiler_Demand_par_input_254 = func_239.CmBoiler_Demand_seq_output_339;
      func_233.CmBoiler_Demand_par_input_272 = func_239.CmBoiler_Demand_seq_output_330;
      func_233.CmBoiler_Demand_par_input_271 = func_239.CmBoiler_Demand_seq_output_314;
      func_233.CmBoiler_Demand_par_input_261 = func_239.CmBoiler_Demand_seq_output_315;
      func_233.CmBoiler_Demand_par_input_285 = func_239.CmBoiler_Demand_seq_output_329;
      func_233.CmBoiler_Demand_par_input_283 = func_239.CmBoiler_Demand_seq_output_340;
      func_233.CmBoiler_Demand_par_input_485 = func_581.CmDemand_Enable_output_19;
      func_233.Execute( env, parameterOffset +39 );
    }

    // [791] Macro call CmBoiler_Demand_OpMode2
    if ( func_779.outputOR)
    {
      func_791.CmBoiler_Demand_OpMode2_input_1 = CmBoiler_Demand_input_1;
      func_791.CmBoiler_Demand_OpMode2_input_2 = CmBoiler_Demand_input_2;
      func_791.CmBoiler_Demand_OpMode2_input_3 = CmBoiler_Demand_input_201;
      func_791.CmBoiler_Demand_OpMode2_input_4 = func_581.CmDemand_Enable_output_84;
      func_791.Execute( env, parameterOffset +98 );
    }

    // [429] Function call CfOr
    func_429.input[0] = func_239.CmBoiler_Demand_seq_output_441;
    func_429.input[1] = func_233.CmBoiler_Demand_par_output_460;
    func_429.input[2] = func_791.CmBoiler_Demand_OpMode2_output_7;
    func_429.Execute(  );

    // [344] Function call CfSubtract
    func_344.input[0] = CmBoiler_Demand_input_1;
    func_344.input[1] = 1F;
    func_344.Execute(  );

    // [363] Function call CfNot
    func_363.input = CmBoiler_Demand_input_201;
    func_363.Execute(  );

    // [364] Function call CfAnd
    func_364.input[0] = func_429.outputOR;
    func_364.input[1] = func_363.output;
    func_364.Execute(  );

    // [355] Function call CfOr
    func_355.input[0] = func_239.CmBoiler_Demand_seq_output_131;
    func_355.input[1] = func_233.CmBoiler_Demand_par_output_131;
    func_355.input[2] = func_791.CmBoiler_Demand_OpMode2_output_6;
    func_355.Execute(  );

    // [358] Function call CfMaximum
    func_358.input[0] = func_239.CmBoiler_Demand_seq_output_122;
    func_358.input[1] = func_233.CmBoiler_Demand_par_output_122;
    func_358.input[2] = func_791.CmBoiler_Demand_OpMode2_output_5;
    func_358.Execute(  );

    // [345] Macro call CmSet_Group_Reg_Bit
    func_345.CmSet_Group_Reg_Bit_input_1 = 983F;
    func_345.CmSet_Group_Reg_Bit_input_2 = func_344.output;
    func_345.CmSet_Group_Reg_Bit_input_3 = func_364.outputAND;
    func_345.CmSet_Group_Reg_Bit_input_4 = true;
    func_345.CmSet_Group_Reg_Bit_input_30 = CmBoiler_Demand_input_2;
    func_345.Execute(  );

    // [614] Macro call CmStaged_capacity_switch_off
    func_614.CmStaged_capacity_switch_off_input_1 = func_358.output;
    func_614.CmStaged_capacity_switch_off_input_27 = CmBoiler_Demand_input_686;
    func_614.Execute( env, parameterOffset +124 );

    // [468] Function call CfInputMultiplexer
    func_468.inputSelect = BooleanToInt(CmBoiler_Demand_input_444);
    func_468.input[1-1] = 0F;
    func_468.input[2-1] = func_614.CmStaged_capacity_switch_off_output_2;
    func_468.Execute(  );

    // [470] Function call CfAnd
    func_470.input[0] = func_355.outputOR;
    func_470.input[1] = CmBoiler_Demand_input_444;
    func_470.Execute(  );
    CmBoiler_Demand_output_131 = func_470.outputAND;

    // [670] Macro call CmMax_Temperature
    func_670.CmMax_Temperature_input_1 = func_468.output;
    func_670.CmMax_Temperature_input_22 = CmBoiler_Demand_input_671;
    func_670.CmMax_Temperature_input_68 = CmBoiler_Demand_input_677;
    func_670.CmMax_Temperature_input_34 = CmBoiler_Demand_input_674;
    func_670.CmMax_Temperature_input_134 = CmBoiler_Demand_input_1;
    func_670.CmMax_Temperature_input_135 = CmBoiler_Demand_input_2;
    func_670.CmMax_Temperature_input_140 = CmBoiler_Demand_input_201;
    func_670.CmMax_Temperature_input_146 = false;
    func_670.Execute( env, parameterOffset +126 );
    CmBoiler_Demand_output_636 = func_670.CmMax_Temperature_output_2;
    CmBoiler_Demand_output_637 = func_670.CmMax_Temperature_output_3;
    CmBoiler_Demand_output_675 = func_670.CmMax_Temperature_output_48;
    CmBoiler_Demand_output_685 = func_670.CmMax_Temperature_output_99;

    // [681] Macro call CmBlockSum
    func_681.CmBlockSum_input_1 = func_239.CmBoiler_Demand_seq_output_564;
    func_681.CmBlockSum_input_2 = func_233.CmBoiler_Demand_par_output_523;
    func_681.CmBlockSum_input_40 = BooleanToFloat(func_791.CmBoiler_Demand_OpMode2_output_8);
    func_681.Execute(  );
    CmBoiler_Demand_output_680 = func_681.CmBlockSum_output_3;

    // [690] Macro call Cmglobal_blocking
    func_690.Cmglobal_blocking_input_1 = CmBoiler_Demand_output_680;
    func_690.Execute(  );

  }
// macro register which are written multiple times
// macro inputs
public float CmBoiler_Demand_input_671; // SupplyTemp
public float CmBoiler_Demand_input_677; // RetTemp
public float CmBoiler_Demand_input_1; // boiler position
public float CmBoiler_Demand_input_2; // boiler group
public boolean CmBoiler_Demand_input_201; // alarm
public boolean CmBoiler_Demand_input_674; // reset
public boolean CmBoiler_Demand_input_444; // enable
public boolean CmBoiler_Demand_input_686; // ST2off
public boolean CmBoiler_Demand_input_746; // StopRed
// macro outputs
public boolean CmBoiler_Demand_output_131; // Next Stage
public boolean CmBoiler_Demand_output_636; // Stage1Cmd
public boolean CmBoiler_Demand_output_637; // Stage2Cmd
public boolean CmBoiler_Demand_output_675; // Max Temp
public boolean CmBoiler_Demand_output_685; // Max Temp 2
public float CmBoiler_Demand_output_680; // Blocking
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CmIDT10 func_597 = new CmIDT10();
protected CmIDT10 func_608 = new CmIDT10();
protected CmIDT10 func_785 = new CmIDT10();
protected CmBoiler_Emergency func_691 = new CmBoiler_Emergency();
protected CmDemand_Enable func_581 = new CmDemand_Enable();
protected CfOr func_729 = new CfOr();
protected CfOr func_731 = new CfOr();
protected CfOr func_779 = new CfOr();
protected CfIdt func_628 = new CfIdt();
protected CfIdt func_629 = new CfIdt();
protected CmBoiler_Demand_seq func_239 = new CmBoiler_Demand_seq();
protected CmBoiler_Demand_par func_233 = new CmBoiler_Demand_par();
protected CmBoiler_Demand_OpMode2 func_791 = new CmBoiler_Demand_OpMode2();
protected CfOr func_429 = new CfOr();
protected CfSubtract func_344 = new CfSubtract();
protected CfNot func_363 = new CfNot();
protected CfAnd func_364 = new CfAnd();
protected CfOr func_355 = new CfOr();
protected CfMaximum func_358 = new CfMaximum();
protected CmSet_Group_Reg_Bit func_345 = new CmSet_Group_Reg_Bit();
protected CmStaged_capacity_switch_off func_614 = new CmStaged_capacity_switch_off();
protected CfInputMultiplexer func_468 = new CfInputMultiplexer();
protected CfAnd func_470 = new CfAnd();
protected CmMax_Temperature func_670 = new CmMax_Temperature();
protected CmBlockSum func_681 = new CmBlockSum();
protected Cmglobal_blocking func_690 = new Cmglobal_blocking();

// default constructor
public CmBoiler_Demand()
{
  func_628.configure(4);
  func_629.configure(4);
  func_429.configure(3);
  func_355.configure(3);
  func_358.configure(3);
}

  public void Start()
  {
    func_597.Start();
    func_608.Start();
    func_785.Start();
    func_691.Start();
    func_581.Start();
    func_239.Start();
    func_233.Start();
    func_791.Start();
    func_345.Start();
    func_614.Start();
    func_670.Start();
    func_681.Start();
    func_690.Start();
  }
}
