/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Boiler Demand OpMode2
Macro id:      6222900836248322875
Macro version: 39
Last change:   12.10.2016 - 10:21
Access Level:  2
Inputs:
  [1] boiler position
  [2] boiler group
  [3] alarm
  [4] StartEnable
Outputs:
  [1] Boiler Stage
  [2] Next Stage
  [3] timer_active
  [4] Blocking
  [5] SelfEnable
Parameter:
  [1] ST1-02: minimum on time stage 1
  [2] ST1-04: blocking time to switch on next stage or boiler
  [3] ST2-02: minimum on time stage 2
  [4] ST2-04: blocking time to switch on next stage or boiler
  [5] ST1-03: minimum off time stage 1
  [6] ST1-05: blocking time to switch off next stage or boiler
  [7] ST2-03: minimum off time stage 2
  [8] ST2-05: blocking time to switch off next stage or boiler
  [9] ST1-01: capacity stage 1
  [10] ST2-01: capacity stage 2
Description:

================================================================================*/

public class CmBoiler_Demand_OpMode2
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [243] Macro call CmIDT10
    func_243.CmIDT10_input_1 = env.getParameter(parameterOffset);
    func_243.CmIDT10_input_2 = env.getParameter(parameterOffset + 1);
    func_243.CmIDT10_input_3 = env.getParameter(parameterOffset + 2);
    func_243.CmIDT10_input_4 = env.getParameter(parameterOffset + 3);
    func_243.CmIDT10_input_5 = env.getParameter(parameterOffset + 4);
    func_243.CmIDT10_input_6 = env.getParameter(parameterOffset + 5);
    func_243.CmIDT10_input_7 = env.getParameter(parameterOffset + 6);
    func_243.CmIDT10_input_8 = env.getParameter(parameterOffset + 7);
    func_243.CmIDT10_input_9 = 0F;
    func_243.CmIDT10_input_10 = 0F;
    func_243.Execute(  );
    env.setParameter(parameterOffset + 10, func_243.CmIDT10_output_21);
    env.setParameter(parameterOffset + 12, func_243.CmIDT10_output_22);
    env.setParameter(parameterOffset + 14, func_243.CmIDT10_output_23);
    env.setParameter(parameterOffset + 16, func_243.CmIDT10_output_24);
    env.setParameter(parameterOffset + 22, func_243.CmIDT10_output_25);
    env.setParameter(parameterOffset + 24, func_243.CmIDT10_output_26);
    env.setParameter(parameterOffset + 18, func_243.CmIDT10_output_27);
    env.setParameter(parameterOffset + 20, func_243.CmIDT10_output_28);

    // [254] Macro call CmRead_Group_Register
    func_254.CmRead_Group_Register_input_2 = CmBoiler_Demand_OpMode2_input_2;
    func_254.CmRead_Group_Register_input_53 = 1012F;
    func_254.Execute(  );

    // [255] Function call CfCompare2
    func_255.inputA = func_254.CmRead_Group_Register_output_31;
    func_255.inputB = -3F;
    func_255.Execute(  );

    // [256] Function call CfInputMultiplexer
    func_256.inputSelect = BooleanToInt(func_255.outputEqualOrLess);
    func_256.input[1-1] = register_0;
    func_256.input[2-1] = 0F;
    func_256.Execute(  );
    register_0 = func_256.output;

    // [293] Function call CfCompare2
    func_293.inputA = env.getParameter(parameterOffset + 8);
    func_293.inputB = 0F;
    func_293.Execute(  );

    // [282] Function call CfOr
    func_282.input[0] = ControlFunction.GetStartupFlag();
    func_282.input[1] = CmBoiler_Demand_OpMode2_input_3;
    func_282.input[2] = func_293.outputEqualOrLess;
    func_282.input[3] = func_255.outputEqualOrLess;
    func_282.Execute(  );

    // [276] Macro call CmEnable_Demand_seq
    func_276.CmEnable_Demand_seq_input_1 = CmBoiler_Demand_OpMode2_input_1;
    func_276.CmEnable_Demand_seq_input_2 = CmBoiler_Demand_OpMode2_input_2;
    func_276.CmEnable_Demand_seq_input_201 = CmBoiler_Demand_OpMode2_input_3;
    func_276.CmEnable_Demand_seq_input_301 = CmBoiler_Demand_OpMode2_input_4;
    func_276.Execute(  );

    // [277] Function call CfInputMultiplexer
    func_277.inputSelect = BooleanToInt(func_276.CmEnable_Demand_seq_output_297);
    func_277.input[1-1] = 0F;
    func_277.input[2-1] = register_0;
    func_277.Execute(  );
    CmBoiler_Demand_OpMode2_output_5 = func_277.output;

    // [420] Macro call CmBoiler_Demand_add_seq_1
    func_420.CmBoiler_Demand_add_seq_1_input_1 = CmBoiler_Demand_OpMode2_input_1;
    func_420.CmBoiler_Demand_add_seq_1_input_2 = CmBoiler_Demand_OpMode2_input_2;
    func_420.CmBoiler_Demand_add_seq_1_input_278 = func_276.CmEnable_Demand_seq_output_278;
    func_420.CmBoiler_Demand_add_seq_1_input_279 = register_0;
    func_420.CmBoiler_Demand_add_seq_1_input_285 = func_446.CmTimer_output_3;
    func_420.Execute(  );
    register_0 = func_420.CmBoiler_Demand_add_seq_1_output_280;

    // [424] Macro call CmTimer
    func_424.CmTimer_input_1 = func_420.CmBoiler_Demand_add_seq_1_output_297;
    func_424.CmTimer_input_2 = func_282.outputOR;
    func_424.Execute( env, parameterOffset +10 );

    // [425] Macro call CmTimer
    func_425.CmTimer_input_1 = func_420.CmBoiler_Demand_add_seq_1_output_298;
    func_425.CmTimer_input_2 = func_282.outputOR;
    func_425.Execute( env, parameterOffset +12 );

    // [428] Macro call CmBoiler_Demand_add_seq_2
    func_428.CmBoiler_Demand_add_seq_2_input_1 = CmBoiler_Demand_OpMode2_input_1;
    func_428.CmBoiler_Demand_add_seq_2_input_2 = CmBoiler_Demand_OpMode2_input_2;
    func_428.CmBoiler_Demand_add_seq_2_input_278 = func_276.CmEnable_Demand_seq_output_278;
    func_428.CmBoiler_Demand_add_seq_2_input_279 = register_0;
    func_428.CmBoiler_Demand_add_seq_2_input_285 = func_425.CmTimer_output_3;
    func_428.Execute(  );
    register_0 = func_428.CmBoiler_Demand_add_seq_2_output_280;

    // [434] Macro call CmTimer
    func_434.CmTimer_input_1 = func_428.CmBoiler_Demand_add_seq_2_output_297;
    func_434.CmTimer_input_2 = func_342.outputOR;
    func_434.Execute( env, parameterOffset +14 );

    // [436] Macro call CmTimer
    func_436.CmTimer_input_1 = func_428.CmBoiler_Demand_add_seq_2_output_298;
    func_436.CmTimer_input_2 = func_342.outputOR;
    func_436.Execute( env, parameterOffset +16 );

    // [466] Macro call CmBoilerDemand_add_OpMod2
    func_466.CmBoilerDemand_add_OpMod2_input_1 = CmBoiler_Demand_OpMode2_input_1;
    func_466.CmBoilerDemand_add_OpMod2_input_2 = CmBoiler_Demand_OpMode2_input_2;
    func_466.CmBoilerDemand_add_OpMod2_input_3 = func_276.CmEnable_Demand_seq_output_278;
    func_466.CmBoilerDemand_add_OpMod2_input_4 = register_0;
    func_466.CmBoilerDemand_add_OpMod2_input_5 = func_425.CmTimer_output_3;
    func_466.Execute(  );
    CmBoiler_Demand_OpMode2_output_6 = func_466.CmBoilerDemand_add_OpMod2_output_6;

    // [452] Macro call CmBoiler_Demand_del_seq_1
    func_452.CmBoiler_Demand_del_seq_1_input_1 = CmBoiler_Demand_OpMode2_input_1;
    func_452.CmBoiler_Demand_del_seq_1_input_2 = CmBoiler_Demand_OpMode2_input_2;
    func_452.CmBoiler_Demand_del_seq_1_input_278 = func_276.CmEnable_Demand_seq_output_288;
    func_452.CmBoiler_Demand_del_seq_1_input_279 = register_0;
    func_452.CmBoiler_Demand_del_seq_1_input_285 = func_434.CmTimer_output_3;
    func_452.Execute(  );
    register_0 = func_452.CmBoiler_Demand_del_seq_1_output_280;

    // [442] Macro call CmTimer
    func_442.CmTimer_input_1 = func_452.CmBoiler_Demand_del_seq_1_output_297;
    func_442.CmTimer_input_2 = func_342.outputOR;
    func_442.Execute( env, parameterOffset +18 );

    // [444] Macro call CmTimer
    func_444.CmTimer_input_1 = func_452.CmBoiler_Demand_del_seq_1_output_298;
    func_444.CmTimer_input_2 = func_342.outputOR;
    func_444.Execute( env, parameterOffset +20 );

    // [467] Macro call CmBoiler_Demand_del_OpMode2_2
    func_467.CmBoiler_Demand_del_OpMode2_2_input_116 = CmBoiler_Demand_OpMode2_input_1;
    func_467.CmBoiler_Demand_del_OpMode2_2_input_115 = CmBoiler_Demand_OpMode2_input_2;
    func_467.CmBoiler_Demand_del_OpMode2_2_input_117 = func_276.CmEnable_Demand_seq_output_288;
    func_467.CmBoiler_Demand_del_OpMode2_2_input_118 = register_0;
    func_467.CmBoiler_Demand_del_OpMode2_2_input_119 = func_444.CmTimer_output_3;
    func_467.CmBoiler_Demand_del_OpMode2_2_input_244 = CmBoiler_Demand_OpMode2_input_3;
    func_467.CmBoiler_Demand_del_OpMode2_2_input_258 = false;
    func_467.Execute(  );
    register_0 = func_467.CmBoiler_Demand_del_OpMode2_2_output_120;

    // [446] Macro call CmTimer
    func_446.CmTimer_input_1 = func_467.CmBoiler_Demand_del_OpMode2_2_output_121;
    func_446.CmTimer_input_2 = func_282.outputOR;
    func_446.Execute( env, parameterOffset +22 );

    // [448] Macro call CmTimer
    func_448.CmTimer_input_1 = func_467.CmBoiler_Demand_del_OpMode2_2_output_151;
    func_448.CmTimer_input_2 = func_282.outputOR;
    func_448.Execute( env, parameterOffset +24 );

    // [472] Macro call CmBoiler_Demand_del_OpMode2_3
    func_472.CmBoiler_Demand_del_OpMode2_3_input_116 = CmBoiler_Demand_OpMode2_input_1;
    func_472.CmBoiler_Demand_del_OpMode2_3_input_115 = CmBoiler_Demand_OpMode2_input_2;
    func_472.CmBoiler_Demand_del_OpMode2_3_input_117 = func_276.CmEnable_Demand_seq_output_288;
    func_472.CmBoiler_Demand_del_OpMode2_3_input_118 = register_0;
    func_472.Execute(  );

    // [326] Function call CfCompare1
    func_326.inputA = CmBoiler_Demand_OpMode2_output_5;
    func_326.inputB = 2F;
    func_326.Execute(  );

    // [327] Macro call CmRead_Group_Register
    func_327.CmRead_Group_Register_input_2 = CmBoiler_Demand_OpMode2_input_2;
    func_327.CmRead_Group_Register_input_53 = 1012F;
    func_327.Execute(  );

    // [328] Function call CfCompare1
    func_328.inputA = CmBoiler_Demand_OpMode2_output_5;
    func_328.inputB = 0F;
    func_328.Execute(  );

    // [341] Function call CfCompare2
    func_341.inputA = env.getParameter(parameterOffset + 9);
    func_341.inputB = 0F;
    func_341.Execute(  );

    // [344] Function call CfOr
    func_344.input[0] = FloatToBoolean(CmBoiler_Demand_OpMode2_output_5);
    func_344.input[1] = CmBoiler_Demand_OpMode2_output_6;
    func_344.input[2] = func_424.CmTimer_output_3;
    func_344.input[3] = func_446.CmTimer_output_3;
    func_344.input[4] = func_448.CmTimer_output_3;
    func_344.input[5] = func_425.CmTimer_output_3;
    func_344.input[6] = func_442.CmTimer_output_3;
    func_344.input[7] = func_434.CmTimer_output_3;
    func_344.input[8] = func_444.CmTimer_output_3;
    func_344.input[9] = func_436.CmTimer_output_3;
    func_344.Execute(  );

    // [414] Function call CfOr
    func_414.input[0] = func_424.CmTimer_output_3;
    func_414.input[1] = func_425.CmTimer_output_3;
    func_414.input[2] = func_434.CmTimer_output_3;
    func_414.input[3] = func_436.CmTimer_output_3;
    func_414.Execute(  );

    // [415] Function call CfOr
    func_415.input[0] = func_446.CmTimer_output_3;
    func_415.input[1] = func_448.CmTimer_output_3;
    func_415.input[2] = func_442.CmTimer_output_3;
    func_415.input[3] = func_444.CmTimer_output_3;
    func_415.Execute(  );

    // [329] Function call CfLastValue
    func_329.input = BooleanToFloat(func_414.outputOR);
    func_329.Execute(  );

    // [331] Function call CfCompare1
    func_331.inputA = func_327.CmRead_Group_Register_output_31;
    func_331.inputB = 0F;
    func_331.Execute(  );

    // [335] Function call CfLastValue
    func_335.input = BooleanToFloat(func_415.outputOR);
    func_335.Execute(  );

    // [342] Function call CfOr
    func_342.input[0] = func_282.outputOR;
    func_342.input[1] = func_341.outputEqualOrLess;
    func_342.input[2] = func_255.outputEqualOrLess;
    func_342.Execute(  );

    // [345] Function call CfLastValue
    func_345.input = BooleanToFloat(func_344.outputOR);
    func_345.Execute(  );
    CmBoiler_Demand_OpMode2_output_9 = FloatToBoolean(func_345.outputLast);

    // [330] Function call CfCompare1
    func_330.inputA = func_329.outputCurrent;
    func_330.inputB = func_329.outputLast;
    func_330.Execute(  );

    // [332] Function call CfAnd
    func_332.input[0] = func_414.outputOR;
    func_332.input[1] = func_326.outputLess;
    func_332.input[2] = func_331.outputGreater;
    func_332.Execute(  );

    // [334] Function call CfAnd
    func_334.input[0] = func_415.outputOR;
    func_334.input[1] = func_331.outputLess;
    func_334.input[2] = func_328.outputGreater;
    func_334.Execute(  );

    // [336] Function call CfCompare1
    func_336.inputA = func_335.outputCurrent;
    func_336.inputB = func_335.outputLast;
    func_336.Execute(  );

    // [333] Function call CfOr
    func_333.input[0] = func_330.outputLess;
    func_333.input[1] = func_332.outputAND;
    func_333.input[2] = func_414.outputOR;
    func_333.Execute(  );

    // [338] Function call CfOr
    func_338.input[0] = func_334.outputAND;
    func_338.input[1] = func_336.outputLess;
    func_338.input[2] = func_415.outputOR;
    func_338.Execute(  );

    // [337] Function call CfAnd
    func_337.input[0] = func_333.outputOR;
    func_337.input[1] = func_331.outputGreater;
    func_337.Execute(  );

    // [339] Function call CfAnd
    func_339.input[0] = func_331.outputLess;
    func_339.input[1] = func_338.outputOR;
    func_339.Execute(  );

    // [340] Function call CfOr
    func_340.input[0] = func_337.outputAND;
    func_340.input[1] = func_339.outputAND;
    func_340.Execute(  );
    CmBoiler_Demand_OpMode2_output_7 = func_340.outputOR;

    // [427] Macro call CmBlocking
    func_427.CmBlocking_input_1 = func_424.CmTimer_output_3;
    func_427.CmBlocking_input_2 = func_446.CmTimer_output_3;
    func_427.CmBlocking_input_3 = func_425.CmTimer_output_3;
    func_427.CmBlocking_input_4 = func_448.CmTimer_output_3;
    func_427.CmBlocking_input_5 = func_434.CmTimer_output_3;
    func_427.CmBlocking_input_6 = func_442.CmTimer_output_3;
    func_427.CmBlocking_input_7 = func_436.CmTimer_output_3;
    func_427.CmBlocking_input_8 = func_444.CmTimer_output_3;
    func_427.Execute(  );
    CmBoiler_Demand_OpMode2_output_8 = FloatToBoolean(func_427.CmBlocking_output_9);

  }
// macro register which are written multiple times
protected float register_0 = 0;
// macro inputs
public float CmBoiler_Demand_OpMode2_input_1; // boiler position
public float CmBoiler_Demand_OpMode2_input_2; // boiler group
public boolean CmBoiler_Demand_OpMode2_input_3; // alarm
public boolean CmBoiler_Demand_OpMode2_input_4; // StartEnable
// macro outputs
public float CmBoiler_Demand_OpMode2_output_5; // Boiler Stage
public boolean CmBoiler_Demand_OpMode2_output_6; // Next Stage
public boolean CmBoiler_Demand_OpMode2_output_7; // timer_active
public boolean CmBoiler_Demand_OpMode2_output_8; // Blocking
public boolean CmBoiler_Demand_OpMode2_output_9; // SelfEnable
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CmIDT10 func_243 = new CmIDT10();
protected CmRead_Group_Register func_254 = new CmRead_Group_Register();
protected CfCompare2 func_255 = new CfCompare2();
protected CfInputMultiplexer func_256 = new CfInputMultiplexer();
protected CfCompare2 func_293 = new CfCompare2();
protected CfOr func_282 = new CfOr();
protected CmEnable_Demand_seq func_276 = new CmEnable_Demand_seq();
protected CfInputMultiplexer func_277 = new CfInputMultiplexer();
protected CmBoiler_Demand_add_seq_1 func_420 = new CmBoiler_Demand_add_seq_1();
protected CmTimer func_424 = new CmTimer();
protected CmTimer func_425 = new CmTimer();
protected CmBoiler_Demand_add_seq_2 func_428 = new CmBoiler_Demand_add_seq_2();
protected CmTimer func_434 = new CmTimer();
protected CmTimer func_436 = new CmTimer();
protected CmBoilerDemand_add_OpMod2 func_466 = new CmBoilerDemand_add_OpMod2();
protected CmBoiler_Demand_del_seq_1 func_452 = new CmBoiler_Demand_del_seq_1();
protected CmTimer func_442 = new CmTimer();
protected CmTimer func_444 = new CmTimer();
protected CmBoiler_Demand_del_OpMode2_2 func_467 = new CmBoiler_Demand_del_OpMode2_2();
protected CmTimer func_446 = new CmTimer();
protected CmTimer func_448 = new CmTimer();
protected CmBoiler_Demand_del_OpMode2_3 func_472 = new CmBoiler_Demand_del_OpMode2_3();
protected CfCompare1 func_326 = new CfCompare1();
protected CmRead_Group_Register func_327 = new CmRead_Group_Register();
protected CfCompare1 func_328 = new CfCompare1();
protected CfCompare2 func_341 = new CfCompare2();
protected CfOr func_344 = new CfOr();
protected CfOr func_414 = new CfOr();
protected CfOr func_415 = new CfOr();
protected CfLastValue func_329 = new CfLastValue();
protected CfCompare1 func_331 = new CfCompare1();
protected CfLastValue func_335 = new CfLastValue();
protected CfOr func_342 = new CfOr();
protected CfLastValue func_345 = new CfLastValue();
protected CfCompare1 func_330 = new CfCompare1();
protected CfAnd func_332 = new CfAnd();
protected CfAnd func_334 = new CfAnd();
protected CfCompare1 func_336 = new CfCompare1();
protected CfOr func_333 = new CfOr();
protected CfOr func_338 = new CfOr();
protected CfAnd func_337 = new CfAnd();
protected CfAnd func_339 = new CfAnd();
protected CfOr func_340 = new CfOr();
protected CmBlocking func_427 = new CmBlocking();

// default constructor
public CmBoiler_Demand_OpMode2()
{
  func_282.configure(4);
  func_344.configure(10);
  func_414.configure(4);
  func_415.configure(4);
  func_342.configure(3);
  func_332.configure(3);
  func_334.configure(3);
  func_333.configure(3);
  func_338.configure(3);
}

  public void Start()
  {
    func_243.Start();
    func_254.Start();
    func_276.Start();
    func_420.Start();
    func_424.Start();
    func_425.Start();
    func_428.Start();
    func_434.Start();
    func_436.Start();
    func_466.Start();
    func_452.Start();
    func_442.Start();
    func_444.Start();
    func_467.Start();
    func_446.Start();
    func_448.Start();
    func_472.Start();
    func_327.Start();
    func_329.Start();
    func_335.Start();
    func_345.Start();
    func_427.Start();
  }
}
