/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Boiler Demand mod
Macro id:      6063356692777665504
Macro version: 175
Last change:   29.01.2016 - 14:42
Access Level:  2
Inputs:
  [1] reset
  [2] SupplyTemp
  [3] boiler position
  [4] boiler group
  [5] alarm
  [6] enable
  [7] RetTemp
  [8] StopRed
  [9] alm for ModStage
  [10] Alarm
Outputs:
  [1] Stage1Cmd
  [2] Next Stage
  [3] Mod_Stage
  [4] Max Temp
  [5] Max Temp 2
  [6] Setpt Ctrl
  [7] Blocking Signal
  [8] OptimOff
Parameter:
  [1] ST1-02: minimum on time stage 1
  [2] ST1-03: minimum off time stage 1
  [3] ST1-04: blocking time to switch on the next stage or boiler
  [4] ST1-05: blocking time to switch off the next stage or boiler
  [5] STM-04: blocking time to switch on the next stage or boiler
  [6] STM-05: blocking time to switch off the next stage or boiler
  [7] STM-06: minimum output modulating stage
  [8] STM-07: maximum output modulating stage
  [9] STM-08: maximum raise per minute
  [10] ST1-01: capacity stage 1
  [11] STM-01: capacity modulating stage
  [12] BST-01: maximum boiler supply temperature stage 1
  [13] BST-03: maximum boiler supply temp. modulating stage
  [14] BST-05: P-band maximum supply temperature control
  [15] SPO-01: setpoint offset
  [16] SPO-02: setpoint low input
  [17] SPO-03: setpoint high intput
  [18] SPO-04: setpoint low output
  [19] SPO-05: setpoint high output
  [20] BST-02: maximum boiler supply temperature stage 2
  [21] SYS-04: maximum boiler runtime
Description:

================================================================================*/

public class CmBoiler_Demand_mod
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [486] Macro call CmIDT10
    func_486.CmIDT10_input_1 = env.getParameter(parameterOffset);
    func_486.CmIDT10_input_2 = env.getParameter(parameterOffset + 1);
    func_486.CmIDT10_input_3 = env.getParameter(parameterOffset + 2);
    func_486.CmIDT10_input_4 = env.getParameter(parameterOffset + 3);
    func_486.CmIDT10_input_5 = env.getParameter(parameterOffset + 4);
    func_486.CmIDT10_input_6 = env.getParameter(parameterOffset + 5);
    func_486.CmIDT10_input_7 = env.getParameter(parameterOffset + 6);
    func_486.CmIDT10_input_8 = env.getParameter(parameterOffset + 7);
    func_486.CmIDT10_input_9 = env.getParameter(parameterOffset + 8);
    func_486.CmIDT10_input_10 = env.getParameter(parameterOffset + 1);
    func_486.Execute(  );
    env.setParameter(parameterOffset + 22, func_486.CmIDT10_output_21);
    env.setParameter(parameterOffset + 23, func_486.CmIDT10_output_22);
    env.setParameter(parameterOffset + 24, func_486.CmIDT10_output_23);
    env.setParameter(parameterOffset + 25, func_486.CmIDT10_output_24);
    env.setParameter(parameterOffset + 26, func_486.CmIDT10_output_25);
    env.setParameter(parameterOffset + 27, func_486.CmIDT10_output_26);
    env.setParameter(parameterOffset + 28, func_486.CmIDT10_output_27);
    env.setParameter(parameterOffset + 29, func_486.CmIDT10_output_28);
    env.setParameter(parameterOffset + 30, func_486.CmIDT10_output_29);
    env.setParameter(parameterOffset + 172, func_486.CmIDT10_output_30);

    // [574] Macro call CmIDT10
    func_574.CmIDT10_input_1 = env.getParameter(parameterOffset);
    func_574.CmIDT10_input_2 = env.getParameter(parameterOffset + 1);
    func_574.CmIDT10_input_3 = env.getParameter(parameterOffset + 2);
    func_574.CmIDT10_input_4 = env.getParameter(parameterOffset + 3);
    func_574.CmIDT10_input_5 = env.getParameter(parameterOffset + 4);
    func_574.CmIDT10_input_6 = env.getParameter(parameterOffset + 5);
    func_574.CmIDT10_input_7 = env.getParameter(parameterOffset + 6);
    func_574.CmIDT10_input_8 = env.getParameter(parameterOffset + 7);
    func_574.CmIDT10_input_9 = env.getParameter(parameterOffset + 8);
    func_574.CmIDT10_input_10 = env.getParameter(parameterOffset + 14);
    func_574.Execute(  );
    env.setParameter(parameterOffset + 59, func_574.CmIDT10_output_21);
    env.setParameter(parameterOffset + 62, func_574.CmIDT10_output_22);
    env.setParameter(parameterOffset + 60, func_574.CmIDT10_output_23);
    env.setParameter(parameterOffset + 63, func_574.CmIDT10_output_24);
    env.setParameter(parameterOffset + 61, func_574.CmIDT10_output_25);
    env.setParameter(parameterOffset + 64, func_574.CmIDT10_output_26);
    env.setParameter(parameterOffset + 67, func_574.CmIDT10_output_27);
    env.setParameter(parameterOffset + 68, func_574.CmIDT10_output_28);
    env.setParameter(parameterOffset + 69, func_574.CmIDT10_output_29);
    env.setParameter(parameterOffset + 180, func_574.CmIDT10_output_30);

    // [544] Macro call CmIDT10
    func_544.CmIDT10_input_1 = env.getParameter(parameterOffset + 9);
    func_544.CmIDT10_input_2 = env.getParameter(parameterOffset + 10);
    func_544.CmIDT10_input_3 = env.getParameter(parameterOffset + 11);
    func_544.CmIDT10_input_4 = env.getParameter(parameterOffset + 19);
    func_544.CmIDT10_input_5 = env.getParameter(parameterOffset + 12);
    func_544.CmIDT10_input_6 = env.getParameter(parameterOffset + 13);
    func_544.CmIDT10_input_7 = env.getParameter(parameterOffset + 15);
    func_544.CmIDT10_input_8 = env.getParameter(parameterOffset + 16);
    func_544.CmIDT10_input_9 = env.getParameter(parameterOffset + 17);
    func_544.CmIDT10_input_10 = env.getParameter(parameterOffset + 18);
    func_544.Execute(  );
    env.setParameter(parameterOffset + 166, func_544.CmIDT10_output_21);
    env.setParameter(parameterOffset + 167, func_544.CmIDT10_output_22);
    env.setParameter(parameterOffset + 168, func_544.CmIDT10_output_23);
    env.setParameter(parameterOffset + 169, func_544.CmIDT10_output_24);
    env.setParameter(parameterOffset + 170, func_544.CmIDT10_output_25);
    env.setParameter(parameterOffset + 171, func_544.CmIDT10_output_26);
    env.setParameter(parameterOffset + 181, func_544.CmIDT10_output_27);
    env.setParameter(parameterOffset + 182, func_544.CmIDT10_output_28);
    env.setParameter(parameterOffset + 183, func_544.CmIDT10_output_29);
    env.setParameter(parameterOffset + 184, func_544.CmIDT10_output_30);

    // [772] Macro call CmIDT10
    func_772.CmIDT10_input_1 = env.getParameter(parameterOffset);
    func_772.CmIDT10_input_2 = env.getParameter(parameterOffset + 1);
    func_772.CmIDT10_input_3 = env.getParameter(parameterOffset + 2);
    func_772.CmIDT10_input_4 = env.getParameter(parameterOffset + 3);
    func_772.CmIDT10_input_5 = env.getParameter(parameterOffset + 4);
    func_772.CmIDT10_input_6 = env.getParameter(parameterOffset + 5);
    func_772.CmIDT10_input_7 = env.getParameter(parameterOffset + 6);
    func_772.CmIDT10_input_8 = env.getParameter(parameterOffset + 7);
    func_772.CmIDT10_input_9 = env.getParameter(parameterOffset + 8);
    func_772.CmIDT10_input_10 = 0F;
    func_772.Execute(  );
    env.setParameter(parameterOffset + 131, func_772.CmIDT10_output_21);
    env.setParameter(parameterOffset + 132, func_772.CmIDT10_output_22);
    env.setParameter(parameterOffset + 133, func_772.CmIDT10_output_23);
    env.setParameter(parameterOffset + 134, func_772.CmIDT10_output_24);
    env.setParameter(parameterOffset + 135, func_772.CmIDT10_output_25);
    env.setParameter(parameterOffset + 136, func_772.CmIDT10_output_26);
    env.setParameter(parameterOffset + 137, func_772.CmIDT10_output_27);
    env.setParameter(parameterOffset + 138, func_772.CmIDT10_output_28);
    env.setParameter(parameterOffset + 139, func_772.CmIDT10_output_29);

    // [668] Macro call CmBoiler_Emergency
    func_668.CmBoiler_Emergency_input_1 = CmBoiler_Demand_mod_input_535;
    func_668.CmBoiler_Emergency_input_20 = CmBoiler_Demand_mod_input_2;
    func_668.CmBoiler_Emergency_input_33 = CmBoiler_Demand_mod_input_201;
    func_668.CmBoiler_Emergency_input_49 = CmBoiler_Demand_mod_input_1;
    func_668.Execute(  );

    // [652] Macro call CmOptimizedOff
    func_652.CmOptimizedOff_input_4 = CmBoiler_Demand_mod_input_2;
    func_652.CmOptimizedOff_input_31 = CmBoiler_Demand_mod_input_1;
    func_652.Execute( env, parameterOffset +21 );

    // [509] Macro call CmDemand_Enable
    func_509.CmDemand_Enable_input_17 = FloatToBoolean(func_668.CmBoiler_Emergency_output_2);
    func_509.CmDemand_Enable_input_23 = CmBoiler_Demand_mod_input_2;
    func_509.CmDemand_Enable_input_64 = CmBoiler_Demand_mod_input_707;
    func_509.CmDemand_Enable_input_79 = CmBoiler_Demand_mod_input_1;
    func_509.Execute(  );

    // [701] Function call CfOr
    func_701.input[0] = func_239.CmBoiler_Demand_seq_mod_output_602;
    func_701.input[1] = func_509.CmDemand_Enable_output_18;
    func_701.Execute(  );

    // [702] Function call CfOr
    func_702.input[0] = func_509.CmDemand_Enable_output_19;
    func_702.input[1] = func_555.CmBoiler_Demand_par_mod_output_564;
    func_702.Execute(  );

    // [239] Macro call CmBoiler_Demand_seq_mod
    if ( func_701.outputOR)
    {
      func_239.CmBoiler_Demand_seq_mod_input_1 = CmBoiler_Demand_mod_input_1;
      func_239.CmBoiler_Demand_seq_mod_input_2 = CmBoiler_Demand_mod_input_2;
      func_239.CmBoiler_Demand_seq_mod_input_322 = CmBoiler_Demand_mod_input_201;
      func_239.CmBoiler_Demand_seq_mod_input_350 = func_555.CmBoiler_Demand_par_mod_output_256;
      func_239.CmBoiler_Demand_seq_mod_input_313 = func_555.CmBoiler_Demand_par_mod_output_257;
      func_239.CmBoiler_Demand_seq_mod_input_285 = func_555.CmBoiler_Demand_par_mod_output_281;
      func_239.CmBoiler_Demand_seq_mod_input_338 = func_555.CmBoiler_Demand_par_mod_output_274;
      func_239.CmBoiler_Demand_seq_mod_input_316 = func_555.CmBoiler_Demand_par_mod_output_266;
      func_239.CmBoiler_Demand_seq_mod_input_341 = func_555.CmBoiler_Demand_par_mod_output_282;
      func_239.CmBoiler_Demand_seq_mod_input_551 = func_509.CmDemand_Enable_output_18;
      func_239.CmBoiler_Demand_seq_mod_input_583 = func_652.CmOptimizedOff_output_80;
      func_239.Execute( env, parameterOffset +22 );
    }

    // [555] Macro call CmBoiler_Demand_par_mod
    if ( func_702.outputOR)
    {
      func_555.CmBoiler_Demand_par_mod_input_1 = CmBoiler_Demand_mod_input_1;
      func_555.CmBoiler_Demand_par_mod_input_2 = CmBoiler_Demand_mod_input_2;
      func_555.CmBoiler_Demand_par_mod_input_201 = CmBoiler_Demand_mod_input_201;
      func_555.CmBoiler_Demand_par_mod_input_284 = func_239.CmBoiler_Demand_seq_mod_output_297;
      func_555.CmBoiler_Demand_par_mod_input_255 = func_239.CmBoiler_Demand_seq_mod_output_298;
      func_555.CmBoiler_Demand_par_mod_input_254 = func_239.CmBoiler_Demand_seq_mod_output_339;
      func_555.CmBoiler_Demand_par_mod_input_272 = func_239.CmBoiler_Demand_seq_mod_output_330;
      func_555.CmBoiler_Demand_par_mod_input_261 = func_239.CmBoiler_Demand_seq_mod_output_315;
      func_555.CmBoiler_Demand_par_mod_input_283 = func_239.CmBoiler_Demand_seq_mod_output_340;
      func_555.CmBoiler_Demand_par_mod_input_485 = func_509.CmDemand_Enable_output_19;
      func_555.Execute( env, parameterOffset +59 );
    }

    // [760] Function call CfOr
    func_760.input[0] = func_509.CmDemand_Enable_output_84;
    func_760.input[1] = func_777.CmBoiler_Demand_OpMode2_mod_output_234;
    func_760.Execute(  );

    // [777] Macro call CmBoiler_Demand_OpMode2_mod
    if ( func_760.outputOR)
    {
      func_777.CmBoiler_Demand_OpMode2_mod_input_1 = CmBoiler_Demand_mod_input_1;
      func_777.CmBoiler_Demand_OpMode2_mod_input_2 = CmBoiler_Demand_mod_input_2;
      func_777.CmBoiler_Demand_OpMode2_mod_input_3 = CmBoiler_Demand_mod_input_201;
      func_777.CmBoiler_Demand_OpMode2_mod_input_235 = func_652.CmOptimizedOff_output_80;
      func_777.CmBoiler_Demand_OpMode2_mod_input_4 = func_509.CmDemand_Enable_output_84;
      func_777.Execute( env, parameterOffset +129 );
    }

    // [358] Function call CfMaximum
    func_358.input[0] = func_239.CmBoiler_Demand_seq_mod_output_122;
    func_358.input[1] = func_555.CmBoiler_Demand_par_mod_output_122;
    func_358.input[2] = func_777.CmBoiler_Demand_OpMode2_mod_output_5;
    func_358.Execute(  );

    // [541] Macro call CmMod_capacity_switch_off
    func_541.CmMod_capacity_switch_off_input_1 = func_358.output;
    func_541.CmMod_capacity_switch_off_input_32 = FloatToBoolean(func_668.CmBoiler_Emergency_output_2);
    func_541.Execute( env, parameterOffset +166 );

    // [754] Function call CfInputMultiplexer
    func_754.inputSelect = BooleanToInt(CmBoiler_Demand_mod_input_535);
    func_754.input[1-1] = 0F;
    func_754.input[2-1] = func_541.CmMod_capacity_switch_off_output_2;
    func_754.Execute(  );

    // [591] Macro call CmMax_Temperature
    func_591.CmMax_Temperature_input_1 = func_754.output;
    func_591.CmMax_Temperature_input_22 = CmBoiler_Demand_mod_input_593;
    func_591.CmMax_Temperature_input_68 = CmBoiler_Demand_mod_input_626;
    func_591.CmMax_Temperature_input_34 = CmBoiler_Demand_mod_input_596;
    func_591.CmMax_Temperature_input_134 = CmBoiler_Demand_mod_input_1;
    func_591.CmMax_Temperature_input_135 = CmBoiler_Demand_mod_input_2;
    func_591.CmMax_Temperature_input_140 = CmBoiler_Demand_mod_input_201;
    func_591.CmMax_Temperature_input_146 = func_598.CmSetpoint_Control_output_204;
    func_591.Execute( env, parameterOffset +168 );
    CmBoiler_Demand_mod_output_604 = func_591.CmMax_Temperature_output_2;
    CmBoiler_Demand_mod_output_594 = func_591.CmMax_Temperature_output_48;
    CmBoiler_Demand_mod_output_638 = func_591.CmMax_Temperature_output_99;

    // [598] Macro call CmSetpoint_Control
    func_598.CmSetpoint_Control_input_9 = func_754.output;
    func_598.CmSetpoint_Control_input_183 = CmBoiler_Demand_mod_input_1;
    func_598.CmSetpoint_Control_input_186 = CmBoiler_Demand_mod_input_2;
    func_598.CmSetpoint_Control_input_194 = CmBoiler_Demand_mod_input_796;
    func_598.Execute( env, parameterOffset +180 );
    CmBoiler_Demand_mod_output_605 = func_598.CmSetpoint_Control_output_1;

    // [355] Function call CfOr
    func_355.input[0] = func_239.CmBoiler_Demand_seq_mod_output_131;
    func_355.input[1] = func_555.CmBoiler_Demand_par_mod_output_131;
    func_355.input[2] = func_777.CmBoiler_Demand_OpMode2_mod_output_240;
    func_355.Execute(  );
    CmBoiler_Demand_mod_output_131 = func_355.outputOR;

    // [429] Function call CfOr
    func_429.input[0] = func_239.CmBoiler_Demand_seq_mod_output_441;
    func_429.input[1] = func_555.CmBoiler_Demand_par_mod_output_460;
    func_429.input[2] = func_777.CmBoiler_Demand_OpMode2_mod_output_217;
    func_429.Execute(  );

    // [576] Function call CfMaximum
    func_576.input[0] = func_239.CmBoiler_Demand_seq_mod_output_518;
    func_576.input[1] = func_555.CmBoiler_Demand_par_mod_output_521;
    func_576.input[2] = func_777.CmBoiler_Demand_OpMode2_mod_output_239;
    func_576.Execute(  );

    // [363] Function call CfNot
    func_363.input = CmBoiler_Demand_mod_input_201;
    func_363.Execute(  );

    // [344] Function call CfSubtract
    func_344.input[0] = CmBoiler_Demand_mod_input_1;
    func_344.input[1] = 1F;
    func_344.Execute(  );

    // [364] Function call CfAnd
    func_364.input[0] = func_429.outputOR;
    func_364.input[1] = func_363.output;
    func_364.Execute(  );

    // [345] Macro call CmSet_Group_Reg_Bit
    func_345.CmSet_Group_Reg_Bit_input_1 = 983F;
    func_345.CmSet_Group_Reg_Bit_input_2 = func_344.output;
    func_345.CmSet_Group_Reg_Bit_input_3 = func_364.outputAND;
    func_345.CmSet_Group_Reg_Bit_input_4 = true;
    func_345.CmSet_Group_Reg_Bit_input_30 = CmBoiler_Demand_mod_input_2;
    func_345.Execute(  );

    // [623] Function call CfIdt
    func_623.input = env.getParameter(parameterOffset + 9);
    func_623.Execute(  );
    env.setParameter(parameterOffset + 31, func_623.output[0]);
    env.setParameter(parameterOffset + 65, func_623.output[1]);
    env.setParameter(parameterOffset + 129, func_623.output[2]);

    // [624] Function call CfIdt
    func_624.input = env.getParameter(parameterOffset + 10);
    func_624.Execute(  );
    env.setParameter(parameterOffset + 32, func_624.output[0]);
    env.setParameter(parameterOffset + 66, func_624.output[1]);
    env.setParameter(parameterOffset + 130, func_624.output[2]);

    // [631] Macro call CmBlockSum
    func_631.CmBlockSum_input_1 = func_239.CmBoiler_Demand_seq_mod_output_576;
    func_631.CmBlockSum_input_2 = func_555.CmBoiler_Demand_par_mod_output_535;
    func_631.CmBlockSum_input_40 = func_777.CmBoiler_Demand_OpMode2_mod_output_210;
    func_631.Execute(  );
    CmBoiler_Demand_mod_output_628 = func_631.CmBlockSum_output_3;

    // [635] Function call CfMinimum
    func_635.input[0] = func_591.CmMax_Temperature_output_85;
    func_635.input[1] = func_576.output;
    func_635.Execute(  );

    // [748] Function call CfAnd
    func_748.input[0] = CmBoiler_Demand_mod_input_747;
    func_748.input[1] = FloatToBoolean(func_668.CmBoiler_Emergency_output_2);
    func_748.input[2] = CmBoiler_Demand_mod_input_535;
    func_748.Execute(  );

    // [672] Function call CfInputMultiplexer
    func_672.inputSelect = BooleanToInt(func_748.outputAND);
    func_672.input[1-1] = 0F;
    func_672.input[2-1] = func_635.output;
    func_672.Execute(  );
    CmBoiler_Demand_mod_output_444 = func_672.output;

    // [658] Macro call Cmglobal_blocking
    func_658.Cmglobal_blocking_input_1 = CmBoiler_Demand_mod_output_628;
    func_658.Execute(  );

    // [787] Function call CfOr
    func_787.input[0] = func_239.CmBoiler_Demand_seq_mod_output_639;
    func_787.input[1] = func_777.CmBoiler_Demand_OpMode2_mod_output_259;
    func_787.Execute(  );
    CmBoiler_Demand_mod_output_790 = func_787.outputOR;

  }
// macro register which are written multiple times
// macro inputs
public boolean CmBoiler_Demand_mod_input_596; // reset
public float CmBoiler_Demand_mod_input_593; // SupplyTemp
public float CmBoiler_Demand_mod_input_1; // boiler position
public float CmBoiler_Demand_mod_input_2; // boiler group
public boolean CmBoiler_Demand_mod_input_201; // alarm
public boolean CmBoiler_Demand_mod_input_535; // enable
public float CmBoiler_Demand_mod_input_626; // RetTemp
public boolean CmBoiler_Demand_mod_input_707; // StopRed
public boolean CmBoiler_Demand_mod_input_747; // alm for ModStage
public boolean CmBoiler_Demand_mod_input_796; // Alarm
// macro outputs
public boolean CmBoiler_Demand_mod_output_604; // Stage1Cmd
public boolean CmBoiler_Demand_mod_output_131; // Next Stage
public float CmBoiler_Demand_mod_output_444; // Mod_Stage
public boolean CmBoiler_Demand_mod_output_594; // Max Temp
public boolean CmBoiler_Demand_mod_output_638; // Max Temp 2
public float CmBoiler_Demand_mod_output_605; // Setpt Ctrl
public float CmBoiler_Demand_mod_output_628; // Blocking Signal
public boolean CmBoiler_Demand_mod_output_790; // OptimOff
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CmIDT10 func_486 = new CmIDT10();
protected CmIDT10 func_574 = new CmIDT10();
protected CmIDT10 func_544 = new CmIDT10();
protected CmIDT10 func_772 = new CmIDT10();
protected CmBoiler_Emergency func_668 = new CmBoiler_Emergency();
protected CmOptimizedOff func_652 = new CmOptimizedOff();
protected CmDemand_Enable func_509 = new CmDemand_Enable();
protected CfOr func_701 = new CfOr();
protected CfOr func_702 = new CfOr();
protected CmBoiler_Demand_seq_mod func_239 = new CmBoiler_Demand_seq_mod();
protected CmBoiler_Demand_par_mod func_555 = new CmBoiler_Demand_par_mod();
protected CfOr func_760 = new CfOr();
protected CmBoiler_Demand_OpMode2_mod func_777 = new CmBoiler_Demand_OpMode2_mod();
protected CfMaximum func_358 = new CfMaximum();
protected CmMod_capacity_switch_off func_541 = new CmMod_capacity_switch_off();
protected CfInputMultiplexer func_754 = new CfInputMultiplexer();
protected CmMax_Temperature func_591 = new CmMax_Temperature();
protected CmSetpoint_Control func_598 = new CmSetpoint_Control();
protected CfOr func_355 = new CfOr();
protected CfOr func_429 = new CfOr();
protected CfMaximum func_576 = new CfMaximum();
protected CfNot func_363 = new CfNot();
protected CfSubtract func_344 = new CfSubtract();
protected CfAnd func_364 = new CfAnd();
protected CmSet_Group_Reg_Bit func_345 = new CmSet_Group_Reg_Bit();
protected CfIdt func_623 = new CfIdt();
protected CfIdt func_624 = new CfIdt();
protected CmBlockSum func_631 = new CmBlockSum();
protected CfMinimum func_635 = new CfMinimum();
protected CfAnd func_748 = new CfAnd();
protected CfInputMultiplexer func_672 = new CfInputMultiplexer();
protected Cmglobal_blocking func_658 = new Cmglobal_blocking();
protected CfOr func_787 = new CfOr();

// default constructor
public CmBoiler_Demand_mod()
{
  func_358.configure(3);
  func_355.configure(3);
  func_429.configure(3);
  func_576.configure(3);
  func_623.configure(3);
  func_624.configure(3);
  func_748.configure(3);
}

  public void Start()
  {
    func_486.Start();
    func_574.Start();
    func_544.Start();
    func_772.Start();
    func_668.Start();
    func_652.Start();
    func_509.Start();
    func_239.Start();
    func_555.Start();
    func_777.Start();
    func_541.Start();
    func_591.Start();
    func_598.Start();
    func_345.Start();
    func_631.Start();
    func_658.Start();
  }
}
