/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Boiler Demand par mod
Macro id:      6085212706200093590
Macro version: 29
Last change:   27.01.2016 - 12:33
Access Level:  2
Inputs:
  [1] boiler position
  [2] boiler group
  [3] alarm
  [4] ST1_minOnTime
  [5] ST1_swOnDelay
  [6] ST1_minOffTime
  [7] ST1_swOffDelay
  [8] ST2_swOnDelay
  [9] ST2_swOffDelay
  [10] StartEnable
Outputs:
  [1] Boiler Stage
  [2] Next Stage
  [3] ST1_minOnTime
  [4] ST1_swOnDelay
  [5] ST1_minOffTime
  [6] ST1_swOffDelay
  [7] ST2_swOnDelay
  [8] ST2_swOffDelay
  [9] timer_active
  [10] ModStage
  [11] Blocking
  [12] SeldEnable
Parameter:
  [1] ST1-02: minimum on time stage 1
  [2] ST1-04: blocking time to switch on next stage or boiler
  [3] ST2-04: blocking time to switch on next stage or boiler
  [4] ST1-03: minimum off time stage 1
  [5] ST1-05: blocking time to switch off next stage or boiler
  [6] ST2-05: blocking time to switch off next stage or boiler
  [7] ST1-01: capacity stage 1
  [8] ST2-01: capacity stage 2
  [9] STM-06: minimum output modulating stage
  [10] STM-07: maximum output modulating stage
  [11] STM-08: maximum raise per minute
Description:

================================================================================*/

public class CmBoiler_Demand_par_mod
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [496] Macro call CmIDT10
    func_496.CmIDT10_input_1 = env.getParameter(parameterOffset);
    func_496.CmIDT10_input_2 = env.getParameter(parameterOffset + 1);
    func_496.CmIDT10_input_3 = env.getParameter(parameterOffset + 8);
    func_496.CmIDT10_input_4 = env.getParameter(parameterOffset + 2);
    func_496.CmIDT10_input_5 = env.getParameter(parameterOffset + 3);
    func_496.CmIDT10_input_6 = env.getParameter(parameterOffset + 4);
    func_496.CmIDT10_input_7 = env.getParameter(parameterOffset + 9);
    func_496.CmIDT10_input_8 = env.getParameter(parameterOffset + 5);
    func_496.CmIDT10_input_9 = env.getParameter(parameterOffset + 10);
    func_496.CmIDT10_input_10 = 0F;
    func_496.Execute(  );
    env.setParameter(parameterOffset + 12, func_496.CmIDT10_output_21);
    env.setParameter(parameterOffset + 14, func_496.CmIDT10_output_22);
    env.setParameter(parameterOffset + 32, func_496.CmIDT10_output_23);
    env.setParameter(parameterOffset + 39, func_496.CmIDT10_output_24);
    env.setParameter(parameterOffset + 66, func_496.CmIDT10_output_25);
    env.setParameter(parameterOffset + 64, func_496.CmIDT10_output_26);
    env.setParameter(parameterOffset + 33, func_496.CmIDT10_output_27);
    env.setParameter(parameterOffset + 68, func_496.CmIDT10_output_28);
    env.setParameter(parameterOffset + 34, func_496.CmIDT10_output_29);

    // [394] Macro call CmRead_Group_Register
    func_394.CmRead_Group_Register_input_2 = CmBoiler_Demand_par_mod_input_2;
    func_394.CmRead_Group_Register_input_53 = 1012F;
    func_394.Execute(  );

    // [567] Function call CfCompare2
    func_567.inputA = func_394.CmRead_Group_Register_output_31;
    func_567.inputB = -3F;
    func_567.Execute(  );

    // [572] Function call CfInputMultiplexer
    func_572.inputSelect = BooleanToInt(func_567.outputEqualOrLess);
    func_572.input[1-1] = register_0;
    func_572.input[2-1] = 0F;
    func_572.Execute(  );
    register_0 = func_572.output;

    // [239] Macro call CmEnable_Demand_par
    func_239.CmEnable_Demand_par_input_1 = CmBoiler_Demand_par_mod_input_1;
    func_239.CmEnable_Demand_par_input_2 = CmBoiler_Demand_par_mod_input_2;
    func_239.CmEnable_Demand_par_input_201 = CmBoiler_Demand_par_mod_input_201;
    func_239.CmEnable_Demand_par_input_296 = CmBoiler_Demand_par_mod_input_485;
    func_239.Execute(  );

    // [467] Function call CfInputMultiplexer
    func_467.inputSelect = BooleanToInt(func_239.CmEnable_Demand_par_output_293);
    func_467.input[1-1] = 0F;
    func_467.input[2-1] = register_0;
    func_467.Execute(  );
    CmBoiler_Demand_par_mod_output_122 = func_467.output;

    // [510] Function call CfCompare2
    func_510.inputA = env.getParameter(parameterOffset + 6);
    func_510.inputB = 0F;
    func_510.Execute(  );

    // [311] Function call CfOr
    func_311.input[0] = ControlFunction.GetStartupFlag();
    func_311.input[1] = CmBoiler_Demand_par_mod_input_201;
    func_311.input[2] = func_510.outputEqualOrLess;
    func_311.input[3] = func_567.outputEqualOrLess;
    func_311.Execute(  );

    // [513] Function call CfCompare2
    func_513.inputA = env.getParameter(parameterOffset + 7);
    func_513.inputB = 0F;
    func_513.Execute(  );

    // [517] Function call CfOr
    func_517.input[0] = func_311.outputOR;
    func_517.input[1] = func_513.outputEqualOrLess;
    func_517.Execute(  );

    // [295] Function call CfOr
    func_295.input[0] = CmBoiler_Demand_par_mod_input_254;
    func_295.input[1] = CmBoiler_Demand_par_mod_output_281;
    func_295.Execute(  );

    // [244] Macro call CmBoiler_Demand_add_par_1
    func_244.CmBoiler_Demand_add_par_1_input_1 = CmBoiler_Demand_par_mod_input_1;
    func_244.CmBoiler_Demand_add_par_1_input_2 = CmBoiler_Demand_par_mod_input_2;
    func_244.CmBoiler_Demand_add_par_1_input_201 = func_239.CmEnable_Demand_par_output_278;
    func_244.CmBoiler_Demand_add_par_1_input_266 = register_0;
    func_244.CmBoiler_Demand_add_par_1_input_268 = func_295.outputOR;
    func_244.Execute( env, parameterOffset +11 );
    register_0 = func_244.CmBoiler_Demand_add_par_1_output_272;

    // [286] Macro call CmTimer
    func_286.CmTimer_input_1 = func_244.CmBoiler_Demand_add_par_1_output_270;
    func_286.CmTimer_input_2 = func_311.outputOR;
    func_286.Execute( env, parameterOffset +12 );
    CmBoiler_Demand_par_mod_output_256 = func_286.CmTimer_output_3;

    // [287] Macro call CmTimer
    func_287.CmTimer_input_1 = func_244.CmBoiler_Demand_add_par_1_output_271;
    func_287.CmTimer_input_2 = func_311.outputOR;
    func_287.Execute( env, parameterOffset +14 );
    CmBoiler_Demand_par_mod_output_257 = func_287.CmTimer_output_3;

    // [300] Function call CfOr
    func_300.input[0] = CmBoiler_Demand_par_mod_input_255;
    func_300.input[1] = CmBoiler_Demand_par_mod_output_257;
    func_300.Execute(  );

    // [363] Macro call CmBoiler_Demand_add_par_2
    func_363.CmBoiler_Demand_add_par_2_input_1 = CmBoiler_Demand_par_mod_input_1;
    func_363.CmBoiler_Demand_add_par_2_input_2 = CmBoiler_Demand_par_mod_input_2;
    func_363.CmBoiler_Demand_add_par_2_input_201 = func_239.CmEnable_Demand_par_output_278;
    func_363.CmBoiler_Demand_add_par_2_input_266 = register_0;
    func_363.CmBoiler_Demand_add_par_2_input_279 = func_300.outputOR;
    func_363.Execute( env, parameterOffset +16 );

    // [306] Function call CfOr
    func_306.input[0] = CmBoiler_Demand_par_mod_input_255;
    func_306.input[1] = CmBoiler_Demand_par_mod_output_257;
    func_306.Execute(  );

    // [522] Macro call CmBoiler_Demand_add_par_3_mod
    func_522.CmBoiler_Demand_add_par_3_mod_input_1 = CmBoiler_Demand_par_mod_input_1;
    func_522.CmBoiler_Demand_add_par_3_mod_input_2 = CmBoiler_Demand_par_mod_input_2;
    func_522.CmBoiler_Demand_add_par_3_mod_input_201 = func_239.CmEnable_Demand_par_output_278;
    func_522.CmBoiler_Demand_add_par_3_mod_input_266 = register_0;
    func_522.CmBoiler_Demand_add_par_3_mod_input_279 = func_306.outputOR;
    func_522.CmBoiler_Demand_add_par_3_mod_input_424 = CmBoiler_Demand_par_mod_input_201;
    func_522.Execute( env, parameterOffset +32 );
    register_0 = func_522.CmBoiler_Demand_add_par_3_mod_output_272;
    CmBoiler_Demand_par_mod_output_521 = func_522.CmBoiler_Demand_add_par_3_mod_output_395;

    // [289] Macro call CmTimer
    func_289.CmTimer_input_1 = func_522.CmBoiler_Demand_add_par_3_mod_output_271;
    func_289.CmTimer_input_2 = func_517.outputOR;
    func_289.Execute( env, parameterOffset +39 );
    CmBoiler_Demand_par_mod_output_266 = func_289.CmTimer_output_3;

    // [303] Function call CfOr
    func_303.input[0] = CmBoiler_Demand_par_mod_input_261;
    func_303.input[1] = CmBoiler_Demand_par_mod_output_266;
    func_303.input[2] = func_522.CmBoiler_Demand_add_par_3_mod_output_396;
    func_303.Execute(  );

    // [372] Macro call CmBoiler_Demand_add_par_4
    func_372.CmBoiler_Demand_add_par_4_input_1 = CmBoiler_Demand_par_mod_input_1;
    func_372.CmBoiler_Demand_add_par_4_input_2 = CmBoiler_Demand_par_mod_input_2;
    func_372.CmBoiler_Demand_add_par_4_input_201 = func_239.CmEnable_Demand_par_output_278;
    func_372.CmBoiler_Demand_add_par_4_input_266 = register_0;
    func_372.CmBoiler_Demand_add_par_4_input_268 = func_303.outputOR;
    func_372.Execute( env, parameterOffset +41 );

    // [345] Function call CfIdt
    func_345.input = BooleanToFloat(func_311.outputOR);
    func_345.Execute(  );

    // [530] Macro call CmBoiler_Demand_del_par_1_mod
    func_530.CmBoiler_Demand_del_par_1_mod_input_1 = CmBoiler_Demand_par_mod_input_1;
    func_530.CmBoiler_Demand_del_par_1_mod_input_2 = CmBoiler_Demand_par_mod_input_2;
    func_530.CmBoiler_Demand_del_par_1_mod_input_278 = func_239.CmEnable_Demand_par_output_288;
    func_530.CmBoiler_Demand_del_par_1_mod_input_279 = register_0;
    func_530.Execute( env, parameterOffset +57 );
    register_0 = func_530.CmBoiler_Demand_del_par_1_mod_output_280;

    // [341] Macro call CmTimer
    func_341.CmTimer_input_1 = func_530.CmBoiler_Demand_del_par_1_mod_output_298;
    func_341.CmTimer_input_2 = func_517.outputOR;
    func_341.Execute( env, parameterOffset +64 );
    CmBoiler_Demand_par_mod_output_282 = func_341.CmTimer_output_3;

    // [317] Function call CfOr
    func_317.input[0] = CmBoiler_Demand_par_mod_input_283;
    func_317.input[1] = CmBoiler_Demand_par_mod_output_282;
    func_317.Execute(  );

    // [385] Macro call CmBoiler_Demand_del_par_2
    func_385.CmBoiler_Demand_del_par_2_input_1 = CmBoiler_Demand_par_mod_input_1;
    func_385.CmBoiler_Demand_del_par_2_input_2 = CmBoiler_Demand_par_mod_input_2;
    func_385.CmBoiler_Demand_del_par_2_input_278 = func_239.CmEnable_Demand_par_output_288;
    func_385.CmBoiler_Demand_del_par_2_input_279 = register_0;
    func_385.CmBoiler_Demand_del_par_2_input_310 = func_317.outputOR;
    func_385.Execute(  );

    // [319] Function call CfOr
    func_319.input[0] = CmBoiler_Demand_par_mod_input_283;
    func_319.input[1] = CmBoiler_Demand_par_mod_output_282;
    func_319.Execute(  );

    // [381] Macro call CmBoiler_Demand_del_par_3
    func_381.CmBoiler_Demand_del_par_3_input_1 = CmBoiler_Demand_par_mod_input_1;
    func_381.CmBoiler_Demand_del_par_3_input_2 = CmBoiler_Demand_par_mod_input_2;
    func_381.CmBoiler_Demand_del_par_3_input_278 = func_557.outputOR;
    func_381.CmBoiler_Demand_del_par_3_input_279 = register_0;
    func_381.CmBoiler_Demand_del_par_3_input_310 = func_319.outputOR;
    func_381.Execute(  );
    register_0 = func_381.CmBoiler_Demand_del_par_3_output_280;

    // [340] Macro call CmTimer
    func_340.CmTimer_input_1 = func_381.CmBoiler_Demand_del_par_3_output_370;
    func_340.CmTimer_input_2 = FloatToBoolean(func_345.output[0]);
    func_340.Execute( env, parameterOffset +66 );
    CmBoiler_Demand_par_mod_output_281 = func_340.CmTimer_output_3;

    // [339] Macro call CmTimer
    func_339.CmTimer_input_1 = func_381.CmBoiler_Demand_del_par_3_output_371;
    func_339.CmTimer_input_2 = FloatToBoolean(func_345.output[0]);
    func_339.Execute( env, parameterOffset +68 );
    CmBoiler_Demand_par_mod_output_274 = func_339.CmTimer_output_3;

    // [328] Function call CfOr
    func_328.input[0] = CmBoiler_Demand_par_mod_input_272;
    func_328.input[1] = CmBoiler_Demand_par_mod_output_274;
    func_328.Execute(  );

    // [275] Macro call CmBoiler_Demand_del_par_4
    func_275.CmBoiler_Demand_del_par_4_input_1 = CmBoiler_Demand_par_mod_input_1;
    func_275.CmBoiler_Demand_del_par_4_input_2 = CmBoiler_Demand_par_mod_input_2;
    func_275.CmBoiler_Demand_del_par_4_input_278 = func_239.CmEnable_Demand_par_output_288;
    func_275.CmBoiler_Demand_del_par_4_input_279 = register_0;
    func_275.CmBoiler_Demand_del_par_4_input_373 = func_328.outputOR;
    func_275.Execute(  );

    // [389] Function call CfOr
    func_389.input[0] = CmBoiler_Demand_par_mod_output_256;
    func_389.input[1] = CmBoiler_Demand_par_mod_output_257;
    func_389.input[2] = CmBoiler_Demand_par_mod_output_266;
    func_389.input[3] = func_522.CmBoiler_Demand_add_par_3_mod_output_396;
    func_389.Execute(  );

    // [390] Function call CfOr
    func_390.input[0] = CmBoiler_Demand_par_mod_output_282;
    func_390.input[1] = CmBoiler_Demand_par_mod_output_274;
    func_390.input[2] = CmBoiler_Demand_par_mod_output_281;
    func_390.Execute(  );

    // [393] Function call CfCompare1
    func_393.inputA = CmBoiler_Demand_par_mod_output_122;
    func_393.inputB = 2F;
    func_393.Execute(  );

    // [395] Function call CfCompare1
    func_395.inputA = CmBoiler_Demand_par_mod_output_122;
    func_395.inputB = 0F;
    func_395.Execute(  );

    // [396] Function call CfLastValue
    func_396.input = BooleanToFloat(func_389.outputOR);
    func_396.Execute(  );

    // [402] Function call CfLastValue
    func_402.input = BooleanToFloat(func_390.outputOR);
    func_402.Execute(  );

    // [397] Function call CfCompare1
    func_397.inputA = func_396.outputCurrent;
    func_397.inputB = func_396.outputLast;
    func_397.Execute(  );

    // [398] Function call CfCompare1
    func_398.inputA = func_394.CmRead_Group_Register_output_31;
    func_398.inputB = 0F;
    func_398.Execute(  );

    // [403] Function call CfCompare1
    func_403.inputA = func_402.outputCurrent;
    func_403.inputB = func_402.outputLast;
    func_403.Execute(  );

    // [399] Function call CfAnd
    func_399.input[0] = func_389.outputOR;
    func_399.input[1] = func_393.outputLess;
    func_399.input[2] = func_398.outputGreater;
    func_399.Execute(  );

    // [401] Function call CfAnd
    func_401.input[0] = func_398.outputLess;
    func_401.input[1] = func_390.outputOR;
    func_401.input[2] = func_395.outputGreater;
    func_401.Execute(  );

    // [400] Function call CfOr
    func_400.input[0] = func_397.outputLess;
    func_400.input[1] = func_389.outputOR;
    func_400.input[2] = func_399.outputAND;
    func_400.Execute(  );

    // [405] Function call CfOr
    func_405.input[0] = func_401.outputAND;
    func_405.input[1] = func_390.outputOR;
    func_405.input[2] = func_403.outputLess;
    func_405.Execute(  );

    // [404] Function call CfAnd
    func_404.input[0] = func_400.outputOR;
    func_404.input[1] = func_398.outputGreater;
    func_404.Execute(  );

    // [406] Function call CfAnd
    func_406.input[0] = func_398.outputLess;
    func_406.input[1] = func_405.outputOR;
    func_406.Execute(  );

    // [407] Function call CfOr
    func_407.input[0] = func_404.outputAND;
    func_407.input[1] = func_406.outputAND;
    func_407.Execute(  );
    CmBoiler_Demand_par_mod_output_460 = func_407.outputOR;

    // [536] Macro call CmBlocking
    func_536.CmBlocking_input_1 = CmBoiler_Demand_par_mod_output_256;
    func_536.CmBlocking_input_2 = CmBoiler_Demand_par_mod_output_281;
    func_536.CmBlocking_input_3 = CmBoiler_Demand_par_mod_output_257;
    func_536.CmBlocking_input_4 = CmBoiler_Demand_par_mod_output_274;
    func_536.CmBlocking_input_5 = false;
    func_536.CmBlocking_input_6 = false;
    func_536.CmBlocking_input_7 = CmBoiler_Demand_par_mod_output_266;
    func_536.CmBlocking_input_8 = CmBoiler_Demand_par_mod_output_282;
    func_536.Execute(  );
    CmBoiler_Demand_par_mod_output_535 = func_536.CmBlocking_output_9;

    // [557] Function call CfOr
    func_557.input[0] = func_239.CmEnable_Demand_par_output_288;
    func_557.input[1] = func_319.outputOR;
    func_557.Execute(  );

    // [561] Function call CfOr
    func_561.input[0] = FloatToBoolean(CmBoiler_Demand_par_mod_output_521);
    func_561.input[1] = CmBoiler_Demand_par_mod_output_131;
    func_561.input[2] = CmBoiler_Demand_par_mod_output_281;
    func_561.input[3] = CmBoiler_Demand_par_mod_output_256;
    func_561.input[4] = CmBoiler_Demand_par_mod_output_274;
    func_561.input[5] = CmBoiler_Demand_par_mod_output_257;
    func_561.input[6] = CmBoiler_Demand_par_mod_output_282;
    func_561.input[7] = CmBoiler_Demand_par_mod_output_266;
    func_561.Execute(  );

    // [575] Function call CfLastValue
    func_575.input = BooleanToFloat(func_561.outputOR);
    func_575.Execute(  );
    CmBoiler_Demand_par_mod_output_564 = FloatToBoolean(func_575.outputLast);

  }
// macro register which are written multiple times
protected float register_0 = 0;
// macro inputs
public float CmBoiler_Demand_par_mod_input_1; // boiler position
public float CmBoiler_Demand_par_mod_input_2; // boiler group
public boolean CmBoiler_Demand_par_mod_input_201; // alarm
public boolean CmBoiler_Demand_par_mod_input_284; // ST1_minOnTime(not used)
public boolean CmBoiler_Demand_par_mod_input_255; // ST1_swOnDelay
public boolean CmBoiler_Demand_par_mod_input_254; // ST1_minOffTime
public boolean CmBoiler_Demand_par_mod_input_272; // ST1_swOffDelay
public boolean CmBoiler_Demand_par_mod_input_261; // ST2_swOnDelay
public boolean CmBoiler_Demand_par_mod_input_283; // ST2_swOffDelay
public boolean CmBoiler_Demand_par_mod_input_485; // StartEnable
// macro outputs
public float CmBoiler_Demand_par_mod_output_122; // Boiler Stage
public boolean CmBoiler_Demand_par_mod_output_131; // Next Stage
public boolean CmBoiler_Demand_par_mod_output_256; // ST1_minOnTime
public boolean CmBoiler_Demand_par_mod_output_257; // ST1_swOnDelay
public boolean CmBoiler_Demand_par_mod_output_281; // ST1_minOffTime
public boolean CmBoiler_Demand_par_mod_output_274; // ST1_swOffDelay
public boolean CmBoiler_Demand_par_mod_output_266; // ST2_swOnDelay
public boolean CmBoiler_Demand_par_mod_output_282; // ST2_swOffDelay
public boolean CmBoiler_Demand_par_mod_output_460; // timer_active
public float CmBoiler_Demand_par_mod_output_521; // ModStage
public float CmBoiler_Demand_par_mod_output_535; // Blocking
public boolean CmBoiler_Demand_par_mod_output_564; // SeldEnable
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CmIDT10 func_496 = new CmIDT10();
protected CmRead_Group_Register func_394 = new CmRead_Group_Register();
protected CfCompare2 func_567 = new CfCompare2();
protected CfInputMultiplexer func_572 = new CfInputMultiplexer();
protected CmEnable_Demand_par func_239 = new CmEnable_Demand_par();
protected CfInputMultiplexer func_467 = new CfInputMultiplexer();
protected CfCompare2 func_510 = new CfCompare2();
protected CfOr func_311 = new CfOr();
protected CfCompare2 func_513 = new CfCompare2();
protected CfOr func_517 = new CfOr();
protected CfOr func_295 = new CfOr();
protected CmBoiler_Demand_add_par_1 func_244 = new CmBoiler_Demand_add_par_1();
protected CmTimer func_286 = new CmTimer();
protected CmTimer func_287 = new CmTimer();
protected CfOr func_300 = new CfOr();
protected CmBoiler_Demand_add_par_2 func_363 = new CmBoiler_Demand_add_par_2();
protected CfOr func_306 = new CfOr();
protected CmBoiler_Demand_add_par_3_mod func_522 = new CmBoiler_Demand_add_par_3_mod();
protected CmTimer func_289 = new CmTimer();
protected CfOr func_303 = new CfOr();
protected CmBoiler_Demand_add_par_4 func_372 = new CmBoiler_Demand_add_par_4();
protected CfIdt func_345 = new CfIdt();
protected CmBoiler_Demand_del_par_1_mod func_530 = new CmBoiler_Demand_del_par_1_mod();
protected CmTimer func_341 = new CmTimer();
protected CfOr func_317 = new CfOr();
protected CmBoiler_Demand_del_par_2 func_385 = new CmBoiler_Demand_del_par_2();
protected CfOr func_319 = new CfOr();
protected CmBoiler_Demand_del_par_3 func_381 = new CmBoiler_Demand_del_par_3();
protected CmTimer func_340 = new CmTimer();
protected CmTimer func_339 = new CmTimer();
protected CfOr func_328 = new CfOr();
protected CmBoiler_Demand_del_par_4 func_275 = new CmBoiler_Demand_del_par_4();
protected CfOr func_389 = new CfOr();
protected CfOr func_390 = new CfOr();
protected CfCompare1 func_393 = new CfCompare1();
protected CfCompare1 func_395 = new CfCompare1();
protected CfLastValue func_396 = new CfLastValue();
protected CfLastValue func_402 = new CfLastValue();
protected CfCompare1 func_397 = new CfCompare1();
protected CfCompare1 func_398 = new CfCompare1();
protected CfCompare1 func_403 = new CfCompare1();
protected CfAnd func_399 = new CfAnd();
protected CfAnd func_401 = new CfAnd();
protected CfOr func_400 = new CfOr();
protected CfOr func_405 = new CfOr();
protected CfAnd func_404 = new CfAnd();
protected CfAnd func_406 = new CfAnd();
protected CfOr func_407 = new CfOr();
protected CmBlocking func_536 = new CmBlocking();
protected CfOr func_557 = new CfOr();
protected CfOr func_561 = new CfOr();
protected CfLastValue func_575 = new CfLastValue();

// default constructor
public CmBoiler_Demand_par_mod()
{
  func_311.configure(4);
  func_303.configure(3);
  func_389.configure(4);
  func_390.configure(3);
  func_399.configure(3);
  func_401.configure(3);
  func_400.configure(3);
  func_405.configure(3);
  func_561.configure(8);
}

  public void Start()
  {
    func_496.Start();
    func_394.Start();
    func_239.Start();
    func_244.Start();
    func_286.Start();
    func_287.Start();
    func_363.Start();
    func_522.Start();
    func_289.Start();
    func_372.Start();
    func_530.Start();
    func_341.Start();
    func_385.Start();
    func_381.Start();
    func_340.Start();
    func_339.Start();
    func_275.Start();
    func_396.Start();
    func_402.Start();
    func_536.Start();
    func_575.Start();
  }
}
