/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Boiler Demand seq
Macro id:      6046584527329951883
Macro version: 141
Last change:   27.01.2016 - 13:51
Access Level:  2
Inputs:
  [1] boiler position
  [2] boiler group
  [3] alarm
  [4] ST1_minOnTime
  [5] ST1_swOnDelay
  [6] ST1_minOffTime
  [7] ST1_swOffDelay
  [8] ST2_minOnTime
  [9] ST2_swOnDelay
  [10] ST2_minOffTime
  [11] ST2_swOffDelay
  [12] StartEnable
Outputs:
  [1] Boiler Stage
  [2] Next Stage
  [3] ST1_minOnTime
  [4] ST1_swOnDelay
  [5] ST1_minOffTime
  [6] ST1_swOffDelay
  [7] ST2_minOnTime
  [8] ST2_swOnDelay
  [9] ST2_minOffTime
  [10] ST2_swOffDelay
  [11] timer_active
  [12] Blocking
  [13] SelfEnable
Parameter:
  [1] ST1-02: minimum on time stage 1
  [2] ST1-04: blocking time to switch on next stage or boiler
  [3] ST2-02: minimum on time stage 2
  [4] ST2-04: blocking time to switch on next stage or boiler
  [5] ST1-03: minimum off time stage 1
  [6] ST1-05: blocking time to switch off next stage or boiler
  [7] ST2-03: minimum off time stage 2
  [8] ST2-05: blocking time to switch off next stage or boiler
  [9] ST1-01: capacity stage 1
  [10] ST2-01: capacity stage 2
Description:

================================================================================*/

public class CmBoiler_Demand_seq
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [536] Macro call CmIDT10
    func_536.CmIDT10_input_1 = env.getParameter(parameterOffset);
    func_536.CmIDT10_input_2 = env.getParameter(parameterOffset + 1);
    func_536.CmIDT10_input_3 = env.getParameter(parameterOffset + 2);
    func_536.CmIDT10_input_4 = env.getParameter(parameterOffset + 3);
    func_536.CmIDT10_input_5 = env.getParameter(parameterOffset + 4);
    func_536.CmIDT10_input_6 = env.getParameter(parameterOffset + 5);
    func_536.CmIDT10_input_7 = env.getParameter(parameterOffset + 6);
    func_536.CmIDT10_input_8 = env.getParameter(parameterOffset + 7);
    func_536.CmIDT10_input_9 = 0F;
    func_536.CmIDT10_input_10 = 0F;
    func_536.Execute(  );
    env.setParameter(parameterOffset + 10, func_536.CmIDT10_output_21);
    env.setParameter(parameterOffset + 12, func_536.CmIDT10_output_22);
    env.setParameter(parameterOffset + 14, func_536.CmIDT10_output_23);
    env.setParameter(parameterOffset + 16, func_536.CmIDT10_output_24);
    env.setParameter(parameterOffset + 22, func_536.CmIDT10_output_25);
    env.setParameter(parameterOffset + 24, func_536.CmIDT10_output_26);
    env.setParameter(parameterOffset + 18, func_536.CmIDT10_output_27);
    env.setParameter(parameterOffset + 20, func_536.CmIDT10_output_28);

    // [586] Macro call CmRead_Group_Register
    func_586.CmRead_Group_Register_input_2 = CmBoiler_Demand_seq_input_2;
    func_586.CmRead_Group_Register_input_53 = 1012F;
    func_586.Execute(  );

    // [590] Function call CfCompare2
    func_590.inputA = func_586.CmRead_Group_Register_output_31;
    func_590.inputB = -3F;
    func_590.Execute(  );

    // [593] Function call CfInputMultiplexer
    func_593.inputSelect = BooleanToInt(func_590.outputEqualOrLess);
    func_593.input[1-1] = register_0;
    func_593.input[2-1] = 0F;
    func_593.Execute(  );
    register_0 = func_593.output;

    // [319] Macro call CmEnable_Demand_seq
    func_319.CmEnable_Demand_seq_input_1 = CmBoiler_Demand_seq_input_1;
    func_319.CmEnable_Demand_seq_input_2 = CmBoiler_Demand_seq_input_2;
    func_319.CmEnable_Demand_seq_input_201 = CmBoiler_Demand_seq_input_322;
    func_319.CmEnable_Demand_seq_input_301 = CmBoiler_Demand_seq_input_516;
    func_319.Execute(  );

    // [514] Function call CfInputMultiplexer
    func_514.inputSelect = BooleanToInt(func_319.CmEnable_Demand_seq_output_297);
    func_514.input[1-1] = 0F;
    func_514.input[2-1] = register_0;
    func_514.Execute(  );
    CmBoiler_Demand_seq_output_122 = func_514.output;

    // [362] Function call CfOr
    func_362.input[0] = ControlFunction.GetStartupFlag();
    func_362.input[1] = CmBoiler_Demand_seq_input_322;
    func_362.input[2] = func_554.outputEqualOrLess;
    func_362.input[3] = func_590.outputEqualOrLess;
    func_362.Execute(  );

    // [365] Function call CfOr
    func_365.input[0] = CmBoiler_Demand_seq_input_285;
    func_365.input[1] = CmBoiler_Demand_seq_output_339;
    func_365.Execute(  );

    // [300] Macro call CmBoiler_Demand_add_seq_1
    func_300.CmBoiler_Demand_add_seq_1_input_1 = CmBoiler_Demand_seq_input_1;
    func_300.CmBoiler_Demand_add_seq_1_input_2 = CmBoiler_Demand_seq_input_2;
    func_300.CmBoiler_Demand_add_seq_1_input_278 = func_319.CmEnable_Demand_seq_output_278;
    func_300.CmBoiler_Demand_add_seq_1_input_279 = register_0;
    func_300.CmBoiler_Demand_add_seq_1_input_285 = func_365.outputOR;
    func_300.Execute(  );
    register_0 = func_300.CmBoiler_Demand_add_seq_1_output_280;

    // [352] Macro call CmTimer
    func_352.CmTimer_input_1 = func_300.CmBoiler_Demand_add_seq_1_output_297;
    func_352.CmTimer_input_2 = func_362.outputOR;
    func_352.Execute( env, parameterOffset +10 );
    CmBoiler_Demand_seq_output_297 = func_352.CmTimer_output_3;

    // [354] Macro call CmTimer
    func_354.CmTimer_input_1 = func_300.CmBoiler_Demand_add_seq_1_output_298;
    func_354.CmTimer_input_2 = func_362.outputOR;
    func_354.Execute( env, parameterOffset +12 );
    CmBoiler_Demand_seq_output_298 = func_354.CmTimer_output_3;

    // [372] Function call CfOr
    func_372.input[0] = CmBoiler_Demand_seq_input_313;
    func_372.input[1] = CmBoiler_Demand_seq_output_298;
    func_372.Execute(  );

    // [308] Macro call CmBoiler_Demand_add_seq_2
    func_308.CmBoiler_Demand_add_seq_2_input_1 = CmBoiler_Demand_seq_input_1;
    func_308.CmBoiler_Demand_add_seq_2_input_2 = CmBoiler_Demand_seq_input_2;
    func_308.CmBoiler_Demand_add_seq_2_input_278 = func_319.CmEnable_Demand_seq_output_278;
    func_308.CmBoiler_Demand_add_seq_2_input_279 = register_0;
    func_308.CmBoiler_Demand_add_seq_2_input_285 = func_372.outputOR;
    func_308.Execute(  );
    register_0 = func_308.CmBoiler_Demand_add_seq_2_output_280;

    // [357] Macro call CmTimer
    func_357.CmTimer_input_1 = func_308.CmBoiler_Demand_add_seq_2_output_297;
    func_357.CmTimer_input_2 = func_558.outputOR;
    func_357.Execute( env, parameterOffset +14 );
    CmBoiler_Demand_seq_output_314 = func_357.CmTimer_output_3;

    // [358] Macro call CmTimer
    func_358.CmTimer_input_1 = func_308.CmBoiler_Demand_add_seq_2_output_298;
    func_358.CmTimer_input_2 = func_558.outputOR;
    func_358.Execute( env, parameterOffset +16 );
    CmBoiler_Demand_seq_output_315 = func_358.CmTimer_output_3;

    // [373] Function call CfOr
    func_373.input[0] = CmBoiler_Demand_seq_input_316;
    func_373.input[1] = CmBoiler_Demand_seq_output_315;
    func_373.Execute(  );

    // [309] Macro call CmBoiler_Demand_add_seq_3
    func_309.CmBoiler_Demand_add_seq_3_input_1 = CmBoiler_Demand_seq_input_1;
    func_309.CmBoiler_Demand_add_seq_3_input_2 = CmBoiler_Demand_seq_input_2;
    func_309.CmBoiler_Demand_add_seq_3_input_278 = func_319.CmEnable_Demand_seq_output_278;
    func_309.CmBoiler_Demand_add_seq_3_input_279 = register_0;
    func_309.CmBoiler_Demand_add_seq_3_input_285 = func_373.outputOR;
    func_309.Execute(  );
    CmBoiler_Demand_seq_output_131 = func_309.CmBoiler_Demand_add_seq_3_output_349;

    // [406] Function call CfIdt
    func_406.input = BooleanToFloat(func_362.outputOR);
    func_406.Execute(  );

    // [375] Function call CfOr
    func_375.input[0] = CmBoiler_Demand_seq_input_331;
    func_375.input[1] = CmBoiler_Demand_seq_output_314;
    func_375.Execute(  );

    // [323] Macro call CmBoiler_Demand_del_seq_1
    func_323.CmBoiler_Demand_del_seq_1_input_1 = CmBoiler_Demand_seq_input_1;
    func_323.CmBoiler_Demand_del_seq_1_input_2 = CmBoiler_Demand_seq_input_2;
    func_323.CmBoiler_Demand_del_seq_1_input_278 = func_319.CmEnable_Demand_seq_output_288;
    func_323.CmBoiler_Demand_del_seq_1_input_279 = register_0;
    func_323.CmBoiler_Demand_del_seq_1_input_285 = func_375.outputOR;
    func_323.Execute(  );
    register_0 = func_323.CmBoiler_Demand_del_seq_1_output_280;

    // [384] Macro call CmTimer
    func_384.CmTimer_input_1 = func_323.CmBoiler_Demand_del_seq_1_output_297;
    func_384.CmTimer_input_2 = func_558.outputOR;
    func_384.Execute( env, parameterOffset +18 );
    CmBoiler_Demand_seq_output_329 = func_384.CmTimer_output_3;

    // [385] Macro call CmTimer
    func_385.CmTimer_input_1 = func_323.CmBoiler_Demand_del_seq_1_output_298;
    func_385.CmTimer_input_2 = func_558.outputOR;
    func_385.Execute( env, parameterOffset +20 );
    CmBoiler_Demand_seq_output_340 = func_385.CmTimer_output_3;

    // [378] Function call CfOr
    func_378.input[0] = CmBoiler_Demand_seq_input_338;
    func_378.input[1] = CmBoiler_Demand_seq_output_330;
    func_378.Execute(  );

    // [380] Function call CfOr
    func_380.input[0] = CmBoiler_Demand_seq_input_341;
    func_380.input[1] = CmBoiler_Demand_seq_output_340;
    func_380.Execute(  );

    // [334] Macro call CmBoiler_Demand_del_seq_2
    func_334.CmBoiler_Demand_del_seq_2_input_1 = CmBoiler_Demand_seq_input_1;
    func_334.CmBoiler_Demand_del_seq_2_input_2 = CmBoiler_Demand_seq_input_2;
    func_334.CmBoiler_Demand_del_seq_2_input_278 = func_319.CmEnable_Demand_seq_output_288;
    func_334.CmBoiler_Demand_del_seq_2_input_279 = register_0;
    func_334.CmBoiler_Demand_del_seq_2_input_285 = func_378.outputOR;
    func_334.CmBoiler_Demand_del_seq_2_input_336 = func_380.outputOR;
    func_334.CmBoiler_Demand_del_seq_2_input_456 = CmBoiler_Demand_seq_input_322;
    func_334.CmBoiler_Demand_del_seq_2_input_467 = false;
    func_334.Execute(  );
    register_0 = func_334.CmBoiler_Demand_del_seq_2_output_280;

    // [386] Macro call CmTimer
    func_386.CmTimer_input_1 = func_334.CmBoiler_Demand_del_seq_2_output_297;
    func_386.CmTimer_input_2 = FloatToBoolean(func_406.output[0]);
    func_386.Execute( env, parameterOffset +22 );
    CmBoiler_Demand_seq_output_339 = func_386.CmTimer_output_3;

    // [387] Macro call CmTimer
    func_387.CmTimer_input_1 = func_334.CmBoiler_Demand_del_seq_2_output_298;
    func_387.CmTimer_input_2 = FloatToBoolean(func_406.output[0]);
    func_387.Execute( env, parameterOffset +24 );
    CmBoiler_Demand_seq_output_330 = func_387.CmTimer_output_3;

    // [433] Function call CfOr
    func_433.input[0] = CmBoiler_Demand_seq_output_297;
    func_433.input[1] = CmBoiler_Demand_seq_output_298;
    func_433.input[2] = CmBoiler_Demand_seq_output_314;
    func_433.input[3] = CmBoiler_Demand_seq_output_315;
    func_433.Execute(  );

    // [470] Function call CfOr
    func_470.input[0] = CmBoiler_Demand_seq_output_329;
    func_470.input[1] = CmBoiler_Demand_seq_output_330;
    func_470.input[2] = CmBoiler_Demand_seq_output_339;
    func_470.input[3] = CmBoiler_Demand_seq_output_340;
    func_470.Execute(  );

    // [457] Function call CfCompare1
    func_457.inputA = CmBoiler_Demand_seq_output_122;
    func_457.inputB = 2F;
    func_457.Execute(  );

    // [462] Macro call CmRead_Group_Register
    func_462.CmRead_Group_Register_input_2 = CmBoiler_Demand_seq_input_2;
    func_462.CmRead_Group_Register_input_53 = 1012F;
    func_462.Execute(  );

    // [476] Function call CfCompare1
    func_476.inputA = CmBoiler_Demand_seq_output_122;
    func_476.inputB = 0F;
    func_476.Execute(  );

    // [443] Function call CfLastValue
    func_443.input = BooleanToFloat(func_433.outputOR);
    func_443.Execute(  );

    // [449] Function call CfCompare1
    func_449.inputA = func_443.outputCurrent;
    func_449.inputB = func_443.outputLast;
    func_449.Execute(  );

    // [463] Function call CfCompare1
    func_463.inputA = func_462.CmRead_Group_Register_output_31;
    func_463.inputB = 0F;
    func_463.Execute(  );

    // [454] Function call CfAnd
    func_454.input[0] = func_433.outputOR;
    func_454.input[1] = func_457.outputLess;
    func_454.input[2] = func_463.outputGreater;
    func_454.Execute(  );

    // [491] Function call CfOr
    func_491.input[0] = func_449.outputLess;
    func_491.input[1] = func_454.outputAND;
    func_491.input[2] = func_433.outputOR;
    func_491.Execute(  );

    // [473] Function call CfAnd
    func_473.input[0] = func_470.outputOR;
    func_473.input[1] = func_463.outputLess;
    func_473.input[2] = func_476.outputGreater;
    func_473.Execute(  );

    // [480] Function call CfLastValue
    func_480.input = BooleanToFloat(func_470.outputOR);
    func_480.Execute(  );

    // [483] Function call CfCompare1
    func_483.inputA = func_480.outputCurrent;
    func_483.inputB = func_480.outputLast;
    func_483.Execute(  );

    // [492] Function call CfAnd
    func_492.input[0] = func_491.outputOR;
    func_492.input[1] = func_463.outputGreater;
    func_492.Execute(  );

    // [496] Function call CfOr
    func_496.input[0] = func_473.outputAND;
    func_496.input[1] = func_483.outputLess;
    func_496.input[2] = func_470.outputOR;
    func_496.Execute(  );

    // [497] Function call CfAnd
    func_497.input[0] = func_463.outputLess;
    func_497.input[1] = func_496.outputOR;
    func_497.Execute(  );

    // [451] Function call CfOr
    func_451.input[0] = func_492.outputAND;
    func_451.input[1] = func_497.outputAND;
    func_451.Execute(  );
    CmBoiler_Demand_seq_output_441 = func_451.outputOR;

    // [554] Function call CfCompare2
    func_554.inputA = env.getParameter(parameterOffset + 8);
    func_554.inputB = 0F;
    func_554.Execute(  );

    // [556] Function call CfCompare2
    func_556.inputA = env.getParameter(parameterOffset + 9);
    func_556.inputB = 0F;
    func_556.Execute(  );

    // [558] Function call CfOr
    func_558.input[0] = func_362.outputOR;
    func_558.input[1] = func_556.outputEqualOrLess;
    func_558.input[2] = func_590.outputEqualOrLess;
    func_558.Execute(  );

    // [562] Macro call CmBlocking
    func_562.CmBlocking_input_1 = CmBoiler_Demand_seq_output_297;
    func_562.CmBlocking_input_2 = CmBoiler_Demand_seq_output_339;
    func_562.CmBlocking_input_3 = CmBoiler_Demand_seq_output_298;
    func_562.CmBlocking_input_4 = CmBoiler_Demand_seq_output_330;
    func_562.CmBlocking_input_5 = CmBoiler_Demand_seq_output_314;
    func_562.CmBlocking_input_6 = CmBoiler_Demand_seq_output_329;
    func_562.CmBlocking_input_7 = CmBoiler_Demand_seq_output_315;
    func_562.CmBlocking_input_8 = CmBoiler_Demand_seq_output_340;
    func_562.Execute(  );
    CmBoiler_Demand_seq_output_564 = func_562.CmBlocking_output_9;

    // [582] Function call CfOr
    func_582.input[0] = FloatToBoolean(CmBoiler_Demand_seq_output_122);
    func_582.input[1] = CmBoiler_Demand_seq_output_131;
    func_582.input[2] = CmBoiler_Demand_seq_output_339;
    func_582.input[3] = CmBoiler_Demand_seq_output_297;
    func_582.input[4] = CmBoiler_Demand_seq_output_330;
    func_582.input[5] = CmBoiler_Demand_seq_output_298;
    func_582.input[6] = CmBoiler_Demand_seq_output_329;
    func_582.input[7] = CmBoiler_Demand_seq_output_314;
    func_582.input[8] = CmBoiler_Demand_seq_output_340;
    func_582.input[9] = CmBoiler_Demand_seq_output_315;
    func_582.Execute(  );

    // [595] Function call CfLastValue
    func_595.input = BooleanToFloat(func_582.outputOR);
    func_595.Execute(  );
    CmBoiler_Demand_seq_output_585 = FloatToBoolean(func_595.outputLast);

  }
// macro register which are written multiple times
protected float register_0 = 0;
// macro inputs
public float CmBoiler_Demand_seq_input_1; // boiler position
public float CmBoiler_Demand_seq_input_2; // boiler group
public boolean CmBoiler_Demand_seq_input_322; // alarm
public boolean CmBoiler_Demand_seq_input_350; // ST1_minOnTime(not used)
public boolean CmBoiler_Demand_seq_input_313; // ST1_swOnDelay
public boolean CmBoiler_Demand_seq_input_285; // ST1_minOffTime
public boolean CmBoiler_Demand_seq_input_338; // ST1_swOffDelay
public boolean CmBoiler_Demand_seq_input_331; // ST2_minOnTime
public boolean CmBoiler_Demand_seq_input_316; // ST2_swOnDelay
public boolean CmBoiler_Demand_seq_input_351; // ST2_minOffTime(not used)
public boolean CmBoiler_Demand_seq_input_341; // ST2_swOffDelay
public boolean CmBoiler_Demand_seq_input_516; // StartEnable
// macro outputs
public float CmBoiler_Demand_seq_output_122; // Boiler Stage
public boolean CmBoiler_Demand_seq_output_131; // Next Stage
public boolean CmBoiler_Demand_seq_output_297; // ST1_minOnTime
public boolean CmBoiler_Demand_seq_output_298; // ST1_swOnDelay
public boolean CmBoiler_Demand_seq_output_339; // ST1_minOffTime
public boolean CmBoiler_Demand_seq_output_330; // ST1_swOffDelay
public boolean CmBoiler_Demand_seq_output_314; // ST2_minOnTime
public boolean CmBoiler_Demand_seq_output_315; // ST2_swOnDelay
public boolean CmBoiler_Demand_seq_output_329; // ST2_minOffTime
public boolean CmBoiler_Demand_seq_output_340; // ST2_swOffDelay
public boolean CmBoiler_Demand_seq_output_441; // timer_active
public float CmBoiler_Demand_seq_output_564; // Blocking
public boolean CmBoiler_Demand_seq_output_585; // SelfEnable
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CmIDT10 func_536 = new CmIDT10();
protected CmRead_Group_Register func_586 = new CmRead_Group_Register();
protected CfCompare2 func_590 = new CfCompare2();
protected CfInputMultiplexer func_593 = new CfInputMultiplexer();
protected CmEnable_Demand_seq func_319 = new CmEnable_Demand_seq();
protected CfInputMultiplexer func_514 = new CfInputMultiplexer();
protected CfOr func_362 = new CfOr();
protected CfOr func_365 = new CfOr();
protected CmBoiler_Demand_add_seq_1 func_300 = new CmBoiler_Demand_add_seq_1();
protected CmTimer func_352 = new CmTimer();
protected CmTimer func_354 = new CmTimer();
protected CfOr func_372 = new CfOr();
protected CmBoiler_Demand_add_seq_2 func_308 = new CmBoiler_Demand_add_seq_2();
protected CmTimer func_357 = new CmTimer();
protected CmTimer func_358 = new CmTimer();
protected CfOr func_373 = new CfOr();
protected CmBoiler_Demand_add_seq_3 func_309 = new CmBoiler_Demand_add_seq_3();
protected CfIdt func_406 = new CfIdt();
protected CfOr func_375 = new CfOr();
protected CmBoiler_Demand_del_seq_1 func_323 = new CmBoiler_Demand_del_seq_1();
protected CmTimer func_384 = new CmTimer();
protected CmTimer func_385 = new CmTimer();
protected CfOr func_378 = new CfOr();
protected CfOr func_380 = new CfOr();
protected CmBoiler_Demand_del_seq_2 func_334 = new CmBoiler_Demand_del_seq_2();
protected CmTimer func_386 = new CmTimer();
protected CmTimer func_387 = new CmTimer();
protected CfOr func_433 = new CfOr();
protected CfOr func_470 = new CfOr();
protected CfCompare1 func_457 = new CfCompare1();
protected CmRead_Group_Register func_462 = new CmRead_Group_Register();
protected CfCompare1 func_476 = new CfCompare1();
protected CfLastValue func_443 = new CfLastValue();
protected CfCompare1 func_449 = new CfCompare1();
protected CfCompare1 func_463 = new CfCompare1();
protected CfAnd func_454 = new CfAnd();
protected CfOr func_491 = new CfOr();
protected CfAnd func_473 = new CfAnd();
protected CfLastValue func_480 = new CfLastValue();
protected CfCompare1 func_483 = new CfCompare1();
protected CfAnd func_492 = new CfAnd();
protected CfOr func_496 = new CfOr();
protected CfAnd func_497 = new CfAnd();
protected CfOr func_451 = new CfOr();
protected CfCompare2 func_554 = new CfCompare2();
protected CfCompare2 func_556 = new CfCompare2();
protected CfOr func_558 = new CfOr();
protected CmBlocking func_562 = new CmBlocking();
protected CfOr func_582 = new CfOr();
protected CfLastValue func_595 = new CfLastValue();

// default constructor
public CmBoiler_Demand_seq()
{
  func_362.configure(4);
  func_433.configure(4);
  func_470.configure(4);
  func_454.configure(3);
  func_491.configure(3);
  func_473.configure(3);
  func_496.configure(3);
  func_558.configure(3);
  func_582.configure(10);
}

  public void Start()
  {
    func_536.Start();
    func_586.Start();
    func_319.Start();
    func_300.Start();
    func_352.Start();
    func_354.Start();
    func_308.Start();
    func_357.Start();
    func_358.Start();
    func_309.Start();
    func_323.Start();
    func_384.Start();
    func_385.Start();
    func_334.Start();
    func_386.Start();
    func_387.Start();
    func_462.Start();
    func_443.Start();
    func_480.Start();
    func_562.Start();
    func_595.Start();
  }
}
