/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Boiler Demand seq mod
Macro id:      6063353361340564070
Macro version: 161
Last change:   27.01.2016 - 12:47
Access Level:  2
Inputs:
  [1] boiler position
  [2] boiler group
  [3] alarm
  [4] ST1_minOnTime
  [5] ST1_swOnDelay
  [6] ST1_minOffTime
  [7] ST1_swOffDelay
  [8] ST2_swOnDelay
  [9] ST2_swOffDelay
  [10] StartEnable
  [11] OptimOffEnable
Outputs:
  [1] Boiler Stage
  [2] Next Stage
  [3] ST1_minOnTime
  [4] ST1_swOnDelay
  [5] ST1_minOffTime
  [6] ST1_swOffDelay
  [7] ST2_swOnDelay
  [8] ST2_swOffDelay
  [9] timer_active
  [10] ModStage
  [11] Blocking
  [12] SelfEnable
  [13] OptimOff
Parameter:
  [1] ST1-02: minimum on time stage 1
  [2] ST1-03: minimum off time stage 1
  [3] ST1-04: blocking time to switch on the next stage or boiler
  [4] ST1-05: blocking time to switch off the next stage or boiler
  [5] STM-04: blocking time to switch on the next stage or boiler
  [6] STM-05: blocking time to switch off the next stage or boiler
  [7] STM-06: minimum output modulating stage
  [8] STM-07: maximum output modulating stage
  [9] STM-08: maximum raise per minute
  [10] St1-01: ST1 capacity
  [11] StM-01: ST2 capacity
Description:

================================================================================*/

public class CmBoiler_Demand_seq_mod
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [535] Macro call CmIDT10
    func_535.CmIDT10_input_1 = env.getParameter(parameterOffset);
    func_535.CmIDT10_input_2 = env.getParameter(parameterOffset + 2);
    func_535.CmIDT10_input_3 = env.getParameter(parameterOffset + 4);
    func_535.CmIDT10_input_4 = env.getParameter(parameterOffset + 1);
    func_535.CmIDT10_input_5 = env.getParameter(parameterOffset + 3);
    func_535.CmIDT10_input_6 = env.getParameter(parameterOffset + 5);
    func_535.CmIDT10_input_7 = env.getParameter(parameterOffset + 6);
    func_535.CmIDT10_input_8 = env.getParameter(parameterOffset + 7);
    func_535.CmIDT10_input_9 = env.getParameter(parameterOffset + 8);
    func_535.CmIDT10_input_10 = 0F;
    func_535.Execute(  );
    env.setParameter(parameterOffset + 11, func_535.CmIDT10_output_21);
    env.setParameter(parameterOffset + 13, func_535.CmIDT10_output_22);
    env.setParameter(parameterOffset + 25, func_535.CmIDT10_output_23);
    env.setParameter(parameterOffset + 33, func_535.CmIDT10_output_24);
    env.setParameter(parameterOffset + 35, func_535.CmIDT10_output_25);
    env.setParameter(parameterOffset + 31, func_535.CmIDT10_output_26);
    env.setParameter(parameterOffset + 15, func_535.CmIDT10_output_27);
    env.setParameter(parameterOffset + 16, func_535.CmIDT10_output_28);
    env.setParameter(parameterOffset + 17, func_535.CmIDT10_output_29);

    // [462] Macro call CmRead_Group_Register
    func_462.CmRead_Group_Register_input_2 = CmBoiler_Demand_seq_mod_input_2;
    func_462.CmRead_Group_Register_input_53 = 1012F;
    func_462.Execute(  );

    // [605] Function call CfCompare2
    func_605.inputA = func_462.CmRead_Group_Register_output_31;
    func_605.inputB = -3F;
    func_605.Execute(  );

    // [610] Function call CfInputMultiplexer
    func_610.inputSelect = BooleanToInt(func_605.outputEqualOrLess);
    func_610.input[1-1] = register_0;
    func_610.input[2-1] = 0F;
    func_610.Execute(  );
    register_0 = func_610.output;

    // [319] Macro call CmEnable_Demand_seq
    func_319.CmEnable_Demand_seq_input_1 = CmBoiler_Demand_seq_mod_input_1;
    func_319.CmEnable_Demand_seq_input_2 = CmBoiler_Demand_seq_mod_input_2;
    func_319.CmEnable_Demand_seq_input_201 = CmBoiler_Demand_seq_mod_input_322;
    func_319.CmEnable_Demand_seq_input_301 = CmBoiler_Demand_seq_mod_input_551;
    func_319.Execute(  );
    register_2 = BooleanToFloat(func_319.CmEnable_Demand_seq_output_288);

    // [646] Function call CfCompare1
    func_646.inputA = CmBoiler_Demand_seq_mod_output_122;
    func_646.inputB = 0F;
    func_646.Execute(  );

    // [463] Function call CfCompare1
    func_463.inputA = func_462.CmRead_Group_Register_output_31;
    func_463.inputB = 0F;
    func_463.Execute(  );

    // [651] Function call CfNot
    func_651.input = func_463.outputEqual;
    func_651.Execute(  );

    // [644] Function call CfOr
    func_644.input[0] = func_646.outputEqual;
    func_644.input[1] = func_651.output;
    func_644.Execute(  );

    // [640] Function call CfRsFlipFlop
    func_640.inputSet = CmBoiler_Demand_seq_mod_input_583;
    func_640.inputReset = func_644.outputOR;
    func_640.Execute(  );

    // [642] Function call CfIdt
    func_642.input = BooleanToFloat(func_640.output);
    func_642.Execute(  );
    CmBoiler_Demand_seq_mod_output_639 = FloatToBoolean(func_642.output[0]);

    // [584] Function call CfOr
    func_584.input[0] = FloatToBoolean(register_2);
    func_584.input[1] = func_380.outputOR;
    func_584.input[2] = func_640.output;
    func_584.Execute(  );
    register_2 = BooleanToFloat(func_584.outputOR);

    // [552] Function call CfInputMultiplexer
    func_552.inputSelect = BooleanToInt(func_319.CmEnable_Demand_seq_output_297);
    func_552.input[1-1] = 0F;
    func_552.input[2-1] = register_0;
    func_552.Execute(  );
    CmBoiler_Demand_seq_mod_output_122 = func_552.output;

    // [362] Function call CfOr
    func_362.input[0] = ControlFunction.GetStartupFlag();
    func_362.input[1] = CmBoiler_Demand_seq_mod_input_322;
    func_362.Execute(  );

    // [558] Function call CfCompare2
    func_558.inputA = env.getParameter(parameterOffset + 9);
    func_558.inputB = 0F;
    func_558.Execute(  );

    // [567] Function call CfOr
    func_567.input[0] = func_362.outputOR;
    func_567.input[1] = func_558.outputEqualOrLess;
    func_567.input[2] = func_605.outputEqualOrLess;
    func_567.Execute(  );

    // [561] Function call CfCompare2
    func_561.inputA = env.getParameter(parameterOffset + 10);
    func_561.inputB = 0F;
    func_561.Execute(  );

    // [575] Function call CfOr
    func_575.input[0] = func_362.outputOR;
    func_575.input[1] = func_561.outputEqualOrLess;
    func_575.input[2] = func_605.outputEqualOrLess;
    func_575.Execute(  );

    // [365] Function call CfOr
    func_365.input[0] = CmBoiler_Demand_seq_mod_input_285;
    func_365.input[1] = CmBoiler_Demand_seq_mod_output_339;
    func_365.Execute(  );

    // [300] Macro call CmBoiler_Demand_add_seq_1
    func_300.CmBoiler_Demand_add_seq_1_input_1 = CmBoiler_Demand_seq_mod_input_1;
    func_300.CmBoiler_Demand_add_seq_1_input_2 = CmBoiler_Demand_seq_mod_input_2;
    func_300.CmBoiler_Demand_add_seq_1_input_278 = func_319.CmEnable_Demand_seq_output_278;
    func_300.CmBoiler_Demand_add_seq_1_input_279 = register_0;
    func_300.CmBoiler_Demand_add_seq_1_input_285 = func_365.outputOR;
    func_300.Execute(  );
    register_0 = func_300.CmBoiler_Demand_add_seq_1_output_280;

    // [352] Macro call CmTimer
    func_352.CmTimer_input_1 = func_300.CmBoiler_Demand_add_seq_1_output_297;
    func_352.CmTimer_input_2 = func_567.outputOR;
    func_352.Execute( env, parameterOffset +11 );
    CmBoiler_Demand_seq_mod_output_297 = func_352.CmTimer_output_3;

    // [354] Macro call CmTimer
    func_354.CmTimer_input_1 = func_300.CmBoiler_Demand_add_seq_1_output_298;
    func_354.CmTimer_input_2 = func_567.outputOR;
    func_354.Execute( env, parameterOffset +13 );
    CmBoiler_Demand_seq_mod_output_298 = func_354.CmTimer_output_3;

    // [372] Function call CfOr
    func_372.input[0] = CmBoiler_Demand_seq_mod_input_313;
    func_372.input[1] = CmBoiler_Demand_seq_mod_output_298;
    func_372.Execute(  );

    // [513] Macro call CmBoiler_Demand_add_seq_2_mod
    func_513.CmBoiler_Demand_add_seq_2_mod_input_1 = CmBoiler_Demand_seq_mod_input_1;
    func_513.CmBoiler_Demand_add_seq_2_mod_input_2 = CmBoiler_Demand_seq_mod_input_2;
    func_513.CmBoiler_Demand_add_seq_2_mod_input_278 = func_319.CmEnable_Demand_seq_output_278;
    func_513.CmBoiler_Demand_add_seq_2_mod_input_279 = register_0;
    func_513.CmBoiler_Demand_add_seq_2_mod_input_285 = func_372.outputOR;
    func_513.CmBoiler_Demand_add_seq_2_mod_input_395 = CmBoiler_Demand_seq_mod_input_322;
    func_513.Execute( env, parameterOffset +15 );
    register_0 = func_513.CmBoiler_Demand_add_seq_2_mod_output_280;
    CmBoiler_Demand_seq_mod_output_518 = func_513.CmBoiler_Demand_add_seq_2_mod_output_322;

    // [358] Macro call CmTimer
    func_358.CmTimer_input_1 = func_513.CmBoiler_Demand_add_seq_2_mod_output_298;
    func_358.CmTimer_input_2 = func_575.outputOR;
    func_358.Execute( env, parameterOffset +25 );
    CmBoiler_Demand_seq_mod_output_315 = func_358.CmTimer_output_3;

    // [373] Function call CfOr
    func_373.input[0] = CmBoiler_Demand_seq_mod_input_316;
    func_373.input[1] = CmBoiler_Demand_seq_mod_output_315;
    func_373.input[2] = func_513.CmBoiler_Demand_add_seq_2_mod_output_328;
    func_373.Execute(  );

    // [309] Macro call CmBoiler_Demand_add_seq_3
    func_309.CmBoiler_Demand_add_seq_3_input_1 = CmBoiler_Demand_seq_mod_input_1;
    func_309.CmBoiler_Demand_add_seq_3_input_2 = CmBoiler_Demand_seq_mod_input_2;
    func_309.CmBoiler_Demand_add_seq_3_input_278 = func_319.CmEnable_Demand_seq_output_278;
    func_309.CmBoiler_Demand_add_seq_3_input_279 = register_0;
    func_309.CmBoiler_Demand_add_seq_3_input_285 = func_373.outputOR;
    func_309.Execute(  );
    CmBoiler_Demand_seq_mod_output_131 = func_309.CmBoiler_Demand_add_seq_3_output_349;

    // [378] Function call CfOr
    func_378.input[0] = CmBoiler_Demand_seq_mod_input_338;
    func_378.input[1] = CmBoiler_Demand_seq_mod_output_330;
    func_378.Execute(  );

    // [522] Macro call CmBoiler_Demand_del_seq_1_mod
    func_522.CmBoiler_Demand_del_seq_1_mod_input_1 = CmBoiler_Demand_seq_mod_input_1;
    func_522.CmBoiler_Demand_del_seq_1_mod_input_2 = CmBoiler_Demand_seq_mod_input_2;
    func_522.CmBoiler_Demand_del_seq_1_mod_input_278 = FloatToBoolean(register_2);
    func_522.CmBoiler_Demand_del_seq_1_mod_input_279 = register_0;
    func_522.CmBoiler_Demand_del_seq_1_mod_input_285 = func_378.outputOR;
    func_522.Execute( env, parameterOffset +27 );
    register_0 = func_522.CmBoiler_Demand_del_seq_1_mod_output_280;

    // [385] Macro call CmTimer
    func_385.CmTimer_input_1 = func_522.CmBoiler_Demand_del_seq_1_mod_output_298;
    func_385.CmTimer_input_2 = func_575.outputOR;
    func_385.Execute( env, parameterOffset +31 );
    CmBoiler_Demand_seq_mod_output_340 = func_385.CmTimer_output_3;

    // [380] Function call CfOr
    func_380.input[0] = CmBoiler_Demand_seq_mod_input_341;
    func_380.input[1] = CmBoiler_Demand_seq_mod_output_340;
    func_380.Execute(  );

    // [334] Macro call CmBoiler_Demand_del_seq_2
    func_334.CmBoiler_Demand_del_seq_2_input_1 = CmBoiler_Demand_seq_mod_input_1;
    func_334.CmBoiler_Demand_del_seq_2_input_2 = CmBoiler_Demand_seq_mod_input_2;
    func_334.CmBoiler_Demand_del_seq_2_input_278 = FloatToBoolean(register_2);
    func_334.CmBoiler_Demand_del_seq_2_input_279 = register_0;
    func_334.CmBoiler_Demand_del_seq_2_input_285 = func_378.outputOR;
    func_334.CmBoiler_Demand_del_seq_2_input_336 = func_380.outputOR;
    func_334.CmBoiler_Demand_del_seq_2_input_456 = CmBoiler_Demand_seq_mod_input_322;
    func_334.CmBoiler_Demand_del_seq_2_input_467 = func_640.output;
    func_334.Execute(  );
    register_0 = func_334.CmBoiler_Demand_del_seq_2_output_280;

    // [386] Macro call CmTimer
    func_386.CmTimer_input_1 = func_334.CmBoiler_Demand_del_seq_2_output_297;
    func_386.CmTimer_input_2 = func_567.outputOR;
    func_386.Execute( env, parameterOffset +33 );
    CmBoiler_Demand_seq_mod_output_339 = func_386.CmTimer_output_3;

    // [387] Macro call CmTimer
    func_387.CmTimer_input_1 = func_334.CmBoiler_Demand_del_seq_2_output_298;
    func_387.CmTimer_input_2 = func_567.outputOR;
    func_387.Execute( env, parameterOffset +35 );
    CmBoiler_Demand_seq_mod_output_330 = func_387.CmTimer_output_3;

    // [433] Function call CfOr
    func_433.input[0] = CmBoiler_Demand_seq_mod_output_297;
    func_433.input[1] = CmBoiler_Demand_seq_mod_output_298;
    func_433.input[2] = CmBoiler_Demand_seq_mod_output_315;
    func_433.input[3] = func_513.CmBoiler_Demand_add_seq_2_mod_output_328;
    func_433.Execute(  );

    // [470] Function call CfOr
    func_470.input[0] = CmBoiler_Demand_seq_mod_output_340;
    func_470.input[1] = CmBoiler_Demand_seq_mod_output_330;
    func_470.input[2] = CmBoiler_Demand_seq_mod_output_339;
    func_470.Execute(  );

    // [457] Function call CfCompare1
    func_457.inputA = CmBoiler_Demand_seq_mod_output_122;
    func_457.inputB = 2F;
    func_457.Execute(  );

    // [476] Function call CfCompare1
    func_476.inputA = CmBoiler_Demand_seq_mod_output_122;
    func_476.inputB = 0F;
    func_476.Execute(  );

    // [443] Function call CfLastValue
    func_443.input = BooleanToFloat(func_433.outputOR);
    func_443.Execute(  );

    // [449] Function call CfCompare1
    func_449.inputA = func_443.outputCurrent;
    func_449.inputB = func_443.outputLast;
    func_449.Execute(  );

    // [454] Function call CfAnd
    func_454.input[0] = func_433.outputOR;
    func_454.input[1] = func_457.outputLess;
    func_454.input[2] = func_463.outputGreater;
    func_454.Execute(  );

    // [491] Function call CfOr
    func_491.input[0] = func_449.outputLess;
    func_491.input[1] = func_454.outputAND;
    func_491.input[2] = func_433.outputOR;
    func_491.Execute(  );

    // [473] Function call CfAnd
    func_473.input[0] = func_470.outputOR;
    func_473.input[1] = func_463.outputLess;
    func_473.input[2] = func_476.outputGreater;
    func_473.Execute(  );

    // [480] Function call CfLastValue
    func_480.input = BooleanToFloat(func_470.outputOR);
    func_480.Execute(  );

    // [483] Function call CfCompare1
    func_483.inputA = func_480.outputCurrent;
    func_483.inputB = func_480.outputLast;
    func_483.Execute(  );

    // [492] Function call CfAnd
    func_492.input[0] = func_491.outputOR;
    func_492.input[1] = func_463.outputGreater;
    func_492.Execute(  );

    // [496] Function call CfOr
    func_496.input[0] = func_473.outputAND;
    func_496.input[1] = func_483.outputLess;
    func_496.input[2] = func_470.outputOR;
    func_496.Execute(  );

    // [497] Function call CfAnd
    func_497.input[0] = func_463.outputLess;
    func_497.input[1] = func_496.outputOR;
    func_497.Execute(  );

    // [451] Function call CfOr
    func_451.input[0] = func_492.outputAND;
    func_451.input[1] = func_497.outputAND;
    func_451.Execute(  );
    CmBoiler_Demand_seq_mod_output_441 = func_451.outputOR;

    // [577] Macro call CmBlocking
    func_577.CmBlocking_input_1 = CmBoiler_Demand_seq_mod_output_297;
    func_577.CmBlocking_input_2 = CmBoiler_Demand_seq_mod_output_339;
    func_577.CmBlocking_input_3 = CmBoiler_Demand_seq_mod_output_298;
    func_577.CmBlocking_input_4 = CmBoiler_Demand_seq_mod_output_330;
    func_577.CmBlocking_input_5 = false;
    func_577.CmBlocking_input_6 = false;
    func_577.CmBlocking_input_7 = CmBoiler_Demand_seq_mod_output_315;
    func_577.CmBlocking_input_8 = CmBoiler_Demand_seq_mod_output_340;
    func_577.Execute(  );
    CmBoiler_Demand_seq_mod_output_576 = func_577.CmBlocking_output_9;

    // [599] Function call CfOr
    func_599.input[0] = FloatToBoolean(CmBoiler_Demand_seq_mod_output_518);
    func_599.input[1] = CmBoiler_Demand_seq_mod_output_131;
    func_599.input[2] = CmBoiler_Demand_seq_mod_output_339;
    func_599.input[3] = CmBoiler_Demand_seq_mod_output_297;
    func_599.input[4] = CmBoiler_Demand_seq_mod_output_330;
    func_599.input[5] = CmBoiler_Demand_seq_mod_output_298;
    func_599.input[6] = CmBoiler_Demand_seq_mod_output_340;
    func_599.input[7] = CmBoiler_Demand_seq_mod_output_315;
    func_599.Execute(  );

    // [613] Function call CfLastValue
    func_613.input = BooleanToFloat(func_599.outputOR);
    func_613.Execute(  );
    CmBoiler_Demand_seq_mod_output_602 = FloatToBoolean(func_613.outputLast);

  }
// macro register which are written multiple times
protected float register_0 = 0;
protected float register_2 = 0;
// macro inputs
public float CmBoiler_Demand_seq_mod_input_1; // boiler position
public float CmBoiler_Demand_seq_mod_input_2; // boiler group
public boolean CmBoiler_Demand_seq_mod_input_322; // alarm
public boolean CmBoiler_Demand_seq_mod_input_350; // ST1_minOnTime(not used)
public boolean CmBoiler_Demand_seq_mod_input_313; // ST1_swOnDelay
public boolean CmBoiler_Demand_seq_mod_input_285; // ST1_minOffTime
public boolean CmBoiler_Demand_seq_mod_input_338; // ST1_swOffDelay
public boolean CmBoiler_Demand_seq_mod_input_316; // ST2_swOnDelay
public boolean CmBoiler_Demand_seq_mod_input_341; // ST2_swOffDelay
public boolean CmBoiler_Demand_seq_mod_input_551; // StartEnable
public boolean CmBoiler_Demand_seq_mod_input_583; // OptimOffEnable
// macro outputs
public float CmBoiler_Demand_seq_mod_output_122; // Boiler Stage
public boolean CmBoiler_Demand_seq_mod_output_131; // Next Stage
public boolean CmBoiler_Demand_seq_mod_output_297; // ST1_minOnTime
public boolean CmBoiler_Demand_seq_mod_output_298; // ST1_swOnDelay
public boolean CmBoiler_Demand_seq_mod_output_339; // ST1_minOffTime
public boolean CmBoiler_Demand_seq_mod_output_330; // ST1_swOffDelay
public boolean CmBoiler_Demand_seq_mod_output_315; // ST2_swOnDelay
public boolean CmBoiler_Demand_seq_mod_output_340; // ST2_swOffDelay
public boolean CmBoiler_Demand_seq_mod_output_441; // timer_active
public float CmBoiler_Demand_seq_mod_output_518; // ModStage
public float CmBoiler_Demand_seq_mod_output_576; // Blocking
public boolean CmBoiler_Demand_seq_mod_output_602; // SelfEnable
public boolean CmBoiler_Demand_seq_mod_output_639; // OptimOff
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CmIDT10 func_535 = new CmIDT10();
protected CmRead_Group_Register func_462 = new CmRead_Group_Register();
protected CfCompare2 func_605 = new CfCompare2();
protected CfInputMultiplexer func_610 = new CfInputMultiplexer();
protected CmEnable_Demand_seq func_319 = new CmEnable_Demand_seq();
protected CfCompare1 func_646 = new CfCompare1();
protected CfCompare1 func_463 = new CfCompare1();
protected CfNot func_651 = new CfNot();
protected CfOr func_644 = new CfOr();
protected CfRsFlipFlop func_640 = new CfRsFlipFlop();
protected CfIdt func_642 = new CfIdt();
protected CfOr func_584 = new CfOr();
protected CfInputMultiplexer func_552 = new CfInputMultiplexer();
protected CfOr func_362 = new CfOr();
protected CfCompare2 func_558 = new CfCompare2();
protected CfOr func_567 = new CfOr();
protected CfCompare2 func_561 = new CfCompare2();
protected CfOr func_575 = new CfOr();
protected CfOr func_365 = new CfOr();
protected CmBoiler_Demand_add_seq_1 func_300 = new CmBoiler_Demand_add_seq_1();
protected CmTimer func_352 = new CmTimer();
protected CmTimer func_354 = new CmTimer();
protected CfOr func_372 = new CfOr();
protected CmBoiler_Demand_add_seq_2_mod func_513 = new CmBoiler_Demand_add_seq_2_mod();
protected CmTimer func_358 = new CmTimer();
protected CfOr func_373 = new CfOr();
protected CmBoiler_Demand_add_seq_3 func_309 = new CmBoiler_Demand_add_seq_3();
protected CfOr func_378 = new CfOr();
protected CmBoiler_Demand_del_seq_1_mod func_522 = new CmBoiler_Demand_del_seq_1_mod();
protected CmTimer func_385 = new CmTimer();
protected CfOr func_380 = new CfOr();
protected CmBoiler_Demand_del_seq_2 func_334 = new CmBoiler_Demand_del_seq_2();
protected CmTimer func_386 = new CmTimer();
protected CmTimer func_387 = new CmTimer();
protected CfOr func_433 = new CfOr();
protected CfOr func_470 = new CfOr();
protected CfCompare1 func_457 = new CfCompare1();
protected CfCompare1 func_476 = new CfCompare1();
protected CfLastValue func_443 = new CfLastValue();
protected CfCompare1 func_449 = new CfCompare1();
protected CfAnd func_454 = new CfAnd();
protected CfOr func_491 = new CfOr();
protected CfAnd func_473 = new CfAnd();
protected CfLastValue func_480 = new CfLastValue();
protected CfCompare1 func_483 = new CfCompare1();
protected CfAnd func_492 = new CfAnd();
protected CfOr func_496 = new CfOr();
protected CfAnd func_497 = new CfAnd();
protected CfOr func_451 = new CfOr();
protected CmBlocking func_577 = new CmBlocking();
protected CfOr func_599 = new CfOr();
protected CfLastValue func_613 = new CfLastValue();

// default constructor
public CmBoiler_Demand_seq_mod()
{
  func_584.configure(3);
  func_567.configure(3);
  func_575.configure(3);
  func_373.configure(3);
  func_433.configure(4);
  func_470.configure(3);
  func_454.configure(3);
  func_491.configure(3);
  func_473.configure(3);
  func_496.configure(3);
  func_599.configure(8);
}

  public void Start()
  {
    func_535.Start();
    func_462.Start();
    func_319.Start();
    func_640.Start();
    func_300.Start();
    func_352.Start();
    func_354.Start();
    func_513.Start();
    func_358.Start();
    func_309.Start();
    func_522.Start();
    func_385.Start();
    func_334.Start();
    func_386.Start();
    func_387.Start();
    func_443.Start();
    func_480.Start();
    func_577.Start();
    func_613.Start();
  }
}
