/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    BufDischargingControl
Macro id:      6120064577476493797
Macro version: 17
Last change:   11.11.2015 - 09:23
Access Level:  2
Inputs:
  [1] BufUpperTemp
  [2] EffLowerTemp
  [3] HeatDemandIn
  [4] CHG
  [5] DCHG
  [6] CFG-01 = CHG
  [7] CFG-01 = DCHG
Outputs:
  [1] ChgOverValve1
Parameter:
  [1] DCHG-01: switch to buffer hysteresis
  [2] DCHG-02: switch to boiler hysteresis
Description:

================================================================================*/

public class CmBufDischargingControl
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [10] Function call CfAddition
    func_10.input[0] = CmBufDischargingControl_input_5;
    func_10.input[1] = env.getParameter(parameterOffset);
    func_10.Execute(  );

    // [20] Function call CfSubtract
    func_20.input[0] = CmBufDischargingControl_input_5;
    func_20.input[1] = env.getParameter(parameterOffset + 1);
    func_20.Execute(  );

    // [6] Function call CfCompare1
    func_6.inputA = CmBufDischargingControl_input_23;
    func_6.inputB = func_10.output;
    func_6.Execute(  );

    // [16] Function call CfCompare1
    func_16.inputA = CmBufDischargingControl_input_4;
    func_16.inputB = func_20.output;
    func_16.Execute(  );

    // [30] Function call CfAnd
    func_30.input[0] = func_6.outputGreater;
    func_30.input[1] = func_16.outputLess;
    func_30.Execute(  );

    // [34] Function call CfDelayOnOff
    func_34.input = func_30.outputAND;
    func_34.Execute( env, parameterOffset + 2 );

    // [32] Function call CfInputMultiplexer
    func_32.inputSelect = BooleanToInt(func_34.output);
    func_32.input[1-1] = BooleanToFloat(func_6.outputGreater);
    func_32.input[2-1] = 0F;
    func_32.Execute(  );

    // [33] Function call CfInputMultiplexer
    func_33.inputSelect = BooleanToInt(func_34.output);
    func_33.input[1-1] = BooleanToFloat(func_16.outputLess);
    func_33.input[2-1] = 1F;
    func_33.Execute(  );

    // [14] Function call CfJkFlipFlop
    func_14.inputSet = FloatToBoolean(func_32.output);
    func_14.inputClock = false;
    func_14.inputReset = FloatToBoolean(func_33.output);
    func_14.Execute(  );

    // [56] Function call CfAnd
    func_56.input[0] = func_14.output;
    func_56.input[1] = CmBufDischargingControl_input_55;
    func_56.Execute(  );

    // [13] Function call CfInputMultiplexer
    func_13.inputSelect = BooleanToInt(func_56.outputNAND);
    func_13.input[1-1] = 0F;
    func_13.input[2-1] = 1F;
    func_13.Execute(  );

    // [63] Function call CfInputMultiplexer
    func_63.inputSelect = BooleanToInt(CmBufDischargingControl_input_62);
    func_63.input[1-1] = func_13.output;
    func_63.input[2-1] = 0F;
    func_63.Execute(  );
    CmBufDischargingControl_output_1 = FloatToBoolean(func_63.output);

  }
// macro register which are written multiple times
// macro inputs
public float CmBufDischargingControl_input_4; // BufUpperTemp
public float CmBufDischargingControl_input_23; // EffLowerTemp
public float CmBufDischargingControl_input_5; // HeatDemandIn
public boolean CmBufDischargingControl_input_45; // CHG(not used)
public boolean CmBufDischargingControl_input_46; // DCHG(not used)
public boolean CmBufDischargingControl_input_62; // CFG-01 = CHG
public boolean CmBufDischargingControl_input_55; // CFG-01 = DCHG
// macro outputs
public boolean CmBufDischargingControl_output_1; // ChgOverValve1
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfAddition func_10 = new CfAddition();
protected CfSubtract func_20 = new CfSubtract();
protected CfCompare1 func_6 = new CfCompare1();
protected CfCompare1 func_16 = new CfCompare1();
protected CfAnd func_30 = new CfAnd();
protected CfDelayOnOff func_34 = new CfDelayOnOff();
protected CfInputMultiplexer func_32 = new CfInputMultiplexer();
protected CfInputMultiplexer func_33 = new CfInputMultiplexer();
protected CfJkFlipFlop func_14 = new CfJkFlipFlop();
protected CfAnd func_56 = new CfAnd();
protected CfInputMultiplexer func_13 = new CfInputMultiplexer();
protected CfInputMultiplexer func_63 = new CfInputMultiplexer();

// default constructor
public CmBufDischargingControl()
{
}

  public void Start()
  {
    func_34.Start();
    func_14.Start();
  }
}
