/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    BufHeatDemand
Macro id:      6119064682032530279
Macro version: 22
Last change:   05.11.2015 - 08:48
Access Level:  2
Inputs:
  [1] HeadDemandIn
  [2] EffLowerTemp
  [3] BufUpperTemp
  [4] ExtLoading
  [5] OperationMode
Outputs:
  [1] HeadDemandOut
  [2] Buf_SpShift
  [3] CHG_control
  [4] DCHG_control
Parameter:
  [1] CFG-01: enable charging control
  [2] CHG-01: switch to buffer hysteresis
  [3] CHG-02: start boiler hysteresis
  [4] DCHG-01: switch to buffer hysteresis
  [5] DCHG-02: switch to boiler hysteresis
  [6] SOL-01: head demand decrease during uncontrolled loading
  [7] SOL-02: switch off delay heat demand decrease after external loading
Description:

================================================================================*/

public class CmBufHeatDemand
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [15] Function call CfSubtract
    func_15.input[0] = CmBufHeatDemand_input_1;
    func_15.input[1] = env.getParameter(parameterOffset + 2);
    func_15.Execute(  );

    // [24] Function call CfAddition
    func_24.input[0] = CmBufHeatDemand_input_1;
    func_24.input[1] = env.getParameter(parameterOffset + 3);
    func_24.Execute(  );

    // [25] Function call CfSubtract
    func_25.input[0] = CmBufHeatDemand_input_1;
    func_25.input[1] = env.getParameter(parameterOffset + 4);
    func_25.Execute(  );

    // [118] Function call CfIdt
    func_118.input = 0F;
    func_118.Execute(  );
    env.setParameter(parameterOffset + 7, func_118.output[0]);

    // [124] Function call CfMultiply
    func_124.input[0] = env.getParameter(parameterOffset + 6);
    func_124.input[1] = 60F;
    func_124.Execute(  );
    env.setParameter(parameterOffset + 8, func_124.output);

    // [53] Function call CfDelayOnOff
    func_53.input = CmBufHeatDemand_input_48;
    func_53.Execute( env, parameterOffset + 7 );

    // [75] Function call CfAddition
    func_75.input[0] = CmBufHeatDemand_input_1;
    func_75.input[1] = env.getParameter(parameterOffset + 1);
    func_75.Execute(  );

    // [102] Function call CfWindow
    func_102.inputValue = CmBufHeatDemand_input_101;
    func_102.inputMinimum = 4.8F;
    func_102.inputMaximum = 6.2F;
    func_102.Execute(  );

    // [14] Function call CfCompare1
    func_14.inputA = CmBufHeatDemand_input_9;
    func_14.inputB = func_15.output;
    func_14.Execute(  );

    // [26] Function call CfCompare1
    func_26.inputA = CmBufHeatDemand_input_8;
    func_26.inputB = func_24.output;
    func_26.Execute(  );

    // [27] Function call CfCompare1
    func_27.inputA = CmBufHeatDemand_input_9;
    func_27.inputB = func_25.output;
    func_27.Execute(  );

    // [76] Function call CfCompare1
    func_76.inputA = CmBufHeatDemand_input_8;
    func_76.inputB = func_75.output;
    func_76.Execute(  );

    // [127] Function call CfIdt
    func_127.input = BooleanToFloat(func_28.output);
    func_127.Execute(  );
    CmBufHeatDemand_output_126 = FloatToBoolean(func_127.output[0]);

    // [139] Function call CfAnd
    func_139.input[0] = func_26.outputGreater;
    func_139.input[1] = func_27.outputLess;
    func_139.Execute(  );

    // [143] Function call CfAnd
    func_143.input[0] = func_14.outputLess;
    func_143.input[1] = func_76.outputGreater;
    func_143.Execute(  );

    // [140] Function call CfDelayOnOff
    func_140.input = func_139.outputAND;
    func_140.Execute( env, parameterOffset + 9 );

    // [144] Function call CfDelayOnOff
    func_144.input = func_143.outputAND;
    func_144.Execute( env, parameterOffset + 11 );

    // [141] Function call CfInputMultiplexer
    func_141.inputSelect = BooleanToInt(func_140.output);
    func_141.input[1-1] = BooleanToFloat(func_26.outputGreater);
    func_141.input[2-1] = 0F;
    func_141.Execute(  );

    // [142] Function call CfInputMultiplexer
    func_142.inputSelect = BooleanToInt(func_140.output);
    func_142.input[1-1] = BooleanToFloat(func_27.outputLess);
    func_142.input[2-1] = 1F;
    func_142.Execute(  );

    // [28] Function call CfJkFlipFlop
    func_28.inputSet = FloatToBoolean(func_141.output);
    func_28.inputClock = false;
    func_28.inputReset = FloatToBoolean(func_142.output);
    func_28.Execute(  );

    // [145] Function call CfInputMultiplexer
    func_145.inputSelect = BooleanToInt(func_144.output);
    func_145.input[1-1] = BooleanToFloat(func_76.outputGreater);
    func_145.input[2-1] = 0F;
    func_145.Execute(  );

    // [146] Function call CfInputMultiplexer
    func_146.inputSelect = BooleanToInt(func_144.output);
    func_146.input[1-1] = BooleanToFloat(func_14.outputLess);
    func_146.input[2-1] = 1F;
    func_146.Execute(  );

    // [74] Function call CfJkFlipFlop
    func_74.inputSet = FloatToBoolean(func_146.output);
    func_74.inputClock = false;
    func_74.inputReset = FloatToBoolean(func_145.output);
    func_74.Execute(  );

    // [18] Function call CfInputMultiplexer
    func_18.inputSelect = BooleanToInt(func_74.output);
    func_18.input[1-1] = 0F;
    func_18.input[2-1] = CmBufHeatDemand_input_1;
    func_18.Execute(  );

    // [29] Function call CfInputMultiplexer
    func_29.inputSelect = BooleanToInt(func_28.output);
    func_29.input[1-1] = CmBufHeatDemand_input_1;
    func_29.input[2-1] = 0F;
    func_29.Execute(  );

    // [109] Function call CfIdt
    func_109.input = BooleanToFloat(func_74.output);
    func_109.Execute(  );
    CmBufHeatDemand_output_108 = FloatToBoolean(func_109.output[0]);

    // [44] Function call CfInputMultiplexer
    func_44.inputSelect = FloatToInt(env.getParameter(parameterOffset));
    func_44.input[1-1] = 0F;
    func_44.input[2-1] = func_18.output;
    func_44.input[3-1] = func_29.output;
    func_44.Execute(  );

    // [56] Function call CfSubtract
    func_56.input[0] = func_44.output;
    func_56.input[1] = env.getParameter(parameterOffset + 5);
    func_56.Execute(  );

    // [51] Function call CfInputMultiplexer
    func_51.inputSelect = BooleanToInt(func_53.output);
    func_51.input[1-1] = func_44.output;
    func_51.input[2-1] = func_56.output;
    func_51.Execute(  );

    // [82] Function call CfMaximum
    func_82.input[0] = func_51.output;
    func_82.input[1] = 0F;
    func_82.Execute(  );

    // [104] Function call CfInputMultiplexer
    func_104.inputSelect = BooleanToInt(func_102.output);
    func_104.input[1-1] = func_82.output;
    func_104.input[2-1] = 0F;
    func_104.Execute(  );
    CmBufHeatDemand_output_2 = func_104.output;

    // [116] Function call CfInputMultiplexer
    func_116.inputSelect = BooleanToInt(func_53.output);
    func_116.input[1-1] = 0F;
    func_116.input[2-1] = env.getParameter(parameterOffset + 5);
    func_116.Execute(  );
    CmBufHeatDemand_output_62 = func_116.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmBufHeatDemand_input_1; // HeadDemandIn
public float CmBufHeatDemand_input_8; // EffLowerTemp
public float CmBufHeatDemand_input_9; // BufUpperTemp
public boolean CmBufHeatDemand_input_48; // ExtLoading
public float CmBufHeatDemand_input_101; // OperationMode
// macro outputs
public float CmBufHeatDemand_output_2; // HeadDemandOut
public float CmBufHeatDemand_output_62; // Buf_SpShift
public boolean CmBufHeatDemand_output_108; // CHG_control
public boolean CmBufHeatDemand_output_126; // DCHG_control
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfSubtract func_15 = new CfSubtract();
protected CfAddition func_24 = new CfAddition();
protected CfSubtract func_25 = new CfSubtract();
protected CfIdt func_118 = new CfIdt();
protected CfMultiply func_124 = new CfMultiply();
protected CfDelayOnOff func_53 = new CfDelayOnOff();
protected CfAddition func_75 = new CfAddition();
protected CfWindow func_102 = new CfWindow();
protected CfCompare1 func_14 = new CfCompare1();
protected CfCompare1 func_26 = new CfCompare1();
protected CfCompare1 func_27 = new CfCompare1();
protected CfCompare1 func_76 = new CfCompare1();
protected CfIdt func_127 = new CfIdt();
protected CfAnd func_139 = new CfAnd();
protected CfAnd func_143 = new CfAnd();
protected CfDelayOnOff func_140 = new CfDelayOnOff();
protected CfDelayOnOff func_144 = new CfDelayOnOff();
protected CfInputMultiplexer func_141 = new CfInputMultiplexer();
protected CfInputMultiplexer func_142 = new CfInputMultiplexer();
protected CfJkFlipFlop func_28 = new CfJkFlipFlop();
protected CfInputMultiplexer func_145 = new CfInputMultiplexer();
protected CfInputMultiplexer func_146 = new CfInputMultiplexer();
protected CfJkFlipFlop func_74 = new CfJkFlipFlop();
protected CfInputMultiplexer func_18 = new CfInputMultiplexer();
protected CfInputMultiplexer func_29 = new CfInputMultiplexer();
protected CfIdt func_109 = new CfIdt();
protected CfInputMultiplexer func_44 = new CfInputMultiplexer();
protected CfSubtract func_56 = new CfSubtract();
protected CfInputMultiplexer func_51 = new CfInputMultiplexer();
protected CfMaximum func_82 = new CfMaximum();
protected CfInputMultiplexer func_104 = new CfInputMultiplexer();
protected CfInputMultiplexer func_116 = new CfInputMultiplexer();

// default constructor
public CmBufHeatDemand()
{
  func_44.configure(4);
}

  public void Start()
  {
    func_53.Start();
    func_140.Start();
    func_144.Start();
    func_28.Start();
    func_74.Start();
  }
}
