/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    BypassValve
Macro id:      6119057689261637954
Macro version: 21
Last change:   17.11.2015 - 07:53
Access Level:  2
Inputs:
  [1] BufLoadLevel
  [2] FilteredOATemp
  [3] BufUpperTemp
  [4] EffLowerTemp
  [5] CFG-01 = CHG
  [6] ExtLoading
  [7] BufCharging
  [8] BufDischarging
  [9] CFG-01 = DCHG
Outputs:
  [1] BypassValve1
  [2] BypassValve2
  [3] BypassValve3
  [4] BypassValve4
  [5] StopHighOATemp
  [6] BufOverheatAlm
  [7] Overheat
Parameter:
  [1] OAT-01: stop buffer loading high OAT limit
  [2] OVHT-01: max buffer upper temperature
  [3] OVHT-02: max buffer lower temperature
  [4] OVHT-03: alarm delay for max alarm (0=off)
  [5] OVHT-04: switching differential buffer alarm
Description:

================================================================================*/

public class CmBypassValve
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [10] Function call CfWindow
    func_10.inputValue = CmBypassValve_input_1;
    func_10.inputMinimum = 0.8F;
    func_10.inputMaximum = 4.2F;
    func_10.Execute(  );

    // [11] Function call CfWindow
    func_11.inputValue = CmBypassValve_input_1;
    func_11.inputMinimum = 3.8F;
    func_11.inputMaximum = 4.2F;
    func_11.Execute(  );

    // [12] Function call CfWindow
    func_12.inputValue = CmBypassValve_input_1;
    func_12.inputMinimum = 2.8F;
    func_12.inputMaximum = 4.2F;
    func_12.Execute(  );

    // [13] Function call CfWindow
    func_13.inputValue = CmBypassValve_input_1;
    func_13.inputMinimum = 1.8F;
    func_13.inputMaximum = 4.2F;
    func_13.Execute(  );

    // [38] Function call CfCompare1
    func_38.inputA = env.getParameter(parameterOffset);
    func_38.inputB = 90F;
    func_38.Execute(  );

    // [45] Function call CfCompare1
    func_45.inputA = CmBypassValve_input_27;
    func_45.inputB = env.getParameter(parameterOffset);
    func_45.Execute(  );

    // [68] Function call CfIdt
    func_68.input = env.getParameter(parameterOffset + 3);
    func_68.Execute(  );
    env.setParameter(parameterOffset + 7, func_68.output[0]);

    // [72] Function call CfCompare1
    func_72.inputA = env.getParameter(parameterOffset + 3);
    func_72.inputB = 0F;
    func_72.Execute(  );

    // [85] Function call CfHysteresis
    func_85.inputX = CmBypassValve_input_54;
    func_85.inputW = env.getParameter(parameterOffset + 1);
    func_85.Execute( env, parameterOffset + 5 );

    // [86] Function call CfHysteresis
    func_86.inputX = CmBypassValve_input_157;
    func_86.inputW = env.getParameter(parameterOffset + 2);
    func_86.Execute( env, parameterOffset + 6 );

    // [95] Function call CfIdt
    func_95.input = env.getParameter(parameterOffset + 4);
    func_95.Execute(  );
    env.setParameter(parameterOffset + 5, func_95.output[0]);
    env.setParameter(parameterOffset + 6, func_95.output[1]);

    // [134] Function call CfNot
    func_134.input = CmBypassValve_input_120;
    func_134.Execute(  );

    // [151] Function call CfNot
    func_151.input = CmBypassValve_input_119;
    func_151.Execute(  );

    // [42] Function call CfAnd
    func_42.input[0] = func_38.outputLess;
    func_42.input[1] = func_45.outputGreater;
    func_42.Execute(  );
    CmBypassValve_output_29 = func_42.outputAND;

    // [89] Function call CfOr
    func_89.input[0] = func_85.output1;
    func_89.input[1] = func_86.output1;
    func_89.Execute(  );

    // [132] Function call CfAnd
    func_132.input[0] = CmBypassValve_input_122;
    func_132.input[1] = func_134.output;
    func_132.Execute(  );

    // [92] Function call CfAnd
    func_92.input[0] = func_72.outputGreater;
    func_92.input[1] = func_89.outputOR;
    func_92.Execute(  );

    // [116] Function call CfIdt
    func_116.input = BooleanToFloat(func_89.outputOR);
    func_116.Execute(  );
    CmBypassValve_output_115 = FloatToBoolean(func_116.output[0]);

    // [137] Function call CfOr
    func_137.input[0] = func_132.outputAND;
    func_137.input[1] = CmBypassValve_input_121;
    func_137.input[2] = CmBypassValve_input_155;
    func_137.Execute(  );

    // [65] Function call CfDelayOnOff
    func_65.input = func_92.outputAND;
    func_65.Execute( env, parameterOffset + 7 );
    CmBypassValve_output_60 = func_65.output;

    // [139] Function call CfAnd
    func_139.input[0] = func_137.outputOR;
    func_139.input[1] = CmBypassValve_input_119;
    func_139.Execute(  );

    // [152] Function call CfAnd
    func_152.input[0] = func_151.output;
    func_152.input[1] = func_137.outputOR;
    func_152.Execute(  );

    // [96] Function call CfOr
    func_96.input[0] = CmBypassValve_output_29;
    func_96.input[1] = func_89.outputOR;
    func_96.input[2] = func_152.outputAND;
    func_96.Execute(  );

    // [128] Function call CfInputMultiplexer
    func_128.inputSelect = BooleanToInt(func_139.outputAND);
    func_128.input[1-1] = BooleanToFloat(func_10.output);
    func_128.input[2-1] = 1F;
    func_128.Execute(  );

    // [129] Function call CfInputMultiplexer
    func_129.inputSelect = BooleanToInt(func_139.outputAND);
    func_129.input[1-1] = BooleanToFloat(func_13.output);
    func_129.input[2-1] = 1F;
    func_129.Execute(  );

    // [130] Function call CfInputMultiplexer
    func_130.inputSelect = BooleanToInt(func_139.outputAND);
    func_130.input[1-1] = BooleanToFloat(func_11.output);
    func_130.input[2-1] = 1F;
    func_130.Execute(  );

    // [131] Function call CfInputMultiplexer
    func_131.inputSelect = BooleanToInt(func_139.outputAND);
    func_131.input[1-1] = BooleanToFloat(func_12.output);
    func_131.input[2-1] = 1F;
    func_131.Execute(  );

    // [30] Function call CfInputMultiplexer
    func_30.inputSelect = BooleanToInt(func_96.outputOR);
    func_30.input[1-1] = func_128.output;
    func_30.input[2-1] = 0F;
    func_30.Execute(  );
    CmBypassValve_output_2 = FloatToBoolean(func_30.output);

    // [33] Function call CfInputMultiplexer
    func_33.inputSelect = BooleanToInt(func_96.outputOR);
    func_33.input[1-1] = func_129.output;
    func_33.input[2-1] = 0F;
    func_33.Execute(  );
    CmBypassValve_output_3 = FloatToBoolean(func_33.output);

    // [34] Function call CfInputMultiplexer
    func_34.inputSelect = BooleanToInt(func_96.outputOR);
    func_34.input[1-1] = func_131.output;
    func_34.input[2-1] = 0F;
    func_34.Execute(  );
    CmBypassValve_output_4 = FloatToBoolean(func_34.output);

    // [36] Function call CfInputMultiplexer
    func_36.inputSelect = BooleanToInt(func_96.outputOR);
    func_36.input[1-1] = func_130.output;
    func_36.input[2-1] = 0F;
    func_36.Execute(  );
    CmBypassValve_output_5 = FloatToBoolean(func_36.output);

  }
// macro register which are written multiple times
// macro inputs
public float CmBypassValve_input_1; // BufLoadLevel
public float CmBypassValve_input_27; // FilteredOATemp
public float CmBypassValve_input_54; // BufUpperTemp
public float CmBypassValve_input_157; // EffLowerTemp
public boolean CmBypassValve_input_122; // CFG-01 = CHG
public boolean CmBypassValve_input_119; // ExtLoading
public boolean CmBypassValve_input_120; // BufCharging
public boolean CmBypassValve_input_121; // BufDischarging
public boolean CmBypassValve_input_155; // CFG-01 = DCHG
// macro outputs
public boolean CmBypassValve_output_2; // BypassValve1
public boolean CmBypassValve_output_3; // BypassValve2
public boolean CmBypassValve_output_4; // BypassValve3
public boolean CmBypassValve_output_5; // BypassValve4
public boolean CmBypassValve_output_29; // StopHighOATemp
public boolean CmBypassValve_output_60; // BufOverheatAlm
public boolean CmBypassValve_output_115; // Overheat
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfWindow func_10 = new CfWindow();
protected CfWindow func_11 = new CfWindow();
protected CfWindow func_12 = new CfWindow();
protected CfWindow func_13 = new CfWindow();
protected CfCompare1 func_38 = new CfCompare1();
protected CfCompare1 func_45 = new CfCompare1();
protected CfIdt func_68 = new CfIdt();
protected CfCompare1 func_72 = new CfCompare1();
protected CfHysteresis func_85 = new CfHysteresis();
protected CfHysteresis func_86 = new CfHysteresis();
protected CfIdt func_95 = new CfIdt();
protected CfNot func_134 = new CfNot();
protected CfNot func_151 = new CfNot();
protected CfAnd func_42 = new CfAnd();
protected CfOr func_89 = new CfOr();
protected CfAnd func_132 = new CfAnd();
protected CfAnd func_92 = new CfAnd();
protected CfIdt func_116 = new CfIdt();
protected CfOr func_137 = new CfOr();
protected CfDelayOnOff func_65 = new CfDelayOnOff();
protected CfAnd func_139 = new CfAnd();
protected CfAnd func_152 = new CfAnd();
protected CfOr func_96 = new CfOr();
protected CfInputMultiplexer func_128 = new CfInputMultiplexer();
protected CfInputMultiplexer func_129 = new CfInputMultiplexer();
protected CfInputMultiplexer func_130 = new CfInputMultiplexer();
protected CfInputMultiplexer func_131 = new CfInputMultiplexer();
protected CfInputMultiplexer func_30 = new CfInputMultiplexer();
protected CfInputMultiplexer func_33 = new CfInputMultiplexer();
protected CfInputMultiplexer func_34 = new CfInputMultiplexer();
protected CfInputMultiplexer func_36 = new CfInputMultiplexer();

// default constructor
public CmBypassValve()
{
  func_95.configure(2);
  func_137.configure(3);
  func_96.configure(3);
}

  public void Start()
  {
    func_85.Start();
    func_86.Start();
    func_65.Start();
  }
}
