/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    ChargingPumpCmd
Macro id:      5981692449092797181
Macro version: 17
Last change:   23.03.2015 - 10:45
Access Level:  2
Inputs:
  [1] SysSupplayTemp
  [2] UpperTemp
  [3] ContinuousCntr
  [4] On/Off_Cntr
  [5] LegProtEnabled
  [6] OverheatProt
Outputs:
  [1] PumpCmd
  [2] ValveEnable
Parameter:
  [1] SST-01: temp. difference primary/secondary system
  [2] PRP-01: start-up delay primary/ secondary system
  [3] CFG-01: system configuration
  [4] PRP-02: switch off delay primary pump
Description:

================================================================================*/

public class CmChargingPumpCmd
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [18] Function call CfAddition
    func_18.input[0] = CmChargingPumpCmd_input_3;
    func_18.input[1] = env.getParameter(parameterOffset);
    func_18.Execute(  );

    // [22] Function call CfHysteresis
    func_22.inputX = CmChargingPumpCmd_input_2;
    func_22.inputW = 3F;
    func_22.Execute( env, parameterOffset + 4 );

    // [48] Function call CfIdt
    func_48.input = env.getParameter(parameterOffset + 1);
    func_48.Execute(  );
    env.setParameter(parameterOffset + 5, func_48.output[0]);

    // [69] Function call CfOr
    func_69.input[0] = CmChargingPumpCmd_input_5;
    func_69.input[1] = CmChargingPumpCmd_input_6;
    func_69.Execute(  );

    // [118] Function call CfWindow
    func_118.inputValue = env.getParameter(parameterOffset + 2);
    func_118.inputMinimum = 1.8F;
    func_118.inputMaximum = 3.2F;
    func_118.Execute(  );

    // [132] Function call CfIdt
    func_132.input = env.getParameter(parameterOffset + 3);
    func_132.Execute(  );
    env.setParameter(parameterOffset + 8, func_132.output[0]);

    // [14] Function call CfCompare1
    func_14.inputA = CmChargingPumpCmd_input_1;
    func_14.inputB = func_18.output;
    func_14.Execute(  );

    // [119] Function call CfInputMultiplexer
    func_119.inputSelect = BooleanToInt(func_118.output);
    func_119.input[1-1] = BooleanToFloat(func_22.output1);
    func_119.input[2-1] = BooleanToFloat(CmChargingPumpCmd_input_120);
    func_119.Execute(  );

    // [24] Function call CfAnd
    func_24.input[0] = FloatToBoolean(func_119.output);
    func_24.input[1] = func_14.outputGreater;
    func_24.Execute(  );

    // [53] Function call CfIdt
    func_53.input = BooleanToFloat(func_24.outputAND);
    func_53.Execute(  );
    CmChargingPumpCmd_output_52 = FloatToBoolean(func_53.output[0]);

    // [65] Function call CfAnd
    func_65.input[0] = func_24.outputAND;
    func_65.input[1] = func_69.outputOR;
    func_65.Execute(  );

    // [62] Function call CfOr
    func_62.input[0] = func_24.outputAND;
    func_62.input[1] = func_65.outputAND;
    func_62.Execute(  );

    // [47] Function call CfDelayOnOff
    func_47.input = func_62.outputOR;
    func_47.Execute( env, parameterOffset + 5 );

    // [61] Function call CfInputMultiplexer
    func_61.inputSelect = FloatToInt(env.getParameter(parameterOffset + 2));
    func_61.input[1-1] = 0F;
    func_61.input[2-1] = func_119.output;
    func_61.input[3-1] = func_119.output;
    func_61.input[4-1] = BooleanToFloat(func_47.output);
    func_61.Execute(  );

    // [130] Function call CfDelayOnOff
    func_130.input = FloatToBoolean(func_61.output);
    func_130.Execute( env, parameterOffset + 7 );
    CmChargingPumpCmd_output_51 = func_130.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmChargingPumpCmd_input_1; // SysSupplayTemp
public float CmChargingPumpCmd_input_3; // UpperTemp
public float CmChargingPumpCmd_input_2; // ContinuousCntr
public boolean CmChargingPumpCmd_input_120; // On/Off_Cntr
public boolean CmChargingPumpCmd_input_5; // LegProtEnabled
public boolean CmChargingPumpCmd_input_6; // OverheatProt
// macro outputs
public boolean CmChargingPumpCmd_output_51; // PumpCmd
public boolean CmChargingPumpCmd_output_52; // ValveEnable
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfAddition func_18 = new CfAddition();
protected CfHysteresis func_22 = new CfHysteresis();
protected CfIdt func_48 = new CfIdt();
protected CfOr func_69 = new CfOr();
protected CfWindow func_118 = new CfWindow();
protected CfIdt func_132 = new CfIdt();
protected CfCompare1 func_14 = new CfCompare1();
protected CfInputMultiplexer func_119 = new CfInputMultiplexer();
protected CfAnd func_24 = new CfAnd();
protected CfIdt func_53 = new CfIdt();
protected CfAnd func_65 = new CfAnd();
protected CfOr func_62 = new CfOr();
protected CfDelayOnOff func_47 = new CfDelayOnOff();
protected CfInputMultiplexer func_61 = new CfInputMultiplexer();
protected CfDelayOnOff func_130 = new CfDelayOnOff();

// default constructor
public CmChargingPumpCmd()
{
  func_61.configure(5);
}

  public void Start()
  {
    func_22.Start();
    func_47.Start();
    func_130.Start();
  }
}
