/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    CirculationPumpCmd
Macro id:      5981758258272010550
Macro version: 15
Last change:   23.03.2015 - 09:39
Access Level:  2
Inputs:
  [1] FlowSwitch
  [2] LegProtEnabled
  [3] HolidaySwitch
  [4] MaxThermostat
  [5] OverhatProt
  [6] Occupied
  [7] ExtOperation
Outputs:
  [1] CircPumpCmd
Parameter:
  [1] SEP-02: circulation pump off delay
  [2] SEP-04: circulation pump during overheat protection
  [3] SEP-03: run circulation pump during occupied and extended operation
Description:

================================================================================*/

public class CmCirculationPumpCmd
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [6] Function call CfIdt
    func_6.input = env.getParameter(parameterOffset);
    func_6.Execute(  );
    env.setParameter(parameterOffset + 4, func_6.output[0]);

    // [15] Function call CfNot
    func_15.input = CmCirculationPumpCmd_input_13;
    func_15.Execute(  );

    // [27] Function call CfWindow
    func_27.inputValue = env.getParameter(parameterOffset + 1);
    func_27.inputMinimum = 1.8F;
    func_27.inputMaximum = 2.2F;
    func_27.Execute(  );

    // [33] Function call CfWindow
    func_33.inputValue = env.getParameter(parameterOffset + 1);
    func_33.inputMinimum = 3.8F;
    func_33.inputMaximum = 4.2F;
    func_33.Execute(  );

    // [37] Function call CfWindow
    func_37.inputValue = env.getParameter(parameterOffset + 1);
    func_37.inputMinimum = 2.8F;
    func_37.inputMaximum = 3.2F;
    func_37.Execute(  );

    // [55] Function call CfWindow
    func_55.inputValue = env.getParameter(parameterOffset + 2);
    func_55.inputMinimum = 0.8F;
    func_55.inputMaximum = 1.2F;
    func_55.Execute(  );

    // [57] Function call CfOr
    func_57.input[0] = CmCirculationPumpCmd_input_44;
    func_57.input[1] = CmCirculationPumpCmd_input_45;
    func_57.Execute(  );

    // [34] Function call CfOr
    func_34.input[0] = func_27.output;
    func_34.input[1] = func_33.output;
    func_34.Execute(  );

    // [38] Function call CfOr
    func_38.input[0] = func_33.output;
    func_38.input[1] = func_37.output;
    func_38.Execute(  );

    // [56] Function call CfAnd
    func_56.input[0] = func_55.output;
    func_56.input[1] = func_57.outputOR;
    func_56.Execute(  );

    // [24] Function call CfAnd
    func_24.input[0] = CmCirculationPumpCmd_input_22;
    func_24.input[1] = func_34.outputOR;
    func_24.Execute(  );

    // [39] Function call CfAnd
    func_39.input[0] = CmCirculationPumpCmd_input_23;
    func_39.input[1] = func_38.outputOR;
    func_39.Execute(  );

    // [62] Function call CfOr
    func_62.input[0] = CmCirculationPumpCmd_input_1;
    func_62.input[1] = func_56.outputAND;
    func_62.Execute(  );

    // [9] Function call CfOr
    func_9.input[0] = func_62.outputOR;
    func_9.input[1] = func_24.outputAND;
    func_9.input[2] = func_39.outputAND;
    func_9.Execute(  );

    // [49] Function call CfAnd
    func_49.input[0] = func_15.output;
    func_49.input[1] = func_9.outputOR;
    func_49.Execute(  );

    // [48] Function call CfOr
    func_48.input[0] = func_49.outputAND;
    func_48.input[1] = CmCirculationPumpCmd_input_8;
    func_48.Execute(  );

    // [4] Function call CfDelayOnOff
    func_4.input = func_48.outputOR;
    func_4.Execute( env, parameterOffset + 3 );
    CmCirculationPumpCmd_output_2 = func_4.output;

  }
// macro register which are written multiple times
// macro inputs
public boolean CmCirculationPumpCmd_input_1; // FlowSwitch
public boolean CmCirculationPumpCmd_input_8; // LegProtEnabled
public boolean CmCirculationPumpCmd_input_13; // HolidaySwitch
public boolean CmCirculationPumpCmd_input_22; // MaxThermostat
public boolean CmCirculationPumpCmd_input_23; // OverhatProt
public boolean CmCirculationPumpCmd_input_44; // Occupied
public boolean CmCirculationPumpCmd_input_45; // ExtOperation
// macro outputs
public boolean CmCirculationPumpCmd_output_2; // CircPumpCmd
// helper functions

// class variables
protected CfIdt func_6 = new CfIdt();
protected CfNot func_15 = new CfNot();
protected CfWindow func_27 = new CfWindow();
protected CfWindow func_33 = new CfWindow();
protected CfWindow func_37 = new CfWindow();
protected CfWindow func_55 = new CfWindow();
protected CfOr func_57 = new CfOr();
protected CfOr func_34 = new CfOr();
protected CfOr func_38 = new CfOr();
protected CfAnd func_56 = new CfAnd();
protected CfAnd func_24 = new CfAnd();
protected CfAnd func_39 = new CfAnd();
protected CfOr func_62 = new CfOr();
protected CfOr func_9 = new CfOr();
protected CfAnd func_49 = new CfAnd();
protected CfOr func_48 = new CfOr();
protected CfDelayOnOff func_4 = new CfDelayOnOff();

// default constructor
public CmCirculationPumpCmd()
{
  func_9.configure(3);
}

  public void Start()
  {
    func_4.Start();
  }
}
