/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Continous Flow G1
Macro id:      6028775553732968912
Macro version: 18
Last change:   23.03.2015 - 11:54
Access Level:  2
Inputs:
  [1] FilteredOAT
  [2] HeatDemand
  [3] GroupSeqPref
Outputs:
  [1] ContFlowActiv
Parameter:
  [1] SYS-01: continuous flow enabled
  [2] SYS-02: continuous flow switch off delay
  [3] SST-05: min heat demand to start heat gen
Description:

================================================================================*/

public class CmContinous_Flow_G1
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [54] Function call CfDivide
    func_54.inputA = env.getParameter(parameterOffset + 1);
    func_54.inputB = 100F;
    func_54.Execute(  );

    // [55] Function call CfTruncate
    func_55.input = func_54.output;
    func_55.Execute(  );

    // [56] Function call CfMultiply
    func_56.input[0] = func_55.output;
    func_56.input[1] = 60F;
    func_56.Execute(  );

    // [58] Function call CfMultiply
    func_58.input[0] = func_55.output;
    func_58.input[1] = 100F;
    func_58.Execute(  );

    // [59] Function call CfSubtract
    func_59.input[0] = env.getParameter(parameterOffset + 1);
    func_59.input[1] = func_58.output;
    func_59.Execute(  );

    // [57] Function call CfAddition
    func_57.input[0] = func_56.output;
    func_57.input[1] = func_59.output;
    func_57.Execute(  );

    // [12] Function call CfCompare1
    func_12.inputA = CmContinous_Flow_G1_input_2;
    func_12.inputB = env.getParameter(parameterOffset + 2);
    func_12.Execute(  );

    // [120] Macro call CmRead_Group_Register
    func_120.CmRead_Group_Register_input_2 = CmContinous_Flow_G1_input_75;
    func_120.CmRead_Group_Register_input_53 = 1004F;
    func_120.Execute(  );

    // [126] Function call CfCompare2
    func_126.inputA = func_120.CmRead_Group_Register_output_31;
    func_126.inputB = 0F;
    func_126.Execute(  );

    // [16] Function call CfAnd
    func_16.input[0] = func_12.outputLess;
    func_16.input[1] = func_126.outputEqualOrLess;
    func_16.Execute(  );

    // [27] Function call CfTimeCounter
    func_27.inputSignal = func_16.outputAND;
    func_27.inputReset = func_16.outputNAND;
    func_27.Execute(  );

    // [40] Function call CfMultiply
    func_40.input[0] = IntToFloat(func_27.outputHours);
    func_40.input[1] = 60F;
    func_40.Execute(  );

    // [41] Function call CfAddition
    func_41.input[0] = func_40.output;
    func_41.input[1] = IntToFloat(func_27.outputMinutes);
    func_41.Execute(  );

    // [67] Function call CfCompare1
    func_67.inputA = func_57.output;
    func_67.inputB = func_41.output;
    func_67.Execute(  );

    // [60] Function call CfIdt
    func_60.input = 1F;
    func_60.Execute(  );
    env.setParameter(parameterOffset + 3, func_60.output[0]);

    // [39] Function call CfHysteresis
    func_39.inputX = CmContinous_Flow_G1_input_1;
    func_39.inputW = 2F;
    func_39.Execute( env, parameterOffset + 3 );

    // [38] Function call CfOr
    func_38.input[0] = func_67.outputGreater;
    func_38.input[1] = func_39.output2;
    func_38.Execute(  );

    // [6] Function call CfInputMultiplexer
    func_6.inputSelect = FloatToInt(env.getParameter(parameterOffset));
    func_6.input[1-1] = 0F;
    func_6.input[2-1] = 1F;
    func_6.input[3-1] = BooleanToFloat(func_38.outputOR);
    func_6.Execute(  );

    // [78] Function call CfMultiply
    func_78.input[0] = func_6.output;
    func_78.input[1] = 10F;
    func_78.Execute(  );

    // [79] Function call CfMultiply
    func_79.input[0] = func_6.output;
    func_79.input[1] = 100F;
    func_79.Execute(  );

    // [74] Function call CfInputMultiplexer
    func_74.inputSelect = FloatToInt(CmContinous_Flow_G1_input_75);
    func_74.input[1-1] = func_6.output;
    func_74.input[2-1] = func_6.output;
    func_74.input[3-1] = func_78.output;
    func_74.input[4-1] = func_79.output;
    func_74.Execute(  );

    // [85] Function call CfNot
    func_85.input = FloatToBoolean(func_6.output);
    func_85.Execute(  );

    // [84] Function call CfWrGlobalRegister
    func_84.inputValue = func_6.output;
    func_84.inputRegister = 973;
    func_84.inputEnable = func_85.output;
    func_84.inputMode = 0;
    func_84.Execute(  );

    // [116] Function call CfRdGlobalRegister
    func_116.inputRegister = 973;
    func_116.inputReset = false;
    func_116.inputResetValue = 0F;
    func_116.Execute(  );

    // [112] Function call CfNot
    func_112.input = FloatToBoolean(func_116.output);
    func_112.Execute(  );

    // [110] Function call CfAnd
    func_110.input[0] = FloatToBoolean(func_6.output);
    func_110.input[1] = func_112.output;
    func_110.Execute(  );

    // [111] Function call CfWrGlobalRegister
    func_111.inputValue = BooleanToFloat(func_110.outputAND);
    func_111.inputRegister = 973;
    func_111.inputEnable = func_110.outputAND;
    func_111.inputMode = 0;
    func_111.Execute(  );

    // [5] Function call CfWrGlobalRegister
    func_5.inputValue = func_74.output;
    func_5.inputRegister = 979;
    func_5.inputEnable = true;
    func_5.inputMode = 0;
    func_5.Execute(  );

    // [82] Function call CfIdt
    func_82.input = func_74.output;
    func_82.Execute(  );
    CmContinous_Flow_G1_output_81 = FloatToBoolean(func_82.output[0]);

  }
// macro register which are written multiple times
// macro inputs
public float CmContinous_Flow_G1_input_1; // FilteredOAT
public float CmContinous_Flow_G1_input_2; // HeatDemand
public float CmContinous_Flow_G1_input_75; // GroupSeqPref
// macro outputs
public boolean CmContinous_Flow_G1_output_81; // ContFlowActiv
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private float   IntToFloat    (int     value) { return (float) value; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfDivide func_54 = new CfDivide();
protected CfTruncate func_55 = new CfTruncate();
protected CfMultiply func_56 = new CfMultiply();
protected CfMultiply func_58 = new CfMultiply();
protected CfSubtract func_59 = new CfSubtract();
protected CfAddition func_57 = new CfAddition();
protected CfCompare1 func_12 = new CfCompare1();
protected CmRead_Group_Register func_120 = new CmRead_Group_Register();
protected CfCompare2 func_126 = new CfCompare2();
protected CfAnd func_16 = new CfAnd();
protected CfTimeCounter func_27 = new CfTimeCounter();
protected CfMultiply func_40 = new CfMultiply();
protected CfAddition func_41 = new CfAddition();
protected CfCompare1 func_67 = new CfCompare1();
protected CfIdt func_60 = new CfIdt();
protected CfHysteresis func_39 = new CfHysteresis();
protected CfOr func_38 = new CfOr();
protected CfInputMultiplexer func_6 = new CfInputMultiplexer();
protected CfMultiply func_78 = new CfMultiply();
protected CfMultiply func_79 = new CfMultiply();
protected CfInputMultiplexer func_74 = new CfInputMultiplexer();
protected CfNot func_85 = new CfNot();
protected CfWrGlobalRegister func_84 = new CfWrGlobalRegister();
protected CfRdGlobalRegister func_116 = new CfRdGlobalRegister();
protected CfNot func_112 = new CfNot();
protected CfAnd func_110 = new CfAnd();
protected CfWrGlobalRegister func_111 = new CfWrGlobalRegister();
protected CfWrGlobalRegister func_5 = new CfWrGlobalRegister();
protected CfIdt func_82 = new CfIdt();

// default constructor
public CmContinous_Flow_G1()
{
  func_6.configure(4);
  func_74.configure(5);
}

  public void Start()
  {
    func_120.Start();
    func_27.Start();
    func_39.Start();
  }
}
