/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Continuous Control
Macro id:      5982023496199307272
Macro version: 14
Last change:   04.04.2014 - 09:37
Access Level:  2
Inputs:
  [1] CalcDHW_Sp
  [2] UpperTemp
  [3] LowerTemp
  [4] SST_Alarm
Outputs:
  [1] ContinuousCntr
Parameter:
  [1] UWT-01: P-band buffer temperature control
  [2] LWT-02: D-time buffer temperature control
  [3] SST-01: temp. difference primary/ secondary system
  [4] SYS-06: autmatic/ manual reset
Description:

================================================================================*/

public class CmContinuous_Control
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [13] Function call CfIdt
    func_13.input = env.getParameter(parameterOffset);
    func_13.Execute(  );
    env.setParameter(parameterOffset + 4, func_13.output[0]);

    // [15] Function call CfCompare1
    func_15.inputA = CmContinuous_Control_input_3;
    func_15.inputB = 999F;
    func_15.Execute(  );

    // [27] Function call CfDivide
    func_27.inputA = env.getParameter(parameterOffset);
    func_27.inputB = 4F;
    func_27.Execute(  );

    // [30] Function call CfIdt
    func_30.input = env.getParameter(parameterOffset + 1);
    func_30.Execute(  );
    env.setParameter(parameterOffset + 15, func_30.output[0]);

    // [42] Function call CfAnd
    func_42.input[0] = CmContinuous_Control_input_39;
    func_42.input[1] = FloatToBoolean(env.getParameter(parameterOffset + 3));
    func_42.Execute(  );

    // [63] Function call CfPidPlus
    func_63.inputX = CmContinuous_Control_input_2;
    func_63.inputW = CmContinuous_Control_input_1;
    func_63.Execute( env, parameterOffset + 4 );

    // [79] Function call CfIdt
    func_79.input = 0F;
    func_79.Execute(  );
    env.setParameter(parameterOffset + 6, func_79.output[0]);
    env.setParameter(parameterOffset + 11, func_79.output[1]);
    env.setParameter(parameterOffset + 16, func_79.output[2]);

    // [61] Function call CfAddition
    func_61.input[0] = CmContinuous_Control_input_1;
    func_61.input[1] = func_27.output;
    func_61.Execute(  );

    // [62] Function call CfSubtract
    func_62.input[0] = CmContinuous_Control_input_1;
    func_62.input[1] = func_27.output;
    func_62.Execute(  );

    // [77] Function call CfMultiply
    func_77.input[0] = func_27.output;
    func_77.input[1] = 2F;
    func_77.Execute(  );

    // [24] Function call CfIdt
    func_24.input = func_77.output;
    func_24.Execute(  );
    env.setParameter(parameterOffset + 14, func_24.output[0]);
    env.setParameter(parameterOffset + 9, func_24.output[1]);

    // [65] Function call CfPidPlus
    func_65.inputX = CmContinuous_Control_input_2;
    func_65.inputW = func_61.output;
    func_65.Execute( env, parameterOffset + 9 );

    // [66] Function call CfPidPlus
    func_66.inputX = CmContinuous_Control_input_3;
    func_66.inputW = func_62.output;
    func_66.Execute( env, parameterOffset + 14 );

    // [31] Function call CfMinimum
    func_31.input[0] = func_65.output;
    func_31.input[1] = func_66.output;
    func_31.Execute(  );

    // [18] Function call CfInputMultiplexer
    func_18.inputSelect = BooleanToInt(func_15.outputEqual);
    func_18.input[1-1] = func_31.output;
    func_18.input[2-1] = func_63.output;
    func_18.Execute(  );

    // [51] Function call CfInputMultiplexer
    func_51.inputSelect = BooleanToInt(func_42.outputAND);
    func_51.input[1-1] = func_18.output;
    func_51.input[2-1] = 0F;
    func_51.Execute(  );
    CmContinuous_Control_output_4 = func_51.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmContinuous_Control_input_1; // CalcDHW_Sp
public float CmContinuous_Control_input_2; // UpperTemp
public float CmContinuous_Control_input_3; // LowerTemp
public boolean CmContinuous_Control_input_39; // SST_Alarm
// macro outputs
public float CmContinuous_Control_output_4; // ContinuousCntr
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfIdt func_13 = new CfIdt();
protected CfCompare1 func_15 = new CfCompare1();
protected CfDivide func_27 = new CfDivide();
protected CfIdt func_30 = new CfIdt();
protected CfAnd func_42 = new CfAnd();
protected CfPidPlus func_63 = new CfPidPlus();
protected CfIdt func_79 = new CfIdt();
protected CfAddition func_61 = new CfAddition();
protected CfSubtract func_62 = new CfSubtract();
protected CfMultiply func_77 = new CfMultiply();
protected CfIdt func_24 = new CfIdt();
protected CfPidPlus func_65 = new CfPidPlus();
protected CfPidPlus func_66 = new CfPidPlus();
protected CfMinimum func_31 = new CfMinimum();
protected CfInputMultiplexer func_18 = new CfInputMultiplexer();
protected CfInputMultiplexer func_51 = new CfInputMultiplexer();

// default constructor
public CmContinuous_Control()
{
  func_79.configure(3);
  func_24.configure(2);
}

  public void Start()
  {
    func_63.Start();
    func_65.Start();
    func_66.Start();
  }
}
