/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Cycle time
Macro id:      6050344211158401987
Macro version: 7
Last change:   09.11.2016 - 11:17
Access Level:  2
Inputs:
Outputs:
  [1] CT
Parameter:
  [1] Par01 Reset
  [2] Par02 CycleTime for Restart
Description:
This is a macro to calcuate the cycle time precisely.

Special cases:

If the reset and overruns takes place the value of the last loop is used.

During startup the value from the parameter 'Par02 CycleTime for Restart' is used. This values is stored once every 24 hours after starting the application. startup 


++++++++++++++++++++++++++++++++++++++++++
Jochen Steinhilber
22 Aug 2014
================================================================================*/

public class CmCycle_time
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [8] Function call CfTimeCounter
    func_8.inputSignal = true;
    func_8.inputReset = func_24.outputGreater;
    func_8.Execute(  );

    // [9] Function call CfIdt
    func_9.input = LongToFloat(func_8.regRuntimeMilliSec);
    func_9.Execute(  );

    // [10] Function call CfLastValue
    func_10.input = func_9.output[0];
    func_10.Execute(  );

    // [11] Function call CfSubtract
    func_11.input[0] = func_10.outputCurrent;
    func_11.input[1] = func_10.outputLast;
    func_11.Execute(  );

    // [12] Function call CfDivide
    func_12.inputA = func_11.output;
    func_12.inputB = 1000F;
    func_12.Execute(  );

    // [19] Function call CfInputMultiplexer ("Startup")
    func_19.inputSelect = BooleanToInt(ControlFunction.GetStartupFlag());
    func_19.input[1-1] = func_12.output;
    func_19.input[2-1] = env.getParameter(parameterOffset + 1);
    func_19.Execute(  );

    // [22] Function call CfInputMultiplexer ("During reset keep fixed value")
    func_22.inputSelect = BooleanToInt(func_24.outputGreater);
    func_22.input[1-1] = func_19.output;
    func_22.input[2-1] = env.getParameter(parameterOffset + 1);
    func_22.Execute(  );

    // [29] Function call CfIdt
    func_29.input = func_22.output;
    func_29.Execute(  );
    env.setParameter(parameterOffset + 1, func_29.output[0]);
    CmCycle_time_output_13 = func_29.output[1];

    // [24] Function call CfCompare1
    func_24.inputA = func_9.output[0];
    func_24.inputB = env.getParameter(parameterOffset);
    func_24.Execute(  );

  }
// macro register which are written multiple times
// macro inputs
// macro outputs
public float CmCycle_time_output_13; // CT
// helper functions
private float   LongToFloat   (long    value) { return (float) value; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfTimeCounter func_8 = new CfTimeCounter();
protected CfIdt func_9 = new CfIdt();
protected CfLastValue func_10 = new CfLastValue();
protected CfSubtract func_11 = new CfSubtract();
protected CfDivide func_12 = new CfDivide();
protected CfInputMultiplexer func_19 = new CfInputMultiplexer();
protected CfInputMultiplexer func_22 = new CfInputMultiplexer();
protected CfIdt func_29 = new CfIdt();
protected CfCompare1 func_24 = new CfCompare1();

// default constructor
public CmCycle_time()
{
  func_29.configure(2);
}

  public void Start()
  {
    func_8.Start();
    func_10.Start();
  }
}
