/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    DHA/DHW Setpoint
Macro id:      5981989560094032621
Macro version: 13
Last change:   05.05.2014 - 09:00
Access Level:  2
Inputs:
  [1] SetpointSchedule
  [2] DayExtension
  [3] HolidaySwitch
  [4] OverheatProt
  [5] LegProtEnabled
Outputs:
  [1] CalcDHW_Sp
  [2] Occupied
  [3] Un-Occupied
Parameter:
  [1] SYS-01: occupied/ un-occupied changeover
  [2] DEX-01: DHW setpoint extended operation
  [3] LEG-01: anti-legionella setpoint
  [4] SYS-02: setpoint raise at OverheatProt
  [5] SYS-03: setpoint decrease/ minute after a OverheatProt
Description:

================================================================================*/

public class CmDHADHW_Setpoint
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [11] Function call CfCompare1
    func_11.inputA = CmDHADHW_Setpoint_input_1;
    func_11.inputB = env.getParameter(parameterOffset);
    func_11.Execute(  );

    // [48] Function call CfSubtract
    func_48.input[0] = env.getParameter(parameterOffset);
    func_48.input[1] = 0.1F;
    func_48.Execute(  );

    // [56] Function call CfNot
    func_56.input = CmDHADHW_Setpoint_input_6;
    func_56.Execute(  );

    // [58] Function call CfNot
    func_58.input = CmDHADHW_Setpoint_input_39;
    func_58.Execute(  );

    // [75] Function call CfIdt
    func_75.input = env.getParameter(parameterOffset + 4);
    func_75.Execute(  );
    env.setParameter(parameterOffset + 6, func_75.output[0]);

    // [15] Function call CfIdt
    func_15.input = BooleanToFloat(func_11.outputGreater);
    func_15.Execute(  );
    CmDHADHW_Setpoint_output_9 = FloatToBoolean(func_15.output[0]);

    // [18] Function call CfCompare1
    func_18.inputA = CmDHADHW_Setpoint_input_1;
    func_18.inputB = func_48.output;
    func_18.Execute(  );

    // [52] Function call CfAnd
    func_52.input[0] = CmDHADHW_Setpoint_input_8;
    func_52.input[1] = func_56.output;
    func_52.input[2] = func_58.output;
    func_52.Execute(  );

    // [24] Function call CfIdt
    func_24.input = BooleanToFloat(func_18.outputLess);
    func_24.Execute(  );
    CmDHADHW_Setpoint_output_10 = FloatToBoolean(func_24.output[0]);

    // [27] Function call CfOr
    func_27.input[0] = FloatToBoolean(func_15.output[1]);
    func_27.input[1] = FloatToBoolean(func_24.output[1]);
    func_27.Execute(  );

    // [26] Function call CfInputMultiplexer
    func_26.inputSelect = BooleanToInt(func_27.outputOR);
    func_26.input[1-1] = 0F;
    func_26.input[2-1] = CmDHADHW_Setpoint_input_1;
    func_26.Execute(  );

    // [29] Function call CfInputMultiplexer
    func_29.inputSelect = BooleanToInt(CmDHADHW_Setpoint_input_7);
    func_29.input[1-1] = func_26.output;
    func_29.input[2-1] = 0F;
    func_29.Execute(  );

    // [38] Function call CfInputMultiplexer
    func_38.inputSelect = BooleanToInt(CmDHADHW_Setpoint_input_39);
    func_38.input[1-1] = func_29.output;
    func_38.input[2-1] = env.getParameter(parameterOffset + 2);
    func_38.Execute(  );

    // [37] Function call CfInputMultiplexer
    func_37.inputSelect = BooleanToInt(CmDHADHW_Setpoint_input_6);
    func_37.input[1-1] = func_38.output;
    func_37.input[2-1] = env.getParameter(parameterOffset + 1);
    func_37.Execute(  );

    // [62] Function call CfAddition
    func_62.input[0] = func_37.output;
    func_62.input[1] = env.getParameter(parameterOffset + 3);
    func_62.Execute(  );

    // [76] Function call CfInputMultiplexer
    func_76.inputSelect = BooleanToInt(func_52.outputAND);
    func_76.input[1-1] = func_37.output;
    func_76.input[2-1] = func_62.output;
    func_76.Execute(  );

    // [74] Function call CfValueRamp
    func_74.inputValue = func_76.output;
    func_74.Execute( env, parameterOffset + 5 );

    // [89] Function call CfCompare1
    func_89.inputA = func_37.output;
    func_89.inputB = func_74.output;
    func_89.Execute(  );

    // [90] Function call CfMonoflop
    func_90.input = BooleanToFloat(func_89.outputLess);
    func_90.Execute( env, parameterOffset + 7 );

    // [88] Function call CfJkFlipFlop
    func_88.inputSet = func_52.outputAND;
    func_88.inputClock = false;
    func_88.inputReset = func_90.output;
    func_88.Execute(  );

    // [50] Function call CfInputMultiplexer
    func_50.inputSelect = BooleanToInt(func_88.output);
    func_50.input[1-1] = func_37.output;
    func_50.input[2-1] = func_74.output;
    func_50.Execute(  );

    // [96] Function call CfMinimum
    func_96.input[0] = func_50.output;
    func_96.input[1] = env.getParameter(parameterOffset + 2);
    func_96.Execute(  );
    CmDHADHW_Setpoint_output_2 = func_96.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmDHADHW_Setpoint_input_1; // SetpointSchedule
public boolean CmDHADHW_Setpoint_input_6; // DayExtension
public boolean CmDHADHW_Setpoint_input_7; // HolidaySwitch
public boolean CmDHADHW_Setpoint_input_8; // OverheatProt
public boolean CmDHADHW_Setpoint_input_39; // LegProtEnabled
// macro outputs
public float CmDHADHW_Setpoint_output_2; // CalcDHW_Sp
public boolean CmDHADHW_Setpoint_output_9; // Occupied
public boolean CmDHADHW_Setpoint_output_10; // Un-Occupied
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfCompare1 func_11 = new CfCompare1();
protected CfSubtract func_48 = new CfSubtract();
protected CfNot func_56 = new CfNot();
protected CfNot func_58 = new CfNot();
protected CfIdt func_75 = new CfIdt();
protected CfIdt func_15 = new CfIdt();
protected CfCompare1 func_18 = new CfCompare1();
protected CfAnd func_52 = new CfAnd();
protected CfIdt func_24 = new CfIdt();
protected CfOr func_27 = new CfOr();
protected CfInputMultiplexer func_26 = new CfInputMultiplexer();
protected CfInputMultiplexer func_29 = new CfInputMultiplexer();
protected CfInputMultiplexer func_38 = new CfInputMultiplexer();
protected CfInputMultiplexer func_37 = new CfInputMultiplexer();
protected CfAddition func_62 = new CfAddition();
protected CfInputMultiplexer func_76 = new CfInputMultiplexer();
protected CfValueRamp func_74 = new CfValueRamp();
protected CfCompare1 func_89 = new CfCompare1();
protected CfMonoflop func_90 = new CfMonoflop();
protected CfJkFlipFlop func_88 = new CfJkFlipFlop();
protected CfInputMultiplexer func_50 = new CfInputMultiplexer();
protected CfMinimum func_96 = new CfMinimum();

// default constructor
public CmDHADHW_Setpoint()
{
  func_15.configure(2);
  func_52.configure(3);
  func_24.configure(2);
}

  public void Start()
  {
    func_74.Start();
    func_90.Start();
    func_88.Start();
  }
}
