/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    DayExtensionHE/DHW
Macro id:      6017730048773063649
Macro version: 4
Last change:   26.05.2014 - 15:48
Access Level:  2
Inputs:
  [1] DayExtension
  [2] Un-OccPeriod
  [3] HolidaySwitch
  [4] DHW_TempSp
Outputs:
  [1] DayExtActiv
Parameter:
  [1] SST-03: occupied/ un-occupied changeover
  [2] DEX-01: DHW setpoint extended operation
  [3] DEX-02: auto reset time from extended operation
Description:

================================================================================*/

public class CmDayExtensionHEDHW
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [16] Function call CfCompare1
    func_16.inputA = CmDayExtensionHEDHW_input_8;
    func_16.inputB = env.getParameter(parameterOffset);
    func_16.Execute(  );

    // [21] Function call CfMultiply
    func_21.input[0] = env.getParameter(parameterOffset + 2);
    func_21.input[1] = 60F;
    func_21.Execute(  );
    env.setParameter(parameterOffset + 3, func_21.output);

    // [24] Function call CfWindow
    func_24.inputValue = env.getParameter(parameterOffset + 2);
    func_24.inputMinimum = -0.2F;
    func_24.inputMaximum = 0.2F;
    func_24.Execute(  );

    // [27] Function call CfOr
    func_27.input[0] = CmDayExtensionHEDHW_input_3;
    func_27.input[1] = CmDayExtensionHEDHW_input_2;
    func_27.Execute(  );

    // [9] Function call CfAnd
    func_9.input[0] = CmDayExtensionHEDHW_input_1;
    func_9.input[1] = func_16.outputLess;
    func_9.input[2] = func_27.outputOR;
    func_9.Execute(  );

    // [18] Function call CfMonoflop
    func_18.input = BooleanToFloat(func_9.outputAND);
    func_18.Execute( env, parameterOffset + 3 );

    // [23] Function call CfInputMultiplexer
    func_23.inputSelect = BooleanToInt(func_24.output);
    func_23.input[1-1] = BooleanToFloat(func_18.output);
    func_23.input[2-1] = BooleanToFloat(func_9.outputAND);
    func_23.Execute(  );
    CmDayExtensionHEDHW_output_4 = FloatToBoolean(func_23.output);

  }
// macro register which are written multiple times
// macro inputs
public boolean CmDayExtensionHEDHW_input_1; // DayExtension
public boolean CmDayExtensionHEDHW_input_2; // Un-OccPeriod
public boolean CmDayExtensionHEDHW_input_3; // HolidaySwitch
public float CmDayExtensionHEDHW_input_8; // DHW_TempSp
// macro outputs
public boolean CmDayExtensionHEDHW_output_4; // DayExtActiv
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfCompare1 func_16 = new CfCompare1();
protected CfMultiply func_21 = new CfMultiply();
protected CfWindow func_24 = new CfWindow();
protected CfOr func_27 = new CfOr();
protected CfAnd func_9 = new CfAnd();
protected CfMonoflop func_18 = new CfMonoflop();
protected CfInputMultiplexer func_23 = new CfInputMultiplexer();

// default constructor
public CmDayExtensionHEDHW()
{
  func_9.configure(3);
}

  public void Start()
  {
    func_18.Start();
  }
}
