/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Filtered Temperature
Macro id:      6076324634548566961
Macro version: 13
Last change:   19.12.2016 - 12:00
Access Level:  2
Inputs:
  [1] Temperature 1
  [2] Temperature 2
Outputs:
  [1] CalculateTemp
Parameter:
  [1] SYS-01: selection for SYS-02 - 0=min; 1=h
  [2] SYS-02: filter time; 0=disable
  [3] SYS-03: filter input configuration
Description:
The Macro filtered temperature is a general purpose module, which
provides a smooth filtered output from any varying analog 
input.
Typically the module can be applied to the outside air 
temperature sensor in order to eliminate sudden 
temperature variations and thus provide for a more stable
operation of the control system.

INPUTS:
  Temperature 1 =   temperature input 1                            (analog)
  Temperature 2 =   temperature input 2                            (analog)  

OUTPUTS:
  CalculateTemp = smooth filtered temperature            (analog)

PARAMETER:
  P01= for P003 0= minute / 1=hours 
  P02= filter time 0=disable
  P03= selector for calculation
             0= temp 1
             1= min Temp 
             2= max Temp
             3= average of input 1 and 2
--------------------------------------------------------------------------------------
================================================================================*/

public class CmFiltered_Temperature
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [677] Macro call CmCycle_time
    func_677.Execute( env, parameterOffset +3 );

    // [678] Function call CfMinimum
    func_678.input[0] = CmFiltered_Temperature_input_2;
    func_678.input[1] = CmFiltered_Temperature_input_3;
    func_678.Execute(  );

    // [679] Function call CfMaximum
    func_679.input[0] = CmFiltered_Temperature_input_2;
    func_679.input[1] = CmFiltered_Temperature_input_3;
    func_679.Execute(  );

    // [680] Function call CfAverage
    func_680.input[0] = CmFiltered_Temperature_input_2;
    func_680.input[1] = CmFiltered_Temperature_input_3;
    func_680.ExecuteArithmeticAverage( );
    // [682] Function call CfInputMultiplexer
    func_682.inputSelect = FloatToInt(env.getParameter(parameterOffset));
    func_682.input[1-1] = 60F;
    func_682.input[2-1] = 3600F;
    func_682.Execute(  );

    // [684] Function call CfLastValue
    func_684.input = env.getParameter(parameterOffset + 1);
    func_684.Execute(  );

    // [686] Function call CfLastValue
    func_686.input = env.getParameter(parameterOffset);
    func_686.Execute(  );

    // [689] Function call CfLastValue
    func_689.input = env.getParameter(parameterOffset + 2);
    func_689.Execute(  );

    // [697] Function call CfCompare1
    func_697.inputA = env.getParameter(parameterOffset + 1);
    func_697.inputB = 0.1F;
    func_697.Execute(  );

    // [681] Function call CfInputMultiplexer
    func_681.inputSelect = FloatToInt(env.getParameter(parameterOffset + 2));
    func_681.input[1-1] = CmFiltered_Temperature_input_2;
    func_681.input[2-1] = func_678.output;
    func_681.input[3-1] = func_679.output;
    func_681.input[4-1] = func_680.outputA;
    func_681.Execute(  );

    // [683] Function call CfMultiply
    func_683.input[0] = func_682.output;
    func_683.input[1] = env.getParameter(parameterOffset + 1);
    func_683.Execute(  );

    // [685] Function call CfCompare1
    func_685.inputA = func_684.outputCurrent;
    func_685.inputB = func_684.outputLast;
    func_685.Execute(  );

    // [687] Function call CfSubtract
    func_687.input[0] = func_686.outputCurrent;
    func_687.input[1] = func_686.outputLast;
    func_687.Execute(  );

    // [690] Function call CfSubtract
    func_690.input[0] = func_689.outputCurrent;
    func_690.input[1] = func_689.outputLast;
    func_690.Execute(  );

    // [693] Function call CfAddition
    func_693.input[0] = func_677.CmCycle_time_output_13;
    func_693.input[1] = 2F;
    func_693.Execute(  );

    // [688] Function call CfAbsolute
    func_688.input = func_687.output;
    func_688.Execute(  );

    // [691] Function call CfAbsolute
    func_691.input = func_690.output;
    func_691.Execute(  );

    // [694] Function call CfIdt
    func_694.input = func_693.output;
    func_694.Execute(  );
    env.setParameter(parameterOffset + 5, func_694.output[0]);

    // [692] Function call CfOr
    func_692.input[0] = func_685.outputGreater;
    func_692.input[1] = func_685.outputLess;
    func_692.input[2] = FloatToBoolean(func_688.outputAbs);
    func_692.input[3] = FloatToBoolean(func_691.outputAbs);
    func_692.input[4] = func_772.outputGreater;
    func_692.input[5] = func_772.outputLess;
    func_692.Execute(  );

    // [695] Function call CfMonoflop
    func_695.input = BooleanToFloat(func_692.outputOR);
    func_695.Execute( env, parameterOffset + 5 );

    // [696] Function call CfLastValue
    func_696.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_696.Execute(  );

    // [772] Function call CfCompare1
    func_772.inputA = func_696.outputCurrent;
    func_772.inputB = func_696.outputLast;
    func_772.Execute(  );

    // [698] Function call CfOr
    func_698.input[0] = func_695.output;
    func_698.input[1] = func_697.outputLess;
    func_698.Execute(  );

    // [699] Function call CfInputMultiplexer
    func_699.inputSelect = BooleanToInt(func_698.outputOR);
    func_699.input[1-1] = func_683.output;
    func_699.input[2-1] = func_677.CmCycle_time_output_13;
    func_699.Execute(  );

    // [700] Function call CfIdt
    func_700.input = func_699.output;
    func_700.Execute(  );
    env.setParameter(parameterOffset + 6, func_700.output[0]);

    // [701] Function call CfSubtract
    func_701.input[0] = func_681.output;
    func_701.input[1] = CmFiltered_Temperature_output_4;
    func_701.Execute(  );

    // [702] Function call CfIntegral
    func_702.inputX = func_701.output;
    func_702.inputMax = 100F;
    func_702.Execute( env, parameterOffset + 6 );
    CmFiltered_Temperature_output_4 = func_702.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmFiltered_Temperature_input_2; // Temperature 1
public float CmFiltered_Temperature_input_3; // Temperature 2
// macro outputs
public float CmFiltered_Temperature_output_4; // CalculateTemp
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CmCycle_time func_677 = new CmCycle_time();
protected CfMinimum func_678 = new CfMinimum();
protected CfMaximum func_679 = new CfMaximum();
protected CfAverage func_680 = new CfAverage();
protected CfInputMultiplexer func_682 = new CfInputMultiplexer();
protected CfLastValue func_684 = new CfLastValue();
protected CfLastValue func_686 = new CfLastValue();
protected CfLastValue func_689 = new CfLastValue();
protected CfCompare1 func_697 = new CfCompare1();
protected CfInputMultiplexer func_681 = new CfInputMultiplexer();
protected CfMultiply func_683 = new CfMultiply();
protected CfCompare1 func_685 = new CfCompare1();
protected CfSubtract func_687 = new CfSubtract();
protected CfSubtract func_690 = new CfSubtract();
protected CfAddition func_693 = new CfAddition();
protected CfAbsolute func_688 = new CfAbsolute();
protected CfAbsolute func_691 = new CfAbsolute();
protected CfIdt func_694 = new CfIdt();
protected CfOr func_692 = new CfOr();
protected CfMonoflop func_695 = new CfMonoflop();
protected CfLastValue func_696 = new CfLastValue();
protected CfCompare1 func_772 = new CfCompare1();
protected CfOr func_698 = new CfOr();
protected CfInputMultiplexer func_699 = new CfInputMultiplexer();
protected CfIdt func_700 = new CfIdt();
protected CfSubtract func_701 = new CfSubtract();
protected CfIntegral func_702 = new CfIntegral();

// default constructor
public CmFiltered_Temperature()
{
  func_681.configure(5);
  func_692.configure(6);
}

  public void Start()
  {
    func_677.Start();
    func_684.Start();
    func_686.Start();
    func_689.Start();
    func_695.Start();
    func_696.Start();
    func_702.Start();
  }
}
