/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    HeatDemandHE/DHW
Macro id:      6017727612471739238
Macro version: 10
Last change:   25.06.2014 - 08:04
Access Level:  2
Inputs:
  [1] CalcDHW_Sp
  [2] OperationMode
  [3] DayExtension
  [4] CircPumpEnable
Outputs:
  [1] CalcHtgDemand
Parameter:
  [1] SYS-01: heat demand transmission
  [2] SYS-03: autmatic/ manual reset
  [3] SST-04: setpoint raise to compensate losses
Description:

================================================================================*/

public class CmHeatDemandHEDHW
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [9] Function call CfWindow
    func_9.inputValue = env.getParameter(parameterOffset);
    func_9.inputMinimum = -0.8F;
    func_9.inputMaximum = 0.2F;
    func_9.Execute(  );

    // [13] Function call CfWindow
    func_13.inputValue = env.getParameter(parameterOffset);
    func_13.inputMinimum = 0.8F;
    func_13.inputMaximum = 1.2F;
    func_13.Execute(  );

    // [42] Function call CfWindow
    func_42.inputValue = env.getParameter(parameterOffset);
    func_42.inputMinimum = 1.8F;
    func_42.inputMaximum = 2.2F;
    func_42.Execute(  );

    // [44] Function call CfAddition
    func_44.input[0] = CmHeatDemandHEDHW_input_1;
    func_44.input[1] = env.getParameter(parameterOffset + 2);
    func_44.Execute(  );

    // [68] Function call CfWindow
    func_68.inputValue = CmHeatDemandHEDHW_input_50;
    func_68.inputMinimum = 1.8F;
    func_68.inputMaximum = 4.2F;
    func_68.Execute(  );

    // [89] Function call CfWindow
    func_89.inputValue = CmHeatDemandHEDHW_input_50;
    func_89.inputMinimum = 8.8F;
    func_89.inputMaximum = 9.2F;
    func_89.Execute(  );

    // [97] Function call CfWindow
    func_97.inputValue = env.getParameter(parameterOffset + 1);
    func_97.inputMinimum = -0.2F;
    func_97.inputMaximum = 0.2F;
    func_97.Execute(  );

    // [115] Function call CfWindow
    func_115.inputValue = CmHeatDemandHEDHW_input_50;
    func_115.inputMinimum = 9.8F;
    func_115.inputMaximum = 10.2F;
    func_115.Execute(  );

    // [23] Function call CfAnd
    func_23.input[0] = func_13.output;
    func_23.input[1] = CmHeatDemandHEDHW_input_112;
    func_23.Execute(  );

    // [91] Function call CfAnd
    func_91.input[0] = func_89.output;
    func_91.input[1] = func_97.output;
    func_91.Execute(  );

    // [64] Function call CfOr
    func_64.input[0] = func_68.output;
    func_64.input[1] = func_115.output;
    func_64.input[2] = func_91.outputAND;
    func_64.input[3] = CmHeatDemandHEDHW_input_71;
    func_64.Execute(  );

    // [52] Function call CfAnd
    func_52.input[0] = func_42.output;
    func_52.input[1] = func_64.outputOR;
    func_52.Execute(  );

    // [129] Function call CfOr
    func_129.input[0] = func_23.outputAND;
    func_129.input[1] = func_52.outputAND;
    func_129.Execute(  );

    // [43] Function call CfInputMultiplexer
    func_43.inputSelect = BooleanToInt(func_129.outputOR);
    func_43.input[1-1] = 0F;
    func_43.input[2-1] = func_44.output;
    func_43.Execute(  );

    // [11] Function call CfInputMultiplexer
    func_11.inputSelect = BooleanToInt(func_9.output);
    func_11.input[1-1] = func_43.output;
    func_11.input[2-1] = 0F;
    func_11.Execute(  );
    CmHeatDemandHEDHW_output_3 = func_11.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmHeatDemandHEDHW_input_1; // CalcDHW_Sp
public float CmHeatDemandHEDHW_input_50; // OperationMode
public boolean CmHeatDemandHEDHW_input_71; // DayExtension
public boolean CmHeatDemandHEDHW_input_112; // CircPumpEnable
// macro outputs
public float CmHeatDemandHEDHW_output_3; // CalcHtgDemand
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfWindow func_9 = new CfWindow();
protected CfWindow func_13 = new CfWindow();
protected CfWindow func_42 = new CfWindow();
protected CfAddition func_44 = new CfAddition();
protected CfWindow func_68 = new CfWindow();
protected CfWindow func_89 = new CfWindow();
protected CfWindow func_97 = new CfWindow();
protected CfWindow func_115 = new CfWindow();
protected CfAnd func_23 = new CfAnd();
protected CfAnd func_91 = new CfAnd();
protected CfOr func_64 = new CfOr();
protected CfAnd func_52 = new CfAnd();
protected CfOr func_129 = new CfOr();
protected CfInputMultiplexer func_43 = new CfInputMultiplexer();
protected CfInputMultiplexer func_11 = new CfInputMultiplexer();

// default constructor
public CmHeatDemandHEDHW()
{
  func_64.configure(4);
}

  public void Start()
  {
  }
}
