/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    HeatDemand_DHA/DHW
Macro id:      5982094521720111471
Macro version: 16
Last change:   03.06.2014 - 14:30
Access Level:  2
Inputs:
  [1] CalcDHW_Sp
  [2] RenEnergCharge
  [3] ContinuousCntr
  [4] On/OffCntr
  [5] OperationMode
  [6] DayExtension
Outputs:
  [1] CalcHtgDemand
Parameter:
  [1] SST-01: temp. diffence primary/ secondary system
  [2] SST-03: heat demand setpoint shift
  [3] SYS-05: heat demand transmission
  [4] SYS-06: autmatic/ manual reset
Description:

================================================================================*/

public class CmHeatDemand_DHADHW
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [9] Function call CfWindow
    func_9.inputValue = env.getParameter(parameterOffset + 2);
    func_9.inputMinimum = -0.8F;
    func_9.inputMaximum = 0.2F;
    func_9.Execute(  );

    // [13] Function call CfWindow
    func_13.inputValue = env.getParameter(parameterOffset + 2);
    func_13.inputMinimum = 0.8F;
    func_13.inputMaximum = 1.2F;
    func_13.Execute(  );

    // [19] Function call CfInputMultiplexer
    func_19.inputSelect = BooleanToInt(CmHeatDemand_DHADHW_input_2);
    func_19.input[1-1] = 0F;
    func_19.input[2-1] = env.getParameter(parameterOffset + 1);
    func_19.Execute(  );

    // [32] Function call CfHysteresis
    func_32.inputX = CmHeatDemand_DHADHW_input_7;
    func_32.inputW = 3F;
    func_32.Execute( env, parameterOffset + 4 );

    // [42] Function call CfWindow
    func_42.inputValue = env.getParameter(parameterOffset + 2);
    func_42.inputMinimum = 1.8F;
    func_42.inputMaximum = 2.2F;
    func_42.Execute(  );

    // [44] Function call CfAddition
    func_44.input[0] = CmHeatDemand_DHADHW_input_1;
    func_44.input[1] = env.getParameter(parameterOffset);
    func_44.Execute(  );

    // [68] Function call CfWindow
    func_68.inputValue = CmHeatDemand_DHADHW_input_50;
    func_68.inputMinimum = 1.8F;
    func_68.inputMaximum = 2.2F;
    func_68.Execute(  );

    // [89] Function call CfWindow
    func_89.inputValue = CmHeatDemand_DHADHW_input_50;
    func_89.inputMinimum = 8.8F;
    func_89.inputMaximum = 9.2F;
    func_89.Execute(  );

    // [97] Function call CfWindow
    func_97.inputValue = env.getParameter(parameterOffset + 3);
    func_97.inputMinimum = -0.2F;
    func_97.inputMaximum = 0.2F;
    func_97.Execute(  );

    // [113] Function call CfWindow
    func_113.inputValue = CmHeatDemand_DHADHW_input_50;
    func_113.inputMinimum = 5.8F;
    func_113.inputMaximum = 7.2F;
    func_113.Execute(  );

    // [116] Function call CfWindow
    func_116.inputValue = CmHeatDemand_DHADHW_input_50;
    func_116.inputMinimum = 8.8F;
    func_116.inputMaximum = 10.2F;
    func_116.Execute(  );

    // [29] Function call CfOr
    func_29.input[0] = func_32.output1;
    func_29.input[1] = CmHeatDemand_DHADHW_input_8;
    func_29.Execute(  );

    // [91] Function call CfAnd
    func_91.input[0] = func_89.output;
    func_91.input[1] = func_97.output;
    func_91.Execute(  );

    // [23] Function call CfAnd
    func_23.input[0] = func_13.output;
    func_23.input[1] = func_29.outputOR;
    func_23.Execute(  );

    // [64] Function call CfOr
    func_64.input[0] = func_68.output;
    func_64.input[1] = func_113.output;
    func_64.input[2] = func_116.output;
    func_64.input[3] = func_91.outputAND;
    func_64.input[4] = CmHeatDemand_DHADHW_input_71;
    func_64.Execute(  );

    // [52] Function call CfAnd
    func_52.input[0] = func_42.output;
    func_52.input[1] = func_64.outputOR;
    func_52.Execute(  );

    // [43] Function call CfInputMultiplexer
    func_43.inputSelect = BooleanToInt(func_52.outputAND);
    func_43.input[1-1] = 0F;
    func_43.input[2-1] = func_44.output;
    func_43.Execute(  );

    // [14] Function call CfInputMultiplexer
    func_14.inputSelect = BooleanToInt(func_23.outputAND);
    func_14.input[1-1] = func_43.output;
    func_14.input[2-1] = func_44.output;
    func_14.Execute(  );

    // [18] Function call CfSubtract
    func_18.input[0] = func_14.output;
    func_18.input[1] = func_19.output;
    func_18.Execute(  );

    // [11] Function call CfInputMultiplexer
    func_11.inputSelect = BooleanToInt(func_9.output);
    func_11.input[1-1] = func_18.output;
    func_11.input[2-1] = 0F;
    func_11.Execute(  );
    CmHeatDemand_DHADHW_output_3 = func_11.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmHeatDemand_DHADHW_input_1; // CalcDHW_Sp
public boolean CmHeatDemand_DHADHW_input_2; // RenEnergCharge
public float CmHeatDemand_DHADHW_input_7; // ContinuousCntr
public boolean CmHeatDemand_DHADHW_input_8; // On/OffCntr
public float CmHeatDemand_DHADHW_input_50; // OperationMode
public boolean CmHeatDemand_DHADHW_input_71; // DayExtension
// macro outputs
public float CmHeatDemand_DHADHW_output_3; // CalcHtgDemand
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfWindow func_9 = new CfWindow();
protected CfWindow func_13 = new CfWindow();
protected CfInputMultiplexer func_19 = new CfInputMultiplexer();
protected CfHysteresis func_32 = new CfHysteresis();
protected CfWindow func_42 = new CfWindow();
protected CfAddition func_44 = new CfAddition();
protected CfWindow func_68 = new CfWindow();
protected CfWindow func_89 = new CfWindow();
protected CfWindow func_97 = new CfWindow();
protected CfWindow func_113 = new CfWindow();
protected CfWindow func_116 = new CfWindow();
protected CfOr func_29 = new CfOr();
protected CfAnd func_91 = new CfAnd();
protected CfAnd func_23 = new CfAnd();
protected CfOr func_64 = new CfOr();
protected CfAnd func_52 = new CfAnd();
protected CfInputMultiplexer func_43 = new CfInputMultiplexer();
protected CfInputMultiplexer func_14 = new CfInputMultiplexer();
protected CfSubtract func_18 = new CfSubtract();
protected CfInputMultiplexer func_11 = new CfInputMultiplexer();

// default constructor
public CmHeatDemand_DHADHW()
{
  func_64.configure(5);
}

  public void Start()
  {
    func_32.Start();
  }
}
