/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    HeatGenDemand
Macro id:      6026148093653680384
Macro version: 49
Last change:   08.12.2016 - 10:21
Access Level:  2
Inputs:
  [1] DemandIn
  [2] SupplyTemp
  [3] SupRetTemp
  [4] Outside Air Temp
  [5] MaxRedBoiler
  [6] leadingGroup
Outputs:
  [1] PIout
  [2] HeatGenDemand
  [3] DISP-04: calc time reach setp
  [4] DISP-05: exp sys sup temp
  [5] CalcSetpoint
Parameter:
  [1] CFG-01: control mode configuration
  [2] SST-01: minimum supply temperature
  [3] SST-02: maximum supply temperature
  [4] SST-03: setpoint raise
  [5] SST-04: maximum setpoint increment per minute
  [6] SST-06: P-band following stages control
  [7] SST-07: I-time following stages control
  [8] SST-08: forward time expected system supply temperature
  [9] SST-09: time to reach setpoint
  [10] SST-10: control region following stages
  [11] SST-11: temperature span switching on boilers
  [12] SST-12: temperature span switching off boilers
  [13] OAT-01: low limit outside air temperature to enable the next boiler
  [14] OAT-02: high limit outside air temperature to disable the next boiler
  [15] OVR-01: high limit control deviation to enable the next boiler
  [16] OVR-02: low limit control deviation to disable the next boiler
  [17] OVR-03: switch on delay overrides
  [18] OVR-04: switch off delay overrides
  [19] SST-05: mini heat demand to start heat gen
Description:

================================================================================*/

public class CmHeatGenDemand
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [39] Macro call CmIDT05
    func_39.CmIDT05_input_1 = env.getParameter(parameterOffset + 1);
    func_39.CmIDT05_input_2 = env.getParameter(parameterOffset + 2);
    func_39.CmIDT05_input_3 = env.getParameter(parameterOffset + 3);
    func_39.CmIDT05_input_4 = env.getParameter(parameterOffset + 4);
    func_39.CmIDT05_input_5 = env.getParameter(parameterOffset + 18);
    func_39.Execute(  );
    env.setParameter(parameterOffset + 19, func_39.CmIDT05_output_21);
    env.setParameter(parameterOffset + 20, func_39.CmIDT05_output_22);
    env.setParameter(parameterOffset + 21, func_39.CmIDT05_output_23);
    env.setParameter(parameterOffset + 22, func_39.CmIDT05_output_24);
    env.setParameter(parameterOffset + 23, func_39.CmIDT05_output_25);

    // [81] Macro call CmIDT05
    func_81.CmIDT05_input_1 = env.getParameter(parameterOffset + 12);
    func_81.CmIDT05_input_2 = env.getParameter(parameterOffset + 13);
    func_81.CmIDT05_input_3 = env.getParameter(parameterOffset + 14);
    func_81.CmIDT05_input_4 = env.getParameter(parameterOffset + 15);
    func_81.CmIDT05_input_5 = env.getParameter(parameterOffset + 16);
    func_81.Execute(  );
    env.setParameter(parameterOffset + 44, func_81.CmIDT05_output_21);
    env.setParameter(parameterOffset + 45, func_81.CmIDT05_output_22);
    env.setParameter(parameterOffset + 46, func_81.CmIDT05_output_23);
    env.setParameter(parameterOffset + 47, func_81.CmIDT05_output_24);
    env.setParameter(parameterOffset + 48, func_81.CmIDT05_output_25);

    // [30] Macro call CmIDT10
    func_30.CmIDT10_input_1 = env.getParameter(parameterOffset);
    func_30.CmIDT10_input_2 = env.getParameter(parameterOffset + 5);
    func_30.CmIDT10_input_3 = env.getParameter(parameterOffset + 6);
    func_30.CmIDT10_input_4 = env.getParameter(parameterOffset + 7);
    func_30.CmIDT10_input_5 = env.getParameter(parameterOffset + 8);
    func_30.CmIDT10_input_6 = env.getParameter(parameterOffset + 9);
    func_30.CmIDT10_input_7 = env.getParameter(parameterOffset + 10);
    func_30.CmIDT10_input_8 = env.getParameter(parameterOffset + 11);
    func_30.CmIDT10_input_9 = env.getParameter(parameterOffset + 1);
    func_30.CmIDT10_input_10 = env.getParameter(parameterOffset + 17);
    func_30.Execute(  );
    env.setParameter(parameterOffset + 27, func_30.CmIDT10_output_21);
    env.setParameter(parameterOffset + 25, func_30.CmIDT10_output_22);
    env.setParameter(parameterOffset + 26, func_30.CmIDT10_output_23);
    env.setParameter(parameterOffset + 33, func_30.CmIDT10_output_24);
    env.setParameter(parameterOffset + 34, func_30.CmIDT10_output_25);
    env.setParameter(parameterOffset + 41, func_30.CmIDT10_output_26);
    env.setParameter(parameterOffset + 42, func_30.CmIDT10_output_27);
    env.setParameter(parameterOffset + 43, func_30.CmIDT10_output_28);
    env.setParameter(parameterOffset + 35, func_30.CmIDT10_output_29);
    env.setParameter(parameterOffset + 49, func_30.CmIDT10_output_30);

    // [143] Function call CfIdt
    func_143.input = env.getParameter(parameterOffset + 2);
    func_143.Execute(  );
    env.setParameter(parameterOffset + 36, func_143.output[0]);

    // [7] Macro call Cmsetpoint_calculation_with_ramp
    func_7.Cmsetpoint_calculation_with_ramp_input_1 = CmHeatGenDemand_input_1;
    func_7.Cmsetpoint_calculation_with_ramp_input_56 = CmHeatGenDemand_input_91;
    func_7.Execute( env, parameterOffset +19 );

    // [23] Macro call Cmtemperature_control
    func_23.Cmtemperature_control_input_1 = func_7.Cmsetpoint_calculation_with_ramp_output_2;
    func_23.Cmtemperature_control_input_16 = CmHeatGenDemand_input_2;
    func_23.Cmtemperature_control_input_17 = CmHeatGenDemand_input_3;
    func_23.Execute( env, parameterOffset +25 );

    // [28] Macro call Cmforward_time_calculation
    func_28.Cmforward_time_calculation_input_1 = func_7.Cmsetpoint_calculation_with_ramp_output_2;
    func_28.Cmforward_time_calculation_input_2 = func_23.Cmtemperature_control_output_56;
    func_28.Execute( env, parameterOffset +33 );
    CmHeatGenDemand_output_48 = func_28.Cmforward_time_calculation_output_72;
    CmHeatGenDemand_output_49 = func_28.Cmforward_time_calculation_output_73;

    // [26] Macro call Cmheat_generator_demand
    func_26.Cmheat_generator_demand_input_2 = func_7.Cmsetpoint_calculation_with_ramp_output_2;
    func_26.Cmheat_generator_demand_input_1 = func_23.Cmtemperature_control_output_56;
    func_26.Cmheat_generator_demand_input_84 = func_28.Cmforward_time_calculation_output_19;
    func_26.Execute( env, parameterOffset +41 );

    // [51] Function call CfIdt
    func_51.input = func_7.Cmsetpoint_calculation_with_ramp_output_2;
    func_51.Execute(  );
    CmHeatGenDemand_output_50 = func_51.output[0];

    // [70] Function call CfSubtract
    func_70.input[0] = func_7.Cmsetpoint_calculation_with_ramp_output_2;
    func_70.input[1] = func_23.Cmtemperature_control_output_56;
    func_70.Execute(  );

    // [56] Function call CfWrGlobalRegister
    func_56.inputValue = func_7.Cmsetpoint_calculation_with_ramp_output_2;
    func_56.inputRegister = 974;
    func_56.inputEnable = true;
    func_56.inputMode = 0;
    func_56.Execute(  );

    // [57] Function call CfWrGlobalRegister
    func_57.inputValue = func_23.Cmtemperature_control_output_2;
    func_57.inputRegister = 1008;
    func_57.inputEnable = true;
    func_57.inputMode = 0;
    func_57.Execute(  );

    // [61] Function call CfIdt
    func_61.input = func_23.Cmtemperature_control_output_2;
    func_61.Execute(  );
    CmHeatGenDemand_output_4 = func_61.output[0];

    // [87] Macro call CmCntInSequence
    func_87.CmCntInSequence_input_3 = CmHeatGenDemand_input_90;
    func_87.CmCntInSequence_input_23 = CmHeatGenDemand_input_91;
    func_87.Execute(  );

    // [62] Macro call CmRedundantCmd
    func_62.CmRedundantCmd_input_22 = CmHeatGenDemand_input_67;
    func_62.CmRedundantCmd_input_23 = func_70.output;
    func_62.Execute( env, parameterOffset +44 );

    // [123] Function call CfWrGlobalRegister
    func_123.inputValue = func_62.CmRedundantCmd_output_99;
    func_123.inputRegister = 970;
    func_123.inputEnable = true;
    func_123.inputMode = 0;
    func_123.Execute(  );

    // [101] Function call CfNot
    func_101.input = ControlFunction.GetStartupFlag();
    func_101.Execute(  );

    // [102] Function call CfDelay
    func_102.inputA = func_101.output;
    func_102.inputB = func_101.output;
    func_102.Execute( env, parameterOffset + 62 );

    // [98] Function call CfInputMultiplexer
    func_98.inputSelect = BooleanToInt(func_102.outputDelayedA);
    func_98.input[1-1] = -2F;
    func_98.input[2-1] = func_26.Cmheat_generator_demand_output_3;
    func_98.Execute(  );

    // [129] Macro call CmDemandDelay
    func_129.CmDemandDelay_input_1 = func_98.output;
    func_129.Execute(  );

    // [135] Macro call CmRead_Group_Register
    func_135.CmRead_Group_Register_input_2 = CmHeatGenDemand_input_91;
    func_135.CmRead_Group_Register_input_53 = 998F;
    func_135.Execute(  );

    // [131] Function call CfCompare1
    func_131.inputA = func_135.CmRead_Group_Register_output_31;
    func_131.inputB = 0F;
    func_131.Execute(  );

    // [139] Function call CfInputMultiplexer
    func_139.inputSelect = BooleanToInt(func_131.outputEqual);
    func_139.input[1-1] = 0F;
    func_139.input[2-1] = func_129.CmDemandDelay_output_15;
    func_139.Execute(  );
    CmHeatGenDemand_output_5 = func_139.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmHeatGenDemand_input_1; // DemandIn
public float CmHeatGenDemand_input_2; // SupplyTemp
public float CmHeatGenDemand_input_3; // SupRetTemp
public float CmHeatGenDemand_input_67; // Outside Air Temp
public float CmHeatGenDemand_input_90; // MaxRedBoiler
public float CmHeatGenDemand_input_91; // leadingGroup
// macro outputs
public float CmHeatGenDemand_output_4; // PIout
public float CmHeatGenDemand_output_5; // HeatGenDemand
public float CmHeatGenDemand_output_48; // DISP-04: calc time reach setp
public float CmHeatGenDemand_output_49; // DISP-05: exp sys sup temp
public float CmHeatGenDemand_output_50; // CalcSetpoint
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CmIDT05 func_39 = new CmIDT05();
protected CmIDT05 func_81 = new CmIDT05();
protected CmIDT10 func_30 = new CmIDT10();
protected CfIdt func_143 = new CfIdt();
protected Cmsetpoint_calculation_with_ramp func_7 = new Cmsetpoint_calculation_with_ramp();
protected Cmtemperature_control func_23 = new Cmtemperature_control();
protected Cmforward_time_calculation func_28 = new Cmforward_time_calculation();
protected Cmheat_generator_demand func_26 = new Cmheat_generator_demand();
protected CfIdt func_51 = new CfIdt();
protected CfSubtract func_70 = new CfSubtract();
protected CfWrGlobalRegister func_56 = new CfWrGlobalRegister();
protected CfWrGlobalRegister func_57 = new CfWrGlobalRegister();
protected CfIdt func_61 = new CfIdt();
protected CmCntInSequence func_87 = new CmCntInSequence();
protected CmRedundantCmd func_62 = new CmRedundantCmd();
protected CfWrGlobalRegister func_123 = new CfWrGlobalRegister();
protected CfNot func_101 = new CfNot();
protected CfDelay func_102 = new CfDelay();
protected CfInputMultiplexer func_98 = new CfInputMultiplexer();
protected CmDemandDelay func_129 = new CmDemandDelay();
protected CmRead_Group_Register func_135 = new CmRead_Group_Register();
protected CfCompare1 func_131 = new CfCompare1();
protected CfInputMultiplexer func_139 = new CfInputMultiplexer();

// default constructor
public CmHeatGenDemand()
{
}

  public void Start()
  {
    func_39.Start();
    func_81.Start();
    func_30.Start();
    func_7.Start();
    func_23.Start();
    func_28.Start();
    func_26.Start();
    func_87.Start();
    func_62.Start();
    func_102.Start();
    func_129.Start();
    func_135.Start();
  }
}
