/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    LegTempFailedAlm
Macro id:      5982125215672434997
Macro version: 6
Last change:   19.02.2014 - 16:22
Access Level:  2
Inputs:
  [1] Setpoint
  [2] ActualValue
  [3] AutoReset
  [4] ManReset
  [5] Enable
Outputs:
  [1] LegTempAlm
Parameter:
  [1] LEG-02: time to reach legionella setpoint
  [2] SYS-06: automatic/ manual reset
Description:

================================================================================*/

public class CmLegTempFailedAlm
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [3] Function call CfIdt
    func_3.input = env.getParameter(parameterOffset);
    func_3.Execute(  );
    env.setParameter(parameterOffset + 3, func_3.output[0]);

    // [4] Function call CfCompare1
    func_4.inputA = CmLegTempFailedAlm_input_28;
    func_4.inputB = CmLegTempFailedAlm_input_27;
    func_4.Execute(  );

    // [5] Function call CfCompare1
    func_5.inputA = env.getParameter(parameterOffset);
    func_5.inputB = 0.5F;
    func_5.Execute(  );

    // [38] Function call CfMonoflop
    func_38.input = BooleanToFloat(CmLegTempFailedAlm_input_30);
    func_38.Execute( env, parameterOffset + 2 );

    // [6] Function call CfAnd
    func_6.input[0] = func_4.outputLess;
    func_6.input[1] = CmLegTempFailedAlm_input_29;
    func_6.input[2] = func_5.outputGreater;
    func_6.Execute(  );

    // [40] Function call CfDelayOnOff
    func_40.input = func_6.outputAND;
    func_40.Execute( env, parameterOffset + 3 );

    // [8] Function call CfJkFlipFlop
    func_8.inputSet = func_40.output;
    func_8.inputClock = false;
    func_8.inputReset = CmLegTempFailedAlm_input_32;
    func_8.Execute(  );

    // [33] Function call CfJkFlipFlop
    func_33.inputSet = func_40.output;
    func_33.inputClock = false;
    func_33.inputReset = func_38.output;
    func_33.Execute(  );

    // [9] Function call CfInputMultiplexer
    func_9.inputSelect = FloatToInt(env.getParameter(parameterOffset + 1));
    func_9.input[1-1] = BooleanToFloat(func_33.output);
    func_9.input[2-1] = BooleanToFloat(func_8.output);
    func_9.Execute(  );
    CmLegTempFailedAlm_output_31 = FloatToBoolean(func_9.output);

  }
// macro register which are written multiple times
// macro inputs
public float CmLegTempFailedAlm_input_27; // Setpoint
public float CmLegTempFailedAlm_input_28; // ActualValue
public boolean CmLegTempFailedAlm_input_30; // AutoReset
public boolean CmLegTempFailedAlm_input_32; // ManReset
public boolean CmLegTempFailedAlm_input_29; // Enable
// macro outputs
public boolean CmLegTempFailedAlm_output_31; // LegTempAlm
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfIdt func_3 = new CfIdt();
protected CfCompare1 func_4 = new CfCompare1();
protected CfCompare1 func_5 = new CfCompare1();
protected CfMonoflop func_38 = new CfMonoflop();
protected CfAnd func_6 = new CfAnd();
protected CfDelayOnOff func_40 = new CfDelayOnOff();
protected CfJkFlipFlop func_8 = new CfJkFlipFlop();
protected CfJkFlipFlop func_33 = new CfJkFlipFlop();
protected CfInputMultiplexer func_9 = new CfInputMultiplexer();

// default constructor
public CmLegTempFailedAlm()
{
  func_6.configure(3);
}

  public void Start()
  {
    func_38.Start();
    func_40.Start();
    func_8.Start();
    func_33.Start();
  }
}
