/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    LegionellaProt
Macro id:      5982108421220991019
Macro version: 21
Last change:   25.06.2014 - 10:53
Access Level:  2
Inputs:
  [1] UnOccPeriod
  [2] DayExtension
  [3] LegProtEnabled
  [4] UpperTemp
  [5] LowerTemp
  [6] Reset
Outputs:
  [1] LegProtActiv
  [2] DHWS_Leg_Alm
Parameter:
  [1] UWT-01: P-band buffer temperature control
  [2] LEG-01: anti-legionella setpoint
  [3] LEG-02: time to reach legionella setpoint
  [4] LEG-03: legionella duration
  [5] SYS-06: automatic/ manual reset
Description:

================================================================================*/

public class CmLegionellaProt
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [19] Function call CfNot
    func_19.input = CmLegionellaProt_input_2;
    func_19.Execute(  );

    // [41] Function call CfDivide
    func_41.inputA = env.getParameter(parameterOffset);
    func_41.inputB = 2F;
    func_41.Execute(  );

    // [48] Function call CfIdt
    func_48.input = env.getParameter(parameterOffset + 3);
    func_48.Execute(  );
    env.setParameter(parameterOffset + 6, func_48.output[0]);

    // [71] Function call CfIdt
    func_71.input = env.getParameter(parameterOffset + 2);
    func_71.Execute(  );
    env.setParameter(parameterOffset + 8, func_71.output[0]);
    env.setParameter(parameterOffset + 13, func_71.output[1]);

    // [72] Function call CfIdt
    func_72.input = env.getParameter(parameterOffset + 4);
    func_72.Execute(  );
    env.setParameter(parameterOffset + 9, func_72.output[0]);
    env.setParameter(parameterOffset + 14, func_72.output[1]);

    // [119] Function call CfNot
    func_119.input = CmLegionellaProt_input_1;
    func_119.Execute(  );

    // [121] Function call CfMonoflop
    func_121.input = BooleanToFloat(CmLegionellaProt_input_3);
    func_121.Execute( env, parameterOffset + 5 );

    // [145] Function call CfWindow
    func_145.inputValue = env.getParameter(parameterOffset + 4);
    func_145.inputMinimum = 0.8F;
    func_145.inputMaximum = 1.2F;
    func_145.Execute(  );

    // [40] Function call CfSubtract
    func_40.input[0] = env.getParameter(parameterOffset + 1);
    func_40.input[1] = func_41.output;
    func_40.Execute(  );

    // [115] Function call CfOr
    func_115.input[0] = CmLegionellaProt_input_2;
    func_115.input[1] = func_119.output;
    func_115.Execute(  );

    // [26] Function call CfCompare1
    func_26.inputA = CmLegionellaProt_input_5;
    func_26.inputB = func_40.output;
    func_26.Execute(  );

    // [29] Function call CfCompare1
    func_29.inputA = CmLegionellaProt_input_6;
    func_29.inputB = func_40.output;
    func_29.Execute(  );

    // [44] Function call CfAnd
    func_44.input[0] = func_26.outputGreater;
    func_44.input[1] = func_29.outputGreater;
    func_44.Execute(  );

    // [14] Function call CfAnd
    func_14.input[0] = CmLegionellaProt_input_1;
    func_14.input[1] = func_19.output;
    func_14.input[2] = func_22.output;
    func_14.Execute(  );
    CmLegionellaProt_output_4 = func_14.outputAND;

    // [54] Function call CfInputMultiplexer
    func_54.inputSelect = BooleanToInt(CmLegionellaProt_output_4);
    func_54.input[1-1] = 0F;
    func_54.input[2-1] = BooleanToFloat(func_44.outputAND);
    func_54.Execute(  );

    // [94] Function call CfAnd
    func_94.input[0] = CmLegionellaProt_output_4;
    func_94.input[1] = func_115.outputOR;
    func_94.Execute(  );

    // [46] Function call CfDelayOnOff
    func_46.input = FloatToBoolean(func_54.output);
    func_46.Execute( env, parameterOffset + 6 );

    // [155] Function call CfOr
    func_155.input[0] = func_112.output;
    func_155.input[1] = CmLegionellaProt_input_80;
    func_155.Execute(  );

    // [74] Macro call CmLegTempFailedAlm
    func_74.CmLegTempFailedAlm_input_27 = func_40.output;
    func_74.CmLegTempFailedAlm_input_28 = CmLegionellaProt_input_6;
    func_74.CmLegTempFailedAlm_input_30 = func_155.outputOR;
    func_74.CmLegTempFailedAlm_input_32 = CmLegionellaProt_input_80;
    func_74.CmLegTempFailedAlm_input_29 = CmLegionellaProt_output_4;
    func_74.Execute( env, parameterOffset +8 );

    // [78] Macro call CmLegTempFailedAlm
    func_78.CmLegTempFailedAlm_input_27 = func_40.output;
    func_78.CmLegTempFailedAlm_input_28 = CmLegionellaProt_input_5;
    func_78.CmLegTempFailedAlm_input_30 = func_155.outputOR;
    func_78.CmLegTempFailedAlm_input_32 = CmLegionellaProt_input_80;
    func_78.CmLegTempFailedAlm_input_29 = CmLegionellaProt_output_4;
    func_78.Execute( env, parameterOffset +13 );

    // [84] Function call CfOr
    func_84.input[0] = func_74.CmLegTempFailedAlm_output_31;
    func_84.input[1] = func_78.CmLegTempFailedAlm_output_31;
    func_84.Execute(  );
    CmLegionellaProt_output_8 = func_84.outputOR;

    // [95] Function call CfOr
    func_95.input[0] = func_94.outputAND;
    func_95.input[1] = CmLegionellaProt_output_8;
    func_95.input[2] = func_46.output;
    func_95.Execute(  );

    // [108] Function call CfAnd
    func_108.input[0] = CmLegionellaProt_output_8;
    func_108.input[1] = CmLegionellaProt_output_4;
    func_108.Execute(  );

    // [146] Function call CfAnd
    func_146.input[0] = func_145.output;
    func_146.input[1] = CmLegionellaProt_output_8;
    func_146.Execute(  );

    // [55] Function call CfMonoflop
    func_55.input = BooleanToFloat(func_95.outputOR);
    func_55.Execute( env, parameterOffset + 18 );

    // [112] Function call CfDelayOnOff
    func_112.input = func_108.outputAND;
    func_112.Execute( env, parameterOffset + 19 );

    // [147] Function call CfInputMultiplexer
    func_147.inputSelect = BooleanToInt(func_146.outputAND);
    func_147.input[1-1] = BooleanToFloat(func_121.output);
    func_147.input[2-1] = 0F;
    func_147.Execute(  );

    // [22] Function call CfJkFlipFlop
    func_22.inputSet = FloatToBoolean(func_147.output);
    func_22.inputClock = false;
    func_22.inputReset = func_55.output;
    func_22.Execute(  );

  }
// macro register which are written multiple times
// macro inputs
public boolean CmLegionellaProt_input_1; // UnOccPeriod
public boolean CmLegionellaProt_input_2; // DayExtension
public boolean CmLegionellaProt_input_3; // LegProtEnabled
public float CmLegionellaProt_input_5; // UpperTemp
public float CmLegionellaProt_input_6; // LowerTemp
public boolean CmLegionellaProt_input_80; // Reset
// macro outputs
public boolean CmLegionellaProt_output_4; // LegProtActiv
public boolean CmLegionellaProt_output_8; // DHWS_Leg_Alm
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfNot func_19 = new CfNot();
protected CfDivide func_41 = new CfDivide();
protected CfIdt func_48 = new CfIdt();
protected CfIdt func_71 = new CfIdt();
protected CfIdt func_72 = new CfIdt();
protected CfNot func_119 = new CfNot();
protected CfMonoflop func_121 = new CfMonoflop();
protected CfWindow func_145 = new CfWindow();
protected CfSubtract func_40 = new CfSubtract();
protected CfOr func_115 = new CfOr();
protected CfCompare1 func_26 = new CfCompare1();
protected CfCompare1 func_29 = new CfCompare1();
protected CfAnd func_44 = new CfAnd();
protected CfAnd func_14 = new CfAnd();
protected CfInputMultiplexer func_54 = new CfInputMultiplexer();
protected CfAnd func_94 = new CfAnd();
protected CfDelayOnOff func_46 = new CfDelayOnOff();
protected CfOr func_155 = new CfOr();
protected CmLegTempFailedAlm func_74 = new CmLegTempFailedAlm();
protected CmLegTempFailedAlm func_78 = new CmLegTempFailedAlm();
protected CfOr func_84 = new CfOr();
protected CfOr func_95 = new CfOr();
protected CfAnd func_108 = new CfAnd();
protected CfAnd func_146 = new CfAnd();
protected CfMonoflop func_55 = new CfMonoflop();
protected CfDelayOnOff func_112 = new CfDelayOnOff();
protected CfInputMultiplexer func_147 = new CfInputMultiplexer();
protected CfJkFlipFlop func_22 = new CfJkFlipFlop();

// default constructor
public CmLegionellaProt()
{
  func_71.configure(2);
  func_72.configure(2);
  func_14.configure(3);
  func_95.configure(3);
}

  public void Start()
  {
    func_121.Start();
    func_46.Start();
    func_74.Start();
    func_78.Start();
    func_55.Start();
    func_112.Start();
    func_22.Start();
  }
}
