/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    MaxCntrReturnTemp
Macro id:      5954212807075431172
Macro version: 9
Last change:   21.10.2014 - 11:15
Access Level:  2
Inputs:
  [1] OutsideAirTmperature
  [2] ReturnWaterTemperature
  [3] RWT_Available
Outputs:
  [1] Y-CntrRWT
Parameter:
  [1] RWT-01: min. OAT RWT control
  [2] RWT-02: max. OAT RWT control
  [3] RWT-03: low setpoint
  [4] RWT-04: high setpoint
  [5] RWT-05: P-band RWT control
  [6] RWT-06: I-time RWT control
  [7] DISP-04: Calc RWT SP
Description:

================================================================================*/

public class CmMaxCntrReturnTemp
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [68] Macro call CmIDT_Ramp2
    func_68.CmIDT_Ramp2_input_46 = CmMaxCntrReturnTemp_input_60;
    func_68.CmIDT_Ramp2_input_1 = -50F;
    func_68.CmIDT_Ramp2_input_2 = 50F;
    func_68.CmIDT_Ramp2_input_3 = 0F;
    func_68.CmIDT_Ramp2_input_4 = 100F;
    func_68.CmIDT_Ramp2_input_5 = env.getParameter(parameterOffset);
    func_68.CmIDT_Ramp2_input_6 = env.getParameter(parameterOffset);
    func_68.CmIDT_Ramp2_input_7 = env.getParameter(parameterOffset);
    func_68.CmIDT_Ramp2_input_8 = env.getParameter(parameterOffset + 1);
    func_68.CmIDT_Ramp2_input_9 = env.getParameter(parameterOffset + 3);
    func_68.CmIDT_Ramp2_input_10 = env.getParameter(parameterOffset + 3);
    func_68.CmIDT_Ramp2_input_11 = env.getParameter(parameterOffset + 2);
    func_68.Execute( env, parameterOffset +7 );

    // [86] Function call CfIdt
    func_86.input = env.getParameter(parameterOffset + 4);
    func_86.Execute(  );
    env.setParameter(parameterOffset + 18, func_86.output[0]);

    // [87] Function call CfIdt
    func_87.input = env.getParameter(parameterOffset + 5);
    func_87.Execute(  );
    env.setParameter(parameterOffset + 20, func_87.output[0]);

    // [82] Function call CfMinimum
    func_82.input[0] = func_68.CmIDT_Ramp2_output_47;
    func_82.input[1] = env.getParameter(parameterOffset + 3);
    func_82.Execute(  );

    // [83] Function call CfMaximum
    func_83.input[0] = func_82.output;
    func_83.input[1] = env.getParameter(parameterOffset + 2);
    func_83.Execute(  );

    // [85] Function call CfSubtract
    func_85.input[0] = CmMaxCntrReturnTemp_input_61;
    func_85.input[1] = func_83.output;
    func_85.Execute(  );

    // [139] Function call CfInputMultiplexer
    func_139.inputSelect = BooleanToInt(CmMaxCntrReturnTemp_input_135);
    func_139.input[1-1] = 0F;
    func_139.input[2-1] = func_83.output;
    func_139.Execute(  );
    env.setParameter(parameterOffset + 6, func_139.output);

    // [88] Function call CfPid
    func_88.inputX = func_85.output;
    func_88.inputW = 0F;
    func_88.Execute( env, parameterOffset + 18 );

    // [89] Function call CfAddition
    func_89.input[0] = func_88.output;
    func_89.input[1] = 50F;
    func_89.Execute(  );

    // [130] Function call CfMaximum
    func_130.input[0] = func_89.output;
    func_130.input[1] = 0F;
    func_130.Execute(  );

    // [90] Function call CfMinimum
    func_90.input[0] = func_130.output;
    func_90.input[1] = 100F;
    func_90.Execute(  );

    // [136] Function call CfInputMultiplexer
    func_136.inputSelect = BooleanToInt(CmMaxCntrReturnTemp_input_135);
    func_136.input[1-1] = 0F;
    func_136.input[2-1] = func_90.output;
    func_136.Execute(  );
    CmMaxCntrReturnTemp_output_57 = func_136.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmMaxCntrReturnTemp_input_60; // OutsideAirTmperature
public float CmMaxCntrReturnTemp_input_61; // ReturnWaterTemperature
public boolean CmMaxCntrReturnTemp_input_135; // RWT_Available
// macro outputs
public float CmMaxCntrReturnTemp_output_57; // Y-CntrRWT
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CmIDT_Ramp2 func_68 = new CmIDT_Ramp2();
protected CfIdt func_86 = new CfIdt();
protected CfIdt func_87 = new CfIdt();
protected CfMinimum func_82 = new CfMinimum();
protected CfMaximum func_83 = new CfMaximum();
protected CfSubtract func_85 = new CfSubtract();
protected CfInputMultiplexer func_139 = new CfInputMultiplexer();
protected CfPid func_88 = new CfPid();
protected CfAddition func_89 = new CfAddition();
protected CfMaximum func_130 = new CfMaximum();
protected CfMinimum func_90 = new CfMinimum();
protected CfInputMultiplexer func_136 = new CfInputMultiplexer();

// default constructor
public CmMaxCntrReturnTemp()
{
}

  public void Start()
  {
    func_68.Start();
    func_88.Start();
  }
}
