/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Max Temperature
Macro id:      6085950792624243385
Macro version: 32
Last change:   29.01.2016 - 14:42
Access Level:  2
Inputs:
  [1] Boiler Stage
  [2] SupplyTemp
  [3] Ret Temp
  [4] reset
  [5] boiler pos
  [6] boiler group
  [7] Alarm
  [8] HoldSPactive
Outputs:
  [1] Stage1Cmd
  [2] Stage2Cmd
  [3] Max Temp
  [4] Max Temp 2
  [5] Mod
Parameter:
  [1] BST-01: maximum boiler supply temperature stage 1
  [2] BST-02: maximum boiler supply temperature stage 2
  [3] BST-03: maximum boiler supply temp. modulating stage
  [4] BST-05: P-band maximum supply temperature control
  [5] ST1-03: minimum off time stage 1
  [6] ST2-03: minimum off time stage 2
Description:

================================================================================*/

public class CmMax_Temperature
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [28] Macro call CmIDT05
    func_28.CmIDT05_input_1 = 1F;
    func_28.CmIDT05_input_2 = 1F;
    func_28.CmIDT05_input_3 = env.getParameter(parameterOffset + 4);
    func_28.CmIDT05_input_4 = env.getParameter(parameterOffset + 5);
    func_28.CmIDT05_input_5 = 0F;
    func_28.Execute(  );
    env.setParameter(parameterOffset + 6, func_28.CmIDT05_output_21);
    env.setParameter(parameterOffset + 9, func_28.CmIDT05_output_22);
    env.setParameter(parameterOffset + 7, func_28.CmIDT05_output_23);
    env.setParameter(parameterOffset + 10, func_28.CmIDT05_output_24);

    // [105] Function call CfCompare1
    func_105.inputA = CmMax_Temperature_input_22;
    func_105.inputB = 999F;
    func_105.Execute(  );

    // [14] Function call CfHysteresis
    func_14.inputX = CmMax_Temperature_input_22;
    func_14.inputW = env.getParameter(parameterOffset);
    func_14.Execute( env, parameterOffset + 6 );

    // [100] Function call CfAnd
    func_100.input[0] = func_14.output1;
    func_100.input[1] = func_105.outputLess;
    func_100.Execute(  );

    // [20] Macro call CmTimer
    func_20.CmTimer_input_1 = func_100.outputAND;
    func_20.CmTimer_input_2 = CmMax_Temperature_input_34;
    func_20.Execute( env, parameterOffset +7 );

    // [36] Function call CfOr
    func_36.input[0] = func_20.CmTimer_output_3;
    func_36.input[1] = func_100.outputAND;
    func_36.Execute(  );

    // [17] Function call CfHysteresis
    func_17.inputX = CmMax_Temperature_input_22;
    func_17.inputW = env.getParameter(parameterOffset + 1);
    func_17.Execute( env, parameterOffset + 9 );

    // [101] Function call CfAnd
    func_101.input[0] = func_17.output1;
    func_101.input[1] = func_105.outputLess;
    func_101.Execute(  );

    // [25] Macro call CmTimer
    func_25.CmTimer_input_1 = func_101.outputAND;
    func_25.CmTimer_input_2 = CmMax_Temperature_input_34;
    func_25.Execute( env, parameterOffset +10 );

    // [38] Function call CfOr
    func_38.input[0] = func_25.CmTimer_output_3;
    func_38.input[1] = func_101.outputAND;
    func_38.Execute(  );
    CmMax_Temperature_output_99 = func_38.outputOR;

    // [110] Function call CfSubtract
    func_110.input[0] = env.getParameter(parameterOffset + 2);
    func_110.input[1] = env.getParameter(parameterOffset + 3);
    func_110.Execute(  );

    // [92] Function call CfLinearConverter
    func_92.inputValue = CmMax_Temperature_input_22;
    func_92.inputInLimit1 = env.getParameter(parameterOffset + 2);
    func_92.inputInLimit2 = func_110.output;
    func_92.inputOutLimit1 = 0F;
    func_92.inputOutLimit2 = 100F;
    func_92.Execute(  );

    // [94] Function call CfCompare1
    func_94.inputA = CmMax_Temperature_input_22;
    func_94.inputB = 999F;
    func_94.Execute(  );

    // [98] Function call CfInputMultiplexer
    func_98.inputSelect = BooleanToInt(func_94.outputEqual);
    func_98.input[1-1] = func_92.output;
    func_98.input[2-1] = 100F;
    func_98.Execute(  );
    CmMax_Temperature_output_85 = func_98.output;

    // [6] Function call CfCompare1
    func_6.inputA = CmMax_Temperature_input_1;
    func_6.inputB = 1F;
    func_6.Execute(  );

    // [51] Function call CfCompare1
    func_51.inputA = CmMax_Temperature_input_22;
    func_51.inputB = 999F;
    func_51.Execute(  );

    // [5] Function call CfCompare1
    func_5.inputA = CmMax_Temperature_input_1;
    func_5.inputB = 0F;
    func_5.Execute(  );

    // [58] Function call CfOr
    func_58.input[0] = func_51.outputEqual;
    func_58.input[1] = func_36.outputNOR;
    func_58.Execute(  );

    // [56] Function call CfOr
    func_56.input[0] = func_38.outputNOR;
    func_56.input[1] = func_51.outputEqual;
    func_56.Execute(  );

    // [62] Function call CfAnd
    func_62.input[0] = func_36.outputOR;
    func_62.input[1] = func_51.outputLess;
    func_62.Execute(  );
    CmMax_Temperature_output_48 = func_62.outputAND;

    // [130] Function call CfOr
    func_130.input[0] = func_5.outputGreater;
    func_130.input[1] = CmMax_Temperature_input_146;
    func_130.Execute(  );

    // [141] Function call CfNot
    func_141.input = CmMax_Temperature_input_140;
    func_141.Execute(  );

    // [41] Function call CfAnd
    func_41.input[0] = func_130.outputOR;
    func_41.input[1] = func_58.outputOR;
    func_41.input[2] = func_141.output;
    func_41.Execute(  );
    CmMax_Temperature_output_2 = func_41.outputAND;

    // [44] Function call CfAnd
    func_44.input[0] = func_56.outputOR;
    func_44.input[1] = func_6.outputGreater;
    func_44.input[2] = func_141.output;
    func_44.Execute(  );
    CmMax_Temperature_output_3 = func_44.outputAND;

  }
// macro register which are written multiple times
// macro inputs
public float CmMax_Temperature_input_1; // Boiler Stage
public float CmMax_Temperature_input_22; // SupplyTemp
public float CmMax_Temperature_input_68; // Ret Temp(not used)
public boolean CmMax_Temperature_input_34; // reset
public float CmMax_Temperature_input_134; // boiler pos(not used)
public float CmMax_Temperature_input_135; // boiler group(not used)
public boolean CmMax_Temperature_input_140; // Alarm
public boolean CmMax_Temperature_input_146; // HoldSPactive
// macro outputs
public boolean CmMax_Temperature_output_2; // Stage1Cmd
public boolean CmMax_Temperature_output_3; // Stage2Cmd
public boolean CmMax_Temperature_output_48; // Max Temp
public boolean CmMax_Temperature_output_99; // Max Temp 2
public float CmMax_Temperature_output_85; // Mod
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CmIDT05 func_28 = new CmIDT05();
protected CfCompare1 func_105 = new CfCompare1();
protected CfHysteresis func_14 = new CfHysteresis();
protected CfAnd func_100 = new CfAnd();
protected CmTimer func_20 = new CmTimer();
protected CfOr func_36 = new CfOr();
protected CfHysteresis func_17 = new CfHysteresis();
protected CfAnd func_101 = new CfAnd();
protected CmTimer func_25 = new CmTimer();
protected CfOr func_38 = new CfOr();
protected CfSubtract func_110 = new CfSubtract();
protected CfLinearConverter func_92 = new CfLinearConverter();
protected CfCompare1 func_94 = new CfCompare1();
protected CfInputMultiplexer func_98 = new CfInputMultiplexer();
protected CfCompare1 func_6 = new CfCompare1();
protected CfCompare1 func_51 = new CfCompare1();
protected CfCompare1 func_5 = new CfCompare1();
protected CfOr func_58 = new CfOr();
protected CfOr func_56 = new CfOr();
protected CfAnd func_62 = new CfAnd();
protected CfOr func_130 = new CfOr();
protected CfNot func_141 = new CfNot();
protected CfAnd func_41 = new CfAnd();
protected CfAnd func_44 = new CfAnd();

// default constructor
public CmMax_Temperature()
{
  func_41.configure(3);
  func_44.configure(3);
}

  public void Start()
  {
    func_28.Start();
    func_14.Start();
    func_20.Start();
    func_17.Start();
    func_25.Start();
  }
}
