/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    PrimRWTContHE/DHW
Macro id:      6018038544529494867
Macro version: 39
Last change:   06.05.2019 - 11:18
Access Level:  2
Inputs:
  [1] PriRetTemp
  [2] PriRetTempSp
  [3] DistrHtgSupTemp
  [4] LegionellaActive
Outputs:
  [1] ValveControl
  [2] CalcRWTempSp
Parameter:
  [1] RWT-01: return water setpointraise during legionella
  [2] RWT-02: P-band return temperature control
  [3] VLV-01: valve position limit
Description:

================================================================================*/

public class CmPrimRWTContHEDHW
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [38] Function call CfInputMultiplexer
    func_38.inputSelect = BooleanToInt(CmPrimRWTContHEDHW_input_22);
    func_38.input[1-1] = 0F;
    func_38.input[2-1] = env.getParameter(parameterOffset);
    func_38.Execute(  );

    // [91] Macro call CmTempSenAvailable
    func_91.CmTempSenAvailable_input_1 = CmPrimRWTContHEDHW_input_1;
    func_91.Execute(  );

    // [92] Macro call CmTempSenAvailable
    func_92.CmTempSenAvailable_input_1 = CmPrimRWTContHEDHW_input_2;
    func_92.Execute(  );

    // [37] Function call CfAddition
    func_37.input[0] = CmPrimRWTContHEDHW_input_2;
    func_37.input[1] = func_38.output;
    func_37.Execute(  );

    // [103] Function call CfAnd
    func_103.input[0] = func_91.CmTempSenAvailable_output_2;
    func_103.input[1] = func_92.CmTempSenAvailable_output_2;
    func_103.Execute(  );

    // [64] Function call CfInputMultiplexer
    func_64.inputSelect = BooleanToInt(func_103.outputAND);
    func_64.input[1-1] = 0F;
    func_64.input[2-1] = func_37.output;
    func_64.Execute(  );

    // [45] Function call CfIdt
    func_45.input = func_64.output;
    func_45.Execute(  );
    CmPrimRWTContHEDHW_output_3 = func_45.output[1];

    // [116] Function call CfSubtract
    func_116.input[0] = func_45.output[0];
    func_116.input[1] = env.getParameter(parameterOffset + 1);
    func_116.Execute(  );

    // [117] Macro call CmIDT_Ramp
    func_117.CmIDT_Ramp_input_46 = CmPrimRWTContHEDHW_input_1;
    func_117.CmIDT_Ramp_input_1 = -150F;
    func_117.CmIDT_Ramp_input_2 = 150F;
    func_117.CmIDT_Ramp_input_3 = 0F;
    func_117.CmIDT_Ramp_input_4 = 100F;
    func_117.CmIDT_Ramp_input_5 = func_116.output;
    func_117.CmIDT_Ramp_input_6 = func_45.output[2];
    func_117.CmIDT_Ramp_input_7 = func_45.output[2];
    func_117.CmIDT_Ramp_input_8 = func_45.output[2];
    func_117.CmIDT_Ramp_input_9 = env.getParameter(parameterOffset + 2);
    func_117.CmIDT_Ramp_input_10 = 0F;
    func_117.CmIDT_Ramp_input_11 = 0F;
    func_117.Execute( env, parameterOffset +3 );

    // [62] Function call CfInputMultiplexer
    func_62.inputSelect = BooleanToInt(func_103.outputAND);
    func_62.input[1-1] = 100F;
    func_62.input[2-1] = func_117.CmIDT_Ramp_output_47;
    func_62.Execute(  );
    CmPrimRWTContHEDHW_output_44 = func_62.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmPrimRWTContHEDHW_input_1; // PriRetTemp
public float CmPrimRWTContHEDHW_input_2; // PriRetTempSp
public float CmPrimRWTContHEDHW_input_21; // DistrHtgSupTemp(not used)
public boolean CmPrimRWTContHEDHW_input_22; // LegionellaActive
// macro outputs
public float CmPrimRWTContHEDHW_output_44; // ValveControl
public float CmPrimRWTContHEDHW_output_3; // CalcRWTempSp
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfInputMultiplexer func_38 = new CfInputMultiplexer();
protected CmTempSenAvailable func_91 = new CmTempSenAvailable();
protected CmTempSenAvailable func_92 = new CmTempSenAvailable();
protected CfAddition func_37 = new CfAddition();
protected CfAnd func_103 = new CfAnd();
protected CfInputMultiplexer func_64 = new CfInputMultiplexer();
protected CfIdt func_45 = new CfIdt();
protected CfSubtract func_116 = new CfSubtract();
protected CmIDT_Ramp func_117 = new CmIDT_Ramp();
protected CfInputMultiplexer func_62 = new CfInputMultiplexer();

// default constructor
public CmPrimRWTContHEDHW()
{
  func_45.configure(3);
}

  public void Start()
  {
    func_91.Start();
    func_92.Start();
    func_117.Start();
  }
}
