/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Primary RWT Control
Macro id:      5987196047922823496
Macro version: 33
Last change:   06.05.2019 - 11:12
Access Level:  2
Inputs:
  [1] PriRetTemp
  [2] PriRetTempSp
  [3] OutsideAirTemp
  [4] DistrHtgSupTemp
  [5] LegionellaActive
Outputs:
  [1] ValveControl
  [2] CalcRWTempSp
Parameter:
  [1] RWT-01: return water setpointraise during legionella
  [2] RWT-02: P-band return temperature control
  [3] RWT-03: return water setpoint raise at high DST or low OAT
  [4] RWT-04: return water control configuration
  [5] OAT-02: minimum outside air temperature
  [6] OAT-03: maximum outside air temperature
  [7] DST-01: minimum district supply temperature
  [8] DST-02: maximum district supply temperature
  [9] VLV-01: valve position limit
Description:

================================================================================*/

public class CmPrimary_RWT_Control
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [18] Macro call CmIDT_Ramp
    func_18.CmIDT_Ramp_input_46 = CmPrimary_RWT_Control_input_20;
    func_18.CmIDT_Ramp_input_1 = -50F;
    func_18.CmIDT_Ramp_input_2 = 50F;
    func_18.CmIDT_Ramp_input_3 = 0F;
    func_18.CmIDT_Ramp_input_4 = 100F;
    func_18.CmIDT_Ramp_input_5 = env.getParameter(parameterOffset + 4);
    func_18.CmIDT_Ramp_input_6 = env.getParameter(parameterOffset + 5);
    func_18.CmIDT_Ramp_input_7 = env.getParameter(parameterOffset + 5);
    func_18.CmIDT_Ramp_input_8 = env.getParameter(parameterOffset + 5);
    func_18.CmIDT_Ramp_input_9 = env.getParameter(parameterOffset + 2);
    func_18.CmIDT_Ramp_input_10 = 0F;
    func_18.CmIDT_Ramp_input_11 = 0F;
    func_18.Execute( env, parameterOffset +9 );

    // [24] Macro call CmIDT_Ramp
    func_24.CmIDT_Ramp_input_46 = CmPrimary_RWT_Control_input_21;
    func_24.CmIDT_Ramp_input_1 = -150F;
    func_24.CmIDT_Ramp_input_2 = 150F;
    func_24.CmIDT_Ramp_input_3 = 0F;
    func_24.CmIDT_Ramp_input_4 = 100F;
    func_24.CmIDT_Ramp_input_5 = env.getParameter(parameterOffset + 6);
    func_24.CmIDT_Ramp_input_6 = env.getParameter(parameterOffset + 7);
    func_24.CmIDT_Ramp_input_7 = env.getParameter(parameterOffset + 7);
    func_24.CmIDT_Ramp_input_8 = env.getParameter(parameterOffset + 7);
    func_24.CmIDT_Ramp_input_9 = 0F;
    func_24.CmIDT_Ramp_input_10 = env.getParameter(parameterOffset + 2);
    func_24.CmIDT_Ramp_input_11 = env.getParameter(parameterOffset + 2);
    func_24.Execute( env, parameterOffset +20 );

    // [38] Function call CfInputMultiplexer
    func_38.inputSelect = BooleanToInt(CmPrimary_RWT_Control_input_22);
    func_38.input[1-1] = 0F;
    func_38.input[2-1] = env.getParameter(parameterOffset);
    func_38.Execute(  );

    // [49] Macro call CmTempSenAvailable
    func_49.CmTempSenAvailable_input_1 = CmPrimary_RWT_Control_input_1;
    func_49.Execute(  );

    // [86] Macro call CmTempSenAvailable
    func_86.CmTempSenAvailable_input_1 = CmPrimary_RWT_Control_input_2;
    func_86.Execute(  );

    // [91] Macro call CmTempSenAvailable
    func_91.CmTempSenAvailable_input_1 = CmPrimary_RWT_Control_input_1;
    func_91.Execute(  );

    // [92] Macro call CmTempSenAvailable
    func_92.CmTempSenAvailable_input_1 = CmPrimary_RWT_Control_input_2;
    func_92.Execute(  );

    // [29] Function call CfAddition
    func_29.input[0] = CmPrimary_RWT_Control_input_2;
    func_29.input[1] = func_18.CmIDT_Ramp_output_47;
    func_29.Execute(  );

    // [90] Function call CfAnd
    func_90.input[0] = func_49.CmTempSenAvailable_output_2;
    func_90.input[1] = func_86.CmTempSenAvailable_output_2;
    func_90.Execute(  );

    // [103] Function call CfAnd
    func_103.input[0] = func_91.CmTempSenAvailable_output_2;
    func_103.input[1] = func_92.CmTempSenAvailable_output_2;
    func_103.Execute(  );

    // [143] Function call CfAddition
    func_143.input[0] = CmPrimary_RWT_Control_input_2;
    func_143.input[1] = func_24.CmIDT_Ramp_output_47;
    func_143.Execute(  );

    // [27] Function call CfInputMultiplexer
    func_27.inputSelect = FloatToInt(env.getParameter(parameterOffset + 3));
    func_27.input[1-1] = 0F;
    func_27.input[2-1] = CmPrimary_RWT_Control_input_2;
    func_27.input[3-1] = func_29.output;
    func_27.input[4-1] = func_143.output;
    func_27.Execute(  );

    // [37] Function call CfAddition
    func_37.input[0] = func_27.output;
    func_37.input[1] = func_38.output;
    func_37.Execute(  );

    // [64] Function call CfInputMultiplexer
    func_64.inputSelect = BooleanToInt(func_103.outputAND);
    func_64.input[1-1] = 0F;
    func_64.input[2-1] = func_37.output;
    func_64.Execute(  );

    // [45] Function call CfIdt
    func_45.input = func_64.output;
    func_45.Execute(  );
    CmPrimary_RWT_Control_output_3 = func_45.output[1];

    // [116] Function call CfSubtract
    func_116.input[0] = func_45.output[0];
    func_116.input[1] = env.getParameter(parameterOffset + 1);
    func_116.Execute(  );

    // [117] Macro call CmIDT_Ramp
    func_117.CmIDT_Ramp_input_46 = CmPrimary_RWT_Control_input_1;
    func_117.CmIDT_Ramp_input_1 = -150F;
    func_117.CmIDT_Ramp_input_2 = 150F;
    func_117.CmIDT_Ramp_input_3 = 0F;
    func_117.CmIDT_Ramp_input_4 = 100F;
    func_117.CmIDT_Ramp_input_5 = func_116.output;
    func_117.CmIDT_Ramp_input_6 = func_45.output[2];
    func_117.CmIDT_Ramp_input_7 = func_45.output[2];
    func_117.CmIDT_Ramp_input_8 = func_45.output[2];
    func_117.CmIDT_Ramp_input_9 = env.getParameter(parameterOffset + 8);
    func_117.CmIDT_Ramp_input_10 = 0F;
    func_117.CmIDT_Ramp_input_11 = 0F;
    func_117.Execute( env, parameterOffset +31 );

    // [62] Function call CfInputMultiplexer
    func_62.inputSelect = BooleanToInt(func_90.outputAND);
    func_62.input[1-1] = 100F;
    func_62.input[2-1] = func_117.CmIDT_Ramp_output_47;
    func_62.Execute(  );
    CmPrimary_RWT_Control_output_44 = func_62.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmPrimary_RWT_Control_input_1; // PriRetTemp
public float CmPrimary_RWT_Control_input_2; // PriRetTempSp
public float CmPrimary_RWT_Control_input_20; // OutsideAirTemp
public float CmPrimary_RWT_Control_input_21; // DistrHtgSupTemp
public boolean CmPrimary_RWT_Control_input_22; // LegionellaActive
// macro outputs
public float CmPrimary_RWT_Control_output_44; // ValveControl
public float CmPrimary_RWT_Control_output_3; // CalcRWTempSp
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }

// class variables
protected CmIDT_Ramp func_18 = new CmIDT_Ramp();
protected CmIDT_Ramp func_24 = new CmIDT_Ramp();
protected CfInputMultiplexer func_38 = new CfInputMultiplexer();
protected CmTempSenAvailable func_49 = new CmTempSenAvailable();
protected CmTempSenAvailable func_86 = new CmTempSenAvailable();
protected CmTempSenAvailable func_91 = new CmTempSenAvailable();
protected CmTempSenAvailable func_92 = new CmTempSenAvailable();
protected CfAddition func_29 = new CfAddition();
protected CfAnd func_90 = new CfAnd();
protected CfAnd func_103 = new CfAnd();
protected CfAddition func_143 = new CfAddition();
protected CfInputMultiplexer func_27 = new CfInputMultiplexer();
protected CfAddition func_37 = new CfAddition();
protected CfInputMultiplexer func_64 = new CfInputMultiplexer();
protected CfIdt func_45 = new CfIdt();
protected CfSubtract func_116 = new CfSubtract();
protected CmIDT_Ramp func_117 = new CmIDT_Ramp();
protected CfInputMultiplexer func_62 = new CfInputMultiplexer();

// default constructor
public CmPrimary_RWT_Control()
{
  func_27.configure(5);
  func_45.configure(3);
}

  public void Start()
  {
    func_18.Start();
    func_24.Start();
    func_49.Start();
    func_86.Start();
    func_91.Start();
    func_92.Start();
    func_117.Start();
  }
}
