/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    RedundantCmd
Macro id:      6044006381367853692
Macro version: 32
Last change:   07.11.2016 - 14:38
Access Level:  2
Inputs:
  [1] OutsideAirTemp
  [2] SupplyDeviation
Outputs:
  [1] HeatGenDemandOut
Parameter:
  [1] OAT-01: low limit OAT to enable
  [2] OAT-02: high limit OAT to disable
  [3] OVR-01: high limit deviation to enable
  [4] OVR-02: low limit deviation to disable
  [5] OVR-03: switch on delay
  [6] OVR-04: switch off delay
Description:

================================================================================*/

public class CmRedundantCmd
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [31] Macro call CmIDT10
    func_31.CmIDT10_input_1 = env.getParameter(parameterOffset);
    func_31.CmIDT10_input_2 = env.getParameter(parameterOffset + 1);
    func_31.CmIDT10_input_3 = env.getParameter(parameterOffset + 4);
    func_31.CmIDT10_input_4 = env.getParameter(parameterOffset + 5);
    func_31.CmIDT10_input_5 = env.getParameter(parameterOffset + 2);
    func_31.CmIDT10_input_6 = env.getParameter(parameterOffset + 3);
    func_31.CmIDT10_input_7 = env.getParameter(parameterOffset + 4);
    func_31.CmIDT10_input_8 = env.getParameter(parameterOffset + 5);
    func_31.CmIDT10_input_9 = 0F;
    func_31.CmIDT10_input_10 = 0F;
    func_31.Execute(  );
    env.setParameter(parameterOffset + 6, func_31.CmIDT10_output_21);
    env.setParameter(parameterOffset + 7, func_31.CmIDT10_output_22);
    env.setParameter(parameterOffset + 8, func_31.CmIDT10_output_23);
    env.setParameter(parameterOffset + 9, func_31.CmIDT10_output_24);
    env.setParameter(parameterOffset + 13, func_31.CmIDT10_output_25);
    env.setParameter(parameterOffset + 12, func_31.CmIDT10_output_26);
    env.setParameter(parameterOffset + 15, func_31.CmIDT10_output_27);
    env.setParameter(parameterOffset + 14, func_31.CmIDT10_output_28);

    // [7] Macro call Cmdeviation
    func_7.Cmdeviation_input_1 = CmRedundantCmd_input_22;
    func_7.Execute( env, parameterOffset +6 );

    // [152] Function call CfCompare2
    func_152.inputA = env.getParameter(parameterOffset);
    func_152.inputB = -50F;
    func_152.Execute(  );

    // [153] Function call CfCompare2
    func_153.inputA = CmRedundantCmd_input_22;
    func_153.inputB = 999F;
    func_153.Execute(  );

    // [151] Function call CfOr
    func_151.input[0] = func_7.Cmdeviation_output_64;
    func_151.input[1] = func_152.outputEqualOrLess;
    func_151.input[2] = func_153.outputEqualOrGreater;
    func_151.Execute(  );

    // [150] Function call CfRsFlipFlop
    func_150.inputSet = func_7.Cmdeviation_output_46;
    func_150.inputReset = func_151.outputOR;
    func_150.Execute(  );

    // [10] Macro call Cmdeviation
    func_10.Cmdeviation_input_1 = CmRedundantCmd_input_23;
    func_10.Execute( env, parameterOffset +12 );

    // [154] Function call CfCompare2
    func_154.inputA = env.getParameter(parameterOffset + 2);
    func_154.inputB = 100F;
    func_154.Execute(  );

    // [155] Function call CfOr
    func_155.input[0] = func_10.Cmdeviation_output_46;
    func_155.input[1] = func_154.outputEqualOrGreater;
    func_155.Execute(  );

    // [139] Function call CfRsFlipFlop
    func_139.inputSet = func_10.Cmdeviation_output_64;
    func_139.inputReset = func_155.outputOR;
    func_139.Execute(  );

    // [158] Function call CfOr
    func_158.input[0] = func_150.output;
    func_158.input[1] = func_139.output;
    func_158.Execute(  );
    CmRedundantCmd_output_99 = BooleanToFloat(func_158.outputOR);

  }
// macro register which are written multiple times
// macro inputs
public float CmRedundantCmd_input_22; // OutsideAirTemp
public float CmRedundantCmd_input_23; // SupplyDeviation
// macro outputs
public float CmRedundantCmd_output_99; // HeatGenDemandOut
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }

// class variables
protected CmIDT10 func_31 = new CmIDT10();
protected Cmdeviation func_7 = new Cmdeviation();
protected CfCompare2 func_152 = new CfCompare2();
protected CfCompare2 func_153 = new CfCompare2();
protected CfOr func_151 = new CfOr();
protected CfRsFlipFlop func_150 = new CfRsFlipFlop();
protected Cmdeviation func_10 = new Cmdeviation();
protected CfCompare2 func_154 = new CfCompare2();
protected CfOr func_155 = new CfOr();
protected CfRsFlipFlop func_139 = new CfRsFlipFlop();
protected CfOr func_158 = new CfOr();

// default constructor
public CmRedundantCmd()
{
  func_151.configure(3);
}

  public void Start()
  {
    func_31.Start();
    func_7.Start();
    func_150.Start();
    func_10.Start();
    func_139.Start();
  }
}
