/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    SOL_Buffer
Macro id:      6142776879402189611
Macro version: 22
Last change:   11.08.2015 - 15:48
Access Level:  2
Inputs:
  [1] Delta_T_on
  [2] SolPanelTemp
  [3] BufLowerTemp
  [4] SolarPower
  [5] PumpPower
  [6] BufOverheatAlm
  [7] BufStopHighOAT
Outputs:
  [1] PumpCmd
  [2] OpMode3
Parameter:
  [1] SOLP-02: temperature difference to switch off/ over
Description:

================================================================================*/

public class CmSOL_Buffer
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [14] Function call CfCompare1
    func_14.inputA = CmSOL_Buffer_input_53;
    func_14.inputB = env.getParameter(parameterOffset);
    func_14.Execute(  );

    // [16] Function call CfSubtract
    func_16.input[0] = CmSOL_Buffer_input_53;
    func_16.input[1] = env.getParameter(parameterOffset);
    func_16.Execute(  );

    // [15] Function call CfInputMultiplexer
    func_15.inputSelect = BooleanToInt(func_14.outputLess);
    func_15.input[1-1] = func_16.output;
    func_15.input[2-1] = 0.1F;
    func_15.Execute(  );
    env.setParameter(parameterOffset + 1, func_15.output);

    // [13] Function call CfSubtract
    func_13.input[0] = CmSOL_Buffer_input_55;
    func_13.input[1] = CmSOL_Buffer_input_57;
    func_13.Execute(  );

    // [72] Function call CfOr
    func_72.input[0] = CmSOL_Buffer_input_66;
    func_72.input[1] = CmSOL_Buffer_input_67;
    func_72.Execute(  );

    // [10] Function call CfHysteresis
    func_10.inputX = func_13.output;
    func_10.inputW = CmSOL_Buffer_input_53;
    func_10.Execute( env, parameterOffset + 1 );

    // [73] Function call CfNot
    func_73.input = func_72.outputOR;
    func_73.Execute(  );

    // [106] Function call CfCompare1
    func_106.inputA = CmSOL_Buffer_input_62;
    func_106.inputB = -999F;
    func_106.Execute(  );

    // [11] Function call CfAnd
    func_11.input[0] = func_73.output;
    func_11.input[1] = func_10.output1;
    func_11.Execute(  );

    // [12] Function call CfMultiply
    func_12.input[0] = CmSOL_Buffer_input_75;
    func_12.input[1] = 3F;
    func_12.Execute(  );

    // [8] Function call CfCompare1
    func_8.inputA = func_12.output;
    func_8.inputB = CmSOL_Buffer_input_62;
    func_8.Execute(  );

    // [118] Function call CfDelay
    func_118.inputA = CmSOL_Buffer_output_65;
    func_118.inputB = CmSOL_Buffer_output_65;
    func_118.Execute( env, parameterOffset + 2 );

    // [128] Function call CfCompare1
    func_128.inputA = CmSOL_Buffer_input_62;
    func_128.inputB = -990F;
    func_128.Execute(  );

    // [114] Function call CfAnd
    func_114.input[0] = func_118.outputDelayedA;
    func_114.input[1] = func_8.outputGreater;
    func_114.input[2] = func_128.outputGreater;
    func_114.Execute(  );

    // [113] Function call CfMonoflop
    func_113.input = BooleanToFloat(func_114.outputAND);
    func_113.Execute( env, parameterOffset + 3 );

    // [112] Function call CfNot
    func_112.input = func_113.output;
    func_112.Execute(  );

    // [111] Function call CfAnd
    func_111.input[0] = func_11.outputAND;
    func_111.input[1] = func_112.output;
    func_111.Execute(  );

    // [107] Function call CfInputMultiplexer
    func_107.inputSelect = BooleanToInt(func_106.outputGreater);
    func_107.input[1-1] = BooleanToFloat(func_11.outputAND);
    func_107.input[2-1] = BooleanToFloat(func_111.outputAND);
    func_107.Execute(  );
    CmSOL_Buffer_output_65 = FloatToBoolean(func_107.output);

    // [124] Function call CfIdt
    func_124.input = BooleanToFloat(func_113.output);
    func_124.Execute(  );
    CmSOL_Buffer_output_126 = FloatToBoolean(func_124.output[0]);

  }
// macro register which are written multiple times
// macro inputs
public float CmSOL_Buffer_input_53; // Delta_T_on
public float CmSOL_Buffer_input_55; // SolPanelTemp
public float CmSOL_Buffer_input_57; // BufLowerTemp
public float CmSOL_Buffer_input_62; // SolarPower
public float CmSOL_Buffer_input_75; // PumpPower
public boolean CmSOL_Buffer_input_66; // BufOverheatAlm
public boolean CmSOL_Buffer_input_67; // BufStopHighOAT
// macro outputs
public boolean CmSOL_Buffer_output_65; // PumpCmd
public boolean CmSOL_Buffer_output_126; // OpMode3
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfCompare1 func_14 = new CfCompare1();
protected CfSubtract func_16 = new CfSubtract();
protected CfInputMultiplexer func_15 = new CfInputMultiplexer();
protected CfSubtract func_13 = new CfSubtract();
protected CfOr func_72 = new CfOr();
protected CfHysteresis func_10 = new CfHysteresis();
protected CfNot func_73 = new CfNot();
protected CfCompare1 func_106 = new CfCompare1();
protected CfAnd func_11 = new CfAnd();
protected CfMultiply func_12 = new CfMultiply();
protected CfCompare1 func_8 = new CfCompare1();
protected CfDelay func_118 = new CfDelay();
protected CfCompare1 func_128 = new CfCompare1();
protected CfAnd func_114 = new CfAnd();
protected CfMonoflop func_113 = new CfMonoflop();
protected CfNot func_112 = new CfNot();
protected CfAnd func_111 = new CfAnd();
protected CfInputMultiplexer func_107 = new CfInputMultiplexer();
protected CfIdt func_124 = new CfIdt();

// default constructor
public CmSOL_Buffer()
{
  func_114.configure(3);
}

  public void Start()
  {
    func_10.Start();
    func_118.Start();
    func_113.Start();
  }
}
