/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    SOL_DHW
Macro id:      6142772358013780728
Macro version: 21
Last change:   11.08.2015 - 15:55
Access Level:  2
Inputs:
  [1] Delta_T_on
  [2] SolPanelTemp
  [3] DHWLowerTemp
  [4] DHWUpperTemp
  [5] SolarPower
  [6] PumpPower
Outputs:
  [1] PumpCmd
  [2] OpMode3
Parameter:
  [1] SOLP-02: temperature difference to switch off/ over
  [2] DHW-01: DHW maximum upper temperature protection
  [3] DHW-02: DHW maximum lower temperature protection
Description:

================================================================================*/

public class CmSOL_DHW
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [14] Function call CfCompare1
    func_14.inputA = CmSOL_DHW_input_53;
    func_14.inputB = env.getParameter(parameterOffset);
    func_14.Execute(  );

    // [16] Function call CfSubtract
    func_16.input[0] = CmSOL_DHW_input_53;
    func_16.input[1] = env.getParameter(parameterOffset);
    func_16.Execute(  );

    // [15] Function call CfInputMultiplexer
    func_15.inputSelect = BooleanToInt(func_14.outputLess);
    func_15.input[1-1] = func_16.output;
    func_15.input[2-1] = 0.1F;
    func_15.Execute(  );
    env.setParameter(parameterOffset + 5, func_15.output);

    // [125] Function call CfSubtract
    func_125.input[0] = env.getParameter(parameterOffset + 1);
    func_125.input[1] = 5F;
    func_125.Execute(  );

    // [124] Function call CfCompare1
    func_124.inputA = CmSOL_DHW_input_60;
    func_124.inputB = 990F;
    func_124.Execute(  );

    // [123] Function call CfInputMultiplexer
    func_123.inputSelect = BooleanToInt(func_124.outputGreater);
    func_123.input[1-1] = CmSOL_DHW_input_60;
    func_123.input[2-1] = func_125.output;
    func_123.Execute(  );

    // [69] Function call CfHysteresis
    func_69.inputX = func_123.output;
    func_69.inputW = env.getParameter(parameterOffset + 1);
    func_69.Execute( env, parameterOffset + 3 );

    // [72] Function call CfHysteresis
    func_72.inputX = CmSOL_DHW_input_57;
    func_72.inputW = env.getParameter(parameterOffset + 2);
    func_72.Execute( env, parameterOffset + 4 );

    // [73] Function call CfOr
    func_73.input[0] = func_69.output1;
    func_73.input[1] = func_72.output1;
    func_73.Execute(  );

    // [74] Function call CfNot
    func_74.input = func_73.outputOR;
    func_74.Execute(  );

    // [86] Function call CfCompare1
    func_86.inputA = CmSOL_DHW_input_62;
    func_86.inputB = -999F;
    func_86.Execute(  );

    // [13] Function call CfSubtract
    func_13.input[0] = CmSOL_DHW_input_55;
    func_13.input[1] = CmSOL_DHW_input_57;
    func_13.Execute(  );

    // [10] Function call CfHysteresis
    func_10.inputX = func_13.output;
    func_10.inputW = CmSOL_DHW_input_53;
    func_10.Execute( env, parameterOffset + 5 );

    // [11] Function call CfAnd
    func_11.input[0] = func_74.output;
    func_11.input[1] = func_10.output1;
    func_11.Execute(  );

    // [12] Function call CfMultiply
    func_12.input[0] = CmSOL_DHW_input_76;
    func_12.input[1] = 3F;
    func_12.Execute(  );

    // [8] Function call CfCompare1
    func_8.inputA = func_12.output;
    func_8.inputB = CmSOL_DHW_input_62;
    func_8.Execute(  );

    // [108] Function call CfDelay
    func_108.inputA = CmSOL_DHW_output_65;
    func_108.inputB = CmSOL_DHW_output_65;
    func_108.Execute( env, parameterOffset + 6 );

    // [129] Function call CfCompare1
    func_129.inputA = CmSOL_DHW_input_62;
    func_129.inputB = -990F;
    func_129.Execute(  );

    // [106] Function call CfAnd
    func_106.input[0] = func_108.outputDelayedA;
    func_106.input[1] = func_8.outputGreater;
    func_106.input[2] = func_129.outputGreater;
    func_106.Execute(  );

    // [104] Function call CfMonoflop
    func_104.input = BooleanToFloat(func_106.outputAND);
    func_104.Execute( env, parameterOffset + 7 );

    // [105] Function call CfNot
    func_105.input = func_104.output;
    func_105.Execute(  );

    // [103] Function call CfAnd
    func_103.input[0] = func_11.outputAND;
    func_103.input[1] = func_105.output;
    func_103.Execute(  );

    // [96] Function call CfInputMultiplexer
    func_96.inputSelect = BooleanToInt(func_86.outputGreater);
    func_96.input[1-1] = BooleanToFloat(func_11.outputAND);
    func_96.input[2-1] = BooleanToFloat(func_103.outputAND);
    func_96.Execute(  );
    CmSOL_DHW_output_65 = FloatToBoolean(func_96.output);

    // [116] Function call CfIdt
    func_116.input = BooleanToFloat(func_104.output);
    func_116.Execute(  );
    CmSOL_DHW_output_115 = FloatToBoolean(func_116.output[0]);

  }
// macro register which are written multiple times
// macro inputs
public float CmSOL_DHW_input_53; // Delta_T_on
public float CmSOL_DHW_input_55; // SolPanelTemp
public float CmSOL_DHW_input_57; // DHWLowerTemp
public float CmSOL_DHW_input_60; // DHWUpperTemp
public float CmSOL_DHW_input_62; // SolarPower
public float CmSOL_DHW_input_76; // PumpPower
// macro outputs
public boolean CmSOL_DHW_output_65; // PumpCmd
public boolean CmSOL_DHW_output_115; // OpMode3
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfCompare1 func_14 = new CfCompare1();
protected CfSubtract func_16 = new CfSubtract();
protected CfInputMultiplexer func_15 = new CfInputMultiplexer();
protected CfSubtract func_125 = new CfSubtract();
protected CfCompare1 func_124 = new CfCompare1();
protected CfInputMultiplexer func_123 = new CfInputMultiplexer();
protected CfHysteresis func_69 = new CfHysteresis();
protected CfHysteresis func_72 = new CfHysteresis();
protected CfOr func_73 = new CfOr();
protected CfNot func_74 = new CfNot();
protected CfCompare1 func_86 = new CfCompare1();
protected CfSubtract func_13 = new CfSubtract();
protected CfHysteresis func_10 = new CfHysteresis();
protected CfAnd func_11 = new CfAnd();
protected CfMultiply func_12 = new CfMultiply();
protected CfCompare1 func_8 = new CfCompare1();
protected CfDelay func_108 = new CfDelay();
protected CfCompare1 func_129 = new CfCompare1();
protected CfAnd func_106 = new CfAnd();
protected CfMonoflop func_104 = new CfMonoflop();
protected CfNot func_105 = new CfNot();
protected CfAnd func_103 = new CfAnd();
protected CfInputMultiplexer func_96 = new CfInputMultiplexer();
protected CfIdt func_116 = new CfIdt();

// default constructor
public CmSOL_DHW()
{
  func_106.configure(3);
}

  public void Start()
  {
    func_69.Start();
    func_72.Start();
    func_10.Start();
    func_108.Start();
    func_104.Start();
  }
}
