/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    SecSTContHE/DHW
Macro id:      6017731406740849412
Macro version: 11
Last change:   24.06.2014 - 14:56
Access Level:  2
Inputs:
  [1] SecSupTemp
  [2] SecSupTempSp
  [3] HolidaySwitch
  [4] DayExtension
  [5] Unoccupied
  [6] Reset
Outputs:
  [1] ValveControl
  [2] CalcSecSupTempSp
  [3] HE_Failure
  [4] MinSupTempProt
Parameter:
  [1] SST-01: maximum supply temperature
  [2] SST-02: minimum supply temperature
  [3] SST-04: setpoint raise to compensate losses
  [4] SST-05: maximum setpoint raise per minute
  [5] SST-06: P-band SST control
  [6] SST-07: I-time system supply temperature control
  [7] SST-08: D-time system supply temperature control
  [8] SYS-02: HE_Failure enable after release
  [9] SYS-03: automatic/ manual reset
Description:

================================================================================*/

public class CmSecSTContHEDHW
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [14] Function call CfIdt
    func_14.input = env.getParameter(parameterOffset + 3);
    func_14.Execute(  );
    env.setParameter(parameterOffset + 9, func_14.output[0]);

    // [16] Function call CfAddition
    func_16.input[0] = CmSecSTContHEDHW_input_2;
    func_16.input[1] = env.getParameter(parameterOffset + 2);
    func_16.Execute(  );

    // [32] Macro call CmIDT05
    func_32.CmIDT05_input_1 = env.getParameter(parameterOffset + 4);
    func_32.CmIDT05_input_2 = env.getParameter(parameterOffset + 5);
    func_32.CmIDT05_input_3 = env.getParameter(parameterOffset + 6);
    func_32.CmIDT05_input_4 = 600F;
    func_32.CmIDT05_input_5 = env.getParameter(parameterOffset + 8);
    func_32.Execute(  );
    env.setParameter(parameterOffset + 13, func_32.CmIDT05_output_21);
    env.setParameter(parameterOffset + 15, func_32.CmIDT05_output_22);
    env.setParameter(parameterOffset + 14, func_32.CmIDT05_output_23);
    env.setParameter(parameterOffset + 18, func_32.CmIDT05_output_24);
    env.setParameter(parameterOffset + 19, func_32.CmIDT05_output_25);

    // [86] Function call CfIdt
    func_86.input = env.getParameter(parameterOffset + 7);
    func_86.Execute(  );
    env.setParameter(parameterOffset + 11, func_86.output[0]);

    // [101] Function call CfWindow
    func_101.inputValue = env.getParameter(parameterOffset + 8);
    func_101.inputMinimum = 0.8F;
    func_101.inputMaximum = 1.2F;
    func_101.Execute(  );

    // [123] Function call CfIdt
    func_123.input = 10000F;
    func_123.Execute(  );
    env.setParameter(parameterOffset + 10, func_123.output[0]);

    // [277] Function call CfNot
    func_277.input = CmSecSTContHEDHW_input_269;
    func_277.Execute(  );

    // [289] Function call CfOr
    func_289.input[0] = CmSecSTContHEDHW_input_268;
    func_289.input[1] = CmSecSTContHEDHW_input_279;
    func_289.Execute(  );

    // [290] Function call CfNot
    func_290.input = ControlFunction.GetStartupFlag();
    func_290.Execute(  );

    // [12] Function call CfValueRamp
    func_12.inputValue = func_16.output;
    func_12.Execute( env, parameterOffset + 9 );

    // [85] Function call CfDelayOnOff
    func_85.input = func_290.output;
    func_85.Execute( env, parameterOffset + 11 );

    // [276] Function call CfAnd
    func_276.input[0] = func_289.outputOR;
    func_276.input[1] = func_277.output;
    func_276.Execute(  );

    // [24] Function call CfMaximum
    func_24.input[0] = func_12.output;
    func_24.input[1] = env.getParameter(parameterOffset + 1);
    func_24.Execute(  );

    // [25] Function call CfMinimum
    func_25.input[0] = env.getParameter(parameterOffset);
    func_25.input[1] = func_24.output;
    func_25.Execute(  );

    // [19] Function call CfIdt
    func_19.input = func_25.output;
    func_19.Execute(  );
    CmSecSTContHEDHW_output_18 = func_19.output[1];

    // [275] Function call CfInputMultiplexer
    func_275.inputSelect = BooleanToInt(func_276.outputAND);
    func_275.input[1-1] = func_19.output[0];
    func_275.input[2-1] = 0F;
    func_275.Execute(  );

    // [241] Function call CfPidPlus
    func_241.inputX = CmSecSTContHEDHW_input_1;
    func_241.inputW = func_275.output;
    func_241.Execute( env, parameterOffset + 13 );

    // [278] Function call CfIdt
    func_278.input = func_275.output;
    func_278.Execute(  );

    // [73] Function call CfSubtract
    func_73.input[0] = func_278.output[0];
    func_73.input[1] = env.getParameter(parameterOffset + 4);
    func_73.Execute(  );

    // [70] Macro call CmTempFailedAlm
    func_70.CmTempFailedAlm_input_1 = CmSecSTContHEDHW_input_1;
    func_70.CmTempFailedAlm_input_2 = func_73.output;
    func_70.CmTempFailedAlm_input_3 = CmSecSTContHEDHW_input_72;
    func_70.CmTempFailedAlm_input_17 = func_85.output;
    func_70.Execute( env, parameterOffset +18 );

    // [99] Function call CfIdt
    func_99.input = BooleanToFloat(func_70.CmTempFailedAlm_output_4);
    func_99.Execute(  );
    CmSecSTContHEDHW_output_71 = FloatToBoolean(func_99.output[0]);

    // [100] Function call CfAnd
    func_100.input[0] = FloatToBoolean(func_99.output[1]);
    func_100.input[1] = func_101.output;
    func_100.Execute(  );

    // [102] Function call CfInputMultiplexer
    func_102.inputSelect = BooleanToInt(func_100.outputAND);
    func_102.input[1-1] = func_241.output;
    func_102.input[2-1] = 0F;
    func_102.Execute(  );
    CmSecSTContHEDHW_output_3 = func_102.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmSecSTContHEDHW_input_1; // SecSupTemp
public float CmSecSTContHEDHW_input_2; // SecSupTempSp
public boolean CmSecSTContHEDHW_input_268; // HolidaySwitch
public boolean CmSecSTContHEDHW_input_269; // DayExtension
public boolean CmSecSTContHEDHW_input_279; // Unoccupied
public boolean CmSecSTContHEDHW_input_72; // Reset
// macro outputs
public float CmSecSTContHEDHW_output_3; // ValveControl
public float CmSecSTContHEDHW_output_18; // CalcSecSupTempSp
public boolean CmSecSTContHEDHW_output_71; // HE_Failure
public boolean CmSecSTContHEDHW_output_114; // MinSupTempProt(not used)
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfIdt func_14 = new CfIdt();
protected CfAddition func_16 = new CfAddition();
protected CmIDT05 func_32 = new CmIDT05();
protected CfIdt func_86 = new CfIdt();
protected CfWindow func_101 = new CfWindow();
protected CfIdt func_123 = new CfIdt();
protected CfNot func_277 = new CfNot();
protected CfOr func_289 = new CfOr();
protected CfNot func_290 = new CfNot();
protected CfValueRamp func_12 = new CfValueRamp();
protected CfDelayOnOff func_85 = new CfDelayOnOff();
protected CfAnd func_276 = new CfAnd();
protected CfMaximum func_24 = new CfMaximum();
protected CfMinimum func_25 = new CfMinimum();
protected CfIdt func_19 = new CfIdt();
protected CfInputMultiplexer func_275 = new CfInputMultiplexer();
protected CfPidPlus func_241 = new CfPidPlus();
protected CfIdt func_278 = new CfIdt();
protected CfSubtract func_73 = new CfSubtract();
protected CmTempFailedAlm func_70 = new CmTempFailedAlm();
protected CfIdt func_99 = new CfIdt();
protected CfAnd func_100 = new CfAnd();
protected CfInputMultiplexer func_102 = new CfInputMultiplexer();

// default constructor
public CmSecSTContHEDHW()
{
  func_19.configure(2);
  func_99.configure(2);
}

  public void Start()
  {
    func_32.Start();
    func_12.Start();
    func_85.Start();
    func_241.Start();
    func_70.Start();
  }
}
