/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    SecSupTempControl
Macro id:      5987607158618850221
Macro version: 48
Last change:   10.07.2015 - 10:40
Access Level:  2
Inputs:
  [1] SecSupTemp
  [2] HeatDemand
  [3] Reset
  [4] FilteredOATemp
  [5] SecPmpStatAlm
Outputs:
  [1] ValveControl
  [2] CalcSecSupTempSp
  [3] HE_Failure
  [4] MinSupTempProt
Parameter:
  [1] SST-01: maximum supply temperature
  [2] SST-02: minimum supply temperature
  [3] SST-04: setpoint raise to compensate losses
  [4] SST-05: maximum setpoint raise per minute
  [5] SST-06: P-band SST control
  [6] SST-07: I-time system supply temperature control
  [7] SST-08: D-time system supply temperature control
  [8] SYS-02: HE_Failure enable after release
  [9] SYS-03: automatic/ manual reset
  [10] OAT-01: low limit frost protection
Description:

================================================================================*/

public class CmSecSupTempControl
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [14] Function call CfIdt
    func_14.input = env.getParameter(parameterOffset + 3);
    func_14.Execute(  );
    env.setParameter(parameterOffset + 12, func_14.output[0]);

    // [32] Macro call CmIDT05
    func_32.CmIDT05_input_1 = env.getParameter(parameterOffset + 4);
    func_32.CmIDT05_input_2 = env.getParameter(parameterOffset + 5);
    func_32.CmIDT05_input_3 = env.getParameter(parameterOffset + 6);
    func_32.CmIDT05_input_4 = 600F;
    func_32.CmIDT05_input_5 = env.getParameter(parameterOffset + 8);
    func_32.Execute(  );
    env.setParameter(parameterOffset + 20, func_32.CmIDT05_output_21);
    env.setParameter(parameterOffset + 22, func_32.CmIDT05_output_22);
    env.setParameter(parameterOffset + 21, func_32.CmIDT05_output_23);
    env.setParameter(parameterOffset + 16, func_32.CmIDT05_output_24);
    env.setParameter(parameterOffset + 17, func_32.CmIDT05_output_25);

    // [39] Function call CfCompare1
    func_39.inputA = CmSecSupTempControl_input_2;
    func_39.inputB = 0F;
    func_39.Execute(  );

    // [58] Function call CfHysteresis
    func_58.inputX = CmSecSupTempControl_input_1;
    func_58.inputW = env.getParameter(parameterOffset + 1);
    func_58.Execute( env, parameterOffset + 10 );

    // [101] Function call CfWindow
    func_101.inputValue = env.getParameter(parameterOffset + 8);
    func_101.inputMinimum = 0.8F;
    func_101.inputMaximum = 1.2F;
    func_101.Execute(  );

    // [123] Function call CfIdt
    func_123.input = 10000F;
    func_123.Execute(  );
    env.setParameter(parameterOffset + 13, func_123.output[0]);

    // [125] Function call CfCompare1
    func_125.inputA = CmSecSupTempControl_input_2;
    func_125.inputB = 0F;
    func_125.Execute(  );

    // [248] Function call CfHysteresis
    func_248.inputX = CmSecSupTempControl_input_247;
    func_248.inputW = env.getParameter(parameterOffset + 9);
    func_248.Execute( env, parameterOffset + 11 );

    // [262] Function call CfCompare1
    func_262.inputA = CmSecSupTempControl_input_2;
    func_262.inputB = 0F;
    func_262.Execute(  );

    // [269] Function call CfInputMultiplexer
    func_269.inputSelect = BooleanToInt(CmSecSupTempControl_input_268);
    func_269.input[1-1] = env.getParameter(parameterOffset + 2);
    func_269.input[2-1] = 0F;
    func_269.Execute(  );

    // [16] Function call CfAddition
    func_16.input[0] = CmSecSupTempControl_input_2;
    func_16.input[1] = func_269.output;
    func_16.Execute(  );

    // [244] Function call CfAnd
    func_244.input[0] = func_58.output2;
    func_244.input[1] = func_248.output2;
    func_244.Execute(  );

    // [12] Function call CfValueRamp
    func_12.inputValue = func_16.output;
    func_12.Execute( env, parameterOffset + 12 );

    // [55] Function call CfInputMultiplexer
    func_55.inputSelect = BooleanToInt(func_244.outputAND);
    func_55.input[1-1] = 0F;
    func_55.input[2-1] = env.getParameter(parameterOffset + 1);
    func_55.Execute(  );

    // [24] Function call CfMaximum
    func_24.input[0] = func_12.output;
    func_24.input[1] = env.getParameter(parameterOffset + 1);
    func_24.Execute(  );

    // [115] Function call CfIdt
    func_115.input = func_55.output;
    func_115.Execute(  );

    // [25] Function call CfMinimum
    func_25.input[0] = env.getParameter(parameterOffset);
    func_25.input[1] = func_24.output;
    func_25.Execute(  );

    // [129] Function call CfAnd
    func_129.input[0] = FloatToBoolean(func_115.output[2]);
    func_129.input[1] = func_125.outputEqual;
    func_129.Execute(  );
    CmSecSupTempControl_output_114 = func_129.outputAND;

    // [261] Function call CfCompare1
    func_261.inputA = func_115.output[1];
    func_261.inputB = 0F;
    func_261.Execute(  );

    // [41] Function call CfInputMultiplexer
    func_41.inputSelect = BooleanToInt(func_39.outputEqual);
    func_41.input[1-1] = func_25.output;
    func_41.input[2-1] = func_115.output[0];
    func_41.Execute(  );

    // [263] Function call CfAnd
    func_263.input[0] = func_262.outputEqual;
    func_263.input[1] = func_261.outputEqual;
    func_263.Execute(  );

    // [19] Function call CfIdt
    func_19.input = func_41.output;
    func_19.Execute(  );
    CmSecSupTempControl_output_18 = func_19.output[1];

    // [73] Function call CfSubtract
    func_73.input[0] = CmSecSupTempControl_output_18;
    func_73.input[1] = env.getParameter(parameterOffset + 4);
    func_73.Execute(  );

    // [265] Function call CfInputMultiplexer
    func_265.inputSelect = BooleanToInt(func_263.outputAND);
    func_265.input[1-1] = func_19.output[0];
    func_265.input[2-1] = -100F;
    func_265.Execute(  );

    // [86] Function call CfIdt
    func_86.input = env.getParameter(parameterOffset + 7);
    func_86.Execute(  );
    env.setParameter(parameterOffset + 14, func_86.output[0]);

    // [287] Function call CfNot
    func_287.input = ControlFunction.GetStartupFlag();
    func_287.Execute(  );

    // [85] Function call CfDelayOnOff
    func_85.input = func_287.output;
    func_85.Execute( env, parameterOffset + 14 );

    // [70] Macro call CmTempFailedAlm
    func_70.CmTempFailedAlm_input_1 = CmSecSupTempControl_input_1;
    func_70.CmTempFailedAlm_input_2 = func_73.output;
    func_70.CmTempFailedAlm_input_3 = CmSecSupTempControl_input_72;
    func_70.CmTempFailedAlm_input_17 = func_85.output;
    func_70.Execute( env, parameterOffset +16 );

    // [241] Function call CfPidPlus
    func_241.inputX = CmSecSupTempControl_input_1;
    func_241.inputW = func_265.output;
    func_241.Execute( env, parameterOffset + 20 );

    // [99] Function call CfIdt
    func_99.input = BooleanToFloat(func_70.CmTempFailedAlm_output_4);
    func_99.Execute(  );
    CmSecSupTempControl_output_71 = FloatToBoolean(func_99.output[0]);

    // [100] Function call CfAnd
    func_100.input[0] = FloatToBoolean(func_99.output[1]);
    func_100.input[1] = func_101.output;
    func_100.Execute(  );

    // [102] Function call CfInputMultiplexer
    func_102.inputSelect = BooleanToInt(func_100.outputAND);
    func_102.input[1-1] = func_241.output;
    func_102.input[2-1] = 0F;
    func_102.Execute(  );
    CmSecSupTempControl_output_3 = func_102.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmSecSupTempControl_input_1; // SecSupTemp
public float CmSecSupTempControl_input_2; // HeatDemand
public boolean CmSecSupTempControl_input_72; // Reset
public float CmSecSupTempControl_input_247; // FilteredOATemp
public boolean CmSecSupTempControl_input_268; // SecPmpStatAlm
// macro outputs
public float CmSecSupTempControl_output_3; // ValveControl
public float CmSecSupTempControl_output_18; // CalcSecSupTempSp
public boolean CmSecSupTempControl_output_71; // HE_Failure
public boolean CmSecSupTempControl_output_114; // MinSupTempProt
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfIdt func_14 = new CfIdt();
protected CmIDT05 func_32 = new CmIDT05();
protected CfCompare1 func_39 = new CfCompare1();
protected CfHysteresis func_58 = new CfHysteresis();
protected CfWindow func_101 = new CfWindow();
protected CfIdt func_123 = new CfIdt();
protected CfCompare1 func_125 = new CfCompare1();
protected CfHysteresis func_248 = new CfHysteresis();
protected CfCompare1 func_262 = new CfCompare1();
protected CfInputMultiplexer func_269 = new CfInputMultiplexer();
protected CfAddition func_16 = new CfAddition();
protected CfAnd func_244 = new CfAnd();
protected CfValueRamp func_12 = new CfValueRamp();
protected CfInputMultiplexer func_55 = new CfInputMultiplexer();
protected CfMaximum func_24 = new CfMaximum();
protected CfIdt func_115 = new CfIdt();
protected CfMinimum func_25 = new CfMinimum();
protected CfAnd func_129 = new CfAnd();
protected CfCompare1 func_261 = new CfCompare1();
protected CfInputMultiplexer func_41 = new CfInputMultiplexer();
protected CfAnd func_263 = new CfAnd();
protected CfIdt func_19 = new CfIdt();
protected CfSubtract func_73 = new CfSubtract();
protected CfInputMultiplexer func_265 = new CfInputMultiplexer();
protected CfIdt func_86 = new CfIdt();
protected CfNot func_287 = new CfNot();
protected CfDelayOnOff func_85 = new CfDelayOnOff();
protected CmTempFailedAlm func_70 = new CmTempFailedAlm();
protected CfPidPlus func_241 = new CfPidPlus();
protected CfIdt func_99 = new CfIdt();
protected CfAnd func_100 = new CfAnd();
protected CfInputMultiplexer func_102 = new CfInputMultiplexer();

// default constructor
public CmSecSupTempControl()
{
  func_115.configure(3);
  func_19.configure(2);
  func_99.configure(2);
}

  public void Start()
  {
    func_32.Start();
    func_58.Start();
    func_248.Start();
    func_12.Start();
    func_85.Start();
    func_70.Start();
    func_241.Start();
  }
}
