/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    SelectionSpTemperature
Macro id:      5971606743572021981
Macro version: 14
Last change:   14.12.2016 - 12:37
Access Level:  2
Inputs:
  [1] RmTmpSpScedule
  [2] ContPtAdj
  [3] ManSwCond
  [4] SummerSwitch
  [5] HolidaySwitch
  [6] DayExtension
  [7] RmSpRampIn
Outputs:
  [1] CalcRoomSp
  [2] DispCalcRoomSp
  [3] OverrActive
  [4] DayExtActive
Parameter:
  [1] manuel occupied setpoint
  [2] manuel un-occupied setpoint
  [3] manuel un-occupied setpoint summer
  [4] manuel un-occupied setpoint holiday
  [5] auto reset time from extended operation
Description:

================================================================================*/

public class CmSelectionSpTemperature
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [102] Function call CfCompare1
    func_102.inputA = CmSelectionSpTemperature_input_101;
    func_102.inputB = 0F;
    func_102.Execute(  );

    // [37] Function call CfMultiply
    func_37.input[0] = env.getParameter(parameterOffset + 4);
    func_37.input[1] = 60F;
    func_37.Execute(  );
    env.setParameter(parameterOffset + 6, func_37.output);

    // [24] Function call CfDelayOnOff
    func_24.input = CmSelectionSpTemperature_input_60;
    func_24.Execute( env, parameterOffset + 5 );

    // [40] Function call CfAddition
    func_40.input[0] = CmSelectionSpTemperature_input_13;
    func_40.input[1] = CmSelectionSpTemperature_input_6;
    func_40.Execute(  );

    // [106] Function call CfInputMultiplexer
    func_106.inputSelect = BooleanToInt(func_102.outputGreater);
    func_106.input[1-1] = func_40.output;
    func_106.input[2-1] = CmSelectionSpTemperature_input_101;
    func_106.Execute(  );

    // [93] Function call CfAddition
    func_93.input[0] = env.getParameter(parameterOffset);
    func_93.input[1] = CmSelectionSpTemperature_input_6;
    func_93.Execute(  );

    // [22] Function call CfInputMultiplexer
    func_22.inputSelect = FloatToInt(CmSelectionSpTemperature_input_1);
    func_22.input[1-1] = env.getParameter(parameterOffset + 1);
    func_22.input[2-1] = func_93.output;
    func_22.input[3-1] = func_93.output;
    func_22.input[4-1] = func_106.output;
    func_22.Execute(  );

    // [88] Function call CfIdt
    func_88.input = BooleanToFloat(func_24.output);
    func_88.Execute(  );
    CmSelectionSpTemperature_output_99 = FloatToBoolean(func_88.output[1]);

    // [48] Function call CfInputMultiplexer
    func_48.inputSelect = BooleanToInt(CmSelectionSpTemperature_input_3);
    func_48.input[1-1] = func_22.output;
    func_48.input[2-1] = env.getParameter(parameterOffset + 3);
    func_48.Execute(  );

    // [81] Function call CfWindow
    func_81.inputValue = CmSelectionSpTemperature_input_1;
    func_81.inputMinimum = -0.2F;
    func_81.inputMaximum = 2.2F;
    func_81.Execute(  );

    // [80] Function call CfOr
    func_80.input[0] = func_81.output;
    func_80.input[1] = FloatToBoolean(func_88.output[0]);
    func_80.input[2] = CmSelectionSpTemperature_input_3;
    func_80.input[3] = CmSelectionSpTemperature_input_2;
    func_80.input[4] = func_102.outputGreater;
    func_80.Execute(  );
    CmSelectionSpTemperature_output_73 = func_80.outputOR;

    // [70] Function call CfInputMultiplexer
    func_70.inputSelect = FloatToInt(func_88.output[2]);
    func_70.input[1-1] = func_48.output;
    func_70.input[2-1] = func_93.output;
    func_70.Execute(  );

    // [47] Function call CfInputMultiplexer
    func_47.inputSelect = BooleanToInt(CmSelectionSpTemperature_input_2);
    func_47.input[1-1] = func_70.output;
    func_47.input[2-1] = env.getParameter(parameterOffset + 2);
    func_47.Execute(  );

    // [52] Function call CfIdt
    func_52.input = func_47.output;
    func_52.Execute(  );
    CmSelectionSpTemperature_output_5 = func_52.output[0];
    CmSelectionSpTemperature_output_7 = func_52.output[1];

  }
// macro register which are written multiple times
// macro inputs
public float CmSelectionSpTemperature_input_13; // RmTmpSpScedule
public float CmSelectionSpTemperature_input_6; // ContPtAdj
public float CmSelectionSpTemperature_input_1; // ManSwCond
public boolean CmSelectionSpTemperature_input_2; // SummerSwitch
public boolean CmSelectionSpTemperature_input_3; // HolidaySwitch
public boolean CmSelectionSpTemperature_input_60; // DayExtension
public float CmSelectionSpTemperature_input_101; // RmSpRampIn
// macro outputs
public float CmSelectionSpTemperature_output_5; // CalcRoomSp
public float CmSelectionSpTemperature_output_7; // DispCalcRoomSp
public boolean CmSelectionSpTemperature_output_73; // OverrActive
public boolean CmSelectionSpTemperature_output_99; // DayExtActive
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfCompare1 func_102 = new CfCompare1();
protected CfMultiply func_37 = new CfMultiply();
protected CfDelayOnOff func_24 = new CfDelayOnOff();
protected CfAddition func_40 = new CfAddition();
protected CfInputMultiplexer func_106 = new CfInputMultiplexer();
protected CfAddition func_93 = new CfAddition();
protected CfInputMultiplexer func_22 = new CfInputMultiplexer();
protected CfIdt func_88 = new CfIdt();
protected CfInputMultiplexer func_48 = new CfInputMultiplexer();
protected CfWindow func_81 = new CfWindow();
protected CfOr func_80 = new CfOr();
protected CfInputMultiplexer func_70 = new CfInputMultiplexer();
protected CfInputMultiplexer func_47 = new CfInputMultiplexer();
protected CfIdt func_52 = new CfIdt();

// default constructor
public CmSelectionSpTemperature()
{
  func_22.configure(5);
  func_88.configure(3);
  func_80.configure(5);
  func_52.configure(2);
}

  public void Start()
  {
    func_24.Start();
  }
}
