/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Setpoint Control
Macro id:      6078134255860318512
Macro version: 20
Last change:   29.01.2016 - 14:40
Access Level:  2
Inputs:
  [1] Stage
  [2] boiler position
  [3] boiler group
  [4] Alarm
Outputs:
  [1] SetpCntrl
  [2] holdSP
Parameter:
  [1] SPO-01: setpoint offset
  [2] SPO-02: setpoint low input
  [3] SPO-03: setpoint high input
  [4] SPO-04: setpoint low output
  [5] SPO-05: setpoint high output
Description:

================================================================================*/

public class CmSetpoint_Control
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [157] Function call CfRdGlobalRegister
    func_157.inputRegister = 1008;
    func_157.inputReset = false;
    func_157.inputResetValue = 0F;
    func_157.Execute(  );

    // [148] Function call CfRdGlobalRegister
    func_148.inputRegister = 974;
    func_148.inputReset = false;
    func_148.inputResetValue = 0F;
    func_148.Execute(  );

    // [153] Function call CfSubtract
    func_153.input[0] = func_148.output;
    func_153.input[1] = env.getParameter(parameterOffset);
    func_153.Execute(  );

    // [150] Function call CfAddition
    func_150.input[0] = func_148.output;
    func_150.input[1] = env.getParameter(parameterOffset);
    func_150.Execute(  );

    // [154] Function call CfLinearConverter
    func_154.inputValue = func_157.output;
    func_154.inputInLimit1 = 0F;
    func_154.inputInLimit2 = 100F;
    func_154.inputOutLimit1 = func_153.output;
    func_154.inputOutLimit2 = func_150.output;
    func_154.Execute(  );

    // [162] Function call CfLinearConverter
    func_162.inputValue = func_154.output;
    func_162.inputInLimit1 = env.getParameter(parameterOffset + 1);
    func_162.inputInLimit2 = env.getParameter(parameterOffset + 2);
    func_162.inputOutLimit1 = env.getParameter(parameterOffset + 3);
    func_162.inputOutLimit2 = env.getParameter(parameterOffset + 4);
    func_162.Execute(  );

    // [172] Function call CfCompare2
    func_172.inputA = CmSetpoint_Control_input_9;
    func_172.inputB = 1F;
    func_172.Execute(  );

    // [200] Macro call CmHoldSPout
    func_200.CmHoldSPout_input_16 = CmSetpoint_Control_input_186;
    func_200.CmHoldSPout_input_29 = CmSetpoint_Control_input_183;
    func_200.CmHoldSPout_input_131 = CmSetpoint_Control_input_194;
    func_200.CmHoldSPout_input_177 = func_172.outputEqualOrGreater;
    func_200.Execute(  );

    // [199] Function call CfInputMultiplexer
    func_199.inputSelect = BooleanToInt(CmSetpoint_Control_input_194);
    func_199.input[1-1] = BooleanToFloat(func_200.CmHoldSPout_output_27);
    func_199.input[2-1] = 0F;
    func_199.Execute(  );

    // [171] Function call CfMultiply
    func_171.input[0] = func_162.output;
    func_171.input[1] = func_199.output;
    func_171.Execute(  );
    CmSetpoint_Control_output_1 = func_171.output;

    // [207] Function call CfIdt
    func_207.input = func_199.output;
    func_207.Execute(  );
    CmSetpoint_Control_output_204 = FloatToBoolean(func_207.output[0]);

  }
// macro register which are written multiple times
// macro inputs
public float CmSetpoint_Control_input_9; // Stage
public float CmSetpoint_Control_input_183; // boiler position
public float CmSetpoint_Control_input_186; // boiler group
public boolean CmSetpoint_Control_input_194; // Alarm
// macro outputs
public float CmSetpoint_Control_output_1; // SetpCntrl
public boolean CmSetpoint_Control_output_204; // holdSP
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfRdGlobalRegister func_157 = new CfRdGlobalRegister();
protected CfRdGlobalRegister func_148 = new CfRdGlobalRegister();
protected CfSubtract func_153 = new CfSubtract();
protected CfAddition func_150 = new CfAddition();
protected CfLinearConverter func_154 = new CfLinearConverter();
protected CfLinearConverter func_162 = new CfLinearConverter();
protected CfCompare2 func_172 = new CfCompare2();
protected CmHoldSPout func_200 = new CmHoldSPout();
protected CfInputMultiplexer func_199 = new CfInputMultiplexer();
protected CfMultiply func_171 = new CfMultiply();
protected CfIdt func_207 = new CfIdt();

// default constructor
public CmSetpoint_Control()
{
}

  public void Start()
  {
    func_200.Start();
  }
}
