/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Sol_ChgOverValve
Macro id:      6142805671518667745
Macro version: 10
Last change:   12.08.2015 - 09:07
Access Level:  2
Inputs:
  [1] SolPanelTemp
  [2] DHWLowerTemp
  [3] DHWUpperTemp
  [4] DHW_TempSp
  [5] BufferLowerTemp
  [6] BufOverheatAlm
  [7] BufStopHighOAT
Outputs:
  [1] ChgOverValve
Parameter:
  [1] SOLP-02: temperature difference to switch off/ over
  [2] DHW-01: DHW maximum upper temperature protection
  [3] DHW-02: DHW maximum lower temperature protection
  [4] DHW-03: DHW priority 1 = no priority; 2 = priority
Description:

================================================================================*/

public class CmSol_ChgOverValve
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [4] Function call CfSubtract
    func_4.input[0] = CmSol_ChgOverValve_input_2;
    func_4.input[1] = CmSol_ChgOverValve_input_3;
    func_4.Execute(  );

    // [27] Function call CfCompare1
    func_27.inputA = CmSol_ChgOverValve_input_3;
    func_27.inputB = env.getParameter(parameterOffset + 2);
    func_27.Execute(  );

    // [37] Function call CfWindow
    func_37.inputValue = env.getParameter(parameterOffset + 3);
    func_37.inputMinimum = 1.8F;
    func_37.inputMaximum = 2.2F;
    func_37.Execute(  );

    // [57] Function call CfSubtract
    func_57.input[0] = CmSol_ChgOverValve_input_2;
    func_57.input[1] = CmSol_ChgOverValve_input_56;
    func_57.Execute(  );

    // [90] Function call CfSubtract
    func_90.input[0] = CmSol_ChgOverValve_input_36;
    func_90.input[1] = 5F;
    func_90.Execute(  );

    // [95] Function call CfCompare1
    func_95.inputA = env.getParameter(parameterOffset + 3);
    func_95.inputB = 2F;
    func_95.Execute(  );

    // [123] Function call CfSubtract
    func_123.input[0] = env.getParameter(parameterOffset + 1);
    func_123.input[1] = 5F;
    func_123.Execute(  );

    // [11] Function call CfCompare1
    func_11.inputA = func_4.output;
    func_11.inputB = env.getParameter(parameterOffset);
    func_11.Execute(  );

    // [59] Function call CfCompare1
    func_59.inputA = func_57.output;
    func_59.inputB = env.getParameter(parameterOffset);
    func_59.Execute(  );

    // [91] Function call CfCompare1
    func_91.inputA = func_90.output;
    func_91.inputB = CmSol_ChgOverValve_input_3;
    func_91.Execute(  );

    // [96] Function call CfMonoflop
    func_96.input = BooleanToFloat(func_95.outputEqual);
    func_96.Execute( env, parameterOffset + 4 );

    // [125] Function call CfCompare1
    func_125.inputA = CmSol_ChgOverValve_input_24;
    func_125.inputB = 990F;
    func_125.Execute(  );

    // [124] Function call CfInputMultiplexer
    func_124.inputSelect = BooleanToInt(func_125.outputGreater);
    func_124.input[1-1] = CmSol_ChgOverValve_input_24;
    func_124.input[2-1] = func_123.output;
    func_124.Execute(  );

    // [26] Function call CfCompare1
    func_26.inputA = func_124.output;
    func_26.inputB = env.getParameter(parameterOffset + 1);
    func_26.Execute(  );

    // [94] Function call CfAnd
    func_94.input[0] = func_91.outputGreater;
    func_94.input[1] = func_96.output;
    func_94.Execute(  );

    // [15] Function call CfOr
    func_15.input[0] = func_11.outputLess;
    func_15.input[1] = func_26.outputGreater;
    func_15.input[2] = func_27.outputGreater;
    func_15.Execute(  );

    // [39] Function call CfAnd
    func_39.input[0] = func_11.outputGreater;
    func_39.input[1] = func_26.outputLess;
    func_39.input[2] = func_27.outputLess;
    func_39.input[3] = func_37.output;
    func_39.input[4] = func_91.outputGreater;
    func_39.Execute(  );

    // [67] Function call CfOr
    func_67.input[0] = func_39.outputAND;
    func_67.input[1] = func_94.outputAND;
    func_67.input[2] = CmSol_ChgOverValve_input_68;
    func_67.input[3] = CmSol_ChgOverValve_input_69;
    func_67.input[4] = func_59.outputLess;
    func_67.Execute(  );

    // [34] Function call CfRsFlipFlop
    func_34.inputSet = func_15.outputOR;
    func_34.inputReset = func_67.outputOR;
    func_34.Execute(  );
    CmSol_ChgOverValve_output_1 = func_34.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmSol_ChgOverValve_input_2; // SolPanelTemp
public float CmSol_ChgOverValve_input_3; // DHWLowerTemp
public float CmSol_ChgOverValve_input_24; // DHWUpperTemp
public float CmSol_ChgOverValve_input_36; // DHW_TempSp
public float CmSol_ChgOverValve_input_56; // BufferLowerTemp
public boolean CmSol_ChgOverValve_input_68; // BufOverheatAlm
public boolean CmSol_ChgOverValve_input_69; // BufStopHighOAT
// macro outputs
public boolean CmSol_ChgOverValve_output_1; // ChgOverValve
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfSubtract func_4 = new CfSubtract();
protected CfCompare1 func_27 = new CfCompare1();
protected CfWindow func_37 = new CfWindow();
protected CfSubtract func_57 = new CfSubtract();
protected CfSubtract func_90 = new CfSubtract();
protected CfCompare1 func_95 = new CfCompare1();
protected CfSubtract func_123 = new CfSubtract();
protected CfCompare1 func_11 = new CfCompare1();
protected CfCompare1 func_59 = new CfCompare1();
protected CfCompare1 func_91 = new CfCompare1();
protected CfMonoflop func_96 = new CfMonoflop();
protected CfCompare1 func_125 = new CfCompare1();
protected CfInputMultiplexer func_124 = new CfInputMultiplexer();
protected CfCompare1 func_26 = new CfCompare1();
protected CfAnd func_94 = new CfAnd();
protected CfOr func_15 = new CfOr();
protected CfAnd func_39 = new CfAnd();
protected CfOr func_67 = new CfOr();
protected CfRsFlipFlop func_34 = new CfRsFlipFlop();

// default constructor
public CmSol_ChgOverValve()
{
  func_15.configure(3);
  func_39.configure(5);
  func_67.configure(5);
}

  public void Start()
  {
    func_96.Start();
    func_34.Start();
  }
}
