/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    ValveControlHE/DHW
Macro id:      6020588434983224210
Macro version: 3
Last change:   03.06.2014 - 08:43
Access Level:  2
Inputs:
  [1] ControlSignal1
  [2] ControlSignal2
  [3] ControlSignal3
Outputs:
  [1] ValveControl
  [2] PumpEnable
  [3] ControlSig1Activ
  [4] ControlSig2Activ
  [5] ControlSig3Activ
Parameter:
  [1] VLV-02: minimum valve position
  [2] VLV-03: maximum valve position raise per minute
Description:

================================================================================*/

public class CmValveControlHEDHW
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [7] Function call CfMinimum
    func_7.input[0] = CmValveControlHEDHW_input_1;
    func_7.input[1] = CmValveControlHEDHW_input_2;
    func_7.input[2] = CmValveControlHEDHW_input_3;
    func_7.Execute(  );

    // [11] Function call CfIdt
    func_11.input = env.getParameter(parameterOffset + 1);
    func_11.Execute(  );
    env.setParameter(parameterOffset + 2, func_11.output[0]);

    // [66] Function call CfIdt
    func_66.input = 1F;
    func_66.Execute(  );
    env.setParameter(parameterOffset + 5, func_66.output[0]);

    // [9] Function call CfValueRamp
    func_9.inputValue = func_7.output;
    func_9.Execute( env, parameterOffset + 2 );

    // [22] Function call CfCompare1
    func_22.inputA = func_7.output;
    func_22.inputB = CmValveControlHEDHW_input_2;
    func_22.Execute(  );

    // [26] Function call CfCompare1
    func_26.inputA = func_7.output;
    func_26.inputB = CmValveControlHEDHW_input_3;
    func_26.Execute(  );

    // [29] Function call CfCompare1
    func_29.inputA = func_7.output;
    func_29.inputB = CmValveControlHEDHW_input_1;
    func_29.Execute(  );

    // [13] Function call CfCompare1
    func_13.inputA = func_9.output;
    func_13.inputB = env.getParameter(parameterOffset);
    func_13.Execute(  );

    // [47] Function call CfInputMultiplexer
    func_47.inputSelect = BooleanToInt(func_22.outputEqual);
    func_47.input[1-1] = 0F;
    func_47.input[2-1] = 2F;
    func_47.Execute(  );

    // [75] Function call CfHysteresis
    func_75.inputX = func_9.output;
    func_75.inputW = 3F;
    func_75.Execute( env, parameterOffset + 4 );
    CmValveControlHEDHW_output_68 = func_75.output1;

    // [17] Function call CfInputMultiplexer
    func_17.inputSelect = BooleanToInt(func_13.outputLess);
    func_17.input[1-1] = func_9.output;
    func_17.input[2-1] = 0F;
    func_17.Execute(  );
    CmValveControlHEDHW_output_4 = func_17.output;

    // [49] Function call CfInputMultiplexer
    func_49.inputSelect = BooleanToInt(func_29.outputEqual);
    func_49.input[1-1] = func_47.output;
    func_49.input[2-1] = 1F;
    func_49.Execute(  );

    // [51] Function call CfInputMultiplexer
    func_51.inputSelect = BooleanToInt(func_26.outputEqual);
    func_51.input[1-1] = func_49.output;
    func_51.input[2-1] = 3F;
    func_51.Execute(  );

    // [44] Function call CfOutputMultiplexer
    func_44.inputSelect = FloatToInt(func_51.output);
    func_44.inputValue = 1F;
    func_44.Execute( env, parameterOffset + 5 );
    if ( func_44.outputValid[1]) CmValveControlHEDHW_output_23 = FloatToBoolean(func_44.output[1]);
    if ( func_44.outputValid[2]) CmValveControlHEDHW_output_24 = FloatToBoolean(func_44.output[2]);
    if ( func_44.outputValid[3]) CmValveControlHEDHW_output_25 = FloatToBoolean(func_44.output[3]);

  }
// macro register which are written multiple times
// macro inputs
public float CmValveControlHEDHW_input_1; // ControlSignal1
public float CmValveControlHEDHW_input_2; // ControlSignal2
public float CmValveControlHEDHW_input_3; // ControlSignal3
// macro outputs
public float CmValveControlHEDHW_output_4; // ValveControl
public boolean CmValveControlHEDHW_output_68; // PumpEnable
public boolean CmValveControlHEDHW_output_23; // ControlSig1Activ
public boolean CmValveControlHEDHW_output_24; // ControlSig2Activ
public boolean CmValveControlHEDHW_output_25; // ControlSig3Activ
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfMinimum func_7 = new CfMinimum();
protected CfIdt func_11 = new CfIdt();
protected CfIdt func_66 = new CfIdt();
protected CfValueRamp func_9 = new CfValueRamp();
protected CfCompare1 func_22 = new CfCompare1();
protected CfCompare1 func_26 = new CfCompare1();
protected CfCompare1 func_29 = new CfCompare1();
protected CfCompare1 func_13 = new CfCompare1();
protected CfInputMultiplexer func_47 = new CfInputMultiplexer();
protected CfHysteresis func_75 = new CfHysteresis();
protected CfInputMultiplexer func_17 = new CfInputMultiplexer();
protected CfInputMultiplexer func_49 = new CfInputMultiplexer();
protected CfInputMultiplexer func_51 = new CfInputMultiplexer();
protected CfOutputMultiplexer func_44 = new CfOutputMultiplexer();

// default constructor
public CmValveControlHEDHW()
{
  func_7.configure(3);
  func_44.configure(4);
}

  public void Start()
  {
    func_9.Start();
    func_75.Start();
  }
}
