/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    boiler_capacity
Macro id:      6085274266449740046
Macro version: 19
Last change:   14.09.2015 - 15:19
Access Level:  2
Inputs:
  [1] Stage1
  [2] Stage2
  [3] StageMod
  [4] boiler group
  [5] RetTempSP
  [6] Alarm
Outputs:
  [1] ActCapacity
  [2] SparePower
  [3] ActCapacity2
Parameter:
  [1] ST1-01: capacity stage 1
  [2] ST2-01: capacity stage 2
  [3] BST-04: minimum boiler supply temperature
Description:

================================================================================*/

public class Cmboiler_capacity
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [75] Function call CfIdt
    func_75.input = 2F;
    func_75.Execute(  );
    env.setParameter(parameterOffset + 3, func_75.output[0]);
    env.setParameter(parameterOffset + 5, func_75.output[1]);

    // [82] Function call CfNot
    func_82.input = Cmboiler_capacity_input_81;
    func_82.Execute(  );

    // [9] Function call CfMultiply
    func_9.input[0] = BooleanToFloat(func_82.output);
    func_9.input[1] = env.getParameter(parameterOffset);
    func_9.input[2] = BooleanToFloat(Cmboiler_capacity_input_1);
    func_9.Execute(  );

    // [30] Function call CfDivide
    func_30.inputA = Cmboiler_capacity_input_3;
    func_30.inputB = 100F;
    func_30.Execute(  );

    // [13] Function call CfMaximum
    func_13.input[0] = BooleanToFloat(Cmboiler_capacity_input_2);
    func_13.input[1] = func_30.output;
    func_13.Execute(  );

    // [11] Function call CfMultiply
    func_11.input[0] = BooleanToFloat(func_82.output);
    func_11.input[1] = env.getParameter(parameterOffset + 1);
    func_11.input[2] = func_13.output;
    func_11.Execute(  );

    // [16] Function call CfAddition
    func_16.input[0] = func_9.output;
    func_16.input[1] = func_11.output;
    func_16.Execute(  );

    // [72] Function call CfIdt
    func_72.input = func_16.output;
    func_72.Execute(  );
    Cmboiler_capacity_output_4 = func_72.output[0];
    Cmboiler_capacity_output_79 = func_72.output[1];

    // [17] Function call CfAddition
    func_17.input[0] = env.getParameter(parameterOffset);
    func_17.input[1] = env.getParameter(parameterOffset + 1);
    func_17.Execute(  );

    // [22] Function call CfSubtract
    func_22.input[0] = func_17.output;
    func_22.input[1] = func_16.output;
    func_22.Execute(  );
    Cmboiler_capacity_output_6 = func_22.output;

    // [59] Function call CfMaximum
    func_59.input[0] = Cmboiler_capacity_output_4;
    func_59.input[1] = 0F;
    func_59.Execute(  );

    // [60] Function call CfMinimum
    func_60.input[0] = func_59.output;
    func_60.input[1] = 9999F;
    func_60.Execute(  );

    // [61] Function call CfTruncate
    func_61.input = func_60.output;
    func_61.Execute(  );

    // [71] Macro call Cmtransfer_power
    func_71.Cmtransfer_power_input_1 = FloatToBoolean(func_16.output);
    func_71.Cmtransfer_power_input_2 = env.getParameter(parameterOffset + 2);
    func_71.Cmtransfer_power_input_15 = Cmboiler_capacity_input_40;
    func_71.Cmtransfer_power_input_67 = 992F;
    func_71.Cmtransfer_power_input_70 = func_61.output;
    func_71.Execute( env, parameterOffset +3 );

    // [64] Function call CfMaximum
    func_64.input[0] = Cmboiler_capacity_output_6;
    func_64.input[1] = 0F;
    func_64.Execute(  );

    // [65] Function call CfMinimum
    func_65.input[0] = func_64.output;
    func_65.input[1] = 9999F;
    func_65.Execute(  );

    // [66] Function call CfTruncate
    func_66.input = func_65.output;
    func_66.Execute(  );

    // [54] Macro call Cmtransfer_power
    func_54.Cmtransfer_power_input_1 = FloatToBoolean(func_16.output);
    func_54.Cmtransfer_power_input_2 = Cmboiler_capacity_input_55;
    func_54.Cmtransfer_power_input_15 = Cmboiler_capacity_input_40;
    func_54.Cmtransfer_power_input_67 = 989F;
    func_54.Cmtransfer_power_input_70 = func_66.output;
    func_54.Execute( env, parameterOffset +5 );

  }
// macro register which are written multiple times
// macro inputs
public boolean Cmboiler_capacity_input_1; // Stage1
public boolean Cmboiler_capacity_input_2; // Stage2
public float Cmboiler_capacity_input_3; // StageMod
public float Cmboiler_capacity_input_40; // boiler group
public float Cmboiler_capacity_input_55; // RetTempSP
public boolean Cmboiler_capacity_input_81; // Alarm
// macro outputs
public float Cmboiler_capacity_output_4; // ActCapacity
public float Cmboiler_capacity_output_6; // SparePower
public float Cmboiler_capacity_output_79; // ActCapacity2
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfIdt func_75 = new CfIdt();
protected CfNot func_82 = new CfNot();
protected CfMultiply func_9 = new CfMultiply();
protected CfDivide func_30 = new CfDivide();
protected CfMaximum func_13 = new CfMaximum();
protected CfMultiply func_11 = new CfMultiply();
protected CfAddition func_16 = new CfAddition();
protected CfIdt func_72 = new CfIdt();
protected CfAddition func_17 = new CfAddition();
protected CfSubtract func_22 = new CfSubtract();
protected CfMaximum func_59 = new CfMaximum();
protected CfMinimum func_60 = new CfMinimum();
protected CfTruncate func_61 = new CfTruncate();
protected Cmtransfer_power func_71 = new Cmtransfer_power();
protected CfMaximum func_64 = new CfMaximum();
protected CfMinimum func_65 = new CfMinimum();
protected CfTruncate func_66 = new CfTruncate();
protected Cmtransfer_power func_54 = new Cmtransfer_power();

// default constructor
public Cmboiler_capacity()
{
  func_75.configure(2);
  func_9.configure(3);
  func_11.configure(3);
  func_72.configure(2);
}

  public void Start()
  {
    func_71.Start();
    func_54.Start();
  }
}
