/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    caretaker
Macro id:      5965719461831902158
Macro version: 8
Last change:   07.06.2016 - 11:05
Access Level:  2
Inputs:
  [1] fiteredoOATemp
  [2] WinterSwitch
  [3] SummerSwitch
Outputs:
  [1] Sommer active (0=Heating)
Parameter:
  [1] OAT-01: high limit smooth filtered long period
  [2] OAT-02: high limit smooth filtered short period
  [3] OAT-04: long time smooth filtering
  [4] DISP-03: long term smooth filtered outside air temperature
Description:

================================================================================*/

public class Cmcaretaker
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [25] Function call CfHysteresis
    func_25.inputX = Cmcaretaker_input_1;
    func_25.inputW = env.getParameter(parameterOffset + 1);
    func_25.Execute( env, parameterOffset + 4 );

    // [34] Function call CfNot
    func_34.input = Cmcaretaker_input_3;
    func_34.Execute(  );

    // [6] Function call CfHysteresis
    func_6.inputX = env.getParameter(parameterOffset + 3);
    func_6.inputW = env.getParameter(parameterOffset);
    func_6.Execute( env, parameterOffset + 5 );

    // [28] Function call CfOr
    func_28.input[0] = Cmcaretaker_input_4;
    func_28.input[1] = func_25.output1;
    func_28.input[2] = func_6.output1;
    func_28.Execute(  );

    // [31] Function call CfAnd
    func_31.input[0] = func_34.output;
    func_31.input[1] = func_28.outputOR;
    func_31.Execute(  );
    Cmcaretaker_output_5 = func_31.outputAND;

    // [18] Macro call CmIDT05
    func_18.CmIDT05_input_1 = 1F;
    func_18.CmIDT05_input_2 = env.getParameter(parameterOffset + 2);
    func_18.CmIDT05_input_3 = 0F;
    func_18.CmIDT05_input_4 = 0F;
    func_18.CmIDT05_input_5 = 0F;
    func_18.Execute(  );
    env.setParameter(parameterOffset + 6, func_18.CmIDT05_output_21);
    env.setParameter(parameterOffset + 7, func_18.CmIDT05_output_22);
    env.setParameter(parameterOffset + 8, func_18.CmIDT05_output_23);

    // [9] Macro call CmFiltered_Temperature
    func_9.CmFiltered_Temperature_input_2 = Cmcaretaker_input_1;
    func_9.CmFiltered_Temperature_input_3 = 0F;
    func_9.Execute( env, parameterOffset +6 );
    env.setParameter(parameterOffset + 3, func_9.CmFiltered_Temperature_output_4);

  }
// macro register which are written multiple times
// macro inputs
public float Cmcaretaker_input_1; // fiteredoOATemp
public boolean Cmcaretaker_input_3; // WinterSwitch
public boolean Cmcaretaker_input_4; // SummerSwitch
// macro outputs
public boolean Cmcaretaker_output_5; // Sommer active (0=Heating)
// helper functions

// class variables
protected CfHysteresis func_25 = new CfHysteresis();
protected CfNot func_34 = new CfNot();
protected CfHysteresis func_6 = new CfHysteresis();
protected CfOr func_28 = new CfOr();
protected CfAnd func_31 = new CfAnd();
protected CmIDT05 func_18 = new CmIDT05();
protected CmFiltered_Temperature func_9 = new CmFiltered_Temperature();

// default constructor
public Cmcaretaker()
{
  func_28.configure(3);
}

  public void Start()
  {
    func_25.Start();
    func_6.Start();
    func_18.Start();
    func_9.Start();
  }
}
