/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    forward time calculation
Macro id:      6025467389602169269
Macro version: 22
Last change:   05.03.2018 - 10:57
Access Level:  2
Inputs:
  [1] setpoint
  [2] temp input
Outputs:
  [1] DISP-04: calc time reach setp
  [2] DISP-05: exp sys sup temp
  [3] SST09 exceeded
Parameter:
  [1] SST-08: forward time expected system supply temperature
  [2] SST-09: time to reach setpoint
  [3] SST-01: minimum supply temperature
  [4] SST-02: maximum supply temperature
Description:

================================================================================*/

public class Cmforward_time_calculation
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [77] Function call CfIdt
    func_77.input = 30F;
    func_77.Execute(  );
    env.setParameter(parameterOffset + 5, func_77.output[0]);

    // [50] Macro call CmCycleTime
    func_50.Execute( env, parameterOffset +4 );

    // [42] Function call CfLastValue
    func_42.input = Cmforward_time_calculation_input_2;
    func_42.Execute(  );

    // [45] Function call CfSubtract
    func_45.input[0] = func_42.outputCurrent;
    func_45.input[1] = func_42.outputLast;
    func_45.Execute(  );

    // [76] Macro call CmE_Filter
    func_76.CmE_Filter_input_23 = func_45.output;
    func_76.CmE_Filter_input_47 = func_50.CmCycleTime_output_1;
    func_76.CmE_Filter_input_67 = 100F;
    func_76.Execute( env, parameterOffset +5 );

    // [79] Function call CfDivide
    func_79.inputA = 60F;
    func_79.inputB = func_50.CmCycleTime_output_1;
    func_79.Execute(  );

    // [40] Function call CfMultiply
    func_40.input[0] = func_76.CmE_Filter_output_24;
    func_40.input[1] = env.getParameter(parameterOffset);
    func_40.input[2] = func_79.output;
    func_40.Execute(  );

    // [41] Function call CfAddition
    func_41.input[0] = func_40.output;
    func_41.input[1] = Cmforward_time_calculation_input_2;
    func_41.Execute(  );

    // [152] Function call CfSubtract
    func_152.input[0] = env.getParameter(parameterOffset + 2);
    func_152.input[1] = 5F;
    func_152.Execute(  );

    // [148] Function call CfMaximum
    func_148.input[0] = func_41.output;
    func_148.input[1] = func_152.output;
    func_148.Execute(  );

    // [153] Function call CfAddition
    func_153.input[0] = 5F;
    func_153.input[1] = env.getParameter(parameterOffset + 3);
    func_153.Execute(  );

    // [146] Function call CfMinimum
    func_146.input[0] = func_148.output;
    func_146.input[1] = func_153.output;
    func_146.Execute(  );
    Cmforward_time_calculation_output_73 = func_146.output;

    // [7] Function call CfSubtract
    func_7.input[0] = Cmforward_time_calculation_input_1;
    func_7.input[1] = Cmforward_time_calculation_input_2;
    func_7.Execute(  );

    // [54] Function call CfMultiply
    func_54.input[0] = func_76.CmE_Filter_output_24;
    func_54.input[1] = func_79.output;
    func_54.Execute(  );

    // [12] Function call CfDivide
    func_12.inputA = func_7.output;
    func_12.inputB = func_54.output;
    func_12.Execute(  );

    // [86] Function call CfMinimum
    func_86.input[0] = func_12.output;
    func_86.input[1] = 999F;
    func_86.Execute(  );

    // [87] Function call CfMaximum
    func_87.input[0] = func_86.output;
    func_87.input[1] = -999F;
    func_87.Execute(  );

    // [94] Function call CfCompare1
    func_94.inputA = Cmforward_time_calculation_input_1;
    func_94.inputB = Cmforward_time_calculation_input_2;
    func_94.Execute(  );

    // [114] Function call CfOr
    func_114.input[0] = func_94.outputEqual;
    func_114.input[1] = func_94.outputLess;
    func_114.Execute(  );

    // [91] Function call CfCompare1
    func_91.inputA = func_76.CmE_Filter_output_24;
    func_91.inputB = 0F;
    func_91.Execute(  );

    // [101] Function call CfAnd
    func_101.input[0] = func_91.outputGreater;
    func_101.input[1] = func_114.outputOR;
    func_101.Execute(  );

    // [98] Function call CfAnd
    func_98.input[0] = func_91.outputLess;
    func_98.input[1] = func_94.outputGreater;
    func_98.Execute(  );

    // [104] Function call CfOr
    func_104.input[0] = func_98.outputAND;
    func_104.input[1] = func_101.outputAND;
    func_104.Execute(  );

    // [57] Function call CfAbsolute
    func_57.input = func_87.output;
    func_57.Execute(  );

    // [90] Function call CfInputMultiplexer
    func_90.inputSelect = BooleanToInt(func_104.outputOR);
    func_90.input[1-1] = func_57.outputAbs;
    func_90.input[2-1] = 999F;
    func_90.Execute(  );

    // [16] Function call CfCompare1
    func_16.inputA = func_90.output;
    func_16.inputB = env.getParameter(parameterOffset + 1);
    func_16.Execute(  );
    Cmforward_time_calculation_output_19 = func_16.outputGreater;

    // [156] Function call CfCompare1
    func_156.inputA = func_87.output;
    func_156.inputB = 0F;
    func_156.Execute(  );

    // [109] Function call CfInputMultiplexer
    func_109.inputSelect = BooleanToInt(func_156.outputLess);
    func_109.input[1-1] = func_57.outputAbs;
    func_109.input[2-1] = 999F;
    func_109.Execute(  );
    Cmforward_time_calculation_output_72 = func_109.output;

  }
// macro register which are written multiple times
// macro inputs
public float Cmforward_time_calculation_input_1; // setpoint
public float Cmforward_time_calculation_input_2; // temp input
// macro outputs
public float Cmforward_time_calculation_output_72; // DISP-04: calc time reach setp
public float Cmforward_time_calculation_output_73; // DISP-05: exp sys sup temp
public boolean Cmforward_time_calculation_output_19; // SST09 exceeded
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfIdt func_77 = new CfIdt();
protected CmCycleTime func_50 = new CmCycleTime();
protected CfLastValue func_42 = new CfLastValue();
protected CfSubtract func_45 = new CfSubtract();
protected CmE_Filter func_76 = new CmE_Filter();
protected CfDivide func_79 = new CfDivide();
protected CfMultiply func_40 = new CfMultiply();
protected CfAddition func_41 = new CfAddition();
protected CfSubtract func_152 = new CfSubtract();
protected CfMaximum func_148 = new CfMaximum();
protected CfAddition func_153 = new CfAddition();
protected CfMinimum func_146 = new CfMinimum();
protected CfSubtract func_7 = new CfSubtract();
protected CfMultiply func_54 = new CfMultiply();
protected CfDivide func_12 = new CfDivide();
protected CfMinimum func_86 = new CfMinimum();
protected CfMaximum func_87 = new CfMaximum();
protected CfCompare1 func_94 = new CfCompare1();
protected CfOr func_114 = new CfOr();
protected CfCompare1 func_91 = new CfCompare1();
protected CfAnd func_101 = new CfAnd();
protected CfAnd func_98 = new CfAnd();
protected CfOr func_104 = new CfOr();
protected CfAbsolute func_57 = new CfAbsolute();
protected CfInputMultiplexer func_90 = new CfInputMultiplexer();
protected CfCompare1 func_16 = new CfCompare1();
protected CfCompare1 func_156 = new CfCompare1();
protected CfInputMultiplexer func_109 = new CfInputMultiplexer();

// default constructor
public Cmforward_time_calculation()
{
  func_40.configure(3);
}

  public void Start()
  {
    func_50.Start();
    func_42.Start();
    func_76.Start();
  }
}
