/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:33
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.heating;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    temperature control
Macro id:      6021800498444632637
Macro version: 5
Last change:   03.02.2015 - 07:28
Access Level:  2
Inputs:
  [1] setpoint
  [2] system supply temp
  [3] system return temp
Outputs:
  [1] PI control
  [2] control temp sensor
Parameter:
  [1] P-Band
  [2] I-Time
  [3] control mode conf
Description:

================================================================================*/

public class Cmtemperature_control
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [36] Function call CfIdt
    func_36.input = env.getParameter(parameterOffset);
    func_36.Execute(  );
    env.setParameter(parameterOffset + 3, func_36.output[0]);

    // [37] Function call CfIdt
    func_37.input = env.getParameter(parameterOffset + 1);
    func_37.Execute(  );
    env.setParameter(parameterOffset + 5, func_37.output[0]);

    // [29] Function call CfCompare2
    func_29.inputA = Cmtemperature_control_input_16;
    func_29.inputB = 999F;
    func_29.Execute(  );

    // [30] Function call CfCompare2
    func_30.inputA = Cmtemperature_control_input_17;
    func_30.inputB = 999F;
    func_30.Execute(  );

    // [31] Function call CfInputMultiplexer
    func_31.inputSelect = BooleanToInt(func_29.outputEqualOrGreater);
    func_31.input[1-1] = Cmtemperature_control_input_16;
    func_31.input[2-1] = 0F;
    func_31.Execute(  );

    // [32] Function call CfInputMultiplexer
    func_32.inputSelect = BooleanToInt(func_30.outputEqualOrGreater);
    func_32.input[1-1] = Cmtemperature_control_input_17;
    func_32.input[2-1] = 0F;
    func_32.Execute(  );

    // [10] Function call CfCompare1
    func_10.inputA = env.getParameter(parameterOffset + 1);
    func_10.inputB = 0F;
    func_10.Execute(  );

    // [15] Function call CfMaximum
    func_15.input[0] = func_31.output;
    func_15.input[1] = func_32.output;
    func_15.Execute(  );

    // [8] Function call CfInputMultiplexer
    func_8.inputSelect = BooleanToInt(func_10.outputGreater);
    func_8.input[1-1] = 0F;
    func_8.input[2-1] = env.getParameter(parameterOffset + 1);
    func_8.Execute(  );

    // [46] Function call CfInputMultiplexer
    func_46.inputSelect = FloatToInt(env.getParameter(parameterOffset + 2));
    func_46.input[1-1] = Cmtemperature_control_input_16;
    func_46.input[2-1] = Cmtemperature_control_input_16;
    func_46.input[3-1] = Cmtemperature_control_input_17;
    func_46.input[4-1] = func_15.output;
    func_46.Execute(  );

    // [6] Function call CfPidPlus
    func_6.inputX = func_46.output;
    func_6.inputW = Cmtemperature_control_input_1;
    func_6.inputIntegralOn = FloatToBoolean(func_8.output);
    func_6.Execute( env, parameterOffset + 3 );
    Cmtemperature_control_output_2 = func_6.output;

    // [57] Function call CfIdt
    func_57.input = func_46.output;
    func_57.Execute(  );
    Cmtemperature_control_output_56 = func_57.output[0];

  }
// macro register which are written multiple times
// macro inputs
public float Cmtemperature_control_input_1; // setpoint
public float Cmtemperature_control_input_16; // system supply temp
public float Cmtemperature_control_input_17; // system return temp
// macro outputs
public float Cmtemperature_control_output_2; // PI control
public float Cmtemperature_control_output_56; // control temp sensor
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfIdt func_36 = new CfIdt();
protected CfIdt func_37 = new CfIdt();
protected CfCompare2 func_29 = new CfCompare2();
protected CfCompare2 func_30 = new CfCompare2();
protected CfInputMultiplexer func_31 = new CfInputMultiplexer();
protected CfInputMultiplexer func_32 = new CfInputMultiplexer();
protected CfCompare1 func_10 = new CfCompare1();
protected CfMaximum func_15 = new CfMaximum();
protected CfInputMultiplexer func_8 = new CfInputMultiplexer();
protected CfInputMultiplexer func_46 = new CfInputMultiplexer();
protected CfPidPlus func_6 = new CfPidPlus();
protected CfIdt func_57 = new CfIdt();

// default constructor
public Cmtemperature_control()
{
  func_46.configure(5);
}

  public void Start()
  {
    func_6.Start();
  }
}
