/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    CSA_ConstSupplyAirNordic
Macro id:      5972416096844284650
Macro version: 14
Last change:   26.03.2018 - 11:43
Access Level:  2
Inputs:
  [1] SupplyAirTemp
  [2] SupplyAirTempSp
  [3] HVAC_Mode
  [4] ContrPtAdj
  [5] FilteredOATemp
  [6] CO2_Sensor
  [7] FanEnable
  [8] EnRecSeqSwitch
  [9] PlantMode
  [10] HumidityMode
Outputs:
  [1] HeatCtrlSig
  [2] CoolCtrlSig
  [3] ERCCtrlSig
  [4] FanSpeedCtrlSig
  [5] FanStageCmd
  [6] CalcSupAirTmpSp
  [7] OATLimitCooling
  [8] SAT_ContrDev
Parameter:
  [1] START-01: limit OAT to start frost  protection
  [2] START-02: supply air temperature setpoint raise
  [3] START-03: SAT control raised setpoint decrease time
  [4] OAT-01: limit OAT;  heater closed
  [5] OAT-02: limit OAT;  cooler closed
  [6] SAT-01: supply air temperature low setpoint
  [7] SAT-02: supply air temperature high setpoint
  [8] WCS-01: start point OAT winter comp. SAT
  [9] WCS-02: end  point OAT winter comp. SAT
  [10] WCS-03: supply air temperature setpoint  raise
  [11] SAT-03: supply air temp. control P-band
  [12] SAT-04: supply air temp. control I-time
  [13] SAT-05: sequence start point heating valve
  [14] SAT-06: sequence end point heating valve
  [15] SAT-09: sequence start point energy recovery
  [16] SAT-10 :sequence end point energy recovery
  [17] SAT-11: sequence start point cooling valve
  [18] SAT-12: sequence end point cooling valve
  [19] CO2-01: air quality setpoint ; 0 = disable internal controller
  [20] CO2-02: air quality P-band
  [21] CO2-05: sequence start point air quality override fan speed
  [22] CO2-06: sequence end point air quality override fan speed
  [23] SCR-01: start point OAT summer comp. SAT
  [24] SCR-02: stop point OAT summer comp. SAT
  [25] SCR-03: supply temperature setpoint raise
Description:
The macro is a control strategy module for an air handling unit with fresh air dampers. It determines the control strategy of an air handling unit with integrated options for fan enable, plant, humidity and economiser mode overrides.
The air handling strategy provides the following functions: 

Configuration
 - Defined start procedure after download, power failure or alarm 

Energy Saving Functions
 - Outdoor Temperature Heating/ Cooling Limits 
 - Summer/ Winter Compensation 
 - CO2 Or Air Quality Override Control 
 - Reversing Energy Recovery Control Signal 

Protection Functions 
 - Frost Protection and Frost Recovery 
 - Delayed Switch Off 

Overrides 
 - Plant Mode 
 - Humidity Mode
================================================================================*/

public class BCmCSA_ConstSupplyAirNordic
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmCSA_ConstSupplyAirNordic_output_11().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmCSA_ConstSupplyAirNordic_output_11().setStatus(BStatus.disabled);
    getCmCSA_ConstSupplyAirNordic_output_12().setStatus(BStatus.disabled);
    getCmCSA_ConstSupplyAirNordic_output_13().setStatus(BStatus.disabled);
    getCmCSA_ConstSupplyAirNordic_output_14().setStatus(BStatus.disabled);
    getCmCSA_ConstSupplyAirNordic_output_15().setStatus(BStatus.disabled);
    getCmCSA_ConstSupplyAirNordic_output_16().setStatus(BStatus.disabled);
    getCmCSA_ConstSupplyAirNordic_output_163().setStatus(BStatus.disabled);
    getCmCSA_ConstSupplyAirNordic_output_149().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmCSA_ConstSupplyAirNordic_output_11().setStatus(BStatus.ok);
    getCmCSA_ConstSupplyAirNordic_output_12().setStatus(BStatus.ok);
    getCmCSA_ConstSupplyAirNordic_output_13().setStatus(BStatus.ok);
    getCmCSA_ConstSupplyAirNordic_output_14().setStatus(BStatus.ok);
    getCmCSA_ConstSupplyAirNordic_output_15().setStatus(BStatus.ok);
    getCmCSA_ConstSupplyAirNordic_output_16().setStatus(BStatus.ok);
    getCmCSA_ConstSupplyAirNordic_output_163().setStatus(BStatus.ok);
    getCmCSA_ConstSupplyAirNordic_output_149().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [54] Macro call CmIDT20
    func_54.CmIDT20_input_1 = (float) getCmCSA_ConstSupplyAirNordic_parameter_17();
    func_54.CmIDT20_input_2 = (float) getCmCSA_ConstSupplyAirNordic_parameter_18();
    func_54.CmIDT20_input_3 = (float) getCmCSA_ConstSupplyAirNordic_parameter_19();
    func_54.CmIDT20_input_4 = (float) getCmCSA_ConstSupplyAirNordic_parameter_20();
    func_54.CmIDT20_input_5 = (float) getCmCSA_ConstSupplyAirNordic_parameter_21();
    func_54.CmIDT20_input_6 = (float) getCmCSA_ConstSupplyAirNordic_parameter_22();
    func_54.CmIDT20_input_7 = (float) getCmCSA_ConstSupplyAirNordic_parameter_23();
    func_54.CmIDT20_input_8 = (float) getCmCSA_ConstSupplyAirNordic_parameter_24();
    func_54.CmIDT20_input_9 = (float) getCmCSA_ConstSupplyAirNordic_parameter_25();
    func_54.CmIDT20_input_10 = (float) getCmCSA_ConstSupplyAirNordic_parameter_26();
    func_54.CmIDT20_input_11 = (float) getCmCSA_ConstSupplyAirNordic_parameter_28();
    func_54.CmIDT20_input_12 = (float) getCmCSA_ConstSupplyAirNordic_parameter_29();
    func_54.CmIDT20_input_13 = (float) getCmCSA_ConstSupplyAirNordic_parameter_27();
    func_54.CmIDT20_input_14 = (float) getCmCSA_ConstSupplyAirNordic_parameter_30();
    func_54.CmIDT20_input_15 = (float) getCmCSA_ConstSupplyAirNordic_parameter_31();
    func_54.CmIDT20_input_16 = (float) getCmCSA_ConstSupplyAirNordic_parameter_32();
    func_54.CmIDT20_input_17 = (float) getCmCSA_ConstSupplyAirNordic_parameter_33();
    func_54.CmIDT20_input_18 = (float) getCmCSA_ConstSupplyAirNordic_parameter_34();
    func_54.CmIDT20_input_19 = (float) getCmCSA_ConstSupplyAirNordic_parameter_35();
    func_54.CmIDT20_input_20 = (float) getCmCSA_ConstSupplyAirNordic_parameter_36();
    func_54.Execute(  );
    setParameter(0, func_54.CmIDT20_output_21);
    setParameter(12, func_54.CmIDT20_output_22);
    setParameter(13, func_54.CmIDT20_output_23);
    setParameter(33, func_54.CmIDT20_output_24);
    setParameter(34, func_54.CmIDT20_output_25);
    setParameter(15, func_54.CmIDT20_output_26);
    setParameter(16, func_54.CmIDT20_output_27);
    setParameter(3, func_54.CmIDT20_output_28);
    setParameter(4, func_54.CmIDT20_output_29);
    setParameter(5, func_54.CmIDT20_output_30);
    setParameter(17, func_54.CmIDT20_output_31);
    setParameter(18, func_54.CmIDT20_output_32);
    setParameter(27, func_54.CmIDT20_output_33);
    setParameter(28, func_54.CmIDT20_output_34);
    setParameter(29, func_54.CmIDT20_output_35);
    setParameter(30, func_54.CmIDT20_output_36);
    setParameter(31, func_54.CmIDT20_output_37);
    setParameter(32, func_54.CmIDT20_output_38);
    setParameter(35, func_54.CmIDT20_output_39);
    setParameter(36, func_54.CmIDT20_output_40);

    // [70] Macro call CmIDT05
    func_70.CmIDT05_input_1 = (float) getCmCSA_ConstSupplyAirNordic_parameter_37();
    func_70.CmIDT05_input_2 = (float) getCmCSA_ConstSupplyAirNordic_parameter_38();
    func_70.CmIDT05_input_3 = (float) getCmCSA_ConstSupplyAirNordic_parameter_19();
    func_70.CmIDT05_input_4 = 0F;
    func_70.CmIDT05_input_5 = 0F;
    func_70.Execute(  );
    setParameter(39, func_70.CmIDT05_output_21);
    setParameter(40, func_70.CmIDT05_output_22);
    setParameter(1, func_70.CmIDT05_output_23);
    setParameter(37, func_70.CmIDT05_output_24);
    setParameter(38, func_70.CmIDT05_output_25);

    // [152] Function call CfIdt
    func_152.input = 0F;
    func_152.Execute(  );
    setParameter(25, func_152.output[0]);

    // [183] Macro call CmIDT05
    func_183.CmIDT05_input_1 = (float) getCmCSA_ConstSupplyAirNordic_parameter_180();
    func_183.CmIDT05_input_2 = (float) getCmCSA_ConstSupplyAirNordic_parameter_181();
    func_183.CmIDT05_input_3 = (float) getCmCSA_ConstSupplyAirNordic_parameter_182();
    func_183.CmIDT05_input_4 = 0F;
    func_183.CmIDT05_input_5 = 0F;
    func_183.Execute(  );
    setParameter(6, func_183.CmIDT05_output_21);
    setParameter(7, func_183.CmIDT05_output_22);
    setParameter(8, func_183.CmIDT05_output_23);

    // [40] Macro call CmAHU_Startup
    func_40.CmAHU_Startup_input_14 = getCmCSA_ConstSupplyAirNordic_input_4().getValue();
    func_40.CmAHU_Startup_input_15 = (float) getCmCSA_ConstSupplyAirNordic_input_6().getValue();
    func_40.CmAHU_Startup_input_16 = (float) getCmCSA_ConstSupplyAirNordic_input_5().getValue();
    func_40.Execute( this, 0 );

    // [82] Macro call CmControl_Point_Adjustment
    func_82.CmControl_Point_Adjustment_input_7 = (float) getCmCSA_ConstSupplyAirNordic_input_3().getValue();
    func_82.Execute(  );

    // [86] Macro call CmConstant_SAT_ontrol
    func_86.CmConstant_SAT_ontrol_input_5 = (float) getCmCSA_ConstSupplyAirNordic_input_5().getValue();
    func_86.CmConstant_SAT_ontrol_input_6 = (float) getCmCSA_ConstSupplyAirNordic_input_9().getValue();
    func_86.CmConstant_SAT_ontrol_input_10 = func_82.CmControl_Point_Adjustment_output_10;
    func_86.Execute( this, 3 );

    // [43] Macro call CmAHU_Setpoint_Ramp
    func_43.CmAHU_Setpoint_Ramp_input_1 = func_40.CmAHU_Startup_output_35;
    func_43.CmAHU_Setpoint_Ramp_input_47 = func_86.CmConstant_SAT_ontrol_output_16;
    func_43.Execute( this, 12 );

    // [118] Macro call CmLimit_SAT
    func_118.CmLimit_SAT_input_1 = func_43.CmAHU_Setpoint_Ramp_output_48;
    func_118.CmLimit_SAT_input_14 = 0F;
    func_118.Execute( this, 15 );
    setCmCSA_ConstSupplyAirNordic_output_16(func_118.CmLimit_SAT_output_2);

    // [140] Macro call CmSupply_PID
    func_140.CmSupply_PID_input_13 = func_118.CmLimit_SAT_output_3;
    func_140.CmSupply_PID_input_14 = (float) getCmCSA_ConstSupplyAirNordic_input_1().getValue();
    func_140.CmSupply_PID_input_15 = func_40.CmAHU_Startup_output_34;
    func_140.Execute( this, 17 );

    // [121] Macro call CmERC_Reverse
    func_121.CmERC_Reverse_input_2 = 999F;
    func_121.CmERC_Reverse_input_4 = 999F;
    func_121.CmERC_Reverse_input_29 = 999F;
    func_121.CmERC_Reverse_input_3 = getCmCSA_ConstSupplyAirNordic_input_8().getValue();
    func_121.Execute( this, 25 );

    // [104] Macro call CmOutput_Sequence
    func_104.CmOutput_Sequence_input_1 = func_140.CmSupply_PID_output_22;
    func_104.CmOutput_Sequence_input_37 = func_121.CmERC_Reverse_output_1;
    func_104.Execute( this, 27 );

    // [157] Macro call CmOAT_Limits_Nordic
    func_157.CmOAT_Limits_Nordic_input_16 = (float) getCmCSA_ConstSupplyAirNordic_input_5().getValue();
    func_157.CmOAT_Limits_Nordic_input_21 = (float) getCmCSA_ConstSupplyAirNordic_input_7().getValue();
    func_157.CmOAT_Limits_Nordic_input_1 = func_104.CmOutput_Sequence_output_2;
    func_157.CmOAT_Limits_Nordic_input_2 = func_104.CmOutput_Sequence_output_3;
    func_157.CmOAT_Limits_Nordic_input_29 = (float) getCmCSA_ConstSupplyAirNordic_input_160().getValue();
    func_157.Execute( this, 33 );

    // [101] Macro call CmCO2_Control
    func_101.CmCO2_Control_input_1 = 0F;
    func_101.CmCO2_Control_input_51 = 0F;
    func_101.CmCO2_Control_input_7 = (float) getCmCSA_ConstSupplyAirNordic_input_2().getValue();
    func_101.Execute( this, 35 );

    // [76] Macro call CmFrost_Protection
    func_76.CmFrost_Protection_input_35 = func_40.CmAHU_Startup_output_34;
    func_76.CmFrost_Protection_input_51 = func_40.CmAHU_Startup_output_79;
    func_76.CmFrost_Protection_input_1 = func_157.CmOAT_Limits_Nordic_output_3;
    func_76.CmFrost_Protection_input_2 = func_157.CmOAT_Limits_Nordic_output_4;
    func_76.CmFrost_Protection_input_3 = func_104.CmOutput_Sequence_output_4;
    func_76.CmFrost_Protection_input_4 = func_101.CmCO2_Control_output_2;
    func_76.CmFrost_Protection_input_38 = 0F;
    func_76.CmFrost_Protection_input_22 = (float) getCmCSA_ConstSupplyAirNordic_input_6().getValue();
    func_76.Execute( this, 46 );
    setCmCSA_ConstSupplyAirNordic_output_11(func_76.CmFrost_Protection_output_6);
    setCmCSA_ConstSupplyAirNordic_output_12(func_76.CmFrost_Protection_output_7);
    setCmCSA_ConstSupplyAirNordic_output_13(func_76.CmFrost_Protection_output_8);
    setCmCSA_ConstSupplyAirNordic_output_14(func_76.CmFrost_Protection_output_9);
    setCmCSA_ConstSupplyAirNordic_output_15(func_76.CmFrost_Protection_output_10);

    // [150] Function call CfSubtract
    func_150.input[0] = (float) getCmCSA_ConstSupplyAirNordic_output_16().getValue();
    func_150.input[1] = (float) getCmCSA_ConstSupplyAirNordic_input_1().getValue();
    func_150.Execute(  );
    setCmCSA_ConstSupplyAirNordic_output_149(func_150.output);

    // [164] Function call CfCompare1
    func_164.inputA = (float) getCmCSA_ConstSupplyAirNordic_input_160().getValue();
    func_164.inputB = 999F;
    func_164.Execute(  );

    // [165] Function call CfInputMultiplexer
    func_165.inputSelect = BooleanToInt(func_164.outputEqual);
    func_165.input[1-1] = 999F;
    func_165.input[2-1] = (float) getCmCSA_ConstSupplyAirNordic_parameter_21();
    func_165.Execute(  );
    setCmCSA_ConstSupplyAirNordic_output_163(func_165.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    6F, 600F, 10F, -10F, 10F, 4F, 28F, 34F,
    4F, -10F, 10F, 4F, 10F, 600F, 1F, 14F,
    26F, 15F, 600F, 10F, 3F, 0F, 1000F, 100F,
    0F, 1F, 1F, 0F, 35F, 55F, 75F, 75F,
    100F, 20F, 14F, 1000F, 200F, 0F, 50F, 50F,
    100F, 3F, 0F, 0F, 100F, 0F, 10F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// HeatCtrlSig
  public static final Property CmCSA_ConstSupplyAirNordic_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_output_11() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_output_11); }
  public void setCmCSA_ConstSupplyAirNordic_output_11(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_output_11,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_output_11(float v) { getCmCSA_ConstSupplyAirNordic_output_11().setValue(v); }
// CoolCtrlSig
  public static final Property CmCSA_ConstSupplyAirNordic_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_output_12() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_output_12); }
  public void setCmCSA_ConstSupplyAirNordic_output_12(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_output_12,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_output_12(float v) { getCmCSA_ConstSupplyAirNordic_output_12().setValue(v); }
// ERCCtrlSig
  public static final Property CmCSA_ConstSupplyAirNordic_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_output_13() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_output_13); }
  public void setCmCSA_ConstSupplyAirNordic_output_13(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_output_13,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_output_13(float v) { getCmCSA_ConstSupplyAirNordic_output_13().setValue(v); }
// FanSpeedCtrlSig
  public static final Property CmCSA_ConstSupplyAirNordic_output_14 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_output_14() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_output_14); }
  public void setCmCSA_ConstSupplyAirNordic_output_14(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_output_14,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_output_14(float v) { getCmCSA_ConstSupplyAirNordic_output_14().setValue(v); }
// FanStageCmd
  public static final Property CmCSA_ConstSupplyAirNordic_output_15 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_output_15() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_output_15); }
  public void setCmCSA_ConstSupplyAirNordic_output_15(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_output_15,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_output_15(float v) { getCmCSA_ConstSupplyAirNordic_output_15().setValue(v); }
// CalcSupAirTmpSp
  public static final Property CmCSA_ConstSupplyAirNordic_output_16 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_output_16() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_output_16); }
  public void setCmCSA_ConstSupplyAirNordic_output_16(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_output_16,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_output_16(float v) { getCmCSA_ConstSupplyAirNordic_output_16().setValue(v); }
// OATLimitCooling
  public static final Property CmCSA_ConstSupplyAirNordic_output_163 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_output_163() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_output_163); }
  public void setCmCSA_ConstSupplyAirNordic_output_163(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_output_163,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_output_163(float v) { getCmCSA_ConstSupplyAirNordic_output_163().setValue(v); }
// SAT_ContrDev
  public static final Property CmCSA_ConstSupplyAirNordic_output_149 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_output_149() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_output_149); }
  public void setCmCSA_ConstSupplyAirNordic_output_149(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_output_149,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_output_149(float v) { getCmCSA_ConstSupplyAirNordic_output_149().setValue(v); }

  // macro parameter
// START-01: limit OAT to start frost  protection
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_17 = newProperty( 0, BDouble.make( 6 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(10)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_17() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_17); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_17(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_17,v,null); }
// START-02: supply air temperature setpoint raise
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_18 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_18() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_18); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_18(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_18,v,null); }
// START-03: SAT control raised setpoint decrease time
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_19 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_19() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_19); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_19(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_19,v,null); }
// OAT-01: limit OAT;  heater closed
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_20 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_20() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_20); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_20(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_20,v,null); }
// OAT-02: limit OAT;  cooler closed
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_21 = newProperty( 0, BDouble.make( 6 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_21() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_21); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_21(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_21,v,null); }
// SAT-01: supply air temperature low setpoint
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_22 = newProperty( 0, BDouble.make( 14 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(6)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_22() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_22); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_22(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_22,v,null); }
// SAT-02: supply air temperature high setpoint
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_23 = newProperty( 0, BDouble.make( 35 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(6)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_23() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_23); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_23(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_23,v,null); }
// WCS-01: start point OAT winter comp. SAT
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_24 = newProperty( 0, BDouble.make( -10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_24() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_24); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_24(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_24,v,null); }
// WCS-02: end  point OAT winter comp. SAT
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_25 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_25() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_25); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_25(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_25,v,null); }
// WCS-03: supply air temperature setpoint  raise
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_26 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(10)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_26() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_26); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_26(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_26,v,null); }
// SAT-03: supply air temp. control P-band
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_28 = newProperty( 0, BDouble.make( 200 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(5000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_28() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_28); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_28(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_28,v,null); }
// SAT-04: supply air temp. control I-time
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_29 = newProperty( 0, BDouble.make( 50 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_29() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_29); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_29(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_29,v,null); }
// SAT-05: sequence start point heating valve
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_27 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_27() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_27); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_27(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_27,v,null); }
// SAT-06: sequence end point heating valve
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_30 = newProperty( 0, BDouble.make( 50 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_30() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_30); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_30(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_30,v,null); }
// SAT-09: sequence start point energy recovery
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_31 = newProperty( 0, BDouble.make( 50 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_31() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_31); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_31(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_31,v,null); }
// SAT-10 :sequence end point energy recovery
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_32 = newProperty( 0, BDouble.make( 75 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_32() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_32); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_32(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_32,v,null); }
// SAT-11: sequence start point cooling valve
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_33 = newProperty( 0, BDouble.make( 75 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_33() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_33); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_33(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_33,v,null); }
// SAT-12: sequence end point cooling valve
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_34 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_34() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_34); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_34(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_34,v,null); }
// CO2-01: air quality setpoint ; 0 = disable internal controller
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_35 = newProperty( 0, BDouble.make( 1000 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(10000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("parts per million"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_35() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_35); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_35(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_35,v,null); }
// CO2-02: air quality P-band
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_36 = newProperty( 0, BDouble.make( 200 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("parts per million"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_36() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_36); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_36(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_36,v,null); }
// CO2-05: sequence start point air quality override fan speed
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_37 = newProperty( 0, BDouble.make( 50 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_37() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_37); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_37(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_37,v,null); }
// CO2-06: sequence end point air quality override fan speed
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_38 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_38() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_38); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_38(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_38,v,null); }
// SCR-01: start point OAT summer comp. SAT
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_180 = newProperty( 0, BDouble.make( 28 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_180() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_180); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_180(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_180,v,null); }
// SCR-02: stop point OAT summer comp. SAT
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_181 = newProperty( 0, BDouble.make( 34 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_181() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_181); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_181(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_181,v,null); }
// SCR-03: supply temperature setpoint raise
  public static final Property CmCSA_ConstSupplyAirNordic_parameter_182 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(10)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmCSA_ConstSupplyAirNordic_parameter_182() { return getDouble(CmCSA_ConstSupplyAirNordic_parameter_182); }
  public void setCmCSA_ConstSupplyAirNordic_parameter_182(double v) { setDouble(CmCSA_ConstSupplyAirNordic_parameter_182,v,null); }

  // macro inputs
// SupplyAirTemp
  public static final Property CmCSA_ConstSupplyAirNordic_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_input_1() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_input_1); }
  public void setCmCSA_ConstSupplyAirNordic_input_1(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_input_1,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_input_1(float v) { getCmCSA_ConstSupplyAirNordic_input_1().setValue(v); }
// SupplyAirTempSp
  public static final Property CmCSA_ConstSupplyAirNordic_input_9 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_input_9() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_input_9); }
  public void setCmCSA_ConstSupplyAirNordic_input_9(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_input_9,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_input_9(float v) { getCmCSA_ConstSupplyAirNordic_input_9().setValue(v); }
// HVAC_Mode
  public static final Property CmCSA_ConstSupplyAirNordic_input_160 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_input_160() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_input_160); }
  public void setCmCSA_ConstSupplyAirNordic_input_160(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_input_160,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_input_160(float v) { getCmCSA_ConstSupplyAirNordic_input_160().setValue(v); }
// ContrPtAdj
  public static final Property CmCSA_ConstSupplyAirNordic_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_input_3() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_input_3); }
  public void setCmCSA_ConstSupplyAirNordic_input_3(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_input_3,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_input_3(float v) { getCmCSA_ConstSupplyAirNordic_input_3().setValue(v); }
// FilteredOATemp
  public static final Property CmCSA_ConstSupplyAirNordic_input_5 = newProperty( Flags.SUMMARY, new BStatusNumeric( 15 ), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_input_5() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_input_5); }
  public void setCmCSA_ConstSupplyAirNordic_input_5(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_input_5,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_input_5(float v) { getCmCSA_ConstSupplyAirNordic_input_5().setValue(v); }
// CO2_Sensor
  public static final Property CmCSA_ConstSupplyAirNordic_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_input_2() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_input_2); }
  public void setCmCSA_ConstSupplyAirNordic_input_2(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_input_2,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_input_2(float v) { getCmCSA_ConstSupplyAirNordic_input_2().setValue(v); }
// FanEnable
  public static final Property CmCSA_ConstSupplyAirNordic_input_4 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmCSA_ConstSupplyAirNordic_input_4() { return (BStatusBoolean) get(CmCSA_ConstSupplyAirNordic_input_4); }
  public void setCmCSA_ConstSupplyAirNordic_input_4(BStatusBoolean v) { set(CmCSA_ConstSupplyAirNordic_input_4,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_input_4(boolean v) { getCmCSA_ConstSupplyAirNordic_input_4().setValue(v); }
// EnRecSeqSwitch
  public static final Property CmCSA_ConstSupplyAirNordic_input_8 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmCSA_ConstSupplyAirNordic_input_8() { return (BStatusBoolean) get(CmCSA_ConstSupplyAirNordic_input_8); }
  public void setCmCSA_ConstSupplyAirNordic_input_8(BStatusBoolean v) { set(CmCSA_ConstSupplyAirNordic_input_8,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_input_8(boolean v) { getCmCSA_ConstSupplyAirNordic_input_8().setValue(v); }
// PlantMode
  public static final Property CmCSA_ConstSupplyAirNordic_input_6 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_input_6() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_input_6); }
  public void setCmCSA_ConstSupplyAirNordic_input_6(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_input_6,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_input_6(float v) { getCmCSA_ConstSupplyAirNordic_input_6().setValue(v); }
// HumidityMode
  public static final Property CmCSA_ConstSupplyAirNordic_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmCSA_ConstSupplyAirNordic_input_7() { return (BStatusNumeric) get(CmCSA_ConstSupplyAirNordic_input_7); }
  public void setCmCSA_ConstSupplyAirNordic_input_7(BStatusNumeric v) { set(CmCSA_ConstSupplyAirNordic_input_7,v,null); }
  public void setCmCSA_ConstSupplyAirNordic_input_7(float v) { getCmCSA_ConstSupplyAirNordic_input_7().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.03 [14] 26.03.2018-11:43").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5972416096844284650").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmCSA_ConstSupplyAirNordic.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

  // class variables
  protected CmIDT20 func_54 = new CmIDT20();
  protected CmIDT05 func_70 = new CmIDT05();
  protected CfIdt func_152 = new CfIdt();
  protected CmIDT05 func_183 = new CmIDT05();
  protected CmAHU_Startup func_40 = new CmAHU_Startup();
  protected CmControl_Point_Adjustment func_82 = new CmControl_Point_Adjustment();
  protected CmConstant_SAT_ontrol func_86 = new CmConstant_SAT_ontrol();
  protected CmAHU_Setpoint_Ramp func_43 = new CmAHU_Setpoint_Ramp();
  protected CmLimit_SAT func_118 = new CmLimit_SAT();
  protected CmSupply_PID func_140 = new CmSupply_PID();
  protected CmERC_Reverse func_121 = new CmERC_Reverse();
  protected CmOutput_Sequence func_104 = new CmOutput_Sequence();
  protected CmOAT_Limits_Nordic func_157 = new CmOAT_Limits_Nordic();
  protected CmCO2_Control func_101 = new CmCO2_Control();
  protected CmFrost_Protection func_76 = new CmFrost_Protection();
  protected CfSubtract func_150 = new CfSubtract();
  protected CfCompare1 func_164 = new CfCompare1();
  protected CfInputMultiplexer func_165 = new CfInputMultiplexer();

  // default constructor
  public BCmCSA_ConstSupplyAirNordic()
  {
  }

  public void Start()
  {
    func_54.Start();
    func_70.Start();
    func_183.Start();
    func_40.Start();
    func_82.Start();
    func_86.Start();
    func_43.Start();
    func_118.Start();
    func_140.Start();
    func_121.Start();
    func_104.Start();
    func_157.Start();
    func_101.Start();
    func_76.Start();
  }
}
