/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    DMA_OnOffDamperNordic
Macro id:      5971325719209312763
Macro version: 21
Last change:   11.06.2015 - 15:00
Access Level:  2
Inputs:
  [1] DamperEnable
  [2] OAD_EndSwitch
  [3] EAD_EndSwitch
  [4] PlantMode
Outputs:
  [1] OAD_Cmd
  [2] EAD_Cmd
  [3] SupFanEnable
  [4] ExhFanEnable
  [5] OADAlarm
  [6] EADAlarm
  [7] OperationMode
Parameter:
  [1] ALM-01: damper run-time
  [2] ALM-02: end switch is connected
  [3] SYS-01: delay OAD
  [4] SYS-02: delay EAD
  [5] DISP-01: outside air damper alarm
  [6] DISP-02: exhaust air damper alarm
Description:
The macro "DMA_OnOffDamperNordic" is an output module. This macro provides 2-position control of the outside air and exhaust air dampers, with integrated options for fan enable and plant mode.
It has options to delay the two damper output signals and to separately enable the supply and exhaust fans.
================================================================================*/

public class BCmDMA_OnOffDamperNordic
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmDMA_OnOffDamperNordic_output_6().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmDMA_OnOffDamperNordic_output_6().setStatus(BStatus.disabled);
    getCmDMA_OnOffDamperNordic_output_7().setStatus(BStatus.disabled);
    getCmDMA_OnOffDamperNordic_output_8().setStatus(BStatus.disabled);
    getCmDMA_OnOffDamperNordic_output_544().setStatus(BStatus.disabled);
    getCmDMA_OnOffDamperNordic_output_9().setStatus(BStatus.disabled);
    getCmDMA_OnOffDamperNordic_output_545().setStatus(BStatus.disabled);
    getCmDMA_OnOffDamperNordic_output_668().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmDMA_OnOffDamperNordic_output_6().setStatus(BStatus.ok);
    getCmDMA_OnOffDamperNordic_output_7().setStatus(BStatus.ok);
    getCmDMA_OnOffDamperNordic_output_8().setStatus(BStatus.ok);
    getCmDMA_OnOffDamperNordic_output_544().setStatus(BStatus.ok);
    getCmDMA_OnOffDamperNordic_output_9().setStatus(BStatus.ok);
    getCmDMA_OnOffDamperNordic_output_545().setStatus(BStatus.ok);
    getCmDMA_OnOffDamperNordic_output_668().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [597] Function call CfWindow
    func_597.inputValue = (float) getCmDMA_OnOffDamperNordic_input_5().getValue();
    func_597.inputMinimum = 0.9F;
    func_597.inputMaximum = 6.1F;
    func_597.Execute(  );

    // [599] Function call CfAnd
    func_599.input[0] = func_597.output;
    func_599.input[1] = getCmDMA_OnOffDamperNordic_input_1().getValue();
    func_599.Execute(  );

    // [561] Function call CfIdt
    func_561.input = (float) getCmDMA_OnOffDamperNordic_parameter_542();
    func_561.Execute(  );
    setParameter(0, func_561.output[0]);

    // [562] Function call CfIdt
    func_562.input = (float) getCmDMA_OnOffDamperNordic_parameter_543();
    func_562.Execute(  );
    setParameter(1, func_562.output[0]);

    // [547] Function call CfDelay
    func_547.inputA = func_599.outputAND;
    func_547.inputB = func_599.outputAND;
    func_547.Execute( this, 0 );

    // [550] Function call CfDelay
    func_550.inputA = func_599.outputAND;
    func_550.inputB = func_599.outputAND;
    func_550.Execute( this, 1 );

    // [492] Function call CfIdt
    func_492.input = (float) getCmDMA_OnOffDamperNordic_parameter_11();
    func_492.Execute(  );
    setParameter(2, func_492.output[0]);

    // [633] Function call CfIdt
    func_633.input = (float) getCmDMA_OnOffDamperNordic_parameter_12();
    func_633.Execute(  );
    setParameter(3, func_633.output[0]);

    // [581] Function call CfIdt
    func_581.input = (float) getCmDMA_OnOffDamperNordic_parameter_11();
    func_581.Execute(  );
    setParameter(5, func_581.output[0]);

    // [636] Function call CfIdt
    func_636.input = (float) getCmDMA_OnOffDamperNordic_parameter_12();
    func_636.Execute(  );
    setParameter(6, func_636.output[0]);

    // [643] Macro call CmFanEnableNordic
    func_643.CmFanEnableNordic_input_1 = func_547.outputDelayedA;
    func_643.CmFanEnableNordic_input_2 = getCmDMA_OnOffDamperNordic_input_2().getValue();
    func_643.CmFanEnableNordic_input_63 = getCmDMA_OnOffDamperNordic_output_9().getValue();
    func_643.CmFanEnableNordic_input_64 = getCmDMA_OnOffDamperNordic_output_545().getValue();
    func_643.Execute( this, 2 );

    // [644] Macro call CmFanEnableNordic
    func_644.CmFanEnableNordic_input_1 = func_550.outputDelayedA;
    func_644.CmFanEnableNordic_input_2 = getCmDMA_OnOffDamperNordic_input_3().getValue();
    func_644.CmFanEnableNordic_input_63 = getCmDMA_OnOffDamperNordic_output_545().getValue();
    func_644.CmFanEnableNordic_input_64 = getCmDMA_OnOffDamperNordic_output_9().getValue();
    func_644.Execute( this, 5 );

    // [382] Function call CfInputMultiplexer
    func_382.inputSelect = FloatToInt((float) getCmDMA_OnOffDamperNordic_parameter_12());
    func_382.input[1-1] = 0F;
    func_382.input[2-1] = BooleanToFloat(func_547.outputDelayedA);
    func_382.Execute(  );

    // [569] Function call CfInputMultiplexer
    func_569.inputSelect = FloatToInt((float) getCmDMA_OnOffDamperNordic_parameter_12());
    func_569.input[1-1] = 0F;
    func_569.input[2-1] = BooleanToFloat(func_550.outputDelayedA);
    func_569.Execute(  );

    // [533] Function call CfIdt
    func_533.input = (float) getCmDMA_OnOffDamperNordic_parameter_11();
    func_533.Execute(  );
    setParameter(8, func_533.output[0]);
    setParameter(9, func_533.output[1]);

    // [524] Function call CfDelay
    func_524.inputA = FloatToBoolean(func_382.output);
    func_524.inputB = getCmDMA_OnOffDamperNordic_input_2().getValue();
    func_524.Execute( this, 8 );

    // [527] Function call CfDelay
    func_527.inputA = FloatToBoolean(func_569.output);
    func_527.inputB = getCmDMA_OnOffDamperNordic_input_3().getValue();
    func_527.Execute( this, 9 );

    // [507] Function call CfIdt
    func_507.input = BooleanToFloat(func_524.outputAlarm);
    func_507.Execute(  );
    setCmDMA_OnOffDamperNordic_parameter_327(func_507.output[0]);
    setCmDMA_OnOffDamperNordic_output_9(FloatToBoolean(func_507.output[1]));

    // [508] Function call CfIdt
    func_508.input = BooleanToFloat(func_527.outputAlarm);
    func_508.Execute(  );
    setCmDMA_OnOffDamperNordic_output_545(FloatToBoolean(func_508.output[0]));
    setCmDMA_OnOffDamperNordic_parameter_350(func_508.output[1]);

    // [493] Function call CfCompare1
    func_493.inputA = (float) getCmDMA_OnOffDamperNordic_input_5().getValue();
    func_493.inputB = 30F;
    func_493.Execute(  );

    // [392] Function call CfCompare1
    func_392.inputA = (float) getCmDMA_OnOffDamperNordic_input_5().getValue();
    func_392.inputB = 20F;
    func_392.Execute(  );

    // [400] Function call CfCompare1
    func_400.inputA = (float) getCmDMA_OnOffDamperNordic_input_5().getValue();
    func_400.inputB = 21F;
    func_400.Execute(  );

    // [577] Function call CfOr
    func_577.input[0] = FloatToBoolean((float) getCmDMA_OnOffDamperNordic_parameter_327());
    func_577.input[1] = FloatToBoolean((float) getCmDMA_OnOffDamperNordic_parameter_350());
    func_577.Execute(  );

    // [663] Function call CfOr
    func_663.input[0] = func_493.outputEqual;
    func_663.input[1] = func_392.outputEqual;
    func_663.input[2] = func_400.outputEqual;
    func_663.Execute(  );

    // [669] Function call CfOr
    func_669.input[0] = func_577.outputOR;
    func_669.input[1] = func_663.outputOR;
    func_669.Execute(  );

    // [645] Function call CfInputMultiplexer
    func_645.inputSelect = BooleanToInt(func_400.outputEqual);
    func_645.input[1-1] = 15F;
    func_645.input[2-1] = 13F;
    func_645.Execute(  );

    // [659] Function call CfInputMultiplexer
    func_659.inputSelect = BooleanToInt(func_392.outputEqual);
    func_659.input[1-1] = func_645.output;
    func_659.input[2-1] = 12F;
    func_659.Execute(  );

    // [647] Function call CfInputMultiplexer
    func_647.inputSelect = BooleanToInt(func_577.outputOR);
    func_647.input[1-1] = func_659.output;
    func_647.input[2-1] = 10F;
    func_647.Execute(  );

    // [661] Function call CfInputMultiplexer
    func_661.inputSelect = BooleanToInt(func_493.outputEqual);
    func_661.input[1-1] = func_647.output;
    func_661.input[2-1] = 2F;
    func_661.Execute(  );
    setCmDMA_OnOffDamperNordic_output_668(func_661.output);

    // [657] Function call CfInputMultiplexer
    func_657.inputSelect = BooleanToInt(func_663.outputOR);
    func_657.input[1-1] = BooleanToFloat(func_547.outputDelayedA);
    func_657.input[2-1] = 0F;
    func_657.Execute(  );
    setCmDMA_OnOffDamperNordic_output_6(FloatToBoolean(func_657.output));

    // [651] Function call CfInputMultiplexer
    func_651.inputSelect = BooleanToInt(func_663.outputOR);
    func_651.input[1-1] = BooleanToFloat(func_550.outputDelayedA);
    func_651.input[2-1] = 0F;
    func_651.Execute(  );
    setCmDMA_OnOffDamperNordic_output_7(FloatToBoolean(func_651.output));

    // [653] Function call CfInputMultiplexer
    func_653.inputSelect = BooleanToInt(func_669.outputOR);
    func_653.input[1-1] = BooleanToFloat(func_644.CmFanEnableNordic_output_3);
    func_653.input[2-1] = 0F;
    func_653.Execute(  );
    setCmDMA_OnOffDamperNordic_output_544(FloatToBoolean(func_653.output));

    // [655] Function call CfInputMultiplexer
    func_655.inputSelect = BooleanToInt(func_669.outputOR);
    func_655.input[1-1] = BooleanToFloat(func_643.CmFanEnableNordic_output_3);
    func_655.input[2-1] = 0F;
    func_655.Execute(  );
    setCmDMA_OnOffDamperNordic_output_8(FloatToBoolean(func_655.output));

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    10F, 10F, 150F, 0F, 10F, 150F, 0F, 10F,
    10F, 10F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// OAD_Cmd
  public static final Property CmDMA_OnOffDamperNordic_output_6 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDMA_OnOffDamperNordic_output_6() { return (BStatusBoolean) get(CmDMA_OnOffDamperNordic_output_6); }
  public void setCmDMA_OnOffDamperNordic_output_6(BStatusBoolean v) { set(CmDMA_OnOffDamperNordic_output_6,v,null); }
  public void setCmDMA_OnOffDamperNordic_output_6(boolean v) { getCmDMA_OnOffDamperNordic_output_6().setValue(v); }
// EAD_Cmd
  public static final Property CmDMA_OnOffDamperNordic_output_7 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDMA_OnOffDamperNordic_output_7() { return (BStatusBoolean) get(CmDMA_OnOffDamperNordic_output_7); }
  public void setCmDMA_OnOffDamperNordic_output_7(BStatusBoolean v) { set(CmDMA_OnOffDamperNordic_output_7,v,null); }
  public void setCmDMA_OnOffDamperNordic_output_7(boolean v) { getCmDMA_OnOffDamperNordic_output_7().setValue(v); }
// SupFanEnable
  public static final Property CmDMA_OnOffDamperNordic_output_8 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDMA_OnOffDamperNordic_output_8() { return (BStatusBoolean) get(CmDMA_OnOffDamperNordic_output_8); }
  public void setCmDMA_OnOffDamperNordic_output_8(BStatusBoolean v) { set(CmDMA_OnOffDamperNordic_output_8,v,null); }
  public void setCmDMA_OnOffDamperNordic_output_8(boolean v) { getCmDMA_OnOffDamperNordic_output_8().setValue(v); }
// ExhFanEnable
  public static final Property CmDMA_OnOffDamperNordic_output_544 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDMA_OnOffDamperNordic_output_544() { return (BStatusBoolean) get(CmDMA_OnOffDamperNordic_output_544); }
  public void setCmDMA_OnOffDamperNordic_output_544(BStatusBoolean v) { set(CmDMA_OnOffDamperNordic_output_544,v,null); }
  public void setCmDMA_OnOffDamperNordic_output_544(boolean v) { getCmDMA_OnOffDamperNordic_output_544().setValue(v); }
// OADAlarm
  public static final Property CmDMA_OnOffDamperNordic_output_9 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDMA_OnOffDamperNordic_output_9() { return (BStatusBoolean) get(CmDMA_OnOffDamperNordic_output_9); }
  public void setCmDMA_OnOffDamperNordic_output_9(BStatusBoolean v) { set(CmDMA_OnOffDamperNordic_output_9,v,null); }
  public void setCmDMA_OnOffDamperNordic_output_9(boolean v) { getCmDMA_OnOffDamperNordic_output_9().setValue(v); }
// EADAlarm
  public static final Property CmDMA_OnOffDamperNordic_output_545 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmDMA_OnOffDamperNordic_output_545() { return (BStatusBoolean) get(CmDMA_OnOffDamperNordic_output_545); }
  public void setCmDMA_OnOffDamperNordic_output_545(BStatusBoolean v) { set(CmDMA_OnOffDamperNordic_output_545,v,null); }
  public void setCmDMA_OnOffDamperNordic_output_545(boolean v) { getCmDMA_OnOffDamperNordic_output_545().setValue(v); }
// OperationMode
  public static final Property CmDMA_OnOffDamperNordic_output_668 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmDMA_OnOffDamperNordic_output_668() { return (BStatusNumeric) get(CmDMA_OnOffDamperNordic_output_668); }
  public void setCmDMA_OnOffDamperNordic_output_668(BStatusNumeric v) { set(CmDMA_OnOffDamperNordic_output_668,v,null); }
  public void setCmDMA_OnOffDamperNordic_output_668(float v) { getCmDMA_OnOffDamperNordic_output_668().setValue(v); }

  // macro parameter
// ALM-01: damper run-time
  public static final Property CmDMA_OnOffDamperNordic_parameter_11 = newProperty( 0, BDouble.make( 150 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1440)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmDMA_OnOffDamperNordic_parameter_11() { return getDouble(CmDMA_OnOffDamperNordic_parameter_11); }
  public void setCmDMA_OnOffDamperNordic_parameter_11(double v) { setDouble(CmDMA_OnOffDamperNordic_parameter_11,v,null); }
// ALM-02: end switch is connected
  public static final Property CmDMA_OnOffDamperNordic_parameter_12 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmDMA_OnOffDamperNordic_parameter_12() { return getDouble(CmDMA_OnOffDamperNordic_parameter_12); }
  public void setCmDMA_OnOffDamperNordic_parameter_12(double v) { setDouble(CmDMA_OnOffDamperNordic_parameter_12,v,null); }
// SYS-01: delay OAD
  public static final Property CmDMA_OnOffDamperNordic_parameter_542 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1440)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmDMA_OnOffDamperNordic_parameter_542() { return getDouble(CmDMA_OnOffDamperNordic_parameter_542); }
  public void setCmDMA_OnOffDamperNordic_parameter_542(double v) { setDouble(CmDMA_OnOffDamperNordic_parameter_542,v,null); }
// SYS-02: delay EAD
  public static final Property CmDMA_OnOffDamperNordic_parameter_543 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1440)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmDMA_OnOffDamperNordic_parameter_543() { return getDouble(CmDMA_OnOffDamperNordic_parameter_543); }
  public void setCmDMA_OnOffDamperNordic_parameter_543(double v) { setDouble(CmDMA_OnOffDamperNordic_parameter_543,v,null); }
// DISP-01: outside air damper alarm
  public static final Property CmDMA_OnOffDamperNordic_parameter_327 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmDMA_OnOffDamperNordic_parameter_327() { return getDouble(CmDMA_OnOffDamperNordic_parameter_327); }
  public void setCmDMA_OnOffDamperNordic_parameter_327(double v) { setDouble(CmDMA_OnOffDamperNordic_parameter_327,v,null); }
// DISP-02: exhaust air damper alarm
  public static final Property CmDMA_OnOffDamperNordic_parameter_350 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmDMA_OnOffDamperNordic_parameter_350() { return getDouble(CmDMA_OnOffDamperNordic_parameter_350); }
  public void setCmDMA_OnOffDamperNordic_parameter_350(double v) { setDouble(CmDMA_OnOffDamperNordic_parameter_350,v,null); }

  // macro inputs
// DamperEnable
  public static final Property CmDMA_OnOffDamperNordic_input_1 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmDMA_OnOffDamperNordic_input_1() { return (BStatusBoolean) get(CmDMA_OnOffDamperNordic_input_1); }
  public void setCmDMA_OnOffDamperNordic_input_1(BStatusBoolean v) { set(CmDMA_OnOffDamperNordic_input_1,v,null); }
  public void setCmDMA_OnOffDamperNordic_input_1(boolean v) { getCmDMA_OnOffDamperNordic_input_1().setValue(v); }
// OAD_EndSwitch
  public static final Property CmDMA_OnOffDamperNordic_input_2 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmDMA_OnOffDamperNordic_input_2() { return (BStatusBoolean) get(CmDMA_OnOffDamperNordic_input_2); }
  public void setCmDMA_OnOffDamperNordic_input_2(BStatusBoolean v) { set(CmDMA_OnOffDamperNordic_input_2,v,null); }
  public void setCmDMA_OnOffDamperNordic_input_2(boolean v) { getCmDMA_OnOffDamperNordic_input_2().setValue(v); }
// EAD_EndSwitch
  public static final Property CmDMA_OnOffDamperNordic_input_3 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmDMA_OnOffDamperNordic_input_3() { return (BStatusBoolean) get(CmDMA_OnOffDamperNordic_input_3); }
  public void setCmDMA_OnOffDamperNordic_input_3(BStatusBoolean v) { set(CmDMA_OnOffDamperNordic_input_3,v,null); }
  public void setCmDMA_OnOffDamperNordic_input_3(boolean v) { getCmDMA_OnOffDamperNordic_input_3().setValue(v); }
// PlantMode
  public static final Property CmDMA_OnOffDamperNordic_input_5 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmDMA_OnOffDamperNordic_input_5() { return (BStatusNumeric) get(CmDMA_OnOffDamperNordic_input_5); }
  public void setCmDMA_OnOffDamperNordic_input_5(BStatusNumeric v) { set(CmDMA_OnOffDamperNordic_input_5,v,null); }
  public void setCmDMA_OnOffDamperNordic_input_5(float v) { getCmDMA_OnOffDamperNordic_input_5().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.01 [21] 11.06.2015-15:00").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5971325719209312763").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmDMA_OnOffDamperNordic.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfWindow func_597 = new CfWindow();
  protected CfAnd func_599 = new CfAnd();
  protected CfIdt func_561 = new CfIdt();
  protected CfIdt func_562 = new CfIdt();
  protected CfDelay func_547 = new CfDelay();
  protected CfDelay func_550 = new CfDelay();
  protected CfIdt func_492 = new CfIdt();
  protected CfIdt func_633 = new CfIdt();
  protected CfIdt func_581 = new CfIdt();
  protected CfIdt func_636 = new CfIdt();
  protected CmFanEnableNordic func_643 = new CmFanEnableNordic();
  protected CmFanEnableNordic func_644 = new CmFanEnableNordic();
  protected CfInputMultiplexer func_382 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_569 = new CfInputMultiplexer();
  protected CfIdt func_533 = new CfIdt();
  protected CfDelay func_524 = new CfDelay();
  protected CfDelay func_527 = new CfDelay();
  protected CfIdt func_507 = new CfIdt();
  protected CfIdt func_508 = new CfIdt();
  protected CfCompare1 func_493 = new CfCompare1();
  protected CfCompare1 func_392 = new CfCompare1();
  protected CfCompare1 func_400 = new CfCompare1();
  protected CfOr func_577 = new CfOr();
  protected CfOr func_663 = new CfOr();
  protected CfOr func_669 = new CfOr();
  protected CfInputMultiplexer func_645 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_659 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_647 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_661 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_657 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_651 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_653 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_655 = new CfInputMultiplexer();

  // default constructor
  public BCmDMA_OnOffDamperNordic()
  {
    func_533.configure(2);
    func_507.configure(2);
    func_508.configure(2);
    func_663.configure(3);
  }

  public void Start()
  {
    func_547.Start();
    func_550.Start();
    func_643.Start();
    func_644.Start();
    func_524.Start();
    func_527.Start();
  }
}
