/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    ERC_Efficiency
Macro id:      6147613273422784431
Macro version: 14
Last change:   22.03.2016 - 15:31
Access Level:  2
Inputs:
  [1] ERCCtrlSig
  [2] T1_InletAirTemp
  [3] T2_SupplyAirERC
  [4] T3_ReturnAirTemp
  [5] T4_ExhaustAirTemp
  [6] SupFan_running
  [7] ExtFan_running
  [8] ERC_running
  [9] Sommer_Mode
Outputs:
  [1] ERCEfficiency
  [2] EfficiencyType
  [3] Efficiency_Alarm
Parameter:
  [1] EFF-01 Efficiency calculation start-up delay
  [2] EFF-02 Efficiency calculation compensation
  [3] EFF-03 Minimum control signal for efficiency calculation
  [4] EFF-04 Calculate the efficiency in summer
  [5] ALM-01 Efficiency alarm level
  [6] ALM-02 Efficiency alarm delay
  [7] ALM-03 Efficiency alarm hysteresis
  [8] ALM-04 Efficiency minimum control signal alarm
  [9] ALM-05 Minimum control signal hysteresis
Description:
The macro calculates the efficiency of the energy recovery unit based on temperatures.
An efficiency level is used to generate an alarm if the ERC efficiency is too low.
It has also a parameter for disabling the calculation at summer and/ or low control signal.
================================================================================*/

public class BCmERC_Efficiency
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmERC_Efficiency_output_9().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmERC_Efficiency_output_9().setStatus(BStatus.disabled);
    getCmERC_Efficiency_output_196().setStatus(BStatus.disabled);
    getCmERC_Efficiency_output_10().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmERC_Efficiency_output_9().setStatus(BStatus.ok);
    getCmERC_Efficiency_output_196().setStatus(BStatus.ok);
    getCmERC_Efficiency_output_10().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [134] Function call CfIdt
    func_134.input = (float) getCmERC_Efficiency_parameter_16();
    func_134.Execute(  );
    setParameter(0, func_134.output[0]);
    setParameter(1, func_134.output[1]);

    // [141] Function call CfIdt
    func_141.input = (float) getCmERC_Efficiency_parameter_11();
    func_141.Execute(  );
    setParameter(9, func_141.output[0]);

    // [142] Function call CfIdt
    func_142.input = (float) getCmERC_Efficiency_parameter_12();
    func_142.Execute(  );
    setParameter(8, func_142.output[0]);

    // [205] Function call CfIdt
    func_205.input = (float) getCmERC_Efficiency_parameter_15();
    func_205.Execute(  );
    setParameter(2, func_205.output[0]);

    // [207] Function call CfIdt
    func_207.input = (float) getCmERC_Efficiency_parameter_14();
    func_207.Execute(  );
    setParameter(3, func_207.output[0]);

    // [209] Function call CfCompare1
    func_209.inputA = (float) getCmERC_Efficiency_input_138().getValue();
    func_209.inputB = 999F;
    func_209.Execute(  );

    // [212] Function call CfNot
    func_212.input = func_209.outputLess;
    func_212.Execute(  );

    // [132] Macro call CmERCEffCalculation
    if ( func_212.output)
    {
      func_132.CmERCEffCalculation_input_1 = (float) getCmERC_Efficiency_input_2().getValue();
      func_132.CmERCEffCalculation_input_2 = (float) getCmERC_Efficiency_input_3().getValue();
      func_132.CmERCEffCalculation_input_3 = (float) getCmERC_Efficiency_input_2().getValue();
      func_132.CmERCEffCalculation_input_47 = (float) getCmERC_Efficiency_input_1().getValue();
      func_132.CmERCEffCalculation_input_4 = (float) getCmERC_Efficiency_input_4().getValue();
      func_132.Execute( this, 0 );
    }

    // [137] Macro call CmERCEffCalculation
    if ( func_209.outputLess)
    {
      func_137.CmERCEffCalculation_input_1 = (float) getCmERC_Efficiency_input_138().getValue();
      func_137.CmERCEffCalculation_input_2 = (float) getCmERC_Efficiency_input_1().getValue();
      func_137.CmERCEffCalculation_input_3 = (float) getCmERC_Efficiency_input_2().getValue();
      func_137.CmERCEffCalculation_input_47 = (float) getCmERC_Efficiency_input_1().getValue();
      func_137.CmERCEffCalculation_input_4 = (float) getCmERC_Efficiency_input_4().getValue();
      func_137.Execute( this, 1 );
    }

    // [213] Function call CfInputMultiplexer
    func_213.inputSelect = BooleanToInt(func_209.outputLess);
    func_213.input[1-1] = func_132.CmERCEffCalculation_output_5;
    func_213.input[2-1] = func_137.CmERCEffCalculation_output_5;
    func_213.Execute(  );

    // [199] Macro call CmERCEffOverrides
    func_199.CmERCEffOverrides_input_1 = getCmERC_Efficiency_input_8().getValue();
    func_199.CmERCEffOverrides_input_2 = getCmERC_Efficiency_input_6().getValue();
    func_199.CmERCEffOverrides_input_3 = getCmERC_Efficiency_input_5().getValue();
    func_199.CmERCEffOverrides_input_4 = (float) getCmERC_Efficiency_input_4().getValue();
    func_199.CmERCEffOverrides_input_5 = getCmERC_Efficiency_input_7().getValue();
    func_199.CmERCEffOverrides_input_79 = (float) getCmERC_Efficiency_parameter_18();
    func_199.CmERCEffOverrides_input_76 = (float) getCmERC_Efficiency_parameter_17();
    func_199.CmERCEffOverrides_input_77 = (float) getCmERC_Efficiency_parameter_13();
    func_199.Execute( this, 2 );

    // [152] Function call CfHysteresis
    func_152.inputX = func_213.output;
    func_152.inputW = (float) getCmERC_Efficiency_parameter_66();
    func_152.Execute( this, 8 );

    // [158] Function call CfDelayOnOff
    func_158.input = func_152.output2;
    func_158.Execute( this, 9 );

    // [164] Function call CfInputMultiplexer
    func_164.inputSelect = BooleanToInt(func_199.CmERCEffOverrides_output_6);
    func_164.input[1-1] = func_213.output;
    func_164.input[2-1] = 0F;
    func_164.Execute(  );
    setCmERC_Efficiency_output_9(func_164.output);

    // [165] Function call CfInputMultiplexer
    func_165.inputSelect = BooleanToInt(func_199.CmERCEffOverrides_output_7);
    func_165.input[1-1] = BooleanToFloat(func_158.output);
    func_165.input[2-1] = 0F;
    func_165.Execute(  );
    setCmERC_Efficiency_output_10(FloatToBoolean(func_165.output));

    // [219] Function call CfAddition
    func_219.input[0] = BooleanToFloat(func_212.output);
    func_219.input[1] = 1F;
    func_219.Execute(  );

    // [217] Function call CfMaximum
    func_217.input[0] = func_219.output;
    func_217.input[1] = BooleanToFloat(func_209.outputLess);
    func_217.Execute(  );

    // [216] Function call CfInputMultiplexer
    func_216.inputSelect = BooleanToInt(func_199.CmERCEffOverrides_output_6);
    func_216.input[1-1] = func_217.output;
    func_216.input[2-1] = 0F;
    func_216.Execute(  );
    setCmERC_Efficiency_output_196(func_216.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    1F, 1F, 180F, 5F, 4F, 5F, 10F, 0F,
    0F, 10F, 0F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// ERCEfficiency
  public static final Property CmERC_Efficiency_output_9 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), BFacets.make(BFacets.UNITS, BUnit.getUnit("percent")));
  public BStatusNumeric getCmERC_Efficiency_output_9() { return (BStatusNumeric) get(CmERC_Efficiency_output_9); }
  public void setCmERC_Efficiency_output_9(BStatusNumeric v) { set(CmERC_Efficiency_output_9,v,null); }
  public void setCmERC_Efficiency_output_9(float v) { getCmERC_Efficiency_output_9().setValue(v); }
// EfficiencyType
  public static final Property CmERC_Efficiency_output_196 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmERC_Efficiency_output_196() { return (BStatusNumeric) get(CmERC_Efficiency_output_196); }
  public void setCmERC_Efficiency_output_196(BStatusNumeric v) { set(CmERC_Efficiency_output_196,v,null); }
  public void setCmERC_Efficiency_output_196(float v) { getCmERC_Efficiency_output_196().setValue(v); }
// Efficiency_Alarm
  public static final Property CmERC_Efficiency_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmERC_Efficiency_output_10() { return (BStatusBoolean) get(CmERC_Efficiency_output_10); }
  public void setCmERC_Efficiency_output_10(BStatusBoolean v) { set(CmERC_Efficiency_output_10,v,null); }
  public void setCmERC_Efficiency_output_10(boolean v) { getCmERC_Efficiency_output_10().setValue(v); }

  // macro parameter
// EFF-01 Efficiency calculation start-up delay
  public static final Property CmERC_Efficiency_parameter_15 = newProperty( 0, BDouble.make( 180 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmERC_Efficiency_parameter_15() { return getDouble(CmERC_Efficiency_parameter_15); }
  public void setCmERC_Efficiency_parameter_15(double v) { setDouble(CmERC_Efficiency_parameter_15,v,null); }
// EFF-02 Efficiency calculation compensation
  public static final Property CmERC_Efficiency_parameter_16 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmERC_Efficiency_parameter_16() { return getDouble(CmERC_Efficiency_parameter_16); }
  public void setCmERC_Efficiency_parameter_16(double v) { setDouble(CmERC_Efficiency_parameter_16,v,null); }
// EFF-03 Minimum control signal for efficiency calculation
  public static final Property CmERC_Efficiency_parameter_18 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(5)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmERC_Efficiency_parameter_18() { return getDouble(CmERC_Efficiency_parameter_18); }
  public void setCmERC_Efficiency_parameter_18(double v) { setDouble(CmERC_Efficiency_parameter_18,v,null); }
// EFF-04 Calculate the efficiency in summer
  public static final Property CmERC_Efficiency_parameter_17 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmERC_Efficiency_parameter_17() { return getDouble(CmERC_Efficiency_parameter_17); }
  public void setCmERC_Efficiency_parameter_17(double v) { setDouble(CmERC_Efficiency_parameter_17,v,null); }
// ALM-01 Efficiency alarm level
  public static final Property CmERC_Efficiency_parameter_66 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmERC_Efficiency_parameter_66() { return getDouble(CmERC_Efficiency_parameter_66); }
  public void setCmERC_Efficiency_parameter_66(double v) { setDouble(CmERC_Efficiency_parameter_66,v,null); }
// ALM-02 Efficiency alarm delay
  public static final Property CmERC_Efficiency_parameter_11 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmERC_Efficiency_parameter_11() { return getDouble(CmERC_Efficiency_parameter_11); }
  public void setCmERC_Efficiency_parameter_11(double v) { setDouble(CmERC_Efficiency_parameter_11,v,null); }
// ALM-03 Efficiency alarm hysteresis
  public static final Property CmERC_Efficiency_parameter_12 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmERC_Efficiency_parameter_12() { return getDouble(CmERC_Efficiency_parameter_12); }
  public void setCmERC_Efficiency_parameter_12(double v) { setDouble(CmERC_Efficiency_parameter_12,v,null); }
// ALM-04 Efficiency minimum control signal alarm
  public static final Property CmERC_Efficiency_parameter_13 = newProperty( 0, BDouble.make( 90 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmERC_Efficiency_parameter_13() { return getDouble(CmERC_Efficiency_parameter_13); }
  public void setCmERC_Efficiency_parameter_13(double v) { setDouble(CmERC_Efficiency_parameter_13,v,null); }
// ALM-05 Minimum control signal hysteresis
  public static final Property CmERC_Efficiency_parameter_14 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmERC_Efficiency_parameter_14() { return getDouble(CmERC_Efficiency_parameter_14); }
  public void setCmERC_Efficiency_parameter_14(double v) { setDouble(CmERC_Efficiency_parameter_14,v,null); }

  // macro inputs
// ERCCtrlSig
  public static final Property CmERC_Efficiency_input_4 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), BFacets.make(BFacets.UNITS, BUnit.getUnit("percent")));
  public BStatusNumeric getCmERC_Efficiency_input_4() { return (BStatusNumeric) get(CmERC_Efficiency_input_4); }
  public void setCmERC_Efficiency_input_4(BStatusNumeric v) { set(CmERC_Efficiency_input_4,v,null); }
  public void setCmERC_Efficiency_input_4(float v) { getCmERC_Efficiency_input_4().setValue(v); }
// T1_InletAirTemp
  public static final Property CmERC_Efficiency_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmERC_Efficiency_input_1() { return (BStatusNumeric) get(CmERC_Efficiency_input_1); }
  public void setCmERC_Efficiency_input_1(BStatusNumeric v) { set(CmERC_Efficiency_input_1,v,null); }
  public void setCmERC_Efficiency_input_1(float v) { getCmERC_Efficiency_input_1().setValue(v); }
// T2_SupplyAirERC
  public static final Property CmERC_Efficiency_input_138 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmERC_Efficiency_input_138() { return (BStatusNumeric) get(CmERC_Efficiency_input_138); }
  public void setCmERC_Efficiency_input_138(BStatusNumeric v) { set(CmERC_Efficiency_input_138,v,null); }
  public void setCmERC_Efficiency_input_138(float v) { getCmERC_Efficiency_input_138().setValue(v); }
// T3_ReturnAirTemp
  public static final Property CmERC_Efficiency_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmERC_Efficiency_input_2() { return (BStatusNumeric) get(CmERC_Efficiency_input_2); }
  public void setCmERC_Efficiency_input_2(BStatusNumeric v) { set(CmERC_Efficiency_input_2,v,null); }
  public void setCmERC_Efficiency_input_2(float v) { getCmERC_Efficiency_input_2().setValue(v); }
// T4_ExhaustAirTemp
  public static final Property CmERC_Efficiency_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius")));
  public BStatusNumeric getCmERC_Efficiency_input_3() { return (BStatusNumeric) get(CmERC_Efficiency_input_3); }
  public void setCmERC_Efficiency_input_3(BStatusNumeric v) { set(CmERC_Efficiency_input_3,v,null); }
  public void setCmERC_Efficiency_input_3(float v) { getCmERC_Efficiency_input_3().setValue(v); }
// SupFan_running
  public static final Property CmERC_Efficiency_input_5 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmERC_Efficiency_input_5() { return (BStatusBoolean) get(CmERC_Efficiency_input_5); }
  public void setCmERC_Efficiency_input_5(BStatusBoolean v) { set(CmERC_Efficiency_input_5,v,null); }
  public void setCmERC_Efficiency_input_5(boolean v) { getCmERC_Efficiency_input_5().setValue(v); }
// ExtFan_running
  public static final Property CmERC_Efficiency_input_6 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmERC_Efficiency_input_6() { return (BStatusBoolean) get(CmERC_Efficiency_input_6); }
  public void setCmERC_Efficiency_input_6(BStatusBoolean v) { set(CmERC_Efficiency_input_6,v,null); }
  public void setCmERC_Efficiency_input_6(boolean v) { getCmERC_Efficiency_input_6().setValue(v); }
// ERC_running
  public static final Property CmERC_Efficiency_input_8 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmERC_Efficiency_input_8() { return (BStatusBoolean) get(CmERC_Efficiency_input_8); }
  public void setCmERC_Efficiency_input_8(BStatusBoolean v) { set(CmERC_Efficiency_input_8,v,null); }
  public void setCmERC_Efficiency_input_8(boolean v) { getCmERC_Efficiency_input_8().setValue(v); }
// Sommer_Mode
  public static final Property CmERC_Efficiency_input_7 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmERC_Efficiency_input_7() { return (BStatusBoolean) get(CmERC_Efficiency_input_7); }
  public void setCmERC_Efficiency_input_7(BStatusBoolean v) { set(CmERC_Efficiency_input_7,v,null); }
  public void setCmERC_Efficiency_input_7(boolean v) { getCmERC_Efficiency_input_7().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.03 [14] 22.03.2016-15:31").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6147613273422784431").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmERC_Efficiency.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfIdt func_134 = new CfIdt();
  protected CfIdt func_141 = new CfIdt();
  protected CfIdt func_142 = new CfIdt();
  protected CfIdt func_205 = new CfIdt();
  protected CfIdt func_207 = new CfIdt();
  protected CfCompare1 func_209 = new CfCompare1();
  protected CfNot func_212 = new CfNot();
  protected CmERCEffCalculation func_132 = new CmERCEffCalculation();
  protected CmERCEffCalculation func_137 = new CmERCEffCalculation();
  protected CfInputMultiplexer func_213 = new CfInputMultiplexer();
  protected CmERCEffOverrides func_199 = new CmERCEffOverrides();
  protected CfHysteresis func_152 = new CfHysteresis();
  protected CfDelayOnOff func_158 = new CfDelayOnOff();
  protected CfInputMultiplexer func_164 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_165 = new CfInputMultiplexer();
  protected CfAddition func_219 = new CfAddition();
  protected CfMaximum func_217 = new CfMaximum();
  protected CfInputMultiplexer func_216 = new CfInputMultiplexer();

  // default constructor
  public BCmERC_Efficiency()
  {
    func_134.configure(2);
  }

  public void Start()
  {
    func_132.Start();
    func_137.Start();
    func_199.Start();
    func_152.Start();
    func_158.Start();
  }
}
