/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    ERC_WheelStatusAlarmNordic
Macro id:      5970898139258814865
Macro version: 29
Last change:   10.01.2017 - 15:00
Access Level:  2
Inputs:
  [1] WheelEnable
  [2] Alarm
  [3] Reset
Outputs:
  [1] Status
  [2] WheelCmd
  [3] FailCmdAlarm
  [4] CommAlarm
  [5] Disp_WheelSpeed
Parameter:
  [1] SYS-01: minimum rotation speed; 0 = steady signal
  [2] ALM-01: delay status alarm
  [3] ALM-02: Wheel reset type
Description:
This macro provides Wheel control. It offers fail to command alarm and Wheel exercise.

================================================================================*/

public class BCmERC_WheelStatusAlarmNordic
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmERC_WheelStatusAlarmNordic_output_61().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmERC_WheelStatusAlarmNordic_output_61().setStatus(BStatus.disabled);
    getCmERC_WheelStatusAlarmNordic_output_140().setStatus(BStatus.disabled);
    getCmERC_WheelStatusAlarmNordic_output_12().setStatus(BStatus.disabled);
    getCmERC_WheelStatusAlarmNordic_output_13().setStatus(BStatus.disabled);
    getCmERC_WheelStatusAlarmNordic_output_76().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmERC_WheelStatusAlarmNordic_output_61().setStatus(BStatus.ok);
    getCmERC_WheelStatusAlarmNordic_output_140().setStatus(BStatus.ok);
    getCmERC_WheelStatusAlarmNordic_output_12().setStatus(BStatus.ok);
    getCmERC_WheelStatusAlarmNordic_output_13().setStatus(BStatus.ok);
    getCmERC_WheelStatusAlarmNordic_output_76().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [98] Macro call CmIDT20
    func_98.CmIDT20_input_1 = 0F;
    func_98.CmIDT20_input_2 = (float) getCmERC_WheelStatusAlarmNordic_parameter_19();
    func_98.CmIDT20_input_3 = (float) getCmERC_WheelStatusAlarmNordic_parameter_20();
    func_98.CmIDT20_input_4 = (float) getCmERC_WheelStatusAlarmNordic_parameter_21();
    func_98.CmIDT20_input_5 = 10F;
    func_98.CmIDT20_input_6 = 1E+08F;
    func_98.CmIDT20_input_7 = 50F;
    func_98.CmIDT20_input_8 = 0.5F;
    func_98.CmIDT20_input_9 = 1F;
    func_98.CmIDT20_input_10 = 100F;
    func_98.CmIDT20_input_11 = 1E+08F;
    func_98.CmIDT20_input_12 = 50F;
    func_98.CmIDT20_input_13 = 0F;
    func_98.CmIDT20_input_14 = 1F;
    func_98.CmIDT20_input_15 = 100F;
    func_98.CmIDT20_input_16 = func_98.CmIDT20_output_40;
    func_98.CmIDT20_input_17 = func_98.CmIDT20_output_40;
    func_98.CmIDT20_input_18 = func_98.CmIDT20_output_40;
    func_98.CmIDT20_input_19 = func_98.CmIDT20_output_40;
    func_98.CmIDT20_input_20 = func_98.CmIDT20_output_40;
    func_98.Execute(  );
    setParameter(17, func_98.CmIDT20_output_23);
    setParameter(18, func_98.CmIDT20_output_24);
    setParameter(0, func_98.CmIDT20_output_25);
    setParameter(1, func_98.CmIDT20_output_26);
    setParameter(2, func_98.CmIDT20_output_27);
    setParameter(3, func_98.CmIDT20_output_28);
    setParameter(4, func_98.CmIDT20_output_29);
    setParameter(5, func_98.CmIDT20_output_30);
    setParameter(8, func_98.CmIDT20_output_31);
    setParameter(9, func_98.CmIDT20_output_32);
    setParameter(10, func_98.CmIDT20_output_33);
    setParameter(11, func_98.CmIDT20_output_34);
    setParameter(12, func_98.CmIDT20_output_35);

    // [53] Function call CfCompare2
    func_53.inputA = (float) getCmERC_WheelStatusAlarmNordic_parameter_20();
    func_53.inputB = 0F;
    func_53.Execute(  );

    // [56] Function call CfInputMultiplexer
    func_56.inputSelect = BooleanToInt(func_53.outputEqualOrLess);
    func_56.input[1-1] = 1F;
    func_56.input[2-1] = 0F;
    func_56.Execute(  );
    setParameter(19, func_56.output);

    // [22] Macro call CmPulseCounter
    func_22.Execute( this, 0 );
    setCmERC_WheelStatusAlarmNordic_output_61(func_22.CmPulseCounter_output_10);

    // [26] Macro call CmTimeCounter
    func_26.Execute( this, 8 );
    setCmERC_WheelStatusAlarmNordic_output_61(func_26.CmTimeCounter_output_6);

    // [67] Function call CfMaximum
    func_67.input[0] = func_22.CmPulseCounter_output_5;
    func_67.input[1] = func_26.CmTimeCounter_output_4;
    func_67.Execute(  );

    // [49] Function call CfCompare2
    func_49.inputA = func_67.output;
    func_49.inputB = (float) getCmERC_WheelStatusAlarmNordic_parameter_19();
    func_49.Execute(  );

    // [75] Function call CfCompare1
    func_75.inputA = (float) getCmERC_WheelStatusAlarmNordic_parameter_19();
    func_75.inputB = 0F;
    func_75.Execute(  );

    // [131] Function call CfNot
    func_131.input = getCmERC_WheelStatusAlarmNordic_input_141().getValue();
    func_131.Execute(  );

    // [134] Function call CfCompare2
    func_134.inputA = func_67.output;
    func_134.inputB = 1F;
    func_134.Execute(  );

    // [143] Function call CfIdt
    func_143.input = BooleanToFloat(getCmERC_WheelStatusAlarmNordic_input_141().getValue());
    func_143.Execute(  );
    setCmERC_WheelStatusAlarmNordic_output_140(FloatToBoolean(func_143.output[0]));

    // [128] Function call CfAnd
    func_128.input[0] = func_131.output;
    func_128.input[1] = func_134.outputEqualOrGreater;
    func_128.Execute(  );

    // [137] Function call CfOr
    func_137.input[0] = func_49.outputEqualOrGreater;
    func_137.input[1] = func_128.outputAND;
    func_137.Execute(  );

    // [74] Function call CfInputMultiplexer
    func_74.inputSelect = BooleanToInt(func_75.outputGreater);
    func_74.input[1-1] = (float) getCmERC_WheelStatusAlarmNordic_output_61().getValue();
    func_74.input[2-1] = BooleanToFloat(func_137.outputOR);
    func_74.Execute(  );

    // [77] Function call CfInputMultiplexer
    func_77.inputSelect = BooleanToInt(func_75.outputGreater);
    func_77.input[1-1] = (float) getCmERC_WheelStatusAlarmNordic_output_61().getValue();
    func_77.input[2-1] = func_67.output;
    func_77.Execute(  );
    setCmERC_WheelStatusAlarmNordic_output_76(func_77.output);

    // [2] Macro call CmAlarms
    func_2.CmAlarms_input_1 = getCmERC_WheelStatusAlarmNordic_input_141().getValue();
    func_2.CmAlarms_input_2 = FloatToBoolean(func_74.output);
    func_2.CmAlarms_input_3 = getCmERC_WheelStatusAlarmNordic_input_9().getValue();
    func_2.CmAlarms_input_4 = getCmERC_WheelStatusAlarmNordic_input_10().getValue();
    func_2.Execute( this, 17 );
    setCmERC_WheelStatusAlarmNordic_output_12(func_2.CmAlarms_output_7);
    setCmERC_WheelStatusAlarmNordic_output_13(func_2.CmAlarms_output_53);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    10F, 0F, 50F, 0F, 1F, 100F, 50F, -1F,
    0F, 50F, 0F, 1F, 100F, 10F, 10F, 50F,
    -1F, 60F, 1F, 1F, 10F, 10F, 1F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// Status
  public static final Property CmERC_WheelStatusAlarmNordic_output_61 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmERC_WheelStatusAlarmNordic_output_61() { return (BStatusNumeric) get(CmERC_WheelStatusAlarmNordic_output_61); }
  public void setCmERC_WheelStatusAlarmNordic_output_61(BStatusNumeric v) { set(CmERC_WheelStatusAlarmNordic_output_61,v,null); }
  public void setCmERC_WheelStatusAlarmNordic_output_61(float v) { getCmERC_WheelStatusAlarmNordic_output_61().setValue(v); }
// WheelCmd
  public static final Property CmERC_WheelStatusAlarmNordic_output_140 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmERC_WheelStatusAlarmNordic_output_140() { return (BStatusBoolean) get(CmERC_WheelStatusAlarmNordic_output_140); }
  public void setCmERC_WheelStatusAlarmNordic_output_140(BStatusBoolean v) { set(CmERC_WheelStatusAlarmNordic_output_140,v,null); }
  public void setCmERC_WheelStatusAlarmNordic_output_140(boolean v) { getCmERC_WheelStatusAlarmNordic_output_140().setValue(v); }
// FailCmdAlarm
  public static final Property CmERC_WheelStatusAlarmNordic_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmERC_WheelStatusAlarmNordic_output_12() { return (BStatusBoolean) get(CmERC_WheelStatusAlarmNordic_output_12); }
  public void setCmERC_WheelStatusAlarmNordic_output_12(BStatusBoolean v) { set(CmERC_WheelStatusAlarmNordic_output_12,v,null); }
  public void setCmERC_WheelStatusAlarmNordic_output_12(boolean v) { getCmERC_WheelStatusAlarmNordic_output_12().setValue(v); }
// CommAlarm
  public static final Property CmERC_WheelStatusAlarmNordic_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmERC_WheelStatusAlarmNordic_output_13() { return (BStatusBoolean) get(CmERC_WheelStatusAlarmNordic_output_13); }
  public void setCmERC_WheelStatusAlarmNordic_output_13(BStatusBoolean v) { set(CmERC_WheelStatusAlarmNordic_output_13,v,null); }
  public void setCmERC_WheelStatusAlarmNordic_output_13(boolean v) { getCmERC_WheelStatusAlarmNordic_output_13().setValue(v); }
// Disp_WheelSpeed
  public static final Property CmERC_WheelStatusAlarmNordic_output_76 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmERC_WheelStatusAlarmNordic_output_76() { return (BStatusNumeric) get(CmERC_WheelStatusAlarmNordic_output_76); }
  public void setCmERC_WheelStatusAlarmNordic_output_76(BStatusNumeric v) { set(CmERC_WheelStatusAlarmNordic_output_76,v,null); }
  public void setCmERC_WheelStatusAlarmNordic_output_76(float v) { getCmERC_WheelStatusAlarmNordic_output_76().setValue(v); }

  // macro parameter
// SYS-01: minimum rotation speed; 0 = steady signal
  public static final Property CmERC_WheelStatusAlarmNordic_parameter_19 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(900)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("per minute"))));
  public double getCmERC_WheelStatusAlarmNordic_parameter_19() { return getDouble(CmERC_WheelStatusAlarmNordic_parameter_19); }
  public void setCmERC_WheelStatusAlarmNordic_parameter_19(double v) { setDouble(CmERC_WheelStatusAlarmNordic_parameter_19,v,null); }
// ALM-01: delay status alarm
  public static final Property CmERC_WheelStatusAlarmNordic_parameter_20 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(60)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmERC_WheelStatusAlarmNordic_parameter_20() { return getDouble(CmERC_WheelStatusAlarmNordic_parameter_20); }
  public void setCmERC_WheelStatusAlarmNordic_parameter_20(double v) { setDouble(CmERC_WheelStatusAlarmNordic_parameter_20,v,null); }
// ALM-02: Wheel reset type
  public static final Property CmERC_WheelStatusAlarmNordic_parameter_21 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmERC_WheelStatusAlarmNordic_parameter_21() { return getDouble(CmERC_WheelStatusAlarmNordic_parameter_21); }
  public void setCmERC_WheelStatusAlarmNordic_parameter_21(double v) { setDouble(CmERC_WheelStatusAlarmNordic_parameter_21,v,null); }

  // macro inputs
// WheelEnable
  public static final Property CmERC_WheelStatusAlarmNordic_input_141 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmERC_WheelStatusAlarmNordic_input_141() { return (BStatusBoolean) get(CmERC_WheelStatusAlarmNordic_input_141); }
  public void setCmERC_WheelStatusAlarmNordic_input_141(BStatusBoolean v) { set(CmERC_WheelStatusAlarmNordic_input_141,v,null); }
  public void setCmERC_WheelStatusAlarmNordic_input_141(boolean v) { getCmERC_WheelStatusAlarmNordic_input_141().setValue(v); }
// Alarm
  public static final Property CmERC_WheelStatusAlarmNordic_input_9 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmERC_WheelStatusAlarmNordic_input_9() { return (BStatusBoolean) get(CmERC_WheelStatusAlarmNordic_input_9); }
  public void setCmERC_WheelStatusAlarmNordic_input_9(BStatusBoolean v) { set(CmERC_WheelStatusAlarmNordic_input_9,v,null); }
  public void setCmERC_WheelStatusAlarmNordic_input_9(boolean v) { getCmERC_WheelStatusAlarmNordic_input_9().setValue(v); }
// Reset
  public static final Property CmERC_WheelStatusAlarmNordic_input_10 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmERC_WheelStatusAlarmNordic_input_10() { return (BStatusBoolean) get(CmERC_WheelStatusAlarmNordic_input_10); }
  public void setCmERC_WheelStatusAlarmNordic_input_10(BStatusBoolean v) { set(CmERC_WheelStatusAlarmNordic_input_10,v,null); }
  public void setCmERC_WheelStatusAlarmNordic_input_10(boolean v) { getCmERC_WheelStatusAlarmNordic_input_10().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.02 [29] 10.01.2017-15:00").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5970898139258814865").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmERC_WheelStatusAlarmNordic.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmIDT20 func_98 = new CmIDT20();
  protected CfCompare2 func_53 = new CfCompare2();
  protected CfInputMultiplexer func_56 = new CfInputMultiplexer();
  protected CmPulseCounter func_22 = new CmPulseCounter();
  protected CmTimeCounter func_26 = new CmTimeCounter();
  protected CfMaximum func_67 = new CfMaximum();
  protected CfCompare2 func_49 = new CfCompare2();
  protected CfCompare1 func_75 = new CfCompare1();
  protected CfNot func_131 = new CfNot();
  protected CfCompare2 func_134 = new CfCompare2();
  protected CfIdt func_143 = new CfIdt();
  protected CfAnd func_128 = new CfAnd();
  protected CfOr func_137 = new CfOr();
  protected CfInputMultiplexer func_74 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_77 = new CfInputMultiplexer();
  protected CmAlarms func_2 = new CmAlarms();

  // default constructor
  public BCmERC_WheelStatusAlarmNordic()
  {
  }

  public void Start()
  {
    func_98.Start();
    func_22.Start();
    func_26.Start();
    func_2.Start();
  }
}
