/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    FNA_2St_FanSimpleNordic
Macro id:      5976155415483298061
Macro version: 11
Last change:   10.01.2017 - 14:56
Access Level:  2
Inputs:
  [1] FanStageCmd
  [2] FanEnable
  [3] EffManSwCond_MSt
  [4] FilteredOATemp
  [5] Status1
  [6] Status2
  [7] Alarm1
  [8] Alarm2
  [9] FanBeltIn
  [10] MaintSw
  [11] Reset
  [12] PlantMode
Outputs:
  [1] Stage1Cmd
  [2] Stage2Cmd
  [3] NextFanEnable
  [4] FailCmdAlarm
  [5] FanBeltAlarm
  [6] CommAlarm
  [7] OperationMode
Parameter:
  [1] SYS-01: serial/ parallel contacts ST1/ST2 0=serial
  [2] STx-01: delay from off to low speed
  [3] STx-02: delay from low to high speed
  [4] STx-03: delay from high to low speed
  [5] NFE-01: delay next fan enable
  [6] FSLIM-01: limit OAT to switch to min. speed
  [7] ALM-01: maint switch NO/NC; 1 = NC
  [8] ALM-02: maint switch reset type; 0= Man/ 1 = AutRes
  [9] ALM-03: fan alarm reset type 0=Man/ 1=AutRes
  [10] ALM-04: delay status alarm
  [11] ALM-05: delay fan belt alarm
  [12] DISP-01: fan belt alarm; 1 = alarm
  [13] DISP-02: fan fail cmd alarm; 1=alarm
Description:
This macro provides fan control for 1 stage (on/ off) or 2 stages (off/ low/ high) with fan alarms, delayed start-up of stages and integrated plant and fire overrides. 
The fan speed can be controlled with following inputs:
 - Fan enable
 - Fan speed control
 - Manual switch condition from wall modules
 - Fan maintenance switch
 - Plant mode from an air handling unit strategy
================================================================================*/

public class BCmFNA_2St_FanSimpleNordic
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmFNA_2St_FanSimpleNordic_output_21().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmFNA_2St_FanSimpleNordic_output_21().setStatus(BStatus.disabled);
    getCmFNA_2St_FanSimpleNordic_output_22().setStatus(BStatus.disabled);
    getCmFNA_2St_FanSimpleNordic_output_23().setStatus(BStatus.disabled);
    getCmFNA_2St_FanSimpleNordic_output_24().setStatus(BStatus.disabled);
    getCmFNA_2St_FanSimpleNordic_output_25().setStatus(BStatus.disabled);
    getCmFNA_2St_FanSimpleNordic_output_26().setStatus(BStatus.disabled);
    getCmFNA_2St_FanSimpleNordic_output_607().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmFNA_2St_FanSimpleNordic_output_21().setStatus(BStatus.ok);
    getCmFNA_2St_FanSimpleNordic_output_22().setStatus(BStatus.ok);
    getCmFNA_2St_FanSimpleNordic_output_23().setStatus(BStatus.ok);
    getCmFNA_2St_FanSimpleNordic_output_24().setStatus(BStatus.ok);
    getCmFNA_2St_FanSimpleNordic_output_25().setStatus(BStatus.ok);
    getCmFNA_2St_FanSimpleNordic_output_26().setStatus(BStatus.ok);
    getCmFNA_2St_FanSimpleNordic_output_607().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [565] Function call CfIdt
    func_565.input = 3F;
    func_565.Execute(  );
    setParameter(0, func_565.output[0]);

    // [212] Function call CfTruncate
    func_212.input = BooleanToFloat(ControlFunction.GetStartupFlag());
    func_212.Execute(  );

    // [199] Function call CfWindow
    func_199.inputValue = (float) getCmFNA_2St_FanSimpleNordic_input_12().getValue();
    func_199.inputMinimum = 3.7F;
    func_199.inputMaximum = 1000F;
    func_199.Execute(  );

    // [198] Function call CfWindow
    func_198.inputValue = (float) getCmFNA_2St_FanSimpleNordic_input_12().getValue();
    func_198.inputMinimum = 1.7F;
    func_198.inputMaximum = 3.3F;
    func_198.Execute(  );

    // [553] Function call CfWindow
    func_553.inputValue = (float) getCmFNA_2St_FanSimpleNordic_input_12().getValue();
    func_553.inputMinimum = 2.7F;
    func_553.inputMaximum = 3.3F;
    func_553.Execute(  );

    // [552] Function call CfInputMultiplexer
    func_552.inputSelect = BooleanToInt(func_553.output);
    func_552.input[1-1] = 1F;
    func_552.input[2-1] = 2F;
    func_552.Execute(  );

    // [555] Function call CfHysteresis
    func_555.inputX = (float) getCmFNA_2St_FanSimpleNordic_parameter_557();
    func_555.inputW = (float) getCmFNA_2St_FanSimpleNordic_input_538().getValue();
    func_555.Execute( this, 0 );

    // [564] Function call CfInputMultiplexer
    func_564.inputSelect = BooleanToInt(func_555.output1);
    func_564.input[1-1] = 2F;
    func_564.input[2-1] = 1F;
    func_564.Execute(  );

    // [215] Function call CfInputMultiplexer
    func_215.inputSelect = BooleanToInt(func_198.output);
    func_215.input[1-1] = 0F;
    func_215.input[2-1] = func_552.output;
    func_215.Execute(  );

    // [203] Function call CfMinimum
    func_203.input[0] = (float) getCmFNA_2St_FanSimpleNordic_input_11().getValue();
    func_203.input[1] = func_564.output;
    func_203.Execute(  );

    // [218] Function call CfInputMultiplexer
    func_218.inputSelect = BooleanToInt(func_199.output);
    func_218.input[1-1] = func_215.output;
    func_218.input[2-1] = func_203.output;
    func_218.Execute(  );

    // [205] Function call CfTruncate
    func_205.input = (float) getCmFNA_2St_FanSimpleNordic_input_13().getValue();
    func_205.Execute(  );

    // [213] Function call CfCompare1
    func_213.inputA = func_205.output;
    func_213.inputB = 30F;
    func_213.Execute(  );

    // [232] Macro call CmFan_Release
    func_232.CmFan_Release_input_1 = func_205.output;
    func_232.CmFan_Release_input_2 = FloatToBoolean(func_212.output);
    func_232.CmFan_Release_input_4 = func_218.output;
    func_232.CmFan_Release_input_5 = func_512.outputOR;
    func_232.Execute(  );

    // [206] Function call CfAnd
    func_206.input[0] = getCmFNA_2St_FanSimpleNordic_input_10().getValue();
    func_206.input[1] = func_232.CmFan_Release_output_6;
    func_206.Execute(  );

    // [229] Macro call CmRelease_Stage_1
    func_229.CmRelease_Stage_1_input_2 = FloatToBoolean(func_212.output);
    func_229.CmRelease_Stage_1_input_4 = func_206.outputAND;
    func_229.Execute(  );

    // [207] Macro call CmDelay_Stage_1
    func_207.CmDelay_Stage_1_input_1 = func_230.CmRelease_Stage_2_output_5;
    func_207.CmDelay_Stage_1_input_2 = func_206.outputAND;
    func_207.CmDelay_Stage_1_input_3 = (float) getCmFNA_2St_FanSimpleNordic_parameter_28();
    func_207.CmDelay_Stage_1_input_4 = (float) getCmFNA_2St_FanSimpleNordic_parameter_30();
    func_207.Execute( this, 1 );

    // [455] Function call CfNot
    func_455.input = func_207.CmDelay_Stage_1_output_5;
    func_455.Execute(  );

    // [454] Function call CfAnd
    func_454.input[0] = func_455.output;
    func_454.input[1] = func_206.outputAND;
    func_454.Execute(  );

    // [230] Macro call CmRelease_Stage_2
    func_230.CmRelease_Stage_2_input_1 = func_218.output;
    func_230.CmRelease_Stage_2_input_3 = func_454.outputAND;
    func_230.CmRelease_Stage_2_input_46 = (float) getCmFNA_2St_FanSimpleNordic_parameter_29();
    func_230.Execute( this, 3 );

    // [447] Function call CfIdt
    func_447.input = 0F;
    func_447.Execute(  );
    setParameter(8, func_447.output[0]);

    // [446] Function call CfIdt
    func_446.input = 2F;
    func_446.Execute(  );
    setParameter(9, func_446.output[0]);

    // [436] Function call CfOr
    func_436.input[0] = getCmFNA_2St_FanSimpleNordic_output_21().getValue();
    func_436.input[1] = func_230.CmRelease_Stage_2_output_5;
    func_436.Execute(  );

    // [437] Function call CfDelayOnOff
    func_437.input = func_436.outputOR;
    func_437.Execute( this, 8 );

    // [233] Macro call CmNext_Fan_Enable
    func_233.CmNext_Fan_Enable_input_1 = func_206.outputAND;
    func_233.CmNext_Fan_Enable_input_3 = func_437.output;
    func_233.CmNext_Fan_Enable_input_6 = (float) getCmFNA_2St_FanSimpleNordic_parameter_31();
    func_233.Execute( this, 10 );

    // [419] Function call CfIdt
    func_419.input = 0F;
    func_419.Execute(  );
    setParameter(11, func_419.output[0]);

    // [418] Function call CfIdt
    func_418.input = 1F;
    func_418.Execute(  );
    setParameter(12, func_418.output[0]);

    // [416] Function call CfDelayOnOff
    func_416.input = func_230.CmRelease_Stage_2_output_5;
    func_416.Execute( this, 11 );

    // [188] Function call CfAnd
    func_188.input[0] = FloatToBoolean((float) getCmFNA_2St_FanSimpleNordic_parameter_160());
    func_188.input[1] = func_416.output;
    func_188.Execute(  );

    // [200] Function call CfIdt
    func_200.input = 1F;
    func_200.Execute(  );
    setParameter(15, func_200.output[0]);
    setParameter(21, func_200.output[1]);

    // [201] Function call CfIdt
    func_201.input = (float) getCmFNA_2St_FanSimpleNordic_parameter_165();
    func_201.Execute(  );
    setParameter(13, func_201.output[0]);
    setParameter(19, func_201.output[1]);

    // [202] Function call CfIdt
    func_202.input = (float) getCmFNA_2St_FanSimpleNordic_parameter_163();
    func_202.Execute(  );
    setParameter(14, func_202.output[0]);
    setParameter(20, func_202.output[1]);

    // [204] Function call CfCompare1
    func_204.inputA = (float) getCmFNA_2St_FanSimpleNordic_parameter_165();
    func_204.inputB = 0F;
    func_204.Execute(  );

    // [220] Macro call CmAlarms
    if ( func_526.outputOR)
    {
      func_220.CmAlarms_input_1 = getCmFNA_2St_FanSimpleNordic_output_21().getValue();
      func_220.CmAlarms_input_2 = getCmFNA_2St_FanSimpleNordic_input_14().getValue();
      func_220.CmAlarms_input_3 = false;
      func_220.CmAlarms_input_4 = func_481.output;
      func_220.Execute( this, 13 );
    }

    // [216] Macro call CmAlarms
    if ( func_526.outputOR)
    {
      func_216.CmAlarms_input_1 = func_230.CmRelease_Stage_2_output_5;
      func_216.CmAlarms_input_2 = getCmFNA_2St_FanSimpleNordic_input_15().getValue();
      func_216.CmAlarms_input_3 = false;
      func_216.CmAlarms_input_4 = func_481.output;
      func_216.Execute( this, 19 );
    }

    // [223] Function call CfOr
    func_223.input[0] = func_220.CmAlarms_output_7;
    func_223.input[1] = func_216.CmAlarms_output_7;
    func_223.Execute(  );

    // [540] Function call CfAnd
    func_540.input[0] = func_223.outputOR;
    func_540.input[1] = func_526.outputOR;
    func_540.Execute(  );

    // [224] Function call CfOr
    func_224.input[0] = func_220.CmAlarms_output_53;
    func_224.input[1] = func_216.CmAlarms_output_53;
    func_224.Execute(  );

    // [542] Function call CfAnd
    func_542.input[0] = func_224.outputOR;
    func_542.input[1] = func_526.outputOR;
    func_542.Execute(  );

    // [227] Function call CfIdt
    func_227.input = BooleanToFloat(func_542.outputAND);
    func_227.Execute(  );

    // [228] Function call CfIdt
    func_228.input = BooleanToFloat(func_540.outputAND);
    func_228.Execute(  );
    setCmFNA_2St_FanSimpleNordic_output_24(FloatToBoolean(func_228.output[0]));
    setCmFNA_2St_FanSimpleNordic_parameter_169(func_228.output[1]);

    // [387] Function call CfOr
    func_387.input[0] = FloatToBoolean(func_227.output[1]);
    func_387.input[1] = func_190.CmMaint_Switch_Alarm_output_4;
    func_387.input[2] = getCmFNA_2St_FanSimpleNordic_input_16().getValue();
    func_387.input[3] = getCmFNA_2St_FanSimpleNordic_input_17().getValue();
    func_387.Execute(  );
    setCmFNA_2St_FanSimpleNordic_output_26(func_387.outputOR);

    // [491] Macro call CmIDT05
    func_491.CmIDT05_input_1 = (float) getCmFNA_2St_FanSimpleNordic_parameter_166();
    func_491.CmIDT05_input_2 = 0F;
    func_491.CmIDT05_input_3 = BooleanToFloat(getCmFNA_2St_FanSimpleNordic_output_25().getValue());
    func_491.CmIDT05_input_4 = 0F;
    func_491.CmIDT05_input_5 = 0F;
    func_491.Execute(  );
    setParameter(25, func_491.CmIDT05_output_21);
    setParameter(26, func_491.CmIDT05_output_22);
    setCmFNA_2St_FanSimpleNordic_parameter_38(func_491.CmIDT05_output_23);

    // [182] Function call CfNot
    func_182.input = func_512.outputOR;
    func_182.Execute(  );

    // [172] Function call CfOr
    func_172.input[0] = getCmFNA_2St_FanSimpleNordic_output_21().getValue();
    func_172.input[1] = func_230.CmRelease_Stage_2_output_5;
    func_172.Execute(  );

    // [183] Function call CfAnd
    func_183.input[0] = func_182.output;
    func_183.input[1] = func_172.outputOR;
    func_183.Execute(  );

    // [191] Function call CfCompare1
    func_191.inputA = (float) getCmFNA_2St_FanSimpleNordic_parameter_166();
    func_191.inputB = 0F;
    func_191.Execute(  );

    // [485] Function call CfOr
    func_485.input[0] = func_191.outputGreater;
    func_485.input[1] = getCmFNA_2St_FanSimpleNordic_output_25().getValue();
    func_485.Execute(  );

    // [333] Macro call CmFan_Belt_Alarm
    if ( func_485.outputOR)
    {
      func_333.CmFan_Belt_Alarm_input_20 = func_183.outputAND;
      func_333.CmFan_Belt_Alarm_input_21 = getCmFNA_2St_FanSimpleNordic_input_18().getValue();
      func_333.CmFan_Belt_Alarm_input_22 = func_481.output;
      func_333.Execute( this, 25 );
      setCmFNA_2St_FanSimpleNordic_output_25(func_333.CmFan_Belt_Alarm_output_23);
    }

    // [190] Macro call CmMaint_Switch_Alarm
    func_190.CmMaint_Switch_Alarm_input_2 = getCmFNA_2St_FanSimpleNordic_input_19().getValue();
    func_190.CmMaint_Switch_Alarm_input_146 = FloatToBoolean((float) getCmFNA_2St_FanSimpleNordic_parameter_161());
    func_190.CmMaint_Switch_Alarm_input_1 = FloatToBoolean((float) getCmFNA_2St_FanSimpleNordic_parameter_162());
    func_190.CmMaint_Switch_Alarm_input_3 = func_481.output;
    func_190.Execute(  );

    // [481] Function call CfMonoflop
    func_481.input = BooleanToFloat(getCmFNA_2St_FanSimpleNordic_input_20().getValue());
    func_481.Execute( this, 32 );

    // [508] Function call CfWindow
    func_508.inputValue = (float) getCmFNA_2St_FanSimpleNordic_parameter_163();
    func_508.inputMinimum = 0.8F;
    func_508.inputMaximum = 1.2F;
    func_508.Execute(  );

    // [509] Function call CfOr
    func_509.input[0] = getCmFNA_2St_FanSimpleNordic_output_24().getValue();
    func_509.input[1] = FloatToBoolean(func_227.output[0]);
    func_509.Execute(  );

    // [526] Function call CfOr
    func_526.input[0] = func_204.outputGreater;
    func_526.input[1] = FloatToBoolean(func_227.output[0]);
    func_526.Execute(  );

    // [510] Function call CfNot
    func_510.input = func_508.output;
    func_510.Execute(  );

    // [511] Function call CfAnd
    func_511.input[0] = func_510.output;
    func_511.input[1] = func_509.outputOR;
    func_511.Execute(  );

    // [512] Function call CfOr
    func_512.input[0] = func_511.outputAND;
    func_512.input[1] = getCmFNA_2St_FanSimpleNordic_output_25().getValue();
    func_512.input[2] = func_190.CmMaint_Switch_Alarm_output_4;
    func_512.Execute(  );

    // [608] Function call CfIdt
    func_608.input = BooleanToFloat(func_512.outputOR);
    func_608.Execute(  );

    // [613] Function call CfIdt
    func_613.input = BooleanToFloat(getCmFNA_2St_FanSimpleNordic_output_25().getValue());
    func_613.Execute(  );

    // [611] Function call CfIdt
    func_611.input = BooleanToFloat(func_190.CmMaint_Switch_Alarm_output_4);
    func_611.Execute(  );

    // [609] Function call CfIdt
    func_609.input = BooleanToFloat(func_213.outputEqual);
    func_609.Execute(  );

    // [583] Function call CfInputMultiplexer
    func_583.inputSelect = BooleanToInt(func_207.CmDelay_Stage_1_output_5);
    func_583.input[1-1] = BooleanToFloat(func_229.CmRelease_Stage_1_output_9);
    func_583.input[2-1] = 0F;
    func_583.Execute(  );

    // [589] Function call CfInputMultiplexer
    func_589.inputSelect = BooleanToInt(func_188.outputAND);
    func_589.input[1-1] = func_583.output;
    func_589.input[2-1] = 0F;
    func_589.Execute(  );

    // [592] Function call CfInputMultiplexer
    func_592.inputSelect = FloatToInt(func_608.output[0]);
    func_592.input[1-1] = func_589.output;
    func_592.input[2-1] = 0F;
    func_592.Execute(  );

    // [597] Function call CfInputMultiplexer
    func_597.inputSelect = FloatToInt(func_613.output[0]);
    func_597.input[1-1] = func_592.output;
    func_597.input[2-1] = 0F;
    func_597.Execute(  );

    // [595] Function call CfInputMultiplexer
    func_595.inputSelect = FloatToInt(func_611.output[0]);
    func_595.input[1-1] = func_597.output;
    func_595.input[2-1] = 0F;
    func_595.Execute(  );

    // [587] Function call CfInputMultiplexer
    func_587.inputSelect = BooleanToInt(func_207.CmDelay_Stage_1_output_5);
    func_587.input[1-1] = 15F;
    func_587.input[2-1] = 13F;
    func_587.Execute(  );

    // [585] Function call CfInputMultiplexer
    func_585.inputSelect = BooleanToInt(func_188.outputAND);
    func_585.input[1-1] = func_587.output;
    func_585.input[2-1] = 12F;
    func_585.Execute(  );

    // [604] Function call CfInputMultiplexer
    func_604.inputSelect = FloatToInt(func_608.output[0]);
    func_604.input[1-1] = func_585.output;
    func_604.input[2-1] = 11F;
    func_604.Execute(  );

    // [602] Function call CfInputMultiplexer
    func_602.inputSelect = FloatToInt(func_613.output[0]);
    func_602.input[1-1] = func_604.output;
    func_602.input[2-1] = 10F;
    func_602.Execute(  );

    // [600] Function call CfInputMultiplexer
    func_600.inputSelect = FloatToInt(func_611.output[0]);
    func_600.input[1-1] = func_602.output;
    func_600.input[2-1] = 5F;
    func_600.Execute(  );

    // [593] Function call CfInputMultiplexer
    func_593.inputSelect = FloatToInt(func_609.output[0]);
    func_593.input[1-1] = func_595.output;
    func_593.input[2-1] = 0F;
    func_593.Execute(  );
    setCmFNA_2St_FanSimpleNordic_output_21(FloatToBoolean(func_593.output));

    // [599] Function call CfInputMultiplexer
    func_599.inputSelect = FloatToInt(func_609.output[0]);
    func_599.input[1-1] = func_600.output;
    func_599.input[2-1] = 2F;
    func_599.Execute(  );
    setCmFNA_2St_FanSimpleNordic_output_607(func_599.output);

    // [629] Function call CfInputMultiplexer
    func_629.inputSelect = FloatToInt(func_608.output[0]);
    func_629.input[1-1] = BooleanToFloat(func_230.CmRelease_Stage_2_output_45);
    func_629.input[2-1] = 0F;
    func_629.Execute(  );

    // [625] Function call CfInputMultiplexer
    func_625.inputSelect = FloatToInt(func_613.output[0]);
    func_625.input[1-1] = func_629.output;
    func_625.input[2-1] = 0F;
    func_625.Execute(  );

    // [627] Function call CfInputMultiplexer
    func_627.inputSelect = FloatToInt(func_608.output[0]);
    func_627.input[1-1] = BooleanToFloat(func_233.CmNext_Fan_Enable_output_7);
    func_627.input[2-1] = 0F;
    func_627.Execute(  );

    // [623] Function call CfInputMultiplexer
    func_623.inputSelect = FloatToInt(func_613.output[0]);
    func_623.input[1-1] = func_627.output;
    func_623.input[2-1] = 0F;
    func_623.Execute(  );

    // [621] Function call CfInputMultiplexer
    func_621.inputSelect = FloatToInt(func_611.output[0]);
    func_621.input[1-1] = func_625.output;
    func_621.input[2-1] = 0F;
    func_621.Execute(  );

    // [619] Function call CfInputMultiplexer
    func_619.inputSelect = FloatToInt(func_611.output[0]);
    func_619.input[1-1] = func_623.output;
    func_619.input[2-1] = 0F;
    func_619.Execute(  );

    // [617] Function call CfInputMultiplexer
    func_617.inputSelect = FloatToInt(func_609.output[0]);
    func_617.input[1-1] = func_621.output;
    func_617.input[2-1] = 0F;
    func_617.Execute(  );
    setCmFNA_2St_FanSimpleNordic_output_22(FloatToBoolean(func_617.output));

    // [616] Function call CfInputMultiplexer
    func_616.inputSelect = FloatToInt(func_609.output[0]);
    func_616.input[1-1] = func_619.output;
    func_616.input[2-1] = 0F;
    func_616.Execute(  );
    setCmFNA_2St_FanSimpleNordic_output_23(FloatToBoolean(func_616.output));

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    3F, 1F, 1F, 10F, 1F, 10F, 10F, 10F,
    0F, 2F, 40F, 10F, 10F, 60F, 1F, 1F,
    10F, 10F, 1F, 60F, 1F, 1F, 10F, 10F,
    1F, 60F, 1F, 10F, 15F, 0F, 2F, 0F,
    10F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// Stage1Cmd
  public static final Property CmFNA_2St_FanSimpleNordic_output_21 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_FanSimpleNordic_output_21() { return (BStatusBoolean) get(CmFNA_2St_FanSimpleNordic_output_21); }
  public void setCmFNA_2St_FanSimpleNordic_output_21(BStatusBoolean v) { set(CmFNA_2St_FanSimpleNordic_output_21,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_output_21(boolean v) { getCmFNA_2St_FanSimpleNordic_output_21().setValue(v); }
// Stage2Cmd
  public static final Property CmFNA_2St_FanSimpleNordic_output_22 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_FanSimpleNordic_output_22() { return (BStatusBoolean) get(CmFNA_2St_FanSimpleNordic_output_22); }
  public void setCmFNA_2St_FanSimpleNordic_output_22(BStatusBoolean v) { set(CmFNA_2St_FanSimpleNordic_output_22,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_output_22(boolean v) { getCmFNA_2St_FanSimpleNordic_output_22().setValue(v); }
// NextFanEnable
  public static final Property CmFNA_2St_FanSimpleNordic_output_23 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_FanSimpleNordic_output_23() { return (BStatusBoolean) get(CmFNA_2St_FanSimpleNordic_output_23); }
  public void setCmFNA_2St_FanSimpleNordic_output_23(BStatusBoolean v) { set(CmFNA_2St_FanSimpleNordic_output_23,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_output_23(boolean v) { getCmFNA_2St_FanSimpleNordic_output_23().setValue(v); }
// FailCmdAlarm
  public static final Property CmFNA_2St_FanSimpleNordic_output_24 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_FanSimpleNordic_output_24() { return (BStatusBoolean) get(CmFNA_2St_FanSimpleNordic_output_24); }
  public void setCmFNA_2St_FanSimpleNordic_output_24(BStatusBoolean v) { set(CmFNA_2St_FanSimpleNordic_output_24,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_output_24(boolean v) { getCmFNA_2St_FanSimpleNordic_output_24().setValue(v); }
// FanBeltAlarm
  public static final Property CmFNA_2St_FanSimpleNordic_output_25 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_FanSimpleNordic_output_25() { return (BStatusBoolean) get(CmFNA_2St_FanSimpleNordic_output_25); }
  public void setCmFNA_2St_FanSimpleNordic_output_25(BStatusBoolean v) { set(CmFNA_2St_FanSimpleNordic_output_25,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_output_25(boolean v) { getCmFNA_2St_FanSimpleNordic_output_25().setValue(v); }
// CommAlarm
  public static final Property CmFNA_2St_FanSimpleNordic_output_26 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmFNA_2St_FanSimpleNordic_output_26() { return (BStatusBoolean) get(CmFNA_2St_FanSimpleNordic_output_26); }
  public void setCmFNA_2St_FanSimpleNordic_output_26(BStatusBoolean v) { set(CmFNA_2St_FanSimpleNordic_output_26,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_output_26(boolean v) { getCmFNA_2St_FanSimpleNordic_output_26().setValue(v); }
// OperationMode
  public static final Property CmFNA_2St_FanSimpleNordic_output_607 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmFNA_2St_FanSimpleNordic_output_607() { return (BStatusNumeric) get(CmFNA_2St_FanSimpleNordic_output_607); }
  public void setCmFNA_2St_FanSimpleNordic_output_607(BStatusNumeric v) { set(CmFNA_2St_FanSimpleNordic_output_607,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_output_607(float v) { getCmFNA_2St_FanSimpleNordic_output_607().setValue(v); }

  // macro parameter
// SYS-01: serial/ parallel contacts ST1/ST2 0=serial
  public static final Property CmFNA_2St_FanSimpleNordic_parameter_160 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_FanSimpleNordic_parameter_160() { return getDouble(CmFNA_2St_FanSimpleNordic_parameter_160); }
  public void setCmFNA_2St_FanSimpleNordic_parameter_160(double v) { setDouble(CmFNA_2St_FanSimpleNordic_parameter_160,v,null); }
// STx-01: delay from off to low speed
  public static final Property CmFNA_2St_FanSimpleNordic_parameter_28 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_FanSimpleNordic_parameter_28() { return getDouble(CmFNA_2St_FanSimpleNordic_parameter_28); }
  public void setCmFNA_2St_FanSimpleNordic_parameter_28(double v) { setDouble(CmFNA_2St_FanSimpleNordic_parameter_28,v,null); }
// STx-02: delay from low to high speed
  public static final Property CmFNA_2St_FanSimpleNordic_parameter_29 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(60)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_FanSimpleNordic_parameter_29() { return getDouble(CmFNA_2St_FanSimpleNordic_parameter_29); }
  public void setCmFNA_2St_FanSimpleNordic_parameter_29(double v) { setDouble(CmFNA_2St_FanSimpleNordic_parameter_29,v,null); }
// STx-03: delay from high to low speed
  public static final Property CmFNA_2St_FanSimpleNordic_parameter_30 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(120)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_FanSimpleNordic_parameter_30() { return getDouble(CmFNA_2St_FanSimpleNordic_parameter_30); }
  public void setCmFNA_2St_FanSimpleNordic_parameter_30(double v) { setDouble(CmFNA_2St_FanSimpleNordic_parameter_30,v,null); }
// NFE-01: delay next fan enable
  public static final Property CmFNA_2St_FanSimpleNordic_parameter_31 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_FanSimpleNordic_parameter_31() { return getDouble(CmFNA_2St_FanSimpleNordic_parameter_31); }
  public void setCmFNA_2St_FanSimpleNordic_parameter_31(double v) { setDouble(CmFNA_2St_FanSimpleNordic_parameter_31,v,null); }
// FSLIM-01: limit OAT to switch to min. speed
  public static final Property CmFNA_2St_FanSimpleNordic_parameter_557 = newProperty( 0, BDouble.make( -20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(10)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmFNA_2St_FanSimpleNordic_parameter_557() { return getDouble(CmFNA_2St_FanSimpleNordic_parameter_557); }
  public void setCmFNA_2St_FanSimpleNordic_parameter_557(double v) { setDouble(CmFNA_2St_FanSimpleNordic_parameter_557,v,null); }
// ALM-01: maint switch NO/NC; 1 = NC
  public static final Property CmFNA_2St_FanSimpleNordic_parameter_161 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_FanSimpleNordic_parameter_161() { return getDouble(CmFNA_2St_FanSimpleNordic_parameter_161); }
  public void setCmFNA_2St_FanSimpleNordic_parameter_161(double v) { setDouble(CmFNA_2St_FanSimpleNordic_parameter_161,v,null); }
// ALM-02: maint switch reset type; 0= Man/ 1 = AutRes
  public static final Property CmFNA_2St_FanSimpleNordic_parameter_162 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_FanSimpleNordic_parameter_162() { return getDouble(CmFNA_2St_FanSimpleNordic_parameter_162); }
  public void setCmFNA_2St_FanSimpleNordic_parameter_162(double v) { setDouble(CmFNA_2St_FanSimpleNordic_parameter_162,v,null); }
// ALM-03: fan alarm reset type 0=Man/ 1=AutRes
  public static final Property CmFNA_2St_FanSimpleNordic_parameter_163 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_FanSimpleNordic_parameter_163() { return getDouble(CmFNA_2St_FanSimpleNordic_parameter_163); }
  public void setCmFNA_2St_FanSimpleNordic_parameter_163(double v) { setDouble(CmFNA_2St_FanSimpleNordic_parameter_163,v,null); }
// ALM-04: delay status alarm
  public static final Property CmFNA_2St_FanSimpleNordic_parameter_165 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_FanSimpleNordic_parameter_165() { return getDouble(CmFNA_2St_FanSimpleNordic_parameter_165); }
  public void setCmFNA_2St_FanSimpleNordic_parameter_165(double v) { setDouble(CmFNA_2St_FanSimpleNordic_parameter_165,v,null); }
// ALM-05: delay fan belt alarm
  public static final Property CmFNA_2St_FanSimpleNordic_parameter_166 = newProperty( 0, BDouble.make( 120 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmFNA_2St_FanSimpleNordic_parameter_166() { return getDouble(CmFNA_2St_FanSimpleNordic_parameter_166); }
  public void setCmFNA_2St_FanSimpleNordic_parameter_166(double v) { setDouble(CmFNA_2St_FanSimpleNordic_parameter_166,v,null); }
// DISP-01: fan belt alarm; 1 = alarm
  public static final Property CmFNA_2St_FanSimpleNordic_parameter_38 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_FanSimpleNordic_parameter_38() { return getDouble(CmFNA_2St_FanSimpleNordic_parameter_38); }
  public void setCmFNA_2St_FanSimpleNordic_parameter_38(double v) { setDouble(CmFNA_2St_FanSimpleNordic_parameter_38,v,null); }
// DISP-02: fan fail cmd alarm; 1=alarm
  public static final Property CmFNA_2St_FanSimpleNordic_parameter_169 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmFNA_2St_FanSimpleNordic_parameter_169() { return getDouble(CmFNA_2St_FanSimpleNordic_parameter_169); }
  public void setCmFNA_2St_FanSimpleNordic_parameter_169(double v) { setDouble(CmFNA_2St_FanSimpleNordic_parameter_169,v,null); }

  // macro inputs
// FanStageCmd
  public static final Property CmFNA_2St_FanSimpleNordic_input_11 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmFNA_2St_FanSimpleNordic_input_11() { return (BStatusNumeric) get(CmFNA_2St_FanSimpleNordic_input_11); }
  public void setCmFNA_2St_FanSimpleNordic_input_11(BStatusNumeric v) { set(CmFNA_2St_FanSimpleNordic_input_11,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_input_11(float v) { getCmFNA_2St_FanSimpleNordic_input_11().setValue(v); }
// FanEnable
  public static final Property CmFNA_2St_FanSimpleNordic_input_10 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmFNA_2St_FanSimpleNordic_input_10() { return (BStatusBoolean) get(CmFNA_2St_FanSimpleNordic_input_10); }
  public void setCmFNA_2St_FanSimpleNordic_input_10(BStatusBoolean v) { set(CmFNA_2St_FanSimpleNordic_input_10,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_input_10(boolean v) { getCmFNA_2St_FanSimpleNordic_input_10().setValue(v); }
// EffManSwCond_MSt
  public static final Property CmFNA_2St_FanSimpleNordic_input_12 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmFNA_2St_FanSimpleNordic_input_12() { return (BStatusNumeric) get(CmFNA_2St_FanSimpleNordic_input_12); }
  public void setCmFNA_2St_FanSimpleNordic_input_12(BStatusNumeric v) { set(CmFNA_2St_FanSimpleNordic_input_12,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_input_12(float v) { getCmFNA_2St_FanSimpleNordic_input_12().setValue(v); }
// FilteredOATemp
  public static final Property CmFNA_2St_FanSimpleNordic_input_538 = newProperty( Flags.SUMMARY, new BStatusNumeric( 15 ), null);
  public BStatusNumeric getCmFNA_2St_FanSimpleNordic_input_538() { return (BStatusNumeric) get(CmFNA_2St_FanSimpleNordic_input_538); }
  public void setCmFNA_2St_FanSimpleNordic_input_538(BStatusNumeric v) { set(CmFNA_2St_FanSimpleNordic_input_538,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_input_538(float v) { getCmFNA_2St_FanSimpleNordic_input_538().setValue(v); }
// Status1
  public static final Property CmFNA_2St_FanSimpleNordic_input_14 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFNA_2St_FanSimpleNordic_input_14() { return (BStatusBoolean) get(CmFNA_2St_FanSimpleNordic_input_14); }
  public void setCmFNA_2St_FanSimpleNordic_input_14(BStatusBoolean v) { set(CmFNA_2St_FanSimpleNordic_input_14,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_input_14(boolean v) { getCmFNA_2St_FanSimpleNordic_input_14().setValue(v); }
// Status2
  public static final Property CmFNA_2St_FanSimpleNordic_input_15 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFNA_2St_FanSimpleNordic_input_15() { return (BStatusBoolean) get(CmFNA_2St_FanSimpleNordic_input_15); }
  public void setCmFNA_2St_FanSimpleNordic_input_15(BStatusBoolean v) { set(CmFNA_2St_FanSimpleNordic_input_15,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_input_15(boolean v) { getCmFNA_2St_FanSimpleNordic_input_15().setValue(v); }
// Alarm1
  public static final Property CmFNA_2St_FanSimpleNordic_input_16 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFNA_2St_FanSimpleNordic_input_16() { return (BStatusBoolean) get(CmFNA_2St_FanSimpleNordic_input_16); }
  public void setCmFNA_2St_FanSimpleNordic_input_16(BStatusBoolean v) { set(CmFNA_2St_FanSimpleNordic_input_16,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_input_16(boolean v) { getCmFNA_2St_FanSimpleNordic_input_16().setValue(v); }
// Alarm2
  public static final Property CmFNA_2St_FanSimpleNordic_input_17 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFNA_2St_FanSimpleNordic_input_17() { return (BStatusBoolean) get(CmFNA_2St_FanSimpleNordic_input_17); }
  public void setCmFNA_2St_FanSimpleNordic_input_17(BStatusBoolean v) { set(CmFNA_2St_FanSimpleNordic_input_17,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_input_17(boolean v) { getCmFNA_2St_FanSimpleNordic_input_17().setValue(v); }
// FanBeltIn
  public static final Property CmFNA_2St_FanSimpleNordic_input_18 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmFNA_2St_FanSimpleNordic_input_18() { return (BStatusBoolean) get(CmFNA_2St_FanSimpleNordic_input_18); }
  public void setCmFNA_2St_FanSimpleNordic_input_18(BStatusBoolean v) { set(CmFNA_2St_FanSimpleNordic_input_18,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_input_18(boolean v) { getCmFNA_2St_FanSimpleNordic_input_18().setValue(v); }
// MaintSw
  public static final Property CmFNA_2St_FanSimpleNordic_input_19 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmFNA_2St_FanSimpleNordic_input_19() { return (BStatusBoolean) get(CmFNA_2St_FanSimpleNordic_input_19); }
  public void setCmFNA_2St_FanSimpleNordic_input_19(BStatusBoolean v) { set(CmFNA_2St_FanSimpleNordic_input_19,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_input_19(boolean v) { getCmFNA_2St_FanSimpleNordic_input_19().setValue(v); }
// Reset
  public static final Property CmFNA_2St_FanSimpleNordic_input_20 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmFNA_2St_FanSimpleNordic_input_20() { return (BStatusBoolean) get(CmFNA_2St_FanSimpleNordic_input_20); }
  public void setCmFNA_2St_FanSimpleNordic_input_20(BStatusBoolean v) { set(CmFNA_2St_FanSimpleNordic_input_20,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_input_20(boolean v) { getCmFNA_2St_FanSimpleNordic_input_20().setValue(v); }
// PlantMode
  public static final Property CmFNA_2St_FanSimpleNordic_input_13 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmFNA_2St_FanSimpleNordic_input_13() { return (BStatusNumeric) get(CmFNA_2St_FanSimpleNordic_input_13); }
  public void setCmFNA_2St_FanSimpleNordic_input_13(BStatusNumeric v) { set(CmFNA_2St_FanSimpleNordic_input_13,v,null); }
  public void setCmFNA_2St_FanSimpleNordic_input_13(float v) { getCmFNA_2St_FanSimpleNordic_input_13().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.03 [11] 10.01.2017-14:56").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5976155415483298061").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmFNA_2St_FanSimpleNordic.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfIdt func_565 = new CfIdt();
  protected CfTruncate func_212 = new CfTruncate();
  protected CfWindow func_199 = new CfWindow();
  protected CfWindow func_198 = new CfWindow();
  protected CfWindow func_553 = new CfWindow();
  protected CfInputMultiplexer func_552 = new CfInputMultiplexer();
  protected CfHysteresis func_555 = new CfHysteresis();
  protected CfInputMultiplexer func_564 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_215 = new CfInputMultiplexer();
  protected CfMinimum func_203 = new CfMinimum();
  protected CfInputMultiplexer func_218 = new CfInputMultiplexer();
  protected CfTruncate func_205 = new CfTruncate();
  protected CfCompare1 func_213 = new CfCompare1();
  protected CmFan_Release func_232 = new CmFan_Release();
  protected CfAnd func_206 = new CfAnd();
  protected CmRelease_Stage_1 func_229 = new CmRelease_Stage_1();
  protected CmDelay_Stage_1 func_207 = new CmDelay_Stage_1();
  protected CfNot func_455 = new CfNot();
  protected CfAnd func_454 = new CfAnd();
  protected CmRelease_Stage_2 func_230 = new CmRelease_Stage_2();
  protected CfIdt func_447 = new CfIdt();
  protected CfIdt func_446 = new CfIdt();
  protected CfOr func_436 = new CfOr();
  protected CfDelayOnOff func_437 = new CfDelayOnOff();
  protected CmNext_Fan_Enable func_233 = new CmNext_Fan_Enable();
  protected CfIdt func_419 = new CfIdt();
  protected CfIdt func_418 = new CfIdt();
  protected CfDelayOnOff func_416 = new CfDelayOnOff();
  protected CfAnd func_188 = new CfAnd();
  protected CfIdt func_200 = new CfIdt();
  protected CfIdt func_201 = new CfIdt();
  protected CfIdt func_202 = new CfIdt();
  protected CfCompare1 func_204 = new CfCompare1();
  protected CmAlarms func_220 = new CmAlarms();
  protected CmAlarms func_216 = new CmAlarms();
  protected CfOr func_223 = new CfOr();
  protected CfAnd func_540 = new CfAnd();
  protected CfOr func_224 = new CfOr();
  protected CfAnd func_542 = new CfAnd();
  protected CfIdt func_227 = new CfIdt();
  protected CfIdt func_228 = new CfIdt();
  protected CfOr func_387 = new CfOr();
  protected CmIDT05 func_491 = new CmIDT05();
  protected CfNot func_182 = new CfNot();
  protected CfOr func_172 = new CfOr();
  protected CfAnd func_183 = new CfAnd();
  protected CfCompare1 func_191 = new CfCompare1();
  protected CfOr func_485 = new CfOr();
  protected CmFan_Belt_Alarm func_333 = new CmFan_Belt_Alarm();
  protected CmMaint_Switch_Alarm func_190 = new CmMaint_Switch_Alarm();
  protected CfMonoflop func_481 = new CfMonoflop();
  protected CfWindow func_508 = new CfWindow();
  protected CfOr func_509 = new CfOr();
  protected CfOr func_526 = new CfOr();
  protected CfNot func_510 = new CfNot();
  protected CfAnd func_511 = new CfAnd();
  protected CfOr func_512 = new CfOr();
  protected CfIdt func_608 = new CfIdt();
  protected CfIdt func_613 = new CfIdt();
  protected CfIdt func_611 = new CfIdt();
  protected CfIdt func_609 = new CfIdt();
  protected CfInputMultiplexer func_583 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_589 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_592 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_597 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_595 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_587 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_585 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_604 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_602 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_600 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_593 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_599 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_629 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_625 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_627 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_623 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_621 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_619 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_617 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_616 = new CfInputMultiplexer();

  // default constructor
  public BCmFNA_2St_FanSimpleNordic()
  {
    func_200.configure(2);
    func_201.configure(2);
    func_202.configure(2);
    func_227.configure(2);
    func_228.configure(2);
    func_387.configure(4);
    func_512.configure(3);
  }

  public void Start()
  {
    func_555.Start();
    func_232.Start();
    func_229.Start();
    func_207.Start();
    func_230.Start();
    func_437.Start();
    func_233.Start();
    func_416.Start();
    func_220.Start();
    func_216.Start();
    func_491.Start();
    func_333.Start();
    func_190.Start();
    func_481.Start();
  }
}
