/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    SCA_DXCoolingNordic
Macro id:      5978732667824057411
Macro version: 10
Last change:   23.09.2015 - 12:47
Access Level:  2
Inputs:
  [1] CoolCtrlSig
  [2] MinLimSensor
  [3] EmergencyStop
  [4] FanBeltIn
  [5] FilteredOATemp
  [6] OATLimitCooling
  [7] PlantMode
Outputs:
  [1] Stage1Cmd
  [2] Stage2Cmd
  [3] Stage3Cmd
  [4] Stage4Cmd
  [5] CoolControl
  [6] SeqSignal
  [7] MinSAT_SpShift
Parameter:
  [1] LIM-01 Limitation control: setpoint
  [2] LIM-02 Limitation control: P-band
  [3] LIM-03 Limitation control: I-time
  [4] OAT-01: OAT temp. difference to start the next stages
  [5] OAT-02. OAT temp. difference to start the last stage
  [6] STx-01: blocking on time
  [7] STx-02: blocking off time
  [8] SYS-01: Total number of digital stages
  [9] SYS-02: Enable analog output
  [10] SYS-03: Stage differential
  [11] SYS-04: Conversation mode
  [12] SYS-05: Delay after initialise
  [13] SYS-06: Minimum supply air temperature setpoint shift
  [14] DISP-01: Total number of stages
  [15] DISP-02: Requested stages
  [16] DISP-03: Actual stages
Description:
The "SCA_DXCooling" is a four stages output step-controller module. With this module, four steps can be controlled in a linear or binary mode. If more steps are needed, an add-on module for step-controller can be connected to this SCA_DXCooling.
================================================================================*/

public class BCmSCA_DXCoolingNordic
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmSCA_DXCoolingNordic_output_6().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmSCA_DXCoolingNordic_output_6().setStatus(BStatus.disabled);
    getCmSCA_DXCoolingNordic_output_86().setStatus(BStatus.disabled);
    getCmSCA_DXCoolingNordic_output_87().setStatus(BStatus.disabled);
    getCmSCA_DXCoolingNordic_output_88().setStatus(BStatus.disabled);
    getCmSCA_DXCoolingNordic_output_89().setStatus(BStatus.disabled);
    getCmSCA_DXCoolingNordic_output_90().setStatus(BStatus.disabled);
    getCmSCA_DXCoolingNordic_output_208().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmSCA_DXCoolingNordic_output_6().setStatus(BStatus.ok);
    getCmSCA_DXCoolingNordic_output_86().setStatus(BStatus.ok);
    getCmSCA_DXCoolingNordic_output_87().setStatus(BStatus.ok);
    getCmSCA_DXCoolingNordic_output_88().setStatus(BStatus.ok);
    getCmSCA_DXCoolingNordic_output_89().setStatus(BStatus.ok);
    getCmSCA_DXCoolingNordic_output_90().setStatus(BStatus.ok);
    getCmSCA_DXCoolingNordic_output_208().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [179] Macro call CmIDT20
    func_179.CmIDT20_input_1 = (float) getCmSCA_DXCoolingNordic_parameter_21();
    func_179.CmIDT20_input_2 = (float) getCmSCA_DXCoolingNordic_parameter_12();
    func_179.CmIDT20_input_3 = (float) getCmSCA_DXCoolingNordic_parameter_13();
    func_179.CmIDT20_input_4 = (float) getCmSCA_DXCoolingNordic_parameter_14();
    func_179.CmIDT20_input_5 = (float) getCmSCA_DXCoolingNordic_parameter_15();
    func_179.CmIDT20_input_6 = (float) getCmSCA_DXCoolingNordic_parameter_16();
    func_179.CmIDT20_input_7 = (float) getCmSCA_DXCoolingNordic_parameter_17();
    func_179.CmIDT20_input_8 = (float) getCmSCA_DXCoolingNordic_parameter_18();
    func_179.CmIDT20_input_9 = (float) getCmSCA_DXCoolingNordic_parameter_19();
    func_179.CmIDT20_input_10 = (float) getCmSCA_DXCoolingNordic_parameter_17();
    func_179.CmIDT20_input_11 = (float) getCmSCA_DXCoolingNordic_parameter_18();
    func_179.CmIDT20_input_12 = (float) getCmSCA_DXCoolingNordic_parameter_19();
    func_179.CmIDT20_input_13 = getParameter(45);
    func_179.CmIDT20_input_14 = (float) getCmSCA_DXCoolingNordic_parameter_18();
    func_179.CmIDT20_input_15 = (float) getCmSCA_DXCoolingNordic_parameter_20();
    func_179.CmIDT20_input_16 = (float) getCmSCA_DXCoolingNordic_parameter_17();
    func_179.CmIDT20_input_17 = getParameter(48);
    func_179.CmIDT20_input_18 = (float) getCmSCA_DXCoolingNordic_parameter_18();
    func_179.CmIDT20_input_19 = (float) getCmSCA_DXCoolingNordic_parameter_207();
    func_179.CmIDT20_input_20 = (float) getCmSCA_DXCoolingNordic_parameter_24();
    func_179.Execute(  );
    setParameter(0, func_179.CmIDT20_output_21);
    setParameter(3, func_179.CmIDT20_output_22);
    setParameter(4, func_179.CmIDT20_output_23);
    setParameter(5, func_179.CmIDT20_output_24);
    setParameter(21, func_179.CmIDT20_output_25);
    setParameter(22, func_179.CmIDT20_output_26);
    setParameter(23, func_179.CmIDT20_output_27);
    setParameter(24, func_179.CmIDT20_output_28);
    setParameter(25, func_179.CmIDT20_output_29);
    setParameter(42, func_179.CmIDT20_output_30);
    setParameter(43, func_179.CmIDT20_output_31);
    setParameter(44, func_179.CmIDT20_output_32);
    setCmSCA_DXCoolingNordic_parameter_22(func_179.CmIDT20_output_33);
    setParameter(46, func_179.CmIDT20_output_34);
    setParameter(47, func_179.CmIDT20_output_35);
    setParameter(50, func_179.CmIDT20_output_36);
    setCmSCA_DXCoolingNordic_parameter_24(func_179.CmIDT20_output_37);
    setParameter(49, func_179.CmIDT20_output_38);
    setParameter(56, func_179.CmIDT20_output_39);
    setParameter(57, func_179.CmIDT20_output_40);

    // [202] Macro call CmIDT05
    func_202.CmIDT05_input_1 = 0F;
    func_202.CmIDT05_input_2 = 0F;
    func_202.CmIDT05_input_3 = (float) getCmSCA_DXCoolingNordic_parameter_17();
    func_202.CmIDT05_input_4 = (float) getCmSCA_DXCoolingNordic_parameter_18();
    func_202.CmIDT05_input_5 = (float) getCmSCA_DXCoolingNordic_parameter_19();
    func_202.Execute(  );
    setParameter(28, func_202.CmIDT05_output_21);
    setParameter(29, func_202.CmIDT05_output_22);
    setParameter(30, func_202.CmIDT05_output_23);
    setParameter(31, func_202.CmIDT05_output_24);
    setParameter(32, func_202.CmIDT05_output_25);

    // [216] Macro call CmIDT05
    func_216.CmIDT05_input_1 = (float) getCmSCA_DXCoolingNordic_parameter_24();
    func_216.CmIDT05_input_2 = (float) getCmSCA_DXCoolingNordic_parameter_18();
    func_216.CmIDT05_input_3 = (float) getCmSCA_DXCoolingNordic_parameter_20();
    func_216.CmIDT05_input_4 = (float) getCmSCA_DXCoolingNordic_parameter_228();
    func_216.CmIDT05_input_5 = (float) getCmSCA_DXCoolingNordic_parameter_229();
    func_216.Execute(  );
    setParameter(58, func_216.CmIDT05_output_21);
    setParameter(59, func_216.CmIDT05_output_22);
    setParameter(60, func_216.CmIDT05_output_23);
    setParameter(35, func_216.CmIDT05_output_24);
    setParameter(36, func_216.CmIDT05_output_25);

    // [83] Macro call CmStart_Heater_Cooler
    func_83.CmStart_Heater_Cooler_input_3 = getCmSCA_DXCoolingNordic_input_3().getValue();
    func_83.CmStart_Heater_Cooler_input_4 = getCmSCA_DXCoolingNordic_input_4().getValue();
    func_83.CmStart_Heater_Cooler_input_5 = (float) getCmSCA_DXCoolingNordic_input_5().getValue();
    func_83.Execute( this, 0 );

    // [209] Macro call CmDXC_Control
    func_209.CmDXC_Control_input_84 = (float) getCmSCA_DXCoolingNordic_input_84().getValue();
    func_209.CmDXC_Control_input_85 = (float) getCmSCA_DXCoolingNordic_input_85().getValue();
    func_209.Execute( this, 3 );

    // [136] Macro call CmStep_Controller
    func_136.CmStep_Controller_input_292 = func_83.CmStart_Heater_Cooler_output_6;
    func_136.CmStep_Controller_input_84 = func_209.CmDXC_Control_output_89;
    func_136.Execute( this, 21 );

    // [200] Macro call CmStep_Controller
    func_200.CmStep_Controller_input_292 = func_83.CmStart_Heater_Cooler_output_6;
    func_200.CmStep_Controller_input_84 = func_209.CmDXC_Control_output_89;
    func_200.Execute( this, 28 );

    // [230] Macro call CmLimit_Stages
    func_230.CmLimit_Stages_input_1 = (float) getCmSCA_DXCoolingNordic_input_226().getValue();
    func_230.CmLimit_Stages_input_2 = (float) getCmSCA_DXCoolingNordic_input_227().getValue();
    func_230.Execute( this, 35 );

    // [240] Function call CfMinimum
    func_240.input[0] = func_230.CmLimit_Stages_output_3;
    func_240.input[1] = func_200.CmStep_Controller_output_262;
    func_240.Execute(  );
    setCmSCA_DXCoolingNordic_parameter_23(func_240.output);

    // [244] Function call CfMinimum
    func_244.input[0] = func_136.CmStep_Controller_output_262;
    func_244.input[1] = func_230.CmLimit_Stages_output_3;
    func_244.Execute(  );

    // [124] Macro call CmAnalog_Sequence
    func_124.CmAnalog_Sequence_input_162 = func_244.output;
    func_124.CmAnalog_Sequence_input_84 = func_209.CmDXC_Control_output_89;
    func_124.CmAnalog_Sequence_input_213 = func_83.CmStart_Heater_Cooler_output_6;
    func_124.Execute( this, 42 );

    // [153] Macro call CmSaw_tooth
    func_153.CmSaw_tooth_input_84 = func_124.CmAnalog_Sequence_output_89;
    func_153.CmSaw_tooth_input_99 = func_124.CmAnalog_Sequence_output_139;
    func_153.CmSaw_tooth_input_102 = func_124.CmAnalog_Sequence_output_175;
    func_153.CmSaw_tooth_input_110 = func_124.CmAnalog_Sequence_output_182;
    func_153.CmSaw_tooth_input_100 = func_244.output;
    func_153.Execute( this, 46 );

    // [166] Macro call CmOutput_Switch
    func_166.CmOutput_Switch_input_84 = func_153.CmSaw_tooth_output_89;
    func_166.CmOutput_Switch_input_5 = func_244.output;
    func_166.CmOutput_Switch_input_187 = func_83.CmStart_Heater_Cooler_output_6;
    func_166.CmOutput_Switch_input_238 = true;
    func_166.Execute( this, 47 );
    setCmSCA_DXCoolingNordic_output_6(func_166.CmOutput_Switch_output_6);
    setCmSCA_DXCoolingNordic_output_86(func_166.CmOutput_Switch_output_86);
    setCmSCA_DXCoolingNordic_output_87(func_166.CmOutput_Switch_output_87);
    setCmSCA_DXCoolingNordic_output_88(func_166.CmOutput_Switch_output_88);
    setCmSCA_DXCoolingNordic_output_89(func_166.CmOutput_Switch_output_89);

    // [212] Macro call CmMinimum_Supply_Shift
    func_212.Execute( this, 56 );
    setCmSCA_DXCoolingNordic_output_208(func_212.CmMinimum_Supply_Shift_output_5);

    // [214] Macro call CmSequencing
    func_214.Execute( this, 58 );
    setCmSCA_DXCoolingNordic_output_90(func_214.CmSequencing_output_1);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    15F, 10F, 1F, 35F, 10F, 0F, 3F, 0F,
    1000F, 100F, 0F, 3F, 0F, 1000F, 100F, 0F,
    3F, 0F, 1000F, 100F, 0F, 20F, 20F, 4F,
    0F, 50F, 1F, 1F, 20F, 20F, 4F, 0F,
    50F, 1F, 1F, 4F, 4F, 2F, 2F, 2F,
    2F, 2F, 4F, 0F, 50F, 0F, 0F, 0F,
    0F, 0F, 0F, 1F, 2F, 2F, 2F, 2F,
    2F, 0F, 0F, 0F, 0F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// Stage1Cmd
  public static final Property CmSCA_DXCoolingNordic_output_6 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSCA_DXCoolingNordic_output_6() { return (BStatusBoolean) get(CmSCA_DXCoolingNordic_output_6); }
  public void setCmSCA_DXCoolingNordic_output_6(BStatusBoolean v) { set(CmSCA_DXCoolingNordic_output_6,v,null); }
  public void setCmSCA_DXCoolingNordic_output_6(boolean v) { getCmSCA_DXCoolingNordic_output_6().setValue(v); }
// Stage2Cmd
  public static final Property CmSCA_DXCoolingNordic_output_86 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSCA_DXCoolingNordic_output_86() { return (BStatusBoolean) get(CmSCA_DXCoolingNordic_output_86); }
  public void setCmSCA_DXCoolingNordic_output_86(BStatusBoolean v) { set(CmSCA_DXCoolingNordic_output_86,v,null); }
  public void setCmSCA_DXCoolingNordic_output_86(boolean v) { getCmSCA_DXCoolingNordic_output_86().setValue(v); }
// Stage3Cmd
  public static final Property CmSCA_DXCoolingNordic_output_87 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSCA_DXCoolingNordic_output_87() { return (BStatusBoolean) get(CmSCA_DXCoolingNordic_output_87); }
  public void setCmSCA_DXCoolingNordic_output_87(BStatusBoolean v) { set(CmSCA_DXCoolingNordic_output_87,v,null); }
  public void setCmSCA_DXCoolingNordic_output_87(boolean v) { getCmSCA_DXCoolingNordic_output_87().setValue(v); }
// Stage4Cmd
  public static final Property CmSCA_DXCoolingNordic_output_88 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSCA_DXCoolingNordic_output_88() { return (BStatusBoolean) get(CmSCA_DXCoolingNordic_output_88); }
  public void setCmSCA_DXCoolingNordic_output_88(BStatusBoolean v) { set(CmSCA_DXCoolingNordic_output_88,v,null); }
  public void setCmSCA_DXCoolingNordic_output_88(boolean v) { getCmSCA_DXCoolingNordic_output_88().setValue(v); }
// CoolControl
  public static final Property CmSCA_DXCoolingNordic_output_89 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSCA_DXCoolingNordic_output_89() { return (BStatusNumeric) get(CmSCA_DXCoolingNordic_output_89); }
  public void setCmSCA_DXCoolingNordic_output_89(BStatusNumeric v) { set(CmSCA_DXCoolingNordic_output_89,v,null); }
  public void setCmSCA_DXCoolingNordic_output_89(float v) { getCmSCA_DXCoolingNordic_output_89().setValue(v); }
// SeqSignal
  public static final Property CmSCA_DXCoolingNordic_output_90 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSCA_DXCoolingNordic_output_90() { return (BStatusNumeric) get(CmSCA_DXCoolingNordic_output_90); }
  public void setCmSCA_DXCoolingNordic_output_90(BStatusNumeric v) { set(CmSCA_DXCoolingNordic_output_90,v,null); }
  public void setCmSCA_DXCoolingNordic_output_90(float v) { getCmSCA_DXCoolingNordic_output_90().setValue(v); }
// MinSAT_SpShift
  public static final Property CmSCA_DXCoolingNordic_output_208 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSCA_DXCoolingNordic_output_208() { return (BStatusNumeric) get(CmSCA_DXCoolingNordic_output_208); }
  public void setCmSCA_DXCoolingNordic_output_208(BStatusNumeric v) { set(CmSCA_DXCoolingNordic_output_208,v,null); }
  public void setCmSCA_DXCoolingNordic_output_208(float v) { getCmSCA_DXCoolingNordic_output_208().setValue(v); }

  // macro parameter
// LIM-01 Limitation control: setpoint
  public static final Property CmSCA_DXCoolingNordic_parameter_12 = newProperty( 0, BDouble.make( 14 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(200)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmSCA_DXCoolingNordic_parameter_12() { return getDouble(CmSCA_DXCoolingNordic_parameter_12); }
  public void setCmSCA_DXCoolingNordic_parameter_12(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_12,v,null); }
// LIM-02 Limitation control: P-band
  public static final Property CmSCA_DXCoolingNordic_parameter_13 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmSCA_DXCoolingNordic_parameter_13() { return getDouble(CmSCA_DXCoolingNordic_parameter_13); }
  public void setCmSCA_DXCoolingNordic_parameter_13(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_13,v,null); }
// LIM-03 Limitation control: I-time
  public static final Property CmSCA_DXCoolingNordic_parameter_14 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSCA_DXCoolingNordic_parameter_14() { return getDouble(CmSCA_DXCoolingNordic_parameter_14); }
  public void setCmSCA_DXCoolingNordic_parameter_14(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_14,v,null); }
// OAT-01: OAT temp. difference to start the next stages
  public static final Property CmSCA_DXCoolingNordic_parameter_228 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmSCA_DXCoolingNordic_parameter_228() { return getDouble(CmSCA_DXCoolingNordic_parameter_228); }
  public void setCmSCA_DXCoolingNordic_parameter_228(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_228,v,null); }
// OAT-02. OAT temp. difference to start the last stage
  public static final Property CmSCA_DXCoolingNordic_parameter_229 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmSCA_DXCoolingNordic_parameter_229() { return getDouble(CmSCA_DXCoolingNordic_parameter_229); }
  public void setCmSCA_DXCoolingNordic_parameter_229(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_229,v,null); }
// STx-01: blocking on time
  public static final Property CmSCA_DXCoolingNordic_parameter_15 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSCA_DXCoolingNordic_parameter_15() { return getDouble(CmSCA_DXCoolingNordic_parameter_15); }
  public void setCmSCA_DXCoolingNordic_parameter_15(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_15,v,null); }
// STx-02: blocking off time
  public static final Property CmSCA_DXCoolingNordic_parameter_16 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSCA_DXCoolingNordic_parameter_16() { return getDouble(CmSCA_DXCoolingNordic_parameter_16); }
  public void setCmSCA_DXCoolingNordic_parameter_16(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_16,v,null); }
// SYS-01: Total number of digital stages
  public static final Property CmSCA_DXCoolingNordic_parameter_17 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(100)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSCA_DXCoolingNordic_parameter_17() { return getDouble(CmSCA_DXCoolingNordic_parameter_17); }
  public void setCmSCA_DXCoolingNordic_parameter_17(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_17,v,null); }
// SYS-02: Enable analog output
  public static final Property CmSCA_DXCoolingNordic_parameter_18 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSCA_DXCoolingNordic_parameter_18() { return getDouble(CmSCA_DXCoolingNordic_parameter_18); }
  public void setCmSCA_DXCoolingNordic_parameter_18(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_18,v,null); }
// SYS-03: Stage differential
  public static final Property CmSCA_DXCoolingNordic_parameter_19 = newProperty( 0, BDouble.make( 50 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmSCA_DXCoolingNordic_parameter_19() { return getDouble(CmSCA_DXCoolingNordic_parameter_19); }
  public void setCmSCA_DXCoolingNordic_parameter_19(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_19,v,null); }
// SYS-04: Conversation mode
  public static final Property CmSCA_DXCoolingNordic_parameter_20 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSCA_DXCoolingNordic_parameter_20() { return getDouble(CmSCA_DXCoolingNordic_parameter_20); }
  public void setCmSCA_DXCoolingNordic_parameter_20(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_20,v,null); }
// SYS-05: Delay after initialise
  public static final Property CmSCA_DXCoolingNordic_parameter_21 = newProperty( 0, BDouble.make( 50 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSCA_DXCoolingNordic_parameter_21() { return getDouble(CmSCA_DXCoolingNordic_parameter_21); }
  public void setCmSCA_DXCoolingNordic_parameter_21(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_21,v,null); }
// SYS-06: Minimum supply air temperature setpoint shift
  public static final Property CmSCA_DXCoolingNordic_parameter_207 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(30)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmSCA_DXCoolingNordic_parameter_207() { return getDouble(CmSCA_DXCoolingNordic_parameter_207); }
  public void setCmSCA_DXCoolingNordic_parameter_207(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_207,v,null); }
// DISP-01: Total number of stages
  public static final Property CmSCA_DXCoolingNordic_parameter_22 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(100)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSCA_DXCoolingNordic_parameter_22() { return getDouble(CmSCA_DXCoolingNordic_parameter_22); }
  public void setCmSCA_DXCoolingNordic_parameter_22(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_22,v,null); }
// DISP-02: Requested stages
  public static final Property CmSCA_DXCoolingNordic_parameter_23 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(100)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSCA_DXCoolingNordic_parameter_23() { return getDouble(CmSCA_DXCoolingNordic_parameter_23); }
  public void setCmSCA_DXCoolingNordic_parameter_23(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_23,v,null); }
// DISP-03: Actual stages
  public static final Property CmSCA_DXCoolingNordic_parameter_24 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(100)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSCA_DXCoolingNordic_parameter_24() { return getDouble(CmSCA_DXCoolingNordic_parameter_24); }
  public void setCmSCA_DXCoolingNordic_parameter_24(double v) { setDouble(CmSCA_DXCoolingNordic_parameter_24,v,null); }

  // macro inputs
// CoolCtrlSig
  public static final Property CmSCA_DXCoolingNordic_input_84 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmSCA_DXCoolingNordic_input_84() { return (BStatusNumeric) get(CmSCA_DXCoolingNordic_input_84); }
  public void setCmSCA_DXCoolingNordic_input_84(BStatusNumeric v) { set(CmSCA_DXCoolingNordic_input_84,v,null); }
  public void setCmSCA_DXCoolingNordic_input_84(float v) { getCmSCA_DXCoolingNordic_input_84().setValue(v); }
// MinLimSensor
  public static final Property CmSCA_DXCoolingNordic_input_85 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmSCA_DXCoolingNordic_input_85() { return (BStatusNumeric) get(CmSCA_DXCoolingNordic_input_85); }
  public void setCmSCA_DXCoolingNordic_input_85(BStatusNumeric v) { set(CmSCA_DXCoolingNordic_input_85,v,null); }
  public void setCmSCA_DXCoolingNordic_input_85(float v) { getCmSCA_DXCoolingNordic_input_85().setValue(v); }
// EmergencyStop
  public static final Property CmSCA_DXCoolingNordic_input_3 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmSCA_DXCoolingNordic_input_3() { return (BStatusBoolean) get(CmSCA_DXCoolingNordic_input_3); }
  public void setCmSCA_DXCoolingNordic_input_3(BStatusBoolean v) { set(CmSCA_DXCoolingNordic_input_3,v,null); }
  public void setCmSCA_DXCoolingNordic_input_3(boolean v) { getCmSCA_DXCoolingNordic_input_3().setValue(v); }
// FanBeltIn
  public static final Property CmSCA_DXCoolingNordic_input_4 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmSCA_DXCoolingNordic_input_4() { return (BStatusBoolean) get(CmSCA_DXCoolingNordic_input_4); }
  public void setCmSCA_DXCoolingNordic_input_4(BStatusBoolean v) { set(CmSCA_DXCoolingNordic_input_4,v,null); }
  public void setCmSCA_DXCoolingNordic_input_4(boolean v) { getCmSCA_DXCoolingNordic_input_4().setValue(v); }
// FilteredOATemp
  public static final Property CmSCA_DXCoolingNordic_input_226 = newProperty( Flags.SUMMARY, new BStatusNumeric( 15 ), null);
  public BStatusNumeric getCmSCA_DXCoolingNordic_input_226() { return (BStatusNumeric) get(CmSCA_DXCoolingNordic_input_226); }
  public void setCmSCA_DXCoolingNordic_input_226(BStatusNumeric v) { set(CmSCA_DXCoolingNordic_input_226,v,null); }
  public void setCmSCA_DXCoolingNordic_input_226(float v) { getCmSCA_DXCoolingNordic_input_226().setValue(v); }
// OATLimitCooling
  public static final Property CmSCA_DXCoolingNordic_input_227 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmSCA_DXCoolingNordic_input_227() { return (BStatusNumeric) get(CmSCA_DXCoolingNordic_input_227); }
  public void setCmSCA_DXCoolingNordic_input_227(BStatusNumeric v) { set(CmSCA_DXCoolingNordic_input_227,v,null); }
  public void setCmSCA_DXCoolingNordic_input_227(float v) { getCmSCA_DXCoolingNordic_input_227().setValue(v); }
// PlantMode
  public static final Property CmSCA_DXCoolingNordic_input_5 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmSCA_DXCoolingNordic_input_5() { return (BStatusNumeric) get(CmSCA_DXCoolingNordic_input_5); }
  public void setCmSCA_DXCoolingNordic_input_5(BStatusNumeric v) { set(CmSCA_DXCoolingNordic_input_5,v,null); }
  public void setCmSCA_DXCoolingNordic_input_5(float v) { getCmSCA_DXCoolingNordic_input_5().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.02 [10] 23.09.2015-12:47").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5978732667824057411").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmSCA_DXCoolingNordic.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions

  // class variables
  protected CmIDT20 func_179 = new CmIDT20();
  protected CmIDT05 func_202 = new CmIDT05();
  protected CmIDT05 func_216 = new CmIDT05();
  protected CmStart_Heater_Cooler func_83 = new CmStart_Heater_Cooler();
  protected CmDXC_Control func_209 = new CmDXC_Control();
  protected CmStep_Controller func_136 = new CmStep_Controller();
  protected CmStep_Controller func_200 = new CmStep_Controller();
  protected CmLimit_Stages func_230 = new CmLimit_Stages();
  protected CfMinimum func_240 = new CfMinimum();
  protected CfMinimum func_244 = new CfMinimum();
  protected CmAnalog_Sequence func_124 = new CmAnalog_Sequence();
  protected CmSaw_tooth func_153 = new CmSaw_tooth();
  protected CmOutput_Switch func_166 = new CmOutput_Switch();
  protected CmMinimum_Supply_Shift func_212 = new CmMinimum_Supply_Shift();
  protected CmSequencing func_214 = new CmSequencing();

  // default constructor
  public BCmSCA_DXCoolingNordic()
  {
  }

  public void Start()
  {
    func_179.Start();
    func_202.Start();
    func_216.Start();
    func_83.Start();
    func_209.Start();
    func_136.Start();
    func_200.Start();
    func_230.Start();
    func_124.Start();
    func_153.Start();
    func_166.Start();
    func_212.Start();
    func_214.Start();
  }
}
