/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    SPB_AirFlowControlNordic
Macro id:      5976417671389905301
Macro version: 30
Last change:   15.01.2019 - 14:17
Access Level:  2
Inputs:
  [1] DiffPressSensor
  [2] AirFlowCompTemp
  [3] AirFlow_Sp
  [4] AirFlow_Sp_Low
  [5] AirFlow_Sp_High
  [6] FanEnableSig
  [7] EffManSwCmd_MSt
  [8] FilteredOATemp
  [9] PlantMode
Outputs:
  [1] FanSpeedSig
  [2] Eff_AirFlow_Sp
  [3] CalcAirFlow_m3ph
  [4] CalcAirFlow_lps
  [5] FlowIndication
Parameter:
  [1] AFL-01: setpoint increase/ decrease per minute
  [2] AFL-02: P-band air flow control
  [3] AFL-03: I-time air flow control
  [4] AFL-04: scaling factor calculated air flow
  [5] AFL-05: air flow calculation option
  [6] AFL-06: air density compensation active
  [7] FSC-01: output signal increase per min
  [8] FSC-02: minimum fan speed signal
  [9] FSC-03: maximum fam speed signal
  [10] SYS-01: filter time; 0=disable
  [11] SYS-02: threshold flow indication
  [12] FSLIM-01: limit OAT to switch to min. speed
  [13] DISP-01: status of FNE
  [14] DISP-02: level of FSC
  [15] DISP-03: actual AirFlow_Sp
  [16] DISP-04: Flow Indication
Description:
The Macro "SPB_AirFlowControl" is a control module providing duct air flow filtering and control as an input for the variable fan speed control module. The module has integrated features for plant overrides.

The SPB_StatPressControl module provides filtering of the duct air flow and an analogue output for the variable fan speed control module. The duct air flow is filtered to provide a smoothed value, which is used to eliminate sudden duct air flow variations and thus provides a more stable operation of the duct air flow control. A duct static high limit sensor prevents the ducts against damage, caused by too high pressures.

The module has analogue inputs for a duct air flow sensor, a duct static high pressure limit sensor, a damper control signal and a digital input for the fan enable signal. It has an analogue output for fan speed command.

The module incorporates plant mode overrides and program initialise from the power failure module.
================================================================================*/

public class BCmSPB_AirFlowControlNordic
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmSPB_AirFlowControlNordic_output_7().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmSPB_AirFlowControlNordic_output_7().setStatus(BStatus.disabled);
    getCmSPB_AirFlowControlNordic_output_220().setStatus(BStatus.disabled);
    getCmSPB_AirFlowControlNordic_output_191().setStatus(BStatus.disabled);
    getCmSPB_AirFlowControlNordic_output_230().setStatus(BStatus.disabled);
    getCmSPB_AirFlowControlNordic_output_192().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmSPB_AirFlowControlNordic_output_7().setStatus(BStatus.ok);
    getCmSPB_AirFlowControlNordic_output_220().setStatus(BStatus.ok);
    getCmSPB_AirFlowControlNordic_output_191().setStatus(BStatus.ok);
    getCmSPB_AirFlowControlNordic_output_230().setStatus(BStatus.ok);
    getCmSPB_AirFlowControlNordic_output_192().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [122] Macro call CmIDT20
    func_122.CmIDT20_input_1 = (float) getCmSPB_AirFlowControlNordic_parameter_52();
    func_122.CmIDT20_input_2 = (float) getCmSPB_AirFlowControlNordic_parameter_53();
    func_122.CmIDT20_input_3 = (float) getCmSPB_AirFlowControlNordic_parameter_61();
    func_122.CmIDT20_input_4 = BooleanToFloat(getCmSPB_AirFlowControlNordic_input_35().getValue());
    func_122.CmIDT20_input_5 = (float) getCmSPB_AirFlowControlNordic_parameter_51();
    func_122.CmIDT20_input_6 = 0F;
    func_122.CmIDT20_input_7 = 0F;
    func_122.CmIDT20_input_8 = 0F;
    func_122.CmIDT20_input_9 = 0F;
    func_122.CmIDT20_input_10 = (float) getCmSPB_AirFlowControlNordic_parameter_60();
    func_122.CmIDT20_input_11 = 0F;
    func_122.CmIDT20_input_12 = 0F;
    func_122.CmIDT20_input_13 = 0F;
    func_122.CmIDT20_input_14 = 3F;
    func_122.CmIDT20_input_15 = 0F;
    func_122.CmIDT20_input_16 = 0F;
    func_122.CmIDT20_input_17 = 0F;
    func_122.CmIDT20_input_18 = 0F;
    func_122.CmIDT20_input_19 = 0F;
    func_122.CmIDT20_input_20 = 0F;
    func_122.Execute(  );
    setParameter(6, func_122.CmIDT20_output_21);
    setParameter(7, func_122.CmIDT20_output_22);
    setParameter(1, func_122.CmIDT20_output_23);
    setCmSPB_AirFlowControlNordic_parameter_62(func_122.CmIDT20_output_24);
    setParameter(5, func_122.CmIDT20_output_25);
    setParameter(13, func_122.CmIDT20_output_30);
    setParameter(4, func_122.CmIDT20_output_34);

    // [67] Macro call CmCycleTime
    func_67.Execute( this, 0 );

    // [28] Macro call CmE_Filter
    func_28.CmE_Filter_input_23 = (float) getCmSPB_AirFlowControlNordic_input_32().getValue();
    func_28.CmE_Filter_input_47 = func_67.CmCycleTime_output_1;
    func_28.CmE_Filter_input_67 = 20000F;
    func_28.Execute( this, 1 );

    // [212] Macro call CmAirflow_calculation
    func_212.CmAirflow_calculation_input_1 = func_28.CmE_Filter_output_24;
    func_212.CmAirflow_calculation_input_2 = (float) getCmSPB_AirFlowControlNordic_input_198().getValue();
    func_212.CmAirflow_calculation_input_31 = (float) getCmSPB_AirFlowControlNordic_parameter_218();
    func_212.CmAirflow_calculation_input_44 = FloatToBoolean((float) getCmSPB_AirFlowControlNordic_parameter_231());
    func_212.CmAirflow_calculation_input_45 = FloatToBoolean((float) getCmSPB_AirFlowControlNordic_parameter_232());
    func_212.Execute(  );
    setCmSPB_AirFlowControlNordic_output_230(func_212.CmAirflow_calculation_output_43);

    // [1] Macro call CmRelease
    func_1.CmRelease_input_2 = 0F;
    func_1.CmRelease_input_3 = (float) getCmSPB_AirFlowControlNordic_input_36().getValue();
    func_1.CmRelease_input_4 = getCmSPB_AirFlowControlNordic_input_35().getValue();
    func_1.Execute(  );

    // [215] Function call CfMinimum
    func_215.input[0] = (float) getCmSPB_AirFlowControlNordic_input_154().getValue();
    func_215.input[1] = 5F;
    func_215.Execute(  );

    // [183] Function call CfHysteresis
    func_183.inputX = (float) getCmSPB_AirFlowControlNordic_parameter_157();
    func_183.inputW = (float) getCmSPB_AirFlowControlNordic_input_153().getValue();
    func_183.Execute( this, 4 );

    // [186] Function call CfInputMultiplexer
    func_186.inputSelect = BooleanToInt(func_183.output1);
    func_186.input[1-1] = (float) getCmSPB_AirFlowControlNordic_input_38().getValue();
    func_186.input[2-1] = (float) getCmSPB_AirFlowControlNordic_input_151().getValue();
    func_186.Execute(  );

    // [170] Function call CfInputMultiplexer
    func_170.inputSelect = FloatToInt(func_215.output);
    func_170.input[1-1] = 0F;
    func_170.input[2-1] = 0F;
    func_170.input[3-1] = (float) getCmSPB_AirFlowControlNordic_input_151().getValue();
    func_170.input[4-1] = (float) getCmSPB_AirFlowControlNordic_input_152().getValue();
    func_170.input[5-1] = func_186.output;
    func_170.input[6-1] = func_186.output;
    func_170.Execute(  );

    // [109] Macro call CmSetpoint_Ramp
    func_109.CmSetpoint_Ramp_input_7 = func_1.CmRelease_output_5;
    func_109.CmSetpoint_Ramp_input_10 = 0F;
    func_109.CmSetpoint_Ramp_input_19 = func_170.output;
    func_109.Execute( this, 5 );

    // [24] Macro call CmControl_Signal_Air_Flow
    func_24.CmControl_Signal_Air_Flow_input_11 = func_109.CmSetpoint_Ramp_output_20;
    func_24.CmControl_Signal_Air_Flow_input_12 = func_212.CmAirflow_calculation_output_3;
    func_24.CmControl_Signal_Air_Flow_input_14 = func_1.CmRelease_output_5;
    func_24.CmControl_Signal_Air_Flow_input_15 = true;
    func_24.Execute( this, 6 );

    // [15] Macro call CmFanspeed_ramp_up
    func_15.CmFanspeed_ramp_up_input_1 = func_1.CmRelease_output_5;
    func_15.Execute( this, 13 );

    // [8] Function call CfMinimum
    func_8.input[0] = func_24.CmControl_Signal_Air_Flow_output_13;
    func_8.input[1] = (float) getCmSPB_AirFlowControlNordic_parameter_156();
    func_8.input[2] = func_15.CmFanspeed_ramp_up_output_3;
    func_8.Execute(  );

    // [182] Function call CfMaximum
    func_182.input[0] = (float) getCmSPB_AirFlowControlNordic_parameter_155();
    func_182.input[1] = func_8.output;
    func_182.Execute(  );

    // [3] Function call CfInputMultiplexer
    func_3.inputSelect = BooleanToInt(func_1.CmRelease_output_5);
    func_3.input[1-1] = 0F;
    func_3.input[2-1] = func_182.output;
    func_3.Execute(  );

    // [5] Function call CfIdt
    func_5.input = func_3.output;
    func_5.Execute(  );
    setCmSPB_AirFlowControlNordic_output_7(func_5.output[0]);

    // [108] Function call CfIdt
    func_108.input = func_3.output;
    func_108.Execute(  );
    setCmSPB_AirFlowControlNordic_parameter_63(func_108.output[0]);

    // [112] Function call CfIdt
    func_112.input = func_109.CmSetpoint_Ramp_output_20;
    func_112.Execute(  );
    setCmSPB_AirFlowControlNordic_parameter_64(func_112.output[0]);

    // [235] Function call CfIdt
    func_235.input = 0.05F;
    func_235.Execute(  );
    setParameter(14, func_235.output[0]);

    // [208] Function call CfHysteresis
    func_208.inputX = (float) getCmSPB_AirFlowControlNordic_output_191().getValue();
    func_208.inputW = (float) getCmSPB_AirFlowControlNordic_parameter_201();
    func_208.Execute( this, 14 );

    // [221] Function call CfIdt
    func_221.input = func_212.CmAirflow_calculation_output_3;
    func_221.Execute(  );
    setCmSPB_AirFlowControlNordic_output_191(func_221.output[0]);

    // [228] Function call CfIdt
    func_228.input = func_170.output;
    func_228.Execute(  );
    setCmSPB_AirFlowControlNordic_output_220(func_228.output[0]);

    // [237] Function call CfIdt
    func_237.input = BooleanToFloat(func_208.output1);
    func_237.Execute(  );
    setCmSPB_AirFlowControlNordic_output_192(FloatToBoolean(func_237.output[0]));
    setCmSPB_AirFlowControlNordic_parameter_202(func_237.output[1]);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    1F, 25F, 5F, 10F, 3F, 2500F, 0F, 0F,
    3F, 0F, 1000F, 100F, 0F, 25F, 3F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// FanSpeedSig
  public static final Property CmSPB_AirFlowControlNordic_output_7 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSPB_AirFlowControlNordic_output_7() { return (BStatusNumeric) get(CmSPB_AirFlowControlNordic_output_7); }
  public void setCmSPB_AirFlowControlNordic_output_7(BStatusNumeric v) { set(CmSPB_AirFlowControlNordic_output_7,v,null); }
  public void setCmSPB_AirFlowControlNordic_output_7(float v) { getCmSPB_AirFlowControlNordic_output_7().setValue(v); }
// Eff_AirFlow_Sp
  public static final Property CmSPB_AirFlowControlNordic_output_220 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSPB_AirFlowControlNordic_output_220() { return (BStatusNumeric) get(CmSPB_AirFlowControlNordic_output_220); }
  public void setCmSPB_AirFlowControlNordic_output_220(BStatusNumeric v) { set(CmSPB_AirFlowControlNordic_output_220,v,null); }
  public void setCmSPB_AirFlowControlNordic_output_220(float v) { getCmSPB_AirFlowControlNordic_output_220().setValue(v); }
// CalcAirFlow_m3ph
  public static final Property CmSPB_AirFlowControlNordic_output_191 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSPB_AirFlowControlNordic_output_191() { return (BStatusNumeric) get(CmSPB_AirFlowControlNordic_output_191); }
  public void setCmSPB_AirFlowControlNordic_output_191(BStatusNumeric v) { set(CmSPB_AirFlowControlNordic_output_191,v,null); }
  public void setCmSPB_AirFlowControlNordic_output_191(float v) { getCmSPB_AirFlowControlNordic_output_191().setValue(v); }
// CalcAirFlow_lps
  public static final Property CmSPB_AirFlowControlNordic_output_230 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSPB_AirFlowControlNordic_output_230() { return (BStatusNumeric) get(CmSPB_AirFlowControlNordic_output_230); }
  public void setCmSPB_AirFlowControlNordic_output_230(BStatusNumeric v) { set(CmSPB_AirFlowControlNordic_output_230,v,null); }
  public void setCmSPB_AirFlowControlNordic_output_230(float v) { getCmSPB_AirFlowControlNordic_output_230().setValue(v); }
// FlowIndication
  public static final Property CmSPB_AirFlowControlNordic_output_192 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSPB_AirFlowControlNordic_output_192() { return (BStatusBoolean) get(CmSPB_AirFlowControlNordic_output_192); }
  public void setCmSPB_AirFlowControlNordic_output_192(BStatusBoolean v) { set(CmSPB_AirFlowControlNordic_output_192,v,null); }
  public void setCmSPB_AirFlowControlNordic_output_192(boolean v) { getCmSPB_AirFlowControlNordic_output_192().setValue(v); }

  // macro parameter
// AFL-01: setpoint increase/ decrease per minute
  public static final Property CmSPB_AirFlowControlNordic_parameter_51 = newProperty( 0, BDouble.make( 2500 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(10000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("cubic meters per hour"))));
  public double getCmSPB_AirFlowControlNordic_parameter_51() { return getDouble(CmSPB_AirFlowControlNordic_parameter_51); }
  public void setCmSPB_AirFlowControlNordic_parameter_51(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_51,v,null); }
// AFL-02: P-band air flow control
  public static final Property CmSPB_AirFlowControlNordic_parameter_52 = newProperty( 0, BDouble.make( 1000 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(10000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("cubic meters per hour"))));
  public double getCmSPB_AirFlowControlNordic_parameter_52() { return getDouble(CmSPB_AirFlowControlNordic_parameter_52); }
  public void setCmSPB_AirFlowControlNordic_parameter_52(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_52,v,null); }
// AFL-03: I-time air flow control
  public static final Property CmSPB_AirFlowControlNordic_parameter_53 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSPB_AirFlowControlNordic_parameter_53() { return getDouble(CmSPB_AirFlowControlNordic_parameter_53); }
  public void setCmSPB_AirFlowControlNordic_parameter_53(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_53,v,null); }
// AFL-04: scaling factor calculated air flow
  public static final Property CmSPB_AirFlowControlNordic_parameter_218 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(100000)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmSPB_AirFlowControlNordic_parameter_218() { return getDouble(CmSPB_AirFlowControlNordic_parameter_218); }
  public void setCmSPB_AirFlowControlNordic_parameter_218(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_218,v,null); }
// AFL-05: air flow calculation option
  public static final Property CmSPB_AirFlowControlNordic_parameter_231 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSPB_AirFlowControlNordic_parameter_231() { return getDouble(CmSPB_AirFlowControlNordic_parameter_231); }
  public void setCmSPB_AirFlowControlNordic_parameter_231(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_231,v,null); }
// AFL-06: air density compensation active
  public static final Property CmSPB_AirFlowControlNordic_parameter_232 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSPB_AirFlowControlNordic_parameter_232() { return getDouble(CmSPB_AirFlowControlNordic_parameter_232); }
  public void setCmSPB_AirFlowControlNordic_parameter_232(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_232,v,null); }
// FSC-01: output signal increase per min
  public static final Property CmSPB_AirFlowControlNordic_parameter_60 = newProperty( 0, BDouble.make( 25 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmSPB_AirFlowControlNordic_parameter_60() { return getDouble(CmSPB_AirFlowControlNordic_parameter_60); }
  public void setCmSPB_AirFlowControlNordic_parameter_60(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_60,v,null); }
// FSC-02: minimum fan speed signal
  public static final Property CmSPB_AirFlowControlNordic_parameter_155 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmSPB_AirFlowControlNordic_parameter_155() { return getDouble(CmSPB_AirFlowControlNordic_parameter_155); }
  public void setCmSPB_AirFlowControlNordic_parameter_155(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_155,v,null); }
// FSC-03: maximum fam speed signal
  public static final Property CmSPB_AirFlowControlNordic_parameter_156 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmSPB_AirFlowControlNordic_parameter_156() { return getDouble(CmSPB_AirFlowControlNordic_parameter_156); }
  public void setCmSPB_AirFlowControlNordic_parameter_156(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_156,v,null); }
// SYS-01: filter time; 0=disable
  public static final Property CmSPB_AirFlowControlNordic_parameter_61 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSPB_AirFlowControlNordic_parameter_61() { return getDouble(CmSPB_AirFlowControlNordic_parameter_61); }
  public void setCmSPB_AirFlowControlNordic_parameter_61(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_61,v,null); }
// SYS-02: threshold flow indication
  public static final Property CmSPB_AirFlowControlNordic_parameter_201 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(10000)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSPB_AirFlowControlNordic_parameter_201() { return getDouble(CmSPB_AirFlowControlNordic_parameter_201); }
  public void setCmSPB_AirFlowControlNordic_parameter_201(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_201,v,null); }
// FSLIM-01: limit OAT to switch to min. speed
  public static final Property CmSPB_AirFlowControlNordic_parameter_157 = newProperty( 0, BDouble.make( -20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(10)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmSPB_AirFlowControlNordic_parameter_157() { return getDouble(CmSPB_AirFlowControlNordic_parameter_157); }
  public void setCmSPB_AirFlowControlNordic_parameter_157(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_157,v,null); }
// DISP-01: status of FNE
  public static final Property CmSPB_AirFlowControlNordic_parameter_62 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSPB_AirFlowControlNordic_parameter_62() { return getDouble(CmSPB_AirFlowControlNordic_parameter_62); }
  public void setCmSPB_AirFlowControlNordic_parameter_62(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_62,v,null); }
// DISP-02: level of FSC
  public static final Property CmSPB_AirFlowControlNordic_parameter_63 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("percent"))));
  public double getCmSPB_AirFlowControlNordic_parameter_63() { return getDouble(CmSPB_AirFlowControlNordic_parameter_63); }
  public void setCmSPB_AirFlowControlNordic_parameter_63(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_63,v,null); }
// DISP-03: actual AirFlow_Sp
  public static final Property CmSPB_AirFlowControlNordic_parameter_64 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(0)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("cubic meters per hour"))));
  public double getCmSPB_AirFlowControlNordic_parameter_64() { return getDouble(CmSPB_AirFlowControlNordic_parameter_64); }
  public void setCmSPB_AirFlowControlNordic_parameter_64(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_64,v,null); }
// DISP-04: Flow Indication
  public static final Property CmSPB_AirFlowControlNordic_parameter_202 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSPB_AirFlowControlNordic_parameter_202() { return getDouble(CmSPB_AirFlowControlNordic_parameter_202); }
  public void setCmSPB_AirFlowControlNordic_parameter_202(double v) { setDouble(CmSPB_AirFlowControlNordic_parameter_202,v,null); }

  // macro inputs
// DiffPressSensor
  public static final Property CmSPB_AirFlowControlNordic_input_32 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmSPB_AirFlowControlNordic_input_32() { return (BStatusNumeric) get(CmSPB_AirFlowControlNordic_input_32); }
  public void setCmSPB_AirFlowControlNordic_input_32(BStatusNumeric v) { set(CmSPB_AirFlowControlNordic_input_32,v,null); }
  public void setCmSPB_AirFlowControlNordic_input_32(float v) { getCmSPB_AirFlowControlNordic_input_32().setValue(v); }
// AirFlowCompTemp
  public static final Property CmSPB_AirFlowControlNordic_input_198 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmSPB_AirFlowControlNordic_input_198() { return (BStatusNumeric) get(CmSPB_AirFlowControlNordic_input_198); }
  public void setCmSPB_AirFlowControlNordic_input_198(BStatusNumeric v) { set(CmSPB_AirFlowControlNordic_input_198,v,null); }
  public void setCmSPB_AirFlowControlNordic_input_198(float v) { getCmSPB_AirFlowControlNordic_input_198().setValue(v); }
// AirFlow_Sp
  public static final Property CmSPB_AirFlowControlNordic_input_38 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmSPB_AirFlowControlNordic_input_38() { return (BStatusNumeric) get(CmSPB_AirFlowControlNordic_input_38); }
  public void setCmSPB_AirFlowControlNordic_input_38(BStatusNumeric v) { set(CmSPB_AirFlowControlNordic_input_38,v,null); }
  public void setCmSPB_AirFlowControlNordic_input_38(float v) { getCmSPB_AirFlowControlNordic_input_38().setValue(v); }
// AirFlow_Sp_Low
  public static final Property CmSPB_AirFlowControlNordic_input_151 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmSPB_AirFlowControlNordic_input_151() { return (BStatusNumeric) get(CmSPB_AirFlowControlNordic_input_151); }
  public void setCmSPB_AirFlowControlNordic_input_151(BStatusNumeric v) { set(CmSPB_AirFlowControlNordic_input_151,v,null); }
  public void setCmSPB_AirFlowControlNordic_input_151(float v) { getCmSPB_AirFlowControlNordic_input_151().setValue(v); }
// AirFlow_Sp_High
  public static final Property CmSPB_AirFlowControlNordic_input_152 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmSPB_AirFlowControlNordic_input_152() { return (BStatusNumeric) get(CmSPB_AirFlowControlNordic_input_152); }
  public void setCmSPB_AirFlowControlNordic_input_152(BStatusNumeric v) { set(CmSPB_AirFlowControlNordic_input_152,v,null); }
  public void setCmSPB_AirFlowControlNordic_input_152(float v) { getCmSPB_AirFlowControlNordic_input_152().setValue(v); }
// FanEnableSig
  public static final Property CmSPB_AirFlowControlNordic_input_35 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmSPB_AirFlowControlNordic_input_35() { return (BStatusBoolean) get(CmSPB_AirFlowControlNordic_input_35); }
  public void setCmSPB_AirFlowControlNordic_input_35(BStatusBoolean v) { set(CmSPB_AirFlowControlNordic_input_35,v,null); }
  public void setCmSPB_AirFlowControlNordic_input_35(boolean v) { getCmSPB_AirFlowControlNordic_input_35().setValue(v); }
// EffManSwCmd_MSt
  public static final Property CmSPB_AirFlowControlNordic_input_154 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmSPB_AirFlowControlNordic_input_154() { return (BStatusNumeric) get(CmSPB_AirFlowControlNordic_input_154); }
  public void setCmSPB_AirFlowControlNordic_input_154(BStatusNumeric v) { set(CmSPB_AirFlowControlNordic_input_154,v,null); }
  public void setCmSPB_AirFlowControlNordic_input_154(float v) { getCmSPB_AirFlowControlNordic_input_154().setValue(v); }
// FilteredOATemp
  public static final Property CmSPB_AirFlowControlNordic_input_153 = newProperty( Flags.SUMMARY, new BStatusNumeric( 15 ), null);
  public BStatusNumeric getCmSPB_AirFlowControlNordic_input_153() { return (BStatusNumeric) get(CmSPB_AirFlowControlNordic_input_153); }
  public void setCmSPB_AirFlowControlNordic_input_153(BStatusNumeric v) { set(CmSPB_AirFlowControlNordic_input_153,v,null); }
  public void setCmSPB_AirFlowControlNordic_input_153(float v) { getCmSPB_AirFlowControlNordic_input_153().setValue(v); }
// PlantMode
  public static final Property CmSPB_AirFlowControlNordic_input_36 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmSPB_AirFlowControlNordic_input_36() { return (BStatusNumeric) get(CmSPB_AirFlowControlNordic_input_36); }
  public void setCmSPB_AirFlowControlNordic_input_36(BStatusNumeric v) { set(CmSPB_AirFlowControlNordic_input_36,v,null); }
  public void setCmSPB_AirFlowControlNordic_input_36(float v) { getCmSPB_AirFlowControlNordic_input_36().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.02 [30] 15.01.2019-14:17").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5976417671389905301").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmSPB_AirFlowControlNordic.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmIDT20 func_122 = new CmIDT20();
  protected CmCycleTime func_67 = new CmCycleTime();
  protected CmE_Filter func_28 = new CmE_Filter();
  protected CmAirflow_calculation func_212 = new CmAirflow_calculation();
  protected CmRelease func_1 = new CmRelease();
  protected CfMinimum func_215 = new CfMinimum();
  protected CfHysteresis func_183 = new CfHysteresis();
  protected CfInputMultiplexer func_186 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_170 = new CfInputMultiplexer();
  protected CmSetpoint_Ramp func_109 = new CmSetpoint_Ramp();
  protected CmControl_Signal_Air_Flow func_24 = new CmControl_Signal_Air_Flow();
  protected CmFanspeed_ramp_up func_15 = new CmFanspeed_ramp_up();
  protected CfMinimum func_8 = new CfMinimum();
  protected CfMaximum func_182 = new CfMaximum();
  protected CfInputMultiplexer func_3 = new CfInputMultiplexer();
  protected CfIdt func_5 = new CfIdt();
  protected CfIdt func_108 = new CfIdt();
  protected CfIdt func_112 = new CfIdt();
  protected CfIdt func_235 = new CfIdt();
  protected CfHysteresis func_208 = new CfHysteresis();
  protected CfIdt func_221 = new CfIdt();
  protected CfIdt func_228 = new CfIdt();
  protected CfIdt func_237 = new CfIdt();

  // default constructor
  public BCmSPB_AirFlowControlNordic()
  {
    func_170.configure(7);
    func_8.configure(3);
    func_237.configure(2);
  }

  public void Start()
  {
    func_122.Start();
    func_67.Start();
    func_28.Start();
    func_212.Start();
    func_1.Start();
    func_183.Start();
    func_109.Start();
    func_24.Start();
    func_15.Start();
    func_208.Start();
  }
}
