/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Constant SAT ontrol
Macro id:      5893698963987497158
Macro version: 19
Last change:   19.03.2018 - 15:15
Access Level:  2
Inputs:
  [1] FilteredOATemp
  [2] SupplyTSP
  [3] ContrPtAdj
Outputs:
  [1] SupplyTSP
Parameter:
  [1] WCS-01: start point OAT winter comp. SAT
  [2] WCS-02: end  point OAT winter comp. SAT
  [3] WCS-03: supply air temperature setpoint raise
  [4] SCR-01: start point OAT summer comp. SAT
  [5] SCR-02: stop point OAT summer comp. SAT
  [6] SCR-03: supply temperature setpoint raise
Description:

================================================================================*/

public class CmConstant_SAT_ontrol
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [18] Macro call CmIDT05
    func_18.CmIDT05_input_1 = env.getParameter(parameterOffset);
    func_18.CmIDT05_input_2 = env.getParameter(parameterOffset + 1);
    func_18.CmIDT05_input_3 = env.getParameter(parameterOffset + 2);
    func_18.CmIDT05_input_4 = 0F;
    func_18.CmIDT05_input_5 = 0F;
    func_18.Execute(  );
    env.setParameter(parameterOffset + 6, func_18.CmIDT05_output_21);
    env.setParameter(parameterOffset + 7, func_18.CmIDT05_output_22);
    env.setParameter(parameterOffset + 8, func_18.CmIDT05_output_23);

    // [3] Macro call CmWinter_Compensation
    func_3.CmWinter_Compensation_input_4 = CmConstant_SAT_ontrol_input_6;
    func_3.CmWinter_Compensation_input_5 = CmConstant_SAT_ontrol_input_5;
    func_3.Execute( env, parameterOffset +6 );

    // [26] Function call CfLinearConverter
    func_26.inputValue = CmConstant_SAT_ontrol_input_5;
    func_26.inputInLimit1 = env.getParameter(parameterOffset + 3);
    func_26.inputInLimit2 = env.getParameter(parameterOffset + 4);
    func_26.inputOutLimit1 = 0F;
    func_26.inputOutLimit2 = env.getParameter(parameterOffset + 5);
    func_26.Execute(  );

    // [11] Function call CfAddition
    func_11.input[0] = func_3.CmWinter_Compensation_output_6;
    func_11.input[1] = CmConstant_SAT_ontrol_input_10;
    func_11.input[2] = func_26.output;
    func_11.Execute(  );
    CmConstant_SAT_ontrol_output_16 = func_11.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmConstant_SAT_ontrol_input_5; // FilteredOATemp
public float CmConstant_SAT_ontrol_input_6; // SupplyTSP
public float CmConstant_SAT_ontrol_input_10; // ContrPtAdj
// macro outputs
public float CmConstant_SAT_ontrol_output_16; // SupplyTSP
// helper functions

// class variables
protected CmIDT05 func_18 = new CmIDT05();
protected CmWinter_Compensation func_3 = new CmWinter_Compensation();
protected CfLinearConverter func_26 = new CfLinearConverter();
protected CfAddition func_11 = new CfAddition();

// default constructor
public CmConstant_SAT_ontrol()
{
  func_11.configure(3);
}

  public void Start()
  {
    func_18.Start();
    func_3.Start();
  }
}
