/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Damper Enable
Macro id:      5886358799257698317
Macro version: 14
Last change:   09.11.2015 - 13:45
Access Level:  2
Inputs:
  [1] OAT< LimitOAT-03
  [2] PlantMode
  [3] PumpOffAlarm
  [4] RWTSensorDisabled
  [5] DamperEnableByRWT
Outputs:
  [1] DamperEnable
  [2] DamperEnableAlarm
Parameter:
  [1] DME-01: damper enable or alarm delay
  [2] ALM-03: AHU stops at pump off alarm at low outdoor temperature
Description:
DamperEnableByRWT set to 0 when no RWTsensor is connected
RWTSensorDisabled set to 1 when no RWT sensor is connected
================================================================================*/

public class CmDamper_Enable
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [20] Function call CfEqual
    func_20.input = FloatToInt(CmDamper_Enable_input_6);
    func_20.inputCompare[1-1] = 1;
    func_20.inputCompare[2-1] = 2;
    func_20.inputCompare[3-1] = 3;
    func_20.inputCompare[4-1] = 4;
    func_20.inputCompare[5-1] = 5;
    func_20.inputCompare[6-1] = 6;
    func_20.Execute(  );

    // [21] Function call CfIdt
    func_21.input = env.getParameter(parameterOffset);
    func_21.Execute(  );
    env.setParameter(parameterOffset + 3, func_21.output[0]);
    env.setParameter(parameterOffset + 2, func_21.output[1]);

    // [22] Function call CfCompare1
    func_22.inputA = env.getParameter(parameterOffset);
    func_22.inputB = 1F;
    func_22.Execute(  );

    // [31] Function call CfAnd
    func_31.input[0] = FloatToBoolean(env.getParameter(parameterOffset + 1));
    func_31.input[1] = CmDamper_Enable_input_8;
    func_31.input[2] = CmDamper_Enable_input_10;
    func_31.Execute(  );

    // [46] Function call CfOr
    func_46.input[0] = func_22.outputGreater;
    func_46.input[1] = func_22.outputEqual;
    func_46.Execute(  );

    // [53] Function call CfAnd
    func_53.input[0] = CmDamper_Enable_input_8;
    func_53.input[1] = func_20.output;
    func_53.Execute(  );

    // [17] Function call CfAnd
    func_17.input[0] = func_53.outputAND;
    func_17.input[1] = func_46.outputOR;
    func_17.Execute(  );

    // [33] Function call CfDelay
    func_33.inputA = func_90.outputOR;
    func_33.inputB = func_90.outputOR;
    func_33.Execute( env, parameterOffset + 2 );

    // [13] Function call CfDelay
    func_13.inputA = func_17.outputAND;
    func_13.inputB = func_17.outputAND;
    func_13.Execute( env, parameterOffset + 3 );

    // [56] Function call CfNot
    func_56.input = CmDamper_Enable_input_8;
    func_56.Execute(  );

    // [55] Function call CfAnd
    func_55.input[0] = func_20.output;
    func_55.input[1] = func_56.output;
    func_55.Execute(  );

    // [54] Function call CfOr
    func_54.input[0] = func_33.outputDelayedA;
    func_54.input[1] = func_55.outputAND;
    func_54.Execute(  );

    // [90] Function call CfOr
    func_90.input[0] = func_53.outputAND;
    func_90.input[1] = func_55.outputAND;
    func_90.Execute(  );

    // [66] Function call CfAnd
    func_66.input[0] = func_31.outputNAND;
    func_66.input[1] = func_54.outputOR;
    func_66.input[2] = CmDamper_Enable_input_11;
    func_66.Execute(  );
    CmDamper_Enable_output_4 = func_66.outputAND;

    // [98] Function call CfNot
    func_98.input = CmDamper_Enable_input_11;
    func_98.Execute(  );

    // [94] Function call CfAnd
    func_94.input[0] = func_13.outputDelayedA;
    func_94.input[1] = func_98.output;
    func_94.Execute(  );

    // [64] Function call CfOr
    func_64.input[0] = func_31.outputAND;
    func_64.input[1] = func_94.outputAND;
    func_64.Execute(  );
    CmDamper_Enable_output_5 = func_64.outputOR;

  }
// macro register which are written multiple times
// macro inputs
public boolean CmDamper_Enable_input_8; // OAT< LimitOAT-03
public float CmDamper_Enable_input_6; // PlantMode
public boolean CmDamper_Enable_input_10; // PumpOffAlarm
public boolean CmDamper_Enable_input_12; // RWTSensorDisabled(not used)
public boolean CmDamper_Enable_input_11; // DamperEnableByRWT
// macro outputs
public boolean CmDamper_Enable_output_4; // DamperEnable
public boolean CmDamper_Enable_output_5; // DamperEnableAlarm
// helper functions
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfEqual func_20 = new CfEqual();
protected CfIdt func_21 = new CfIdt();
protected CfCompare1 func_22 = new CfCompare1();
protected CfAnd func_31 = new CfAnd();
protected CfOr func_46 = new CfOr();
protected CfAnd func_53 = new CfAnd();
protected CfAnd func_17 = new CfAnd();
protected CfDelay func_33 = new CfDelay();
protected CfDelay func_13 = new CfDelay();
protected CfNot func_56 = new CfNot();
protected CfAnd func_55 = new CfAnd();
protected CfOr func_54 = new CfOr();
protected CfOr func_90 = new CfOr();
protected CfAnd func_66 = new CfAnd();
protected CfNot func_98 = new CfNot();
protected CfAnd func_94 = new CfAnd();
protected CfOr func_64 = new CfOr();

// default constructor
public CmDamper_Enable()
{
  func_20.configure(7);
  func_21.configure(2);
  func_31.configure(3);
  func_66.configure(3);
}

  public void Start()
  {
    func_33.Start();
    func_13.Start();
  }
}
