/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    ERCEffOverrides
Macro id:      6148276387124871353
Macro version: 4
Last change:   17.12.2015 - 12:57
Access Level:  2
Inputs:
  [1] ERC_running
  [2] ExtFan_running
  [3] SupFan_running
  [4] ERCCtrlSig
  [5] Summer_Mode
  [6] EFF-03 Min control signal calculation
  [7] EFF-04 Calculate in summer
  [8] ALM-04 Minimum control signal alarm
Outputs:
  [1] OverrideCalculation
  [2] OverrideAlarm
Parameter:
  [1] EFF-01 Efficiency calculation start-up delay
  [2] ALM-05 Minimum control signal hysteresis
Description:

================================================================================*/

public class CmERCEffOverrides
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [15] Function call CfIdt
    func_15.input = BooleanToFloat(CmERCEffOverrides_input_5);
    func_15.Execute(  );

    // [16] Function call CfIdt
    func_16.input = BooleanToFloat(CmERCEffOverrides_input_1);
    func_16.Execute(  );

    // [17] Function call CfIdt
    func_17.input = BooleanToFloat(CmERCEffOverrides_input_2);
    func_17.Execute(  );

    // [18] Function call CfIdt
    func_18.input = BooleanToFloat(CmERCEffOverrides_input_3);
    func_18.Execute(  );

    // [19] Function call CfIdt
    func_19.input = CmERCEffOverrides_input_4;
    func_19.Execute(  );

    // [34] Function call CfIdt
    func_34.input = env.getParameter(parameterOffset);
    func_34.Execute(  );
    env.setParameter(parameterOffset + 4, func_34.output[0]);

    // [21] Function call CfAnd
    func_21.input[0] = FloatToBoolean(func_16.output[0]);
    func_21.input[1] = FloatToBoolean(func_17.output[0]);
    func_21.input[2] = FloatToBoolean(func_18.output[0]);
    func_21.Execute(  );

    // [22] Function call CfInputMultiplexer ("Sommer")
    func_22.inputSelect = FloatToInt(CmERCEffOverrides_input_76);
    func_22.input[1-1] = func_15.output[0];
    func_22.input[2-1] = 0F;
    func_22.Execute(  );

    // [23] Function call CfHysteresis
    func_23.inputX = func_19.output[0];
    func_23.inputW = CmERCEffOverrides_input_79;
    func_23.Execute( env, parameterOffset + 2 );

    // [32] Function call CfIdt
    func_32.input = env.getParameter(parameterOffset + 1);
    func_32.Execute(  );
    env.setParameter(parameterOffset + 3, func_32.output[0]);

    // [24] Function call CfHysteresis
    func_24.inputX = func_19.output[0];
    func_24.inputW = CmERCEffOverrides_input_77;
    func_24.Execute( env, parameterOffset + 3 );

    // [25] Function call CfDelayOnOff
    func_25.input = func_21.outputAND;
    func_25.Execute( env, parameterOffset + 4 );

    // [26] Function call CfNot
    func_26.input = func_23.output1;
    func_26.Execute(  );

    // [27] Function call CfNot
    func_27.input = func_24.output1;
    func_27.Execute(  );

    // [28] Function call CfNot ("Oppstart")
    func_28.input = func_25.output;
    func_28.Execute(  );

    // [29] Function call CfOr ("Kriterier for tillatt beregning")
    func_29.input[0] = FloatToBoolean(func_22.output);
    func_29.input[1] = func_28.output;
    func_29.input[2] = func_26.output;
    func_29.Execute(  );
    CmERCEffOverrides_output_6 = func_29.outputOR;

    // [30] Function call CfOr ("Kriterier for tillatt alarm")
    func_30.input[0] = FloatToBoolean(func_22.output);
    func_30.input[1] = func_28.output;
    func_30.input[2] = func_27.output;
    func_30.Execute(  );
    CmERCEffOverrides_output_7 = func_30.outputOR;

  }
// macro register which are written multiple times
// macro inputs
public boolean CmERCEffOverrides_input_1; // ERC_running
public boolean CmERCEffOverrides_input_2; // ExtFan_running
public boolean CmERCEffOverrides_input_3; // SupFan_running
public float CmERCEffOverrides_input_4; // ERCCtrlSig
public boolean CmERCEffOverrides_input_5; // Summer_Mode
public float CmERCEffOverrides_input_79; // EFF-03 Min control signal calculation
public float CmERCEffOverrides_input_76; // EFF-04 Calculate in summer
public float CmERCEffOverrides_input_77; // ALM-04 Minimum control signal alarm
// macro outputs
public boolean CmERCEffOverrides_output_6; // OverrideCalculation
public boolean CmERCEffOverrides_output_7; // OverrideAlarm
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfIdt func_15 = new CfIdt();
protected CfIdt func_16 = new CfIdt();
protected CfIdt func_17 = new CfIdt();
protected CfIdt func_18 = new CfIdt();
protected CfIdt func_19 = new CfIdt();
protected CfIdt func_34 = new CfIdt();
protected CfAnd func_21 = new CfAnd();
protected CfInputMultiplexer func_22 = new CfInputMultiplexer();
protected CfHysteresis func_23 = new CfHysteresis();
protected CfIdt func_32 = new CfIdt();
protected CfHysteresis func_24 = new CfHysteresis();
protected CfDelayOnOff func_25 = new CfDelayOnOff();
protected CfNot func_26 = new CfNot();
protected CfNot func_27 = new CfNot();
protected CfNot func_28 = new CfNot();
protected CfOr func_29 = new CfOr();
protected CfOr func_30 = new CfOr();

// default constructor
public CmERCEffOverrides()
{
  func_21.configure(3);
  func_29.configure(3);
  func_30.configure(3);
}

  public void Start()
  {
    func_23.Start();
    func_24.Start();
    func_25.Start();
  }
}
