/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Fan Sequence
Macro id:      5898539085837893865
Macro version: 27
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] CalcRoomTmpSP
  [2] RoomRetAirTemp
  [3] ComfEnable
Outputs:
  [1] FanSpeed
Parameter:
  [1] RMT-01: room temperature control P-band
  [2] RMT-03: span for SAT-setpoint shift
  [3] RMT-04: fan speed control type
  [4] RMT-05: room temperature comfort zone
Description:

================================================================================*/

public class CmFan_Sequence
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [90] Function call CfIdt
    func_90.input = 1F;
    func_90.Execute(  );
    env.setParameter(parameterOffset + 4, func_90.output[0]);

    // [44] Function call CfDivide
    func_44.inputA = env.getParameter(parameterOffset);
    func_44.inputB = 2F;
    func_44.Execute(  );

    // [115] Function call CfMultiply
    func_115.input[0] = func_44.output;
    func_115.input[1] = env.getParameter(parameterOffset + 1);
    func_115.Execute(  );

    // [114] Function call CfDivide
    func_114.inputA = func_115.output;
    func_114.inputB = 100F;
    func_114.Execute(  );

    // [105] Function call CfInputMultiplexer
    func_105.inputSelect = BooleanToInt(CmFan_Sequence_input_107);
    func_105.input[1-1] = 0F;
    func_105.input[2-1] = env.getParameter(parameterOffset + 3);
    func_105.Execute(  );

    // [102] Function call CfDivide
    func_102.inputA = func_105.output;
    func_102.inputB = 2F;
    func_102.Execute(  );

    // [99] Function call CfSubtract
    func_99.input[0] = CmFan_Sequence_input_1;
    func_99.input[1] = func_114.output;
    func_99.input[2] = func_102.output;
    func_99.Execute(  );

    // [122] Function call CfSubtract
    func_122.input[0] = CmFan_Sequence_input_1;
    func_122.input[1] = func_44.output;
    func_122.input[2] = func_102.output;
    func_122.Execute(  );

    // [97] Function call CfAddition
    func_97.input[0] = CmFan_Sequence_input_1;
    func_97.input[1] = func_114.output;
    func_97.input[2] = func_102.output;
    func_97.Execute(  );

    // [121] Function call CfAddition
    func_121.input[0] = CmFan_Sequence_input_1;
    func_121.input[1] = func_44.output;
    func_121.input[2] = func_102.output;
    func_121.Execute(  );

    // [57] Function call CfLinearConverter
    func_57.inputValue = CmFan_Sequence_input_51;
    func_57.inputInLimit1 = func_99.output;
    func_57.inputInLimit2 = func_122.output;
    func_57.inputOutLimit1 = 0F;
    func_57.inputOutLimit2 = 100F;
    func_57.Execute(  );

    // [58] Function call CfLinearConverter
    func_58.inputValue = CmFan_Sequence_input_51;
    func_58.inputInLimit1 = func_97.output;
    func_58.inputInLimit2 = func_121.output;
    func_58.inputOutLimit1 = 0F;
    func_58.inputOutLimit2 = 100F;
    func_58.Execute(  );

    // [86] Function call CfOutputMultiplexer
    func_86.inputSelect = FloatToInt(env.getParameter(parameterOffset + 2));
    func_86.inputValue = 1F;
    func_86.Execute( env, parameterOffset + 4 );

    // [87] Function call CfOr
    func_87.input[0] = FloatToBoolean(func_86.output[1]);
    func_87.input[1] = FloatToBoolean(func_86.output[3]);
    func_87.Execute(  );

    // [89] Function call CfOr
    func_89.input[0] = FloatToBoolean(func_86.output[2]);
    func_89.input[1] = FloatToBoolean(func_86.output[3]);
    func_89.Execute(  );

    // [73] Function call CfInputMultiplexer
    func_73.inputSelect = BooleanToInt(func_87.outputOR);
    func_73.input[1-1] = 0F;
    func_73.input[2-1] = func_57.output;
    func_73.Execute(  );

    // [78] Function call CfInputMultiplexer
    func_78.inputSelect = BooleanToInt(func_89.outputOR);
    func_78.input[1-1] = 0F;
    func_78.input[2-1] = func_58.output;
    func_78.Execute(  );

    // [67] Function call CfMaximum
    func_67.input[0] = func_73.output;
    func_67.input[1] = func_78.output;
    func_67.Execute(  );
    CmFan_Sequence_output_2 = func_67.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmFan_Sequence_input_1; // CalcRoomTmpSP
public float CmFan_Sequence_input_51; // RoomRetAirTemp
public boolean CmFan_Sequence_input_107; // ComfEnable
// macro outputs
public float CmFan_Sequence_output_2; // FanSpeed
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfIdt func_90 = new CfIdt();
protected CfDivide func_44 = new CfDivide();
protected CfMultiply func_115 = new CfMultiply();
protected CfDivide func_114 = new CfDivide();
protected CfInputMultiplexer func_105 = new CfInputMultiplexer();
protected CfDivide func_102 = new CfDivide();
protected CfSubtract func_99 = new CfSubtract();
protected CfSubtract func_122 = new CfSubtract();
protected CfAddition func_97 = new CfAddition();
protected CfAddition func_121 = new CfAddition();
protected CfLinearConverter func_57 = new CfLinearConverter();
protected CfLinearConverter func_58 = new CfLinearConverter();
protected CfOutputMultiplexer func_86 = new CfOutputMultiplexer();
protected CfOr func_87 = new CfOr();
protected CfOr func_89 = new CfOr();
protected CfInputMultiplexer func_73 = new CfInputMultiplexer();
protected CfInputMultiplexer func_78 = new CfInputMultiplexer();
protected CfMaximum func_67 = new CfMaximum();

// default constructor
public CmFan_Sequence()
{
  func_99.configure(3);
  func_122.configure(3);
  func_97.configure(3);
  func_121.configure(3);
  func_86.configure(4);
}

  public void Start()
  {
  }
}
