/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Flow Balancing
Macro id:      5800565212194013796
Macro version: 22
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] DamperControlSignal
  [2] PlantMode
  [3] Recirc_I_Enable
  [4] DisplaySupplyFlow
Outputs:
  [1] RecircControl
Parameter:
  [1] SAF-01: predefined flow during 100% recirculation; 0 = disable
  [2] SAF-02: Pband flow balance control
  [3] SAF-03: Itime flow balance control
Description:

================================================================================*/

public class CmFlow_Balancing
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [67] Function call CfIdt
    func_67.input = env.getParameter(parameterOffset + 1);
    func_67.Execute(  );
    env.setParameter(parameterOffset + 5, func_67.output[0]);

    // [66] Function call CfIdt
    func_66.input = env.getParameter(parameterOffset + 2);
    func_66.Execute(  );
    env.setParameter(parameterOffset + 7, func_66.output[0]);

    // [43] Function call CfHysteresis
    func_43.inputX = env.getParameter(parameterOffset);
    func_43.inputW = 0F;
    func_43.Execute( env, parameterOffset + 3 );

    // [49] Function call CfIdt
    func_49.input = CmFlow_Balancing_input_50;
    func_49.Execute(  );

    // [48] Function call CfHysteresis
    func_48.inputX = func_49.output[0];
    func_48.inputW = -0.5F;
    func_48.Execute( env, parameterOffset + 4 );

    // [52] Function call CfIdt
    func_52.input = CmFlow_Balancing_input_54;
    func_52.Execute(  );

    // [55] Function call CfEqual
    func_55.input = FloatToInt(func_52.output[0]);
    func_55.inputCompare[1-1] = 1;
    func_55.inputCompare[2-1] = 2;
    func_55.inputCompare[3-1] = 6;
    func_55.Execute(  );

    // [58] Function call CfOr
    func_58.input[0] = func_48.output2;
    func_58.input[1] = func_55.output;
    func_58.Execute(  );

    // [75] Function call CfIdt
    func_75.input = CmFlow_Balancing_input_79;
    func_75.Execute(  );

    // [72] Function call CfIdt
    func_72.input = BooleanToFloat(CmFlow_Balancing_input_73);
    func_72.Execute(  );

    // [10] Function call CfPidPlus
    func_10.inputX = func_75.output[0];
    func_10.inputW = env.getParameter(parameterOffset);
    func_10.inputIntegralOn = FloatToBoolean(func_72.output[0]);
    func_10.Execute( env, parameterOffset + 5 );

    // [60] Function call CfOr
    func_60.input[0] = func_43.output2;
    func_60.input[1] = func_58.outputNOR;
    func_60.Execute(  );

    // [11] Function call CfInputMultiplexer
    func_11.inputSelect = BooleanToInt(func_60.outputOR);
    func_11.input[1-1] = func_10.output;
    func_11.input[2-1] = 100F;
    func_11.Execute(  );

    // [64] Function call CfIdt
    func_64.input = func_11.output;
    func_64.Execute(  );
    CmFlow_Balancing_output_65 = func_64.output[0];

  }
// macro register which are written multiple times
// macro inputs
public float CmFlow_Balancing_input_50; // DamperControlSignal
public float CmFlow_Balancing_input_54; // PlantMode
public boolean CmFlow_Balancing_input_73; // Recirc_I_Enable
public float CmFlow_Balancing_input_79; // DisplaySupplyFlow
// macro outputs
public float CmFlow_Balancing_output_65; // RecircControl
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfIdt func_67 = new CfIdt();
protected CfIdt func_66 = new CfIdt();
protected CfHysteresis func_43 = new CfHysteresis();
protected CfIdt func_49 = new CfIdt();
protected CfHysteresis func_48 = new CfHysteresis();
protected CfIdt func_52 = new CfIdt();
protected CfEqual func_55 = new CfEqual();
protected CfOr func_58 = new CfOr();
protected CfIdt func_75 = new CfIdt();
protected CfIdt func_72 = new CfIdt();
protected CfPidPlus func_10 = new CfPidPlus();
protected CfOr func_60 = new CfOr();
protected CfInputMultiplexer func_11 = new CfInputMultiplexer();
protected CfIdt func_64 = new CfIdt();

// default constructor
public CmFlow_Balancing()
{
  func_55.configure(4);
}

  public void Start()
  {
    func_43.Start();
    func_48.Start();
    func_10.Start();
  }
}
