/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    FrostProtectionNordic
Macro id:      5975063012358226805
Macro version: 2
Last change:   31.01.2014 - 15:27
Access Level:  2
Inputs:
  [1] Thermostat
  [2] RWTsensor
  [3] SATsensor
Outputs:
  [1] Alarm
Parameter:
  [1] RWT-06: frost protection limit return water sensor
  [2] SAT-01: supply air frost protection limit
  [3] SAT-02: supply air frost protection limit delay
Description:

================================================================================*/

public class CmFrostProtectionNordic
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [8] Function call CfHysteresis
    func_8.inputX = env.getParameter(parameterOffset);
    func_8.inputW = CmFrostProtectionNordic_input_2;
    func_8.Execute( env, parameterOffset + 3 );

    // [11] Function call CfHysteresis
    func_11.inputX = env.getParameter(parameterOffset + 1);
    func_11.inputW = CmFrostProtectionNordic_input_3;
    func_11.Execute( env, parameterOffset + 4 );

    // [20] Function call CfIdt
    func_20.input = 2F;
    func_20.Execute(  );
    env.setParameter(parameterOffset + 4, func_20.output[0]);
    env.setParameter(parameterOffset + 3, func_20.output[1]);

    // [22] Function call CfIdt
    func_22.input = env.getParameter(parameterOffset + 2);
    func_22.Execute(  );
    env.setParameter(parameterOffset + 5, func_22.output[0]);

    // [14] Function call CfDelay
    func_14.inputA = func_11.output1;
    func_14.inputB = func_11.output1;
    func_14.Execute( env, parameterOffset + 5 );

    // [17] Function call CfOr
    func_17.input[0] = func_8.output1;
    func_17.input[1] = func_14.outputDelayedA;
    func_17.input[2] = CmFrostProtectionNordic_input_1;
    func_17.Execute(  );
    CmFrostProtectionNordic_output_4 = func_17.outputOR;

  }
// macro register which are written multiple times
// macro inputs
public boolean CmFrostProtectionNordic_input_1; // Thermostat
public float CmFrostProtectionNordic_input_2; // RWTsensor
public float CmFrostProtectionNordic_input_3; // SATsensor
// macro outputs
public boolean CmFrostProtectionNordic_output_4; // Alarm
// helper functions

// class variables
protected CfHysteresis func_8 = new CfHysteresis();
protected CfHysteresis func_11 = new CfHysteresis();
protected CfIdt func_20 = new CfIdt();
protected CfIdt func_22 = new CfIdt();
protected CfDelay func_14 = new CfDelay();
protected CfOr func_17 = new CfOr();

// default constructor
public CmFrostProtectionNordic()
{
  func_20.configure(2);
  func_17.configure(3);
}

  public void Start()
  {
    func_8.Start();
    func_11.Start();
    func_14.Start();
  }
}
