/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    High limit pressure control
Macro id:      5800581101281869830
Macro version: 17
Last change:   09.07.2015 - 12:44
Access Level:  2
Inputs:
  [1] HighPressureSensor_999
  [2] HighPressureSensor
Outputs:
  [1] HighPressureSensor_control
Parameter:
  [1] DSH-01: setpoint high limit static pressure control
  [2] DSH-02: Pband high limit static pressure control
  [3] DSH-03: Itime high limit static pressure control
Description:

================================================================================*/

public class CmHigh_limit_pressure_control
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [4] Function call CfIdt
    func_4.input = BooleanToFloat(CmHigh_limit_pressure_control_input_9);
    func_4.Execute(  );

    // [22] Function call CfIdt
    func_22.input = env.getParameter(parameterOffset + 1);
    func_22.Execute(  );
    env.setParameter(parameterOffset + 3, func_22.output[0]);

    // [40] Function call CfDivide
    func_40.inputA = func_22.output[1];
    func_40.inputB = 2F;
    func_40.Execute(  );

    // [28] Function call CfIdt
    func_28.input = CmHigh_limit_pressure_control_input_27;
    func_28.Execute(  );

    // [15] Function call CfCompare1
    func_15.inputA = env.getParameter(parameterOffset + 2);
    func_15.inputB = 0F;
    func_15.Execute(  );

    // [44] Function call CfNegate
    func_44.input = func_40.output;
    func_44.Execute(  );

    // [43] Function call CfInputMultiplexer
    func_43.inputSelect = BooleanToInt(func_15.outputGreater);
    func_43.input[1-1] = func_44.output;
    func_43.input[2-1] = func_40.output;
    func_43.Execute(  );

    // [32] Function call CfAddition
    func_32.input[0] = env.getParameter(parameterOffset);
    func_32.input[1] = func_43.output;
    func_32.Execute(  );

    // [19] Function call CfPidPlus
    func_19.inputX = func_28.output[0];
    func_19.inputW = func_32.output;
    func_19.inputIntegralOn = func_15.outputGreater;
    func_19.Execute( env, parameterOffset + 3 );

    // [2] Function call CfInputMultiplexer
    func_2.inputSelect = FloatToInt(func_4.output[0]);
    func_2.input[1-1] = func_19.output;
    func_2.input[2-1] = 100F;
    func_2.Execute(  );

    // [1] Function call CfIdt
    func_1.input = func_2.output;
    func_1.Execute(  );
    CmHigh_limit_pressure_control_output_10 = func_1.output[0];

  }
// macro register which are written multiple times
// macro inputs
public boolean CmHigh_limit_pressure_control_input_9; // HighPressureSensor_999
public float CmHigh_limit_pressure_control_input_27; // HighPressureSensor
// macro outputs
public float CmHigh_limit_pressure_control_output_10; // HighPressureSensor_control
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }

// class variables
protected CfIdt func_4 = new CfIdt();
protected CfIdt func_22 = new CfIdt();
protected CfDivide func_40 = new CfDivide();
protected CfIdt func_28 = new CfIdt();
protected CfCompare1 func_15 = new CfCompare1();
protected CfNegate func_44 = new CfNegate();
protected CfInputMultiplexer func_43 = new CfInputMultiplexer();
protected CfAddition func_32 = new CfAddition();
protected CfPidPlus func_19 = new CfPidPlus();
protected CfInputMultiplexer func_2 = new CfInputMultiplexer();
protected CfIdt func_1 = new CfIdt();

// default constructor
public CmHigh_limit_pressure_control()
{
  func_22.configure(2);
}

  public void Start()
  {
    func_19.Start();
  }
}
