/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Output Sequence
Macro id:      5894041775311422303
Macro version: 12
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] Y-SAT
  [2] ERC reverse
Outputs:
  [1] HeatControl
  [2] CoolControl
  [3] ERCControl
Parameter:
  [1] SAT-05: sequence start point heating valve
  [2] SAT-06: sequence end point heating valve
  [3] SAT-09: sequence start point energy recovery
  [4] SAT-10 :sequence end point energy recovery
  [5] SAT-11: sequence start point cooling valve
  [6] SAT-12: sequence end point cooling valve
Description:

================================================================================*/

public class CmOutput_Sequence
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [24] Function call CfMaximum
    func_24.input[0] = env.getParameter(parameterOffset);
    func_24.input[1] = env.getParameter(parameterOffset + 1);
    func_24.Execute(  );

    // [12] Function call CfLinearConverter
    func_12.inputValue = CmOutput_Sequence_input_1;
    func_12.inputInLimit1 = env.getParameter(parameterOffset);
    func_12.inputInLimit2 = env.getParameter(parameterOffset + 1);
    func_12.inputOutLimit1 = 100F;
    func_12.inputOutLimit2 = 0F;
    func_12.Execute(  );

    // [16] Function call CfInputMultiplexer
    func_16.inputSelect = FloatToInt(func_24.output);
    func_16.input[1-1] = 0F;
    func_16.input[2-1] = func_12.output;
    func_16.Execute(  );
    CmOutput_Sequence_output_2 = func_16.output;

    // [35] Function call CfLinearConverter
    func_35.inputValue = CmOutput_Sequence_input_1;
    func_35.inputInLimit1 = env.getParameter(parameterOffset + 2);
    func_35.inputInLimit2 = env.getParameter(parameterOffset + 3);
    func_35.inputOutLimit1 = 100F;
    func_35.inputOutLimit2 = 0F;
    func_35.Execute(  );

    // [14] Function call CfLinearConverter
    func_14.inputValue = CmOutput_Sequence_input_1;
    func_14.inputInLimit1 = env.getParameter(parameterOffset + 2);
    func_14.inputInLimit2 = env.getParameter(parameterOffset + 3);
    func_14.inputOutLimit1 = 0F;
    func_14.inputOutLimit2 = 100F;
    func_14.Execute(  );

    // [25] Function call CfMaximum
    func_25.input[0] = env.getParameter(parameterOffset + 2);
    func_25.input[1] = env.getParameter(parameterOffset + 3);
    func_25.Execute(  );

    // [36] Function call CfInputMultiplexer
    func_36.inputSelect = BooleanToInt(CmOutput_Sequence_input_37);
    func_36.input[1-1] = func_35.output;
    func_36.input[2-1] = func_14.output;
    func_36.Execute(  );

    // [17] Function call CfInputMultiplexer
    func_17.inputSelect = FloatToInt(func_25.output);
    func_17.input[1-1] = 0F;
    func_17.input[2-1] = func_36.output;
    func_17.Execute(  );
    CmOutput_Sequence_output_4 = func_17.output;

    // [15] Function call CfLinearConverter
    func_15.inputValue = CmOutput_Sequence_input_1;
    func_15.inputInLimit1 = env.getParameter(parameterOffset + 4);
    func_15.inputInLimit2 = env.getParameter(parameterOffset + 5);
    func_15.inputOutLimit1 = 0F;
    func_15.inputOutLimit2 = 100F;
    func_15.Execute(  );

    // [27] Function call CfMaximum
    func_27.input[0] = env.getParameter(parameterOffset + 4);
    func_27.input[1] = env.getParameter(parameterOffset + 5);
    func_27.Execute(  );

    // [19] Function call CfInputMultiplexer
    func_19.inputSelect = FloatToInt(func_27.output);
    func_19.input[1-1] = 0F;
    func_19.input[2-1] = func_15.output;
    func_19.Execute(  );
    CmOutput_Sequence_output_3 = func_19.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmOutput_Sequence_input_1; // Y-SAT
public boolean CmOutput_Sequence_input_37; // ERC reverse
// macro outputs
public float CmOutput_Sequence_output_2; // HeatControl
public float CmOutput_Sequence_output_3; // CoolControl
public float CmOutput_Sequence_output_4; // ERCControl
// helper functions
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }

// class variables
protected CfMaximum func_24 = new CfMaximum();
protected CfLinearConverter func_12 = new CfLinearConverter();
protected CfInputMultiplexer func_16 = new CfInputMultiplexer();
protected CfLinearConverter func_35 = new CfLinearConverter();
protected CfLinearConverter func_14 = new CfLinearConverter();
protected CfMaximum func_25 = new CfMaximum();
protected CfInputMultiplexer func_36 = new CfInputMultiplexer();
protected CfInputMultiplexer func_17 = new CfInputMultiplexer();
protected CfLinearConverter func_15 = new CfLinearConverter();
protected CfMaximum func_27 = new CfMaximum();
protected CfInputMultiplexer func_19 = new CfInputMultiplexer();

// default constructor
public CmOutput_Sequence()
{
}

  public void Start()
  {
  }
}
