/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Plant Mode 3 Nordic
Macro id:      5978729850316466222
Macro version: 5
Last change:   21.09.2017 - 11:51
Access Level:  2
Inputs:
  [1] FilteredOATemp
  [2] RoomRetAirTemp
  [3] CalcRoomSP
  [4] Occ_Period_MSt
  [5] NIPUEnable
Outputs:
  [1] PlantMode3
Parameter:
  [1] NIPU-01 time before occupied period
  [2] NIPU-02: outside air temperature low limit
  [3] NIPU-03: room temp. shiftt
  [4] NIPU-04: diff. between RMT and OAT
  [5] NIPU-05: switching differential NIPU-02, -03, -04
  [6] NIPU-06: switch on delay
  [7] NIPU-07: switch off delay
Description:

================================================================================*/

public class CmPlant_Mode_3_Nordic
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [155] Macro call CmIDT05
    func_155.CmIDT05_input_1 = env.getParameter(parameterOffset + 1);
    func_155.CmIDT05_input_2 = env.getParameter(parameterOffset + 3);
    func_155.CmIDT05_input_3 = env.getParameter(parameterOffset + 4);
    func_155.CmIDT05_input_4 = env.getParameter(parameterOffset + 5);
    func_155.CmIDT05_input_5 = env.getParameter(parameterOffset + 6);
    func_155.Execute(  );
    env.setParameter(parameterOffset + 8, func_155.CmIDT05_output_21);
    env.setParameter(parameterOffset + 9, func_155.CmIDT05_output_22);
    env.setParameter(parameterOffset + 10, func_155.CmIDT05_output_23);
    env.setParameter(parameterOffset + 11, func_155.CmIDT05_output_24);
    env.setParameter(parameterOffset + 12, func_155.CmIDT05_output_25);

    // [160] Function call CfMultiply
    func_160.input[0] = env.getParameter(parameterOffset);
    func_160.input[1] = 60F;
    func_160.Execute(  );

    // [173] Function call CfNextSchedule
    func_173.input = CmPlant_Mode_3_Nordic_input_1;
    func_173.Execute( env, parameterOffset + 7 );

    // [162] Function call CfCompare1
    func_162.inputA = IntToFloat(func_173.outputTimeUntilChange);
    func_162.inputB = func_160.output;
    func_162.Execute(  );

    // [209] Function call CfWindow
    func_209.inputValue = func_173.outputNextValue;
    func_209.inputMinimum = 1.8F;
    func_209.inputMaximum = 4.2F;
    func_209.Execute(  );

    // [194] Function call CfOr
    func_194.input[0] = func_162.outputEqual;
    func_194.input[1] = func_162.outputLess;
    func_194.Execute(  );

    // [220] Function call CfWindow
    func_220.inputValue = CmPlant_Mode_3_Nordic_input_1;
    func_220.inputMinimum = 0.8F;
    func_220.inputMaximum = 1.2F;
    func_220.Execute(  );

    // [222] Function call CfCompare1
    func_222.inputA = env.getParameter(parameterOffset);
    func_222.inputB = 0F;
    func_222.Execute(  );

    // [232] Function call CfCompare2
    func_232.inputA = CmPlant_Mode_3_Nordic_input_16;
    func_232.inputB = 100F;
    func_232.Execute(  );

    // [229] Function call CfCompare2
    func_229.inputA = CmPlant_Mode_3_Nordic_input_2;
    func_229.inputB = 100F;
    func_229.Execute(  );

    // [168] Function call CfAnd
    func_168.input[0] = func_209.output;
    func_168.input[1] = func_194.outputOR;
    func_168.input[2] = func_220.output;
    func_168.input[3] = func_222.outputGreater;
    func_168.input[4] = func_229.outputEqualOrLess;
    func_168.input[5] = func_232.outputEqualOrLess;
    func_168.Execute(  );

    // [151] Function call CfNightPurge
    func_151.inputRoomTemp = CmPlant_Mode_3_Nordic_input_2;
    func_151.inputOutsideAirTemp = CmPlant_Mode_3_Nordic_input_16;
    func_151.inputStartStop = func_168.outputAND;
    func_151.inputRoomTempSetpointShift = env.getParameter(parameterOffset + 2);
    func_151.inputRoomTempSetpoint = CmPlant_Mode_3_Nordic_input_17;
    func_151.Execute( env, parameterOffset + 8 );

    // [156] Function call CfDelayOnOff
    func_156.input = func_151.outputActive;
    func_156.Execute( env, parameterOffset + 11 );

    // [247] Function call CfAnd
    func_247.input[0] = func_156.output;
    func_247.input[1] = CmPlant_Mode_3_Nordic_input_234;
    func_247.Execute(  );
    CmPlant_Mode_3_Nordic_output_3 = func_247.outputAND;

  }
// macro register which are written multiple times
// macro inputs
public float CmPlant_Mode_3_Nordic_input_16; // FilteredOATemp
public float CmPlant_Mode_3_Nordic_input_2; // RoomRetAirTemp
public float CmPlant_Mode_3_Nordic_input_17; // CalcRoomSP
public float CmPlant_Mode_3_Nordic_input_1; // Occ_Period_MSt
public boolean CmPlant_Mode_3_Nordic_input_234; // NIPUEnable
// macro outputs
public boolean CmPlant_Mode_3_Nordic_output_3; // PlantMode3
// helper functions
private float   IntToFloat    (int     value) { return (float) value; }

// class variables
protected CmIDT05 func_155 = new CmIDT05();
protected CfMultiply func_160 = new CfMultiply();
protected CfNextSchedule func_173 = new CfNextSchedule();
protected CfCompare1 func_162 = new CfCompare1();
protected CfWindow func_209 = new CfWindow();
protected CfOr func_194 = new CfOr();
protected CfWindow func_220 = new CfWindow();
protected CfCompare1 func_222 = new CfCompare1();
protected CfCompare2 func_232 = new CfCompare2();
protected CfCompare2 func_229 = new CfCompare2();
protected CfAnd func_168 = new CfAnd();
protected CfNightPurge func_151 = new CfNightPurge();
protected CfDelayOnOff func_156 = new CfDelayOnOff();
protected CfAnd func_247 = new CfAnd();

// default constructor
public CmPlant_Mode_3_Nordic()
{
  func_168.configure(6);
}

  public void Start()
  {
    func_155.Start();
    func_151.Start();
    func_156.Start();
  }
}
