/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Return Water Setpoint ControlNordic
Macro id:      5973981145760803935
Macro version: 6
Last change:   09.11.2015 - 14:14
Access Level:  2
Inputs:
  [1] RWTSensor
  [2] OAT>LimitOAT-03
  [3] Incr/DecrFrostRecovery
  [4] PlantMode
  [5] RetTmpSpOcc
  [6] RetTmpSpUnOcc
  [7] RetSetpointSelect
Outputs:
  [1] RWTControl
  [2] DamperEnableByRWT
  [3] RWTsetpoint
Parameter:
  [1] RWT-03: return water temperature maximum setpoint
  [2] RWT-04: return water temperature P-band
  [3] RWT-05: return water temperature setpoint ramp
Description:

================================================================================*/

public class CmReturn_Water_Setpoint_ControlNordic
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [176] Function call CfCompare1
    func_176.inputA = CmReturn_Water_Setpoint_ControlNordic_input_139;
    func_176.inputB = 22F;
    func_176.Execute(  );

    // [177] Function call CfWindow
    func_177.inputValue = CmReturn_Water_Setpoint_ControlNordic_input_139;
    func_177.inputMinimum = 3.9F;
    func_177.inputMaximum = 6.1F;
    func_177.Execute(  );

    // [179] Function call CfOr
    func_179.input[0] = func_176.outputEqual;
    func_179.input[1] = func_177.output;
    func_179.Execute(  );

    // [183] Function call CfInputMultiplexer
    func_183.inputSelect = BooleanToInt(func_179.outputOR);
    func_183.input[1-1] = CmReturn_Water_Setpoint_ControlNordic_input_156;
    func_183.input[2-1] = CmReturn_Water_Setpoint_ControlNordic_input_155;
    func_183.Execute(  );

    // [124] Function call CfIdt
    func_124.input = env.getParameter(parameterOffset + 1);
    func_124.Execute(  );
    env.setParameter(parameterOffset + 3, func_124.output[0]);

    // [153] Function call CfIdt
    func_153.input = 0F;
    func_153.Execute(  );
    env.setParameter(parameterOffset + 5, func_153.output[0]);

    // [123] Function call CfPidPlus
    func_123.inputX = CmReturn_Water_Setpoint_ControlNordic_input_2;
    func_123.inputW = func_154.output;
    func_123.inputIntegralOn = false;
    func_123.Execute( env, parameterOffset + 3 );

    // [163] Function call CfInputMultiplexer
    func_163.inputSelect = FloatToInt(CmReturn_Water_Setpoint_ControlNordic_input_157);
    func_163.input[1-1] = CmReturn_Water_Setpoint_ControlNordic_input_156;
    func_163.input[2-1] = CmReturn_Water_Setpoint_ControlNordic_input_156;
    func_163.input[3-1] = CmReturn_Water_Setpoint_ControlNordic_input_156;
    func_163.input[4-1] = CmReturn_Water_Setpoint_ControlNordic_input_155;
    func_163.input[5-1] = func_183.output;
    func_163.Execute(  );

    // [31] Function call CfMinimum
    func_31.input[0] = func_163.output;
    func_31.input[1] = env.getParameter(parameterOffset);
    func_31.Execute(  );

    // [32] Function call CfAddition
    func_32.input[0] = func_31.output;
    func_32.input[1] = CmReturn_Water_Setpoint_ControlNordic_input_4;
    func_32.Execute(  );

    // [154] Function call CfValueRamp2
    func_154.inputValue = func_32.output;
    func_154.inputRisingSlope = env.getParameter(parameterOffset + 2);
    func_154.inputFallingSlope = env.getParameter(parameterOffset + 2);
    func_154.Execute( env );

    // [193] Function call CfDivide
    func_193.inputA = env.getParameter(parameterOffset + 1);
    func_193.inputB = 2F;
    func_193.Execute(  );

    // [191] Function call CfSubtract
    func_191.input[0] = func_154.output;
    func_191.input[1] = func_193.output;
    func_191.Execute(  );

    // [102] Function call CfCompare1
    func_102.inputA = CmReturn_Water_Setpoint_ControlNordic_input_2;
    func_102.inputB = func_191.output;
    func_102.Execute(  );

    // [80] Function call CfCompare1
    func_80.inputA = CmReturn_Water_Setpoint_ControlNordic_input_2;
    func_80.inputB = 999F;
    func_80.Execute(  );

    // [200] Function call CfOr
    func_200.input[0] = func_80.outputEqual;
    func_200.input[1] = func_102.outputGreater;
    func_200.Execute(  );

    // [86] Function call CfIdt
    func_86.input = BooleanToFloat(func_200.outputOR);
    func_86.Execute(  );
    CmReturn_Water_Setpoint_ControlNordic_output_6 = FloatToBoolean(func_86.output[0]);

    // [127] Function call CfIdt
    func_127.input = func_154.output;
    func_127.Execute(  );
    CmReturn_Water_Setpoint_ControlNordic_output_126 = func_127.output[0];

    // [34] Function call CfInputMultiplexer
    func_34.inputSelect = BooleanToInt(CmReturn_Water_Setpoint_ControlNordic_input_90);
    func_34.input[1-1] = func_123.output;
    func_34.input[2-1] = 0F;
    func_34.Execute(  );
    CmReturn_Water_Setpoint_ControlNordic_output_5 = func_34.output;

  }
// macro register which are written multiple times
// macro inputs
public float CmReturn_Water_Setpoint_ControlNordic_input_2; // RWTSensor
public boolean CmReturn_Water_Setpoint_ControlNordic_input_90; // OAT>LimitOAT-03
public float CmReturn_Water_Setpoint_ControlNordic_input_4; // Incr/DecrFrostRecovery
public float CmReturn_Water_Setpoint_ControlNordic_input_139; // PlantMode
public float CmReturn_Water_Setpoint_ControlNordic_input_155; // RetTmpSpOcc
public float CmReturn_Water_Setpoint_ControlNordic_input_156; // RetTmpSpUnOcc
public float CmReturn_Water_Setpoint_ControlNordic_input_157; // RetSetpointSelect
// macro outputs
public float CmReturn_Water_Setpoint_ControlNordic_output_5; // RWTControl
public boolean CmReturn_Water_Setpoint_ControlNordic_output_6; // DamperEnableByRWT
public float CmReturn_Water_Setpoint_ControlNordic_output_126; // RWTsetpoint
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
private int     FloatToInt    (float   value) { return (int) value;   }
private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

// class variables
protected CfCompare1 func_176 = new CfCompare1();
protected CfWindow func_177 = new CfWindow();
protected CfOr func_179 = new CfOr();
protected CfInputMultiplexer func_183 = new CfInputMultiplexer();
protected CfIdt func_124 = new CfIdt();
protected CfIdt func_153 = new CfIdt();
protected CfPidPlus func_123 = new CfPidPlus();
protected CfInputMultiplexer func_163 = new CfInputMultiplexer();
protected CfMinimum func_31 = new CfMinimum();
protected CfAddition func_32 = new CfAddition();
protected CfValueRamp2 func_154 = new CfValueRamp2();
protected CfDivide func_193 = new CfDivide();
protected CfSubtract func_191 = new CfSubtract();
protected CfCompare1 func_102 = new CfCompare1();
protected CfCompare1 func_80 = new CfCompare1();
protected CfOr func_200 = new CfOr();
protected CfIdt func_86 = new CfIdt();
protected CfIdt func_127 = new CfIdt();
protected CfInputMultiplexer func_34 = new CfInputMultiplexer();

// default constructor
public CmReturn_Water_Setpoint_ControlNordic()
{
  func_163.configure(6);
}

  public void Start()
  {
    func_123.Start();
    func_154.Start();
  }
}
