/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:37
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicaircondition;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    Step Controller
Macro id:      5925669055771968463
Macro version: 62
Last change:   05.12.2013 - 09:30
Access Level:  2
Inputs:
  [1] Release
  [2] HeatControl
Outputs:
  [1] ActStage
Parameter:
  [1] STx-01: blocking on time
  [2] STx-02: blocking off time
  [3] SYS-01: Total number of digital stages
  [4] SYS-02: Enable analog output
  [5] SYS-03: Stage differential
Description:

================================================================================*/

public class CmStep_Controller
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [233] Function call CfIdt
    func_233.input = env.getParameter(parameterOffset);
    func_233.Execute(  );
    env.setParameter(parameterOffset + 5, func_233.output[0]);

    // [250] Function call CfIdt
    func_250.input = env.getParameter(parameterOffset + 1);
    func_250.Execute(  );
    env.setParameter(parameterOffset + 6, func_250.output[0]);

    // [217] Function call CfLastValue
    func_217.input = func_290.output;
    func_217.Execute(  );

    // [219] Function call CfCompare1
    func_219.inputA = func_217.outputCurrent;
    func_219.inputB = func_217.outputLast;
    func_219.Execute(  );

    // [228] Function call CfMonoflop
    func_228.input = BooleanToFloat(func_219.outputGreater);
    func_228.Execute( env, parameterOffset + 5 );

    // [229] Function call CfNot
    func_229.input = func_228.output;
    func_229.Execute(  );

    // [150] Function call CfAddition
    func_150.input[0] = 1F;
    func_150.input[1] = func_290.output;
    func_150.Execute(  );

    // [148] Function call CfDivide
    func_148.inputA = env.getParameter(parameterOffset + 4);
    func_148.inputB = 100F;
    func_148.Execute(  );

    // [188] Function call CfAddition
    func_188.input[0] = env.getParameter(parameterOffset + 3);
    func_188.input[1] = env.getParameter(parameterOffset + 2);
    func_188.Execute(  );

    // [152] Function call CfSubtract
    func_152.input[0] = func_290.output;
    func_152.input[1] = func_148.output;
    func_152.Execute(  );

    // [154] Function call CfDivide
    func_154.inputA = 100F;
    func_154.inputB = func_188.output;
    func_154.Execute(  );

    // [156] Function call CfMultiply
    func_156.input[0] = func_150.output;
    func_156.input[1] = func_154.output;
    func_156.Execute(  );

    // [158] Function call CfMultiply
    func_158.input[0] = func_152.output;
    func_158.input[1] = func_154.output;
    func_158.Execute(  );

    // [236] Function call CfCompare2
    func_236.inputA = CmStep_Controller_input_84;
    func_236.inputB = func_156.output;
    func_236.Execute(  );

    // [161] Function call CfCompare1 ("next stage off")
    func_161.inputA = CmStep_Controller_input_84;
    func_161.inputB = func_158.output;
    func_161.Execute(  );

    // [184] Function call CfSubtract
    func_184.input[0] = func_290.output;
    func_184.input[1] = 1F;
    func_184.Execute(  );

    // [238] Function call CfLastValue
    func_238.input = func_290.output;
    func_238.Execute(  );

    // [239] Function call CfCompare1
    func_239.inputA = func_238.outputLast;
    func_239.inputB = func_238.outputCurrent;
    func_239.Execute(  );

    // [241] Function call CfMonoflop
    func_241.input = BooleanToFloat(func_239.outputGreater);
    func_241.Execute( env, parameterOffset + 6 );

    // [243] Function call CfNot
    func_243.input = func_241.output;
    func_243.Execute(  );

    // [214] Function call CfAnd
    func_214.input[0] = func_229.output;
    func_214.input[1] = func_236.outputEqualOrGreater;
    func_214.Execute(  );

    // [170] Function call CfInputMultiplexer ("increment")
    func_170.inputSelect = BooleanToInt(func_214.outputAND);
    func_170.input[1-1] = func_290.output;
    func_170.input[2-1] = func_150.output;
    func_170.Execute(  );

    // [245] Function call CfAnd
    func_245.input[0] = func_161.outputLess;
    func_245.input[1] = func_243.output;
    func_245.Execute(  );

    // [168] Function call CfInputMultiplexer ("decrement")
    func_168.inputSelect = BooleanToInt(func_245.outputAND);
    func_168.input[1-1] = func_170.output;
    func_168.input[2-1] = func_184.output;
    func_168.Execute(  );

    // [290] Function call CfInputMultiplexer
    func_290.inputSelect = BooleanToInt(CmStep_Controller_input_292);
    func_290.input[1-1] = 0F;
    func_290.input[2-1] = func_168.output;
    func_290.Execute(  );

    // [299] Function call CfIdt
    func_299.input = func_290.output;
    func_299.Execute(  );
    CmStep_Controller_output_262 = func_299.output[0];

  }
// macro register which are written multiple times
// macro inputs
public boolean CmStep_Controller_input_292; // Release
public float CmStep_Controller_input_84; // HeatControl
// macro outputs
public float CmStep_Controller_output_262; // ActStage
// helper functions
private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }

// class variables
protected CfIdt func_233 = new CfIdt();
protected CfIdt func_250 = new CfIdt();
protected CfLastValue func_217 = new CfLastValue();
protected CfCompare1 func_219 = new CfCompare1();
protected CfMonoflop func_228 = new CfMonoflop();
protected CfNot func_229 = new CfNot();
protected CfAddition func_150 = new CfAddition();
protected CfDivide func_148 = new CfDivide();
protected CfAddition func_188 = new CfAddition();
protected CfSubtract func_152 = new CfSubtract();
protected CfDivide func_154 = new CfDivide();
protected CfMultiply func_156 = new CfMultiply();
protected CfMultiply func_158 = new CfMultiply();
protected CfCompare2 func_236 = new CfCompare2();
protected CfCompare1 func_161 = new CfCompare1();
protected CfSubtract func_184 = new CfSubtract();
protected CfLastValue func_238 = new CfLastValue();
protected CfCompare1 func_239 = new CfCompare1();
protected CfMonoflop func_241 = new CfMonoflop();
protected CfNot func_243 = new CfNot();
protected CfAnd func_214 = new CfAnd();
protected CfInputMultiplexer func_170 = new CfInputMultiplexer();
protected CfAnd func_245 = new CfAnd();
protected CfInputMultiplexer func_168 = new CfInputMultiplexer();
protected CfInputMultiplexer func_290 = new CfInputMultiplexer();
protected CfIdt func_299 = new CfIdt();

// default constructor
public CmStep_Controller()
{
}

  public void Start()
  {
    func_217.Start();
    func_228.Start();
    func_238.Start();
    func_241.Start();
  }
}
