/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:41
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicgeneral;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    LIN_LinearChar_5points
Macro id:      5974239586916762256
Macro version: 19
Last change:   07.02.2018 - 09:09
Access Level:  2
Inputs:
  [1] X
  [2] X1
  [3] Y1
  [4] X2
  [5] Y2
  [6] X3
  [7] Y3
  [8] X4
  [9] Y4
  [10] X5
  [11] Y5
Outputs:
  [1] Y
Parameter:
  [1] SYS-01: define characteristics breakpoints
  [2] SYS-02: number of breakpoints
  [3] CHR-01: X1
  [4] CHR-02: Y1
  [5] CHR-03: X2
  [6] CHR-04: Y2
  [7] CHR-05: X3
  [8] CHR-06: Y3
  [9] CHR-07: X4
  [10] CHR-08: Y4
  [11] CHR-09: X5
  [12] CHR-10: Y5
Description:
The "LIN_LinearChar_5points" macro converts a non-linear signal into partially linearized signal with 4 linear segments and 5 breaking points (5 pairs of parameters).

The macro can linearize the input characteristics using a set of 10 parameters or 10 analog input values.

================================================================================*/

public class BCmLIN_LinearChar_5points
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmLIN_LinearChar_5points_output_12().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmLIN_LinearChar_5points_output_12().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmLIN_LinearChar_5points_output_12().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [53] Function call CfInputMultiplexer
    func_53.inputSelect = FloatToInt((float) getCmLIN_LinearChar_5points_parameter_13());
    func_53.input[1-1] = (float) getCmLIN_LinearChar_5points_parameter_15();
    func_53.input[2-1] = (float) getCmLIN_LinearChar_5points_input_2().getValue();
    func_53.Execute(  );

    // [55] Function call CfInputMultiplexer
    func_55.inputSelect = FloatToInt((float) getCmLIN_LinearChar_5points_parameter_13());
    func_55.input[1-1] = (float) getCmLIN_LinearChar_5points_parameter_16();
    func_55.input[2-1] = (float) getCmLIN_LinearChar_5points_input_3().getValue();
    func_55.Execute(  );

    // [56] Function call CfInputMultiplexer
    func_56.inputSelect = FloatToInt((float) getCmLIN_LinearChar_5points_parameter_13());
    func_56.input[1-1] = (float) getCmLIN_LinearChar_5points_parameter_17();
    func_56.input[2-1] = (float) getCmLIN_LinearChar_5points_input_4().getValue();
    func_56.Execute(  );

    // [57] Function call CfInputMultiplexer
    func_57.inputSelect = FloatToInt((float) getCmLIN_LinearChar_5points_parameter_13());
    func_57.input[1-1] = (float) getCmLIN_LinearChar_5points_parameter_18();
    func_57.input[2-1] = (float) getCmLIN_LinearChar_5points_input_5().getValue();
    func_57.Execute(  );

    // [58] Function call CfInputMultiplexer
    func_58.inputSelect = FloatToInt((float) getCmLIN_LinearChar_5points_parameter_13());
    func_58.input[1-1] = (float) getCmLIN_LinearChar_5points_parameter_19();
    func_58.input[2-1] = (float) getCmLIN_LinearChar_5points_input_6().getValue();
    func_58.Execute(  );

    // [59] Function call CfInputMultiplexer
    func_59.inputSelect = FloatToInt((float) getCmLIN_LinearChar_5points_parameter_13());
    func_59.input[1-1] = (float) getCmLIN_LinearChar_5points_parameter_20();
    func_59.input[2-1] = (float) getCmLIN_LinearChar_5points_input_7().getValue();
    func_59.Execute(  );

    // [62] Function call CfInputMultiplexer
    func_62.inputSelect = FloatToInt((float) getCmLIN_LinearChar_5points_parameter_13());
    func_62.input[1-1] = (float) getCmLIN_LinearChar_5points_parameter_21();
    func_62.input[2-1] = (float) getCmLIN_LinearChar_5points_input_8().getValue();
    func_62.Execute(  );

    // [63] Function call CfInputMultiplexer
    func_63.inputSelect = FloatToInt((float) getCmLIN_LinearChar_5points_parameter_13());
    func_63.input[1-1] = (float) getCmLIN_LinearChar_5points_parameter_22();
    func_63.input[2-1] = (float) getCmLIN_LinearChar_5points_input_9().getValue();
    func_63.Execute(  );

    // [66] Function call CfInputMultiplexer
    func_66.inputSelect = FloatToInt((float) getCmLIN_LinearChar_5points_parameter_13());
    func_66.input[1-1] = (float) getCmLIN_LinearChar_5points_parameter_23();
    func_66.input[2-1] = (float) getCmLIN_LinearChar_5points_input_10().getValue();
    func_66.Execute(  );

    // [67] Function call CfInputMultiplexer
    func_67.inputSelect = FloatToInt((float) getCmLIN_LinearChar_5points_parameter_13());
    func_67.input[1-1] = (float) getCmLIN_LinearChar_5points_parameter_24();
    func_67.input[2-1] = (float) getCmLIN_LinearChar_5points_input_11().getValue();
    func_67.Execute(  );

    // [25] Function call CfLinearConverter
    func_25.inputValue = (float) getCmLIN_LinearChar_5points_input_1().getValue();
    func_25.inputInLimit1 = func_53.output;
    func_25.inputInLimit2 = func_56.output;
    func_25.inputOutLimit1 = func_55.output;
    func_25.inputOutLimit2 = func_57.output;
    func_25.Execute(  );

    // [121] Function call CfCompare1
    func_121.inputA = (float) getCmLIN_LinearChar_5points_input_1().getValue();
    func_121.inputB = func_53.output;
    func_121.Execute(  );

    // [125] Function call CfAddition
    func_125.input[0] = BooleanToFloat(func_121.outputGreater);
    func_125.input[1] = BooleanToFloat(func_121.outputGreater);
    func_125.Execute(  );

    // [27] Function call CfLinearConverter
    func_27.inputValue = (float) getCmLIN_LinearChar_5points_input_1().getValue();
    func_27.inputInLimit1 = func_56.output;
    func_27.inputInLimit2 = func_58.output;
    func_27.inputOutLimit1 = func_57.output;
    func_27.inputOutLimit2 = func_59.output;
    func_27.Execute(  );

    // [73] Function call CfCompare1
    func_73.inputA = (float) getCmLIN_LinearChar_5points_input_1().getValue();
    func_73.inputB = func_56.output;
    func_73.Execute(  );

    // [75] Function call CfInputMultiplexer
    func_75.inputSelect = BooleanToInt(func_73.outputGreater);
    func_75.input[1-1] = 0F;
    func_75.input[2-1] = func_27.output;
    func_75.Execute(  );

    // [104] Function call CfMultiply
    func_104.input[0] = BooleanToFloat(func_73.outputGreater);
    func_104.input[1] = 3F;
    func_104.Execute(  );

    // [31] Function call CfLinearConverter
    func_31.inputValue = (float) getCmLIN_LinearChar_5points_input_1().getValue();
    func_31.inputInLimit1 = func_58.output;
    func_31.inputInLimit2 = func_62.output;
    func_31.inputOutLimit1 = func_59.output;
    func_31.inputOutLimit2 = func_63.output;
    func_31.Execute(  );

    // [80] Function call CfCompare1
    func_80.inputA = (float) getCmLIN_LinearChar_5points_input_1().getValue();
    func_80.inputB = func_58.output;
    func_80.Execute(  );

    // [79] Function call CfInputMultiplexer
    func_79.inputSelect = BooleanToInt(func_80.outputGreater);
    func_79.input[1-1] = 0F;
    func_79.input[2-1] = func_31.output;
    func_79.Execute(  );

    // [102] Function call CfMultiply
    func_102.input[0] = BooleanToFloat(func_80.outputGreater);
    func_102.input[1] = 4F;
    func_102.Execute(  );

    // [29] Function call CfLinearConverter
    func_29.inputValue = (float) getCmLIN_LinearChar_5points_input_1().getValue();
    func_29.inputInLimit1 = func_62.output;
    func_29.inputInLimit2 = func_66.output;
    func_29.inputOutLimit1 = func_63.output;
    func_29.inputOutLimit2 = func_67.output;
    func_29.Execute(  );

    // [85] Function call CfCompare1
    func_85.inputA = (float) getCmLIN_LinearChar_5points_input_1().getValue();
    func_85.inputB = func_62.output;
    func_85.Execute(  );

    // [83] Function call CfInputMultiplexer
    func_83.inputSelect = BooleanToInt(func_85.outputGreater);
    func_83.input[1-1] = 0F;
    func_83.input[2-1] = func_29.output;
    func_83.Execute(  );

    // [101] Function call CfMultiply
    func_101.input[0] = BooleanToFloat(func_85.outputGreater);
    func_101.input[1] = 5F;
    func_101.Execute(  );

    // [118] Function call CfMaximum
    func_118.input[0] = func_101.output;
    func_118.input[1] = func_102.output;
    func_118.input[2] = func_104.output;
    func_118.input[3] = func_125.output;
    func_118.Execute(  );

    // [98] Function call CfMinimum
    func_98.input[0] = (float) getCmLIN_LinearChar_5points_parameter_14();
    func_98.input[1] = func_118.output;
    func_98.Execute(  );

    // [37] Function call CfInputMultiplexer
    func_37.inputSelect = FloatToInt(func_98.output);
    func_37.input[1-1] = func_25.output;
    func_37.input[2-1] = 0F;
    func_37.input[3-1] = func_25.output;
    func_37.input[4-1] = func_75.output;
    func_37.input[5-1] = func_79.output;
    func_37.input[6-1] = func_83.output;
    func_37.Execute(  );
    setCmLIN_LinearChar_5points_output_12(func_37.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// Y
  public static final Property CmLIN_LinearChar_5points_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmLIN_LinearChar_5points_output_12() { return (BStatusNumeric) get(CmLIN_LinearChar_5points_output_12); }
  public void setCmLIN_LinearChar_5points_output_12(BStatusNumeric v) { set(CmLIN_LinearChar_5points_output_12,v,null); }
  public void setCmLIN_LinearChar_5points_output_12(float v) { getCmLIN_LinearChar_5points_output_12().setValue(v); }

  // macro parameter
// SYS-01: define characteristics breakpoints
  public static final Property CmLIN_LinearChar_5points_parameter_13 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmLIN_LinearChar_5points_parameter_13() { return getDouble(CmLIN_LinearChar_5points_parameter_13); }
  public void setCmLIN_LinearChar_5points_parameter_13(double v) { setDouble(CmLIN_LinearChar_5points_parameter_13,v,null); }
// SYS-02: number of breakpoints
  public static final Property CmLIN_LinearChar_5points_parameter_14 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(5)), BFacets.make(BFacets.MIN, BDouble.make(2)) ));
  public double getCmLIN_LinearChar_5points_parameter_14() { return getDouble(CmLIN_LinearChar_5points_parameter_14); }
  public void setCmLIN_LinearChar_5points_parameter_14(double v) { setDouble(CmLIN_LinearChar_5points_parameter_14,v,null); }
// CHR-01: X1
  public static final Property CmLIN_LinearChar_5points_parameter_15 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1E+07)), BFacets.make(BFacets.MIN, BDouble.make(-1E+07)) ));
  public double getCmLIN_LinearChar_5points_parameter_15() { return getDouble(CmLIN_LinearChar_5points_parameter_15); }
  public void setCmLIN_LinearChar_5points_parameter_15(double v) { setDouble(CmLIN_LinearChar_5points_parameter_15,v,null); }
// CHR-02: Y1
  public static final Property CmLIN_LinearChar_5points_parameter_16 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1E+07)), BFacets.make(BFacets.MIN, BDouble.make(-1E+07)) ));
  public double getCmLIN_LinearChar_5points_parameter_16() { return getDouble(CmLIN_LinearChar_5points_parameter_16); }
  public void setCmLIN_LinearChar_5points_parameter_16(double v) { setDouble(CmLIN_LinearChar_5points_parameter_16,v,null); }
// CHR-03: X2
  public static final Property CmLIN_LinearChar_5points_parameter_17 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1E+07)), BFacets.make(BFacets.MIN, BDouble.make(-1E+07)) ));
  public double getCmLIN_LinearChar_5points_parameter_17() { return getDouble(CmLIN_LinearChar_5points_parameter_17); }
  public void setCmLIN_LinearChar_5points_parameter_17(double v) { setDouble(CmLIN_LinearChar_5points_parameter_17,v,null); }
// CHR-04: Y2
  public static final Property CmLIN_LinearChar_5points_parameter_18 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1E+07)), BFacets.make(BFacets.MIN, BDouble.make(-1E+07)) ));
  public double getCmLIN_LinearChar_5points_parameter_18() { return getDouble(CmLIN_LinearChar_5points_parameter_18); }
  public void setCmLIN_LinearChar_5points_parameter_18(double v) { setDouble(CmLIN_LinearChar_5points_parameter_18,v,null); }
// CHR-05: X3
  public static final Property CmLIN_LinearChar_5points_parameter_19 = newProperty( 0, BDouble.make( 4 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1E+07)), BFacets.make(BFacets.MIN, BDouble.make(-1E+07)) ));
  public double getCmLIN_LinearChar_5points_parameter_19() { return getDouble(CmLIN_LinearChar_5points_parameter_19); }
  public void setCmLIN_LinearChar_5points_parameter_19(double v) { setDouble(CmLIN_LinearChar_5points_parameter_19,v,null); }
// CHR-06: Y3
  public static final Property CmLIN_LinearChar_5points_parameter_20 = newProperty( 0, BDouble.make( 80 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1E+07)), BFacets.make(BFacets.MIN, BDouble.make(-1E+07)) ));
  public double getCmLIN_LinearChar_5points_parameter_20() { return getDouble(CmLIN_LinearChar_5points_parameter_20); }
  public void setCmLIN_LinearChar_5points_parameter_20(double v) { setDouble(CmLIN_LinearChar_5points_parameter_20,v,null); }
// CHR-07: X4
  public static final Property CmLIN_LinearChar_5points_parameter_21 = newProperty( 0, BDouble.make( 7 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1E+07)), BFacets.make(BFacets.MIN, BDouble.make(-1E+07)) ));
  public double getCmLIN_LinearChar_5points_parameter_21() { return getDouble(CmLIN_LinearChar_5points_parameter_21); }
  public void setCmLIN_LinearChar_5points_parameter_21(double v) { setDouble(CmLIN_LinearChar_5points_parameter_21,v,null); }
// CHR-08: Y4
  public static final Property CmLIN_LinearChar_5points_parameter_22 = newProperty( 0, BDouble.make( 95 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1E+07)), BFacets.make(BFacets.MIN, BDouble.make(-1E+07)) ));
  public double getCmLIN_LinearChar_5points_parameter_22() { return getDouble(CmLIN_LinearChar_5points_parameter_22); }
  public void setCmLIN_LinearChar_5points_parameter_22(double v) { setDouble(CmLIN_LinearChar_5points_parameter_22,v,null); }
// CHR-09: X5
  public static final Property CmLIN_LinearChar_5points_parameter_23 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1E+07)), BFacets.make(BFacets.MIN, BDouble.make(-1E+07)) ));
  public double getCmLIN_LinearChar_5points_parameter_23() { return getDouble(CmLIN_LinearChar_5points_parameter_23); }
  public void setCmLIN_LinearChar_5points_parameter_23(double v) { setDouble(CmLIN_LinearChar_5points_parameter_23,v,null); }
// CHR-10: Y5
  public static final Property CmLIN_LinearChar_5points_parameter_24 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1E+07)), BFacets.make(BFacets.MIN, BDouble.make(-1E+07)) ));
  public double getCmLIN_LinearChar_5points_parameter_24() { return getDouble(CmLIN_LinearChar_5points_parameter_24); }
  public void setCmLIN_LinearChar_5points_parameter_24(double v) { setDouble(CmLIN_LinearChar_5points_parameter_24,v,null); }

  // macro inputs
// X
  public static final Property CmLIN_LinearChar_5points_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmLIN_LinearChar_5points_input_1() { return (BStatusNumeric) get(CmLIN_LinearChar_5points_input_1); }
  public void setCmLIN_LinearChar_5points_input_1(BStatusNumeric v) { set(CmLIN_LinearChar_5points_input_1,v,null); }
  public void setCmLIN_LinearChar_5points_input_1(float v) { getCmLIN_LinearChar_5points_input_1().setValue(v); }
// X1
  public static final Property CmLIN_LinearChar_5points_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmLIN_LinearChar_5points_input_2() { return (BStatusNumeric) get(CmLIN_LinearChar_5points_input_2); }
  public void setCmLIN_LinearChar_5points_input_2(BStatusNumeric v) { set(CmLIN_LinearChar_5points_input_2,v,null); }
  public void setCmLIN_LinearChar_5points_input_2(float v) { getCmLIN_LinearChar_5points_input_2().setValue(v); }
// Y1
  public static final Property CmLIN_LinearChar_5points_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmLIN_LinearChar_5points_input_3() { return (BStatusNumeric) get(CmLIN_LinearChar_5points_input_3); }
  public void setCmLIN_LinearChar_5points_input_3(BStatusNumeric v) { set(CmLIN_LinearChar_5points_input_3,v,null); }
  public void setCmLIN_LinearChar_5points_input_3(float v) { getCmLIN_LinearChar_5points_input_3().setValue(v); }
// X2
  public static final Property CmLIN_LinearChar_5points_input_4 = newProperty( Flags.SUMMARY, new BStatusNumeric( 2 ), null);
  public BStatusNumeric getCmLIN_LinearChar_5points_input_4() { return (BStatusNumeric) get(CmLIN_LinearChar_5points_input_4); }
  public void setCmLIN_LinearChar_5points_input_4(BStatusNumeric v) { set(CmLIN_LinearChar_5points_input_4,v,null); }
  public void setCmLIN_LinearChar_5points_input_4(float v) { getCmLIN_LinearChar_5points_input_4().setValue(v); }
// Y2
  public static final Property CmLIN_LinearChar_5points_input_5 = newProperty( Flags.SUMMARY, new BStatusNumeric( 60 ), null);
  public BStatusNumeric getCmLIN_LinearChar_5points_input_5() { return (BStatusNumeric) get(CmLIN_LinearChar_5points_input_5); }
  public void setCmLIN_LinearChar_5points_input_5(BStatusNumeric v) { set(CmLIN_LinearChar_5points_input_5,v,null); }
  public void setCmLIN_LinearChar_5points_input_5(float v) { getCmLIN_LinearChar_5points_input_5().setValue(v); }
// X3
  public static final Property CmLIN_LinearChar_5points_input_6 = newProperty( Flags.SUMMARY, new BStatusNumeric( 4 ), null);
  public BStatusNumeric getCmLIN_LinearChar_5points_input_6() { return (BStatusNumeric) get(CmLIN_LinearChar_5points_input_6); }
  public void setCmLIN_LinearChar_5points_input_6(BStatusNumeric v) { set(CmLIN_LinearChar_5points_input_6,v,null); }
  public void setCmLIN_LinearChar_5points_input_6(float v) { getCmLIN_LinearChar_5points_input_6().setValue(v); }
// Y3
  public static final Property CmLIN_LinearChar_5points_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 80 ), null);
  public BStatusNumeric getCmLIN_LinearChar_5points_input_7() { return (BStatusNumeric) get(CmLIN_LinearChar_5points_input_7); }
  public void setCmLIN_LinearChar_5points_input_7(BStatusNumeric v) { set(CmLIN_LinearChar_5points_input_7,v,null); }
  public void setCmLIN_LinearChar_5points_input_7(float v) { getCmLIN_LinearChar_5points_input_7().setValue(v); }
// X4
  public static final Property CmLIN_LinearChar_5points_input_8 = newProperty( Flags.SUMMARY, new BStatusNumeric( 7 ), null);
  public BStatusNumeric getCmLIN_LinearChar_5points_input_8() { return (BStatusNumeric) get(CmLIN_LinearChar_5points_input_8); }
  public void setCmLIN_LinearChar_5points_input_8(BStatusNumeric v) { set(CmLIN_LinearChar_5points_input_8,v,null); }
  public void setCmLIN_LinearChar_5points_input_8(float v) { getCmLIN_LinearChar_5points_input_8().setValue(v); }
// Y4
  public static final Property CmLIN_LinearChar_5points_input_9 = newProperty( Flags.SUMMARY, new BStatusNumeric( 95 ), null);
  public BStatusNumeric getCmLIN_LinearChar_5points_input_9() { return (BStatusNumeric) get(CmLIN_LinearChar_5points_input_9); }
  public void setCmLIN_LinearChar_5points_input_9(BStatusNumeric v) { set(CmLIN_LinearChar_5points_input_9,v,null); }
  public void setCmLIN_LinearChar_5points_input_9(float v) { getCmLIN_LinearChar_5points_input_9().setValue(v); }
// X5
  public static final Property CmLIN_LinearChar_5points_input_10 = newProperty( Flags.SUMMARY, new BStatusNumeric( 10 ), null);
  public BStatusNumeric getCmLIN_LinearChar_5points_input_10() { return (BStatusNumeric) get(CmLIN_LinearChar_5points_input_10); }
  public void setCmLIN_LinearChar_5points_input_10(BStatusNumeric v) { set(CmLIN_LinearChar_5points_input_10,v,null); }
  public void setCmLIN_LinearChar_5points_input_10(float v) { getCmLIN_LinearChar_5points_input_10().setValue(v); }
// Y5
  public static final Property CmLIN_LinearChar_5points_input_11 = newProperty( Flags.SUMMARY, new BStatusNumeric( 100 ), null);
  public BStatusNumeric getCmLIN_LinearChar_5points_input_11() { return (BStatusNumeric) get(CmLIN_LinearChar_5points_input_11); }
  public void setCmLIN_LinearChar_5points_input_11(BStatusNumeric v) { set(CmLIN_LinearChar_5points_input_11,v,null); }
  public void setCmLIN_LinearChar_5points_input_11(float v) { getCmLIN_LinearChar_5points_input_11().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.03 [19] 07.02.2018-09:09").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5974239586916762256").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmLIN_LinearChar_5points.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }

  // class variables
  protected CfInputMultiplexer func_53 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_55 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_56 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_57 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_58 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_59 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_62 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_63 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_66 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_67 = new CfInputMultiplexer();
  protected CfLinearConverter func_25 = new CfLinearConverter();
  protected CfCompare1 func_121 = new CfCompare1();
  protected CfAddition func_125 = new CfAddition();
  protected CfLinearConverter func_27 = new CfLinearConverter();
  protected CfCompare1 func_73 = new CfCompare1();
  protected CfInputMultiplexer func_75 = new CfInputMultiplexer();
  protected CfMultiply func_104 = new CfMultiply();
  protected CfLinearConverter func_31 = new CfLinearConverter();
  protected CfCompare1 func_80 = new CfCompare1();
  protected CfInputMultiplexer func_79 = new CfInputMultiplexer();
  protected CfMultiply func_102 = new CfMultiply();
  protected CfLinearConverter func_29 = new CfLinearConverter();
  protected CfCompare1 func_85 = new CfCompare1();
  protected CfInputMultiplexer func_83 = new CfInputMultiplexer();
  protected CfMultiply func_101 = new CfMultiply();
  protected CfMaximum func_118 = new CfMaximum();
  protected CfMinimum func_98 = new CfMinimum();
  protected CfInputMultiplexer func_37 = new CfInputMultiplexer();

  // default constructor
  public BCmLIN_LinearChar_5points()
  {
    func_118.configure(4);
    func_37.configure(7);
  }

  public void Start()
  {
  }
}
