/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:41
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicgeneral;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    RSA_AHUManSwitchNordic
Macro id:      5974664951803936982
Macro version: 20
Last change:   11.06.2015 - 15:00
Access Level:  2
Inputs:
  [1] OnLow
  [2] OnHigh
  [3] Auto
Outputs:
  [1] ManSwCond
  [2] ManSwCond_MSt
  [3] Reset
Parameter:
  [1] RST-01: reset alarms
  [2] ABF-01 anti-beat filter - delay time
Description:
The macro "RSA_AHUManSwitchNordic" provides a manual overrides signal for air handling units. It can be used for 1 or 2 staged- and variable speed fans
It transforms three digital inputs into a manual override signal for the air handling plant strategy.


================================================================================*/

public class BCmRSA_AHUManSwitchNordic
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmRSA_AHUManSwitchNordic_output_4().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmRSA_AHUManSwitchNordic_output_4().setStatus(BStatus.disabled);
    getCmRSA_AHUManSwitchNordic_output_5().setStatus(BStatus.disabled);
    getCmRSA_AHUManSwitchNordic_output_6().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmRSA_AHUManSwitchNordic_output_4().setStatus(BStatus.ok);
    getCmRSA_AHUManSwitchNordic_output_5().setStatus(BStatus.ok);
    getCmRSA_AHUManSwitchNordic_output_6().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [19] Macro call CmIDT05
    func_19.CmIDT05_input_1 = (float) getCmRSA_AHUManSwitchNordic_parameter_8();
    func_19.CmIDT05_input_2 = (float) getCmRSA_AHUManSwitchNordic_parameter_8();
    func_19.CmIDT05_input_3 = (float) getCmRSA_AHUManSwitchNordic_parameter_8();
    func_19.CmIDT05_input_4 = func_60.output;
    func_19.CmIDT05_input_5 = func_34.output;
    func_19.Execute(  );
    setParameter(0, func_19.CmIDT05_output_21);
    setParameter(2, func_19.CmIDT05_output_22);
    setParameter(4, func_19.CmIDT05_output_23);
    setCmRSA_AHUManSwitchNordic_output_4(func_19.CmIDT05_output_24);
    setCmRSA_AHUManSwitchNordic_output_5(func_19.CmIDT05_output_25);

    // [86] Function call CfAddition
    func_86.input[0] = (float) getCmRSA_AHUManSwitchNordic_parameter_8();
    func_86.input[1] = 1F;
    func_86.Execute(  );

    // [78] Function call CfIdt
    func_78.input = func_86.output;
    func_78.Execute(  );
    setParameter(1, func_78.output[0]);
    setParameter(3, func_78.output[1]);
    setParameter(5, func_78.output[2]);

    // [79] Function call CfDelayOnOff
    func_79.input = getCmRSA_AHUManSwitchNordic_input_1().getValue();
    func_79.Execute( this, 0 );

    // [80] Function call CfDelayOnOff
    func_80.input = getCmRSA_AHUManSwitchNordic_input_3().getValue();
    func_80.Execute( this, 2 );

    // [82] Function call CfDelayOnOff
    func_82.input = getCmRSA_AHUManSwitchNordic_input_2().getValue();
    func_82.Execute( this, 4 );

    // [58] Function call CfMultiply
    func_58.input[0] = BooleanToFloat(func_80.output);
    func_58.input[1] = 2F;
    func_58.Execute(  );

    // [59] Function call CfMultiply
    func_59.input[0] = BooleanToFloat(func_82.output);
    func_59.input[1] = 4F;
    func_59.Execute(  );

    // [61] Function call CfAddition
    func_61.input[0] = BooleanToFloat(func_79.output);
    func_61.input[1] = func_58.output;
    func_61.input[2] = func_59.output;
    func_61.Execute(  );

    // [60] Function call CfInputMultiplexer
    func_60.inputSelect = FloatToInt(func_61.output);
    func_60.input[1-1] = 0F;
    func_60.input[2-1] = 1F;
    func_60.input[3-1] = 2F;
    func_60.input[4-1] = 1F;
    func_60.input[5-1] = 3F;
    func_60.input[6-1] = 1F;
    func_60.input[7-1] = 2F;
    func_60.input[8-1] = 1F;
    func_60.Execute(  );

    // [34] Function call CfAddition
    func_34.input[0] = func_60.output;
    func_34.input[1] = 1F;
    func_34.Execute(  );

    // [66] Function call CfIdt
    func_66.input = (float) getCmRSA_AHUManSwitchNordic_parameter_7();
    func_66.Execute(  );
    setParameter(6, func_66.output[0]);

    // [68] Function call CfNot
    func_68.input = FloatToBoolean(func_60.output);
    func_68.Execute(  );

    // [72] Function call CfIdt
    func_72.input = 5F;
    func_72.Execute(  );
    setParameter(7, func_72.output[0]);

    // [87] Function call CfCompare1
    func_87.inputA = 0.9F;
    func_87.inputB = (float) getCmRSA_AHUManSwitchNordic_parameter_7();
    func_87.Execute(  );

    // [94] Function call CfAnd
    func_94.input[0] = func_68.output;
    func_94.input[1] = func_87.outputLess;
    func_94.Execute(  );

    // [63] Function call CfDelay
    func_63.inputA = func_94.outputAND;
    func_63.inputB = func_94.outputAND;
    func_63.Execute( this, 6 );

    // [74] Function call CfMonoflop
    func_74.input = BooleanToFloat(func_63.outputDelayedA);
    func_74.Execute( this, 7 );
    setCmRSA_AHUManSwitchNordic_output_6(func_74.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    10F, 10F, 10F, 10F, 10F, 10F, 10F, 1F,
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// ManSwCond
  public static final Property CmRSA_AHUManSwitchNordic_output_4 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmRSA_AHUManSwitchNordic_output_4() { return (BStatusNumeric) get(CmRSA_AHUManSwitchNordic_output_4); }
  public void setCmRSA_AHUManSwitchNordic_output_4(BStatusNumeric v) { set(CmRSA_AHUManSwitchNordic_output_4,v,null); }
  public void setCmRSA_AHUManSwitchNordic_output_4(float v) { getCmRSA_AHUManSwitchNordic_output_4().setValue(v); }
// ManSwCond_MSt
  public static final Property CmRSA_AHUManSwitchNordic_output_5 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmRSA_AHUManSwitchNordic_output_5() { return (BStatusNumeric) get(CmRSA_AHUManSwitchNordic_output_5); }
  public void setCmRSA_AHUManSwitchNordic_output_5(BStatusNumeric v) { set(CmRSA_AHUManSwitchNordic_output_5,v,null); }
  public void setCmRSA_AHUManSwitchNordic_output_5(float v) { getCmRSA_AHUManSwitchNordic_output_5().setValue(v); }
// Reset
  public static final Property CmRSA_AHUManSwitchNordic_output_6 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmRSA_AHUManSwitchNordic_output_6() { return (BStatusBoolean) get(CmRSA_AHUManSwitchNordic_output_6); }
  public void setCmRSA_AHUManSwitchNordic_output_6(BStatusBoolean v) { set(CmRSA_AHUManSwitchNordic_output_6,v,null); }
  public void setCmRSA_AHUManSwitchNordic_output_6(boolean v) { getCmRSA_AHUManSwitchNordic_output_6().setValue(v); }

  // macro parameter
// RST-01: reset alarms
  public static final Property CmRSA_AHUManSwitchNordic_parameter_7 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmRSA_AHUManSwitchNordic_parameter_7() { return getDouble(CmRSA_AHUManSwitchNordic_parameter_7); }
  public void setCmRSA_AHUManSwitchNordic_parameter_7(double v) { setDouble(CmRSA_AHUManSwitchNordic_parameter_7,v,null); }
// ABF-01 anti-beat filter - delay time
  public static final Property CmRSA_AHUManSwitchNordic_parameter_8 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmRSA_AHUManSwitchNordic_parameter_8() { return getDouble(CmRSA_AHUManSwitchNordic_parameter_8); }
  public void setCmRSA_AHUManSwitchNordic_parameter_8(double v) { setDouble(CmRSA_AHUManSwitchNordic_parameter_8,v,null); }

  // macro inputs
// OnLow
  public static final Property CmRSA_AHUManSwitchNordic_input_1 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmRSA_AHUManSwitchNordic_input_1() { return (BStatusBoolean) get(CmRSA_AHUManSwitchNordic_input_1); }
  public void setCmRSA_AHUManSwitchNordic_input_1(BStatusBoolean v) { set(CmRSA_AHUManSwitchNordic_input_1,v,null); }
  public void setCmRSA_AHUManSwitchNordic_input_1(boolean v) { getCmRSA_AHUManSwitchNordic_input_1().setValue(v); }
// OnHigh
  public static final Property CmRSA_AHUManSwitchNordic_input_3 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmRSA_AHUManSwitchNordic_input_3() { return (BStatusBoolean) get(CmRSA_AHUManSwitchNordic_input_3); }
  public void setCmRSA_AHUManSwitchNordic_input_3(BStatusBoolean v) { set(CmRSA_AHUManSwitchNordic_input_3,v,null); }
  public void setCmRSA_AHUManSwitchNordic_input_3(boolean v) { getCmRSA_AHUManSwitchNordic_input_3().setValue(v); }
// Auto
  public static final Property CmRSA_AHUManSwitchNordic_input_2 = newProperty( Flags.SUMMARY, new BStatusBoolean( false, BStatus.nullStatus), null);
  public BStatusBoolean getCmRSA_AHUManSwitchNordic_input_2() { return (BStatusBoolean) get(CmRSA_AHUManSwitchNordic_input_2); }
  public void setCmRSA_AHUManSwitchNordic_input_2(BStatusBoolean v) { set(CmRSA_AHUManSwitchNordic_input_2,v,null); }
  public void setCmRSA_AHUManSwitchNordic_input_2(boolean v) { getCmRSA_AHUManSwitchNordic_input_2().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.01 [20] 11.06.2015-15:00").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5974664951803936982").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmRSA_AHUManSwitchNordic.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmIDT05 func_19 = new CmIDT05();
  protected CfAddition func_86 = new CfAddition();
  protected CfIdt func_78 = new CfIdt();
  protected CfDelayOnOff func_79 = new CfDelayOnOff();
  protected CfDelayOnOff func_80 = new CfDelayOnOff();
  protected CfDelayOnOff func_82 = new CfDelayOnOff();
  protected CfMultiply func_58 = new CfMultiply();
  protected CfMultiply func_59 = new CfMultiply();
  protected CfAddition func_61 = new CfAddition();
  protected CfInputMultiplexer func_60 = new CfInputMultiplexer();
  protected CfAddition func_34 = new CfAddition();
  protected CfIdt func_66 = new CfIdt();
  protected CfNot func_68 = new CfNot();
  protected CfIdt func_72 = new CfIdt();
  protected CfCompare1 func_87 = new CfCompare1();
  protected CfAnd func_94 = new CfAnd();
  protected CfDelay func_63 = new CfDelay();
  protected CfMonoflop func_74 = new CfMonoflop();

  // default constructor
  public BCmRSA_AHUManSwitchNordic()
  {
    func_78.configure(3);
    func_61.configure(3);
    func_60.configure(9);
  }

  public void Start()
  {
    func_19.Start();
    func_79.Start();
    func_80.Start();
    func_82.Start();
    func_63.Start();
    func_74.Start();
  }
}
