/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:41
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicgeneral;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    SWM_SummerWinterMode
Macro id:      5974274782494982965
Macro version: 22
Last change:   11.06.2015 - 15:00
Access Level:  2
Inputs:
  [1] SummerWinterMode
  [2] FilteredOATemp
  [3] OATLimitHeating
  [4] OATLimitCooling
  [5] SummerStartDate
  [6] SummerEndDate
  [7] WinterStartDate
  [8] WinterEndDate
Outputs:
  [1] Summer
  [2] Winter
  [3] HVAC_Mode
  [4] OATLimitHeating
  [5] OATLimitCooling
Parameter:
  [1] SYS-01: define heating limits mode
  [2] OAT-01: OAT limit heating
  [3] OAT-02: OAT limit cooling
  [4] SUM-01: summer start date
  [5] SUM-02: summer end date
  [6] WIN-01: winter start date
  [7] WIN-02: winter end date
Description:
The "SWM_SummerWinterMode" macro provides summer, winter and HVACMode signals to enable heating and cooling. 

Summer and winter modes can be switched using

- the input switch 
- outdoor temperature limits 
- based on date ranges 

The analog inputs values fro dates and outdoor temperature limits are an alternative, if you have to adjust these values with another BACnet device, since BACnet does not support parameters.

================================================================================*/

public class BCmSWM_SummerWinterMode
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmSWM_SummerWinterMode_output_9().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmSWM_SummerWinterMode_output_9().setStatus(BStatus.disabled);
    getCmSWM_SummerWinterMode_output_10().setStatus(BStatus.disabled);
    getCmSWM_SummerWinterMode_output_11().setStatus(BStatus.disabled);
    getCmSWM_SummerWinterMode_output_12().setStatus(BStatus.disabled);
    getCmSWM_SummerWinterMode_output_13().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmSWM_SummerWinterMode_output_9().setStatus(BStatus.ok);
    getCmSWM_SummerWinterMode_output_10().setStatus(BStatus.ok);
    getCmSWM_SummerWinterMode_output_11().setStatus(BStatus.ok);
    getCmSWM_SummerWinterMode_output_12().setStatus(BStatus.ok);
    getCmSWM_SummerWinterMode_output_13().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [43] Macro call CmIDT05
    func_43.CmIDT05_input_1 = 1F;
    func_43.CmIDT05_input_2 = 2F;
    func_43.CmIDT05_input_3 = func_76.CmSWM_Parameter_switch_output_76;
    func_43.CmIDT05_input_4 = func_76.CmSWM_Parameter_switch_output_77;
    func_43.CmIDT05_input_5 = 2F;
    func_43.Execute(  );
    setParameter(7, func_43.CmIDT05_output_21);
    setParameter(8, func_43.CmIDT05_output_22);
    setCmSWM_SummerWinterMode_output_12(func_43.CmIDT05_output_23);
    setCmSWM_SummerWinterMode_output_13(func_43.CmIDT05_output_24);
    setParameter(9, func_43.CmIDT05_output_25);

    // [106] Macro call CmIDT10
    func_106.CmIDT10_input_1 = (float) getCmSWM_SummerWinterMode_parameter_14();
    func_106.CmIDT10_input_2 = (float) getCmSWM_SummerWinterMode_parameter_15();
    func_106.CmIDT10_input_3 = (float) getCmSWM_SummerWinterMode_parameter_16();
    func_106.CmIDT10_input_4 = (float) getCmSWM_SummerWinterMode_parameter_17();
    func_106.CmIDT10_input_5 = (float) getCmSWM_SummerWinterMode_parameter_18();
    func_106.CmIDT10_input_6 = (float) getCmSWM_SummerWinterMode_parameter_19();
    func_106.CmIDT10_input_7 = (float) getCmSWM_SummerWinterMode_parameter_20();
    func_106.CmIDT10_input_8 = 0F;
    func_106.CmIDT10_input_9 = 0F;
    func_106.CmIDT10_input_10 = 0F;
    func_106.Execute(  );
    setParameter(0, func_106.CmIDT10_output_21);
    setParameter(1, func_106.CmIDT10_output_22);
    setParameter(2, func_106.CmIDT10_output_23);
    setParameter(3, func_106.CmIDT10_output_24);
    setParameter(4, func_106.CmIDT10_output_25);
    setParameter(5, func_106.CmIDT10_output_26);
    setParameter(6, func_106.CmIDT10_output_27);

    // [76] Macro call CmSWM_Parameter_switch
    func_76.CmSWM_Parameter_switch_input_3 = (float) getCmSWM_SummerWinterMode_input_3().getValue();
    func_76.CmSWM_Parameter_switch_input_4 = (float) getCmSWM_SummerWinterMode_input_4().getValue();
    func_76.CmSWM_Parameter_switch_input_5 = (float) getCmSWM_SummerWinterMode_input_5().getValue();
    func_76.CmSWM_Parameter_switch_input_6 = (float) getCmSWM_SummerWinterMode_input_6().getValue();
    func_76.CmSWM_Parameter_switch_input_7 = (float) getCmSWM_SummerWinterMode_input_7().getValue();
    func_76.CmSWM_Parameter_switch_input_8 = (float) getCmSWM_SummerWinterMode_input_8().getValue();
    func_76.Execute( this, 0 );

    // [92] Function call CfIdt
    func_92.input = IntToFloat(ControlFunction.GetDayAndMonth());
    func_92.Execute(  );

    // [136] Function call CfCompare2
    func_136.inputA = func_92.output[0];
    func_136.inputB = func_76.CmSWM_Parameter_switch_output_78;
    func_136.Execute(  );

    // [137] Function call CfCompare2
    func_137.inputA = func_92.output[0];
    func_137.inputB = func_76.CmSWM_Parameter_switch_output_79;
    func_137.Execute(  );

    // [141] Function call CfCompare2
    func_141.inputA = func_92.output[0];
    func_141.inputB = func_76.CmSWM_Parameter_switch_output_80;
    func_141.Execute(  );

    // [140] Function call CfCompare2
    func_140.inputA = func_92.output[0];
    func_140.inputB = func_76.CmSWM_Parameter_switch_output_81;
    func_140.Execute(  );

    // [23] Function call CfOutputMultiplexer
    func_23.inputSelect = FloatToInt((float) getCmSWM_SummerWinterMode_input_1().getValue());
    func_23.inputValue = 1F;
    func_23.Execute( this, 7 );

    // [37] Function call CfHysteresis
    func_37.inputX = (float) getCmSWM_SummerWinterMode_input_2().getValue();
    func_37.inputW = func_76.CmSWM_Parameter_switch_output_77;
    func_37.Execute( this, 8 );

    // [54] Function call CfHysteresis
    func_54.inputX = func_76.CmSWM_Parameter_switch_output_76;
    func_54.inputW = (float) getCmSWM_SummerWinterMode_input_2().getValue();
    func_54.Execute( this, 9 );

    // [138] Function call CfAnd
    func_138.input[0] = func_136.outputEqualOrGreater;
    func_138.input[1] = func_137.outputEqualOrLess;
    func_138.Execute(  );

    // [159] Function call CfOr
    func_159.input[0] = func_141.outputEqualOrGreater;
    func_159.input[1] = func_140.outputEqualOrLess;
    func_159.Execute(  );

    // [57] Function call CfAnd
    func_57.input[0] = FloatToBoolean(func_23.output[5]);
    func_57.input[1] = func_37.output1;
    func_57.Execute(  );

    // [60] Function call CfAnd
    func_60.input[0] = FloatToBoolean(func_23.output[5]);
    func_60.input[1] = func_54.output1;
    func_60.Execute(  );

    // [87] Function call CfAnd
    func_87.input[0] = FloatToBoolean(func_23.output[6]);
    func_87.input[1] = func_138.outputAND;
    func_87.Execute(  );

    // [88] Function call CfAnd
    func_88.input[0] = FloatToBoolean(func_23.output[6]);
    func_88.input[1] = func_159.outputOR;
    func_88.Execute(  );

    // [31] Function call CfOr
    func_31.input[0] = FloatToBoolean(func_23.output[2]);
    func_31.input[1] = FloatToBoolean(func_23.output[4]);
    func_31.input[2] = func_57.outputAND;
    func_31.input[3] = func_87.outputAND;
    func_31.Execute(  );
    setCmSWM_SummerWinterMode_output_9(func_31.outputOR);

    // [34] Function call CfOr
    func_34.input[0] = FloatToBoolean(func_23.output[3]);
    func_34.input[1] = FloatToBoolean(func_23.output[4]);
    func_34.input[2] = func_60.outputAND;
    func_34.input[3] = func_88.outputAND;
    func_34.Execute(  );
    setCmSWM_SummerWinterMode_output_10(func_34.outputOR);

    // [75] Function call CfInputMultiplexer
    func_75.inputSelect = BooleanToInt(getCmSWM_SummerWinterMode_output_10().getValue());
    func_75.input[1-1] = 1F;
    func_75.input[2-1] = 2F;
    func_75.Execute(  );

    // [72] Function call CfAnd
    func_72.input[0] = getCmSWM_SummerWinterMode_output_9().getValue();
    func_72.input[1] = getCmSWM_SummerWinterMode_output_10().getValue();
    func_72.Execute(  );

    // [74] Function call CfInputMultiplexer
    func_74.inputSelect = BooleanToInt(getCmSWM_SummerWinterMode_output_9().getValue());
    func_74.input[1-1] = func_75.output;
    func_74.input[2-1] = 3F;
    func_74.Execute(  );

    // [73] Function call CfInputMultiplexer
    func_73.inputSelect = BooleanToInt(func_72.outputAND);
    func_73.input[1-1] = func_74.output;
    func_73.input[2-1] = 4F;
    func_73.Execute(  );

    // [35] Function call CfInputMultiplexer
    func_35.inputSelect = FloatToInt((float) getCmSWM_SummerWinterMode_input_1().getValue());
    func_35.input[1-1] = 1F;
    func_35.input[2-1] = 1F;
    func_35.input[3-1] = 3F;
    func_35.input[4-1] = 2F;
    func_35.input[5-1] = 4F;
    func_35.input[6-1] = func_73.output;
    func_35.input[7-1] = func_73.output;
    func_35.Execute(  );
    setCmSWM_SummerWinterMode_output_11(func_35.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    1F, 20F, 14F, 1506F, 1509F, 109F, 3050F, 1F,
    0F, 0F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// Summer
  public static final Property CmSWM_SummerWinterMode_output_9 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSWM_SummerWinterMode_output_9() { return (BStatusBoolean) get(CmSWM_SummerWinterMode_output_9); }
  public void setCmSWM_SummerWinterMode_output_9(BStatusBoolean v) { set(CmSWM_SummerWinterMode_output_9,v,null); }
  public void setCmSWM_SummerWinterMode_output_9(boolean v) { getCmSWM_SummerWinterMode_output_9().setValue(v); }
// Winter
  public static final Property CmSWM_SummerWinterMode_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSWM_SummerWinterMode_output_10() { return (BStatusBoolean) get(CmSWM_SummerWinterMode_output_10); }
  public void setCmSWM_SummerWinterMode_output_10(BStatusBoolean v) { set(CmSWM_SummerWinterMode_output_10,v,null); }
  public void setCmSWM_SummerWinterMode_output_10(boolean v) { getCmSWM_SummerWinterMode_output_10().setValue(v); }
// HVAC_Mode
  public static final Property CmSWM_SummerWinterMode_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSWM_SummerWinterMode_output_11() { return (BStatusNumeric) get(CmSWM_SummerWinterMode_output_11); }
  public void setCmSWM_SummerWinterMode_output_11(BStatusNumeric v) { set(CmSWM_SummerWinterMode_output_11,v,null); }
  public void setCmSWM_SummerWinterMode_output_11(float v) { getCmSWM_SummerWinterMode_output_11().setValue(v); }
// OATLimitHeating
  public static final Property CmSWM_SummerWinterMode_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSWM_SummerWinterMode_output_12() { return (BStatusNumeric) get(CmSWM_SummerWinterMode_output_12); }
  public void setCmSWM_SummerWinterMode_output_12(BStatusNumeric v) { set(CmSWM_SummerWinterMode_output_12,v,null); }
  public void setCmSWM_SummerWinterMode_output_12(float v) { getCmSWM_SummerWinterMode_output_12().setValue(v); }
// OATLimitCooling
  public static final Property CmSWM_SummerWinterMode_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSWM_SummerWinterMode_output_13() { return (BStatusNumeric) get(CmSWM_SummerWinterMode_output_13); }
  public void setCmSWM_SummerWinterMode_output_13(BStatusNumeric v) { set(CmSWM_SummerWinterMode_output_13,v,null); }
  public void setCmSWM_SummerWinterMode_output_13(float v) { getCmSWM_SummerWinterMode_output_13().setValue(v); }

  // macro parameter
// SYS-01: define heating limits mode
  public static final Property CmSWM_SummerWinterMode_parameter_14 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSWM_SummerWinterMode_parameter_14() { return getDouble(CmSWM_SummerWinterMode_parameter_14); }
  public void setCmSWM_SummerWinterMode_parameter_14(double v) { setDouble(CmSWM_SummerWinterMode_parameter_14,v,null); }
// OAT-01: OAT limit heating
  public static final Property CmSWM_SummerWinterMode_parameter_15 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmSWM_SummerWinterMode_parameter_15() { return getDouble(CmSWM_SummerWinterMode_parameter_15); }
  public void setCmSWM_SummerWinterMode_parameter_15(double v) { setDouble(CmSWM_SummerWinterMode_parameter_15,v,null); }
// OAT-02: OAT limit cooling
  public static final Property CmSWM_SummerWinterMode_parameter_16 = newProperty( 0, BDouble.make( 14 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmSWM_SummerWinterMode_parameter_16() { return getDouble(CmSWM_SummerWinterMode_parameter_16); }
  public void setCmSWM_SummerWinterMode_parameter_16(double v) { setDouble(CmSWM_SummerWinterMode_parameter_16,v,null); }
// SUM-01: summer start date
  public static final Property CmSWM_SummerWinterMode_parameter_17 = newProperty( 0, BDouble.make( 1506 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3112)), BFacets.make(BFacets.MIN, BDouble.make(101)) ));
  public double getCmSWM_SummerWinterMode_parameter_17() { return getDouble(CmSWM_SummerWinterMode_parameter_17); }
  public void setCmSWM_SummerWinterMode_parameter_17(double v) { setDouble(CmSWM_SummerWinterMode_parameter_17,v,null); }
// SUM-02: summer end date
  public static final Property CmSWM_SummerWinterMode_parameter_18 = newProperty( 0, BDouble.make( 1509 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3112)), BFacets.make(BFacets.MIN, BDouble.make(101)) ));
  public double getCmSWM_SummerWinterMode_parameter_18() { return getDouble(CmSWM_SummerWinterMode_parameter_18); }
  public void setCmSWM_SummerWinterMode_parameter_18(double v) { setDouble(CmSWM_SummerWinterMode_parameter_18,v,null); }
// WIN-01: winter start date
  public static final Property CmSWM_SummerWinterMode_parameter_19 = newProperty( 0, BDouble.make( 109 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3112)), BFacets.make(BFacets.MIN, BDouble.make(101)) ));
  public double getCmSWM_SummerWinterMode_parameter_19() { return getDouble(CmSWM_SummerWinterMode_parameter_19); }
  public void setCmSWM_SummerWinterMode_parameter_19(double v) { setDouble(CmSWM_SummerWinterMode_parameter_19,v,null); }
// WIN-02: winter end date
  public static final Property CmSWM_SummerWinterMode_parameter_20 = newProperty( 0, BDouble.make( 3005 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3112)), BFacets.make(BFacets.MIN, BDouble.make(101)) ));
  public double getCmSWM_SummerWinterMode_parameter_20() { return getDouble(CmSWM_SummerWinterMode_parameter_20); }
  public void setCmSWM_SummerWinterMode_parameter_20(double v) { setDouble(CmSWM_SummerWinterMode_parameter_20,v,null); }

  // macro inputs
// SummerWinterMode
  public static final Property CmSWM_SummerWinterMode_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmSWM_SummerWinterMode_input_1() { return (BStatusNumeric) get(CmSWM_SummerWinterMode_input_1); }
  public void setCmSWM_SummerWinterMode_input_1(BStatusNumeric v) { set(CmSWM_SummerWinterMode_input_1,v,null); }
  public void setCmSWM_SummerWinterMode_input_1(float v) { getCmSWM_SummerWinterMode_input_1().setValue(v); }
// FilteredOATemp
  public static final Property CmSWM_SummerWinterMode_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmSWM_SummerWinterMode_input_2() { return (BStatusNumeric) get(CmSWM_SummerWinterMode_input_2); }
  public void setCmSWM_SummerWinterMode_input_2(BStatusNumeric v) { set(CmSWM_SummerWinterMode_input_2,v,null); }
  public void setCmSWM_SummerWinterMode_input_2(float v) { getCmSWM_SummerWinterMode_input_2().setValue(v); }
// OATLimitHeating
  public static final Property CmSWM_SummerWinterMode_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 20 ), null);
  public BStatusNumeric getCmSWM_SummerWinterMode_input_3() { return (BStatusNumeric) get(CmSWM_SummerWinterMode_input_3); }
  public void setCmSWM_SummerWinterMode_input_3(BStatusNumeric v) { set(CmSWM_SummerWinterMode_input_3,v,null); }
  public void setCmSWM_SummerWinterMode_input_3(float v) { getCmSWM_SummerWinterMode_input_3().setValue(v); }
// OATLimitCooling
  public static final Property CmSWM_SummerWinterMode_input_4 = newProperty( Flags.SUMMARY, new BStatusNumeric( 14 ), null);
  public BStatusNumeric getCmSWM_SummerWinterMode_input_4() { return (BStatusNumeric) get(CmSWM_SummerWinterMode_input_4); }
  public void setCmSWM_SummerWinterMode_input_4(BStatusNumeric v) { set(CmSWM_SummerWinterMode_input_4,v,null); }
  public void setCmSWM_SummerWinterMode_input_4(float v) { getCmSWM_SummerWinterMode_input_4().setValue(v); }
// SummerStartDate
  public static final Property CmSWM_SummerWinterMode_input_5 = newProperty( Flags.SUMMARY, new BStatusNumeric( 1506 ), null);
  public BStatusNumeric getCmSWM_SummerWinterMode_input_5() { return (BStatusNumeric) get(CmSWM_SummerWinterMode_input_5); }
  public void setCmSWM_SummerWinterMode_input_5(BStatusNumeric v) { set(CmSWM_SummerWinterMode_input_5,v,null); }
  public void setCmSWM_SummerWinterMode_input_5(float v) { getCmSWM_SummerWinterMode_input_5().setValue(v); }
// SummerEndDate
  public static final Property CmSWM_SummerWinterMode_input_6 = newProperty( Flags.SUMMARY, new BStatusNumeric( 1509 ), null);
  public BStatusNumeric getCmSWM_SummerWinterMode_input_6() { return (BStatusNumeric) get(CmSWM_SummerWinterMode_input_6); }
  public void setCmSWM_SummerWinterMode_input_6(BStatusNumeric v) { set(CmSWM_SummerWinterMode_input_6,v,null); }
  public void setCmSWM_SummerWinterMode_input_6(float v) { getCmSWM_SummerWinterMode_input_6().setValue(v); }
// WinterStartDate
  public static final Property CmSWM_SummerWinterMode_input_7 = newProperty( Flags.SUMMARY, new BStatusNumeric( 109 ), null);
  public BStatusNumeric getCmSWM_SummerWinterMode_input_7() { return (BStatusNumeric) get(CmSWM_SummerWinterMode_input_7); }
  public void setCmSWM_SummerWinterMode_input_7(BStatusNumeric v) { set(CmSWM_SummerWinterMode_input_7,v,null); }
  public void setCmSWM_SummerWinterMode_input_7(float v) { getCmSWM_SummerWinterMode_input_7().setValue(v); }
// WinterEndDate
  public static final Property CmSWM_SummerWinterMode_input_8 = newProperty( Flags.SUMMARY, new BStatusNumeric( 3005 ), null);
  public BStatusNumeric getCmSWM_SummerWinterMode_input_8() { return (BStatusNumeric) get(CmSWM_SummerWinterMode_input_8); }
  public void setCmSWM_SummerWinterMode_input_8(BStatusNumeric v) { set(CmSWM_SummerWinterMode_input_8,v,null); }
  public void setCmSWM_SummerWinterMode_input_8(float v) { getCmSWM_SummerWinterMode_input_8().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.01 [22] 11.06.2015-15:00").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "5974274782494982965").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmSWM_SummerWinterMode.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   IntToFloat    (int     value) { return (float) value; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CmIDT05 func_43 = new CmIDT05();
  protected CmIDT10 func_106 = new CmIDT10();
  protected CmSWM_Parameter_switch func_76 = new CmSWM_Parameter_switch();
  protected CfIdt func_92 = new CfIdt();
  protected CfCompare2 func_136 = new CfCompare2();
  protected CfCompare2 func_137 = new CfCompare2();
  protected CfCompare2 func_141 = new CfCompare2();
  protected CfCompare2 func_140 = new CfCompare2();
  protected CfOutputMultiplexer func_23 = new CfOutputMultiplexer();
  protected CfHysteresis func_37 = new CfHysteresis();
  protected CfHysteresis func_54 = new CfHysteresis();
  protected CfAnd func_138 = new CfAnd();
  protected CfOr func_159 = new CfOr();
  protected CfAnd func_57 = new CfAnd();
  protected CfAnd func_60 = new CfAnd();
  protected CfAnd func_87 = new CfAnd();
  protected CfAnd func_88 = new CfAnd();
  protected CfOr func_31 = new CfOr();
  protected CfOr func_34 = new CfOr();
  protected CfInputMultiplexer func_75 = new CfInputMultiplexer();
  protected CfAnd func_72 = new CfAnd();
  protected CfInputMultiplexer func_74 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_73 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_35 = new CfInputMultiplexer();

  // default constructor
  public BCmSWM_SummerWinterMode()
  {
    func_23.configure(7);
    func_31.configure(4);
    func_34.configure(4);
    func_35.configure(8);
  }

  public void Start()
  {
    func_43.Start();
    func_106.Start();
    func_76.Start();
    func_37.Start();
    func_54.Start();
  }
}
