/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:41
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.nordicgeneral;

import cl.hvac.base.*;

/*==============================================================================
Macro name:    SWM_Parameter_switch
Macro id:      5974295425177354331
Macro version: 14
Last change:   30.01.2014 - 12:52
Access Level:  2
Inputs:
  [1] OATLimitHeating
  [2] OATLimitCooling
  [3] SummerStartDate
  [4] SummerEndDate
  [5] WinterStartDate
  [6] WinterEndDate
Outputs:
  [1] OAT01
  [2] OAT02
  [3] SUM01
  [4] SUM02
  [5] WIN01
  [6] WIN02
Parameter:
  [1] SYS-01: define heating limits mode
  [2] OAT-01: OAT limit heating
  [3] OAT-02: OAT limit cooling
  [4] SUM-01: summer start date
  [5] SUM-02: summer end date
  [6] WIN-01: winter start date
  [7] WIN-02: winter end date
Description:

================================================================================*/

public class CmSWM_Parameter_switch
{
  void Execute(IEnvironment env, int parameterOffset)

  {
    // [50] Function call CfInputMultiplexer
    func_50.inputSelect = FloatToInt(env.getParameter(parameterOffset));
    func_50.input[1-1] = env.getParameter(parameterOffset + 1);
    func_50.input[2-1] = CmSWM_Parameter_switch_input_3;
    func_50.Execute(  );
    CmSWM_Parameter_switch_output_76 = func_50.output;

    // [51] Function call CfInputMultiplexer
    func_51.inputSelect = FloatToInt(env.getParameter(parameterOffset));
    func_51.input[1-1] = env.getParameter(parameterOffset + 2);
    func_51.input[2-1] = CmSWM_Parameter_switch_input_4;
    func_51.Execute(  );
    CmSWM_Parameter_switch_output_77 = func_51.output;

    // [82] Function call CfInputMultiplexer
    func_82.inputSelect = FloatToInt(env.getParameter(parameterOffset));
    func_82.input[1-1] = env.getParameter(parameterOffset + 3);
    func_82.input[2-1] = CmSWM_Parameter_switch_input_5;
    func_82.Execute(  );

    // [90] Macro call CmSwitch_Date
    func_90.CmSwitch_Date_input_1 = func_82.output;
    func_90.Execute(  );
    CmSWM_Parameter_switch_output_78 = func_90.CmSwitch_Date_output_2;

    // [88] Function call CfInputMultiplexer
    func_88.inputSelect = FloatToInt(env.getParameter(parameterOffset));
    func_88.input[1-1] = env.getParameter(parameterOffset + 4);
    func_88.input[2-1] = CmSWM_Parameter_switch_input_6;
    func_88.Execute(  );

    // [93] Macro call CmSwitch_Date
    func_93.CmSwitch_Date_input_1 = func_88.output;
    func_93.Execute(  );
    CmSWM_Parameter_switch_output_79 = func_93.CmSwitch_Date_output_2;

    // [86] Function call CfInputMultiplexer
    func_86.inputSelect = FloatToInt(env.getParameter(parameterOffset));
    func_86.input[1-1] = env.getParameter(parameterOffset + 5);
    func_86.input[2-1] = CmSWM_Parameter_switch_input_7;
    func_86.Execute(  );

    // [94] Macro call CmSwitch_Date
    func_94.CmSwitch_Date_input_1 = func_86.output;
    func_94.Execute(  );
    CmSWM_Parameter_switch_output_80 = func_94.CmSwitch_Date_output_2;

    // [84] Function call CfInputMultiplexer
    func_84.inputSelect = FloatToInt(env.getParameter(parameterOffset));
    func_84.input[1-1] = env.getParameter(parameterOffset + 6);
    func_84.input[2-1] = CmSWM_Parameter_switch_input_8;
    func_84.Execute(  );

    // [95] Macro call CmSwitch_Date
    func_95.CmSwitch_Date_input_1 = func_84.output;
    func_95.Execute(  );
    CmSWM_Parameter_switch_output_81 = func_95.CmSwitch_Date_output_2;

  }
// macro register which are written multiple times
// macro inputs
public float CmSWM_Parameter_switch_input_3; // OATLimitHeating
public float CmSWM_Parameter_switch_input_4; // OATLimitCooling
public float CmSWM_Parameter_switch_input_5; // SummerStartDate
public float CmSWM_Parameter_switch_input_6; // SummerEndDate
public float CmSWM_Parameter_switch_input_7; // WinterStartDate
public float CmSWM_Parameter_switch_input_8; // WinterEndDate
// macro outputs
public float CmSWM_Parameter_switch_output_76; // OAT01
public float CmSWM_Parameter_switch_output_77; // OAT02
public float CmSWM_Parameter_switch_output_78; // SUM01
public float CmSWM_Parameter_switch_output_79; // SUM02
public float CmSWM_Parameter_switch_output_80; // WIN01
public float CmSWM_Parameter_switch_output_81; // WIN02
// helper functions
private int     FloatToInt    (float   value) { return (int) value;   }

// class variables
protected CfInputMultiplexer func_50 = new CfInputMultiplexer();
protected CfInputMultiplexer func_51 = new CfInputMultiplexer();
protected CfInputMultiplexer func_82 = new CfInputMultiplexer();
protected CmSwitch_Date func_90 = new CmSwitch_Date();
protected CfInputMultiplexer func_88 = new CfInputMultiplexer();
protected CmSwitch_Date func_93 = new CmSwitch_Date();
protected CfInputMultiplexer func_86 = new CfInputMultiplexer();
protected CmSwitch_Date func_94 = new CmSwitch_Date();
protected CfInputMultiplexer func_84 = new CfInputMultiplexer();
protected CmSwitch_Date func_95 = new CmSwitch_Date();

// default constructor
public CmSWM_Parameter_switch()
{
}

  public void Start()
  {
    func_90.Start();
    func_93.Start();
    func_94.Start();
    func_95.Start();
  }
}
