/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:44
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.room_control;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    PRCC_PreCtrlClg
Macro id:      6324201957039800391
Macro version: 42
Last change:   07.03.2018 - 08:33
Access Level:  2
Inputs:
  [1] CoolTemp
  [2] HumRefRoom
  [3] TempRefRoom
  [4] HumidSwitch
  [5] MaxClgVlvPos
  [6] TherminalLoad
  [7] FiltOATemp
  [8] HVAC_Mode
  [9] HolidaySw
Outputs:
  [1] CoolValveControl
  [2] CoolPmpCmd
  [3] ChillerCmd
  [4] ApplicModeXL10
  [5] ApplicModeIRM
  [6] DewPoint
  [7] CalcCoolSp
Parameter:
  [1] SYS-01: 4-pipe system=1
  [2] SYS-02: cooling control type
  [3] CSP-01: low outside air temp limit
  [4] CSP-02: low cooling setpoint
  [5] CSP-03: high outside air temp limit
  [6] CSP-04: high cooling setpoint
  [7] DEWP-01: dew point offset
  [8] DEWP-02: ambient air pressure
  [9] DEWP-03: setpoint step
  [10] DEWP-04: setpoint step interval
  [11] DEWP-05: set point down-ramp
  [12] CLTC-01: P-band heating pre-control
  [13] CLTC-02: I-time heating pre-control
  [14] CLTC-03: D-time heating pre-control
  [15] CH-01: min runtime chiller
  [16] CH-02: min off time chiller
  [17] CPMP-01: switch on delay heating pump
  [18] CPMP-02: switch off delay heating pump
Description:
The pre-control provides:
•Cooling or changeover pre-control with optional pump, valve outputs. 
For changeover control you need both the cooling and the heating pre-control macros.
•Options to connect external bus systems to the pre-control circuit.

================================================================================*/

public class BCmPRCC_PreCtrlClg
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmPRCC_PreCtrlClg_output_10().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmPRCC_PreCtrlClg_output_10().setStatus(BStatus.disabled);
    getCmPRCC_PreCtrlClg_output_11().setStatus(BStatus.disabled);
    getCmPRCC_PreCtrlClg_output_547().setStatus(BStatus.disabled);
    getCmPRCC_PreCtrlClg_output_13().setStatus(BStatus.disabled);
    getCmPRCC_PreCtrlClg_output_735().setStatus(BStatus.disabled);
    getCmPRCC_PreCtrlClg_output_546().setStatus(BStatus.disabled);
    getCmPRCC_PreCtrlClg_output_15().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmPRCC_PreCtrlClg_output_10().setStatus(BStatus.ok);
    getCmPRCC_PreCtrlClg_output_11().setStatus(BStatus.ok);
    getCmPRCC_PreCtrlClg_output_547().setStatus(BStatus.ok);
    getCmPRCC_PreCtrlClg_output_13().setStatus(BStatus.ok);
    getCmPRCC_PreCtrlClg_output_735().setStatus(BStatus.ok);
    getCmPRCC_PreCtrlClg_output_546().setStatus(BStatus.ok);
    getCmPRCC_PreCtrlClg_output_15().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [437] Function call CfCompare1
    func_437.inputA = (float) getCmPRCC_PreCtrlClg_input_6().getValue();
    func_437.inputB = 4F;
    func_437.Execute(  );

    // [432] Function call CfCompare1
    func_432.inputA = (float) getCmPRCC_PreCtrlClg_input_6().getValue();
    func_432.inputB = 3F;
    func_432.Execute(  );

    // [429] Function call CfAnd
    func_429.input[0] = func_437.outputEqual;
    func_429.input[1] = FloatToBoolean((float) getCmPRCC_PreCtrlClg_parameter_17());
    func_429.Execute(  );

    // [447] Function call CfNot
    func_447.input = getCmPRCC_PreCtrlClg_input_7().getValue();
    func_447.Execute(  );

    // [427] Function call CfOr
    func_427.input[0] = func_429.outputAND;
    func_427.input[1] = func_432.outputEqual;
    func_427.Execute(  );

    // [446] Function call CfAnd
    func_446.input[0] = func_427.outputOR;
    func_446.input[1] = func_447.output;
    func_446.Execute(  );

    // [425] Function call CfInputMultiplexer
    func_425.inputSelect = FloatToInt((float) getCmPRCC_PreCtrlClg_input_6().getValue());
    func_425.input[1-1] = 6F;
    func_425.input[2-1] = 6F;
    func_425.input[3-1] = 1F;
    func_425.input[4-1] = 3F;
    func_425.input[5-1] = 0F;
    func_425.input[6-1] = 6F;
    func_425.Execute(  );

    // [802] Function call CfNot
    func_802.input = FloatToBoolean((float) getCmPRCC_PreCtrlClg_parameter_17());
    func_802.Execute(  );

    // [801] Function call CfAnd
    func_801.input[0] = func_437.outputEqual;
    func_801.input[1] = func_802.output;
    func_801.Execute(  );

    // [798] Function call CfOr
    func_798.input[0] = func_801.outputAND;
    func_798.input[1] = getCmPRCC_PreCtrlClg_input_7().getValue();
    func_798.Execute(  );

    // [443] Function call CfInputMultiplexer
    func_443.inputSelect = BooleanToInt(func_798.outputOR);
    func_443.input[1-1] = func_425.output;
    func_443.input[2-1] = 6F;
    func_443.Execute(  );
    setCmPRCC_PreCtrlClg_output_13(func_443.output);

    // [736] Function call CfInputMultiplexer
    func_736.inputSelect = FloatToInt((float) getCmPRCC_PreCtrlClg_output_13().getValue());
    func_736.input[1-1] = 4F;
    func_736.input[2-1] = 3F;
    func_736.input[3-1] = 1F;
    func_736.input[4-1] = 2F;
    func_736.input[5-1] = 1F;
    func_736.input[6-1] = 1F;
    func_736.input[7-1] = 1F;
    func_736.Execute(  );
    setCmPRCC_PreCtrlClg_output_735(func_736.output);

    // [463] Function call CfMaximum
    func_463.input[0] = (float) getCmPRCC_PreCtrlClg_input_460().getValue();
    func_463.input[1] = 0F;
    func_463.input[2] = (float) getCmPRCC_PreCtrlClg_input_3().getValue();
    func_463.Execute(  );

    // [461] Function call CfMinimum
    func_461.input[0] = func_463.output;
    func_461.input[1] = 100F;
    func_461.Execute(  );

    // [55] Function call CfIdt
    func_55.input = func_461.output;
    func_55.Execute(  );

    // [59] Function call CfIdt
    func_59.input = 6F;
    func_59.Execute(  );
    setParameter(0, func_59.output[0]);

    // [60] Function call CfHysteresis
    func_60.inputX = func_461.output;
    func_60.inputW = 8F;
    func_60.Execute( this, 0 );

    // [577] Function call CfIdt
    func_577.input = 1F;
    func_577.Execute(  );
    setParameter(1, func_577.output[0]);

    // [602] Function call CfNot
    func_602.input = FloatToBoolean(func_582.output[0]);
    func_602.Execute(  );

    // [581] Function call CfDifferential
    func_581.input = BooleanToFloat(func_602.output);
    func_581.Execute( this, 1 );

    // [582] Function call CfIdt
    func_582.input = BooleanToFloat(func_602.output);
    func_582.Execute(  );

    // [576] Function call CfSubtract ("1/t0")
    func_576.input[0] = func_581.output;
    func_576.input[1] = 0F;
    func_576.Execute(  );

    // [575] Function call CfAbsolute
    func_575.input = func_576.output;
    func_575.Execute(  );

    // [579] Function call CfMultiply
    func_579.input[0] = func_575.outputAbs;
    func_579.input[1] = (float) getCmPRCC_PreCtrlClg_parameter_556();
    func_579.input[2] = 60F;
    func_579.Execute(  );

    // [578] Function call CfMaximum ("mku")
    func_578.input[0] = func_579.output;
    func_578.input[1] = 0.001F;
    func_578.Execute(  );

    // [580] Function call CfDivide ("mku")
    func_580.inputA = (float) getCmPRCC_PreCtrlClg_parameter_554();
    func_580.inputB = func_578.output;
    func_580.Execute(  );

    // [682] Function call CfSubtract
    func_682.input[0] = func_695.output;
    func_682.input[1] = func_580.output;
    func_682.Execute(  );

    // [752] Function call CfInputMultiplexer
    func_752.inputSelect = FloatToInt((float) getCmPRCC_PreCtrlClg_parameter_659());
    func_752.input[1-1] = 1F;
    func_752.input[2-1] = BooleanToFloat(getCmPRCC_PreCtrlClg_input_544().getValue());
    func_752.input[3-1] = 1F;
    func_752.Execute(  );

    // [690] Function call CfInputMultiplexer
    func_690.inputSelect = FloatToInt(func_752.output);
    func_690.input[1-1] = func_695.output;
    func_690.input[2-1] = func_682.output;
    func_690.Execute(  );

    // [693] Function call CfAddition
    func_693.input[0] = func_690.output;
    func_693.input[1] = (float) getCmPRCC_PreCtrlClg_parameter_554();
    func_693.Execute(  );

    // [732] Function call CfNot
    func_732.input = func_728.outputDelayedA;
    func_732.Execute(  );

    // [727] Function call CfInputMultiplexer
    func_727.inputSelect = FloatToInt(func_752.output);
    func_727.input[1-1] = BooleanToFloat(func_732.output);
    func_727.input[2-1] = 0F;
    func_727.Execute(  );

    // [730] Function call CfMultiply
    func_730.input[0] = (float) getCmPRCC_PreCtrlClg_parameter_555();
    func_730.input[1] = 60F;
    func_730.Execute(  );

    // [729] Function call CfMaximum
    func_729.input[0] = func_730.output;
    func_729.input[1] = 6F;
    func_729.Execute(  );
    setParameter(2, func_729.output);

    // [728] Function call CfDelay
    func_728.inputA = FloatToBoolean(func_727.output);
    func_728.inputB = FloatToBoolean(func_727.output);
    func_728.Execute( this, 2 );

    // [725] Function call CfAnd
    func_725.input[0] = FloatToBoolean(func_727.output);
    func_725.input[1] = func_726.output;
    func_725.Execute(  );

    // [726] Function call CfNot
    func_726.input = FloatToBoolean(func_727.output);
    func_726.Execute(  );

    // [692] Function call CfInputMultiplexer
    func_692.inputSelect = BooleanToInt(func_725.outputAND);
    func_692.input[1-1] = func_690.output;
    func_692.input[2-1] = func_693.output;
    func_692.Execute(  );

    // [694] Function call CfMaximum
    func_694.input[0] = func_692.output;
    func_694.input[1] = 0F;
    func_694.Execute(  );

    // [695] Function call CfMinimum
    func_695.input[0] = func_694.output;
    func_695.input[1] = 50F;
    func_695.Execute(  );

    // [642] Function call CfAddition
    func_642.input[0] = (float) getCmPRCC_PreCtrlClg_parameter_549();
    func_642.input[1] = (float) getCmPRCC_PreCtrlClg_parameter_551();
    func_642.Execute(  );

    // [643] Function call CfDivide
    func_643.inputA = func_642.output;
    func_643.inputB = 2F;
    func_643.Execute(  );

    // [629] Macro call CmIDT10
    func_629.CmIDT10_input_1 = (float) getCmPRCC_PreCtrlClg_parameter_549();
    func_629.CmIDT10_input_2 = (float) getCmPRCC_PreCtrlClg_parameter_548();
    func_629.CmIDT10_input_3 = (float) getCmPRCC_PreCtrlClg_parameter_550();
    func_629.CmIDT10_input_4 = (float) getCmPRCC_PreCtrlClg_parameter_551();
    func_629.CmIDT10_input_5 = (float) getCmPRCC_PreCtrlClg_parameter_549();
    func_629.CmIDT10_input_6 = (float) getCmPRCC_PreCtrlClg_parameter_551();
    func_629.CmIDT10_input_7 = func_643.output;
    func_629.CmIDT10_input_8 = (float) getCmPRCC_PreCtrlClg_parameter_548();
    func_629.CmIDT10_input_9 = (float) getCmPRCC_PreCtrlClg_parameter_550();
    func_629.CmIDT10_input_10 = 0F;
    func_629.Execute(  );
    setParameter(4, func_629.CmIDT10_output_21);
    setParameter(5, func_629.CmIDT10_output_22);
    setParameter(6, func_629.CmIDT10_output_23);
    setParameter(3, func_629.CmIDT10_output_24);
    setParameter(8, func_629.CmIDT10_output_25);
    setParameter(13, func_629.CmIDT10_output_26);
    setParameter(11, func_629.CmIDT10_output_27);
    setParameter(7, func_629.CmIDT10_output_28);
    setParameter(12, func_629.CmIDT10_output_29);

    // [645] Function call CfAddition
    func_645.input[0] = (float) getCmPRCC_PreCtrlClg_parameter_548();
    func_645.input[1] = (float) getCmPRCC_PreCtrlClg_parameter_550();
    func_645.Execute(  );

    // [646] Function call CfDivide
    func_646.inputA = func_645.output;
    func_646.inputB = 2F;
    func_646.Execute(  );

    // [648] Function call CfIdt
    func_648.input = func_646.output;
    func_648.Execute(  );
    setParameter(9, func_648.output[0]);
    setParameter(10, func_648.output[1]);

    // [614] Function call CfRamp
    func_614.input = (float) getCmPRCC_PreCtrlClg_input_247().getValue();
    func_614.Execute( this, 3 );

    // [605] Function call CfEnthalpy
    func_605.inputOAT = (float) getCmPRCC_PreCtrlClg_input_543().getValue();
    func_605.inputRelHumidity = (float) getCmPRCC_PreCtrlClg_input_542().getValue();
    func_605.inputAirPressure = (float) getCmPRCC_PreCtrlClg_parameter_553();
    func_605.Execute(  );

    // [608] Function call CfDewpoint
    func_608.inputAbsHumidity = func_605.outputAbsHumidity;
    func_608.inputAirPressure = (float) getCmPRCC_PreCtrlClg_parameter_553();
    func_608.Execute(  );

    // [733] Function call CfIdt
    func_733.input = func_608.output;
    func_733.Execute(  );
    setCmPRCC_PreCtrlClg_output_546(func_733.output[0]);

    // [611] Function call CfAddition
    func_611.input[0] = (float) getCmPRCC_PreCtrlClg_parameter_552();
    func_611.input[1] = func_608.output;
    func_611.Execute(  );

    // [658] Function call CfCompare1
    func_658.inputA = (float) getCmPRCC_PreCtrlClg_parameter_659();
    func_658.inputB = 0F;
    func_658.Execute(  );

    // [664] Function call CfCompare1
    func_664.inputA = (float) getCmPRCC_PreCtrlClg_parameter_659();
    func_664.inputB = 2F;
    func_664.Execute(  );

    // [677] Function call CfCompare1
    func_677.inputA = (float) getCmPRCC_PreCtrlClg_parameter_659();
    func_677.inputB = 1F;
    func_677.Execute(  );

    // [679] Function call CfAddition
    func_679.input[0] = func_614.output;
    func_679.input[1] = func_695.output;
    func_679.Execute(  );

    // [656] Function call CfMultiply
    func_656.input[0] = BooleanToFloat(func_658.outputEqual);
    func_656.input[1] = func_614.output;
    func_656.Execute(  );

    // [662] Function call CfMultiply
    func_662.input[0] = BooleanToFloat(func_664.outputEqual);
    func_662.input[1] = func_611.output;
    func_662.Execute(  );

    // [676] Function call CfMultiply
    func_676.input[0] = BooleanToFloat(func_677.outputEqual);
    func_676.input[1] = func_679.output;
    func_676.Execute(  );

    // [655] Function call CfMaximum
    func_655.input[0] = func_656.output;
    func_655.input[1] = func_662.output;
    func_655.input[2] = func_676.output;
    func_655.Execute(  );
    setCmPRCC_PreCtrlClg_output_15(func_655.output);

    // [327] Function call CfIdt
    func_327.input = (float) getCmPRCC_PreCtrlClg_parameter_25();
    func_327.Execute(  );
    setParameter(14, func_327.output[0]);

    // [328] Function call CfIdt
    func_328.input = (float) getCmPRCC_PreCtrlClg_parameter_26();
    func_328.Execute(  );
    setParameter(16, func_328.output[0]);

    // [329] Function call CfIdt
    func_329.input = (float) getCmPRCC_PreCtrlClg_parameter_27();
    func_329.Execute(  );
    setParameter(15, func_329.output[0]);

    // [804] Function call CfPidPlus
    func_804.inputX = (float) getCmPRCC_PreCtrlClg_output_15().getValue();
    func_804.inputW = (float) getCmPRCC_PreCtrlClg_input_1().getValue();
    func_804.inputIntegralOn = true;
    func_804.Execute( this, 14 );

    // [279] Function call CfIdt
    func_279.input = func_55.output[0];
    func_279.Execute(  );

    // [282] Function call CfIdt
    func_282.input = 6F;
    func_282.Execute(  );
    setParameter(19, func_282.output[0]);

    // [283] Function call CfHysteresis
    func_283.inputX = func_279.output[0];
    func_283.inputW = 8F;
    func_283.Execute( this, 19 );

    // [412] Function call CfIdt
    func_412.input = (float) getCmPRCC_PreCtrlClg_parameter_29();
    func_412.Execute(  );
    setParameter(20, func_412.output[0]);

    // [414] Function call CfIdt
    func_414.input = (float) getCmPRCC_PreCtrlClg_parameter_30();
    func_414.Execute(  );
    setParameter(21, func_414.output[0]);

    // [737] Function call CfCompare1
    func_737.inputA = (float) getCmPRCC_PreCtrlClg_input_1().getValue();
    func_737.inputB = 999F;
    func_737.Execute(  );

    // [741] Function call CfInputMultiplexer
    func_741.inputSelect = BooleanToInt(func_737.outputLess);
    func_741.input[1-1] = 100F;
    func_741.input[2-1] = func_804.output;
    func_741.Execute(  );

    // [745] Function call CfAnd
    func_745.input[0] = func_446.outputAND;
    func_745.input[1] = func_60.output1;
    func_745.Execute(  );

    // [491] Function call CfMultiply
    func_491.input[0] = BooleanToFloat(func_745.outputAND);
    func_491.input[1] = func_741.output;
    func_491.Execute(  );
    setCmPRCC_PreCtrlClg_output_10(func_491.output);

    // [486] Function call CfAnd
    func_486.input[0] = func_283.output1;
    func_486.input[1] = func_446.outputAND;
    func_486.Execute(  );

    // [410] Function call CfDelayOnOff
    func_410.input = func_486.outputAND;
    func_410.Execute( this, 20 );
    setCmPRCC_PreCtrlClg_output_11(func_410.output);

    // [557] Function call CfIdt
    func_557.input = 70F;
    func_557.Execute(  );
    setParameter(22, func_557.output[0]);

    // [558] Function call CfHysteresis
    func_558.inputX = (float) getCmPRCC_PreCtrlClg_output_10().getValue();
    func_558.inputW = 80F;
    func_558.Execute( this, 22 );

    // [562] Function call CfAnd
    func_562.input[0] = func_558.output1;
    func_562.input[1] = func_60.output1;
    func_562.input[2] = func_446.outputAND;
    func_562.input[3] = func_767.output;
    func_562.Execute(  );

    // [771] Function call CfIdt
    func_771.input = (float) getCmPRCC_PreCtrlClg_parameter_753();
    func_771.Execute(  );
    setParameter(23, func_771.output[0]);

    // [770] Function call CfMonoflop
    func_770.input = BooleanToFloat(func_562.outputAND);
    func_770.Execute( this, 23 );

    // [773] Function call CfOr
    func_773.input[0] = func_770.output;
    func_773.input[1] = func_562.outputAND;
    func_773.Execute(  );

    // [757] Function call CfNot
    func_757.input = func_773.outputOR;
    func_757.Execute(  );

    // [761] Function call CfIdt
    func_761.input = (float) getCmPRCC_PreCtrlClg_parameter_754();
    func_761.Execute(  );
    setParameter(24, func_761.output[0]);

    // [755] Function call CfMonoflop
    func_755.input = BooleanToFloat(func_757.output);
    func_755.Execute( this, 24 );

    // [767] Function call CfNot
    func_767.input = func_755.output;
    func_767.Execute(  );

    // [788] Function call CfInputMultiplexer
    func_788.inputSelect = BooleanToInt(func_755.output);
    func_788.input[1-1] = BooleanToFloat(func_773.outputOR);
    func_788.input[2-1] = 0F;
    func_788.Execute(  );
    setCmPRCC_PreCtrlClg_output_547(FloatToBoolean(func_788.output));

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 0F, 10F, 0F, 100F, 0F, 100F, 0F,
    0F, 50F, 50F, 50F, 100F, 100F, 100F, 0F,
    24F, 100F, 0F, 0F, 10F, 10F, 0F, 1F,
    1F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// CoolValveControl
  public static final Property CmPRCC_PreCtrlClg_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPRCC_PreCtrlClg_output_10() { return (BStatusNumeric) get(CmPRCC_PreCtrlClg_output_10); }
  public void setCmPRCC_PreCtrlClg_output_10(BStatusNumeric v) { set(CmPRCC_PreCtrlClg_output_10,v,null); }
  public void setCmPRCC_PreCtrlClg_output_10(float v) { getCmPRCC_PreCtrlClg_output_10().setValue(v); }
// CoolPmpCmd
  public static final Property CmPRCC_PreCtrlClg_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPRCC_PreCtrlClg_output_11() { return (BStatusBoolean) get(CmPRCC_PreCtrlClg_output_11); }
  public void setCmPRCC_PreCtrlClg_output_11(BStatusBoolean v) { set(CmPRCC_PreCtrlClg_output_11,v,null); }
  public void setCmPRCC_PreCtrlClg_output_11(boolean v) { getCmPRCC_PreCtrlClg_output_11().setValue(v); }
// ChillerCmd
  public static final Property CmPRCC_PreCtrlClg_output_547 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPRCC_PreCtrlClg_output_547() { return (BStatusBoolean) get(CmPRCC_PreCtrlClg_output_547); }
  public void setCmPRCC_PreCtrlClg_output_547(BStatusBoolean v) { set(CmPRCC_PreCtrlClg_output_547,v,null); }
  public void setCmPRCC_PreCtrlClg_output_547(boolean v) { getCmPRCC_PreCtrlClg_output_547().setValue(v); }
// ApplicModeXL10
  public static final Property CmPRCC_PreCtrlClg_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPRCC_PreCtrlClg_output_13() { return (BStatusNumeric) get(CmPRCC_PreCtrlClg_output_13); }
  public void setCmPRCC_PreCtrlClg_output_13(BStatusNumeric v) { set(CmPRCC_PreCtrlClg_output_13,v,null); }
  public void setCmPRCC_PreCtrlClg_output_13(float v) { getCmPRCC_PreCtrlClg_output_13().setValue(v); }
// ApplicModeIRM
  public static final Property CmPRCC_PreCtrlClg_output_735 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPRCC_PreCtrlClg_output_735() { return (BStatusNumeric) get(CmPRCC_PreCtrlClg_output_735); }
  public void setCmPRCC_PreCtrlClg_output_735(BStatusNumeric v) { set(CmPRCC_PreCtrlClg_output_735,v,null); }
  public void setCmPRCC_PreCtrlClg_output_735(float v) { getCmPRCC_PreCtrlClg_output_735().setValue(v); }
// DewPoint
  public static final Property CmPRCC_PreCtrlClg_output_546 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPRCC_PreCtrlClg_output_546() { return (BStatusNumeric) get(CmPRCC_PreCtrlClg_output_546); }
  public void setCmPRCC_PreCtrlClg_output_546(BStatusNumeric v) { set(CmPRCC_PreCtrlClg_output_546,v,null); }
  public void setCmPRCC_PreCtrlClg_output_546(float v) { getCmPRCC_PreCtrlClg_output_546().setValue(v); }
// CalcCoolSp
  public static final Property CmPRCC_PreCtrlClg_output_15 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPRCC_PreCtrlClg_output_15() { return (BStatusNumeric) get(CmPRCC_PreCtrlClg_output_15); }
  public void setCmPRCC_PreCtrlClg_output_15(BStatusNumeric v) { set(CmPRCC_PreCtrlClg_output_15,v,null); }
  public void setCmPRCC_PreCtrlClg_output_15(float v) { getCmPRCC_PreCtrlClg_output_15().setValue(v); }

  // macro parameter
// SYS-01: 4-pipe system=1
  public static final Property CmPRCC_PreCtrlClg_parameter_17 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPRCC_PreCtrlClg_parameter_17() { return getDouble(CmPRCC_PreCtrlClg_parameter_17); }
  public void setCmPRCC_PreCtrlClg_parameter_17(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_17,v,null); }
// SYS-02: cooling control type
  public static final Property CmPRCC_PreCtrlClg_parameter_659 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPRCC_PreCtrlClg_parameter_659() { return getDouble(CmPRCC_PreCtrlClg_parameter_659); }
  public void setCmPRCC_PreCtrlClg_parameter_659(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_659,v,null); }
// CSP-01: low outside air temp limit
  public static final Property CmPRCC_PreCtrlClg_parameter_548 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmPRCC_PreCtrlClg_parameter_548() { return getDouble(CmPRCC_PreCtrlClg_parameter_548); }
  public void setCmPRCC_PreCtrlClg_parameter_548(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_548,v,null); }
// CSP-02: low cooling setpoint
  public static final Property CmPRCC_PreCtrlClg_parameter_549 = newProperty( 0, BDouble.make( 18 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(2)), BFacets.make(BFacets.MAX, BDouble.make(25)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmPRCC_PreCtrlClg_parameter_549() { return getDouble(CmPRCC_PreCtrlClg_parameter_549); }
  public void setCmPRCC_PreCtrlClg_parameter_549(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_549,v,null); }
// CSP-03: high outside air temp limit
  public static final Property CmPRCC_PreCtrlClg_parameter_550 = newProperty( 0, BDouble.make( 35 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmPRCC_PreCtrlClg_parameter_550() { return getDouble(CmPRCC_PreCtrlClg_parameter_550); }
  public void setCmPRCC_PreCtrlClg_parameter_550(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_550,v,null); }
// CSP-04: high cooling setpoint
  public static final Property CmPRCC_PreCtrlClg_parameter_551 = newProperty( 0, BDouble.make( 12 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(2)), BFacets.make(BFacets.MAX, BDouble.make(25)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmPRCC_PreCtrlClg_parameter_551() { return getDouble(CmPRCC_PreCtrlClg_parameter_551); }
  public void setCmPRCC_PreCtrlClg_parameter_551(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_551,v,null); }
// DEWP-01: dew point offset
  public static final Property CmPRCC_PreCtrlClg_parameter_552 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmPRCC_PreCtrlClg_parameter_552() { return getDouble(CmPRCC_PreCtrlClg_parameter_552); }
  public void setCmPRCC_PreCtrlClg_parameter_552(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_552,v,null); }
// DEWP-02: ambient air pressure
  public static final Property CmPRCC_PreCtrlClg_parameter_553 = newProperty( 0, BDouble.make( 1013 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(800)), BFacets.make(BFacets.MAX, BDouble.make(1100)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("pascal"))));
  public double getCmPRCC_PreCtrlClg_parameter_553() { return getDouble(CmPRCC_PreCtrlClg_parameter_553); }
  public void setCmPRCC_PreCtrlClg_parameter_553(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_553,v,null); }
// DEWP-03: setpoint step
  public static final Property CmPRCC_PreCtrlClg_parameter_554 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmPRCC_PreCtrlClg_parameter_554() { return getDouble(CmPRCC_PreCtrlClg_parameter_554); }
  public void setCmPRCC_PreCtrlClg_parameter_554(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_554,v,null); }
// DEWP-04: setpoint step interval
  public static final Property CmPRCC_PreCtrlClg_parameter_555 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(120)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmPRCC_PreCtrlClg_parameter_555() { return getDouble(CmPRCC_PreCtrlClg_parameter_555); }
  public void setCmPRCC_PreCtrlClg_parameter_555(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_555,v,null); }
// DEWP-05: set point down-ramp
  public static final Property CmPRCC_PreCtrlClg_parameter_556 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(20)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmPRCC_PreCtrlClg_parameter_556() { return getDouble(CmPRCC_PreCtrlClg_parameter_556); }
  public void setCmPRCC_PreCtrlClg_parameter_556(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_556,v,null); }
// CLTC-01: P-band heating pre-control
  public static final Property CmPRCC_PreCtrlClg_parameter_25 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmPRCC_PreCtrlClg_parameter_25() { return getDouble(CmPRCC_PreCtrlClg_parameter_25); }
  public void setCmPRCC_PreCtrlClg_parameter_25(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_25,v,null); }
// CLTC-02: I-time heating pre-control
  public static final Property CmPRCC_PreCtrlClg_parameter_26 = newProperty( 0, BDouble.make( 24 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPRCC_PreCtrlClg_parameter_26() { return getDouble(CmPRCC_PreCtrlClg_parameter_26); }
  public void setCmPRCC_PreCtrlClg_parameter_26(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_26,v,null); }
// CLTC-03: D-time heating pre-control
  public static final Property CmPRCC_PreCtrlClg_parameter_27 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPRCC_PreCtrlClg_parameter_27() { return getDouble(CmPRCC_PreCtrlClg_parameter_27); }
  public void setCmPRCC_PreCtrlClg_parameter_27(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_27,v,null); }
// CH-01: min runtime chiller
  public static final Property CmPRCC_PreCtrlClg_parameter_753 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPRCC_PreCtrlClg_parameter_753() { return getDouble(CmPRCC_PreCtrlClg_parameter_753); }
  public void setCmPRCC_PreCtrlClg_parameter_753(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_753,v,null); }
// CH-02: min off time chiller
  public static final Property CmPRCC_PreCtrlClg_parameter_754 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPRCC_PreCtrlClg_parameter_754() { return getDouble(CmPRCC_PreCtrlClg_parameter_754); }
  public void setCmPRCC_PreCtrlClg_parameter_754(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_754,v,null); }
// CPMP-01: switch on delay heating pump
  public static final Property CmPRCC_PreCtrlClg_parameter_29 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPRCC_PreCtrlClg_parameter_29() { return getDouble(CmPRCC_PreCtrlClg_parameter_29); }
  public void setCmPRCC_PreCtrlClg_parameter_29(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_29,v,null); }
// CPMP-02: switch off delay heating pump
  public static final Property CmPRCC_PreCtrlClg_parameter_30 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPRCC_PreCtrlClg_parameter_30() { return getDouble(CmPRCC_PreCtrlClg_parameter_30); }
  public void setCmPRCC_PreCtrlClg_parameter_30(double v) { setDouble(CmPRCC_PreCtrlClg_parameter_30,v,null); }

  // macro inputs
// CoolTemp
  public static final Property CmPRCC_PreCtrlClg_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmPRCC_PreCtrlClg_input_1() { return (BStatusNumeric) get(CmPRCC_PreCtrlClg_input_1); }
  public void setCmPRCC_PreCtrlClg_input_1(BStatusNumeric v) { set(CmPRCC_PreCtrlClg_input_1,v,null); }
  public void setCmPRCC_PreCtrlClg_input_1(float v) { getCmPRCC_PreCtrlClg_input_1().setValue(v); }
// HumRefRoom
  public static final Property CmPRCC_PreCtrlClg_input_542 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmPRCC_PreCtrlClg_input_542() { return (BStatusNumeric) get(CmPRCC_PreCtrlClg_input_542); }
  public void setCmPRCC_PreCtrlClg_input_542(BStatusNumeric v) { set(CmPRCC_PreCtrlClg_input_542,v,null); }
  public void setCmPRCC_PreCtrlClg_input_542(float v) { getCmPRCC_PreCtrlClg_input_542().setValue(v); }
// TempRefRoom
  public static final Property CmPRCC_PreCtrlClg_input_543 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmPRCC_PreCtrlClg_input_543() { return (BStatusNumeric) get(CmPRCC_PreCtrlClg_input_543); }
  public void setCmPRCC_PreCtrlClg_input_543(BStatusNumeric v) { set(CmPRCC_PreCtrlClg_input_543,v,null); }
  public void setCmPRCC_PreCtrlClg_input_543(float v) { getCmPRCC_PreCtrlClg_input_543().setValue(v); }
// HumidSwitch
  public static final Property CmPRCC_PreCtrlClg_input_544 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmPRCC_PreCtrlClg_input_544() { return (BStatusBoolean) get(CmPRCC_PreCtrlClg_input_544); }
  public void setCmPRCC_PreCtrlClg_input_544(BStatusBoolean v) { set(CmPRCC_PreCtrlClg_input_544,v,null); }
  public void setCmPRCC_PreCtrlClg_input_544(boolean v) { getCmPRCC_PreCtrlClg_input_544().setValue(v); }
// MaxClgVlvPos
  public static final Property CmPRCC_PreCtrlClg_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmPRCC_PreCtrlClg_input_3() { return (BStatusNumeric) get(CmPRCC_PreCtrlClg_input_3); }
  public void setCmPRCC_PreCtrlClg_input_3(BStatusNumeric v) { set(CmPRCC_PreCtrlClg_input_3,v,null); }
  public void setCmPRCC_PreCtrlClg_input_3(float v) { getCmPRCC_PreCtrlClg_input_3().setValue(v); }
// TherminalLoad
  public static final Property CmPRCC_PreCtrlClg_input_460 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmPRCC_PreCtrlClg_input_460() { return (BStatusNumeric) get(CmPRCC_PreCtrlClg_input_460); }
  public void setCmPRCC_PreCtrlClg_input_460(BStatusNumeric v) { set(CmPRCC_PreCtrlClg_input_460,v,null); }
  public void setCmPRCC_PreCtrlClg_input_460(float v) { getCmPRCC_PreCtrlClg_input_460().setValue(v); }
// FiltOATemp
  public static final Property CmPRCC_PreCtrlClg_input_247 = newProperty( Flags.SUMMARY, new BStatusNumeric( 15 ), null);
  public BStatusNumeric getCmPRCC_PreCtrlClg_input_247() { return (BStatusNumeric) get(CmPRCC_PreCtrlClg_input_247); }
  public void setCmPRCC_PreCtrlClg_input_247(BStatusNumeric v) { set(CmPRCC_PreCtrlClg_input_247,v,null); }
  public void setCmPRCC_PreCtrlClg_input_247(float v) { getCmPRCC_PreCtrlClg_input_247().setValue(v); }
// HVAC_Mode
  public static final Property CmPRCC_PreCtrlClg_input_6 = newProperty( Flags.SUMMARY, new BStatusNumeric( 3 ), null);
  public BStatusNumeric getCmPRCC_PreCtrlClg_input_6() { return (BStatusNumeric) get(CmPRCC_PreCtrlClg_input_6); }
  public void setCmPRCC_PreCtrlClg_input_6(BStatusNumeric v) { set(CmPRCC_PreCtrlClg_input_6,v,null); }
  public void setCmPRCC_PreCtrlClg_input_6(float v) { getCmPRCC_PreCtrlClg_input_6().setValue(v); }
// HolidaySw
  public static final Property CmPRCC_PreCtrlClg_input_7 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPRCC_PreCtrlClg_input_7() { return (BStatusBoolean) get(CmPRCC_PreCtrlClg_input_7); }
  public void setCmPRCC_PreCtrlClg_input_7(BStatusBoolean v) { set(CmPRCC_PreCtrlClg_input_7,v,null); }
  public void setCmPRCC_PreCtrlClg_input_7(boolean v) { getCmPRCC_PreCtrlClg_input_7().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.02 [42] 07.03.2018-08:33").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6324201957039800391").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmPRCC_PreCtrlClg.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfCompare1 func_437 = new CfCompare1();
  protected CfCompare1 func_432 = new CfCompare1();
  protected CfAnd func_429 = new CfAnd();
  protected CfNot func_447 = new CfNot();
  protected CfOr func_427 = new CfOr();
  protected CfAnd func_446 = new CfAnd();
  protected CfInputMultiplexer func_425 = new CfInputMultiplexer();
  protected CfNot func_802 = new CfNot();
  protected CfAnd func_801 = new CfAnd();
  protected CfOr func_798 = new CfOr();
  protected CfInputMultiplexer func_443 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_736 = new CfInputMultiplexer();
  protected CfMaximum func_463 = new CfMaximum();
  protected CfMinimum func_461 = new CfMinimum();
  protected CfIdt func_55 = new CfIdt();
  protected CfIdt func_59 = new CfIdt();
  protected CfHysteresis func_60 = new CfHysteresis();
  protected CfIdt func_577 = new CfIdt();
  protected CfNot func_602 = new CfNot();
  protected CfDifferential func_581 = new CfDifferential();
  protected CfIdt func_582 = new CfIdt();
  protected CfSubtract func_576 = new CfSubtract();
  protected CfAbsolute func_575 = new CfAbsolute();
  protected CfMultiply func_579 = new CfMultiply();
  protected CfMaximum func_578 = new CfMaximum();
  protected CfDivide func_580 = new CfDivide();
  protected CfSubtract func_682 = new CfSubtract();
  protected CfInputMultiplexer func_752 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_690 = new CfInputMultiplexer();
  protected CfAddition func_693 = new CfAddition();
  protected CfNot func_732 = new CfNot();
  protected CfInputMultiplexer func_727 = new CfInputMultiplexer();
  protected CfMultiply func_730 = new CfMultiply();
  protected CfMaximum func_729 = new CfMaximum();
  protected CfDelay func_728 = new CfDelay();
  protected CfAnd func_725 = new CfAnd();
  protected CfNot func_726 = new CfNot();
  protected CfInputMultiplexer func_692 = new CfInputMultiplexer();
  protected CfMaximum func_694 = new CfMaximum();
  protected CfMinimum func_695 = new CfMinimum();
  protected CfAddition func_642 = new CfAddition();
  protected CfDivide func_643 = new CfDivide();
  protected CmIDT10 func_629 = new CmIDT10();
  protected CfAddition func_645 = new CfAddition();
  protected CfDivide func_646 = new CfDivide();
  protected CfIdt func_648 = new CfIdt();
  protected CfRamp func_614 = new CfRamp();
  protected CfEnthalpy func_605 = new CfEnthalpy();
  protected CfDewpoint func_608 = new CfDewpoint();
  protected CfIdt func_733 = new CfIdt();
  protected CfAddition func_611 = new CfAddition();
  protected CfCompare1 func_658 = new CfCompare1();
  protected CfCompare1 func_664 = new CfCompare1();
  protected CfCompare1 func_677 = new CfCompare1();
  protected CfAddition func_679 = new CfAddition();
  protected CfMultiply func_656 = new CfMultiply();
  protected CfMultiply func_662 = new CfMultiply();
  protected CfMultiply func_676 = new CfMultiply();
  protected CfMaximum func_655 = new CfMaximum();
  protected CfIdt func_327 = new CfIdt();
  protected CfIdt func_328 = new CfIdt();
  protected CfIdt func_329 = new CfIdt();
  protected CfPidPlus func_804 = new CfPidPlus();
  protected CfIdt func_279 = new CfIdt();
  protected CfIdt func_282 = new CfIdt();
  protected CfHysteresis func_283 = new CfHysteresis();
  protected CfIdt func_412 = new CfIdt();
  protected CfIdt func_414 = new CfIdt();
  protected CfCompare1 func_737 = new CfCompare1();
  protected CfInputMultiplexer func_741 = new CfInputMultiplexer();
  protected CfAnd func_745 = new CfAnd();
  protected CfMultiply func_491 = new CfMultiply();
  protected CfAnd func_486 = new CfAnd();
  protected CfDelayOnOff func_410 = new CfDelayOnOff();
  protected CfIdt func_557 = new CfIdt();
  protected CfHysteresis func_558 = new CfHysteresis();
  protected CfAnd func_562 = new CfAnd();
  protected CfIdt func_771 = new CfIdt();
  protected CfMonoflop func_770 = new CfMonoflop();
  protected CfOr func_773 = new CfOr();
  protected CfNot func_757 = new CfNot();
  protected CfIdt func_761 = new CfIdt();
  protected CfMonoflop func_755 = new CfMonoflop();
  protected CfNot func_767 = new CfNot();
  protected CfInputMultiplexer func_788 = new CfInputMultiplexer();

  // default constructor
  public BCmPRCC_PreCtrlClg()
  {
    func_425.configure(7);
    func_736.configure(8);
    func_463.configure(3);
    func_579.configure(3);
    func_752.configure(4);
    func_648.configure(2);
    func_655.configure(3);
    func_562.configure(4);
  }

  public void Start()
  {
    func_60.Start();
    func_581.Start();
    func_728.Start();
    func_629.Start();
    func_804.Start();
    func_283.Start();
    func_410.Start();
    func_558.Start();
    func_770.Start();
    func_755.Start();
  }
}
