/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:44
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.room_control;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    PRCH_PreCtrlHtg
Macro id:      6320145176364843731
Macro version: 32
Last change:   07.03.2018 - 08:37
Access Level:  2
Inputs:
  [1] HtgFlowTemp
  [2] MaxHtgVlvPos
  [3] TherminalLoad
  [4] FiltOATemp
  [5] HVAC_Mode
  [6] HolidaySw
  [7] CoolValve
  [8] CoolPmpCmd
Outputs:
  [1] HtgValveControl
  [2] HtgPmpCmd
  [3] HeatDemand
  [4] ChgOverCmd
  [5] ApplicModeXL10
  [6] ApplicModeIRM
  [7] CalcRmSp
  [8] CalcHtgSp
Parameter:
  [1] HTD-01: heat demand transmission
  [2] SYS-01: 4-pipe system=1
  [3] RMSP-01: room temperature setpoint for low demand
  [4] RMSP-02: room temperature setpoint for mid demand
  [5] RMSP-03: room temperature setpoint for high demand
  [6] FLT-01: maximum flow temperature limit pre-heating
  [7] HCA-01: heating curve curvature
  [8] HCA-02: heating curve slope
  [9] FLTC-01: P-band heating pre-control
  [10] FLTC-02: I-time heating pre-control
  [11] FLTC-03: D-time heating pre-control
  [12] FLTC-04: heating control switch on delay
  [13] HPMP-01: switch on delay heating pump
  [14] HPMP-02: switch off delay heating pump
  [15] FRZ-01: enable freeze protection
  [16] FRZ-02: flow temp. setpoint frost protection
  [17] FRZ-03: OAT limit frost protection
  [18] FRZ-04: frost protection heating pump runtime for cyclic on
  [19] FRZ-05: frost protection heating pump delay for cyclic off
Description:
The pre-control provides:
•Heating or changeover pre-control with optional pump, valve and
  changeover output for a two pipe system. 
For changeover control you need both the cooling and the heating pre-control macros.
•Freeze protection at low outside air temperatures.
•Options to connect external bus systems to the pre-control circuit.

================================================================================*/

public class BCmPRCH_PreCtrlHtg
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmPRCH_PreCtrlHtg_output_10().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmPRCH_PreCtrlHtg_output_10().setStatus(BStatus.disabled);
    getCmPRCH_PreCtrlHtg_output_11().setStatus(BStatus.disabled);
    getCmPRCH_PreCtrlHtg_output_320().setStatus(BStatus.disabled);
    getCmPRCH_PreCtrlHtg_output_12().setStatus(BStatus.disabled);
    getCmPRCH_PreCtrlHtg_output_13().setStatus(BStatus.disabled);
    getCmPRCH_PreCtrlHtg_output_630().setStatus(BStatus.disabled);
    getCmPRCH_PreCtrlHtg_output_14().setStatus(BStatus.disabled);
    getCmPRCH_PreCtrlHtg_output_15().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmPRCH_PreCtrlHtg_output_10().setStatus(BStatus.ok);
    getCmPRCH_PreCtrlHtg_output_11().setStatus(BStatus.ok);
    getCmPRCH_PreCtrlHtg_output_320().setStatus(BStatus.ok);
    getCmPRCH_PreCtrlHtg_output_12().setStatus(BStatus.ok);
    getCmPRCH_PreCtrlHtg_output_13().setStatus(BStatus.ok);
    getCmPRCH_PreCtrlHtg_output_630().setStatus(BStatus.ok);
    getCmPRCH_PreCtrlHtg_output_14().setStatus(BStatus.ok);
    getCmPRCH_PreCtrlHtg_output_15().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [437] Function call CfCompare1
    func_437.inputA = (float) getCmPRCH_PreCtrlHtg_input_6().getValue();
    func_437.inputB = 4F;
    func_437.Execute(  );

    // [432] Function call CfCompare1
    func_432.inputA = (float) getCmPRCH_PreCtrlHtg_input_6().getValue();
    func_432.inputB = 2F;
    func_432.Execute(  );

    // [429] Function call CfAnd
    func_429.input[0] = func_437.outputEqual;
    func_429.input[1] = FloatToBoolean((float) getCmPRCH_PreCtrlHtg_parameter_17());
    func_429.Execute(  );

    // [447] Function call CfNot
    func_447.input = getCmPRCH_PreCtrlHtg_input_7().getValue();
    func_447.Execute(  );

    // [427] Function call CfOr
    func_427.input[0] = func_429.outputAND;
    func_427.input[1] = func_432.outputEqual;
    func_427.Execute(  );

    // [446] Function call CfAnd
    func_446.input[0] = func_427.outputOR;
    func_446.input[1] = func_447.output;
    func_446.Execute(  );

    // [425] Function call CfInputMultiplexer
    func_425.inputSelect = FloatToInt((float) getCmPRCH_PreCtrlHtg_input_6().getValue());
    func_425.input[1-1] = 6F;
    func_425.input[2-1] = 6F;
    func_425.input[3-1] = 1F;
    func_425.input[4-1] = 3F;
    func_425.input[5-1] = 0F;
    func_425.input[6-1] = 6F;
    func_425.Execute(  );

    // [647] Function call CfNot
    func_647.input = FloatToBoolean((float) getCmPRCH_PreCtrlHtg_parameter_17());
    func_647.Execute(  );

    // [648] Function call CfAnd
    func_648.input[0] = func_437.outputEqual;
    func_648.input[1] = func_647.output;
    func_648.Execute(  );

    // [649] Function call CfOr
    func_649.input[0] = func_648.outputAND;
    func_649.input[1] = getCmPRCH_PreCtrlHtg_input_7().getValue();
    func_649.Execute(  );

    // [443] Function call CfInputMultiplexer
    func_443.inputSelect = BooleanToInt(func_649.outputOR);
    func_443.input[1-1] = func_425.output;
    func_443.input[2-1] = 6F;
    func_443.Execute(  );
    setCmPRCH_PreCtrlHtg_output_13(func_443.output);

    // [631] Function call CfInputMultiplexer
    func_631.inputSelect = FloatToInt((float) getCmPRCH_PreCtrlHtg_output_13().getValue());
    func_631.input[1-1] = 4F;
    func_631.input[2-1] = 3F;
    func_631.input[3-1] = 1F;
    func_631.input[4-1] = 2F;
    func_631.input[5-1] = 1F;
    func_631.input[6-1] = 1F;
    func_631.input[7-1] = 1F;
    func_631.Execute(  );
    setCmPRCH_PreCtrlHtg_output_630(func_631.output);

    // [477] Function call CfCompare1
    func_477.inputA = (float) getCmPRCH_PreCtrlHtg_input_6().getValue();
    func_477.inputB = 3F;
    func_477.Execute(  );

    // [478] Function call CfCompare1
    func_478.inputA = (float) getCmPRCH_PreCtrlHtg_parameter_17();
    func_478.inputB = 0F;
    func_478.Execute(  );

    // [540] Function call CfMultiply
    func_540.input[0] = (float) getCmPRCH_PreCtrlHtg_input_460().getValue();
    func_540.input[1] = -1F;
    func_540.Execute(  );

    // [463] Function call CfMaximum
    func_463.input[0] = func_540.output;
    func_463.input[1] = 0F;
    func_463.input[2] = (float) getCmPRCH_PreCtrlHtg_input_3().getValue();
    func_463.Execute(  );

    // [461] Function call CfMinimum
    func_461.input[0] = func_463.output;
    func_461.input[1] = 100F;
    func_461.Execute(  );

    // [55] Function call CfIdt
    func_55.input = func_461.output;
    func_55.Execute(  );

    // [59] Function call CfIdt
    func_59.input = 6F;
    func_59.Execute(  );
    setParameter(0, func_59.output[0]);

    // [60] Function call CfHysteresis
    func_60.inputX = func_461.output;
    func_60.inputW = 8F;
    func_60.Execute( this, 0 );

    // [69] Function call CfIdt
    func_69.input = (float) getCmPRCH_PreCtrlHtg_parameter_28();
    func_69.Execute(  );
    setParameter(1, func_69.output[0]);

    // [563] Function call CfDelay
    func_563.inputA = func_60.output1;
    func_563.inputB = func_60.output1;
    func_563.Execute( this, 1 );

    // [635] Function call CfIdt
    func_635.input = BooleanToFloat(func_60.output1);
    func_635.Execute(  );

    // [78] Function call CfSubtract ("Diff")
    func_78.input[0] = (float) getCmPRCH_PreCtrlHtg_parameter_20();
    func_78.input[1] = (float) getCmPRCH_PreCtrlHtg_parameter_19();
    func_78.Execute(  );

    // [58] Function call CfMaximum ("nie o")
    func_58.input[0] = func_78.output;
    func_58.input[1] = 0.1F;
    func_58.Execute(  );

    // [63] Function call CfDivide ("* K/% 80-100%")
    func_63.inputA = func_58.output;
    func_63.inputB = 20F;
    func_63.Execute(  );

    // [54] Function call CfSubtract ("Diff")
    func_54.input[0] = (float) getCmPRCH_PreCtrlHtg_parameter_19();
    func_54.input[1] = (float) getCmPRCH_PreCtrlHtg_parameter_18();
    func_54.Execute(  );

    // [57] Function call CfMaximum ("nie 0")
    func_57.input[0] = func_54.output;
    func_57.input[1] = 0.1F;
    func_57.Execute(  );

    // [62] Function call CfDivide ("* K/% 0-20%")
    func_62.inputA = func_57.output;
    func_62.inputB = 20F;
    func_62.Execute(  );

    // [73] Function call CfSubtract ("Diff 100-ist")
    func_73.input[0] = func_55.output[0];
    func_73.input[1] = 80F;
    func_73.Execute(  );

    // [61] Function call CfSubtract ("Diff 20-ist")
    func_61.input[0] = 20F;
    func_61.input[1] = func_55.output[0];
    func_61.Execute(  );

    // [64] Function call CfCompare1 ("<=80%")
    func_64.inputA = 80F;
    func_64.inputB = func_55.output[0];
    func_64.Execute(  );

    // [65] Function call CfNot
    func_65.input = func_64.outputLess;
    func_65.Execute(  );

    // [131] Function call CfCompare2
    func_131.inputA = func_55.output[0];
    func_131.inputB = 20F;
    func_131.Execute(  );

    // [76] Function call CfMultiply ("shift 80-100%")
    func_76.input[0] = func_63.output;
    func_76.input[1] = BooleanToFloat(func_64.outputLess);
    func_76.input[2] = func_73.output;
    func_76.Execute(  );

    // [45] Function call CfAddition ("shift addieren")
    func_45.input[0] = (float) getCmPRCH_PreCtrlHtg_parameter_19();
    func_45.input[1] = func_76.output;
    func_45.Execute(  );

    // [44] Function call CfAddition
    func_44.input[0] = BooleanToFloat(func_636.output);
    func_44.input[1] = BooleanToFloat(func_65.output);
    func_44.input[2] = BooleanToFloat(func_131.outputEqualOrLess);
    func_44.Execute(  );

    // [636] Function call CfNot
    func_636.input = FloatToBoolean(func_635.output[0]);
    func_636.Execute(  );

    // [71] Function call CfMultiply ("shift 0-20%")
    func_71.input[0] = BooleanToFloat(func_131.outputEqualOrLess);
    func_71.input[1] = func_61.output;
    func_71.input[2] = func_62.output;
    func_71.Execute(  );

    // [46] Function call CfSubtract ("shift abziehen")
    func_46.input[0] = (float) getCmPRCH_PreCtrlHtg_parameter_19();
    func_46.input[1] = func_71.output;
    func_46.Execute(  );

    // [47] Function call CfInputMultiplexer
    func_47.inputSelect = FloatToInt(func_44.output);
    func_47.input[1-1] = func_45.output;
    func_47.input[2-1] = (float) getCmPRCH_PreCtrlHtg_parameter_19();
    func_47.input[3-1] = func_46.output;
    func_47.input[4-1] = 0F;
    func_47.Execute(  );

    // [52] Function call CfMinimum
    func_52.input[0] = (float) getCmPRCH_PreCtrlHtg_parameter_20();
    func_52.input[1] = func_47.output;
    func_52.Execute(  );

    // [49] Function call CfMaximum
    func_49.input[0] = func_52.output;
    func_49.input[1] = (float) getCmPRCH_PreCtrlHtg_parameter_18();
    func_49.Execute(  );
    setCmPRCH_PreCtrlHtg_output_14(func_49.output);

    // [171] Function call CfIdt ("1k zu FRZ-03")
    func_171.input = 1F;
    func_171.Execute(  );
    setParameter(2, func_171.output[0]);

    // [172] Function call CfHysteresis
    func_172.inputX = (float) getCmPRCH_PreCtrlHtg_parameter_33();
    func_172.inputW = (float) getCmPRCH_PreCtrlHtg_input_247().getValue();
    func_172.Execute( this, 2 );

    // [605] Function call CfCompare1
    func_605.inputA = (float) getCmPRCH_PreCtrlHtg_parameter_31();
    func_605.inputB = 1F;
    func_605.Execute(  );

    // [613] Function call CfOr
    func_613.input[0] = func_605.outputEqual;
    func_613.input[1] = func_605.outputGreater;
    func_613.Execute(  );

    // [576] Function call CfAnd
    func_576.input[0] = func_172.output1;
    func_576.input[1] = func_613.outputOR;
    func_576.Execute(  );

    // [175] Function call CfIdt
    func_175.input = (float) getCmPRCH_PreCtrlHtg_parameter_22();
    func_175.Execute(  );
    setParameter(3, func_175.output[0]);

    // [176] Function call CfIdt
    func_176.input = (float) getCmPRCH_PreCtrlHtg_parameter_23();
    func_176.Execute(  );
    setParameter(4, func_176.output[0]);

    // [177] Function call CfHeatingCurve
    func_177.inputRoomSetpoint = (float) getCmPRCH_PreCtrlHtg_output_14().getValue();
    func_177.inputOutdoorTemperature = (float) getCmPRCH_PreCtrlHtg_input_247().getValue();
    func_177.Execute( this, 3 );

    // [181] Function call CfAnd
    func_181.input[0] = func_172.output1;
    func_181.input[1] = func_199.outputDelayedA;
    func_181.input[2] = FloatToBoolean((float) getCmPRCH_PreCtrlHtg_parameter_166());
    func_181.input[3] = FloatToBoolean((float) getCmPRCH_PreCtrlHtg_parameter_167());
    func_181.input[4] = func_605.outputGreater;
    func_181.Execute(  );

    // [189] Function call CfIdt
    func_189.input = (float) getCmPRCH_PreCtrlHtg_parameter_166();
    func_189.Execute(  );
    setParameter(5, func_189.output[0]);

    // [190] Function call CfMonoflop
    func_190.input = BooleanToFloat(func_181.outputAND);
    func_190.Execute( this, 5 );

    // [182] Function call CfMinimum
    func_182.input[0] = func_177.output;
    func_182.input[1] = (float) getCmPRCH_PreCtrlHtg_parameter_21();
    func_182.Execute(  );

    // [422] Function call CfNot
    func_422.input = func_190.output;
    func_422.Execute(  );

    // [193] Function call CfMultiply
    func_193.input[0] = (float) getCmPRCH_PreCtrlHtg_parameter_167();
    func_193.input[1] = 60F;
    func_193.Execute(  );
    setParameter(6, func_193.output);

    // [199] Function call CfDelay
    func_199.inputA = func_422.output;
    func_199.inputB = func_422.output;
    func_199.Execute( this, 6 );

    // [589] Function call CfIdt
    func_589.input = BooleanToFloat(func_190.output);
    func_589.Execute(  );

    // [185] Function call CfMultiply ("Mintemp")
    func_185.input[0] = (float) getCmPRCH_PreCtrlHtg_parameter_32();
    func_185.input[1] = BooleanToFloat(func_576.outputAND);
    func_185.Execute(  );

    // [639] Function call CfMultiply ("Mintemp")
    func_639.input[0] = func_182.output;
    func_639.input[1] = BooleanToFloat(func_563.outputDelayedA);
    func_639.Execute(  );

    // [191] Function call CfMaximum
    func_191.input[0] = func_185.output;
    func_191.input[1] = func_639.output;
    func_191.Execute(  );
    setCmPRCH_PreCtrlHtg_output_15(func_191.output);

    // [327] Function call CfIdt
    func_327.input = (float) getCmPRCH_PreCtrlHtg_parameter_25();
    func_327.Execute(  );
    setParameter(7, func_327.output[0]);

    // [328] Function call CfIdt
    func_328.input = (float) getCmPRCH_PreCtrlHtg_parameter_26();
    func_328.Execute(  );
    setParameter(9, func_328.output[0]);

    // [329] Function call CfIdt
    func_329.input = (float) getCmPRCH_PreCtrlHtg_parameter_27();
    func_329.Execute(  );
    setParameter(8, func_329.output[0]);

    // [651] Function call CfPidPlus
    func_651.inputX = (float) getCmPRCH_PreCtrlHtg_input_1().getValue();
    func_651.inputW = (float) getCmPRCH_PreCtrlHtg_output_15().getValue();
    func_651.inputIntegralOn = true;
    func_651.Execute( this, 7 );

    // [280] Function call CfIdt
    func_280.input = 6F;
    func_280.Execute(  );
    setParameter(12, func_280.output[0]);

    // [547] Function call CfCompare1
    func_547.inputA = (float) getCmPRCH_PreCtrlHtg_input_1().getValue();
    func_547.inputB = 999F;
    func_547.Execute(  );

    // [542] Function call CfInputMultiplexer
    func_542.inputSelect = BooleanToInt(func_547.outputLess);
    func_542.input[1-1] = 100F;
    func_542.input[2-1] = func_651.output;
    func_542.Execute(  );

    // [569] Function call CfOr
    func_569.input[0] = func_563.outputDelayedA;
    func_569.input[1] = func_576.outputAND;
    func_569.Execute(  );

    // [560] Function call CfInputMultiplexer
    func_560.inputSelect = BooleanToInt(func_569.outputOR);
    func_560.input[1-1] = 0F;
    func_560.input[2-1] = func_542.output;
    func_560.Execute(  );

    // [281] Function call CfHysteresis
    func_281.inputX = func_560.output;
    func_281.inputW = 8F;
    func_281.Execute( this, 12 );

    // [594] Function call CfIdt
    func_594.input = func_55.output[0];
    func_594.Execute(  );

    // [597] Function call CfMaximum
    func_597.input[0] = func_560.output;
    func_597.input[1] = func_594.output[0];
    func_597.Execute(  );

    // [317] Function call CfCompare2
    func_317.inputA = func_597.output;
    func_317.inputB = 2F;
    func_317.Execute(  );

    // [282] Function call CfIdt
    func_282.input = 6F;
    func_282.Execute(  );
    setParameter(13, func_282.output[0]);

    // [283] Function call CfHysteresis
    func_283.inputX = func_594.output[0];
    func_283.inputW = 8F;
    func_283.Execute( this, 13 );

    // [412] Function call CfIdt
    func_412.input = (float) getCmPRCH_PreCtrlHtg_parameter_29();
    func_412.Execute(  );
    setParameter(14, func_412.output[0]);

    // [414] Function call CfIdt
    func_414.input = (float) getCmPRCH_PreCtrlHtg_parameter_30();
    func_414.Execute(  );
    setParameter(15, func_414.output[0]);

    // [486] Function call CfAnd
    func_486.input[0] = func_283.output1;
    func_486.input[1] = func_446.outputAND;
    func_486.Execute(  );

    // [410] Function call CfDelayOnOff
    func_410.input = func_486.outputAND;
    func_410.Execute( this, 14 );

    // [528] Function call CfMultiply
    func_528.input[0] = BooleanToFloat(func_281.output1);
    func_528.input[1] = (float) getCmPRCH_PreCtrlHtg_output_15().getValue();
    func_528.Execute(  );

    // [539] Function call CfMultiply
    func_539.input[0] = BooleanToFloat(func_317.outputEqualOrGreater);
    func_539.input[1] = (float) getCmPRCH_PreCtrlHtg_output_15().getValue();
    func_539.Execute(  );

    // [289] Function call CfInputMultiplexer
    func_289.inputSelect = FloatToInt((float) getCmPRCH_PreCtrlHtg_parameter_16());
    func_289.input[1-1] = 0F;
    func_289.input[2-1] = func_528.output;
    func_289.input[3-1] = func_539.output;
    func_289.Execute(  );

    // [479] Function call CfAnd
    func_479.input[0] = func_477.outputEqual;
    func_479.input[1] = func_478.outputEqual;
    func_479.Execute(  );
    setCmPRCH_PreCtrlHtg_output_12(func_479.outputAND);

    // [491] Function call CfMultiply
    func_491.input[0] = BooleanToFloat(func_446.outputAND);
    func_491.input[1] = func_560.output;
    func_491.Execute(  );

    // [481] Function call CfMaximum
    func_481.input[0] = func_491.output;
    func_481.input[1] = (float) getCmPRCH_PreCtrlHtg_input_8().getValue();
    func_481.Execute(  );
    setCmPRCH_PreCtrlHtg_output_10(func_481.output);

    // [614] Function call CfAnd
    func_614.input[0] = func_172.output1;
    func_614.input[1] = func_605.outputEqual;
    func_614.Execute(  );

    // [598] Function call CfOr
    func_598.input[0] = func_410.output;
    func_598.input[1] = FloatToBoolean(func_589.output[0]);
    func_598.input[2] = func_614.outputAND;
    func_598.Execute(  );

    // [482] Function call CfOr
    func_482.input[0] = getCmPRCH_PreCtrlHtg_input_9().getValue();
    func_482.input[1] = func_598.outputOR;
    func_482.Execute(  );
    setCmPRCH_PreCtrlHtg_output_11(func_482.outputOR);

    // [492] Function call CfMultiply
    func_492.input[0] = BooleanToFloat(func_446.outputAND);
    func_492.input[1] = func_289.output;
    func_492.Execute(  );
    setCmPRCH_PreCtrlHtg_output_320(func_492.output);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    0F, 10F, 0F, 1F, 1F, 60F, 0F, 3F,
    0F, 1000F, 100F, 0F, 0F, 0F, 10F, 10F,
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  // macro outputs
// HtgValveControl
  public static final Property CmPRCH_PreCtrlHtg_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPRCH_PreCtrlHtg_output_10() { return (BStatusNumeric) get(CmPRCH_PreCtrlHtg_output_10); }
  public void setCmPRCH_PreCtrlHtg_output_10(BStatusNumeric v) { set(CmPRCH_PreCtrlHtg_output_10,v,null); }
  public void setCmPRCH_PreCtrlHtg_output_10(float v) { getCmPRCH_PreCtrlHtg_output_10().setValue(v); }
// HtgPmpCmd
  public static final Property CmPRCH_PreCtrlHtg_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPRCH_PreCtrlHtg_output_11() { return (BStatusBoolean) get(CmPRCH_PreCtrlHtg_output_11); }
  public void setCmPRCH_PreCtrlHtg_output_11(BStatusBoolean v) { set(CmPRCH_PreCtrlHtg_output_11,v,null); }
  public void setCmPRCH_PreCtrlHtg_output_11(boolean v) { getCmPRCH_PreCtrlHtg_output_11().setValue(v); }
// HeatDemand
  public static final Property CmPRCH_PreCtrlHtg_output_320 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPRCH_PreCtrlHtg_output_320() { return (BStatusNumeric) get(CmPRCH_PreCtrlHtg_output_320); }
  public void setCmPRCH_PreCtrlHtg_output_320(BStatusNumeric v) { set(CmPRCH_PreCtrlHtg_output_320,v,null); }
  public void setCmPRCH_PreCtrlHtg_output_320(float v) { getCmPRCH_PreCtrlHtg_output_320().setValue(v); }
// ChgOverCmd
  public static final Property CmPRCH_PreCtrlHtg_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmPRCH_PreCtrlHtg_output_12() { return (BStatusBoolean) get(CmPRCH_PreCtrlHtg_output_12); }
  public void setCmPRCH_PreCtrlHtg_output_12(BStatusBoolean v) { set(CmPRCH_PreCtrlHtg_output_12,v,null); }
  public void setCmPRCH_PreCtrlHtg_output_12(boolean v) { getCmPRCH_PreCtrlHtg_output_12().setValue(v); }
// ApplicModeXL10
  public static final Property CmPRCH_PreCtrlHtg_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPRCH_PreCtrlHtg_output_13() { return (BStatusNumeric) get(CmPRCH_PreCtrlHtg_output_13); }
  public void setCmPRCH_PreCtrlHtg_output_13(BStatusNumeric v) { set(CmPRCH_PreCtrlHtg_output_13,v,null); }
  public void setCmPRCH_PreCtrlHtg_output_13(float v) { getCmPRCH_PreCtrlHtg_output_13().setValue(v); }
// ApplicModeIRM
  public static final Property CmPRCH_PreCtrlHtg_output_630 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPRCH_PreCtrlHtg_output_630() { return (BStatusNumeric) get(CmPRCH_PreCtrlHtg_output_630); }
  public void setCmPRCH_PreCtrlHtg_output_630(BStatusNumeric v) { set(CmPRCH_PreCtrlHtg_output_630,v,null); }
  public void setCmPRCH_PreCtrlHtg_output_630(float v) { getCmPRCH_PreCtrlHtg_output_630().setValue(v); }
// CalcRmSp
  public static final Property CmPRCH_PreCtrlHtg_output_14 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPRCH_PreCtrlHtg_output_14() { return (BStatusNumeric) get(CmPRCH_PreCtrlHtg_output_14); }
  public void setCmPRCH_PreCtrlHtg_output_14(BStatusNumeric v) { set(CmPRCH_PreCtrlHtg_output_14,v,null); }
  public void setCmPRCH_PreCtrlHtg_output_14(float v) { getCmPRCH_PreCtrlHtg_output_14().setValue(v); }
// CalcHtgSp
  public static final Property CmPRCH_PreCtrlHtg_output_15 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmPRCH_PreCtrlHtg_output_15() { return (BStatusNumeric) get(CmPRCH_PreCtrlHtg_output_15); }
  public void setCmPRCH_PreCtrlHtg_output_15(BStatusNumeric v) { set(CmPRCH_PreCtrlHtg_output_15,v,null); }
  public void setCmPRCH_PreCtrlHtg_output_15(float v) { getCmPRCH_PreCtrlHtg_output_15().setValue(v); }

  // macro parameter
// HTD-01: heat demand transmission
  public static final Property CmPRCH_PreCtrlHtg_parameter_16 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPRCH_PreCtrlHtg_parameter_16() { return getDouble(CmPRCH_PreCtrlHtg_parameter_16); }
  public void setCmPRCH_PreCtrlHtg_parameter_16(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_16,v,null); }
// SYS-01: 4-pipe system=1
  public static final Property CmPRCH_PreCtrlHtg_parameter_17 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPRCH_PreCtrlHtg_parameter_17() { return getDouble(CmPRCH_PreCtrlHtg_parameter_17); }
  public void setCmPRCH_PreCtrlHtg_parameter_17(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_17,v,null); }
// RMSP-01: room temperature setpoint for low demand
  public static final Property CmPRCH_PreCtrlHtg_parameter_18 = newProperty( 0, BDouble.make( 17 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmPRCH_PreCtrlHtg_parameter_18() { return getDouble(CmPRCH_PreCtrlHtg_parameter_18); }
  public void setCmPRCH_PreCtrlHtg_parameter_18(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_18,v,null); }
// RMSP-02: room temperature setpoint for mid demand
  public static final Property CmPRCH_PreCtrlHtg_parameter_19 = newProperty( 0, BDouble.make( 20 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmPRCH_PreCtrlHtg_parameter_19() { return getDouble(CmPRCH_PreCtrlHtg_parameter_19); }
  public void setCmPRCH_PreCtrlHtg_parameter_19(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_19,v,null); }
// RMSP-03: room temperature setpoint for high demand
  public static final Property CmPRCH_PreCtrlHtg_parameter_20 = newProperty( 0, BDouble.make( 23 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmPRCH_PreCtrlHtg_parameter_20() { return getDouble(CmPRCH_PreCtrlHtg_parameter_20); }
  public void setCmPRCH_PreCtrlHtg_parameter_20(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_20,v,null); }
// FLT-01: maximum flow temperature limit pre-heating
  public static final Property CmPRCH_PreCtrlHtg_parameter_21 = newProperty( 0, BDouble.make( 82 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(150)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmPRCH_PreCtrlHtg_parameter_21() { return getDouble(CmPRCH_PreCtrlHtg_parameter_21); }
  public void setCmPRCH_PreCtrlHtg_parameter_21(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_21,v,null); }
// HCA-01: heating curve curvature
  public static final Property CmPRCH_PreCtrlHtg_parameter_22 = newProperty( 0, BDouble.make( 1.33 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmPRCH_PreCtrlHtg_parameter_22() { return getDouble(CmPRCH_PreCtrlHtg_parameter_22); }
  public void setCmPRCH_PreCtrlHtg_parameter_22(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_22,v,null); }
// HCA-02: heating curve slope
  public static final Property CmPRCH_PreCtrlHtg_parameter_23 = newProperty( 0, BDouble.make( 1.6 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(4.5)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPRCH_PreCtrlHtg_parameter_23() { return getDouble(CmPRCH_PreCtrlHtg_parameter_23); }
  public void setCmPRCH_PreCtrlHtg_parameter_23(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_23,v,null); }
// FLTC-01: P-band heating pre-control
  public static final Property CmPRCH_PreCtrlHtg_parameter_25 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("kelvin"))));
  public double getCmPRCH_PreCtrlHtg_parameter_25() { return getDouble(CmPRCH_PreCtrlHtg_parameter_25); }
  public void setCmPRCH_PreCtrlHtg_parameter_25(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_25,v,null); }
// FLTC-02: I-time heating pre-control
  public static final Property CmPRCH_PreCtrlHtg_parameter_26 = newProperty( 0, BDouble.make( 24 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPRCH_PreCtrlHtg_parameter_26() { return getDouble(CmPRCH_PreCtrlHtg_parameter_26); }
  public void setCmPRCH_PreCtrlHtg_parameter_26(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_26,v,null); }
// FLTC-03: D-time heating pre-control
  public static final Property CmPRCH_PreCtrlHtg_parameter_27 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(1000)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPRCH_PreCtrlHtg_parameter_27() { return getDouble(CmPRCH_PreCtrlHtg_parameter_27); }
  public void setCmPRCH_PreCtrlHtg_parameter_27(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_27,v,null); }
// FLTC-04: heating control switch on delay
  public static final Property CmPRCH_PreCtrlHtg_parameter_28 = newProperty( 0, BDouble.make( 30 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPRCH_PreCtrlHtg_parameter_28() { return getDouble(CmPRCH_PreCtrlHtg_parameter_28); }
  public void setCmPRCH_PreCtrlHtg_parameter_28(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_28,v,null); }
// HPMP-01: switch on delay heating pump
  public static final Property CmPRCH_PreCtrlHtg_parameter_29 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPRCH_PreCtrlHtg_parameter_29() { return getDouble(CmPRCH_PreCtrlHtg_parameter_29); }
  public void setCmPRCH_PreCtrlHtg_parameter_29(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_29,v,null); }
// HPMP-02: switch off delay heating pump
  public static final Property CmPRCH_PreCtrlHtg_parameter_30 = newProperty( 0, BDouble.make( 300 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPRCH_PreCtrlHtg_parameter_30() { return getDouble(CmPRCH_PreCtrlHtg_parameter_30); }
  public void setCmPRCH_PreCtrlHtg_parameter_30(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_30,v,null); }
// FRZ-01: enable freeze protection
  public static final Property CmPRCH_PreCtrlHtg_parameter_31 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmPRCH_PreCtrlHtg_parameter_31() { return getDouble(CmPRCH_PreCtrlHtg_parameter_31); }
  public void setCmPRCH_PreCtrlHtg_parameter_31(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_31,v,null); }
// FRZ-02: flow temp. setpoint frost protection
  public static final Property CmPRCH_PreCtrlHtg_parameter_32 = newProperty( 0, BDouble.make( 10 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(2)), BFacets.make(BFacets.MAX, BDouble.make(20)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmPRCH_PreCtrlHtg_parameter_32() { return getDouble(CmPRCH_PreCtrlHtg_parameter_32); }
  public void setCmPRCH_PreCtrlHtg_parameter_32(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_32,v,null); }
// FRZ-03: OAT limit frost protection
  public static final Property CmPRCH_PreCtrlHtg_parameter_33 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-50)), BFacets.make(BFacets.MAX, BDouble.make(50)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("celsius"))));
  public double getCmPRCH_PreCtrlHtg_parameter_33() { return getDouble(CmPRCH_PreCtrlHtg_parameter_33); }
  public void setCmPRCH_PreCtrlHtg_parameter_33(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_33,v,null); }
// FRZ-04: frost protection heating pump runtime for cyclic on
  public static final Property CmPRCH_PreCtrlHtg_parameter_166 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(720)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmPRCH_PreCtrlHtg_parameter_166() { return getDouble(CmPRCH_PreCtrlHtg_parameter_166); }
  public void setCmPRCH_PreCtrlHtg_parameter_166(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_166,v,null); }
// FRZ-05: frost protection heating pump delay for cyclic off
  public static final Property CmPRCH_PreCtrlHtg_parameter_167 = newProperty( 0, BDouble.make( 5 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(180)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("minute"))));
  public double getCmPRCH_PreCtrlHtg_parameter_167() { return getDouble(CmPRCH_PreCtrlHtg_parameter_167); }
  public void setCmPRCH_PreCtrlHtg_parameter_167(double v) { setDouble(CmPRCH_PreCtrlHtg_parameter_167,v,null); }

  // macro inputs
// HtgFlowTemp
  public static final Property CmPRCH_PreCtrlHtg_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmPRCH_PreCtrlHtg_input_1() { return (BStatusNumeric) get(CmPRCH_PreCtrlHtg_input_1); }
  public void setCmPRCH_PreCtrlHtg_input_1(BStatusNumeric v) { set(CmPRCH_PreCtrlHtg_input_1,v,null); }
  public void setCmPRCH_PreCtrlHtg_input_1(float v) { getCmPRCH_PreCtrlHtg_input_1().setValue(v); }
// MaxHtgVlvPos
  public static final Property CmPRCH_PreCtrlHtg_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmPRCH_PreCtrlHtg_input_3() { return (BStatusNumeric) get(CmPRCH_PreCtrlHtg_input_3); }
  public void setCmPRCH_PreCtrlHtg_input_3(BStatusNumeric v) { set(CmPRCH_PreCtrlHtg_input_3,v,null); }
  public void setCmPRCH_PreCtrlHtg_input_3(float v) { getCmPRCH_PreCtrlHtg_input_3().setValue(v); }
// TherminalLoad
  public static final Property CmPRCH_PreCtrlHtg_input_460 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmPRCH_PreCtrlHtg_input_460() { return (BStatusNumeric) get(CmPRCH_PreCtrlHtg_input_460); }
  public void setCmPRCH_PreCtrlHtg_input_460(BStatusNumeric v) { set(CmPRCH_PreCtrlHtg_input_460,v,null); }
  public void setCmPRCH_PreCtrlHtg_input_460(float v) { getCmPRCH_PreCtrlHtg_input_460().setValue(v); }
// FiltOATemp
  public static final Property CmPRCH_PreCtrlHtg_input_247 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmPRCH_PreCtrlHtg_input_247() { return (BStatusNumeric) get(CmPRCH_PreCtrlHtg_input_247); }
  public void setCmPRCH_PreCtrlHtg_input_247(BStatusNumeric v) { set(CmPRCH_PreCtrlHtg_input_247,v,null); }
  public void setCmPRCH_PreCtrlHtg_input_247(float v) { getCmPRCH_PreCtrlHtg_input_247().setValue(v); }
// HVAC_Mode
  public static final Property CmPRCH_PreCtrlHtg_input_6 = newProperty( Flags.SUMMARY, new BStatusNumeric( 2 ), null);
  public BStatusNumeric getCmPRCH_PreCtrlHtg_input_6() { return (BStatusNumeric) get(CmPRCH_PreCtrlHtg_input_6); }
  public void setCmPRCH_PreCtrlHtg_input_6(BStatusNumeric v) { set(CmPRCH_PreCtrlHtg_input_6,v,null); }
  public void setCmPRCH_PreCtrlHtg_input_6(float v) { getCmPRCH_PreCtrlHtg_input_6().setValue(v); }
// HolidaySw
  public static final Property CmPRCH_PreCtrlHtg_input_7 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPRCH_PreCtrlHtg_input_7() { return (BStatusBoolean) get(CmPRCH_PreCtrlHtg_input_7); }
  public void setCmPRCH_PreCtrlHtg_input_7(BStatusBoolean v) { set(CmPRCH_PreCtrlHtg_input_7,v,null); }
  public void setCmPRCH_PreCtrlHtg_input_7(boolean v) { getCmPRCH_PreCtrlHtg_input_7().setValue(v); }
// CoolValve
  public static final Property CmPRCH_PreCtrlHtg_input_8 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmPRCH_PreCtrlHtg_input_8() { return (BStatusNumeric) get(CmPRCH_PreCtrlHtg_input_8); }
  public void setCmPRCH_PreCtrlHtg_input_8(BStatusNumeric v) { set(CmPRCH_PreCtrlHtg_input_8,v,null); }
  public void setCmPRCH_PreCtrlHtg_input_8(float v) { getCmPRCH_PreCtrlHtg_input_8().setValue(v); }
// CoolPmpCmd
  public static final Property CmPRCH_PreCtrlHtg_input_9 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmPRCH_PreCtrlHtg_input_9() { return (BStatusBoolean) get(CmPRCH_PreCtrlHtg_input_9); }
  public void setCmPRCH_PreCtrlHtg_input_9(BStatusBoolean v) { set(CmPRCH_PreCtrlHtg_input_9,v,null); }
  public void setCmPRCH_PreCtrlHtg_input_9(boolean v) { getCmPRCH_PreCtrlHtg_input_9().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.02 [32] 07.03.2018-08:37").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6320145176364843731").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmPRCH_PreCtrlHtg.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfCompare1 func_437 = new CfCompare1();
  protected CfCompare1 func_432 = new CfCompare1();
  protected CfAnd func_429 = new CfAnd();
  protected CfNot func_447 = new CfNot();
  protected CfOr func_427 = new CfOr();
  protected CfAnd func_446 = new CfAnd();
  protected CfInputMultiplexer func_425 = new CfInputMultiplexer();
  protected CfNot func_647 = new CfNot();
  protected CfAnd func_648 = new CfAnd();
  protected CfOr func_649 = new CfOr();
  protected CfInputMultiplexer func_443 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_631 = new CfInputMultiplexer();
  protected CfCompare1 func_477 = new CfCompare1();
  protected CfCompare1 func_478 = new CfCompare1();
  protected CfMultiply func_540 = new CfMultiply();
  protected CfMaximum func_463 = new CfMaximum();
  protected CfMinimum func_461 = new CfMinimum();
  protected CfIdt func_55 = new CfIdt();
  protected CfIdt func_59 = new CfIdt();
  protected CfHysteresis func_60 = new CfHysteresis();
  protected CfIdt func_69 = new CfIdt();
  protected CfDelay func_563 = new CfDelay();
  protected CfIdt func_635 = new CfIdt();
  protected CfSubtract func_78 = new CfSubtract();
  protected CfMaximum func_58 = new CfMaximum();
  protected CfDivide func_63 = new CfDivide();
  protected CfSubtract func_54 = new CfSubtract();
  protected CfMaximum func_57 = new CfMaximum();
  protected CfDivide func_62 = new CfDivide();
  protected CfSubtract func_73 = new CfSubtract();
  protected CfSubtract func_61 = new CfSubtract();
  protected CfCompare1 func_64 = new CfCompare1();
  protected CfNot func_65 = new CfNot();
  protected CfCompare2 func_131 = new CfCompare2();
  protected CfMultiply func_76 = new CfMultiply();
  protected CfAddition func_45 = new CfAddition();
  protected CfAddition func_44 = new CfAddition();
  protected CfNot func_636 = new CfNot();
  protected CfMultiply func_71 = new CfMultiply();
  protected CfSubtract func_46 = new CfSubtract();
  protected CfInputMultiplexer func_47 = new CfInputMultiplexer();
  protected CfMinimum func_52 = new CfMinimum();
  protected CfMaximum func_49 = new CfMaximum();
  protected CfIdt func_171 = new CfIdt();
  protected CfHysteresis func_172 = new CfHysteresis();
  protected CfCompare1 func_605 = new CfCompare1();
  protected CfOr func_613 = new CfOr();
  protected CfAnd func_576 = new CfAnd();
  protected CfIdt func_175 = new CfIdt();
  protected CfIdt func_176 = new CfIdt();
  protected CfHeatingCurve func_177 = new CfHeatingCurve();
  protected CfAnd func_181 = new CfAnd();
  protected CfIdt func_189 = new CfIdt();
  protected CfMonoflop func_190 = new CfMonoflop();
  protected CfMinimum func_182 = new CfMinimum();
  protected CfNot func_422 = new CfNot();
  protected CfMultiply func_193 = new CfMultiply();
  protected CfDelay func_199 = new CfDelay();
  protected CfIdt func_589 = new CfIdt();
  protected CfMultiply func_185 = new CfMultiply();
  protected CfMultiply func_639 = new CfMultiply();
  protected CfMaximum func_191 = new CfMaximum();
  protected CfIdt func_327 = new CfIdt();
  protected CfIdt func_328 = new CfIdt();
  protected CfIdt func_329 = new CfIdt();
  protected CfPidPlus func_651 = new CfPidPlus();
  protected CfIdt func_280 = new CfIdt();
  protected CfCompare1 func_547 = new CfCompare1();
  protected CfInputMultiplexer func_542 = new CfInputMultiplexer();
  protected CfOr func_569 = new CfOr();
  protected CfInputMultiplexer func_560 = new CfInputMultiplexer();
  protected CfHysteresis func_281 = new CfHysteresis();
  protected CfIdt func_594 = new CfIdt();
  protected CfMaximum func_597 = new CfMaximum();
  protected CfCompare2 func_317 = new CfCompare2();
  protected CfIdt func_282 = new CfIdt();
  protected CfHysteresis func_283 = new CfHysteresis();
  protected CfIdt func_412 = new CfIdt();
  protected CfIdt func_414 = new CfIdt();
  protected CfAnd func_486 = new CfAnd();
  protected CfDelayOnOff func_410 = new CfDelayOnOff();
  protected CfMultiply func_528 = new CfMultiply();
  protected CfMultiply func_539 = new CfMultiply();
  protected CfInputMultiplexer func_289 = new CfInputMultiplexer();
  protected CfAnd func_479 = new CfAnd();
  protected CfMultiply func_491 = new CfMultiply();
  protected CfMaximum func_481 = new CfMaximum();
  protected CfAnd func_614 = new CfAnd();
  protected CfOr func_598 = new CfOr();
  protected CfOr func_482 = new CfOr();
  protected CfMultiply func_492 = new CfMultiply();

  // default constructor
  public BCmPRCH_PreCtrlHtg()
  {
    func_425.configure(7);
    func_631.configure(8);
    func_463.configure(3);
    func_76.configure(3);
    func_44.configure(3);
    func_71.configure(3);
    func_47.configure(5);
    func_181.configure(5);
    func_289.configure(4);
    func_598.configure(3);
  }

  public void Start()
  {
    func_60.Start();
    func_563.Start();
    func_172.Start();
    func_177.Start();
    func_190.Start();
    func_199.Start();
    func_651.Start();
    func_281.Start();
    func_283.Start();
    func_410.Start();
  }
}
