/*
Copyright (c) 2022 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/

package com.honeywell.honplantcontroller.hmi.alarm;

import javax.baja.nre.annotations.NiagaraProperty;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.sys.BComponent;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

import com.honeywell.honplantcontroller.hmi.enums.BHMISyncStatus;


@NiagaraProperty(
    name = "urgentAlarmPriority",
    type = "BAlarmPriorityConfigEntry",
    defaultValue = "new BAlarmPriorityConfigEntry(0, 84)"
)
@NiagaraProperty(
    name = "highAlarmPriority",
    type = "BAlarmPriorityConfigEntry",
    defaultValue = "new BAlarmPriorityConfigEntry(85, 169)"
)
@NiagaraProperty(
    name = "lowAlarmPriority",
    type = "BAlarmPriorityConfigEntry",
    defaultValue = "new BAlarmPriorityConfigEntry(170, 255)"
)
@NiagaraProperty(
    name ="syncStatus",
    type = "BHMISyncStatus",
    defaultValue = "BHMISyncStatus.DEFAULT",
    flags = Flags.HIDDEN | Flags.READONLY | Flags.DEFAULT_ON_CLONE
)

@NiagaraType
public class BAlarmPriorityConfig extends BComponent {
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.honeywell.honplantcontroller.hmi.alarm.BAlarmPriorityConfig(1873530709)1.0$ @*/
/* Generated Wed Jun 29 10:20:59 CEST 2022 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "urgentAlarmPriority"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code urgentAlarmPriority} property.
   * @see #getUrgentAlarmPriority
   * @see #setUrgentAlarmPriority
   */
  public static final Property urgentAlarmPriority = newProperty(0, new BAlarmPriorityConfigEntry(0, 84), null);
  
  /**
   * Get the {@code urgentAlarmPriority} property.
   * @see #urgentAlarmPriority
   */
  public BAlarmPriorityConfigEntry getUrgentAlarmPriority() { return (BAlarmPriorityConfigEntry)get(urgentAlarmPriority); }
  
  /**
   * Set the {@code urgentAlarmPriority} property.
   * @see #urgentAlarmPriority
   */
  public void setUrgentAlarmPriority(BAlarmPriorityConfigEntry v) { set(urgentAlarmPriority, v, null); }

////////////////////////////////////////////////////////////////
// Property "highAlarmPriority"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code highAlarmPriority} property.
   * @see #getHighAlarmPriority
   * @see #setHighAlarmPriority
   */
  public static final Property highAlarmPriority = newProperty(0, new BAlarmPriorityConfigEntry(85, 169), null);
  
  /**
   * Get the {@code highAlarmPriority} property.
   * @see #highAlarmPriority
   */
  public BAlarmPriorityConfigEntry getHighAlarmPriority() { return (BAlarmPriorityConfigEntry)get(highAlarmPriority); }
  
  /**
   * Set the {@code highAlarmPriority} property.
   * @see #highAlarmPriority
   */
  public void setHighAlarmPriority(BAlarmPriorityConfigEntry v) { set(highAlarmPriority, v, null); }

////////////////////////////////////////////////////////////////
// Property "lowAlarmPriority"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code lowAlarmPriority} property.
   * @see #getLowAlarmPriority
   * @see #setLowAlarmPriority
   */
  public static final Property lowAlarmPriority = newProperty(0, new BAlarmPriorityConfigEntry(170, 255), null);
  
  /**
   * Get the {@code lowAlarmPriority} property.
   * @see #lowAlarmPriority
   */
  public BAlarmPriorityConfigEntry getLowAlarmPriority() { return (BAlarmPriorityConfigEntry)get(lowAlarmPriority); }
  
  /**
   * Set the {@code lowAlarmPriority} property.
   * @see #lowAlarmPriority
   */
  public void setLowAlarmPriority(BAlarmPriorityConfigEntry v) { set(lowAlarmPriority, v, null); }

////////////////////////////////////////////////////////////////
// Property "syncStatus"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code syncStatus} property.
   * @see #getSyncStatus
   * @see #setSyncStatus
   */
  public static final Property syncStatus = newProperty(Flags.HIDDEN | Flags.READONLY | Flags.DEFAULT_ON_CLONE, BHMISyncStatus.DEFAULT, null);
  
  /**
   * Get the {@code syncStatus} property.
   * @see #syncStatus
   */
  public BHMISyncStatus getSyncStatus() { return (BHMISyncStatus)get(syncStatus); }
  
  /**
   * Set the {@code syncStatus} property.
   * @see #syncStatus
   */
  public void setSyncStatus(BHMISyncStatus v) { set(syncStatus, v, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BAlarmPriorityConfig.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

}
