/*
Copyright (c) 2022 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/

package com.honeywell.honplantcontroller.hmi.alarm;

import javax.baja.nre.annotations.NiagaraProperty;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.sys.BComplex;
import javax.baja.sys.BComponent;
import javax.baja.sys.Context;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

import com.honeywell.honplantcontroller.hmi.enums.BHMISyncStatus;


@NiagaraProperty(
    name = "lowRange",
    type = "int",
    defaultValue = "0"
)
@NiagaraProperty(
    name = "highRange",
    type = "int",
    defaultValue = "0"
)

@NiagaraType
public class BAlarmPriorityConfigEntry extends BComponent {
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.honeywell.honplantcontroller.hmi.alarm.BAlarmPriorityConfigEntry(950852743)1.0$ @*/
/* Generated Wed Jun 29 11:27:21 CEST 2022 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "lowRange"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code lowRange} property.
   * @see #getLowRange
   * @see #setLowRange
   */
  public static final Property lowRange = newProperty(0, 0, null);
  
  /**
   * Get the {@code lowRange} property.
   * @see #lowRange
   */
  public int getLowRange() { return getInt(lowRange); }
  
  /**
   * Set the {@code lowRange} property.
   * @see #lowRange
   */
  public void setLowRange(int v) { setInt(lowRange, v, null); }

////////////////////////////////////////////////////////////////
// Property "highRange"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code highRange} property.
   * @see #getHighRange
   * @see #setHighRange
   */
  public static final Property highRange = newProperty(0, 0, null);
  
  /**
   * Get the {@code highRange} property.
   * @see #highRange
   */
  public int getHighRange() { return getInt(highRange); }
  
  /**
   * Set the {@code highRange} property.
   * @see #highRange
   */
  public void setHighRange(int v) { setInt(highRange, v, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BAlarmPriorityConfigEntry.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public static final BAlarmPriorityConfigEntry DEFAULT = new BAlarmPriorityConfigEntry();

  public BAlarmPriorityConfigEntry() {

  }

  public BAlarmPriorityConfigEntry(int lowRange, int highRange ) {
    setLowRange(lowRange);
    setHighRange(highRange);
  }

  @Override
  public void changed(Property property, Context context) {
    super.changed(property, context);

    if(lowRange.equals(property) ||  highRange.equals(property)) {
      BComplex parent = getParent();
      if(parent instanceof BAlarmPriorityConfig) {
        BAlarmPriorityConfig alarmPriorityConfig = (BAlarmPriorityConfig)parent;
        alarmPriorityConfig.setSyncStatus(BHMISyncStatus.outOfSync);
      }
    }
  }


}
