/*
Copyright (c) 2022 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/

package com.honeywell.honplantcontroller.hmi.comm;

import com.honeywell.honplantcontroller.hmi.utils.HonPlantControllerHMILogger;
import com.tridium.bacnet.stack.link.mstp.BBacnetMstpLinkLayer;
import com.tridium.bacnet.stack.network.BNetworkPort;
import com.tridium.bacnet.stack.network.NetworkPdu;

import javax.baja.nre.annotations.NiagaraType;
import javax.baja.nre.util.ByteArrayUtil;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

@NiagaraType
public class BHMIBacnetMstpLinkLayer extends BBacnetMstpLinkLayer {
  /*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
  /*@ $com.honeywell.honplantcontroller.mmi.comm.BHMIBacnetMstpLinkLayer(2979906276)1.0$ @*/
  /* Generated Wed Jun 29 11:57:01 CEST 2022 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////

  @Override
  public Type getType() {
    return TYPE;
  }

  public static final Type TYPE = Sys.loadType(BHMIBacnetMstpLinkLayer.class);

  /*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/
  public BHMIBacnetMstpLinkLayer() {
    BHonPlantControllerBacnetProperties props = new BHonPlantControllerBacnetProperties();
    setPortName(props.getPortName());
    setBaudRate(props.getBaudRate());
    setMstpAddress(props.getMstpAddresse());
    setMaxMaster(1);
    setSupportExtendedFrames(false);

    if ((getParent() != null) && (getParent() instanceof BNetworkPort))
      ((BNetworkPort)getParent()).setNetworkNumber(props.getNetworkNumber());
  }

  @Override
  public synchronized void sendRequest(byte[] destAddress, NetworkPdu npdu) {
    //Should not forward any routed IAMs/Bacnet messages
    if (npdu.getHopCount() < 255) {
      HonPlantControllerHMILogger.fine("[BHMIBacnetMstpLinkLayer.sendRequest] routeded IAMs/Bacnet messages are filtered because of hopCount: " + npdu.getHopCount());
      return;
    }

    super.sendRequest(destAddress, npdu);
  }
}
