/*
 *  Copyright (c) 2018 Honeywell International, Inc. All rights reserved.
 *
 *  This file contains trade secrets of Honeywell International, Inc.  No part 
 *  may be reproduced or transmitted in any form by any means or for any 
 *  purpose without the express written permission of Honeywell.
 */

/**
 * 
 * Requirement ID: 
 * @author E577861 - Suresh Khatri
 * @since May 26, 2022
 */

package com.honeywell.honplantcontroller.hmi.comm;

import javax.baja.bacnet.BBacnetNetwork;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.sys.BInterface;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.util.BServiceContainer;

import com.honeywell.honplantcontroller.hmi.service.BHonPlantControllerHMI;

@NiagaraType
public interface BIHonPlantControllerHMIInterface extends BInterface{
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.honeywell.honplantcontroller.hmi.comm.BIHonPlantControllerHMIInterface(2979906276)1.0$ @*/
/* Generated Wed Jun 29 10:47:46 CEST 2022 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  Type TYPE = Sys.loadType(BIHonPlantControllerHMIInterface.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


	default BHonPlantControllerHMI getHMIDevice() {
		return null;
	}
	
	public static BIHonPlantControllerHMIInterface getHonPlantControllerHMIInterface() {
		BIHonPlantControllerHMIInterface plantControllerHMIInterface = null;
		
		if(!Sys.isStation())
			return plantControllerHMIInterface;
		
		BServiceContainer services = Sys.getStation().getServices();
		if(null == services)
			return plantControllerHMIInterface;
		
		
		services.lease();
		services.lease(10);
		
		BIHonPlantControllerHMIInterface[] plantControllerHMIInterfaces = services.getChildren(BIHonPlantControllerHMIInterface.class);
		if(null == plantControllerHMIInterfaces || plantControllerHMIInterfaces.length <= 0)
			return plantControllerHMIInterface;
		
		return plantControllerHMIInterfaces[0];
	}
	public static BBacnetNetwork getBacnetNetwork(){
		BIHonPlantControllerHMIInterface honPlantControllerHMIInterface = BIHonPlantControllerHMIInterface.getHonPlantControllerHMIInterface();
		if(null ==  honPlantControllerHMIInterface)
			return null;

		BHonPlantControllerHMI hmiDevice = honPlantControllerHMIInterface.getHMIDevice();
		if(null ==  hmiDevice)
			return null;

		return hmiDevice.getBacnetNetwork();
	}
}
