/*
Copyright (c) 2022 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/

package com.honeywell.honplantcontroller.hmi.enums;

import javax.baja.nre.annotations.NiagaraEnum;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.nre.annotations.Range;
import javax.baja.sys.BFrozenEnum;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

@NiagaraEnum(
    range = {
        @Range(value = "allAlarm", ordinal = 0x0),
        @Range(value = "urgentAlarm", ordinal = 0x01),
        @Range(value = "highAlarm", ordinal = 0x02),
        @Range(value = "lowAlarm", ordinal = 0x03),
        
    }
)

@NiagaraType
public final class BHMIAlarmLevelEnum extends BFrozenEnum {
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.honeywell.honplantcontroller.hmi.enums.BHMIAlarmLevelEnum(3288119859)1.0$ @*/
/* Generated Tue Mar 01 19:43:21 IST 2022 by Slot-o-Matic (c) Tridium, Inc. 2012 */
  
  /** Ordinal value for allAlarm. */
  public static final int ALL_ALARM = 0;
  /** Ordinal value for urgentAlarm. */
  public static final int URGENT_ALARM = 1;
  /** Ordinal value for highAlarm. */
  public static final int HIGH_ALARM = 2;
  /** Ordinal value for lowAlarm. */
  public static final int LOW_ALARM = 3;
  
  /** BHMIAlarmLevelEnum constant for allAlarm. */
  public static final BHMIAlarmLevelEnum allAlarm = new BHMIAlarmLevelEnum(ALL_ALARM);
  /** BHMIAlarmLevelEnum constant for urgentAlarm. */
  public static final BHMIAlarmLevelEnum urgentAlarm = new BHMIAlarmLevelEnum(URGENT_ALARM);
  /** BHMIAlarmLevelEnum constant for highAlarm. */
  public static final BHMIAlarmLevelEnum highAlarm = new BHMIAlarmLevelEnum(HIGH_ALARM);
  /** BHMIAlarmLevelEnum constant for lowAlarm. */
  public static final BHMIAlarmLevelEnum lowAlarm = new BHMIAlarmLevelEnum(LOW_ALARM);
  
  /** Factory method with ordinal. */
  public static BHMIAlarmLevelEnum make(int ordinal)
  {
    return (BHMIAlarmLevelEnum)allAlarm.getRange().get(ordinal, false);
  }
  
  /** Factory method with tag. */
  public static BHMIAlarmLevelEnum make(String tag)
  {
    return (BHMIAlarmLevelEnum)allAlarm.getRange().get(tag);
  }
  
  /** Private constructor. */
  private BHMIAlarmLevelEnum(int ordinal)
  {
    super(ordinal);
  }
  
  public static final BHMIAlarmLevelEnum DEFAULT = allAlarm;

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BHMIAlarmLevelEnum.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

}
