/*
Copyright (c) 2022 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/

package com.honeywell.honplantcontroller.hmi.enums;

import javax.baja.nre.annotations.NiagaraEnum;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.nre.annotations.Range;
import javax.baja.sys.BFrozenEnum;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

@NiagaraEnum(
    range = {
        @Range(value = "allControlPoints", ordinal = 0x0),
        @Range(value = "allDataPoints", ordinal = 0x01),
        @Range(value = "taggedPoints", ordinal = 0x02),
        @Range(value = "onlyFAL", ordinal = 0x03)
    },
    defaultValue="allDataPoints"
)

@NiagaraType
public final class BHMIPointExportOptions extends BFrozenEnum {
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.honeywell.honplantcontroller.hmi.enums.BHMIPointExportOptions(1782679840)1.0$ @*/
/* Generated Mon Aug 01 13:40:04 IST 2022 by Slot-o-Matic (c) Tridium, Inc. 2012 */
  
  /** Ordinal value for allControlPoints. */
  public static final int ALL_CONTROL_POINTS = 0;
  /** Ordinal value for allDataPoints. */
  public static final int ALL_DATA_POINTS = 1;
  /** Ordinal value for taggedPoints. */
  public static final int TAGGED_POINTS = 2;
  /** Ordinal value for onlyFAL. */
  public static final int ONLY_FAL = 3;
  
  /** BHMIPointExportOptions constant for allControlPoints. */
  public static final BHMIPointExportOptions allControlPoints = new BHMIPointExportOptions(ALL_CONTROL_POINTS);
  /** BHMIPointExportOptions constant for allDataPoints. */
  public static final BHMIPointExportOptions allDataPoints = new BHMIPointExportOptions(ALL_DATA_POINTS);
  /** BHMIPointExportOptions constant for taggedPoints. */
  public static final BHMIPointExportOptions taggedPoints = new BHMIPointExportOptions(TAGGED_POINTS);
  /** BHMIPointExportOptions constant for onlyFAL. */
  public static final BHMIPointExportOptions onlyFAL = new BHMIPointExportOptions(ONLY_FAL);
  
  /** Factory method with ordinal. */
  public static BHMIPointExportOptions make(int ordinal)
  {
    return (BHMIPointExportOptions)allControlPoints.getRange().get(ordinal, false);
  }
  
  /** Factory method with tag. */
  public static BHMIPointExportOptions make(String tag)
  {
    return (BHMIPointExportOptions)allControlPoints.getRange().get(tag);
  }
  
  /** Private constructor. */
  private BHMIPointExportOptions(int ordinal)
  {
    super(ordinal);
  }
  
  public static final BHMIPointExportOptions DEFAULT = allDataPoints;

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BHMIPointExportOptions.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/
}
