/*
Copyright (c) 2022 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/
package com.honeywell.honplantcontroller.hmi.enums;

import javax.baja.nre.annotations.NiagaraEnum;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.nre.annotations.Range;
import javax.baja.sys.BFrozenEnum;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;


@NiagaraEnum(
    range = {
        @Range(value = "idle", ordinal = 0),
        @Range(value = "initializeBacnetNetwork", ordinal = 1),
        @Range(value = "exportPoints", ordinal = 2),
        @Range(value = "exportSchedulesAndCalendars", ordinal = 3),
        @Range(value = "completeCommission", ordinal = 4),
        @Range(value = "failedCommission", ordinal = 5),
        
    }
)

@SuppressWarnings({"squid:S1845"})
@NiagaraType
public final class BHonPlantControllerHMICommissionStateMaschine extends BFrozenEnum {
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.honeywell.honplantcontroller.hmi.enums.BHonPlantControllerHMICommisionStateMaschine(749084910)1.0$ @*/
/* Generated Fri Feb 25 10:36:31 CET 2022 by Slot-o-Matic (c) Tridium, Inc. 2012 */
  
  /** Ordinal value for idle. */
  public static final int IDLE = 0;
  /** Ordinal value for initializeBacnetNetwork. */
  public static final int INITIALIZE_BACNET_NETWORK = 1;
  /** Ordinal value for exportPoints. */
  public static final int EXPORT_POINTS = 2;
  /** Ordinal value for exportSchedulesAndCalendars. */
  public static final int EXPORT_SCHEDULES_AND_CALENDARS = 3;
  /** Ordinal value for completeCommission. */
  public static final int COMPLETE_COMMISSION = 4;
  /** Ordinal value for failedCommission. */
  public static final int FAILED_COMMISSION = 5;
  
  /** BHonPlantControllerHMICommisionStateMaschine constant for idle. */
  public static final BHonPlantControllerHMICommissionStateMaschine idle = new BHonPlantControllerHMICommissionStateMaschine(IDLE);
  /** BHonPlantControllerHMICommisionStateMaschine constant for initializeBacnetNetwork. */
  public static final BHonPlantControllerHMICommissionStateMaschine initializeBacnetNetwork = new BHonPlantControllerHMICommissionStateMaschine(INITIALIZE_BACNET_NETWORK);
  /** BHonPlantControllerHMICommisionStateMaschine constant for exportPoints. */
  public static final BHonPlantControllerHMICommissionStateMaschine exportPoints = new BHonPlantControllerHMICommissionStateMaschine(EXPORT_POINTS);
  /** BHonPlantControllerHMICommisionStateMaschine constant for exportSchedulesAndCalendars. */
  public static final BHonPlantControllerHMICommissionStateMaschine exportSchedulesAndCalendars = new BHonPlantControllerHMICommissionStateMaschine(EXPORT_SCHEDULES_AND_CALENDARS);
  /** BHonPlantControllerHMICommisionStateMaschine constant for completeCommission. */
  public static final BHonPlantControllerHMICommissionStateMaschine completeCommission = new BHonPlantControllerHMICommissionStateMaschine(COMPLETE_COMMISSION);
  /** BHonPlantControllerHMICommisionStateMaschine constant for failedCommission. */
  public static final BHonPlantControllerHMICommissionStateMaschine failedCommission = new BHonPlantControllerHMICommissionStateMaschine(FAILED_COMMISSION);
  
  /** Factory method with ordinal. */
  public static BHonPlantControllerHMICommissionStateMaschine make(int ordinal)
  {
    return (BHonPlantControllerHMICommissionStateMaschine)idle.getRange().get(ordinal, false);
  }
  
  /** Factory method with tag. */
  public static BHonPlantControllerHMICommissionStateMaschine make(String tag)
  {
    return (BHonPlantControllerHMICommissionStateMaschine)idle.getRange().get(tag);
  }
  
  /** Private constructor. */
  private BHonPlantControllerHMICommissionStateMaschine(int ordinal)
  {
    super(ordinal);
  }
  
  public static final BHonPlantControllerHMICommissionStateMaschine DEFAULT = idle;

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BHonPlantControllerHMICommissionStateMaschine.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/
    
}
