/*
Copyright (c) 2022 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/
package com.honeywell.honplantcontroller.hmi.messages;

import javax.baja.bacnet.datatypes.BBacnetUnsigned;
import javax.baja.nre.util.ByteBuffer;

import com.honeywell.honplantcontroller.hmi.utils.HonPlantControllerHMILogger;
import com.tridium.bacnet.asn.AsnInputStream;

public class RequestCertMessage {

    private int index = 0;

    public RequestCertMessage(byte[] bytes) {


        if (bytes == null || bytes.length <= 1) {
            return;
        }
        AsnInputStream asnInputStream  = new AsnInputStream(bytes);

        try {
            BBacnetUnsigned certIndex = asnInputStream.readUnsigned();

            index = certIndex.getInt();

        } catch (Exception e) {
        	HonPlantControllerHMILogger.finest(e.getMessage());
        }
    }

    /**
     * Retrieve message as raw byte array to be send over bacnet
     * @return byte array
     */
    public byte[] getBytes() {
        ByteBuffer dataBuffer = new ByteBuffer();
        dataBuffer.writeByte((byte)index);
        return dataBuffer.toByteArray();
    }
    public int getIndex() {return index;}
}
