/*
 *  Copyright (c) 2018 Honeywell International, Inc. All rights reserved.
 *
 *  This file contains trade secrets of Honeywell International, Inc.  No part 
 *  may be reproduced or transmitted in any form by any means or for any 
 *  purpose without the express written permission of Honeywell.
 */

/**
 * 
 * Requirement ID: 
 * @author H151723 - Yashswini Varangaonkar
 * @since 19 April 2023
 */


package com.honeywell.honplantcontroller.hmi.service;

import javax.baja.bacnet.BBacnetDevice;
import javax.baja.bacnet.config.BBacnetConfigDeviceExt;
import javax.baja.bacnet.datatypes.BBacnetAddress;
import javax.baja.bacnet.datatypes.BBacnetObjectIdentifier;
import javax.baja.nre.annotations.NiagaraProperty;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.sys.BBoolean;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

@NiagaraProperty(
		name = "hmiDeviceName",
				type = "baja:String",
			    defaultValue = "HMIDevice",
			    flags = Flags.HIDDEN | Flags.READONLY
		
				)


@NiagaraProperty(
		name = "enabled",
		type = "baja:Boolean",
		defaultValue = "BBoolean.TRUE",
		flags = Flags.HIDDEN | Flags.READONLY,
		override = true
)


@NiagaraProperty(name = "address", 
				type = "bacnet:BacnetAddress",
				defaultValue = "new BBacnetAddress()", 
				flags = Flags.HIDDEN  | Flags.READONLY ,
				override = true)

@NiagaraProperty(name = "config",
				 type = "bacnet:BacnetConfigDeviceExt",
				 defaultValue = "new BBacnetConfigDeviceExt()", 
				 flags = Flags.HIDDEN  | Flags.READONLY,
				 override = true)
 


@NiagaraType
public class BHMIDevice extends BBacnetDevice{
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.honeywell.honplantcontroller.hmi.service.BHMIDevice(2360428627)1.0$ @*/
/* Generated Mon Apr 24 20:01:41 IST 2023 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "hmiDeviceName"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code hmiDeviceName} property.
   * @see #getHmiDeviceName
   * @see #setHmiDeviceName
   */
  public static final Property hmiDeviceName = newProperty(Flags.HIDDEN | Flags.READONLY, "HMIDevice", null);
  
  /**
   * Get the {@code hmiDeviceName} property.
   * @see #hmiDeviceName
   */
  public String getHmiDeviceName() { return getString(hmiDeviceName); }
  
  /**
   * Set the {@code hmiDeviceName} property.
   * @see #hmiDeviceName
   */
  public void setHmiDeviceName(String v) { setString(hmiDeviceName, v, null); }

////////////////////////////////////////////////////////////////
// Property "enabled"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code enabled} property.
   * @see #getEnabled
   * @see #setEnabled
   */
  public static final Property enabled = newProperty(Flags.HIDDEN | Flags.READONLY, ((BBoolean)(BBoolean.TRUE)).getBoolean(), null);

////////////////////////////////////////////////////////////////
// Property "address"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code address} property.
   * @see #getAddress
   * @see #setAddress
   */
  public static final Property address = newProperty(Flags.HIDDEN | Flags.READONLY, new BBacnetAddress(), null);

////////////////////////////////////////////////////////////////
// Property "config"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code config} property.
   * @see #getConfig
   * @see #setConfig
   */
  public static final Property config = newProperty(Flags.HIDDEN | Flags.READONLY, new BBacnetConfigDeviceExt(), null);

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BHMIDevice.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/
  
 
	@Override
	public void started() throws Exception {
		super.started();

		getConfig().getDeviceObject().setFlags(getConfig().getDeviceObject().getSlot("objectId"), Flags.READONLY);

	}
 
}

