package com.honeywell.honplantcontroller.hmi.user.authenticator;


import javax.baja.authn.BAuthenticationScheme;
import javax.baja.authn.BPasswordAuthenticationScheme;
import javax.baja.nre.annotations.NiagaraProperty;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.security.BPassword;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BComplex;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.user.BUser;
import javax.baja.user.BUserService;

import com.honeywell.honplantcontroller.hmi.utils.HonPlantControllerHMILogger;
import com.tridium.user.BGlobalPasswordConfiguration;
import com.tridium.user.BUserPasswordConfiguration;

@NiagaraProperty(name = "forceResetAtNextLogin", type = "boolean", defaultValue = "false", override=true, flags=Flags.HIDDEN|Flags.READONLY)

@NiagaraType
public class BUserPinConfiguration
    extends BUserPasswordConfiguration
{
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.honeywell.honplantcontroller.hmi.user.authenticator.BUserPinConfiguration(3218421829)1.0$ @*/
/* Generated Fri Apr 15 18:51:24 IST 2022 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "forceResetAtNextLogin"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code forceResetAtNextLogin} property.
   * @see #getForceResetAtNextLogin
   * @see #setForceResetAtNextLogin
   */
  public static final Property forceResetAtNextLogin = newProperty(Flags.HIDDEN | Flags.READONLY, false, null);

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BUserPinConfiguration.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


  public void passwordModified(BPassword newPin) {
    try {

      if (!isMounted()) {
        return;
      }

      BComplex parent = getParent();
      if (!(parent instanceof BHonPlantControllerHMIAuthenticator)) {
        return;
      }

      BHonPlantControllerHMIAuthenticator auth = (BHonPlantControllerHMIAuthenticator) parent;


      if (!(auth.getParent() instanceof BUser)) {
        return;
      }

      BUser user = (BUser) auth.getParent();
      if (user.getParent() instanceof BUserService) {
        BAuthenticationScheme scheme = user.getAuthenticationScheme();
        //
        ///CLOVER:OFF
        if (scheme instanceof BPasswordAuthenticationScheme) {
          BPasswordAuthenticationScheme passScheme = (BPasswordAuthenticationScheme) scheme;
          BGlobalPasswordConfiguration passConfig = passScheme.getGlobalPasswordConfiguration();

          if (!getExpiration().isNull()) {
            setExpiration(BAbsTime.now().add(passConfig.getExpirationInterval()));
          }
        }
        ///CLOVER:ON
      }

      BPassword pin = newPin;
      if(!getPasswordHistory().contains(user.getUsername(),  pin)) {
        setPasswordHistory(getPasswordHistory().add(user.getUsername(), pin));
      }

    }
    catch (Exception ex) {
    	HonPlantControllerHMILogger.warning(ex.getMessage());
    }
  }
}
