/*
Copyright (c) 2022 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/
package com.honeywell.honplantcontroller.hmi.util;

import javax.baja.naming.BOrd;
import javax.baja.nre.annotations.NiagaraProperty;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.sys.BComponent;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

@NiagaraProperty(
        name = "pointOrd", type = "BOrd", defaultValue = "BOrd.make(\"station:|slot:\")"
)
@NiagaraProperty(
        name = "exportFAL",
        type = "boolean",
        defaultValue = "true"
)
@NiagaraProperty(
        name = "exportObject",
        type = "boolean",
        defaultValue = "true"
)
@NiagaraProperty(
        name = "exportSchedule",
        type = "boolean",
        defaultValue = "true"
)
@NiagaraProperty(
        name = "exportCalendar",
        type = "boolean",
        defaultValue = "true")

@NiagaraType
public class BBacnetFastAccessListExportProperties extends BComponent {
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.honeywell.honplantcontroller.hmi.util.BBacnetFastAccessListExportProperties(1819247847)1.0$ @*/
/* Generated Sun Feb 27 18:03:56 CET 2022 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "pointOrd"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code pointOrd} property.
   * @see #getPointOrd
   * @see #setPointOrd
   */
  public static final Property pointOrd = newProperty(0, BOrd.make("station:|slot:"), null);
  
  /**
   * Get the {@code pointOrd} property.
   * @see #pointOrd
   */
  public BOrd getPointOrd() { return (BOrd)get(pointOrd); }
  
  /**
   * Set the {@code pointOrd} property.
   * @see #pointOrd
   */
  public void setPointOrd(BOrd v) { set(pointOrd, v, null); }

////////////////////////////////////////////////////////////////
// Property "exportFAL"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code exportFAL} property.
   * @see #getExportFAL
   * @see #setExportFAL
   */
  public static final Property exportFAL = newProperty(0, true, null);
  
  /**
   * Get the {@code exportFAL} property.
   * @see #exportFAL
   */
  public boolean getExportFAL() { return getBoolean(exportFAL); }
  
  /**
   * Set the {@code exportFAL} property.
   * @see #exportFAL
   */
  public void setExportFAL(boolean v) { setBoolean(exportFAL, v, null); }

////////////////////////////////////////////////////////////////
// Property "exportObject"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code exportObject} property.
   * @see #getExportObject
   * @see #setExportObject
   */
  public static final Property exportObject = newProperty(0, true, null);
  
  /**
   * Get the {@code exportObject} property.
   * @see #exportObject
   */
  public boolean getExportObject() { return getBoolean(exportObject); }
  
  /**
   * Set the {@code exportObject} property.
   * @see #exportObject
   */
  public void setExportObject(boolean v) { setBoolean(exportObject, v, null); }

////////////////////////////////////////////////////////////////
// Property "exportSchedule"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code exportSchedule} property.
   * @see #getExportSchedule
   * @see #setExportSchedule
   */
  public static final Property exportSchedule = newProperty(0, true, null);
  
  /**
   * Get the {@code exportSchedule} property.
   * @see #exportSchedule
   */
  public boolean getExportSchedule() { return getBoolean(exportSchedule); }
  
  /**
   * Set the {@code exportSchedule} property.
   * @see #exportSchedule
   */
  public void setExportSchedule(boolean v) { setBoolean(exportSchedule, v, null); }

////////////////////////////////////////////////////////////////
// Property "exportCalendar"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code exportCalendar} property.
   * @see #getExportCalendar
   * @see #setExportCalendar
   */
  public static final Property exportCalendar = newProperty(0, true, null);
  
  /**
   * Get the {@code exportCalendar} property.
   * @see #exportCalendar
   */
  public boolean getExportCalendar() { return getBoolean(exportCalendar); }
  
  /**
   * Set the {@code exportCalendar} property.
   * @see #exportCalendar
   */
  public void setExportCalendar(boolean v) { setBoolean(exportCalendar, v, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BBacnetFastAccessListExportProperties.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/
}
