/*
 *  Copyright (c) 2022 Honeywell International, Inc. All rights reserved.
 *
 *  This file contains trade secrets of Honeywell International, Inc.  No part 
 *  may be reproduced or transmitted in any form by any means or for any 
 *  purpose without the express written permission of Honeywell.
 */

package com.honeywell.honplantcontroller.hmi.utils;

import javax.baja.bacnet.io.AsnException;

import com.tridium.bacnet.asn.AsnOutputStream;
import com.tridium.bacnet.services.BacnetError;
import com.tridium.bacnet.services.confirmed.ConfirmedPrivateTransferRequest;

public class HMIConfirmedPrivateTransferRequest extends ConfirmedPrivateTransferRequest {

    private long vendorId;
    private long serviceNumber;
    private byte[] serviceParameters;

    public HMIConfirmedPrivateTransferRequest(long vendorId, long serviceNumber, byte[] serviceParameters) {
        super(vendorId, serviceNumber, serviceParameters);
        this.vendorId = vendorId;
        this.serviceNumber = serviceNumber;
        this.serviceParameters = serviceParameters;
    }

    @Override
    public void writeEncoded(AsnOutputStream outputStream) {
        outputStream.writeUnsignedInteger(0, this.vendorId);
        outputStream.writeUnsignedInteger(1, this.serviceNumber);
        outputStream.write(this.serviceParameters);
    }

    public BacnetError doParseError(int errorChoice, byte[] encodedError) throws AsnException {
        return super.doParseError(errorChoice, encodedError);
    }
}
