/*
Copyright (c) 2022 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/
package com.honeywell.honplantcontroller.hmi.utils;

import javax.baja.bacnet.datatypes.BErrorType;
import javax.baja.bacnet.enums.BBacnetErrorClass;
import javax.baja.bacnet.enums.BBacnetErrorCode;
import javax.baja.bacnet.io.ErrorException;

public class HonPlantControllerBacnetErrorFactory {
    
    private HonPlantControllerBacnetErrorFactory() {

    }

    public static ErrorException makeAlarmDbError() {
        return new ErrorException(new BErrorType(BBacnetErrorClass.RESOURCES, BBacnetErrorCode.INTERNAL_ERROR)); 
    } 

    public static ErrorException makeInvalidIndicesError() {
        return new ErrorException(new BErrorType(BBacnetErrorClass.RESOURCES, BBacnetErrorCode.INVALID_ARRAY_INDEX)); 
    }
}
