/*
Copyright (c) 2022 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/
package com.honeywell.honplantcontroller.hmi.view;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.logging.Level;

import javax.baja.control.BControlPoint;
import javax.baja.naming.BOrd;
import javax.baja.naming.SlotPath;
import javax.baja.nre.annotations.Facet;
import javax.baja.nre.annotations.NiagaraAction;
import javax.baja.nre.annotations.NiagaraProperty;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.query.BQueryResult;
import javax.baja.sys.Action;
import javax.baja.sys.BComplex;
import javax.baja.sys.BComponent;
import javax.baja.sys.BFacets;
import javax.baja.sys.BIcon;
import javax.baja.sys.BInteger;
import javax.baja.sys.BObject;
import javax.baja.sys.BValue;
import javax.baja.sys.BVector;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.LocalizableRuntimeException;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.tag.Id;
import javax.baja.util.BFormat;

import com.honeywell.honplantcontroller.hmi.enums.BHMISyncStatus;
import com.honeywell.honplantcontroller.hmi.limitations.HonHMILimitations;
import com.honeywell.honplantcontroller.hmi.service.BHonPlantControllerHMI;
import com.honeywell.honplantcontroller.hmi.utils.HonPlantControllerHMILogger;
import com.honeywell.honplantcontroller.hmi.util.HonPlantControllerFastAccessListUtils;

@NiagaraProperty(
        name="objectsList",
        type="BVector",
        defaultValue = "new BVector()",
        flags= Flags.HIDDEN
)

@NiagaraProperty(
        name="updateIntervalMillis",
        type="long",
        defaultValue = "15000",
        flags= Flags.HIDDEN | Flags.TRANSIENT,
        facets = {
                @Facet(name="BFacets.MIN", value="BInteger.make(5000)"),
                @Facet(name="BFacets.MAX", value= "BInteger.make(120000)")
        },
        override = true

)

@NiagaraProperty(
        name="pointName",
        type="BFormat",
        defaultValue = "BFormat.make(\"%displayName%\")"
)

@NiagaraProperty(
        name = "syncStatus",
        type = "BHMISyncStatus",
        defaultValue = "BHMISyncStatus.DEFAULT",
        flags = Flags.HIDDEN | Flags.READONLY
)

@NiagaraAction(
        name="addObject",
        parameterType = "BComponent",
        defaultValue = "new BComponent()",
        flags= Flags.HIDDEN
)

@NiagaraAction(
        name="removeObject",
        parameterType = "BComponent",
        defaultValue = "new BComponent()",
        flags= Flags.HIDDEN
)

@NiagaraAction(
        name="syncObjectList",
        flags= Flags.HIDDEN
)


@SuppressWarnings({"squid:S1845"})
@NiagaraType
public class BFastAccessList extends BHMIView {
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.honeywell.honplantcontroller.hmi.view.BFastAccessList(302943004)1.0$ @*/
/* Generated Thu Aug 04 14:44:50 CEST 2022 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "objectsList"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code objectsList} property.
   * @see #getObjectsList
   * @see #setObjectsList
   */
  public static final Property objectsList = newProperty(Flags.HIDDEN, new BVector(), null);
  
  /**
   * Get the {@code objectsList} property.
   * @see #objectsList
   */
  public BVector getObjectsList() { return (BVector)get(objectsList); }
  
  /**
   * Set the {@code objectsList} property.
   * @see #objectsList
   */
  public void setObjectsList(BVector v) { set(objectsList, v, null); }

////////////////////////////////////////////////////////////////
// Property "updateIntervalMillis"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code updateIntervalMillis} property.
   * @see #getUpdateIntervalMillis
   * @see #setUpdateIntervalMillis
   */
  public static final Property updateIntervalMillis = newProperty(Flags.HIDDEN | Flags.TRANSIENT, 15000, BFacets.make(BFacets.make(BFacets.MIN, BInteger.make(5000)), BFacets.make(BFacets.MAX, BInteger.make(120000))));

////////////////////////////////////////////////////////////////
// Property "pointName"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code pointName} property.
   * @see #getPointName
   * @see #setPointName
   */
  public static final Property pointName = newProperty(0, BFormat.make("%displayName%"), null);
  
  /**
   * Get the {@code pointName} property.
   * @see #pointName
   */
  public BFormat getPointName() { return (BFormat)get(pointName); }
  
  /**
   * Set the {@code pointName} property.
   * @see #pointName
   */
  public void setPointName(BFormat v) { set(pointName, v, null); }

////////////////////////////////////////////////////////////////
// Property "syncStatus"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code syncStatus} property.
   * @see #getSyncStatus
   * @see #setSyncStatus
   */
  public static final Property syncStatus = newProperty(Flags.HIDDEN | Flags.READONLY, BHMISyncStatus.DEFAULT, null);
  
  /**
   * Get the {@code syncStatus} property.
   * @see #syncStatus
   */
  public BHMISyncStatus getSyncStatus() { return (BHMISyncStatus)get(syncStatus); }
  
  /**
   * Set the {@code syncStatus} property.
   * @see #syncStatus
   */
  public void setSyncStatus(BHMISyncStatus v) { set(syncStatus, v, null); }

////////////////////////////////////////////////////////////////
// Action "addObject"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code addObject} action.
   * @see #addObject(BComponent parameter)
   */
  public static final Action addObject = newAction(Flags.HIDDEN, new BComponent(), null);
  
  /**
   * Invoke the {@code addObject} action.
   * @see #addObject
   */
  public void addObject(BComponent parameter) { invoke(addObject, parameter, null); }

////////////////////////////////////////////////////////////////
// Action "removeObject"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code removeObject} action.
   * @see #removeObject(BComponent parameter)
   */
  public static final Action removeObject = newAction(Flags.HIDDEN, new BComponent(), null);
  
  /**
   * Invoke the {@code removeObject} action.
   * @see #removeObject
   */
  public void removeObject(BComponent parameter) { invoke(removeObject, parameter, null); }

////////////////////////////////////////////////////////////////
// Action "syncObjectList"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code syncObjectList} action.
   * @see #syncObjectList()
   */
  public static final Action syncObjectList = newAction(Flags.HIDDEN, null);
  
  /**
   * Invoke the {@code syncObjectList} action.
   * @see #syncObjectList
   */
  public void syncObjectList() { invoke(syncObjectList, null, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BFastAccessList.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  @Override
  public void changed(Property property, Context context) {
	  if(property == syncStatus && getSyncStatus().getOrdinal() == BHMISyncStatus.OUT_OF_SYNC) {
		  updateFALStatusInHMIDevice();
	  }
  }

  private void updateFALStatusInHMIDevice() {
	if(!Sys.isStation() || !Sys.atSteadyState())
		return;
	
	BComplex falHome = getParent();
	if(!(falHome instanceof BHonPlantControllerFALHome))
		return;
	
	BComplex home = falHome.getParent();
	if(!(home instanceof BHonPlantControllerHome))
		return;
	
	BComplex hmiDevice= home.getParent();
	if(!(hmiDevice instanceof BHonPlantControllerHMI))
		return;
	
	((BHonPlantControllerHMI)hmiDevice).setFalSyncStatus(BHMISyncStatus.outOfSync);
  }

public String makeHmiDisplayName(BComponent comp)
  {
    if(comp instanceof BControlPoint)
    {
      return getPointName().format(comp);
    }
    else
    { // must be a reference point
      try
      {
        BOrd ord = (BOrd)comp.get("pointOrd");
        BControlPoint  point = (BControlPoint) ord.resolve(Sys.getStation()).get();
        return getPointName().format(point);
      }
      catch(Exception ex) { ; }
    }
    return comp.getDisplayName(null);
  }
  /*
  private BFalAssignment[] getAssignments()
  {
    if(_assignments == null)
    {
      syncObjectList();

      BFalAssignment[] rAssignments = getObjectsList().getChildren(BFalAssignment.class);
      ArrayList<BFalAssignment> list = new ArrayList<BFalAssignment>();
      String sNameFilter = getNameFilter().replace("*", ".*");

      for(int i=0; i<rAssignments.length;i++)
      {
        BObject obj = rAssignments[i].getObjectOrd().resolve(Sys.getStation()).get();
        if(obj != null && obj instanceof BComponent)
        {
          if(sNameFilter.equals(".*") || makeMmiDisplayName((BComponent) obj).matches(sNameFilter))
            list.add(rAssignments[i]);
        }
      }

      _assignments = list.toArray(new BFalAssignment[list.size()]);
    }

    return _assignments;
  }*/

  @Override
  public boolean isParentLegal(BComponent parent)
  {
    return parent instanceof BHonPlantControllerFALHome;
  }

  @Override
  public final void checkAdd(String name, BValue value, int flags, BFacets facets, Context context)
  {
    if(context != null && context == Context.decoding)
    {
      return;
    }

    if(!isRunning())
    {
      return;
    }

    throw new LocalizableRuntimeException("honPlantControllerHMI", "BFastAccessList.NoChildrenBelowFAL");
  }

  ///CLOVER:OFF
  @Override
  public BIcon getIcon()
  {
    return icon;
  }
  ///CLOVER:ON

  /**
   * checks if object is valid to assign to fast access list
   * @param obj
   * @return valid to assign
   */
	public boolean isValidToAssign(BObject obj) {
		if (!(obj instanceof BComponent))
			return false;

		if (obj instanceof BControlPoint || (obj.getType().toString().startsWith("clIOcreation:")
				&& obj.getType().toString().contains("Ref")
				&& (obj.getType().toString().endsWith("Point") || obj.getType().toString().endsWith("Writable")))) {
			try {
				return checkIfObjectFromSameStationSpace((BComponent) obj);
			} catch (Exception e) {
				return true;
			}
		}
		return false;
	}

	private boolean checkIfObjectFromSameStationSpace(BComponent component) {
		// handles if component dropped from palette
		Type typeOfComponentBeforeBeingDropped = component.getType();
		BComponent t = (BComponent) component.getHandleOrd().resolve(this).get();
		Type typeOfComponentAfterBeingDropped = t.getType();
		if (!typeOfComponentBeforeBeingDropped.equals(typeOfComponentAfterBeingDropped)) {
			return false;
		}
		// handles if component dropped from different station
		String componentOrd = getComponentBase(component);
		String currentOrd = getComponentBase((BComponent)this);
		return componentOrd.equals(currentOrd);
	}
  
	private String getComponentBase(BComponent comp) {
		String componentOrd = comp.getAbsoluteOrd().toString();
		int index1 = componentOrd.indexOf(comp.getHandleOrd().toString());
		componentOrd = componentOrd.substring(0, index1 - 2);
		return componentOrd;
	}
  
  public void doAddObject(BComponent obj)
  {
    // This can unfortunately not be tested because the exception is not is not populated to the test. 
    // If you have a nice idea how this is accomplished go ahead BFastAccessTest#testExceedLimit
    ///CLOVER:OFF
    if (hasPointLimitExceeded()) {
      throw new LocalizableRuntimeException("honPlantControllerHMI", "BFastAccessList.points.limit.exceeded");
    }
    ///COLVER:ON

    try
    {
      if(!isValidToAssign(obj))
      {
        return;
      }

      BOrd ord = obj.getHandleOrd();

      BVector objectList = getObjectsList();
      BFalAssignment entry = new BFalAssignment(ord);

      if(objectList.get(SlotPath.escape(ord.toString())) != null)
      {
        return;
      }

      objectList.add(SlotPath.escape(ord.toString()), entry);

      HonPlantControllerFastAccessListUtils.addTag((BComponent) ord.resolve(Sys.getStation()).get(), _tagIdFALname, getDisplayName(null)); //resolve otherwise AddTag doesn't work !!!
      setSyncStatus(BHMISyncStatus.outOfSync);
    }
    catch(Exception ex)
    {
    	HonPlantControllerHMILogger.finest(ex.getMessage());
    }
  }

  public void addObjectWithNoStatusUpdate(BComponent obj)
  {
    // This can unfortunately not be tested because the exception is not is not populated to the test. 
    // If you have a nice idea how this is accomplished go ahead BFastAccessTest#testExceedLimit
    ///CLOVER:OFF
    if (hasPointLimitExceeded()) {
      throw new LocalizableRuntimeException("honPlantControllerHMI", "BFastAccessList.points.limit.exceeded");
    }
    ///COLVER:ON

    try
    {
      if(!isValidToAssign(obj))
      {
        return;
      }

      BOrd ord = obj.getHandleOrd();

      BVector objectList = getObjectsList();
      BFalAssignment entry = new BFalAssignment(ord);

      if(objectList.get(SlotPath.escape(ord.toString())) != null)
      {
        return;
      }

      objectList.add(SlotPath.escape(ord.toString()), entry);

      HonPlantControllerFastAccessListUtils.addTag((BComponent) ord.resolve(Sys.getStation()).get(), _tagIdFALname, getDisplayName(null)); //resolve otherwise AddTag doesn't work !!!
    }
    catch(Exception ex)
    {
    	HonPlantControllerHMILogger.finest(ex.getMessage());
    }
  }


  public void doRemoveObject(BComponent obj)
  {
    HonPlantControllerHMILogger.finest("BFastAccessList.doRemoveObject obj: " + obj.getHandleOrd());

    try
    {
      if(!isValidToAssign(obj))
      {
        return;
      }

      BVector objectList = getObjectsList();

      BOrd ord = obj.getHandleOrd();

      objectList.remove(SlotPath.escape(ord.toString()));
      // Will remove Tag when only single Point is deleted from Fast Access List
      HonPlantControllerFastAccessListUtils.removeTag((BComponent) ord.resolve(Sys.getStation()).get(), _tagIdFALname, getDisplayName(null)); //resolve otherwise RemoveTag doesn't work !!!

      // Will remove Tag when complete Fast Access List is removed
      HonPlantControllerFastAccessListUtils.removeTag(obj, _tagIdFALname, getDisplayName(null)); //resolve otherwise RemoveTag doesn't work !!!
      setSyncStatus(BHMISyncStatus.outOfSync);
    }
    catch(Exception ex)
    {
      HonPlantControllerHMILogger.finest(ex.getMessage());
    }
  }

  public void removeObjectWithNoStatusUpdate(BComponent obj)
  {
    HonPlantControllerHMILogger.finest("BFastAccessList.removeObjectWithNoStatusUpdate(" + this.getName() + ") obj: " + obj.getHandleOrd() + " : " + obj.getName());

    try
    {
      if(!isValidToAssign(obj))
      {
    	  HonPlantControllerHMILogger.finest("Invalid obj type");
        return;
      }

      BVector objectList = getObjectsList();

      BOrd ord = obj.getHandleOrd();
      HonPlantControllerHMILogger.finest("BFastAccessList.removeObjectWithNoStatusUpdate" + ord);
      objectList.remove(SlotPath.escape(ord.toString()));
      HonPlantControllerHMILogger.finest("BFastAccessList.removeObjectWithNoStatusUpdate: removed " + ord);

      // Will remove Tag when only single Point is deleted from Fast Access List
      HonPlantControllerFastAccessListUtils.removeTag((BComponent) ord.resolve(Sys.getStation()).get(), _tagIdFALname, getDisplayName(null)); //resolve otherwise RemoveTag doesn't work !!!

      // Will remove Tag when complete Fast Access List is removed
      HonPlantControllerFastAccessListUtils.removeTag(obj, _tagIdFALname, getDisplayName(null)); //resolve otherwise RemoveTag doesn't work !!!
    }
    catch(Exception ex)
    {
    	HonPlantControllerHMILogger.finest(ex.getMessage());
    }
  }

  public void updateTags()
  {
    if(_lastDisplayName.equals(getDisplayName(null)))
    {
      return;
    }

    BVector objectsList = getObjectsList();
    BComponent[] children = objectsList.getChildComponents();
    for(int i=0; i<children.length; i++)
    {
      BComponent child = children[i];
      if(child instanceof BFalAssignment)
      {
        try
        {
          BObject obj = ((BFalAssignment)child).getObjectOrd().get(objectsList);
          if(obj != null)
          {
            HonPlantControllerFastAccessListUtils.updateTag((BComponent) obj, _tagIdFALname, _lastDisplayName, getDisplayName(null));
          }
        }
        catch(Exception ex)
        {
        }
      }
    }
    _lastDisplayName = getDisplayName(null);
  }
  
  public void removeTags() {
	  HonPlantControllerHMILogger.checkAndLog(Level.FINEST,
	      "[BFastAccessList.removeTags] remove Tags of element = " + getDisplayName(null));
	  BVector objectsList = getObjectsList();
	  BComponent[] children = objectsList.getChildComponents();
	  for(int i=0; i<children.length; i++)
	  {
	    BComponent child = children[i];
	    if(child instanceof BFalAssignment)
	    {
	      try
	      {
	        BObject obj = ((BFalAssignment)child).getObjectOrd().get(objectsList);
	        if(obj != null)
	        {
	          HonPlantControllerHMILogger.checkAndLog(Level.FINEST,
	              "[BFastAccessList.removeTags] object = " + ((BComponent) obj).getName());
	          HonPlantControllerFastAccessListUtils.removeTag((BComponent) obj, _tagIdFALname, getDisplayName(null));
	        }
	      }
	      catch(Exception ex)
	      {
	        HonPlantControllerHMILogger.finest("[BFastAccessList.removeTags] object = " + ex.getMessage());
	      }
	    }
	  }
	}
  
  private void fillObjectsWithTag(BOrd query, ArrayList<BComponent> objectsWithTag)
  {
    BQueryResult result = (BQueryResult)query.get(Sys.getStation());

    result.stream().forEach(obj->
    {
      if(obj instanceof BComponent && isValidToAssign((BComponent)obj))
      {
        if(!objectsWithTag.contains(obj))
      {
        objectsWithTag.add((BComponent) obj);
      }
      }
    });
  }

  public void doSyncObjectList()
  {
    //remove deleted entries (ObjectList)
    BVector objsList = getObjectsList();
    BComponent[] children = objsList.getChildComponents();
    ArrayList<BComponent> curObjList = new ArrayList<>();
    
    for (int i = 0; i < children.length; i++)
    {
      boolean remove = true;
      BComponent child = children[i];
      if(child instanceof BFalAssignment)
      {
        try
        {
          BObject obj = ((BFalAssignment)child).getObjectOrd().get(objsList);
          if(obj != null)
          {
            remove = false;
          }
        }
        catch(Exception ex)
        {
        }
      }

      if(remove)
        objsList.remove(child);
      else
      {
        BObject obj = ((BFalAssignment)child).getObjectOrd().get(Sys.getStation());
        if(obj != null)
        {
          curObjList.add((BComponent) obj);
        }
      }
    }

    //add tagged entries
    ArrayList<BComponent> objectsWithTag = new ArrayList<>();

    /*
     * The query to get the tagged Component needs to be split across multiple queries because
     * with the current regular expression support in NEQL it is not possible to distinguish the following 
     * Scenario:
     * Component_1[hon:FALname] => $2;a;b;c
     * Component_2[hon:FALname] => a;b;3$2;c
     * Component_3[hon:FALname] => a;b;c$2
     * 
     * with an query lik ".*$2.* also Component_3 would be part of the result which is wrong.
     * 
     * Therefore the query is split to find component if
     * 1. the name is the only entry e.g. [$2].
     * 2. the name is at the end of the list e.g. [a;c;v;$2].
     * 3. the name ist at the start of the list e.g. [$2;a;c;v].
     * 4. the name is somewhere in the middle of the list e.g. [a;$2;c;v].
     * 
     */
    
    BOrd onlyEntryQuery = BOrd.make(MessageFormat.format("neql: {0} like \"{1}\"", _tagIdFALname, escape(getDisplayName(null))));
    fillObjectsWithTag(onlyEntryQuery, objectsWithTag);

    BOrd lastEntryQuery = BOrd.make(MessageFormat.format("neql: {0} like \".*;{1}\"", _tagIdFALname, escape(getDisplayName(null))));
    fillObjectsWithTag(lastEntryQuery, objectsWithTag);

    BOrd firstEntryQuery = BOrd.make(MessageFormat.format("neql: {0} like \"{1};.*\"", _tagIdFALname, escape(getDisplayName(null))));
    fillObjectsWithTag(firstEntryQuery, objectsWithTag);

    BOrd middleEntryQuery = BOrd.make(MessageFormat.format("neql: {0} like \".*;{1};.*\"", _tagIdFALname, escape(getDisplayName(null))));
    fillObjectsWithTag(middleEntryQuery, objectsWithTag);

    for(BComponent obj : objectsWithTag)
    {
      if(!curObjList.contains(obj))
      {
        curObjList.add(obj);
        addObject(obj);
      }
    }

    //remove untagged entries
    for(int i=0; i<curObjList.size(); i++)
    {
      BComponent obj = curObjList.get(i);

      if(!objectsWithTag.contains(obj))
      {
        removeObject(obj);
      }
    }
  }

  @Override
  public void descendantsStarted() throws Exception
  {
    super.descendantsStarted();

    if(!isRunning())
    {
      return;
    }

    _lastDisplayName = getDisplayName(null);
  }

  /**
   * Will escape all characters which are used in a regular expression.
   * <p>
   * Example: 
   * <pre>
   * escape("$22*11") -> "/$22/*11";
   * escape("(02)Test") -> "\(02\)Test"
   * </pre>
   * 
   * 
   * @param str String to be escaped.
   * @return escaped string or null if passed string is null or empty string if passed string is empty.
   */
  private String escape(String str) {
    
    if (null == str) {
      return null;
    }
    
    if (str.isEmpty()) {
      return "";
    }
    
    StringBuilder builder = new StringBuilder();
    for (char character : str.toCharArray()) {
      if (isSpecialCharacter(character)) {
        builder.append("\\").append(character);
      }
      else {
        builder.append(character);
      }
    }
    return builder.toString();
  }
  
  /**
   * Checks if the character passed to the method is one of the following:
   * <pre>
   *     '$', '.', '^', '|', '+', '*', '(', ')', '[', ']', '{', '}'
   * </pre>
   * @param character char which will be checked.
   * @return {@code true} if the character is one of the mentioned characters and {@code false} if not.
   */
  private boolean isSpecialCharacter(char character) {
    // TODO check if where is already any method that checks that, otherwise update this method to fix future issues.
    return (
      character == '$' || character == '.' ||
      character == '^' || character == '|' ||
      character == '+' || character == '*' ||
      character == '(' || character == ')' ||
      character == '[' || character == ']' || 
      character == '{' || character == '}'
    );
  }

  public void resetSyncStatus() {
    setSyncStatus(BHMISyncStatus.inSync);
  }


  public boolean hasPointLimitExceeded() {
    return getObjectsList().getChildren(BFalAssignment.class).length >= HonHMILimitations.getMaxNumberOfPointsPerFastAccessList();
  }

  private static final BIcon icon = BIcon.make("module://icons/x16/detailsView.png");
  public static final Id _tagIdFALname = Id.newId("hon:FALname");

  private String _lastDisplayName = "";

}
