
/*
Copyright (c) 2022 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/
package com.honeywell.honplantcontroller.hmi.view;

import javax.baja.nre.annotations.NiagaraProperty;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.sys.BIcon;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.util.Lexicon;

import com.honeywell.honplantcontroller.hmi.enums.BHMISyncStatus;


@NiagaraProperty(
        name = "childrenCreated",
        type = "boolean",
        defaultValue = "false",
        flags = Flags.HIDDEN
)

@NiagaraProperty(
        name = "fastAccessLists",
        type = "BHonPlantControllerFALHome",
        defaultValue = "new BHonPlantControllerFALHome()"
)

@NiagaraType
public class BHonPlantControllerHome extends BHMIView {
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.honeywell.honplantcontroller.hmi.view.BHonPlantControllerHome(3426537124)1.0$ @*/
/* Generated Wed Jun 29 11:35:10 CEST 2022 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "childrenCreated"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code childrenCreated} property.
   * @see #getChildrenCreated
   * @see #setChildrenCreated
   */
  public static final Property childrenCreated = newProperty(Flags.HIDDEN, false, null);
  
  /**
   * Get the {@code childrenCreated} property.
   * @see #childrenCreated
   */
  public boolean getChildrenCreated() { return getBoolean(childrenCreated); }
  
  /**
   * Set the {@code childrenCreated} property.
   * @see #childrenCreated
   */
  public void setChildrenCreated(boolean v) { setBoolean(childrenCreated, v, null); }

////////////////////////////////////////////////////////////////
// Property "fastAccessLists"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code fastAccessLists} property.
   * @see #getFastAccessLists
   * @see #setFastAccessLists
   */
  public static final Property fastAccessLists = newProperty(0, new BHonPlantControllerFALHome(), null);
  
  /**
   * Get the {@code fastAccessLists} property.
   * @see #fastAccessLists
   */
  public BHonPlantControllerFALHome getFastAccessLists() { return (BHonPlantControllerFALHome)get(fastAccessLists); }
  
  /**
   * Set the {@code fastAccessLists} property.
   * @see #fastAccessLists
   */
  public void setFastAccessLists(BHonPlantControllerFALHome v) { set(fastAccessLists, v, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BHonPlantControllerHome.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


  @Override
  public void started() throws Exception
  {
    super.started();

    if(!getChildrenCreated())
    {
      removeAll();

//      BHonPlantControllerFALHome fals = new BHonPlantControllerFALHome();
//      Property prop = add("fastAccessLists", fals);
//      setDisplayName(prop, BFormat.make(LEX.get("view_home_fals", "Fast Access Lists")), null);
//      //fals.setMmiImage(BMmiImageEnum.star);
//
//      BFastAccessList fal = new BFastAccessList();
//      prop = fals.add("fastAccessList", fal);
//      fals.setDisplayName(prop, BFormat.make(LEX.get("view_fals_fal", "Fast Access List")), null);
      /*
      BMenu alarms = new BMenu();
      prop = add("alarms", alarms);
      setDisplayName(prop, BFormat.make(LEX.get("view_home_alarms")), null);
      alarms.setMmiImage(BMmiImageEnum.alarms);

      BDataPointList pointsInAlarm = new BDataPointList();
      prop = alarms.add("pointsInAlarm", pointsInAlarm);
      alarms.setDisplayName(prop, BFormat.make(LEX.get("view_alarms_pointsInAlarm")), null);
      pointsInAlarm.setListType(BDataPointListTypeEnum.pointsInAlarm);

      BAlarmList alarmList = new BAlarmList();
      prop = alarms.add("alarmList", alarmList);
      alarms.setDisplayName(prop, BFormat.make(LEX.get("view_alarms_alarmList")), null);

      BMenu general = new BMenu();
      prop = add("menu", general);
      setDisplayName(prop, BFormat.make(LEX.get("view_home_general")), null);
      general.setMmiImage(BMmiImageEnum.menu);

      BDataPointList pointsInManual = new BDataPointList();
      prop = general.add("pointsInManual", pointsInManual);
      general.setDisplayName(prop, BFormat.make(LEX.get("view_general_pointsInManual")), null);
      pointsInManual.setListType(BDataPointListTypeEnum.overwrittenPoints);

      BDataPointList stationPointList = new BDataPointList();
      prop = general.add("stationPointList", stationPointList);
      general.setDisplayName(prop, BFormat.make(LEX.get("view_general_stationPointList")), null);
      stationPointList.setListType(BDataPointListTypeEnum.allPoints);

      BControllerSettings settings = new BControllerSettings();
      prop = general.add("settings", settings);
      general.setDisplayName(prop, BFormat.make(LEX.get("view_general_controllerSettings")), null);

      BControllerInformation info = new BControllerInformation();
      prop = general.add("info", info);
      general.setDisplayName(prop, BFormat.make(LEX.get("view_general_controllerInformation")), null);

      BMenu login = new BLoginUserOptions();
      prop = add("login", login);
      setDisplayName(prop, BFormat.make(LEX.get("view_home_login")), null);
      login.setMmiImage(BMmiImageEnum.none);
      */
      setChildrenCreated(true);
    }
  }

  @Override
  public BIcon getIcon()
  {
    return icon;
  }


  public BHMISyncStatus getFALSyncStatus() {
    BHonPlantControllerFALHome falHome = getFastAccessLists();

    return falHome.getFALSyncStatus();
  }

  public void resetFALSyncStatus() {
    getFastAccessLists().resetFALSyncStatus();
  }

  private static final BIcon icon = BIcon.make("module://icons/x16/home.png");
  private static final Lexicon LEX = Lexicon.make(BHonPlantControllerHome.class);
}

