/*******************************************************************************
Automatically generated file
Created by 'Control Macro Library Conversion Tool'
Creation time: 01.12.2020 17:27
Copyright (C) Honeywell GmbH D-71101 Schoenaich 2020
*******************************************************************************/

package cl.hvac.chiller;

import javax.baja.status.*;
import javax.baja.sys.*;
import javax.baja.units.*;
import cl.hvac.*;
import cl.hvac.base.*;

/*==============================================================================
Macro name:    SQA_ChillerSeq
Macro id:      6247347688713486541
Macro version: 173
Last change:   26.02.2019 - 10:48
Access Level:  2
Inputs:
  [1] Load1_Status
  [2] Load1_Alarm
  [3] Load2_Status
  [4] Load2_Alarm
  [5] Load3_Status
  [6] Load3_Alarm
  [7] Req_NoLoads
  [8] CommInput
  [9] Reset
  [10] Enable
Outputs:
  [1] Load1Cmd
  [2] Load2Cmd
  [3] Load3Cmd
  [4] GroupFeedbackSig
  [5] CommOutput
  [6] DispOpLoads
  [7] Load1_AlarmOut
  [8] Load2_AlarmOut
  [9] Load3_AlarmOut
Parameter:
  [1] SEQ-01: input signal for number of loads
  [2] SEQ-02: staging up delay
  [3] SEQ-03: staging down delay
  [4] SEQ-04: take over transition function
  [5] SEQ-05: number of stages per load output
  [6] SEQ-06: output control
  [7] SEQ-07: sequence overwrite
  [8] CYC-01: sequence rotation
  [9] CYC-02: type of changeover
  [10] CYC-03: period of change over
  [11] CYC-04: day of change over
  [12] CYC-05: time of change over
  [13] CYC-06: max. runtime difference
  [14] ALM-01: delay status alarm load1
  [15] ALM-02: delay status alarm load2
  [16] ALM-03: delay status alarm load3
  [17] ALM-04: reset 0=manual
  [18] ALM-05: failure change-over delay
  [19] POS-01: sequence load1; 0 = disable
  [20] POS-02: sequence load2; 0 = disable
  [21] POS-03: sequence load3; 0 = disable
  [22] POS-04: sequence load4; 0 = disable
  [23] POS-05: sequence load5; 0 = disable
  [24] POS-06: sequence load6; 0 = disable
  [25] POS-07: sequence load7; 0 = disable
  [26] POS-08: sequence load8; 0 = disable
  [27] POS-09: sequence load9; 0 = disable
  [28] POS-10: sequence load10; 0 = disable
  [29] POS-11: sequence load11; 0 = disable
  [30] POS-12: sequence load12; 0 = disable
  [31] POS-13: AdjustNoLoads
  [32] RUNT-01: runtime load1
  [33] RUNT-02: runtime load2
  [34] RUNT-03: runtime load3
  [35] RUNT-04: runtime load4
  [36] RUNT-05: runtime load5
  [37] RUNT-06: runtime load6
  [38] RUNT-07: runtime load7
  [39] RUNT-08: runtime load8
  [40] RUNT-09: runtime load9
  [41] RUNT-10: runtime load10
  [42] RUNT-11: runtime load11
  [43] RUNT-12: runtime load12
  [44] SYS-01: use group feedback signal
  [45] DISP-01: next to start load
  [46] DISP-02: next to stop load
Description:
The sequencer macro SQA_ChillerSeq is a general purpose module. It can be used to sequence up to 3 loads. In combination with the sequencer add on module „SQB_ChillerSeqAddOn“, the number of outputs can be extended up to 12 loads. The loads can be chillers, pumps, fans, or even complete cooling towers. The sequence order can be changed on the basis of one of the following conditions:
 * time rotation
 * load rotation ( first on - first off )
 * run-time rotation
================================================================================*/

public class BCmSQA_ChillerSeq
  extends BControlFunctionSupport
  implements IEnvironment
{
  public void doExecute()
  {
    if (getEnabledIn().getBoolean())
    {
      Execute( );
      if (getCmSQA_ChillerSeq_output_8().getStatus() == BStatus.disabled)
        setOutputStatusOk();
    }
    else
    {
      setOutputStatusDisabled();
    }
  }

  public void setOutputStatusDisabled()
  {
    getCmSQA_ChillerSeq_output_8().setStatus(BStatus.disabled);
    getCmSQA_ChillerSeq_output_9().setStatus(BStatus.disabled);
    getCmSQA_ChillerSeq_output_10().setStatus(BStatus.disabled);
    getCmSQA_ChillerSeq_output_11().setStatus(BStatus.disabled);
    getCmSQA_ChillerSeq_output_12().setStatus(BStatus.disabled);
    getCmSQA_ChillerSeq_output_13().setStatus(BStatus.disabled);
    getCmSQA_ChillerSeq_output_8316().setStatus(BStatus.disabled);
    getCmSQA_ChillerSeq_output_8317().setStatus(BStatus.disabled);
    getCmSQA_ChillerSeq_output_8318().setStatus(BStatus.disabled);
  }

  public void setOutputStatusOk()
  {
    getCmSQA_ChillerSeq_output_8().setStatus(BStatus.ok);
    getCmSQA_ChillerSeq_output_9().setStatus(BStatus.ok);
    getCmSQA_ChillerSeq_output_10().setStatus(BStatus.ok);
    getCmSQA_ChillerSeq_output_11().setStatus(BStatus.ok);
    getCmSQA_ChillerSeq_output_12().setStatus(BStatus.ok);
    getCmSQA_ChillerSeq_output_13().setStatus(BStatus.ok);
    getCmSQA_ChillerSeq_output_8316().setStatus(BStatus.ok);
    getCmSQA_ChillerSeq_output_8317().setStatus(BStatus.ok);
    getCmSQA_ChillerSeq_output_8318().setStatus(BStatus.ok);
  }

  void Execute( )
  {
    // cycle time calculation
    long ticks = ControlFunction.GetSystemTicks();
    lastCycleTime = (float)(ticks - lastSystemTicks) / 1000.0F;
    lastSystemTicks = ticks;

    // [9773] Function call CfNot
    func_9773.input = ControlFunction.GetStartupFlag();
    func_9773.Execute(  );

    // [9771] Function call CfAnd
    func_9771.input[0] = getCmSQA_ChillerSeq_input_6().getValue();
    func_9771.input[1] = func_9773.output;
    func_9771.Execute(  );

    // [72] Function call CfIdt
    func_72.input = register_325;
    func_72.Execute(  );

    // [73] Function call CfIdt
    func_73.input = register_326;
    func_73.Execute(  );

    // [74] Function call CfIdt
    func_74.input = register_327;
    func_74.Execute(  );

    // [75] Function call CfIdt
    func_75.input = register_328;
    func_75.Execute(  );

    // [76] Function call CfIdt
    func_76.input = register_329;
    func_76.Execute(  );

    // [77] Function call CfIdt
    func_77.input = register_330;
    func_77.Execute(  );

    // [78] Function call CfIdt
    func_78.input = register_331;
    func_78.Execute(  );

    // [79] Function call CfIdt
    func_79.input = register_332;
    func_79.Execute(  );

    // [80] Function call CfIdt
    func_80.input = register_333;
    func_80.Execute(  );

    // [81] Function call CfIdt
    func_81.input = register_334;
    func_81.Execute(  );

    // [82] Function call CfIdt
    func_82.input = register_335;
    func_82.Execute(  );

    // [83] Function call CfIdt
    func_83.input = register_336;
    func_83.Execute(  );

    // [84] Function call CfIdt
    func_84.input = register_311;
    func_84.Execute(  );

    // [85] Function call CfIdt
    func_85.input = register_312;
    func_85.Execute(  );

    // [86] Function call CfIdt
    func_86.input = register_313;
    func_86.Execute(  );

    // [87] Function call CfIdt
    func_87.input = func_6055.CmCommInputProc_output_188;
    func_87.Execute(  );

    // [88] Function call CfIdt
    func_88.input = func_6055.CmCommInputProc_output_189;
    func_88.Execute(  );

    // [89] Function call CfIdt
    func_89.input = func_6055.CmCommInputProc_output_190;
    func_89.Execute(  );

    // [90] Function call CfIdt
    func_90.input = func_6055.CmCommInputProc_output_191;
    func_90.Execute(  );

    // [91] Function call CfIdt
    func_91.input = func_6055.CmCommInputProc_output_192;
    func_91.Execute(  );

    // [92] Function call CfIdt
    func_92.input = func_6055.CmCommInputProc_output_193;
    func_92.Execute(  );

    // [93] Function call CfIdt
    func_93.input = func_6055.CmCommInputProc_output_194;
    func_93.Execute(  );

    // [94] Function call CfIdt
    func_94.input = func_6055.CmCommInputProc_output_195;
    func_94.Execute(  );

    // [95] Function call CfIdt
    func_95.input = func_6055.CmCommInputProc_output_196;
    func_95.Execute(  );

    // [101] Function call CfInputMultiplexer
    func_101.inputSelect = FloatToInt(func_84.output[0]);
    func_101.input[1-1] = func_72.output[0];
    func_101.input[2-1] = 0F;
    func_101.Execute(  );

    // [102] Function call CfInputMultiplexer
    func_102.inputSelect = FloatToInt(func_85.output[0]);
    func_102.input[1-1] = func_73.output[0];
    func_102.input[2-1] = 0F;
    func_102.Execute(  );

    // [103] Function call CfInputMultiplexer
    func_103.inputSelect = FloatToInt(func_86.output[0]);
    func_103.input[1-1] = func_74.output[0];
    func_103.input[2-1] = 0F;
    func_103.Execute(  );

    // [104] Function call CfInputMultiplexer
    func_104.inputSelect = FloatToInt(func_87.output[0]);
    func_104.input[1-1] = func_75.output[0];
    func_104.input[2-1] = 0F;
    func_104.Execute(  );

    // [105] Function call CfInputMultiplexer
    func_105.inputSelect = FloatToInt(func_88.output[0]);
    func_105.input[1-1] = func_76.output[0];
    func_105.input[2-1] = 0F;
    func_105.Execute(  );

    // [106] Function call CfInputMultiplexer
    func_106.inputSelect = FloatToInt(func_89.output[0]);
    func_106.input[1-1] = func_77.output[0];
    func_106.input[2-1] = 0F;
    func_106.Execute(  );

    // [107] Function call CfInputMultiplexer
    func_107.inputSelect = FloatToInt(func_90.output[0]);
    func_107.input[1-1] = func_78.output[0];
    func_107.input[2-1] = 0F;
    func_107.Execute(  );

    // [108] Function call CfInputMultiplexer
    func_108.inputSelect = FloatToInt(func_91.output[0]);
    func_108.input[1-1] = func_79.output[0];
    func_108.input[2-1] = 0F;
    func_108.Execute(  );

    // [109] Function call CfInputMultiplexer
    func_109.inputSelect = FloatToInt(func_92.output[0]);
    func_109.input[1-1] = func_80.output[0];
    func_109.input[2-1] = 0F;
    func_109.Execute(  );

    // [110] Function call CfInputMultiplexer
    func_110.inputSelect = FloatToInt(func_93.output[0]);
    func_110.input[1-1] = func_81.output[0];
    func_110.input[2-1] = 0F;
    func_110.Execute(  );

    // [111] Function call CfInputMultiplexer
    func_111.inputSelect = FloatToInt(func_94.output[0]);
    func_111.input[1-1] = func_82.output[0];
    func_111.input[2-1] = 0F;
    func_111.Execute(  );

    // [112] Function call CfInputMultiplexer
    func_112.inputSelect = FloatToInt(func_95.output[0]);
    func_112.input[1-1] = func_83.output[0];
    func_112.input[2-1] = 0F;
    func_112.Execute(  );

    // [113] Function call CfAddition
    func_113.input[0] = func_84.output[0];
    func_113.input[1] = func_85.output[0];
    func_113.input[2] = func_86.output[0];
    func_113.input[3] = func_87.output[0];
    func_113.input[4] = func_88.output[0];
    func_113.input[5] = func_89.output[0];
    func_113.input[6] = func_90.output[0];
    func_113.input[7] = func_91.output[0];
    func_113.input[8] = func_92.output[0];
    func_113.input[9] = func_93.output[0];
    func_113.input[10] = func_94.output[0];
    func_113.input[11] = func_95.output[0];
    func_113.Execute(  );

    // [116] Function call CfIdt
    func_116.input = func_101.output;
    func_116.Execute(  );
    register_325 = func_116.output[0];

    // [117] Function call CfIdt
    func_117.input = func_102.output;
    func_117.Execute(  );
    register_326 = func_117.output[0];

    // [118] Function call CfIdt
    func_118.input = func_103.output;
    func_118.Execute(  );
    register_327 = func_118.output[0];

    // [119] Function call CfIdt
    func_119.input = func_104.output;
    func_119.Execute(  );
    register_328 = func_119.output[0];

    // [120] Function call CfIdt
    func_120.input = func_105.output;
    func_120.Execute(  );
    register_329 = func_120.output[0];

    // [121] Function call CfIdt
    func_121.input = func_106.output;
    func_121.Execute(  );
    register_330 = func_121.output[0];

    // [122] Function call CfIdt
    func_122.input = func_107.output;
    func_122.Execute(  );
    register_331 = func_122.output[0];

    // [123] Function call CfIdt
    func_123.input = func_108.output;
    func_123.Execute(  );
    register_332 = func_123.output[0];

    // [124] Function call CfIdt
    func_124.input = func_109.output;
    func_124.Execute(  );
    register_333 = func_124.output[0];

    // [125] Function call CfIdt
    func_125.input = func_110.output;
    func_125.Execute(  );
    register_334 = func_125.output[0];

    // [126] Function call CfIdt
    func_126.input = func_111.output;
    func_126.Execute(  );
    register_335 = func_126.output[0];

    // [127] Function call CfIdt
    func_127.input = func_112.output;
    func_127.Execute(  );
    register_336 = func_127.output[0];

    // [128] Function call CfIdt
    func_128.input = func_113.output;
    func_128.Execute(  );

    // [5924] Function call CfIdt
    func_5924.input = func_5927.output[0];
    func_5924.Execute(  );

    // [5925] Function call CfAddition
    func_5925.input[0] = func_5924.output[0];
    func_5925.input[1] = 1F;
    func_5925.Execute(  );

    // [5926] Function call CfMinimum
    func_5926.input[0] = func_5925.output;
    func_5926.input[1] = 10F;
    func_5926.Execute(  );

    // [5927] Function call CfIdt
    func_5927.input = func_5926.output;
    func_5927.Execute(  );

    // [221] Function call CfEqual
    func_221.input = 2;
    func_221.inputCompare[1-1] = FloatToInt((float) getCmSQA_ChillerSeq_parameter_15());
    func_221.Execute(  );

    // [9093] Macro call CmFlank_Pulse
    func_9093.CmFlank_Pulse_input_10 = ControlFunction.GetStartupFlag();
    func_9093.Execute(  );

    // [9140] Function call CfLastValue
    func_9140.input = (float) getCmSQA_ChillerSeq_parameter_9098();
    func_9140.Execute(  );

    // [9137] Function call CfCompare1
    func_9137.inputA = func_9140.outputCurrent;
    func_9137.inputB = func_9140.outputLast;
    func_9137.Execute(  );

    // [9096] Function call CfOr
    func_9096.input[0] = func_9093.CmFlank_Pulse_output_12;
    func_9096.input[1] = func_9137.outputGreater;
    func_9096.input[2] = func_9137.outputLess;
    func_9096.Execute(  );

    // [9149] Function call CfInputMultiplexer
    func_9149.inputSelect = BooleanToInt(func_9096.outputOR);
    func_9149.input[1-1] = func_9149.output;
    func_9149.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_9098();
    func_9149.Execute(  );

    // [9150] Function call CfInputMultiplexer
    func_9150.inputSelect = BooleanToInt(func_9096.outputOR);
    func_9150.input[1-1] = func_9150.output;
    func_9150.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_9098();
    func_9150.Execute(  );

    // [9146] Function call CfInputMultiplexer
    func_9146.inputSelect = BooleanToInt(func_9096.outputOR);
    func_9146.input[1-1] = register_279;
    func_9146.input[2-1] = 0F;
    func_9146.Execute(  );
    register_279 = func_9146.output;

    // [9147] Function call CfInputMultiplexer
    func_9147.inputSelect = BooleanToInt(func_9096.outputOR);
    func_9147.input[1-1] = func_9147.output;
    func_9147.input[2-1] = 0F;
    func_9147.Execute(  );

    // [222] Function call CfIdt
    func_222.input = register_311;
    func_222.Execute(  );

    // [223] Function call CfIdt
    func_223.input = register_312;
    func_223.Execute(  );

    // [224] Function call CfIdt
    func_224.input = register_313;
    func_224.Execute(  );

    // [225] Function call CfIdt
    func_225.input = func_6055.CmCommInputProc_output_188;
    func_225.Execute(  );

    // [226] Function call CfIdt
    func_226.input = func_6055.CmCommInputProc_output_189;
    func_226.Execute(  );

    // [227] Function call CfIdt
    func_227.input = func_6055.CmCommInputProc_output_190;
    func_227.Execute(  );

    // [228] Function call CfIdt
    func_228.input = func_6055.CmCommInputProc_output_191;
    func_228.Execute(  );

    // [229] Function call CfIdt
    func_229.input = func_6055.CmCommInputProc_output_192;
    func_229.Execute(  );

    // [230] Function call CfIdt
    func_230.input = func_6055.CmCommInputProc_output_193;
    func_230.Execute(  );

    // [231] Function call CfIdt
    func_231.input = func_6055.CmCommInputProc_output_194;
    func_231.Execute(  );

    // [232] Function call CfIdt
    func_232.input = func_6055.CmCommInputProc_output_195;
    func_232.Execute(  );

    // [233] Function call CfIdt
    func_233.input = func_6055.CmCommInputProc_output_196;
    func_233.Execute(  );

    // [248] Function call CfIdt
    func_248.input = func_9150.output;
    func_248.Execute(  );

    // [249] Function call CfAnd
    func_249.input[0] = func_221.output;
    func_249.input[1] = FloatToBoolean(func_222.output[0]);
    func_249.Execute(  );

    // [250] Function call CfAnd
    func_250.input[0] = func_221.output;
    func_250.input[1] = FloatToBoolean(func_223.output[0]);
    func_250.Execute(  );

    // [251] Function call CfAnd
    func_251.input[0] = func_221.output;
    func_251.input[1] = FloatToBoolean(func_224.output[0]);
    func_251.Execute(  );

    // [252] Function call CfAnd
    func_252.input[0] = func_221.output;
    func_252.input[1] = FloatToBoolean(func_225.output[0]);
    func_252.Execute(  );

    // [253] Function call CfAnd
    func_253.input[0] = func_221.output;
    func_253.input[1] = FloatToBoolean(func_226.output[0]);
    func_253.Execute(  );

    // [254] Function call CfAnd
    func_254.input[0] = func_221.output;
    func_254.input[1] = FloatToBoolean(func_227.output[0]);
    func_254.Execute(  );

    // [255] Function call CfAnd
    func_255.input[0] = func_221.output;
    func_255.input[1] = FloatToBoolean(func_228.output[0]);
    func_255.Execute(  );

    // [256] Function call CfAnd
    func_256.input[0] = func_221.output;
    func_256.input[1] = FloatToBoolean(func_229.output[0]);
    func_256.Execute(  );

    // [257] Function call CfAnd
    func_257.input[0] = func_221.output;
    func_257.input[1] = FloatToBoolean(func_230.output[0]);
    func_257.Execute(  );

    // [258] Function call CfAnd
    func_258.input[0] = func_221.output;
    func_258.input[1] = FloatToBoolean(func_231.output[0]);
    func_258.Execute(  );

    // [259] Function call CfAnd
    func_259.input[0] = func_221.output;
    func_259.input[1] = FloatToBoolean(func_232.output[0]);
    func_259.Execute(  );

    // [260] Function call CfAnd
    func_260.input[0] = func_221.output;
    func_260.input[1] = FloatToBoolean(func_233.output[0]);
    func_260.Execute(  );

    // [265] Function call CfInputMultiplexer
    func_265.inputSelect = BooleanToInt(func_249.outputAND);
    func_265.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_33();
    func_265.input[2-1] = func_248.output[0];
    func_265.Execute(  );

    // [266] Function call CfInputMultiplexer
    func_266.inputSelect = BooleanToInt(func_250.outputAND);
    func_266.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_34();
    func_266.input[2-1] = func_248.output[0];
    func_266.Execute(  );

    // [267] Function call CfInputMultiplexer
    func_267.inputSelect = BooleanToInt(func_251.outputAND);
    func_267.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_35();
    func_267.input[2-1] = func_248.output[0];
    func_267.Execute(  );

    // [268] Function call CfInputMultiplexer
    func_268.inputSelect = BooleanToInt(func_252.outputAND);
    func_268.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_36();
    func_268.input[2-1] = func_248.output[0];
    func_268.Execute(  );

    // [269] Function call CfInputMultiplexer
    func_269.inputSelect = BooleanToInt(func_253.outputAND);
    func_269.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_37();
    func_269.input[2-1] = func_248.output[0];
    func_269.Execute(  );

    // [270] Function call CfInputMultiplexer
    func_270.inputSelect = BooleanToInt(func_254.outputAND);
    func_270.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_38();
    func_270.input[2-1] = func_248.output[0];
    func_270.Execute(  );

    // [271] Function call CfInputMultiplexer
    func_271.inputSelect = BooleanToInt(func_255.outputAND);
    func_271.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_39();
    func_271.input[2-1] = func_248.output[0];
    func_271.Execute(  );

    // [272] Function call CfInputMultiplexer
    func_272.inputSelect = BooleanToInt(func_256.outputAND);
    func_272.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_40();
    func_272.input[2-1] = func_248.output[0];
    func_272.Execute(  );

    // [273] Function call CfInputMultiplexer
    func_273.inputSelect = BooleanToInt(func_257.outputAND);
    func_273.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_41();
    func_273.input[2-1] = func_248.output[0];
    func_273.Execute(  );

    // [274] Function call CfInputMultiplexer
    func_274.inputSelect = BooleanToInt(func_258.outputAND);
    func_274.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_42();
    func_274.input[2-1] = func_248.output[0];
    func_274.Execute(  );

    // [275] Function call CfInputMultiplexer
    func_275.inputSelect = BooleanToInt(func_259.outputAND);
    func_275.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_43();
    func_275.input[2-1] = func_248.output[0];
    func_275.Execute(  );

    // [276] Function call CfInputMultiplexer
    func_276.inputSelect = BooleanToInt(func_260.outputAND);
    func_276.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_44();
    func_276.input[2-1] = func_248.output[0];
    func_276.Execute(  );

    // [279] Function call CfIdt
    func_279.input = func_265.output;
    func_279.Execute(  );
    register_293 = func_279.output[0];

    // [280] Function call CfIdt
    func_280.input = func_266.output;
    func_280.Execute(  );
    register_294 = func_280.output[0];

    // [281] Function call CfIdt
    func_281.input = func_267.output;
    func_281.Execute(  );
    register_295 = func_281.output[0];

    // [282] Function call CfIdt
    func_282.input = func_268.output;
    func_282.Execute(  );
    register_296 = func_282.output[0];

    // [283] Function call CfIdt
    func_283.input = func_269.output;
    func_283.Execute(  );
    register_297 = func_283.output[0];

    // [284] Function call CfIdt
    func_284.input = func_270.output;
    func_284.Execute(  );
    register_298 = func_284.output[0];

    // [285] Function call CfIdt
    func_285.input = func_271.output;
    func_285.Execute(  );
    register_299 = func_285.output[0];

    // [286] Function call CfIdt
    func_286.input = func_272.output;
    func_286.Execute(  );
    register_300 = func_286.output[0];

    // [287] Function call CfIdt
    func_287.input = func_273.output;
    func_287.Execute(  );
    register_301 = func_287.output[0];

    // [288] Function call CfIdt
    func_288.input = func_274.output;
    func_288.Execute(  );
    register_302 = func_288.output[0];

    // [289] Function call CfIdt
    func_289.input = func_275.output;
    func_289.Execute(  );
    register_303 = func_289.output[0];

    // [290] Function call CfIdt
    func_290.input = func_276.output;
    func_290.Execute(  );
    register_304 = func_290.output[0];

    // [291] Function call CfIdt
    func_291.input = func_265.output;
    func_291.Execute(  );
    setCmSQA_ChillerSeq_parameter_33(func_291.output[0]);

    // [292] Function call CfIdt
    func_292.input = func_266.output;
    func_292.Execute(  );
    setCmSQA_ChillerSeq_parameter_34(func_292.output[0]);

    // [293] Function call CfIdt
    func_293.input = func_267.output;
    func_293.Execute(  );
    setCmSQA_ChillerSeq_parameter_35(func_293.output[0]);

    // [294] Function call CfIdt
    func_294.input = func_268.output;
    func_294.Execute(  );
    setCmSQA_ChillerSeq_parameter_36(func_294.output[0]);

    // [295] Function call CfIdt
    func_295.input = func_269.output;
    func_295.Execute(  );
    setCmSQA_ChillerSeq_parameter_37(func_295.output[0]);

    // [296] Function call CfIdt
    func_296.input = func_270.output;
    func_296.Execute(  );
    setCmSQA_ChillerSeq_parameter_38(func_296.output[0]);

    // [297] Function call CfIdt
    func_297.input = func_271.output;
    func_297.Execute(  );
    setCmSQA_ChillerSeq_parameter_39(func_297.output[0]);

    // [298] Function call CfIdt
    func_298.input = func_272.output;
    func_298.Execute(  );
    setCmSQA_ChillerSeq_parameter_40(func_298.output[0]);

    // [299] Function call CfIdt
    func_299.input = func_273.output;
    func_299.Execute(  );
    setCmSQA_ChillerSeq_parameter_41(func_299.output[0]);

    // [300] Function call CfIdt
    func_300.input = func_274.output;
    func_300.Execute(  );
    setCmSQA_ChillerSeq_parameter_42(func_300.output[0]);

    // [301] Function call CfIdt
    func_301.input = func_275.output;
    func_301.Execute(  );
    setCmSQA_ChillerSeq_parameter_43(func_301.output[0]);

    // [302] Function call CfIdt
    func_302.input = func_276.output;
    func_302.Execute(  );
    setCmSQA_ChillerSeq_parameter_44(func_302.output[0]);

    // [6055] Macro call CmCommInputProc
    func_6055.CmCommInputProc_input_109 = (float) getCmSQA_ChillerSeq_input_5().getValue();
    func_6055.CmCommInputProc_input_115 = (float) getCmSQA_ChillerSeq_parameter_45();
    func_6055.CmCommInputProc_input_116 = (float) getCmSQA_ChillerSeq_parameter_46();
    func_6055.CmCommInputProc_input_117 = (float) getCmSQA_ChillerSeq_parameter_47();
    func_6055.CmCommInputProc_input_118 = (float) getCmSQA_ChillerSeq_parameter_48();
    func_6055.CmCommInputProc_input_119 = (float) getCmSQA_ChillerSeq_parameter_49();
    func_6055.CmCommInputProc_input_120 = (float) getCmSQA_ChillerSeq_parameter_50();
    func_6055.CmCommInputProc_input_121 = (float) getCmSQA_ChillerSeq_parameter_51();
    func_6055.CmCommInputProc_input_122 = (float) getCmSQA_ChillerSeq_parameter_52();
    func_6055.CmCommInputProc_input_123 = (float) getCmSQA_ChillerSeq_parameter_53();
    func_6055.CmCommInputProc_input_124 = (float) getCmSQA_ChillerSeq_parameter_54();
    func_6055.CmCommInputProc_input_125 = (float) getCmSQA_ChillerSeq_parameter_55();
    func_6055.CmCommInputProc_input_126 = (float) getCmSQA_ChillerSeq_parameter_56();
    func_6055.CmCommInputProc_input_127 = register_311;
    func_6055.CmCommInputProc_input_128 = register_312;
    func_6055.CmCommInputProc_input_129 = register_313;
    func_6055.CmCommInputProc_input_176 = func_6055.CmCommInputProc_output_188;
    func_6055.CmCommInputProc_input_177 = func_6055.CmCommInputProc_output_189;
    func_6055.CmCommInputProc_input_178 = func_6055.CmCommInputProc_output_190;
    func_6055.CmCommInputProc_input_179 = func_6055.CmCommInputProc_output_191;
    func_6055.CmCommInputProc_input_180 = func_6055.CmCommInputProc_output_192;
    func_6055.CmCommInputProc_input_181 = func_6055.CmCommInputProc_output_193;
    func_6055.CmCommInputProc_input_182 = func_6055.CmCommInputProc_output_194;
    func_6055.CmCommInputProc_input_183 = func_6055.CmCommInputProc_output_195;
    func_6055.CmCommInputProc_input_184 = func_6055.CmCommInputProc_output_196;
    func_6055.Execute( this, 0 );
    setCmSQA_ChillerSeq_parameter_48(func_6055.CmCommInputProc_output_133);
    setCmSQA_ChillerSeq_parameter_49(func_6055.CmCommInputProc_output_134);
    setCmSQA_ChillerSeq_parameter_50(func_6055.CmCommInputProc_output_135);
    setCmSQA_ChillerSeq_parameter_51(func_6055.CmCommInputProc_output_136);
    setCmSQA_ChillerSeq_parameter_52(func_6055.CmCommInputProc_output_137);
    setCmSQA_ChillerSeq_parameter_53(func_6055.CmCommInputProc_output_138);
    setCmSQA_ChillerSeq_parameter_54(func_6055.CmCommInputProc_output_139);
    setCmSQA_ChillerSeq_parameter_55(func_6055.CmCommInputProc_output_140);
    setCmSQA_ChillerSeq_parameter_56(func_6055.CmCommInputProc_output_141);
    register_311 = func_6055.CmCommInputProc_output_185;
    register_312 = func_6055.CmCommInputProc_output_186;
    register_313 = func_6055.CmCommInputProc_output_187;

    // [8342] Macro call CmFlank_Pulse
    func_8342.CmFlank_Pulse_input_10 = getCmSQA_ChillerSeq_input_7().getValue();
    func_8342.Execute(  );

    // [8336] Macro call CmAlarm_LD
    func_8336.CmAlarm_LD_input_2 = FloatToBoolean((float) getCmSQA_ChillerSeq_parameter_26());
    func_8336.CmAlarm_LD_input_3 = FloatToBoolean(register_311);
    func_8336.CmAlarm_LD_input_91 = FloatToBoolean((float) getCmSQA_ChillerSeq_input_1().getValue());
    func_8336.CmAlarm_LD_input_121 = getCmSQA_ChillerSeq_input_8313().getValue();
    func_8336.CmAlarm_LD_input_104 = FloatToBoolean((float) getCmSQA_ChillerSeq_output_8().getValue());
    func_8336.CmAlarm_LD_input_122 = (float) getCmSQA_ChillerSeq_parameter_23();
    func_8336.CmAlarm_LD_input_1 = func_8342.CmFlank_Pulse_output_11;
    func_8336.CmAlarm_LD_input_105 = FloatToBoolean((float) getCmSQA_ChillerSeq_parameter_5632());
    func_8336.Execute( this, 9 );
    register_311 = BooleanToFloat(func_8336.CmAlarm_LD_output_4);

    // [8338] Macro call CmAlarm_LD
    func_8338.CmAlarm_LD_input_2 = FloatToBoolean((float) getCmSQA_ChillerSeq_parameter_26());
    func_8338.CmAlarm_LD_input_3 = FloatToBoolean(register_312);
    func_8338.CmAlarm_LD_input_91 = FloatToBoolean((float) getCmSQA_ChillerSeq_input_2().getValue());
    func_8338.CmAlarm_LD_input_121 = getCmSQA_ChillerSeq_input_8314().getValue();
    func_8338.CmAlarm_LD_input_104 = FloatToBoolean((float) getCmSQA_ChillerSeq_output_9().getValue());
    func_8338.CmAlarm_LD_input_122 = (float) getCmSQA_ChillerSeq_parameter_24();
    func_8338.CmAlarm_LD_input_1 = func_8342.CmFlank_Pulse_output_11;
    func_8338.CmAlarm_LD_input_105 = FloatToBoolean((float) getCmSQA_ChillerSeq_parameter_5632());
    func_8338.Execute( this, 10 );
    register_312 = BooleanToFloat(func_8338.CmAlarm_LD_output_4);

    // [8340] Macro call CmAlarm_LD
    func_8340.CmAlarm_LD_input_2 = FloatToBoolean((float) getCmSQA_ChillerSeq_parameter_26());
    func_8340.CmAlarm_LD_input_3 = FloatToBoolean(register_313);
    func_8340.CmAlarm_LD_input_91 = FloatToBoolean((float) getCmSQA_ChillerSeq_input_3().getValue());
    func_8340.CmAlarm_LD_input_121 = getCmSQA_ChillerSeq_input_8315().getValue();
    func_8340.CmAlarm_LD_input_104 = FloatToBoolean((float) getCmSQA_ChillerSeq_output_10().getValue());
    func_8340.CmAlarm_LD_input_122 = (float) getCmSQA_ChillerSeq_parameter_25();
    func_8340.CmAlarm_LD_input_1 = func_8342.CmFlank_Pulse_output_11;
    func_8340.CmAlarm_LD_input_105 = FloatToBoolean((float) getCmSQA_ChillerSeq_parameter_5632());
    func_8340.Execute( this, 11 );
    register_313 = BooleanToFloat(func_8340.CmAlarm_LD_output_4);

    // [453] Function call CfIdt
    func_453.input = register_325;
    func_453.Execute(  );

    // [454] Function call CfIdt
    func_454.input = register_326;
    func_454.Execute(  );

    // [455] Function call CfIdt
    func_455.input = register_327;
    func_455.Execute(  );

    // [456] Function call CfIdt
    func_456.input = register_328;
    func_456.Execute(  );

    // [457] Function call CfIdt
    func_457.input = register_329;
    func_457.Execute(  );

    // [458] Function call CfIdt
    func_458.input = register_330;
    func_458.Execute(  );

    // [459] Function call CfIdt
    func_459.input = register_331;
    func_459.Execute(  );

    // [460] Function call CfIdt
    func_460.input = register_332;
    func_460.Execute(  );

    // [461] Function call CfIdt
    func_461.input = register_333;
    func_461.Execute(  );

    // [462] Function call CfIdt
    func_462.input = register_334;
    func_462.Execute(  );

    // [463] Function call CfIdt
    func_463.input = register_335;
    func_463.Execute(  );

    // [464] Function call CfIdt
    func_464.input = register_336;
    func_464.Execute(  );

    // [466] Function call CfAddition
    func_466.input[0] = func_453.output[0];
    func_466.input[1] = func_454.output[0];
    func_466.input[2] = func_455.output[0];
    func_466.input[3] = func_456.output[0];
    func_466.input[4] = func_457.output[0];
    func_466.input[5] = func_458.output[0];
    func_466.input[6] = func_459.output[0];
    func_466.input[7] = func_460.output[0];
    func_466.input[8] = func_461.output[0];
    func_466.input[9] = func_462.output[0];
    func_466.input[10] = func_463.output[0];
    func_466.input[11] = func_464.output[0];
    func_466.Execute(  );
    register_279 = func_466.output;

    // [493] Function call CfMultiply
    func_493.input[0] = (float) getCmSQA_ChillerSeq_parameter_30();
    func_493.input[1] = func_9150.output;
    func_493.Execute(  );

    // [495] Function call CfIdt
    func_495.input = func_597.output[0];
    func_495.Execute(  );

    // [6467] Function call CfCompare1
    func_6467.inputA = (float) getCmSQA_ChillerSeq_parameter_31();
    func_6467.inputB = 2F;
    func_6467.Execute(  );

    // [497] Function call CfInputMultiplexer
    func_497.inputSelect = BooleanToInt(func_6467.outputEqual);
    func_497.input[1-1] = func_493.output;
    func_497.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_30();
    func_497.Execute(  );

    // [498] Function call CfAddition
    func_498.input[0] = func_495.output[0];
    func_498.input[1] = 1F;
    func_498.Execute(  );

    // [499] Function call CfSubtract
    func_499.input[0] = func_495.output[0];
    func_499.input[1] = 1F;
    func_499.Execute(  );

    // [501] Function call CfIdt
    func_501.input = (float) getCmSQA_ChillerSeq_input_4().getValue();
    func_501.Execute(  );

    // [503] Function call CfMaximum
    func_503.input[0] = func_497.output;
    func_503.input[1] = 1F;
    func_503.Execute(  );

    // [504] Function call CfMultiply
    func_504.input[0] = func_498.output;
    func_504.input[1] = 100F;
    func_504.Execute(  );

    // [505] Function call CfMultiply
    func_505.input[0] = func_499.output;
    func_505.input[1] = 99F;
    func_505.Execute(  );

    // [6462] Function call CfCompare1
    func_6462.inputA = func_507.output[0];
    func_6462.inputB = 0F;
    func_6462.Execute(  );

    // [507] Function call CfIdt
    func_507.input = func_501.output[0];
    func_507.Execute(  );

    // [510] Function call CfCompare1
    func_510.inputA = func_501.output[0];
    func_510.inputB = 0F;
    func_510.Execute(  );

    // [513] Function call CfDivide
    func_513.inputA = func_504.output;
    func_513.inputB = func_503.output;
    func_513.Execute(  );

    // [514] Function call CfDivide
    func_514.inputA = func_505.output;
    func_514.inputB = func_503.output;
    func_514.Execute(  );

    // [519] Function call CfIdt
    func_519.input = func_597.output[0];
    func_519.Execute(  );

    // [524] Function call CfIdt
    func_524.input = func_597.output[0];
    func_524.Execute(  );

    // [6463] Function call CfCompare2
    func_6463.inputA = func_501.output[0];
    func_6463.inputB = 1F;
    func_6463.Execute(  );

    // [526] Function call CfAnd
    func_526.input[0] = func_6462.outputEqual;
    func_526.input[1] = func_6463.outputEqualOrGreater;
    func_526.Execute(  );

    // [527] Function call CfAnd
    func_527.input[0] = func_510.outputLess;
    func_527.input[1] = func_6462.outputEqual;
    func_527.Execute(  );

    // [529] Function call CfAddition
    func_529.input[0] = func_519.output[0];
    func_529.input[1] = 1F;
    func_529.Execute(  );

    // [530] Function call CfSubtract
    func_530.input[0] = func_519.output[0];
    func_530.input[1] = 1F;
    func_530.Execute(  );

    // [533] Function call CfAddition
    func_533.input[0] = func_524.output[0];
    func_533.input[1] = 1F;
    func_533.Execute(  );

    // [534] Function call CfSubtract
    func_534.input[0] = func_524.output[0];
    func_534.input[1] = 1F;
    func_534.Execute(  );

    // [538] Function call CfInputMultiplexer
    func_538.inputSelect = BooleanToInt(func_526.outputAND);
    func_538.input[1-1] = func_560.output[0];
    func_538.input[2-1] = func_529.output;
    func_538.Execute(  );

    // [6466] Function call CfCompare2
    func_6466.inputA = func_501.output[0];
    func_6466.inputB = func_513.output;
    func_6466.Execute(  );

    // [539] Function call CfInputMultiplexer
    func_539.inputSelect = BooleanToInt(func_6466.outputEqualOrGreater);
    func_539.input[1-1] = func_524.output[0];
    func_539.input[2-1] = func_533.output;
    func_539.Execute(  );

    // [541] Function call CfMultiply
    func_541.input[0] = (float) getCmSQA_ChillerSeq_parameter_30();
    func_541.input[1] = func_9150.output;
    func_541.Execute(  );

    // [544] Function call CfInputMultiplexer
    func_544.inputSelect = BooleanToInt(func_527.outputAND);
    func_544.input[1-1] = func_538.output;
    func_544.input[2-1] = func_530.output;
    func_544.Execute(  );

    // [6465] Function call CfCompare2
    func_6465.inputA = func_514.output;
    func_6465.inputB = func_501.output[0];
    func_6465.Execute(  );

    // [545] Function call CfInputMultiplexer
    func_545.inputSelect = BooleanToInt(func_6465.outputEqualOrGreater);
    func_545.input[1-1] = func_539.output;
    func_545.input[2-1] = func_534.output;
    func_545.Execute(  );

    // [6454] Function call CfCompare1
    func_6454.inputA = (float) getCmSQA_ChillerSeq_parameter_31();
    func_6454.inputB = 2F;
    func_6454.Execute(  );

    // [547] Function call CfInputMultiplexer
    func_547.inputSelect = BooleanToInt(func_6454.outputEqual);
    func_547.input[1-1] = func_541.output;
    func_547.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_30();
    func_547.Execute(  );

    // [548] Function call CfInputMultiplexer
    func_548.inputSelect = FloatToInt((float) getCmSQA_ChillerSeq_parameter_16());
    func_548.input[1-1] = (float) getCmSQA_ChillerSeq_input_4().getValue();
    func_548.input[2-1] = func_544.output;
    func_548.input[3-1] = func_545.output;
    func_548.Execute(  );

    // [551] Function call CfMinimum
    func_551.input[0] = func_547.output;
    func_551.input[1] = func_548.output;
    func_551.Execute(  );

    // [555] Function call CfMaximum
    func_555.input[0] = func_551.output;
    func_555.input[1] = 0F;
    func_555.Execute(  );

    // [5974] Function call CfNot
    func_5974.input = func_9771.outputAND;
    func_5974.Execute(  );

    // [556] Function call CfOr
    func_556.input[0] = false;
    func_556.input[1] = func_5974.output;
    func_556.Execute(  );

    // [558] Function call CfInputMultiplexer
    func_558.inputSelect = BooleanToInt(func_556.outputOR);
    func_558.input[1-1] = func_555.output;
    func_558.input[2-1] = 0F;
    func_558.Execute(  );

    // [560] Function call CfIdt
    func_560.input = func_558.output;
    func_560.Execute(  );

    // [564] Function call CfCompare1
    func_564.inputA = func_597.output[0];
    func_564.inputB = func_558.output;
    func_564.Execute(  );

    // [570] Function call CfSubtract
    func_570.input[0] = func_597.output[0];
    func_570.input[1] = 1F;
    func_570.Execute(  );

    // [572] Function call CfAddition
    func_572.input[0] = 1F;
    func_572.input[1] = func_597.output[0];
    func_572.Execute(  );

    // [575] Function call CfCompare1
    func_575.inputA = func_558.output;
    func_575.inputB = func_597.output[0];
    func_575.Execute(  );

    // [6502] Function call CfNot
    func_6502.input = FloatToBoolean(func_6534.output[0]);
    func_6502.Execute(  );

    // [580] Function call CfAnd
    func_580.input[0] = func_564.outputLess;
    func_580.input[1] = func_6502.output;
    func_580.Execute(  );

    // [585] Function call CfInputMultiplexer
    func_585.inputSelect = BooleanToInt(func_580.outputAND);
    func_585.input[1-1] = func_597.output[0];
    func_585.input[2-1] = func_572.output;
    func_585.Execute(  );

    // [6501] Function call CfNot
    func_6501.input = FloatToBoolean(func_6533.output[0]);
    func_6501.Execute(  );

    // [586] Function call CfAnd
    func_586.input[0] = func_6501.output;
    func_586.input[1] = func_575.outputLess;
    func_586.Execute(  );

    // [590] Function call CfInputMultiplexer
    func_590.inputSelect = BooleanToInt(func_586.outputAND);
    func_590.input[1-1] = func_585.output;
    func_590.input[2-1] = func_570.output;
    func_590.Execute(  );

    // [6500] Function call CfNot
    func_6500.input = func_9771.outputAND;
    func_6500.Execute(  );

    // [591] Function call CfOr
    func_591.input[0] = false;
    func_591.input[1] = func_6500.output;
    func_591.Execute(  );

    // [593] Function call CfInputMultiplexer
    func_593.inputSelect = BooleanToInt(func_591.outputOR);
    func_593.input[1-1] = func_590.output;
    func_593.input[2-1] = 0F;
    func_593.Execute(  );

    // [595] Function call CfIdt
    func_595.input = func_597.output[0];
    func_595.Execute(  );

    // [597] Function call CfIdt
    func_597.input = func_593.output;
    func_597.Execute(  );

    // [601] Function call CfMultiply
    func_601.input[0] = func_593.output;
    func_601.input[1] = func_9150.output;
    func_601.Execute(  );

    // [603] Function call CfCompare1
    func_603.inputA = func_595.output[0];
    func_603.inputB = func_593.output;
    func_603.Execute(  );

    // [604] Function call CfNot
    func_604.input = func_603.outputLess;
    func_604.Execute(  );

    // [605] Function call CfCompare1
    func_605.inputA = func_593.output;
    func_605.inputB = func_595.output[0];
    func_605.Execute(  );

    // [606] Function call CfNot
    func_606.input = func_605.outputLess;
    func_606.Execute(  );

    // [6531] Function call CfCompare1
    func_6531.inputA = (float) getCmSQA_ChillerSeq_parameter_31();
    func_6531.inputB = 2F;
    func_6531.Execute(  );

    // [609] Function call CfInputMultiplexer
    func_609.inputSelect = BooleanToInt(func_6531.outputEqual);
    func_609.input[1-1] = func_593.output;
    func_609.input[2-1] = func_601.output;
    func_609.Execute(  );

    // [615] Function call CfAddition
    func_615.input[0] = func_609.output;
    func_615.input[1] = (float) getCmSQA_ChillerSeq_input_1().getValue();
    func_615.input[2] = (float) getCmSQA_ChillerSeq_input_2().getValue();
    func_615.input[3] = (float) getCmSQA_ChillerSeq_input_3().getValue();
    func_615.Execute(  );

    // [627] Function call CfInputMultiplexer
    func_627.inputSelect = FloatToInt((float) getCmSQA_ChillerSeq_parameter_5632());
    func_627.input[1-1] = func_609.output;
    func_627.input[2-1] = func_615.output;
    func_627.Execute(  );

    // [6535] Function call CfNot
    func_6535.input = func_646.output;
    func_6535.Execute(  );

    // [628] Function call CfAnd
    func_628.input[0] = func_603.outputLess;
    func_628.input[1] = func_6535.output;
    func_628.Execute(  );

    // [629] Function call CfAnd
    func_629.input[0] = func_646.output;
    func_629.input[1] = func_604.output;
    func_629.Execute(  );

    // [6532] Function call CfNot
    func_6532.input = func_647.output;
    func_6532.Execute(  );

    // [630] Function call CfAnd
    func_630.input[0] = func_605.outputLess;
    func_630.input[1] = func_6532.output;
    func_630.Execute(  );

    // [631] Function call CfAnd
    func_631.input[0] = func_647.output;
    func_631.input[1] = func_606.output;
    func_631.Execute(  );

    // [633] Function call CfCompare1
    func_633.inputA = func_627.output;
    func_633.inputB = func_660.output[0];
    func_633.Execute(  );

    // [635] Function call CfCompare1
    func_635.inputA = func_660.output[0];
    func_635.inputB = func_627.output;
    func_635.Execute(  );

    // [637] Function call CfIdt
    func_637.input = (float) getCmSQA_ChillerSeq_parameter_27();
    func_637.Execute(  );
    setParameter(12, func_637.output[0]);

    // [638] Function call CfDelay
    func_638.inputA = func_629.outputAND;
    func_638.inputB = func_629.outputAND;
    func_638.Execute( this, 12 );

    // [639] Function call CfIdt
    func_639.input = (float) getCmSQA_ChillerSeq_parameter_28();
    func_639.Execute(  );
    setParameter(13, func_639.output[0]);

    // [640] Function call CfDelay
    func_640.inputA = func_631.outputAND;
    func_640.inputB = func_631.outputAND;
    func_640.Execute( this, 13 );

    // [646] Function call CfRsFlipFlop
    func_646.inputSet = func_628.outputAND;
    func_646.inputReset = func_638.outputDelayedA;
    func_646.Execute(  );

    // [6534] Function call CfIdt
    func_6534.input = BooleanToFloat(func_646.output);
    func_6534.Execute(  );

    // [647] Function call CfRsFlipFlop
    func_647.inputSet = func_630.outputAND;
    func_647.inputReset = func_640.outputDelayedA;
    func_647.Execute(  );

    // [6533] Function call CfIdt
    func_6533.input = BooleanToFloat(func_647.output);
    func_6533.Execute(  );

    // [650] Function call CfMultiply
    func_650.input[0] = -1F;
    func_650.input[1] = BooleanToFloat(func_633.outputLess);
    func_650.Execute(  );

    // [651] Function call CfMultiply
    func_651.input[0] = 1F;
    func_651.input[1] = BooleanToFloat(func_635.outputLess);
    func_651.Execute(  );

    // [655] Function call CfAddition
    func_655.input[0] = func_655.output;
    func_655.input[1] = func_650.output;
    func_655.input[2] = func_651.output;
    func_655.Execute(  );

    // [656] Function call CfIdt
    func_656.input = func_128.output[0];
    func_656.Execute(  );

    // [657] Function call CfIdt
    func_657.input = func_661.output[0];
    func_657.Execute(  );

    // [658] Function call CfIdt
    func_658.input = register_279;
    func_658.Execute(  );

    // [660] Function call CfIdt
    func_660.input = func_655.output;
    func_660.Execute(  );

    // [661] Function call CfIdt
    func_661.input = func_656.output[0];
    func_661.Execute(  );

    // [662] Function call CfCompare1
    func_662.inputA = func_657.output[0];
    func_662.inputB = func_656.output[0];
    func_662.Execute(  );

    // [663] Function call CfNot
    func_663.input = func_662.outputLess;
    func_663.Execute(  );

    // [664] Function call CfCompare1
    func_664.inputA = func_658.output[0];
    func_664.inputB = func_655.output;
    func_664.Execute(  );

    // [666] Function call CfCompare1
    func_666.inputA = func_655.output;
    func_666.inputB = func_658.output[0];
    func_666.Execute(  );

    // [6527] Function call CfNot
    func_6527.input = FloatToBoolean(func_6526.output[0]);
    func_6527.Execute(  );

    // [6528] Function call CfNot
    func_6528.input = FloatToBoolean(func_7572.output);
    func_6528.Execute(  );

    // [682] Function call CfAnd
    func_682.input[0] = func_664.outputLess;
    func_682.input[1] = func_6527.output;
    func_682.input[2] = func_6528.output;
    func_682.Execute(  );

    // [6525] Function call CfNot
    func_6525.input = func_704.output;
    func_6525.Execute(  );

    // [685] Function call CfAnd
    func_685.input[0] = func_662.outputLess;
    func_685.input[1] = func_6525.output;
    func_685.Execute(  );

    // [686] Function call CfAnd
    func_686.input[0] = func_704.output;
    func_686.input[1] = func_663.output;
    func_686.Execute(  );

    // [689] Function call CfIdt
    func_689.input = (float) getCmSQA_ChillerSeq_parameter_29();
    func_689.Execute(  );
    setParameter(14, func_689.output[0]);

    // [690] Function call CfDelay
    func_690.inputA = func_686.outputAND;
    func_690.inputB = func_686.outputAND;
    func_690.Execute( this, 14 );

    // [704] Function call CfRsFlipFlop
    func_704.inputSet = func_685.outputAND;
    func_704.inputReset = func_690.outputDelayedA;
    func_704.Execute(  );

    // [6526] Function call CfIdt
    func_6526.input = BooleanToFloat(func_704.output);
    func_6526.Execute(  );

    // [7104] Function call CfCompare2
    func_7104.inputA = register_325;
    func_7104.inputB = 1F;
    func_7104.Execute(  );

    // [731] Function call CfInputMultiplexer
    func_731.inputSelect = BooleanToInt(func_7104.outputEqualOrGreater);
    func_731.input[1-1] = 0F;
    func_731.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_45();
    func_731.Execute(  );

    // [7132] Function call CfCompare2
    func_7132.inputA = register_326;
    func_7132.inputB = 1F;
    func_7132.Execute(  );

    // [732] Function call CfInputMultiplexer
    func_732.inputSelect = BooleanToInt(func_7132.outputEqualOrGreater);
    func_732.input[1-1] = 0F;
    func_732.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_46();
    func_732.Execute(  );

    // [7135] Function call CfCompare2
    func_7135.inputA = register_327;
    func_7135.inputB = 1F;
    func_7135.Execute(  );

    // [733] Function call CfInputMultiplexer
    func_733.inputSelect = BooleanToInt(func_7135.outputEqualOrGreater);
    func_733.input[1-1] = 0F;
    func_733.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_47();
    func_733.Execute(  );

    // [7137] Function call CfCompare2
    func_7137.inputA = register_328;
    func_7137.inputB = 1F;
    func_7137.Execute(  );

    // [734] Function call CfInputMultiplexer
    func_734.inputSelect = BooleanToInt(func_7137.outputEqualOrGreater);
    func_734.input[1-1] = 0F;
    func_734.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_48();
    func_734.Execute(  );

    // [7139] Function call CfCompare2
    func_7139.inputA = register_329;
    func_7139.inputB = 1F;
    func_7139.Execute(  );

    // [735] Function call CfInputMultiplexer
    func_735.inputSelect = BooleanToInt(func_7139.outputEqualOrGreater);
    func_735.input[1-1] = 0F;
    func_735.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_49();
    func_735.Execute(  );

    // [7141] Function call CfCompare2
    func_7141.inputA = register_330;
    func_7141.inputB = 1F;
    func_7141.Execute(  );

    // [736] Function call CfInputMultiplexer
    func_736.inputSelect = BooleanToInt(func_7141.outputEqualOrGreater);
    func_736.input[1-1] = 0F;
    func_736.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_50();
    func_736.Execute(  );

    // [7143] Function call CfCompare2
    func_7143.inputA = register_331;
    func_7143.inputB = 1F;
    func_7143.Execute(  );

    // [737] Function call CfInputMultiplexer
    func_737.inputSelect = BooleanToInt(func_7143.outputEqualOrGreater);
    func_737.input[1-1] = 0F;
    func_737.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_51();
    func_737.Execute(  );

    // [7145] Function call CfCompare2
    func_7145.inputA = register_332;
    func_7145.inputB = 1F;
    func_7145.Execute(  );

    // [738] Function call CfInputMultiplexer
    func_738.inputSelect = BooleanToInt(func_7145.outputEqualOrGreater);
    func_738.input[1-1] = 0F;
    func_738.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_52();
    func_738.Execute(  );

    // [7146] Function call CfCompare2
    func_7146.inputA = register_333;
    func_7146.inputB = 1F;
    func_7146.Execute(  );

    // [739] Function call CfInputMultiplexer
    func_739.inputSelect = BooleanToInt(func_7146.outputEqualOrGreater);
    func_739.input[1-1] = 0F;
    func_739.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_53();
    func_739.Execute(  );

    // [7147] Function call CfCompare2
    func_7147.inputA = register_334;
    func_7147.inputB = 1F;
    func_7147.Execute(  );

    // [740] Function call CfInputMultiplexer
    func_740.inputSelect = BooleanToInt(func_7147.outputEqualOrGreater);
    func_740.input[1-1] = 0F;
    func_740.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_54();
    func_740.Execute(  );

    // [7148] Function call CfCompare2
    func_7148.inputA = register_335;
    func_7148.inputB = 1F;
    func_7148.Execute(  );

    // [741] Function call CfInputMultiplexer
    func_741.inputSelect = BooleanToInt(func_7148.outputEqualOrGreater);
    func_741.input[1-1] = 0F;
    func_741.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_55();
    func_741.Execute(  );

    // [7149] Function call CfCompare2
    func_7149.inputA = register_336;
    func_7149.inputB = 1F;
    func_7149.Execute(  );

    // [742] Function call CfInputMultiplexer
    func_742.inputSelect = BooleanToInt(func_7149.outputEqualOrGreater);
    func_742.input[1-1] = 0F;
    func_742.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_56();
    func_742.Execute(  );

    // [7133] Function call CfCompare1
    func_7133.inputA = (float) getCmSQA_ChillerSeq_parameter_33();
    func_7133.inputB = 0F;
    func_7133.Execute(  );

    // [768] Function call CfOr
    func_768.input[0] = func_7104.outputEqualOrGreater;
    func_768.input[1] = FloatToBoolean(register_311);
    func_768.input[2] = func_7133.outputEqual;
    func_768.Execute(  );

    // [7134] Function call CfCompare1
    func_7134.inputA = (float) getCmSQA_ChillerSeq_parameter_34();
    func_7134.inputB = 0F;
    func_7134.Execute(  );

    // [769] Function call CfOr
    func_769.input[0] = func_7132.outputEqualOrGreater;
    func_769.input[1] = FloatToBoolean(register_312);
    func_769.input[2] = func_7134.outputEqual;
    func_769.Execute(  );

    // [7136] Function call CfCompare1
    func_7136.inputA = (float) getCmSQA_ChillerSeq_parameter_35();
    func_7136.inputB = 0F;
    func_7136.Execute(  );

    // [770] Function call CfOr
    func_770.input[0] = func_7135.outputEqualOrGreater;
    func_770.input[1] = FloatToBoolean(register_313);
    func_770.input[2] = func_7136.outputEqual;
    func_770.Execute(  );

    // [7138] Function call CfCompare1
    func_7138.inputA = (float) getCmSQA_ChillerSeq_parameter_36();
    func_7138.inputB = 0F;
    func_7138.Execute(  );

    // [771] Function call CfOr
    func_771.input[0] = func_7137.outputEqualOrGreater;
    func_771.input[1] = FloatToBoolean(func_6055.CmCommInputProc_output_188);
    func_771.input[2] = func_7138.outputEqual;
    func_771.Execute(  );

    // [7140] Function call CfCompare1
    func_7140.inputA = (float) getCmSQA_ChillerSeq_parameter_37();
    func_7140.inputB = 0F;
    func_7140.Execute(  );

    // [772] Function call CfOr
    func_772.input[0] = func_7139.outputEqualOrGreater;
    func_772.input[1] = FloatToBoolean(func_6055.CmCommInputProc_output_189);
    func_772.input[2] = func_7140.outputEqual;
    func_772.Execute(  );

    // [7142] Function call CfCompare1
    func_7142.inputA = (float) getCmSQA_ChillerSeq_parameter_38();
    func_7142.inputB = 0F;
    func_7142.Execute(  );

    // [773] Function call CfOr
    func_773.input[0] = func_7141.outputEqualOrGreater;
    func_773.input[1] = FloatToBoolean(func_6055.CmCommInputProc_output_190);
    func_773.input[2] = func_7142.outputEqual;
    func_773.Execute(  );

    // [7144] Function call CfCompare1
    func_7144.inputA = (float) getCmSQA_ChillerSeq_parameter_39();
    func_7144.inputB = 0F;
    func_7144.Execute(  );

    // [774] Function call CfOr
    func_774.input[0] = func_7143.outputEqualOrGreater;
    func_774.input[1] = FloatToBoolean(func_6055.CmCommInputProc_output_191);
    func_774.input[2] = func_7144.outputEqual;
    func_774.Execute(  );

    // [7150] Function call CfCompare1
    func_7150.inputA = (float) getCmSQA_ChillerSeq_parameter_40();
    func_7150.inputB = 0F;
    func_7150.Execute(  );

    // [775] Function call CfOr
    func_775.input[0] = func_7145.outputEqualOrGreater;
    func_775.input[1] = FloatToBoolean(func_6055.CmCommInputProc_output_192);
    func_775.input[2] = func_7150.outputEqual;
    func_775.Execute(  );

    // [7151] Function call CfCompare1
    func_7151.inputA = (float) getCmSQA_ChillerSeq_parameter_41();
    func_7151.inputB = 0F;
    func_7151.Execute(  );

    // [776] Function call CfOr
    func_776.input[0] = func_7146.outputEqualOrGreater;
    func_776.input[1] = FloatToBoolean(func_6055.CmCommInputProc_output_193);
    func_776.input[2] = func_7151.outputEqual;
    func_776.Execute(  );

    // [7152] Function call CfCompare1
    func_7152.inputA = (float) getCmSQA_ChillerSeq_parameter_42();
    func_7152.inputB = 0F;
    func_7152.Execute(  );

    // [777] Function call CfOr
    func_777.input[0] = func_7147.outputEqualOrGreater;
    func_777.input[1] = FloatToBoolean(func_6055.CmCommInputProc_output_194);
    func_777.input[2] = func_7152.outputEqual;
    func_777.Execute(  );

    // [7153] Function call CfCompare1
    func_7153.inputA = (float) getCmSQA_ChillerSeq_parameter_43();
    func_7153.inputB = 0F;
    func_7153.Execute(  );

    // [778] Function call CfOr
    func_778.input[0] = func_7148.outputEqualOrGreater;
    func_778.input[1] = FloatToBoolean(func_6055.CmCommInputProc_output_195);
    func_778.input[2] = func_7153.outputEqual;
    func_778.Execute(  );

    // [7154] Function call CfCompare1
    func_7154.inputA = (float) getCmSQA_ChillerSeq_parameter_44();
    func_7154.inputB = 0F;
    func_7154.Execute(  );

    // [779] Function call CfOr
    func_779.input[0] = func_7149.outputEqualOrGreater;
    func_779.input[1] = FloatToBoolean(func_6055.CmCommInputProc_output_196);
    func_779.input[2] = func_7154.outputEqual;
    func_779.Execute(  );

    // [784] Function call CfMaximum
    func_784.input[0] = func_731.output;
    func_784.input[1] = func_732.output;
    func_784.input[2] = func_733.output;
    func_784.input[3] = func_734.output;
    func_784.input[4] = func_735.output;
    func_784.input[5] = func_736.output;
    func_784.input[6] = func_737.output;
    func_784.input[7] = func_738.output;
    func_784.input[8] = func_739.output;
    func_784.input[9] = func_740.output;
    func_784.input[10] = func_741.output;
    func_784.input[11] = func_742.output;
    func_784.Execute(  );

    // [789] Function call CfInputMultiplexer
    func_789.inputSelect = BooleanToInt(func_768.outputOR);
    func_789.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_45();
    func_789.input[2-1] = 999999F;
    func_789.Execute(  );

    // [790] Function call CfInputMultiplexer
    func_790.inputSelect = BooleanToInt(func_769.outputOR);
    func_790.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_46();
    func_790.input[2-1] = 999999F;
    func_790.Execute(  );

    // [791] Function call CfInputMultiplexer
    func_791.inputSelect = BooleanToInt(func_770.outputOR);
    func_791.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_47();
    func_791.input[2-1] = 999999F;
    func_791.Execute(  );

    // [792] Function call CfInputMultiplexer
    func_792.inputSelect = BooleanToInt(func_771.outputOR);
    func_792.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_48();
    func_792.input[2-1] = 999999F;
    func_792.Execute(  );

    // [793] Function call CfInputMultiplexer
    func_793.inputSelect = BooleanToInt(func_772.outputOR);
    func_793.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_49();
    func_793.input[2-1] = 999999F;
    func_793.Execute(  );

    // [794] Function call CfInputMultiplexer
    func_794.inputSelect = BooleanToInt(func_773.outputOR);
    func_794.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_50();
    func_794.input[2-1] = 999999F;
    func_794.Execute(  );

    // [795] Function call CfInputMultiplexer
    func_795.inputSelect = BooleanToInt(func_774.outputOR);
    func_795.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_51();
    func_795.input[2-1] = 999999F;
    func_795.Execute(  );

    // [796] Function call CfInputMultiplexer
    func_796.inputSelect = BooleanToInt(func_775.outputOR);
    func_796.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_52();
    func_796.input[2-1] = 999999F;
    func_796.Execute(  );

    // [797] Function call CfInputMultiplexer
    func_797.inputSelect = BooleanToInt(func_776.outputOR);
    func_797.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_53();
    func_797.input[2-1] = 999999F;
    func_797.Execute(  );

    // [798] Function call CfInputMultiplexer
    func_798.inputSelect = BooleanToInt(func_777.outputOR);
    func_798.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_54();
    func_798.input[2-1] = 999999F;
    func_798.Execute(  );

    // [799] Function call CfInputMultiplexer
    func_799.inputSelect = BooleanToInt(func_778.outputOR);
    func_799.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_55();
    func_799.input[2-1] = 999999F;
    func_799.Execute(  );

    // [800] Function call CfInputMultiplexer
    func_800.inputSelect = BooleanToInt(func_779.outputOR);
    func_800.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_56();
    func_800.input[2-1] = 999999F;
    func_800.Execute(  );

    // [783] Function call CfSplit
    func_783.input = ControlFunction.GetDayAndMonth();
    func_783.Execute( this, 15 );

    // [7228] Function call CfCompare1
    func_7228.inputA = IntToFloat(ControlFunction.GetWeekday());
    func_7228.inputB = (float) getCmSQA_ChillerSeq_parameter_19();
    func_7228.Execute(  );

    // [7229] Function call CfCompare1
    func_7229.inputA = (float) getCmSQA_ChillerSeq_parameter_18();
    func_7229.inputB = 2F;
    func_7229.Execute(  );

    // [802] Function call CfAnd
    func_802.input[0] = func_7228.outputEqual;
    func_802.input[1] = func_7229.outputEqual;
    func_802.Execute(  );

    // [7230] Function call CfCompare1
    func_7230.inputA = (float) getCmSQA_ChillerSeq_parameter_18();
    func_7230.inputB = 1F;
    func_7230.Execute(  );

    // [7233] Function call CfCompare1
    func_7233.inputA = IntToFloat(func_783.output[0]);
    func_7233.inputB = (float) getCmSQA_ChillerSeq_parameter_19();
    func_7233.Execute(  );

    // [7231] Function call CfCompare1
    func_7231.inputA = (float) getCmSQA_ChillerSeq_parameter_18();
    func_7231.inputB = 3F;
    func_7231.Execute(  );

    // [803] Function call CfAnd
    func_803.input[0] = func_7233.outputEqual;
    func_803.input[1] = func_7231.outputEqual;
    func_803.Execute(  );

    // [805] Function call CfMinimum
    func_805.input[0] = func_789.output;
    func_805.input[1] = func_790.output;
    func_805.input[2] = func_791.output;
    func_805.input[3] = func_792.output;
    func_805.input[4] = func_793.output;
    func_805.input[5] = func_794.output;
    func_805.input[6] = func_795.output;
    func_805.input[7] = func_796.output;
    func_805.input[8] = func_797.output;
    func_805.input[9] = func_798.output;
    func_805.input[10] = func_799.output;
    func_805.input[11] = func_800.output;
    func_805.Execute(  );

    // [807] Function call CfOr
    func_807.input[0] = func_802.outputAND;
    func_807.input[1] = func_803.outputAND;
    func_807.input[2] = func_7230.outputEqual;
    func_807.Execute(  );

    // [808] Function call CfSubtract
    func_808.input[0] = func_784.output;
    func_808.input[1] = func_805.output;
    func_808.Execute(  );

    // [7238] Function call CfCompare1
    func_7238.inputA = IntToFloat(ControlFunction.GetHoursAndMinutes());
    func_7238.inputB = (float) getCmSQA_ChillerSeq_parameter_20();
    func_7238.Execute(  );

    // [810] Function call CfAnd
    func_810.input[0] = func_7238.outputEqual;
    func_810.input[1] = func_807.outputOR;
    func_810.Execute(  );

    // [812] Function call CfIdt
    func_812.input = func_814.output[0];
    func_812.Execute(  );

    // [814] Function call CfIdt
    func_814.input = BooleanToFloat(func_810.outputAND);
    func_814.Execute(  );

    // [815] Function call CfSubtract
    func_815.input[0] = BooleanToFloat(func_810.outputAND);
    func_815.input[1] = func_812.output[0];
    func_815.Execute(  );

    // [816] Function call CfAbsolute
    func_816.input = func_815.output;
    func_816.Execute(  );

    // [820] Function call CfAnd
    func_820.input[0] = FloatToBoolean(func_816.outputAbs);
    func_820.input[1] = func_810.outputAND;
    func_820.Execute(  );

    // [822] Function call CfCompare1
    func_822.inputA = (float) getCmSQA_ChillerSeq_parameter_32();
    func_822.inputB = 0F;
    func_822.Execute(  );

    // [824] Function call CfCompare1
    func_824.inputA = (float) getCmSQA_ChillerSeq_parameter_15();
    func_824.inputB = 1F;
    func_824.Execute(  );

    // [7642] Function call CfAnd
    func_7642.input[0] = func_824.outputEqual;
    func_7642.input[1] = func_820.outputNAND;
    func_7642.Execute(  );

    // [7265] Function call CfAnd
    func_7265.input[0] = func_820.outputAND;
    func_7265.input[1] = func_824.outputEqual;
    func_7265.input[2] = func_822.outputEqual;
    func_7265.Execute(  );

    // [7107] Macro call Cmsequence_rotation
    func_7107.Cmsequence_rotation_input_1 = (float) getCmSQA_ChillerSeq_parameter_33();
    func_7107.Cmsequence_rotation_input_2 = func_9150.output;
    func_7107.Execute(  );

    // [7110] Macro call Cmsequence_rotation
    func_7110.Cmsequence_rotation_input_1 = (float) getCmSQA_ChillerSeq_parameter_34();
    func_7110.Cmsequence_rotation_input_2 = func_9150.output;
    func_7110.Execute(  );

    // [7111] Macro call Cmsequence_rotation
    func_7111.Cmsequence_rotation_input_1 = (float) getCmSQA_ChillerSeq_parameter_35();
    func_7111.Cmsequence_rotation_input_2 = func_9150.output;
    func_7111.Execute(  );

    // [7112] Macro call Cmsequence_rotation
    func_7112.Cmsequence_rotation_input_1 = (float) getCmSQA_ChillerSeq_parameter_36();
    func_7112.Cmsequence_rotation_input_2 = func_9150.output;
    func_7112.Execute(  );

    // [7113] Macro call Cmsequence_rotation
    func_7113.Cmsequence_rotation_input_1 = (float) getCmSQA_ChillerSeq_parameter_37();
    func_7113.Cmsequence_rotation_input_2 = func_9150.output;
    func_7113.Execute(  );

    // [7114] Macro call Cmsequence_rotation
    func_7114.Cmsequence_rotation_input_1 = (float) getCmSQA_ChillerSeq_parameter_38();
    func_7114.Cmsequence_rotation_input_2 = func_9150.output;
    func_7114.Execute(  );

    // [7239] Macro call Cmswitch_x_12
    if ( func_7265.outputAND)
    {
      func_7239.Cmswitch_x_12_input_1 = func_7265.outputAND;
      func_7239.Cmswitch_x_12_input_2 = (float) getCmSQA_ChillerSeq_parameter_33();
      func_7239.Cmswitch_x_12_input_3 = func_7107.Cmsequence_rotation_output_3;
      func_7239.Cmswitch_x_12_input_4 = register_293;
      func_7239.Cmswitch_x_12_input_5 = func_7107.Cmsequence_rotation_output_4;
      func_7239.Cmswitch_x_12_input_6 = (float) getCmSQA_ChillerSeq_parameter_34();
      func_7239.Cmswitch_x_12_input_7 = func_7110.Cmsequence_rotation_output_3;
      func_7239.Cmswitch_x_12_input_8 = register_294;
      func_7239.Cmswitch_x_12_input_9 = func_7110.Cmsequence_rotation_output_4;
      func_7239.Cmswitch_x_12_input_10 = (float) getCmSQA_ChillerSeq_parameter_35();
      func_7239.Cmswitch_x_12_input_11 = func_7111.Cmsequence_rotation_output_3;
      func_7239.Cmswitch_x_12_input_12 = register_295;
      func_7239.Cmswitch_x_12_input_13 = func_7111.Cmsequence_rotation_output_4;
      func_7239.Cmswitch_x_12_input_14 = (float) getCmSQA_ChillerSeq_parameter_36();
      func_7239.Cmswitch_x_12_input_15 = func_7112.Cmsequence_rotation_output_3;
      func_7239.Cmswitch_x_12_input_16 = register_296;
      func_7239.Cmswitch_x_12_input_17 = func_7112.Cmsequence_rotation_output_4;
      func_7239.Cmswitch_x_12_input_18 = (float) getCmSQA_ChillerSeq_parameter_37();
      func_7239.Cmswitch_x_12_input_19 = func_7113.Cmsequence_rotation_output_3;
      func_7239.Cmswitch_x_12_input_20 = register_297;
      func_7239.Cmswitch_x_12_input_21 = func_7113.Cmsequence_rotation_output_4;
      func_7239.Cmswitch_x_12_input_22 = (float) getCmSQA_ChillerSeq_parameter_38();
      func_7239.Cmswitch_x_12_input_23 = func_7114.Cmsequence_rotation_output_3;
      func_7239.Cmswitch_x_12_input_24 = register_298;
      func_7239.Cmswitch_x_12_input_25 = func_7114.Cmsequence_rotation_output_4;
      func_7239.Execute(  );
      setCmSQA_ChillerSeq_parameter_33(func_7239.Cmswitch_x_12_output_26);
      register_293 = func_7239.Cmswitch_x_12_output_27;
      setCmSQA_ChillerSeq_parameter_34(func_7239.Cmswitch_x_12_output_28);
      register_294 = func_7239.Cmswitch_x_12_output_29;
      setCmSQA_ChillerSeq_parameter_35(func_7239.Cmswitch_x_12_output_30);
      register_295 = func_7239.Cmswitch_x_12_output_31;
      setCmSQA_ChillerSeq_parameter_36(func_7239.Cmswitch_x_12_output_32);
      register_296 = func_7239.Cmswitch_x_12_output_33;
      setCmSQA_ChillerSeq_parameter_37(func_7239.Cmswitch_x_12_output_34);
      register_297 = func_7239.Cmswitch_x_12_output_35;
      setCmSQA_ChillerSeq_parameter_38(func_7239.Cmswitch_x_12_output_36);
      register_298 = func_7239.Cmswitch_x_12_output_37;
    }

    // [7115] Macro call Cmsequence_rotation
    func_7115.Cmsequence_rotation_input_1 = (float) getCmSQA_ChillerSeq_parameter_39();
    func_7115.Cmsequence_rotation_input_2 = func_9150.output;
    func_7115.Execute(  );

    // [7116] Macro call Cmsequence_rotation
    func_7116.Cmsequence_rotation_input_1 = (float) getCmSQA_ChillerSeq_parameter_40();
    func_7116.Cmsequence_rotation_input_2 = func_9150.output;
    func_7116.Execute(  );

    // [7117] Macro call Cmsequence_rotation
    func_7117.Cmsequence_rotation_input_1 = (float) getCmSQA_ChillerSeq_parameter_41();
    func_7117.Cmsequence_rotation_input_2 = func_9150.output;
    func_7117.Execute(  );

    // [7118] Macro call Cmsequence_rotation
    func_7118.Cmsequence_rotation_input_1 = (float) getCmSQA_ChillerSeq_parameter_42();
    func_7118.Cmsequence_rotation_input_2 = func_9150.output;
    func_7118.Execute(  );

    // [7119] Macro call Cmsequence_rotation
    func_7119.Cmsequence_rotation_input_1 = (float) getCmSQA_ChillerSeq_parameter_43();
    func_7119.Cmsequence_rotation_input_2 = func_9150.output;
    func_7119.Execute(  );

    // [7120] Macro call Cmsequence_rotation
    func_7120.Cmsequence_rotation_input_1 = (float) getCmSQA_ChillerSeq_parameter_44();
    func_7120.Cmsequence_rotation_input_2 = func_9150.output;
    func_7120.Execute(  );

    // [7252] Macro call Cmswitch_x_12
    if ( func_7265.outputAND)
    {
      func_7252.Cmswitch_x_12_input_1 = func_7265.outputAND;
      func_7252.Cmswitch_x_12_input_2 = (float) getCmSQA_ChillerSeq_parameter_39();
      func_7252.Cmswitch_x_12_input_3 = func_7115.Cmsequence_rotation_output_3;
      func_7252.Cmswitch_x_12_input_4 = register_299;
      func_7252.Cmswitch_x_12_input_5 = func_7115.Cmsequence_rotation_output_4;
      func_7252.Cmswitch_x_12_input_6 = (float) getCmSQA_ChillerSeq_parameter_40();
      func_7252.Cmswitch_x_12_input_7 = func_7116.Cmsequence_rotation_output_3;
      func_7252.Cmswitch_x_12_input_8 = register_300;
      func_7252.Cmswitch_x_12_input_9 = func_7116.Cmsequence_rotation_output_4;
      func_7252.Cmswitch_x_12_input_10 = (float) getCmSQA_ChillerSeq_parameter_41();
      func_7252.Cmswitch_x_12_input_11 = func_7117.Cmsequence_rotation_output_3;
      func_7252.Cmswitch_x_12_input_12 = register_301;
      func_7252.Cmswitch_x_12_input_13 = func_7117.Cmsequence_rotation_output_4;
      func_7252.Cmswitch_x_12_input_14 = (float) getCmSQA_ChillerSeq_parameter_42();
      func_7252.Cmswitch_x_12_input_15 = func_7118.Cmsequence_rotation_output_3;
      func_7252.Cmswitch_x_12_input_16 = register_302;
      func_7252.Cmswitch_x_12_input_17 = func_7118.Cmsequence_rotation_output_4;
      func_7252.Cmswitch_x_12_input_18 = (float) getCmSQA_ChillerSeq_parameter_43();
      func_7252.Cmswitch_x_12_input_19 = func_7119.Cmsequence_rotation_output_3;
      func_7252.Cmswitch_x_12_input_20 = register_303;
      func_7252.Cmswitch_x_12_input_21 = func_7119.Cmsequence_rotation_output_4;
      func_7252.Cmswitch_x_12_input_22 = (float) getCmSQA_ChillerSeq_parameter_44();
      func_7252.Cmswitch_x_12_input_23 = func_7120.Cmsequence_rotation_output_3;
      func_7252.Cmswitch_x_12_input_24 = register_304;
      func_7252.Cmswitch_x_12_input_25 = func_7120.Cmsequence_rotation_output_4;
      func_7252.Execute(  );
      setCmSQA_ChillerSeq_parameter_39(func_7252.Cmswitch_x_12_output_26);
      register_299 = func_7252.Cmswitch_x_12_output_27;
      setCmSQA_ChillerSeq_parameter_40(func_7252.Cmswitch_x_12_output_28);
      register_300 = func_7252.Cmswitch_x_12_output_29;
      setCmSQA_ChillerSeq_parameter_41(func_7252.Cmswitch_x_12_output_30);
      register_301 = func_7252.Cmswitch_x_12_output_31;
      setCmSQA_ChillerSeq_parameter_42(func_7252.Cmswitch_x_12_output_32);
      register_302 = func_7252.Cmswitch_x_12_output_33;
      setCmSQA_ChillerSeq_parameter_43(func_7252.Cmswitch_x_12_output_34);
      register_303 = func_7252.Cmswitch_x_12_output_35;
      setCmSQA_ChillerSeq_parameter_44(func_7252.Cmswitch_x_12_output_36);
      register_304 = func_7252.Cmswitch_x_12_output_37;
    }

    // [920] Function call CfIdt
    func_920.input = register_305;
    func_920.Execute(  );

    // [923] Function call CfIdt
    func_923.input = func_814.output[0];
    func_923.Execute(  );

    // [926] Function call CfIdt
    func_926.input = func_7572.output;
    func_926.Execute(  );

    // [929] Function call CfCompare1
    func_929.inputA = (float) getCmSQA_ChillerSeq_parameter_15();
    func_929.inputB = 3F;
    func_929.Execute(  );

    // [7186] Function call CfNot
    func_7186.input = func_929.outputEqual;
    func_7186.Execute(  );

    // [7227] Function call CfNot
    func_7227.input = FloatToBoolean(func_920.output[0]);
    func_7227.Execute(  );

    // [7578] Function call CfIdt
    func_7578.input = BooleanToFloat(func_7186.output);
    func_7578.Execute(  );

    // [7571] Function call CfInputMultiplexer
    func_7571.inputSelect = BooleanToInt(func_7584.outputOR);
    func_7571.input[1-1] = func_923.output[0];
    func_7571.input[2-1] = register_305;
    func_7571.Execute(  );
    register_305 = func_7571.output;

    // [932] Function call CfAnd
    func_932.input[0] = FloatToBoolean(func_923.output[0]);
    func_932.input[1] = func_7227.output;
    func_932.Execute(  );

    // [7187] Function call CfCompare2
    func_7187.inputA = func_808.output;
    func_7187.inputB = (float) getCmSQA_ChillerSeq_parameter_22();
    func_7187.Execute(  );

    // [938] Function call CfRound
    func_938.input = func_926.output[0];
    func_938.Execute(  );

    // [939] Function call CfSubtract
    func_939.input[0] = 1F;
    func_939.input[1] = func_926.output[0];
    func_939.Execute(  );

    // [7194] Function call CfCompare1
    func_7194.inputA = 0F;
    func_7194.inputB = (float) getCmSQA_ChillerSeq_parameter_17();
    func_7194.Execute(  );

    // [943] Function call CfAnd
    func_943.input[0] = func_932.outputAND;
    func_943.input[1] = func_7194.outputEqual;
    func_943.input[2] = FloatToBoolean(func_939.output);
    func_943.Execute(  );

    // [7193] Function call CfCompare1
    func_7193.inputA = 1F;
    func_7193.inputB = (float) getCmSQA_ChillerSeq_parameter_17();
    func_7193.Execute(  );

    // [944] Function call CfAnd
    func_944.input[0] = func_932.outputAND;
    func_944.input[1] = func_7193.outputEqual;
    func_944.input[2] = func_7187.outputEqualOrGreater;
    func_944.input[3] = FloatToBoolean(func_939.output);
    func_944.Execute(  );

    // [7189] Function call CfCompare1
    func_7189.inputA = 2F;
    func_7189.inputB = (float) getCmSQA_ChillerSeq_parameter_17();
    func_7189.Execute(  );

    // [945] Function call CfAnd
    func_945.input[0] = func_7187.outputEqualOrGreater;
    func_945.input[1] = func_7189.outputEqual;
    func_945.input[2] = FloatToBoolean(func_939.output);
    func_945.Execute(  );

    // [7188] Function call CfCompare2
    func_7188.inputA = 11F;
    func_7188.inputB = func_7580.output;
    func_7188.Execute(  );

    // [946] Function call CfAnd
    func_946.input[0] = FloatToBoolean(func_938.output);
    func_946.input[1] = func_7188.outputEqualOrGreater;
    func_946.Execute(  );

    // [948] Function call CfOr
    func_948.input[0] = func_943.outputAND;
    func_948.input[1] = func_944.outputAND;
    func_948.input[2] = func_945.outputAND;
    func_948.input[3] = func_946.outputAND;
    func_948.Execute(  );

    // [949] Function call CfIdt
    func_949.input = func_7572.output;
    func_949.Execute(  );

    // [7584] Function call CfOr
    func_7584.input[0] = func_7186.output;
    func_7584.input[1] = func_822.outputGreater;
    func_7584.input[2] = func_7642.outputAND;
    func_7584.Execute(  );

    // [7572] Function call CfInputMultiplexer
    func_7572.inputSelect = BooleanToInt(func_7584.outputOR);
    func_7572.input[1-1] = BooleanToFloat(func_948.outputOR);
    func_7572.input[2-1] = func_7572.output;
    func_7572.Execute(  );

    // [7573] Function call CfInputMultiplexer
    func_7573.inputSelect = BooleanToInt(func_7584.outputOR);
    func_7573.input[1-1] = func_949.output[0];
    func_7573.input[2-1] = func_7573.output;
    func_7573.Execute(  );

    // [954] Function call CfIdt
    func_954.input = func_7580.output;
    func_954.Execute(  );

    // [955] Function call CfIdt
    func_955.input = func_7573.output;
    func_955.Execute(  );

    // [7225] Function call CfCompare2
    func_7225.inputA = func_954.output[0];
    func_7225.inputB = 12F;
    func_7225.Execute(  );

    // [957] Function call CfAddition
    func_957.input[0] = func_954.output[0];
    func_957.input[1] = 1F;
    func_957.Execute(  );

    // [961] Function call CfIdt
    func_961.input = func_7572.output;
    func_961.Execute(  );

    // [963] Function call CfInputMultiplexer
    func_963.inputSelect = BooleanToInt(func_7225.outputEqualOrGreater);
    func_963.input[1-1] = func_957.output;
    func_963.input[2-1] = func_954.output[0];
    func_963.Execute(  );

    // [964] Function call CfIdt
    func_964.input = register_289;
    func_964.Execute(  );

    // [7226] Function call CfNot
    func_7226.input = FloatToBoolean(func_955.output[0]);
    func_7226.Execute(  );

    // [965] Function call CfAnd
    func_965.input[0] = func_7226.output;
    func_965.input[1] = FloatToBoolean(func_961.output[0]);
    func_965.Execute(  );

    // [967] Function call CfInputMultiplexer
    func_967.inputSelect = BooleanToInt(func_965.outputAND);
    func_967.input[1-1] = func_963.output;
    func_967.input[2-1] = 1F;
    func_967.Execute(  );

    // [968] Function call CfInputMultiplexer
    func_968.inputSelect = BooleanToInt(func_965.outputAND);
    func_968.input[1-1] = func_964.output[0];
    func_968.input[2-1] = 0F;
    func_968.Execute(  );

    // [7588] Function call CfOr
    func_7588.input[0] = func_822.outputGreater;
    func_7588.input[1] = FloatToBoolean(func_7578.output[0]);
    func_7588.input[2] = func_7642.outputAND;
    func_7588.Execute(  );

    // [7580] Function call CfInputMultiplexer
    func_7580.inputSelect = BooleanToInt(func_7588.outputOR);
    func_7580.input[1-1] = func_967.output;
    func_7580.input[2-1] = func_7580.output;
    func_7580.Execute(  );

    // [7581] Function call CfInputMultiplexer
    func_7581.inputSelect = BooleanToInt(func_7588.outputOR);
    func_7581.input[1-1] = func_968.output;
    func_7581.input[2-1] = func_964.output[0];
    func_7581.Execute(  );
    register_289 = func_7581.output;

    // [7562] Function call CfCompare1
    func_7562.inputA = func_961.output[0];
    func_7562.inputB = 0F;
    func_7562.Execute(  );

    // [1001] Function call CfIdt
    func_1001.input = register_289;
    func_1001.Execute(  );

    // [7526] Macro call Cmruntime_selector
    func_7526.Cmruntime_selector_input_1 = (float) getCmSQA_ChillerSeq_parameter_45();
    func_7526.Cmruntime_selector_input_2 = (float) getCmSQA_ChillerSeq_parameter_33();
    func_7526.Cmruntime_selector_input_24 = 0.01F;
    func_7526.Cmruntime_selector_input_3 = func_1001.output[0];
    func_7526.Execute(  );

    // [7525] Macro call Cmruntime_selector
    func_7525.Cmruntime_selector_input_1 = (float) getCmSQA_ChillerSeq_parameter_46();
    func_7525.Cmruntime_selector_input_2 = (float) getCmSQA_ChillerSeq_parameter_34();
    func_7525.Cmruntime_selector_input_24 = 0.02F;
    func_7525.Cmruntime_selector_input_3 = func_1001.output[0];
    func_7525.Execute(  );

    // [7524] Macro call Cmruntime_selector
    func_7524.Cmruntime_selector_input_1 = (float) getCmSQA_ChillerSeq_parameter_47();
    func_7524.Cmruntime_selector_input_2 = (float) getCmSQA_ChillerSeq_parameter_35();
    func_7524.Cmruntime_selector_input_24 = 0.03F;
    func_7524.Cmruntime_selector_input_3 = func_1001.output[0];
    func_7524.Execute(  );

    // [7520] Macro call Cmruntime_selector
    func_7520.Cmruntime_selector_input_1 = (float) getCmSQA_ChillerSeq_parameter_48();
    func_7520.Cmruntime_selector_input_2 = (float) getCmSQA_ChillerSeq_parameter_36();
    func_7520.Cmruntime_selector_input_24 = 0.04F;
    func_7520.Cmruntime_selector_input_3 = func_1001.output[0];
    func_7520.Execute(  );

    // [7527] Macro call Cmruntime_selector
    func_7527.Cmruntime_selector_input_1 = (float) getCmSQA_ChillerSeq_parameter_49();
    func_7527.Cmruntime_selector_input_2 = (float) getCmSQA_ChillerSeq_parameter_37();
    func_7527.Cmruntime_selector_input_24 = 0.05F;
    func_7527.Cmruntime_selector_input_3 = func_1001.output[0];
    func_7527.Execute(  );

    // [7528] Macro call Cmruntime_selector
    func_7528.Cmruntime_selector_input_1 = (float) getCmSQA_ChillerSeq_parameter_50();
    func_7528.Cmruntime_selector_input_2 = (float) getCmSQA_ChillerSeq_parameter_38();
    func_7528.Cmruntime_selector_input_24 = 0.06F;
    func_7528.Cmruntime_selector_input_3 = func_1001.output[0];
    func_7528.Execute(  );

    // [7529] Macro call Cmruntime_selector
    func_7529.Cmruntime_selector_input_1 = (float) getCmSQA_ChillerSeq_parameter_51();
    func_7529.Cmruntime_selector_input_2 = (float) getCmSQA_ChillerSeq_parameter_39();
    func_7529.Cmruntime_selector_input_24 = 0.07F;
    func_7529.Cmruntime_selector_input_3 = func_1001.output[0];
    func_7529.Execute(  );

    // [7530] Macro call Cmruntime_selector
    func_7530.Cmruntime_selector_input_1 = (float) getCmSQA_ChillerSeq_parameter_52();
    func_7530.Cmruntime_selector_input_2 = (float) getCmSQA_ChillerSeq_parameter_40();
    func_7530.Cmruntime_selector_input_24 = 0.08F;
    func_7530.Cmruntime_selector_input_3 = func_1001.output[0];
    func_7530.Execute(  );

    // [7531] Macro call Cmruntime_selector
    func_7531.Cmruntime_selector_input_1 = (float) getCmSQA_ChillerSeq_parameter_53();
    func_7531.Cmruntime_selector_input_2 = (float) getCmSQA_ChillerSeq_parameter_41();
    func_7531.Cmruntime_selector_input_24 = 0.09F;
    func_7531.Cmruntime_selector_input_3 = func_1001.output[0];
    func_7531.Execute(  );

    // [7532] Macro call Cmruntime_selector
    func_7532.Cmruntime_selector_input_1 = (float) getCmSQA_ChillerSeq_parameter_54();
    func_7532.Cmruntime_selector_input_2 = (float) getCmSQA_ChillerSeq_parameter_42();
    func_7532.Cmruntime_selector_input_24 = 0.1F;
    func_7532.Cmruntime_selector_input_3 = func_1001.output[0];
    func_7532.Execute(  );

    // [7533] Macro call Cmruntime_selector
    func_7533.Cmruntime_selector_input_1 = (float) getCmSQA_ChillerSeq_parameter_55();
    func_7533.Cmruntime_selector_input_2 = (float) getCmSQA_ChillerSeq_parameter_43();
    func_7533.Cmruntime_selector_input_24 = 0.11F;
    func_7533.Cmruntime_selector_input_3 = func_1001.output[0];
    func_7533.Execute(  );

    // [7534] Macro call Cmruntime_selector
    func_7534.Cmruntime_selector_input_1 = (float) getCmSQA_ChillerSeq_parameter_56();
    func_7534.Cmruntime_selector_input_2 = (float) getCmSQA_ChillerSeq_parameter_44();
    func_7534.Cmruntime_selector_input_24 = 0.12F;
    func_7534.Cmruntime_selector_input_3 = func_1001.output[0];
    func_7534.Execute(  );

    // [977] Function call CfAddition
    func_977.input[0] = (float) getCmSQA_ChillerSeq_parameter_45();
    func_977.input[1] = 0.01F;
    func_977.Execute(  );

    // [978] Function call CfAddition
    func_978.input[0] = (float) getCmSQA_ChillerSeq_parameter_46();
    func_978.input[1] = 0.02F;
    func_978.Execute(  );

    // [979] Function call CfAddition
    func_979.input[0] = (float) getCmSQA_ChillerSeq_parameter_47();
    func_979.input[1] = 0.03F;
    func_979.Execute(  );

    // [980] Function call CfAddition
    func_980.input[0] = (float) getCmSQA_ChillerSeq_parameter_48();
    func_980.input[1] = 0.04F;
    func_980.Execute(  );

    // [981] Function call CfAddition
    func_981.input[0] = (float) getCmSQA_ChillerSeq_parameter_49();
    func_981.input[1] = 0.05F;
    func_981.Execute(  );

    // [982] Function call CfAddition
    func_982.input[0] = (float) getCmSQA_ChillerSeq_parameter_50();
    func_982.input[1] = 0.06F;
    func_982.Execute(  );

    // [983] Function call CfAddition
    func_983.input[0] = (float) getCmSQA_ChillerSeq_parameter_51();
    func_983.input[1] = 0.07F;
    func_983.Execute(  );

    // [984] Function call CfAddition
    func_984.input[0] = (float) getCmSQA_ChillerSeq_parameter_52();
    func_984.input[1] = 0.08F;
    func_984.Execute(  );

    // [985] Function call CfAddition
    func_985.input[0] = (float) getCmSQA_ChillerSeq_parameter_53();
    func_985.input[1] = 0.09F;
    func_985.Execute(  );

    // [986] Function call CfAddition
    func_986.input[0] = (float) getCmSQA_ChillerSeq_parameter_54();
    func_986.input[1] = 0.1F;
    func_986.Execute(  );

    // [987] Function call CfAddition
    func_987.input[0] = (float) getCmSQA_ChillerSeq_parameter_55();
    func_987.input[1] = 0.11F;
    func_987.Execute(  );

    // [988] Function call CfAddition
    func_988.input[0] = (float) getCmSQA_ChillerSeq_parameter_56();
    func_988.input[1] = 0.12F;
    func_988.Execute(  );

    // [1053] Function call CfMinimum
    func_1053.input[0] = func_7526.Cmruntime_selector_output_4;
    func_1053.input[1] = func_7525.Cmruntime_selector_output_4;
    func_1053.input[2] = func_7524.Cmruntime_selector_output_4;
    func_1053.input[3] = func_7520.Cmruntime_selector_output_4;
    func_1053.input[4] = func_7527.Cmruntime_selector_output_4;
    func_1053.input[5] = func_7528.Cmruntime_selector_output_4;
    func_1053.input[6] = func_7529.Cmruntime_selector_output_4;
    func_1053.input[7] = func_7530.Cmruntime_selector_output_4;
    func_1053.input[8] = func_7531.Cmruntime_selector_output_4;
    func_1053.input[9] = func_7532.Cmruntime_selector_output_4;
    func_1053.input[10] = func_7533.Cmruntime_selector_output_4;
    func_1053.input[11] = func_7534.Cmruntime_selector_output_4;
    func_1053.Execute(  );

    // [7574] Function call CfOr
    func_7574.input[0] = FloatToBoolean(func_7578.output[0]);
    func_7574.input[1] = func_7642.outputAND;
    func_7574.input[2] = func_7562.outputEqual;
    func_7574.input[3] = func_822.outputGreater;
    func_7574.Execute(  );

    // [7565] Function call CfInputMultiplexer
    func_7565.inputSelect = BooleanToInt(func_7574.outputOR);
    func_7565.input[1-1] = func_1053.output;
    func_7565.input[2-1] = register_289;
    func_7565.Execute(  );

    // [1055] Function call CfIdt
    func_1055.input = func_7565.output;
    func_1055.Execute(  );
    register_289 = func_1055.output[0];

    // [7447] Function call CfCompare1
    func_7447.inputA = func_977.output;
    func_7447.inputB = func_1053.output;
    func_7447.Execute(  );

    // [7449] Function call CfCompare1
    func_7449.inputA = func_978.output;
    func_7449.inputB = func_1053.output;
    func_7449.Execute(  );

    // [7450] Function call CfCompare1
    func_7450.inputA = func_1053.output;
    func_7450.inputB = func_979.output;
    func_7450.Execute(  );

    // [7465] Function call CfCompare1
    func_7465.inputA = func_1053.output;
    func_7465.inputB = func_980.output;
    func_7465.Execute(  );

    // [7466] Function call CfCompare1
    func_7466.inputA = func_1053.output;
    func_7466.inputB = func_981.output;
    func_7466.Execute(  );

    // [7469] Function call CfCompare1
    func_7469.inputA = func_1053.output;
    func_7469.inputB = func_982.output;
    func_7469.Execute(  );

    // [7470] Function call CfCompare1
    func_7470.inputA = func_1053.output;
    func_7470.inputB = func_983.output;
    func_7470.Execute(  );

    // [7473] Function call CfCompare1
    func_7473.inputA = func_1053.output;
    func_7473.inputB = func_984.output;
    func_7473.Execute(  );

    // [7474] Function call CfCompare1
    func_7474.inputA = func_1053.output;
    func_7474.inputB = func_985.output;
    func_7474.Execute(  );

    // [7475] Function call CfCompare1
    func_7475.inputA = func_1053.output;
    func_7475.inputB = func_986.output;
    func_7475.Execute(  );

    // [7476] Function call CfCompare1
    func_7476.inputA = func_1053.output;
    func_7476.inputB = func_987.output;
    func_7476.Execute(  );

    // [7477] Function call CfCompare1
    func_7477.inputA = func_1053.output;
    func_7477.inputB = func_988.output;
    func_7477.Execute(  );

    // [7604] Function call CfInputMultiplexer
    func_7604.inputSelect = BooleanToInt(func_7477.outputEqual);
    func_7604.input[1-1] = 0F;
    func_7604.input[2-1] = 12F;
    func_7604.Execute(  );

    // [7606] Function call CfInputMultiplexer
    func_7606.inputSelect = BooleanToInt(func_7476.outputEqual);
    func_7606.input[1-1] = func_7604.output;
    func_7606.input[2-1] = 11F;
    func_7606.Execute(  );

    // [7608] Function call CfInputMultiplexer
    func_7608.inputSelect = BooleanToInt(func_7475.outputEqual);
    func_7608.input[1-1] = func_7606.output;
    func_7608.input[2-1] = 10F;
    func_7608.Execute(  );

    // [7610] Function call CfInputMultiplexer
    func_7610.inputSelect = BooleanToInt(func_7474.outputEqual);
    func_7610.input[1-1] = func_7608.output;
    func_7610.input[2-1] = 9F;
    func_7610.Execute(  );

    // [7612] Function call CfInputMultiplexer
    func_7612.inputSelect = BooleanToInt(func_7473.outputEqual);
    func_7612.input[1-1] = func_7610.output;
    func_7612.input[2-1] = 8F;
    func_7612.Execute(  );

    // [7614] Function call CfInputMultiplexer
    func_7614.inputSelect = BooleanToInt(func_7470.outputEqual);
    func_7614.input[1-1] = func_7612.output;
    func_7614.input[2-1] = 7F;
    func_7614.Execute(  );

    // [7616] Function call CfInputMultiplexer
    func_7616.inputSelect = BooleanToInt(func_7469.outputEqual);
    func_7616.input[1-1] = func_7614.output;
    func_7616.input[2-1] = 6F;
    func_7616.Execute(  );

    // [7619] Function call CfInputMultiplexer
    func_7619.inputSelect = BooleanToInt(func_7466.outputEqual);
    func_7619.input[1-1] = func_7616.output;
    func_7619.input[2-1] = 5F;
    func_7619.Execute(  );

    // [7620] Function call CfInputMultiplexer
    func_7620.inputSelect = BooleanToInt(func_7465.outputEqual);
    func_7620.input[1-1] = func_7619.output;
    func_7620.input[2-1] = 4F;
    func_7620.Execute(  );

    // [7621] Function call CfInputMultiplexer
    func_7621.inputSelect = BooleanToInt(func_7450.outputEqual);
    func_7621.input[1-1] = func_7620.output;
    func_7621.input[2-1] = 3F;
    func_7621.Execute(  );

    // [7622] Function call CfInputMultiplexer
    func_7622.inputSelect = BooleanToInt(func_7449.outputEqual);
    func_7622.input[1-1] = func_7621.output;
    func_7622.input[2-1] = 2F;
    func_7622.Execute(  );

    // [7623] Function call CfInputMultiplexer
    func_7623.inputSelect = BooleanToInt(func_7447.outputEqual);
    func_7623.input[1-1] = func_7622.output;
    func_7623.input[2-1] = 1F;
    func_7623.Execute(  );

    // [1158] Function call CfIdt
    func_1158.input = func_7580.output;
    func_1158.Execute(  );

    // [1161] Function call CfOutputMultiplexer
    func_1161.inputSelect = FloatToInt(func_7623.output);
    func_1161.inputValue = func_1158.output[0];
    func_1161.Execute( this, 17 );
    if ( func_1161.outputValid[0]) register_356 = func_1161.output[0];

    // [7536] Function call CfCompare2
    func_7536.inputA = func_7623.output;
    func_7536.inputB = 1F;
    func_7536.Execute(  );

    // [7603] Function call CfAnd
    func_7603.input[0] = func_7574.outputNOR;
    func_7603.input[1] = func_7536.outputEqualOrGreater;
    func_7603.Execute(  );

    // [8080] Macro call Cmruntime_switches
    func_8080.Cmruntime_switches_input_1 = func_7603.outputAND;
    func_8080.Cmruntime_switches_input_68 = func_7623.output;
    func_8080.Cmruntime_switches_input_2 = register_293;
    func_8080.Cmruntime_switches_input_3 = func_1161.output[1];
    func_8080.Cmruntime_switches_input_4 = register_294;
    func_8080.Cmruntime_switches_input_5 = func_1161.output[2];
    func_8080.Cmruntime_switches_input_6 = register_295;
    func_8080.Cmruntime_switches_input_7 = func_1161.output[3];
    func_8080.Cmruntime_switches_input_8 = register_296;
    func_8080.Cmruntime_switches_input_9 = func_1161.output[4];
    func_8080.Cmruntime_switches_input_10 = register_297;
    func_8080.Cmruntime_switches_input_11 = func_1161.output[5];
    func_8080.Cmruntime_switches_input_12 = register_298;
    func_8080.Cmruntime_switches_input_13 = func_1161.output[6];
    func_8080.Cmruntime_switches_input_14 = register_299;
    func_8080.Cmruntime_switches_input_15 = func_1161.output[7];
    func_8080.Cmruntime_switches_input_16 = register_300;
    func_8080.Cmruntime_switches_input_17 = func_1161.output[8];
    func_8080.Cmruntime_switches_input_18 = register_301;
    func_8080.Cmruntime_switches_input_19 = func_1161.output[9];
    func_8080.Cmruntime_switches_input_20 = register_302;
    func_8080.Cmruntime_switches_input_21 = func_1161.output[10];
    func_8080.Cmruntime_switches_input_22 = register_303;
    func_8080.Cmruntime_switches_input_23 = func_1161.output[11];
    func_8080.Cmruntime_switches_input_24 = register_304;
    func_8080.Cmruntime_switches_input_25 = func_1161.output[12];
    func_8080.Execute(  );

    // [7539] Function call CfIdt
    func_7539.input = func_8080.Cmruntime_switches_output_26;
    func_7539.Execute(  );
    register_293 = func_7539.output[0];
    setCmSQA_ChillerSeq_parameter_33(func_7539.output[1]);

    // [7541] Function call CfIdt
    func_7541.input = func_8080.Cmruntime_switches_output_27;
    func_7541.Execute(  );
    register_294 = func_7541.output[0];
    setCmSQA_ChillerSeq_parameter_34(func_7541.output[1]);

    // [7542] Function call CfIdt
    func_7542.input = func_8080.Cmruntime_switches_output_28;
    func_7542.Execute(  );
    register_295 = func_7542.output[0];
    setCmSQA_ChillerSeq_parameter_35(func_7542.output[1]);

    // [7543] Function call CfIdt
    func_7543.input = func_8080.Cmruntime_switches_output_29;
    func_7543.Execute(  );
    register_296 = func_7543.output[0];
    setCmSQA_ChillerSeq_parameter_36(func_7543.output[1]);

    // [7544] Function call CfIdt
    func_7544.input = func_8080.Cmruntime_switches_output_30;
    func_7544.Execute(  );
    register_297 = func_7544.output[0];
    setCmSQA_ChillerSeq_parameter_37(func_7544.output[1]);

    // [7545] Function call CfIdt
    func_7545.input = func_8080.Cmruntime_switches_output_31;
    func_7545.Execute(  );
    register_298 = func_7545.output[0];
    setCmSQA_ChillerSeq_parameter_38(func_7545.output[1]);

    // [7546] Function call CfIdt
    func_7546.input = func_8080.Cmruntime_switches_output_32;
    func_7546.Execute(  );
    register_299 = func_7546.output[0];
    setCmSQA_ChillerSeq_parameter_39(func_7546.output[1]);

    // [7547] Function call CfIdt
    func_7547.input = func_8080.Cmruntime_switches_output_33;
    func_7547.Execute(  );
    register_300 = func_7547.output[0];
    setCmSQA_ChillerSeq_parameter_40(func_7547.output[1]);

    // [7548] Function call CfIdt
    func_7548.input = func_8080.Cmruntime_switches_output_34;
    func_7548.Execute(  );
    register_301 = func_7548.output[0];
    setCmSQA_ChillerSeq_parameter_41(func_7548.output[1]);

    // [7549] Function call CfIdt
    func_7549.input = func_8080.Cmruntime_switches_output_35;
    func_7549.Execute(  );
    register_302 = func_7549.output[0];
    setCmSQA_ChillerSeq_parameter_42(func_7549.output[1]);

    // [7550] Function call CfIdt
    func_7550.input = func_8080.Cmruntime_switches_output_36;
    func_7550.Execute(  );
    register_303 = func_7550.output[0];
    setCmSQA_ChillerSeq_parameter_43(func_7550.output[1]);

    // [7551] Function call CfIdt
    func_7551.input = func_8080.Cmruntime_switches_output_37;
    func_7551.Execute(  );
    register_304 = func_7551.output[0];
    setCmSQA_ChillerSeq_parameter_44(func_7551.output[1]);

    // [1191] Function call CfIdt
    func_1191.input = func_814.output[0];
    func_1191.Execute(  );

    // [1192] Function call CfIdt
    func_1192.input = register_305;
    func_1192.Execute(  );

    // [1193] Function call CfIdt
    func_1193.input = func_7572.output;
    func_1193.Execute(  );

    // [1194] Function call CfIdt
    func_1194.input = func_7573.output;
    func_1194.Execute(  );

    // [1196] Function call CfIdt
    func_1196.input = func_1191.output[0];
    func_1196.Execute(  );
    register_305 = func_1196.output[0];

    // [1197] Function call CfSubtract
    func_1197.input[0] = 1F;
    func_1197.input[1] = func_1192.output[0];
    func_1197.Execute(  );

    // [1198] Function call CfSubtract
    func_1198.input[0] = 1F;
    func_1198.input[1] = func_1194.output[0];
    func_1198.Execute(  );

    // [1201] Function call CfAnd
    func_1201.input[0] = FloatToBoolean(func_1191.output[0]);
    func_1201.input[1] = FloatToBoolean(func_1197.output);
    func_1201.Execute(  );

    // [1203] Function call CfAnd
    func_1203.input[0] = FloatToBoolean(func_1193.output[0]);
    func_1203.input[1] = FloatToBoolean(func_1198.output);
    func_1203.Execute(  );

    // [8143] Function call CfCompare1
    func_8143.inputA = (float) getCmSQA_ChillerSeq_parameter_15();
    func_8143.inputB = 1F;
    func_8143.Execute(  );

    // [1206] Function call CfAnd
    func_1206.input[0] = func_8143.outputEqual;
    func_1206.input[1] = func_1201.outputAND;
    func_1206.Execute(  );

    // [8142] Function call CfCompare1
    func_8142.inputA = (float) getCmSQA_ChillerSeq_parameter_15();
    func_8142.inputB = 3F;
    func_8142.Execute(  );

    // [1207] Function call CfAnd
    func_1207.input[0] = func_8142.outputEqual;
    func_1207.input[1] = func_1203.outputAND;
    func_1207.Execute(  );

    // [1211] Function call CfCompare1
    func_1211.inputA = (float) getCmSQA_ChillerSeq_parameter_21();
    func_1211.inputB = 0F;
    func_1211.Execute(  );

    // [8141] Function call CfNot
    func_8141.input = func_9771.outputAND;
    func_8141.Execute(  );

    // [1214] Function call CfOr
    func_1214.input[0] = func_1206.outputAND;
    func_1214.input[1] = func_1207.outputAND;
    func_1214.input[2] = func_8141.output;
    func_1214.input[3] = false;
    func_1214.input[4] = func_7211.outputEqual;
    func_1214.Execute(  );

    // [7211] Function call CfCompare1
    func_7211.inputA = (float) getCmSQA_ChillerSeq_parameter_32();
    func_7211.inputB = 2F;
    func_7211.Execute(  );

    // [7212] Function call CfInputMultiplexer
    func_7212.inputSelect = BooleanToInt(func_7211.outputEqual);
    func_7212.input[1-1] = (float) getCmSQA_ChillerSeq_parameter_32();
    func_7212.input[2-1] = 1F;
    func_7212.Execute(  );
    setCmSQA_ChillerSeq_parameter_32(func_7212.output);

    // [1221] Function call CfIdt
    func_1221.input = BooleanToFloat(func_1214.outputOR);
    func_1221.Execute(  );

    // [8272] Macro call Cmswitch_x_12
    func_8272.Cmswitch_x_12_input_1 = func_1214.outputOR;
    func_8272.Cmswitch_x_12_input_2 = register_325;
    func_8272.Cmswitch_x_12_input_3 = 0F;
    func_8272.Cmswitch_x_12_input_4 = register_326;
    func_8272.Cmswitch_x_12_input_5 = 0F;
    func_8272.Cmswitch_x_12_input_6 = register_327;
    func_8272.Cmswitch_x_12_input_7 = 0F;
    func_8272.Cmswitch_x_12_input_8 = register_328;
    func_8272.Cmswitch_x_12_input_9 = 0F;
    func_8272.Cmswitch_x_12_input_10 = register_329;
    func_8272.Cmswitch_x_12_input_11 = 0F;
    func_8272.Cmswitch_x_12_input_12 = register_330;
    func_8272.Cmswitch_x_12_input_13 = 0F;
    func_8272.Cmswitch_x_12_input_14 = register_331;
    func_8272.Cmswitch_x_12_input_15 = 0F;
    func_8272.Cmswitch_x_12_input_16 = register_332;
    func_8272.Cmswitch_x_12_input_17 = 0F;
    func_8272.Cmswitch_x_12_input_18 = register_333;
    func_8272.Cmswitch_x_12_input_19 = 0F;
    func_8272.Cmswitch_x_12_input_20 = register_334;
    func_8272.Cmswitch_x_12_input_21 = 0F;
    func_8272.Cmswitch_x_12_input_22 = register_335;
    func_8272.Cmswitch_x_12_input_23 = 0F;
    func_8272.Cmswitch_x_12_input_24 = register_336;
    func_8272.Cmswitch_x_12_input_25 = 0F;
    func_8272.Execute(  );
    register_325 = func_8272.Cmswitch_x_12_output_26;
    register_326 = func_8272.Cmswitch_x_12_output_27;
    register_327 = func_8272.Cmswitch_x_12_output_28;
    register_328 = func_8272.Cmswitch_x_12_output_29;
    register_329 = func_8272.Cmswitch_x_12_output_30;
    register_330 = func_8272.Cmswitch_x_12_output_31;
    register_331 = func_8272.Cmswitch_x_12_output_32;
    register_332 = func_8272.Cmswitch_x_12_output_33;
    register_333 = func_8272.Cmswitch_x_12_output_34;
    register_334 = func_8272.Cmswitch_x_12_output_35;
    register_335 = func_8272.Cmswitch_x_12_output_36;
    register_336 = func_8272.Cmswitch_x_12_output_37;

    // [8284] Function call CfInputMultiplexer
    func_8284.inputSelect = BooleanToInt(func_1214.outputOR);
    func_8284.input[1-1] = register_323;
    func_8284.input[2-1] = BooleanToFloat(func_1211.outputLess);
    func_8284.Execute(  );
    register_323 = func_8284.output;

    // [9201] Function call CfAnd
    func_9201.input[0] = func_1214.outputNOR;
    func_9201.input[1] = FloatToBoolean(func_8447.output);
    func_9201.input[2] = func_682.outputAND;
    func_9201.Execute(  );

    // [9408] Macro call CmIncrease_Operation_List
    if ( func_9201.outputAND)
    {
      func_9408.CmIncrease_Operation_List_input_1 = register_325;
      func_9408.CmIncrease_Operation_List_input_2 = register_326;
      func_9408.CmIncrease_Operation_List_input_3 = register_327;
      func_9408.CmIncrease_Operation_List_input_4 = register_328;
      func_9408.CmIncrease_Operation_List_input_5 = register_329;
      func_9408.CmIncrease_Operation_List_input_6 = register_330;
      func_9408.CmIncrease_Operation_List_input_7 = register_331;
      func_9408.CmIncrease_Operation_List_input_8 = register_332;
      func_9408.CmIncrease_Operation_List_input_9 = register_333;
      func_9408.CmIncrease_Operation_List_input_10 = register_334;
      func_9408.CmIncrease_Operation_List_input_11 = register_335;
      func_9408.CmIncrease_Operation_List_input_12 = register_336;
      func_9408.CmIncrease_Operation_List_input_46 = func_8447.output;
      func_9408.Execute( this, 18 );
      register_325 = func_9408.CmIncrease_Operation_List_output_13;
      register_326 = func_9408.CmIncrease_Operation_List_output_14;
      register_327 = func_9408.CmIncrease_Operation_List_output_15;
      register_328 = func_9408.CmIncrease_Operation_List_output_16;
      register_329 = func_9408.CmIncrease_Operation_List_output_17;
      register_330 = func_9408.CmIncrease_Operation_List_output_18;
      register_331 = func_9408.CmIncrease_Operation_List_output_19;
      register_332 = func_9408.CmIncrease_Operation_List_output_20;
      register_333 = func_9408.CmIncrease_Operation_List_output_21;
      register_334 = func_9408.CmIncrease_Operation_List_output_22;
      register_335 = func_9408.CmIncrease_Operation_List_output_23;
      register_336 = func_9408.CmIncrease_Operation_List_output_24;
    }

    // [9277] Function call CfCompare1
    func_9277.inputA = (float) getCmSQA_ChillerSeq_parameter_15();
    func_9277.inputB = 2F;
    func_9277.Execute(  );

    // [9274] Function call CfAnd
    func_9274.input[0] = func_9201.outputAND;
    func_9274.input[1] = func_9277.outputEqual;
    func_9274.Execute(  );

    // [9273] Macro call CmLoad_rotation_increase
    func_9273.CmLoad_rotation_increase_input_1 = register_325;
    func_9273.CmLoad_rotation_increase_input_2 = register_326;
    func_9273.CmLoad_rotation_increase_input_3 = register_327;
    func_9273.CmLoad_rotation_increase_input_4 = register_328;
    func_9273.CmLoad_rotation_increase_input_5 = register_329;
    func_9273.CmLoad_rotation_increase_input_6 = register_330;
    func_9273.CmLoad_rotation_increase_input_7 = register_331;
    func_9273.CmLoad_rotation_increase_input_8 = register_332;
    func_9273.CmLoad_rotation_increase_input_9 = register_333;
    func_9273.CmLoad_rotation_increase_input_10 = register_334;
    func_9273.CmLoad_rotation_increase_input_11 = register_335;
    func_9273.CmLoad_rotation_increase_input_12 = register_336;
    func_9273.CmLoad_rotation_increase_input_13 = (float) getCmSQA_ChillerSeq_parameter_33();
    func_9273.CmLoad_rotation_increase_input_14 = (float) getCmSQA_ChillerSeq_parameter_34();
    func_9273.CmLoad_rotation_increase_input_15 = (float) getCmSQA_ChillerSeq_parameter_35();
    func_9273.CmLoad_rotation_increase_input_16 = (float) getCmSQA_ChillerSeq_parameter_36();
    func_9273.CmLoad_rotation_increase_input_17 = (float) getCmSQA_ChillerSeq_parameter_37();
    func_9273.CmLoad_rotation_increase_input_18 = (float) getCmSQA_ChillerSeq_parameter_38();
    func_9273.CmLoad_rotation_increase_input_19 = (float) getCmSQA_ChillerSeq_parameter_39();
    func_9273.CmLoad_rotation_increase_input_20 = (float) getCmSQA_ChillerSeq_parameter_40();
    func_9273.CmLoad_rotation_increase_input_21 = (float) getCmSQA_ChillerSeq_parameter_41();
    func_9273.CmLoad_rotation_increase_input_22 = (float) getCmSQA_ChillerSeq_parameter_42();
    func_9273.CmLoad_rotation_increase_input_23 = (float) getCmSQA_ChillerSeq_parameter_43();
    func_9273.CmLoad_rotation_increase_input_24 = (float) getCmSQA_ChillerSeq_parameter_44();
    func_9273.CmLoad_rotation_increase_input_102 = FloatToBoolean(register_311);
    func_9273.CmLoad_rotation_increase_input_103 = FloatToBoolean(register_312);
    func_9273.CmLoad_rotation_increase_input_104 = FloatToBoolean(register_313);
    func_9273.CmLoad_rotation_increase_input_105 = FloatToBoolean(func_6055.CmCommInputProc_output_188);
    func_9273.CmLoad_rotation_increase_input_106 = FloatToBoolean(func_6055.CmCommInputProc_output_189);
    func_9273.CmLoad_rotation_increase_input_107 = FloatToBoolean(func_6055.CmCommInputProc_output_190);
    func_9273.CmLoad_rotation_increase_input_108 = FloatToBoolean(func_6055.CmCommInputProc_output_191);
    func_9273.CmLoad_rotation_increase_input_109 = FloatToBoolean(func_6055.CmCommInputProc_output_192);
    func_9273.CmLoad_rotation_increase_input_110 = FloatToBoolean(func_6055.CmCommInputProc_output_193);
    func_9273.CmLoad_rotation_increase_input_111 = FloatToBoolean(func_6055.CmCommInputProc_output_194);
    func_9273.CmLoad_rotation_increase_input_112 = FloatToBoolean(func_6055.CmCommInputProc_output_195);
    func_9273.CmLoad_rotation_increase_input_113 = FloatToBoolean(func_6055.CmCommInputProc_output_196);
    func_9273.CmLoad_rotation_increase_input_257 = func_9150.output;
    func_9273.CmLoad_rotation_increase_input_255 = func_8447.output;
    func_9273.CmLoad_rotation_increase_input_262 = register_293;
    func_9273.CmLoad_rotation_increase_input_263 = register_294;
    func_9273.CmLoad_rotation_increase_input_264 = register_295;
    func_9273.CmLoad_rotation_increase_input_265 = register_296;
    func_9273.CmLoad_rotation_increase_input_266 = register_297;
    func_9273.CmLoad_rotation_increase_input_267 = register_298;
    func_9273.CmLoad_rotation_increase_input_268 = register_299;
    func_9273.CmLoad_rotation_increase_input_269 = register_300;
    func_9273.CmLoad_rotation_increase_input_270 = register_301;
    func_9273.CmLoad_rotation_increase_input_271 = register_302;
    func_9273.CmLoad_rotation_increase_input_272 = register_303;
    func_9273.CmLoad_rotation_increase_input_273 = register_304;
    func_9273.Execute( this, 19 );

    // [9282] Macro call Cmswitch_x_12
    func_9282.Cmswitch_x_12_input_1 = func_9274.outputAND;
    func_9282.Cmswitch_x_12_input_2 = register_293;
    func_9282.Cmswitch_x_12_input_3 = func_9273.CmLoad_rotation_increase_output_25;
    func_9282.Cmswitch_x_12_input_4 = register_294;
    func_9282.Cmswitch_x_12_input_5 = func_9273.CmLoad_rotation_increase_output_26;
    func_9282.Cmswitch_x_12_input_6 = register_295;
    func_9282.Cmswitch_x_12_input_7 = func_9273.CmLoad_rotation_increase_output_27;
    func_9282.Cmswitch_x_12_input_8 = register_296;
    func_9282.Cmswitch_x_12_input_9 = func_9273.CmLoad_rotation_increase_output_28;
    func_9282.Cmswitch_x_12_input_10 = register_297;
    func_9282.Cmswitch_x_12_input_11 = func_9273.CmLoad_rotation_increase_output_29;
    func_9282.Cmswitch_x_12_input_12 = register_298;
    func_9282.Cmswitch_x_12_input_13 = func_9273.CmLoad_rotation_increase_output_30;
    func_9282.Cmswitch_x_12_input_14 = register_299;
    func_9282.Cmswitch_x_12_input_15 = func_9273.CmLoad_rotation_increase_output_31;
    func_9282.Cmswitch_x_12_input_16 = register_300;
    func_9282.Cmswitch_x_12_input_17 = func_9273.CmLoad_rotation_increase_output_32;
    func_9282.Cmswitch_x_12_input_18 = register_301;
    func_9282.Cmswitch_x_12_input_19 = func_9273.CmLoad_rotation_increase_output_33;
    func_9282.Cmswitch_x_12_input_20 = register_302;
    func_9282.Cmswitch_x_12_input_21 = func_9273.CmLoad_rotation_increase_output_34;
    func_9282.Cmswitch_x_12_input_22 = register_303;
    func_9282.Cmswitch_x_12_input_23 = func_9273.CmLoad_rotation_increase_output_35;
    func_9282.Cmswitch_x_12_input_24 = register_304;
    func_9282.Cmswitch_x_12_input_25 = func_9273.CmLoad_rotation_increase_output_36;
    func_9282.Execute(  );
    register_293 = func_9282.Cmswitch_x_12_output_26;
    register_294 = func_9282.Cmswitch_x_12_output_27;
    register_295 = func_9282.Cmswitch_x_12_output_28;
    register_296 = func_9282.Cmswitch_x_12_output_29;
    register_297 = func_9282.Cmswitch_x_12_output_30;
    register_298 = func_9282.Cmswitch_x_12_output_31;
    register_299 = func_9282.Cmswitch_x_12_output_32;
    register_300 = func_9282.Cmswitch_x_12_output_33;
    register_301 = func_9282.Cmswitch_x_12_output_34;
    register_302 = func_9282.Cmswitch_x_12_output_35;
    register_303 = func_9282.Cmswitch_x_12_output_36;
    register_304 = func_9282.Cmswitch_x_12_output_37;

    // [9294] Macro call Cmswitch_x_12
    func_9294.Cmswitch_x_12_input_1 = func_9274.outputAND;
    func_9294.Cmswitch_x_12_input_2 = (float) getCmSQA_ChillerSeq_parameter_33();
    func_9294.Cmswitch_x_12_input_3 = func_9273.CmLoad_rotation_increase_output_114;
    func_9294.Cmswitch_x_12_input_4 = (float) getCmSQA_ChillerSeq_parameter_34();
    func_9294.Cmswitch_x_12_input_5 = func_9273.CmLoad_rotation_increase_output_115;
    func_9294.Cmswitch_x_12_input_6 = (float) getCmSQA_ChillerSeq_parameter_35();
    func_9294.Cmswitch_x_12_input_7 = func_9273.CmLoad_rotation_increase_output_116;
    func_9294.Cmswitch_x_12_input_8 = (float) getCmSQA_ChillerSeq_parameter_36();
    func_9294.Cmswitch_x_12_input_9 = func_9273.CmLoad_rotation_increase_output_117;
    func_9294.Cmswitch_x_12_input_10 = (float) getCmSQA_ChillerSeq_parameter_37();
    func_9294.Cmswitch_x_12_input_11 = func_9273.CmLoad_rotation_increase_output_118;
    func_9294.Cmswitch_x_12_input_12 = (float) getCmSQA_ChillerSeq_parameter_38();
    func_9294.Cmswitch_x_12_input_13 = func_9273.CmLoad_rotation_increase_output_119;
    func_9294.Cmswitch_x_12_input_14 = (float) getCmSQA_ChillerSeq_parameter_39();
    func_9294.Cmswitch_x_12_input_15 = func_9273.CmLoad_rotation_increase_output_120;
    func_9294.Cmswitch_x_12_input_16 = (float) getCmSQA_ChillerSeq_parameter_40();
    func_9294.Cmswitch_x_12_input_17 = func_9273.CmLoad_rotation_increase_output_121;
    func_9294.Cmswitch_x_12_input_18 = (float) getCmSQA_ChillerSeq_parameter_41();
    func_9294.Cmswitch_x_12_input_19 = func_9273.CmLoad_rotation_increase_output_122;
    func_9294.Cmswitch_x_12_input_20 = (float) getCmSQA_ChillerSeq_parameter_42();
    func_9294.Cmswitch_x_12_input_21 = func_9273.CmLoad_rotation_increase_output_123;
    func_9294.Cmswitch_x_12_input_22 = (float) getCmSQA_ChillerSeq_parameter_43();
    func_9294.Cmswitch_x_12_input_23 = func_9273.CmLoad_rotation_increase_output_124;
    func_9294.Cmswitch_x_12_input_24 = (float) getCmSQA_ChillerSeq_parameter_44();
    func_9294.Cmswitch_x_12_input_25 = func_9273.CmLoad_rotation_increase_output_125;
    func_9294.Execute(  );
    setCmSQA_ChillerSeq_parameter_33(func_9294.Cmswitch_x_12_output_26);
    setCmSQA_ChillerSeq_parameter_34(func_9294.Cmswitch_x_12_output_27);
    setCmSQA_ChillerSeq_parameter_35(func_9294.Cmswitch_x_12_output_28);
    setCmSQA_ChillerSeq_parameter_36(func_9294.Cmswitch_x_12_output_29);
    setCmSQA_ChillerSeq_parameter_37(func_9294.Cmswitch_x_12_output_30);
    setCmSQA_ChillerSeq_parameter_38(func_9294.Cmswitch_x_12_output_31);
    setCmSQA_ChillerSeq_parameter_39(func_9294.Cmswitch_x_12_output_32);
    setCmSQA_ChillerSeq_parameter_40(func_9294.Cmswitch_x_12_output_33);
    setCmSQA_ChillerSeq_parameter_41(func_9294.Cmswitch_x_12_output_34);
    setCmSQA_ChillerSeq_parameter_42(func_9294.Cmswitch_x_12_output_35);
    setCmSQA_ChillerSeq_parameter_43(func_9294.Cmswitch_x_12_output_36);
    setCmSQA_ChillerSeq_parameter_44(func_9294.Cmswitch_x_12_output_37);

    // [9307] Function call CfAnd
    func_9307.input[0] = func_1214.outputNOR;
    func_9307.input[1] = FloatToBoolean(func_8731.output);
    func_9307.input[2] = func_666.outputLess;
    func_9307.Execute(  );

    // [9410] Macro call CmDecrease_Operation_List
    if ( func_9307.outputAND)
    {
      func_9410.CmDecrease_Operation_List_input_1 = register_325;
      func_9410.CmDecrease_Operation_List_input_2 = register_326;
      func_9410.CmDecrease_Operation_List_input_3 = register_327;
      func_9410.CmDecrease_Operation_List_input_4 = register_328;
      func_9410.CmDecrease_Operation_List_input_5 = register_329;
      func_9410.CmDecrease_Operation_List_input_6 = register_330;
      func_9410.CmDecrease_Operation_List_input_7 = register_331;
      func_9410.CmDecrease_Operation_List_input_8 = register_332;
      func_9410.CmDecrease_Operation_List_input_9 = register_333;
      func_9410.CmDecrease_Operation_List_input_10 = register_334;
      func_9410.CmDecrease_Operation_List_input_11 = register_335;
      func_9410.CmDecrease_Operation_List_input_12 = register_336;
      func_9410.CmDecrease_Operation_List_input_46 = func_8731.output;
      func_9410.Execute( this, 20 );
      register_325 = func_9410.CmDecrease_Operation_List_output_13;
      register_326 = func_9410.CmDecrease_Operation_List_output_14;
      register_327 = func_9410.CmDecrease_Operation_List_output_15;
      register_328 = func_9410.CmDecrease_Operation_List_output_16;
      register_329 = func_9410.CmDecrease_Operation_List_output_17;
      register_330 = func_9410.CmDecrease_Operation_List_output_18;
      register_331 = func_9410.CmDecrease_Operation_List_output_19;
      register_332 = func_9410.CmDecrease_Operation_List_output_20;
      register_333 = func_9410.CmDecrease_Operation_List_output_21;
      register_334 = func_9410.CmDecrease_Operation_List_output_22;
      register_335 = func_9410.CmDecrease_Operation_List_output_23;
      register_336 = func_9410.CmDecrease_Operation_List_output_24;
    }

    // [9331] Function call CfAnd
    func_9331.input[0] = func_9307.outputAND;
    func_9331.input[1] = func_9277.outputEqual;
    func_9331.Execute(  );

    // [9316] Macro call CmLoad_rotation_decrease
    func_9316.CmLoad_rotation_decrease_input_1 = register_325;
    func_9316.CmLoad_rotation_decrease_input_2 = register_326;
    func_9316.CmLoad_rotation_decrease_input_3 = register_327;
    func_9316.CmLoad_rotation_decrease_input_4 = register_328;
    func_9316.CmLoad_rotation_decrease_input_5 = register_329;
    func_9316.CmLoad_rotation_decrease_input_6 = register_330;
    func_9316.CmLoad_rotation_decrease_input_7 = register_331;
    func_9316.CmLoad_rotation_decrease_input_8 = register_332;
    func_9316.CmLoad_rotation_decrease_input_9 = register_333;
    func_9316.CmLoad_rotation_decrease_input_10 = register_334;
    func_9316.CmLoad_rotation_decrease_input_11 = register_335;
    func_9316.CmLoad_rotation_decrease_input_12 = register_336;
    func_9316.CmLoad_rotation_decrease_input_13 = (float) getCmSQA_ChillerSeq_parameter_33();
    func_9316.CmLoad_rotation_decrease_input_14 = (float) getCmSQA_ChillerSeq_parameter_34();
    func_9316.CmLoad_rotation_decrease_input_15 = (float) getCmSQA_ChillerSeq_parameter_35();
    func_9316.CmLoad_rotation_decrease_input_16 = (float) getCmSQA_ChillerSeq_parameter_36();
    func_9316.CmLoad_rotation_decrease_input_17 = (float) getCmSQA_ChillerSeq_parameter_37();
    func_9316.CmLoad_rotation_decrease_input_18 = (float) getCmSQA_ChillerSeq_parameter_38();
    func_9316.CmLoad_rotation_decrease_input_19 = (float) getCmSQA_ChillerSeq_parameter_39();
    func_9316.CmLoad_rotation_decrease_input_20 = (float) getCmSQA_ChillerSeq_parameter_40();
    func_9316.CmLoad_rotation_decrease_input_21 = (float) getCmSQA_ChillerSeq_parameter_41();
    func_9316.CmLoad_rotation_decrease_input_22 = (float) getCmSQA_ChillerSeq_parameter_42();
    func_9316.CmLoad_rotation_decrease_input_23 = (float) getCmSQA_ChillerSeq_parameter_43();
    func_9316.CmLoad_rotation_decrease_input_24 = (float) getCmSQA_ChillerSeq_parameter_44();
    func_9316.CmLoad_rotation_decrease_input_257 = func_9150.output;
    func_9316.CmLoad_rotation_decrease_input_255 = func_8731.output;
    func_9316.CmLoad_rotation_decrease_input_301 = register_293;
    func_9316.CmLoad_rotation_decrease_input_302 = register_294;
    func_9316.CmLoad_rotation_decrease_input_303 = register_295;
    func_9316.CmLoad_rotation_decrease_input_304 = register_296;
    func_9316.CmLoad_rotation_decrease_input_305 = register_297;
    func_9316.CmLoad_rotation_decrease_input_306 = register_298;
    func_9316.CmLoad_rotation_decrease_input_307 = register_299;
    func_9316.CmLoad_rotation_decrease_input_308 = register_300;
    func_9316.CmLoad_rotation_decrease_input_309 = register_301;
    func_9316.CmLoad_rotation_decrease_input_310 = register_302;
    func_9316.CmLoad_rotation_decrease_input_311 = register_303;
    func_9316.CmLoad_rotation_decrease_input_312 = register_304;
    func_9316.Execute( this, 21 );

    // [9334] Macro call Cmswitch_x_12
    func_9334.Cmswitch_x_12_input_1 = func_9331.outputAND;
    func_9334.Cmswitch_x_12_input_2 = (float) getCmSQA_ChillerSeq_parameter_33();
    func_9334.Cmswitch_x_12_input_3 = func_9316.CmLoad_rotation_decrease_output_114;
    func_9334.Cmswitch_x_12_input_4 = (float) getCmSQA_ChillerSeq_parameter_34();
    func_9334.Cmswitch_x_12_input_5 = func_9316.CmLoad_rotation_decrease_output_115;
    func_9334.Cmswitch_x_12_input_6 = (float) getCmSQA_ChillerSeq_parameter_35();
    func_9334.Cmswitch_x_12_input_7 = func_9316.CmLoad_rotation_decrease_output_116;
    func_9334.Cmswitch_x_12_input_8 = (float) getCmSQA_ChillerSeq_parameter_36();
    func_9334.Cmswitch_x_12_input_9 = func_9316.CmLoad_rotation_decrease_output_117;
    func_9334.Cmswitch_x_12_input_10 = (float) getCmSQA_ChillerSeq_parameter_37();
    func_9334.Cmswitch_x_12_input_11 = func_9316.CmLoad_rotation_decrease_output_118;
    func_9334.Cmswitch_x_12_input_12 = (float) getCmSQA_ChillerSeq_parameter_38();
    func_9334.Cmswitch_x_12_input_13 = func_9316.CmLoad_rotation_decrease_output_119;
    func_9334.Cmswitch_x_12_input_14 = (float) getCmSQA_ChillerSeq_parameter_39();
    func_9334.Cmswitch_x_12_input_15 = func_9316.CmLoad_rotation_decrease_output_120;
    func_9334.Cmswitch_x_12_input_16 = (float) getCmSQA_ChillerSeq_parameter_40();
    func_9334.Cmswitch_x_12_input_17 = func_9316.CmLoad_rotation_decrease_output_121;
    func_9334.Cmswitch_x_12_input_18 = (float) getCmSQA_ChillerSeq_parameter_41();
    func_9334.Cmswitch_x_12_input_19 = func_9316.CmLoad_rotation_decrease_output_122;
    func_9334.Cmswitch_x_12_input_20 = (float) getCmSQA_ChillerSeq_parameter_42();
    func_9334.Cmswitch_x_12_input_21 = func_9316.CmLoad_rotation_decrease_output_123;
    func_9334.Cmswitch_x_12_input_22 = (float) getCmSQA_ChillerSeq_parameter_43();
    func_9334.Cmswitch_x_12_input_23 = func_9316.CmLoad_rotation_decrease_output_124;
    func_9334.Cmswitch_x_12_input_24 = (float) getCmSQA_ChillerSeq_parameter_44();
    func_9334.Cmswitch_x_12_input_25 = func_9316.CmLoad_rotation_decrease_output_125;
    func_9334.Execute(  );
    setCmSQA_ChillerSeq_parameter_33(func_9334.Cmswitch_x_12_output_26);
    setCmSQA_ChillerSeq_parameter_34(func_9334.Cmswitch_x_12_output_27);
    setCmSQA_ChillerSeq_parameter_35(func_9334.Cmswitch_x_12_output_28);
    setCmSQA_ChillerSeq_parameter_36(func_9334.Cmswitch_x_12_output_29);
    setCmSQA_ChillerSeq_parameter_37(func_9334.Cmswitch_x_12_output_30);
    setCmSQA_ChillerSeq_parameter_38(func_9334.Cmswitch_x_12_output_31);
    setCmSQA_ChillerSeq_parameter_39(func_9334.Cmswitch_x_12_output_32);
    setCmSQA_ChillerSeq_parameter_40(func_9334.Cmswitch_x_12_output_33);
    setCmSQA_ChillerSeq_parameter_41(func_9334.Cmswitch_x_12_output_34);
    setCmSQA_ChillerSeq_parameter_42(func_9334.Cmswitch_x_12_output_35);
    setCmSQA_ChillerSeq_parameter_43(func_9334.Cmswitch_x_12_output_36);
    setCmSQA_ChillerSeq_parameter_44(func_9334.Cmswitch_x_12_output_37);

    // [9347] Macro call Cmswitch_x_12
    func_9347.Cmswitch_x_12_input_1 = func_9331.outputAND;
    func_9347.Cmswitch_x_12_input_2 = register_293;
    func_9347.Cmswitch_x_12_input_3 = func_9316.CmLoad_rotation_decrease_output_289;
    func_9347.Cmswitch_x_12_input_4 = register_294;
    func_9347.Cmswitch_x_12_input_5 = func_9316.CmLoad_rotation_decrease_output_290;
    func_9347.Cmswitch_x_12_input_6 = register_295;
    func_9347.Cmswitch_x_12_input_7 = func_9316.CmLoad_rotation_decrease_output_291;
    func_9347.Cmswitch_x_12_input_8 = register_296;
    func_9347.Cmswitch_x_12_input_9 = func_9316.CmLoad_rotation_decrease_output_292;
    func_9347.Cmswitch_x_12_input_10 = register_297;
    func_9347.Cmswitch_x_12_input_11 = func_9316.CmLoad_rotation_decrease_output_293;
    func_9347.Cmswitch_x_12_input_12 = register_298;
    func_9347.Cmswitch_x_12_input_13 = func_9316.CmLoad_rotation_decrease_output_294;
    func_9347.Cmswitch_x_12_input_14 = register_299;
    func_9347.Cmswitch_x_12_input_15 = func_9316.CmLoad_rotation_decrease_output_295;
    func_9347.Cmswitch_x_12_input_16 = register_300;
    func_9347.Cmswitch_x_12_input_17 = func_9316.CmLoad_rotation_decrease_output_296;
    func_9347.Cmswitch_x_12_input_18 = register_301;
    func_9347.Cmswitch_x_12_input_19 = func_9316.CmLoad_rotation_decrease_output_297;
    func_9347.Cmswitch_x_12_input_20 = register_302;
    func_9347.Cmswitch_x_12_input_21 = func_9316.CmLoad_rotation_decrease_output_298;
    func_9347.Cmswitch_x_12_input_22 = register_303;
    func_9347.Cmswitch_x_12_input_23 = func_9316.CmLoad_rotation_decrease_output_299;
    func_9347.Cmswitch_x_12_input_24 = register_304;
    func_9347.Cmswitch_x_12_input_25 = func_9316.CmLoad_rotation_decrease_output_300;
    func_9347.Execute(  );
    register_293 = func_9347.Cmswitch_x_12_output_26;
    register_294 = func_9347.Cmswitch_x_12_output_27;
    register_295 = func_9347.Cmswitch_x_12_output_28;
    register_296 = func_9347.Cmswitch_x_12_output_29;
    register_297 = func_9347.Cmswitch_x_12_output_30;
    register_298 = func_9347.Cmswitch_x_12_output_31;
    register_299 = func_9347.Cmswitch_x_12_output_32;
    register_300 = func_9347.Cmswitch_x_12_output_33;
    register_301 = func_9347.Cmswitch_x_12_output_34;
    register_302 = func_9347.Cmswitch_x_12_output_35;
    register_303 = func_9347.Cmswitch_x_12_output_36;
    register_304 = func_9347.Cmswitch_x_12_output_37;

    // [1550] Function call CfAddition
    func_1550.input[0] = func_660.output[0];
    func_1550.input[1] = 1F;
    func_1550.Execute(  );

    // [1551] Function call CfMaximum
    func_1551.input[0] = 1F;
    func_1551.input[1] = func_9150.output;
    func_1551.Execute(  );

    // [1553] Function call CfDivide
    func_1553.inputA = func_1550.output;
    func_1553.inputB = func_1551.output;
    func_1553.Execute(  );

    // [8350] Function call CfCompare1
    func_8350.inputA = (float) getCmSQA_ChillerSeq_parameter_31();
    func_8350.inputB = 0F;
    func_8350.Execute(  );

    // [1556] Function call CfInputMultiplexer
    func_1556.inputSelect = BooleanToInt(func_8350.outputEqual);
    func_1556.input[1-1] = func_1553.output;
    func_1556.input[2-1] = (float) getCmSQA_ChillerSeq_parameter_30();
    func_1556.Execute(  );

    // [8357] Macro call Cmnext_to_start
    func_8357.Cmnext_to_start_input_1 = register_325;
    func_8357.Cmnext_to_start_input_2 = func_1556.output;
    func_8357.Cmnext_to_start_input_3 = (float) getCmSQA_ChillerSeq_parameter_33();
    func_8357.Cmnext_to_start_input_4 = register_293;
    func_8357.Cmnext_to_start_input_5 = register_311;
    func_8357.Execute(  );

    // [8360] Macro call Cmnext_to_start
    func_8360.Cmnext_to_start_input_1 = register_326;
    func_8360.Cmnext_to_start_input_2 = func_1556.output;
    func_8360.Cmnext_to_start_input_3 = (float) getCmSQA_ChillerSeq_parameter_34();
    func_8360.Cmnext_to_start_input_4 = register_294;
    func_8360.Cmnext_to_start_input_5 = register_312;
    func_8360.Execute(  );

    // [8363] Macro call Cmnext_to_start
    func_8363.Cmnext_to_start_input_1 = register_327;
    func_8363.Cmnext_to_start_input_2 = func_1556.output;
    func_8363.Cmnext_to_start_input_3 = (float) getCmSQA_ChillerSeq_parameter_35();
    func_8363.Cmnext_to_start_input_4 = register_295;
    func_8363.Cmnext_to_start_input_5 = register_313;
    func_8363.Execute(  );

    // [8364] Macro call Cmnext_to_start
    func_8364.Cmnext_to_start_input_1 = register_328;
    func_8364.Cmnext_to_start_input_2 = func_1556.output;
    func_8364.Cmnext_to_start_input_3 = (float) getCmSQA_ChillerSeq_parameter_36();
    func_8364.Cmnext_to_start_input_4 = register_296;
    func_8364.Cmnext_to_start_input_5 = func_6055.CmCommInputProc_output_188;
    func_8364.Execute(  );

    // [8366] Macro call Cmnext_to_start
    func_8366.Cmnext_to_start_input_1 = register_329;
    func_8366.Cmnext_to_start_input_2 = func_1556.output;
    func_8366.Cmnext_to_start_input_3 = (float) getCmSQA_ChillerSeq_parameter_37();
    func_8366.Cmnext_to_start_input_4 = register_297;
    func_8366.Cmnext_to_start_input_5 = func_6055.CmCommInputProc_output_189;
    func_8366.Execute(  );

    // [8368] Macro call Cmnext_to_start
    func_8368.Cmnext_to_start_input_1 = register_330;
    func_8368.Cmnext_to_start_input_2 = func_1556.output;
    func_8368.Cmnext_to_start_input_3 = (float) getCmSQA_ChillerSeq_parameter_38();
    func_8368.Cmnext_to_start_input_4 = register_298;
    func_8368.Cmnext_to_start_input_5 = func_6055.CmCommInputProc_output_190;
    func_8368.Execute(  );

    // [8370] Macro call Cmnext_to_start
    func_8370.Cmnext_to_start_input_1 = register_331;
    func_8370.Cmnext_to_start_input_2 = func_1556.output;
    func_8370.Cmnext_to_start_input_3 = (float) getCmSQA_ChillerSeq_parameter_39();
    func_8370.Cmnext_to_start_input_4 = register_299;
    func_8370.Cmnext_to_start_input_5 = func_6055.CmCommInputProc_output_191;
    func_8370.Execute(  );

    // [8371] Macro call Cmnext_to_start
    func_8371.Cmnext_to_start_input_1 = register_332;
    func_8371.Cmnext_to_start_input_2 = func_1556.output;
    func_8371.Cmnext_to_start_input_3 = (float) getCmSQA_ChillerSeq_parameter_40();
    func_8371.Cmnext_to_start_input_4 = register_300;
    func_8371.Cmnext_to_start_input_5 = func_6055.CmCommInputProc_output_192;
    func_8371.Execute(  );

    // [8373] Macro call Cmnext_to_start
    func_8373.Cmnext_to_start_input_1 = register_333;
    func_8373.Cmnext_to_start_input_2 = func_1556.output;
    func_8373.Cmnext_to_start_input_3 = (float) getCmSQA_ChillerSeq_parameter_41();
    func_8373.Cmnext_to_start_input_4 = register_301;
    func_8373.Cmnext_to_start_input_5 = func_6055.CmCommInputProc_output_193;
    func_8373.Execute(  );

    // [8372] Macro call Cmnext_to_start
    func_8372.Cmnext_to_start_input_1 = register_334;
    func_8372.Cmnext_to_start_input_2 = func_1556.output;
    func_8372.Cmnext_to_start_input_3 = (float) getCmSQA_ChillerSeq_parameter_42();
    func_8372.Cmnext_to_start_input_4 = register_302;
    func_8372.Cmnext_to_start_input_5 = func_6055.CmCommInputProc_output_194;
    func_8372.Execute(  );

    // [8374] Macro call Cmnext_to_start
    func_8374.Cmnext_to_start_input_1 = register_335;
    func_8374.Cmnext_to_start_input_2 = func_1556.output;
    func_8374.Cmnext_to_start_input_3 = (float) getCmSQA_ChillerSeq_parameter_43();
    func_8374.Cmnext_to_start_input_4 = register_303;
    func_8374.Cmnext_to_start_input_5 = func_6055.CmCommInputProc_output_195;
    func_8374.Execute(  );

    // [8375] Macro call Cmnext_to_start
    func_8375.Cmnext_to_start_input_1 = register_336;
    func_8375.Cmnext_to_start_input_2 = func_1556.output;
    func_8375.Cmnext_to_start_input_3 = (float) getCmSQA_ChillerSeq_parameter_44();
    func_8375.Cmnext_to_start_input_4 = register_304;
    func_8375.Cmnext_to_start_input_5 = func_6055.CmCommInputProc_output_196;
    func_8375.Execute(  );

    // [1669] Function call CfMinimum
    func_1669.input[0] = func_8357.Cmnext_to_start_output_6;
    func_1669.input[1] = func_8360.Cmnext_to_start_output_6;
    func_1669.input[2] = func_8363.Cmnext_to_start_output_6;
    func_1669.input[3] = func_8364.Cmnext_to_start_output_6;
    func_1669.input[4] = func_8366.Cmnext_to_start_output_6;
    func_1669.input[5] = func_8368.Cmnext_to_start_output_6;
    func_1669.input[6] = func_8370.Cmnext_to_start_output_6;
    func_1669.input[7] = func_8371.Cmnext_to_start_output_6;
    func_1669.input[8] = func_8373.Cmnext_to_start_output_6;
    func_1669.input[9] = func_8372.Cmnext_to_start_output_6;
    func_1669.input[10] = func_8374.Cmnext_to_start_output_6;
    func_1669.input[11] = func_8375.Cmnext_to_start_output_6;
    func_1669.Execute(  );

    // [8424] Function call CfCompare1
    func_8424.inputA = func_1669.output;
    func_8424.inputB = (float) getCmSQA_ChillerSeq_parameter_33();
    func_8424.Execute(  );

    // [8425] Function call CfCompare1
    func_8425.inputA = func_1669.output;
    func_8425.inputB = (float) getCmSQA_ChillerSeq_parameter_34();
    func_8425.Execute(  );

    // [8426] Function call CfCompare1
    func_8426.inputA = func_1669.output;
    func_8426.inputB = (float) getCmSQA_ChillerSeq_parameter_35();
    func_8426.Execute(  );

    // [8427] Function call CfCompare1
    func_8427.inputA = func_1669.output;
    func_8427.inputB = (float) getCmSQA_ChillerSeq_parameter_36();
    func_8427.Execute(  );

    // [8428] Function call CfCompare1
    func_8428.inputA = func_1669.output;
    func_8428.inputB = (float) getCmSQA_ChillerSeq_parameter_37();
    func_8428.Execute(  );

    // [8429] Function call CfCompare1
    func_8429.inputA = func_1669.output;
    func_8429.inputB = (float) getCmSQA_ChillerSeq_parameter_38();
    func_8429.Execute(  );

    // [8430] Function call CfCompare1
    func_8430.inputA = func_1669.output;
    func_8430.inputB = (float) getCmSQA_ChillerSeq_parameter_39();
    func_8430.Execute(  );

    // [8431] Function call CfCompare1
    func_8431.inputA = func_1669.output;
    func_8431.inputB = (float) getCmSQA_ChillerSeq_parameter_40();
    func_8431.Execute(  );

    // [8432] Function call CfCompare1
    func_8432.inputA = func_1669.output;
    func_8432.inputB = (float) getCmSQA_ChillerSeq_parameter_41();
    func_8432.Execute(  );

    // [8433] Function call CfCompare1
    func_8433.inputA = func_1669.output;
    func_8433.inputB = (float) getCmSQA_ChillerSeq_parameter_42();
    func_8433.Execute(  );

    // [8434] Function call CfCompare1
    func_8434.inputA = func_1669.output;
    func_8434.inputB = (float) getCmSQA_ChillerSeq_parameter_43();
    func_8434.Execute(  );

    // [8435] Function call CfCompare1
    func_8435.inputA = func_1669.output;
    func_8435.inputB = (float) getCmSQA_ChillerSeq_parameter_44();
    func_8435.Execute(  );

    // [8436] Function call CfInputMultiplexer
    func_8436.inputSelect = BooleanToInt(func_8435.outputEqual);
    func_8436.input[1-1] = 0F;
    func_8436.input[2-1] = 12F;
    func_8436.Execute(  );

    // [8437] Function call CfInputMultiplexer
    func_8437.inputSelect = BooleanToInt(func_8434.outputEqual);
    func_8437.input[1-1] = func_8436.output;
    func_8437.input[2-1] = 11F;
    func_8437.Execute(  );

    // [8438] Function call CfInputMultiplexer
    func_8438.inputSelect = BooleanToInt(func_8433.outputEqual);
    func_8438.input[1-1] = func_8437.output;
    func_8438.input[2-1] = 10F;
    func_8438.Execute(  );

    // [8439] Function call CfInputMultiplexer
    func_8439.inputSelect = BooleanToInt(func_8432.outputEqual);
    func_8439.input[1-1] = func_8438.output;
    func_8439.input[2-1] = 9F;
    func_8439.Execute(  );

    // [8440] Function call CfInputMultiplexer
    func_8440.inputSelect = BooleanToInt(func_8431.outputEqual);
    func_8440.input[1-1] = func_8439.output;
    func_8440.input[2-1] = 8F;
    func_8440.Execute(  );

    // [8441] Function call CfInputMultiplexer
    func_8441.inputSelect = BooleanToInt(func_8430.outputEqual);
    func_8441.input[1-1] = func_8440.output;
    func_8441.input[2-1] = 7F;
    func_8441.Execute(  );

    // [8442] Function call CfInputMultiplexer
    func_8442.inputSelect = BooleanToInt(func_8429.outputEqual);
    func_8442.input[1-1] = func_8441.output;
    func_8442.input[2-1] = 6F;
    func_8442.Execute(  );

    // [8443] Function call CfInputMultiplexer
    func_8443.inputSelect = BooleanToInt(func_8428.outputEqual);
    func_8443.input[1-1] = func_8442.output;
    func_8443.input[2-1] = 5F;
    func_8443.Execute(  );

    // [8444] Function call CfInputMultiplexer
    func_8444.inputSelect = BooleanToInt(func_8427.outputEqual);
    func_8444.input[1-1] = func_8443.output;
    func_8444.input[2-1] = 4F;
    func_8444.Execute(  );

    // [8445] Function call CfInputMultiplexer
    func_8445.inputSelect = BooleanToInt(func_8426.outputEqual);
    func_8445.input[1-1] = func_8444.output;
    func_8445.input[2-1] = 3F;
    func_8445.Execute(  );

    // [8446] Function call CfInputMultiplexer
    func_8446.inputSelect = BooleanToInt(func_8425.outputEqual);
    func_8446.input[1-1] = func_8445.output;
    func_8446.input[2-1] = 2F;
    func_8446.Execute(  );

    // [8447] Function call CfInputMultiplexer
    func_8447.inputSelect = BooleanToInt(func_8424.outputEqual);
    func_8447.input[1-1] = func_8446.output;
    func_8447.input[2-1] = 1F;
    func_8447.Execute(  );

    // [1726] Function call CfSubtract
    func_1726.input[0] = func_660.output[0];
    func_1726.input[1] = 0.5F;
    func_1726.Execute(  );

    // [1727] Function call CfMaximum
    func_1727.input[0] = 1F;
    func_1727.input[1] = func_9150.output;
    func_1727.Execute(  );

    // [1729] Function call CfDivide
    func_1729.inputA = func_1726.output;
    func_1729.inputB = func_1727.output;
    func_1729.Execute(  );

    // [8718] Function call CfCompare1
    func_8718.inputA = (float) getCmSQA_ChillerSeq_parameter_31();
    func_8718.inputB = 0F;
    func_8718.Execute(  );

    // [1744] Function call CfInputMultiplexer
    func_1744.inputSelect = BooleanToInt(func_8718.outputEqual);
    func_1744.input[1-1] = func_1729.output;
    func_1744.input[2-1] = 1F;
    func_1744.Execute(  );

    // [5736] Function call CfCompare2
    func_5736.inputA = register_325;
    func_5736.inputB = func_1744.output;
    func_5736.Execute(  );

    // [5737] Function call CfCompare2
    func_5737.inputA = register_326;
    func_5737.inputB = func_1744.output;
    func_5737.Execute(  );

    // [5738] Function call CfCompare2
    func_5738.inputA = register_327;
    func_5738.inputB = func_1744.output;
    func_5738.Execute(  );

    // [5739] Function call CfCompare2
    func_5739.inputA = register_328;
    func_5739.inputB = func_1744.output;
    func_5739.Execute(  );

    // [5740] Function call CfCompare2
    func_5740.inputA = register_329;
    func_5740.inputB = func_1744.output;
    func_5740.Execute(  );

    // [5741] Function call CfCompare2
    func_5741.inputA = register_330;
    func_5741.inputB = func_1744.output;
    func_5741.Execute(  );

    // [5742] Function call CfCompare2
    func_5742.inputA = register_331;
    func_5742.inputB = func_1744.output;
    func_5742.Execute(  );

    // [5743] Function call CfCompare2
    func_5743.inputA = register_332;
    func_5743.inputB = func_1744.output;
    func_5743.Execute(  );

    // [5744] Function call CfCompare2
    func_5744.inputA = register_333;
    func_5744.inputB = func_1744.output;
    func_5744.Execute(  );

    // [5745] Function call CfCompare2
    func_5745.inputA = register_334;
    func_5745.inputB = func_1744.output;
    func_5745.Execute(  );

    // [5747] Function call CfCompare2
    func_5747.inputA = register_335;
    func_5747.inputB = func_1744.output;
    func_5747.Execute(  );

    // [5746] Function call CfCompare2
    func_5746.inputA = register_336;
    func_5746.inputB = func_1744.output;
    func_5746.Execute(  );

    // [1783] Function call CfInputMultiplexer
    func_1783.inputSelect = BooleanToInt(func_5736.outputEqualOrGreater);
    func_1783.input[1-1] = -999F;
    func_1783.input[2-1] = register_293;
    func_1783.Execute(  );

    // [1784] Function call CfInputMultiplexer
    func_1784.inputSelect = BooleanToInt(func_5737.outputEqualOrGreater);
    func_1784.input[1-1] = -999F;
    func_1784.input[2-1] = register_294;
    func_1784.Execute(  );

    // [1785] Function call CfInputMultiplexer
    func_1785.inputSelect = BooleanToInt(func_5738.outputEqualOrGreater);
    func_1785.input[1-1] = -999F;
    func_1785.input[2-1] = register_295;
    func_1785.Execute(  );

    // [1786] Function call CfInputMultiplexer
    func_1786.inputSelect = BooleanToInt(func_5739.outputEqualOrGreater);
    func_1786.input[1-1] = -999F;
    func_1786.input[2-1] = register_296;
    func_1786.Execute(  );

    // [1787] Function call CfInputMultiplexer
    func_1787.inputSelect = BooleanToInt(func_5740.outputEqualOrGreater);
    func_1787.input[1-1] = -999F;
    func_1787.input[2-1] = register_297;
    func_1787.Execute(  );

    // [1788] Function call CfInputMultiplexer
    func_1788.inputSelect = BooleanToInt(func_5741.outputEqualOrGreater);
    func_1788.input[1-1] = -999F;
    func_1788.input[2-1] = register_298;
    func_1788.Execute(  );

    // [1789] Function call CfInputMultiplexer
    func_1789.inputSelect = BooleanToInt(func_5742.outputEqualOrGreater);
    func_1789.input[1-1] = -999F;
    func_1789.input[2-1] = register_299;
    func_1789.Execute(  );

    // [1790] Function call CfInputMultiplexer
    func_1790.inputSelect = BooleanToInt(func_5743.outputEqualOrGreater);
    func_1790.input[1-1] = -999F;
    func_1790.input[2-1] = register_300;
    func_1790.Execute(  );

    // [1791] Function call CfInputMultiplexer
    func_1791.inputSelect = BooleanToInt(func_5744.outputEqualOrGreater);
    func_1791.input[1-1] = -999F;
    func_1791.input[2-1] = register_301;
    func_1791.Execute(  );

    // [1792] Function call CfInputMultiplexer
    func_1792.inputSelect = BooleanToInt(func_5745.outputEqualOrGreater);
    func_1792.input[1-1] = -999F;
    func_1792.input[2-1] = register_302;
    func_1792.Execute(  );

    // [1793] Function call CfInputMultiplexer
    func_1793.inputSelect = BooleanToInt(func_5747.outputEqualOrGreater);
    func_1793.input[1-1] = -999F;
    func_1793.input[2-1] = register_303;
    func_1793.Execute(  );

    // [1794] Function call CfInputMultiplexer
    func_1794.inputSelect = BooleanToInt(func_5746.outputEqualOrGreater);
    func_1794.input[1-1] = -999F;
    func_1794.input[2-1] = register_304;
    func_1794.Execute(  );

    // [1796] Function call CfMaximum
    func_1796.input[0] = func_1783.output;
    func_1796.input[1] = func_1784.output;
    func_1796.input[2] = func_1785.output;
    func_1796.input[3] = func_1786.output;
    func_1796.input[4] = func_1787.output;
    func_1796.input[5] = func_1788.output;
    func_1796.input[6] = func_1789.output;
    func_1796.input[7] = func_1790.output;
    func_1796.input[8] = func_1791.output;
    func_1796.input[9] = func_1792.output;
    func_1796.input[10] = func_1793.output;
    func_1796.input[11] = func_1794.output;
    func_1796.Execute(  );

    // [8719] Function call CfCompare1
    func_8719.inputA = func_1796.output;
    func_8719.inputB = (float) getCmSQA_ChillerSeq_parameter_33();
    func_8719.Execute(  );

    // [8732] Function call CfCompare1
    func_8732.inputA = func_1796.output;
    func_8732.inputB = (float) getCmSQA_ChillerSeq_parameter_34();
    func_8732.Execute(  );

    // [8733] Function call CfCompare1
    func_8733.inputA = func_1796.output;
    func_8733.inputB = (float) getCmSQA_ChillerSeq_parameter_35();
    func_8733.Execute(  );

    // [8734] Function call CfCompare1
    func_8734.inputA = func_1796.output;
    func_8734.inputB = (float) getCmSQA_ChillerSeq_parameter_36();
    func_8734.Execute(  );

    // [8735] Function call CfCompare1
    func_8735.inputA = func_1796.output;
    func_8735.inputB = (float) getCmSQA_ChillerSeq_parameter_37();
    func_8735.Execute(  );

    // [8736] Function call CfCompare1
    func_8736.inputA = func_1796.output;
    func_8736.inputB = (float) getCmSQA_ChillerSeq_parameter_38();
    func_8736.Execute(  );

    // [8737] Function call CfCompare1
    func_8737.inputA = func_1796.output;
    func_8737.inputB = (float) getCmSQA_ChillerSeq_parameter_39();
    func_8737.Execute(  );

    // [8738] Function call CfCompare1
    func_8738.inputA = func_1796.output;
    func_8738.inputB = (float) getCmSQA_ChillerSeq_parameter_40();
    func_8738.Execute(  );

    // [8739] Function call CfCompare1
    func_8739.inputA = func_1796.output;
    func_8739.inputB = (float) getCmSQA_ChillerSeq_parameter_41();
    func_8739.Execute(  );

    // [8740] Function call CfCompare1
    func_8740.inputA = func_1796.output;
    func_8740.inputB = (float) getCmSQA_ChillerSeq_parameter_42();
    func_8740.Execute(  );

    // [8741] Function call CfCompare1
    func_8741.inputA = func_1796.output;
    func_8741.inputB = (float) getCmSQA_ChillerSeq_parameter_43();
    func_8741.Execute(  );

    // [8742] Function call CfCompare1
    func_8742.inputA = func_1796.output;
    func_8742.inputB = (float) getCmSQA_ChillerSeq_parameter_44();
    func_8742.Execute(  );

    // [8720] Function call CfInputMultiplexer
    func_8720.inputSelect = BooleanToInt(func_8742.outputEqual);
    func_8720.input[1-1] = 0F;
    func_8720.input[2-1] = 12F;
    func_8720.Execute(  );

    // [8721] Function call CfInputMultiplexer
    func_8721.inputSelect = BooleanToInt(func_8741.outputEqual);
    func_8721.input[1-1] = func_8720.output;
    func_8721.input[2-1] = 11F;
    func_8721.Execute(  );

    // [8722] Function call CfInputMultiplexer
    func_8722.inputSelect = BooleanToInt(func_8740.outputEqual);
    func_8722.input[1-1] = func_8721.output;
    func_8722.input[2-1] = 10F;
    func_8722.Execute(  );

    // [8723] Function call CfInputMultiplexer
    func_8723.inputSelect = BooleanToInt(func_8739.outputEqual);
    func_8723.input[1-1] = func_8722.output;
    func_8723.input[2-1] = 9F;
    func_8723.Execute(  );

    // [8724] Function call CfInputMultiplexer
    func_8724.inputSelect = BooleanToInt(func_8738.outputEqual);
    func_8724.input[1-1] = func_8723.output;
    func_8724.input[2-1] = 8F;
    func_8724.Execute(  );

    // [8725] Function call CfInputMultiplexer
    func_8725.inputSelect = BooleanToInt(func_8737.outputEqual);
    func_8725.input[1-1] = func_8724.output;
    func_8725.input[2-1] = 7F;
    func_8725.Execute(  );

    // [8726] Function call CfInputMultiplexer
    func_8726.inputSelect = BooleanToInt(func_8736.outputEqual);
    func_8726.input[1-1] = func_8725.output;
    func_8726.input[2-1] = 6F;
    func_8726.Execute(  );

    // [8727] Function call CfInputMultiplexer
    func_8727.inputSelect = BooleanToInt(func_8735.outputEqual);
    func_8727.input[1-1] = func_8726.output;
    func_8727.input[2-1] = 5F;
    func_8727.Execute(  );

    // [8728] Function call CfInputMultiplexer
    func_8728.inputSelect = BooleanToInt(func_8734.outputEqual);
    func_8728.input[1-1] = func_8727.output;
    func_8728.input[2-1] = 4F;
    func_8728.Execute(  );

    // [8729] Function call CfInputMultiplexer
    func_8729.inputSelect = BooleanToInt(func_8733.outputEqual);
    func_8729.input[1-1] = func_8728.output;
    func_8729.input[2-1] = 3F;
    func_8729.Execute(  );

    // [8730] Function call CfInputMultiplexer
    func_8730.inputSelect = BooleanToInt(func_8732.outputEqual);
    func_8730.input[1-1] = func_8729.output;
    func_8730.input[2-1] = 2F;
    func_8730.Execute(  );

    // [8731] Function call CfInputMultiplexer
    func_8731.inputSelect = BooleanToInt(func_8719.outputEqual);
    func_8731.input[1-1] = func_8730.output;
    func_8731.input[2-1] = 1F;
    func_8731.Execute(  );

    // [1857] Function call CfIdt
    func_1857.input = register_279;
    func_1857.Execute(  );

    // [1858] Function call CfIdt
    func_1858.input = func_660.output[0];
    func_1858.Execute(  );

    // [1883] Function call CfAddition
    func_1883.input[0] = func_1977.output[0];
    func_1883.input[1] = func_1979.output[0];
    func_1883.Execute(  );

    // [5685] Function call CfCompare2
    func_5685.inputA = func_1857.output[0];
    func_5685.inputB = func_1858.output[0];
    func_5685.Execute(  );

    // [1888] Function call CfIdt
    func_1888.input = func_1988.output[0];
    func_1888.Execute(  );

    // [1905] Function call CfCompare1
    func_1905.inputA = func_1883.output;
    func_1905.inputB = 2F;
    func_1905.Execute(  );

    // [1906] Function call CfNot
    func_1906.input = func_1905.outputLess;
    func_1906.Execute(  );

    // [1911] Function call CfIdt
    func_1911.input = func_1221.output[0];
    func_1911.Execute(  );

    // [1914] Function call CfRound
    func_1914.input = func_1888.output[0];
    func_1914.Execute(  );

    // [8754] Function call CfNot
    func_8754.input = false;
    func_8754.Execute(  );

    // [8757] Function call CfNot
    func_8757.input = FloatToBoolean(func_6526.output[0]);
    func_8757.Execute(  );

    // [1964] Function call CfAnd
    func_1964.input[0] = FloatToBoolean(func_2251.output[0]);
    func_1964.input[1] = func_1906.output;
    func_1964.input[2] = func_8757.output;
    func_1964.input[3] = func_8754.output;
    func_1964.input[4] = func_9771.outputAND;
    func_1964.Execute(  );

    // [1965] Function call CfIdt
    func_1965.input = func_8774.output;
    func_1965.Execute(  );

    // [8173] Function call CfNot
    func_8173.input = false;
    func_8173.Execute(  );

    // [8174] Function call CfNot
    func_8174.input = FloatToBoolean(func_1888.output[0]);
    func_8174.Execute(  );

    // [1967] Function call CfAnd
    func_1967.input[0] = FloatToBoolean(func_1911.output[0]);
    func_1967.input[1] = func_9771.outputAND;
    func_1967.input[2] = func_8173.output;
    func_1967.input[3] = func_8174.output;
    func_1967.Execute(  );

    // [1968] Function call CfAnd
    func_1968.input[0] = FloatToBoolean(func_1914.output);
    func_1968.input[1] = func_5685.outputEqualOrGreater;
    func_1968.Execute(  );

    // [8758] Macro call CmIncDecrDetection
    func_8758.CmIncDecrDetection_input_1 = register_325;
    func_8758.CmIncDecrDetection_input_2 = func_8810.Cmswitch_x_12_output_26;
    func_8758.Execute(  );

    // [8761] Macro call CmIncDecrDetection
    func_8761.CmIncDecrDetection_input_1 = register_326;
    func_8761.CmIncDecrDetection_input_2 = func_8810.Cmswitch_x_12_output_27;
    func_8761.Execute(  );

    // [8762] Macro call CmIncDecrDetection
    func_8762.CmIncDecrDetection_input_1 = register_327;
    func_8762.CmIncDecrDetection_input_2 = func_8810.Cmswitch_x_12_output_28;
    func_8762.Execute(  );

    // [8763] Macro call CmIncDecrDetection
    func_8763.CmIncDecrDetection_input_1 = register_328;
    func_8763.CmIncDecrDetection_input_2 = func_8810.Cmswitch_x_12_output_29;
    func_8763.Execute(  );

    // [8764] Macro call CmIncDecrDetection
    func_8764.CmIncDecrDetection_input_1 = register_329;
    func_8764.CmIncDecrDetection_input_2 = func_8810.Cmswitch_x_12_output_30;
    func_8764.Execute(  );

    // [8765] Macro call CmIncDecrDetection
    func_8765.CmIncDecrDetection_input_1 = register_330;
    func_8765.CmIncDecrDetection_input_2 = func_8810.Cmswitch_x_12_output_31;
    func_8765.Execute(  );

    // [8766] Macro call CmIncDecrDetection
    func_8766.CmIncDecrDetection_input_1 = register_331;
    func_8766.CmIncDecrDetection_input_2 = func_8810.Cmswitch_x_12_output_32;
    func_8766.Execute(  );

    // [8767] Macro call CmIncDecrDetection
    func_8767.CmIncDecrDetection_input_1 = register_332;
    func_8767.CmIncDecrDetection_input_2 = func_8810.Cmswitch_x_12_output_33;
    func_8767.Execute(  );

    // [8768] Macro call CmIncDecrDetection
    func_8768.CmIncDecrDetection_input_1 = register_333;
    func_8768.CmIncDecrDetection_input_2 = func_8810.Cmswitch_x_12_output_34;
    func_8768.Execute(  );

    // [8769] Macro call CmIncDecrDetection
    func_8769.CmIncDecrDetection_input_1 = register_334;
    func_8769.CmIncDecrDetection_input_2 = func_8810.Cmswitch_x_12_output_35;
    func_8769.Execute(  );

    // [8770] Macro call CmIncDecrDetection
    func_8770.CmIncDecrDetection_input_1 = register_335;
    func_8770.CmIncDecrDetection_input_2 = func_8810.Cmswitch_x_12_output_36;
    func_8770.Execute(  );

    // [8771] Macro call CmIncDecrDetection
    func_8771.CmIncDecrDetection_input_1 = register_336;
    func_8771.CmIncDecrDetection_input_2 = func_8810.Cmswitch_x_12_output_37;
    func_8771.Execute(  );

    // [1969] Function call CfAddition
    func_1969.input[0] = func_8758.CmIncDecrDetection_output_3;
    func_1969.input[1] = func_8761.CmIncDecrDetection_output_3;
    func_1969.input[2] = func_8762.CmIncDecrDetection_output_3;
    func_1969.input[3] = func_8763.CmIncDecrDetection_output_3;
    func_1969.input[4] = func_8764.CmIncDecrDetection_output_3;
    func_1969.input[5] = func_8765.CmIncDecrDetection_output_3;
    func_1969.input[6] = func_8766.CmIncDecrDetection_output_3;
    func_1969.input[7] = func_8767.CmIncDecrDetection_output_3;
    func_1969.input[8] = func_8768.CmIncDecrDetection_output_3;
    func_1969.input[9] = func_8769.CmIncDecrDetection_output_3;
    func_1969.input[10] = func_8770.CmIncDecrDetection_output_3;
    func_1969.input[11] = func_8771.CmIncDecrDetection_output_3;
    func_1969.Execute(  );

    // [1970] Function call CfAddition
    func_1970.input[0] = func_8758.CmIncDecrDetection_output_4;
    func_1970.input[1] = func_8761.CmIncDecrDetection_output_4;
    func_1970.input[2] = func_8762.CmIncDecrDetection_output_4;
    func_1970.input[3] = func_8763.CmIncDecrDetection_output_4;
    func_1970.input[4] = func_8764.CmIncDecrDetection_output_4;
    func_1970.input[5] = func_8765.CmIncDecrDetection_output_4;
    func_1970.input[6] = func_8766.CmIncDecrDetection_output_4;
    func_1970.input[7] = func_8767.CmIncDecrDetection_output_4;
    func_1970.input[8] = func_8768.CmIncDecrDetection_output_4;
    func_1970.input[9] = func_8769.CmIncDecrDetection_output_4;
    func_1970.input[10] = func_8770.CmIncDecrDetection_output_4;
    func_1970.input[11] = func_8771.CmIncDecrDetection_output_4;
    func_1970.Execute(  );

    // [1971] Function call CfRound
    func_1971.input = BooleanToFloat(func_1964.outputAND);
    func_1971.Execute(  );

    // [1972] Function call CfSubtract
    func_1972.input[0] = 1F;
    func_1972.input[1] = BooleanToFloat(func_1964.outputAND);
    func_1972.Execute(  );

    // [1973] Function call CfRound
    func_1973.input = func_1965.output[0];
    func_1973.Execute(  );

    // [1974] Function call CfSubtract
    func_1974.input[0] = 1F;
    func_1974.input[1] = func_1965.output[0];
    func_1974.Execute(  );

    // [1976] Function call CfRsFlipFlop
    func_1976.inputSet = func_1967.outputAND;
    func_1976.inputReset = func_1968.outputAND;
    func_1976.Execute(  );

    // [1977] Function call CfIdt
    func_1977.input = func_1969.output;
    func_1977.Execute(  );

    // [1978] Function call CfIdt
    func_1978.input = func_1988.output[0];
    func_1978.Execute(  );

    // [1979] Function call CfIdt
    func_1979.input = func_1970.output;
    func_1979.Execute(  );

    // [1980] Function call CfAddition
    func_1980.input[0] = func_1969.output;
    func_1980.input[1] = func_1970.output;
    func_1980.Execute(  );

    // [1981] Function call CfCompare1
    func_1981.inputA = 0F;
    func_1981.inputB = func_1970.output;
    func_1981.Execute(  );

    // [1983] Function call CfAnd
    func_1983.input[0] = FloatToBoolean(func_1971.output);
    func_1983.input[1] = FloatToBoolean(func_1974.output);
    func_1983.Execute(  );

    // [1986] Function call CfAnd
    func_1986.input[0] = FloatToBoolean(func_1973.output);
    func_1986.input[1] = FloatToBoolean(func_1972.output);
    func_1986.Execute(  );

    // [1988] Function call CfIdt
    func_1988.input = BooleanToFloat(func_1976.output);
    func_1988.Execute(  );

    // [1989] Function call CfCompare1
    func_1989.inputA = BooleanToFloat(func_1976.output);
    func_1989.inputB = 0F;
    func_1989.Execute(  );

    // [5684] Function call CfNot
    func_5684.input = FloatToBoolean(func_1978.output[0]);
    func_5684.Execute(  );

    // [1992] Function call CfCompare1
    func_1992.inputA = func_1980.output;
    func_1992.inputB = 1F;
    func_1992.Execute(  );

    // [1998] Function call CfIdt
    func_1998.input = (float) getCmSQA_ChillerSeq_parameter_21();
    func_1998.Execute(  );
    setParameter(22, func_1998.output[0]);

    // [1999] Function call CfDelay
    func_1999.inputA = func_1986.outputAND;
    func_1999.inputB = func_1986.outputAND;
    func_1999.Execute( this, 22 );

    // [2001] Function call CfAnd
    func_2001.input[0] = func_5684.output;
    func_2001.input[1] = func_1992.outputEqual;
    func_2001.Execute(  );

    // [2002] Function call CfRsFlipFlop
    func_2002.inputSet = func_1983.outputAND;
    func_2002.inputReset = func_1999.outputDelayedA;
    func_2002.Execute(  );

    // [2006] Function call CfCompare1
    func_2006.inputA = BooleanToFloat(func_2001.outputAND);
    func_2006.inputB = 0F;
    func_2006.Execute(  );

    // [8774] Function call CfInputMultiplexer
    func_8774.inputSelect = BooleanToInt(func_1989.outputGreater);
    func_8774.input[1-1] = BooleanToFloat(func_2002.output);
    func_8774.input[2-1] = func_8774.output;
    func_8774.Execute(  );

    // [8773] Function call CfOr
    func_8773.input[0] = func_1989.outputGreater;
    func_8773.input[1] = func_2006.outputEqual;
    func_8773.Execute(  );

    // [8772] Function call CfInputMultiplexer
    func_8772.inputSelect = BooleanToInt(func_8773.outputOR);
    func_8772.input[1-1] = BooleanToFloat(func_1981.outputLess);
    func_8772.input[2-1] = register_323;
    func_8772.Execute(  );
    register_323 = func_8772.output;

    // [2014] Function call CfIdt
    func_2014.input = register_323;
    func_2014.Execute(  );

    // [2068] Function call CfCompare1
    func_2068.inputA = func_2014.output[0];
    func_2068.inputB = 0F;
    func_2068.Execute(  );

    // [9076] Macro call Cmsearch_i
    if ( func_2068.outputEqual)
    {
      func_9076.Cmsearch_i_input_1 = func_8810.Cmswitch_x_12_output_26;
      func_9076.Cmsearch_i_input_2 = register_325;
      func_9076.Cmsearch_i_input_3 = func_8810.Cmswitch_x_12_output_27;
      func_9076.Cmsearch_i_input_4 = register_326;
      func_9076.Cmsearch_i_input_5 = func_8810.Cmswitch_x_12_output_28;
      func_9076.Cmsearch_i_input_6 = register_327;
      func_9076.Cmsearch_i_input_7 = func_8810.Cmswitch_x_12_output_29;
      func_9076.Cmsearch_i_input_8 = register_328;
      func_9076.Cmsearch_i_input_9 = func_8810.Cmswitch_x_12_output_30;
      func_9076.Cmsearch_i_input_10 = register_329;
      func_9076.Cmsearch_i_input_11 = func_8810.Cmswitch_x_12_output_31;
      func_9076.Cmsearch_i_input_12 = register_330;
      func_9076.Cmsearch_i_input_13 = func_8810.Cmswitch_x_12_output_32;
      func_9076.Cmsearch_i_input_14 = register_331;
      func_9076.Cmsearch_i_input_15 = func_8810.Cmswitch_x_12_output_33;
      func_9076.Cmsearch_i_input_16 = register_332;
      func_9076.Cmsearch_i_input_17 = func_8810.Cmswitch_x_12_output_34;
      func_9076.Cmsearch_i_input_18 = register_333;
      func_9076.Cmsearch_i_input_19 = func_8810.Cmswitch_x_12_output_35;
      func_9076.Cmsearch_i_input_20 = register_334;
      func_9076.Cmsearch_i_input_21 = func_8810.Cmswitch_x_12_output_36;
      func_9076.Cmsearch_i_input_22 = register_335;
      func_9076.Cmsearch_i_input_23 = func_8810.Cmswitch_x_12_output_37;
      func_9076.Cmsearch_i_input_24 = register_336;
      func_9076.Execute(  );
    }

    // [9120] Function call CfInputMultiplexer
    func_9120.inputSelect = BooleanToInt(func_2068.outputEqual);
    func_9120.input[1-1] = 0F;
    func_9120.input[2-1] = func_9076.Cmsearch_i_output_25;
    func_9120.Execute(  );

    // [9426] Function call CfCompare1
    func_9426.inputA = func_9076.Cmsearch_i_output_25;
    func_9426.inputB = 0F;
    func_9426.Execute(  );

    // [9423] Function call CfAnd
    func_9423.input[0] = func_9426.outputEqual;
    func_9423.input[1] = func_2068.outputEqual;
    func_9423.Execute(  );

    // [9421] Function call CfOr
    func_9421.input[0] = func_9423.outputAND;
    func_9421.input[1] = func_2068.outputGreater;
    func_9421.Execute(  );

    // [9072] Macro call Cmsearch_i
    if ( func_9421.outputOR)
    {
      func_9072.Cmsearch_i_input_1 = register_325;
      func_9072.Cmsearch_i_input_2 = func_8810.Cmswitch_x_12_output_26;
      func_9072.Cmsearch_i_input_3 = register_326;
      func_9072.Cmsearch_i_input_4 = func_8810.Cmswitch_x_12_output_27;
      func_9072.Cmsearch_i_input_5 = register_327;
      func_9072.Cmsearch_i_input_6 = func_8810.Cmswitch_x_12_output_28;
      func_9072.Cmsearch_i_input_7 = register_328;
      func_9072.Cmsearch_i_input_8 = func_8810.Cmswitch_x_12_output_29;
      func_9072.Cmsearch_i_input_9 = register_329;
      func_9072.Cmsearch_i_input_10 = func_8810.Cmswitch_x_12_output_30;
      func_9072.Cmsearch_i_input_11 = register_330;
      func_9072.Cmsearch_i_input_12 = func_8810.Cmswitch_x_12_output_31;
      func_9072.Cmsearch_i_input_13 = register_331;
      func_9072.Cmsearch_i_input_14 = func_8810.Cmswitch_x_12_output_32;
      func_9072.Cmsearch_i_input_15 = register_332;
      func_9072.Cmsearch_i_input_16 = func_8810.Cmswitch_x_12_output_33;
      func_9072.Cmsearch_i_input_17 = register_333;
      func_9072.Cmsearch_i_input_18 = func_8810.Cmswitch_x_12_output_34;
      func_9072.Cmsearch_i_input_19 = register_334;
      func_9072.Cmsearch_i_input_20 = func_8810.Cmswitch_x_12_output_35;
      func_9072.Cmsearch_i_input_21 = register_335;
      func_9072.Cmsearch_i_input_22 = func_8810.Cmswitch_x_12_output_36;
      func_9072.Cmsearch_i_input_23 = register_336;
      func_9072.Cmsearch_i_input_24 = func_8810.Cmswitch_x_12_output_37;
      func_9072.Execute(  );
    }

    // [9124] Function call CfInputMultiplexer
    func_9124.inputSelect = BooleanToInt(func_9421.outputOR);
    func_9124.input[1-1] = func_9120.output;
    func_9124.input[2-1] = func_9072.Cmsearch_i_output_25;
    func_9124.Execute(  );

    // [8809] Function call CfNot
    func_8809.input = FloatToBoolean(func_1988.output[0]);
    func_8809.Execute(  );

    // [8808] Function call CfNot
    func_8808.input = FloatToBoolean(func_8774.output);
    func_8808.Execute(  );

    // [8807] Function call CfCompare2
    func_8807.inputA = func_9124.output;
    func_8807.inputB = 1F;
    func_8807.Execute(  );

    // [2246] Function call CfAnd
    func_2246.input[0] = func_8809.output;
    func_2246.input[1] = func_8808.output;
    func_2246.input[2] = func_8807.outputEqualOrGreater;
    func_2246.Execute(  );

    // [2240] Function call CfIdt
    func_2240.input = func_9124.output;
    func_2240.Execute(  );

    // [2247] Function call CfInputMultiplexer
    func_2247.inputSelect = FloatToInt(func_2240.output[0]);
    func_2247.input[1-1] = register_356;
    func_2247.input[2-1] = register_325;
    func_2247.input[3-1] = register_326;
    func_2247.input[4-1] = register_327;
    func_2247.input[5-1] = register_328;
    func_2247.input[6-1] = register_329;
    func_2247.input[7-1] = register_330;
    func_2247.input[8-1] = register_331;
    func_2247.input[9-1] = register_332;
    func_2247.input[10-1] = register_333;
    func_2247.input[11-1] = register_334;
    func_2247.input[12-1] = register_335;
    func_2247.input[13-1] = register_336;
    func_2247.Execute(  );

    // [2251] Function call CfIdt
    func_2251.input = BooleanToFloat(func_2246.outputAND);
    func_2251.Execute(  );

    // [2252] Function call CfCompare1
    func_2252.inputA = BooleanToFloat(func_2246.outputAND);
    func_2252.inputB = 0F;
    func_2252.Execute(  );

    // [9748] Function call CfInputMultiplexer
    func_9748.inputSelect = BooleanToInt(func_2252.outputEqual);
    func_9748.input[1-1] = func_2240.output[0];
    func_9748.input[2-1] = 0F;
    func_9748.Execute(  );

    // [8806] Function call CfCompare2
    func_8806.inputA = func_1979.output[0];
    func_8806.inputB = 1F;
    func_8806.Execute(  );

    // [2241] Function call CfCompare1
    func_2241.inputA = func_1977.output[0];
    func_2241.inputB = 1F;
    func_2241.Execute(  );

    // [2255] Function call CfInputMultiplexer
    func_2255.inputSelect = FloatToInt(register_323);
    func_2255.input[1-1] = BooleanToFloat(func_8806.outputEqualOrGreater);
    func_2255.input[2-1] = BooleanToFloat(func_2241.outputLess);
    func_2255.Execute(  );

    // [2254] Function call CfOutputMultiplexer
    func_2254.inputSelect = FloatToInt(func_9748.output);
    func_2254.inputValue = func_2247.output;
    func_2254.Execute( this, 23 );
    if ( func_2254.outputValid[0]) register_356 = func_2254.output[0];

    // [8810] Macro call Cmswitch_x_12
    func_8810.Cmswitch_x_12_input_1 = func_2252.outputEqual;
    func_8810.Cmswitch_x_12_input_2 = func_2254.output[1];
    func_8810.Cmswitch_x_12_input_3 = func_8810.Cmswitch_x_12_output_26;
    func_8810.Cmswitch_x_12_input_4 = func_2254.output[2];
    func_8810.Cmswitch_x_12_input_5 = func_8810.Cmswitch_x_12_output_27;
    func_8810.Cmswitch_x_12_input_6 = func_2254.output[3];
    func_8810.Cmswitch_x_12_input_7 = func_8810.Cmswitch_x_12_output_28;
    func_8810.Cmswitch_x_12_input_8 = func_2254.output[4];
    func_8810.Cmswitch_x_12_input_9 = func_8810.Cmswitch_x_12_output_29;
    func_8810.Cmswitch_x_12_input_10 = func_2254.output[5];
    func_8810.Cmswitch_x_12_input_11 = func_8810.Cmswitch_x_12_output_30;
    func_8810.Cmswitch_x_12_input_12 = func_2254.output[6];
    func_8810.Cmswitch_x_12_input_13 = func_8810.Cmswitch_x_12_output_31;
    func_8810.Cmswitch_x_12_input_14 = func_2254.output[7];
    func_8810.Cmswitch_x_12_input_15 = func_8810.Cmswitch_x_12_output_32;
    func_8810.Cmswitch_x_12_input_16 = func_2254.output[8];
    func_8810.Cmswitch_x_12_input_17 = func_8810.Cmswitch_x_12_output_33;
    func_8810.Cmswitch_x_12_input_18 = func_2254.output[9];
    func_8810.Cmswitch_x_12_input_19 = func_8810.Cmswitch_x_12_output_34;
    func_8810.Cmswitch_x_12_input_20 = func_2254.output[10];
    func_8810.Cmswitch_x_12_input_21 = func_8810.Cmswitch_x_12_output_35;
    func_8810.Cmswitch_x_12_input_22 = func_2254.output[11];
    func_8810.Cmswitch_x_12_input_23 = func_8810.Cmswitch_x_12_output_36;
    func_8810.Cmswitch_x_12_input_24 = func_2254.output[12];
    func_8810.Cmswitch_x_12_input_25 = func_8810.Cmswitch_x_12_output_37;
    func_8810.Execute(  );

    // [8805] Function call CfInputMultiplexer
    func_8805.inputSelect = BooleanToInt(func_2252.outputEqual);
    func_8805.input[1-1] = func_2255.output;
    func_8805.input[2-1] = register_323;
    func_8805.Execute(  );
    register_323 = func_8805.output;

    // [5630] Macro call CmGroupFeedback_out
    func_5630.CmGroupFeedback_out_input_1 = (float) getCmSQA_ChillerSeq_input_1().getValue();
    func_5630.CmGroupFeedback_out_input_2 = (float) getCmSQA_ChillerSeq_input_2().getValue();
    func_5630.CmGroupFeedback_out_input_3 = (float) getCmSQA_ChillerSeq_input_3().getValue();
    func_5630.CmGroupFeedback_out_input_4 = func_9150.output;
    func_5630.CmGroupFeedback_out_input_5 = func_128.output[0];
    func_5630.CmGroupFeedback_out_input_6 = func_597.output[0];
    func_5630.CmGroupFeedback_out_input_7 = (float) getCmSQA_ChillerSeq_parameter_30();
    func_5630.CmGroupFeedback_out_input_9 = FloatToBoolean((float) getCmSQA_ChillerSeq_parameter_5632());
    func_5630.Execute(  );
    setCmSQA_ChillerSeq_output_11(func_5630.CmGroupFeedback_out_output_8);

    // [2288] Function call CfIdt
    func_2288.input = func_9124.output;
    func_2288.Execute(  );

    // [2290] Function call CfIdt
    func_2290.input = func_2251.output[0];
    func_2290.Execute(  );

    // [5679] Function call CfCompare2
    func_5679.inputA = func_2288.output[0];
    func_5679.inputB = 4F;
    func_5679.Execute(  );

    // [2294] Function call CfAnd
    func_2294.input[0] = FloatToBoolean(func_2290.output[0]);
    func_2294.input[1] = func_5679.outputEqualOrGreater;
    func_2294.Execute(  );

    // [2296] Function call CfInputMultiplexer
    func_2296.inputSelect = FloatToInt(func_2288.output[0]);
    func_2296.input[1-1] = register_356;
    func_2296.input[2-1] = func_8810.Cmswitch_x_12_output_26;
    func_2296.input[3-1] = func_8810.Cmswitch_x_12_output_27;
    func_2296.input[4-1] = func_8810.Cmswitch_x_12_output_28;
    func_2296.input[5-1] = func_8810.Cmswitch_x_12_output_29;
    func_2296.input[6-1] = func_8810.Cmswitch_x_12_output_30;
    func_2296.input[7-1] = func_8810.Cmswitch_x_12_output_31;
    func_2296.input[8-1] = func_8810.Cmswitch_x_12_output_32;
    func_2296.input[9-1] = func_8810.Cmswitch_x_12_output_33;
    func_2296.input[10-1] = func_8810.Cmswitch_x_12_output_34;
    func_2296.input[11-1] = func_8810.Cmswitch_x_12_output_35;
    func_2296.input[12-1] = func_8810.Cmswitch_x_12_output_36;
    func_2296.input[13-1] = func_8810.Cmswitch_x_12_output_37;
    func_2296.Execute(  );

    // [2298] Function call CfMerge
    func_2298.input[0] = 1F;
    func_2298.input[1] = func_2288.output[0];
    func_2298.input[2] = func_2296.output;
    func_2298.Execute( this, 24 );

    // [2300] Function call CfInputMultiplexer
    func_2300.inputSelect = BooleanToInt(func_2294.outputAND);
    func_2300.input[1-1] = 0F;
    func_2300.input[2-1] = IntToFloat(func_2298.outputResult);
    func_2300.Execute(  );
    setCmSQA_ChillerSeq_output_12(func_2300.output);

    // [2321] Function call CfSubtract
    func_2321.input[0] = 1F;
    func_2321.input[1] = register_311;
    func_2321.Execute(  );

    // [2322] Function call CfSubtract
    func_2322.input[0] = 1F;
    func_2322.input[1] = 0;
    func_2322.Execute(  );

    // [2323] Function call CfIdt
    func_2323.input = BooleanToFloat(func_9771.outputAND);
    func_2323.Execute(  );

    // [2324] Function call CfSubtract
    func_2324.input[0] = 1F;
    func_2324.input[1] = register_312;
    func_2324.Execute(  );

    // [2325] Function call CfSubtract
    func_2325.input[0] = 1F;
    func_2325.input[1] = register_313;
    func_2325.Execute(  );

    // [2326] Function call CfAddition
    func_2326.input[0] = func_8810.Cmswitch_x_12_output_26;
    func_2326.input[1] = func_8810.Cmswitch_x_12_output_27;
    func_2326.input[2] = func_8810.Cmswitch_x_12_output_28;
    func_2326.input[3] = func_8810.Cmswitch_x_12_output_29;
    func_2326.input[4] = func_8810.Cmswitch_x_12_output_30;
    func_2326.input[5] = func_8810.Cmswitch_x_12_output_31;
    func_2326.input[6] = func_8810.Cmswitch_x_12_output_32;
    func_2326.input[7] = func_8810.Cmswitch_x_12_output_33;
    func_2326.input[8] = func_8810.Cmswitch_x_12_output_34;
    func_2326.input[9] = func_8810.Cmswitch_x_12_output_35;
    func_2326.input[10] = func_8810.Cmswitch_x_12_output_36;
    func_2326.input[11] = func_8810.Cmswitch_x_12_output_37;
    func_2326.Execute(  );

    // [9763] Function call CfLastValue
    func_9763.input = func_2326.output;
    func_9763.Execute(  );

    // [9766] Function call CfMinimum
    func_9766.input[0] = func_9763.outputCurrent;
    func_9766.input[1] = func_9763.outputLast;
    func_9766.Execute(  );
    setCmSQA_ChillerSeq_output_13(func_9766.output);

    // [2328] Function call CfIdt
    func_2328.input = func_8810.Cmswitch_x_12_output_26;
    func_2328.Execute(  );

    // [2329] Function call CfAnd
    func_2329.input[0] = FloatToBoolean(func_2321.output);
    func_2329.input[1] = FloatToBoolean(func_2322.output);
    func_2329.input[2] = FloatToBoolean(func_2323.output[0]);
    func_2329.Execute(  );

    // [2330] Function call CfIdt
    func_2330.input = func_8810.Cmswitch_x_12_output_27;
    func_2330.Execute(  );

    // [2331] Function call CfAnd
    func_2331.input[0] = FloatToBoolean(func_2324.output);
    func_2331.input[1] = FloatToBoolean(func_2322.output);
    func_2331.input[2] = FloatToBoolean(func_2323.output[0]);
    func_2331.Execute(  );

    // [2332] Function call CfIdt
    func_2332.input = func_8810.Cmswitch_x_12_output_28;
    func_2332.Execute(  );

    // [2333] Function call CfAnd
    func_2333.input[0] = FloatToBoolean(func_2325.output);
    func_2333.input[1] = FloatToBoolean(func_2322.output);
    func_2333.input[2] = FloatToBoolean(func_2323.output[0]);
    func_2333.Execute(  );

    // [2336] Function call CfInputMultiplexer
    func_2336.inputSelect = BooleanToInt(func_2329.outputAND);
    func_2336.input[1-1] = BooleanToFloat(func_2329.outputAND);
    func_2336.input[2-1] = func_2328.output[0];
    func_2336.Execute(  );

    // [2337] Function call CfInputMultiplexer
    func_2337.inputSelect = BooleanToInt(func_2331.outputAND);
    func_2337.input[1-1] = BooleanToFloat(func_2331.outputAND);
    func_2337.input[2-1] = func_2330.output[0];
    func_2337.Execute(  );

    // [2338] Function call CfInputMultiplexer
    func_2338.inputSelect = BooleanToInt(func_2333.outputAND);
    func_2338.input[1-1] = BooleanToFloat(func_2333.outputAND);
    func_2338.input[2-1] = func_2332.output[0];
    func_2338.Execute(  );

    // [2339] Function call CfIdt
    func_2339.input = func_2349.output[0];
    func_2339.Execute(  );

    // [2347] Function call CfSubtract
    func_2347.input[0] = func_2339.output[0];
    func_2347.input[1] = IntToFloat(ControlFunction.GetMinuteAfterMidnight());
    func_2347.Execute(  );

    // [2348] Function call CfAbsolute
    func_2348.input = func_2347.output;
    func_2348.Execute(  );

    // [2349] Function call CfIdt
    func_2349.input = IntToFloat(ControlFunction.GetMinuteAfterMidnight());
    func_2349.Execute(  );

    // [8071] Function call CfInputMultiplexer
    func_8071.inputSelect = 0;
    func_8071.input[1-1] = 60F;
    func_8071.input[2-1] = 3F;
    func_8071.Execute(  );

    // [9151] Macro call CmRuntime_LD
    func_9151.CmRuntime_LD_input_1 = func_2348.outputAbs;
    func_9151.CmRuntime_LD_input_2 = FloatToBoolean(func_2336.output);
    func_9151.CmRuntime_LD_input_44 = func_8071.output;
    func_9151.CmRuntime_LD_input_48 = false;
    func_9151.Execute(  );

    // [9153] Macro call CmRuntime_LD
    func_9153.CmRuntime_LD_input_1 = func_2348.outputAbs;
    func_9153.CmRuntime_LD_input_2 = FloatToBoolean(func_2337.output);
    func_9153.CmRuntime_LD_input_44 = func_8071.output;
    func_9153.CmRuntime_LD_input_48 = false;
    func_9153.Execute(  );

    // [9154] Macro call CmRuntime_LD
    func_9154.CmRuntime_LD_input_1 = func_2348.outputAbs;
    func_9154.CmRuntime_LD_input_2 = FloatToBoolean(func_2338.output);
    func_9154.CmRuntime_LD_input_44 = func_8071.output;
    func_9154.CmRuntime_LD_input_48 = false;
    func_9154.Execute(  );

    // [2341] Function call CfIdt
    func_2341.input = func_2336.output;
    func_2341.Execute(  );
    setCmSQA_ChillerSeq_output_8(func_2341.output[0]);

    // [2343] Function call CfIdt
    func_2343.input = func_2337.output;
    func_2343.Execute(  );
    setCmSQA_ChillerSeq_output_9(func_2343.output[0]);

    // [2345] Function call CfIdt
    func_2345.input = func_2338.output;
    func_2345.Execute(  );
    setCmSQA_ChillerSeq_output_10(func_2345.output[0]);

    // [8330] Function call CfOr
    func_8330.input[0] = FloatToBoolean(register_311);
    func_8330.input[1] = getCmSQA_ChillerSeq_input_8313().getValue();
    func_8330.Execute(  );
    setCmSQA_ChillerSeq_output_8316(func_8330.outputOR);

    // [8333] Function call CfOr
    func_8333.input[0] = FloatToBoolean(register_312);
    func_8333.input[1] = getCmSQA_ChillerSeq_input_8314().getValue();
    func_8333.Execute(  );
    setCmSQA_ChillerSeq_output_8317(func_8333.outputOR);

    // [8334] Function call CfOr
    func_8334.input[0] = FloatToBoolean(register_313);
    func_8334.input[1] = getCmSQA_ChillerSeq_input_8315().getValue();
    func_8334.Execute(  );
    setCmSQA_ChillerSeq_output_8318(func_8334.outputOR);

    // [2376] Function call CfIdt
    func_2376.input = func_8447.output;
    func_2376.Execute(  );
    setCmSQA_ChillerSeq_parameter_57(func_2376.output[0]);

    // [2377] Function call CfIdt
    func_2377.input = func_8731.output;
    func_2377.Execute(  );
    setCmSQA_ChillerSeq_parameter_58(func_2377.output[0]);

    // [9775] Macro call CmWriteRuntime
    func_9775.CmWriteRuntime_input_1 = ControlFunction.GetStartupFlag();
    func_9775.CmWriteRuntime_input_3 = func_9151.CmRuntime_LD_output_3;
    func_9775.CmWriteRuntime_input_4 = (float) getCmSQA_ChillerSeq_parameter_45();
    func_9775.Execute(  );
    setCmSQA_ChillerSeq_parameter_45(func_9775.CmWriteRuntime_output_5);

    // [9777] Macro call CmWriteRuntime
    func_9777.CmWriteRuntime_input_1 = ControlFunction.GetStartupFlag();
    func_9777.CmWriteRuntime_input_3 = func_9153.CmRuntime_LD_output_3;
    func_9777.CmWriteRuntime_input_4 = (float) getCmSQA_ChillerSeq_parameter_46();
    func_9777.Execute(  );
    setCmSQA_ChillerSeq_parameter_46(func_9777.CmWriteRuntime_output_5);

    // [9779] Macro call CmWriteRuntime
    func_9779.CmWriteRuntime_input_1 = ControlFunction.GetStartupFlag();
    func_9779.CmWriteRuntime_input_3 = func_9154.CmRuntime_LD_output_3;
    func_9779.CmWriteRuntime_input_4 = (float) getCmSQA_ChillerSeq_parameter_47();
    func_9779.Execute(  );
    setCmSQA_ChillerSeq_parameter_47(func_9779.CmWriteRuntime_output_5);

  }

  // parameter for functions and sub macros
  protected float [] parameterList = new float []
  {
    10F, 10F, 10F, 10F, 2F, 0F, 0F, 0F,
    45F, 60F, 60F, 60F, 600F, 600F, 60F, 100F,
    100F, 0F, 0F, 0F, 0F, 0F, 0F, 0F,
    10F, 100F, 10F
  };

  // implementation of IEnvironment
  public float getParameter(int index)
  {
    return parameterList[index];
  };

  public void setParameter(int index, float value)
  {
    parameterList[index] = value;
  };

  // macro register which are written multiple times
  protected float register_279 = 0;
  protected float register_289 = 0;
  protected float register_293 = 0;
  protected float register_294 = 0;
  protected float register_295 = 0;
  protected float register_296 = 0;
  protected float register_297 = 0;
  protected float register_298 = 0;
  protected float register_299 = 0;
  protected float register_300 = 0;
  protected float register_301 = 0;
  protected float register_302 = 0;
  protected float register_303 = 0;
  protected float register_304 = 0;
  protected float register_305 = 0;
  protected float register_311 = 0;
  protected float register_312 = 0;
  protected float register_313 = 0;
  protected float register_323 = 0;
  protected float register_325 = 0;
  protected float register_326 = 0;
  protected float register_327 = 0;
  protected float register_328 = 0;
  protected float register_329 = 0;
  protected float register_330 = 0;
  protected float register_331 = 0;
  protected float register_332 = 0;
  protected float register_333 = 0;
  protected float register_334 = 0;
  protected float register_335 = 0;
  protected float register_336 = 0;
  protected float register_356 = 0;
  // macro outputs
// Load1Cmd
  public static final Property CmSQA_ChillerSeq_output_8 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSQA_ChillerSeq_output_8() { return (BStatusNumeric) get(CmSQA_ChillerSeq_output_8); }
  public void setCmSQA_ChillerSeq_output_8(BStatusNumeric v) { set(CmSQA_ChillerSeq_output_8,v,null); }
  public void setCmSQA_ChillerSeq_output_8(float v) { getCmSQA_ChillerSeq_output_8().setValue(v); }
// Load2Cmd
  public static final Property CmSQA_ChillerSeq_output_9 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSQA_ChillerSeq_output_9() { return (BStatusNumeric) get(CmSQA_ChillerSeq_output_9); }
  public void setCmSQA_ChillerSeq_output_9(BStatusNumeric v) { set(CmSQA_ChillerSeq_output_9,v,null); }
  public void setCmSQA_ChillerSeq_output_9(float v) { getCmSQA_ChillerSeq_output_9().setValue(v); }
// Load3Cmd
  public static final Property CmSQA_ChillerSeq_output_10 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSQA_ChillerSeq_output_10() { return (BStatusNumeric) get(CmSQA_ChillerSeq_output_10); }
  public void setCmSQA_ChillerSeq_output_10(BStatusNumeric v) { set(CmSQA_ChillerSeq_output_10,v,null); }
  public void setCmSQA_ChillerSeq_output_10(float v) { getCmSQA_ChillerSeq_output_10().setValue(v); }
// GroupFeedbackSig
  public static final Property CmSQA_ChillerSeq_output_11 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSQA_ChillerSeq_output_11() { return (BStatusNumeric) get(CmSQA_ChillerSeq_output_11); }
  public void setCmSQA_ChillerSeq_output_11(BStatusNumeric v) { set(CmSQA_ChillerSeq_output_11,v,null); }
  public void setCmSQA_ChillerSeq_output_11(float v) { getCmSQA_ChillerSeq_output_11().setValue(v); }
// CommOutput
  public static final Property CmSQA_ChillerSeq_output_12 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSQA_ChillerSeq_output_12() { return (BStatusNumeric) get(CmSQA_ChillerSeq_output_12); }
  public void setCmSQA_ChillerSeq_output_12(BStatusNumeric v) { set(CmSQA_ChillerSeq_output_12,v,null); }
  public void setCmSQA_ChillerSeq_output_12(float v) { getCmSQA_ChillerSeq_output_12().setValue(v); }
// DispOpLoads
  public static final Property CmSQA_ChillerSeq_output_13 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusNumeric( 0, BStatus.disabled), null);
  public BStatusNumeric getCmSQA_ChillerSeq_output_13() { return (BStatusNumeric) get(CmSQA_ChillerSeq_output_13); }
  public void setCmSQA_ChillerSeq_output_13(BStatusNumeric v) { set(CmSQA_ChillerSeq_output_13,v,null); }
  public void setCmSQA_ChillerSeq_output_13(float v) { getCmSQA_ChillerSeq_output_13().setValue(v); }
// Load1_AlarmOut
  public static final Property CmSQA_ChillerSeq_output_8316 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSQA_ChillerSeq_output_8316() { return (BStatusBoolean) get(CmSQA_ChillerSeq_output_8316); }
  public void setCmSQA_ChillerSeq_output_8316(BStatusBoolean v) { set(CmSQA_ChillerSeq_output_8316,v,null); }
  public void setCmSQA_ChillerSeq_output_8316(boolean v) { getCmSQA_ChillerSeq_output_8316().setValue(v); }
// Load2_AlarmOut
  public static final Property CmSQA_ChillerSeq_output_8317 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSQA_ChillerSeq_output_8317() { return (BStatusBoolean) get(CmSQA_ChillerSeq_output_8317); }
  public void setCmSQA_ChillerSeq_output_8317(BStatusBoolean v) { set(CmSQA_ChillerSeq_output_8317,v,null); }
  public void setCmSQA_ChillerSeq_output_8317(boolean v) { getCmSQA_ChillerSeq_output_8317().setValue(v); }
// Load3_AlarmOut
  public static final Property CmSQA_ChillerSeq_output_8318 = newProperty( Flags.SUMMARY|Flags.READONLY|Flags.OPERATOR|Flags.TRANSIENT, new BStatusBoolean( false, BStatus.disabled), null);
  public BStatusBoolean getCmSQA_ChillerSeq_output_8318() { return (BStatusBoolean) get(CmSQA_ChillerSeq_output_8318); }
  public void setCmSQA_ChillerSeq_output_8318(BStatusBoolean v) { set(CmSQA_ChillerSeq_output_8318,v,null); }
  public void setCmSQA_ChillerSeq_output_8318(boolean v) { getCmSQA_ChillerSeq_output_8318().setValue(v); }

  // macro parameter
// SEQ-01: input signal for number of loads
  public static final Property CmSQA_ChillerSeq_parameter_16 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_16() { return getDouble(CmSQA_ChillerSeq_parameter_16); }
  public void setCmSQA_ChillerSeq_parameter_16(double v) { setDouble(CmSQA_ChillerSeq_parameter_16,v,null); }
// SEQ-02: staging up delay
  public static final Property CmSQA_ChillerSeq_parameter_27 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSQA_ChillerSeq_parameter_27() { return getDouble(CmSQA_ChillerSeq_parameter_27); }
  public void setCmSQA_ChillerSeq_parameter_27(double v) { setDouble(CmSQA_ChillerSeq_parameter_27,v,null); }
// SEQ-03: staging down delay
  public static final Property CmSQA_ChillerSeq_parameter_28 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSQA_ChillerSeq_parameter_28() { return getDouble(CmSQA_ChillerSeq_parameter_28); }
  public void setCmSQA_ChillerSeq_parameter_28(double v) { setDouble(CmSQA_ChillerSeq_parameter_28,v,null); }
// SEQ-04: take over transition function
  public static final Property CmSQA_ChillerSeq_parameter_21 = newProperty( 0, BDouble.make( 600 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(-3600)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSQA_ChillerSeq_parameter_21() { return getDouble(CmSQA_ChillerSeq_parameter_21); }
  public void setCmSQA_ChillerSeq_parameter_21(double v) { setDouble(CmSQA_ChillerSeq_parameter_21,v,null); }
// SEQ-05: number of stages per load output
  public static final Property CmSQA_ChillerSeq_parameter_30 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmSQA_ChillerSeq_parameter_30() { return getDouble(CmSQA_ChillerSeq_parameter_30); }
  public void setCmSQA_ChillerSeq_parameter_30(double v) { setDouble(CmSQA_ChillerSeq_parameter_30,v,null); }
// SEQ-06: output control
  public static final Property CmSQA_ChillerSeq_parameter_31 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_31() { return getDouble(CmSQA_ChillerSeq_parameter_31); }
  public void setCmSQA_ChillerSeq_parameter_31(double v) { setDouble(CmSQA_ChillerSeq_parameter_31,v,null); }
// SEQ-07: sequence overwrite
  public static final Property CmSQA_ChillerSeq_parameter_32 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_32() { return getDouble(CmSQA_ChillerSeq_parameter_32); }
  public void setCmSQA_ChillerSeq_parameter_32(double v) { setDouble(CmSQA_ChillerSeq_parameter_32,v,null); }
// CYC-01: sequence rotation
  public static final Property CmSQA_ChillerSeq_parameter_15 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_15() { return getDouble(CmSQA_ChillerSeq_parameter_15); }
  public void setCmSQA_ChillerSeq_parameter_15(double v) { setDouble(CmSQA_ChillerSeq_parameter_15,v,null); }
// CYC-02: type of changeover
  public static final Property CmSQA_ChillerSeq_parameter_17 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_17() { return getDouble(CmSQA_ChillerSeq_parameter_17); }
  public void setCmSQA_ChillerSeq_parameter_17(double v) { setDouble(CmSQA_ChillerSeq_parameter_17,v,null); }
// CYC-03: period of change over
  public static final Property CmSQA_ChillerSeq_parameter_18 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_18() { return getDouble(CmSQA_ChillerSeq_parameter_18); }
  public void setCmSQA_ChillerSeq_parameter_18(double v) { setDouble(CmSQA_ChillerSeq_parameter_18,v,null); }
// CYC-04: day of change over
  public static final Property CmSQA_ChillerSeq_parameter_19 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(31)), BFacets.make(BFacets.MIN, BDouble.make(1)) ));
  public double getCmSQA_ChillerSeq_parameter_19() { return getDouble(CmSQA_ChillerSeq_parameter_19); }
  public void setCmSQA_ChillerSeq_parameter_19(double v) { setDouble(CmSQA_ChillerSeq_parameter_19,v,null); }
// CYC-05: time of change over
  public static final Property CmSQA_ChillerSeq_parameter_20 = newProperty( 0, BDouble.make( 1000 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(2359)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_20() { return getDouble(CmSQA_ChillerSeq_parameter_20); }
  public void setCmSQA_ChillerSeq_parameter_20(double v) { setDouble(CmSQA_ChillerSeq_parameter_20,v,null); }
// CYC-06: max. runtime difference
  public static final Property CmSQA_ChillerSeq_parameter_22 = newProperty( 0, BDouble.make( 100 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(1)), BFacets.make(BFacets.MAX, BDouble.make(9999)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("hour"))));
  public double getCmSQA_ChillerSeq_parameter_22() { return getDouble(CmSQA_ChillerSeq_parameter_22); }
  public void setCmSQA_ChillerSeq_parameter_22(double v) { setDouble(CmSQA_ChillerSeq_parameter_22,v,null); }
// ALM-01: delay status alarm load1
  public static final Property CmSQA_ChillerSeq_parameter_23 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSQA_ChillerSeq_parameter_23() { return getDouble(CmSQA_ChillerSeq_parameter_23); }
  public void setCmSQA_ChillerSeq_parameter_23(double v) { setDouble(CmSQA_ChillerSeq_parameter_23,v,null); }
// ALM-02: delay status alarm load2
  public static final Property CmSQA_ChillerSeq_parameter_24 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSQA_ChillerSeq_parameter_24() { return getDouble(CmSQA_ChillerSeq_parameter_24); }
  public void setCmSQA_ChillerSeq_parameter_24(double v) { setDouble(CmSQA_ChillerSeq_parameter_24,v,null); }
// ALM-03: delay status alarm load3
  public static final Property CmSQA_ChillerSeq_parameter_25 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSQA_ChillerSeq_parameter_25() { return getDouble(CmSQA_ChillerSeq_parameter_25); }
  public void setCmSQA_ChillerSeq_parameter_25(double v) { setDouble(CmSQA_ChillerSeq_parameter_25,v,null); }
// ALM-04: reset 0=manual
  public static final Property CmSQA_ChillerSeq_parameter_26 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_26() { return getDouble(CmSQA_ChillerSeq_parameter_26); }
  public void setCmSQA_ChillerSeq_parameter_26(double v) { setDouble(CmSQA_ChillerSeq_parameter_26,v,null); }
// ALM-05: failure change-over delay
  public static final Property CmSQA_ChillerSeq_parameter_29 = newProperty( 0, BDouble.make( 60 ), BFacets.make( BFacets.make( BFacets.make(BFacets.MIN, BDouble.make(0)), BFacets.make(BFacets.MAX, BDouble.make(3600)) ),  BFacets.make(BFacets.UNITS, BUnit.getUnit("second"))));
  public double getCmSQA_ChillerSeq_parameter_29() { return getDouble(CmSQA_ChillerSeq_parameter_29); }
  public void setCmSQA_ChillerSeq_parameter_29(double v) { setDouble(CmSQA_ChillerSeq_parameter_29,v,null); }
// POS-01: sequence load1; 0 = disable
  public static final Property CmSQA_ChillerSeq_parameter_33 = newProperty( 0, BDouble.make( 1 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_33() { return getDouble(CmSQA_ChillerSeq_parameter_33); }
  public void setCmSQA_ChillerSeq_parameter_33(double v) { setDouble(CmSQA_ChillerSeq_parameter_33,v,null); }
// POS-02: sequence load2; 0 = disable
  public static final Property CmSQA_ChillerSeq_parameter_34 = newProperty( 0, BDouble.make( 2 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_34() { return getDouble(CmSQA_ChillerSeq_parameter_34); }
  public void setCmSQA_ChillerSeq_parameter_34(double v) { setDouble(CmSQA_ChillerSeq_parameter_34,v,null); }
// POS-03: sequence load3; 0 = disable
  public static final Property CmSQA_ChillerSeq_parameter_35 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_35() { return getDouble(CmSQA_ChillerSeq_parameter_35); }
  public void setCmSQA_ChillerSeq_parameter_35(double v) { setDouble(CmSQA_ChillerSeq_parameter_35,v,null); }
// POS-04: sequence load4; 0 = disable
  public static final Property CmSQA_ChillerSeq_parameter_36 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_36() { return getDouble(CmSQA_ChillerSeq_parameter_36); }
  public void setCmSQA_ChillerSeq_parameter_36(double v) { setDouble(CmSQA_ChillerSeq_parameter_36,v,null); }
// POS-05: sequence load5; 0 = disable
  public static final Property CmSQA_ChillerSeq_parameter_37 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_37() { return getDouble(CmSQA_ChillerSeq_parameter_37); }
  public void setCmSQA_ChillerSeq_parameter_37(double v) { setDouble(CmSQA_ChillerSeq_parameter_37,v,null); }
// POS-06: sequence load6; 0 = disable
  public static final Property CmSQA_ChillerSeq_parameter_38 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_38() { return getDouble(CmSQA_ChillerSeq_parameter_38); }
  public void setCmSQA_ChillerSeq_parameter_38(double v) { setDouble(CmSQA_ChillerSeq_parameter_38,v,null); }
// POS-07: sequence load7; 0 = disable
  public static final Property CmSQA_ChillerSeq_parameter_39 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_39() { return getDouble(CmSQA_ChillerSeq_parameter_39); }
  public void setCmSQA_ChillerSeq_parameter_39(double v) { setDouble(CmSQA_ChillerSeq_parameter_39,v,null); }
// POS-08: sequence load8; 0 = disable
  public static final Property CmSQA_ChillerSeq_parameter_40 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_40() { return getDouble(CmSQA_ChillerSeq_parameter_40); }
  public void setCmSQA_ChillerSeq_parameter_40(double v) { setDouble(CmSQA_ChillerSeq_parameter_40,v,null); }
// POS-09: sequence load9; 0 = disable
  public static final Property CmSQA_ChillerSeq_parameter_41 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_41() { return getDouble(CmSQA_ChillerSeq_parameter_41); }
  public void setCmSQA_ChillerSeq_parameter_41(double v) { setDouble(CmSQA_ChillerSeq_parameter_41,v,null); }
// POS-10: sequence load10; 0 = disable
  public static final Property CmSQA_ChillerSeq_parameter_42 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_42() { return getDouble(CmSQA_ChillerSeq_parameter_42); }
  public void setCmSQA_ChillerSeq_parameter_42(double v) { setDouble(CmSQA_ChillerSeq_parameter_42,v,null); }
// POS-11: sequence load11; 0 = disable
  public static final Property CmSQA_ChillerSeq_parameter_43 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_43() { return getDouble(CmSQA_ChillerSeq_parameter_43); }
  public void setCmSQA_ChillerSeq_parameter_43(double v) { setDouble(CmSQA_ChillerSeq_parameter_43,v,null); }
// POS-12: sequence load12; 0 = disable
  public static final Property CmSQA_ChillerSeq_parameter_44 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_44() { return getDouble(CmSQA_ChillerSeq_parameter_44); }
  public void setCmSQA_ChillerSeq_parameter_44(double v) { setDouble(CmSQA_ChillerSeq_parameter_44,v,null); }
// POS-13: AdjustNoLoads
  public static final Property CmSQA_ChillerSeq_parameter_9098 = newProperty( 0, BDouble.make( 3 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(12)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_9098() { return getDouble(CmSQA_ChillerSeq_parameter_9098); }
  public void setCmSQA_ChillerSeq_parameter_9098(double v) { setDouble(CmSQA_ChillerSeq_parameter_9098,v,null); }
// RUNT-01: runtime load1
  public static final Property CmSQA_ChillerSeq_parameter_45 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)), BFacets.make(BFacets.UNITS, BUnit.getUnit("hour")) ));
  public double getCmSQA_ChillerSeq_parameter_45() { return getDouble(CmSQA_ChillerSeq_parameter_45); }
  public void setCmSQA_ChillerSeq_parameter_45(double v) { setDouble(CmSQA_ChillerSeq_parameter_45,v,null); }
// RUNT-02: runtime load2
  public static final Property CmSQA_ChillerSeq_parameter_46 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)), BFacets.make(BFacets.UNITS, BUnit.getUnit("hour")) ));
  public double getCmSQA_ChillerSeq_parameter_46() { return getDouble(CmSQA_ChillerSeq_parameter_46); }
  public void setCmSQA_ChillerSeq_parameter_46(double v) { setDouble(CmSQA_ChillerSeq_parameter_46,v,null); }
// RUNT-03: runtime load3
  public static final Property CmSQA_ChillerSeq_parameter_47 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)), BFacets.make(BFacets.UNITS, BUnit.getUnit("hour")) ));
  public double getCmSQA_ChillerSeq_parameter_47() { return getDouble(CmSQA_ChillerSeq_parameter_47); }
  public void setCmSQA_ChillerSeq_parameter_47(double v) { setDouble(CmSQA_ChillerSeq_parameter_47,v,null); }
// RUNT-04: runtime load4
  public static final Property CmSQA_ChillerSeq_parameter_48 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)), BFacets.make(BFacets.UNITS, BUnit.getUnit("hour")) ));
  public double getCmSQA_ChillerSeq_parameter_48() { return getDouble(CmSQA_ChillerSeq_parameter_48); }
  public void setCmSQA_ChillerSeq_parameter_48(double v) { setDouble(CmSQA_ChillerSeq_parameter_48,v,null); }
// RUNT-05: runtime load5
  public static final Property CmSQA_ChillerSeq_parameter_49 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)), BFacets.make(BFacets.UNITS, BUnit.getUnit("hour")) ));
  public double getCmSQA_ChillerSeq_parameter_49() { return getDouble(CmSQA_ChillerSeq_parameter_49); }
  public void setCmSQA_ChillerSeq_parameter_49(double v) { setDouble(CmSQA_ChillerSeq_parameter_49,v,null); }
// RUNT-06: runtime load6
  public static final Property CmSQA_ChillerSeq_parameter_50 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)), BFacets.make(BFacets.UNITS, BUnit.getUnit("hour")) ));
  public double getCmSQA_ChillerSeq_parameter_50() { return getDouble(CmSQA_ChillerSeq_parameter_50); }
  public void setCmSQA_ChillerSeq_parameter_50(double v) { setDouble(CmSQA_ChillerSeq_parameter_50,v,null); }
// RUNT-07: runtime load7
  public static final Property CmSQA_ChillerSeq_parameter_51 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)), BFacets.make(BFacets.UNITS, BUnit.getUnit("hour")) ));
  public double getCmSQA_ChillerSeq_parameter_51() { return getDouble(CmSQA_ChillerSeq_parameter_51); }
  public void setCmSQA_ChillerSeq_parameter_51(double v) { setDouble(CmSQA_ChillerSeq_parameter_51,v,null); }
// RUNT-08: runtime load8
  public static final Property CmSQA_ChillerSeq_parameter_52 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)), BFacets.make(BFacets.UNITS, BUnit.getUnit("hour")) ));
  public double getCmSQA_ChillerSeq_parameter_52() { return getDouble(CmSQA_ChillerSeq_parameter_52); }
  public void setCmSQA_ChillerSeq_parameter_52(double v) { setDouble(CmSQA_ChillerSeq_parameter_52,v,null); }
// RUNT-09: runtime load9
  public static final Property CmSQA_ChillerSeq_parameter_53 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)), BFacets.make(BFacets.UNITS, BUnit.getUnit("hour")) ));
  public double getCmSQA_ChillerSeq_parameter_53() { return getDouble(CmSQA_ChillerSeq_parameter_53); }
  public void setCmSQA_ChillerSeq_parameter_53(double v) { setDouble(CmSQA_ChillerSeq_parameter_53,v,null); }
// RUNT-10: runtime load10
  public static final Property CmSQA_ChillerSeq_parameter_54 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)), BFacets.make(BFacets.UNITS, BUnit.getUnit("hour")) ));
  public double getCmSQA_ChillerSeq_parameter_54() { return getDouble(CmSQA_ChillerSeq_parameter_54); }
  public void setCmSQA_ChillerSeq_parameter_54(double v) { setDouble(CmSQA_ChillerSeq_parameter_54,v,null); }
// RUNT-11: runtime load11
  public static final Property CmSQA_ChillerSeq_parameter_55 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)), BFacets.make(BFacets.UNITS, BUnit.getUnit("hour")) ));
  public double getCmSQA_ChillerSeq_parameter_55() { return getDouble(CmSQA_ChillerSeq_parameter_55); }
  public void setCmSQA_ChillerSeq_parameter_55(double v) { setDouble(CmSQA_ChillerSeq_parameter_55,v,null); }
// RUNT-12: runtime load12
  public static final Property CmSQA_ChillerSeq_parameter_56 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(3.402823E+38)), BFacets.make(BFacets.UNITS, BUnit.getUnit("hour")) ));
  public double getCmSQA_ChillerSeq_parameter_56() { return getDouble(CmSQA_ChillerSeq_parameter_56); }
  public void setCmSQA_ChillerSeq_parameter_56(double v) { setDouble(CmSQA_ChillerSeq_parameter_56,v,null); }
// SYS-01: use group feedback signal
  public static final Property CmSQA_ChillerSeq_parameter_5632 = newProperty( 0, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(1)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_5632() { return getDouble(CmSQA_ChillerSeq_parameter_5632); }
  public void setCmSQA_ChillerSeq_parameter_5632(double v) { setDouble(CmSQA_ChillerSeq_parameter_5632,v,null); }
// DISP-01: next to start load
  public static final Property CmSQA_ChillerSeq_parameter_57 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_57() { return getDouble(CmSQA_ChillerSeq_parameter_57); }
  public void setCmSQA_ChillerSeq_parameter_57(double v) { setDouble(CmSQA_ChillerSeq_parameter_57,v,null); }
// DISP-02: next to stop load
  public static final Property CmSQA_ChillerSeq_parameter_58 = newProperty( Flags.READONLY|Flags.TRANSIENT, BDouble.make( 0 ), BFacets.make( BFacets.make(BFacets.MAX, BDouble.make(0)), BFacets.make(BFacets.MIN, BDouble.make(0)) ));
  public double getCmSQA_ChillerSeq_parameter_58() { return getDouble(CmSQA_ChillerSeq_parameter_58); }
  public void setCmSQA_ChillerSeq_parameter_58(double v) { setDouble(CmSQA_ChillerSeq_parameter_58,v,null); }

  // macro inputs
// Load1_Status
  public static final Property CmSQA_ChillerSeq_input_1 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmSQA_ChillerSeq_input_1() { return (BStatusNumeric) get(CmSQA_ChillerSeq_input_1); }
  public void setCmSQA_ChillerSeq_input_1(BStatusNumeric v) { set(CmSQA_ChillerSeq_input_1,v,null); }
  public void setCmSQA_ChillerSeq_input_1(float v) { getCmSQA_ChillerSeq_input_1().setValue(v); }
// Load1_Alarm
  public static final Property CmSQA_ChillerSeq_input_8313 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmSQA_ChillerSeq_input_8313() { return (BStatusBoolean) get(CmSQA_ChillerSeq_input_8313); }
  public void setCmSQA_ChillerSeq_input_8313(BStatusBoolean v) { set(CmSQA_ChillerSeq_input_8313,v,null); }
  public void setCmSQA_ChillerSeq_input_8313(boolean v) { getCmSQA_ChillerSeq_input_8313().setValue(v); }
// Load2_Status
  public static final Property CmSQA_ChillerSeq_input_2 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmSQA_ChillerSeq_input_2() { return (BStatusNumeric) get(CmSQA_ChillerSeq_input_2); }
  public void setCmSQA_ChillerSeq_input_2(BStatusNumeric v) { set(CmSQA_ChillerSeq_input_2,v,null); }
  public void setCmSQA_ChillerSeq_input_2(float v) { getCmSQA_ChillerSeq_input_2().setValue(v); }
// Load2_Alarm
  public static final Property CmSQA_ChillerSeq_input_8314 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmSQA_ChillerSeq_input_8314() { return (BStatusBoolean) get(CmSQA_ChillerSeq_input_8314); }
  public void setCmSQA_ChillerSeq_input_8314(BStatusBoolean v) { set(CmSQA_ChillerSeq_input_8314,v,null); }
  public void setCmSQA_ChillerSeq_input_8314(boolean v) { getCmSQA_ChillerSeq_input_8314().setValue(v); }
// Load3_Status
  public static final Property CmSQA_ChillerSeq_input_3 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0 ), null);
  public BStatusNumeric getCmSQA_ChillerSeq_input_3() { return (BStatusNumeric) get(CmSQA_ChillerSeq_input_3); }
  public void setCmSQA_ChillerSeq_input_3(BStatusNumeric v) { set(CmSQA_ChillerSeq_input_3,v,null); }
  public void setCmSQA_ChillerSeq_input_3(float v) { getCmSQA_ChillerSeq_input_3().setValue(v); }
// Load3_Alarm
  public static final Property CmSQA_ChillerSeq_input_8315 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmSQA_ChillerSeq_input_8315() { return (BStatusBoolean) get(CmSQA_ChillerSeq_input_8315); }
  public void setCmSQA_ChillerSeq_input_8315(BStatusBoolean v) { set(CmSQA_ChillerSeq_input_8315,v,null); }
  public void setCmSQA_ChillerSeq_input_8315(boolean v) { getCmSQA_ChillerSeq_input_8315().setValue(v); }
// Req_NoLoads
  public static final Property CmSQA_ChillerSeq_input_4 = newProperty( Flags.SUMMARY, new BStatusNumeric( 0, BStatus.nullStatus), null);
  public BStatusNumeric getCmSQA_ChillerSeq_input_4() { return (BStatusNumeric) get(CmSQA_ChillerSeq_input_4); }
  public void setCmSQA_ChillerSeq_input_4(BStatusNumeric v) { set(CmSQA_ChillerSeq_input_4,v,null); }
  public void setCmSQA_ChillerSeq_input_4(float v) { getCmSQA_ChillerSeq_input_4().setValue(v); }
// CommInput
  public static final Property CmSQA_ChillerSeq_input_5 = newProperty( Flags.SUMMARY, new BStatusNumeric( 999 ), null);
  public BStatusNumeric getCmSQA_ChillerSeq_input_5() { return (BStatusNumeric) get(CmSQA_ChillerSeq_input_5); }
  public void setCmSQA_ChillerSeq_input_5(BStatusNumeric v) { set(CmSQA_ChillerSeq_input_5,v,null); }
  public void setCmSQA_ChillerSeq_input_5(float v) { getCmSQA_ChillerSeq_input_5().setValue(v); }
// Reset
  public static final Property CmSQA_ChillerSeq_input_7 = newProperty( Flags.SUMMARY, new BStatusBoolean( false ), null);
  public BStatusBoolean getCmSQA_ChillerSeq_input_7() { return (BStatusBoolean) get(CmSQA_ChillerSeq_input_7); }
  public void setCmSQA_ChillerSeq_input_7(BStatusBoolean v) { set(CmSQA_ChillerSeq_input_7,v,null); }
  public void setCmSQA_ChillerSeq_input_7(boolean v) { getCmSQA_ChillerSeq_input_7().setValue(v); }
// Enable
  public static final Property CmSQA_ChillerSeq_input_6 = newProperty( Flags.SUMMARY, new BStatusBoolean( true ), null);
  public BStatusBoolean getCmSQA_ChillerSeq_input_6() { return (BStatusBoolean) get(CmSQA_ChillerSeq_input_6); }
  public void setCmSQA_ChillerSeq_input_6(BStatusBoolean v) { set(CmSQA_ChillerSeq_input_6,v,null); }
  public void setCmSQA_ChillerSeq_input_6(boolean v) { getCmSQA_ChillerSeq_input_6().setValue(v); }

  public static final Property enabledIn = newProperty( 0, new BStatusBoolean( true ), null);
  public BStatusBoolean getEnabledIn() { return (BStatusBoolean) get(enabledIn); }
  public void setEnabledIn(BStatusBoolean v) { set(enabledIn,v,null); }
  public void setEnabledIn(boolean v) { getEnabledIn().setValue(v); }


  public static final Property versionInfo = newProperty( Flags.READONLY, BString.make( "51.02 [173] 26.02.2019-10:48").getString(), null);
  public String getVersionInfo() { return getString(versionInfo); }
  public void setVersionInfo(String v) { setString(versionInfo,v,null); }


  public static final Property macroId = newProperty( Flags.READONLY|Flags.HIDDEN, BString.make( "6247347688713486541").getString(), null);
  public String getMacroId() { return getString(macroId); }
  public void setMacroId(String v) { setString(macroId,v,null); }

  // TYPE declaration
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BCmSQA_ChillerSeq.class);


  // cycle time
  protected long lastSystemTicks = 0;
  protected float lastCycleTime = 0;

  // implementation of IEnvironment interface
  public float getCycleTime()
  { 
    return lastCycleTime;
  }

  public void started() throws Exception
  {
    super.started();
    Start();
    lastSystemTicks = ControlFunction.GetSystemTicks();

  }

  public int getHighestPriority(int inputId)
  {
    return 0;
  }

  public float getPriorityValue(int inputId, int priorityIndex)
  {
    return Float.NaN;
  }

  public void setPriorityValue(int outputId, int priorityIndex, float value, boolean setNull)
  {
  }

  // helper functions
  private float   BooleanToFloat(boolean value) { return value ? 1 : 0; }
  private float   IntToFloat    (int     value) { return (float) value; }
  private int     BooleanToInt  (boolean value) { return value ? 1 : 0; }
  private int     FloatToInt    (float   value) { return (int) value;   }
  private boolean FloatToBoolean(float   value) { return value >= 0.5F; }

  // class variables
  protected CfNot func_9773 = new CfNot();
  protected CfAnd func_9771 = new CfAnd();
  protected CfIdt func_72 = new CfIdt();
  protected CfIdt func_73 = new CfIdt();
  protected CfIdt func_74 = new CfIdt();
  protected CfIdt func_75 = new CfIdt();
  protected CfIdt func_76 = new CfIdt();
  protected CfIdt func_77 = new CfIdt();
  protected CfIdt func_78 = new CfIdt();
  protected CfIdt func_79 = new CfIdt();
  protected CfIdt func_80 = new CfIdt();
  protected CfIdt func_81 = new CfIdt();
  protected CfIdt func_82 = new CfIdt();
  protected CfIdt func_83 = new CfIdt();
  protected CfIdt func_84 = new CfIdt();
  protected CfIdt func_85 = new CfIdt();
  protected CfIdt func_86 = new CfIdt();
  protected CfIdt func_87 = new CfIdt();
  protected CfIdt func_88 = new CfIdt();
  protected CfIdt func_89 = new CfIdt();
  protected CfIdt func_90 = new CfIdt();
  protected CfIdt func_91 = new CfIdt();
  protected CfIdt func_92 = new CfIdt();
  protected CfIdt func_93 = new CfIdt();
  protected CfIdt func_94 = new CfIdt();
  protected CfIdt func_95 = new CfIdt();
  protected CfInputMultiplexer func_101 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_102 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_103 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_104 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_105 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_106 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_107 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_108 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_109 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_110 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_111 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_112 = new CfInputMultiplexer();
  protected CfAddition func_113 = new CfAddition();
  protected CfIdt func_116 = new CfIdt();
  protected CfIdt func_117 = new CfIdt();
  protected CfIdt func_118 = new CfIdt();
  protected CfIdt func_119 = new CfIdt();
  protected CfIdt func_120 = new CfIdt();
  protected CfIdt func_121 = new CfIdt();
  protected CfIdt func_122 = new CfIdt();
  protected CfIdt func_123 = new CfIdt();
  protected CfIdt func_124 = new CfIdt();
  protected CfIdt func_125 = new CfIdt();
  protected CfIdt func_126 = new CfIdt();
  protected CfIdt func_127 = new CfIdt();
  protected CfIdt func_128 = new CfIdt();
  protected CfIdt func_5924 = new CfIdt();
  protected CfAddition func_5925 = new CfAddition();
  protected CfMinimum func_5926 = new CfMinimum();
  protected CfIdt func_5927 = new CfIdt();
  protected CfEqual func_221 = new CfEqual();
  protected CmFlank_Pulse func_9093 = new CmFlank_Pulse();
  protected CfLastValue func_9140 = new CfLastValue();
  protected CfCompare1 func_9137 = new CfCompare1();
  protected CfOr func_9096 = new CfOr();
  protected CfInputMultiplexer func_9149 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_9150 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_9146 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_9147 = new CfInputMultiplexer();
  protected CfIdt func_222 = new CfIdt();
  protected CfIdt func_223 = new CfIdt();
  protected CfIdt func_224 = new CfIdt();
  protected CfIdt func_225 = new CfIdt();
  protected CfIdt func_226 = new CfIdt();
  protected CfIdt func_227 = new CfIdt();
  protected CfIdt func_228 = new CfIdt();
  protected CfIdt func_229 = new CfIdt();
  protected CfIdt func_230 = new CfIdt();
  protected CfIdt func_231 = new CfIdt();
  protected CfIdt func_232 = new CfIdt();
  protected CfIdt func_233 = new CfIdt();
  protected CfIdt func_248 = new CfIdt();
  protected CfAnd func_249 = new CfAnd();
  protected CfAnd func_250 = new CfAnd();
  protected CfAnd func_251 = new CfAnd();
  protected CfAnd func_252 = new CfAnd();
  protected CfAnd func_253 = new CfAnd();
  protected CfAnd func_254 = new CfAnd();
  protected CfAnd func_255 = new CfAnd();
  protected CfAnd func_256 = new CfAnd();
  protected CfAnd func_257 = new CfAnd();
  protected CfAnd func_258 = new CfAnd();
  protected CfAnd func_259 = new CfAnd();
  protected CfAnd func_260 = new CfAnd();
  protected CfInputMultiplexer func_265 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_266 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_267 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_268 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_269 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_270 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_271 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_272 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_273 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_274 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_275 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_276 = new CfInputMultiplexer();
  protected CfIdt func_279 = new CfIdt();
  protected CfIdt func_280 = new CfIdt();
  protected CfIdt func_281 = new CfIdt();
  protected CfIdt func_282 = new CfIdt();
  protected CfIdt func_283 = new CfIdt();
  protected CfIdt func_284 = new CfIdt();
  protected CfIdt func_285 = new CfIdt();
  protected CfIdt func_286 = new CfIdt();
  protected CfIdt func_287 = new CfIdt();
  protected CfIdt func_288 = new CfIdt();
  protected CfIdt func_289 = new CfIdt();
  protected CfIdt func_290 = new CfIdt();
  protected CfIdt func_291 = new CfIdt();
  protected CfIdt func_292 = new CfIdt();
  protected CfIdt func_293 = new CfIdt();
  protected CfIdt func_294 = new CfIdt();
  protected CfIdt func_295 = new CfIdt();
  protected CfIdt func_296 = new CfIdt();
  protected CfIdt func_297 = new CfIdt();
  protected CfIdt func_298 = new CfIdt();
  protected CfIdt func_299 = new CfIdt();
  protected CfIdt func_300 = new CfIdt();
  protected CfIdt func_301 = new CfIdt();
  protected CfIdt func_302 = new CfIdt();
  protected CmCommInputProc func_6055 = new CmCommInputProc();
  protected CmFlank_Pulse func_8342 = new CmFlank_Pulse();
  protected CmAlarm_LD func_8336 = new CmAlarm_LD();
  protected CmAlarm_LD func_8338 = new CmAlarm_LD();
  protected CmAlarm_LD func_8340 = new CmAlarm_LD();
  protected CfIdt func_453 = new CfIdt();
  protected CfIdt func_454 = new CfIdt();
  protected CfIdt func_455 = new CfIdt();
  protected CfIdt func_456 = new CfIdt();
  protected CfIdt func_457 = new CfIdt();
  protected CfIdt func_458 = new CfIdt();
  protected CfIdt func_459 = new CfIdt();
  protected CfIdt func_460 = new CfIdt();
  protected CfIdt func_461 = new CfIdt();
  protected CfIdt func_462 = new CfIdt();
  protected CfIdt func_463 = new CfIdt();
  protected CfIdt func_464 = new CfIdt();
  protected CfAddition func_466 = new CfAddition();
  protected CfMultiply func_493 = new CfMultiply();
  protected CfIdt func_495 = new CfIdt();
  protected CfCompare1 func_6467 = new CfCompare1();
  protected CfInputMultiplexer func_497 = new CfInputMultiplexer();
  protected CfAddition func_498 = new CfAddition();
  protected CfSubtract func_499 = new CfSubtract();
  protected CfIdt func_501 = new CfIdt();
  protected CfMaximum func_503 = new CfMaximum();
  protected CfMultiply func_504 = new CfMultiply();
  protected CfMultiply func_505 = new CfMultiply();
  protected CfCompare1 func_6462 = new CfCompare1();
  protected CfIdt func_507 = new CfIdt();
  protected CfCompare1 func_510 = new CfCompare1();
  protected CfDivide func_513 = new CfDivide();
  protected CfDivide func_514 = new CfDivide();
  protected CfIdt func_519 = new CfIdt();
  protected CfIdt func_524 = new CfIdt();
  protected CfCompare2 func_6463 = new CfCompare2();
  protected CfAnd func_526 = new CfAnd();
  protected CfAnd func_527 = new CfAnd();
  protected CfAddition func_529 = new CfAddition();
  protected CfSubtract func_530 = new CfSubtract();
  protected CfAddition func_533 = new CfAddition();
  protected CfSubtract func_534 = new CfSubtract();
  protected CfInputMultiplexer func_538 = new CfInputMultiplexer();
  protected CfCompare2 func_6466 = new CfCompare2();
  protected CfInputMultiplexer func_539 = new CfInputMultiplexer();
  protected CfMultiply func_541 = new CfMultiply();
  protected CfInputMultiplexer func_544 = new CfInputMultiplexer();
  protected CfCompare2 func_6465 = new CfCompare2();
  protected CfInputMultiplexer func_545 = new CfInputMultiplexer();
  protected CfCompare1 func_6454 = new CfCompare1();
  protected CfInputMultiplexer func_547 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_548 = new CfInputMultiplexer();
  protected CfMinimum func_551 = new CfMinimum();
  protected CfMaximum func_555 = new CfMaximum();
  protected CfNot func_5974 = new CfNot();
  protected CfOr func_556 = new CfOr();
  protected CfInputMultiplexer func_558 = new CfInputMultiplexer();
  protected CfIdt func_560 = new CfIdt();
  protected CfCompare1 func_564 = new CfCompare1();
  protected CfSubtract func_570 = new CfSubtract();
  protected CfAddition func_572 = new CfAddition();
  protected CfCompare1 func_575 = new CfCompare1();
  protected CfNot func_6502 = new CfNot();
  protected CfAnd func_580 = new CfAnd();
  protected CfInputMultiplexer func_585 = new CfInputMultiplexer();
  protected CfNot func_6501 = new CfNot();
  protected CfAnd func_586 = new CfAnd();
  protected CfInputMultiplexer func_590 = new CfInputMultiplexer();
  protected CfNot func_6500 = new CfNot();
  protected CfOr func_591 = new CfOr();
  protected CfInputMultiplexer func_593 = new CfInputMultiplexer();
  protected CfIdt func_595 = new CfIdt();
  protected CfIdt func_597 = new CfIdt();
  protected CfMultiply func_601 = new CfMultiply();
  protected CfCompare1 func_603 = new CfCompare1();
  protected CfNot func_604 = new CfNot();
  protected CfCompare1 func_605 = new CfCompare1();
  protected CfNot func_606 = new CfNot();
  protected CfCompare1 func_6531 = new CfCompare1();
  protected CfInputMultiplexer func_609 = new CfInputMultiplexer();
  protected CfAddition func_615 = new CfAddition();
  protected CfInputMultiplexer func_627 = new CfInputMultiplexer();
  protected CfNot func_6535 = new CfNot();
  protected CfAnd func_628 = new CfAnd();
  protected CfAnd func_629 = new CfAnd();
  protected CfNot func_6532 = new CfNot();
  protected CfAnd func_630 = new CfAnd();
  protected CfAnd func_631 = new CfAnd();
  protected CfCompare1 func_633 = new CfCompare1();
  protected CfCompare1 func_635 = new CfCompare1();
  protected CfIdt func_637 = new CfIdt();
  protected CfDelay func_638 = new CfDelay();
  protected CfIdt func_639 = new CfIdt();
  protected CfDelay func_640 = new CfDelay();
  protected CfRsFlipFlop func_646 = new CfRsFlipFlop();
  protected CfIdt func_6534 = new CfIdt();
  protected CfRsFlipFlop func_647 = new CfRsFlipFlop();
  protected CfIdt func_6533 = new CfIdt();
  protected CfMultiply func_650 = new CfMultiply();
  protected CfMultiply func_651 = new CfMultiply();
  protected CfAddition func_655 = new CfAddition();
  protected CfIdt func_656 = new CfIdt();
  protected CfIdt func_657 = new CfIdt();
  protected CfIdt func_658 = new CfIdt();
  protected CfIdt func_660 = new CfIdt();
  protected CfIdt func_661 = new CfIdt();
  protected CfCompare1 func_662 = new CfCompare1();
  protected CfNot func_663 = new CfNot();
  protected CfCompare1 func_664 = new CfCompare1();
  protected CfCompare1 func_666 = new CfCompare1();
  protected CfNot func_6527 = new CfNot();
  protected CfNot func_6528 = new CfNot();
  protected CfAnd func_682 = new CfAnd();
  protected CfNot func_6525 = new CfNot();
  protected CfAnd func_685 = new CfAnd();
  protected CfAnd func_686 = new CfAnd();
  protected CfIdt func_689 = new CfIdt();
  protected CfDelay func_690 = new CfDelay();
  protected CfRsFlipFlop func_704 = new CfRsFlipFlop();
  protected CfIdt func_6526 = new CfIdt();
  protected CfCompare2 func_7104 = new CfCompare2();
  protected CfInputMultiplexer func_731 = new CfInputMultiplexer();
  protected CfCompare2 func_7132 = new CfCompare2();
  protected CfInputMultiplexer func_732 = new CfInputMultiplexer();
  protected CfCompare2 func_7135 = new CfCompare2();
  protected CfInputMultiplexer func_733 = new CfInputMultiplexer();
  protected CfCompare2 func_7137 = new CfCompare2();
  protected CfInputMultiplexer func_734 = new CfInputMultiplexer();
  protected CfCompare2 func_7139 = new CfCompare2();
  protected CfInputMultiplexer func_735 = new CfInputMultiplexer();
  protected CfCompare2 func_7141 = new CfCompare2();
  protected CfInputMultiplexer func_736 = new CfInputMultiplexer();
  protected CfCompare2 func_7143 = new CfCompare2();
  protected CfInputMultiplexer func_737 = new CfInputMultiplexer();
  protected CfCompare2 func_7145 = new CfCompare2();
  protected CfInputMultiplexer func_738 = new CfInputMultiplexer();
  protected CfCompare2 func_7146 = new CfCompare2();
  protected CfInputMultiplexer func_739 = new CfInputMultiplexer();
  protected CfCompare2 func_7147 = new CfCompare2();
  protected CfInputMultiplexer func_740 = new CfInputMultiplexer();
  protected CfCompare2 func_7148 = new CfCompare2();
  protected CfInputMultiplexer func_741 = new CfInputMultiplexer();
  protected CfCompare2 func_7149 = new CfCompare2();
  protected CfInputMultiplexer func_742 = new CfInputMultiplexer();
  protected CfCompare1 func_7133 = new CfCompare1();
  protected CfOr func_768 = new CfOr();
  protected CfCompare1 func_7134 = new CfCompare1();
  protected CfOr func_769 = new CfOr();
  protected CfCompare1 func_7136 = new CfCompare1();
  protected CfOr func_770 = new CfOr();
  protected CfCompare1 func_7138 = new CfCompare1();
  protected CfOr func_771 = new CfOr();
  protected CfCompare1 func_7140 = new CfCompare1();
  protected CfOr func_772 = new CfOr();
  protected CfCompare1 func_7142 = new CfCompare1();
  protected CfOr func_773 = new CfOr();
  protected CfCompare1 func_7144 = new CfCompare1();
  protected CfOr func_774 = new CfOr();
  protected CfCompare1 func_7150 = new CfCompare1();
  protected CfOr func_775 = new CfOr();
  protected CfCompare1 func_7151 = new CfCompare1();
  protected CfOr func_776 = new CfOr();
  protected CfCompare1 func_7152 = new CfCompare1();
  protected CfOr func_777 = new CfOr();
  protected CfCompare1 func_7153 = new CfCompare1();
  protected CfOr func_778 = new CfOr();
  protected CfCompare1 func_7154 = new CfCompare1();
  protected CfOr func_779 = new CfOr();
  protected CfMaximum func_784 = new CfMaximum();
  protected CfInputMultiplexer func_789 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_790 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_791 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_792 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_793 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_794 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_795 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_796 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_797 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_798 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_799 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_800 = new CfInputMultiplexer();
  protected CfSplit func_783 = new CfSplit();
  protected CfCompare1 func_7228 = new CfCompare1();
  protected CfCompare1 func_7229 = new CfCompare1();
  protected CfAnd func_802 = new CfAnd();
  protected CfCompare1 func_7230 = new CfCompare1();
  protected CfCompare1 func_7233 = new CfCompare1();
  protected CfCompare1 func_7231 = new CfCompare1();
  protected CfAnd func_803 = new CfAnd();
  protected CfMinimum func_805 = new CfMinimum();
  protected CfOr func_807 = new CfOr();
  protected CfSubtract func_808 = new CfSubtract();
  protected CfCompare1 func_7238 = new CfCompare1();
  protected CfAnd func_810 = new CfAnd();
  protected CfIdt func_812 = new CfIdt();
  protected CfIdt func_814 = new CfIdt();
  protected CfSubtract func_815 = new CfSubtract();
  protected CfAbsolute func_816 = new CfAbsolute();
  protected CfAnd func_820 = new CfAnd();
  protected CfCompare1 func_822 = new CfCompare1();
  protected CfCompare1 func_824 = new CfCompare1();
  protected CfAnd func_7642 = new CfAnd();
  protected CfAnd func_7265 = new CfAnd();
  protected Cmsequence_rotation func_7107 = new Cmsequence_rotation();
  protected Cmsequence_rotation func_7110 = new Cmsequence_rotation();
  protected Cmsequence_rotation func_7111 = new Cmsequence_rotation();
  protected Cmsequence_rotation func_7112 = new Cmsequence_rotation();
  protected Cmsequence_rotation func_7113 = new Cmsequence_rotation();
  protected Cmsequence_rotation func_7114 = new Cmsequence_rotation();
  protected Cmswitch_x_12 func_7239 = new Cmswitch_x_12();
  protected Cmsequence_rotation func_7115 = new Cmsequence_rotation();
  protected Cmsequence_rotation func_7116 = new Cmsequence_rotation();
  protected Cmsequence_rotation func_7117 = new Cmsequence_rotation();
  protected Cmsequence_rotation func_7118 = new Cmsequence_rotation();
  protected Cmsequence_rotation func_7119 = new Cmsequence_rotation();
  protected Cmsequence_rotation func_7120 = new Cmsequence_rotation();
  protected Cmswitch_x_12 func_7252 = new Cmswitch_x_12();
  protected CfIdt func_920 = new CfIdt();
  protected CfIdt func_923 = new CfIdt();
  protected CfIdt func_926 = new CfIdt();
  protected CfCompare1 func_929 = new CfCompare1();
  protected CfNot func_7186 = new CfNot();
  protected CfNot func_7227 = new CfNot();
  protected CfIdt func_7578 = new CfIdt();
  protected CfInputMultiplexer func_7571 = new CfInputMultiplexer();
  protected CfAnd func_932 = new CfAnd();
  protected CfCompare2 func_7187 = new CfCompare2();
  protected CfRound func_938 = new CfRound();
  protected CfSubtract func_939 = new CfSubtract();
  protected CfCompare1 func_7194 = new CfCompare1();
  protected CfAnd func_943 = new CfAnd();
  protected CfCompare1 func_7193 = new CfCompare1();
  protected CfAnd func_944 = new CfAnd();
  protected CfCompare1 func_7189 = new CfCompare1();
  protected CfAnd func_945 = new CfAnd();
  protected CfCompare2 func_7188 = new CfCompare2();
  protected CfAnd func_946 = new CfAnd();
  protected CfOr func_948 = new CfOr();
  protected CfIdt func_949 = new CfIdt();
  protected CfOr func_7584 = new CfOr();
  protected CfInputMultiplexer func_7572 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_7573 = new CfInputMultiplexer();
  protected CfIdt func_954 = new CfIdt();
  protected CfIdt func_955 = new CfIdt();
  protected CfCompare2 func_7225 = new CfCompare2();
  protected CfAddition func_957 = new CfAddition();
  protected CfIdt func_961 = new CfIdt();
  protected CfInputMultiplexer func_963 = new CfInputMultiplexer();
  protected CfIdt func_964 = new CfIdt();
  protected CfNot func_7226 = new CfNot();
  protected CfAnd func_965 = new CfAnd();
  protected CfInputMultiplexer func_967 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_968 = new CfInputMultiplexer();
  protected CfOr func_7588 = new CfOr();
  protected CfInputMultiplexer func_7580 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_7581 = new CfInputMultiplexer();
  protected CfCompare1 func_7562 = new CfCompare1();
  protected CfIdt func_1001 = new CfIdt();
  protected Cmruntime_selector func_7526 = new Cmruntime_selector();
  protected Cmruntime_selector func_7525 = new Cmruntime_selector();
  protected Cmruntime_selector func_7524 = new Cmruntime_selector();
  protected Cmruntime_selector func_7520 = new Cmruntime_selector();
  protected Cmruntime_selector func_7527 = new Cmruntime_selector();
  protected Cmruntime_selector func_7528 = new Cmruntime_selector();
  protected Cmruntime_selector func_7529 = new Cmruntime_selector();
  protected Cmruntime_selector func_7530 = new Cmruntime_selector();
  protected Cmruntime_selector func_7531 = new Cmruntime_selector();
  protected Cmruntime_selector func_7532 = new Cmruntime_selector();
  protected Cmruntime_selector func_7533 = new Cmruntime_selector();
  protected Cmruntime_selector func_7534 = new Cmruntime_selector();
  protected CfAddition func_977 = new CfAddition();
  protected CfAddition func_978 = new CfAddition();
  protected CfAddition func_979 = new CfAddition();
  protected CfAddition func_980 = new CfAddition();
  protected CfAddition func_981 = new CfAddition();
  protected CfAddition func_982 = new CfAddition();
  protected CfAddition func_983 = new CfAddition();
  protected CfAddition func_984 = new CfAddition();
  protected CfAddition func_985 = new CfAddition();
  protected CfAddition func_986 = new CfAddition();
  protected CfAddition func_987 = new CfAddition();
  protected CfAddition func_988 = new CfAddition();
  protected CfMinimum func_1053 = new CfMinimum();
  protected CfOr func_7574 = new CfOr();
  protected CfInputMultiplexer func_7565 = new CfInputMultiplexer();
  protected CfIdt func_1055 = new CfIdt();
  protected CfCompare1 func_7447 = new CfCompare1();
  protected CfCompare1 func_7449 = new CfCompare1();
  protected CfCompare1 func_7450 = new CfCompare1();
  protected CfCompare1 func_7465 = new CfCompare1();
  protected CfCompare1 func_7466 = new CfCompare1();
  protected CfCompare1 func_7469 = new CfCompare1();
  protected CfCompare1 func_7470 = new CfCompare1();
  protected CfCompare1 func_7473 = new CfCompare1();
  protected CfCompare1 func_7474 = new CfCompare1();
  protected CfCompare1 func_7475 = new CfCompare1();
  protected CfCompare1 func_7476 = new CfCompare1();
  protected CfCompare1 func_7477 = new CfCompare1();
  protected CfInputMultiplexer func_7604 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_7606 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_7608 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_7610 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_7612 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_7614 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_7616 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_7619 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_7620 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_7621 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_7622 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_7623 = new CfInputMultiplexer();
  protected CfIdt func_1158 = new CfIdt();
  protected CfOutputMultiplexer func_1161 = new CfOutputMultiplexer();
  protected CfCompare2 func_7536 = new CfCompare2();
  protected CfAnd func_7603 = new CfAnd();
  protected Cmruntime_switches func_8080 = new Cmruntime_switches();
  protected CfIdt func_7539 = new CfIdt();
  protected CfIdt func_7541 = new CfIdt();
  protected CfIdt func_7542 = new CfIdt();
  protected CfIdt func_7543 = new CfIdt();
  protected CfIdt func_7544 = new CfIdt();
  protected CfIdt func_7545 = new CfIdt();
  protected CfIdt func_7546 = new CfIdt();
  protected CfIdt func_7547 = new CfIdt();
  protected CfIdt func_7548 = new CfIdt();
  protected CfIdt func_7549 = new CfIdt();
  protected CfIdt func_7550 = new CfIdt();
  protected CfIdt func_7551 = new CfIdt();
  protected CfIdt func_1191 = new CfIdt();
  protected CfIdt func_1192 = new CfIdt();
  protected CfIdt func_1193 = new CfIdt();
  protected CfIdt func_1194 = new CfIdt();
  protected CfIdt func_1196 = new CfIdt();
  protected CfSubtract func_1197 = new CfSubtract();
  protected CfSubtract func_1198 = new CfSubtract();
  protected CfAnd func_1201 = new CfAnd();
  protected CfAnd func_1203 = new CfAnd();
  protected CfCompare1 func_8143 = new CfCompare1();
  protected CfAnd func_1206 = new CfAnd();
  protected CfCompare1 func_8142 = new CfCompare1();
  protected CfAnd func_1207 = new CfAnd();
  protected CfCompare1 func_1211 = new CfCompare1();
  protected CfNot func_8141 = new CfNot();
  protected CfOr func_1214 = new CfOr();
  protected CfCompare1 func_7211 = new CfCompare1();
  protected CfInputMultiplexer func_7212 = new CfInputMultiplexer();
  protected CfIdt func_1221 = new CfIdt();
  protected Cmswitch_x_12 func_8272 = new Cmswitch_x_12();
  protected CfInputMultiplexer func_8284 = new CfInputMultiplexer();
  protected CfAnd func_9201 = new CfAnd();
  protected CmIncrease_Operation_List func_9408 = new CmIncrease_Operation_List();
  protected CfCompare1 func_9277 = new CfCompare1();
  protected CfAnd func_9274 = new CfAnd();
  protected CmLoad_rotation_increase func_9273 = new CmLoad_rotation_increase();
  protected Cmswitch_x_12 func_9282 = new Cmswitch_x_12();
  protected Cmswitch_x_12 func_9294 = new Cmswitch_x_12();
  protected CfAnd func_9307 = new CfAnd();
  protected CmDecrease_Operation_List func_9410 = new CmDecrease_Operation_List();
  protected CfAnd func_9331 = new CfAnd();
  protected CmLoad_rotation_decrease func_9316 = new CmLoad_rotation_decrease();
  protected Cmswitch_x_12 func_9334 = new Cmswitch_x_12();
  protected Cmswitch_x_12 func_9347 = new Cmswitch_x_12();
  protected CfAddition func_1550 = new CfAddition();
  protected CfMaximum func_1551 = new CfMaximum();
  protected CfDivide func_1553 = new CfDivide();
  protected CfCompare1 func_8350 = new CfCompare1();
  protected CfInputMultiplexer func_1556 = new CfInputMultiplexer();
  protected Cmnext_to_start func_8357 = new Cmnext_to_start();
  protected Cmnext_to_start func_8360 = new Cmnext_to_start();
  protected Cmnext_to_start func_8363 = new Cmnext_to_start();
  protected Cmnext_to_start func_8364 = new Cmnext_to_start();
  protected Cmnext_to_start func_8366 = new Cmnext_to_start();
  protected Cmnext_to_start func_8368 = new Cmnext_to_start();
  protected Cmnext_to_start func_8370 = new Cmnext_to_start();
  protected Cmnext_to_start func_8371 = new Cmnext_to_start();
  protected Cmnext_to_start func_8373 = new Cmnext_to_start();
  protected Cmnext_to_start func_8372 = new Cmnext_to_start();
  protected Cmnext_to_start func_8374 = new Cmnext_to_start();
  protected Cmnext_to_start func_8375 = new Cmnext_to_start();
  protected CfMinimum func_1669 = new CfMinimum();
  protected CfCompare1 func_8424 = new CfCompare1();
  protected CfCompare1 func_8425 = new CfCompare1();
  protected CfCompare1 func_8426 = new CfCompare1();
  protected CfCompare1 func_8427 = new CfCompare1();
  protected CfCompare1 func_8428 = new CfCompare1();
  protected CfCompare1 func_8429 = new CfCompare1();
  protected CfCompare1 func_8430 = new CfCompare1();
  protected CfCompare1 func_8431 = new CfCompare1();
  protected CfCompare1 func_8432 = new CfCompare1();
  protected CfCompare1 func_8433 = new CfCompare1();
  protected CfCompare1 func_8434 = new CfCompare1();
  protected CfCompare1 func_8435 = new CfCompare1();
  protected CfInputMultiplexer func_8436 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8437 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8438 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8439 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8440 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8441 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8442 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8443 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8444 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8445 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8446 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8447 = new CfInputMultiplexer();
  protected CfSubtract func_1726 = new CfSubtract();
  protected CfMaximum func_1727 = new CfMaximum();
  protected CfDivide func_1729 = new CfDivide();
  protected CfCompare1 func_8718 = new CfCompare1();
  protected CfInputMultiplexer func_1744 = new CfInputMultiplexer();
  protected CfCompare2 func_5736 = new CfCompare2();
  protected CfCompare2 func_5737 = new CfCompare2();
  protected CfCompare2 func_5738 = new CfCompare2();
  protected CfCompare2 func_5739 = new CfCompare2();
  protected CfCompare2 func_5740 = new CfCompare2();
  protected CfCompare2 func_5741 = new CfCompare2();
  protected CfCompare2 func_5742 = new CfCompare2();
  protected CfCompare2 func_5743 = new CfCompare2();
  protected CfCompare2 func_5744 = new CfCompare2();
  protected CfCompare2 func_5745 = new CfCompare2();
  protected CfCompare2 func_5747 = new CfCompare2();
  protected CfCompare2 func_5746 = new CfCompare2();
  protected CfInputMultiplexer func_1783 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1784 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1785 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1786 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1787 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1788 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1789 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1790 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1791 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1792 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1793 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_1794 = new CfInputMultiplexer();
  protected CfMaximum func_1796 = new CfMaximum();
  protected CfCompare1 func_8719 = new CfCompare1();
  protected CfCompare1 func_8732 = new CfCompare1();
  protected CfCompare1 func_8733 = new CfCompare1();
  protected CfCompare1 func_8734 = new CfCompare1();
  protected CfCompare1 func_8735 = new CfCompare1();
  protected CfCompare1 func_8736 = new CfCompare1();
  protected CfCompare1 func_8737 = new CfCompare1();
  protected CfCompare1 func_8738 = new CfCompare1();
  protected CfCompare1 func_8739 = new CfCompare1();
  protected CfCompare1 func_8740 = new CfCompare1();
  protected CfCompare1 func_8741 = new CfCompare1();
  protected CfCompare1 func_8742 = new CfCompare1();
  protected CfInputMultiplexer func_8720 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8721 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8722 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8723 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8724 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8725 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8726 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8727 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8728 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8729 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8730 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_8731 = new CfInputMultiplexer();
  protected CfIdt func_1857 = new CfIdt();
  protected CfIdt func_1858 = new CfIdt();
  protected CfAddition func_1883 = new CfAddition();
  protected CfCompare2 func_5685 = new CfCompare2();
  protected CfIdt func_1888 = new CfIdt();
  protected CfCompare1 func_1905 = new CfCompare1();
  protected CfNot func_1906 = new CfNot();
  protected CfIdt func_1911 = new CfIdt();
  protected CfRound func_1914 = new CfRound();
  protected CfNot func_8754 = new CfNot();
  protected CfNot func_8757 = new CfNot();
  protected CfAnd func_1964 = new CfAnd();
  protected CfIdt func_1965 = new CfIdt();
  protected CfNot func_8173 = new CfNot();
  protected CfNot func_8174 = new CfNot();
  protected CfAnd func_1967 = new CfAnd();
  protected CfAnd func_1968 = new CfAnd();
  protected CmIncDecrDetection func_8758 = new CmIncDecrDetection();
  protected CmIncDecrDetection func_8761 = new CmIncDecrDetection();
  protected CmIncDecrDetection func_8762 = new CmIncDecrDetection();
  protected CmIncDecrDetection func_8763 = new CmIncDecrDetection();
  protected CmIncDecrDetection func_8764 = new CmIncDecrDetection();
  protected CmIncDecrDetection func_8765 = new CmIncDecrDetection();
  protected CmIncDecrDetection func_8766 = new CmIncDecrDetection();
  protected CmIncDecrDetection func_8767 = new CmIncDecrDetection();
  protected CmIncDecrDetection func_8768 = new CmIncDecrDetection();
  protected CmIncDecrDetection func_8769 = new CmIncDecrDetection();
  protected CmIncDecrDetection func_8770 = new CmIncDecrDetection();
  protected CmIncDecrDetection func_8771 = new CmIncDecrDetection();
  protected CfAddition func_1969 = new CfAddition();
  protected CfAddition func_1970 = new CfAddition();
  protected CfRound func_1971 = new CfRound();
  protected CfSubtract func_1972 = new CfSubtract();
  protected CfRound func_1973 = new CfRound();
  protected CfSubtract func_1974 = new CfSubtract();
  protected CfRsFlipFlop func_1976 = new CfRsFlipFlop();
  protected CfIdt func_1977 = new CfIdt();
  protected CfIdt func_1978 = new CfIdt();
  protected CfIdt func_1979 = new CfIdt();
  protected CfAddition func_1980 = new CfAddition();
  protected CfCompare1 func_1981 = new CfCompare1();
  protected CfAnd func_1983 = new CfAnd();
  protected CfAnd func_1986 = new CfAnd();
  protected CfIdt func_1988 = new CfIdt();
  protected CfCompare1 func_1989 = new CfCompare1();
  protected CfNot func_5684 = new CfNot();
  protected CfCompare1 func_1992 = new CfCompare1();
  protected CfIdt func_1998 = new CfIdt();
  protected CfDelay func_1999 = new CfDelay();
  protected CfAnd func_2001 = new CfAnd();
  protected CfRsFlipFlop func_2002 = new CfRsFlipFlop();
  protected CfCompare1 func_2006 = new CfCompare1();
  protected CfInputMultiplexer func_8774 = new CfInputMultiplexer();
  protected CfOr func_8773 = new CfOr();
  protected CfInputMultiplexer func_8772 = new CfInputMultiplexer();
  protected CfIdt func_2014 = new CfIdt();
  protected CfCompare1 func_2068 = new CfCompare1();
  protected Cmsearch_i func_9076 = new Cmsearch_i();
  protected CfInputMultiplexer func_9120 = new CfInputMultiplexer();
  protected CfCompare1 func_9426 = new CfCompare1();
  protected CfAnd func_9423 = new CfAnd();
  protected CfOr func_9421 = new CfOr();
  protected Cmsearch_i func_9072 = new Cmsearch_i();
  protected CfInputMultiplexer func_9124 = new CfInputMultiplexer();
  protected CfNot func_8809 = new CfNot();
  protected CfNot func_8808 = new CfNot();
  protected CfCompare2 func_8807 = new CfCompare2();
  protected CfAnd func_2246 = new CfAnd();
  protected CfIdt func_2240 = new CfIdt();
  protected CfInputMultiplexer func_2247 = new CfInputMultiplexer();
  protected CfIdt func_2251 = new CfIdt();
  protected CfCompare1 func_2252 = new CfCompare1();
  protected CfInputMultiplexer func_9748 = new CfInputMultiplexer();
  protected CfCompare2 func_8806 = new CfCompare2();
  protected CfCompare1 func_2241 = new CfCompare1();
  protected CfInputMultiplexer func_2255 = new CfInputMultiplexer();
  protected CfOutputMultiplexer func_2254 = new CfOutputMultiplexer();
  protected Cmswitch_x_12 func_8810 = new Cmswitch_x_12();
  protected CfInputMultiplexer func_8805 = new CfInputMultiplexer();
  protected CmGroupFeedback_out func_5630 = new CmGroupFeedback_out();
  protected CfIdt func_2288 = new CfIdt();
  protected CfIdt func_2290 = new CfIdt();
  protected CfCompare2 func_5679 = new CfCompare2();
  protected CfAnd func_2294 = new CfAnd();
  protected CfInputMultiplexer func_2296 = new CfInputMultiplexer();
  protected CfMerge func_2298 = new CfMerge();
  protected CfInputMultiplexer func_2300 = new CfInputMultiplexer();
  protected CfSubtract func_2321 = new CfSubtract();
  protected CfSubtract func_2322 = new CfSubtract();
  protected CfIdt func_2323 = new CfIdt();
  protected CfSubtract func_2324 = new CfSubtract();
  protected CfSubtract func_2325 = new CfSubtract();
  protected CfAddition func_2326 = new CfAddition();
  protected CfLastValue func_9763 = new CfLastValue();
  protected CfMinimum func_9766 = new CfMinimum();
  protected CfIdt func_2328 = new CfIdt();
  protected CfAnd func_2329 = new CfAnd();
  protected CfIdt func_2330 = new CfIdt();
  protected CfAnd func_2331 = new CfAnd();
  protected CfIdt func_2332 = new CfIdt();
  protected CfAnd func_2333 = new CfAnd();
  protected CfInputMultiplexer func_2336 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2337 = new CfInputMultiplexer();
  protected CfInputMultiplexer func_2338 = new CfInputMultiplexer();
  protected CfIdt func_2339 = new CfIdt();
  protected CfSubtract func_2347 = new CfSubtract();
  protected CfAbsolute func_2348 = new CfAbsolute();
  protected CfIdt func_2349 = new CfIdt();
  protected CfInputMultiplexer func_8071 = new CfInputMultiplexer();
  protected CmRuntime_LD func_9151 = new CmRuntime_LD();
  protected CmRuntime_LD func_9153 = new CmRuntime_LD();
  protected CmRuntime_LD func_9154 = new CmRuntime_LD();
  protected CfIdt func_2341 = new CfIdt();
  protected CfIdt func_2343 = new CfIdt();
  protected CfIdt func_2345 = new CfIdt();
  protected CfOr func_8330 = new CfOr();
  protected CfOr func_8333 = new CfOr();
  protected CfOr func_8334 = new CfOr();
  protected CfIdt func_2376 = new CfIdt();
  protected CfIdt func_2377 = new CfIdt();
  protected CmWriteRuntime func_9775 = new CmWriteRuntime();
  protected CmWriteRuntime func_9777 = new CmWriteRuntime();
  protected CmWriteRuntime func_9779 = new CmWriteRuntime();

  // default constructor
  public BCmSQA_ChillerSeq()
  {
    func_113.configure(12);
    func_221.configure(2);
    func_9096.configure(3);
    func_466.configure(12);
    func_548.configure(4);
    func_615.configure(4);
    func_655.configure(3);
    func_682.configure(3);
    func_768.configure(3);
    func_769.configure(3);
    func_770.configure(3);
    func_771.configure(3);
    func_772.configure(3);
    func_773.configure(3);
    func_774.configure(3);
    func_775.configure(3);
    func_776.configure(3);
    func_777.configure(3);
    func_778.configure(3);
    func_779.configure(3);
    func_784.configure(12);
    func_805.configure(12);
    func_807.configure(3);
    func_7265.configure(3);
    func_943.configure(3);
    func_944.configure(4);
    func_945.configure(3);
    func_948.configure(4);
    func_7584.configure(3);
    func_7588.configure(3);
    func_1053.configure(12);
    func_7574.configure(4);
    func_1161.configure(13);
    func_7539.configure(2);
    func_7541.configure(2);
    func_7542.configure(2);
    func_7543.configure(2);
    func_7544.configure(2);
    func_7545.configure(2);
    func_7546.configure(2);
    func_7547.configure(2);
    func_7548.configure(2);
    func_7549.configure(2);
    func_7550.configure(2);
    func_7551.configure(2);
    func_1214.configure(5);
    func_9201.configure(3);
    func_9307.configure(3);
    func_1669.configure(12);
    func_1796.configure(12);
    func_1964.configure(5);
    func_1967.configure(4);
    func_1969.configure(12);
    func_1970.configure(12);
    func_2246.configure(3);
    func_2247.configure(14);
    func_2254.configure(13);
    func_2296.configure(14);
    func_2298.configure(3);
    func_2326.configure(12);
    func_2329.configure(3);
    func_2331.configure(3);
    func_2333.configure(3);
  }

  public void Start()
  {
    func_9093.Start();
    func_9140.Start();
    func_6055.Start();
    func_8342.Start();
    func_8336.Start();
    func_8338.Start();
    func_8340.Start();
    func_638.Start();
    func_640.Start();
    func_646.Start();
    func_647.Start();
    func_690.Start();
    func_704.Start();
    func_7107.Start();
    func_7110.Start();
    func_7111.Start();
    func_7112.Start();
    func_7113.Start();
    func_7114.Start();
    func_7239.Start();
    func_7115.Start();
    func_7116.Start();
    func_7117.Start();
    func_7118.Start();
    func_7119.Start();
    func_7120.Start();
    func_7252.Start();
    func_7526.Start();
    func_7525.Start();
    func_7524.Start();
    func_7520.Start();
    func_7527.Start();
    func_7528.Start();
    func_7529.Start();
    func_7530.Start();
    func_7531.Start();
    func_7532.Start();
    func_7533.Start();
    func_7534.Start();
    func_8080.Start();
    func_8272.Start();
    func_9408.Start();
    func_9273.Start();
    func_9282.Start();
    func_9294.Start();
    func_9410.Start();
    func_9316.Start();
    func_9334.Start();
    func_9347.Start();
    func_8357.Start();
    func_8360.Start();
    func_8363.Start();
    func_8364.Start();
    func_8366.Start();
    func_8368.Start();
    func_8370.Start();
    func_8371.Start();
    func_8373.Start();
    func_8372.Start();
    func_8374.Start();
    func_8375.Start();
    func_8758.Start();
    func_8761.Start();
    func_8762.Start();
    func_8763.Start();
    func_8764.Start();
    func_8765.Start();
    func_8766.Start();
    func_8767.Start();
    func_8768.Start();
    func_8769.Start();
    func_8770.Start();
    func_8771.Start();
    func_1976.Start();
    func_1999.Start();
    func_2002.Start();
    func_9076.Start();
    func_9072.Start();
    func_8810.Start();
    func_5630.Start();
    func_9763.Start();
    func_9151.Start();
    func_9153.Start();
    func_9154.Start();
    func_9775.Start();
    func_9777.Start();
    func_9779.Start();
  }
}
